                                   },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "units": "Kelvin_scale"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa"
                                                }
                                            }
                                        }
                                    }
                                },
                                "indo": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "indo",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temoerature of lower soil layer",
                                                    "pointwidth": "0.0"
                                                },
                                                "t": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "qv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water mixing ratio",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temoerature of lower soil layer",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "qv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water mixing ratio",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            "T_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "T_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1979-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "Y_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.2246",
                                "standard_name": "latitude"
                            },
                            "T_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1979-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "X_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.2248",
                                "standard_name": "longitude"
                            },
                            "S_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "1",
                                "calendar": "360",
                                "pointwidth": "1",
                                "long_name": "Months",
                                "modulo": "12.0",
                                "modulus": "12.0"
                            },
                            "T_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "3",
                                "standard_name": "time"
                            },
                            "S_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "calendar": "360",
                                "long_name": "Start time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "lead Time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "0",
                                "long_name": "Start time"
                            },
                            "Y_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "X_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.2248",
                                "standard_name": "longitude"
                            },
                            "Y_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "X_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.5396",
                                "standard_name": "longitude"
                            },
                            "M_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "T_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "T_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1971-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1971-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "X_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.2248",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1971-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "hPa",
                                "gridtype": "0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.2194",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since  1971-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0",
                                "standard_name": "time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.2248001",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/RegCM3"
                        },
                        "SESA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SESA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WRFInstitute": "IRI-Columbia U. http://iri.columbia.edu",
                                "WRFAuthor": "A. G. Munoz (agmunoz@iri.columbia.edu)",
                                "WRFSource": "WRF3.3 @ 20 km - Boundary: NNRP2 ",
                                "description": "South East South America",
                                "Conventions": "IRIDL"
                            },
                            "WRF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "WRF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DJF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DJF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Geopotential",
                                        "missing_value": "9.96920997E36",
                                        "units": "m2 s2",
                                        "pointwidth": "1.0"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "2622920",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "windspeed_colors",
                                        "long_name": "wind v-component",
                                        "missing_value": "9.96920997E36",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "2622920",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "windspeed_colors",
                                        "long_name": "wind u-component",
                                        "missing_value": "9.96920997E36",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "tx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "scale_max": "40.0",
                                        "ncolor": "254",
                                        "scale_min": "-40.0",
                                        "CS": "-40",
                                        "colorscalename": "temp_colors",
                                        "CE": "40",
                                        "units": "Kelvin_scale",
                                        "long_name": "Maximum daily temperature",
                                        "missing_value": "9.96920997E36",
                                        "pointwidth": "1.0"
                                    },
                                    "tn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "scale_max": "40.0",
                                        "ncolor": "254",
                                        "scale_min": "-40.0",
                                        "CS": "-40",
                                        "colorscalename": "temp_colors",
                                        "CE": "40",
                                        "units": "Kelvin_scale",
                                        "long_name": "Minimum daily temperature",
                                        "missing_value": "9.96920997E36",
                                        "pointwidth": "1.0"
                                    },
                                    "t2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "scale_max": "40.0",
                                        "ncolor": "254",
                                        "scale_min": "-40.0",
                                        "CS": "-40",
                                        "colorscalename": "temp_colors",
                                        "CE": "40",
                                        "units": "Kelvin_scale",
                                        "long_name": "Mean daily temperature",
                                        "missing_value": "9.96920997E36",
                                        "pointwidth": "1.0"
                                    },
                                    "pr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "290304",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "precip_colors",
                                        "units": "mm/day",
                                        "long_name": "Daily precipitation",
                                        "missing_value": "9.96920997E36",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure levels"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "Latitude",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "long_name": "Longitude",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Member"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/SESA"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "Brazil",
                            "East_Africa",
                            "GHA",
                            "NorthWest_Pacific",
                            "RegCM3",
                            "SESA"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "GLOBAL",
                        "REGIONAL"
                    ]
                },
                "COUPLED": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "COUPLED",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GLOBALECHAM4p5SOMobsSSTdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.COUPLED/.GLOBAL.ECHAM4p5-SOM-obsSST.dataset_documentation.html",
                        "GLOBALECHAM4p5SOMobsSSTiridlhasSemantics": "iriref:DeWitt_DG",
                        "GLOBALECHAM4p5MOM3DC2references": "Roeckner_etal1996 Danabasoglu_etal2006 Derber_Rosati1989 DeWitt_DG2005 Luo_JJ2005a Pacanowski_Griffies1998 ",
                        "GLOBALECHAM4p5MOM3DC2description": "Retrospective monthly data of 8-month forecast from direct coupled ECHAM4p5 and MOM3, starting date from Jan 1982 to Present. Please contact David G. DeWitt (daved at iri.columbia.edu) for any questions regarding this dataset",
                        "GLOBALECHAM4p5MOM3DC2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.COUPLED/.GLOBAL.ECHAM4p5-MOM3-DC2.dataset_documentation.html",
                        "GLOBALECHAM4p5MOM3DC2iridlhasSemantics": "iriref:DeWitt_DG",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYoceandescription": " grid",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYoceanbinaryfilename": "/mstore/iri/modelling/daved/C12.D/echam4_3.00amip2/WorkMOM3MedRes2pl.D/EXP.D/Jan1982.D/Run.D/post/ocn_dat%mc%y4",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYoceanhistory": " grid",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYatmdescription": "ECHAM4.5 AMIP2a",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYatmmissing_value": "-999.0",
                        "GLOBALECHAM4p5MOM3DC1Long_Free_RunMONTHLYatmhistory": "ECHAM4.5 AMIP2a",
                        "GLOBALECHAM4p5MOM3DC1ForecastsMONTHLYnote": "Jan and Jul starts are missing for the Std run, but not yet marked as missing data.",
                        "GLOBALECHAM4p5MOM3DC1ForecastsDAILYnote": "Jan and Jul starts are missing for the Std run, but not yet marked as missing data.",
                        "GLOBALECHAM4p5MOM3DC1references": "Roeckner_etal1996",
                        "GLOBALECHAM4p5MOM3DC1iridlhasSemantics": "iriref:DeWitt_DG",
                        "GLOBALECHAM4p5MOM3AC1references": "Roeckner_etal1996",
                        "GLOBALECHAM4p5MOM3AC1description": "Retrospective monthly data of 8-month forecast from ECHAM4p5-MOM3, starting date from Jan 1982 to Present. Please contact David G. DeWitt (daved at iri.columbia.edu) for any questions regarding this dataset",
                        "GLOBALECHAM4p5MOM3AC1iridlhasSemantics": "iridl:MPI_Met",
                        "GLOBALECHAM4p5GMLcfsSSTCFS_sstensemble12MONTHLYOCEANiridlhasSemantics": "iridl:India_ERFS",
                        "GLOBALECHAM4p5GMLcfsSSTCFS_sstensemble12MONTHLYATMiridlhasSemantics": "iridl:India_ERFS",
                        "GLOBALECHAM4p5GMLcfsSSTreferences": "Roeckner_etal1996",
                        "GLOBALECHAM4p5GMLcfsSSTdescription": "ECHAM-GML",
                        "GLOBALECHAM4p5GMLcfsSSTmodel_description": "http://portal.iri.columbia.edu/portal/server.pt/gateway/PTARGS_0_0_1526_1038_7918_43/http%3B/iriportal3.ldeo.columbia.edu%3B7087/publishedcontent/publish/development/climate_activities/prediction/forecast_methodologies/gdm_page_editor_portlet/mixed_layer_text.html",
                        "GLOBALECHAM4p5GMLcfsSSTiridlhasSemantics": "iriref:DeWitt_DG",
                        "Conventions": "IRIDL"
                    },
                    "GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ECHAM4p5SOMobsSST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5-SOM-obsSST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "ECHAM4p5MOM3DC2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5-MOM3-DC2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OCEAN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OCEAN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "htf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "htf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "units": " W m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "hmlt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hmlt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "ocean_mixed_layer_thickness",
                                        "long_name": "kpp mixed layer depth",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "hblt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hblt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "kpp boundary layer depth",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "fwf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fwf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "fresh water flux",
                                        "units": "meter+3/sq meter",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "eta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "eta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "free surface height",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    }
                                },
                                "BelowSeaSurface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BelowSeaSurface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "w": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "w",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "upward_sea_water_velocity",
                                        "long_name": "meridional current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "sea_water_y_velocity",
                                        "long_name": "meridional current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "sea_water_x_velocity",
                                        "long_name": "zonal current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "t": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "s": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "s",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "salinity",
                                        "units": "PSU",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    }
                                }
                            },
                            "ATM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ATM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnd10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnd10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter meridional wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter zonal wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "9"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "9"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "two meter dewpoint",
                                        "units": "Kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "soil wetness",
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "snowf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow fall",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "snowd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "sea level pressure",
                                        "units": "pascals",
                                        "cNZ": "9"
                                    },
                                    "sicef": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sicef",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "9"
                                    },
                                    "siced": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "siced",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "surface sensible heat flux",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "runoff",
                                        "cNZ": "9"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "9"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_longwave_fluxxflux",
                                        "long_name": "out long wave radiation",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_fluxflux",
                                        "long_name": "net shortwave at toa",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "surface latent heat flux",
                                        "units": " watts/sq meter",
                                        "cNZ": "9"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "cloud_area_fraction",
                                        "long_name": "total cloud cover",
                                        "cNZ": "9"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "cNZ": "9"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "9"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "9"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "9"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "9"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "9"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    }
                                },
                                "Mon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Mon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                }
                            }
                        },
                        "ECHAM4p5MOM3DC1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5-MOM3-DC1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Long_Free_Run": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Long_Free_Run",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ocean": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ocean",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "w": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "w",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical velocity",
                                            "units": "cm/s",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional current",
                                            "units": "cm/s",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal current",
                                            "units": "cm/s",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "temp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "temperature",
                                            "units": "Celsius_scale",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "taux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "taux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal wind stress",
                                            "units": "dynes/cm2",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "tau": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tau",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional wind stress",
                                            "units": "dynes/cm2",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "sflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "salt flux",
                                            "units": "g/cm2",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "sal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "salinity",
                                            "units": "fraction above .035",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "hflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "heat flux",
                                            "units": "cal/cm2",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        },
                                        "eta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "eta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface height",
                                            "units": "cm",
                                            "missing_value": "-9.99999979E33",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "atm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "atm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "top": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "top",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "olr",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "net shortwave at toa",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            }
                                        },
                                        "surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface meridional wind stress",
                                                "units": "N/m2",
                                                "cNZ": "9"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface zonal wind stress",
                                                "units": "N/m2",
                                                "cNZ": "9"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface temperature",
                                                "cNZ": "9"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea level pressure",
                                                "units": "Pascals",
                                                "cNZ": "9"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface sensible heat flux",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            },
                                            "sg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface geopotential",
                                                "cNZ": "9"
                                            },
                                            "pl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "m/s",
                                                "cNZ": "9"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "net shortwave at ground",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "net longwave at ground",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface latent heat flux",
                                                "units": "W/m2",
                                                "cNZ": "9"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evaporation",
                                                "units": "meters/second",
                                                "cNZ": "9"
                                            },
                                            "cp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "m/s",
                                                "cNZ": "9"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "total cloud cover",
                                                "cNZ": "9"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional velocity",
                                                "units": "meters/second",
                                                "cNZ": "9"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal velocity",
                                                "units": "meters/second",
                                                "cNZ": "9"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "temperature",
                                                "units": "Kelvin_scale",
                                                "cNZ": "9"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "9"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "cNZ": "9"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "geopotential height",
                                                "units": "gpm",
                                                "cNZ": "9"
                                            }
                                        },
                                        "above_ground": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "above_ground",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "temperature at 2m",
                                                "units": "Kelvin_scale",
                                                "cNZ": "9"
                                            }
                                        }
                                    }
                                }
                            },
                            "Forecasts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecasts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "meridional velocity",
                                        "units": "meters/second",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "zonal velocity",
                                        "units": "meters/second",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "surface meridional wind stress",
                                        "units": "Pa",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "surface zonal wind stress",
                                        "units": "Pa",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "pointwidth": "1.0",
                                        "units": "months since 1960-01-01",
                                        "calendar": "360",
                                        "standard_name": "forecast_reference_time"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "surface temperature",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "sea level pressure",
                                        "units": "Pa",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "surface sensible heat flux",
                                        "units": "W/m2",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "specific humidity",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "precipotatble water",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "total precipitation",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "vertical pressure velocity",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "olr",
                                        "units": "W/m2",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "net shortwave at toa",
                                        "units": "W/m2",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "surface latent heat flux watts/sq meter",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "long_name": "geopotential height",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "evaporation meters/second",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "total cloud cover",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    }
                                },
                                "DAILY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DAILY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 850 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "geopotential_height",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "z700": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z700",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 700 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "geopotential_height",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "z500": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z500",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 500mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "geopotential_height",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "z200": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z200",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 200mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "geopotential_height",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "v925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "long_name": "meridional wind at 925 mb",
                                        "standard_name": "northward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "v850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "long_name": "meridional wind at 850 mb",
                                        "standard_name": "northward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "v700": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v700",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "long_name": "meridional wind at 700 mb",
                                        "standard_name": "northward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "v200": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v200",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "long_name": "meridional wind at 200 mb",
                                        "standard_name": "northward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "u925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 925 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "eastward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "u850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 850 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "eastward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "u700": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u700",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 700 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "eastward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "u200": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u200",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 200 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "standard_name": "eastward wind",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "t850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "standard_name": "air_temperature",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "t700": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t700",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "standard_name": "air_temperature",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "standard_name": "air_temperature",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "t200": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t200",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "units": "Kelvin_scale",
                                        "grid_name": "grid-1",
                                        "standard_name": "air_temperature",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "pointwidth": "1.0",
                                        "units": "days since 1980 00:00:00",
                                        "calendar": "standard",
                                        "standard_name": "forecast_reference_time"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": "Pa",
                                        "grid_name": "grid-1",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "missing_value": "-999.0",
                                        "comments": "Unknown1 variable comment",
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "grid_type": "generic",
                                        "pointwidth": "0"
                                    },
                                    "q925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "specific humidity at 925 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "q850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "specific humidity at 850 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "q700": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q700",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "specific humidity at 700 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "precipitable water",
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "total precipitation",
                                        "grid_name": "grid-1",
                                        "units": "unitless",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    },
                                    "o500": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "o500",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "time_statistic": "instantaneous",
                                        "level_description": "Earth surface",
                                        "long_name": "vertical pressure velocity at 500 mb",
                                        "units": "unitless",
                                        "grid_name": "grid-1",
                                        "missing_value": "-999.0",
                                        "grid_type": "generic",
                                        "comments": "Unknown1 variable comment",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "ECHAM4p5MOM3AC1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5-MOM3-AC1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OCEAN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OCEAN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "htf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "htf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "units": " W m-2",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "hmlt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hmlt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "kpp mixed layer depth",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "hblt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hblt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "kpp boundary layer depth",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "fwf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fwf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "fresh water flux",
                                        "units": "meter+3/sq meter",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "eta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "eta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "free surface height",
                                        "units": "m",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    }
                                },
                                "subM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "subM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "dirname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dirname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "BelowSeaSurface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BelowSeaSurface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "w": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "w",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal current",
                                        "units": "m s-1",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "t": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    },
                                    "s": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "s",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "salinity",
                                        "units": "PSU",
                                        "cNZ": "0",
                                        "missing_value": "-9.99999979E33"
                                    }
                                }
                            },
                            "ATM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ATM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnd10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnd10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter meridional wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter zonal wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter dewpoint",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "snowf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow fall",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "snowd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": " pascals",
                                        "cNZ": "17"
                                    },
                                    "sicef": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sicef",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "17"
                                    },
                                    "siced": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "siced",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "runoff",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "out long wave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at toa",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": " watts/sq meter",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "cNZ": "17"
                                    }
                                },
                                "subM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "subM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                },
                                "Mon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Mon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "dirname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dirname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                }
                            }
                        },
                        "ECHAM4p5GMLcfsSST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5-GML-cfsSST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CFS_sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CFS_sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ensemble12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ensemble12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "MONTHLY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MONTHLY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "OCEAN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "OCEAN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "Forecast time",
                                                "pointwidth": "1.0",
                                                "units": "months since 1960-01-01",
                                                "standard_name": "time",
                                                "calendar": "360"
                                            },
                                            "Surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "vvlcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "vvlcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface meridional wind",
                                                    "units": "m s-1",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "uvlcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvlcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface zonal wind",
                                                    "units": "m s-1",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "tauycli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tauycli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface meridional wind stress",
                                                    "units": "N m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "tauxcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tauxcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface zonal wind stress",
                                                    "units": "N m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "swcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "observed short wave radiation climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "sw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "oceanic short wave radiation",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "sstrelfact": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sstrelfact",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Newtonian cooling time scale",
                                                    "units": "day",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "sstobsanom": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sstobsanom",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "observed sst anoamly",
                                                    "units": "K",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "sstmlanom": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sstmlanom",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sea surface temperature anomaly",
                                                    "units": "K",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "shsea": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "shsea",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s sensible heat flux",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "shscli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "shscli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s sensible heat flux climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "shcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "shcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "observed sensible heat flux climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "sh": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sh",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "oceanic sensible heat flux",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "seagsstcl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "seagsstcl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "model sst climatology",
                                                    "units": "K",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "qspcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qspcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface specific humidity climatology",
                                                    "units": "kg kg-1",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "qek": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qek",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "lateral heat flux by anomalous Ekman transport",
                                                    "units": "W m**-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "premask": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "premask",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "mask for prescribed SST,1:prescribed ",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                },
                                                "mld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "mld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "mixed layer depth",
                                                    "units": "m",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lwsea": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwsea",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s long wave radiation",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lwscli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwscli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s long wave radiation climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lwcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "observed long wave radiation climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "oceanic long wave radiation",
                                                    "units": "w s-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lndmask": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lndmask",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "land sea mask, 1:sea",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                },
                                                "lhsea": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lhsea",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s latent heat",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lhscli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lhscli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Seager\\'s latent heat climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lhcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lhcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "observed latent heat climatology",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "lh": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lh",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "oceanic latent heat fulx",
                                                    "units": "W m-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "hnewt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "hnewt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "heat flux due to Newtonian cooling term",
                                                    "units": "W m**-2",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "cldcli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cldcli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud cover",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                },
                                                "aircli": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "aircli",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface air temperature climatology",
                                                    "units": "K",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "BelowSeaSurface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "BelowSeaSurface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "tmp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tmp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "K",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                },
                                                "salt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "salt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "salinity",
                                                    "units": "PSU",
                                                    "cNZ": "0",
                                                    "missing_value": "-9.99999979E33",
                                                    "pointwidth": "1.0"
                                                }
                                            }
                                        },
                                        "ATM": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ATM",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "Forecast time",
                                                "pointwidth": "1.0",
                                                "units": "months since 1960-01-01",
                                                "standard_name": "time",
                                                "calendar": "360"
                                            },
                                            "Surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "wnd10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "wnd10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "10 meter wind speed",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "10 meter meridional wind",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "10 meter zonal wind",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "tauy": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tauy",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface meridional wind stress",
                                                    "units": " newton m-2",
                                                    "cNZ": "17"
                                                },
                                                "taux": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "taux",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface zonal wind stress",
                                                    "units": " newton m-2",
                                                    "cNZ": "17"
                                                },
                                                "t2mmin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2mmin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "two meter minimum temperature",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "t2mmax": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2mmax",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "two meter maximum temperature",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "t2md": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2md",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "two meter dewpoint",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature at 2m",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "sw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "soil wetness",
                                                    "units": "m",
                                                    "cNZ": "17"
                                                },
                                                "st": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "st",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface temperature",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "snowf": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "snowf",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "snow fall",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "snowd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "snowd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "snow depth",
                                                    "units": "m",
                                                    "cNZ": "17"
                                                },
                                                "slp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "slp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sea level pressure",
                                                    "units": " pascals",
                                                    "cNZ": "17"
                                                },
                                                "sicef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sicef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sea ice fraction",
                                                    "cNZ": "17"
                                                },
                                                "siced": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "siced",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sea ice depth",
                                                    "units": "m",
                                                    "cNZ": "17"
                                                },
                                                "sh": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sh",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface sensible heat flux",
                                                    "units": " W m-2",
                                                    "cNZ": "17"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "runoff",
                                                    "cNZ": "17"
                                                },
                                                "pwat": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "pwat",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "precipitable water",
                                                    "units": "mm",
                                                    "cNZ": "17"
                                                },
                                                "prec": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prec",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "olr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "olr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "out long wave radiation",
                                                    "units": "W m-2",
                                                    "cNZ": "17"
                                                },
                                                "nswt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "nswt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net shortwave at toa",
                                                    "units": "W m-2",
                                                    "cNZ": "17"
                                                },
                                                "nswg": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "nswg",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net shortwave at ground",
                                                    "units": "W m-2",
                                                    "cNZ": "17"
                                                },
                                                "nlwg": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "nlwg",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net longwave at ground",
                                                    "units": "W m-2",
                                                    "cNZ": "17"
                                                },
                                                "lh": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lh",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface latent heat flux",
                                                    "units": " watts/sq meter",
                                                    "cNZ": "17"
                                                },
                                                "evap": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evap",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evaporation",
                                                    "units": "m s-1",
                                                    "cNZ": "17"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total cloud cover",
                                                    "cNZ": "17"
                                                },
                                                "alb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "alb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "albedo",
                                                    "cNZ": "17"
                                                }
                                            },
                                            "PressureLevel": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PressureLevel",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "vrt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "vrt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "vorticity",
                                                    "units": "m",
                                                    "cNZ": "17"
                                                },
                                                "velpot": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "velpot",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "velocity potential",
                                                    "units": "m2 s-1",
                                                    "cNZ": "17"
                                                },
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind",
                                                    "units": "m/s",
                                                    "cNZ": "17"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind",
                                                    "units": "m/s",
                                                    "cNZ": "17"
                                                },
                                                "tmp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tmp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "K",
                                                    "cNZ": "17"
                                                },
                                                "stream": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "stream",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "stream function",
                                                    "cNZ": "17"
                                                },
                                                "rh": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rh",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "relative humidity",
                                                    "cNZ": "17"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "cNZ": "17"
                                                },
                                                "omega": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "omega",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "vertical pressure velocity",
                                                    "units": "pascals/s",
                                                    "cNZ": "17"
                                                },
                                                "gz": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "gz",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "geopotential height",
                                                    "units": "gpm",
                                                    "cNZ": "17"
                                                },
                                                "div": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "div",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "divergence",
                                                    "units": "s-1",
                                                    "cNZ": "17"
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "Z_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "standard_name": "depth"
                    },
                    "P_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure level"
                    },
                    "Z_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.5",
                        "standard_name": "longitude"
                    },
                    "P_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "calendar": "360",
                        "standard_name": "time"
                    },
                    "levels": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "levels",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0"
                    },
                    "S_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time"
                    },
                    "L_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period"
                    },
                    "Z_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "S_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "scale_max": "-2450846.5",
                        "units": "days since 1980 00:00:00",
                        "scale_min": "-2459581.5",
                        "calendar": "standard",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_reference_time"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0"
                    },
                    "L_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period"
                    },
                    "M_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "standard_name": "realization"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.4968619",
                        "standard_name": "longitude"
                    },
                    "S_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Start time",
                        "calendar": "360"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble member"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "long_name": "Depth below sea surface"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure level"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.8125",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble member"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Start time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/IRI/MP/RESEARCH/COUPLED"
                },
                "FORECASTS": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MP/RESEARCH/FORECASTS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "FORECASTS",
                    "restriction": "requires dlauth tokens"
                },
                "OCEAN": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MP/RESEARCH/OCEAN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "OCEAN",
                    "restriction": "requires dlauth tokens"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "ASSIMILATION",
                    "ATMOSPHERE",
                    "COUPLED",
                    "FORECASTS",
                    "OCEAN"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "RESEARCH"
            ]
        },
        "Projects": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Projects",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Conventions": "IRIDL"
            },
            "dir": "SOURCES/IRI/Projects"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Analyses",
            "EPPF",
            "FD",
            "MD",
            "MP",
            "Projects"
        ]
    },
    "IRIARCS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IRI-ARCS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CMPJCFMRdescription": "IRI-ARCS Coupled-Modelling Project Joint Coupled Forecast in Medium Resolution for air-sea interface parameters",
            "CMPJCFMRlong_name": "Medium Resolution.",
            "CMPJCFHRdescription": "IRI-ARCS Coupled-Modelling Project Joint Coupled Forecast in High Resolution for air-sea interface parameters",
            "CMPJCFHRlong_name": "High Resolution.",
            "CMPJCFiridlhasSemantics": "iridl:forecast",
            "CMPJCFlong_name": "Joint Coupled Forecast",
            "CMPAMIPdescription": "Atmospheric Model Intercomparison Project runs",
            "CMPAMIPsee_also": "/SOURCES/Models/.AMIP/",
            "CMPlong_name": "Coupled-Modelling Project",
            "description": "International Research Institute/Applied Research Centers",
            "iridlhasSemantics": "iridl:IRI",
            "Conventions": "IRIDL"
        },
        "CMP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CMP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "JCF": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "JCF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional wind stress",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal wind stress",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "1",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "land and sea temperature",
                        "units": "degreeC",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "sflx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sflx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "salt flux",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "hflx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hflx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "heat flux",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "hc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "temperature average over upper 20 layers (200 meters)",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    }
                },
                "HR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional wind stress",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal wind stress",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "1",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "land and sea temperature",
                        "units": "degreeC",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "sflx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sflx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "salt flux",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "hflx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hflx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "heat flux",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "hc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "temperature average over upper 20 layers (200 meters)",
                        "missing_value": "-9.99999979E33",
                        "units": "unitless",
                        "pointwidth": "0"
                    }
                }
            },
            "AMIP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AMIP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ECHAM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "COLA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "COLA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "CCM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CCM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.5"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "standard_name": "forecast_period",
            "long_name": "lead time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "start time",
            "pointwidth": "0"
        },
        "dir": "SOURCES/IRI-ARCS"
    },
    "ISCCP": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ISCCP",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MONTHLYsee": "/SOURCES/.GEDEX/.isccp_c2/",
            "ISCCP": "/SOURCES/.NASA/.ISCCP/.D2/",
            "see": "/SOURCES/.GEDEX/.isccp_c2.cdf/",
            "references": "Seager_Blumenthal1994 Bishop_Rossow1991",
            "description": "Cloudiness and solar radiation data from the International Satellite Cloud Climatology Project",
            "Conventions": "IRIDL",
            "iridlhasSemantics": "iridl:WCRP",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ISCCP/.dataset_documentation.html"
        },
        "OLD": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "OLD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "long_name": "solar radiation"
            },
            "derived": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "derived",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "srb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "srb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "file_missing_value": "-99.999901",
                    "units": "unitless",
                    "history": "[[([ SOLSFC.ISCCP solr ] * $1-a$) [(ISCCP Solar Radation Data) (X regridded on SOLSFC.ISCCP) (Y regridded on SOLSFC.ISCCP)]] [() (U.S. Navy bathymetry plus land heights)]]"
                }
            }
        },
        "MONTHLY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MONTHLY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "history": "ISCCP Solar Radation Data (corrected)",
                "long_name": "solar radiation"
            },
            "lowcloud": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lowcloud",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Ave Freq Low Clouds  Cumulus and Stratus",
                "units": "/%",
                "long_name": "Low Cld Freq",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "long_name": "cloudiness"
            }
        },
        "MEAN": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MEAN",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "long_name": "cloudiness"
            }
        },
        "Fitted": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Fitted",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "srb": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "srb",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "CI": "2",
                "history": "[(ISCCP Solar Radation Data (corrected)) ([ ISCCP MONTHLY solr ] * $1-a$)]",
                "source": ">ISCCP fitted to ERBE</a>",
                "long_name": "surface radiation budget",
                "missing_value": "NaN",
                "CE": "320",
                "CS": "0"
            }
        },
        "derivederbegrid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "derivederbegrid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "srb": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "srb",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "W/m2",
                "long_name": "surface radiation budget",
                "history": "[[(ISCCP MONTHLY solr) [(ISCCP Solar Radation Data (corrected)) (X regridded on ISCCP MONTHLY solr) (Y regridded on ISCCP MONTHLY solr)]] [($1-a$) (1. - [ albedo [ [ [ mod [ T , 12 ] ] * 30. ] , Y , 5. , 2.1000000E-02 ] ])]]"
            }
        },
        "derived": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "derived",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "srb": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "srb",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "W/m2",
                "long_name": "surface radiation budget",
                "history": "[(ISCCP Solar Radation Data (corrected)) ([ ISCCP MONTHLY solr ] * $1-a$)]"
            }
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5",
            "long_name": "Longitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5"
        },
        "dir": "SOURCES/ISCCP"
    },
    "IWMI": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IWMI",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "IDSI_Senegaldescription": "International Water Management Institute - Integrated Drought Severity Index for Senegal - 2001 to 2018",
            "Conventions": "IRIDL"
        },
        "IDSI_Senegal": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "IDSI_Senegal",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "IDSI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IDSI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Integrated Drought Severity Index",
                "units": "unitless",
                "pointwidth": "12"
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "long_name": "Latitude",
            "pointwidth": "0.004166999"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "12"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "long_name": "Longitude",
            "pointwidth": "0.004167"
        },
        "dir": "SOURCES/IWMI"
    },
    "Indices": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Indices",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Tahitislpc8110expires": "1617667200",
            "Tahitislpc8110long_name": "1981-2010 base period",
            "Tahitidescription": "Sea level pressure data from Tahiti",
            "Tahitiupdated": "http://www.cpc.ncep.noaa.gov/data/indices/tahiti",
            "Tahitiexpires": "1617667200",
            "Tahitidataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.Tahiti.dataset_documentation.html",
            "TahitiiridlhasSemantics": "iridl:NOAA",
            "TahitiFAQ": "http://www.cpc.ncep.noaa.gov/data/indices/Readme.index.shtml",
            "TahitiCPC": "http://www.cpc.ncep.noaa.gov/data/indices/",
            "Tahitihistorical": "ftp://ftp.cpc.ncep.noaa.gov/wd52dg/data/indices/tahiti.his",
            "standardizeddescription": "Standardized Southern Oscillation Index",
            "soic8110iridlhasSemantics": "iriref:Cole_J",
            "soic8110long_name": "1981-2010 base period",
            "soiupdated": "http://www.cpc.ncep.noaa.gov/data/indices/soi",
            "soiFAQ": "http://www.cpc.ncep.noaa.gov/data/indices/Readme.index.shtml",
            "soiCPC": "http://www.cpc.ncep.noaa.gov/data/indices/",
            "QBOdescription": "Quasi-Biennial Oscillation Index",
            "QBOftp_url": "https://psl.noaa.gov/data/correlation/qbo.data",
            "QBOexpires": "1614902400",
            "QBOinstitution": "Physical Sciences Laboratory |  NOAA",
            "QBOwebsite": "https://psl.noaa.gov/data/climateindices/list/",
            "QBOhistory": "Climate Indices: Monthly Atmospheric and Ocean Time-Series",
            "PDOdescription": "Monthly Pacific Decadal Oscillation Index from JISAO",
            "PDOJISAO": "http://research.jisao.washington.edu/pdo/",
            "PDOiridlhasSemantics": "iridl:JISAO",
            "PDOdata": "http://research.jisao.washington.edu/pdo/PDO.latest.txt",
            "PDOlong_name": "Pacific Decadal Oscillation Index",
            "PDOreferences": "Zhang_etal1997 Mantua_etal1997",
            "ninoNCEP_OIv2expires": "1615161600",
            "ninoNCEP_OIv2iridlhasSemantics": "iridl:NCEP",
            "ninoNCEP_OIv2references": "Reynolds_etal2002",
            "ninoNCEPexpires": "1615161600",
            "ninoNCEPiridlhasSemantics": "iridl:NCEP",
            "ninoNCEPreferences": "Reynolds_Smith1994",
            "ninoKAPLANexpires": "1615161600",
            "ninoKAPLANiridlhasSemantics": "iridl:LDEO",
            "ninoKAPLANreferences": "Kaplan_etal1998",
            "ninoEXTENDEDexpires": "1615161600",
            "ninoEXTENDEDiridlhasSemantics": "iridl:NOAA",
            "ninoEXTENDEDreferences": "Kaplan_etal1998 Reynolds_etal2002",
            "ninodataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.nino.dataset_documentation.html",
            "naodescription": "North Atlantic Oscillation Index",
            "naosource": "James Hurrell",
            "naodataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.nao.dataset_documentation.html",
            "naoiridlhasSemantics": "iridl:NCAR",
            "naolong_name": "North Atlantic Oscillation Index",
            "indiadescription": "Summer monsoon rainfall data from India",
            "indiasource": "IITM-Pune",
            "indiadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.india.dataset_documentation.html",
            "indiairidlhasSemantics": "iridl:IITM",
            "indialong_name": "All India",
            "indiareferences": "Sontakke_etal1993",
            "HANSENGlobaldescription": "Analysis of average global temperature at annual, seasonal, and monthly time scales",
            "HANSENGlobaldataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.HANSEN.Global.dataset_documentation.html",
            "HANSENGlobalreferences": "Hansen_Lebedeff1988",
            "HANSENGlobalhistory": "update of Hansen and Lebedeff (1987)",
            "HANSENdescription": "Analysis of average global temperature at annual, seasonal, and monthly time scales",
            "HANSENiridlhasSemantics": "iridl:GISS",
            "Easterslplong_name": "sea level pressure",
            "Easterdescription": "Sea level pressure data from Easter Island",
            "Easterdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.Easter.dataset_documentation.html",
            "EasteriridlhasSemantics": "iridl:NOAA",
            "Easterlong_name": "Easter Island",
            "Darwinslpc8110expires": "1617667200",
            "Darwinslpc8110long_name": "1981-2010 base period",
            "Darwindescription": "Sea level pressure data from Darwin, Australia",
            "Darwinupdated": "http://www.cpc.ncep.noaa.gov/data/indices/darwin",
            "Darwinexpires": "1617667200",
            "Darwindataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.Darwin.dataset_documentation.html",
            "DarwiniridlhasSemantics": "iriref:Cole_J",
            "Darwinlong_name": "Darwin",
            "DarwinFAQ": "http://www.cpc.ncep.noaa.gov/data/indices/Readme.index.shtml",
            "DarwinCPC": "http://www.cpc.ncep.noaa.gov/data/indices/",
            "Darwinhistorical": "ftp://ftp.cpc.ncep.noaa.gov/wd52dg/data/indices/darwin.his",
            "dailyECCCPNAdescription": "Pacific/North American",
            "dailyECCCPNAcomment": "The loading patterns of NAO and PNA are obtained using a rotated EOF (REOF) analysis following Barnston and Livezey (1987). The REOF is conducted for the monthly mean 500-hPa geopotential height anomalies over the Northern Hemisphere (20-90N) using the NCEP/NCAR reanalyses from 1951 to 2010. Monthly mean anomalies for all 12 calendar months and 10 rotated varimax spatial patterns are used. Since the NAO and PNA variability has the largest variance in the cold season, the patterns are thus dominated by characteristics in winter. Similar definition was used in Johansson (2007), Lin et al. (2009), and Frederiksen and Lin (2013). Analysis provided courtesy of Hai Lin (hai.lin@canada.ca) of Environment Canada.",
            "dailyECCCPNAreferences": "Barnston_Livezey1987 Frederiksen_Lin2013 Johansson2007 Lin_etal2009",
            "dailyECCCNAOdescription": "North Atlantic Oscillation",
            "dailyECCCNAOcomment": "The loading patterns of NAO and PNA are obtained using a rotated EOF (REOF) analysis following Barnston and Livezey (1987). The REOF is conducted for the monthly mean 500-hPa geopotential height anomalies over the Northern Hemisphere (20-90N) using the NCEP/NCAR reanalyses from 1951 to 2010. Monthly mean anomalies for all 12 calendar months and 10 rotated varimax spatial patterns are used. Since the NAO and PNA variability has the largest variance in the cold season, the patterns are thus dominated by characteristics in winter. Similar definition was used in Johansson (2007), Lin et al. (2009), and Frederiksen and Lin (2013). Analysis provided courtesy of Hai Lin (hai.lin@canada.ca) of Environment Canada.",
            "dailyECCCNAOreferences": "Barnston_Livezey1987 Frederiksen_Lin2013 Johansson2007 Lin_etal2009",
            "dailyECCCdescription": "Environment and Climate Change Canada",
            "dailydescription": "Daily Teleconnection Indices",
            "dailylong_name": "Daily Teleconnection Indices",
            "CPC_IndicesNHTIexpires": "1617494400",
            "CPC_IndicesNHTIdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.CPC_Indices.NHTI.dataset_documentation.html",
            "CPC_IndicesNHTIreferences": "Barnston_Livezey1987 Bell_Halpert1995 Hurrell1995 Mo_Livezey1986 Wallace_Gutzler1981",
            "CPC_IndicesNHTIlong_name": "Northern Hemisphere Teleconnection Indices",
            "CPC_Indicesdescription": "Northern Hemispheric Teleconnection Indices from the Climate Prediction Center",
            "CPC_IndicesiridlhasSemantics": "iridl:NOAA",
            "ensomonitorhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Indices/.ensomonitor.html",
            "description": "A set of time series that monitor climate",
            "Conventions": "IRIDL"
        },
        "Tahiti": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Tahiti",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "full": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "full",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb above 1000",
                    "missing_value": "-999.90002",
                    "expires": "1617667200",
                    "standard_name": "air_pressure_at_sea_level",
                    "long_name": "sea level pressure"
                },
                "c8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "c8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standardized": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "standardized",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "standardized sea level pressure anomalies",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "expires": "1617667200",
                        "history": "Averaged over T[Jan 1981, Dec 2010] minimum 0.0% data present",
                        "standard_name": "air_pressure_anomaly",
                        "file_missing_value": "-999.90002"
                    },
                    "clim": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clim",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_pressure_at_sea_level",
                        "long_name": "sea level pressure climatology",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "file_missing_value": "-999.90002",
                        "units": "mb above 1000",
                        "expires": "1617667200"
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_pressure_anomaly",
                        "long_name": "sea level pressure anomalies",
                        "units": "mb",
                        "missing_value": "NaN",
                        "expires": "1617667200",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "file_missing_value": "-999.90002"
                    }
                }
            }
        },
        "standardized": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "standardized",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "soi": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "soi",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "missing_value": "-999.0",
                "source": "Judy Cole",
                "iridlhasSemantics": "iridl:NOAA",
                "long_name": "Southern Oscillation Index"
            }
        },
        "soi": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "soi",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "c8110": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "c8110",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "standardized": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "standardized",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "standardized slp difference",
                    "missing_value": "NaN",
                    "expires": "1617667200",
                    "units": "unitless",
                    "history": "Averaged over T[Jan 1981, Dec 2010] minimum 0.0% data present",
                    "standard_name": "air_pressure_anomaly",
                    "file_missing_value": "-999.90002"
                },
                "anomaly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "anomaly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "long_name": "sea level pressure anomaly",
                    "expires": "1617667200",
                    "units": "unitless",
                    "history": "Averaged over T[Jan 1981, Dec 2010] minimum 0.0% data present",
                    "standard_name": "air_pressure_anomaly",
                    "file_missing_value": "-999.90002"
                }
            }
        },
        "QBO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "QBO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "QBO_realtime": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "QBO_realtime",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Calculated at PSL (from the zonal average of the 30mb zonal wind at the equator as computed from the NCEP/NCAR Reanalysis).",
                "institution": "Physical Sciences Laboratory |  NOAA",
                "title": "Quasi-Biennial Oscillation",
                "scale_min": "-30.0",
                "scale_max": "30.0",
                "CE": "30",
                "CS": "-30",
                "ncolor": "254",
                "colorscalename": "std_anomaly_colors",
                "maxncolor": "254",
                "colormap": "255",
                "missing_value": "-999.0",
                "long_name": "Quasi-Biennial Oscillation",
                "units": "ms-1",
                "expires": "1614902400",
                "pointwidth": "0"
            }
        },
        "PDO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PDO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "pdo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pdo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "missing_value": "-9999.0"
            }
        },
        "nino": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "nino",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NCEP_OIv2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCEP_OIv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NINO4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO4",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "expires": "1615161600",
                    "iridlhasSemantics": "iridl:Nino4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta } { 150W - 160E } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta }   { 150W - 160E } ) ] [ 5N - 5S ]",
                    "standard_name": "sea_surface_temperature",
                    "pointwidth": "1.0"
                },
                "NINO34": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO34",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO34",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "expires": "1615161600",
                    "iridlhasSemantics": "iridl:Nino3.4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta } { 120W - 170W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta }   { 120W - 170W } ) ] [ 5N - 5S ]",
                    "standard_name": "sea_surface_temperature",
                    "pointwidth": "1.0"
                },
                "NINO3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO3",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "expires": "1615161600",
                    "iridlhasSemantics": "iridl:Nino3",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta } { 90W - 150W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta }   { 90W - 150W } ) ] [ 5N - 5S ]",
                    "standard_name": "sea_surface_temperature",
                    "pointwidth": "1.0"
                },
                "NINO12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO12",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "expires": "1615161600",
                    "iridlhasSemantics": "iridl:Nino1_2",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta } { 80W - 90W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv2 monthly ssta }   { 80W - 90W } ) ] [ 0 - 10S ]",
                    "standard_name": "sea_surface_temperature",
                    "pointwidth": "1.0"
                }
            },
            "NCEP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCEP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NINO4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO4",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta } { 150W - 160E } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta }   { 150W - 160E } ) ] [ 5N - 5S ]",
                    "PLOTCOAST": "1"
                },
                "NINO34": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO34",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO34",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3.4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta } { 120W - 170W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta }   { 120W - 170W } ) ] [ 5N - 5S ]",
                    "PLOTCOAST": "1"
                },
                "NINO3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO3",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta } { 90W - 150W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta }   { 90W - 150W } ) ] [ 5N - 5S ]",
                    "PLOTCOAST": "1"
                },
                "NINO12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO12",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino1_2",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta } { 80W - 90W } ) / ( $integral dX$   dataflag { NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 monthly ssta }   { 80W - 90W } ) ] [ 0 - 10S ]",
                    "PLOTCOAST": "1"
                }
            },
            "KAPLAN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "KAPLAN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NINO4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO4",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN RSA_MOHSST5 OS ssta } { 150W - 160E } ) / ( $integral dX$   dataflag { KAPLAN RSA_MOHSST5 OS ssta }   { 150W - 160E } ) ] [ 5N - 5S ]",
                    "Version": "2; June 96"
                },
                "NINO34": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO34",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO34",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3.4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN RSA_MOHSST5 OS ssta } { 120W - 170W } ) / ( $integral dX$   dataflag { KAPLAN RSA_MOHSST5 OS ssta }   { 120W - 170W } ) ] [ 5N - 5S ]",
                    "Version": "2; June 96"
                },
                "NINO3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO3",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN RSA_MOHSST5 OS ssta } { 90W - 150W } ) / ( $integral dX$   dataflag { KAPLAN RSA_MOHSST5 OS ssta }   { 90W - 150W } ) ] [ 5N - 5S ]",
                    "Version": "2; June 96"
                },
                "NINO12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO12",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino1_2",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN RSA_MOHSST5 OS ssta } { 80W - 90W } ) / ( $integral dX$   dataflag { KAPLAN RSA_MOHSST5 OS ssta }   { 80W - 90W } ) ] [ 0 - 10S ]",
                    "Version": "2; June 96"
                }
            },
            "EXTENDED": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "EXTENDED",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NINO4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO4",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN EXTENDED v2 ssta } { 150W - 160E } ) / ( $integral dX$   dataflag { KAPLAN EXTENDED v2 ssta }   { 150W - 160E } ) ] [ 5N - 5S ]",
                    "file_missing_value": "1.00000002E30"
                },
                "NINO34": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO34",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO34",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3.4",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN EXTENDED v2 ssta } { 120W - 170W } ) / ( $integral dX$   dataflag { KAPLAN EXTENDED v2 ssta }   { 120W - 170W } ) ] [ 5N - 5S ]",
                    "file_missing_value": "1.00000002E30"
                },
                "NINO3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO3",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino3",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN EXTENDED v2 ssta } { 90W - 150W } ) / ( $integral dX$   dataflag { KAPLAN EXTENDED v2 ssta }   { 90W - 150W } ) ] [ 5N - 5S ]",
                    "file_missing_value": "1.00000002E30"
                },
                "NINO12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NINO12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NINO12",
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "iridlhasSemantics": "iridl:Nino1_2",
                    "units": "degree_Celsius",
                    "history": "$integral dY$ [ ( $integral dX$ { KAPLAN EXTENDED v2 ssta } { 80W - 90W } ) / ( $integral dX$   dataflag { KAPLAN EXTENDED v2 ssta }   { 80W - 90W } ) ] [ 0 - 10S ]",
                    "file_missing_value": "1.00000002E30"
                }
            }
        },
        "nao": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "nao",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "100 kilogram meter-1 second-2",
                "long_name": "sea level pressure difference"
            }
        },
        "india": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "india",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "rainfall": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rainfall",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mm",
                "long_name": "summer monsoon rainfall"
            }
        },
        "HANSEN": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "HANSEN",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Global": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Global",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Seasonal": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Seasonal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Temperature"
                    }
                },
                "Monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Temperature"
                    }
                },
                "Annual": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Annual",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Temperature"
                    }
                }
            }
        },
        "Easter": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Easter",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "standardized": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "standardized",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "missing_value": "-999.90002",
                    "long_name": "standardized sea level pressure"
                },
                "full": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "full",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb above 1000",
                    "missing_value": "-999.90002",
                    "long_name": "sea level pressure"
                },
                "anomaly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "anomaly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb above 1000",
                    "missing_value": "-999.90002",
                    "long_name": "sea level pressure anomaly"
                }
            }
        },
        "Darwin": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Darwin",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "full": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "full",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb above 1000",
                    "missing_value": "-999.90002",
                    "expires": "1617667200",
                    "standard_name": "air_pressure_at_sea_level",
                    "long_name": "1882-present sea level pressure"
                },
                "c8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "c8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standardized": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "standardized",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "standardized sea level pressure anomalies",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "expires": "1617667200",
                        "history": "Averaged over T[Jan 1981, Dec 2010] minimum 0.0% data present",
                        "standard_name": "air_pressure_anomaly",
                        "file_missing_value": "-999.90002"
                    },
                    "clim": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clim",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_pressure_at_sea_level",
                        "long_name": "sea level pressure climatology",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "file_missing_value": "-999.90002",
                        "units": "mb above 1000",
                        "expires": "1617667200"
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_pressure_anomaly",
                        "long_name": "sea level pressure anomalies",
                        "units": "mb",
                        "missing_value": "NaN",
                        "expires": "1617667200",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "file_missing_value": "-999.90002"
                    }
                }
            }
        },
        "daily": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "daily",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ECCC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ECCC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PNA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PNA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PNA_pattern": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PNA_pattern",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "PNA Loading Pattern",
                        "missing_value": "9.99999962E35"
                    },
                    "PNA_index": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PNA_index",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "PNA Index",
                        "missing_value": "9.99999962E35"
                    }
                },
                "NAO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NAO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NAO_pattern": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NAO_pattern",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "NAO Loading Pattern",
                        "missing_value": "9.99999962E35"
                    },
                    "NAO_index": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NAO_index",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "NAO Index",
                        "missing_value": "9.99999962E35"
                    }
                }
            }
        },
        "CPC_Indices": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CPC_Indices",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NHTI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NHTI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "West Pacific Pattern"
                },
                "TNH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TNH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "Tropical - Northern Hemisphere Pattern"
                },
                "SCA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SCA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "Scandinavia Pattern"
                },
                "PT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "Pacific Transition Pattern"
                },
                "POL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "POL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "Polar - Eurasia Pattern"
                },
                "PNA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PNA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "Pacific - North American Pattern"
                },
                "NAO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NAO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "North Atlantic Oscillation"
                },
                "ExplVar": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ExplVar",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "percent",
                    "expires": "1617494400",
                    "long_name": "Explained Variance of leading 10 modes"
                },
                "EPNP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EPNP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "East Pacific/North Pacific Pattern"
                },
                "EAWR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EAWR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "East Atlantic/West Russia Pattern"
                },
                "EA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "units": "unitless",
                    "expires": "1617494400",
                    "long_name": "East Atlantic Pattern"
                }
            }
        },
        "T_17": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_17",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_16": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_16",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "expires": "1617667200",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_15": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_15",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "expires": "1614902400",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "0"
        },
        "T_14": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_14",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_12": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_12",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_11": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_11",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "T_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "4"
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "4"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "3.0"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "12.0"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "modulo": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "long_name": "longitude",
            "pointwidth": "2.5"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "long_name": "latitude",
            "pointwidth": "2.5"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "expires": "1617494400",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/Indices"
    },
    "JAMSTEC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "JAMSTEC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SINTEXF_1Octdescription": "Dec-March monthly data predicted from 1Oct  based on SINTEX-F CGCM",
            "SINTEXF_1Novdescription": "Dec-March monthly data predicted from 1Nov  based on SINTEX-F CGCM",
            "SINTEXF_1Maydescription": "June-September monthly data predicted from May-1 start based on SINTEX-F CGCM",
            "SINTEXF_1Jundescription": "Jun-September monthly data predicted from Jun-1 start based on SINTEX-F CGCM",
            "SINTEXF_1Juldescription": "Jul-September monthly data predicted from Jul-1 start based on SINTEX-F CGCM",
            "SINTEXF_1Jandescription": "Jan-March monthly data predicted from 1Jan based on SINTEX-F CGCM",
            "SINTEXF_1Febdescription": "Feb-March monthly data predicted from 1Feb based on SINTEX-F CGCM",
            "SINTEXF_1Decdescription": "Dec-March monthly data predicted from 1Dec  based on SINTEX-F CGCM",
            "SINTEXF_1Augdescription": "Augut-September monthly data predicted from Aug-1 start based on SINTEX-F CGCM",
            "references": "Luo_JJ2005a Luo_JJ2005b Luo_jj2007 Luo_JJ2008a Luo_JJ2008b",
            "description": "Japan Agency for Marine-Earth Science and Technology",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.JAMSTEC/.dataset_documentation.html",
            "Conventions": "IRIDL"
        },
        "SINTEXF_1Oct": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Oct",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Nov": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Nov",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1May": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1May",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Jun": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Jun",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Jul": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Jul",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Jan": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Jan",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Feb": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Feb",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Dec": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Dec",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "SINTEXF_1Aug": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SINTEXF_1Aug",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pointwidth": "1",
                "standard_name": "time",
                "long_name": "Forecast time",
                "units": "months since 1960-01-01",
                "calendar": "360"
            },
            "surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tsurf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tsurf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "surface temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "tprep": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tprep",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "total precipitation",
                    "units": "mm/day",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "TEMP2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TEMP2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "2m air temperature",
                    "units": "C",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "SLP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SLP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "mean sea level pressure",
                    "units": "Pa",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "QVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated specific humidity",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "ALWCVI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ALWCVI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "vertically integrated liquid water cont.",
                    "units": "kg/m2",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            },
            "PressureLevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PressureLevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "v-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "U": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "U",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "u-velocity",
                    "units": "m/s",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "Q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "specific humidity",
                    "units": "kg/kg",
                    "cNZ": "3",
                    "pointwidth": "0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "geopotential height",
                    "units": "gpm",
                    "cNZ": "3",
                    "pointwidth": "0"
                }
            }
        },
        "L_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "forecast_period",
            "long_name": "Lead time"
        },
        "S_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "long_name": "Start time",
            "calendar": "360",
            "standard_name": "forecast_reference_time"
        },
        "S_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "calendar": "360",
            "long_name": "Start time"
        },
        "L_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "forecast_period",
            "long_name": "Lead time"
        },
        "S_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "calendar": "360",
            "long_name": "Start time"
        },
        "S_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "calendar": "360",
            "long_name": "Start time"
        },
        "S_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "calendar": "360"
        },
        "L_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "forecast_period",
            "long_name": "Lead time"
        },
        "S_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "long_name": "Start time",
            "calendar": "360",
            "standard_name": "forecast_reference_time"
        },
        "S_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "long_name": "Start time",
            "calendar": "360",
            "standard_name": "forecast_reference_time"
        },
        "L_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "forecast_period",
            "long_name": "Lead time"
        },
        "S_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "long_name": "Start time",
            "calendar": "360",
            "standard_name": "forecast_reference_time"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "forecast_period",
            "long_name": "Lead time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.125",
            "standard_name": "longitude"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Ensemble member"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "calendar": "360"
        },
        "dir": "SOURCES/JAMSTEC"
    },
    "JONES": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "JONES",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "landseaUEA": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.HadCRUT2",
            "landseadescription": "Combined land/ocean temperature anomaly grids",
            "landonlyUEA": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.CRUTEM2",
            "landonlydescription": "Land air temperature anomaly grids",
            "climUEA": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.climatology/.c6190/",
            "climGCMD_id": "LDEO_JONES",
            "climdescription": "Combined land/ocean temperature climatology",
            "UEA": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/",
            "references": "Jones_etal1986a Jones_etal1986b",
            "description": "Surface temperature anomaly dataset by Jones et. al",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.JONES/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:UEA",
            "Conventions": "IRIDL"
        },
        "landseacuf": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "landsea.cuf",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "t_surface": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "t_surface",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degreeC",
                "long_name": "surface temperature anomaly",
                "missing_value": "32767",
                "scale_factor": "0.01"
            }
        },
        "landonlycuf": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "landonly.cuf",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "t_air": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "t_air",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degreeC",
                "long_name": "air temperature anomaly",
                "missing_value": "32767",
                "scale_factor": "0.01"
            },
            "count": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "count",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dimensionless",
                "long_name": "station count per lat/lon box",
                "missing_value": "-128",
                "add_offset": "128.0"
            }
        },
        "climcuf": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "clim.cuf",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degreeC",
                "long_name": "surface temperature climatology",
                "missing_value": "32767",
                "description": "Combined land/ocean temperature climatology grids, by Phil Jones",
                "scale_factor": "0.01"
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0",
            "long_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "modulo": "12.0",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "5.0",
            "long_name": "longitude"
        },
        "dir": "SOURCES/JONES"
    },
    "KAPLAN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "KAPLAN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RSA_MOHSST5Projectiondescription": "Linear bestfit of the EOF patterns to the data",
            "RSA_MOHSST5OSdescription": "Fixed Interval Optimal Smoother",
            "RSA_MOHSST5OIdescription": "Optimal Interpolation",
            "RSA_MOHSST5KFfdescription": "Kalman filter -- forecast stage",
            "RSA_MOHSST5KFadescription": "Kalman filter -- analysis stage",
            "RSA_MOHSST5references": "Kaplan_etal1998",
            "RSA_MOHSST5dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.RSA_MOHSST5.dataset_documentation.html",
            "RSA_MOHSST5description": "Reduced Space Optimal Analysis of MOHSST5 SST anomaly",
            "RSA_COADS_SLPolddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.RSA_COADS_SLPold.dataset_documentation.html",
            "RSA_COADS_SLP1Projectiondescription": "Linear bestfit of the EOF patterns to the data",
            "RSA_COADS_SLP1OIdescription": "Optimal Interpolation",
            "RSA_COADS_SLP1obsdescription": "COADS data for 4x4 boxes",
            "RSA_COADS_SLP1references": "Kaplan_etal2000",
            "RSA_COADS_SLP1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.RSA_COADS_SLP1.dataset_documentation.html",
            "RSA_COADS_SLP1description": "Reduced Space Optimal Analysis of COADS SLP anomaly",
            "OSxbNCEP2description": "Statistically homogenous concatenation of Kaplan et al [1998] OS SST and Reynolds and Smith [1994] NCEP OI analyses; the latter gets degraded to the resolution of the former",
            "OSxbNCEP2references": "Kaplan_etal1998 Reynolds_Smith1994",
            "OSxbNCEP2note": "revised 13 Sep 2005 and 24 Oct 2005, following the 13 Sep 2005 revision of the Reynolds and Smith Version 2 data set that affected fields from Nov 1981 to Apr 2002",
            "OSxbNCEPreferences": "Kaplan_etal1998 Parker_etal1994 Reynolds_Smith1994",
            "OSxbNCEPdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.OSxbNCEP.dataset_documentation.html",
            "OSxbNCEPdescription": "Statistically homogenous concatenation of Kaplan et al [1998] OS SST and Reynolds and Smith [1994] NCEP OI analyses; the latter gets degraded to the resolution of the former",
            "IndicesWPdescription": "Western Pacific (or Warm Pool) WP index [5S-5N, 120E-170E] from Cane et al. (1996) submitted to Science",
            "IndicesNPdescription": "North Pacific NP index [30N-50N, 150E-120W]",
            "IndicesNINO34long_name": "NINO3.4",
            "IndicesNINO34description": "NINO3.4 index [5S-5N, 170W-120W]",
            "IndicesNINO3description": "NINO3 index [5S-5N, 150W-90W]",
            "IndicesNAidescription": "North Atlantic (intended) NAi index [35N-60N, 60W-0W]",
            "IndicesNAfdescription": "North Atlantic (figure) NAf index [35N-70N, 75W-10W]",
            "IndicesNAcdescription": "North Atlantic (caption) NAc index [30N-50N, 60W-0W]",
            "IndicesGT30description": "Global tropical mean [30S-30N]",
            "IndicesGTdescription": "Global equatorial mean [5S-5N]",
            "IndicesGLdescription": "Global mean [30S-60N]",
            "IndicesEqNAdescription": "Equatorial North Atlantic average  EqNA [5N-20N,80W-15W]",
            "Indicesfdir": "/Data/data2/kaplan/",
            "Indicesreferences": "Kaplan_etal1998 Cane_etal1997",
            "Indicesdescription": "of RSA_MOHSST5; from Kaplan et al. 1998: <i>JGR</i>, <b>103</b>, 18,567-18,589, and  Cane et al. 1997: <i>Science</i>,  <b>275</b>, 957--960, and those related to them",
            "EXTENDEDv2description": "Statistically homogenous concatenation of Kaplan et al [1998] OS SST and Reynolds and Smith [1994] NCEP OI analyses; the latter gets degraded to the resolution of the former",
            "EXTENDEDv2references": "Kaplan_etal1998 Reynolds_Smith1994",
            "EXTENDEDv2note": "revised 13 Sep 2005 and 24 Oct 2005, following the 13 Sep 2005 revision of the Reynolds and Smith Version 2 data set that affected fields from Nov 1981 to Apr 2002",
            "EXTENDEDv1description": "Statistically homogenous concatenation of Kaplan et al [1998] OS SST and Reynolds and Smith [1994] NCEP OI analyses; the latter gets degraded to the resolution of the former",
            "EXTENDEDreferences": "Kaplan_etal1998 Reynolds_Smith1994",
            "EXTENDEDdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.EXTENDED.dataset_documentation.html",
            "COADS_SLPclimreferences": "Kaplan_etal2000",
            "COADS_SLPclimdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KAPLAN/.COADS_SLPclim.dataset_documentation.html",
            "COADS_clim4x4description": "COADS climatology from standard release [1,1a], 1951-1980, 4x4 deg, produced by Y. Kushnir recipe: weighting proportional to number of observations, periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
            "COADS_clim2x2description": "COADS climatology from standard release [1,1a] 1951-1980, 2x2 deg, produced by Y. Kushnir recipe: weighting proportional to number of observations, periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
            "description": "Various datasets by Kaplan et. al",
            "Conventions": "IRIDL",
            "iridlhasSemantics": "iriref:Kaplan_A"
        },
        "unf": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "unf",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "sl_unf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sl_unf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "title": "Sea Level anomaly field of CP model driven by FSU winds",
                "missing_value": "NaN"
            }
        },
        "TPTGsm": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TPTGsm",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slsm_tptg32": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slsm_tptg32",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "title": "Sea Level anomaly field of CP model with data from TP and tide gauge stations assimilated by reduced space OS",
                "missing_value": "NaN"
            }
        },
        "TPsm": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TPsm",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slsm_tp32": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slsm_tp32",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "title": "Sea Level anomaly field of CP model with data from tide gauge stations assimilated by reduced space OS",
                "missing_value": "NaN"
            }
        },
        "TGsm": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TGsm",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slsm_tg32": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slsm_tg32",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "title": "Sea Level anomaly field of CP model with data from tide gauge stations assimilated by reduced space OS",
                "missing_value": "NaN"
            }
        },
        "RSA_MOHSST5": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RSA_MOHSST5",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Projection": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Projection",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "SST anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "Error"
                }
            },
            "OS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "SST anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "Error"
                }
            },
            "OI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "SST anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "Error"
                }
            },
            "Nobs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Nobs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                "missing_value": "32767",
                "description": "Number of observations for 5x5 boxes used in the RS analysis",
                "units": "dimensionless",
                "long_name": "Number of observations"
            },
            "KFf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "KFf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "SST anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "Error"
                }
            },
            "KFa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "KFa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "SST anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; June 96",
                    "history": "Reduced space (80 EOFs)  analysis of MOHSST5 data",
                    "missing_value": "32767",
                    "scale_factor": "0.001",
                    "units": "degreeC",
                    "long_name": "Error"
                }
            }
        },
        "RSA_COADS_SLPold": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RSA_COADS_SLPold",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Ts": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ts",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS OS estimate"
            },
            "Tp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "long_name": "SLP Projection estimate",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "1.00000002E30",
                "Version": "2; June 96"
            },
            "TOI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TOI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS OI estimate"
            },
            "To": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "To",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SST observations"
            },
            "Tf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS KF forecast estimate"
            },
            "Ta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS KF analysis estimate"
            },
            "Nobs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Nobs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "units": "dimensionless",
                "long_name": "Number of independent obs for 4x4 box"
            },
            "ers": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ers",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS OS error"
            },
            "erp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "erp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "long_name": "SLP Projection error",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "1.00000002E30",
                "Version": "2; June 96"
            },
            "erOI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "erOI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS OI error"
            },
            "erf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "erf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS KF forecast error"
            },
            "era": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "era",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Version": "2; June 96",
                "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                "missing_value": "32767",
                "scale_factor": "0.005",
                "units": "mb",
                "long_name": "SLP RS KF analysis error"
            }
        },
        "RSA_COADS_SLP1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RSA_COADS_SLP1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Projection": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Projection",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "slpa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slpa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "long_name": "SLP anomaly",
                    "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                    "missing_value": "1.00000002E30",
                    "Version": "2; Sep 97"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "long_name": "error",
                    "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                    "missing_value": "1.00000002E30",
                    "Version": "2; Sep 97"
                }
            },
            "OI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "slpa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slpa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; Sep 97",
                    "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                    "missing_value": "32767",
                    "scale_factor": "0.005",
                    "units": "mb",
                    "long_name": "SLP anomaly"
                },
                "err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; Sep 97",
                    "history": "Reduced space (80 EOFs)  analysis of COADS SLP data",
                    "missing_value": "32767",
                    "scale_factor": "0.005",
                    "units": "mb",
                    "long_name": "error"
                }
            },
            "obs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "obs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "slpa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slpa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; Sep 97",
                    "history": "COADS SLP anomaly",
                    "missing_value": "32767",
                    "scale_factor": "0.005",
                    "units": "mb",
                    "long_name": "SLP observations"
                },
                "Nobs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Nobs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Version": "2; Sep 97",
                    "history": "COADS observations",
                    "missing_value": "32767",
                    "units": "dimensionless",
                    "long_name": "Number of obs inside 4x4 box"
                }
            }
        },
        "OSxbNCEP2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "OSxbNCEP2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ssta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ssta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Celsius",
                "long_name": "SST anomaly",
                "history": "OS extended by NCEP",
                "missing_value": "1.00000002E30"
            }
        },
        "OSxbNCEP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "OSxbNCEP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ssta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ssta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Celsius",
                "long_name": "SST anomaly",
                "history": "OS extended by NCEP",
                "missing_value": "1.00000002E30"
            }
        },
        "Indices": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Indices",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "WP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NINO34": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NINO34",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NINO3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NINO3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NAi": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NAi",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NAf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NAf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "NAc": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NAc",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "Error from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "GT30": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GT30",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "GT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "GL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            },
            "EqNA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "EqNA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "avOS_err": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS_err",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Error",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "scale_factor": "1.4142135",
                    "missing_value": "1.00000002E30"
                },
                "avOS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avOS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from the analysis of Kaplan et al. (1996) submitted to JGR",
                    "missing_value": "1.00000002E30"
                },
                "avGOSTA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "avGOSTA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "SST anomaly",
                    "units": "degreeC",
                    "description": "from GOSTA (MOHSST5)",
                    "missing_value": "1.00000002E30"
                }
            }
        },
        "EXTENDED": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "EXTENDED",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_Celsius",
                    "long_name": "SST anomaly",
                    "history": "OS extended by NCEP",
                    "missing_value": "1.00000002E30"
                }
            },
            "v1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_Celsius",
                    "long_name": "SST anomaly",
                    "history": "OS extended by NCEP",
                    "missing_value": "1.00000002E30"
                }
            }
        },
        "COADS_windclim": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "COADS_windclim",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "w": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "w",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "windspeed",
                "description": "COADS windspeed (m/s) climatology, 1951-1980, 4x4 deg, produced by Y. Kushnir recipe: periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "meridional wind",
                "description": "COADS meridional wind (m/s) climatology, 1951-1980, 4x4 deg, produced by Y. Kushnir recipe: periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "zonal wind",
                "description": "COADS zonal wind (m/s) climatology, 1951-1980, 4x4 deg, produced by Y. Kushnir recipe: periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            }
        },
        "COADS_SLPclim": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "COADS_SLPclim",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "description": "COADS sea level pressure (mb) climatology for RS OI, 1951-1980, 4x4 deg, produced by Y. Kushnir recipe: periodic 1-2-1 filtering  in time, 4th order Shapiro filter in space",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            }
        },
        "COADS_clim4x4": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "COADS_clim4x4",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "w": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "w",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "windspeed",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "meridional wind",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "zonal wind",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "long_name": "sea level pressure",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            }
        },
        "COADS_clim2x2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "COADS_clim2x2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "w": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "w",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "windspeed",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "meridional wind",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "zonal wind",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "long_name": "sea level pressure",
                "missing_value": "NaN",
                "file_missing_value": "1.00000002E30"
            }
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "long_name": "Latitude"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "2.0",
            "long_name": "Longitude"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "1665.0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "modulo": "1665.0",
            "calendar": "360"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "modulus": "360.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "4.0",
            "long_name": "Longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "4.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "4.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.0",
            "modulus": "360.0"
        },
        "dir": "SOURCES/KAPLAN"
    },
    "KEELING": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "KEELING",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MAUNA_LOAreferences": "Keeling_etal1996 Keeling_etal1989 Keeling_etal1995",
            "MAUNA_LOAdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.KEELING/.MAUNA_LOA.dataset_documentation.html",
            "iridlhasSemantics": "iridl:SIO",
            "Conventions": "IRIDL"
        },
        "MAUNA_LOA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MAUNA_LOA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "co2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "co2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ppmv",
                "long_name": "co2",
                "missing_value": "-99.989998",
                "iridlhasSemantics": "iridl:AtmosphericCO2",
                "file_missing_value": "-99.989998"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "360"
        },
        "dir": "SOURCES/KEELING"
    },
    "LDEO": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/LDEO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "LDEO",
        "restriction": "Public",
        "Deep_Sea_Core": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Deep_Sea_Core",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "references": "Lotti1994",
                "description": "Deep sea core data from Lamont-Doherty Earth Observatory",
                "Conventions": "IRIDL"
            },
            "water_depth": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "water_depth",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m"
            },
            "Type": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Type",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CLIST": "p",
                "scale_max": "8",
                "scale_min": "1",
                "units": "ids"
            },
            "tw_length": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tw_length",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "-180.0",
                "scale_max": "180.0",
                "units": "degree_east"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north"
            },
            "date": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "date",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "0",
                "calendar": "standard",
                "units": "julian_day",
                "pointwidth": "1"
            },
            "core_length": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "core_length",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "basal_age": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "basal_age",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CLIST": " Upper, Late Lower Cretaceous",
                "scale_max": "35",
                "scale_min": "1",
                "units": "ids"
            },
            "core": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "core",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "core"
            },
            "dir": "SOURCES/LDEO/Deep_Sea_Core"
        },
        "TRL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TRL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NADAv2a2008description": "North American Drought Atlas Version 2a, 2008, North American Summer PDSI Reconstructions",
                "NADAv2a2008readmeNADAv22008": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/drought/NAmericanDroughtAtlas.v2/readme-NADAv2-2008.txt",
                "NADAv2a2008Data": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/drought/NAmericanDroughtAtlas.v2/",
                "NADAv2a2008NADA": "http://iridl.ldeo.columbia.edu/SOURCES/.LDEO/.TRL/.NADA2004/.pdsi-atlas.html",
                "NADA2004long_name": "North American Drought Atlas 2004",
                "NADA2004references": "Cook_etal2004",
                "NADA2004iridlhasSemantics": "gcmd:Tree_Rings",
                "NADA2004pdsiatlas": "http://iridl.ldeo.columbia.edu/SOURCES/.LDEO/.TRL/.NADA2004/.pdsi-atlas.html",
                "MADAlong_name": "Monsoon Asia Drought Atlas",
                "MADAreferences": "Cook_etal2010",
                "MADAdescription": "Reconstruction of Palmer Drought Severity Index for Monsoon Asia  based on tree ring data",
                "MADAiridlhasSemantics": "gcmd:Tree_Rings",
                "MADAAsian_Overview": "http://www.ldeo.columbia.edu/res/fac/trl/research/AsiaMonsoon/AsiaOverview.html",
                "long_name": "Tree Ring Laboratory",
                "Conventions": "IRIDL"
            },
            "NADAv2a2008": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NADAv2a-2008",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PDSI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PDSI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-10.0",
                    "scale_max": "10.0",
                    "missing_value": "-999.0",
                    "long_name": "Palmer Drought Severity Index, Jun-Aug",
                    "units": "unitless",
                    "short_name": "PDSI_JJA"
                }
            },
            "NADA2004": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NADA2004",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pdsi": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pdsi",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "5.9591837",
                    "maxncolor": "150",
                    "ncolor": "150",
                    "scale_min": "-5.9591837",
                    "CS": "-5.9591837",
                    "CE": "5.9591837",
                    "colormap": "12632256",
                    "missing_value": "-999.0",
                    "units": "unitless",
                    "iridlhasSemantics": "iridl:PalmerDroughtSeverityIndex"
                }
            },
            "MADA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MADA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "pdsi": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pdsi",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.999001",
                    "iridlhasSemantics": "iridl:PalmerDroughtSeverityIndex",
                    "units": "unitless"
                }
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "3"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "2.5",
                "long_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "long_name": "latitude"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0",
                "standard_name": "time"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "2.5"
            },
            "dir": "SOURCES/LDEO/TRL"
        },
        "Takahashi": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Takahashi",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "hf90long_name": "half 1990 atmospheric correction",
                "dp90long_name": "full 1990 atmospheric correction",
                "description": "Sea-air pCO2 differences and carbon flux data over the global oceans from Lamont-Doherty Earth Observatory",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.LDEO/.Takahashi/.dataset_documentation.html",
                "Conventions": "IRIDL"
            },
            "hf90": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hf90",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "seaair": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sea-air",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pCO2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pCO2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "150.0",
                        "scale_min": "-150.0",
                        "CS": "-150",
                        "CE": "150",
                        "units": "micro atm",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "correlationcolorscale",
                        "colormap": "2763429",
                        "long_name": "pCO2",
                        "missing_value": "NaN"
                    }
                }
            },
            "dp90": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dp90",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "seaair": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sea-air",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pCO2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pCO2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "150.0",
                        "scale_min": "-150.0",
                        "CS": "-150",
                        "CE": "150",
                        "units": "micro atm",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "correlationcolorscale",
                        "colormap": "2763429",
                        "long_name": "pCO2",
                        "missing_value": "NaN"
                    }
                }
            },
            "annual": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "annual",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "carbon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "carbon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "10.0",
                    "scale_min": "-10.0",
                    "CS": "-10",
                    "CE": "10",
                    "units": "10^12 gram/year/4x5 degree box",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "colormap": "2763429",
                    "long_name": "carbon flux",
                    "missing_value": "NaN"
                }
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "4.0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/LDEO/Takahashi"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Deep_Sea_Core",
            "TRL",
            "Takahashi"
        ]
    },
    "LEVITUS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "LEVITUS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Objectively analyzed fields of major ocean parameters at the annual, seasonal, and monthly time scales; Superceded by LEVITUS94",
            "references": "Levitus1982",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.LEVITUS/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:Ocean",
            "Conventions": "IRIDL",
            "LEVITUS94": "http://iridl.ldeo.columbia.edu/SOURCES/.LEVITUS94/"
        },
        "SEASONAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SEASONAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius",
                "history": "Levitus Climatological Temperature and Salinity -- Seasonal",
                "missing_value": "-1.00000000E10"
            },
            "sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "p.s.u.",
                "history": "Levitus Climatological Temperature and Salinity -- Seasonal",
                "missing_value": "-1.00000000E10"
            }
        },
        "MONTHLY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MONTHLY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "FORTRAN_format": "F6.3",
                "valid_min": "-5.0",
                "missing_value": "-1.00000000E09",
                "SCALEMAX": "35.0",
                "units": "Celsius",
                "VALIDMAX": "35.0",
                "scale_min": "-5.0",
                "FORMAT": "F6.3",
                "SCALEMIN": "-5.0",
                "valid_max": "35.0",
                "VALIDMIN": "-5.0",
                "FIELDNAM": "Ocean Temperature",
                "UNITS": "deg C",
                "scale_max": "35.0"
            }
        },
        "ANNUAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ANNUAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius",
                "history": "Levitus annual mean climatology",
                "missing_value": "-1.00000000E10"
            },
            "SIO2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SIO2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micro mol/kg",
                "history": "Levitus annual mean climatology",
                "missing_value": "-9.9899998"
            },
            "sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "psu",
                "history": "Levitus annual mean climatology",
                "missing_value": "-1.00000000E10"
            },
            "PO4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PO4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micro mol/kg",
                "history": "Levitus annual mean climatology",
                "missing_value": "-9.9899998"
            },
            "O2SAT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2SAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "pct",
                "missing_value": "-1.00000000E10",
                "history": "Levitus annual mean climatology"
            },
            "O2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mll",
                "missing_value": "-1.00000000E10",
                "history": "Levitus annual mean climatology"
            },
            "NO3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NO3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micro mol/kg",
                "history": "Levitus annual mean climatology",
                "missing_value": "-9.9899998"
            }
        },
        "Z_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "3.0",
            "modulo": "12.0",
            "calendar": "360"
        },
        "Z_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "modulo": "12.0",
            "calendar": "360"
        },
        "Z_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "depth",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/LEVITUS"
    },
    "LEVITUS94": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "LEVITUS94",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "oceanviews2html": "http://iridl.ldeo.columbia.edu/SOURCES/.LEVITUS94/.oceanviews2.html",
            "oceanviewshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.LEVITUS94/.oceanviews.html",
            "WOA98": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA98/",
            "references": "Conkright:etal1994 Levitus:Boyer1994a Levitus:etal1994 Levitus:Boyer1994c",
            "description": "World Ocean Atlas 1994, an atlas of objectively analyzed fields of major ocean parameters at the annual, seasonal, and monthly time scales. Superceeded by WOA98",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.LEVITUS94/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:Ocean",
            "Conventions": "IRIDL"
        },
        "SEASONAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SEASONAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "Temperature",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "p.s.u.",
                "long_name": "Salinity",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "O2SAT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2SAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Oxygen Saturation",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "O2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Dissolved Oxygen",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "AOU": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AOU",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Apparent Oxygen Utilization",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            }
        },
        "MONTHLY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MONTHLY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Zmix": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Zmix",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "mixed layer depth",
                "missing_value": "NaN",
                "units": "m",
                "fnname": "densa",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "file_missing_value": "NaN"
            },
            "theta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "theta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "fnname": "$theta$",
                "units": "degree_Celsius",
                "long_name": "potential temperature",
                "history": "theta $theta$",
                "missing_value": "NaN",
                "file_missing_value": "NaN"
            },
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "Temperature",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "p.s.u.",
                "long_name": "Salinity",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "potdens": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "potdens",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "potential density",
                "fnname": "densa",
                "units": "g/cm3 above 1",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN",
                "file_missing_value": "NaN"
            }
        },
        "ANNUAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ANNUAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "theta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "theta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "potential temperature",
                "history": "theta $theta$",
                "missing_value": "NaN"
            },
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "Temperature",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "SIO2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SIO2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromolar",
                "long_name": "Silicate",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "p.s.u.",
                "long_name": "Salinity",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "rhoa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rhoa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "g/cm3 above 1",
                "long_name": "density",
                "history": "rhoa",
                "missing_value": "NaN"
            },
            "potdens": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "potdens",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "potential density",
                "fnname": "densa",
                "units": "g/cm3 above 1",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "po4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "po4*",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromolar",
                "long_name": "$@ PO sub 4 sup *$",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN",
                "file_missing_value": "NaN"
            },
            "PO4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PO4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromolar",
                "long_name": "Phosphate",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "O2SAT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2SAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Oxygen Saturation",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "O2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Dissolved Oxygen",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "NO3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NO3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromolar",
                "long_name": "Nitrate",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            },
            "AOU": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AOU",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ml/l",
                "long_name": "Apparent Oxygen Utilization",
                "history": "World Ocean Atlas CD-ROM, Levitus et al., 1994",
                "missing_value": "NaN"
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "pointwidth": "3.0",
            "standard_name": "time",
            "long_name": "Time",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Depth"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "modulo": "12.0",
            "calendar": "360"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/LEVITUS94"
    },
    "LSTM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "LSTM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MFAPmolesworth_etal_2003long_name": "Molesworth etal 2003",
            "MFAPmolesworth_etal_2003references": "Molesworth_etal2003",
            "MFAPdescription": "Meningitis Forecasting for Africa Project",
            "MFAPiridlhasSemantics": "iridl:Meningitis",
            "description": "Liverpool School of Tropical Medicine",
            "iridlhasSemantics": "iridl:LSTM",
            "Conventions": "IRIDL"
        },
        "MFAP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MFAP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "molesworth_etal_2003": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "molesworth_etal_2003",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Location Geometry",
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "region": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "region",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "probmen": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "probmen",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "16777215",
                    "scale_max": "1.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "1",
                    "missing_value": "-9999.0",
                    "long_name": "Predicted Probability of Meningitis Epidemic Experience",
                    "units": "unitless",
                    "PGtype": "float8"
                },
                "obsmen": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "obsmen",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "16777215",
                    "scale_max": "2",
                    "maxncolor": "254",
                    "ncolor": "6",
                    "scale_min": "0",
                    "CS": "0",
                    "CE": "2",
                    "missing_value": "-9999",
                    "CLIST": "Province",
                    "long_name": "Observed Meningitis in Historical Record",
                    "units": "unitless",
                    "PGtype": "int8"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-25.0",
                    "scale_max": "55.0",
                    "units": "degree_east",
                    "missing_value": "NaN",
                    "PGtype": "float8"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-40.0",
                    "scale_max": "40.0",
                    "units": "degree_north",
                    "missing_value": "NaN",
                    "PGtype": "float8"
                },
                "district": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "district",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "country": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "country",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "PGtype": "varchar"
                }
            }
        },
        "gid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/LSTM"
    },
    "Lithosphere": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Lithosphere",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Datasets describing the lithosphere",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "Volcano": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Volcano",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Name": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Name",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Name",
                "units": "unitless"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "longitude",
                "units": "degree_east"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "latitude",
                "units": "degree_north"
            }
        },
        "Earthquake": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Earthquake",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "magnitude": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "magnitude",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "magnitude",
                "units": "unitless",
                "scale_factor": "0.1"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "long_name": "longitude",
                "scale_max": "360.0",
                "scale_min": "0.0"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "latitude",
                "units": "degree_north"
            },
            "depth": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "depth",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "depth",
                "units": "km"
            }
        },
        "I_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "I_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "I": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "I",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/Lithosphere"
    },
    "MIT": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/MIT",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "MIT",
        "restriction": "Public",
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ]
    },
    "MODELRUNS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "MODELRUNS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MEQSFCiridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "MEQSFC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MEQSFC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "eliruncdf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "elirun.cdf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "H": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "H",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "RVARID": "3",
                    "history": "ATL2M HELLERMAN 2m S pro model spinup qa",
                    "missing_value": "1.00000002E30",
                    "verbose": "true"
                }
            }
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "date",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/MODELRUNS"
    },
    "MPI": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "MPI",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridlhasSemantics": "iridl:MPI_Met",
            "Conventions": "IRIDL"
        },
        "dir": "SOURCES/MPI"
    },
    "MSJ": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "MSJ",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "stationsdailysemicleaneddescription": "stations with slight name changes were merged",
            "stationsdailysemicleanedlong_name": "1996-2013 observed precipitation",
            "description": "Meteorological Service Jamaica",
            "Conventions": "IRIDL"
        },
        "stations": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "stations",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "semicleaned": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "semicleaned",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "CS": "0",
                        "scale_min": "0.0",
                        "maxncolor": "254",
                        "colorscalename": "precip_colors",
                        "colormap": "290304",
                        "ncolor": "254",
                        "missing_value": "-999.0",
                        "long_name": "precipitation",
                        "units": "mm",
                        "querystring": "select ifNone(d.prec,-999.0) from (select * from stations join jds) sj left join data d on sj.st_id=d.st_id and sj.jd=d.jd order by sj.st_id,sj.jd",
                        "dbinfordsDriver": "sqlite3",
                        "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                        "dbinfotupleType": "1"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-79.361115",
                        "missing_value": "-999.0",
                        "scale_max": "-75.059166",
                        "long_name": "longitude",
                        "units": "degree_east",
                        "querystring": "select ifNone(lon,-999.0) from stations order by st_id",
                        "dbinfordsDriver": "sqlite3",
                        "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                        "dbinfotupleType": "1"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "SpatialReferenceSystemWKT": "]]",
                        "long_name": "location",
                        "scale_min": "-79.361115",
                        "scale_max": "-75.059166",
                        "units": "degree_east",
                        "querystring": "select ifNone(lon,-999.0) from stations order by st_id",
                        "dbinfordsDriver": "sqlite3",
                        "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                        "dbinfotupleType": "1"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "16.785833",
                        "missing_value": "-999.0",
                        "scale_max": "19.497499",
                        "long_name": "latitude",
                        "units": "degree_north",
                        "querystring": "select ifNone(lat,-999.0) from stations order by st_id",
                        "dbinfordsDriver": "sqlite3",
                        "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                        "dbinfotupleType": "1"
                    }
                }
            },
            "Analyses": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Analyses",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Tailored": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Tailored",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-79.361115",
                            "missing_value": "-999.0",
                            "scale_max": "-75.059166",
                            "long_name": "longitude",
                            "units": "degree_east",
                            "querystring": "select ifNone(lon,-999.0) from stations order by st_id",
                            "dbinfordsDriver": "sqlite3",
                            "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                            "dbinfotupleType": "1"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "SpatialReferenceSystemWKT": "]]",
                            "long_name": "location",
                            "scale_min": "-79.361115",
                            "scale_max": "-75.059166",
                            "units": "degree_east",
                            "querystring": "select ifNone(lon,-999.0) from stations order by st_id",
                            "dbinfordsDriver": "sqlite3",
                            "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                            "dbinfotupleType": "1"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "16.785833",
                            "missing_value": "-999.0",
                            "scale_max": "19.497499",
                            "long_name": "latitude",
                            "units": "degree_north",
                            "querystring": "select ifNone(lat,-999.0) from stations order by st_id",
                            "dbinfordsDriver": "sqlite3",
                            "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                            "dbinfotupleType": "1"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1996, 2400 31 Jan 2013] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "querystring": "select ifNone(d.prec,-999.0) from (select * from stations join jds) sj left join data d on sj.st_id=d.st_id and sj.jd=d.jd order by sj.st_id,sj.jd",
                            "dbinfordsDriver": "sqlite3",
                            "dbinfoconnectString": "/data/ikh/data/msj/msj2.db",
                            "dbinfotupleType": "1"
                        }
                    }
                }
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "st_id": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "st_id",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0"
        },
        "dir": "SOURCES/MSJ"
    },
    "MaliMeteo": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "MaliMeteo",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Agence Nationale de la M\\xc3\\xa9t\\xc3\\xa9orologie du Mali",
            "Conventions": "IRIDL"
        },
        "ENACTS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ENACTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "dir": "SOURCES/MaliMeteo"
    },
    "Models": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Models",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Models",
        "restriction": "Public",
        "AMIP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "AMIP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "BClong_name": "Boundary Conditions",
                "BCdescription": "Sea surface temperature boundary conditions from the Atmospheric Model Intercomparison Project",
                "references": "Gates1992 Gates_etal1999",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.AMIP/.dataset_documentation.html",
                "iridlhasSemantics": "iridl:WCRP",
                "Conventions": "IRIDL"
            },
            "BC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "BC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "long_name": "sea surface temperature"
                }
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "4.0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/Models/AMIP"
        },
        "NMME": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Models/NMME",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "NMME",
            "restriction": "Public",
            "CMC1CanCM3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CMC1-CanCM3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc8110long_name": "1981-2010 Seasonal Climatology",
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTmc8110long_name": "1981-2010 Monthly Climatology",
                    "FORECASTMONTHLYorigACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYorigdescription": "original entry",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYIMPORTANT": "Users who accessed CMC1-CanCM3 and CMC2-CanCM4 FORECAST sea surface temperature (sst) and reference temperature (tref) variables between 23 Feb 2016 and 24 Oct 2016 for forecast start times before 1 Jan 2015 (start times between 1 Jan 2011 and 1 Dec 2014) from the IRI Data Library NMME archive should be aware that they may have downloaded data indexed with the wrong start time (12-month shift) due to a data archiving error.  This error was corrected in this dataset as of 24 Oct 2016.",
                    "GEMNEMO": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.GEM-NEMO/",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "air_temperature",
                            "grib_name": "TMP",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "105",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribNumBits": "16",
                            "gribparam": "11"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "long_name": "Sea Surface Temperature",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "sea_surface_temperature",
                            "grib_name": "WTMP",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "1",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribNumBits": "16",
                            "gribparam": "80"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "long_name": "Total Precipitation",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "1",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribNumBits": "16",
                            "gribparam": "59"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gribcenter": "54",
                            "units": "meter second-1",
                            "long_name": "Meridional Wind",
                            "gribNumBits": "16",
                            "gribvariable": "34",
                            "standard_name": "northward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "34",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "VGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gribcenter": "54",
                            "units": "meter second-1",
                            "long_name": "Zonal Wind",
                            "gribNumBits": "16",
                            "gribvariable": "33",
                            "standard_name": "eastward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "33",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "UGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Reference Temperature at 2 Meters",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribvariable": "11",
                            "gribfield": "1",
                            "gribleveltype": "100",
                            "gribcenter": "54",
                            "long_name": "850 hPa Temperature",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Minimum Temperature at 2 Meters",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "16",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Maximum Temperature at 2 Meters",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "15",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Sea Surface Temperature",
                            "gribNumBits": "16",
                            "standard_name": "sea_surface_temperature",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribparam": "80",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                            "gribNumBits": "16",
                            "standard_name": "soil_moisture_content",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "127",
                            "PDS_TimeRange": "0",
                            "center": "Montreal (RSMC)",
                            "grib_name": "IMGD",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "gribNumBits": "16",
                            "standard_name": "air_pressure_at_sea_level",
                            "gribleveltype": "102",
                            "missing_value": "9.99900026E20",
                            "gribparam": "2",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Total Precipitation",
                            "gribNumBits": "16",
                            "standard_name": "lwe_precipitation_rate",
                            "gribleveltype": "1",
                            "gribparam": "59",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gribcenter": "54",
                            "units": "gpm",
                            "long_name": "Geopotential Height",
                            "gribNumBits": "16",
                            "gribvariable": "7",
                            "standard_name": "geopotential_height",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "7",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "HGT",
                            "gribfield": "1",
                            "pointwidth": "0"
                        }
                    },
                    "mc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "air_temperature",
                            "grib_name": "TMP",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "105",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribNumBits": "16",
                            "gribparam": "11"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "long_name": "Sea Surface Temperature",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "sea_surface_temperature",
                            "grib_name": "WTMP",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "1",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribNumBits": "16",
                            "gribparam": "80"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "long_name": "Total Precipitation",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribleveltype": "1",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribNumBits": "16",
                            "gribparam": "59"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY vgrd",
                            "gribcenter": "54",
                            "units": "meter second-1",
                            "long_name": "Meridional Wind",
                            "gribNumBits": "16",
                            "gribvariable": "34",
                            "standard_name": "northward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "34",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "VGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY ugrd",
                            "gribcenter": "54",
                            "units": "meter second-1",
                            "long_name": "Zonal Wind",
                            "gribNumBits": "16",
                            "gribvariable": "33",
                            "standard_name": "eastward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "33",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "UGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tref",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmp",
                            "gribcenter": "54",
                            "units": "Kelvin_scale",
                            "long_name": "850 hPa Temperature",
                            "gribNumBits": "16",
                            "gribvariable": "11",
                            "standard_name": "air_temperature",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Minimum Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmin",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "gribNumBits": "16",
                            "standard_name": "air_temperature",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "16",
                            "PDS_TimeRange": "2",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Maximum Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmax",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "gribNumBits": "16",
                            "standard_name": "air temperature",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "15",
                            "PDS_TimeRange": "2",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY sst",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Sea Surface Temperature",
                            "gribNumBits": "16",
                            "standard_name": "sea_surface_temperature",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribparam": "80",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY soilw",
                            "units": "kg m-2",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                            "gribNumBits": "16",
                            "standard_name": "soil_moisture_content",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "127",
                            "PDS_TimeRange": "0",
                            "center": "Montreal (RSMC)",
                            "grib_name": "IMGD",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prmsl",
                            "units": "Pa",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "gribNumBits": "16",
                            "standard_name": "air_pressure_at_sea_level",
                            "gribleveltype": "102",
                            "missing_value": "9.99900026E20",
                            "gribparam": "2",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prec",
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "gribfield": "1",
                            "gribcenter": "54",
                            "long_name": "Total Precipitation",
                            "gribNumBits": "16",
                            "standard_name": "lwe_precipitation_rate",
                            "gribleveltype": "1",
                            "gribparam": "59",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "orig": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "orig",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vgrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribcenter": "54",
                                "units": "meter second-1",
                                "long_name": "Meridional Wind",
                                "gribNumBits": "16",
                                "gribvariable": "34",
                                "standard_name": "northward_wind",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribparam": "34",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "VGRD",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "ugrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribcenter": "54",
                                "units": "meter second-1",
                                "long_name": "Zonal Wind",
                                "gribNumBits": "16",
                                "gribvariable": "33",
                                "standard_name": "eastward_wind",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribparam": "33",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "UGRD",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Reference Temperature at 2 Meters",
                                "gribNumBits": "16",
                                "standard_name": "air_temperature",
                                "gribleveltype": "105",
                                "missing_value": "9.99900026E20",
                                "gribparam": "11",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMP",
                                "pointwidth": "0"
                            },
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribcenter": "54",
                                "units": "Kelvin_scale",
                                "long_name": "850 hPa Temperature",
                                "gribNumBits": "16",
                                "gribvariable": "11",
                                "standard_name": "air_temperature",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribparam": "11",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMP",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Minimum Temperature at 2 Meters",
                                "gribNumBits": "16",
                                "standard_name": "air_temperature",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "16",
                                "PDS_TimeRange": "2",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMIN",
                                "pointwidth": "0"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Maximum Temperature at 2 Meters",
                                "gribNumBits": "16",
                                "standard_name": "air temperature",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "15",
                                "PDS_TimeRange": "2",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMAX",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Time",
                                "pointwidth": "1.0",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Sea Surface Temperature",
                                "gribNumBits": "16",
                                "standard_name": "sea_surface_temperature",
                                "gribleveltype": "1",
                                "missing_value": "9.99900026E20",
                                "gribparam": "80",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "WTMP",
                                "pointwidth": "0"
                            },
                            "soilw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg m-2",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                "gribNumBits": "16",
                                "standard_name": "soil_moisture_content",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "127",
                                "PDS_TimeRange": "0",
                                "center": "Montreal (RSMC)",
                                "grib_name": "IMGD",
                                "pointwidth": "0"
                            },
                            "prmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Pressure Reduced to Mean Sea Level",
                                "gribNumBits": "16",
                                "standard_name": "air_pressure_at_sea_level",
                                "gribleveltype": "102",
                                "missing_value": "9.99900026E20",
                                "gribparam": "2",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "PRMSL",
                                "pointwidth": "0"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "gribfield": "1",
                                "gribcenter": "54",
                                "long_name": "Total Precipitation",
                                "gribNumBits": "16",
                                "standard_name": "lwe_precipitation_rate",
                                "gribleveltype": "1",
                                "gribparam": "59",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "PRATE",
                                "pointwidth": "0"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribcenter": "54",
                                "units": "gpm",
                                "long_name": "Geopotential Height",
                                "gribNumBits": "16",
                                "gribvariable": "7",
                                "standard_name": "geopotential_height",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribparam": "7",
                                "PDS_TimeRange": "10",
                                "center": "Montreal (RSMC)",
                                "grib_name": "HGT",
                                "gribfield": "1",
                                "pointwidth": "0"
                            }
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY hgt",
                            "gribcenter": "54",
                            "units": "gpm",
                            "long_name": "Geopotential Height",
                            "gribNumBits": "16",
                            "gribvariable": "7",
                            "standard_name": "geopotential_height",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribparam": "7",
                            "PDS_TimeRange": "10",
                            "center": "Montreal (RSMC)",
                            "grib_name": "HGT",
                            "gribfield": "1",
                            "pointwidth": "0"
                        }
                    }
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "S_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead",
                    "standard_name": "forecast_period"
                },
                "S_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulo": "12.0",
                    "long_name": "Forecast Start Time",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "defaultvalue": "714.0"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "long_name": "Pressure Level"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "defaultvalue": "714.0"
                },
                "dir": "SOURCES/Models/NMME/CMC1-CanCM3"
            },
            "CMC2CanCM4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CMC2-CanCM4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc8110long_name": "1981-2010 Seasonal Climatology",
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTmc8110long_name": "1981-2010 Monthly Climatology",
                    "FORECASTMONTHLYorigACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYorigreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYorigdescription": "original entry",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYIMPORTANT": "Users who accessed CMC1-CanCM3 and CMC2-CanCM4 FORECAST sea surface temperature (sst) and reference temperature (tref) variables between 23 Feb 2016 and 24 Oct 2016 for forecast start times before 1 Jan 2015 (start times between 1 Jan 2011 and 1 Dec 2014) from the IRI Data Library NMME archive should be aware that they may have downloaded data indexed with the wrong start time (12-month shift) due to a data archiving error.  This error was corrected in this dataset as of 24 Oct 2016.",
                    "CanCM4i": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.CanCM4i/",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "air_temperature",
                            "grib_name": "TMP",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "105",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribparam": "11"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "long_name": "Sea Surface Temperature",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "sea_surface_temperature",
                            "grib_name": "WTMP",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "1",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribparam": "80"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "center": "Montreal (RSMC)",
                            "long_name": "Total Precipitation",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "1",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                            "gribparam": "59"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vrgd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vrgd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "meter second-1",
                            "PDS_TimeRange": "10",
                            "long_name": "Meridional Wind",
                            "gribcenter": "54",
                            "gribvariable": "34",
                            "standard_name": "northward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "34",
                            "center": "Montreal (RSMC)",
                            "grib_name": "VGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "meter second-1",
                            "PDS_TimeRange": "10",
                            "long_name": "Meridional Wind",
                            "gribcenter": "54",
                            "gribvariable": "34",
                            "standard_name": "northward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "34",
                            "center": "Montreal (RSMC)",
                            "grib_name": "VGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "meter second-1",
                            "PDS_TimeRange": "10",
                            "long_name": "Zonal Wind",
                            "gribcenter": "54",
                            "gribvariable": "33",
                            "standard_name": "eastward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "33",
                            "center": "Montreal (RSMC)",
                            "grib_name": "UGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "Reference Temperature at 2 Meters",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribvariable": "11",
                            "gribfield": "1",
                            "gribleveltype": "100",
                            "long_name": "850 hPa Temperature",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "Minimum Temperature at 2 Meters",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "16",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "Maximum Temperature at 2 Meters",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "15",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "Sea Surface Temperature",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "sea_surface_temperature",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribparam": "80",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "gribfield": "1",
                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                            "PDS_TimeRange": "0",
                            "gribcenter": "54",
                            "standard_name": "soil_moisture_content",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "127",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "IMGD",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "gribfield": "1",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_pressure_at_sea_level",
                            "gribleveltype": "102",
                            "missing_value": "9.99900026E20",
                            "gribparam": "2",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "gribfield": "1",
                            "long_name": "Total Precipitation",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "lwe_precipitation_rate",
                            "gribleveltype": "1",
                            "gribparam": "59",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "gpm",
                            "PDS_TimeRange": "10",
                            "long_name": "Geopotential Height",
                            "gribcenter": "54",
                            "gribvariable": "7",
                            "standard_name": "geopotential_height",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "7",
                            "center": "Montreal (RSMC)",
                            "grib_name": "HGT",
                            "gribfield": "1",
                            "pointwidth": "0"
                        }
                    },
                    "mc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "air_temperature",
                            "grib_name": "TMP",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "105",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribparam": "11"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "center": "Montreal (RSMC)",
                            "long_name": "Sea Surface Temperature",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "sea_surface_temperature",
                            "grib_name": "WTMP",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "1",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribparam": "80"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "center": "Montreal (RSMC)",
                            "long_name": "Total Precipitation",
                            "gribcenter": "54",
                            "file_missing_value": "9.99900026E20",
                            "missing_value": "NaN",
                            "pointwidth": "0",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "PDS_TimeRange": "10",
                            "gribfield": "1",
                            "gribleveltype": "1",
                            "gribNumBits": "16",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "gribparam": "59"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY vgrd",
                            "units": "meter second-1",
                            "PDS_TimeRange": "10",
                            "long_name": "Meridional Wind",
                            "gribcenter": "54",
                            "gribvariable": "34",
                            "standard_name": "northward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "34",
                            "center": "Montreal (RSMC)",
                            "grib_name": "VGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY ugrd",
                            "units": "meter second-1",
                            "PDS_TimeRange": "10",
                            "long_name": "Zonal Wind",
                            "gribcenter": "54",
                            "gribvariable": "33",
                            "standard_name": "eastward_wind",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "33",
                            "center": "Montreal (RSMC)",
                            "grib_name": "UGRD",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tref",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "missing_value": "9.99900026E20",
                            "gribparam": "11",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmp",
                            "units": "Kelvin_scale",
                            "PDS_TimeRange": "10",
                            "long_name": "850 hPa Temperature",
                            "gribcenter": "54",
                            "gribvariable": "11",
                            "standard_name": "air_temperature",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "11",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMP",
                            "gribfield": "1",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Minimum Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmin",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "PDS_TimeRange": "2",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "16",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Maximum Temperature at 2 Meters",
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmax",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "PDS_TimeRange": "2",
                            "gribcenter": "54",
                            "standard_name": "air_temperature",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "15",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY sst",
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "Sea Surface Temperature",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "sea_surface_temperature",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribparam": "80",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY soilw",
                            "units": "kg m-2",
                            "gribfield": "1",
                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                            "PDS_TimeRange": "0",
                            "gribcenter": "54",
                            "standard_name": "soil_moisture_content",
                            "gribleveltype": "119",
                            "missing_value": "9.99900026E20",
                            "gribparam": "127",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "IMGD",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prmsl",
                            "units": "Pa",
                            "gribfield": "1",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "air_pressure_at_sea_level",
                            "gribleveltype": "102",
                            "missing_value": "9.99900026E20",
                            "gribparam": "2",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prec",
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "gribfield": "1",
                            "long_name": "Total Precipitation",
                            "PDS_TimeRange": "10",
                            "gribcenter": "54",
                            "standard_name": "lwe_precipitation_rate",
                            "gribleveltype": "1",
                            "gribparam": "59",
                            "gribNumBits": "16",
                            "center": "Montreal (RSMC)",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "orig": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "orig",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vgrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meter second-1",
                                "PDS_TimeRange": "10",
                                "long_name": "Meridional Wind",
                                "gribcenter": "54",
                                "gribvariable": "34",
                                "standard_name": "northward_wind",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribNumBits": "16",
                                "gribparam": "34",
                                "center": "Montreal (RSMC)",
                                "grib_name": "VGRD",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "ugrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meter second-1",
                                "PDS_TimeRange": "10",
                                "long_name": "Zonal Wind",
                                "gribcenter": "54",
                                "gribvariable": "33",
                                "standard_name": "eastward_wind",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribNumBits": "16",
                                "gribparam": "33",
                                "center": "Montreal (RSMC)",
                                "grib_name": "UGRD",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Reference Temperature at 2 Meters",
                                "PDS_TimeRange": "10",
                                "gribcenter": "54",
                                "standard_name": "air_temperature",
                                "gribleveltype": "105",
                                "missing_value": "9.99900026E20",
                                "gribparam": "11",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMP",
                                "pointwidth": "0"
                            },
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "PDS_TimeRange": "10",
                                "long_name": "850 hPa Temperature",
                                "gribcenter": "54",
                                "gribvariable": "11",
                                "standard_name": "air_temperature",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribNumBits": "16",
                                "gribparam": "11",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMP",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Minimum Temperature at 2 Meters",
                                "PDS_TimeRange": "2",
                                "gribcenter": "54",
                                "standard_name": "air_temperature",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "16",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMIN",
                                "pointwidth": "0"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Maximum Temperature at 2 Meters",
                                "PDS_TimeRange": "2",
                                "gribcenter": "54",
                                "standard_name": "air_temperature",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "15",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "TMAX",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Time",
                                "pointwidth": "1.0",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Sea Surface Temperature",
                                "PDS_TimeRange": "10",
                                "gribcenter": "54",
                                "standard_name": "sea_surface_temperature",
                                "gribleveltype": "1",
                                "missing_value": "9.99900026E20",
                                "gribparam": "80",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "WTMP",
                                "pointwidth": "0"
                            },
                            "soilw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg m-2",
                                "gribfield": "1",
                                "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                "PDS_TimeRange": "0",
                                "gribcenter": "54",
                                "standard_name": "soil_moisture_content",
                                "gribleveltype": "119",
                                "missing_value": "9.99900026E20",
                                "gribparam": "127",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "IMGD",
                                "pointwidth": "0"
                            },
                            "prmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "long_name": "Pressure Reduced to Mean Sea Level",
                                "PDS_TimeRange": "10",
                                "gribcenter": "54",
                                "standard_name": "air_pressure_at_sea_level",
                                "gribleveltype": "102",
                                "missing_value": "9.99900026E20",
                                "gribparam": "2",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "PRMSL",
                                "pointwidth": "0"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "gribfield": "1",
                                "long_name": "Total Precipitation",
                                "PDS_TimeRange": "10",
                                "gribcenter": "54",
                                "standard_name": "lwe_precipitation_rate",
                                "gribleveltype": "1",
                                "gribparam": "59",
                                "gribNumBits": "16",
                                "center": "Montreal (RSMC)",
                                "grib_name": "PRATE",
                                "pointwidth": "0"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "gpm",
                                "PDS_TimeRange": "10",
                                "long_name": "Geopotential Height",
                                "gribcenter": "54",
                                "gribvariable": "7",
                                "standard_name": "geopotential_height",
                                "gribleveltype": "100",
                                "missing_value": "9.99900026E20",
                                "gribNumBits": "16",
                                "gribparam": "7",
                                "center": "Montreal (RSMC)",
                                "grib_name": "HGT",
                                "gribfield": "1",
                                "pointwidth": "0"
                            }
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY hgt",
                            "units": "gpm",
                            "PDS_TimeRange": "10",
                            "long_name": "Geopotential Height",
                            "gribcenter": "54",
                            "gribvariable": "7",
                            "standard_name": "geopotential_height",
                            "gribleveltype": "100",
                            "missing_value": "9.99900026E20",
                            "gribNumBits": "16",
                            "gribparam": "7",
                            "center": "Montreal (RSMC)",
                            "grib_name": "HGT",
                            "gribfield": "1",
                            "pointwidth": "0"
                        }
                    }
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "S_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead",
                    "standard_name": "forecast_period"
                },
                "S_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulo": "12.0",
                    "long_name": "Forecast Start Time",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "defaultvalue": "714.0"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "long_name": "Pressure Level"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "defaultvalue": "714.0"
                },
                "dir": "SOURCES/Models/NMME/CMC2-CanCM4"
            },
            "COLARSMASCCSM3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "COLA-RSMAS-CCSM3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8210long_name": "1982-2010 Seasonal Climatology",
                    "MONTHLYTitle": "CCSM3.0 MULTI-ENSEMBLES project",
                    "MONTHLYCreated": "Fri Aug  5 17:25:32 EDT 2011",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYConventions": "CF-1.0",
                    "MONTHLYComment": "Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu)",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.COLA-RSMAS-CCSM3/.MONTHLY.dataset_documentation.html",
                    "MONTHLYReferences": "Ben P. Kirtman, Dughong Min. (2009) Multimodel Ensemble ENSO Prediction with CCSM and CFS. Monthly Weather Review 137:9, 2908-2930",
                    "MONTHLYGenerator": "NCL v.5.0",
                    "mc8210long_name": "1982-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "units": "Celsius_scale",
                        "cell_method": "time: mean",
                        "lon": "358.59375",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM3 MONTHLY tref ]) [(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "88.927734",
                        "defaultvalue": "677.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "cell_methods": "time: mean",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM3 MONTHLY sst ]) [(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "89.5",
                        "defaultvalue": "677.0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "lon": "358.59375",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM3 MONTHLY prec ]) [(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "88.927734",
                        "defaultvalue": "677.0"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tsmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tsmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Maximum surface temperature over output period",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: maximum",
                        "pointwidth": "0"
                    },
                    "tsmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tsmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Minimum surface temperature over output period",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: minimum",
                        "pointwidth": "0"
                    },
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: mean",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "standard_name": "sea_surface_temperature",
                        "lat": "89.5",
                        "missing_value": "9.96920997E36",
                        "cell_methods": "time: mean",
                        "pointwidth": "0"
                    },
                    "soilw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soilw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "lon": "358.59375",
                        "units": "kg/m2",
                        "long_name": " merely sum of soil liquid water over levels",
                        "sum_op_ncl": "dim_sum over dimension(s): levsoi",
                        "standard_name": "soil_moisture_content",
                        "lat": "88.927734",
                        "missing_value": "9.99999962E35",
                        "cell_method": "time: mean",
                        "pointwidth": "0"
                    },
                    "runoff": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "runoff",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface runoff + sub-surface drainage + surface runoff at glaciers, wetlands, lakes",
                        "standard_name": "runoff_flux",
                        "units": "mm/s",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.99999962E35",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.96920997E36",
                        "missing_value": "NaN",
                        "units": "mm/day",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "pointwidth": "0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "Geopotential Height (above sea level)",
                        "standard_name": "geopotential_height",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "evap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "evap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "canopy evaporation",
                        "units": "W/m2",
                        "lon": "358.59375",
                        "lat": "88.927734",
                        "missing_value": "9.99999962E35",
                        "cell_method": "time: mean",
                        "pointwidth": "0"
                    }
                },
                "mc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "units": "Celsius_scale",
                        "cell_method": "time: mean",
                        "lon": "358.59375",
                        "history": "[(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "88.927734",
                        "defaultvalue": "677.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "cell_methods": "time: mean",
                        "history": "[(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "89.5",
                        "defaultvalue": "677.0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "lon": "358.59375",
                        "history": "[(Averaged over M[0.5, 6.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "88.927734",
                        "defaultvalue": "677.0"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "677.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/COLA-RSMAS-CCSM3"
            },
            "COLARSMASCCSM4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "COLA-RSMAS-CCSM4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8210long_name": "1982-2010 Seasonal Climatology",
                    "MONTHLYCreated": "Wed May 7 20:32:28 EDT 2014",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYComment": "Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu)",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYexpires": "1617237720",
                    "MONTHLYReferences": "Ben P. Kirtman, Dughong Min. (2009) Multimodel Ensemble ENSO Prediction with CCSM and CFS. Monthly Weather Review 137:9, 2908-2930",
                    "MONTHLYConventions": "CF-1.0",
                    "MONTHLYTitle": "CCSM4.0 National Multi-Model Ensembles(NMME) project",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "MONTHLYGenerator": "NCL v.5.0",
                    "mc8210long_name": "1982-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "units": "Celsius_scale",
                        "lon": "358.75",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "air_temperature",
                        "cell_method": "time: mean",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "90.0",
                        "defaultvalue": "677.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "cell_methods": "time: mean",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "89.5",
                        "defaultvalue": "677.0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "lon": "358.75",
                        "history": "[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "90.0",
                        "defaultvalue": "677.0"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tsmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tsmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "long_name": "Maximum surface temperature over output period",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: maximum",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "tsmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tsmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "long_name": "Minimum surface temperature over output period",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: minimum",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "units": "Kelvin_scale",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.96920997E36",
                        "cell_method": "time: mean",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "expires": "1617237720",
                        "calendar": "360",
                        "bounds": "S",
                        "defaultvalue": "734.0"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "cell_methods": "time: mean",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "long_name": "Sea Surface Temperature",
                        "units": "Celsius_scale",
                        "standard_name": "sea_surface_temperature",
                        "lat": "89.5",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "soilw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soilw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "lon": "358.75",
                        "sum_op_ncl": "dim_sum over dimension(s): levgrnd",
                        "long_name": " merely sum of soil liquid water over levels",
                        "units": "kg/m2",
                        "standard_name": "soil_moisture_content",
                        "cell_method": "time: mean",
                        "lat": "90.0",
                        "missing_value": "9.99999962E35",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "runoff": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "runoff",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "long_name": "surface runoff + sub-surface drainage + surface runoff at glaciers, wetlands, lakes",
                        "standard_name": "runoff_flux",
                        "units": "mm/s",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.99999962E35",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.96920997E36",
                        "missing_value": "NaN",
                        "units": "mm/day",
                        "expires": "1617237720",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "lon": "358.75",
                        "lat": "90.0",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "units": "m",
                        "long_name": "Geopotential Height (above sea level)",
                        "standard_name": "geopotential_height",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    },
                    "evap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "evap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1617237720",
                        "long_name": "canopy evaporation",
                        "units": "W/m2",
                        "lon": "358.75",
                        "lat": "90.0",
                        "missing_value": "9.99999962E35",
                        "cell_method": "time: mean",
                        "pointwidth": "0",
                        "defaultvalue": "734.0"
                    }
                },
                "mc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "units": "Celsius_scale",
                        "lon": "358.75",
                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "air_temperature",
                        "cell_method": "time: mean",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "90.0",
                        "defaultvalue": "677.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "cell_methods": "time: mean",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                        "pointwidth": "0",
                        "missing_value": "NaN",
                        "lat": "89.5",
                        "defaultvalue": "677.0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "lon": "358.75",
                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "Total Precipitation",
                        "missing_value": "NaN",
                        "pointwidth": "0",
                        "lat": "90.0",
                        "defaultvalue": "677.0"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Forecast Start Time",
                    "standard_name": "forecast_reference_time",
                    "expires": "1617237720",
                    "defaultvalue": "734.0",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "677.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/COLA-RSMAS-CCSM4"
            },
            "CPCCMAP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CPC-CMAP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "year0": "0",
                    "filepattern": "/data/dstore4/iri/modelling/daved/NMME_Data.D/Obs.D/cmap.197901.201010.1x1.grb",
                    "Conventions": "IRIDL"
                },
                "prate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm/day",
                    "gribfield": "1",
                    "process": " run.",
                    "long_name": "Precipitation rate",
                    "GRIBgridcode": "3",
                    "PDS_TimeRange": "123",
                    "standard_name": "lwe_precipitation_rate",
                    "gribleveltype": "1",
                    "gribNumBits": "13",
                    "gribparam": "59",
                    "gribcenter": "7",
                    "PTVersion": "2",
                    "grib_name": "PRATE",
                    "center": "US Weather Service - National Met. Center",
                    "calendar": "standard"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/CPC-CMAP"
            },
            "CPCCMAPURD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CPC-CMAP-URD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": "ftp://ftp.cpc.ncep.noaa.gov/NMME/obs/",
                    "Conventions": "IRIDL"
                },
                "prate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Monthly CMAP precipitation over the ocean and CPC Uniified Raingauge Database over land",
                    "missing_value": "-999.0",
                    "long_name": "Total Precipitation (CMAP(ocean) + CPC-URD(land)) ",
                    "standard_name": "lwe_precipitation_rate",
                    "units": "mm/month"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "long_name": "time",
                    "calendar": "360"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/CPC-CMAP-URD"
            },
            "CPCPRECIP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CPC-PRECIP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "year0": "0",
                    "filepattern": "/data/dstore4/iri/modelling/daved/NMME_Data.D/Obs.D/cpc.precip.1982.2010.monthly.1x1.grb",
                    "Conventions": "IRIDL"
                },
                "prate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm/day",
                    "missing_value": "NaN",
                    "file_missing_value": "9.99900026E20",
                    "gribfield": "1",
                    "long_name": "Precipitation rate",
                    "PTVersion": "2",
                    "gribleveltype": "1",
                    "standard_name": "lwe_precipitation_rate",
                    "GRIBgridcode": "3",
                    "PDS_TimeRange": "3",
                    "process": "141",
                    "gribparam": "59",
                    "gribcenter": "7",
                    "grib_name": "PRATE",
                    "center": "US Weather Service - National Met. Center",
                    "gribNumBits": "15",
                    "calendar": "standard"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/CPC-PRECIP"
            },
            "CanCM4i": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CanCM4i",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc8110description": "1981-2010 Seasonal Climatology",
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTmc8110description": "1981-2010 Monthly Climatology",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYexpires": "1617260400",
                    "dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "grib_name": "TMP",
                            "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "41.850006",
                            "scale_min": "-8.1499939",
                            "units": "Celsius_scale",
                            "grib_name": "WTMP",
                            "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Meridional Wind",
                            "units": "m s-1",
                            "grib_name": "VGRD",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Zonal Wind",
                            "units": "m s-1",
                            "grib_name": "UGRD",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Reference Temperature",
                            "units": "K",
                            "grib_name": "TMP",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "850 hPa Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Minimum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Sea Surface Temperature",
                            "units": "K",
                            "grib_name": "WTMP",
                            "scale_min": "260.0",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_pecipitation_rate",
                            "missing_value": "9.99900026E20",
                            "long_name": "Total Precipitation",
                            "grib_name": "PRATE",
                            "units": "mm/day",
                            "file_missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20",
                            "long_name": "Geopotential Height",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "300.0"
                        }
                    },
                    "mc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "grib_name": "TMP",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "41.850006",
                            "scale_min": "-8.1499939",
                            "units": "Celsius_scale",
                            "grib_name": "WTMP",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Meridional Wind",
                            "units": "m s-1",
                            "grib_name": "VGRD",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Zonal Wind",
                            "units": "m s-1",
                            "grib_name": "UGRD",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Reference Temperature",
                            "units": "K",
                            "grib_name": "TMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "850 hPa Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Minimum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "expires": "1617260400",
                            "calendar": "360",
                            "defaultvalue": "734.0",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Sea Surface Temperature",
                            "units": "K",
                            "grib_name": "WTMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_pecipitation_rate",
                            "missing_value": "9.99900026E20",
                            "long_name": "Total Precipitation",
                            "grib_name": "PRATE",
                            "units": "mm/day",
                            "expires": "1617260400",
                            "file_missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20",
                            "long_name": "Geopotential Height",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "300.0"
                        }
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulo": "12.0",
                    "long_name": "Forecast Start Time",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Forecast Start Time",
                    "standard_name": "forecast_reference_time",
                    "expires": "1617260400",
                    "defaultvalue": "734.0",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/CanCM4i"
            },
            "CanSIPSv2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CanSIPSv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYexpires": "1617260400",
                    "dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "long_name": "Meridional Wind",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "VGRD",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "long_name": "Zonal Wind",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "UGRD",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Reference Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "850 hPa Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Minimum Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Maximum Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "260.0",
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "long_name": "Geopotential Height",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "pointwidth": "300.0"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "long_name": "Meridional Wind",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "VGRD",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "long_name": "Zonal Wind",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "UGRD",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Reference Temperature",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "850 hPa Temperature",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Minimum Temperature",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Maximum Temperature",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "expires": "1617260400",
                            "calendar": "360",
                            "bounds": "S",
                            "defaultvalue": "734.0"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "WTMP",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "expires": "1617260400",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "grib_name": "PRATE",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "long_name": "Geopotential Height",
                            "missing_value": "9.99900026E20",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "pointwidth": "300.0"
                        }
                    }
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Forecast Start Time",
                    "standard_name": "forecast_reference_time",
                    "expires": "1617260400",
                    "defaultvalue": "734.0",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/CanSIPSv2"
            },
            "Cansips": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Cansips",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "CanSIPSv2": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.CanSIPSv2/",
                    "Conventions": "IRIDL"
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "long_name": "Meridional Wind",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "VGRD",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "long_name": "Zonal Wind",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "meter second-1",
                            "grib_name": "UGRD",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Reference Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "850 hPa Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Minimum Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Maximum Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Kelvin_scale",
                            "grib_name": "WTMP",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "soil_moisture_content",
                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "kg m-2",
                            "grib_name": "SOILM",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "long_name": "Geopotential Height",
                            "missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "pointwidth": "300.0"
                        }
                    }
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/Cansips"
            },
            "GEMNEMO": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GEM-NEMO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc8110description": "1981-2010 Seasonal Climatology",
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTmc8110description": "1981-2010 Monthly Climatology",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYexpires": "1617260400",
                    "dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "grib_name": "TMP",
                            "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "41.850006",
                            "scale_min": "-8.1499939",
                            "units": "Celsius_scale",
                            "grib_name": "WTMP",
                            "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Meridional Wind",
                            "units": "m s-1",
                            "grib_name": "VGRD",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Zonal Wind",
                            "units": "m s-1",
                            "grib_name": "UGRD",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Reference Temperature",
                            "units": "K",
                            "grib_name": "TMP",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "850 hPa Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Minimum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Sea Surface Temperature",
                            "units": "K",
                            "grib_name": "WTMP",
                            "scale_min": "260.0",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_pecipitation_rate",
                            "missing_value": "9.99900026E20",
                            "long_name": "Total Precipitation",
                            "grib_name": "PRATE",
                            "units": "mm/day",
                            "file_missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20",
                            "long_name": "Geopotential Height",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "300.0"
                        }
                    },
                    "mc8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Celsius_scale",
                            "grib_name": "TMP",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "41.850006",
                            "scale_min": "-8.1499939",
                            "units": "Celsius_scale",
                            "grib_name": "WTMP",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "grib_name": "PRATE",
                            "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "file_missing_value": "9.99900026E20",
                            "standard_name": "lwe_pecipitation_rate",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vgrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vgrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Meridional Wind",
                            "units": "m s-1",
                            "grib_name": "VGRD",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "ugrd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ugrd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "long_name": "Zonal Wind",
                            "units": "m s-1",
                            "grib_name": "UGRD",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "650.0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Reference Temperature",
                            "units": "K",
                            "grib_name": "TMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "850 hPa Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Minimum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMIN",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "grib_name": "TMAX",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "expires": "1617260400",
                            "calendar": "360",
                            "defaultvalue": "734.0",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "9.99900026E20",
                            "long_name": "Sea Surface Temperature",
                            "units": "K",
                            "grib_name": "WTMP",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "long_name": "Pressure Reduced to Mean Sea Level",
                            "units": "Pa",
                            "grib_name": "PRMSL",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_pecipitation_rate",
                            "missing_value": "9.99900026E20",
                            "long_name": "Total Precipitation",
                            "grib_name": "PRATE",
                            "units": "mm/day",
                            "expires": "1617260400",
                            "file_missing_value": "9.99900026E20",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20",
                            "long_name": "Geopotential Height",
                            "units": "gpm",
                            "grib_name": "HGT",
                            "expires": "1617260400",
                            "gribPDSpattern": "04XXXX",
                            "pointwidth": "300.0"
                        }
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulo": "12.0",
                    "long_name": "Forecast Start Time",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "650.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead"
                },
                "P2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Forecast Start Time",
                    "standard_name": "forecast_reference_time",
                    "expires": "1617260400",
                    "defaultvalue": "734.0",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/GEM-NEMO"
            },
            "GFDLCM2p1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL-CM2p1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "MONTHLYhistory": "FERRET V6.401   11-Jul-11",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.GFDL-CM2p1/.MONTHLY.dataset_documentation.html",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYConventions": "CF-1.0",
                    "Conventions": "IRIDL"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "history": "From atmos_ens01.198208-201107.t_ref",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea Surface Temperature",
                        "units": "Celsius_scale",
                        "standard_name": "sea_surface_temperature",
                        "missing_value": "-9.99999979E33",
                        "history": "From 1982-2010.temp_month_ens01",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "history": "From atmos_ens01.198208-201107.precip",
                        "pointwidth": "0"
                    }
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/GFDL-CM2p1"
            },
            "GFDLCM2p1aer04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL-CM2p1-aer04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8210long_name": "1982-2010 Seasonal Climatology",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYConventions": "CF-1.0",
                    "MONTHLYhistory": "FERRET V6.72   7-Jun-12",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "mc8210long_name": "1982-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Minimum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Maximum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea Surface Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "sea_surface_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0"
                    },
                    "mrso": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mrso",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total Soil Moisture Content",
                        "units": "kg m-2",
                        "standard_name": "soil_moisture_content",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "mrro": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mrro",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface and Subsurface Runoff",
                        "units": "kg m-2 s-1",
                        "standard_name": "runoff_flux",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "hght": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hght",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential Height at 200 hPa",
                        "units": "m",
                        "standard_name": "geopotential_height",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    }
                },
                "mc8210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p1-aer04 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 10.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "677.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/GFDL-CM2p1-aer04"
            },
            "GFDLCM2p5FLORA06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL-CM2p5-FLOR-A06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110long_name": "1981-2010 Seasonal Climatology",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYdataset_documentation": "https://www.gfdl.noaa.gov/wp-content/uploads/files/user_files/gav/publications/jetal_14_flor_tsandpr.pdf",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYConventions": "CF-1.0",
                    "MONTHLYhistory": "FERRET V6.72   7-Jun-12",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "mc8110long_name": "1981-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 1999 - 15 Dec 2000] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Minimum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Maximum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea Surface Temperature",
                        "units": "Celsius_scale",
                        "standard_name": "sea_surface_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0"
                    },
                    "hght": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hght",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential Height at 200 hPa",
                        "units": "m",
                        "standard_name": "geopotential_height",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    }
                },
                "mc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "677.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/GFDL-CM2p5-FLOR-A06"
            },
            "GFDLCM2p5FLORB01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL-CM2p5-FLOR-B01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110long_name": "1981-2010 Seasonal Climatology",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYdataset_documentation": "https://www.gfdl.noaa.gov/wp-content/uploads/files/user_files/gav/publications/jetal_14_flor_tsandpr.pdf",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "MONTHLYConventions": "CF-1.0",
                    "MONTHLYhistory": "FERRET V6.72   7-Jun-12",
                    "mc8110long_name": "1981-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Minimum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "t_ref_max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_ref_max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Maximum Temperature",
                        "units": "Kelvin_scale",
                        "standard_name": "air_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea Surface Temperature",
                        "units": "Celsius_scale",
                        "standard_name": "sea_surface_temperature",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0"
                    },
                    "hght": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hght",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential Height at 200 hPa",
                        "units": "m",
                        "standard_name": "geopotential_height",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0"
                    }
                },
                "mc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME GFDL-CM2p5-FLOR-B01 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "677.0",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.99999979E33",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "677.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/GFDL-CM2p5-FLOR-B01"
            },
            "GFDLSPEAR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL-SPEAR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc9120long_name": "1991-2020 Seasonal Climatology",
                    "HINDCASTMONTHLYlong_name": "1991-2020 Monthly",
                    "HINDCASTMONTHLYJournal": "https://doi.org/10.1029/2019MS001895",
                    "HINDCASTmc9120long_name": "1991-2020 Monthly Climatology",
                    "FORECASTMONTHLYexpires": "1617260400",
                    "FORECASTMONTHLYConventions": "CF-1.6",
                    "FORECASTMONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "FORECASTMONTHLYJournal": "https://doi.org/10.1029/2019MS001895",
                    "Journal": "https://doi.org/10.1029/2019MS001895",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc9120": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc9120",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "missing_value": "NaN",
                            "units": "unitless"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0"
                        },
                        "t_ref_min": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_ref_min",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Minimum temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0"
                        },
                        "t_ref_max": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_ref_max",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Sea Surface Temperature",
                            "units": "Celsius_scale",
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.99999979E33",
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "pointwidth": "0"
                        },
                        "h200": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h200",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 200 hPa",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0"
                        }
                    },
                    "mc9120": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc9120",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "missing_value": "NaN",
                            "units": "unitless"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Reference Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "t_ref_min": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_ref_min",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Minimum Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "t_ref_max": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_ref_max",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Maximum Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "expires": "1617260400",
                            "calendar": "360",
                            "bounds": "S",
                            "defaultvalue": "734.0"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Sea Surface Temperature",
                            "units": "Celsius_scale",
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "ssh": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssh",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Sea Surface Height",
                            "standard_name": "sea_surface_height_above_mean_sea_level",
                            "units": "m",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.99999979E33",
                            "expires": "1617260400",
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        },
                        "h200": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h200",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1617260400",
                            "long_name": "Geopotential Height at 200 hPa",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "missing_value": "-9.99999979E33",
                            "pointwidth": "0",
                            "defaultvalue": "734.0"
                        }
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "long_name": "Forecast Start Time",
                    "pointwidth": "0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "standard_name": "forecast_reference_time"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Forecast Start Time",
                    "standard_name": "forecast_reference_time",
                    "expires": "1617260400",
                    "defaultvalue": "734.0",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/GFDL-SPEAR"
            },
            "GHCN_CAMS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GHCN_CAMS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "updatedsource": "ftp://ftp.cpc.ncep.noaa.gov/NMME/obs/",
                    "filepattern": "/data/dstore4/iri/modelling/daved/NMME_Data.D/Obs.D/ghcn_cams_1948_cur.1x1.grb",
                    "Conventions": "IRIDL",
                    "year0": "0"
                },
                "updated": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "updated",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "t2m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t2m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "GHCN+CAMS 2 m temperature (land only)",
                        "standard_name": "air_temperature",
                        "units": "Celsius_scale"
                    }
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribfield": "1",
                    "gribNumBits": "14",
                    "PDS_TimeRange": "123",
                    "long_name": "Reference Temperature",
                    "gribcenter": "7",
                    "standard_name": "air_temperature",
                    "gribleveltype": "105",
                    "process": " run.",
                    "missing_value": "9.99900026E20",
                    "scale_max": "329.79001",
                    "scale_min": "189.96001",
                    "gribparam": "11",
                    "grib_name": "TMP",
                    "PTVersion": "2",
                    "GRIBgridcode": "3",
                    "center": "US Weather Service - National Met. Center",
                    "calendar": "standard"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "long_name": "time",
                    "calendar": "360"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m_above_gnd",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/GHCN_CAMS"
            },
            "IRIECHAM4p5AnomalyCoupled": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IRI-ECHAM4p5-AnomalyCoupled",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYmissing_value": "-999.0",
                    "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.IRI-ECHAM4p5-AnomalyCoupled/.MONTHLY.dataset_documentation.html",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "Conventions": "IRIDL"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "missing_value": "NaN",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Sea Surface Temperature",
                        "standard_name": "sea_surface_temperature",
                        "units": "Celsius_scale",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/IRI-ECHAM4p5-AnomalyCoupled"
            },
            "IRIECHAM4p5DirectCoupled": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IRI-ECHAM4p5-DirectCoupled",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYmissing_value": "-999.0",
                    "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.IRI-ECHAM4p5-DirectCoupled/.MONTHLY.dataset_documentation.html",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYsourcefilename": "/data/dstore4/iri/modelling/daved/BlueFin.D/ECHAM4.5_MOM3DirCpl2.D/EXP.D/TestCpl1b.D/Forecast_FullCoup_TauTaper4_KPPDiur_SfcCurr.D/PutTogPost.D/NMME_AllEns_ForDL.D/Aug.D/%y40801.1x1.precip_ens01.dat",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "Conventions": "IRIDL"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "missing_value": "NaN",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Sea Surface Temperature",
                        "standard_name": "sea_surface_temperature",
                        "units": "Celsius_scale",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/IRI-ECHAM4p5-DirectCoupled"
            },
            "LSMASK": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LSMASK",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "binaryfilename": "/Data/data23/NMME/Obs.D/lsmask.dat",
                    "missing_value": "9.99900026E20",
                    "Conventions": "IRIDL"
                },
                "land": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "land",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "9.99900026E20",
                    "iridlhasSemantics": "iridl:LandCover",
                    "long_name": "Surface Land cover",
                    "units": "unitless"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/LSMASK"
            },
            "NASAGEOSS2S": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NASA-GEOSS2S",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTsc8210long_name": "1982-2010 Seasonal Climatology",
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTMONTHLYdata_availability": "/mark/SOURCES/.Models/.NMME/.NASA-GEOSS2S/.HINDCAST/.MONTHLY/.fileavail/S2/exch%5BS1%5Dtable:/mark/:table/.html",
                    "HINDCASTmc8210long_name": "1982-2010 Monthly Climatology",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8210": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sc8210",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Kelvin_scale",
                            "history": "[(mean [ Models NMME NASA-GEOSS2S HINDCAST MONTHLY tref ]) [(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "fnname": "masknotrange",
                            "history": "[(mean [ Models NMME NASA-GEOSS2S HINDCAST MONTHLY sst ]) [(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "long_name": "Sea Surface Temperature",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "[1.0 9.9999999E+14]",
                            "standard_name": "sea_surface_temperature",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "history": "[(mean [ Models NMME NASA-GEOSS2S HINDCAST MONTHLY prec ]) [(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "long_name": "Total Precipitation",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "9.99999987E14",
                            "standard_name": "lwe_precipitation_rate",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "tauy": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauy",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Northward Surface Stress",
                            "standard_name": "surface_downward_northward_stress",
                            "units": "N m-2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "taux": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "taux",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Eastward Surface Stress",
                            "standard_name": "surface_downward_eastward_stress",
                            "units": "N m-2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "t2mmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t2mmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "file_missing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "long_name": "Minimum Temperature",
                            "standard_name": "air_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "t2mmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t2mmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "file_missing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "long_name": "Maximum Temperature",
                            "standard_name": "air_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fnname": "masknotrange",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "NaN",
                            "file_missing_value": "9.9999999E14",
                            "units": "Celsius_scale",
                            "standard_name": "sea_surface_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "Sm": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Sm",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Previous Month",
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "calendar": "360"
                        },
                        "runoff": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "runoff",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/s",
                            "long_name": "Runoff",
                            "standard_name": "runoff_flux",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99999987E14",
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "vmax": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Upwelling Longwave Flux at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "mrsov": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrsov",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Soil Moisture",
                            "units": "unitless",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "mmdd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mmdd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "h500": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h500",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 500 hPa",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "h250": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h250",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 250 hPa",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "h200": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h200",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 200 hPa",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "evap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "evap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W m-2",
                            "long_name": "Evaporation",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        }
                    },
                    "mc8210": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mc8210",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Near-Surface Temperature",
                            "units": "Kelvin_scale",
                            "history": "[(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "time",
                            "long_name": "Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "fnname": "masknotrange",
                            "history": "[(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "long_name": "Sea Surface Temperature",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "[1.0 9.9999999E+14]",
                            "standard_name": "sea_surface_temperature",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "history": "[(Averaged over M[0.5, 4.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                            "vmin": "-9.99999987E14",
                            "long_name": "Total Precipitation",
                            "vmax": "9.99999987E14",
                            "file_missing_value": "9.99999987E14",
                            "standard_name": "lwe_precipitation_rate",
                            "fmissing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "pointwidth": "0"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "tauy": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauy",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Northward Surface Stress",
                            "standard_name": "surface_downward_northward_stress",
                            "units": "N m-2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "taux": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "taux",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Eastward Surface Stress",
                            "standard_name": "surface_downward_eastward_stress",
                            "units": "N m-2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "t2mmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t2mmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "file_missing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "long_name": "Minimum Temperature",
                            "standard_name": "air_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "t2mmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t2mmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "file_missing_value": "9.99999987E14",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "long_name": "Maximum Temperature",
                            "standard_name": "air_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fnname": "masknotrange",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "NaN",
                            "file_missing_value": "9.9999999E14",
                            "units": "Celsius_scale",
                            "standard_name": "sea_surface_temperature",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0"
                        },
                        "Sm": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Sm",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Previous Month",
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "calendar": "360"
                        },
                        "runoff": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "runoff",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/s",
                            "long_name": "Runoff",
                            "standard_name": "runoff_flux",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "NaN",
                            "file_missing_value": "9.99999987E14",
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "vmax": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Upwelling Longwave Flux at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "mrsov": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrsov",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Soil Moisture",
                            "units": "unitless",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "mmdd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mmdd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "h500": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h500",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 500 hPa",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "h250": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "h250",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 250 hPa",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        },
                        "evap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "evap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W m-2",
                            "long_name": "Evaporation",
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0"
                        }
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "standard_name": "height",
                    "pointwidth": "0",
                    "long_name": "Height"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulus": "12",
                    "standard_name": "forecast_reference_time",
                    "modulo": "12",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "dir": "SOURCES/Models/NMME/NASA-GEOSS2S"
            },
            "NASAGMAO": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NASA-GMAO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLYdataset_documentation": "geos5_model_basics.pptx",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYdata_availability": "/mark/SOURCES/.Models/.NMME/.NASA-GMAO/.MONTHLY/.fileavail/S2/exch%5BS1%5Dtable:/mark/:table/.html",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "Conventions": "IRIDL"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "missing_value": "9.99999987E14",
                        "units": "Kelvin_scale",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.99999987E14",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature",
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0"
                    },
                    "mmdd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mmdd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    }
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "standard_name": "height",
                    "pointwidth": "0",
                    "long_name": "Height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "modulus": "12",
                    "standard_name": "forecast_reference_time",
                    "modulo": "12",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "dir": "SOURCES/Models/NMME/NASA-GMAO"
            },
            "NASAGMAO062012": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NASA-GMAO-062012",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sc8110long_name": "1981-2010 Seasonal Climatology",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYdataset_documentation": "geos5_model_basics.pptx",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYIMPORTANT": "As of 2 November 2016 an error has been found and corrected in the IRI Data Library archive of the NMME NASA-GMAO-062012 January hindcast and forecast starts.  In the January starts (S grid) for ensemble members (M grid) 1-4 (corresponding to starts associated with dates Dec 12th, Dec 17th, Dec 22nd, and Dec 27th), for all variables, the data in these files were being wrongly associated with the January start of the previoius year.  For example, for the January 2014 start, data should be read from files named using the dates 12 Dec 2013 (ensemble member 1), 17 Dec 2013 (ensemble member 2), 22 Dec 2013 (ensemble member 3), 27 Dec 2013 (ensemble member 4), and 01 Jan 2014 (ensemble members 5-11).  However, continuing with this example, in the Data Library archive, the data from ensemble members 1-4 (dated Dec 12, 17, 22, and 27 2013) were being assigned to the January 2013 start, not the intended January 2014 start.  This means that in forecasts with a January monthly start time, ensemble members 1-4 would have been missing until the following January start, when these ensemble members 1-4 would have been filled with data intended for the next January monthly start, or remained missing in the case of the prec, sst, and tref variables from 2014 to 2016.  This error affected only ensemble members 1-4 of the January starts, but affected all variables and all hindcast and forecast years.  This error was the result of an archiving error in the Data Library, not any error in the original data files from NASA, and has been corrected as of 2 November 2016.  Send any questions to help@iri.columbia.edu .",
                    "MONTHLYdata_availability": "/mark/SOURCES/.Models/.NMME/.NASA-GMAO-062012/.MONTHLY/.fileavail/S2/exch%5BS1%5Dtable:/mark/:table/.html",
                    "mc8110long_name": "1981-2010 Monthly Climatology",
                    "Conventions": "IRIDL"
                },
                "sc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME NASA-GMAO-062012 MONTHLY tref ]) [(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME NASA-GMAO-062012 MONTHLY sst ]) [(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(mean [ Models NMME NASA-GMAO-062012 MONTHLY prec ]) [(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "missing_value": "9.99999987E14",
                        "units": "Kelvin_scale",
                        "pointwidth": "0"
                    },
                    "t2mmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t2mmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.99999987E14",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "long_name": "Minimum Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0"
                    },
                    "t2mmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t2mmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.99999987E14",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "long_name": "Maximum Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "file_missing_value": "9.99999987E14",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature",
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0"
                    },
                    "runoff": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "runoff",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/s",
                        "long_name": "Runoff",
                        "standard_name": "runoff_flux",
                        "missing_value": "9.99999987E14",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "long_name": "Total Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0"
                    },
                    "mmdd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mmdd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "h200": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "h200",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential Height at 200 hPa",
                        "standard_name": "geopotential_height",
                        "missing_value": "9.99999987E14",
                        "units": "m",
                        "pointwidth": "0"
                    },
                    "evap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "evap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W m-2",
                        "long_name": "Evaporation",
                        "missing_value": "9.99999987E14",
                        "pointwidth": "0"
                    }
                },
                "mc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Near-Surface Temperature",
                        "standard_name": "air_temperature",
                        "pointwidth": "0",
                        "history": "[(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "Celsius_scale"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "pointwidth": "0",
                        "history": "[(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "pointwidth": "0",
                        "history": "[(Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                        "defaultvalue": "681.0",
                        "missing_value": "NaN",
                        "file_missing_value": "9.99999987E14",
                        "units": "mm/day",
                        "long_name": "Total Precipitation"
                    }
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "forecast_period"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "standard_name": "height",
                    "pointwidth": "0",
                    "long_name": "Height"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "calendar": "360",
                    "long_name": "Forecast Start Time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "defaultvalue": "681.0",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/NMME/NASA-GMAO-062012"
            },
            "NCARCESM1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCAR-CESM1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                    "HINDCASTMONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "HINDCASTMONTHLYConventions": "CF-1.0",
                    "FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "FORECASTMONTHLYreferences": "Kirtman_etal2014",
                    "FORECASTMONTHLYConventions": "CF-1.0",
                    "Conventions": "IRIDL"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Daily maximum of average 2-m temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "tsmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Daily minimum of average 2-m temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference height temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Sea Surface Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Volume fraction of water in soil",
                            "units": "unitless",
                            "standard_name": "volume_fraction_of_water_in_soil",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "runoff": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "runoff",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total liquid runoff (does not include QSNWCPICE)",
                            "standard_name": "runoff_flux",
                            "units": "mm/s",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "gz": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gz",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height (above sea level) at 200mb",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "lev_p": "200.0",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        }
                    }
                },
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Daily maximum of average 2-m temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "tsmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Daily minimum of average 2-m temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reference height temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Sea Surface Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "sea_surface_temperature",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Volume fraction of water in soil",
                            "units": "unitless",
                            "standard_name": "volume_fraction_of_water_in_soil",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "runoff": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "runoff",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total liquid runoff (does not include QSNWCPICE)",
                            "standard_name": "runoff_flux",
                            "units": "mm/s",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/day",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        },
                        "gz": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gz",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height (above sea level) at 200mb",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "lev_p": "200.0",
                            "missing_value": "-9999.0",
                            "pointwidth": "0"
                        }
                    }
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Start Time",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/NCAR-CESM1"
            },
            "NCDCOISST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCDC-OISST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "year0": "0",
                    "filepattern": "/data/dstore4/iri/modelling/daved/NMME_Data.D/Obs.D/oisst.qd.1982.2010.monthly.1x1.grb",
                    "Conventions": "IRIDL"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "gribfield": "1",
                    "long_name": "Sea Surface Temperature",
                    "gribNumBits": "12",
                    "process": "44",
                    "standard_name": "Sea Surface Temperature",
                    "gribleveltype": "1",
                    "GRIBgridcode": "3",
                    "subcenter": "4",
                    "gribparam": "11",
                    "PDS_TimeRange": "1",
                    "gribcenter": "160",
                    "grib_name": "TMP",
                    "center": "160",
                    "PTVersion": "2",
                    "calendar": "standard"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/NCDC-OISST"
            },
            "NCEPCFSv1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCEP-CFSv1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLYadditional_variablesACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "MONTHLYadditional_variablesreferences": "Kirtman_etal2014",
                    "MONTHLYreferences": "Kirtman_etal2014",
                    "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                    "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.NCEP-CFSv1/.MONTHLY.dataset_documentation.html",
                    "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                    "Conventions": "IRIDL"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribfield": "1",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "gribleveltype": "105",
                        "process": "98",
                        "gribNumBits": "14",
                        "scale_min": "206.63",
                        "scale_max": "313.57999",
                        "gribparam": "11",
                        "gribcenter": "7",
                        "GRIBgridcode": "3",
                        "subcenter": "Environmental Modeling Center",
                        "PTVersion": "2",
                        "PDS_TimeRange": "3",
                        "center": "US Weather Service - National Met. Center",
                        "grib_name": "TMP",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "scale_max": "41.160004",
                        "scale_min": "-71.589996",
                        "units": "Celsius_scale",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "process": "98",
                        "gribNumBits": "14",
                        "gribparam": "11",
                        "gribcenter": "7",
                        "GRIBgridcode": "3",
                        "subcenter": "Environmental Modeling Center",
                        "grib_name": "TMP",
                        "PTVersion": "2",
                        "center": "US Weather Service - National Met. Center",
                        "PDS_TimeRange": "3",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "gribfield": "1",
                        "long_name": "Total Precipitation",
                        "standard_name": "precipitation_rate",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "process": "98",
                        "gribparam": "59",
                        "gribcenter": "7",
                        "GRIBgridcode": "3",
                        "subcenter": "Environmental Modeling Center",
                        "PDS_TimeRange": "3",
                        "grib_name": "PRATE",
                        "center": "US Weather Service - National Met. Center",
                        "PTVersion": "2",
                        "pointwidth": "0"
                    },
                    "additional_variables": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "additional_variables",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "z200": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "z200",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gribfield": "1",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "gribleveltype": "100",
                            "process": "98",
                            "missing_value": "9.99900026E20",
                            "gribparam": "7",
                            "gribcenter": "7",
                            "GRIBgridcode": "3",
                            "grib_name": "HGT",
                            "center": "US National Weather Service, National Centers for Environmental Prediction (NCEP)",
                            "PDS_TimeRange": "3",
                            "pointwidth": "0"
                        },
                        "watr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "watr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "gribfield": "1",
                            "long_name": "Water Runoff",
                            "standard_name": "air_temperature",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribparam": "90",
                            "gribcenter": "7",
                            "grib_name": "WATR",
                            "center": "US National Weather Service, National Centers for Environmental Prediction (NCEP)",
                            "GRIBgridcode": "3",
                            "PDS_TimeRange": "3",
                            "pointwidth": "0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "2-Meter Minimum Temperature",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "process": "98",
                            "missing_value": "9.99900026E20",
                            "gribparam": "16",
                            "gribcenter": "7",
                            "GRIBgridcode": "3",
                            "grib_name": "TMIN",
                            "center": "US National Weather Service, National Centers for Environmental Prediction (NCEP)",
                            "PDS_TimeRange": "3",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "2-Meter Maximum Temperature",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "process": "98",
                            "missing_value": "9.99900026E20",
                            "gribparam": "15",
                            "gribcenter": "7",
                            "GRIBgridcode": "3",
                            "grib_name": "TMAX",
                            "center": "US National Weather Service, National Centers for Environmental Prediction (NCEP)",
                            "PDS_TimeRange": "3",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "soilw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "gribfield": "1",
                            "long_name": "Soil Moisture Content",
                            "standard_name": "moisture_content_of_soil_layer",
                            "gribleveltype": "112",
                            "process": "98",
                            "missing_value": "9.99900026E20",
                            "gribparam": "86",
                            "gribcenter": "7",
                            "GRIBgridcode": "3",
                            "grib_name": "SOILM",
                            "center": "US National Weather Service, National Centers for Environmental Prediction (NCEP)",
                            "PDS_TimeRange": "3",
                            "pointwidth": "0"
                        }
                    }
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "height",
                    "long_name": "Height"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "Z1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2",
                    "pointwidth": "0",
                    "standard_name": "depth",
                    "long_name": "Depth"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Ensemble Member",
                    "standard_name": "realization"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "360"
                },
                "dir": "SOURCES/Models/NMME/NCEP-CFSv1"
            },
            "NCEPCFSv2": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Models/NMME/NCEP-CFSv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "NCEP-CFSv2",
                "restriction": "Public",
                "FORECAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FORECAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PENTAD_SAMPLESMONTHLYSamplingTable": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.REALTIME_ENSEMBLE/.FLXF/mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html",
                        "PENTAD_SAMPLESMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "PENTAD_SAMPLESdescription": "pentad realtime forecasts organized as monthly starts of 24-28 members, starting from Apr 2011, matching pattern of CFSv2 hindcast starts",
                        "EARLY_MONTH_SAMPLESMONTHLYSamplingTable": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.NMME_REALTIME_ENSEMBLE/.FLXF/mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html",
                        "EARLY_MONTH_SAMPLESMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "EARLY_MONTH_SAMPLESdescription": "Four times daily realtime forecasts sampled from last day of previous month and first 7 days of current month, organized as monthly starts (S) of 32 members (M), starting from March 2011",
                        "Conventions": "IRIDL"
                    },
                    "PENTAD_SAMPLES": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PENTAD_SAMPLES",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "air_temperature",
                                "long_name": "Reference Temperature",
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "fnname": "maskge",
                                "long_name": "Sea Surface Temperature",
                                "missing_value": "NaN",
                                "standard_name": "sea_surface_temperature",
                                "file_missing_value": "0.0",
                                "cNZ": "7",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Total Precipitation",
                                "units": "mm/day",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "geopotential_height",
                                "long_name": "Geopotential Height at 200 hPa",
                                "units": "gpm",
                                "cNZ": "477",
                                "Z": "Z",
                                "gribfield": "1",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "EARLY_MONTH_SAMPLES": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "EARLY_MONTH_SAMPLES",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "air_temperature",
                                "long_name": "Reference Temperature",
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "fnname": "maskge",
                                "long_name": "Sea Surface Temperature",
                                "missing_value": "NaN",
                                "file_missing_value": "0.0",
                                "standard_name": "sea_surface_temperature",
                                "cNZ": "7",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Total Precipitation",
                                "units": "mm/day",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "geopotential_height",
                                "long_name": "Geopotential Height at 200 hPa",
                                "units": "gpm",
                                "cNZ": "477",
                                "gribfield": "1",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Wind Component"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure level"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/Models/NMME/NCEP-CFSv2/FORECAST"
                },
                "HINDCAST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HINDCAST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PENTAD_SAMPLESsc8210long_name": "1982-2010 Seasonal Climatology",
                        "PENTAD_SAMPLESMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "PENTAD_SAMPLESMONTHLYSamplingTable": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.ENSEMBLE/.FLXF/mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html",
                        "PENTAD_SAMPLESmc8210long_name": "1982-2010 Monthly Climatology",
                        "PENTAD_SAMPLESdescription": "pentad hindcasts organized as monthly starts of 24-28 members (28 members in Nov), from Jan 1982 to Mar 2011",
                        "MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                        "MONTHLYreferences": "Kirtman_etal2014",
                        "MONTHLYdescription": "pentad hindcasts organized as monthly starts of 24 members in all months, from 1982 to 2010",
                        "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.NCEP-CFSv2/.HINDCAST/.MONTHLY.dataset_documentation.html",
                        "MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc9910long_name": "1999-2010 climatology",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc9910dataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc9910description": "Climatology:  ATOVS period",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc9910data": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc9910ACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc8210long_name": "1982-2010 climatology",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc8210dataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc8210description": "Climatology:  Full period",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc8210data": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdc8210ACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERreferences": "Kirtman_etal2014",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdescription": "Climatological Time Series of Monthly Means from 9-Month Runs, Spatially Regridded to NMME 1 Deg. Resolution",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERdata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                        "CLIMATOLOGYCLIMO_9MON_MMTSERACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "CLIMATOLOGYdataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                        "CLIMATOLOGYdescription": "CFSv2 Retrospective Forecast Calibration Climatologies",
                        "Conventions": "IRIDL"
                    },
                    "PENTAD_SAMPLES": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PENTAD_SAMPLES",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sc8210": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sc8210",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Temperature",
                                "units": "Celsius_scale",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "missing_value": "NaN",
                                "gribNumBits": "21",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "air_temperature",
                                "grib_name": "TMP",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                "gribparam": "11",
                                "PTVersion": "2"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "3",
                                "standard_name": "time",
                                "long_name": "Time",
                                "units": "months since 1960-01-01",
                                "calendar": "360"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "center": "US Weather Service - National Met. Center",
                                "long_name": "Sea Surface Temperature",
                                "PDS_TimeRange": "3",
                                "missing_value": "NaN",
                                "gribNumBits": "21",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "sea_surface_temperature",
                                "units": "Celsius_scale",
                                "grib_name": "TMP",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                "gribparam": "11",
                                "PTVersion": "2"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "center": "US Weather Service - National Met. Center",
                                "long_name": "Total Precipitation",
                                "PDS_TimeRange": "3",
                                "missing_value": "NaN",
                                "gribNumBits": "13",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "precipitation_rate",
                                "units": "mm/day",
                                "grib_name": "PRATE",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                "gribparam": "59",
                                "PTVersion": "2"
                            }
                        },
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "air_temperature",
                                "long_name": "Reference Temperature",
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Forecast Time",
                                "pointwidth": "1.0",
                                "units": " months since 1960-01-01",
                                "calendar": "360"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "fnname": "maskge",
                                "long_name": "Sea Surface Temperature",
                                "missing_value": "NaN",
                                "file_missing_value": "0.0",
                                "standard_name": "sea_surface_temperature",
                                "cNZ": "7",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Total Precipitation",
                                "units": "mm/day",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "geopotential_height",
                                "long_name": "Geopotential Height at 200 hPa",
                                "units": "gpm",
                                "cNZ": "477",
                                "gribfield": "1",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            }
                        },
                        "mc8210": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mc8210",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tref": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tref",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Temperature",
                                "units": "Celsius_scale",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "21",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "air_temperature",
                                "grib_name": "TMP",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                "gribparam": "11",
                                "PTVersion": "2"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "units": "months since 1960-01-01",
                                "calendar": "360"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "long_name": "Sea Surface Temperature",
                                "gribNumBits": "21",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "sea_surface_temperature",
                                "units": "Celsius_scale",
                                "grib_name": "TMP",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                "gribparam": "11",
                                "PTVersion": "2"
                            },
                            "prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "center": "US Weather Service - National Met. Center",
                                "long_name": "Total Precipitation",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "13",
                                "pointwidth": "0",
                                "process": " run.",
                                "GRIBgridcode": "3",
                                "standard_name": "precipitation_rate",
                                "units": "mm/day",
                                "grib_name": "PRATE",
                                "gribcenter": "7",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                "gribparam": "59",
                                "PTVersion": "2"
                            }
                        }
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "GRIBgridcode": "3",
                            "long_name": "Reference Temperature",
                            "PTVersion": "2",
                            "PDS_TimeRange": "3",
                            "standard_name": "air_temperature",
                            "gribleveltype": "105",
                            "gribcenter": "7",
                            "scale_max": "315.4577",
                            "scale_min": "206.4713",
                            "gribparam": "11",
                            "gribNumBits": "21",
                            "process": " run.",
                            "center": "US Weather Service - National Met. Center",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Time",
                            "pointwidth": "1.0",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_surface_temperature",
                            "long_name": "Sea Surface Temperature",
                            "scale_max": "43.039307",
                            "scale_min": "-69.973892",
                            "units": "Celsius_scale",
                            "gribfield": "1",
                            "GRIBgridcode": "3",
                            "PTVersion": "2",
                            "PDS_TimeRange": "3",
                            "gribleveltype": "1",
                            "gribcenter": "7",
                            "gribparam": "11",
                            "gribNumBits": "21",
                            "process": " run.",
                            "center": "US Weather Service - National Met. Center",
                            "grib_name": "TMP",
                            "pointwidth": "0"
                        },
                        "prec": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prec",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "gribfield": "1",
                            "GRIBgridcode": "3",
                            "long_name": "Total Precipitation",
                            "PTVersion": "2",
                            "PDS_TimeRange": "3",
                            "standard_name": "precipitation_rate",
                            "gribleveltype": "1",
                            "gribcenter": "7",
                            "gribparam": "59",
                            "gribNumBits": "13",
                            "process": " run.",
                            "center": "US Weather Service - National Met. Center",
                            "grib_name": "PRATE",
                            "pointwidth": "0"
                        }
                    },
                    "CLIMATOLOGY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CLIMATOLOGY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "CLIMO_9MON_MMTSER": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CLIMO_9MON_MMTSER",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dc9910": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dc9910",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "air_temperature",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "long_name": "2-meter air temperature",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "file_missing_value": "0.0",
                                    "missing_value": "NaN",
                                    "units": "Celsius_scale",
                                    "standard_name": "sea_surface_temperature",
                                    "long_name": "sea surface temperature",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "lwe_precipitation_rate",
                                    "units": "mm/day",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "long_name": "precipitation rate",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            },
                            "dc8210": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dc8210",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "air_temperature",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "long_name": "2-meter air temperature",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "file_missing_value": "0.0",
                                    "missing_value": "NaN",
                                    "units": "Celsius_scale",
                                    "standard_name": "sea_surface_temperature",
                                    "long_name": "sea surface temperature",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "lwe_precipitation_rate",
                                    "units": "mm/day",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "long_name": "precipitation rate",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "L_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "standard_name": "forecast_period"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure level"
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "S_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time"
                    },
                    "S_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "pointwidth": "0",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Ensemble Member",
                        "standard_name": "realization"
                    },
                    "L_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1984-01-01 00:00:00",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "calendar": "standard"
                    },
                    "dir": "SOURCES/Models/NMME/NCEP-CFSv2/HINDCAST"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "references": "Kirtman_etal2014",
                        "description": "pentad hindcasts organized as monthly starts of 24 members in all months, from 1982 to 2010",
                        "data_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                        "Conventions": "IRIDL",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Models/.NMME/.NCEP-CFSv2/.MONTHLY/.dataset_documentation.html"
                    },
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribfield": "1",
                        "long_name": "Reference Temperature",
                        "standard_name": "air_temperature",
                        "PTVersion": "2",
                        "process": " run.",
                        "GRIBgridcode": "3",
                        "gribleveltype": "105",
                        "scale_max": "315.4577",
                        "scale_min": "206.4713",
                        "gribparam": "11",
                        "gribcenter": "7",
                        "gribNumBits": "21",
                        "grib_name": "TMP",
                        "center": "US Weather Service - National Met. Center",
                        "PDS_TimeRange": "3",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "scale_max": "43.039307",
                        "scale_min": "-69.973892",
                        "units": "Celsius_scale",
                        "gribfield": "1",
                        "PTVersion": "2",
                        "process": " run.",
                        "GRIBgridcode": "3",
                        "gribleveltype": "1",
                        "gribparam": "11",
                        "gribcenter": "7",
                        "gribNumBits": "21",
                        "grib_name": "TMP",
                        "center": "US Weather Service - National Met. Center",
                        "PDS_TimeRange": "3",
                        "pointwidth": "0"
                    },
                    "prec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "gribfield": "1",
                        "long_name": "Total Precipitation",
                        "standard_name": "precipitation_rate",
                        "PTVersion": "2",
                        "process": " run.",
                        "GRIBgridcode": "3",
                        "gribleveltype": "1",
                        "gribparam": "59",
                        "gribcenter": "7",
                        "gribNumBits": "13",
                        "grib_name": "PRATE",
                        "center": "US Weather Service - National Met. Center",
                        "PDS_TimeRange": "3",
                        "pointwidth": "0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Ensemble Member",
                        "standard_name": "realization"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/Models/NMME/NCEP-CFSv2/MONTHLY"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "FORECAST",
                    "HINDCAST",
                    "MONTHLY"
                ]
            },
            "OIv2_SST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OIv2_SST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "long_name": "OIv2 SST",
                    "standard_name": "sea_surface_temperature",
                    "units": "Celsius_scale"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "long_name": "time",
                    "calendar": "360"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "dir": "SOURCES/Models/NMME/OIv2_SST"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CMC1CanCM3",
                "CMC2CanCM4",
                "COLARSMASCCSM3",
                "COLARSMASCCSM4",
                "CPCCMAP",
                "CPCCMAPURD",
                "CPCPRECIP",
                "CanCM4i",
                "CanSIPSv2",
                "Cansips",
                "GEMNEMO",
                "GFDLCM2p1",
                "GFDLCM2p1aer04",
                "GFDLCM2p5FLORA06",
                "GFDLCM2p5FLORB01",
                "GFDLSPEAR",
                "GHCN_CAMS",
                "IRIECHAM4p5AnomalyCoupled",
                "IRIECHAM4p5DirectCoupled",
                "LSMASK",
                "NASAGEOSS2S",
                "NASAGMAO",
                "NASAGMAO062012",
                "NCARCESM1",
                "NCDCOISST",
                "NCEPCFSv1",
                "NCEPCFSv2",
                "OIv2_SST"
            ]
        },
        "SubX": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Models/SubX",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "SubX",
            "restriction": "Public",
            "CESM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CESM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "LCESM1hindcastcontact": "Jadwiga (Yaga) Richter (jrichter@ucar.edu), Judith Perlwitz (judith.perlwitz@noaa.gov), and Lantao Sun (Lantao.Sun@noaa.gov)",
                    "LCESM1hindcastinstitution_id": "NCAR and NOAA/ESRL/PSD",
                    "LCESM1hindcastReferences": "Original post-processing scripts come from Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu).",
                    "LCESM1hindcastfrequency": "daily",
                    "LCESM1hindcastinstitution": "National Center for Atmospheric Research and NOAA Earth System Research Laboratory Physical Sciences Division",
                    "LCESM1hindcastmodel_id": "CESM1_30LCAM5",
                    "LCESM1hindcastConventions": "CF-1.0",
                    "LCESM1hindcastproject_id": "SUBx project",
                    "LCESM1hindcastGenerator": "NCL v.6.4.0",
                    "LCESM1hindcastmodeling_realm": "atmos",
                    "Conventions": "IRIDL"
                },
                "LCESM1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "30LCESM1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "cell_methods": "time: average over instantaneous 00z,06z,12z,18z",
                            "level_type": "pressure level",
                            "missing_value": "9.96920997E36"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "units": "m s-1",
                            "cell_methods": "time: average over instantaneous 00z,06z,12z,18z",
                            "level_type": "pressure level",
                            "missing_value": "9.96920997E36"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "units": "m s-1",
                            "cell_methods": "time: average over instantaneous 00z,06z,12z,18z",
                            "level_type": "pressure level",
                            "missing_value": "9.96920997E36"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "units": "Kelvin_scale",
                            "cell_methods": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "cell_methods": "time: mean",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Sampling_Sequence": "rad_lwsw",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "cell_methods": "time: mean",
                            "level_type": "top of atmosphere",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "dir": "SOURCES/Models/SubX/CESM"
            },
            "ECCC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Models/SubX/ECCC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ECCC",
                "restriction": "Public",
                "GEM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GEM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "hindcastRMMinstitution": "IRI",
                        "hindcastRMMCreatedBy": "kpegion",
                        "hindcastRMMMatlabSource": "",
                        "hindcastRMMsource": "SubX IRI",
                        "hindcastRMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                        "hindcastRMMlong_title": "SubX RMM",
                        "hindcastRMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                        "hindcastRMMtitle": "SubX RMM",
                        "hindcastdc9915CreatedBy": "kpegion",
                        "hindcastdc9915MatlabSource": "",
                        "hindcastdc9915source": "SubX IRI",
                        "hindcastdc9915institution": "IRI",
                        "hindcastdc9915long_title": "SubX Climatology",
                        "hindcastdc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                        "hindcastdc9915description": "1999-2015 Daily Hindcast Climatology",
                        "hindcastdc9915title": "SubX Climatology",
                        "hindcastdc9915CreationDate": "2018/06/20 06:47:40",
                        "Conventions": "IRIDL"
                    },
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "level_type": "pressure level",
                            "short_name": "VVEL_500mb",
                            "missing_value": "9.99900026E20"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Northward Wind",
                            "level": "10 m above ground",
                            "standard_name": "northward_wind",
                            "level_type": "10 meters above ground",
                            "short_name": "VGRD_10maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Velocity",
                            "units": "m/s",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Eastward Wind",
                            "level": "10 m above ground",
                            "standard_name": "eastward_wind",
                            "level_type": "10 meters above ground",
                            "short_name": "UGRD_10maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Velocity",
                            "units": "m/s",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "level": "surface",
                            "units": "Kelvin_scale",
                            "level_type": "surface",
                            "short_name": "SKINT_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "standard_name": "dew_point_temperature",
                            "level": "2 m above ground",
                            "level_type": "2 meters above ground",
                            "short_name": "DPT_2maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Minimum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmin_2m",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Maximum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmax_2m",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "TMP_2maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Snow Depth Water Equivalent",
                            "level_type": "surface",
                            "standard_name": "surface_snow_melt_amount",
                            "level": "surface",
                            "short_name": "SDWE_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^3",
                            "long_name": "Snow Density",
                            "level": "surface",
                            "standard_name": "snow_density",
                            "level_type": "surface",
                            "short_name": "SDEN_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Proportion",
                            "long_name": "Sea Ice Concentration",
                            "level": "surface",
                            "standard_name": "sea_ice_area_fraction",
                            "level_type": "surface",
                            "short_name": "ICEC_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "level": "top of atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level_type": "top of atmosphere",
                            "short_name": "NLWRF_topofatmosphere",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "level": "surface",
                            "level_type": "surface",
                            "short_name": "Net_rad",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "mean sea level",
                            "long_name": "Mean Sea Level Pressure",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "level_type": "surface",
                            "short_name": "PRES_meansealevel",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level_type": "surface",
                            "short_name": "TPRATE_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Surface Water Runoff",
                            "level_type": "surface",
                            "standard_name": "surface_runoff_amount",
                            "level": "surface",
                            "short_name": "SFCWRO_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "level_type": "pressure level",
                            "short_name": "SPFH_850mb",
                            "missing_value": "9.99900026E20"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Surface Sensible Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level_type": "surface",
                            "short_name": "SHTFL_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Surface Latent Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level_type": "surface",
                            "short_name": "LHTFL_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m/s",
                                "standard_name": "northward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m/s",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "level_type": "pressure level",
                            "short_name": "VVEL_500mb",
                            "missing_value": "9.99900026E20"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Northward Wind",
                            "level": "10 m above ground",
                            "standard_name": "northward_wind",
                            "level_type": "10 meters above ground",
                            "short_name": "VGRD_10maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Velocity",
                            "units": "m/s",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Eastward Wind",
                            "level": "10 m above ground",
                            "standard_name": "eastward_wind",
                            "level_type": "10 meters above ground",
                            "short_name": "UGRD_10maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Velocity",
                            "units": "m/s",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "level": "surface",
                            "units": "Kelvin_scale",
                            "level_type": "surface",
                            "short_name": "SKINT_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "standard_name": "dew_point_temperature",
                            "level": "2 m above ground",
                            "level_type": "2 meters above ground",
                            "short_name": "DPT_2maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Minimum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmin_2m",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Maximum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmax_2m",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "TMP_2maboveground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Snow Depth Water Equivalent",
                            "level_type": "surface",
                            "standard_name": "surface_snow_melt_amount",
                            "level": "surface",
                            "short_name": "SDWE_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^3",
                            "long_name": "Snow Density",
                            "level": "surface",
                            "standard_name": "snow_density",
                            "level_type": "surface",
                            "short_name": "SDEN_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Proportion",
                            "long_name": "Sea Ice Concentration",
                            "level": "surface",
                            "standard_name": "sea_ice_area_fraction",
                            "level_type": "surface",
                            "short_name": "ICEC_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "level": "top of atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level_type": "top of atmosphere",
                            "short_name": "NLWRF_topofatmosphere",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "level": "surface",
                            "level_type": "surface",
                            "short_name": "Net_rad",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "mean sea level",
                            "long_name": "Mean Sea Level Pressure",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "level_type": "surface",
                            "short_name": "PRES_meansealevel",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level_type": "surface",
                            "short_name": "TPRATE_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Surface Water Runoff",
                            "level_type": "surface",
                            "standard_name": "surface_runoff_amount",
                            "level": "surface",
                            "short_name": "SFCWRO_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "level_type": "pressure level",
                            "short_name": "SPFH_850mb",
                            "missing_value": "9.99900026E20"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Surface Sensible Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level_type": "surface",
                            "short_name": "SHTFL_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Surface Latent Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level_type": "surface",
                            "short_name": "LHTFL_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        }
                    },
                    "S_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Start Time",
                        "calendar": "standard"
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member"
                    },
                    "S_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "long_name": "Start Time",
                        "calendar": "standard",
                        "standard_name": "forecast_reference_time"
                    },
                    "P_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Start Time",
                        "calendar": "standard"
                    },
                    "P_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "long_name": "Start Time",
                        "calendar": "standard",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/Models/SubX/ECCC/GEM"
                },
                "GEPS5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GEPS5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Geopotential Height",
                            "level_type": "pressure level",
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "missing_value": "9.99900026E20",
                            "short_name": "VVEL_500mb"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Northward Wind",
                            "level_type": "10 meters above ground",
                            "standard_name": "northward_wind",
                            "short_name": "VGRD_10maboveground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Meridional Velocity",
                            "level_type": "pressure level",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Eastward Wind",
                            "level_type": "10 meters above ground",
                            "standard_name": "eastward_wind",
                            "short_name": "UGRD_10maboveground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Zonal Velocity",
                            "level_type": "pressure level",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "level_type": "surface",
                            "units": "Kelvin_scale",
                            "level": "surface",
                            "short_name": "SKINT_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "dew_point_temperature",
                            "short_name": "DPT_2maboveground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "short_name": "Tmin_2m",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "short_name": "Tmax_2m",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "short_name": "TMP_2maboveground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Snow Depth Water Equivalent",
                            "level_type": "surface",
                            "standard_name": "surface_snow_melt_amount",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "SDWE_surface",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^3",
                            "long_name": "Snow Density",
                            "level_type": "surface",
                            "standard_name": "snow_density",
                            "level": "surface",
                            "short_name": "SDEN_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Proportion",
                            "long_name": "Sea Ice Concentration",
                            "level_type": "surface",
                            "standard_name": "sea_ice_area_fraction",
                            "level": "surface",
                            "short_name": "ICEC_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "level_type": "top of atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level": "top of atmosphere",
                            "missing_value": "9.99900026E20",
                            "short_name": "NLWRF_topofatmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "level_type": "surface",
                            "units": "W/m2",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "Net_rad",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Mean Sea Level Pressure",
                            "level_type": "surface",
                            "units": "Pa",
                            "short_name": "PRES_meansealevel",
                            "level": "mean sea level",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "short_name": "TPRATE_surface",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Surface Water Runoff",
                            "level_type": "surface",
                            "standard_name": "surface_runoff_amount",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "SFCWRO_surface",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "missing_value": "9.99900026E20",
                            "short_name": "SPFH_850mb"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "short_name": "SHTFL_surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "short_name": "LHTFL_surface",
                            "pointwidth": "0.0"
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Geopotential Height",
                            "level_type": "pressure level",
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "missing_value": "9.99900026E20",
                            "short_name": "VVEL_500mb"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Northward Wind",
                            "level_type": "10 meters above ground",
                            "standard_name": "northward_wind",
                            "short_name": "VGRD_10maboveground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Meridional Velocity",
                            "level_type": "pressure level",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "10-meter Eastward Wind",
                            "level_type": "10 meters above ground",
                            "standard_name": "eastward_wind",
                            "short_name": "UGRD_10maboveground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Zonal Velocity",
                            "level_type": "pressure level",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "level_type": "surface",
                            "units": "Kelvin_scale",
                            "level": "surface",
                            "short_name": "SKINT_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "dew_point_temperature",
                            "short_name": "DPT_2maboveground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "short_name": "Tmin_2m",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "short_name": "Tmax_2m",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "short_name": "TMP_2maboveground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Snow Depth Water Equivalent",
                            "level_type": "surface",
                            "standard_name": "surface_snow_melt_amount",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "SDWE_surface",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^3",
                            "long_name": "Snow Density",
                            "level_type": "surface",
                            "standard_name": "snow_density",
                            "level": "surface",
                            "short_name": "SDEN_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Proportion",
                            "long_name": "Sea Ice Concentration",
                            "level_type": "surface",
                            "standard_name": "sea_ice_area_fraction",
                            "level": "surface",
                            "short_name": "ICEC_surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "level_type": "top of atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level": "top of atmosphere",
                            "missing_value": "9.99900026E20",
                            "short_name": "NLWRF_topofatmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "level_type": "surface",
                            "units": "W/m2",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "Net_rad",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Mean Sea Level Pressure",
                            "level_type": "surface",
                            "units": "Pa",
                            "short_name": "PRES_meansealevel",
                            "level": "mean sea level",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "short_name": "TPRATE_surface",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "long_name": "Surface Water Runoff",
                            "level_type": "surface",
                            "standard_name": "surface_runoff_amount",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "short_name": "SFCWRO_surface",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "short_name": "SPFH_850mb"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "short_name": "SHTFL_surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "short_name": "LHTFL_surface",
                            "pointwidth": "0.0"
                        }
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Start Time",
                        "calendar": "standard"
                    },
                    "P_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "long_name": "Start Time",
                        "calendar": "standard",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/Models/SubX/ECCC/GEPS5"
                },
                "GEPS6": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Models/SubX/ECCC/GEPS6",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "GEPS6",
                    "restriction": "Public",
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "long_name": "Pressure Vertical Velocity",
                            "short_name": "VVEL_500mb",
                            "units": "Pa/s",
                            "missing_value": "9.99900026E20"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "10 m above ground",
                            "long_name": "10-meter Northward Wind",
                            "level_type": "10 meters above ground",
                            "short_name": "VGRD_10maboveground",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Meridional Velocity",
                            "units": "m/s",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "10 m above ground",
                            "long_name": "10-meter Eastward Wind",
                            "level_type": "10 meters above ground",
                            "short_name": "UGRD_10maboveground",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "long_name": "Zonal Velocity",
                            "units": "m/s",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "level_type": "surface",
                            "long_name": "Surface Temperature",
                            "short_name": "SKINT_surface",
                            "units": "Kelvin_scale",
                            "missing_value": "9.99900026E20",
                            "standard_name": "surface_temperature",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Dew Point Temperature",
                            "level": "2 m above ground",
                            "level_type": "2 meters above ground",
                            "units": "Kelvin_scale",
                            "standard_name": "dew_point_temperature",
                            "missing_value": "9.99900026E20",
                            "short_name": "DPT_2maboveground",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmin_2m",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "level": "2 m above ground",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "level_type": "2 meters above ground",
                            "short_name": "Tmax_2m",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "level": "2 m above ground",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "2 m above ground",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "short_name": "TMP_2maboveground",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "long_name": "Snow Depth Water Equivalent",
                            "level": "surface",
                            "short_name": "SDWE_surface",
                            "standard_name": "surface_snow_melt_amount",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m^2",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "level_type": "surface",
                            "long_name": "Snow Density",
                            "short_name": "SDEN_surface",
                            "standard_name": "snow_density",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m^3",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Sea Ice Concentration",
                            "level_type": "surface",
                            "short_name": "ICEC_surface",
                            "standard_name": "sea_ice_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "Proportion",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "top of atmosphere",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "level_type": "top of atmosphere",
                            "short_name": "NLWRF_topofatmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "long_name": "Net Surface Radiation",
                            "level_type": "surface",
                            "short_name": "Net_rad",
                            "units": "W/m2",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "mean sea level",
                            "long_name": "Mean Sea Level Pressure",
                            "level_type": "surface",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "missing_value": "9.99900026E20",
                            "short_name": "PRES_meansealevel",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "surface",
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "missing_value": "9.99900026E20",
                            "short_name": "TPRATE_surface",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "long_name": "Surface Water Runoff",
                            "level": "surface",
                            "short_name": "SFCWRO_surface",
                            "standard_name": "surface_runoff_amount",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m^2",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "specific_humidity",
                            "long_name": "Specific Humidity",
                            "short_name": "SPFH_850mb",
                            "units": "unitless",
                            "missing_value": "9.99900026E20",
                            "level": "surface"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "level_type": "surface",
                            "short_name": "SHTFL_surface",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "level_type": "surface",
                            "short_name": "LHTFL_surface",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "missing_value": "9.99900026E20",
                            "level": "surface",
                            "pointwidth": "0.0"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.0",
                            "long_name": "Start Time",
                            "standard_name": "forecast_reference_time"
                        },
                        "dir": "SOURCES/Models/SubX/ECCC/GEPS6/forecast"
                    },
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "VVEL_500mb",
                            "level_type": "pressure level",
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "missing_value": "9.99900026E20"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "VGRD_10maboveground",
                            "units": "m/s",
                            "long_name": "10-meter Northward Wind",
                            "standard_name": "northward_wind",
                            "level_type": "10 meters above ground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "UGRD_10maboveground",
                            "units": "m/s",
                            "long_name": "10-meter Eastward Wind",
                            "standard_name": "eastward_wind",
                            "level_type": "10 meters above ground",
                            "level": "10 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "missing_value": "9.99900026E20"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SKINT_surface",
                            "standard_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "units": "Kelvin_scale",
                            "level_type": "surface",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "DPT_2maboveground",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "standard_name": "dew_point_temperature",
                            "level_type": "2 meters above ground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "Tmin_2m",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "Tmax_2m",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "TMP_2maboveground",
                            "standard_name": "air_temperature",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "level_type": "2 meters above ground",
                            "level": "2 m above ground",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SDWE_surface",
                            "units": "kg/m^2",
                            "long_name": "Snow Depth Water Equivalent",
                            "level_type": "surface",
                            "standard_name": "surface_snow_melt_amount",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "snwd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snwd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SDEN_surface",
                            "units": "kg/m^3",
                            "long_name": "Snow Density",
                            "level_type": "surface",
                            "standard_name": "snow_density",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "ICEC_surface",
                            "units": "Proportion",
                            "long_name": "Sea Ice Concentration",
                            "standard_name": "sea_ice_area_fraction",
                            "level_type": "surface",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "NLWRF_topofatmosphere",
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level_type": "top of atmosphere",
                            "level": "top of atmosphere",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "Net_rad",
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "level_type": "surface",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "PRES_meansealevel",
                            "standard_name": "air_pressure_at_sea_level",
                            "long_name": "Mean Sea Level Pressure",
                            "units": "Pa",
                            "level_type": "surface",
                            "level": "mean sea level",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "TPRATE_surface",
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SFCWRO_surface",
                            "units": "kg/m^2",
                            "long_name": "Surface Water Runoff",
                            "level_type": "surface",
                            "standard_name": "surface_runoff_amount",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SPFH_850mb",
                            "level_type": "pressure level",
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "missing_value": "9.99900026E20"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "SHTFL_surface",
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "short_name": "LHTFL_surface",
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level": "surface",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "dir": "SOURCES/Models/SubX/ECCC/GEPS6/hindcast"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "forecast",
                        "hindcast"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "GEM",
                    "GEPS5",
                    "GEPS6"
                ]
            },
            "EMC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Models/SubX/EMC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "EMC",
                "restriction": "Public",
                "GEFS": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Models/SubX/EMC/GEFS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "GEFS",
                    "restriction": "Public",
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ROMIreferences": "Wang_etal2018",
                            "ROMIdescription": "Real Time OLR MJO Index",
                            "GEFS_Notes": "ftp://ftp.emc.ncep.noaa.gov/gc_wmb/esinsky/GEFS_SubX/Notes_SubX_GEFS.pdf",
                            "Conventions": "IRIDL"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "geopotential_height",
                            "units": "gpm",
                            "level_type": "pressure level",
                            "long_name": "Geopotential Height",
                            "gribPDSpattern": "04XXXX00010305",
                            "pointwidth": "0.0"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "level_type": "pressure level",
                            "long_name": "Pressure Vertical Velocity",
                            "gribPDSpattern": "04XXXX00010208",
                            "pointwidth": "0.0"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "level_type": "10 meters above ground",
                            "units": "m/s",
                            "long_name": "10-meter V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "units": "m/s",
                            "long_name": "V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203",
                            "pointwidth": "0.0"
                        },
                        "uswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Short-Wave Radiation Flux",
                            "standard_name": "surface_upwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "ulwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ulwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Long-Wave Radiation Flux",
                            "standard_name": "surface_upwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "level_type": "10 meters above ground",
                            "units": "m/s",
                            "long_name": "10-meter U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "units": "m/s",
                            "long_name": "U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202",
                            "pointwidth": "0.0"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "surface",
                            "long_name": "Surface Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "dew_point_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Dew Point Temperature",
                            "gribPDSpattern": "04XXXX00010006",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Minimum Air Temperature",
                            "gribPDSpattern": "04XXXX00010005",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Maximum Air Temperature",
                            "gribPDSpattern": "04XXXX00010004",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Mean Air Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "units": "K",
                            "level_type": "pressure level",
                            "long_name": "Air Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m2",
                            "level_type": "surface",
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "gribPDSpattern": "04XXXX0001010D",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "level_type": "surface",
                            "long_name": "V-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010212",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "level_type": "surface",
                            "long_name": "U-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010211",
                            "pointwidth": "0.0"
                        },
                        "soilw4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "1.0-2.0 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "1.0-2.0 meters below ground",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.4-1.0 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "0.4-1.0 meters below ground",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.1-0.4 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "0.1-0.4 meters below ground",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0-0.1 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "0-0.1 meters below ground",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "snod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_thickness_of_surface_snow_amount",
                            "missing_value": "9.99900026E20",
                            "units": "m",
                            "level_type": "surface",
                            "long_name": "Surface Snow Depth",
                            "gribPDSpattern": "04XXXX0001010B",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_snow_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "percent",
                            "level_type": "surface",
                            "long_name": "Surface Snow Cover Percentage",
                            "gribPDSpattern": "04XXXX0001012A",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_ice_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "surface",
                            "long_name": "Surface Sea Ice Cover Proportion",
                            "gribPDSpattern": "04XXXX00010200",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Top-of Atmosphere Upward Long-Wave Radiation Flux",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "missing_value": "9.99900026E20",
                            "level_type": "top of atmosphere",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "units": "Pa",
                            "level_type": "surface",
                            "long_name": "Mean Sea Level Pressure",
                            "gribPDSpattern": "04XXXX00010301",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "precipitation_flux",
                            "missing_value": "9.99900026E20",
                            "units": "kg m-2 s-1",
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX00010107",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "specific_humidity",
                            "level_type": "pressure level",
                            "units": "kg/kg",
                            "long_name": "Specific Humidity",
                            "gribPDSpattern": "04XXXX00010100",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "long_name": "Surface Sensible Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000B",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "long_name": "Surface Latent Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000A",
                            "pointwidth": "0.0"
                        },
                        "dswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Short-Wave Radiation Flux",
                            "standard_name": "surface_downwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "dlwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dlwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Long-Wave Radiation Flux",
                            "standard_name": "surface_downwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "missing_value": "9.99900026E20",
                            "level_type": "180-0 mb above ground",
                            "units": "J/kg",
                            "long_name": "Convective Available Potential Energy",
                            "gribPDSpattern": "04XXXX00010706",
                            "pointwidth": "0.0"
                        },
                        "P_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "L_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "PC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "S_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.0",
                            "long_name": "Start Time",
                            "standard_name": "forecast_reference_time"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.0",
                            "long_name": "Start Time",
                            "standard_name": "forecast_reference_time"
                        },
                        "dir": "SOURCES/Models/SubX/EMC/GEFS/forecast"
                    },
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMMsource": "SubX IRI",
                            "RMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                            "RMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                            "RMMCreatedBy": "kpegion",
                            "RMMinstitution": "IRI",
                            "RMMtitle": "SubX RMM",
                            "RMMlong_title": "SubX RMM",
                            "RMMMatlabSource": "",
                            "dc9916source": "SubX IRI",
                            "dc9916comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                            "dc9916CreatedBy": "kpegion",
                            "dc9916institution": "IRI",
                            "dc9916description": "1999-2015 Daily Hindcast Climatology",
                            "dc9916title": "SubX Climatology",
                            "dc9916long_title": "SubX Climatology",
                            "dc9916CreationDate": "2018/02/04 19:39:37",
                            "dc9916MatlabSource": "",
                            "dc9915source": "SubX IRI",
                            "dc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                            "dc9915CreatedBy": "kpegion",
                            "dc9915institution": "IRI",
                            "dc9915description": "1999-2015 Daily Hindcast Climatology",
                            "dc9915title": "SubX Climatology",
                            "dc9915long_title": "SubX Climatology",
                            "dc9915CreationDate": "2018/02/04 19:39:37",
                            "dc9915MatlabSource": "",
                            "GEFS_Notes": "ftp://ftp.emc.ncep.noaa.gov/gc_wmb/esinsky/GEFS_SubX/Notes_SubX_GEFS.pdf",
                            "Conventions": "IRIDL"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "geopotential_height",
                            "missing_value": "9.99900026E20",
                            "units": "gpm",
                            "long_name": "Geopotential Height",
                            "gribPDSpattern": "04XXXX00010305"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "missing_value": "9.99900026E20",
                            "units": "Pa/s",
                            "long_name": "Pressure Vertical Velocity",
                            "gribPDSpattern": "04XXXX00010208"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "10 meters above ground",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "long_name": "10-meter V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "long_name": "V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203"
                        },
                        "uswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Short-Wave Radiation Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "ulwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ulwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Long-Wave Radiation Flux",
                            "level_type": "surface",
                            "standard_name": "surface_upwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "10 meters above ground",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "long_name": "10-meter U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "units": "m/s",
                            "long_name": "U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "surface_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "Surface Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "standard_name": "dew_point_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "2-meter Dew Point Temperature",
                            "gribPDSpattern": "04XXXX00010006",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "2-meter Minimum Air Temperature",
                            "gribPDSpattern": "04XXXX00010005",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "2-meter Maximum Air Temperature",
                            "gribPDSpattern": "04XXXX00010004",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "2 meters above ground",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "2-meter Mean Air Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "long_name": "Air Temperature",
                            "gribPDSpattern": "04XXXX00010000"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m2",
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "gribPDSpattern": "04XXXX0001010D",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "long_name": "V-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010212",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "long_name": "U-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010211",
                            "pointwidth": "0.0"
                        },
                        "soilw4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "1.0-2.0 m Below Ground Volumetric Soil Moisture Content",
                            "level_type": "1.0-2.0 meters below ground",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.4-1.0 m Below Ground Volumetric Soil Moisture Content",
                            "level_type": "0.4-1.0 meters below ground",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.1-0.4 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "level_type": "0.1-0.4 meters below ground",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0-0.1 m Below Ground Volumetric Soil Moisture Content",
                            "level_type": "0-0.1 meters below ground",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "snod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "lwe_thickness_of_surface_snow_amount",
                            "missing_value": "9.99900026E20",
                            "units": "m",
                            "long_name": "Surface Snow Depth",
                            "gribPDSpattern": "04XXXX0001010B",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "surface_snow_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "percent",
                            "long_name": "Surface Snow Cover Percentage",
                            "gribPDSpattern": "04XXXX0001012A",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "sea_ice_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "long_name": "Surface Sea Ice Cover Proportion",
                            "gribPDSpattern": "04XXXX00010200",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Top-of Atmosphere Upward Long-Wave Radiation Flux",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "units": "Pa",
                            "long_name": "Mean Sea Level Pressure",
                            "gribPDSpattern": "04XXXX00010301",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "parameter_template_discipline_category_number": "8",
                            "units": "kg m-2 s-1",
                            "long_name": "Total Precipitation",
                            "level_type": "surface",
                            "standard_name": "precipitation_flux",
                            "production_status": "Operational products",
                            "missing_value": "1.00000002E20",
                            "level": "0.0",
                            "grid_type": "Latitude/longitude",
                            "center": "US National Weather Service - NCEP (WMC)",
                            "parameter_discipline_and_category": "Meteorological products, Moisture",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "pressure level",
                            "standard_name": "specific_humidity",
                            "missing_value": "9.99900026E20",
                            "units": "kg/kg",
                            "long_name": "Specific Humidity",
                            "gribPDSpattern": "04XXXX00010100",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000B",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "surface",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000A",
                            "pointwidth": "0.0"
                        },
                        "dswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Short-Wave Radiation Flux",
                            "level_type": "surface",
                            "standard_name": "surface_downwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "dlwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dlwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Long-Wave Radiation Flux",
                            "level_type": "surface",
                            "standard_name": "surface_downwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "dc9916": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9916",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "fnname": "maskle",
                                "long_name": "Surface Temperature",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "1.00000002E20",
                                "pointwidth": "0.0"
                            }
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99900026E20"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "fnname": "maskle",
                                "long_name": "Surface Temperature",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "1.00000002E20",
                                "pointwidth": "0.0"
                            }
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level_type": "180-0 mb above ground",
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "missing_value": "9.99900026E20",
                            "units": "J/kg",
                            "long_name": "Convective Available Potential Energy",
                            "gribPDSpattern": "04XXXX00010706",
                            "pointwidth": "0.0"
                        },
                        "P_06": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_06",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "M_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "S_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "dir": "SOURCES/Models/SubX/EMC/GEFS/hindcast"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "forecast",
                        "hindcast"
                    ]
                },
                "GEFSv12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GEFSv12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "forecastROMIdescription": "Real Time OLR MJO Index",
                        "forecastROMIreferences": "Wang_etal2018",
                        "forecastGEFS_Notes": "ftp://ftp.emc.ncep.noaa.gov/gc_wmb/esinsky/GEFS_SubX/Notes_SubX_GEFS.pdf",
                        "Conventions": "IRIDL"
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "geopotential_height",
                            "units": "gpm",
                            "level_type": "pressure level",
                            "long_name": "Geopotential Height",
                            "gribPDSpattern": "04XXXX00010305",
                            "pointwidth": "0.0"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa/s",
                            "level_type": "pressure level",
                            "long_name": "Pressure Vertical Velocity",
                            "gribPDSpattern": "04XXXX00010208",
                            "pointwidth": "0.0"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "northward_wind",
                            "missing_value": "9.99900026E20",
                            "level_type": "10 meters above ground",
                            "units": "m/s",
                            "long_name": "10-meter V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "units": "m/s",
                            "long_name": "V-Component of Wind",
                            "gribPDSpattern": "04XXXX00010203",
                            "pointwidth": "0.0"
                        },
                        "uswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Short-Wave Radiation Flux",
                            "standard_name": "surface_upwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "level_type": "surface",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "ulwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ulwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Upward Long-Wave Radiation Flux",
                            "standard_name": "surface_upwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "level_type": "surface",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "eastward_wind",
                            "missing_value": "9.99900026E20",
                            "level_type": "10 meters above ground",
                            "units": "m/s",
                            "long_name": "10-meter U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "units": "m/s",
                            "long_name": "U-Component of Wind",
                            "gribPDSpattern": "04XXXX00010202",
                            "pointwidth": "0.0"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "surface",
                            "long_name": "Surface Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "dew_point_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Dew Point Temperature",
                            "gribPDSpattern": "04XXXX00010006",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Minimum Air Temperature",
                            "gribPDSpattern": "04XXXX00010005",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Maximum Air Temperature",
                            "gribPDSpattern": "04XXXX00010004",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "missing_value": "9.99900026E20",
                            "units": "K",
                            "level_type": "2 meters above ground",
                            "long_name": "2-meter Mean Air Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "air_temperature",
                            "units": "K",
                            "level_type": "pressure level",
                            "long_name": "Air Temperature",
                            "gribPDSpattern": "04XXXX00010000",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "missing_value": "9.99900026E20",
                            "units": "kg/m2",
                            "level_type": "surface",
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "gribPDSpattern": "04XXXX0001010D",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "level_type": "surface",
                            "long_name": "V-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010212",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "units": "N/m2",
                            "level_type": "surface",
                            "long_name": "U-Component of Surface Momentum Flux",
                            "gribPDSpattern": "04XXXX00010211",
                            "pointwidth": "0.0"
                        },
                        "soilw4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "1.0-2.0 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "level_type": "1.0-2.0 meters below ground",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.4-1.0 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "level_type": "0.4-1.0 meters below ground",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0.1-0.4 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "level_type": "0.1-0.4 meters below ground",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "soilw1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilw1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "0-0.1 m Below Ground Volumetric Soil Moisture Content",
                            "standard_name": "",
                            "missing_value": "9.99900026E20",
                            "level_type": "0-0.1 meters below ground",
                            "units": "unitless",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "snod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lwe_thickness_of_surface_snow_amount",
                            "missing_value": "9.99900026E20",
                            "units": "m",
                            "level_type": "surface",
                            "long_name": "Surface Snow Depth",
                            "gribPDSpattern": "04XXXX0001010B",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "surface_snow_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "percent",
                            "level_type": "surface",
                            "long_name": "Surface Snow Cover Percentage",
                            "gribPDSpattern": "04XXXX0001012A",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_ice_area_fraction",
                            "missing_value": "9.99900026E20",
                            "units": "unitless",
                            "level_type": "surface",
                            "long_name": "Surface Sea Ice Cover Proportion",
                            "gribPDSpattern": "04XXXX00010200",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Top-of Atmosphere Upward Long-Wave Radiation Flux",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "missing_value": "9.99900026E20",
                            "level_type": "top of atmosphere",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_pressure_at_sea_level",
                            "missing_value": "9.99900026E20",
                            "units": "Pa",
                            "level_type": "surface",
                            "long_name": "Mean Sea Level Pressure",
                            "gribPDSpattern": "04XXXX00010301",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "precipitation_flux",
                            "missing_value": "9.99900026E20",
                            "units": "kg m-2 s-1",
                            "level_type": "surface",
                            "long_name": "Total Precipitation",
                            "gribPDSpattern": "04XXXX00010107",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "standard_name": "specific_humidity",
                            "level_type": "pressure level",
                            "units": "kg/kg",
                            "long_name": "Specific Humidity",
                            "gribPDSpattern": "04XXXX00010100",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "long_name": "Surface Sensible Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000B",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "9.99900026E20",
                            "units": "W/m2",
                            "level_type": "surface",
                            "long_name": "Surface Latent Heat Net Flux",
                            "gribPDSpattern": "04XXXX0001000A",
                            "pointwidth": "0.0"
                        },
                        "dswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Short-Wave Radiation Flux",
                            "standard_name": "surface_downwelling_shortwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "level_type": "surface",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "dlwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dlwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Downward Long-Wave Radiation Flux",
                            "standard_name": "surface_downwelling_longwave_flux_in_air",
                            "missing_value": "9.99900026E20",
                            "level_type": "surface",
                            "units": "W/m2",
                            "gribfield": "1",
                            "pointwidth": "0.0"
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "missing_value": "9.99900026E20",
                            "level_type": "180-0 mb above ground",
                            "units": "J/kg",
                            "long_name": "Convective Available Potential Energy",
                            "gribPDSpattern": "04XXXX00010706",
                            "pointwidth": "0.0"
                        }
                    },
                    "P_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days",
                        "gridtype": "0",
                        "pointwidth": "0.0",
                        "standard_name": "forecast_period",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0.0",
                        "long_name": "Start Time",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/Models/SubX/EMC/GEFSv12"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "GEFS",
                    "GEFSv12"
                ]
            },
            "ESRL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ESRL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "FIMr1p1hindcastRMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                    "FIMr1p1hindcastRMMsource": "SubX IRI",
                    "FIMr1p1hindcastRMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "FIMr1p1hindcastRMMlong_title": "SubX RMM",
                    "FIMr1p1hindcastRMMinstitution": "IRI",
                    "FIMr1p1hindcastRMMtitle": "SubX RMM",
                    "FIMr1p1hindcastRMMMatlabSource": "",
                    "FIMr1p1hindcastRMMCreatedBy": "kpegion",
                    "FIMr1p1hindcastdc9916source": "SubX IRI",
                    "FIMr1p1hindcastdc9916comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "FIMr1p1hindcastdc9916long_title": "SubX Climatology",
                    "FIMr1p1hindcastdc9916institution": "IRI",
                    "FIMr1p1hindcastdc9916description": "1999-2015 Daily Hindcast Climatology",
                    "FIMr1p1hindcastdc9916title": "SubX Climatology",
                    "FIMr1p1hindcastdc9916CreationDate": "2017/12/05 16:39:43",
                    "FIMr1p1hindcastdc9916MatlabSource": "periodicCLIMO",
                    "FIMr1p1hindcastdc9916CreatedBy": "kpegion",
                    "FIMr1p1hindcastdc9915source": "SubX IRI",
                    "FIMr1p1hindcastdc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "FIMr1p1hindcastdc9915long_title": "SubX Climatology",
                    "FIMr1p1hindcastdc9915institution": "IRI",
                    "FIMr1p1hindcastdc9915description": "1999-2015 Daily Hindcast Climatology",
                    "FIMr1p1hindcastdc9915title": "SubX Climatology",
                    "FIMr1p1hindcastdc9915CreationDate": "2017/12/05 16:39:43",
                    "FIMr1p1hindcastdc9915MatlabSource": "periodicCLIMO",
                    "FIMr1p1hindcastdc9915CreatedBy": "kpegion",
                    "FIMr1p1hindcastnative_grid": "hex",
                    "FIMr1p1hindcastArchvTimeUnit": "hr",
                    "FIMr1p1hindcastGMT_offset": "-0000",
                    "FIMr1p1hindcastCreated_by": "fim2nc",
                    "FIMr1p1hindcastreal_kind": "4",
                    "FIMr1p1hindcastequation": "hydro",
                    "FIMr1p1hindcastinterp_method": "bilinear",
                    "FIMr1p1hindcastArchvIntvl": "24",
                    "FIMr1p1hindcastNCO": "4.4.5",
                    "FIMr1p1hindcastcase": "fim",
                    "FIMr1p1hindcastlevels": "L64",
                    "FIMr1p1hindcastdescription": "FIMr1.1 Hindcast",
                    "FIMr1p1hindcastmodel": "fim",
                    "FIMr1p1hindcastfixedgridorder": "False",
                    "FIMr1p1forecastROMIreferences": "Wang_etal2018",
                    "FIMr1p1forecastROMIdescription": "Real Time OLR MJO Index",
                    "FIMr1p1forecastnative_grid": "hex",
                    "FIMr1p1forecastArchvTimeUnit": "hr",
                    "FIMr1p1forecastGMT_offset": "-0000",
                    "FIMr1p1forecastCreated_by": "fim2nc",
                    "FIMr1p1forecastreal_kind": "4",
                    "FIMr1p1forecastequation": "hydro",
                    "FIMr1p1forecastinterp_method": "bilinear",
                    "FIMr1p1forecastArchvIntvl": "24",
                    "FIMr1p1forecastlevels": "L64",
                    "FIMr1p1forecastdescription": "FIMr1.1 Forecast",
                    "FIMr1p1forecastmodel": "fim",
                    "Conventions": "IRIDL"
                },
                "FIMr1p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FIMr1p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "gpm",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "time: mean pressure: mean"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "long_name": "Pressure Vertical Velocity",
                            "cell_method": "time: point",
                            "units": "Pa s^-1",
                            "missing_value": "-999999.0",
                            "level_type": "pressure level",
                            "vartyp": "scalar",
                            "cell_methods": "pressure: mean",
                            "pointwidth": "0.0"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter Northward Wind",
                            "cell_method": "time: point",
                            "standard_name": "northward_wind",
                            "level_type": "10 meters above ground",
                            "vartyp": "vector",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "cell_method": "time: point",
                            "vartyp": "vector",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "time: mean pressure: mean"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter Eastward Wind",
                            "cell_method": "time: point",
                            "standard_name": "eastward_wind",
                            "vartyp": "vector",
                            "level_type": "10 meters above ground",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "cell_method": "time: point",
                            "vartyp": "vector",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "time: mean pressure: mean"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "cell_method": "time: point",
                            "standard_name": "dew_point_temperature",
                            "level_type": "2 meters above ground",
                            "vartyp": "scalar",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "cell_methods": "time: minimum",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "cell_methods": "time: maximum",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Mean Air Temperature",
                            "cell_method": "time: point",
                            "standard_name": "air_temperature",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "time: mean pressure: mean"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Snow Water Equivalent",
                            "cell_method": "time: point",
                            "standard_name": "surface_snow_melt_amount",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Meridional Stress",
                            "units": "Pa",
                            "cell_method": "time: point",
                            "vartyp": "vector",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Zonal Stress",
                            "cell_method": "time: point",
                            "units": "Pa",
                            "vartyp": "vector",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Sea Ice Concentration",
                            "standard_name": "sea_ice_area_fraction",
                            "cell_method": "time: mean",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "top of atmosphere",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "cell_method": "time: point",
                            "level_type": "surface",
                            "vartyp": "scalar",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cell_method": "time: point",
                            "long_name": "Mean Sea Level Pressure",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "level_type": "surface",
                            "vartyp": "scalar",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cell_method": "time: point",
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Vertically Integrated Soil Moisture",
                            "standard_name": "soil_moisture_content",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "specific_humidity",
                            "long_name": "Specific Humidity",
                            "cell_method": "time: point",
                            "units": "unitless",
                            "missing_value": "-999999.0",
                            "level_type": "pressure level",
                            "vartyp": "scalar",
                            "cell_methods": "pressure: mean",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "cell_method": "time: point",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "cell_method": "time: point",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level_type": "surface",
                            "vartyp": "scalar",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "dc9916": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9916",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "gpm",
                                "standard_name": "geopotential_height",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            }
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "gpm",
                                "standard_name": "geopotential_height",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "missing_value": "-999999.0",
                                "level_type": "pressure level"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "-9.98999994E-08",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "gpm",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "pressure: mean"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "long_name": "Pressure Vertical Velocity",
                            "cell_method": "time: point",
                            "units": "Pa s^-1",
                            "missing_value": "-999999.0",
                            "level_type": "pressure level",
                            "vartyp": "scalar",
                            "cell_methods": "pressure: mean",
                            "pointwidth": "0.0"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter Northward Wind",
                            "cell_method": "time: point",
                            "standard_name": "northward_wind",
                            "vartyp": "vector",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "cell_method": "time: point",
                            "vartyp": "vector",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "pressure: mean"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter Eastward Wind",
                            "cell_method": "time: point",
                            "standard_name": "eastward_wind",
                            "vartyp": "vector",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "cell_method": "time: point",
                            "vartyp": "vector",
                            "level_type": "pressure level",
                            "missing_value": "-999999.0",
                            "cell_methods": "pressure: mean"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "cell_method": "time: point",
                            "standard_name": "dew_point_temperature",
                            "level_type": "2 meters above ground",
                            "vartyp": "scalar",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Mean Air Temperature",
                            "standard_name": "air_temperature",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "vartyp": "scalar",
                            "missing_value": "-999999.0",
                            "level_type": "pressure level",
                            "cell_methods": "pressure: mean"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Snow Water Equivalent",
                            "cell_method": "time: point",
                            "standard_name": "surface_snow_melt_amount",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Meridional Stress",
                            "units": "Pa",
                            "cell_method": "time: point",
                            "level_type": "surface",
                            "vartyp": "vector",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Zonal Stress",
                            "cell_method": "time: point",
                            "units": "Pa",
                            "vartyp": "vector",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Sea Ice Concentration",
                            "standard_name": "sea_ice_area_fraction",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "top of atmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cell_method": "time: point",
                            "long_name": "Mean Sea Level Pressure",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "level_type": "surface",
                            "vartyp": "scalar",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cell_method": "time: sum",
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Vertically Integrated Soil Moisture",
                            "standard_name": "soil_moisture_content",
                            "cell_method": "time: point",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "specific_humidity",
                            "long_name": "Specific Humidity",
                            "cell_method": "time: point",
                            "units": "unitless",
                            "missing_value": "-999999.0",
                            "level_type": "pressure level",
                            "vartyp": "scalar",
                            "cell_methods": "pressure: mean",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Sensible Heat Flux",
                            "cell_method": "time: point",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "cell_methods": "time: mean",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Latent Heat Flux",
                            "cell_method": "time: point",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "vartyp": "scalar",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "PC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/SubX/ESRL"
            },
            "GMAO": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Models/SubX/GMAO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "GMAO",
                "restriction": "Public",
                "GEOS_V2p1": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Models/SubX/GMAO/GEOS_V2p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "GEOS_V2p1",
                    "restriction": "Public",
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ROMIreferences": "Wang_etal2018",
                            "ROMIdescription": "Real Time OLR MJO Index",
                            "History": "File written by MAPL_CFIO",
                            "Institution": "NASA Global Modeling and Assimilation Office",
                            "Title": "GEOS-S2S-2_1",
                            "Comment": "GEOS-S2S-2_1",
                            "Conventions": "COARDS",
                            "CDO": "Climate Data Operators version 1.7.1 (http://mpimet.mpg.de/cdo)",
                            "Contact": "http://gmao.gsfc.nasa.gov",
                            "References": "http://gmao.gsfc.nasa.gov"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "Pa s-1",
                            "long_name": "Pressure Vertical Velocity",
                            "vmin": "-9.99999987E14",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "m s-1",
                            "long_name": "10-meter V-Component of Wind",
                            "vmin": "-9.99999987E14",
                            "standard_name": "northward_wind",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "10 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "units": "m s-1",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14"
                        },
                        "uswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "long_name": "Surface Upward Short-Wave Radiation Flux",
                            "vmin": "-9.99999987E14",
                            "standard_name": "surface_upwelling_shortwave_flux_in_air",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ulwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ulwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "long_name": "Surface Upward Long-Wave Radiation Flux",
                            "vmin": "-9.99999987E14",
                            "standard_name": "surface_upwelling_longwave_flux_in_air",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "m s-1",
                            "long_name": "10-meter U-Component of Wind",
                            "vmin": "-9.99999987E14",
                            "standard_name": "eastward_wind",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "10 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "long_name": "Zonal Velocity",
                            "vmax": "9.99999987E14",
                            "standard_name": "eastward_wind",
                            "units": "m s-1",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "units": "Kelvin_scale",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "vmin": "-9.99999987E14",
                            "standard_name": "dew_point_temperature",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "vmin": "-9.99999987E14",
                            "standard_name": "air_temperature",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "vmin": "-9.99999987E14",
                            "standard_name": "air_temperature",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "2-meter Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "Air Temperature",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "vmax": "9.99999987E14",
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Northward Surface Stress",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downward_northward_stress",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Eastward Surface Stress",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downward_eastward_stress",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "snod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Surface Snow Depth",
                            "vmax": "9.99999987E14",
                            "standard_name": "thickness_of_snowfall_amount",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Surface Snow Cover Fraction",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_snow_area_fraction",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Sea Ice Concentration",
                            "vmax": "9.99999987E14",
                            "standard_name": "sea_ice_area_fraction",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "top of atmosphere",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Mean Sea Level Pressure",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_pressure_at_sea_level",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmin": "-9.99999987E14",
                            "vmax": "9.99999987E14",
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Vertically Integrated Soil Moisture",
                            "vmax": "9.99999987E14",
                            "standard_name": "soil_moisture_content",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2 s-1",
                            "long_name": "Surface Water Runoff Flux",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_runoff_flux",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Specific Humidity",
                            "vmax": "9.99999987E14",
                            "standard_name": "specific_humidity",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Sensible Heat Net Flux",
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Latent Heat Net Flux",
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "dswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Downward Short-Wave Radiation Flux",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downwelling_shortwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "dlwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dlwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Downward Long-Wave Radiation Flux",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downwelling_longwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "J kg-1",
                            "long_name": "Surface-Based Convective Available Potential Energy",
                            "vmax": "9.99999987E14",
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "vmin": "-9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "P_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "PC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "L_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "S_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.0",
                            "long_name": "Start Time",
                            "standard_name": "forecast_reference_time"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.0",
                            "long_name": "Start Time",
                            "standard_name": "forecast_reference_time"
                        },
                        "dir": "SOURCES/Models/SubX/GMAO/GEOS_V2p1/forecast"
                    },
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                            "RMMsource": "SubX IRI",
                            "RMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                            "RMMlong_title": "SubX RMM",
                            "RMMtitle": "SubX RMM",
                            "RMMinstitution": "IRI",
                            "RMMCreatedBy": "kpegion",
                            "RMMMatlabSource": "",
                            "dc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                            "dc9915source": "SubX IRI",
                            "dc9915CreationDate": "2018/02/22 08:43:19",
                            "dc9915description": "1999-2015 Daily Hindcast Climatology",
                            "dc9915long_title": "SubX Climatology",
                            "dc9915institution": "IRI",
                            "dc9915title": "SubX Climatology",
                            "dc9915CreatedBy": "kpegion",
                            "dc9915MatlabSource": "",
                            "Institution": "NASA Global Modeling and Assimilation Office",
                            "History": "File written by MAPL_CFIO",
                            "Title": "yuri-S2S-2_1_UNSTABLE",
                            "References": "http://gmao.gsfc.nasa.gov",
                            "Conventions": "COARDS",
                            "CDO": "Climate Data Operators version 1.7.1 (http://mpimet.mpg.de/cdo)",
                            "Contact": "http://gmao.gsfc.nasa.gov",
                            "Comment": "yuri-S2S-2_1_UNSTABLE"
                        },
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa s-1",
                            "long_name": "Pressure Vertical Velocity at 500 hPa",
                            "vmax": "9.99999987E14",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "vmin": "-9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter V-Component of Wind",
                            "vmax": "9.99999987E14",
                            "standard_name": "northward_wind",
                            "vmin": "-9.99999987E14",
                            "level_type": "10 meters above ground",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "units": "m s-1",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14"
                        },
                        "uswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Upward Short-Wave Radiation",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_upwelling_shortwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ulwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ulwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Upward Long-Wave Radiation",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_upwelling_longwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-meter U-Component of Wind",
                            "vmax": "9.99999987E14",
                            "standard_name": "eastward_wind",
                            "vmin": "-9.99999987E14",
                            "level_type": "10 meters above ground",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Zonal Velocity",
                            "vmax": "9.99999987E14",
                            "standard_name": "eastward_wind",
                            "units": "m s-1",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "units": "Kelvin_scale",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Dew Point Temperature",
                            "vmax": "9.99999987E14",
                            "standard_name": "dew_point_temperature",
                            "vmin": "-9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Minimum Air Temperature",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "vmin": "-9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-meter Maximum Air Temperature",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "vmin": "-9.99999987E14",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "2-meter Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "Air Temperature",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_temperature",
                            "vmin": "-9.99999987E14",
                            "level_type": "pressure level",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "vmax": "9.99999987E14",
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Northward Surface Stress",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downward_northward_stress",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Eastward Surface Stress",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downward_eastward_stress",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "snod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Surface Snow Depth",
                            "vmax": "9.99999987E14",
                            "standard_name": "thickness_of_snowfall_amount",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Surface Snow Cover Fraction",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_snow_area_fraction",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Sea Ice Concentration",
                            "vmax": "9.99999987E14",
                            "standard_name": "sea_ice_area_fraction",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "level_type": "top of atmosphere",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Mean Sea Level Pressure",
                            "vmax": "9.99999987E14",
                            "standard_name": "air_pressure_at_sea_level",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vmax": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "vmin": "-9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2",
                            "long_name": "Vertically Integrated Soil Moisture",
                            "vmax": "9.99999987E14",
                            "standard_name": "soil_moisture_content",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "mrro": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrro",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg m-2 s-1",
                            "long_name": "Surface Water Runoff",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_runoff_flux",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Specific Humidity at 850 hPa",
                            "vmax": "9.99999987E14",
                            "standard_name": "specific_humidity",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Surface Sensible Heat Net Flux",
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fmissing_value": "9.99999987E14",
                            "long_name": "Surface Latent Heat Net Flux",
                            "vmax": "9.99999987E14",
                            "units": "W/m2",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "dswrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dswrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Downward Short-Wave Radiation Flux",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downwelling_shortwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "dlwrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dlwrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Downward Long-Wave Radiation Flux",
                            "vmax": "9.99999987E14",
                            "standard_name": "surface_downwelling_longwave_flux_in_air",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.99999987E14"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99999987E14"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.99999987E14"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "9.99999987E14",
                                "pointwidth": "0.0"
                            }
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "J kg-1",
                            "long_name": "Surface-Based Convective Available Potential Energy",
                            "vmax": "9.99999987E14",
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "vmin": "-9.99999987E14",
                            "level_type": "surface",
                            "missing_value": "9.99999987E14",
                            "fmissing_value": "9.99999987E14",
                            "pointwidth": "0.0"
                        },
                        "P_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "P1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "pointwidth": "0",
                            "long_name": "Pressure Level"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "long_name": "Pressure Level",
                            "standard_name": "air_pressure"
                        },
                        "S_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "hPa",
                            "gridtype": "0",
                            "standard_name": "air_pressure",
                            "long_name": "Pressure Level"
                        },
                        "S_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "realization",
                            "long_name": "Ensemble Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0.0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "calendar": "standard"
                        },
                        "dir": "SOURCES/Models/SubX/GMAO/GEOS_V2p1/hindcast"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "forecast",
                        "hindcast"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "GEOS_V2p1"
                ]
            },
            "NCEP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCEP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CFSv2hindcastdc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "CFSv2hindcastdc9915source": "SubX IRI",
                    "CFSv2hindcastdc9915MatlabSource": "",
                    "CFSv2hindcastdc9915description": "1999-2016 Daily Hindcast Climatology",
                    "CFSv2hindcastdc9915title": "SubX Climatology",
                    "CFSv2hindcastdc9915long_title": "SubX Climatology",
                    "CFSv2hindcastdc9915institution": "IRI",
                    "CFSv2hindcastdc9915CreatedBy": "kpegion",
                    "CFSv2forecastROMIreferences": "Wang_etal2018",
                    "CFSv2forecastROMIdescription": "Real Time OLR MJO Index",
                    "Conventions": "IRIDL"
                },
                "CFSv2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CFSv2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height at 500 hPa",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "level_type": "pressure level",
                            "interpolation": "no interpolation; data straight from NCEP",
                            "missing_value": "-9999.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Wind",
                            "units": "m/s",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "interpolation": "no interpolation; data straight from NCEP",
                            "missing_value": "-9999.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Wind",
                            "units": "m/s",
                            "standard_name": "eastward_wind",
                            "level_type": "pressure level",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Temperature",
                            "units": "Kelvin_scale",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "level_type": "surface",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Mean Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "level_type": "2 meters above ground",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "pointwidth": "0.0"
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "standard_name": "air_temperature",
                                "units": "Kelvin_scale",
                                "level_type": "2 meters above ground",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "standard_name": "geopotential_height",
                            "level_type": "pressure level",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Wind at 200 hPa",
                            "units": "m/s",
                            "standard_name": "northward_wind",
                            "level_type": "pressure level",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "level_type": "surface",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Mean Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "level_type": "2 meters above ground",
                            "missing_value": "-9999.0",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "standard_name": "precipitation_flux",
                            "units": "kg m-2 s-1",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "interpolation": "bilinearly interpolated from Gaussian grid",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "P_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "pointwidth": "300.0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "PC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/SubX/NCEP"
            },
            "NRL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NRL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NESMhindcastRMMCreatedBy": "kpegion",
                    "NESMhindcastRMMlong_title": "SubX RMM",
                    "NESMhindcastRMMsource": "SubX IRI",
                    "NESMhindcastRMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                    "NESMhindcastRMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "NESMhindcastRMMMatlabSource": "",
                    "NESMhindcastRMMtitle": "SubX RMM",
                    "NESMhindcastRMMinstitution": "IRI",
                    "NESMhindcastdc9915CreatedBy": "kpegion",
                    "NESMhindcastdc9915long_title": "SubX Climatology",
                    "NESMhindcastdc9915source": "SubX IRI",
                    "NESMhindcastdc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "NESMhindcastdc9915description": "1999-2015 Daily Hindcast Climatology",
                    "NESMhindcastdc9915MatlabSource": "",
                    "NESMhindcastdc9915title": "SubX Climatology",
                    "NESMhindcastdc9915institution": "IRI",
                    "NESMhindcastdc9915CreationDate": "2018/02/22 18:27:52",
                    "NESMhindcastSubX_Model": "Navy Earth System Model (NESM)",
                    "NESMforecastROMIreferences": "Wang_etal2018",
                    "NESMforecastROMIdescription": "Real Time OLR MJO Index",
                    "NESMforecastSubX_Model": "Navy Earth System Model (NESM)",
                    "Conventions": "IRIDL"
                },
                "NESM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NESM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "geopotential_height",
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "zg",
                            "standard_name": "geopotential_height",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "lagrangian_tendency_of_air_pressure",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "units": "Pa s-1",
                            "long_name": "Vertical Velocity (omega)",
                            "abbrev": "wap",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "northward_wind",
                            "long_name": "10-meter V-Component of Wind",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "vas",
                            "navgem_type": "flat_files",
                            "standard_name": "northward_wind",
                            "level": "10m",
                            "missing_value": "-9999.0",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "northward_wind",
                            "long_name": "Meridional Velocity",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "va",
                            "standard_name": "northward_wind",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "eastward_wind",
                            "long_name": "10-meter U-Component of Wind",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "uas",
                            "navgem_type": "flat_files",
                            "standard_name": "eastward_wind",
                            "level": "10m",
                            "missing_value": "-9999.0",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "eastward_wind",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "units": "m s-1",
                            "long_name": "Zonal Velocity",
                            "abbrev": "ua",
                            "standard_name": "eastward_wind",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "units": "Kelvin_scale",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "ts",
                            "navgem_type": "mean",
                            "standard_name": "surface_temperature",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "dew_point_temperature",
                            "long_name": "2m dewpoint temperature",
                            "units": "unitless",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "tdps",
                            "level": "2m",
                            "missing_value": "-9999.0",
                            "standardname": "dew_point_temperature",
                            "unit": "K",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "air_temperature",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "tas",
                            "navgem_type": "mean",
                            "standard_name": "air_temperature",
                            "level": "2m",
                            "missing_value": "-9999.0",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Surface stress (tauy)",
                            "frequency": "Daily Average 00Z-00Z",
                            "level": "sfc",
                            "CF_name": "surface_meridional_stress_positive_to_the_south",
                            "missing_value": "-9999.0",
                            "abbrev": "sty",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "sfc",
                            "long_name": "Surface stress (taux)",
                            "frequency": "Daily Average 00Z-00Z",
                            "CF_name": "surface_zonal_stress_positive_to_the_west",
                            "units": "Pa",
                            "abbrev": "stx",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "sea_ice_area_fraction",
                            "long_name": "Sea ice concentration",
                            "units": "unitless",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "sic",
                            "standard_name": "sea_ice_area_fraction",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "-9999.0",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "toa_outgoing_longwave_flux",
                            "frequency": "Accumulated every 24 hours",
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "abbrev": "rlut",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level": "toa",
                            "missing_value": "-9999.0",
                            "level_type": "top of atmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "net_surface_radiation",
                            "long_name": "Net surface Radiation (LWup-LWdown+SWup-SWdown)",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24 hrs",
                            "abbrev": "rad",
                            "standard_name": "surface_net_downward_radiative_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "air_pressure_at_sea_level",
                            "long_name": "Mean sea level pressure",
                            "units": "Pa",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "psl",
                            "standard_name": "air_pressure_at_mean_sea_level",
                            "level": "msl",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "precipitatoin_flux",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "frequency": "Average per 24 hours",
                            "abbrev": "pr",
                            "standard_name": "precipitation_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_upward_sensible_heat_flux",
                            "long_name": "Surface sensible heat flux",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24hrs",
                            "abbrev": "hfss",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_upward_latent_heat_flux",
                            "long_name": "Surface latent heat flux",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24hrs",
                            "abbrev": "hfls",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "missing_value": "-9999.0",
                                "level_type": "pressure level"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "northward_wind",
                                "missing_value": "-9999.0",
                                "level_type": "pressure level"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "missing_value": "-9999.0",
                                "level_type": "pressure level"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "missing_value": "-9999.0",
                                "level_type": "surface",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "missing_value": "-9999.0",
                                "level_type": "2 meters above ground",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "missing_value": "-9999.0",
                                "level_type": "top of atmosphere",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "missing_value": "-9999.0",
                                "level_type": "surface",
                                "pointwidth": "0.0"
                            }
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "atmosphere_convective_available_potential_energy",
                            "units": "J kg-1",
                            "long_name": "Convective available potential energy (CAPE)",
                            "frequency": "Daily Average",
                            "abbrev": "cape",
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "geopotential_height",
                            "long_name": "Geopotential Height",
                            "units": "m",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "zg",
                            "standard_name": "geopotential_height",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "lagrangian_tendency_of_air_pressure",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "units": "Pa s-1",
                            "long_name": "Vertical Velocity (omega)",
                            "abbrev": "wap",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "northward_wind",
                            "long_name": "10-meter V-Component of Wind",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "vas",
                            "navgem_type": "flat_files",
                            "standard_name": "northward_wind",
                            "level": "10m",
                            "missing_value": "-9999.0",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "northward_wind",
                            "long_name": "Meridional Velocity",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "va",
                            "standard_name": "northward_wind",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "eastward_wind",
                            "long_name": "10-meter U-Component of Wind",
                            "units": "m s-1",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "uas",
                            "navgem_type": "flat_files",
                            "standard_name": "eastward_wind",
                            "level": "10m",
                            "missing_value": "-9999.0",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "eastward_wind",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "units": "m s-1",
                            "long_name": "Zonal Velocity",
                            "abbrev": "ua",
                            "standard_name": "eastward_wind",
                            "navgem_type": "flat_files",
                            "missing_value": "-9999.0",
                            "level_unit": "hPa",
                            "level_type": "pressure level"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_temperature",
                            "long_name": "Surface Temperature",
                            "units": "Kelvin_scale",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "ts",
                            "navgem_type": "mean",
                            "standard_name": "surface_temperature",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "dew_point_temperature",
                            "long_name": "2m dewpoint temperature",
                            "units": "unitless",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "tdps",
                            "level": "2m",
                            "missing_value": "-9999.0",
                            "standardname": "dew_point_temperature",
                            "unit": "K",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "air_temperature",
                            "long_name": "2-meter Air Temperature",
                            "units": "Kelvin_scale",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "tas",
                            "navgem_type": "mean",
                            "standard_name": "air_temperature",
                            "level": "2m",
                            "missing_value": "-9999.0",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Surface stress (tauy)",
                            "frequency": "Daily Average 00Z-00Z",
                            "level": "sfc",
                            "CF_name": "surface_meridional_stress_positive_to_the_south",
                            "missing_value": "-9999.0",
                            "abbrev": "sty",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "level": "sfc",
                            "long_name": "Surface stress (taux)",
                            "frequency": "Daily Average 00Z-00Z",
                            "CF_name": "surface_zonal_stress_positive_to_the_west",
                            "units": "Pa",
                            "abbrev": "stx",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "sic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "sea_ice_area_fraction",
                            "long_name": "Sea ice concentration",
                            "units": "unitless",
                            "frequency": "Daily Average 00Z-00Z",
                            "abbrev": "sic",
                            "standard_name": "sea_ice_area_fraction",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "toa_outgoing_longwave_flux",
                            "frequency": "Accumulated every 24 hours",
                            "units": "W/m2",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "abbrev": "rlut",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "level": "toa",
                            "missing_value": "-9999.0",
                            "level_type": "top of atmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "net_surface_radiation",
                            "long_name": "Net surface Radiation (LWup-LWdown+SWup-SWdown)",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24 hrs",
                            "abbrev": "rad",
                            "standard_name": "surface_net_downward_radiative_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "air_pressure_at_sea_level",
                            "long_name": "Mean sea level pressure",
                            "units": "Pa",
                            "frequency": "Average of instantaneous values at 0Z,6Z,12Z,18Z",
                            "abbrev": "psl",
                            "standard_name": "air_pressure_at_mean_sea_level",
                            "level": "msl",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "precipitatoin_flux",
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "frequency": "Average per 24 hours",
                            "abbrev": "pr",
                            "standard_name": "precipitation_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_upward_sensible_heat_flux",
                            "long_name": "Surface sensible heat flux",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24hrs",
                            "abbrev": "hfss",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "surface_upward_latent_heat_flux",
                            "long_name": "Surface latent heat flux",
                            "units": "W/m2",
                            "frequency": "Accumulated every 24hrs",
                            "abbrev": "hfls",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "cape": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cape",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CF_name": "atmosphere_convective_available_potential_energy",
                            "units": "J kg-1",
                            "long_name": "Convective available potential energy (CAPE)",
                            "frequency": "Daily Average",
                            "abbrev": "cape",
                            "standard_name": "atmosphere_convective_available_potential_energy",
                            "level": "sfc",
                            "missing_value": "-9999.0",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "P_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "PC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "long_name": "Start Time",
                    "standard_name": "forecast_reference_time"
                },
                "dir": "SOURCES/Models/SubX/NRL"
            },
            "RSMAS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RSMAS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CCSM4hindcastRMMsource": "SubX IRI",
                    "CCSM4hindcastRMMMatlabSource": "",
                    "CCSM4hindcastRMMlong_name": "Real-time Multivariate MJO Indices Including Interannual Variability",
                    "CCSM4hindcastRMMtitle": "SubX RMM",
                    "CCSM4hindcastRMMlong_title": "SubX RMM",
                    "CCSM4hindcastRMMCreatedBy": "kpegion",
                    "CCSM4hindcastRMMinstitution": "IRI",
                    "CCSM4hindcastRMMcomments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "CCSM4hindcastdc9916source": "SubX IRI",
                    "CCSM4hindcastdc9916MatlabSource": "",
                    "CCSM4hindcastdc9916description": "1999-2015 Daily Hindcast Climatology",
                    "CCSM4hindcastdc9916title": "SubX Climatology",
                    "CCSM4hindcastdc9916long_title": "SubX Climatology",
                    "CCSM4hindcastdc9916CreatedBy": "kpegion",
                    "CCSM4hindcastdc9916institution": "IRI",
                    "CCSM4hindcastdc9916CreationDate": "2018/02/03 00:30:07",
                    "CCSM4hindcastdc9916comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "CCSM4hindcastdc9915source": "SubX IRI",
                    "CCSM4hindcastdc9915MatlabSource": "",
                    "CCSM4hindcastdc9915description": "1999-2015 Daily Hindcast Climatology",
                    "CCSM4hindcastdc9915title": "SubX Climatology",
                    "CCSM4hindcastdc9915long_title": "SubX Climatology",
                    "CCSM4hindcastdc9915CreatedBy": "kpegion",
                    "CCSM4hindcastdc9915institution": "IRI",
                    "CCSM4hindcastdc9915CreationDate": "2018/02/03 00:30:07",
                    "CCSM4hindcastdc9915comments": "SubX project http://cola.gmu.edu/~kpegion/subx/",
                    "CCSM4hindcastcontact": "Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu)",
                    "CCSM4hindcastfrequency": "daily",
                    "CCSM4hindcastmodel_id": "CCSM4_0_a02",
                    "CCSM4hindcastinstitution_id": "UM-RSMAS",
                    "CCSM4hindcastConventions": "CF-1.0",
                    "CCSM4hindcastmodeling_realm": "atmos",
                    "CCSM4hindcastinstitution": "Univ. of Miami - Rosenstiel School of Marine & Atmosphereric Science",
                    "CCSM4hindcastGenerator": "NCL v.6.0",
                    "CCSM4hindcastproject_id": "North America Model Ensembles(NMME) project",
                    "CCSM4hindcastReferences": "Ben P. Kirtman, Dughong Min. (2009) Multimodel Ensemble ENSO Prediction with CCSM and CFS. Monthly Weather Review 137:9, 2908-2930",
                    "CCSM4forecastROMIreferences": "Wang_etal2018",
                    "CCSM4forecastROMIdescription": "Real Time OLR MJO Index",
                    "CCSM4forecastcontact": "Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu)",
                    "CCSM4forecastmodeling_realm": "atmos",
                    "CCSM4forecastfrequency": "daily",
                    "CCSM4forecastConventions": "CF-1.0",
                    "CCSM4forecastinstitution_id": "UM-RSMAS",
                    "CCSM4forecastGenerator": "NCL v.6.0",
                    "CCSM4forecastmodel_id": "CCSM4_0_a02",
                    "CCSM4forecastinstitution": "Univ. of Miami - Rosenstiel School of Marine & Atmosphereric Science",
                    "CCSM4forecastReferences": "Ben P. Kirtman, Dughong Min. (2009) Multimodel Ensemble ENSO Prediction with CCSM and CFS. Monthly Weather Review 137:9, 2908-2930",
                    "CCSM4forecastproject_id": "North America Model Ensembles(NMME) project",
                    "Conventions": "IRIDL"
                },
                "CCSM4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CCSM4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Pressure Vertical Velocity",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "units": "Pa s-1",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "10-meter V-Component of Wind",
                            "units": "m s-1",
                            "standard_name": "northward_wind",
                            "missing_value": "9.96920997E36",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "units": "m s-1",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "10-meter U-Component of Wind",
                            "units": "m s-1",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.96920997E36",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "units": "m s-1",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Minimum Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Maximum Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "units": "kg m-2",
                            "cell_method": "time: mean",
                            "missing_value": "9.99999962E35",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Northward Surface Stress",
                            "standard_name": "surface_downward_northward_stress",
                            "units": "Pa",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Eastward Surface Stress",
                            "standard_name": "surface_downward_eastward_stress",
                            "units": "Pa",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Snow Cover Fraction",
                            "standard_name": "surface_snow_area_fraction",
                            "units": "percent",
                            "cell_method": "time: mean",
                            "missing_value": "9.99999962E35",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "RMM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RMM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RMM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM2",
                                "units": "unitless",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "RMM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RMM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RMM1",
                                "units": "unitless",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "phase": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phase",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "phase",
                                "units": "unitless",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "amplitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amplitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "amplitude",
                                "units": "unitless",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Sampling_Sequence": "rad_lwsw",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "top of atmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "standard_name": "surface_net_downward_radiative_flux",
                            "units": "W/m2",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Sea Level Pressure",
                            "standard_name": "air_pressure_at_mean_sea_level",
                            "units": "Pa",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Vertically Integrated Soil Moisture",
                            "standard_name": "soil_moisture_content",
                            "units": "kg m-2",
                            "cell_method": "time: mean",
                            "missing_value": "9.99999962E35",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Specific Humidity",
                            "standard_name": "specific_humidity",
                            "units": "unitless",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level",
                            "pointwidth": "0.0"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Sensible Heat Flux",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "units": "W/m2",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Latent Heat Flux",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "units": "W/m2",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "dc9916": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9916",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            }
                        },
                        "dc9915": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dc9915",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "standard_name": "geopotential_height",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Velocity",
                                "units": "m s-1",
                                "standard_name": "eastward_wind",
                                "level_type": "pressure level",
                                "missing_value": "9.96920997E36"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "surface_temperature",
                                "level_type": "surface",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2-meter Mean Air Temperature",
                                "units": "Kelvin_scale",
                                "standard_name": "air_temperature",
                                "level_type": "2 meters above ground",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                                "units": "W/m2",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "level_type": "top of atmosphere",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "kg m-2 s-1",
                                "standard_name": "precipitation_flux",
                                "level_type": "surface",
                                "missing_value": "9.96920997E36",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "standard_name": "geopotential_height",
                            "units": "m",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "wap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Pressure Vertical Velocity",
                            "units": "Pa s-1",
                            "standard_name": "lagrangian_tendency_of_air_pressure",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "10-meter V-Component of Wind",
                            "units": "m s-1",
                            "standard_name": "northward_wind",
                            "missing_value": "9.96920997E36",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Meridional Velocity",
                            "standard_name": "northward_wind",
                            "units": "m s-1",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "10-meter U-Component of Wind",
                            "units": "m s-1",
                            "standard_name": "eastward_wind",
                            "missing_value": "9.96920997E36",
                            "level_type": "10 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Zonal Velocity",
                            "standard_name": "eastward_wind",
                            "units": "m s-1",
                            "missing_value": "9.96920997E36",
                            "level_type": "pressure level"
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Temperature",
                            "standard_name": "surface_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Minimum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "cell_method": "time: mean",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Maximum Air Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "cell_method": "time: mean",
                            "level_type": "2 meters above ground",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-meter Air Temperature",
                            "standard_name": "air_temperature",
                            "units": "Kelvin_scale",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "2 meters above ground",
                            "pointwidth": "0.0"
                        },
                        "swe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Water Equivalent of Accumulated Snow Depth",
                            "units": "kg m-2",
                            "standard_name": "liquid_water_content_of_surface_snow",
                            "cell_method": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.99999962E35",
                            "pointwidth": "0.0"
                        },
                        "sty": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sty",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Northward Surface Stress",
                            "units": "Pa",
                            "standard_name": "surface_downward_northward_stress",
                            "cell_method": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "stx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Eastward Surface Stress",
                            "units": "Pa",
                            "standard_name": "surface_downward_eastward_stress",
                            "cell_method": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "snc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Snow Cover Fraction",
                            "units": "percent",
                            "standard_name": "surface_snow_area_fraction",
                            "cell_method": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.99999962E35",
                            "pointwidth": "0.0"
                        },
                        "ROMI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ROMI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "romi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "romi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Real Time OLR MJO Index",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "pointwidth": "0.0"
                            }
                        },
                        "rlut": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlut",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Sampling_Sequence": "rad_lwsw",
                            "long_name": "Outgoing Longwave Radiation at Top of Atmosphere",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "cell_method": "time: mean",
                            "missing_value": "9.96920997E36",
                            "level_type": "top of atmosphere",
                            "pointwidth": "0.0"
                        },
                        "rad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Net Surface Radiation",
                            "units": "W/m2",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mean Sea Level Pressure",
                            "standard_name": "air_pressure_at_sea_level",
                            "units": "Pa",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "pr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Total Precipitation",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation_flux",
                            "level_type": "surface",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0.0"
                        },
                        "mrso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Vertically Integrated Soil Moisture",
                            "units": "kg m-2",
                            "standard_name": "soil_moisture_content",
                            "cell_method": "time: mean",
                            "level_type": "surface",
                            "missing_value": "9.99999962E35",
                            "pointwidth": "0.0"
                        },
                        "huss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "huss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Specific Humidity",
                            "units": "unitless",
                            "standard_name": "specific_humidity",
                            "level_type": "pressure level",
                            "missing_value": "9.96920997E36"
                        },
                        "hfss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Sensible Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_sensible_heat_flux",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        },
                        "hfls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Latent Heat Flux",
                            "units": "W/m2",
                            "standard_name": "surface_upward_latent_heat_flux",
                            "missing_value": "9.96920997E36",
                            "level_type": "surface",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "standard_name": "air_pressure",
                    "long_name": "Pressure Level"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "calendar": "standard"
                },
                "P_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "PC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0",
                    "long_name": "Pressure Level",
                    "standard_name": "air_pressure"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "realization",
                    "long_name": "Ensemble Member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time"
                },
                "dir": "SOURCES/Models/SubX/RSMAS"
            },
            "observed": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "observed",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "climatologiesCPCCPC": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.temperature/.daily/",
                    "climatologiesCPCdescription": "Climatologies 1999-2015",
                    "climatologiesCPCClimate": "http://www.cpc.ncep.noaa.gov/",
                    "Conventions": "IRIDL"
                },
                "climatologies": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatologies",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CPC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CPC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tminSmooth": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tminSmooth",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Manimum Temperature  - triangular smoothing climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        },
                        "tminClim": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tminClim",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Minimum Temperature - climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        },
                        "tmeanSmooth": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmeanSmooth",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mean Temperature  - triangular smoothing climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        },
                        "tmeanClim": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmeanClim",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mean Temperature - climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        },
                        "tmaxSmooth": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmaxSmooth",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Maximum Temperature  - triangular smoothing climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        },
                        "tmaxClim": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmaxClim",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Maximum Temperature - climatology ",
                            "units": "Celsius_scale",
                            "missing_value": "NaN"
                        }
                    }
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude",
                    "long_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0.0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "forecast start time",
                    "calendar": "standard"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude",
                    "long_name": "longitude"
                },
                "dir": "SOURCES/Models/SubX/observed"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CESM",
                "ECCC",
                "EMC",
                "ESRL",
                "GMAO",
                "NCEP",
                "NRL",
                "RSMAS",
                "observed"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "AMIP",
            "NMME",
            "SubX"
        ]
    },
    "Morliere": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Morliere",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Zonal and meridional wind stress data for the Atlantic and Eastern Pacific Oceans from Alain Morliere\\'s model",
            "iridlhasSemantics": "iriref:Morliere_A",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2",
            "history": "Wind stresses from Alain Morliere\\'s model."
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2",
            "history": "Wind stresses from Alain Morliere\\'s model."
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/Morliere"
    },
    "NASA": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/NASA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "NASA",
        "restriction": "Public",
        "ARC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ARC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ECOCASTGIMMSNDVI3gv1p0NCO": "4.3.7",
                "ECOCASTGIMMSNDVI3gv1p0SouthernmostLatitude": "-90",
                "ECOCASTGIMMSNDVI3gv1p0description": "Version 1.0",
                "ECOCASTGIMMSNDVI3gv1p0Data": "https://ecocast.arc.nasa.gov/data/pub/gimms/3g.v1/",
                "ECOCASTGIMMSNDVI3gv1p0CommentsVersion1": "version1 includes two major fixes (a and b), and three minor (c-g): (a) Reprocessed Level 2 entire SeaWIFS mission for the land products to reduce artifacts in the data, particularly changes in calibration after 2006 that generates drops in ndvi lower values. OB.DAAC / Ocean Biology Processing group NASA/GSFC 616  (april 2016) (b) Recovered ndvi negative values of snow-covered regions in winter Northern latitudes.  In Version0, we masked them with zero values, reating artifacts in phenology parameters.  (c) Arranged data in ncd format, compiled it in two nc4 files a year.  Each nc4 file includes 6 months of ndvi data (jan-jun and jul-dec), with a total of 12 (15-day) composites each semester.  (d) Rescaled ndvi values and splitted the flag values from them.  (e) Added a new variable, percentile, to represent the distribution of ndvi values in the time series. Range 10*[0, 100]   (f) Flag values are (simpler):  flag 0: ndvi without apparent issues (good value)  flag 1: ndvi retrieved from spline interpolation  flag 2: ndvi retrieved from seasonal profile (possible snow/cloud)  (g) Flag values are embeded on the percentile variable:  2000*flag + percentile. Thus, the actual percentile three ranges [0 1000], [2000 3000] and [4000 5000] could provide direct information of how interpolation is affecting the time series.",
                "ECOCASTGIMMSNDVI3gv1p0NorthernmostLatitude": "90",
                "ECOCASTGIMMSNDVI3gv1p0Reference": "1. Pinzon, J.E.; Tucker, C.J.  A Non-Stationary 1981-2012 AVHRR NDVI3g Time Series. Remote Sens. 2014, 6, 6929-6960.  2. Pinzon, J.E.; Tucker, C.J.  A Non-Stationary 1981-2015 AVHRR NDVI3g.v1 Time Series: an update.  Remote Sens. 2016, in preparation",
                "ECOCASTGIMMSNDVI3gv1p0WesternmostLongitude": "-180",
                "ECOCASTGIMMSNDVI3gv1p0Documentation": "https://climatedataguide.ucar.edu/climate-data/ndvi-normalized-difference-vegetation-index-3rd-generation-nasagfsc-gimms",
                "ECOCASTGIMMSNDVI3gv1p0Institution": "NASA/GSFC GIMMS",
                "ECOCASTGIMMSNDVI3gv1p0TemporalResolution": "1/24 a year",
                "ECOCASTGIMMSNDVI3gv1p0SpatialResolution": "1/12 x 1/12 degrees",
                "ECOCASTGIMMSNDVI3gv1p0EasternmostLongitude": "180",
                "ECOCASTGIMMSdescription": "Global Inventory Monitoring and Modeling System",
                "ECOCASTdescription": "Ecological Forecasting Lab",
                "description": "Ames Research Center",
                "Conventions": "IRIDL"
            },
            "ECOCAST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ECOCAST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GIMMS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GIMMS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI3g": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI3g",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v1p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "satellites": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "satellites",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "satellite identifier",
                                "units": "ids"
                            },
                            "percentile": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "percentile",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "percentile",
                                "units": "%",
                                "scale_factor": "0.1"
                            },
                            "ndviflag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ndviflag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2",
                                "long_name": "flag",
                                "units": "ids",
                                "scale_min": "0",
                                "CLIST": "ndvi retrieved from seasonal profile (possible snow/cloud)"
                            },
                            "ndvi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ndvi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2263842",
                                "scale_max": "10000",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "-3000",
                                "CS": "-0.3",
                                "CE": "1.0",
                                "iridlhasSemantics": "iridl:NDVI",
                                "plotlast": "1.0",
                                "plotfirst": "-0.3",
                                "long_name": "NDVI",
                                "units": "unitless",
                                "missing_value": "-32768",
                                "scale_factor": "9.99999975E-05",
                                "valid_range": "1.0"
                            },
                            "filevalues": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "filevalues",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "combined percentile and flag original file values"
                            }
                        }
                    }
                }
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.08333334",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1981-01-01 00:00:00",
                "gridtype": "0",
                "calendar": "standard"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.08333333",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NASA/ARC"
        },
        "ASDCDAAC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ASDC-DAAC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CERESEBAFTOAEd2p8version": "This is version 2.8: August 21, 2015",
                "CERESEBAFTOAEd2p8source": "http://ceres-tool.larc.nasa.gov/ord-tool/jsp/EBAFSelection.jsp",
                "CERESEBAFTOAEd2p8references": "Loeb_etal2009",
                "CERESEBAFTOAEd2p8description": "Edition 2.8",
                "CERESEBAFTOAEd2p8Product": "http://ceres.larc.nasa.gov/documents/DQ_summaries/CERES_EBAF_Ed2.8_DQS.pdf",
                "CERESEBAFTOAEd2p8title": "CERES EBAF (Energy Balanced and Filled) TOA Fluxes. Monthly Averages and 15-year Climatology.",
                "CERESEBAFTOAEd2p8comment": "Data is from East to West and South to North. Climatology from 03/2000 to 05/2015.",
                "CERESEBAFTOAEd2p8Fill_Value": "Fill Value is -999.0",
                "CERESEBAFTOAEd2p8institution": "NASA/LaRC (Langley Research Center) Hampton, Va",
                "CERESEBAFTOAdescription": "Energy Balanced And Filled - Top Of Atmosphere",
                "CERESdescription": "Clouds and the Earth\\'s Radiant Energy System",
                "description": "Atmospheric Science Data Center Distributed Active Archive Center",
                "Conventions": "IRIDL"
            },
            "CERES": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CERES",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "EBAFTOA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EBAF-TOA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Ed2p8": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ed2p8",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "toa_sw_clr_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_sw_clr_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Shortwave Flux, Monthly Means, Clear-Sky conditions",
                            "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                            "units": "W/m2",
                            "CF_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                            "IPCC_name": "none"
                        },
                        "toa_sw_all_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_sw_all_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Shortwave Flux, Monthly Means, All-Sky conditions",
                            "standard_name": "toa_outgoing_shortwave_flux",
                            "units": "W/m2",
                            "CF_name": "toa_outgoing_shortwave_flux",
                            "IPCC_name": "none"
                        },
                        "toa_net_clr_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_net_clr_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Net Flux, Monthly Means, Clear-Sky conditions",
                            "units": "W/m2",
                            "IPCC_name": "none"
                        },
                        "toa_net_all_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_net_all_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Net Flux, Monthly Means, All-Sky conditions",
                            "units": "W/m2",
                            "IPCC_name": "none"
                        },
                        "toa_lw_clr_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_lw_clr_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Longwave Flux, Monthly Means, Clear-Sky conditions",
                            "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                            "units": "W/m2",
                            "CF_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                            "IPCC_name": "none"
                        },
                        "toa_lw_all_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_lw_all_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Longwave Flux, Monthly Means, All-Sky conditions",
                            "standard_name": "toa_outgoing_longwave_flux",
                            "units": "W/m2",
                            "CF_name": "toa_outgoing_longwave_flux",
                            "IPCC_name": "none"
                        },
                        "toa_cre_sw_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_cre_sw_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Cloud Radiative Effects Shortwave Flux, Monthly Means",
                            "standard_name": "toa_shortwave_cloud_radiative_effect",
                            "units": "W/m2",
                            "CF_name": "toa_shortwave_cloud_radiative_effect",
                            "IPCC_name": "none"
                        },
                        "toa_cre_net_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_cre_net_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Cloud Radiative Effects Net Flux, Monthly Means",
                            "units": "W/m2",
                            "IPCC_name": "none"
                        },
                        "toa_cre_lw_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_cre_lw_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Top of The Atmosphere Cloud Radiative Effects Longwave Flux, Monthly Means",
                            "standard_name": "toa_longwave_cloud_radiative_effect",
                            "units": "W/m2",
                            "CF_name": "toa_longwave_cloud_radiative_effect",
                            "IPCC_name": "none"
                        },
                        "solar_mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "solar_mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "file_missing_value": "-999.0",
                            "long_name": "Incoming Solar Flux, Monthly Means",
                            "standard_name": "toa_incoming_shortwave_flux",
                            "units": "W/m2",
                            "CF_name": "toa_incoming_shortwave_flux",
                            "IPCC_name": "none"
                        }
                    }
                }
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/NASA/ASDC-DAAC"
        },
        "AVHRRLST": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "AVHRR-LST",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "dataset_documentation": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.AVHRR-LST/documentation.pdf",
                "history": "Night Time Images Revised 1 Jun 2006 from 24 Mar 2006 image files",
                "references": "Pinheiro_etal2006",
                "iridlhasSemantics": "gcmdi:AVHRR",
                "Conventions": "CF-1.0"
            },
            "stime": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stime",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "30000",
                "scale_min": "0",
                "scale_factor": "0.001",
                "grid_mapping": "Projection",
                "long_name": "local solar time",
                "SpatialReferenceSystemWKT": ",1]]",
                "SpatialReferenceSystemDims": "y",
                "units": "unitless",
                "missing_value": "-999",
                "pointwidth": "0.5"
            },
            "Projection": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Projection",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "latitude_of_projection_origin": "1",
                "false_northing": "0",
                "false_easting": "0",
                "longitude_of_central_meridian": "20.0",
                "standard_parallel": "-19.0",
                "grid_mapping_name": "albers_conical_equal_area"
            },
            "LST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Kelvin_scale",
                "standard_name": "surface_temperature",
                "scale_max": "4900",
                "scale_min": "0",
                "scale_factor": "0.1",
                "grid_mapping": "Projection",
                "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                "long_name": "land_surface_temperature",
                "SpatialReferenceSystemWKT": ",1]]",
                "SpatialReferenceSystemDims": "y",
                "missing_value": "-999",
                "pointwidth": "0.5"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "standard_name": "longitude",
                "units": "degree_east",
                "scale_factor": "0.01"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "standard_name": "latitude",
                "units": "degree_north",
                "scale_factor": "0.01"
            },
            "landmask": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "landmask",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "standard_name": "land_binary_mask",
                "grid_mapping": "Projection",
                "units": "unitless",
                "valid_max": "1",
                "valid_min": "0"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_mapping": "Projection",
                "units": "ids",
                "long_name": "cloud mask",
                "SpatialReferenceSystemWKT": ",1]]",
                "CLIST": "Land Shadow",
                "scale_max": "8",
                "plotlast": "8",
                "missing_value": "0",
                "scale_min": "1",
                "plotfirst": "1",
                "SpatialReferenceSystemDims": "y",
                "pointwidth": "0.5"
            },
            "x": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "8000.0",
                "standard_name": "projection_x_coordinate"
            },
            "y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "8000.0",
                "standard_name": "projection_y_coordinate"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1995-01-01 00:00:00",
                "gridtype": "0",
                "pointwidth": "0.5",
                "standard_name": "time",
                "calendar": "standard"
            },
            "dir": "SOURCES/NASA/AVHRR-LST"
        },
        "ERBE": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ERBE",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ClimatologyiridlhasSemantics": "iridl:climatology",
                "references": "Barkstrom_Smith1986 Barkstrom_etal1990",
                "description": "Earth Radiation Budget Experiment",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ERBE/.dataset_documentation.html",
                "iridlhasSemantics": "iridl:CCRS",
                "Conventions": "IRIDL"
            },
            "NOAA9": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA9",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "NOAA10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "ERBS_N9": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERBS_N9",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "ERBS_N10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERBS_N10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "ERBS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERBS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "Climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "missing_value": "NaN",
                        "file_missing_value": "999.98999"
                    }
                }
            },
            "ALL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ALL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                },
                "cloudforcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud-forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    }
                },
                "clearsky": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clear-sky",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "shortwave radiation",
                        "missing_value": "999.98999"
                    },
                    "net": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "net",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "net radiation",
                        "missing_value": "999.98999"
                    },
                    "lw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "W/m2",
                        "long_name": "longwave radiation",
                        "missing_value": "999.98999"
                    },
                    "albedo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "albedo",
                        "scale_max": "100.0",
                        "missing_value": "999.98999",
                        "scale_min": "0.0"
                    }
                }
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "modulus": "12.0",
                "pointwidth": "1.0",
                "long_name": "Time",
                "modulo": "12.0",
                "calendar": "360"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NASA/ERBE"
        },
        "GESDAAC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GES-DAAC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TRMM_L3TRMM_3B42RTv7threehourlydataset_documentation": "ftp://trmmopen.nascom.nasa.gov/pub/merged/V7Documents/3B4XRT_README.pdf",
                "TRMM_L3TRMM_3B42RTv7threehourlysource": "ftp://disc2.nascom.nasa.gov/data/s4pa/TRMM_RT/TRMM_3B42RT.007/",
                "TRMM_L3TRMM_3B42RTv7dailyreferences": "Huffman_etal2007 Huffman_etal2010",
                "TRMM_L3TRMM_3B42RTv7dailydataset_documentation": "ftp://trmmopen.gsfc.nasa.gov/pub/merged/V7Documents/3B4XRT_doc_V7.pdf",
                "TRMM_L3TRMM_3B42RTv7dailyreadme": "ftp://disc2.nascom.nasa.gov/data/TRMM/Gridded/Derived_Products/3B42RT/Daily/readme",
                "TRMM_L3TRMM_3B42RTv7dailysource": "ftp://disc2.nascom.nasa.gov/data/TRMM/Gridded/Derived_Products/3B42RT/Daily/",
                "TRMM_L3TRMM_3B42v7threehourlyproduct": "http://mirador.gsfc.nasa.gov/collections/TRMM_3B42__007.shtml",
                "TRMM_L3TRMM_3B42v7threehourlyreferences": "Huffman_etal2007 Huffman_etal2010",
                "TRMM_L3TRMM_3B42v7threehourlydataset_documentation": "ftp://precip.gsfc.nasa.gov/pub/trmmdocs/3B42_3B43_doc.pdf",
                "TRMM_L3TRMM_3B42v7threehourlyreadme": "http://disc.sci.gsfc.nasa.gov/precipitation/documentation/TRMM_README/TRMM_3B42_readme.shtml",
                "TRMM_L3TRMM_3B42v7threehourlysource": "http://disc2.nascom.nasa.gov/opendap/TRMM_3Hourly_3B42/",
                "TRMM_L3TRMM_3B42v7dailyreferences": "Huffman_etal2007 Huffman_etal2010",
                "TRMM_L3TRMM_3B42v7dailydataset_documentation": "ftp://precip.gsfc.nasa.gov/pub/trmmdocs/3B42_3B43_doc.pdf",
                "TRMM_L3TRMM_3B42v7dailyreadme": "http://disc.sci.gsfc.nasa.gov/precipitation/documentation/TRMM_README/TRMM_3B42_readme.shtml",
                "TRMM_L3TRMM_3B42v7dailydescription": "TRMM Version 7 Daily Precipitation Estimates",
                "TRMM_L3TRMM_3B42v7dailysource": "http://disc2.nascom.nasa.gov/opendap/TRMM_3B42/TRMM_3B42_daily/",
                "TRMM_L3TRMM_3B42v6threehourlyreferences": "Huffman_etal2007",
                "TRMM_L3TRMM_3B42v6threehourlydataset_documentation": "ftp://precip.gsfc.nasa.gov/pub/trmmdocs/3B42_3B43_doc.pdf",
                "TRMM_L3TRMM_3B42v6threehourlyreadme": "http://disc.sci.gsfc.nasa.gov/precipitation/documentation/TRMM_README/TRMM_3B42_readme.shtml",
                "TRMM_L3TRMM_3B42v6threehourlysource": "http://disc2.nascom.nasa.gov/opendap/TRMM_L3/TRMM_3B42/",
                "TRMM_L3TRMM_3B42v6threehourlysuspended": "http://disc.sci.gsfc.nasa.gov/mirador-news-items/status-of-trmm-3b42-3b43",
                "TRMM_L3TRMM_3B42v6dailyreferences": "Huffman_etal2007",
                "TRMM_L3TRMM_3B42v6dailydataset_documentation": "ftp://precip.gsfc.nasa.gov/pub/trmmdocs/3B42_3B43_doc.pdf",
                "TRMM_L3TRMM_3B42v6dailyreadme": "http://disc.sci.gsfc.nasa.gov/precipitation/documentation/TRMM_README/TRMM_3B42_readme.shtml",
                "TRMM_L3TRMM_3B42v6dailysource": "http://disc2.nascom.nasa.gov/opendap/TRMM_3B42/TRMM_3B42_daily/",
                "TRMM_L3TRMM_3B42v6dailysuspended": "http://disc.sci.gsfc.nasa.gov/mirador-news-items/status-of-trmm-3b42-3b43",
                "TRMM_L3description": "Tropical Rainfall Measuring Mission (TRMM) Level 3 Products",
                "PALvegetationcontinenteuropeConventions": "CF-1.0",
                "PALvegetationcontinentreferences": "Brown_etal1985 Rao1993a Rao1993b Staylor1990",
                "PALvegetationavhrr_changeshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GES-DAAC/.PAL.vegetation.avhrr_changes.html",
                "PALvegetationpal_ndvihtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GES-DAAC/.PAL.vegetation.pal_ndvi.html",
                "PALvegetationpalndvi_003html": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GES-DAAC/.PAL.vegetation.palndvi_003.html",
                "PALlong_name": "Pathfinder AVHRR Land",
                "PALdescription": "Vegetation data by continent from Pathfinder AVHRR",
                "PALiridlhasSemantics": "gcmdi:AVHRR",
                "description": "GSFC Earth Sciences Distributed Active Archive Center",
                "Conventions": "IRIDL"
            },
            "TRMM_L3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TRMM_L3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TRMM_3B42RT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TRMM_3B42RT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v7": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v7",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "threehourly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "three-hourly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "6000",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0.0",
                                "CE": "60.0",
                                "colorscalename": "prcp_hrlyrate_smooth",
                                "iridlhasSemantics": "iridl:precipitation",
                                "long_name": "Accumulated Precipitation",
                                "units": "mm",
                                "scale_factor": "0.01",
                                "missing_value": "-31999",
                                "valid_min": "0",
                                "pointwidth": "0.125"
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "300.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "300.0",
                                "colorscalename": "prcp_dailyrate_smooth",
                                "missing_value": "-99999.0",
                                "iridlhasSemantics": "iridl:precipitation",
                                "long_name": "Accumulated Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "TRMM_3B42": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TRMM_3B42",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v7": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v7",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "threehourly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "three-hourly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "satPrecipitationSource": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "satPrecipitationSource",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "data source flag",
                                "units": "ids",
                                "missing_value": "-9999",
                                "pointwidth": "0.125"
                            },
                            "satObservationTime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "satObservationTime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "satellite observation time minus the time of the granule",
                                "units": "minutes",
                                "missing_value": "-99",
                                "pointwidth": "0.125"
                            },
                            "relativeError": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "relativeError",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "random error estimate",
                                "units": "mm/hr",
                                "missing_value": "-9999.9004",
                                "pointwidth": "0.125"
                            },
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "60.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "60.0",
                                "colorscalename": "prcp_hrlyrate_smooth",
                                "iridlhasSemantics": "iridl:precipitation",
                                "long_name": "precipitation estimate",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/hr",
                                "missing_value": "-9999.9004",
                                "pointwidth": "0.125"
                            },
                            "IRprecipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "IRprecipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "60.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "60.0",
                                "colorscalename": "prcp_hrlyrate_smooth",
                                "long_name": "pre-gauge-adjusted infrared precipitation estimate",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/hr",
                                "missing_value": "-9999.9004",
                                "pointwidth": "0.125"
                            },
                            "HQprecipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "60.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "60.0",
                                "colorscalename": "prcp_hrlyrate_smooth",
                                "long_name": "pre-gauge-adjusted microwave precipitation estimate",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/hr",
                                "missing_value": "-9999.9004",
                                "pointwidth": "0.125"
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "Surface Rain from all Satellite and Surface",
                                "standard_name": "lwe_precipitation_rate",
                                "note": "data has been shift 1.5 hours to line up with days",
                                "missing_value": "-9999.9004",
                                "iridlhasSemantics": "iridl:precipitation",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "v6": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v6",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "threehourly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "three-hourly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridlhasSemantics": "iridl:precipitation",
                                "long_name": "Surface Rain from all Satellite and Surface",
                                "units": "mm/hr",
                                "missing_value": "-9999.9004",
                                "pointwidth": "0.125"
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridlhasSemantics": "iridl:precipitation",
                                "note": "data has been shift 1.5 hours to line up with days",
                                "long_name": "Surface Rain from all Satellite and Surface",
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                }
            },
            "PAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "vegetation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vegetation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "continent": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "continent",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "south_america": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "south_america",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-33.0",
                                "scale_min": "-83.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "13.2",
                                "scale_min": "-57.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        },
                        "north_america": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "north_america",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-60.0",
                                "scale_min": "-165.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "72.5",
                                "scale_min": "9.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        },
                        "europe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "europe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "standard_name": "normalized_difference_vegetation_index",
                                "SpatialReferenceSystemDims": "y",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3",
                                "coordinates": "T lat lon"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "60.5",
                                "scale_min": "-13.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east",
                                "standard_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "76.699997",
                                "scale_min": "23.4",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north",
                                "standard_name": "latitude"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        },
                        "australia": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "australia",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "179.5",
                                "scale_min": "93.5",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "7.5",
                                "scale_min": "-48.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        },
                        "asia": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asia",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "180.0",
                                "scale_min": "21.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "79.040001",
                                "scale_min": "4.6999998",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        },
                        "africa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "africa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1306.4999",
                                "scale_max": "14568.499",
                                "colormap": "16777215",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "-0.1",
                                "CE": "0.916",
                                "colorscalename": "NDVIcolorscale",
                                "iridlhasSemantics": "iridl:NDVI",
                                "projection": "Interrupted Goode Homolosine",
                                "long_name": "Normalized Difference Vegetation Index",
                                "units": "unitless",
                                "add_offset": "-1.024",
                                "valid_max": "255",
                                "scale_factor": "0.008",
                                "valid_min": "3"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "72.0",
                                "scale_min": "-32.0",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "38.459999",
                                "scale_min": "-37.73",
                                "missing_value": "NaN",
                                "file_missing_value": "0",
                                "units": "degree_north"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "add_offset": "-15010",
                                "units": "meters"
                            }
                        }
                    }
                }
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "latitude"
            },
            "T_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "pointwidth": "0.125",
                "standard_name": "time",
                "calendar": "standard"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "latitude"
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "standard"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "pointwidth": "0.125",
                "standard_name": "time",
                "calendar": "standard"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "scan": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "scan",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "0"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "pointwidth": "0.125",
                "standard_name": "time",
                "calendar": "standard"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1998-01-01 00:00:00",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude"
            },
            "x_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "y_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "970.5"
            },
            "x_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "y_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "820.5"
            },
            "x_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "projection_x_coordinate"
            },
            "y_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "standard_name": "projection_y_coordinate",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "670.5"
            },
            "x_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "770.5"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "calendar": "standard"
            },
            "x_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "950.5"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "calendar": "standard"
            },
            "x": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "plotlast": "0.5",
                "plotfirst": "1060.5"
            },
            "dir": "SOURCES/NASA/GES-DAAC"
        },
        "GES_DISC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GES_DISC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GPM_L3v06IMERG_Latedailytitle": "GPM Level 3 IMERG Late version 6",
                "GPM_L3v06IMERG_Latedailyexpires": "1615420800",
                "GPM_L3v06IMERG_Finaldailytitle": "GPM Level 3 IMERG Final version 6",
                "GPM_L3v06IMERG_Finaldailyexpires": "1617235200",
                "Conventions": "IRIDL"
            },
            "GPM_L3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GPM_L3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "IMERG_Late": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IMERG_Late",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "randomError_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "randomError_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly randomError retrievals for the day",
                                "expires": "1615420800",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "randomError": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "randomError",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily total error of precipitation estimate",
                                "expires": "1615420800",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal_cnt_cond": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal_cnt_cond",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly precipitationCal retrievals for the day where precipitation is greater than 0",
                                "expires": "1615420800",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of all valid half-hourly precipitationCal retrievals for the day",
                                "expires": "1615420800",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily accumulated precipitation (combined microwave-IR) estimate",
                                "expires": "1615420800",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation_cnt_cond": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation_cnt_cond",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly HQprecipitation retrievals for the day where precipitation is greater than 0",
                                "expires": "1615420800",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of all valid half-hourly HQprecipitation retrievals for the day",
                                "expires": "1615420800",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily accumulated High Quality precipitation from all available MW sources",
                                "expires": "1615420800",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "IMERG_Final": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IMERG_Final",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "randomError_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "randomError_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly randomError retrievals for the day",
                                "expires": "1617235200",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "randomError": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "randomError",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily total error of precipitation estimate",
                                "expires": "1617235200",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal_cnt_cond": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal_cnt_cond",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly precipitationCal retrievals for the day where precipitation is greater than 0",
                                "expires": "1617235200",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of all valid half-hourly precipitationCal retrievals for the day",
                                "expires": "1617235200",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "precipitationCal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitationCal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily accumulated precipitation (combined microwave-IR) estimate",
                                "expires": "1617235200",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation_cnt_cond": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation_cnt_cond",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of valid half-hourly HQprecipitation retrievals for the day where precipitation is greater than 0",
                                "expires": "1617235200",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation_cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation_cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Count of all valid half-hourly HQprecipitation retrievals for the day",
                                "expires": "1617235200",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "HQprecipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HQprecipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "341760",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_0to1000_colors",
                                "long_name": "Daily accumulated High Quality precipitation from all available MW sources",
                                "expires": "1617235200",
                                "missing_value": "-9999.9004",
                                "units": "mm",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                }
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "expires": "1615420800",
                "long_name": "Time",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.09999999",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "expires": "1617235200",
                "long_name": "Time",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.1",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "dir": "SOURCES/NASA/GES_DISC"
        },
        "GISS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GISS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "LeGrande_Schmidt2006v1p1long_name": "v1.1",
                "LeGrande_Schmidt2006v1p1derived": "From calculated_d18O.dat via o18_2nc.f, 2007-01-23",
                "LeGrande_Schmidt2006v1p1authors": "LeGrande and Schmidt, 2006, 2007",
                "LeGrande_Schmidt2006v1p1institution": "NASA Goddard Institute for Space Studies",
                "LeGrande_Schmidt2006v1p1title": "Oxygen Isotopic Composition in Seawater, Ver. 1.1",
                "LeGrande_Schmidt2006v1p1source": "http://data.giss.nasa.gov/o18data/",
                "LeGrande_Schmidt2006v1p0v11": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GISS/.LeGrande_Schmidt2006/.v1p1/",
                "LeGrande_Schmidt2006v1p0long_name": "v1.0",
                "LeGrande_Schmidt2006v1p0derived": "From calculated_d18O.dat via o18_2nc.f, 2005-12-01",
                "LeGrande_Schmidt2006v1p0authors": "LeGrande and Schmidt, 2006",
                "LeGrande_Schmidt2006v1p0institution": "NASA Goddard Institute for Space Studies",
                "LeGrande_Schmidt2006v1p0title": "Oxygen Isotopic Composition in Seawater",
                "LeGrande_Schmidt2006v1p0source": "http://data.giss.nasa.gov/o18data/",
                "LeGrande_Schmidt2006VSMOW": "http://en.wikipedia.org/wiki/VSMOW",
                "LeGrande_Schmidt2006references": "LeGrande_Schmidt2006",
                "LeGrande_Schmidt2006description": "Global gridded dataset of the oxygen isotopic composition in seawater",
                "LeGrande_Schmidt2006iridlhasSemantics": "iridl:GISS",
                "GISSTEMPSHdescription": "Southern Hemisphere Average",
                "GISSTEMPNHdescription": "Northern Hemisphere Average",
                "GISSTEMPGlobaldescription": "Global Average",
                "GISSTEMPd2x2LandOnlyinstitution": "NASA Goddard Institute for Space Studies",
                "GISSTEMPd2x2LandOnlytitle": "GISTEMP Surface Temperature Analysis",
                "GISSTEMPd2x2LandOnlyhistory": "Created 2014-01-21 08:28:19 by SBBX_to_nc 2.0 - ILAND=250,  IOCEAN=none,     Base: 1951-1980",
                "GISSTEMPd2x2LandOnlysource": "http://data.giss.nasa.gov/gistemp/",
                "GISSTEMPd2x2LandOnlyConventions": "CF-1.6",
                "GISSTEMPd2x2LandOceaninstitution": "NASA Goddard Institute for Space Studies",
                "GISSTEMPd2x2LandOceantitle": "GISTEMP Surface Temperature Analysis",
                "GISSTEMPd2x2LandOceanhistory": "Created 2014-01-21 08:28:01 by SBBX_to_nc 2.0 - ILAND=1200, IOCEAN=NCDC/ER3, Base: 1951-1980",
                "GISSTEMPd2x2LandOceansource": "http://data.giss.nasa.gov/gistemp/",
                "GISSTEMPd2x2LandOceanConventions": "CF-1.6",
                "GISSTEMPd2x2description": "Gridded Monthly Maps of Temperature Anomaly Data",
                "GISSTEMPdataset_documentation": "http://data.giss.nasa.gov/gistemp/",
                "GISSTEMPiridlhasSemantics": "iridl:GISS",
                "AgMIPCFAgMERRAdataset_documentation": "http://data.giss.nasa.gov/impacts/agmipcf/agmerra/",
                "AgMIPCFAgMERRAreferences": "Ruane2015",
                "AgMIPCFAgMERRAdescription": "AgMIP Modern-Era Restrospective Analysis for Research and Applications",
                "AgMIPCFdataset_documentation": "http://data.giss.nasa.gov/impacts/agmipcf/",
                "AgMIPCFdescription": "AgMIP Climate Forcing",
                "AgMIPCFiridlhasSemantics": "iridl:GISS",
                "Conventions": "IRIDL"
            },
            "LeGrande_Schmidt2006": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LeGrande_Schmidt2006",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v1p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v1p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "d18o": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "d18o",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "permil (VSMOW)",
                        "missing_value": "-1.00000002E30",
                        "iridlhasSemantics": "iridl:dO18"
                    }
                },
                "v1p0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v1p0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "d18o": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "d18o",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "permil (VSMOW)",
                        "missing_value": "-1.00000002E30",
                        "iridlhasSemantics": "iridl:dO18"
                    }
                }
            },
            "GISSTEMP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GISSTEMP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air temperature anomaly",
                        "standard_name": "air_temperature"
                    },
                    "LOTI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LOTI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air and sea surface temperature anomaly"
                    }
                },
                "NH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air temperature anomaly",
                        "standard_name": "air_temperature"
                    },
                    "LOTI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LOTI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air and sea surface temperature anomaly"
                    }
                },
                "Global": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Global",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air temperature anomaly",
                        "standard_name": "air_temperature"
                    },
                    "LOTI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LOTI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Kelvin",
                        "long_name": "air and sea surface temperature anomaly"
                    }
                },
                "d2x2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "d2x2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "LandOnly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LandOnly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "time_bnds": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "time_bnds",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "tempanomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tempanomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Kelvin",
                            "long_name": "Surface temperature anomaly",
                            "missing_value": "32767",
                            "scale_factor": "0.01",
                            "cell_methods": "time: mean"
                        }
                    },
                    "LandOcean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Land-Ocean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "time_bnds": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "time_bnds",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "tempanomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tempanomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Kelvin",
                            "long_name": "Surface temperature anomaly",
                            "missing_value": "32767",
                            "scale_factor": "0.01",
                            "cell_methods": "time: mean"
                        }
                    }
                }
            },
            "AgMIPCF": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AgMIPCF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "AgMERRA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AgMERRA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wndspd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wndspd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0",
                        "CS": "0",
                        "colormap": "2622920",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "windspeed_colors",
                        "units": "m/s",
                        "long_name": "Wind Speed",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "255",
                        "scale_max": "4000",
                        "ncolor": "254",
                        "scale_min": "-4000",
                        "CS": "-40",
                        "colorscalename": "temp_colors",
                        "CE": "40",
                        "units": "Celsius_scale",
                        "long_name": "Minimum Temperature",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "tmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "255",
                        "scale_max": "4000",
                        "ncolor": "254",
                        "scale_min": "-4000",
                        "CS": "-40",
                        "colorscalename": "temp_colors",
                        "CE": "40",
                        "units": "Celsius_scale",
                        "long_name": "Maximum Temperature",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "tavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "255",
                        "scale_max": "4000",
                        "ncolor": "254",
                        "scale_min": "-4000",
                        "CS": "-40",
                        "colorscalename": "temp_colors",
                        "CE": "40",
                        "units": "Celsius_scale",
                        "long_name": "Average Temperature",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "srad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "srad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0",
                        "CS": "0",
                        "units": "MJ/m2/day",
                        "long_name": "Solar Radiation Flux",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "rhstmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rhstmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "10000",
                        "scale_min": "0",
                        "CS": "0",
                        "CE": "100",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "units": "percent",
                        "long_name": "Relative Humidity at time of Maximum Temperature",
                        "missing_value": "32767",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "prate": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prate",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0",
                        "CS": "0",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "units": "mm/day",
                        "long_name": "Precipitation Rate",
                        "missing_value": "32767",
                        "scale_factor": "0.1",
                        "pointwidth": "0"
                    }
                }
            },
            "depth": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "depth",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "positive": "down"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "modulus": "360.0"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "nv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.0",
                "long_name": "Longitude",
                "standard_name": "longitude",
                "modulus": "360.0"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.0",
                "long_name": "Latitude",
                "standard_name": "latitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "standard"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.25",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "dir": "SOURCES/NASA/GISS"
        },
        "GPCP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GPCP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V2p3CDRpublisher_email": "jjwang@umd.edu",
                "V2p3CDRsensor": "Imager, Imager, Imager, AIRS > Atmospheric Infrared Sounder, SSMIS > Special Sensor Microwave Imager/Sounder",
                "V2p3CDRcomment": "Processing computer: eagle2.umd.edu",
                "V2p3CDRproduct_version": "v23rB1",
                "V2p3CDRinstitution": "ACADEMIC > UMD/ESSIC > Earth System Science Interdisciplinary Center, University of Maryland",
                "V2p3CDRwebpage": "http://eagle1.umd.edu/GPCP_ICDR/",
                "V2p3CDRcdr_program": "NOAA Climate Data Record Program for satellites, FY 2011.",
                "V2p3CDRplatform": "GOES (Geostationary Operational Environmental Satellite), GMS (Japan Geostationary Meteorological Satellite), METEOSAT, Earth Observing System, AQUA, DMSP (Defense Meteorological Satellite Program)",
                "V2p3CDRproject": "GPCP > Global Precipitation Climatology Project",
                "V2p3CDRprocessing_level": "NASA Level 3",
                "V2p3CDRcdm_data_type": "Grid",
                "V2p3CDRsource": "http://eagle1.umd.edu/GPCP_CDR/Monthly_Data/",
                "V2p3CDRcreator_email": "jjwang@umd.edu",
                "V2p3CDRpublisher_name": "NOAA National Centers for Environmental Information (NCEI)",
                "V2p3CDRacknowledgment": "This project was supported in part by a grant from the NOAA Climate Data Record (CDR) Program for satellites.",
                "V2p3CDRMetadata_Conventions": "CF-1.5, Unidata Dataset Discovery v1.0, NOAA CDR v1.0, GDS v2.0",
                "V2p3CDRConventions": "CF-1.6, ACDD 1.3",
                "V2p3CDRtitle": "NOAA Climate Data Record (CDR) of Satellite-Gauge Precipitation from the Global Precipitation Climatatology Project (GPCP), V2.3",
                "V2p3CDRgeospatial_lon_units": "degrees_east",
                "V2p3CDRspatial_resolution": "2.5 degree",
                "V2p3CDRreferences": "Huffman et al. 1997, http://dx.doi.org/10.1175/1520-0477(1997)078<0005:TGPCPG>2.0.CO;2; Adler et al. 2003, http://dx.doi.org/10.1175/1525-7541(2003)004<1147:TVGPCP>2.0.CO;2; Huffman et al. 2009, http://dx.doi.org/10.1029/2009GL040000; Adler et al. 2016, Global Precipitation Climatology Project (GPCP) Monthly Analysis: Climate Algorithm Theoretical Basis Document (C-ATBD)",
                "V2p3CDRkeywords": "EARTH SCIENCE > ATMOSPHERE > PRECIPITATION > PRECIPITATION AMOUNT",
                "V2p3CDRgeospatial_lon_min": "1.25",
                "V2p3CDRpublisher_url": "https://www.ncei.noaa.gov",
                "V2p3CDRcdr_variable": "precipitation",
                "V2p3CDRcontributor_role": "principalInvestigator, principalInvestigator, processor and custodian",
                "V2p3CDRstandard_name_vocabulary": "CF Standard Name Table (v31, 08 March 2016)",
                "V2p3CDRNOTE": "An error entering the GPCP Version 2.3 precipitation dataset in the IRI Data Library resulted in an incorrect reversal of data along the latitude (Y) grid in both the precip and precip_error variables for all months in this dataset entry.  This error was corrected as of 20 December 2017; the data should now be oriented correctly along the latitude (Y) grid.",
                "V2p3CDRcreator_name": "Dr. Jian-Jian Wang",
                "V2p3CDRcontributor_name": "Robert Adler, George Huffman, Mathew Sapiano, Jian-Jian Wang",
                "V2p3CDRdocument": "http://eagle1.umd.edu/GPCP_ICDR/GPCPmonthlyV2.3.pdf",
                "V2p3CDRgeospatial_lat_resolution": "2.5 degrees",
                "V2p3CDRgeospatial_lon_max": "358.75",
                "V2p3CDRnaming_authority": "gov.noaa.ncdc",
                "V2p3CDRdescription": "Climate Data Record",
                "V2p3CDRkeywords_vocabulary": "NASA Global Change Master Directory (GCMD) Earth Science Keywords, Version 7.0",
                "V2p3CDRsummary": "Global Precipitation Climatology Project (GPCP) Version 2.3 gridded, merged satellite/gauge precipitation Climate data Record (CDR) with errors from 1979 to present.",
                "V2p3CDRtime_coverage_duration": "P1M",
                "V2p3CDRgeospatial_lat_units": "degrees_north",
                "V2p3CDRmetadata_link": "gov.noaa.ncdc:C00979",
                "V2p3CDRgeospatial_lat_max": "88.75",
                "V2p3CDRgeospatial_lon_resolution": "2.5 degrees",
                "V2p3CDRexpires": "1614902400",
                "V2p3CDRgeospatial_lat_min": "-88.75",
                "V2p3CDRlicense": "No constraints on data access or use.",
                "V2p2references": "Adler_etal2003 Huffman_etal2009",
                "V2p2dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/NASA/GPCP/V2p2/V2.2_doc.pdf",
                "V2p2citations": "https://iridl.ldeo.columbia.edu/documentation/NASA/GPCP/V2p2/gpcp_citation_list.pdf",
                "V2p2source": "http://gpcp.umd.edu/",
                "V2p1source": "http://precip.gsfc.nasa.gov/",
                "V2p1references": "Adler_etal2003 Huffman_etal2009",
                "V2p1document": "ftp://precip.gsfc.nasa.gov/pub/gpcp-v2.1/doc/V2.1_doc.pdf",
                "V2p1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GPCP/.V2p1.dataset_documentation.html",
                "V2p1summary": "http://precip.gsfc.nasa.gov/gpcp_v2.1_comb_new.html",
                "V2source": "http://precip.gsfc.nasa.gov/",
                "V2references": "Huffman_etal1997",
                "V2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GPCP/.V2.dataset_documentation.html",
                "V2GPCP": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GPCP/.V2p1/",
                "V1DDV1p3NOAA_documentation": "https://data.nodc.noaa.gov/cgi-bin/iso?id=gov.noaa.ncdc:C00999",
                "V1DDV1p3publisher_email": "jjwang@umd.edu",
                "V1DDV1p3sensor": "Imager, AIRS > Atmospheric Infrared Sounder, SSMIS > Special Sensor Microwave Imager/Sounder",
                "V1DDV1p3comment": "Processing computer: eagle2.umd.edu",
                "V1DDV1p3product_version": "v01r03",
                "V1DDV1p3institution": "ACADEMIC > UMD/ESSIC > Earth System Science Interdisciplinary Center, University of Maryland",
                "V1DDV1p3cdr_program": "NOAA Climate Data Record Program for satellites, FY 2011.",
                "V1DDV1p3platform": "GOES (Geostationary Operational Environmental Satellite), GMS (Japan Geostationary Meteorological Satellite), METEOSAT, Earth Observing System, AQUA, DMSP (Defense Meteorological Satellite Program)",
                "V1DDV1p3project": "GPCP > Global Precipitation Climatology Project",
                "V1DDV1p3processing_level": "NASA Level 3",
                "V1DDV1p3cdm_data_type": "Grid",
                "V1DDV1p3source": "https://www.ncei.noaa.gov/data/global-precipitation-climatology-project-gpcp-daily/access/",
                "V1DDV1p3publisher_name": "NOAA National Centers for Environmental Information (NCEI)",
                "V1DDV1p3creator_email": "jjwang@umd.edu",
                "V1DDV1p3long_name": "Version 1.3",
                "V1DDV1p3acknowledgment": "This project was supported in part by a grant from the NOAA Climate Data Record (CDR) Program for satellites.",
                "V1DDV1p3Metadata_Conventions": "CF-1.6, Unidata Dataset Discovery v1.0, NOAA CDR v1.0, GDS v2.0",
                "V1DDV1p3Conventions": "CF-1.6, ACDD 1.3",
                "V1DDV1p3paper": "http://eagle1.umd.edu/GPCP_ICDR/references/2001_Huffman.pdf",
                "V1DDV1p3title": "Global Precipitation Climatatology Project (GPCP) Climate Data Record (CDR), Daily V1.3",
                "V1DDV1p3geospatial_lon_units": "degrees_east",
                "V1DDV1p3dataset_documentation": "http://eagle1.umd.edu/GPCP_ICDR/GPCP_Monthly.html",
                "V1DDV1p3references": "Huffman_etal2001",
                "V1DDV1p3spatial_resolution": "1 degree",
                "V1DDV1p3geospatial_lon_min": "0.0",
                "V1DDV1p3keywords": "EARTH SCIENCE > ATMOSPHERE > PRECIPITATION > PRECIPITATION AMOUNT",
                "V1DDV1p3date_created": "2020-02-06T19:30:42Z",
                "V1DDV1p3publisher_url": "https://www.ncei.noaa.gov",
                "V1DDV1p3cdr_variable": "precipitation",
                "V1DDV1p3contributor_role": "principalInvestigator, processor and custodian",
                "V1DDV1p3creator_name": "Dr. Jian-Jian Wang",
                "V1DDV1p3standard_name_vocabulary": "CF Standard Name Table (v41, 22 February 2017)",
                "V1DDV1p3contributor_name": "Robert Adler, Jian-Jian Wang",
                "V1DDV1p3reference": "Huffman et al. 1997, http://dx.doi.org/10.1175/1520-0477(1997)078<0005:TGPCPG>2.0.CO;2; Adler et al. 2003, http://dx.doi.org/10.1175/1525-7541(2003)004<1147:TVGPCP>2.0.CO;2; Huffman et al. 2009, http://dx.doi.org/10.1029/2009GL040000; Adler et al. 2017, Global Precipitation Climatology Project (GPCP) Daily Analysis: Climate Algorithm Theoretical Basis Document (C-ATBD)",
                "V1DDV1p3geospatial_lat_resolution": "1 degree",
                "V1DDV1p3geospatial_lon_max": "360.0",
                "V1DDV1p3naming_authority": "gov.noaa.ncdc",
                "V1DDV1p3description": "GPCP 1-Degree Daily Combination (Version 1.3)",
                "V1DDV1p3summary": "Global Precipitation Climatology Project (GPCP) Daily Version 1.3 gridded, merged satellite/gauge precipitation Climate data Record (CDR) from 1996 to present.",
                "V1DDV1p3keywords_vocabulary": "NASA Global Change Master Directory (GCMD) Earth Science Keywords, Version 7.0",
                "V1DDV1p3time_coverage_duration": "P1D",
                "V1DDV1p3geospatial_lat_units": "degrees_north",
                "V1DDV1p3metadata_link": "gov.noaa.ncdc:XXXXX",
                "V1DDV1p3geospatial_lat_max": "90.0",
                "V1DDV1p3geospatial_lon_resolution": "1 degree",
                "V1DDV1p3note": "Request to Users:  The GPCP datasets are developed and maintained with international cooperation and are used by the worldwide scientific community. To better understand the evolving requirements across the GPCP user community and to increase the utility of the GPCP product suite, the dataset producers request that a citation be provided for each publication that uses the GPCP products.  Please email the citation to george.j.huffman@nasa.gov or david.t.bolvin@nasa.gov. Your help and cooperation will provide valuable information for making future enhancements to the GPCP product suite.",
                "V1DDV1p3expires": "1612137600",
                "V1DDV1p3geospatial_lat_min": "-90.0",
                "V1DDV1p3license": "No constraints on data access or use.",
                "V1DDV1p2long_name": "Version 1.2",
                "V1DDV1p2references": "Huffman_etal2001",
                "V1DDV1p2dataset_documentation": "ftp://rsd.gsfc.nasa.gov/pub/1dd-v1.2/1DD_v1.2_doc.pdf",
                "V1DDV1p2description": "GPCP 1-Degree Daily Combination (Version 1.2)",
                "V1DDV1p2source": "ftp://rsd.gsfc.nasa.gov/pub/1dd-v1.2/",
                "V1DDV1p2summary": "http://precip.gsfc.nasa.gov/gpcp_daily_comb.html",
                "V1DDV1p2note": "Request to Users:  The GPCP datasets are developed and maintained with international cooperation and are used by the worldwide scientific community. To better understand the evolving requirements across the GPCP user community and to increase the utility of the GPCP product suite, the dataset producers request that a citation be provided for each publication that uses the GPCP products.  Please email the citation to george.j.huffman@nasa.gov or david.t.bolvin@nasa.gov. Your help and cooperation will provide valuable information for making future enhancements to the GPCP product suite.",
                "V1DDV1p1long_name": "Version 1.1",
                "V1DDV1p1references": "Huffman_etal2001",
                "V1DDV1p1description": "1-degree daily combination precipitation estimates",
                "V1DDV1p1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GPCP/.V1DD.V1p1.dataset_documentation.html",
                "V1Breferences": "Huffman_etal1997",
                "V1Bdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GPCP/.V1B.dataset_documentation.html",
                "V1BiridlhasSemantics": "iriref:Huffman_GL",
                "description": "Combined satellite-gauge precipitation estimates and error estimates from the Global Precipitation Climatology Project",
                "Conventions": "IRIDL"
            },
            "V2p3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V2p3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CDR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CDR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "precip_error": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip_error",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1614902400",
                        "long_name": "NOAA CDR of GPCP Satellite-Gauge Combined Precipitation Error",
                        "coordinates": "longitude latitude",
                        "units": "mm/day",
                        "valid_range": "100.0",
                        "missing_value": "-9999.0",
                        "pointwidth": "1.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "expires": "1614902400",
                        "long_name": "NOAA Climate Data Record (CDR) of GPCP Satellite-Gauge Combined Precipitation",
                        "cell_methods": "precip: mean",
                        "coordinates": "longitude latitude time",
                        "units": "mm/day",
                        "missing_value": "-9999.0",
                        "valid_range": "100.0",
                        "pointwidth": "1.0"
                    }
                }
            },
            "V2p2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V2p2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TOVS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TOVS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "SSMI_TOVS_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_TOVS_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "source",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "scale_max": "4.0",
                        "missing_value": "-99999.0",
                        "long_name": "source",
                        "units": "ids",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "SSMI_scattering": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_scattering",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of overpass days",
                        "pointwidth": "0"
                    }
                },
                "SSMI_emission": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_emission",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 55 km images",
                        "pointwidth": "0"
                    }
                },
                "SSMI_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "source",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "scale_max": "1.0",
                        "missing_value": "-99999.0",
                        "long_name": "source",
                        "units": "ids",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 55 km images",
                        "pointwidth": "0"
                    }
                },
                "satellitegauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "satellite-gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "OPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "multisatellite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "multi-satellite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "GPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 2.5 deg. images",
                        "pointwidth": "0"
                    }
                },
                "GPCC_gauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPCC_gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of gauges",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "AGPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AGPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "long_name": "precipitation rate",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                }
            },
            "V2p1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V2p1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TOVS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TOVS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "SSMI_TOVS_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_TOVS_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "source",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "scale_max": "4.0",
                        "missing_value": "-99999.0",
                        "long_name": "source",
                        "units": "ids",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "SSMI_scattering": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_scattering",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of overpass days",
                        "pointwidth": "0"
                    }
                },
                "SSMI_emission": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_emission",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 55 km images",
                        "pointwidth": "0"
                    }
                },
                "SSMI_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "source",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "scale_max": "1.0",
                        "missing_value": "-99999.0",
                        "long_name": "source",
                        "units": "ids",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 55 km images",
                        "pointwidth": "0"
                    }
                },
                "satellitegauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "satellite-gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "OPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "multisatellite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "multi-satellite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "GPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of 2.5 deg. images",
                        "pointwidth": "0"
                    }
                },
                "GPCC_gauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPCC_gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "number of samples",
                        "units": "number of gauges",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                },
                "AGPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AGPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:PrecipitationRate",
                        "missing_value": "-99999.0",
                        "long_name": "precipitation rate",
                        "units": "mm/day",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "long_name": "absolute error",
                        "units": "mm/day",
                        "pointwidth": "0"
                    }
                }
            },
            "V2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TOVS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TOVS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "TOVS",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "SSMI_TOVS_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_TOVS_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "src": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "src",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "4.0",
                        "long_name": "source",
                        "units": "id",
                        "technique": "SSMI/TOVS Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "30.0",
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "SSMI/TOVS Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "7.0",
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "SSMI/TOVS Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "SSMI_scattering": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_scattering",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "30.0",
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "SSMI Scattering",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1000.0",
                        "long_name": "number of samples",
                        "units": "overpass days",
                        "technique": "SSMI Scattering",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "SSMI_emission": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_emission",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "30.0",
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "SSMI Emission",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1000.0",
                        "long_name": "number of samples",
                        "units": "55 km images",
                        "technique": "SSMI Emission",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "SSMI_composite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_composite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "src": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "src",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "long_name": "source",
                        "units": "id",
                        "technique": "SSMI Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "30.0",
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "SSMI Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1000.0",
                        "long_name": "number of samples",
                        "units": "55 km images",
                        "technique": "SSMI Composite",
                        "scale_min": "0.0",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "satellitegauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "satellite-gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "Satellite-Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "Satellite-Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "OPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "OPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "OPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "multisatellite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "multi-satellite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "Multi-Satellite",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "Multi-Satellite",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "GPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "GPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "number of samples",
                        "units": "2.5 deg images",
                        "technique": "GPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "GPCC_gauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPCC_gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "GPCC Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "number of samples",
                        "units": "gauges",
                        "technique": "GPCC Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "GPCC Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "GHCN_CAMS_gauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GHCN_CAMS_gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "GHCN+CAMS Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "number of samples",
                        "units": "gauges",
                        "technique": "GHCN+CAMS Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "GHCN+CAMS Gauge",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                },
                "AGPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AGPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "technique": "AGPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "abs. error",
                        "units": "mm/day",
                        "technique": "AGPI",
                        "missing_value": "-99999.0",
                        "pointwidth": "0"
                    }
                }
            },
            "V1DD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V1DD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "V1p3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V1p3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "time_bounds": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_bounds",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1612137600",
                        "units": "unitless",
                        "comment": "time bounds for each time value",
                        "pointwidth": "1.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1612137600",
                        "coordinates": "T Y X",
                        "cell_methods": "area: mean time: mean",
                        "long_name": "NOAA Climate Data Record (CDR) of Daily GPCP Satellite-Gauge Combined Precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-9999.0",
                        "valid_range": "100.0",
                        "pointwidth": "1.0"
                    },
                    "lon_bounds": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon_bounds",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "comment": "longitude values at the west and east bounds of each pixel."
                    },
                    "lat_bounds": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat_bounds",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "comment": "latitude values at the north and south bounds of each pixel."
                    }
                },
                "V1p2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V1p2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "7868160",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "100",
                        "iridlhasSemantics": "iridl:precipitation",
                        "long_name": "precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-99999.0",
                        "pointwidth": "0.0"
                    }
                },
                "V1p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "V1p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99999.0",
                        "units": "mm/day",
                        "long_name": "precipitation",
                        "pointwidth": "0.0"
                    }
                }
            },
            "V1B": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V1B",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SSMI_scattering": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_scattering",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "SSMI scattering",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "equiv .5 deg images",
                        "technique": "SSMI scattering",
                        "long_name": "number of samples",
                        "missing_value": "-99999.0"
                    }
                },
                "SSMI_emission": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_emission",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "SSMI scattering",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "equiv .5 deg images",
                        "technique": "SSMI emission",
                        "long_name": "number of samples",
                        "missing_value": "-99999.0"
                    }
                },
                "SSMI_combined": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSMI_combined",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "src": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "src",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "id",
                        "technique": "SSMI combined",
                        "long_name": "source",
                        "CLIST": "scat",
                        "scale_max": "1.0",
                        "missing_value": "-99999.0",
                        "scale_min": "0.0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "SSMI combined",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "equiv .5 deg images",
                        "technique": "SSMI combined",
                        "long_name": "number of samples",
                        "missing_value": "-99999.0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "SSMI combined",
                        "long_name": "abs. error",
                        "missing_value": "-99999.0"
                    }
                },
                "satellitegauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "satellite-gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "satellite/gauge",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "satellite/gauge",
                        "long_name": "abs. error",
                        "missing_value": "-99999.0"
                    }
                },
                "multisatellite": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "multi-satellite",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "multi-satellite",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "multi-satellite",
                        "long_name": "abs. error",
                        "missing_value": "-99999.0"
                    }
                },
                "GPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "GPI",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "equiv .5 deg images",
                        "technique": "GPI",
                        "long_name": "number of samples",
                        "missing_value": "-99999.0"
                    }
                },
                "gauge": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gauge",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "bias-cor. gauge",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "nsamp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nsamp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "equiv .5 deg images",
                        "technique": "bias-cor gauge",
                        "long_name": "number of samples",
                        "missing_value": "-99999.0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "bias-cor gauge",
                        "long_name": "abs. error",
                        "missing_value": "-99999.0"
                    }
                },
                "AGPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AGPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "AGPI",
                        "long_name": "precipitation",
                        "missing_value": "-99999.0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "technique": "AGPI",
                        "long_name": "abs. error",
                        "missing_value": "-99999.0"
                    }
                }
            },
            "T_17": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_17",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "expires": "1614902400",
                "long_name": "Time",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_16": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_16",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_15": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_15",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "T_14": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_14",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_13": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_13",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_11": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_11",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "expires": "1612137600",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude"
            },
            "nv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "Time",
                "calendar": "standard",
                "standard_name": "time"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1996-10-01 12:00:00",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NASA/GPCP"
        },
        "GSFC": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NASA/GSFC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "GSFC",
            "restriction": "Public",
            "MERRA": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NASA/GSFC/MERRA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "MERRA",
                "restriction": "Public",
                "Anl_Const_2D": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Anl_Const_2D",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "source": "Global Modeling and Assimilation Office. GEOSops_5_2_0",
                        "comment": "GEOS-5.2.0. This file updated on 2012-09-19 to add AREA parameter.",
                        "missing_value": "9.99999987E14",
                        "references": "http://gmao.gsfc.nasa.gov/research/merra/",
                        "link": "http://gmao.gsfc.nasa.gov/research/merra/",
                        "title": "MERRA reanalysis. GEOS-5.2.0",
                        "Conventions": "CF-1.0",
                        "contact": "http://gmao.gsfc.nasa.gov/",
                        "history": "File written by CFIO",
                        "HDFEOSVersion": "HDFEOS_V2.14",
                        "institution": "Global Modeling and Assimilation Office, NASA Goddard Space Flight Center, Greenbelt, MD 20771"
                    },
                    "SGH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SGH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Standard deviation of topography for gravity wave drag",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "standard_deviation_of_topography",
                        "units": "m",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "PHIS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PHIS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Surface geopotential",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "surface geopotential height",
                        "units": "m2/s2",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "FROCEAN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FROCEAN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Fraction of ocean in grid box",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "fraction_of_ocean",
                        "units": "unitless",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "FRLANDICE": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRLANDICE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Fraction of land ice type in grid box",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "fraction_of_land_ice",
                        "units": "unitless",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "FRLAND": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRLAND",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Fraction of land type in grid box",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "land_fraction",
                        "units": "unitless",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "FRLAKE": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRLAKE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Fraction of lake type in grid box",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "fraction_of_lake",
                        "units": "unitless",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "AREA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AREA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vmin": "-1.00000002E30",
                        "long_name": "Horizontal area of grid box",
                        "fmissing_value": "9.99999987E14",
                        "standard_name": "horizontal_area_of_grid_box",
                        "units": "m2",
                        "missing_value": "9.99999987E14",
                        "valid_range": "1.0000000E30",
                        "vmax": "1.00000002E30"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "minutes since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.6666666",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NASA/GSFC/MERRA/Anl_Const_2D"
                },
                "Anl_MonoLev": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NASA/GSFC/MERRA/Anl_MonoLev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Anl_MonoLev",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "Anl_SigmaLev": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NASA/GSFC/MERRA/Anl_SigmaLev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Anl_SigmaLev",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "Anl_StdLev": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NASA/GSFC/MERRA/Anl_StdLev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Anl_StdLev",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "Anl_TurbFlux_2D": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NASA/GSFC/MERRA/Anl_TurbFlux_2D",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Anl_TurbFlux_2D",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Anl_Const_2D",
                    "Anl_MonoLev",
                    "Anl_SigmaLev",
                    "Anl_StdLev",
                    "Anl_TurbFlux_2D"
                ]
            },
            "MERRA2": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NASA/GSFC/MERRA2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "MERRA2",
                "restriction": "Public",
                "Anl_MonoLev": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NASA/GSFC/MERRA2/Anl_MonoLev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Anl_MonoLev",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Anl_MonoLev"
                ]
            },
            "TOMS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TOMS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NIMBUS7description": "Total Ozone Mapping Spectrometer onboard the Nimbus-7 spacecraft",
                    "EPTOMSdescription": "Total Ozone Mapping Spectrometer onboard the Earth Probe spacecraft",
                    "references": "McPeters_etal1996 McPeters_etal1998",
                    "description": "Total Ozone Mapping Spectrometer",
                    "iridlhasSemantics": "gcmdi:TOMS",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.GSFC/.TOMS/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "OMI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OMI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ai": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ai",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "70",
                            "scale_max": "45",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "10",
                            "CS": "1.0",
                            "CE": "4.5",
                            "description": "OMI Aerosol Index values",
                            "units": "unitless",
                            "long_name": "Aerosol Index",
                            "missing_value": "888",
                            "scale_factor": "0.1"
                        }
                    }
                },
                "NIMBUS7": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NIMBUS7",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "uv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16737535",
                            "scale_max": "12000.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "12000",
                            "description": "Erythemal Exposure -- Monthly Average Estimated Daily Integrated Ultraviolet Irradiance",
                            "long_name": "Erythemal UV",
                            "units": "J m-2",
                            "missing_value": "NaN",
                            "fnname": "mod"
                        },
                        "ai": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ai",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "8388608",
                            "scale_max": "41",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "7",
                            "CS": "0.7",
                            "CE": "4.1999998",
                            "description": "Nimbus7 Monthly Average Aerosol Index values",
                            "long_name": "Aerosol Index",
                            "missing_value": "999",
                            "scale_factor": "0.1"
                        }
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "uv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16737535",
                            "scale_max": "12000.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "12000",
                            "description": "Erythemal Exposure -- Estimated Daily Integrated Ultaviolet Irradiance",
                            "long_name": "Erythemal UV",
                            "units": "J m-2",
                            "missing_value": "NaN",
                            "fnname": "mod"
                        },
                        "ai": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ai",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "8388608",
                            "scale_max": "41",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "7",
                            "CS": "0.7",
                            "CE": "4.1999998",
                            "description": "Nimbus7 Daily Aerosol Index values",
                            "long_name": "Aerosol Index",
                            "missing_value": "999",
                            "scale_factor": "0.1"
                        }
                    }
                },
                "EPTOMS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EPTOMS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "uv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16737535",
                            "scale_max": "12000.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "12000",
                            "description": "Erythemal Exposure -- Monthly Average Estimated Daily Integrated Ultaviolet Irradiance",
                            "long_name": "Erythemal UV",
                            "units": "J m-2",
                            "missing_value": "NaN",
                            "fnname": "mod"
                        },
                        "ai": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ai",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "8388608",
                            "scale_max": "41",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "7",
                            "CS": "0.7",
                            "CE": "4.1999998",
                            "description": "EPTOMS Monthly Average Aerosol Index values",
                            "long_name": "Aerosol Index",
                            "missing_value": "999",
                            "scale_factor": "0.1"
                        }
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "uv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16737535",
                            "scale_max": "12000.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "12000",
                            "description": "Erythemal Exposure -- Estimated Daily Integrated Ultraviolet Irradiance",
                            "long_name": "Erythemal UV",
                            "units": "J m-2",
                            "missing_value": "NaN",
                            "fnname": "mod"
                        },
                        "ai": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ai",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "8388608",
                            "scale_max": "41",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "7",
                            "CS": "0.7",
                            "CE": "4.1999998",
                            "description": "EPTOMS Aerosol Index values",
                            "long_name": "Aerosol Index",
                            "missing_value": "999",
                            "scale_factor": "0.1"
                        }
                    }
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "julian_day",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01 12:00:00",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01 12:00:00",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.25",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/NASA/GSFC/TOMS"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "MERRA",
                "MERRA2",
                "TOMS"
            ]
        },
        "IDS": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NASA/IDS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "IDS",
            "restriction": "Public",
            "Anomalies": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Anomalies",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NASA": "https://cad4nasa.gsfc.nasa.gov/",
                    "Conventions": "IRIDL"
                },
                "precip_chirps": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip_chirps",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "290304",
                    "scale_max": "1601.0",
                    "ncolor": "254",
                    "scale_min": "-1599.0",
                    "CS": "-16",
                    "colorscalename": "prcp_anomaly",
                    "CE": "16",
                    "long_name": "CHIRPS Precip Anomaly",
                    "units": "unitless",
                    "add_offset": "-1.0",
                    "valid_max": "200",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0"
                },
                "ndvi_anom_modis": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ndvi_anom_modis",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "290304",
                    "scale_max": "1601.0",
                    "ncolor": "254",
                    "scale_min": "-1599.0",
                    "CS": "-16",
                    "colorscalename": "prcp_anomaly",
                    "CE": "16",
                    "long_name": "MODIS NDVI Anomaly",
                    "units": "unitless",
                    "add_offset": "-1.0",
                    "valid_max": "200",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0"
                },
                "ndvi_anom_gimms": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ndvi_anom_gimms",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "290304",
                    "scale_max": "1601.0",
                    "ncolor": "254",
                    "scale_min": "-1599.0",
                    "CS": "-16",
                    "colorscalename": "prcp_anomaly",
                    "CE": "16",
                    "long_name": "GIMMS NDVI Anomaly",
                    "units": "unitless",
                    "add_offset": "-1.0",
                    "valid_max": "200",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0"
                },
                "evi_anom_modis": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "evi_anom_modis",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "290304",
                    "scale_max": "1601.0",
                    "ncolor": "254",
                    "scale_min": "-1599.0",
                    "CS": "-16",
                    "colorscalename": "prcp_anomaly",
                    "CE": "16",
                    "long_name": "MODIS EVI Anomaly",
                    "units": "unitless",
                    "add_offset": "-1.0",
                    "valid_max": "200",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.25",
                    "standard_name": "latitude",
                    "long_name": "Latitude"
                },
                "T2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.25",
                    "standard_name": "longitude",
                    "long_name": "Longitude"
                },
                "dir": "SOURCES/NASA/IDS/Anomalies"
            },
            "EvapTrans": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NASA/IDS/EvapTrans",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "EvapTrans",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "Anomalies",
                "EvapTrans"
            ]
        },
        "ISCCP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISCCP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "D2surfacelong_name": "Surface",
                "D2stratus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2stratus_liquidlong_name": "Stratus, liquid",
                "D2stratus_icemean_cloudlong_name": "Mean Cloud",
                "D2stratus_icelong_name": "Stratus, ice",
                "D2stratocumulus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2stratocumulus_liquidlong_name": "Stratocumulus, liquid",
                "D2stratocumulus_icemean_cloudlong_name": "Mean Cloud",
                "D2stratocumulus_icelong_name": "Stratocumulus, ice",
                "D2nimbostratus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2nimbostratus_liquidlong_name": "Nimbostratus, liquid",
                "D2nimbostratus_icemean_cloudlong_name": "Mean Cloud",
                "D2nimbostratus_icelong_name": "Nimbostratus, ice",
                "D2middle_levelmean_cloudlong_name": "Mean Cloud",
                "D2middle_levellong_name": "Middle Level",
                "D2low_levelmean_cloudlong_name": "Mean Cloud",
                "D2low_levellong_name": "Low Level",
                "D2high_levelmean_cloudlong_name": "Mean Cloud",
                "D2high_levellong_name": "High Level",
                "D2deep_convectivemean_cloudlong_name": "Mean Cloud",
                "D2deep_convectivelong_name": "Deep Convective",
                "D2cumulus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2cumulus_liquidlong_name": "Cumulus, liquid",
                "D2cumulus_icemean_cloudlong_name": "Mean Cloud",
                "D2cumulus_icelong_name": "Cumulus, ice",
                "D2cirrusmean_cloudlong_name": "Mean Cloud",
                "D2cirruslong_name": "Cirrus",
                "D2cirrostratusmean_cloudlong_name": "Mean Cloud",
                "D2cirrostratuslong_name": "Cirrostratus",
                "D2altostratus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2altostratus_liquidlong_name": "Altostratus, liquid",
                "D2altostratus_icemean_cloudlong_name": "Mean Cloud",
                "D2altostratus_icelong_name": "Altostratus, ice",
                "D2altocumulus_liquidmean_cloudlong_name": "Mean Cloud",
                "D2altocumulus_liquidlong_name": "Altocumulus, liquid",
                "D2altocumulus_icemean_cloudlong_name": "Mean Cloud",
                "D2altocumulus_icelong_name": "Altocumulus, ice",
                "D2allmean_cloudlong_name": "Mean Cloud",
                "D2alllong_name": "All Cloud Types",
                "D2references": "Rossow_etal1996",
                "D2description": "Cloud characteristics, including amount, optical thickness, and cloud top pressure and temperature, for multiple cloud types from the the International Satellite Cloud Climatology Project",
                "D2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISCCP/.D2.dataset_documentation.html",
                "description": "International Satellite Cloud Climatology Project",
                "Conventions": "IRIDL"
            },
            "D2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "D2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "surface": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "surface",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    },
                    "ice": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ice",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Ice and Snow Cover",
                        "missing_value": "-1000.0"
                    }
                },
                "stratus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stratus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "stratus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stratus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "stratocumulus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stratocumulus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "stratocumulus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stratocumulus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "nimbostratus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "nimbostratus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "nimbostratus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "nimbostratus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "middle_level": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "middle_level",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "low_level": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "low_level",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "modulus": "360",
                    "scale_max": "360.0",
                    "scale_min": "0.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "scale_max": "90.0",
                    "scale_min": "-90.0"
                },
                "high_level": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "high_level",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "deep_convective": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "deep_convective",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "cumulus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cumulus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "cumulus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cumulus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "cirrus": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cirrus",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "cirrostratus": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cirrostratus",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "altostratus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "altostratus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "altostratus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "altostratus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "altocumulus_liquid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "altocumulus_liquid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "altocumulus_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "altocumulus_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "-1000.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "-1000.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "-1000.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                },
                "all": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "all",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean_cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean_cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "waterpath": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "waterpath",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Water Path",
                            "missing_value": "-1000.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Temperature",
                            "missing_value": "255.0"
                        },
                        "press": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "press",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Top Pressure",
                            "missing_value": "255.0"
                        },
                        "optthick": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "optthick",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Optical Thickness",
                            "missing_value": "-1000.0"
                        },
                        "amount": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "amount",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Amount",
                            "missing_value": "255.0"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "modulus": "360",
                        "scale_max": "360.0",
                        "scale_min": "0.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    }
                }
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "long_name": "month",
                "calendar": "360"
            },
            "boxnum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "boxnum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/NASA/ISCCP"
        },
        "ISLSCP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISLSCP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GDSLAMVegetationdescription": "Global data sets for land-atmosphere models, including the Normalized Difference Vegetation Index and other vegetation data parameters",
                "GDSLAMSnowIceOceanssnownesdisdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Snow-Ice-Oceans.snow.nesdis.dataset_documentation.html",
                "GDSLAMSnowIceOceanssnowetacreferences": "Foster_Davy1988",
                "GDSLAMSnowIceOceanssnowetacdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Snow-Ice-Oceans.snow.etac.dataset_documentation.html",
                "GDSLAMSnowIceOceansseasea_icereferences": "Nomura_Grumbine1995",
                "GDSLAMSnowIceOceansseasea_icedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Snow-Ice-Oceans.sea.sea_ice.dataset_documentation.html",
                "GDSLAMSnowIceOceansseanmc_sstreferences": "Reynolds_Smith1994",
                "GDSLAMSnowIceOceansseanmc_sstdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Snow-Ice-Oceans.sea.nmc_sst.dataset_documentation.html",
                "GDSLAMSnowIceOceansdescription": "Global data sets for land-atmosphere models, including snow cover and depth, sea ice, and sea surface temperature data",
                "GDSLAMRadiationCloudsmth_meanreferences": "Darnell_etal1992",
                "GDSLAMRadiationCloudsmth_meandataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Radiation-Clouds.mth_mean.dataset_documentation.html",
                "GDSLAMRadiationCloudsmth_3hrreferences": "Darnell_etal1992",
                "GDSLAMRadiationCloudserbe_albdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Radiation-Clouds.erbe_alb.dataset_documentation.html",
                "GDSLAMRadiationCloudscloudsreferences": "Rossow_etal1991 Rossow_Schiffer1991",
                "GDSLAMRadiationCloudscloudsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Radiation-Clouds.clouds.dataset_documentation.html",
                "GDSLAMRadiationCloudsdescription": "Global data sets for land-atmosphere models, including radiation and cloud properties",
                "GDSLAMNearSurfaceECMWFDaily_6Hourlyprecipitationdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Near-Surface-ECMWF.Daily_6-Hourly.precipitation.dataset_documentation.html",
                "GDSLAMNearSurfaceECMWFreferences": "Brankovic_VanMaanen1985 Mitchell_Lin1994",
                "GDSLAMNearSurfaceECMWFdescription": "Global data sets for land-atmosphere models, including near-surface meteorological analyses and hybrid products from the ECMWF",
                "GDSLAMNearSurfaceECMWFdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Near-Surface-ECMWF.dataset_documentation.html",
                "GDSLAMNearSurfaceECMWFiridlhasSemantics": "iridl:ECMWF",
                "GDSLAMMiscellaneousdescription": "Global data sets for land-atmosphere models, including grid area and a land-sea mask",
                "GDSLAMHydrologySoilssoilsreferences": "Zobler_1986 Webb_etal1993",
                "GDSLAMHydrologySoilsriver_flowreferences": "UniArizona_1995",
                "GDSLAMHydrologySoilsriver_flowdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Hydrology-Soils.river_flow.dataset_documentation.html",
                "GDSLAMHydrologySoilshydro_coverreferences": "Cogley_1994",
                "GDSLAMHydrologySoilsGPCP_precipreferences": "WCRP1990",
                "GDSLAMHydrologySoilsGPCP_precipdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.ISLSCP/.GDSLAM.Hydrology-Soils.GPCP_precip.dataset_documentation.html",
                "GDSLAMHydrologySoilsdescription": "Global data sets for land-atmosphere models, including precipitation, hydrology cover fractions, river basin streamflow, and soil properties",
                "GDSLAMdescription": "Global Data Sets for Land-Atmosphere Models",
                "GDSLAMsource": "NASA Goddard DAAC Science Data Series CDROM",
                "description": "International Satellite Land Surface Climatology Project",
                "Conventions": "IRIDL"
            },
            "GDSLAM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GDSLAM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Vegetation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Vegetation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zol": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zol",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "roughness"
                    },
                    "snowfree": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow-free",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "albedo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "albedo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "snow-free albedo"
                        }
                    },
                    "ndvi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ndvi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "normalized difference vegetation index"
                    },
                    "lai": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lai",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Leaf Area Index"
                    },
                    "grn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Greenness",
                        "description": "Percentage green leaf area of total leaf area"
                    },
                    "fsrndvi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fsr-ndvi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "description": "Fourier-Adjustment, Solar zenith angle corrected, Interpolated Reconstructed (FASIR) Normalized Difference Vegetation Index"
                    },
                    "fpar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fpar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "description": "Fraction of photosynthetic active radiation absorbed by the green vegetation canopy"
                    },
                    "_class": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "class",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "c3 grassland",
                        "scale_max": "15.0",
                        "scale_min": "0.0"
                    }
                },
                "SnowIceOceans": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Snow-Ice-Oceans",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "snow": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "nesdis": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nesdis",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "etac": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "etac",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "snow_depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snow_depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm"
                            }
                        }
                    },
                    "sea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sea_ice": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sea_ice",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "seaice": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "seaice",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "Sea Ice Concentration",
                                "scale_max": "100.0",
                                "scale_min": "0.0"
                            }
                        },
                        "nmc_sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nmc_sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Sea Surface Temperature",
                                "scale_max": "308.0",
                                "scale_min": "270.0"
                            }
                        }
                    }
                },
                "RadiationClouds": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Radiation-Clouds",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mth_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mth_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sur_tont": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_tont",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Total Net Radiation Flux",
                            "missing_value": "-999.0"
                        },
                        "sur_swnt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_swnt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Shortwave Net Radiation Flux",
                            "missing_value": "-999.0"
                        },
                        "sur_swdn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_swdn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Shortwave Downward Radiation Flux",
                            "missing_value": "-999.0"
                        },
                        "sur_lwnt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_lwnt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Longwave Net Radiation Flux",
                            "missing_value": "-999.0"
                        },
                        "sur_lwdn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_lwdn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Longwave Downward Radiation Flux",
                            "missing_value": "-999.0"
                        }
                    },
                    "mth_3hr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mth_3hr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "toa_swup": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_swup",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Top-of-Atmos. Shortwave Upward Radiation Flux",
                            "missing_value": "-9999.0"
                        },
                        "toa_swdn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "toa_swdn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Top-of-Atmos. Shortwave Downward Radiation Flux",
                            "missing_value": "-9999.0"
                        },
                        "sur_swup": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_swup",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Shortwave Upward Radiation Flux",
                            "missing_value": "-9999.0"
                        },
                        "sur_swdn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_swdn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface Shortwave Downward Radiation Flux",
                            "missing_value": "-9999.0"
                        },
                        "sur_padn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_padn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "Surface PAR Downward Flux",
                            "missing_value": "-9999.0"
                        },
                        "fil_flag": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "fil_flag",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "colormap": "65280",
                            "maxncolor": "5",
                            "long_name": "Flag: Observed or Estimated",
                            "CLIST": "Estimated",
                            "scale_max": "1.0",
                            "missing_value": "-99.0",
                            "ncolor": "5",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "1"
                        }
                    },
                    "erbe_alb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "erbe_alb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "albedo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "albedo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Monthly Mean Albedo",
                            "references": "Barkstrom_etal1990",
                            "scale_max": "1.0",
                            "missing_value": "-99.0",
                            "scale_min": "0.0"
                        }
                    },
                    "clouds": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clouds",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "cld_tppr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld_tppr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "millibars",
                            "long_name": "Mean Cloud Top Pressure",
                            "missing_value": "-99.0",
                            "scale_min": "10.0"
                        },
                        "cld_path": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld_path",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "g m-2",
                            "long_name": "Cloud Water Path",
                            "scale_max": "760.0",
                            "missing_value": "-99.0",
                            "scale_min": "0.0"
                        },
                        "cld_opth": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld_opth",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Mean Optical Thickness",
                            "scale_max": "120.0",
                            "missing_value": "-99.0",
                            "scale_min": "0.0"
                        },
                        "cld_amnt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld_amnt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Avg. Freq. of Cloudy Pixels",
                            "scale_max": "100.0",
                            "missing_value": "-99.0",
                            "scale_min": "0.0"
                        }
                    }
                },
                "NearSurfaceECMWF": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Near-Surface-ECMWF",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Time_Invariant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Time_Invariant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "roughness": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "roughness",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Surface Roughness Length"
                        },
                        "albedo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "albedo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Albedo"
                        }
                    },
                    "Monthly_and_Instantaneous": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly_and_Instantaneous",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Standard_Deviation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Standard_Deviation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ssm_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ssm_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Surface Soil Wetness"
                            },
                            "sdp_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdp_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Snow Depth"
                            },
                            "dst_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dst_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Deep Soil Temperature"
                            },
                            "dsm_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dsm_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Deep Soil Wetness"
                            },
                            "cst_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cst_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Climate Deep Soil Temperature"
                            },
                            "csm_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csm_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Climate Deep Soil Wetness"
                            }
                        },
                        "Minimum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Minimum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ssm_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ssm_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Surface Soil Wetness"
                            },
                            "sdp_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdp_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "maxncolor": "254",
                                "colormap": "255",
                                "scale_max": "10.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "10",
                                "long_name": "Snow Depth"
                            },
                            "dst_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dst_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "dsm_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dsm_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Deep Soil Wetness"
                            },
                            "cst_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cst_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Climate Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "csm_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csm_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Climate Deep Soil Wetness"
                            }
                        },
                        "Mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ssm_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ssm_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Surface Soil Wetness"
                            },
                            "sdp_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdp_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "maxncolor": "254",
                                "colormap": "255",
                                "scale_max": "10.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "10",
                                "long_name": "Snow Depth"
                            },
                            "dst_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dst_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "dsm_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dsm_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Deep Soil Wetness"
                            },
                            "cst_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cst_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Climate Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "csm_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csm_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Climate Deep Soil Wetness"
                            }
                        },
                        "Maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ssm_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ssm_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Surface Soil Wetness"
                            },
                            "sdp_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdp_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "maxncolor": "254",
                                "colormap": "255",
                                "scale_max": "10.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "10",
                                "long_name": "Snow Depth"
                            },
                            "dst_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dst_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "dsm_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dsm_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Deep Soil Wetness"
                            },
                            "cst_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cst_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Climate Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "csm_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csm_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Climate Deep Soil Wetness"
                            }
                        },
                        "Instantaneous": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Instantaneous",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ssm_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ssm_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Surface Soil Wetness"
                            },
                            "sdp_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdp_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "maxncolor": "254",
                                "colormap": "255",
                                "scale_max": "10.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "10",
                                "long_name": "Snow Depth"
                            },
                            "dst_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dst_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "dsm_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dsm_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Deep Soil Wetness"
                            },
                            "cst_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cst_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Climate Deep Soil Temperature",
                                "scale_min": "200.0"
                            },
                            "csm_inst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csm_inst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "Climate Deep Soil Wetness"
                            }
                        }
                    },
                    "Monthly_6Hourly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly_6-Hourly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Standard_Deviation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Standard_Deviation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vwnd_str_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_str_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "V Wind Stress"
                            },
                            "vwnd_10m_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_10m_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter V Wind Velocity"
                            },
                            "uwnd_str_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_str_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "U Wind Stress"
                            },
                            "uwnd_10m_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_10m_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter U Wind Velocity"
                            },
                            "toa_swnt_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_swnt_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Shortwave Radiation"
                            },
                            "toa_lwnt_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_lwnt_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Longwave Radiation"
                            },
                            "temp_2m_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp_2m_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Temperature"
                            },
                            "sur_temp_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_temp_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Surface Temperature"
                            },
                            "sur_swnt_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_swnt_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Shortwave Radiation"
                            },
                            "sur_sbht_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_sbht_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Sensible Heat Flux"
                            },
                            "sur_prsr_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_prsr_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Surface Pressure"
                            },
                            "sur_lwnt_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_lwnt_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Longwave Radiation"
                            },
                            "sur_ltht_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_ltht_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Latent Heat Flux"
                            },
                            "msl_prsr_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "msl_prsr_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Mean Sea Level Pressure"
                            },
                            "dwpnt_2m_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dwpnt_2m_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Dew Point Temperature"
                            }
                        },
                        "Minimum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Minimum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vwnd_str_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_str_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "V Wind Stress"
                            },
                            "vwnd_10m_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_10m_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter V Wind Velocity"
                            },
                            "uwnd_str_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_str_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "U Wind Stress"
                            },
                            "uwnd_10m_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_10m_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter U Wind Velocity"
                            },
                            "toa_swnt_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_swnt_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Shortwave Radiation"
                            },
                            "toa_lwnt_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_lwnt_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Longwave Radiation"
                            },
                            "temp_2m_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp_2m_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Temperature",
                                "scale_max": "330.0",
                                "scale_min": "220.0"
                            },
                            "sur_temp_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_temp_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Surface Temperature",
                                "scale_max": "340.0",
                                "scale_min": "190.0"
                            },
                            "sur_swnt_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_swnt_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Shortwave Radiation"
                            },
                            "sur_sbht_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_sbht_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Sensible Heat Flux"
                            },
                            "sur_prsr_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_prsr_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Surface Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "50000.0"
                            },
                            "sur_lwnt_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_lwnt_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Longwave Radiation"
                            },
                            "sur_ltht_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_ltht_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Latent Heat Flux"
                            },
                            "msl_prsr_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "msl_prsr_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Mean Sea Level Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "95000.0"
                            },
                            "dwpnt_2m_min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dwpnt_2m_min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Dew Point Temperature",
                                "scale_max": "306.0",
                                "scale_min": "215.0"
                            }
                        },
                        "Mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vwnd_str_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_str_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "V Wind Stress"
                            },
                            "vwnd_10m_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_10m_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter V Wind Velocity"
                            },
                            "uwnd_str_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_str_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "U Wind Stress"
                            },
                            "uwnd_10m_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_10m_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter U Wind Velocity"
                            },
                            "toa_swnt_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_swnt_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Shortwave Radiation"
                            },
                            "toa_lwnt_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_lwnt_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Longwave Radiation"
                            },
                            "temp_2m_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp_2m_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Temperature",
                                "scale_max": "330.0",
                                "scale_min": "220.0"
                            },
                            "sur_temp_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_temp_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Surface Temperature",
                                "scale_max": "340.0",
                                "scale_min": "190.0"
                            },
                            "sur_swnt_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_swnt_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Shortwave Radiation"
                            },
                            "sur_sbht_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_sbht_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Sensible Heat Flux"
                            },
                            "sur_prsr_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_prsr_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Surface Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "50000.0"
                            },
                            "sur_lwnt_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_lwnt_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Longwave Radiation"
                            },
                            "sur_ltht_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_ltht_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Latent Heat Flux"
                            },
                            "msl_prsr_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "msl_prsr_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Mean Sea Level Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "95000.0"
                            },
                            "dwpnt_2m_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dwpnt_2m_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Dew Point Temperature",
                                "scale_max": "306.0",
                                "scale_min": "215.0"
                            }
                        },
                        "Maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vwnd_str_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_str_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "V Wind Stress"
                            },
                            "vwnd_10m_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd_10m_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter V Wind Velocity"
                            },
                            "uwnd_str_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_str_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "U Wind Stress"
                            },
                            "uwnd_10m_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd_10m_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "long_name": "10-Meter U Wind Velocity"
                            },
                            "toa_swnt_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_swnt_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Shortwave Radiation"
                            },
                            "toa_lwnt_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa_lwnt_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Longwave Radiation"
                            },
                            "temp_2m_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp_2m_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Temperature",
                                "scale_max": "330.0",
                                "scale_min": "220.0"
                            },
                            "sur_temp_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_temp_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Surface Temperature",
                                "scale_max": "340.0",
                                "scale_min": "190.0"
                            },
                            "sur_swnt_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_swnt_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Shortwave Radiation"
                            },
                            "sur_sbht_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_sbht_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Sensible Heat Flux"
                            },
                            "sur_prsr_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_prsr_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Surface Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "50000.0"
                            },
                            "sur_lwnt_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_lwnt_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Net Longwave Radiation"
                            },
                            "sur_ltht_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sur_ltht_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Surface Latent Heat Flux"
                            },
                            "msl_prsr_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "msl_prsr_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "long_name": "Mean Sea Level Pressure",
                                "scale_max": "106000.0",
                                "scale_min": "95000.0"
                            },
                            "dwpnt_2m_max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dwpnt_2m_max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "2-Meter Dew Point Temperature",
                                "scale_max": "306.0",
                                "scale_min": "215.0"
                            }
                        }
                    },
                    "Daily_6Hourly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Daily_6-Hourly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-Meter Temperature",
                            "scale_max": "330.0",
                            "scale_min": "220.0"
                        },
                        "sur_prsr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sur_prsr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "long_name": "Surface Pressure",
                            "scale_max": "106000.0",
                            "scale_min": "50000.0"
                        },
                        "radiation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "radiation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hyb_swdn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hyb_swdn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Hybrid Surface Shortwave Down Radiation",
                                "scale_max": "1200.0",
                                "scale_min": "0.0"
                            },
                            "hyb_lwdn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hyb_lwdn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Hybrid Surface Longwave Down Radiation",
                                "scale_max": "600.0",
                                "scale_min": "0.0"
                            }
                        },
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "totl_prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "totl_prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "long_name": "Hybrid Total Precipitation"
                            },
                            "cnvt_prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnvt_prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "long_name": "Hybrid Convective Precipitation"
                            }
                        },
                        "mwnd_10m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mwnd_10m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "long_name": "10-Meter Wind Magnitude",
                            "scale_max": "35.0",
                            "scale_min": "0.0"
                        },
                        "dwpnt_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dwpnt_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "long_name": "2-Meter Dew Point Temperature",
                            "scale_max": "306.0",
                            "scale_min": "215.0"
                        }
                    }
                },
                "Miscellaneous": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Miscellaneous",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "land_sea_mask": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "land_sea_mask",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Land-Sea Mask"
                    },
                    "gridarea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridarea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Grid Area"
                    }
                },
                "HydrologySoils": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Hydrology-Soils",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "soils": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soils",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "texture": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "texture",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "long_name": "Dominant_Soil_Texture",
                            "CLIST": "Organic",
                            "scale_max": "7.0",
                            "scale_min": "0.0",
                            "colormap": "9639167",
                            "maxncolor": "11",
                            "ncolor": "11",
                            "CS": "0",
                            "CE": "7"
                        },
                        "prof_depth": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prof_depth",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "cm",
                            "long_name": "Soil_Profile_Depth",
                            "scale_max": "800.0",
                            "scale_min": "0.0"
                        },
                        "avgslope": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "avgslope",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "Average_Slope",
                            "scale_max": "40.0",
                            "scale_min": "0.0",
                            "missing_value": "-999.0"
                        }
                    },
                    "river_flow": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "river_flow",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "station": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "station",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "river": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "river",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "monthly_daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly_daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north"
                        },
                        "last_water_year": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "last_water_year",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "GRDC_gauge_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GRDC_gauge_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "flow": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flow",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m^3/sec",
                            "long_name": "Monthly Average Flow Rate",
                            "missing_value": "-9999.0"
                        },
                        "first_water_year": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "first_water_year",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "0",
                            "units": "m"
                        },
                        "country": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "country",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "catch_area": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "catch_area",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "0",
                            "units": "km^2"
                        }
                    },
                    "hydro_cover": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hydro_cover",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "swmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "swmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Swamps & Wetlands"
                        },
                        "smrs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "smrs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "46.0",
                            "scale_min": "0.0",
                            "long_name": "Saltmarsh"
                        },
                        "sltw": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sltw",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Saltwater"
                        },
                        "sflt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sflt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "96.0",
                            "scale_min": "0.0",
                            "long_name": "Salt Flats"
                        },
                        "rnof": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rnof",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/yr",
                            "scale_max": "5010.0",
                            "scale_min": "0.0",
                            "long_name": "Surface Water Runoff"
                        },
                        "rner": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rner",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "500.0",
                            "scale_min": "0.0",
                            "long_name": "RMSE of Surface Water Runoff",
                            "missing_value": "-999.0"
                        },
                        "rice": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rice",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/yr",
                            "scale_max": "1060.0",
                            "scale_min": "-840.0",
                            "long_name": "Ice Runoff"
                        },
                        "land": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "land",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Exposed Land",
                            "missing_value": "-999.0"
                        },
                        "iriv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "iriv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_max": "59.0",
                            "scale_min": "0.0",
                            "long_name": "Intermittent Rivers"
                        },
                        "ilak": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ilak",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Intermittent Water Bodies"
                        },
                        "glac": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "glac",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Glacier Ice"
                        },
                        "friv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "friv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_max": "66.0",
                            "scale_min": "0.0",
                            "long_name": "Perennial Rivers"
                        },
                        "flak": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flak",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Perennial Freshwater Lakes"
                        },
                        "dune": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dune",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Sand Dunes"
                        },
                        "dsrf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dsrf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "scale_max": "100.0",
                            "scale_min": "0.0",
                            "long_name": "Land, Swamp, Sand Dunes & Saltmarsh"
                        },
                        "cryo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cryo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "CLIST": "Ice Sheet",
                            "scale_max": "9.0",
                            "scale_min": "0.0",
                            "colormap": "9639167",
                            "maxncolor": "13",
                            "ncolor": "13",
                            "CS": "0",
                            "CE": "9",
                            "long_name": "Cryosphere Features"
                        },
                        "bas1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bas1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "CLIST": "Tsaidam",
                            "scale_max": "33.0",
                            "scale_min": "-1.0",
                            "colormap": "65280",
                            "maxncolor": "38",
                            "ncolor": "38",
                            "CS": "-1",
                            "CE": "33",
                            "long_name": "Major Drainage Basins"
                        }
                    },
                    "GPCP_precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GPCP_precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SatelliteModelGauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Satellite-Model-Gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precip": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precip",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "scale_max": "1000.0",
                                "scale_min": "0.0",
                                "long_name": "Estimated Monthly Precip."
                            },
                            "browse_fyi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "browse_fyi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "CLIST": "32",
                                "scale_max": "32.0",
                                "scale_min": "-42.0",
                                "maxncolor": "78",
                                "colormap": "255",
                                "ncolor": "78",
                                "CS": "-42",
                                "CE": "32",
                                "long_name": "Gauge Count or Satellite/Model Used in Estimate"
                            }
                        },
                        "Gauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precip": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precip",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "scale_max": "1000.0",
                                "scale_min": "0.0",
                                "long_name": "Monthly Precip."
                            },
                            "gauge_fyi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gauge_fyi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "count",
                                "scale_max": "10.0",
                                "scale_min": "0.0",
                                "long_name": "Gauge Count"
                            }
                        }
                    }
                }
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time",
                "modulo": "12.0",
                "modulus": "12.0"
            },
            "F": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "F",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "hr",
                "gridtype": "0",
                "pointwidth": "3.0"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "standard"
            },
            "C": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "C",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "6.0"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "ID": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ID",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/NASA/ISLSCP"
        },
        "JPL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "JPL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wetlandsdailyinundationswamps_v3p1stableData": "http://happy.ccny.cuny.edu/data/stable/",
                "wetlandsdailyinundationswamps_v3p1stabledescription": "Stable Version Global SWAMPS Inundation Fraction",
                "wetlandsdailyinundationswamps_v3p1nrtData": "http://happy.ccny.cuny.edu/data/nrt/",
                "wetlandsdailyinundationswamps_v3p1nrtdescription": "Near Real Time Global SWAMPS Inundation Fraction",
                "wetlandsdailyinundationswamps_v3p1references": "Schroeder_etal2014",
                "wetlandsdailyinundationdataset_documentation": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.JPL/.wetlands/dailyinundation/documentation.pdf",
                "wetlandsdailyinundationreferences": "Schroeder_etal2014",
                "wetlandsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.JPL/.wetlands.dataset_documentation.html",
                "Conventions": "IRIDL"
            },
            "wetlands": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wetlands",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tendayInundation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tendayInundation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "inundation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "inundation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "units": "unitless",
                        "SpatialReferenceSystemWKT": ",NORTH]]",
                        "scale_max": "1.0",
                        "grid_mapping": "Cylindrical_Equal_Area",
                        "scale_min": "0.0",
                        "SpatialReferenceSystemDims": "y"
                    }
                },
                "sixdayInnundation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sixdayInnundation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "innundation_fraction_anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "innundation_fraction_anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_mapping": "Cylindrical_Equal_Area",
                        "SpatialReferenceSystemDims": "y",
                        "SpatialReferenceSystemWKT": ",NORTH]]",
                        "missing_value": "-9999.0",
                        "scale_max": "1.0",
                        "units": "unitless",
                        "scale_min": "0.0",
                        "pointwidth": "0"
                    }
                },
                "dailyinundation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dailyinundation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v2_ascat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v2_ascat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "inundation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "inundation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "SpatialReferenceSystemWKT": ",NORTH]]",
                            "SpatialReferenceSystemDims": "y",
                            "units": "unitless",
                            "grid_mapping": "Cylindrical_Equal_Area",
                            "scale_min": "0.0",
                            "missing_value": "-99.0",
                            "pointwidth": "1.0"
                        }
                    },
                    "v1_qscat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1_qscat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "inundation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "inundation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "SpatialReferenceSystemWKT": ",NORTH]]",
                            "SpatialReferenceSystemDims": "y",
                            "units": "unitless",
                            "grid_mapping": "Cylindrical_Equal_Area",
                            "scale_min": "0.0",
                            "missing_value": "-9999.0",
                            "pointwidth": "1.0"
                        }
                    },
                    "v1_ers": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1_ers",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "inundation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "inundation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "SpatialReferenceSystemWKT": ",NORTH]]",
                            "SpatialReferenceSystemDims": "y",
                            "units": "unitless",
                            "grid_mapping": "Cylindrical_Equal_Area",
                            "scale_min": "0.0",
                            "missing_value": "-9999.0",
                            "pointwidth": "1.0"
                        }
                    },
                    "swamps_v3p1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "swamps_v3p1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "stable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "fw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "daily fractional surface water (0-1)",
                                "units": "unitless",
                                "pointwidth": "1"
                            },
                            "flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "14474460",
                                "scale_max": "4.0",
                                "maxncolor": "8",
                                "ncolor": "8",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "4",
                                "units": "ids",
                                "CLIST": "Snow",
                                "missing_value": "-9",
                                "long_name": "Flags derived from screening. 0: No data, 1: Valid, 2: permanent water, 3: rain, 4: snow",
                                "pointwidth": "1"
                            }
                        },
                        "nrt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nrt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "fw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "fw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "daily fractional surface water (0-1)",
                                "units": "unitless",
                                "pointwidth": "1"
                            },
                            "flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "14474460",
                                "scale_max": "4.0",
                                "maxncolor": "8",
                                "ncolor": "8",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "4",
                                "units": "ids",
                                "CLIST": "Snow",
                                "missing_value": "-9",
                                "long_name": "Flags derived from screening. 0: No data, 1: Valid, 2: permanent water, 3: rain, 4: snow",
                                "pointwidth": "1"
                            }
                        }
                    }
                }
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "calendar": "standard"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1999-01-01 00:00:00",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "6.0",
                "standard_name": "time"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "x": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "x",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "km",
                "gridtype": "0",
                "pointwidth": "25.067526"
            },
            "y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "km",
                "gridtype": "0",
                "pointwidth": "25.067524"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "1",
                "calendar": "standard"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "1",
                "calendar": "standard"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.2603037",
                "standard_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/NASA/JPL"
        },
        "NCCS_Dataserver": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NASA/NCCS_Dataserver",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "NCCS_Dataserver",
            "restriction": "Public",
            "CREATE_REANALYSIS": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "CREATE_REANALYSIS",
                "restriction": "Public",
                "CRv2c": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "20CRv2c",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "mon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zgSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zgSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Geopotential Height",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zgSprd",
                                "standard_name": "geopotential_height",
                                "units": "m",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "zg"
                            },
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "zg"
                            },
                            "wapSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wapSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "omega (=dp/dt)",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wapSprd",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "units": "Pa s-1",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "wap",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)"
                            },
                            "wap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Omega (=dp/dt)",
                                "units": "Pa s-1",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wap",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "wap",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)"
                            },
                            "vasSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vasSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Northward Near-Surface Wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vasSprd",
                                "coordinates": "height",
                                "standard_name": "northward_wind",
                                "units": "m s-1",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "vas"
                            },
                            "vaSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vaSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Northward Wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vaSprd",
                                "standard_name": "northward_wind",
                                "units": "m s-1",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "va"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "coordinates": "height",
                                "standard_name": "northward_wind",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "vas"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "va",
                                "standard_name": "northward_wind",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "va"
                            },
                            "uasSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uasSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Eastward Near-Surface Wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uasSprd",
                                "coordinates": "height",
                                "standard_name": "eastward_wind",
                                "units": "m s-1",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "uas"
                            },
                            "uaSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uaSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Eastward Wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uaSprd",
                                "standard_name": "eastward_wind",
                                "units": "m s-1",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ua"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "coordinates": "height",
                                "standard_name": "eastward_wind",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "uas"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ua",
                                "standard_name": "eastward_wind",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ua"
                            },
                            "tsSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tsSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Surface Temperature",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tsSprd",
                                "standard_name": "surface_temperature",
                                "units": "Kelvin_scale",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ts",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ts",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tauvSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauvSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Surface Downward Northward Wind Stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauvSprd",
                                "standard_name": "surface_downward_northward_stress",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "original_name": "tauv"
                            },
                            "tauv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Northward Wind Stress",
                                "units": "Pa",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauv",
                                "standard_name": "surface_downward_northward_stress",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "original_name": "tauv"
                            },
                            "tauuSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauuSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "cell_methods": "time: mean",
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauuSprd",
                                "standard_name": "surface_downward_eastward_stress",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "original_name": "tauu"
                            },
                            "tauu": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauu",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "units": "Pa",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauu",
                                "standard_name": "surface_downward_eastward_stress",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "original_name": "tauu"
                            },
                            "tasSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Near-Surface Air Temperature",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasSprd",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "units": "Kelvin_scale",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tas"
                            },
                            "taSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Air Temperature",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "taSprd",
                                "standard_name": "air_temperature",
                                "units": "Kelvin_scale",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ta"
                            },
                            "tasminSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasminSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Daily Minimum Near-Surface Air Temperature",
                                "cell_methods": "time: minimum within days time: mean over days",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasminSprd",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "units": "Kelvin_scale",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tasmin",
                                "comment": "monthly mean of the daily-minimum near-surface air temperature."
                            },
                            "tasmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Minimum Near-Surface Air Temperature",
                                "units": "K",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: minimum within days time: mean over days",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmin",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tasmin",
                                "comment": "monthly mean of the daily-minimum near-surface air temperature."
                            },
                            "tasmaxSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmaxSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Daily Maximum Near-Surface Air Temperature",
                                "cell_methods": "time: maximum within days time: mean over days",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmaxSprd",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "units": "Kelvin_scale",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tasmax",
                                "comment": "monthly mean of the daily-maximum near-surface air temperature."
                            },
                            "tasmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Maximum Near-Surface Air Temperature",
                                "units": "K",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: maximum within days time: mean over days",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmax",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tasmax",
                                "comment": "monthly mean of the daily-maximum near-surface air temperature."
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "coordinates": "height",
                                "standard_name": "air_temperature",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "tas"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "ta"
                            },
                            "rsutSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsutSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "TOA Outgoing Shortwave Radiation",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsutSprd",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "units": "W/m2",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsut",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing  Shortwave Radiation",
                                "units": "W m-2",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsut",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsut",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsusSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsusSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Surface Upwelling Shortwave Radiation",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsusSprd",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                "units": "W/m2",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsus"
                            },
                            "rsus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Shortwave Radiation",
                                "units": "W m-2",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsus",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsus"
                            },
                            "rsdsSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdsSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdsSprd",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                "units": "W/m2",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsds"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "units": "W m-2",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsds",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rsds"
                            },
                            "rldsSprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rldsSprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "statistic": "Ensemble Spread",
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rldsSprd",
                                "standard_name": "surface_downwelling_longwave_flux_in_air",
                                "units": "W/m2",
                                "statistic_method": "Standard deviation calculated by taking standard deviation of the 56 ensemble members at each time step and then averaging STD over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rlds"
                            },
                            "rlds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "units": "W m-2",
                                "statistic": "Ensemble Mean",
                                "cell_methods": "time: mean",
                                "cell_measures": "area: areacella",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlds",
                                "standard_name": "surface_downwelling_longwave_flux_in_air",
                                "statistic_method": "Ensemble mean is calculated by averaging over all 56 ensemble members at each time step and then averaging mean over all time steps in a month",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ensda-v351_20CRv2c_r0i0p0.nc areacella: areacella_fx_ensda-v351_20CRv2c_r0i0p0.nc",
                                "original_name": "rlds"
                            }
                        }
                    },
                    "plev_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "standard_name": "air_pressure",
                        "positive": "down",
                        "axis": "Z",
                        "uniquename": "plev"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "standard_name": "air_pressure",
                        "positive": "down",
                        "axis": "Z",
                        "uniquename": "plev"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1851-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/20CRv2c"
                },
                "CFSR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CFSR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "dayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "hratmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "mon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "hgtprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella"
                            },
                            "wap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Omega (=dp/dt)",
                                "units": "Pa s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "vvelprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wap",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)",
                                "cell_measures": "area: areacella"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "m/s",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "vgrd10m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "standard_name": "northward_wind",
                                "coordinates": "height"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "northward_wind",
                                "original_name": "vgrdprs",
                                "dodsname": "va",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "m/s",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "ugrd10m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "standard_name": "eastward_wind",
                                "coordinates": "height"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "eastward_wind",
                                "original_name": "ugrdprs",
                                "dodsname": "ua",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "o3mrprs*(.603356/1e-6)",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "cell_measures": "area: areacella"
                            },
                            "tauv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Northward Wind Stress",
                                "units": "Pa",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_units": "N/m2",
                                "original_name": "vflxsfc",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauv",
                                "standard_name": "surface_downward_northward_stress",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "tauu": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauu",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "units": "Pa",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_units": "N/m2",
                                "original_name": "uflxsfc",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauu",
                                "standard_name": "surface_downward_eastward_stress",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "tasmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Minimum Near-Surface Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: minimum (interval: 6 hours) within days time: mean over days",
                                "original_name": "tmin2m",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmin",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "comment": "monthly mean of the daily-minimum near-surface air temperature."
                            },
                            "tasmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Maximum Near-Surface Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: maximum (interval: 6 hours) within days time: mean over days",
                                "original_name": "tmax2m",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmax",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "comment": "monthly mean of the daily-maximum near-surface air temperature."
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "tmp2m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "cell_measures": "area: areacella"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "tmpprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella"
                            },
                            "sbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Snow and Ice Sublimation Flux",
                                "units": "kg m-2 s-1",
                                "original_name": "sbsnosfc*0.03456/86400",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "sbl",
                                "standard_name": "surface_snow_and_ice_sublimation_flux",
                                "comment": "The snow and ice sublimation flux is the loss of snow and ice mass from the surface resulting from their conversion to water vapor that enters the atmosphere.",
                                "original_units": "kg/m2/s"
                            },
                            "rsutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "csusftoa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsutcs",
                                "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                                "cell_measures": "area: areacella"
                            },
                            "rsut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing  Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "uswrftoa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsut",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "comment": "at the top of the atmosphere",
                                "cell_measures": "area: areacella"
                            },
                            "rsuscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsuscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "csusfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsuscs",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air_assuming_clear_sky",
                                "cell_measures": "area: areacella"
                            },
                            "rsus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "uswrfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsus",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                "cell_measures": "area: areacella"
                            },
                            "rsdt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Incident Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "dswrftoa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdt",
                                "standard_name": "toa_incoming_shortwave_flux",
                                "comment": "at the top of the atmosphere",
                                "cell_measures": "area: areacella"
                            },
                            "rsdscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": " Surface Downwelling Clear-Sky Shortwave Radiation ",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "csdsfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdscs",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air_assuming_clear_sky",
                                "cell_measures": "area: areacella"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "dswrfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsds",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                "cell_measures": "area: areacella"
                            },
                            "rlutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "csulftoa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlutcs",
                                "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                                "cell_measures": "area: areacella"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Longwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "ulwrftoa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlut",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "comment": "at the top of the atmosphere (to be compared with satellite measurements)",
                                "cell_measures": "area: areacella"
                            },
                            "rlus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Longwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "ulwrfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlus",
                                "standard_name": "surface_upwelling_longwave_flux_in_air",
                                "cell_measures": "area: areacella"
                            },
                            "rldscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rldscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "csdlfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rldscs",
                                "standard_name": "surface_downwelling_longwave_flux_in_air_assuming_clear_sky",
                                "cell_measures": "area: areacella"
                            },
                            "rlds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "dlwrfsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlds",
                                "standard_name": "surface_downwelling_longwave_flux_in_air",
                                "cell_measures": "area: areacella"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "prmslmsl",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "comment": "not, in general, the same as surface pressure",
                                "cell_measures": "area: areacella"
                            },
                            "prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation",
                                "units": "kg m-2 s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "kg/m2/s",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "cpratsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prc",
                                "standard_name": "convective_precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases.",
                                "cell_measures": "area: areacella"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "kg/m2/s",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "pratesfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella"
                            },
                            "huss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "huss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Specific Humidity",
                                "units": "kg/kg",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "kg/kg",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "spfh2m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "huss",
                                "standard_name": "specific_humidity",
                                "coordinates": "height",
                                "cell_measures": "area: areacella"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "kg kg-1",
                                "cell_methods": "time: mean",
                                "original_name": "spfhprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella"
                            },
                            "hfss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Sensible Heat Flux",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "shtflsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfss",
                                "standard_name": "surface_upward_sensible_heat_flux",
                                "cell_measures": "area: areacella"
                            },
                            "hfls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Latent Heat Flux",
                                "units": "W m-2",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "W/m2",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "lhtflsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfls",
                                "standard_name": "surface_upward_latent_heat_flux",
                                "comment": "includes both evaporation and sublimation",
                                "cell_measures": "area: areacella"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_name": "lhtflsfc*0.03456/86400",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "grid_type": "gaussian",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)",
                                "original_units": "kg/m2/s"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "original_name": "tcdcclm",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                "cell_measures": "area: areacella"
                            },
                            "cct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Pressure at Convective Cloud Top",
                                "units": "Pa",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "missing_value": "1.00000002E20",
                                "standard_name": "air_pressure_at_convective_cloud_top",
                                "original_name": "prescclt",
                                "dodsname": "cct",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "ccb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ccb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Pressure at Convective Cloud Base",
                                "units": "Pa",
                                "cell_methods": "time: mean (interval: 6 hours)",
                                "missing_value": "1.00000002E20",
                                "standard_name": "air_pressure_at_convective_cloud_base",
                                "original_name": "prescclb",
                                "dodsname": "ccb",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            }
                        }
                    },
                    "day": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "pratesfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella"
                            }
                        }
                    },
                    "hr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "6hr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "hgtprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "northward_wind",
                                "original_name": "vgrd10m",
                                "dodsname": "vas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc",
                                "coordinates": "height"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "northward_wind",
                                "original_name": "vgrdprs",
                                "dodsname": "va",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "eastward_wind",
                                "original_name": "ugrd10m",
                                "dodsname": "uas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc",
                                "coordinates": "height"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "cell_methods": "time: mean",
                                "missing_value": "1.00000002E20",
                                "standard_name": "eastward_wind",
                                "original_name": "ugrdprs",
                                "dodsname": "ua",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "tmpsfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "comment": " temperature (i.e., SST for open ocean)",
                                "cell_measures": "area: areacella"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "o3mrprs*(.603356/1e-6)",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "cell_measures": "area: areacella"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "tmp2m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "cell_measures": "area: areacella"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "tmpprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "prmslmsl",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "comment": "not, in general, the same as surface pressure",
                                "cell_measures": "area: areacella"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "pratesfc",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "original_units": "kg kg-1",
                                "cell_methods": "time: mean",
                                "original_name": "spfhprs",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "lhtflsfc*0.03456/86400",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)",
                                "cell_measures": "area: areacella"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_CFSR_CFSR_r0i0p0.nc areacella: areacella_fx_CFSR_CFSR_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "original_name": "tcdcclm",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                "cell_measures": "area: areacella"
                            }
                        }
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0",
                        "units": "days since 1979-01-01 00:00:00",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1979-01-01 00:00:00",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1979-01-01 00:00:00",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "positive": "down",
                        "units": "Pa",
                        "axis": "Z",
                        "standard_name": "air_pressure",
                        "uniquename": "plev"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1979-01-01 00:00:00",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/CFSR"
                },
                "ECMWF": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECMWF",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "dayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "hratmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "homepage": "https://www.ecmwf.int/en/forecasts/datasets/reanalysis-datasets/era-interim",
                        "description": "ERA-Interim is a global atmospheric reanalysis that is available from 1 January 1979 to 31 August 2019. It has been superseded by the ERA5 reanalysis.",
                        "Conventions": "IRIDL"
                    },
                    "mon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "original_name": "z/9.80665",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "wap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Omega (=dp/dt)",
                                "units": "Pa s-1",
                                "original_name": "w",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wap",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "v10",
                                "coordinates": "height",
                                "standard_name": "northward_wind",
                                "cell_methods": "time: mean",
                                "dodsname": "vas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_name": "v",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind",
                                "dodsname": "va",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "u10",
                                "coordinates": "height",
                                "standard_name": "eastward_wind",
                                "cell_methods": "time: mean",
                                "dodsname": "uas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_name": "u",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind",
                                "dodsname": "ua",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "original_name": "skt",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "original_name": "o3",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "cell_measures": "area: areacella",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "tauv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Northward Wind Stress",
                                "units": "Pa",
                                "original_name": "inss",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_downward_northward_stress",
                                "cell_methods": "time: mean",
                                "dodsname": "tauv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc"
                            },
                            "tauu": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauu",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "units": "Pa",
                                "original_name": "iews",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_downward_eastward_stress",
                                "cell_methods": "time: mean",
                                "dodsname": "tauu",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "t2m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_name": "t",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "sfcWind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sfcWind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Wind Speed",
                                "original_name": "si10",
                                "missing_value": "1.00000002E20",
                                "dodsname": "sfcWind",
                                "standard_name": "wind_speed",
                                "units": "m s-1",
                                "coordinates": "height",
                                "comments": "sfcWind is the monthly mean of the square root of the sum of the square of 6-hour eastward wind at 10 meters plus the square of the 6-hour northward wind at 10 meters.",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "This is the mean of the speed, not the speed computed from the mean u and v components of wind"
                            },
                            "rsutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "(tisr-tsrc)/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                                "cell_methods": "time: mean",
                                "dodsname": "rsutcs",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "rsut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing  Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "(tisr-tsr)/86400",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsut",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "(ssrd-ssr)/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                "cell_methods": "time: mean",
                                "dodsname": "rsus",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "rsdt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Incident Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "tisr/86400",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdt",
                                "standard_name": "toa_incoming_shortwave_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "ssrd/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                "cell_methods": "time: mean",
                                "dodsname": "rsds",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "rlutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "-ttrc/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                                "cell_methods": "time: mean",
                                "dodsname": "rlutcs",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "-ttr/86400",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlut",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere (to be compared with satellite measurements)"
                            },
                            "rlus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "(strd-str)/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_upwelling_longwave_flux_in_air",
                                "cell_methods": "time: mean",
                                "dodsname": "rlus",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "rlds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "strd/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_downwelling_longwave_flux_in_air",
                                "cell_methods": "time: mean",
                                "dodsname": "rlds",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_name": "msl",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "not, in general, the same as surface pressure"
                            },
                            "prsn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prsn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snowfall Flux",
                                "original_name": "sf/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prsn",
                                "standard_name": "snowfall_flux",
                                "units": "kg m-2 s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes precipitation of all forms of water in the solid phase"
                            },
                            "prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "cp/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prc",
                                "standard_name": "convective_precipitation_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases."
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "tp/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "original_name": "q",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella",
                                "original_units": "kg kg-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "hfss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Sensible Heat Flux",
                                "units": "W m-2",
                                "original_name": "-sshf/86400",
                                "missing_value": "1.00000002E20",
                                "standard_name": "surface_upward_sensible_heat_flux",
                                "cell_methods": "time: mean",
                                "dodsname": "hfss",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_measures": "area: areacella"
                            },
                            "hfls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Latent Heat Flux",
                                "units": "W m-2",
                                "original_name": "-slhf/86400",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfls",
                                "standard_name": "surface_upward_latent_heat_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "includes both evaporation and sublimation"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_name": "-e/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)"
                            },
                            "clwvi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clwvi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Condensed Water Path",
                                "original_name": "tciw+tclw",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clwvi",
                                "standard_name": "atmosphere_cloud_condensed_water_content",
                                "units": "kg m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "mass of condensed (liquid + ice) water in the column divided by the area of the column (not just the area of the cloudy portion of the column). Includes precipitating hydrometeors ONLY if the precipitating hydrometeor affects the calculation of radiative transfer in model."
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "original_name": "tcc*100",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud."
                            },
                            "clivi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clivi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice Water Path",
                                "original_name": "tciw",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clivi",
                                "standard_name": "atmosphere_cloud_ice_content",
                                "units": "kg m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "mass of ice water in the column divided by the area of the column (not just the area of the cloudy portion of the column). Includes precipitating frozen hydrometeors ONLY if the precipitating hydrometeor affects the calculation of radiative transfer in model."
                            }
                        }
                    },
                    "day": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "tp",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "cell_measures": "area: areacella",
                                "comments": "This daily precipitation is prepared by creating a daily mean of the source 6hr precipitation.",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            }
                        }
                    },
                    "hr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "6hr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "original_name": "z/9.80665",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "v10",
                                "coordinates": "height",
                                "standard_name": "northward_wind",
                                "cell_methods": "time: mean",
                                "dodsname": "vas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_name": "v",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind",
                                "dodsname": "va",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "u10",
                                "coordinates": "height",
                                "standard_name": "eastward_wind",
                                "cell_methods": "time: mean",
                                "dodsname": "uas",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_name": "u",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind",
                                "dodsname": "ua",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "missing_value": "1.00000002E20"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "original_name": "skt",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "original_name": "o3",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "cell_measures": "area: areacella",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "t2m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_name": "t",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_name": "msl",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "not, in general, the same as surface pressure"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "tp/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "cell_measures": "area: areacella",
                                "comments": "How this data is processed: ERA-I total precipitation is an accumulated forecast field, measured in m of water from the beginning of the forecast. There are two forecasts per day, from 00 and 12 UTC. This 6hr data is processed by using both forecast start times 00 and 12, and steps 6 and 12. The first of four 6-hour accumulation periods is time 00 step 6, the second is time 00 step 12 minus step 6; the third accumulation period is time 12 step 6, the fourth is time 12 step 12 minus step 6. Be aware there can be spin-up problems, see: http://www.ecmwf.int/en/elibrary/10381-forecast-drift-era-interim.",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "original_name": "q",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella",
                                "original_units": "kg kg-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_name": "-e/86.4",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "cell_measures": "area: areacella",
                                "comments": "How this data is processed: ERA-I evaporation is an accumulated forecast field, measured in m of water from the beginning of the forecast. There are two forecasts per day, from 00 and 12 UTC. This 6hr data is processed by using both forecast start times 00 and 12, and steps 6 and 12. The first of four 6-hour accumulation periods is time 00 step 6, the second is time 00 step 12 minus step 6; the third accumulation period is time 12 step 6, the fourth is time 12 step 12 minus step 6. Be aware there can be spin-up problems, see: http://www.ecmwf.int/en/elibrary/10381-forecast-drift-era-interim.",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "original_name": "tcc*100",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc areacella: areacella_fx_IFS-Cy31r2_ERA-Interim_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud."
                            }
                        }
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "units": "days since 1900-01-01",
                        "standard_name": "time",
                        "uniquename": "time",
                        "pointwidth": "0",
                        "calendar": "gregorian"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "axis": "T",
                        "units": "days since 1900-01-01",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "axis": "Z",
                        "units": "Pa",
                        "standard_name": "air_pressure",
                        "uniquename": "plev",
                        "positive": "down"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "axis": "T",
                        "units": "days since 1900-01-01",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "axis": "T",
                        "units": "days since 1900-01-01",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/ECMWF"
                },
                "ECMWFIFSCy41r2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECMWF-IFS-Cy41r2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ERA5monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "CERA20Cmonatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "ERA5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ERA5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "atmos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "atmos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "m",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "zg",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "z/9.80665",
                                    "cell_methods": "time: mean",
                                    "standard_name": "geopotential_height"
                                },
                                "wap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Omega (=dp/dt)",
                                    "units": "Pa s-1",
                                    "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)",
                                    "missing_value": "1.00000002E20",
                                    "cell_measures": "area: areacella",
                                    "dodsname": "wap",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "w",
                                    "cell_methods": "time: mean",
                                    "standard_name": "lagrangian_tendency_of_air_pressure"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Northward Near-Surface Wind",
                                    "units": "m s-1",
                                    "original_name": "v10",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "northward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "vas",
                                    "coordinates": "height",
                                    "cell_methods": "time: mean"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Northward Wind",
                                    "units": "m s-1",
                                    "original_name": "v",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "northward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "va",
                                    "cell_methods": "time: mean"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Eastward Near-Surface Wind",
                                    "units": "m s-1",
                                    "original_name": "u10",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "eastward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "uas",
                                    "coordinates": "height",
                                    "cell_methods": "time: mean"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Eastward Wind",
                                    "units": "m s-1",
                                    "original_name": "u",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "eastward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ua",
                                    "cell_methods": "time: mean"
                                },
                                "ts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Temperature",
                                    "units": "K",
                                    "comment": " temperature (i.e., SST for open ocean)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ts",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "skt",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_temperature"
                                },
                                "tro3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tro3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Mole Fraction of O3",
                                    "units": "ppmv",
                                    "comments": "Units changed from kg kg**-1 to ppmv",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "tro3",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "o3*(.603356/1e-6)",
                                    "cell_methods": "time: mean",
                                    "standard_name": "mole_fraction_of_ozone_in_air"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downward Northward Wind Stress",
                                    "units": "Pa",
                                    "original_name": "inss",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_downward_northward_stress",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "tauv",
                                    "original_units": "N m-2",
                                    "cell_methods": "time: mean"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downward Eastward Wind Stress",
                                    "units": "Pa",
                                    "original_name": "iews",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_downward_eastward_stress",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "tauu",
                                    "original_units": "N m-2",
                                    "cell_methods": "time: mean"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near-Surface Air Temperature",
                                    "units": "K",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "tas",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "t2m",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_temperature",
                                    "coordinates": "height"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Air Temperature",
                                    "units": "K",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ta",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "t",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_temperature"
                                },
                                "rsutcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsutcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing Clear-Sky Shortwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "(tisr-tsrc)/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsutcs",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "rsut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing  Shortwave Radiation",
                                    "units": "W m-2",
                                    "comment": "at the top of the atmosphere",
                                    "missing_value": "1.00000002E20",
                                    "cell_measures": "area: areacella",
                                    "dodsname": "rsut",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "(tisr-tsr)/86400",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_outgoing_shortwave_flux",
                                    "institution": "ECMWF"
                                },
                                "rsus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upwelling Shortwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "(ssrd-ssr)/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsus",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "rsdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Incident Shortwave Radiation",
                                    "units": "W m-2",
                                    "comment": "at the top of the atmosphere",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsdt",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "tisr/86400",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_incoming_shortwave_flux"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downwelling Shortwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "ssrd/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsds",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "rlutcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlutcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing Clear-Sky Longwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "-ttrc/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlutcs",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "rlut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing Longwave Radiation",
                                    "units": "W m-2",
                                    "comment": "at the top of the atmosphere (to be compared with satellite measurements)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlut",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "-ttr/86400",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_outgoing_longwave_flux"
                                },
                                "rlus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upwelling Longwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "(strd-str)/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_upwelling_longwave_flux_in_air",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlus",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "rlds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downwelling Longwave Radiation",
                                    "units": "W m-2",
                                    "original_name": "strd/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_downwelling_longwave_flux_in_air",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlds",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "psl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Level Pressure",
                                    "units": "Pa",
                                    "comment": "not, in general, the same as surface pressure",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "psl",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "msl",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_pressure_at_sea_level"
                                },
                                "prsn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prsn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snowfall Flux",
                                    "comment": "at surface; includes precipitation of all forms of water in the solid phase",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "prsn",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "sf/86.4",
                                    "cell_methods": "time: mean",
                                    "standard_name": "snowfall_flux",
                                    "units": "kg m-2 s-1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation",
                                    "units": "kg m-2 s-1",
                                    "comment": "at surface; includes both liquid and solid phases.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "prc",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "cp/86.4",
                                    "cell_methods": "time: mean",
                                    "standard_name": "convective_precipitation_flux"
                                },
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "pr",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "mtpr",
                                    "cell_methods": "time: mean",
                                    "standard_name": "precipitation_flux"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "missing_value": "1.00000002E20",
                                    "original_units": "kg kg-1",
                                    "cell_measures": "area: areacella",
                                    "dodsname": "hus",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "q",
                                    "cell_methods": "time: mean",
                                    "standard_name": "specific_humidity"
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upward Sensible Heat Flux",
                                    "units": "W m-2",
                                    "original_name": "-sshf/86400",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "standard_name": "surface_upward_sensible_heat_flux",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "hfss",
                                    "cell_measures": "area: areacella",
                                    "cell_methods": "time: mean"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upward Latent Heat Flux",
                                    "units": "W m-2",
                                    "comment": "includes both evaporation and sublimation",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "hfls",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "-slhf/86400",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_upward_latent_heat_flux"
                                },
                                "evspsbl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evspsbl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation",
                                    "units": "kg m-2 s-1",
                                    "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "evspsbl",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "-mer",
                                    "cell_methods": "time: mean",
                                    "standard_name": "water_evaporation_flux"
                                },
                                "clwvi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clwvi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Condensed Water Path",
                                    "comment": "mass of condensed (liquid + ice) water in the column divided by the area of the column (not just the area of the cloudy portion of the column). Includes precipitating hydrometeors ONLY if the precipitating hydrometeor affects the calculation of radiative transfer in model.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "clwvi",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "tciw+tclw",
                                    "cell_methods": "time: mean",
                                    "standard_name": "atmosphere_cloud_condensed_water_content",
                                    "units": "kg m-2"
                                },
                                "clt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Fraction",
                                    "units": "%",
                                    "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "clt",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "tcc*100",
                                    "cell_methods": "time: mean",
                                    "standard_name": "cloud_area_fraction"
                                },
                                "clivi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clivi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Water Path",
                                    "comment": "mass of ice water in the column divided by the area of the column (not just the area of the cloudy portion of the column). Includes precipitating frozen hydrometeors ONLY if the precipitating hydrometeor affects the calculation of radiative transfer in model.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "clivi",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_ERA5_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_ERA5_r0i0p0.nc",
                                    "original_name": "tciw",
                                    "cell_methods": "time: mean",
                                    "standard_name": "atmosphere_cloud_ice_content",
                                    "units": "kg m-2"
                                }
                            }
                        }
                    },
                    "CERA20C": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CERA-20C",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "atmos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "atmos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Omega (=dp/dt)",
                                    "units": "Pa s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)",
                                    "missing_value": "1.00000002E20",
                                    "cell_measures": "area: areacella",
                                    "dodsname": "wap",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "w",
                                    "cell_methods": "time: mean",
                                    "standard_name": "lagrangian_tendency_of_air_pressure",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Northward Near-Surface Wind",
                                    "units": "m s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "vas",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "v10",
                                    "cell_methods": "time: mean",
                                    "standard_name": "northward_wind",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month.",
                                    "coordinates": "height"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Northward Wind",
                                    "units": "m s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "va",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "v",
                                    "cell_methods": "time: mean",
                                    "standard_name": "northward_wind",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Eastward Near-Surface Wind",
                                    "units": "m s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "uas",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "u10",
                                    "cell_methods": "time: mean",
                                    "standard_name": "eastward_wind",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month.",
                                    "coordinates": "height"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Eastward Wind",
                                    "units": "m s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ua",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "u",
                                    "cell_methods": "time: mean",
                                    "standard_name": "eastward_wind",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "ts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Temperature",
                                    "units": "K",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": " temperature (i.e., SST for open ocean)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ts",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "skt",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_temperature",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downward Northward Wind Stress",
                                    "units": "Pa",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "original_units": "N m-2",
                                    "dodsname": "tauv",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "inss",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_downward_northward_stress",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downward Eastward Wind Stress",
                                    "units": "Pa",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "original_units": "N m-2",
                                    "dodsname": "tauu",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "iews",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_downward_eastward_stress",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near-Surface Air Temperature",
                                    "units": "K",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "tas",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "t2m",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_temperature",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month.",
                                    "coordinates": "height"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Air Temperature",
                                    "units": "K",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ta",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "t",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_temperature",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rsut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing  Shortwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "at the top of the atmosphere",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsut",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "DIFF_PER_SEC(tisr,tsr)",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_outgoing_shortwave_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rsus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upwelling Shortwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsus",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "DIFF_PER_SEC(ssrd,ssr)",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_upwelling_shortwave_flux_in_air",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rsdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Incident Shortwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "at the top of the atmosphere",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsdt",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "tisr",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_incoming_shortwave_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downwelling Shortwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rsds",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "ssrd",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rlut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TOA Outgoing Longwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "at the top of the atmosphere (to be compared with satellite measurements)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlut",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "ttr",
                                    "cell_methods": "time: mean",
                                    "standard_name": "toa_outgoing_longwave_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rlus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upwelling Longwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlus",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "DIFF_PER_SEC(strd,str)",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_upwelling_longwave_flux_in_air",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "rlds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rlds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Downwelling Longwave Radiation",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "rlds",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "strd",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_downwelling_longwave_flux_in_air",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "psl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Level Pressure",
                                    "units": "Pa",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "not, in general, the same as surface pressure",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "psl",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "msl",
                                    "cell_methods": "time: mean",
                                    "standard_name": "air_pressure_at_sea_level",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation",
                                    "units": "kg m-2 s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "at surface; includes both liquid and solid phases.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "prc",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "cp",
                                    "cell_methods": "time: mean",
                                    "standard_name": "convective_precipitation_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "pr",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "tp",
                                    "cell_methods": "time: mean",
                                    "standard_name": "precipitation_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "original_units": "kg kg-1",
                                    "cell_measures": "area: areacella",
                                    "dodsname": "hus",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "q",
                                    "cell_methods": "time: mean",
                                    "standard_name": "specific_humidity",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upward Sensible Heat Flux",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "hfss",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "sshf",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_upward_sensible_heat_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Upward Latent Heat Flux",
                                    "units": "W m-2",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "includes both evaporation and sublimation",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "hfls",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "slhf",
                                    "cell_methods": "time: mean",
                                    "standard_name": "surface_upward_latent_heat_flux",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                },
                                "clt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Fraction",
                                    "units": "%",
                                    "source": "CERA-20C is the ECMWF 10-member ensemble of coupled climate reanalyses of the 20th century, from 1901-2010. It is based on the CERA assimilation system, which assimilates only surface pressure and marine wind observations as well as ocean temperature and salinity profiles. It is an outcome of the ERA-CLIM2 project. For any questions regarding the data access and the data itself, please go to https://climate.copernicus.eu/c3s-user-service-desk and look at the Knowledge Base or contact the User Support via the Enquiry Portal. This file contains modified Copernicus Climate Change Service Information for the years noted in the metadata; neither the European Commission nor ECMWF is responsible for any use that may be made of the Copernicus Information or data it contains.",
                                    "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "clt",
                                    "cell_measures": "area: areacella",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc areacella: areacella_fx_IFS-Cy41r2_CERA20C_r0i0p0.nc",
                                    "original_name": "tcc",
                                    "cell_methods": "time: mean",
                                    "standard_name": "cloud_area_fraction",
                                    "statistic": "Ensemble Mean",
                                    "statistic_method": "Ensemble monthly means files are created from the 3hr instantaneous and accumulated forecast parameters, integrated daily at 18 UTC. Accumulations are adjusted to fall within each calendar month."
                                }
                            }
                        }
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1979-01-01 00:00:00",
                        "gridtype": "2",
                        "calendar": "360"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "axis": "Z",
                        "standard_name": "air_pressure",
                        "uniquename": "plev",
                        "positive": "down"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/ECMWF-IFS-Cy41r2"
                },
                "JMA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "JMA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "JRA55mdlisodayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "JRA55monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "JRA55dayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "JRA55mdliso": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "JRA-55-mdl-iso",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "day": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "day",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "atmos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "atmos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55-mdl-iso_r0i0p0.nc areacella: areacella_fx_JRA-55_JRA-55-mdl-iso_r0i0p0.nc",
                                    "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                    "missing_value": "1.00000002E20",
                                    "cell_methods": "time: mean",
                                    "dodsname": "pr",
                                    "cell_measures": "area: areacella",
                                    "comments": "This daily precipitation is prepared by creating a daily mean of the source 6hr precipitation.",
                                    "original_name": "tpratsfc",
                                    "standard_name": "precipitation_flux"
                                }
                            }
                        }
                    },
                    "JRA55": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "JRA-55",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "mon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "atmos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "atmos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Northward Wind",
                                    "units": "m s-1",
                                    "cell_methods": "time: mean",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55_r0i0p0.nc",
                                    "standard_name": "northward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "va",
                                    "original_name": "vgrdprs"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Eastward Wind",
                                    "units": "m s-1",
                                    "cell_methods": "time: mean",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55_r0i0p0.nc",
                                    "standard_name": "eastward_wind",
                                    "missing_value": "1.00000002E20",
                                    "dodsname": "ua",
                                    "original_name": "ugrdprs"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Air Temperature",
                                    "units": "K",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55_r0i0p0.nc areacella: areacella_fx_JRA-55_JRA-55_r0i0p0.nc",
                                    "missing_value": "1.00000002E20",
                                    "cell_methods": "time: mean",
                                    "dodsname": "ta",
                                    "cell_measures": "area: areacella",
                                    "original_name": "tmpprs",
                                    "standard_name": "air_temperature"
                                },
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55_r0i0p0.nc areacella: areacella_fx_JRA-55_JRA-55_r0i0p0.nc",
                                    "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                    "missing_value": "1.00000002E20",
                                    "cell_methods": "time: mean",
                                    "dodsname": "pr",
                                    "cell_measures": "area: areacella",
                                    "original_name": "tpratsfc",
                                    "standard_name": "precipitation_flux"
                                }
                            }
                        },
                        "day": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "day",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "atmos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "atmos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_JRA-55_JRA-55_r0i0p0.nc areacella: areacella_fx_JRA-55_JRA-55_r0i0p0.nc",
                                    "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                    "missing_value": "1.00000002E20",
                                    "cell_methods": "time: mean",
                                    "dodsname": "pr",
                                    "comments": "How this data is processed: JRA-55 total precipitation, from the fcst_phy2m125 two-dimensional average diagnostic fields, is averaged from the beginning of forecasts up to three hours for 00-03, 06-09, 12-15 and 18-21 UTC, and from three to six hours for 03-06, 09-12, 15-18 and 21-24 UTC. This 6-hour data is produced by averaging the beginning of each three hour forecast with the next three to six hour forecast; the averaged 6 hour periods are 00-03 and 03-06, 06-09 and 09-12, 12-15 and 15-18, and 18-21 and 21-24 UTC.",
                                    "original_name": "tpratsfc",
                                    "standard_name": "precipitation_flux"
                                }
                            }
                        }
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "days since 1900-01-01",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "axis": "T",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "axis": "Z",
                        "standard_name": "air_pressure",
                        "uniquename": "plev",
                        "positive": "down"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1958-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "axis": "Y",
                        "standard_name": "latitude",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "axis": "X",
                        "modulus": "360.0",
                        "standard_name": "longitude",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0",
                        "units": "days since 1900-01-01",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/JMA"
                },
                "MERRA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MERRA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "dayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "hratmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "mon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "H",
                                "cell_methods": "time: mean"
                            },
                            "wap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Omega (=dp/dt)",
                                "units": "Pa s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wap",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "OMEGA",
                                "cell_methods": "time: mean"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "standard_name": "northward_wind",
                                "coordinates": "height",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "v10m",
                                "cell_methods": "time: mean"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "va",
                                "standard_name": "northward_wind",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "V",
                                "cell_methods": "time: mean"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "standard_name": "eastward_wind",
                                "coordinates": "height",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "u10m",
                                "cell_methods": "time: mean"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ua",
                                "standard_name": "eastward_wind",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "U",
                                "cell_methods": "time: mean"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "original_units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "comment": " temperature (i.e., SST for open ocean)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "ts",
                                "cell_methods": "time: mean"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "comments": "Units changed from mg kg**-1 to ppmv",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "O3",
                                "cell_methods": "time: mean"
                            },
                            "tauv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Northward Wind Stress",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "standard_name": "surface_downward_northward_stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauv",
                                "cell_methods": "time: mean",
                                "original_units": "Pa",
                                "original_name": "tauy"
                            },
                            "tauu": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauu",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "units": "Pa",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "standard_name": "surface_downward_eastward_stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauu",
                                "cell_methods": "time: mean",
                                "original_units": "Pa",
                                "original_name": "taux"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "original_units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "t2m",
                                "cell_methods": "time: mean"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "T",
                                "cell_methods": "time: mean"
                            },
                            "rsutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsutcs",
                                "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "DIFF(swtdn,swtntclr)",
                                "cell_methods": "time: mean"
                            },
                            "rsut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing  Shortwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsut",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "comment": "at the top of the atmosphere",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "DIFF(swtdn,swtnt)",
                                "cell_methods": "time: mean"
                            },
                            "rsdt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Incident Shortwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdt",
                                "standard_name": "toa_incoming_shortwave_flux",
                                "comment": "at the top of the atmosphere",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "swtdn",
                                "cell_methods": "time: mean"
                            },
                            "rsdscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": " Surface Downwelling Clear-Sky Shortwave Radiation ",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdscs",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air_assuming_clear_sky",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "swgdnclr",
                                "cell_methods": "time: mean"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsds",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "swgdn",
                                "cell_methods": "time: mean"
                            },
                            "rlutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlutcs",
                                "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "lwtupclr",
                                "cell_methods": "time: mean"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Longwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlut",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "comment": "at the top of the atmosphere (to be compared with satellite measurements)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "lwtup",
                                "cell_methods": "time: mean"
                            },
                            "rlus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlus",
                                "standard_name": "surface_upwelling_longwave_flux_in_air",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "lwgem",
                                "cell_methods": "time: mean"
                            },
                            "rldscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rldscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rldscs",
                                "standard_name": "surface_downwelling_longwave_flux_in_air_assuming_clear_sky",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "lwgabclr",
                                "cell_methods": "time: mean"
                            },
                            "rlds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlds",
                                "standard_name": "surface_downwelling_longwave_flux_in_air",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "lwgab",
                                "cell_methods": "time: mean"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_units": "Pa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "comment": "not, in general, the same as surface pressure",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "slp",
                                "cell_methods": "time: mean"
                            },
                            "prsn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prsn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "original_units": "kg m-2 s-1",
                                "long_name": "Snowfall Flux",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prsn",
                                "standard_name": "snowfall_flux",
                                "units": "kg m-2 s-1",
                                "comment": "at surface; includes precipitation of all forms of water in the solid phase",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "precsno",
                                "cell_methods": "time: mean"
                            },
                            "prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation",
                                "units": "kg m-2 s-1",
                                "original_units": "kg m-2 s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prc",
                                "standard_name": "convective_precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases.",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "preccon",
                                "cell_methods": "time: mean"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_units": "kg m-2 s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "prectot",
                                "cell_methods": "time: mean"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "QV",
                                "cell_methods": "time: mean"
                            },
                            "hfss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Sensible Heat Flux",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfss",
                                "standard_name": "surface_upward_sensible_heat_flux",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "hflux",
                                "cell_methods": "time: mean"
                            },
                            "hfls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Latent Heat Flux",
                                "units": "W m-2",
                                "original_units": "W m-2",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfls",
                                "standard_name": "surface_upward_latent_heat_flux",
                                "comment": "includes both evaporation and sublimation",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "eflux",
                                "cell_methods": "time: mean"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_units": "kg m-2 s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "evap",
                                "cell_methods": "time: mean"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "original_units": "%",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-reanalysis_r0i0p0.nc",
                                "original_name": "cldtot",
                                "cell_methods": "time: mean"
                            },
                            "cl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud Area Fraction",
                                "missing_value": "1.00000002E20",
                                "dodsname": "cl",
                                "standard_name": "cloud_area_fraction_in_atmosphere_layer",
                                "units": "percent",
                                "comment": "Includes both large-scale and convective cloud.",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "CLOUD",
                                "cell_methods": "time: mean"
                            }
                        }
                    },
                    "day": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "comments": "This daily precipitation is prepared by creating a daily mean of the source 6hr precipitation.",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "prectot",
                                "cell_methods": "time: mean"
                            }
                        }
                    },
                    "hr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "6hr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "standard_name": "geopotential_height",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "H",
                                "cell_methods": "time: mean"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "standard_name": "northward_wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "coordinates": "height",
                                "cell_methods": "time: mean",
                                "original_name": "V10M"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "va",
                                "standard_name": "northward_wind",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "V",
                                "cell_methods": "time: mean"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "standard_name": "eastward_wind",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "coordinates": "height",
                                "cell_methods": "time: mean",
                                "original_name": "U10M"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_units": "m s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ua",
                                "standard_name": "eastward_wind",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "U",
                                "cell_methods": "time: mean"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "standard_name": "surface_temperature",
                                "comment": " temperature (i.e., SST for open ocean)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "TS",
                                "cell_methods": "time: mean"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "comments": "Units changed from mg kg**-1 to ppmv",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "standard_name": "mole_fraction_of_ozone_in_air",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "O3",
                                "cell_methods": "time: mean"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella",
                                "coordinates": "height",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "T2M",
                                "cell_methods": "time: mean"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_units": "K",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "standard_name": "air_temperature",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "T",
                                "cell_methods": "time: mean"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_units": "Pa",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "standard_name": "air_pressure_at_sea_level",
                                "comment": "not, in general, the same as surface pressure",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "SLP",
                                "cell_methods": "time: mean"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "PRECTOT",
                                "cell_methods": "time: mean"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "standard_name": "specific_humidity",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "QV",
                                "cell_methods": "time: mean"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "EVAP",
                                "cell_methods": "time: mean"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "standard_name": "cloud_area_fraction",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud.",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA_r0i0p0.nc",
                                "original_name": "CLDTOT",
                                "cell_methods": "time: mean"
                            }
                        }
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "axis": "Z",
                        "standard_name": "air_pressure",
                        "uniquename": "plev",
                        "positive": "down"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "axis": "T",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/MERRA"
                },
                "MERRA2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MERRA2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "dayatmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "hratmoshomepage": "https://cds-cv.nccs.nasa.gov/CREATE-V/",
                        "Conventions": "IRIDL"
                    },
                    "mon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "original_name": "H",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "original_units": "m",
                                "cell_measures": "area: areacella",
                                "comments": "Note that the MERRA-2 variable zg/geopotential height, monthly mean, 3D, 42 pressure levels, for the time range 198001 to 201412, has changed as of September 18, 2018. In the previous version of these files the pressure-level data are extrapolated to mean sea-level (the topology below the mean sea level is filled/masked). The MERRA-2 source data for these files has changed and is no longer filled. The CREATE team has reprocessed this data to be consistent with the available source, so the files we now publish for the MERRA-2 variable H/geopotential height, monthly mean, 3D, 42 pressure levels, for the time range 198001 to 201412, are no longer filled/masked. The 3-hourly and 6-hourly MERRA-2 geopotential height source data was not masked and is not changed.",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "geopotential_height"
                            },
                            "wap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Omega (=dp/dt)",
                                "units": "Pa s-1",
                                "original_name": "OMEGA",
                                "missing_value": "1.00000002E20",
                                "dodsname": "wap",
                                "original_units": "Pa s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "cell_methods": "time: mean",
                                "comment": ", this represents the vertical component of velocity in pressure coordinates (positive down)"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "V10M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind",
                                "coordinates": "height"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_name": "V",
                                "missing_value": "1.00000002E20",
                                "dodsname": "va",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "U10M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind",
                                "coordinates": "height"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_name": "U",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ua",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "original_name": "TS",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "original_units": "K",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "surface_temperature",
                                "cell_methods": "time: mean",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "original_name": "O3",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "cell_measures": "area: areacella",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "mole_fraction_of_ozone_in_air"
                            },
                            "tauv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Northward Wind Stress",
                                "units": "Pa",
                                "cell_methods": "time: mean",
                                "original_units": "Pa",
                                "standard_name": "surface_downward_northward_stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "original_name": "TAUY"
                            },
                            "tauu": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauu",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downward Eastward Wind Stress",
                                "units": "Pa",
                                "cell_methods": "time: mean",
                                "original_units": "Pa",
                                "standard_name": "surface_downward_eastward_stress",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tauu",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "original_name": "TAUX"
                            },
                            "tasmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Minimum Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "T2MMIN",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmin",
                                "original_units": "K",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: minimum within days time: mean over days",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "comment": "monthly mean of the daily-minimum near-surface air temperature."
                            },
                            "tasmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Maximum Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "T2MMAX",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tasmax",
                                "original_units": "K",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: maximum within days time: mean over days",
                                "standard_name": "air_temperature",
                                "coordinates": "height",
                                "comment": "monthly mean of the daily-maximum near-surface air temperature."
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "T2M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "original_units": "K",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature",
                                "coordinates": "height"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_name": "T",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature"
                            },
                            "rsutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWTDN-SWTNTCLR",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsutcs",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "toa_outgoing_shortwave_flux_assuming_clear_sky"
                            },
                            "rsut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing  Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWTDN-SWTNT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsut",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "toa_outgoing_shortwave_flux",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsuscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsuscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Clear-Sky Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWGDNCLR-SWGNTCLR",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsuscs",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air_assuming_clear_sky"
                            },
                            "rsus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWGDN-SWGNT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsus",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_upwelling_shortwave_flux_in_air"
                            },
                            "rsdt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Incident Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWTDN",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdt",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "toa_incoming_shortwave_flux",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere"
                            },
                            "rsdscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsdscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": " Surface Downwelling Clear-Sky Shortwave Radiation ",
                                "units": "W m-2",
                                "original_name": "SWGDNCLR",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsdscs",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air_assuming_clear_sky"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Shortwave Radiation",
                                "units": "W m-2",
                                "original_name": "SWGDN",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rsds",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_downwelling_shortwave_flux_in_air"
                            },
                            "rlutcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlutcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "LWTUPCLR",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlutcs",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "toa_outgoing_longwave_flux_assuming_clear_sky"
                            },
                            "rlut": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlut",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "TOA Outgoing Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "LWTUP",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlut",
                                "original_units": "W m-2 ",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "toa_outgoing_longwave_flux",
                                "cell_methods": "time: mean",
                                "comment": "at the top of the atmosphere (to be compared with satellite measurements)"
                            },
                            "rlus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "LWGEM",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlus",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_upwelling_longwave_flux_in_air"
                            },
                            "rldscs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rldscs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Clear-Sky Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "LWGABCLR",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rldscs",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_downwelling_longwave_flux_in_air_assuming_clear_sky"
                            },
                            "rlds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Downwelling Longwave Radiation",
                                "units": "W m-2",
                                "original_name": "LWGAB",
                                "missing_value": "1.00000002E20",
                                "dodsname": "rlds",
                                "original_units": "W m-2",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_downwelling_longwave_flux_in_air"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_name": "SLP",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_pressure_at_sea_level",
                                "comment": "not, in general, the same as surface pressure"
                            },
                            "prsn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prsn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snowfall Flux",
                                "original_name": "PRECSNO",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prsn",
                                "original_units": "kg m-2 s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "snowfall_flux",
                                "cell_methods": "time: mean",
                                "units": "kg m-2 s-1",
                                "comment": "at surface; includes precipitation of all forms of water in the solid phase"
                            },
                            "prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "PRECCON",
                                "missing_value": "1.00000002E20",
                                "dodsname": "prc",
                                "original_units": "kg m-2 s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "convective_precipitation_flux",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases."
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "PRECTOT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "original_units": "kg m-2 s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "precipitation_flux",
                                "cell_methods": "time: mean",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            },
                            "huss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "huss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Specific Humidity",
                                "units": "kg/kg",
                                "original_name": "QV2M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "huss",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "specific_humidity",
                                "coordinates": "height"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "original_name": "QV",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "specific_humidity"
                            },
                            "hfss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Sensible Heat Flux",
                                "units": "W m-2",
                                "original_name": "HFLUX",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfss",
                                "original_units": "W m-2 ",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_upward_sensible_heat_flux"
                            },
                            "hfls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Upward Latent Heat Flux",
                                "units": "W m-2",
                                "original_name": "EFLUX",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hfls",
                                "original_units": "W m-2 ",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "surface_upward_latent_heat_flux",
                                "cell_methods": "time: mean",
                                "comment": "includes both evaporation and sublimation"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_name": "EVAP",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "original_units": "kg m-2 s-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "water_evaporation_flux",
                                "cell_methods": "time: mean",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "units": "%",
                                "original_name": "CLDTOT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "original_units": "%",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA2_r0i0p0.nc",
                                "standard_name": "cloud_area_fraction",
                                "cell_methods": "time: mean",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud."
                            },
                            "cl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud Area Fraction",
                                "original_name": "CLOUD",
                                "missing_value": "1.00000002E20",
                                "dodsname": "cl",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "cloud_area_fraction_in_atmosphere_layer",
                                "units": "percent",
                                "comment": "Includes both large-scale and convective cloud."
                            }
                        }
                    },
                    "day": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Geopotential Height",
                                "original_name": "H",
                                "dodsname": "zg",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "geopotential_height"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Northward Near-Surface Wind",
                                "original_name": "V10M",
                                "dodsname": "vas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind",
                                "coordinates": "height"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Northward Wind",
                                "original_name": "V",
                                "dodsname": "va",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Eastward Near-Surface Wind",
                                "original_name": "U10M",
                                "dodsname": "uas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind",
                                "coordinates": "height"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Eastward Wind",
                                "original_name": "U",
                                "dodsname": "ua",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Surface Temperature",
                                "original_name": "TS",
                                "dodsname": "ts",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_temperature",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ppmv",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Mole Fraction of O3",
                                "original_name": "O3",
                                "dodsname": "tro3",
                                "cell_measures": "area: areacella",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "mole_fraction_of_ozone_in_air"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Near-Surface Air Temperature",
                                "original_name": "T2M",
                                "dodsname": "tas",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature",
                                "coordinates": "height"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Air Temperature",
                                "original_name": "T",
                                "dodsname": "ta",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Sea Level Pressure",
                                "original_name": "SLP",
                                "dodsname": "psl",
                                "original_units": "Pa",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "standard_name": "air_pressure_at_sea_level",
                                "cell_methods": "time: mean",
                                "comment": "not, in general, the same as surface pressure"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg m-2 s-1",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Precipitation",
                                "original_name": "PRECTOT",
                                "dodsname": "pr",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Specific Humidity",
                                "original_name": "QV",
                                "dodsname": "hus",
                                "original_units": "kg kg-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "specific_humidity"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg m-2 s-1",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Evaporation",
                                "original_name": "EVAP",
                                "dodsname": "evspsbl",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 0.0% dropped",
                                "file_missing_value": "1.00000002E20",
                                "long_name": "Total Cloud Fraction",
                                "original_name": "CLDTOT",
                                "dodsname": "clt",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "cloud_area_fraction",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud."
                            }
                        }
                    },
                    "hr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "6hr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "atmos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "atmos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential Height",
                                "units": "m",
                                "original_name": "H",
                                "missing_value": "1.00000002E20",
                                "dodsname": "zg",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "geopotential_height"
                            },
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "V10M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "vas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind",
                                "coordinates": "height"
                            },
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Northward Wind",
                                "units": "m s-1",
                                "original_name": "V",
                                "missing_value": "1.00000002E20",
                                "dodsname": "va",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "northward_wind"
                            },
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Near-Surface Wind",
                                "units": "m s-1",
                                "original_name": "U10M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "uas",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind",
                                "coordinates": "height"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Eastward Wind",
                                "units": "m s-1",
                                "original_name": "U",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ua",
                                "original_units": "m s-1",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "eastward_wind"
                            },
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Temperature",
                                "units": "K",
                                "original_name": "TS",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ts",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "surface_temperature",
                                "comment": " temperature (i.e., SST for open ocean)"
                            },
                            "tro3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tro3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mole Fraction of O3",
                                "units": "ppmv",
                                "original_name": "O3",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tro3",
                                "cell_measures": "area: areacella",
                                "comments": "Units changed from kg kg**-1 to ppmv",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "mole_fraction_of_ozone_in_air"
                            },
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near-Surface Air Temperature",
                                "units": "K",
                                "original_name": "T2M",
                                "missing_value": "1.00000002E20",
                                "dodsname": "tas",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature",
                                "coordinates": "height"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "units": "K",
                                "original_name": "T",
                                "missing_value": "1.00000002E20",
                                "dodsname": "ta",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "air_temperature"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Level Pressure",
                                "units": "Pa",
                                "original_name": "SLP",
                                "missing_value": "1.00000002E20",
                                "dodsname": "psl",
                                "original_units": "Pa",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "standard_name": "air_pressure_at_sea_level",
                                "cell_methods": "time: mean",
                                "comment": "not, in general, the same as surface pressure"
                            },
                            "pr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation",
                                "units": "kg m-2 s-1",
                                "original_name": "PRECTOT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "pr",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "precipitation_flux",
                                "comment": "at surface; includes both liquid and solid phases from all types of clouds (both large-scale and convective)"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific Humidity",
                                "units": "kg kg-1",
                                "original_name": "QV",
                                "missing_value": "1.00000002E20",
                                "dodsname": "hus",
                                "original_units": "kg kg-1",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "specific_humidity"
                            },
                            "evspsbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evspsbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation",
                                "units": "kg m-2 s-1",
                                "original_name": "EVAP",
                                "missing_value": "1.00000002E20",
                                "dodsname": "evspsbl",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "water_evaporation_flux",
                                "comment": "at surface; flux of water into the atmosphere due to conversion of both liquid and solid phases to vapor (from underlying surface and vegetation)"
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Fraction",
                                "original_name": "CLDTOT",
                                "missing_value": "1.00000002E20",
                                "dodsname": "clt",
                                "cell_measures": "area: areacella",
                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_GEOS-5_MERRA-2_r0i0p0.nc areacella: areacella_fx_GEOS-5_MERRA-2_r0i0p0.nc",
                                "cell_methods": "time: mean",
                                "standard_name": "cloud_area_fraction",
                                "units": "percent",
                                "comment": "for the whole atmospheric column, as seen from the surface or the top of the atmosphere. Include both large-scale and convective cloud."
                            }
                        }
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1980-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "360"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1900-1-1",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1",
                        "standard_name": "time"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1900-1-1",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1",
                        "standard_name": "time"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian",
                        "axis": "T"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "Pa",
                        "standard_name": "air_pressure",
                        "uniquename": "plev",
                        "positive": "down",
                        "axis": "Z"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "axis": "Y",
                        "units": "degree_north",
                        "bounds": "lat_bnds",
                        "uniquename": "lat"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "axis": "X",
                        "units": "degree_east",
                        "bounds": "lon_bnds",
                        "uniquename": "lon"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridtype": "0",
                        "units": "days since 1900-1-1",
                        "bounds": "time_bnds",
                        "standard_name": "time",
                        "uniquename": "time",
                        "calendar": "gregorian",
                        "axis": "T"
                    },
                    "dir": "SOURCES/NASA/NCCS_Dataserver/CREATE_REANALYSIS/MERRA2"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CRv2c",
                    "CFSR",
                    "ECMWF",
                    "ECMWFIFSCy41r2",
                    "JMA",
                    "MERRA",
                    "MERRA2"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CREATE_REANALYSIS"
            ]
        },
        "PODAAC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PO-DAAC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "oceancolorSeaWiFSmonthlydataset_documentation": "http://podaac.jpl.nasa.gov/dataset/SeaWiFS_L3_CHLA_Monthly_9km_R?ids=Measurement&values=Ocean%20Optics",
                "oceancolorSeaWiFSdailydataset_documentation": "http://podaac.jpl.nasa.gov/dataset/SeaWiFS_L3_CHLA_Daily_9km_R?ids=Measurement&values=Ocean%20Optics",
                "oceancolorSeaWiFSreferences": "OReilly_etal2000",
                "oceancolorMODISmonthlydataset_documentation": "http://podaac.jpl.nasa.gov/dataset/MODIS_Aqua_L3_CHLA_Monthly_4km_R",
                "oceancolorMODISreferences": "Bryan_etal2005",
                "Conventions": "IRIDL"
            },
            "oceancolor": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "oceancolor",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SeaWiFS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SeaWiFS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "l3m_data": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "l3m_data",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:DissolvedConcentration",
                            "long_name": "chlorophyll a",
                            "units": "mg/m3",
                            "missing_value": "-32767.0"
                        }
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "l3m_data": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "l3m_data",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:DissolvedConcentration",
                            "long_name": "chlorophyll a",
                            "units": "mg/m3",
                            "missing_value": "-32767.0",
                            "pointwidth": "1.0"
                        }
                    }
                },
                "MODIS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MODIS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "l3m_data": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "l3m_data",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:DissolvedConcentration",
                            "long_name": "chlorophyll a",
                            "units": "mg/m3",
                            "missing_value": "-32767.0"
                        }
                    }
                }
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1997-01-01 00:00:00",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NASA/PO-DAAC"
        },
        "indextex": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NASA/index.tex",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "index.tex",
            "restriction": "Public",
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "msu": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "msu",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Microwave Sounding Unit",
                "references": "Spencer_Christy1990 Spencer_etal1990 Spencer_Christy1993",
                "description": "Gridded oceanic rainfall data from the Microwave Sounding Unit",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NASA/.msu/.dataset_documentation.html",
                "Conventions": "IRIDL"
            },
            "precipitation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "precipitation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-99.900002",
                "units": "mm",
                "long_name": "precipitation"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NASA/msu"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "ARC",
            "ASDCDAAC",
            "AVHRRLST",
            "ERBE",
            "GESDAAC",
            "GES_DISC",
            "GISS",
            "GPCP",
            "GSFC",
            "IDS",
            "ISCCP",
            "ISLSCP",
            "JPL",
            "NCCS_Dataserver",
            "PODAAC",
            "indextex",
            "msu"
        ]
    },
    "NCAR": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "NCAR",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CGDCAStn430ncepdescription": "NCEP Reanalysis Tapered T42 Products",
            "CGDCAStn430ncepdataset_documentationhtml": "http://www.cgd.ucar.edu/cas/catalog/tn430/ncep/t42f/",
            "CGDCAStn430ncepNEWBUDGETS": "http://iridl.ldeo.columbia.edu/SOURCES/.NCAR/.CGD/.CAS/.NEWBUDGETS/",
            "CGDCAStn430era15t42fMONTHLYCMClong_name": "compl. mass corr.",
            "CGDCAStn430era15t42fCLIMATOLOGYc7993CMClong_name": "compl. mass corr.",
            "CGDCAStn430era15t42fdataset_documentationhtml": "http://www.cgd.ucar.edu/cas/catalog/tn430/era15/t42f/",
            "CGDCAStn430era15description": "ECMWF 15-Year Reanalysis Tapered T42 Products",
            "CGDCAStn430description": "Atmospheric Mass, Moisture, and Energy Budget Products",
            "CGDCAStn430dataset_documentationhtml": "http://www.cgd.ucar.edu/cas/catalog/tn430/",
            "CGDCASNEWBUDGETSreferences": "Kalnay_etal1996",
            "CGDCASNEWBUDGETSdescription": "Vertically integrated mass, moisture, heat, and energy budget products derived from the NCEP/NCAR Reanalysis",
            "CGDCASNEWBUDGETSdataset_documentationhtml": "http://www.cgd.ucar.edu/cas/catalog/newbudgets/",
            "CGDCASIndicesPDSI2004references": "Dai_etal2004",
            "CGDCASIndicesPDSI2004description": "Palmer Drought Severity Index (2004) from the National Center for Atmospheric Research",
            "CGDCASIndicesPDSI2004source": "http://www.cgd.ucar.edu/cas/catalog/climind/pdsi.html",
            "CGDCASIndicesPDSI2004dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NCAR/.CGD.CAS.Indices.PDSI2004.dataset_documentation.html",
            "CGDCASIndicesreferences": "Heddinghaus_Sabol1991 Guttman1991",
            "CGDCASIndicesdescription": "Palmer Drought Severity Index from the National Center for Atmospheric Research",
            "CGDCASDai_Chendescription": "Dai and Chen combined global precipitation data set",
            "CGDCASlong_name": "Climate Analysis Section",
            "CGDlong_name": "Climate and Global Dynamics",
            "CCSM4BiasAdjustedHindcastshistory": "Bias correction has been done following International CLIVAR Project Office (2011).The observataion data is NCEP/NCAR Reanalysis from http://www.esrl.noaa.gov/",
            "CCSM4references": "Gent_etal_2011 Large_Yeager_2009",
            "CCSM4dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NCAR/.CCSM4.dataset_documentation.html",
            "description": "National Center for Atmospheric Research",
            "iridlhasSemantics": "iridl:NCAR",
            "Conventions": "IRIDL"
        },
        "CGD": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CGD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CAS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CAS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tn430": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tn430",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ncep": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ncep",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "era15": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "era15",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "t42f": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t42f",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "(kg K)/(m s)",
                                    "long_name": "Heat Flux: Meridional Component [V*T]"
                                },
                                "VQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/(m s)",
                                    "long_name": "Moisture Flux: Meridional Component [V*Q]"
                                },
                                "VK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/(m s)",
                                    "long_name": "Kinetic Energy Flux: Meridional Component [V*KE]"
                                },
                                "UT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "(kg K)/(m s)",
                                    "long_name": "Heat Flux: Zonal Component [U*T]"
                                },
                                "UQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/(m s)",
                                    "long_name": "Moisture Flux: Zonal Component [U*Q]"
                                },
                                "UK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/(m s)",
                                    "long_name": "Kinetic Energy Flux: Zonal Component [U*KE]"
                                },
                                "TETEN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TETEN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Total Energy Tendency"
                                },
                                "TE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg",
                                    "long_name": "Total Energy: Vertically AVERAGED [CpT+Lq+gZ+k]"
                                },
                                "RAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net Downward Radiation, Top of Atmosphere"
                                },
                                "QTEN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QTEN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/(m^2 s)",
                                    "long_name": "Precipitable Water Tendency"
                                },
                                "Q1QF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q1QF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Diabatic Heating minus Frictional Heating"
                                },
                                "PW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m^2",
                                    "long_name": "Precipitable Water"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Surface Pressure"
                                },
                                "MRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Mass Residual"
                                },
                                "KE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "KE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/(m^2)",
                                    "long_name": "Kinetic Energy [(U^2+V^2)/2]"
                                },
                                "FS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net Upward Heat Flux, Surface"
                                },
                                "EP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "Evaporation minus Precipitation (E-P)"
                                },
                                "CMC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CMC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TEDIV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TEDIV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Total Energy Divergence"
                                    },
                                    "LEDIV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LEDIV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Latent Heat Divergence"
                                    },
                                    "DSEDIV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "DSEDIV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Dry Static Energy Divergence"
                                    }
                                }
                            },
                            "CLIMATOLOGY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CLIMATOLOGY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "c7993": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "c7993",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "VT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "(kg K)/(m s)",
                                        "long_name": "Heat Flux: Meridional Component [V*T]"
                                    },
                                    "VQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/(m s)",
                                        "long_name": "Moisture Flux: Meridional Component [V*Q]"
                                    },
                                    "VK": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VK",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/(m s)",
                                        "long_name": "Kinetic Energy Flux: Meridional Component [V*KE]"
                                    },
                                    "UT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "UT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "(kg K)/(m s)",
                                        "long_name": "Heat Flux: Zonal Component [U*T]"
                                    },
                                    "UQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "UQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/(m s)",
                                        "long_name": "Moisture Flux: Zonal Component [U*Q]"
                                    },
                                    "UK": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "UK",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/(m s)",
                                        "long_name": "Kinetic Energy Flux: Zonal Component [U*KE]"
                                    },
                                    "TETEN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TETEN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Total Energy Tendency"
                                    },
                                    "TE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg",
                                        "long_name": "Total Energy: Vertically AVERAGED [CpT+Lq+gZ+k]"
                                    },
                                    "RAD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RAD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Net Downward Radiation, Top of Atmosphere"
                                    },
                                    "QTEN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QTEN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/(m^2 s)",
                                        "long_name": "Precipitable Water Tendency"
                                    },
                                    "Q1QF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q1QF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Diabatic Heating minus Frictional Heating"
                                    },
                                    "PW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/m^2",
                                        "long_name": "Precipitable Water"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "long_name": "Surface Pressure"
                                    },
                                    "MRES": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MRES",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa/s",
                                        "long_name": "Mass Residual"
                                    },
                                    "KE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "KE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/(m^2)",
                                        "long_name": "Kinetic Energy [(U^2+V^2)/2]"
                                    },
                                    "FS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Net Upward Heat Flux, Surface"
                                    },
                                    "EP": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EP",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "long_name": "Evaporation minus Precipitation (E-P)"
                                    },
                                    "CMC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CMC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TEDIV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEDIV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "long_name": "Total Energy Divergence"
                                        },
                                        "LEDIV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LEDIV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "long_name": "Latent Heat Divergence"
                                        },
                                        "DSEDIV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSEDIV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "long_name": "Dry Static Energy Divergence"
                                        }
                                    }
                                }
                            }
                        }
                    }
                },
                "NEWBUDGETS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NEWBUDGETS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "t42f": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t42f",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Geopotential Height",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "Z",
                                "units": "kg/m"
                            },
                            "VZ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VZ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Meridional Geop. Height Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "VZ",
                                "units": "kg/s"
                            },
                            "VT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Meridional Heat Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "VT",
                                "units": "(kg K)/(m s)"
                            },
                            "VQ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VQ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Meridional Moisture Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "VQ",
                                "units": "kg/(m s)"
                            },
                            "VK": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VK",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Meridional Kinetic Energy Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "VK",
                                "units": "J/(m s)"
                            },
                            "VC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Barotropic Correction to Meridional Velocity",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "VC",
                                "units": "m/s"
                            },
                            "V": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Meridional Velocity",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "V",
                                "units": "kg/(m s)"
                            },
                            "UZ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UZ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Zonal Geop. Height Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "UZ",
                                "units": "kg/s"
                            },
                            "UT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Zonal Heat Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "UT",
                                "units": "(kg K)/(m s)"
                            },
                            "UQ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UQ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Zonal Moisture Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "UQ",
                                "units": "kg/(m s)"
                            },
                            "UK": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UK",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Zonal Kinetic Energy Transport",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "UK",
                                "units": "J/(m s)"
                            },
                            "UC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Barotropic Correction to Zonal Velocity",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "UC",
                                "units": "m/s"
                            },
                            "U": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "U",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Zonal Velocity",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "U",
                                "units": "kg/(m s)"
                            },
                            "TETEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TETEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Total Energy Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "TETEN",
                                "units": "W/m2"
                            },
                            "TEDIV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TEDIV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Energy Divergence",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "TEDIV",
                                "units": "W/m2"
                            },
                            "TE": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TE",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Averaged Total Energy",
                                "level": "vertical average",
                                "missing_value": "9.99999962E35",
                                "short_name": "TE",
                                "units": "J/kg"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Temperature",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "T",
                                "units": "kg K/(m^2)"
                            },
                            "QTEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "QTEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable Water Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "QTEN",
                                "units": "kg/(m^2 s)"
                            },
                            "Q1QF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Q1QF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Diabatic Heating minus Frictional Heating",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "Q1QF",
                                "units": "W/m2"
                            },
                            "PW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable Water",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "PW",
                                "units": "kg/m^2"
                            },
                            "PSTEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PSTEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Pressure Tendency",
                                "level": "surface",
                                "missing_value": "9.99999962E35",
                                "short_name": "PSTEN",
                                "units": "Pa/s"
                            },
                            "PS": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PS",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Pressure",
                                "level": "surface",
                                "missing_value": "9.99999962E35",
                                "short_name": "PS",
                                "units": "Pa"
                            },
                            "PHISTEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PHISTEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Surface Geopotential Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "PHISTEN",
                                "units": "W/m2"
                            },
                            "OLR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OLR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Outgoing Longwave Radiation",
                                "level": "TOA (Top of atmosphere)",
                                "sign_convention": ">0 upward through the TOA",
                                "missing_value": "9.99999962E35",
                                "short_name": "OLR"
                            },
                            "NET": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NET",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Net Radiation (ASR-OLR)",
                                "level": "TOA (Top of atmosphere)",
                                "sign_convention": ">0 downward through the TOA",
                                "missing_value": "9.99999962E35",
                                "short_name": "NET"
                            },
                            "MRES": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MRES",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mass Budget Residual",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "MRES",
                                "units": "Pa/s"
                            },
                            "LETEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "LETEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Latent Energy Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "LETEN",
                                "units": "W/m2"
                            },
                            "LEDIV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "LEDIV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Latent Energy Divergence",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "LEDIV",
                                "units": "W/m2"
                            },
                            "KTEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "KTEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Kinetic Energy Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "KTEN",
                                "units": "W/m2"
                            },
                            "KEDIV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "KEDIV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Kinetic Energy Divergence",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "KEDIV",
                                "units": "W/m2"
                            },
                            "KE": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "KE",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Kinetic Energy",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "KE",
                                "units": "J/(m^2)"
                            },
                            "ITEN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ITEN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertically Integrated Internal Energy Tendency",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "ITEN",
                                "units": "W/m2"
                            },
                            "FS": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FS",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Net upward flux through surface",
                                "level": "surface",
                                "sign_convention": ">0 upward through surface into atmosphere",
                                "missing_value": "9.99999962E35",
                                "short_name": "FS"
                            },
                            "EP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "EP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Evaporation minus Precipitation (E - P)",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "EP",
                                "units": "mm/day"
                            },
                            "DSEDIV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DSEDIV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Dry Static Energy Divergence",
                                "level": "vertical integral",
                                "missing_value": "9.99999962E35",
                                "short_name": "DSEDIV",
                                "units": "W/m2"
                            },
                            "ASR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ASR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "TOA Absorbed Solar Radiation",
                                "level": "TOA (Top of atmosphere)",
                                "sign_convention": ">0 downward through the TOA",
                                "missing_value": "9.99999962E35",
                                "short_name": "ASR"
                            }
                        },
                        "ELEVATION": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ELEVATION",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "meters",
                            "long_name": "Ocean Depth and Land Elevation",
                            "missing_value": "9.99999962E35",
                            "short_name": "ELEVATION"
                        }
                    }
                },
                "Indices": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Indices",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PDSI2004": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PDSI2004",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zindex": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zindex",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Z-Index",
                            "missing_value": "-99999.0"
                        },
                        "PDSIdT0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PDSIdT0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "scale_max": "15.0",
                            "scale_min": "-15.0",
                            "missing_value": "-99999.0"
                        },
                        "PDSI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PDSI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Palmer Drought Severity Index",
                            "scale_max": "15.0",
                            "missing_value": "-99999.0",
                            "scale_min": "-15.0"
                        }
                    },
                    "PDSI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PDSI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Palmer Drought Severity Index",
                        "missing_value": "-99999.0"
                    }
                },
                "Dai_Chen": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Dai_Chen",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "long_name": "monthly mean precipitation rate",
                        "missing_value": "-99999.0",
                        "lonFlip": "longitude coordinate variable has been reordered via lonFlip"
                    }
                }
            }
        },
        "CCSM4": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CCSM4",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RawHindcasts": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RawHindcasts",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tas": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tas",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Reference height temperature",
                    "units": "Kelvin_scale",
                    "Fill_value": "1.00000002E20",
                    "missing_value": "1.00000002E20",
                    "cell_methods": "time: mean"
                },
                "slp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "sea level pressure",
                    "Fill_value": "1.00000002E20",
                    "units": "hPa",
                    "cell_methods": "time: mean",
                    "missing_value": "1.00000002E20"
                },
                "pr": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pr",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "precipitation",
                    "units": "mm/day",
                    "Fill_value": "1.00000002E20",
                    "missing_value": "1.00000002E20"
                }
            },
            "BiasAdjustedHindcasts": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "BiasAdjustedHindcasts",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tas": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tas",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Reference height temperature",
                    "units": "Kelvin_scale",
                    "Fill_value": "1.00000002E20",
                    "missing_value": "1.00000002E20",
                    "cell_methods": "time: mean"
                },
                "slp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "sea level pressure",
                    "Fill_value": "1.00000002E20",
                    "units": "hPa",
                    "cell_methods": "time: mean",
                    "missing_value": "1.00000002E20"
                }
            }
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.8125",
            "standard_name": "longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "lat_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "short_name": "lat",
            "long_name": "latitude"
        },
        "lon_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.8125",
            "short_name": "lon",
            "long_name": "longitude",
            "modulus": "360.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.5",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.5",
            "standard_name": "longitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "lat_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "long_name": "latitude"
        },
        "lon_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "long_name": "longitude",
            "pointwidth": "2.5",
            "modulus": "360.0"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Member"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.25",
            "standard_name": "longitude"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.9424084",
            "standard_name": "latitude"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "calendar": "360",
            "standard_name": "forecast reference time"
        },
        "dir": "SOURCES/NCAR"
    },
    "NMC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "NMC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Sea level pressure data from the National Meteorological Center - now known as the National Centers for Environmental Prediction",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "slp": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "slp",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "long_name": "sea level pressure"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "10.0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/NMC"
    },
    "NMC9195": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "NMC9195",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Wind stress data from the National Meteorological Center - now known as the National Centers for Environmental Prediction",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.2309068",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.4814875",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.4690082",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/NMC9195"
    },
    "NOAA": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/NOAA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "NOAA",
        "restriction": "Public",
        "ERL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ERL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CDCGLOBALdailysource": "\\x06",
                "CDCGLOBALdailyreferences": "",
                "CDCGLOBALdailydescription": "\\x0b",
                "CDCGLOBALdailytitle": "\\x1b",
                "CDCGLOBALdailyConventions": "CF-1.2\\\\0\\x0b",
                "CDCGLOBALdailyNCO": "\\x03",
                "CDCGLOBALdailydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.ERL/.CDC.GLOBAL.daily.dataset_documentation.html",
                "CDCGLOBALdaily_NCProperties": "\\r",
                "CDCGLOBALdailyhistory": "]\\x01",
                "CDCGLOBALdailyReferences": ":",
                "CDCGLOBALdailyplatform": "\\x0b",
                "CDCGLOBALdailyCitation": "\\xab",
                "CDCGLOBALdailydataset_title": "\\r",
                "Conventions": "IRIDL"
            },
            "CDC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CDC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Dataset": "\\x07",
                            "units": "W/m2",
                            "level_desc": "",
                            "parent_stat": "\\x0e",
                            "precision": "2",
                            "statistic": "\\t",
                            "long_name": "Daily OLR\\\\0",
                            "var_desc": "\\x1b",
                            "missing_value": "-9.96920997E36"
                        },
                        "info": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "info",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Missing\\\\0",
                            "missing_value": "32766",
                            "valid_range": "10512"
                        }
                    }
                }
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "axis": "\\x04",
                "long_name": "Longitude\\\\0",
                "modulus": "360.0",
                "standard_name": "longitude\\\\0"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "axis": "\\x04",
                "long_name": "Latitude\\\\0",
                "standard_name": "latitude\\\\0"
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "hours since 1800-01-01 00:00:0.0",
                "gridtype": "0",
                "delta_t": "\\x07",
                "calendar": "standard",
                "long_name": "\\t",
                "pointwidth": "24.0",
                "axis": "\\x04",
                "standard_name": "\\r"
            },
            "nmiss": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nmiss",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/NOAA/ERL"
        },
        "ESRL": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NOAA/ESRL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ESRL",
            "restriction": "Public",
            "PSD": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NOAA/ESRL/PSD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "PSD",
                "restriction": "Public",
                "SA18": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/ESRL/PSD/SA18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "SA18",
                    "restriction": "requires dlauth tokens"
                },
                "SA23": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SA23",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5references": "Liebmann, B., and D. Allured, 2005: Daily precipitation grids for South America. Bull. Amer. Meteor. Soc., 86, 1567-1570.DOI: 10.1175/BAMS-86-11-1567",
                        "p0references": "Liebmann, B., and D. Allured, 2005: Daily precipitation grids for South America. Bull. Amer. Meteor. Soc., 86, 1567-1570.DOI: 10.1175/BAMS-86-11-1567",
                        "dataset_documentation": "http://www.esrl.noaa.gov/psd/people/brant.liebmann/south_america_precip.html",
                        "description": "South America",
                        "Conventions": "IRIDL"
                    },
                    "p5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "2p5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "255",
                            "scale_max": "256.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "256",
                            "colorscalename": "daily_precip_colors",
                            "long_name": "Daily precipitation",
                            "units": "mm",
                            "missing_value": "-999.0"
                        },
                        "count": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "count",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Station counts",
                            "units": "unitless",
                            "scale_min": "0",
                            "missing_value": "-99"
                        }
                    },
                    "p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "1p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "255",
                            "scale_max": "256.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "256",
                            "colorscalename": "daily_precip_colors",
                            "long_name": "Daily precipitation",
                            "units": "mm",
                            "missing_value": "-999.0"
                        },
                        "count": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "count",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Station counts",
                            "units": "unitless",
                            "scale_min": "0",
                            "missing_value": "-99"
                        }
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1800-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/ESRL/PSD/SA23"
                },
                "rean20thcent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rean20thcent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V2sixhourlytime_invariantversion": "2.0",
                        "V2sixhourlytime_invariantsource": "http://www.esrl.noaa.gov/psd/thredds/dodsC/Datasets/20thC_ReanV2/catalog.html",
                        "V2sixhourlytime_invariantdataset_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2sixhourlytime_invariantcitation": "Compo, G.P., J.S. Whitaker, and P.D. Sardeshmukh, 2006: Feasibility of a 100 year reanalysis using only surface pressure data. Bull. Amer. Met. Soc., 87, 175-190.",
                        "V2sixhourlytime_invariantreferences": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2sixhourlytime_invariantdescription": "Time-Invariant Data",
                        "V2sixhourlytime_invarianttitle": "4x Daily NOAA-CIRES 20th Century Reanalysis",
                        "V2sixhourlytime_invariantConventions": "CF-1.2",
                        "V2sixhourlytime_invariantinstitution": "NOAA ESRL/PSD",
                        "V2sixhourlytime_invariantplatform": "Model",
                        "V2sixhourlytime_invariantcomments": "Data is from NOAA-CIRES 20th Century Reanalysis version 2 (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                        "V2sixhourlytime_invarianthistory": "created 2009/09 by Hoop (netCDF3)",
                        "V2sixhourlypressure_sprdversion": "2.0",
                        "V2sixhourlypressure_sprdsource": "ftp://ftp.cdc.noaa.gov/Datasets/20thC_ReanV2/",
                        "V2sixhourlypressure_sprddataset_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2sixhourlypressure_sprdcitation": "Compo, G.P., J.S. Whitaker, and P.D. Sardeshmukh, 2006: Feasibility of a 100 year reanalysis using only surface pressure data. Bull. Amer. Met. Soc., 87, 175-190.",
                        "V2sixhourlypressure_sprdreferences": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2sixhourlypressure_sprddescription": "Ensemble Spread of Pressure Level Data",
                        "V2sixhourlypressure_sprdtitle": "4x Daily NOAA-CIRES 20th Century Reanalysis",
                        "V2sixhourlypressure_sprdConventions": "CF-1.2",
                        "V2sixhourlypressure_sprdinstitution": "NOAA ESRL/PSD",
                        "V2sixhourlypressure_sprdplatform": "Model",
                        "V2sixhourlypressure_sprdcomments": "Data is from NOAA-CIRES 20th Century Reanalysis version 2 (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                        "V2sixhourlypressure_sprdhistory": "created 2009/09 by Hoop (netCDF3)",
                        "V2sixhourlypressureversion": "2.0",
                        "V2sixhourlypressuresource": "ftp://ftp.cdc.noaa.gov/Datasets/20thC_ReanV2/",
                        "V2sixhourlypressuredataset_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2sixhourlypressurecitation": "Compo, G.P., J.S. Whitaker, and P.D. Sardeshmukh, 2006: Feasibility of a 100 year reanalysis using only surface pressure data. Bull. Amer. Met. Soc., 87, 175-190.",
                        "V2sixhourlypressurereferences": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2sixhourlypressuredescription": "Ensemble Mean Pressure Level Data",
                        "V2sixhourlypressuretitle": "4x Daily NOAA-CIRES 20th Century Reanalysis",
                        "V2sixhourlypressureConventions": "CF-1.2",
                        "V2sixhourlypressureinstitution": "NOAA ESRL/PSD",
                        "V2sixhourlypressureplatform": "Model",
                        "V2sixhourlypressurecomments": "Data is from NOAA-CIRES 20th Century Reanalysis version 2 (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                        "V2sixhourlypressurehistory": "created 2009/09 by Hoop (netCDF3)",
                        "V2sixhourlymonolevel_sprdtropolong_name": "Tropopause",
                        "V2sixhourlymonolevel_sprdsig995long_name": "Sigma Level 0.995",
                        "V2sixhourlymonolevel_sprdsfclong_name": "Surface",
                        "V2sixhourlymonolevel_sprdmsllong_name": "Mean Sea Level",
                        "V2sixhourlymonolevel_sprdeatmlong_name": "Entire Atmosphere",
                        "V2sixhourlymonolevel_sprdversion": "2.0",
                        "V2sixhourlymonolevel_sprdsource": "ftp://ftp.cdc.noaa.gov/Datasets/20thC_ReanV2/",
                        "V2sixhourlymonolevel_sprddataset_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2sixhourlymonolevel_sprdcitation": "Compo, G.P., J.S. Whitaker, and P.D. Sardeshmukh, 2006: Feasibility of a 100 year reanalysis using only surface pressure data. Bull. Amer. Met. Soc., 87, 175-190.",
                        "V2sixhourlymonolevel_sprdreferences": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2sixhourlymonolevel_sprddescription": "Ensemble Spread of Monolevel Data",
                        "V2sixhourlymonolevel_sprdtitle": "4x Daily NOAA-CIRES 20th Century Reanalysis",
                        "V2sixhourlymonolevel_sprdConventions": "CF-1.2",
                        "V2sixhourlymonolevel_sprdinstitution": "NOAA ESRL/PSD",
                        "V2sixhourlymonolevel_sprdplatform": "Model",
                        "V2sixhourlymonolevel_sprdcomments": "Data is from NOAA-CIRES 20th Century Reanalysis version 2 (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                        "V2sixhourlymonolevel_sprdhistory": "created 2009/09 by Hoop (netCDF3)",
                        "V2sixhourlymonoleveltropolong_name": "Tropopause",
                        "V2sixhourlymonolevelsig995long_name": "Sigma Level 0.995",
                        "V2sixhourlymonolevelsfclong_name": "Surface",
                        "V2sixhourlymonolevelmsllong_name": "Mean Sea Level",
                        "V2sixhourlymonoleveleatmlong_name": "Entire Atmosphere",
                        "V2sixhourlymonolevelversion": "2.0",
                        "V2sixhourlymonolevelsource": "ftp://ftp.cdc.noaa.gov/Datasets/20thC_ReanV2/",
                        "V2sixhourlymonoleveldataset_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2sixhourlymonolevelcitation": "Compo, G.P., J.S. Whitaker, and P.D. Sardeshmukh, 2006: Feasibility of a 100 year reanalysis using only surface pressure data. Bull. Amer. Met. Soc., 87, 175-190.",
                        "V2sixhourlymonolevelreferences": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2sixhourlymonoleveldescription": "Ensemble Mean Monolevel Data",
                        "V2sixhourlymonoleveltitle": "4x Daily NOAA-CIRES 20th Century Reanalysis",
                        "V2sixhourlymonolevelConventions": "CF-1.2",
                        "V2sixhourlymonolevelinstitution": "NOAA ESRL/PSD",
                        "V2sixhourlymonolevelplatform": "Model",
                        "V2sixhourlymonolevelcomments": "Data is from NOAA-CIRES 20th Century Reanalysis version 2 (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                        "V2sixhourlymonolevelhistory": "created 2009/09 by Hoop (netCDF3)",
                        "V2sixhourlydescription": "Six-hourly Data",
                        "V2ESRL": "http://www.esrl.noaa.gov/psd/data/gridded/data.20thC_ReanV2.html",
                        "V2references": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V2description": "NOAA-CIRES Twentieth Century Reanalysis, Version 2",
                        "V1monthlypressureleveldescription": "Pressure level data",
                        "V1monthlypressurelevel20th": "http://www.cdc.noaa.gov/data/gridded/data.20thC_Rean.html",
                        "V1monthlymonoleveldescription": "Data for a single level or integrated over the full depth of the atmosphere",
                        "V1monthlymonolevel20th": "http://www.cdc.noaa.gov/data/gridded/data.20thC_Rean.html",
                        "V1monthlydescription": "Monthly mean data",
                        "V1references": "Compo_etal2011 Compo_etal2006 Whitaker_etal2004",
                        "V1description": "NOAA-CIRES Twentieth Century Reanalysis, Version 1",
                        "V1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.ESRL/.PSD/.rean20thcent/.V1.dataset_documentation.html",
                        "V1ESRL": "http://www.cdc.noaa.gov/data/gridded/data.20thC_Rean.html",
                        "description": "NOAA-CIRES Twentieth Century Reanalysis",
                        "Conventions": "IRIDL"
                    },
                    "V2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sixhourly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "six-hourly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "time_invariant": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_invariant",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "geopotential_height",
                                    "statistic": "Ensemble Mean",
                                    "actual_range": "5685.3",
                                    "long_name": "Geopotential Height at Surface",
                                    "valid_range": "28734",
                                    "var_desc": "Geopotential height",
                                    "GRIB_name": "HGT",
                                    "GRIB_id": "7",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "60000.0",
                                    "precision": "0",
                                    "add_offset": "31266.0",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Surface",
                                    "units": "m"
                                }
                            },
                            "pressure_sprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure_sprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vwnd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vwnd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_range": "32765",
                                    "long_name": "6-hourly V-wind Spread on Pressure Levels",
                                    "actual_range": "51.56",
                                    "statistic": "Ensemble Spread",
                                    "standard_name": "grid_northward_wind",
                                    "var_desc": "v-wind",
                                    "GRIB_name": "VGRD",
                                    "GRIB_id": "132",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "655.31",
                                    "precision": "2",
                                    "scale_factor": "0.01",
                                    "add_offset": "327.66",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "units": "m/s",
                                    "pointwidth": "0"
                                },
                                "uwnd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uwnd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "statistic": "Ensemble Spread",
                                    "actual_range": "51.399",
                                    "long_name": "6-hourly U-wind Spread on Pressure Levels",
                                    "valid_range": "32765",
                                    "var_desc": "u-wind",
                                    "GRIB_name": "UGRD",
                                    "standard_name": "grid_eastward_wind",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "655.31",
                                    "precision": "2",
                                    "add_offset": "327.66",
                                    "scale_factor": "0.01",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "GRIB_id": "131",
                                    "pointwidth": "0"
                                },
                                "shum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "shum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "GRIB_name": "SPFH",
                                    "statistic": "Ensemble Spread",
                                    "long_name": "6-hourly Specific Humidity Spread on Pressure Levels",
                                    "valid_range": "32765",
                                    "var_desc": "Specific humidity",
                                    "standard_name": "specific_humidity",
                                    "GRIB_id": "133",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "0.065531",
                                    "scale_factor": "9.99999997E-07",
                                    "precision": "6",
                                    "add_offset": "0.032766",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "actual_range": "0.0058713",
                                    "pointwidth": "0"
                                },
                                "rhum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rhum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "statistic": "Ensemble Spread",
                                    "actual_range": "49.34",
                                    "units": "percent",
                                    "GRIB_name": "RH",
                                    "valid_range": "32765",
                                    "var_desc": "Relative Humidity",
                                    "standard_name": "relative_humidity",
                                    "GRIB_id": "52",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "65.531",
                                    "scale_factor": "0.001",
                                    "precision": "3",
                                    "add_offset": "32.765999",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "long_name": "6-hourly Relative Humidity Spread on Pressure Levels",
                                    "pointwidth": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "statistic": "Ensemble Spread",
                                    "units": "Pascal/s",
                                    "actual_range": "1.2228",
                                    "long_name": "6-hourly Omega Spread on Pressure Levels",
                                    "valid_range": "32765",
                                    "GRIB_id": "39",
                                    "GRIB_name": "VVEL",
                                    "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "6.5531",
                                    "scale_factor": "9.99999975E-05",
                                    "precision": "4",
                                    "add_offset": "3.2765999",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "var_desc": "Omega (dp/dt)",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "statistic": "Ensemble Spread",
                                    "units": "m",
                                    "actual_range": "1397.82",
                                    "GRIB_name": "HGT",
                                    "valid_range": "32765",
                                    "var_desc": "Geopotential height",
                                    "standard_name": "geopotential_height",
                                    "GRIB_id": "7",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "6553.1",
                                    "scale_factor": "0.1",
                                    "precision": "1",
                                    "add_offset": "3276.6001",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "long_name": "6-hourly Geopotential Heights Spread on Pressure Levels",
                                    "pointwidth": "0"
                                },
                                "air": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "air",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_range": "32765",
                                    "units": "Kelvin_scale",
                                    "actual_range": "39.419",
                                    "statistic": "Ensemble Spread",
                                    "GRIB_name": "TMP",
                                    "var_desc": "Air temperature",
                                    "GRIB_id": "11",
                                    "standard_name": "air_temperature",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "65.531",
                                    "scale_factor": "0.001",
                                    "precision": "3",
                                    "add_offset": "32.765999",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "long_name": "6-hourly Air Temperature Spread on Pressure Levels",
                                    "pointwidth": "0"
                                }
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vwnd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vwnd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "grid_northward_wind",
                                    "statistic": "Ensemble Mean",
                                    "actual_range": "79.4",
                                    "long_name": "6-hourly V-wind on Pressure Levels",
                                    "valid_range": "30234",
                                    "var_desc": "v-wind",
                                    "GRIB_id": "132",
                                    "GRIB_name": "VGRD",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "350.0",
                                    "scale_factor": "0.01",
                                    "precision": "2",
                                    "add_offset": "47.66",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "units": "m/s",
                                    "pointwidth": "0"
                                },
                                "uwnd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uwnd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "grid_eastward_wind",
                                    "statistic": "Ensemble Mean",
                                    "actual_range": "136.2",
                                    "long_name": "6-hourly U-wind on Pressure Levels",
                                    "valid_range": "30234",
                                    "var_desc": "u-wind",
                                    "GRIB_id": "131",
                                    "GRIB_name": "UGRD",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "350.0",
                                    "scale_factor": "0.01",
                                    "precision": "2",
                                    "add_offset": "47.66",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "units": "m/s",
                                    "pointwidth": "0"
                                },
                                "shum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "shum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GRIB_name": "SPFH",
                                    "units": "unitless",
                                    "statistic": "Ensemble Mean",
                                    "long_name": "6-hourly Specific Humidity on Pressure Levels",
                                    "valid_range": "32765",
                                    "var_desc": "Specific humidity",
                                    "standard_name": "specific_humidity",
                                    "GRIB_id": "133",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "0.065431",
                                    "add_offset": "0.032666",
                                    "precision": "6",
                                    "scale_factor": "9.99999997E-07",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "actual_range": "0.02436",
                                    "pointwidth": "0"
                                },
                                "rhum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rhum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_range": "-31766",
                                    "actual_range": "100.0",
                                    "units": "percent",
                                    "long_name": "6-hourly Relative Humidity on Pressure Levels",
                                    "GRIB_name": "RH",
                                    "var_desc": "Relative Humidity",
                                    "standard_name": "relative_humidity",
                                    "GRIB_id": "52",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "100.0",
                                    "add_offset": "3276.6001",
                                    "precision": "1",
                                    "scale_factor": "0.1",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "statistic": "Ensemble Mean",
                                    "pointwidth": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pascal/s",
                                    "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                    "statistic": "Ensemble Mean",
                                    "long_name": "6-hourly Omega on Pressure Levels",
                                    "valid_range": "-13766",
                                    "var_desc": "Omega (dp/dt)",
                                    "GRIB_name": "VVEL",
                                    "GRIB_id": "39",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "8.0",
                                    "add_offset": "21.766001",
                                    "precision": "3",
                                    "scale_factor": "0.001",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "actual_range": "2.102",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "actual_range": "32587.7",
                                    "units": "m",
                                    "statistic": "Ensemble Mean",
                                    "long_name": "6-hourly Geopotential Heights on Pressure Levels",
                                    "valid_range": "28734",
                                    "GRIB_id": "7",
                                    "GRIB_name": "HGT",
                                    "standard_name": "geopotential_height",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "60000.0",
                                    "precision": "0",
                                    "add_offset": "31266.0",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "var_desc": "Geopotential height",
                                    "pointwidth": "0"
                                },
                                "air": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "air",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "actual_range": "323.8",
                                    "statistic": "Ensemble Mean",
                                    "long_name": "6-hourly Air Temperature on Pressure Levels",
                                    "valid_range": "7300",
                                    "standard_name": "air_temperature",
                                    "GRIB_name": "TMP",
                                    "DODStargetchunksize": "25000000",
                                    "parent_stat": "Other",
                                    "missing_value": "32766",
                                    "unpacked_valid_range": "500.0",
                                    "precision": "2",
                                    "add_offset": "427.66",
                                    "scale_factor": "0.01",
                                    "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                    "level_desc": "Pressure Levels",
                                    "var_desc": "Air temperature",
                                    "GRIB_id": "11",
                                    "pointwidth": "0"
                                }
                            },
                            "monolevel_sprd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monolevel_sprd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tropo": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tropo",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "statistic": "Ensemble Spread",
                                        "actual_range": "34.022",
                                        "long_name": "6-hourly V-wind Spread at Tropopause",
                                        "valid_range": "32765",
                                        "standard_name": "grid_northward_wind",
                                        "GRIB_name": "VGRD",
                                        "GRIB_id": "34",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "add_offset": "32.765999",
                                        "precision": "3",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "var_desc": "v-wind",
                                        "pointwidth": "0"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_range": "32765",
                                        "units": "m/s",
                                        "actual_range": "31.001",
                                        "statistic": "Ensemble Spread",
                                        "standard_name": "grid_eastward_wind",
                                        "var_desc": "u-wind",
                                        "GRIB_name": "UGRD",
                                        "GRIB_id": "33",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "long_name": "6-hourly U-wind Spread at Tropopause",
                                        "pointwidth": "0"
                                    },
                                    "pres": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "6-hourly Pressure Spread at Tropopause",
                                        "units": "Pa",
                                        "actual_range": "19586.45",
                                        "statistic": "Ensemble Spread",
                                        "standard_name": "air_pressure",
                                        "var_desc": "Pressure",
                                        "GRIB_name": "PRES",
                                        "GRIB_id": "1",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65531.0",
                                        "precision": "0",
                                        "add_offset": "32766.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "valid_range": "32765",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "var_desc": "Geopotential height",
                                        "units": "m",
                                        "statistic": "Ensemble Spread",
                                        "long_name": "6-hourly Geopotential Heights Spread at Tropopause",
                                        "valid_range": "32765",
                                        "GRIB_id": "7",
                                        "GRIB_name": "HGT",
                                        "standard_name": "geopotential_height",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6553.4",
                                        "precision": "1",
                                        "add_offset": "3276.6001",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "5674.635",
                                        "pointwidth": "0"
                                    },
                                    "air": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "var_desc": "Air temperature",
                                        "units": "Kelvin_scale",
                                        "statistic": "Ensemble Spread",
                                        "long_name": "6-hourly Air Temperature Spread at Tropopause",
                                        "valid_range": "32765",
                                        "GRIB_id": "11",
                                        "GRIB_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "29.179",
                                        "pointwidth": "0"
                                    }
                                },
                                "sig995": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sig995",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "statistic": "Ensemble Spread",
                                        "actual_range": "22.962",
                                        "long_name": "6-hourly V-wind Spread at sigma level 0.995",
                                        "valid_range": "32765",
                                        "var_desc": "v-wind",
                                        "GRIB_id": "34",
                                        "standard_name": "grid_northward_wind",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "add_offset": "32.765999",
                                        "precision": "3",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "GRIB_name": "VGRD",
                                        "pointwidth": "0"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "statistic": "Ensemble Spread",
                                        "units": "m/s",
                                        "actual_range": "18.239",
                                        "GRIB_name": "UGRD",
                                        "valid_range": "32765",
                                        "var_desc": "u-wind",
                                        "standard_name": "grid_eastward_wind",
                                        "GRIB_id": "33",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "long_name": "6-hourly U-wind Spread at sigma level 0.995",
                                        "pointwidth": "0"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "relative_humidity",
                                        "statistic": "Ensemble Spread",
                                        "actual_range": "49.63",
                                        "long_name": "6-hourly Relative Humidity Spread at sigma level 0.995",
                                        "valid_range": "32765",
                                        "var_desc": "Relative Humidity",
                                        "GRIB_name": "RH",
                                        "GRIB_id": "52",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "units": "percent",
                                        "pointwidth": "0"
                                    },
                                    "pottmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pottmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "statistic": "Ensemble Spread",
                                        "units": "Kelvin_scale",
                                        "actual_range": "15.728",
                                        "long_name": "6-hourly Potential Temperature Spread at sigma level 0.995",
                                        "valid_range": "32765",
                                        "var_desc": "Potential Temperature",
                                        "standard_name": "air_potential_temperature",
                                        "GRIB_id": "13",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "precision": "3",
                                        "scale_factor": "0.001",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "GRIB_name": "POT",
                                        "pointwidth": "0"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "statistic": "Ensemble Spread",
                                        "units": "Pascal/s",
                                        "actual_range": "1.25968",
                                        "GRIB_name": "VVEL",
                                        "valid_range": "32765",
                                        "var_desc": "Omega (dp/dt)",
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "GRIB_id": "39",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6.5531",
                                        "scale_factor": "9.99999975E-05",
                                        "precision": "4",
                                        "add_offset": "3.2765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "long_name": "6-hourly Omega Spread at sigma level 0.995",
                                        "pointwidth": "0"
                                    },
                                    "air": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "actual_range": "15.49",
                                        "var_desc": "Air temperature",
                                        "units": "Kelvin_scale",
                                        "statistic": "Ensemble Spread",
                                        "valid_range": "32765",
                                        "standard_name": "air_temperature",
                                        "GRIB_name": "TMP",
                                        "GRIB_id": "11",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "long_name": "6-hourly Air Temperature Spread at sigma level 0.995",
                                        "pointwidth": "0"
                                    }
                                },
                                "sfc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sfc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pres": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure",
                                        "actual_range": "2168.21",
                                        "statistic": "Ensemble Spread",
                                        "long_name": "6-hourly Pressure Spread at Surface",
                                        "valid_range": "32765",
                                        "var_desc": "Pressure",
                                        "GRIB_name": "PRES",
                                        "GRIB_id": "1",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6553.1",
                                        "add_offset": "3276.6001",
                                        "precision": "1",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "cin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "var_desc": "convective inhibition",
                                        "units": "J/kg",
                                        "actual_range": "708.1",
                                        "statistic": "Ensemble Spread",
                                        "valid_range": "32765",
                                        "GRIB_id": "156",
                                        "standard_name": "",
                                        "GRIB_name": "CIN",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6553.1",
                                        "scale_factor": "0.1",
                                        "precision": "1",
                                        "add_offset": "3276.6001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "long_name": "6-hourly CIN Spread",
                                        "pointwidth": "0"
                                    },
                                    "cape": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cape",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "",
                                        "actual_range": "1664.16",
                                        "statistic": "Ensemble Spread",
                                        "long_name": "6-hourly CAPE Spread",
                                        "valid_range": "32765",
                                        "var_desc": "convective available potential energy",
                                        "GRIB_name": "CAPE",
                                        "GRIB_id": "157",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6553.1",
                                        "precision": "1",
                                        "scale_factor": "0.1",
                                        "add_offset": "3276.6001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "units": "J/kg",
                                        "pointwidth": "0"
                                    }
                                },
                                "msl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "msl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "6-hourly Pressure Spread at Mean Sea Level",
                                        "units": "Pa",
                                        "actual_range": "2247.71",
                                        "statistic": "Ensemble Spread",
                                        "valid_range": "32765",
                                        "var_desc": "Mean Sea Level Pressure",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "GRIB_name": "PRMSL",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6553.1",
                                        "scale_factor": "0.1",
                                        "precision": "1",
                                        "add_offset": "3276.6001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Mean Sea Level",
                                        "GRIB_id": "2",
                                        "pointwidth": "0"
                                    }
                                },
                                "eatm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eatm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tco3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tco3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Dobsons",
                                        "actual_range": "72.928",
                                        "statistic": "Ensemble Spread",
                                        "long_name": "6-hourly Total Columnar Ozone Spread",
                                        "valid_range": "32765",
                                        "var_desc": "total columnar ozone",
                                        "standard_name": "equivalent_thickness_at_top_of_atmosphere_o3_content",
                                        "GRIB_id": "10",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "655.31",
                                        "add_offset": "327.66",
                                        "precision": "2",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "GRIB_name": "TOZNE",
                                        "pointwidth": "0"
                                    },
                                    "pr_wtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr_wtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "6-hourly Precipitable Water Spread for entire atmosphere",
                                        "units": "kg/m^2",
                                        "actual_range": "22.664",
                                        "statistic": "Ensemble Spread",
                                        "valid_range": "32765",
                                        "GRIB_id": "54",
                                        "standard_name": "atmosphere_water_vapor_content",
                                        "GRIB_name": "PWAT",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65.531",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "32.765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "var_desc": "Precipitable Water Content",
                                        "pointwidth": "0"
                                    },
                                    "cldwtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cldwtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "GRIB_name": "C WAT",
                                        "actual_range": "0.5533",
                                        "units": "kg/m^2",
                                        "statistic": "Ensemble Spread",
                                        "valid_range": "32765",
                                        "var_desc": "Cloud Water Content",
                                        "GRIB_id": "76",
                                        "standard_name": "atmosphere_cloud_condensed_water_content",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6.5531",
                                        "scale_factor": "9.99999975E-05",
                                        "precision": "4",
                                        "add_offset": "3.2765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "long_name": "6-hourly Cloud Water Spread for entire atmosphere",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "monolevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monolevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tropo": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tropo",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "var_desc": "v-wind",
                                        "units": "m/s",
                                        "statistic": "Ensemble Mean",
                                        "long_name": "6-hourly V-wind at Tropopause",
                                        "valid_range": "30234",
                                        "GRIB_name": "VGRD",
                                        "standard_name": "grid_northward_wind",
                                        "GRIB_id": "132",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "350.0",
                                        "add_offset": "47.66",
                                        "precision": "2",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "72.4",
                                        "pointwidth": "0"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "standard_name": "grid_eastward_wind",
                                        "actual_range": "78.6",
                                        "long_name": "6-hourly U-wind at Tropopause",
                                        "valid_range": "30234",
                                        "var_desc": "u-wind",
                                        "GRIB_name": "UGRD",
                                        "GRIB_id": "131",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "350.0",
                                        "scale_factor": "0.01",
                                        "precision": "2",
                                        "add_offset": "47.66",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "statistic": "Ensemble Mean",
                                        "pointwidth": "0"
                                    },
                                    "pres": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "48398.0",
                                        "long_name": "6-hourly Pressure at Tropopause",
                                        "valid_range": "32734",
                                        "var_desc": "Pressure",
                                        "standard_name": "air_pressure",
                                        "GRIB_name": "PRES",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "65500.0",
                                        "precision": "0",
                                        "add_offset": "32766.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "GRIB_id": "1",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "17569.4",
                                        "long_name": "6-hourly Geopotential Heights at Tropopause",
                                        "valid_range": "28734",
                                        "var_desc": "Geopotential height",
                                        "standard_name": "geopotential_height",
                                        "GRIB_name": "HGT",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "60000.0",
                                        "precision": "0",
                                        "add_offset": "31266.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "GRIB_id": "7",
                                        "pointwidth": "0"
                                    },
                                    "air": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "246.8",
                                        "long_name": "6-hourly Air Temperature at Tropopause",
                                        "valid_range": "6233",
                                        "GRIB_id": "11",
                                        "standard_name": "air_temperature",
                                        "GRIB_name": "TMP",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "500.0",
                                        "add_offset": "427.66",
                                        "precision": "2",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Tropopause",
                                        "var_desc": "Air temperature",
                                        "pointwidth": "0"
                                    }
                                },
                                "sig995": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sig995",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "grid_northward_wind",
                                        "actual_range": "51.3",
                                        "statistic": "Ensemble Mean",
                                        "long_name": "6-hourly V-wind at sigma level 0.995",
                                        "valid_range": "30234",
                                        "var_desc": "v-wind",
                                        "GRIB_name": "VGRD",
                                        "GRIB_id": "132",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "350.0",
                                        "add_offset": "47.66",
                                        "precision": "2",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "grid_eastward_wind",
                                        "actual_range": "38.8",
                                        "statistic": "Ensemble Mean",
                                        "long_name": "6-hourly U-wind at sigma level 0.995",
                                        "valid_range": "30234",
                                        "var_desc": "u-wind",
                                        "GRIB_name": "UGRD",
                                        "GRIB_id": "131",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "350.0",
                                        "add_offset": "47.66",
                                        "precision": "2",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "statistic": "Ensemble Mean",
                                        "units": "percent",
                                        "actual_range": "100.0",
                                        "long_name": "6-hourly Relative Humidity at sigma level 0.995",
                                        "valid_range": "-31766",
                                        "var_desc": "Relative Humidity",
                                        "GRIB_name": "RH",
                                        "GRIB_id": "52",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "100.0",
                                        "precision": "1",
                                        "scale_factor": "0.1",
                                        "add_offset": "3276.6001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "standard_name": "relative_humidity",
                                        "pointwidth": "0"
                                    },
                                    "pottmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pottmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_potential_temperature",
                                        "actual_range": "343.8",
                                        "units": "Kelvin_scale",
                                        "long_name": "6-hourly Potential Temperature at sigma level 0.995",
                                        "valid_range": "22233",
                                        "var_desc": "Potential Temperature",
                                        "GRIB_name": "POT",
                                        "GRIB_id": "13",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "650.0",
                                        "scale_factor": "0.01",
                                        "precision": "2",
                                        "add_offset": "427.66",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "statistic": "Ensemble Mean",
                                        "pointwidth": "0"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "2.173",
                                        "long_name": "6-hourly Omega at sigma level 0.995",
                                        "valid_range": "-13766",
                                        "var_desc": "Omega (dp/dt)",
                                        "GRIB_name": "VVEL",
                                        "GRIB_id": "39",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "8.0",
                                        "scale_factor": "0.001",
                                        "precision": "3",
                                        "add_offset": "21.766001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "units": "Pascal/s",
                                        "pointwidth": "0"
                                    },
                                    "air": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "321.1",
                                        "long_name": "6-hourly Air Temperature at sigma level 0.995",
                                        "valid_range": "6233",
                                        "var_desc": "Air temperature",
                                        "standard_name": "air_temperature",
                                        "GRIB_name": "TMP",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "500.0",
                                        "precision": "2",
                                        "add_offset": "427.66",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "sigma level 0.995",
                                        "GRIB_id": "11",
                                        "pointwidth": "0"
                                    }
                                },
                                "sfc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sfc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pres": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "var_desc": "Pressure",
                                        "statistic": "Ensemble Mean",
                                        "units": "Pa",
                                        "long_name": "6-hourly Pressure at Surface",
                                        "valid_range": "32734",
                                        "standard_name": "air_pressure",
                                        "GRIB_id": "1",
                                        "GRIB_name": "PRES",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "112000.0",
                                        "precision": "0",
                                        "add_offset": "79266.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "actual_range": "109093.0",
                                        "pointwidth": "0"
                                    },
                                    "cin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "statistic": "Ensemble Mean",
                                        "units": "J/kg",
                                        "actual_range": "0.0",
                                        "long_name": "6-hourly CIN",
                                        "valid_range": "32765",
                                        "var_desc": "convective inhibition",
                                        "GRIB_name": "CIN",
                                        "GRIB_id": "156",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "553.1",
                                        "scale_factor": "0.1",
                                        "precision": "1",
                                        "add_offset": "-2723.3999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "standard_name": "",
                                        "pointwidth": "0"
                                    },
                                    "cape": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cape",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "",
                                        "statistic": "Ensemble Mean",
                                        "units": "J/kg",
                                        "long_name": "6-hourly CAPE",
                                        "valid_range": "-24766",
                                        "var_desc": "convective available potential energy",
                                        "GRIB_name": "CAPE",
                                        "GRIB_id": "157",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "8000.0",
                                        "precision": "0",
                                        "add_offset": "32766.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Surface",
                                        "actual_range": "4325.0",
                                        "pointwidth": "0"
                                    }
                                },
                                "msl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "msl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "units": "Pa",
                                        "actual_range": "106689.0",
                                        "long_name": "6-hourly Pressure at Mean Sea Level",
                                        "valid_range": "15234",
                                        "var_desc": "Mean Sea Level Pressure",
                                        "GRIB_name": "PRMSL",
                                        "GRIB_id": "2",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "125000.0",
                                        "precision": "1",
                                        "add_offset": "109766.0",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Mean Sea Level",
                                        "statistic": "Ensemble Mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "eatm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eatm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tco3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tco3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "equivalent_thickness_at_top_of_atmosphere_o3_content",
                                        "long_name": "6-hourly Total Columnar Ozone",
                                        "actual_range": "508.3",
                                        "statistic": "Ensemble Mean",
                                        "valid_range": "-25266",
                                        "var_desc": "total columnar ozone",
                                        "GRIB_name": "TOZNE",
                                        "GRIB_id": "10",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "750.0",
                                        "add_offset": "3276.6001",
                                        "precision": "1",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "units": "Dobsons",
                                        "pointwidth": "0"
                                    },
                                    "pr_wtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr_wtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "atmosphere_water_vapor_content",
                                        "statistic": "Ensemble Mean",
                                        "actual_range": "111.1",
                                        "long_name": "6-hourly Precipitable Water for entire atmosphere",
                                        "valid_range": "-12766",
                                        "var_desc": "Precipitable Water Content",
                                        "GRIB_name": "PWAT",
                                        "GRIB_id": "54",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "150.0",
                                        "scale_factor": "0.01",
                                        "precision": "2",
                                        "add_offset": "277.66",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "units": "kg/m^2",
                                        "pointwidth": "0"
                                    },
                                    "cldwtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cldwtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "atmosphere_cloud_condensed_water_content",
                                        "long_name": "6-hourly Cloud Water for entire atmosphere",
                                        "actual_range": "1.35",
                                        "statistic": "Ensemble Mean",
                                        "valid_range": "32766",
                                        "var_desc": "Cloud Water Content",
                                        "GRIB_name": "C WAT",
                                        "GRIB_id": "76",
                                        "parent_stat": "Other",
                                        "missing_value": "32766",
                                        "unpacked_valid_range": "6.5532",
                                        "scale_factor": "9.99999975E-05",
                                        "precision": "4",
                                        "add_offset": "3.2765999",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis version 2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "units": "kg/m^2",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    },
                    "V1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressurelevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressurelevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "spread": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "spread",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wspd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.01",
                                        "long_name": "Monthly Wind Speed Spread on Pressure Levels",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "unpacked_valid_range": "655.31",
                                        "level_desc": "Pressure Levels",
                                        "missing_value": "32766",
                                        "statistic": "Mean of Ensemble Spread",
                                        "add_offset": "327.66",
                                        "actual_range": "49.893032",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "32765",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "var_desc": "Wind Speed",
                                        "precision": "2",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "327.66",
                                        "GRIB_id": "132",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "v-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "39.368069",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind Spread on Pressure Levels",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "655.31"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "327.66",
                                        "GRIB_id": "131",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "u-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "40.879646",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind Spread on Pressure Levels",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "655.31"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "32765",
                                        "var_desc": "Air temperature",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "27.899998",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Air Temperature Spread on Pressure Levels",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "shum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "shum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "0.032766",
                                        "GRIB_id": "133",
                                        "units": "unitless",
                                        "valid_range": "32765",
                                        "var_desc": "Specific humidity",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "SPFH",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "9.99999997E-07",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "6",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "0.005894484",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Specific Humidity Spread on Pressure Levels",
                                        "standard_name": "specific_humidity",
                                        "unpacked_valid_range": "0.065531"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "52",
                                        "units": "percent",
                                        "valid_range": "32765",
                                        "var_desc": "Relative Humidity",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "RH",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "44.185032",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Relative Humidity Spread on Pressure Levels",
                                        "standard_name": "relative_humidity",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3.2765999",
                                        "GRIB_id": "39",
                                        "units": "Pascal/s",
                                        "valid_range": "32765",
                                        "var_desc": "Omega (dp/dt)",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VVEL",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "9.99999975E-05",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "4",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "0.4898838",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Omega Spread on Pressure Levels",
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "unpacked_valid_range": "6.5531001"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "7",
                                        "units": "m",
                                        "valid_range": "32765",
                                        "var_desc": "Geopotential height",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "HGT",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "1257.6393",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Geopotential Heights Spread on Pressure Levels",
                                        "standard_name": "geopotential_height",
                                        "unpacked_valid_range": "6553.1001"
                                    }
                                },
                                "analysis": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "analysis",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wspd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.01",
                                        "long_name": "Monthly Wind Speed on Pressure Levels",
                                        "unpacked_valid_range": "500.0",
                                        "level_desc": "Pressure Levels",
                                        "missing_value": "32766",
                                        "statistic": "Mean",
                                        "add_offset": "327.66",
                                        "actual_range": "134.59038",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "17234",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean",
                                        "var_desc": "Wind Speed",
                                        "precision": "2",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "vwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "132",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "v-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "55.986767",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind on Pressure Levels",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "uwnd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "131",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "u-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "134.06967",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind on Pressure Levels",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "427.66",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "7300",
                                        "var_desc": "Air temperature",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "316.45837",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Air Temperature on Pressure Levels",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "500.0"
                                    },
                                    "shum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "shum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "0.032666",
                                        "GRIB_id": "133",
                                        "units": "unitless",
                                        "valid_range": "32765",
                                        "var_desc": "Specific humidity",
                                        "missing_value": "32766",
                                        "GRIB_name": "SPFH",
                                        "statistic": "Mean",
                                        "scale_factor": "9.99999997E-07",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "6",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "0.02224097",
                                        "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                        "long_name": "Monthly Specific Humidity on Pressure Levels",
                                        "standard_name": "specific_humidity",
                                        "unpacked_valid_range": "0.065431"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "52",
                                        "units": "percent",
                                        "valid_range": "-31766",
                                        "var_desc": "Relative Humidity",
                                        "missing_value": "32766",
                                        "GRIB_name": "RH",
                                        "statistic": "Mean",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "99.978569",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Relative Humidity on Pressure Levels",
                                        "standard_name": "relative_humidity",
                                        "unpacked_valid_range": "100.0"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "21.766001",
                                        "GRIB_id": "39",
                                        "units": "Pascal/s",
                                        "valid_range": "-13766",
                                        "var_desc": "Omega (dp/dt)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VVEL",
                                        "statistic": "Mean",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "0.5659662",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Omega on Pressure Levels",
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "unpacked_valid_range": "8.0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "31266.0",
                                        "GRIB_id": "7",
                                        "units": "m",
                                        "valid_range": "28734",
                                        "var_desc": "Geopotential height",
                                        "missing_value": "32766",
                                        "GRIB_name": "HGT",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "0",
                                        "level_desc": "Pressure Levels",
                                        "actual_range": "31903.936",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Geopotential Heights on Pressure Levels",
                                        "standard_name": "geopotential_height",
                                        "unpacked_valid_range": "60000.0"
                                    }
                                }
                            },
                            "monolevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monolevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "spread": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "spread",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wspd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.001",
                                        "long_name": "Monthly Wind Speed Spread at Tropopause",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "unpacked_valid_range": "65.530998",
                                        "level_desc": "Tropopause",
                                        "missing_value": "32766",
                                        "statistic": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "actual_range": "27.384998",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "32765",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "var_desc": "Wind Speed",
                                        "precision": "3",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "wspd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.001",
                                        "long_name": "Monthly Wind Speed Spread at sigma level 0.995",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "unpacked_valid_range": "65.530998",
                                        "level_desc": "sigma level 0.995",
                                        "missing_value": "32766",
                                        "statistic": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "actual_range": "13.639845",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "32765",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "var_desc": "Wind Speed",
                                        "precision": "3",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "vwnd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "132",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "v-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Tropopause",
                                        "actual_range": "20.453001",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind Spread at Tropopause",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "vwnd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "132",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "v-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "10.020385",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind Spread at sigma level 0.995",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "uwnd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "131",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "u-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Tropopause",
                                        "actual_range": "20.453001",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind Spread at Tropopause",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "uwnd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "131",
                                        "units": "m/s",
                                        "valid_range": "32765",
                                        "var_desc": "u-wind",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "10.269481",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind Spread at sigma level 0.995",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "tco3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tco3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "327.66",
                                        "GRIB_id": "10",
                                        "units": "Dobsons",
                                        "valid_range": "32765",
                                        "var_desc": "total columnar ozone",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "TOZNE",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "56.182594",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Total Columnar Ozone Spread",
                                        "standard_name": "equivalent_thickness_at_top_of_atmosphere_o3_content",
                                        "unpacked_valid_range": "655.31"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "52",
                                        "units": "percent",
                                        "valid_range": "32765",
                                        "var_desc": "Relative Humidity",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "RH",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "43.992607",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Relative Humidity Spread at sigma level 0.995",
                                        "standard_name": "relative_humidity",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "2",
                                        "units": "Pa",
                                        "valid_range": "32765",
                                        "var_desc": "Mean Sea Level Pressure",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRMSL",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Mean Sea Level",
                                        "actual_range": "1765.1199",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure Spread at Mean Sea Level",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "unpacked_valid_range": "6553.1001"
                                    },
                                    "pres_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "1",
                                        "units": "Pa",
                                        "valid_range": "32765",
                                        "var_desc": "Pressure",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRES",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Tropopause",
                                        "actual_range": "6501.4004",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure Spread at Tropopause",
                                        "standard_name": "air_pressure",
                                        "unpacked_valid_range": "6553.1001"
                                    },
                                    "pres_sfc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres_sfc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "1",
                                        "units": "Pa",
                                        "valid_range": "32765",
                                        "var_desc": "Pressure",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRES",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Surface",
                                        "actual_range": "1779.645",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure Spread at Surface",
                                        "standard_name": "air_pressure",
                                        "unpacked_valid_range": "6553.1001"
                                    },
                                    "pr_wtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr_wtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "54",
                                        "units": "kg/m^2",
                                        "valid_range": "32765",
                                        "var_desc": "Precipitable Water Content",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "PWAT",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "15.803806",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Precipitable Water Spread for entire atmosphere",
                                        "standard_name": "atmosphere_water_vapor_content",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "pottmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pottmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "32.765999",
                                        "GRIB_id": "13",
                                        "units": "degree_Celsius",
                                        "valid_range": "32765",
                                        "var_desc": "Potential Temperature",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "POT",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "21.52643",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Potential Temperature Spread at sigma level 0.995",
                                        "standard_name": "air_potential_temperature",
                                        "unpacked_valid_range": "65.530998"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3.2765999",
                                        "GRIB_id": "39",
                                        "units": "Pascal/s",
                                        "valid_range": "32765",
                                        "var_desc": "Omega (dp/dt)",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VVEL",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "9.99999975E-05",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "4",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "0.6251065",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Omega Spread at sigma level 0.995",
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "unpacked_valid_range": "6.5531001"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "7",
                                        "units": "m",
                                        "valid_range": "32765",
                                        "var_desc": "Geopotential height",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "HGT",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Tropopause",
                                        "actual_range": "3733.1587",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Geopotential Heights Spread at Tropopause",
                                        "standard_name": "geopotential_height",
                                        "unpacked_valid_range": "6553.3999"
                                    },
                                    "cldwtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cldwtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3.2765999",
                                        "GRIB_id": "76",
                                        "units": "kg/m^2",
                                        "valid_range": "32765",
                                        "var_desc": "Cloud Water Content",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "C WAT",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "9.99999975E-05",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "4",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "0.2051433",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Cloud Water Spread for entire atmosphere",
                                        "standard_name": "atmosphere_cloud_condensed_water_content",
                                        "unpacked_valid_range": "6.5531001"
                                    },
                                    "cin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "156",
                                        "units": "J/kg",
                                        "valid_range": "32765",
                                        "var_desc": "convective inhibition",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "CIN",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Surface",
                                        "actual_range": "349.48383",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly CIN Spread",
                                        "standard_name": "",
                                        "unpacked_valid_range": "6553.1001"
                                    },
                                    "cape": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cape",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "157",
                                        "units": "J/kg",
                                        "valid_range": "32765",
                                        "var_desc": "convective available potential energy",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "CAPE",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Surface",
                                        "actual_range": "1061.5549",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly CAPE Spread",
                                        "standard_name": "",
                                        "unpacked_valid_range": "6553.1001"
                                    },
                                    "air_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "31.766001",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "32765",
                                        "var_desc": "Air temperature",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "Tropopause",
                                        "actual_range": "15.976548",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Air Temperature Spread at Tropopause",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "64.530998"
                                    },
                                    "air_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean of Ensemble Spread",
                                        "add_offset": "31.766001",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "32765",
                                        "var_desc": "Air temperature",
                                        "statistic_note": "(which is related to the autocorrelation of that variable)",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean of Ensemble Spread",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "21.356663",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Air Temperature Spread at sigma level 0.995",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "64.530998"
                                    }
                                },
                                "analysis": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "analysis",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wspd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.01",
                                        "long_name": "Monthly Wind Speed at Tropopause",
                                        "unpacked_valid_range": "350.0",
                                        "level_desc": "Tropopause",
                                        "missing_value": "32766",
                                        "statistic": "Mean",
                                        "add_offset": "47.66",
                                        "actual_range": "66.833572",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "30234",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean",
                                        "var_desc": "Wind Speed",
                                        "precision": "2",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "wspd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wspd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_factor": "0.01",
                                        "long_name": "Monthly Wind Speed at sigma level 0.995",
                                        "unpacked_valid_range": "350.0",
                                        "level_desc": "sigma level 0.995",
                                        "missing_value": "32766",
                                        "statistic": "Mean",
                                        "add_offset": "47.66",
                                        "actual_range": "23.314407",
                                        "units": "m/s",
                                        "standard_name": "wind_speed",
                                        "valid_range": "30234",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "parent_stat": "Mean",
                                        "var_desc": "Wind Speed",
                                        "precision": "2",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)"
                                    },
                                    "vwnd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "34",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "v-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "32.082413",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind at Tropopause",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "vwnd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vwnd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "34",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "v-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "VGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "15.298388",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly V-wind at sigma level 0.995",
                                        "standard_name": "grid_northward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "uwnd_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "33",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "u-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "66.38356",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind at Tropopause",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "uwnd_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uwnd_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "47.66",
                                        "GRIB_id": "33",
                                        "units": "m/s",
                                        "valid_range": "30234",
                                        "var_desc": "u-wind",
                                        "missing_value": "32766",
                                        "GRIB_name": "UGRD",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "16.272144",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly U-wind at sigma level 0.995",
                                        "standard_name": "grid_eastward_wind",
                                        "unpacked_valid_range": "350.0"
                                    },
                                    "tco3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tco3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "10",
                                        "units": "Dobsons",
                                        "valid_range": "-25266",
                                        "var_desc": "total columnar ozone",
                                        "missing_value": "32766",
                                        "GRIB_name": "TOZNE",
                                        "statistic": "Mean",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "524.09662",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Total Columnar Ozone",
                                        "standard_name": "equivalent_thickness_at_top_of_atmosphere_o3_content",
                                        "unpacked_valid_range": "750.0"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "3276.6001",
                                        "GRIB_id": "52",
                                        "units": "percent",
                                        "valid_range": "-31766",
                                        "var_desc": "Relative Humidity",
                                        "missing_value": "32766",
                                        "GRIB_name": "RH",
                                        "statistic": "Mean",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "99.900146",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Relative Humidity at sigma level 0.995",
                                        "standard_name": "relative_humidity",
                                        "unpacked_valid_range": "100.0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "109766.0",
                                        "GRIB_id": "2",
                                        "units": "Pa",
                                        "valid_range": "15234",
                                        "var_desc": "Mean Sea Level Pressure",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRMSL",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Mean Sea Level",
                                        "actual_range": "104620.91",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure at Mean Sea Level",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "unpacked_valid_range": "125000.0"
                                    },
                                    "pres_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "32766.0",
                                        "GRIB_id": "1",
                                        "units": "Pa",
                                        "valid_range": "32734",
                                        "var_desc": "Pressure",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRES",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "0",
                                        "level_desc": "Tropopause",
                                        "actual_range": "37205.898",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure at Tropopause",
                                        "standard_name": "air_pressure",
                                        "unpacked_valid_range": "65500.0"
                                    },
                                    "pres_sfc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pres_sfc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "79266.0",
                                        "GRIB_id": "1",
                                        "units": "Pa",
                                        "valid_range": "32734",
                                        "var_desc": "Pressure",
                                        "missing_value": "32766",
                                        "GRIB_name": "PRES",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "0",
                                        "level_desc": "Surface",
                                        "actual_range": "108347.03",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Pressure at Surface",
                                        "standard_name": "air_pressure",
                                        "unpacked_valid_range": "112000.0"
                                    },
                                    "pr_wtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr_wtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "277.66",
                                        "GRIB_id": "54",
                                        "units": "kg/m^2",
                                        "valid_range": "-12766",
                                        "var_desc": "Precipitable Water Content",
                                        "missing_value": "32766",
                                        "GRIB_name": "PWAT",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "70.316452",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Precipitable Water for entire atmosphere",
                                        "standard_name": "atmosphere_water_vapor_content",
                                        "unpacked_valid_range": "150.0"
                                    },
                                    "pottmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pottmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "427.66",
                                        "GRIB_id": "13",
                                        "units": "degree_Celsius",
                                        "valid_range": "22233",
                                        "var_desc": "Potential Temperature",
                                        "missing_value": "32766",
                                        "GRIB_name": "POT",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "327.34357",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Potential Temperature at sigma level 0.995",
                                        "standard_name": "air_potential_temperature",
                                        "unpacked_valid_range": "650.0"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "21.766001",
                                        "GRIB_id": "39",
                                        "units": "Pascal/s",
                                        "valid_range": "-13766",
                                        "var_desc": "Omega (dp/dt)",
                                        "missing_value": "32766",
                                        "GRIB_name": "VVEL",
                                        "statistic": "Mean",
                                        "scale_factor": "0.001",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "3",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "0.6942579",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Omega at sigma level 0.995",
                                        "standard_name": "vertical_air_velocity_expressed_as_tendency_of_pressure",
                                        "unpacked_valid_range": "8.0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "31266.0",
                                        "GRIB_id": "7",
                                        "units": "m",
                                        "valid_range": "28734",
                                        "var_desc": "Geopotential height",
                                        "missing_value": "32766",
                                        "GRIB_name": "HGT",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "0",
                                        "level_desc": "Tropopause",
                                        "actual_range": "18020.645",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Geopotential Heights at Tropopause",
                                        "standard_name": "geopotential_height",
                                        "unpacked_valid_range": "60000.0"
                                    },
                                    "cldwtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cldwtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "3.2765999",
                                        "GRIB_id": "76",
                                        "units": "kg/m^2",
                                        "valid_range": "32766",
                                        "var_desc": "Cloud Water Content",
                                        "missing_value": "32766",
                                        "GRIB_name": "C WAT",
                                        "statistic": "Mean",
                                        "scale_factor": "9.99999975E-05",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "4",
                                        "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                        "actual_range": "0.2816033",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Cloud Water for entire atmosphere",
                                        "standard_name": "atmosphere_cloud_condensed_water_content",
                                        "unpacked_valid_range": "6.5531998"
                                    },
                                    "cin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "1626.6",
                                        "GRIB_id": "156",
                                        "units": "J/kg",
                                        "valid_range": "-13266",
                                        "var_desc": "convective inhibition",
                                        "missing_value": "32766",
                                        "GRIB_name": "CIN",
                                        "statistic": "Mean",
                                        "scale_factor": "0.1",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "1",
                                        "level_desc": "Surface",
                                        "actual_range": "0.1103431",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly CIN",
                                        "standard_name": "",
                                        "unpacked_valid_range": "300.0"
                                    },
                                    "cape": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cape",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "32766.0",
                                        "GRIB_id": "157",
                                        "units": "J/kg",
                                        "valid_range": "-24766",
                                        "var_desc": "convective available potential energy",
                                        "missing_value": "32766",
                                        "GRIB_name": "CAPE",
                                        "statistic": "Mean",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "0",
                                        "level_desc": "Surface",
                                        "actual_range": "2897.6128",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly CAPE",
                                        "standard_name": "",
                                        "unpacked_valid_range": "8000.0"
                                    },
                                    "air_tropo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air_tropo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "427.66",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "6233",
                                        "var_desc": "Air temperature",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "Tropopause",
                                        "actual_range": "230.1158",
                                        "cell_methods": "time: mean (monthly from 6-hourly values)",
                                        "long_name": "Monthly Air Temperature at Tropopause",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "500.0"
                                    },
                                    "air_sig995": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "air_sig995",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "parent_stat": "Mean",
                                        "add_offset": "427.66",
                                        "GRIB_id": "11",
                                        "units": "degree_Celsius",
                                        "valid_range": "6233",
                                        "var_desc": "Air temperature",
                                        "missing_value": "32766",
                                        "GRIB_name": "TMP",
                                        "statistic": "Mean",
                                        "scale_factor": "0.01",
                                        "Dataset": "NOAA-CIRES 20th Century Reanalysis Monthly Averages",
                                        "precision": "2",
                                        "level_desc": "sigma level 0.995",
                                        "actual_range": "314.41098",
                                        "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                        "long_name": "Monthly Air Temperature at sigma level 0.995",
                                        "standard_name": "air_temperature",
                                        "unpacked_valid_range": "500.0"
                                    }
                                }
                            }
                        }
                    },
                    "time_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hours since 1800-1-1 00:00:0.0",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0",
                        "standard_name": "time"
                    },
                    "level_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "millibar",
                        "gridtype": "0"
                    },
                    "time": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1871-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0",
                        "standard_name": "time"
                    },
                    "level_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "millibar",
                        "gridtype": "0",
                        "positive": "down",
                        "actual_range": "10.0",
                        "long_name": "Level",
                        "coordinate_defines": "point",
                        "axis": "Z",
                        "pointwidth": "50.0"
                    },
                    "level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "millibar",
                        "gridtype": "0",
                        "long_name": "Level",
                        "coordinate_defines": "point",
                        "positive": "down",
                        "axis": "Z",
                        "actual_range": "10.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.0",
                        "actual_range": "-90.0",
                        "long_name": "Latitude",
                        "coordinate_defines": "point",
                        "standard_name": "latitude",
                        "axis": "Y"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.0",
                        "actual_range": "358.0",
                        "long_name": "Longitude",
                        "coordinate_defines": "point",
                        "standard_name": "longitude",
                        "axis": "X",
                        "modulus": "360.0"
                    },
                    "dir": "SOURCES/NOAA/ESRL/PSD/rean20thcent"
                },
                "reforecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble_meantitle": "MRF Reforecasting Experiment",
                        "ensemble_meanhistory": "Thu Jan 10 11:38:44 2008: /home/jwhitaker/bin/ncks -d lon,0.0,357.5 -d lat,-90.0,90.0 /home/outgoing/www/tmp-BhjtN.apcp_Surface_ensmean.nc /home/outgoing/www/subtmp-BhjtN.apcp_Surface_ensmean.nc created 2008-1-10",
                        "ensemble_meanplatform": "none",
                        "ensemble_meanConventions": "COARDS",
                        "ensemble15title": "NCEP/CDC MRF Reforecast Data",
                        "ensemble15history": "Created Wed Apr 25 08:06:23 2007 UTC",
                        "ensemble15description": "Forecasts initialized with NCEP early CDAS",
                        "ensemble15platform": "none",
                        "ensemble15Conventions": "COARDS",
                        "ESRL": "http://www.cdc.noaa.gov/people/jeffrey.s.whitaker/refcst/",
                        "data": "http://www.cdc.noaa.gov/reforecast/",
                        "references": "Hamill_etal2006",
                        "description": "ESRL GFS Reforecast",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.ESRL/.PSD/.reforecast/.dataset_documentation.html",
                        "Conventions": "IRIDL"
                    },
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "apcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precision": "-999.0",
                            "long_name": "Accumulated precipitation",
                            "units": "mm",
                            "data_download_level": "Nonemb",
                            "actual_range": "68.57",
                            "parent_stat": "Mean",
                            "valid_range": "9.9692100E36",
                            "data_download_type": "ensemble mean",
                            "missing_value": "32766",
                            "statistic": "Mean",
                            "add_offset": "327.64999",
                            "scale_factor": "0.01",
                            "Dataset": "MRF Reforecasting experiment",
                            "var_desc": "Accumulated precipitation",
                            "pointwidth": "0"
                        }
                    },
                    "ensemble15": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble15",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble_member": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble_member",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "ensemble member (0 is control, +1 is p1, -1 is n1, etc)",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "apcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precision": "-999.0",
                            "units": "mm",
                            "long_name": "Accumulated precipitation",
                            "valid_range": "9.9692100E36",
                            "parent_stat": "Mean",
                            "actual_range": "133.221",
                            "missing_value": "32766",
                            "add_offset": "327.64999",
                            "statistic": "Mean",
                            "scale_factor": "0.01",
                            "Dataset": "NCEP/CDC MRF Reforecast",
                            "var_desc": "Accumulated precipitation",
                            "pointwidth": "0"
                        }
                    },
                    "lag_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lag_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hours",
                        "gridtype": "0",
                        "pointwidth": "12.0"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1979-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "members": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "members",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "lag": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lag",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hours",
                        "gridtype": "0",
                        "pointwidth": "12.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2007-08-24 00:00:00",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Forecast Start Time",
                        "calendar": "standard",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/NOAA/ESRL/PSD/reforecast"
                },
                "reforecast2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "reforecast2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble_meanreferences": "Hamill_etal2013",
                        "ensemble_meanReforecast": "ftp://ftp.cdc.noaa.gov/Projects/Reforecast2/",
                        "ensemble_meannote": "Please note that there are forecasts every 3 hours at leads (L) from 0 to 72 hours and forecasts every 6 hours thereafter, out to 192 hours.  The values at all the 6-hourly leads that are multiples of 6 (L = 6, 12, 18, etc.) are six-hourly values of the given variable (e.g., for precipitation, accumulations over the previous 6 hours).  The values at the remaining 3-hourly leads (L = 3, 9, 15, etc.) are three-hourly values of the given variable (e.g., for precipitation, accumulations over the previous 3 hours). ",
                        "ensemble_meanESRLPSD": "http://esrl.noaa.gov/psd/forecasts/reforecast2/",
                        "Conventions": "IRIDL"
                    },
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmp_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "long_name": "2-Meter Temperature (3 or 6 hourly)",
                            "standard_name": "air_temperature",
                            "gribname": "TMP",
                            "gribcenter": "7",
                            "center": "US National Weather Service - NCEP",
                            "pointwidth": "0"
                        },
                        "tmin_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "long_name": "Minimum Temperature (3 or 6 hourly)",
                            "standard_name": "air_temperature",
                            "gribname": "TMIN",
                            "gribcenter": "7",
                            "center": "US National Weather Service - NCEP",
                            "pointwidth": "0"
                        },
                        "tmax_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "long_name": "Maximum Temperature (3 or 6 hourly)",
                            "standard_name": "air_temperature",
                            "gribname": "TMAX",
                            "gribcenter": "7",
                            "center": "US National Weather Service - NCEP",
                            "pointwidth": "0"
                        },
                        "spfh_2m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "spfh_2m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "long_name": "2-Meter Specific Humidity (3 or 6 hourly)",
                            "standard_name": "specific_humidity",
                            "gribname": "SPFH",
                            "gribcenter": "7",
                            "center": "US National Weather Service - NCEP",
                            "pointwidth": "0"
                        },
                        "apcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m^2",
                            "gribfield": "1",
                            "long_name": "Accumulated Precipitation (3 or 6 hourly)",
                            "standard_name": "precipitation_amount",
                            "gribleveltype": "1",
                            "missing_value": "9.99900026E20",
                            "gribname": "APCP",
                            "gribcenter": "7",
                            "center": "US National Weather Service - NCEP",
                            "pointwidth": "0"
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hours",
                        "gridtype": "0",
                        "long_name": "Lead"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1970-01-01 00:00:00",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Forecast Start Time",
                        "calendar": "standard",
                        "standard_name": "forecast_reference_time"
                    },
                    "dir": "SOURCES/NOAA/ESRL/PSD/reforecast2"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "SA18",
                    "SA23",
                    "rean20thcent",
                    "reforecast",
                    "reforecast2"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "PSD"
            ]
        },
        "GCPS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GCPS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MONTHLYSTATIONreferences": "Baker_etal1995",
                "MONTHLYSTATIONdescription": "Baseline climatological dataset of weather station temperature and precipitation data derived from the Glocal Historical Climate Network",
                "MONTHLYSTATIONdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.GCPS/.MONTHLY.STATION.dataset_documentation.html",
                "MONTHLYGRIDDEDdescription": "Baseline climatological dataset of gridded temperature and precipitation anomalies derived from the Global Historical Climate Network",
                "MONTHLYGRIDDEDdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.GCPS/.MONTHLY.GRIDDED.dataset_documentation.html",
                "MONTHLYreferences": "Baker_etal1995",
                "description": "Global Climate Perspectives System",
                "MONTHLY": "MONTHLY",
                "see_also": ">Global Climate Perspectives System Home Page",
                "Conventions": "IRIDL"
            },
            "MONTHLY": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MONTHLY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "STATION": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STATION",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "WMO Station Name",
                        "units": "unitless"
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "Temperature",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm",
                            "long_name": "Precipitation",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "scale_max": "180.0",
                        "long_name": "longitude",
                        "scale_min": "-180.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "long_name": "latitude",
                        "scale_min": "-90.0"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "Elevation",
                        "missing_value": "-999.0"
                    },
                    "country_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country name",
                        "units": "unitless"
                    },
                    "country_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country code",
                        "units": "unitless"
                    }
                },
                "GRIDDED": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GRIDDED",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "anomalies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomalies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Celsius",
                            "missing_value": "-999.99902",
                            "history": ">NOAA Baseline Climatological Dataset</a>"
                        }
                    },
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "anomalies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomalies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm",
                            "references": "Baker_etal1995",
                            "history": ">NOAA Baseline Climatological Dataset</a>",
                            "missing_value": "-9999.9902"
                        }
                    }
                }
            },
            "IWMO_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "IWMO_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "T",
                "calendar": "360"
            },
            "IWMO": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NOAA/GCPS"
        },
        "NCDC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NCDC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "USHCNlong_name": "United States Historical Climatology Network",
                "USHCNreferences": "Karl_etal1990",
                "USHCNdescription": "Monthly averaged maximum, minimum, and mean temperature and total monthly precipitation from stations in the United States",
                "USHCNdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.USHCN.dataset_documentation.html",
                "USHCNdetailed_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.USHCN.detailed_documentation.html",
                "PaleoTreeringReconstructionsWahl2012Reconlong_name": "1500-1980 Temperature Reconstruction",
                "PaleoTreeringReconstructionsWahl2012Recondata": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/contributions_by_author/wahl2012/",
                "PaleoTreeringReconstructionsWahl2012Recondocumentation": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/contributions_by_author/wahl2012/readme-wahl2012.txt",
                "PaleoTreeringReconstructionsWahl2012references": "Wahl_Smerdon2012",
                "PaleoTreeringReconstructionsWahl2012description": "Western North America 500 Year Annual Temperature Reconstruction",
                "PaleoTreeringReconstructionsWahl2012documentation": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/contributions_by_author/wahl2012/readme-wahl2012.txt",
                "PaleoTreeringReconstructionsWahl2012data": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/contributions_by_author/wahl2012/",
                "PaleoTreeringReconstructionsBriffa1992osr125long_name": "1600-1983 Temperature Reconstruction",
                "PaleoTreeringReconstructionsBriffa1992osr125note": "Anomalies are calculated with respect to the 1951-1970 climatological base period",
                "PaleoTreeringReconstructionsBriffa1992osr115long_name": "1750-1983 Temperature Reconstruction",
                "PaleoTreeringReconstructionsBriffa1992osr115note": "Anomalies are calculated with respect to the 1951-1970 climatological base period",
                "PaleoTreeringReconstructionsBriffa1992references": "Briffa_etal2002 Briffa_etal1992",
                "PaleoTreeringReconstructionsBriffa1992description": "Western North America Gridpoint and Regional Summer Temperature Reconstructions",
                "PaleoTreeringReconstructionsBriffa1992data": "ftp://ftp.ncdc.noaa.gov/pub/data/paleo/treering/reconstructions/westnamerica/briffa1992/briffa1992.txt",
                "PaleoTreeringReconstructionsBriffa1992dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.Paleo.Treering.Reconstructions.Briffa1992.dataset_documentation.html",
                "Paleodescription": "NOAA Paleoclimatology",
                "OISSTversion2p1AVHRRplatform_vocabulary": "Global Change Master Directory (GCMD) Platform Keywords",
                "OISSTversion2p1AVHRRgeospatial_lat_units": "degrees_north",
                "OISSTversion2p1AVHRRprocessing_level": "NOAA Level 4",
                "OISSTversion2p1AVHRRnaming_authority": "gov.noaa.ncei",
                "OISSTversion2p1AVHRRcreator_url": "https://www.ncei.noaa.gov/",
                "OISSTversion2p1AVHRRcomment": "Data was converted from NetCDF-3 to NetCDF-4 format with metadata updates in November 2017.",
                "OISSTversion2p1AVHRRinstitution": "NOAA/National Centers for Environmental Information",
                "OISSTversion2p1AVHRRgeospatial_lat_min": "-90.0",
                "OISSTversion2p1AVHRRgeospatial_lon_resolution": "0.25",
                "OISSTversion2p1AVHRRsource": "ICOADS, NCEP_GTS, GSFC_ICE, NCEP_ICE, Pathfinder_AVHRR, Navy_AVHRR",
                "OISSTversion2p1AVHRRinstrument": "Earth Remote Sensing Instruments > Passive Remote Sensing > Spectrometers/Radiometers > Imaging Spectrometers/Radiometers > AVHRR > Advanced Very High Resolution Radiometer",
                "OISSTversion2p1AVHRRConventions": "CF-1.6, ACDD-1.3",
                "OISSTversion2p1AVHRRhistory": "Final file created using preliminary as first guess, and 3 days of AVHRR data. Preliminary uses only 1 day of AVHRR data.",
                "OISSTversion2p1AVHRRgeospatial_lat_resolution": "0.25",
                "OISSTversion2p1AVHRRinstrument_vocabulary": "Global Change Master Directory (GCMD) Instrument Keywords",
                "OISSTversion2p1AVHRRtitle": "NOAA/NCEI 1/4 Degree Daily Optimum Interpolation Sea Surface Temperature (OISST) Analysis, Version 2.1 - Final",
                "OISSTversion2p1AVHRRncei_template_version": "NCEI_NetCDF_Grid_Template_v2.0",
                "OISSTversion2p1AVHRRgeospatial_lon_max": "360.0",
                "OISSTversion2p1AVHRRmetadata_link": "https://doi.org/10.25921/RE9P-PT57",
                "OISSTversion2p1AVHRRkeywords": "Earth Science > Oceans > Ocean Temperature > Sea Surface Temperature",
                "OISSTversion2p1AVHRRreferences": "Reynolds, et al.(2007) Daily High-Resolution-Blended Analyses for Sea Surface Temperature (available at https://doi.org/10.1175/2007JCLI1824.1). Banzon, et al.(2016) A long-term record of blended satellite and in situ sea-surface temperature for climate monitoring, modeling and environmental studies (available at https://doi.org/10.5194/essd-8-165-2016). Huang et al. (2020) Improvements of the Daily Optimum Interpolation Sea Surface Temperature (DOISST) Version v02r01, submitted.Climatology is based on 1971-2000 OI.v2 SST. Satellite data: Pathfinder AVHRR SST and Navy AVHRR SST. Ice data: NCEP Ice and GSFC Ice.",
                "OISSTversion2p1AVHRRgeospatial_lat_max": "90.0",
                "OISSTversion2p1AVHRRproduct_version": "Version v02r01",
                "OISSTversion2p1AVHRRcreator_email": "oisst-help@noaa.gov",
                "OISSTversion2p1AVHRRkeywords_vocabulary": "Global Change Master Directory (GCMD) Earth Science Keywords",
                "OISSTversion2p1AVHRRsummary": "NOAAs 1/4-degree Daily Optimum Interpolation Sea Surface Temperature (OISST) (sometimes referred to as Reynolds SST, which however also refers to earlier products at different resolution), currently available as version v02r01, is created by interpolating and extrapolating SST observations from different sources, resulting in a smoothed complete field. The sources of data are satellite (AVHRR) and in situ platforms (i.e., ships and buoys), and the specific datasets employed may change over time. At the marginal ice zone, sea ice concentrations are used to generate proxy SSTs.  A preliminary version of this file is produced in near-real time (1-day latency), and then replaced with a final version after 2 weeks. Note that this is the AVHRR-ONLY DOISST, available from Oct 1981, but there is a companion DOISST product that includes microwave satellite data, available from June 2002",
                "OISSTversion2p1AVHRRcdm_data_type": "Grid",
                "OISSTversion2p1AVHRRsensor": "Thermometer, AVHRR",
                "OISSTversion2p1AVHRRplatform": "Ships, buoys, Argo floats, MetOp-A, MetOp-B",
                "OISSTversion2p1AVHRRgeospatial_lon_units": "degrees_east",
                "OISSTversion2p1AVHRRgeospatial_lon_min": "0.0",
                "OISSTversion2p1AVHRRexpires": "1614902400",
                "OISSTversion2p1AVHRRstandard_name_vocabulary": "CF Standard Name Table (v40, 25 January 2017)",
                "OISSTversion2p1FAQ": "https://www.ncdc.noaa.gov/oisst/oisst-frequently-asked-questions",
                "OISSTversion2p1OISSTv21_Product_Page": "https://www.ncdc.noaa.gov/oisst/optimum-interpolation-sea-surface-temperature-oisst-v21",
                "OISSTversion2p1source": "https://www.ncei.noaa.gov/data/sea-surface-temperature-optimum-interpolation/v2.1/access/avhrr/",
                "OISSTversion2p1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.OISST.version2p1.dataset_documentation.html",
                "OISSTversion2p1References": "https://www.ncdc.noaa.gov/oisst/references",
                "OISSTversion2p1Data_Access": "https://www.ncdc.noaa.gov/oisst/data-access",
                "OISSTversion2AVHRRAMSRHistory": "Version 2.0",
                "OISSTversion2AVHRRAMSRContact": "Dick Reynolds, email: Richard.W.Reynolds@noaa.gov & Chunying Liu, email: Chunying.liu@noaa.gov",
                "OISSTversion2AVHRRAMSRSource": "NOAA/National Climatic Data Center",
                "OISSTversion2AVHRRAMSRDescription": "Reynolds, et al.(2007) Daily High-resolution Blended Analyses. Available at ftp://eclipse.ncdc.noaa.gov/pub/OI-daily/daily-sst.pdf  Climatology is based on 1971-2000 OI.v2 SST, Satellite data: AMSR Navy NOAA18 METOP AVHRR, Ice data: NCEP ice",
                "OISSTversion2AVHRRAMSRreferences": "Cavalieri_etal1997 Grumbine_etal1996 May_etal1998 Reynolds_etal2007",
                "OISSTversion2AVHRRAMSRtitle": "Daily-OI-V2, Interim, Data (Ship, Buoy, AMSR, AVHRR: NOAA19, METOP, NCEP-ice)",
                "OISSTversion2AVHRRAMSRConventions": "CF-1.0",
                "OISSTversion2AVHRRAMSRcreation_date": "2011-10-05",
                "OISSTversion2AVHRRHistory": "Version 2.0",
                "OISSTversion2AVHRRContact": "Dick Reynolds, email: Richard.W.Reynolds@noaa.gov & Chunying Liu, email: Chunying.liu@noaa.gov",
                "OISSTversion2AVHRRSource": "NOAA/National Climatic Data Center",
                "OISSTversion2AVHRRDescription": "Reynolds, et al.(2007) Daily High-resolution Blended Analyses. Available at ftp://eclipse.ncdc.noaa.gov/pub/OI-daily/daily-sst.pdf  Climatology is based on 1971-2000 OI.v2 SST, Satellite data: Navy NOAA18 METOP AVHRR, Ice data: NCEP ice",
                "OISSTversion2AVHRRreferences": "Cavalieri_etal1997 Grumbine_etal1996 May_etal1998 Reynolds_etal2007",
                "OISSTversion2AVHRRtitle": "Daily-OI-V2, Interim, Data (Ship, Buoy, AVHRR: NOAA19, METOP, NCEP-ice)",
                "OISSTversion2AVHRRConventions": "CF-1.0",
                "OISSTversion2AVHRRcreation_date": "2012-01-06",
                "OISSTversion2OISSTv2_Product_Page": "http://www.ncdc.noaa.gov/oa/climate/research/sst/oi-daily.php",
                "OISSTversion2OISST_Analysis_Changes": "http://www.ncdc.noaa.gov/oa/climate/research/sst/papers/OI_update.pdf",
                "OISSTversion2references": "Cavalieri_etal1997 Grumbine_etal1996 May_etal1998 Reynolds_etal2007",
                "OISSTversion2source": "ftp://eclipse.ncdc.noaa.gov/pub/OI-daily-v2/NetCDF-uncompress/",
                "OISSTversion2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.OISST.version2.dataset_documentation.html",
                "OISSTversion2whatsnewv2": "http://www.ncdc.noaa.gov/oa/climate/research/sst/papers/whats-new-v2.pdf",
                "OISSTversion2source2": "https://www.ncei.noaa.gov/data/sea-surface-temperature-optimum-interpolation/access/avhrr-only/",
                "GHCN_Dailyversion1long_name": "Global Historical Climatology Network - Daily",
                "GHCN_Dailyversion1references": "Vose_etal1992",
                "GHCN_Dailyversion1description": "Global daily precipitation, minimum temperature, and maximum temperature data",
                "GHCN_Dailyversion1agreementhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GHCN_Daily.version1.agreement.html",
                "GHCN_Dailyversion1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GHCN_Daily.version1.dataset_documentation.html",
                "GHCNv2betadescription": "Monthly weather station precipitation data from the Global Historical Climate Network",
                "GHCNv2betalong_name": "beta version 2 (prcp)",
                "GHCNv2betareferences": "Vose_etal1992",
                "GHCNv2betaagreementhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GHCN.v2beta.agreement.html",
                "GHCNv2long_name": "version 2",
                "GHCNv2references": "Vose_etal1992 Easterling_Peterson1995a Easterling_Peterson1995b Easterling_etal1996 Peterson_Easterling1994 Peterson_Vose1997 Peterson_etal1997",
                "GHCNv2description": "Monthly weather station temperature data from the Global Historical Climate Network",
                "GHCNv2agreementhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GHCN.v2.agreement.html",
                "GHCNv2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GHCN.v2.dataset_documentation.html",
                "GHCNdescription": "Global Historical Climatology Network: monthly weather station temperature and precipitation",
                "GDCNlong_name": "Global Daily Climatology Network",
                "GDCNdescription": "Daily precipitation and minimum and maximum temperature data from the Global Daily Climatology Network",
                "GDCNagreementhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GDCN.agreement.html",
                "GDCNdocumentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GDCN.documentation.html",
                "GDCNiridlhasSemantics": "iriref:Vose_RS",
                "GDCNdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GDCN.dataset_documentation.html",
                "GCPSMONTHLYSTATIONreferences": "Baker_etal1995",
                "GCPSMONTHLYSTATIONdescription": "Baseline climatological dataset of weather station temperature and precipitation data derived from the Glocal Historical Climate Network",
                "GCPSMONTHLYSTATIONdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GCPS.MONTHLY.STATION.dataset_documentation.html",
                "GCPSMONTHLYGRIDDEDdescription": "Baseline climatological dataset of gridded temperature and precipitation anomalies derived from the Global Historical Climate Network",
                "GCPSMONTHLYGRIDDEDdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.GCPS.MONTHLY.GRIDDED.dataset_documentation.html",
                "GCPSMONTHLYreferences": "Baker_etal1995",
                "GCPSdescription": "Global Climate Perspectives System",
                "ERSSTversion5spatial_resolution": "2.0 degree grid",
                "ERSSTversion5license": "No constraints on data access or use",
                "ERSSTversion5geospatial_lat_units": "degrees_north",
                "ERSSTversion5processing_level": "NOAA Level 4",
                "ERSSTversion5naming_authority": "gov.noaa.ncei",
                "ERSSTversion5creator_url": "http://www.ncei.noaa.gov",
                "ERSSTversion5comment": "SSTs were observed by conventional thermometers in Buckets (insulated or un-insulated canvas and wooden buckets), Engine Room Intakers, or floats and drifters",
                "ERSSTversion5publisher_email": "boyin.huang@noaa.gov",
                "ERSSTversion5institution": "NOAA/NESDIS/NCEI/CCOG",
                "ERSSTversion5ERSSTv5": "https://www.ncdc.noaa.gov/data-access/marineocean-data/extended-reconstructed-sea-surface-temperature-ersst-v5",
                "ERSSTversion5geospatial_lat_min": "-89.0",
                "ERSSTversion5geospatial_lon_resolution": "2.0",
                "ERSSTversion5source": "In situ data: ICOADS R3.0 before 2015, NCEP in situ GTS from 2016 to present, and Argo SST from 1999 to present. Ice data: HadISST2 ice before 2015, and NCEP ice after 2015.",
                "ERSSTversion5instrument": "Conventional thermometers",
                "ERSSTversion5Conventions": "CF-1.6, ACDD-1.3",
                "ERSSTversion5geospatial_lat_resolution": "2.0",
                "ERSSTversion5title": "NOAA ERSSTv5 (in situ only)",
                "ERSSTversion5geospatial_lon_max": "359.0",
                "ERSSTversion5metadata_link": "https://doi.org/10.7289/V5T72FNM",
                "ERSSTversion5project": "NOAA Extended Reconstructed Sea Surface Temperature (ERSST)",
                "ERSSTversion5keywords": "Earth Science > Oceans > Ocean Temperature > Sea Surface Temperature >",
                "ERSSTversion5references": "Huang_etal2017",
                "ERSSTversion5geospatial_lat_max": "89.0",
                "ERSSTversion5product_version": "Version 5",
                "ERSSTversion5creator_name": "Boyin Huang",
                "ERSSTversion5creator_email": "boyin.huang@noaa.gov",
                "ERSSTversion5publisher_name": "Boyin Huang",
                "ERSSTversion5keywords_vocabulary": "NASA Global Change Master Directory (GCMD) Science Keywords",
                "ERSSTversion5summary": "ERSST.v5 is developed based on v4 after revisions of 8 parameters using updated data sets and advanced knowledge of ERSST analysis",
                "ERSSTversion5cdm_data_type": "Grid",
                "ERSSTversion5description": "ERSST.v5: Extended Reconstructed Sea Surface Temperature Dataset, Version 5.",
                "ERSSTversion5platform": "Ship and Buoy SSTs from ICOADS R3.0 and NCEP GTS",
                "ERSSTversion5geospatial_lon_units": "degrees_east",
                "ERSSTversion5climatology": "Climatology is based on 1971-2000 SST, Xue, Y., T. M. Smith, and R. W. Reynolds, 2003: Interdecadal changes of 30-yr SST normals during 1871.2000. Journal of Climate, 16, 1601-1612.",
                "ERSSTversion5geospatial_lon_min": "-1.0",
                "ERSSTversion5Metadata_Conventions": "CF-1.6, Unidata Dataset Discovery v1.0",
                "ERSSTversion5expires": "1617321600",
                "ERSSTversion5standard_name_vocabulary": "CF Standard Name Table (v40, 25 January 2017)",
                "ERSSTversion4spatial_resolution": "2.0 degree grid",
                "ERSSTversion4license": "No constraints on data access or use",
                "ERSSTversion4geospatial_lat_units": "degrees_north",
                "ERSSTversion4processing_level": "L4",
                "ERSSTversion4naming_authority": "gov.noaa.ncdc",
                "ERSSTversion4creator_url": "http://www.ncdc.noaa.gov",
                "ERSSTversion4comment": "SSTs were observed by conventional thermometers in Buckets (in sulated or un-insulated canvas and wooded buckets), Engine Room Intakers, or floats and drifters",
                "ERSSTversion4publisher_email": "boyin.huang@noaa.gov",
                "ERSSTversion4institution": "NOAA/NESDIS/NCEI/CCOG",
                "ERSSTversion4ERSSTv4": "http://www.ncdc.noaa.gov/data-access/marineocean-data/extended-reconstructed-sea-surface-temperature-ersst-v4",
                "ERSSTversion4geospatial_lat_min": "-89.0",
                "ERSSTversion4geospatial_lon_resolution": "2.0",
                "ERSSTversion4source": "ICOADS R2.5 SST, NCEP GTS SST, HadISST ice, NCEP ice",
                "ERSSTversion4instrument": "Conventional thermometers",
                "ERSSTversion4Conventions": "CF-1.6",
                "ERSSTversion4geospatial_lat_resolution": "2.0",
                "ERSSTversion4title": "NOAA ERSSTv4 (in situ only)",
                "ERSSTversion4geospatial_lon_max": "359.0",
                "ERSSTversion4metadata_link": "C00884",
                "ERSSTversion4project": "NOAA Extended Reconstructed Sea Surface Temperature (ERSST)",
                "ERSSTversion4keywords": "Earth Science > Oceans > Ocean Temperature > Sea Sur face Temperature >",
                "ERSSTversion4geospatial_lat_max": "89.0",
                "ERSSTversion4references": "Huang_etal2015 Liu_etal2015",
                "ERSSTversion4creator_email": "boyin.huang@noaa.gov",
                "ERSSTversion4creator_name": "Boyin Huang",
                "ERSSTversion4id": "ersst.v4.201701",
                "ERSSTversion4publisher_name": "Boyin Huang",
                "ERSSTversion4keywords_vocabulary": "NASA Global Change Master Directory (GCMD) Science Keywords",
                "ERSSTversion4summary": "ERSST.v4 is developped based on v3b after revisions of 11 parameters using updated data sets and advanced knowledge of ERSST analysis",
                "ERSSTversion4production_version": "Version 5",
                "ERSSTversion4platform": "Ship and Buoy SSTs from ICOADS R2.5 and NCEP GTS",
                "ERSSTversion4cdm_data_type": "Grid",
                "ERSSTversion4description": "In situ data: ICOADS2.5 before 2007, NCEP in situ data from 2008 to present. Ice data: HadISST ice before 2015 and NCEP ice after 2015.",
                "ERSSTversion4geospatial_lon_units": "degrees_east",
                "ERSSTversion4climatology": "Climatology is based on 1971-2000 SST, Xue, Y., T. M. Smith, and R. W. Reynolds, 2003: Interdecadal changes of 30-yr SST normals during 1871.2000. Journal of Climate, 16, 1601-1612.",
                "ERSSTversion4geospatial_lon_min": "-1.0",
                "ERSSTversion4Metadata_Conventions": "CF-1.6, Unidata Dataset Discovery v1.0",
                "ERSSTversion4standard_name_vocabulary": "CF Standard Name Table v27",
                "ERSSTversion3bspatial_resolution": "2.0 degree grid",
                "ERSSTversion3bgeospatial_lat_units": "degrees_north",
                "ERSSTversion3blicense": "No constraints on data access or use",
                "ERSSTversion3bprocessing_level": "L4",
                "ERSSTversion3bnaming_authority": "gov.noaa.ncdc",
                "ERSSTversion3bcreator_url": "http://www.ncdc.noaa.gov",
                "ERSSTversion3bcomment": "SSTs were observed by conventional thermometers in Buckets (in sulated or un-insulated canvas and wooded buckets), Engine Room Intakers, or floats and drifters",
                "ERSSTversion3bnetcdf_Convention": "COARDS",
                "ERSSTversion3bpublisher_email": "boyin.huang@noaa.gov",
                "ERSSTversion3binstitution": "NOAA/NESDIS/NCEI/CCOG",
                "ERSSTversion3bgeospatial_lat_min": "-89.0",
                "ERSSTversion3bgeospatial_lon_resolution": "2.0",
                "ERSSTversion3bsource": "ICOADS R2.5 SST, NCEP GTS SST, HadISST ice, NCEP ice",
                "ERSSTversion3bERSSTv3": "http://www.ncdc.noaa.gov/oa/climate/research/sst/papers/SEA.temps08.pdf",
                "ERSSTversion3blong_name": "version3b",
                "ERSSTversion3binstrument": "Conventional thermometers",
                "ERSSTversion3bConventions": "CF-1.6",
                "ERSSTversion3bhistory": "Version 3b",
                "ERSSTversion3bgeospatial_lat_resolution": "2.0",
                "ERSSTversion3btitle": "ERSST V3b in situ only",
                "ERSSTversion3bcontact": "Dick Reynolds, email: Richard.W.Reynolds@noaa.gov & Chunying Liu, email: Chunying.liu@noaa.gov",
                "ERSSTversion3bgeospatial_lon_max": "359.0",
                "ERSSTversion3bmetadata_link": "C00884",
                "ERSSTversion3bproject": "NOAA Extended Reconstructed Sea Surface Temperature (ERSST)",
                "ERSSTversion3bERSSTv4": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.ERSST/.version4/",
                "ERSSTversion3bkeywords": "Earth Science > Oceans > Ocean Temperature > Sea Sur face Temperature >",
                "ERSSTversion3breferences": "Smith_etal2008 Xue_etal2003",
                "ERSSTversion3bgeospatial_lat_max": "89.0",
                "ERSSTversion3bcreator_name": "Boyin Huang",
                "ERSSTversion3bcreator_email": "boyin.huang@noaa.gov",
                "ERSSTversion3bpublisher_name": "Boyin Huang",
                "ERSSTversion3bkeywords_vocabulary": "NASA Global Change Master Directory (GCMD) Science Keywords",
                "ERSSTversion3bsummary": "ERSST.v3b is developped based on Smith and Reynolds 2003",
                "ERSSTversion3bproduction_version": "Version 5",
                "ERSSTversion3bcdm_data_type": "Grid",
                "ERSSTversion3bplatform": "Ship and Buoy SSTs from ICOADS R2.5 and NCEP GTS",
                "ERSSTversion3bdescription": "In situ data: ICOADS2.5 before 2007, NCEP in situ data from 2008 to present. Ice data: HadISST ice before 2015 and NCEP ice after 2015.",
                "ERSSTversion3bgeospatial_lon_units": "degrees_east",
                "ERSSTversion3bclimatology": "Climatology is based on 1971-2000 SST, Xue, Y., T. M. Smith, and R. W. Reynolds, 2003: Interdecadal changes of 30-yr SST normals during 1871.2000. Journal of Climate, 16, 1601-1612.",
                "ERSSTversion3bgeospatial_lon_min": "-1.0",
                "ERSSTversion3bMetadata_Conventions": "CF-1.6, Unidata Dataset Discovery v1.0",
                "ERSSTversion3bstandard_name_vocabulary": "CF Standard Name Table v27",
                "ERSSTversion2references": "Smith_Reynolds2004",
                "ERSSTversion2description": "Improved extended reconstructed global sea surface temperature data based on COADS data",
                "ERSSTversion2NCDC": "http://lwf.ncdc.noaa.gov/oa/climate/research/sst/sst.html",
                "ERSSTversion2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.ERSST.version2.dataset_documentation.html",
                "ERSSTversion2ERSSTv3": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.ERSST/.version3/",
                "ERSSTversion1ERSSTv2": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.ERSST/.version2/",
                "ERSSTversion1references": "Smith_Reynolds2003",
                "ERSSTversion1description": "Extended reconstructed global sea surface temperature data based on COADS data",
                "ERSSTversion1NCDC": "http://lwf.ncdc.noaa.gov/oa/climate/research/sst/sst.html",
                "ERSSTversion1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.ERSST.version1.dataset_documentation.html",
                "DAILYGLOBALSODdescription": "Global daily WMO weather station data",
                "DAILYGLOBALSODagreementhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.DAILY.GLOBALSOD.agreement.html",
                "DAILYGLOBALSODdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.DAILY.GLOBALSOD.dataset_documentation.html",
                "DAILYFSODNote": "This is a testing version of the data",
                "DAILYFSODreferences": "NCDC1993",
                "DAILYFSODdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.DAILY.FSOD.dataset_documentation.html",
                "DAILYFSODdescription": "Daily weather station data primarily from the United States and parts of South Pacific and Europe",
                "DAILYSTATIONhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.DAILY.STATION.html",
                "CIRSnClimDivv1source": "ftp://ftp.ncdc.noaa.gov/pub/data/cirs/climdiv/",
                "CIRSnClimDivv1description": "Time bias corrected temperature, precipitation, and drought index data for United States climate divisions from the National Climatic Data Center",
                "CIRSnClimDivv1iridlhasSemantics": "iridl:Climate_Division",
                "CIRSnClimDivv1nClimDiv": "ftp://ftp.ncdc.noaa.gov/pub/data/cirs/climdiv/nCLIMDIV-briefing-cirs.pdf",
                "CIRSnClimDivv1format": "ftp://ftp.ncdc.noaa.gov/pub/data/cirs/climdiv/divisional-readme.txt",
                "CIRSnClimDivv1drought": "ftp://ftp.ncdc.noaa.gov/pub/data/cirs/climdiv/drought-readme.txt",
                "CIRSnClimDivv1transition": "ftp://ftp.ncdc.noaa.gov/pub/data/cirs/climdiv/div-dataset-transition-readme.txt",
                "CIRSClimateDivisiondescription": "Time bias corrected temperature, precipitation, and drought index data for United States climate divisions from the National Climatic Data Center",
                "CIRSClimateDivisioniridlhasSemantics": "iridl:Climate_Division",
                "CIRSClimateDivisiondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.CIRS.ClimateDivision.dataset_documentation.html",
                "CIRSClimateDivisionnClimDiv": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCDC/.CIRS/.nClimDiv/.v1/",
                "CIRSdescription": "Climate Index Reference Sequential",
                "CDRPERSIANNCDRv01r01NCEI": "https://www.ncdc.noaa.gov/cdr/atmospheric/precipitation-persiann-cdr",
                "CDRPERSIANNCDRv01r01Maturity": "https://www1.ncdc.noaa.gov/pub/data/sds/cdr/CDRs/PERSIANN/MaturityMatrix_01B-16.pdf",
                "CDRPERSIANNCDRv01r01Data": "https://www.ncei.noaa.gov/data/precipitation-persiann/access/",
                "CDRPERSIANNCDRv01r01Algorithm": "https://www1.ncdc.noaa.gov/pub/data/sds/cdr/CDRs/PERSIANN/AlgorithmDescription_01B-16.pdf",
                "CDRPERSIANNCDRv01r01references": "Ashouri_etal2015",
                "CDRPERSIANNCDRv01r01description": "Version 1 Revision 1",
                "CDRPERSIANNCDRv01r01Overview": "https://www1.ncdc.noaa.gov/pub/data/sds/cdr/CDRs/PERSIANN/CDR_Flyer_01B-16.pdf",
                "CDRPERSIANNCDRv01r01THREDDS": "https://www.ncei.noaa.gov/thredds/satellite/persiann.html",
                "CDRPERSIANNCDRv01r01Use": "https://www1.ncdc.noaa.gov/pub/data/sds/cdr/CDRs/PERSIANN/UseAgreement_01B-16.pdf",
                "CDRPERSIANNCDRdescription": "Precipitation Estimation from Remotely Sensed Information using Artificial Neural Networks",
                "CDRClimate": "http://www.ncdc.noaa.gov/cdr/operationalcdrs.html",
                "description": "National Climatic Data Center",
                "Conventions": "IRIDL",
                "iridlhasSemantics": "iridl:NCDC",
                "NCDC": "http://www.ncdc.noaa.gov/"
            },
            "USHCN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "USHCN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "urban": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "urban",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "calc_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "calc_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                },
                "tos": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tos",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "calc_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "calc_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                },
                "statediv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "statediv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "State Division",
                    "units": "ids"
                },
                "state": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "state",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "long_name": "state",
                    "CLIST": "WY",
                    "scale_max": "48",
                    "scale_min": "1"
                },
                "raw": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raw",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "scale_max": "-60.0",
                    "scale_min": "-130.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "scale_max": "50.0",
                    "scale_min": "20.0"
                },
                "filnet": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "filnet",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "calc_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "calc_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999",
                    "units": "m"
                },
                "cfv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cfv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                }
            },
            "SSMI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SSMI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "weekly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "weekly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "full": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "full",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wetness",
                            "iridlhasSemantics": "iridl:BWI",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        },
                        "SW": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "snow",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        },
                        "BL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "blended temperature",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        }
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wetness",
                            "iridlhasSemantics": "iridl:BWI",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        },
                        "SW": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "snow",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        },
                        "BL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "blended temperature",
                            "missing_value": "-99.0",
                            "standard_name": "time"
                        }
                    }
                },
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "full": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "full",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wetness",
                            "missing_value": "-99.0",
                            "iridlhasSemantics": "iridl:BWI",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "SW": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "snow",
                            "missing_value": "-99.0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "BL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "blended temperature",
                            "missing_value": "-99.0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        }
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wetness",
                            "missing_value": "-99.0",
                            "iridlhasSemantics": "iridl:BWI",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "SW": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "snow",
                            "missing_value": "-99.0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "BL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "blended temperature",
                            "missing_value": "-99.0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        }
                    }
                }
            },
            "Paleo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Paleo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Treering": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Treering",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Reconstructions": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Reconstructions",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Wahl2012": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Wahl2012",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Recon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Recon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "colormap": "2237106",
                                    "scale_max": "6.0",
                                    "ncolor": "254",
                                    "scale_min": "-6.0",
                                    "CS": "-6.0",
                                    "colorscalename": "temp_anomaly_colors_gcm",
                                    "CE": "6.0",
                                    "long_name": "Temperature Anomaly",
                                    "standard_name": "air_temperature_anomaly",
                                    "units": "Celsius_scale",
                                    "missing_value": "-999.0"
                                },
                                "SD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature Standard Deviation",
                                    "units": "Celsius_scale",
                                    "missing_value": "-999.0"
                                },
                                "mean": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mean",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "colormap": "2237106",
                                    "scale_max": "6.0",
                                    "ncolor": "254",
                                    "scale_min": "-6.0",
                                    "CS": "-6.0",
                                    "colorscalename": "temp_anomaly_colors_gcm",
                                    "CE": "6.0",
                                    "long_name": "Mean Temperature",
                                    "standard_name": "air_temperature_anomaly",
                                    "units": "Celsius_scale",
                                    "missing_value": "-999.0"
                                },
                                "iteration": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "iteration",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "2237106",
                                        "scale_max": "6.0",
                                        "ncolor": "254",
                                        "scale_min": "-6.0",
                                        "CS": "-6.0",
                                        "colorscalename": "temp_anomaly_colors_gcm",
                                        "CE": "6.0",
                                        "long_name": "Temperature Anomaly",
                                        "standard_name": "air_temperature_anomaly",
                                        "units": "Celsius_scale",
                                        "missing_value": "-999.90002"
                                    }
                                }
                            }
                        },
                        "Briffa1992": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Briffa1992",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "osr125": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "osr125",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tanom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tanom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "long_name": "Temperature Anomaly",
                                    "missing_value": "-99.900002"
                                }
                            },
                            "osr115": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "osr115",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tanom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tanom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "long_name": "Temperature Anomaly",
                                    "missing_value": "-99.900002"
                                }
                            }
                        }
                    }
                }
            },
            "OISST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OISST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "version2p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version2p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "AVHRR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AVHRR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1614902400",
                            "long_name": "Daily sea surface temperature",
                            "valid_min": "-300",
                            "units": "Celsius_scale",
                            "scale_factor": "0.01",
                            "missing_value": "-999",
                            "valid_max": "4500",
                            "pointwidth": "1.0"
                        },
                        "ice": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ice",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1614902400",
                            "long_name": "Sea ice concentration",
                            "valid_min": "0",
                            "units": "unitless",
                            "scale_factor": "0.01",
                            "missing_value": "-999",
                            "valid_max": "100",
                            "pointwidth": "1.0"
                        },
                        "err": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "err",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1614902400",
                            "long_name": "Estimated error standard deviation of analysed_sst",
                            "valid_min": "0",
                            "units": "Celsius_scale",
                            "scale_factor": "0.01",
                            "missing_value": "-999",
                            "valid_max": "1000",
                            "pointwidth": "1.0"
                        },
                        "anom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1614902400",
                            "long_name": "Daily sea surface temperature anomalies",
                            "valid_min": "-1200",
                            "units": "Celsius_scale",
                            "scale_factor": "0.01",
                            "missing_value": "-999",
                            "valid_max": "1200",
                            "pointwidth": "1.0"
                        }
                    }
                },
                "version2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "AVHRRAMSR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AVHRR-AMSR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                            "long_name": "Daily sea surface temperature",
                            "valid_min": "-300",
                            "units": "Celsius_scale",
                            "missing_value": "-999",
                            "valid_max": "4500",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "ice": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ice",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_ice_area_fraction",
                            "long_name": "Sea ice concentration",
                            "valid_min": "0",
                            "units": "percentage",
                            "missing_value": "-999",
                            "valid_max": "100",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "err": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "err",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Estimated error standard deviation of analysed_sst",
                            "valid_min": "0",
                            "units": "degree_Celsius",
                            "missing_value": "-999",
                            "valid_max": "1000",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "anom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:SeaSurfaceTemperatureAnomaly",
                            "long_name": "Daily sea surface temperature anomalies",
                            "valid_min": "-1200",
                            "units": "degree_Celsius",
                            "missing_value": "-999",
                            "valid_max": "1200",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        }
                    },
                    "AVHRR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AVHRR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                            "long_name": "Daily sea surface temperature",
                            "valid_min": "-300",
                            "units": "Celsius_scale",
                            "missing_value": "-999",
                            "valid_max": "4500",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "ice": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ice",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "sea_ice_area_fraction",
                            "long_name": "Sea ice concentration",
                            "valid_min": "0",
                            "units": "percentage",
                            "missing_value": "-999",
                            "valid_max": "100",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "err": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "err",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Estimated error standard deviation of analysed_sst",
                            "valid_min": "0",
                            "units": "degree_Celsius",
                            "missing_value": "-999",
                            "valid_max": "1000",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        },
                        "anom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:SeaSurfaceTemperatureAnomaly",
                            "long_name": "Daily sea surface temperature anomalies",
                            "valid_min": "-1200",
                            "units": "degree_Celsius",
                            "missing_value": "-999",
                            "valid_max": "1200",
                            "scale_factor": "0.01",
                            "pointwidth": "1.0"
                        }
                    }
                }
            },
            "GHCN_Daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GHCN_Daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "version1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "WMOID": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "WMOID",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "TMIN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMIN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Min_Temperature",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "TMAX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMAX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Max_Temperature",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "STNID3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STNID3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "StationID3",
                        "units": "ids"
                    },
                    "STNID2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STNID2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "StationID2",
                        "units": "ids"
                    },
                    "STN_CODE": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STN_CODE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Station_Code",
                        "units": "unitless"
                    },
                    "QCTMIN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QCTMIN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "QCFlag-Tn",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "QCTMAX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QCTMAX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "QCFlag-Tx",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "QCPCPN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QCPCPN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "QCFlag-Pr",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "PCPN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PCPN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "long_name": "Precipitation",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "Elevation",
                        "missing_value": "-1"
                    },
                    "DMTMIN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DMTMIN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "DMFlag-Tn",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "DMTMAX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DMTMAX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "DMFlag-Tx",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "DMPCPN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DMPCPN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "DMFlag-Pr",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "CC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country_Code",
                        "units": "unitless"
                    }
                }
            },
            "GHCN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GHCN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v2beta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v2beta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "long_name": "precipitation",
                        "missing_value": "-8888",
                        "scale_factor": "0.1"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "long_name": "longitude",
                        "valid_min": "-180.0",
                        "valid_max": "180.0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "fnname": "masknotrangeperiodic",
                        "units": "degree_east",
                        "valid_min": "-180.0",
                        "valid_max": "180.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "long_name": "latitude",
                        "valid_min": "-90.0",
                        "valid_max": "90.0"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999",
                        "units": "m"
                    }
                },
                "v2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "topo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "topo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "MT",
                        "scale_max": "5",
                        "scale_min": "1"
                    },
                    "stveg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stveg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "IC",
                        "scale_max": "6",
                        "scale_min": "1"
                    },
                    "stloc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stloc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "LA",
                        "scale_max": "4",
                        "missing_value": "0",
                        "scale_min": "1"
                    },
                    "raw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "raw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Min": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Min",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "Max": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Max",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        }
                    },
                    "popnl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "popnl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "Urban",
                        "scale_max": "3",
                        "description": "population assessment based on satellite nightlight",
                        "scale_min": "1"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "valid_min": "-180.0",
                        "valid_max": "180.0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "fnname": "masknotrangeperiodic",
                        "units": "degree_east",
                        "valid_min": "-180.0",
                        "valid_max": "180.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "valid_min": "-90.0",
                        "valid_max": "90.0"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "itowndis": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "itowndis",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9",
                        "units": "unitless"
                    },
                    "ipop": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipop",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "1000",
                        "long_name": "population",
                        "missing_value": "-9"
                    },
                    "iloc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iloc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9",
                        "units": "unitless"
                    },
                    "grveg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grveg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "ANTARCTICA",
                        "scale_max": "45",
                        "scale_min": "1"
                    },
                    "elevg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elevg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999",
                        "units": "m"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999",
                        "units": "m"
                    },
                    "country": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "country code",
                        "units": "ids"
                    },
                    "apop": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "apop",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "long_name": "population_type",
                        "CLIST": "U1",
                        "scale_max": "5",
                        "scale_min": "1"
                    },
                    "airstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "airstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "x",
                        "scale_max": "2",
                        "scale_min": "1"
                    },
                    "adjusted": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adjusted",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Min": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Min",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "Max": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Max",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        }
                    }
                }
            },
            "GDCN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GDCN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WMOID": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WMOID",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "TMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "long_name": "Min_Temperature",
                    "missing_value": "-9999",
                    "scale_factor": "0.1"
                },
                "TMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "long_name": "Max_Temperature",
                    "missing_value": "-9999",
                    "scale_factor": "0.1"
                },
                "STID3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STID3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "StationID3",
                    "units": "ids"
                },
                "STID2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STID2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "StationID2",
                    "units": "ids"
                },
                "QCTMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QCTMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "QCFlag-Tn",
                    "missing_value": "-9999",
                    "units": "unitless"
                },
                "QCTMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QCTMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "QCFlag-Tx",
                    "missing_value": "-9999",
                    "units": "unitless"
                },
                "QCPCPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "QCPCPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "QCFlag-Pr",
                    "missing_value": "-9999",
                    "units": "unitless"
                },
                "PCPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PCPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm",
                    "long_name": "Precipitation",
                    "missing_value": "-9999",
                    "scale_factor": "0.1"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "long_name": "Elevation",
                    "missing_value": "0"
                },
                "DMPCPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DMPCPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "DMFlag-Pr",
                    "missing_value": "-9999",
                    "units": "unitless"
                },
                "CC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Country_Code",
                    "units": "unitless"
                }
            },
            "GCPS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GCPS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "STATION": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STATION",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "WMO Station Name",
                            "units": "unitless"
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "long_name": "Precipitation",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "scale_max": "180.0",
                            "long_name": "longitude",
                            "scale_min": "-180.0"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "scale_max": "90.0",
                            "long_name": "latitude",
                            "scale_min": "-90.0"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Elevation",
                            "missing_value": "-999.0"
                        },
                        "country_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "country_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country name",
                            "units": "unitless"
                        },
                        "country_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "country_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country code",
                            "units": "unitless"
                        }
                    },
                    "GRIDDED": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GRIDDED",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "anomalies": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anomalies",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "missing_value": "-999.99902",
                                "history": ">NOAA Baseline Climatological Dataset</a>"
                            }
                        },
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "anomalies": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anomalies",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "references": "Baker_etal1995",
                                "history": ">NOAA Baseline Climatological Dataset</a>",
                                "missing_value": "-9999.9902"
                            }
                        }
                    }
                }
            },
            "ERSST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERSST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "version5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                        "expires": "1617321600",
                        "long_name": "Extended reconstructed sea surface temperature",
                        "units": "Celsius_scale",
                        "valid_min": "-3.0",
                        "valid_max": "45.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "anom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "scale_max": "4.1999998",
                        "ncolor": "254",
                        "scale_min": "-4.1999998",
                        "CS": "-4.1999998",
                        "colorscalename": "sstacolorscale",
                        "CE": "4.1999998",
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperatureAnomaly",
                        "expires": "1617321600",
                        "long_name": "Extended reconstructed SST anomalies",
                        "units": "degree_Celsius",
                        "valid_min": "-12.0",
                        "valid_max": "12.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "version4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                        "long_name": "Extended reconstructed sea surface temperature",
                        "units": "Celsius_scale",
                        "valid_min": "-3.0",
                        "valid_max": "45.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "IOD": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IOD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "C19832015": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1983-2015",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1983-2015",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19832014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1983-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1983-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19832010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1983-2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1983-2010",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19812015": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1981-2015",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1981-2015",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19812014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1981-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1981-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19812010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1981-2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1981-2010",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19792014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1979-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1979-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19612015": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1961-2015",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1961-2015",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19612014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1961-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1961-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19612010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1961-2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1961-2010",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "anom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperatureAnomaly",
                        "long_name": "Extended reconstructed SST anomalies",
                        "units": "degree_Celsius",
                        "valid_min": "-12.0",
                        "valid_max": "12.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "version3b": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version3b",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                        "long_name": "Extended reconstructed sea surface temperature",
                        "units": "degree_Celsius",
                        "valid_min": "-3.0",
                        "valid_max": "45.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "IOD": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IOD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "C19832014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1983-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1983-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19832010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1983-2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1983-2010",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        },
                        "C19612014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C1961-2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iod": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iod",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "2.0",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "CE": "2",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "ncolor": "254",
                                "colorscalename": "sstacolorscale",
                                "long_name": "Indian Ocean Dipole 1961-2014",
                                "units": "degree_Celsius",
                                "history": "Averaged over X[89E, 111E] Y[11S, 1N] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "standard_name": "sea_surface_temperature",
                                "iridlhasSemantics": "iridl:SeaSurfaceTemperature",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "anom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "iridlhasSemantics": "iridl:SeaSurfaceTemperatureAnomaly",
                        "long_name": "Extended reconstructed SST anomalies",
                        "units": "degree_Celsius",
                        "valid_min": "-12.0",
                        "valid_max": "12.0",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "version2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SST": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SST",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea Surface Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "-9999",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Estimated sampling error variance",
                        "units": "unitless",
                        "missing_value": "-9999",
                        "scale_factor": "0.01",
                        "pointwidth": "0"
                    }
                },
                "version1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SST": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SST",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.989998",
                        "units": "Celsius_scale",
                        "long_name": "Sea Surface Temperature",
                        "scale_min": "-1.8"
                    }
                }
            },
            "DAILY": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "DAILY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GLOBALSOD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GLOBALSOD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "snow": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "Snow Depth",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "Precipitation",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "WMO Station Name",
                        "units": "unitless"
                    },
                    "minimum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "minimum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit",
                            "long_name": "Temperature",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wspeed": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wspeed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "knots",
                            "long_name": "Wind Speed",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        },
                        "visibility": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "visibility",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "miles",
                            "long_name": "Visibility",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit",
                            "long_name": "Temperature",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        },
                        "station": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "station",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "long_name": "Pressure",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "sea_level": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sea_level",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "long_name": "Pressure",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "dew_point": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dew_point",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Fahrenheit",
                                "long_name": "Temperature",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        }
                    },
                    "maximum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "maximum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit",
                            "long_name": "Temperature",
                            "missing_value": "-9999",
                            "scale_factor": "0.1"
                        },
                        "sustained": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sustained",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wspeed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wspeed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "knots",
                                "long_name": "Wind Speed",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        },
                        "gust": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gust",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wspeed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wspeed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "knots",
                                "long_name": "Wind Speed",
                                "missing_value": "-9999",
                                "scale_factor": "0.1"
                            }
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "longitude",
                        "units": "degree_east"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "latitude",
                        "units": "degree_north"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Elevation",
                        "units": "m"
                    },
                    "country_state": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_state",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country/State Abbreviation",
                        "units": "unitless"
                    },
                    "call": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "call",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "WMO Station Call Letters",
                        "units": "unitless"
                    },
                    "badw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "badw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "Funnel Cloud Thunder Hail Snow Rain Fog",
                        "scale_max": "63",
                        "long_name": "Bad Weather Indicator",
                        "missing_value": "0",
                        "scale_min": "1"
                    }
                },
                "FSOD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FSOD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "TSUN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TSUN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "minutes",
                        "long_name": "daily total sun",
                        "missing_value": "-9999"
                    },
                    "TMPW": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMPW",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Fahrenheit_scale",
                        "long_name": "average wet-bulb temperature",
                        "missing_value": "-9999"
                    },
                    "TMIN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMIN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Fahrenheit_scale",
                        "long_name": "minimum temperature",
                        "missing_value": "-9999"
                    },
                    "TMAX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMAX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Fahrenheit_scale",
                        "long_name": "maximum temperature",
                        "missing_value": "-9999"
                    },
                    "THIC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "THIC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "thickness of ice on water",
                        "scale_factor": "0.1"
                    },
                    "STSS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STSS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover sunrise to sunset (GOES)",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "STMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover midnight to midnight (GOES)",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SNWD": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNWD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "snow depth",
                        "missing_value": "-9999",
                        "units": "unitless"
                    },
                    "SNOW": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNOW",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "snowfall",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "SMSS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SMSS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover sunrise to sunset",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SMMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SMMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover midnight to midnight",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SGSS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SGSS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average cloudiness sunrise to sunset (GOES)",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SGMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SGMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average cloudiness midnight to midnight (GOES)",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SCSS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SCSS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover sunrise to sunset",
                        "units": "unitless",
                        "scale_factor": "0.1"
                    },
                    "SCMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SCMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average sky cover midnight to midnight",
                        "units": "unitless",
                        "scale_factor": "0.1"
                    },
                    "SASS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SASS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average cloudiness sunrise to sunset",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "SAMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SAMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "average cloudiness midnight to midnight",
                        "units": "unitless",
                        "scale_factor": "0.125"
                    },
                    "PSUN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PSUN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "percentage of possible sun",
                        "missing_value": "-99"
                    },
                    "PRES": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PRES",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "inch_Hg",
                        "long_name": "pressure",
                        "missing_value": "-99999",
                        "scale_factor": "0.001"
                    },
                    "PRCP": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PRCP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "precipitation",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "PKGS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PKGS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mph or knots 16 or 36 point WBAN code",
                        "long_name": "peak gust direction and speed",
                        "missing_value": "-99999"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "MXRH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MXRH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "maximum relative humidity",
                        "missing_value": "-99"
                    },
                    "MNRH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MNRH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "long_name": "minimum relative humidity",
                        "missing_value": "-99"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "scale_max": "180.0",
                        "scale_min": "-180.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "scale_max": "90.0",
                        "scale_min": "-90.0"
                    },
                    "HTDG": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "HTDG",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Fahrenheit",
                        "long_name": "heating degree days",
                        "missing_value": "-99"
                    },
                    "GAHT": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GAHT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "river gauge height",
                        "scale_factor": "0.1"
                    },
                    "FRGT": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRGT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "top of frozen ground layer",
                        "units": "in"
                    },
                    "FRGH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRGH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "thickness of frozen ground layer",
                        "units": "in"
                    },
                    "FRGB": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FRGB",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "base of frozen ground layer",
                        "units": "in"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "elevation",
                        "missing_value": "-99999"
                    },
                    "DPTP": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DPTP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Fahrenheit_scale",
                        "long_name": "average daily dew-point temperature",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "DPNT": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DPNT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Fahrenheit",
                        "long_name": "departure from normal temperature",
                        "missing_value": "-9999"
                    },
                    "CLDG": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CLDG",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Fahrenheit",
                        "long_name": "cooling degree day",
                        "missing_value": "-99"
                    },
                    "AWND": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AWND",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mph",
                        "long_name": "average daily wind speed",
                        "missing_value": "-9999",
                        "scale_factor": "0.1"
                    },
                    "ASSS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ASSS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "average cloudiness sunrise to sunset",
                        "missing_value": "-40",
                        "scale_factor": "0.1"
                    },
                    "ASMM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ASMM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "average cloudiness midnight to midnight",
                        "missing_value": "-40",
                        "scale_factor": "0.1"
                    }
                }
            },
            "CIRS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CIRS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "nClimDiv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "nClimDiv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zndx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zndx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "palmer zindex",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Fahrenheit_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.900002"
                        },
                        "stateweights": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stateweights",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "miles2",
                            "long_name": "state weights",
                            "ncolor": "254",
                            "colormap": "253",
                            "colorscalename": "halfgreyscale",
                            "maxncolor": "254"
                        },
                        "state": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "state",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "state id"
                        },
                        "sp12": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp12",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "12-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "sp09": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp09",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "9-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "sp06": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp06",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "6-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "sp03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "3-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "sp02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "2-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "sp01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sp01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "1-month standardized precipitation index ",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "pmdi": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pmdi",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "modified palmer dsi",
                            "missing_value": "-99.989998",
                            "units": "unitless"
                        },
                        "phdi": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phdi",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "palmer hdi",
                            "description": "palmer hydro drought index",
                            "missing_value": "-99.989998"
                        },
                        "pdsi": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pdsi",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "palmer dsi",
                            "description": "palmer drought severity index",
                            "missing_value": "-99.989998",
                            "iridlhasSemantics": "iridl:PalmerDroughtSeverityIndex"
                        },
                        "pcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "in",
                            "long_name": "precipitation",
                            "missing_value": "-9.9899998"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "long_name": "longitude",
                            "scale_min": "-125.0",
                            "scale_max": "-65.0"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "long_name": "latitude",
                            "scale_min": "15.0",
                            "scale_max": "55.0"
                        },
                        "hdd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hdd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "heating degree days",
                            "missing_value": "-9999.0",
                            "units": "unitless"
                        },
                        "divarea": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "divarea",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "miles2",
                            "long_name": "division area"
                        },
                        "cdd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cdd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "cooling degree days",
                            "missing_value": "-9999.0",
                            "units": "unitless"
                        }
                    }
                },
                "ClimateDivision": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ClimateDivision",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zndx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zndx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "palmer zindex",
                        "missing_value": "-99.989998",
                        "units": "unitless"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Fahrenheit_scale",
                        "long_name": "temperature",
                        "missing_value": "-99.900002"
                    },
                    "stateweights": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stateweights",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "miles2",
                        "long_name": "state weights",
                        "ncolor": "254",
                        "colormap": "253",
                        "colorscalename": "halfgreyscale",
                        "maxncolor": "254"
                    },
                    "stateid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stateid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "state id"
                    },
                    "pmdi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pmdi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "modified palmer dsi",
                        "missing_value": "-99.989998",
                        "units": "unitless"
                    },
                    "phdi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "phdi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "palmer hdi",
                        "description": "palmer hydro drought index",
                        "missing_value": "-99.989998"
                    },
                    "pdsi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pdsi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "palmer dsi",
                        "description": "palmer drought severity index",
                        "missing_value": "-99.989998",
                        "iridlhasSemantics": "iridl:PalmerDroughtSeverityIndex"
                    },
                    "pcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "in",
                        "long_name": "precipitation",
                        "missing_value": "-9.9899998"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "long_name": "longitude",
                        "scale_min": "-125.0",
                        "scale_max": "-65.0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "long_name": "latitude",
                        "scale_min": "15.0",
                        "scale_max": "55.0"
                    },
                    "hdd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hdd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "heating degree days",
                        "missing_value": "-9999.0",
                        "units": "unitless"
                    },
                    "divarea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "divarea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "miles2",
                        "long_name": "division area"
                    },
                    "cdd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cdd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "cooling degree days",
                        "missing_value": "-9999.0",
                        "units": "unitless"
                    }
                }
            },
            "CDR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CDR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PERSIANNCDR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PERSIANN-CDR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v01r01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v01r01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "colormap": "290304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "colorscalename": "precip_colors",
                            "long_name": "precipitation amount",
                            "standard_name": "lwe_thickness_of_precipitation_amount",
                            "units": "mm/day",
                            "missing_value": "-9999.0",
                            "valid_max": "999999.0",
                            "valid_min": "0.0",
                            "pointwidth": "1.0"
                        }
                    }
                }
            },
            "ID": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ID",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "StationID"
            },
            "T_36": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_36",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "0.9999999",
                "long_name": "time",
                "calendar": "360"
            },
            "T_35": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_35",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "0",
                "scale_max": "1.05347520E09",
                "units": "seconds since 1970-01-01",
                "add_offset": "5.67993600E08",
                "scale_min": "5.67993600E08",
                "scale_factor": "86400.0",
                "calendar": "standard",
                "standard_name": "time"
            },
            "Y_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.3333333",
                "standard_name": "latitude"
            },
            "T_34": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_34",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "0.3333333",
                "standard_name": "longitude"
            },
            "MeanSD_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MeanSD_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "MeanSD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MeanSD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "Y_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "T_33": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_33",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12",
                "standard_name": "time"
            },
            "X_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "Monte Carlo Iterations"
            },
            "T_32": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_32",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "6",
                "standard_name": "time"
            },
            "T_31": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_31",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "6",
                "standard_name": "time"
            },
            "X_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "10.0",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "Y_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "T_30": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_30",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "expires": "1614902400",
                "calendar": "standard"
            },
            "T_29": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_29",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1978-01-01 12:00:00",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "1.0",
                "calendar": "standard"
            },
            "T_28": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_28",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1978-01-01 12:00:00",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "1.0",
                "calendar": "standard"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.25",
                "standard_name": "projection_x_coordinate"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "projection_y_coordinate"
            },
            "T_27": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_27",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "Time",
                "calendar": "standard"
            },
            "STNID": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STNID",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "Station"
            },
            "T_26": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_26",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "IWMO_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "station"
            },
            "VER_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "VER_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "version"
            },
            "T_25": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_25",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "T_24": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_24",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "VER": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "VER",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "version"
            },
            "T_23": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_23",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "IWMO_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "station"
            },
            "T_22": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_22",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "T_21": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_21",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "Time",
                "calendar": "standard"
            },
            "ISTA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ISTA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "Station"
            },
            "IWMO_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "IWMO_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "T_20": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_20",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "T",
                "calendar": "360"
            },
            "IWMO_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID"
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "latitude"
            },
            "T_19": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_19",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "X_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "standard_name": "longitude"
            },
            "T_18": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_18",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "expires": "1617321600",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_17": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_17",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_16": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_16",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_15": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_15",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_14": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_14",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_13": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_13",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_11": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_11",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "T_10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "T_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "T_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "T_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "zlev": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "zlev",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0"
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.0",
                "standard_name": "latitude"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.0",
                "standard_name": "longitude"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "T",
                "calendar": "standard"
            },
            "IWMO": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IWMO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "WMO Station ID",
                "total": "14676"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "add_offset": "2403699",
                "calendar": "standard"
            },
            "WBAN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WBAN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "Station"
            },
            "state": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "state",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "stateid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stateid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "IDIV": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IDIV",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "0",
                "long_name": "climate division"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "1.0",
                "calendar": "standard"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.25",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "dir": "SOURCES/NOAA/NCDC"
        },
        "NCEP": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NOAA/NCEP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "NCEP",
            "restriction": "Public",
            "CPC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NOAA/NCEP/CPC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "CPC",
                "restriction": "Public",
                "CAMS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CAMS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "stationtemperatureexpires": "1617260400",
                        "stationprecipitationexpires": "1617260400",
                        "stationexpires": "1617260400",
                        "meanexpires": "1617260400",
                        "anomalyexpires": "1617260400",
                        "references": "Ropelewski_etal1985",
                        "description": "Climate Anomaly Monitoring System monthly gridded and station precipitation and temperature data",
                        "expires": "1617260400",
                        "Conventions": "IRIDL"
                    },
                    "station": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "station",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "missing_value": "-9999.0",
                                "expires": "1617260400"
                            },
                            "start_year": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "start_year",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "record": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "record",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-180.0",
                                "scale_max": "180.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-90.0",
                                "scale_max": "90.0",
                                "units": "degree_north"
                            },
                            "DataFlag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DataFlag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            }
                        },
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "start_year": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "start_year",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "record": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "record",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "missing_value": "-9999.0",
                                "expires": "1617260400"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-180.0",
                                "scale_max": "180.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-90.0",
                                "scale_max": "90.0",
                                "units": "degree_north"
                            },
                            "DataFlag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DataFlag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            }
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/month",
                            "long_name": "precipitation",
                            "missing_value": "-9999.0",
                            "expires": "1617260400"
                        }
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Celsius",
                            "long_name": "temperature anomaly",
                            "missing_value": "-9999.0",
                            "expires": "1617260400"
                        }
                    },
                    "IWMO_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IWMO_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "IWMO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IWMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.0",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "defaultvalue": "733.5",
                        "calendar": "360",
                        "expires": "1617260400"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.0",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/CAMS"
                },
                "CAMS_OPI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CAMS_OPI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v9906v0208_old": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.v0208_old/",
                        "v0208_olddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.v0208_old.dataset_documentation.html",
                        "v0208_oldv0208": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.v0208/",
                        "v0208satelliteexpires": "1617235200",
                        "v0208percentofgammaexpires": "1617235200",
                        "v0208meanexpires": "1617235200",
                        "v0208gaugeexpires": "1617235200",
                        "v0208anomalyexpires": "1617235200",
                        "v0208expires": "1617235200",
                        "v0208dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.v0208.dataset_documentation.html",
                        "original_versionv9906": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.v9906/",
                        "original_versiondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CAMS_OPI/.original_version.dataset_documentation.html",
                        "references": "Janowiak_Xie1999",
                        "Conventions": "IRIDL"
                    },
                    "v9906": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v9906",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "satellite": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "satellite",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "maxncolor": "254",
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "percentofgamma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "percentofgamma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "maxncolor": "254",
                                "colormap": "1973790",
                                "scale_max": "40.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "40",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "gauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "maxncolor": "254",
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "count",
                                "missing_value": "-999.0"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "scale_max": "20.0",
                                "scale_min": "-20.0",
                                "CS": "-20",
                                "CE": "20",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colormap": "8388608",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        }
                    },
                    "v0208_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v0208_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "satellite": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "satellite",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            }
                        },
                        "percentofgamma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "percentofgamma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "precipitation",
                                "units": "percent",
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            }
                        },
                        "gauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "40.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "-40.0",
                                "CS": "-40",
                                "CE": "40",
                                "colormap": "8388608",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "T"
                            }
                        }
                    },
                    "v0208": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v0208",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "satellite": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "satellite",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            }
                        },
                        "percentofgamma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "percentofgamma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "precipitation",
                                "units": "percent",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            }
                        },
                        "gauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1973790",
                                "scale_max": "20.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "20",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "40.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "-40.0",
                                "CS": "-40",
                                "CE": "40",
                                "colormap": "8388608",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360",
                                "bounds": "T"
                            }
                        }
                    },
                    "original_version": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "original_version",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "satellite": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "satellite",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "percentile": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "percentile",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percentile",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "maxncolor": "254",
                                "colormap": "1973790",
                                "scale_max": "800.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "800",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "gauge": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gauge",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "count",
                                "missing_value": "-999.0"
                            }
                        },
                        "climatology": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatology",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "maxncolor": "254",
                                "colormap": "8388608",
                                "scale_max": "400.0",
                                "ncolor": "254",
                                "scale_min": "-400.0",
                                "CS": "-400",
                                "CE": "400",
                                "long_name": "precipitation",
                                "missing_value": "-999.0"
                            }
                        }
                    },
                    "T_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360",
                        "expires": "1617235200"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/CAMS_OPI"
                },
                "CA_SST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CA_SST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v200708description": "SST hindcasts/forecasts released Aug 2007",
                        "v200708source": "ftp://ftp.cpc.ncep.noaa.gov/wd51hd/sst/aug2007",
                        "v200608description": "SST hindcasts/forecasts released Aug 2006",
                        "v200608source": "ftp://ftp.cpc.ncep.noaa.gov/wd51hd/sst/",
                        "v200608v200708": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CA_SST/.v200708/",
                        "updatessource": "ftp://ftp.cpc.ncep.noaa.gov/wd51hd/sst/",
                        "references": "vandenDool1994 vandenDool2007",
                        "description": "Constructed Analog Sea Surface Temperature Forecasts",
                        "iridlhasSemantics": "iridl:forecast",
                        "Conventions": "IRIDL"
                    },
                    "v200708": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v200708",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1.0",
                            "standard_name": "time",
                            "long_name": "Forecast Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "Sea Surface Temperature"
                        },
                        "landsea": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "landsea",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        }
                    },
                    "v200608": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v200608",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1.0",
                            "long_name": "Forecast Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "Sea Surface Temperature"
                        },
                        "landsea": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "landsea",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        }
                    },
                    "updates": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "updates",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "upto201305": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "upto201305",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "Sea Surface Temperature"
                            }
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1.0",
                            "long_name": "Forecast Time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "S:  May-Jul 2013 to Mar-May 2019 appended from NOAA NCEP CPC CA_SST updates post201305 sst",
                            "units": "Kelvin_scale",
                            "long_name": "Sea Surface Temperature"
                        },
                        "post201305": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "post201305",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sea Surface Temperature",
                                "units": "Kelvin_scale"
                            }
                        }
                    },
                    "S_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "long_name": "initial data"
                    },
                    "L_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "CPC lead time"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "member"
                    },
                    "S_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "long_name": "initial data"
                    },
                    "S_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "long_name": "initial data"
                    },
                    "S_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "3.0",
                        "long_name": "initial data",
                        "calendar": "360"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "CPC lead time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "3.0",
                        "long_name": "initial data",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/CA_SST"
                },
                "CLIMAT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CLIMAT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "Monthly station precipitation and temperature data from the Climate Prediction Center",
                        "Conventions": "IRIDL"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "0.0",
                        "scale_min": "-359.98999",
                        "units": "degree_east"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north"
                    },
                    "eve": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "eve",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "climat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "IWMO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IWMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/CLIMAT"
                },
                "CMORPH": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CMORPH",
                    "restriction": "Public",
                    "hourly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "3-hourly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "renamed102015description": "CMORPH data starting from 28 Oct 2015",
                            "orignamesdescription": "CMORPH data from 07 Dec 2002 to 27 Oct 2015",
                            "meanmorpheddescription": "CMORPH V0px RAW 3-hourly appended to CMORPH 3-hourly orignames morphed",
                            "meandescription": "CMORPH data from 07 Dec 2002 to present",
                            "description": "CPC Morphing technique for the production of global precipitation estimates (3-hourly)",
                            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CMORPH/.3-hourly/.dataset_documentation.html",
                            "Conventions": "IRIDL"
                        },
                        "renamed102015": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "renamed102015",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "morphed": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "morphed",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cmorph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cmorph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "long_name": "estimated precipitation",
                                        "units": "mm/hr",
                                        "pointwidth": "0"
                                    }
                                },
                                "microwaveonly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "microwave-only",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "comb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "comb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "estimated precipitation",
                                        "units": "mm/hr",
                                        "missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "orignames": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "orignames",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "morphed": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "morphed",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cmorph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cmorph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "long_name": "estimated precipitation",
                                        "units": "mm/hr",
                                        "pointwidth": "0"
                                    }
                                },
                                "microwaveonly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "microwave-only",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "comb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "comb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "estimated precipitation",
                                        "units": "mm/hr",
                                        "missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "morphed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "morphed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cmorph": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cmorph",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "T:  2100-2400 27 Oct 2015 to 2100-2400 6 Mar 2021 appended from NOAA NCEP CPC CMORPH V0px RAW 3-hourly [ prcp / 3. ]",
                                    "missing_value": "-9999.0",
                                    "long_name": "estimated precipitation",
                                    "units": "mm/hr",
                                    "pointwidth": "0"
                                }
                            },
                            "microwaveonly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "microwave-only",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "comb": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "comb",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "T:  0000-0300 28 Oct 2015 to 2100-2400 2 Oct 2017 appended from NOAA NCEP CPC CMORPH 3-hourly renamed102015 mean microwave-only comb",
                                    "long_name": "estimated precipitation",
                                    "units": "mm/hr",
                                    "missing_value": "-9999.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "T_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "pointwidth": "0.125",
                            "standard_name": "time",
                            "calendar": "standard"
                        },
                        "T_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.125",
                            "standard_name": "time"
                        },
                        "T_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.125"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.25",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.125"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "0.25",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/3-hourly"
                    },
                    "V0px": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V0px",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RAWdailyreferences": "Joyce_etal2004",
                            "RAWdailyexpires": "1615334400",
                            "RAW3hourlyreferences": "Joyce_etal2004",
                            "RAWlong_name": "satellite-only",
                            "Conventions": "IRIDL"
                        },
                        "RAW": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RAW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615334400",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "estimated precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0",
                                    "pointwidth": "1.0"
                                }
                            },
                            "hourly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "3-hourly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "estimated precipitation",
                                    "units": "mm/3hr",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "T_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2005-02-23 12:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "expires": "1615334400",
                            "pointwidth": "1.0",
                            "long_name": "Time",
                            "standard_name": "time"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.25",
                            "standard_name": "latitude",
                            "long_name": "Latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "0.125",
                            "long_name": "Time",
                            "standard_name": "time"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "0.25",
                            "standard_name": "longitude",
                            "long_name": "Longitude"
                        },
                        "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/V0px"
                    },
                    "daily": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "daily",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "daily_calculated": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily_calculated",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "renamed102015description": "CMORPH data starting from 28 Oct 2015",
                            "orignamesdescription": "CMORPH data from 7 Dec 2002 to 27 Oct 2015",
                            "meanmorpheddescription": "Daily average derived from CMORPH V0px RAW 3-hourly appended to CMORPH 3-hourly orignames morphed",
                            "meandescription": "CMORPH data from 07 Dec 2002 to present",
                            "references": "Joyce, R.J., J.E. Janowiak, P. A. Arkin and P. Xie, 2004: CMORPH: A Method that Produces Global Precipitation Estimates from Passive Microwave and Infrared Data at High Spatial and Temporal Resolution. J. Hydrometeorology, 5, 487-503.",
                            "description": "CPC Morphing technique for the production of global precipitation estimates (3-hourly aggregated to daily)",
                            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.CMORPH/.daily_calculated/.dataset_documentation.html",
                            "Conventions": "IRIDL"
                        },
                        "renamed102015": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "renamed102015",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "morphed": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "morphed",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cmorph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cmorph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "long_name": "Estimated precipitation",
                                        "units": "mm/hr",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "file_missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                },
                                "microwaveonly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "microwave-only",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "comb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "comb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Estimated precipitation",
                                        "units": "mm/hr",
                                        "missing_value": "NaN",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "file_missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "orignames": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "orignames",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "morphed": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "morphed",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cmorph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cmorph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "long_name": "Estimated precipitation",
                                        "units": "mm/hr",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "file_missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                },
                                "microwaveonly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "microwave-only",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "comb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "comb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Estimated precipitation",
                                        "units": "mm/hr",
                                        "missing_value": "NaN",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "file_missing_value": "-9999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "morphed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "morphed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cmorph": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cmorph",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-9999.0",
                                    "long_name": "Estimated precipitation",
                                    "units": "mm/hr",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "-9999.0",
                                    "pointwidth": "0"
                                }
                            },
                            "microwaveonly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "microwave-only",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "comb": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "comb",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "T:  28 Oct 2015 to 2 Oct 2017 appended from NOAA NCEP CPC CMORPH daily_calculated renamed102015 mean microwave-only comb",
                                    "long_name": "Estimated precipitation",
                                    "units": "mm/hr",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9999.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "T_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "calendar": "standard",
                            "standard_name": "time"
                        },
                        "T_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "calendar": "standard",
                            "standard_name": "time"
                        },
                        "T_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.25",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2002-12-07 00:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "0.25",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/daily_calculated"
                    },
                    "pentad": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/pentad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "pentad",
                        "restriction": "Public",
                        "mean": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/pentad/mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "mean",
                            "restriction": "Public",
                            "morphed": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/NOAA/NCEP/CPC/CMORPH/pentad/mean/morphed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "morphed",
                                "restriction": "Public",
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "morphed"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "mean"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "hourly",
                        "V0px",
                        "daily",
                        "daily_calculated",
                        "pentad"
                    ]
                },
                "DailyEVE": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/NCEP/CPC/DailyEVE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "DailyEVE",
                    "restriction": "requires dlauth tokens"
                },
                "EVE": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EVE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "references": "Ropelewski_etal1985",
                        "description": "Monthly station precipitation and temperature data from the Climate Prediction Center",
                        "Conventions": "IRIDL",
                        "iridlhasSemantics": "gcmdi:RAIN_GAUGES"
                    },
                    "usid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "usid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "trace": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "trace",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "day": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "day",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cnt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-99.900002",
                                    "units": "unitless"
                                }
                            }
                        }
                    },
                    "total": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "reported": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "reported",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "day": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "day",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cnt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-99.900002",
                                    "units": "unitless"
                                }
                            }
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "day": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "day",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cnt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-99.900002",
                                    "units": "unitless"
                                }
                            }
                        }
                    },
                    "npobs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "npobs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "unitless"
                    },
                    "nobs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nobs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "unitless"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "minmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "minmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "unitless"
                            }
                        },
                        "cnt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cnt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "Min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        },
                        "date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Min": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Min",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "unitless"
                            },
                            "cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "unitless"
                            }
                        },
                        "Max": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Max",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "unitless"
                            },
                            "cnt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "unitless"
                            }
                        }
                    },
                    "Max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        },
                        "date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "scale_max": "0.0",
                        "scale_min": "-359.98999"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "fnname": "masknotrangeperiodic",
                        "units": "degree_east"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "estimated": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "estimated",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless"
                        }
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "country": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "CLIST": "PHILIPPINES",
                        "scale_max": "196",
                        "scale_min": "1"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "time",
                        "calendar": "360"
                    },
                    "IWMO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IWMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/EVE"
                },
                "FEWS": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/NCEP/CPC/FEWS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "FEWS",
                    "restriction": "Public",
                    "Africa": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Africa",
                        "restriction": "Public",
                        "DAILY": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "DAILY",
                            "restriction": "Public",
                            "ARC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ARC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "climatologyc9503iridlhasSemantics": "iridl:climatology",
                                    "references": "Love_etal2004",
                                    "description": "Africa Rainfall Climatology (ARC) precipitation estimates for Africa from the Famine Early Warning System",
                                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.FEWS/.Africa/.DAILY/.ARC/.dataset_documentation.html",
                                    "Conventions": "IRIDL"
                                },
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "est_prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "est_prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "colormap": "14053594",
                                        "scale_max": "600.0",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "CE": "600",
                                        "units": "mm/day",
                                        "description": "CPC/Africa Rainfall Climatology: Daily Values",
                                        "long_name": "Estimated Precipitation",
                                        "standard_name": "lwe_precipitation_rate",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "climatology": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "climatology",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "c9503": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "c9503",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "est_prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "est_prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "14053594",
                                            "scale_max": "600.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "600",
                                            "description": "CPC/Africa Rainfall Climatology: Daily Means",
                                            "units": "mm/day",
                                            "long_name": "Estimated Precipitation",
                                            "standard_name": "lwe_precipitation_rate",
                                            "missing_value": "-999.0",
                                            "pointwidth": "1.0",
                                            "calendar": "standard"
                                        }
                                    }
                                },
                                "T_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 1995-01-07 12:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "standard_name": "time",
                                    "calendar": "standard"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0",
                                    "pointwidth": "0.1",
                                    "standard_name": "latitude"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 1960-01-01 12:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "standard_name": "time",
                                    "calendar": "standard"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "0",
                                    "pointwidth": "0.1",
                                    "standard_name": "longitude"
                                },
                                "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY/ARC"
                            },
                            "ARC2": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY/ARC2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "ARC2",
                                "restriction": "Public",
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Data": "ftp://ftp.cpc.ncep.noaa.gov/fews/fewsdata/africa/arc2/",
                                        "Africa": "http://www.cpc.ncep.noaa.gov/products/fews/AFR_CLIM/AMS_ARC2a.pdf",
                                        "expires": "1615386900",
                                        "CPC": "ftp://ftp.cpc.ncep.noaa.gov/fews/fewsdata/africa/arc2/ARC2_missing_dates.txt",
                                        "Conventions": "IRIDL"
                                    },
                                    "est_prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "est_prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1615386900",
                                        "colormap": "14053594",
                                        "scale_max": "600.0",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "CE": "600",
                                        "units": "mm/day",
                                        "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                        "long_name": "Estimated Precipitation",
                                        "standard_name": "lwe_precipitation_rate",
                                        "missing_value": "-999.0",
                                        "pointwidth": "1.0"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "pointwidth": "0.1",
                                        "standard_name": "latitude"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1960-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "expires": "1615386900",
                                        "pointwidth": "1.0",
                                        "standard_name": "time"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "0",
                                        "pointwidth": "0.1",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY/ARC2/daily"
                                },
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "description": "African Rainfall Climatology from the Famine Early Warning System",
                                        "Conventions": "IRIDL"
                                    },
                                    "est_prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "est_prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Monthly Average Estimated Precipitation",
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "history": "Boxes with less than 92.0% dropped",
                                        "file_missing_value": "-999.0",
                                        "expires": "1615214100",
                                        "colormap": "14053594",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                        "pointwidth": "1.0"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "pointwidth": "0.1",
                                        "standard_name": "latitude"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "calendar": "360",
                                        "pointwidth": "1.0"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "0",
                                        "pointwidth": "0.1",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY/ARC2/monthly"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "daily",
                                    "monthly"
                                ]
                            },
                            "RFEv2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RFEv2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "references": "Love2002",
                                    "expires": "1615161600",
                                    "Conventions": "IRIDL"
                                },
                                "est_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "est_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "14053594",
                                    "scale_max": "1200.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "1200",
                                    "description": "CPC/Famine Early Warning System Daily Estimates",
                                    "units": "mm/day",
                                    "long_name": "Estimated Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "missing_value": "-999.0",
                                    "calendar": "standard",
                                    "pointwidth": "1.0",
                                    "bounds": "T"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0",
                                    "pointwidth": "0.1",
                                    "standard_name": "latitude"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2000-10-31 12:00:00",
                                    "gridtype": "0",
                                    "calendar": "standard",
                                    "pointwidth": "1.0",
                                    "standard_name": "time"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "0",
                                    "pointwidth": "0.1",
                                    "standard_name": "longitude"
                                },
                                "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/DAILY/RFEv2"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "ARC",
                                "ARC2",
                                "RFEv2"
                            ]
                        },
                        "TENDAY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TEN-DAY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RFEv2references": "Love2002",
                                "RFEv2expires": "1615420800",
                                "RFEv1references": "Herman_etal1997",
                                "description": "Estimated ten-day precipitation (RFE and ARC2) in Africa from the Famine Early Warning System",
                                "Conventions": "IRIDL"
                            },
                            "RFEv2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RFEv2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "est_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "est_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "expires": "1615420800",
                                    "maxncolor": "254",
                                    "units": "mm",
                                    "colormap": "14053594",
                                    "scale_max": "1200.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "1200",
                                    "long_name": "Estimated Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "description": "CPC/Famine Early Warning System Dekadal Estimates"
                                }
                            },
                            "RFEv1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RFEv1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "est_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "est_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm",
                                    "maxncolor": "254",
                                    "colormap": "14053594",
                                    "scale_max": "1200.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "1200",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "Estimated Precipitation",
                                    "description": "CPC/FEWS Estimated Precipitation Archive, RFE Version 1",
                                    "missing_value": "-99.0"
                                }
                            },
                            "ARC2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ARC2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "est_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "est_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "long_name": "Estimated Dekadal Precipitation",
                                    "units": "mm",
                                    "history": "Boxes with less than 100.0% dropped",
                                    "expires": "1615214100",
                                    "file_missing_value": "-999.0",
                                    "colormap": "14053594",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                    "standard_name": "lwe_precipitation_rate",
                                    "pointwidth": "1.0"
                                },
                                "climatology": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "climatology",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "dc19832014": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc1983-2014",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "est_prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "est_prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Dekadal ARC2 1983-2014 average",
                                            "base_period": "1983-2014",
                                            "history": "Averaged over T2[0.5, 1152.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "expires": "1615214100",
                                            "file_missing_value": "-999.0",
                                            "colormap": "14053594",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                            "standard_name": "lwe_precipitation_rate",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            },
                            "T_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1615420800"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.1",
                                "standard_name": "latitude"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "standard"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1960-01-01 12:00:00",
                                "gridtype": "0",
                                "calendar": "standard"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2003-01-01",
                                "gridtype": "1",
                                "modulus": "365.0",
                                "calendar": "365",
                                "modulo": "365.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.1",
                                "standard_name": "latitude"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.1",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/Africa/TEN-DAY"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "DAILY",
                            "TENDAY"
                        ]
                    },
                    "DAILY": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/DAILY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "DAILY",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "SAsia": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SAsia",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RFEv2references": "Love2002",
                            "RFEv2description": "Gridded precipitation estimates in South Asia from CPC/FEWS",
                            "description": "Gridded precipitation estimates (RFE) in South Asia from CPC/FEWS",
                            "Conventions": "IRIDL"
                        },
                        "RFEv2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RFEv2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "est_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "est_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "14053594",
                                    "scale_max": "600.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "600",
                                    "units": "mm/day",
                                    "long_name": "Estimated Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "description": "CPC/Famine Early Warning System Daily Precipitation Estimates for South Asia",
                                    "missing_value": "-999.0",
                                    "calendar": "standard",
                                    "pointwidth": "1.0",
                                    "bounds": "T"
                                }
                            }
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.1",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2001-05-01 12:00:00",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.1",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/SAsia"
                    },
                    "TENDAY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TEN-DAY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RFEv2references": "Love2002",
                            "RFEv2expires": "1615420800",
                            "RFEv1references": "Herman_etal1997",
                            "description": "Estimated ten-day precipitation (RFE and ARC2) in Africa from the Famine Early Warning System",
                            "Conventions": "IRIDL"
                        },
                        "RFEv2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RFEv2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "est_prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "est_prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "expires": "1615420800",
                                "maxncolor": "254",
                                "units": "mm",
                                "colormap": "14053594",
                                "scale_max": "1200.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "1200",
                                "long_name": "Estimated Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "description": "CPC/Famine Early Warning System Dekadal Estimates"
                            }
                        },
                        "RFEv1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RFEv1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "est_prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "est_prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm",
                                "maxncolor": "254",
                                "colormap": "14053594",
                                "scale_max": "1200.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "1200",
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Estimated Precipitation",
                                "description": "CPC/FEWS Estimated Precipitation Archive, RFE Version 1",
                                "missing_value": "-99.0"
                            }
                        },
                        "ARC2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ARC2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "est_prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "est_prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "long_name": "Estimated Dekadal Precipitation",
                                "units": "mm",
                                "history": "Boxes with less than 100.0% dropped",
                                "expires": "1615214100",
                                "file_missing_value": "-999.0",
                                "colormap": "14053594",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            },
                            "climatology": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dc19832014": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dc1983-2014",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "est_prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "est_prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Dekadal ARC2 1983-2014 average",
                                        "base_period": "1983-2014",
                                        "history": "Averaged over T2[0.5, 1152.5] minimum 0.0% data present",
                                        "missing_value": "NaN",
                                        "units": "mm",
                                        "expires": "1615214100",
                                        "file_missing_value": "-999.0",
                                        "colormap": "14053594",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                        "standard_name": "lwe_precipitation_rate",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "T_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "expires": "1615420800"
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.1",
                            "standard_name": "latitude"
                        },
                        "T_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard"
                        },
                        "T_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01 12:00:00",
                            "gridtype": "0",
                            "calendar": "standard"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "1",
                            "modulus": "365.0",
                            "calendar": "365",
                            "modulo": "365.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.1",
                            "standard_name": "latitude"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.1",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/NOAA/NCEP/CPC/FEWS/TEN-DAY"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Africa",
                        "DAILY",
                        "SAsia",
                        "TENDAY"
                    ]
                },
                "GHCN_CAMS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GHCN_CAMS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "griddeddeg0p5description": "CPC Monthly Global Surface Air Temperature Data Set at 0.5 degree from 1948-present",
                        "griddeddeg0p5references": "Fan_VanDenDool2004 Fan_VanDenDool2008",
                        "griddeddeg0p5expires": "1617235200",
                        "griddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.GHCN_CAMS/.gridded.dataset_documentation.html",
                        "description": "station data",
                        "Conventions": "IRIDL"
                    },
                    "gridded": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridded",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "deg0p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature",
                                "standard_name": "air_temperature",
                                "missing_value": "9.99900026E20",
                                "expires": "1617235200",
                                "units": "Celsius_scale",
                                "gribfield": "1"
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "pointwidth": "1.0",
                        "calendar": "360",
                        "expires": "1617235200"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GHCN_CAMS"
                },
                "GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "halfhourlydata": "ftp://ftp.cpc.ncep.noaa.gov/precip/global_full_res_IR/",
                        "halfhourlyexpires": "1615186800",
                        "halfhourlyFull": "http://www.cpc.ncep.noaa.gov/products/global_precip/html/wpage.full_res.html",
                        "dailysource": "ftp.cpc.ncep.noaa.gov precip/noaa..",
                        "dailydataset_title": "NOAA Interpolated Outgoing Longwave Radiation (OLR)",
                        "dailyreferences": "Liebmann_Smith1996",
                        "dailydescription": "Data is interpolated in time and space from NOAA twice-daily OLR values and averaged to once daily",
                        "dailytitle": "Daily Mean Interpolated OLR",
                        "dailyConventions": "CF-1.2",
                        "dailyplatform": "Observation",
                        "dailyNCO": "4.0.0",
                        "dailydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.GLOBAL/.daily.dataset_documentation.html",
                        "dailyhistory": "Converted to chunked, deflated non-packed NetCDF4 2020/08",
                        "dailyCitation": "Liebmann and Smith: June 2006: Description of a Complete (Interpolated) Outgoing Longwave Radiation Dataset. Bulletin of the American Meteorological Society, 77, 1275-1277",
                        "dailyReferences": "https://www.psl.noaa.gov/data/gridded/data.interp_OLR.html",
                        "daily_NCProperties": "version=2,netcdf=4.7.0,hdf5=1.10.5,",
                        "climatologyiridlhasSemantics": "iridl:climatology",
                        "Conventions": "IRIDL"
                    },
                    "pentad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pentad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "olra": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olra",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "outgoing longwave radiation anomaly",
                            "missing_value": "-9999.0"
                        },
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "outgoing longwave radiation",
                            "missing_value": "-9999.0"
                        }
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "outgoing longwave radiation",
                            "missing_value": "-9999.0"
                        }
                    },
                    "halfhourly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "half-hourly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ir": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ir",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "255",
                            "expires": "1615186800",
                            "scale_max": "329",
                            "units": "Kelvin_scale",
                            "add_offset": "75",
                            "scale_min": "75",
                            "pointwidth": "0.04166666"
                        }
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Dataset": "NOAA Interpolated OLR",
                            "parent_stat": "Individual Obs",
                            "units": "W/m2",
                            "statistic": "Mean",
                            "valid_range": "500.0",
                            "actual_range": "344.5",
                            "precision": "2",
                            "long_name": "Daily OLR",
                            "level_desc": "Other",
                            "missing_value": "-9.96920997E36",
                            "var_desc": "Outgoing Longwave Radiation"
                        },
                        "info": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "info",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Missing",
                            "missing_value": "32766",
                            "valid_range": "10512"
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "olr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "olr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "W/m2",
                            "long_name": "outgoing longwave radiation",
                            "missing_value": "-9999.0"
                        }
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1999-12-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "pointwidth": "0.02083333",
                        "calendar": "standard",
                        "expires": "1615186800"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.0363858",
                        "standard_name": "latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.03637649",
                        "standard_name": "longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "long_name": "Latitude",
                        "standard_name": "latitude",
                        "actual_range": "-90.0",
                        "axis": "Y"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "long_name": "Longitude",
                        "actual_range": "360.0",
                        "standard_name": "longitude",
                        "axis": "X",
                        "modulus": "360.0"
                    },
                    "time": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1974-01-01",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1.0"
                    },
                    "nmiss": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nmiss",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GLOBAL"
                },
                "GMSM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GMSM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Global Monthly Soil Moisture",
                        "description": "Global monthly high resolution soil moisture dataset from the Climate Prediction Center",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.GMSM/.dataset_documentation.html",
                        "Conventions": "IRIDL"
                    },
                    "w": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "w",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "250",
                        "scale_max": "740.0",
                        "maxncolor": "254",
                        "ncolor": "253",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "740.0",
                        "references": "Fan_VanDenDool2004",
                        "units": "mm"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GMSM"
                },
                "GOB": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GOB",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V0pxdailyREALTIMEexpires": "1615310400",
                        "Conventions": "IRIDL"
                    },
                    "V0px": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V0px",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "RETRO": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RETRO",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "blended daily precipitation",
                                    "units": "mm/day",
                                    "pointwidth": "1.0"
                                }
                            },
                            "REALTIME": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REALTIME",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615310400",
                                    "missing_value": "-999.0",
                                    "long_name": "blended daily precipitation",
                                    "units": "mm/day",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Time",
                        "calendar": "standard",
                        "standard_name": "time"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615310400",
                        "pointwidth": "1.0",
                        "long_name": "Time",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.25",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GOB"
                },
                "GSOD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GSOD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.GSOD/.MONTHLY.dataset_documentation.html",
                        "MONTHLYhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.GSOD/.MONTHLY.html",
                        "description": "Global Summary of the Day station observations",
                        "Conventions": "IRIDL"
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "longitude",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "latitude",
                            "units": "degree_north"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "elevation",
                            "units": "m"
                        },
                        "DCNTS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "DCNTS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "reported": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reported",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "trace": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "trace",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "precipitation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precipitation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "days": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "days",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days",
                                            "long_name": "days",
                                            "molyid": "39",
                                            "missing_value": "0",
                                            "molydesc": "number of days a trace of precipitation reported",
                                            "molyname": "NDTPR"
                                        }
                                    }
                                },
                                "measurable": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "measurable",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "precipitation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precipitation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "days": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "days",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days",
                                            "long_name": "days",
                                            "molyid": "38",
                                            "missing_value": "0",
                                            "molydesc": "days measureable precipition reported",
                                            "molyname": "NDPR"
                                        }
                                    }
                                }
                            },
                            "radiation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "radiation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "values": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "values",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "count": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "count",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "count",
                                        "molyid": "28",
                                        "missing_value": "-999",
                                        "molydesc": "number of radiation values",
                                        "molyname": "NRADV"
                                    }
                                }
                            },
                            "paired": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "paired",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "minmax": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "minmax",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "count": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "count",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "count",
                                        "molyid": "33",
                                        "missing_value": "0",
                                        "molydesc": "number of paired maximum and minimum temperatures",
                                        "molyname": "NPMXMN"
                                    }
                                }
                            },
                            "observations": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "observations",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "with_precip": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "with_precip",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "count": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "count",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "count",
                                        "molyid": "31",
                                        "missing_value": "-999",
                                        "molydesc": "number of observations with precipitation",
                                        "molyname": "NOBSP"
                                    }
                                },
                                "count": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "count",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "count",
                                    "molyid": "30",
                                    "missing_value": "-999",
                                    "molydesc": "number of observations",
                                    "molyname": "NOBS"
                                }
                            },
                            "month": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "month",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "days": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "days",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days",
                                    "long_name": "days",
                                    "molyid": "50",
                                    "missing_value": "-999",
                                    "molydesc": "number of days in the month",
                                    "molyname": "NDAYS"
                                }
                            },
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vapor": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vapor",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pressure": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pressure",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "count": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "count",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days",
                                            "long_name": "count",
                                            "molyid": "43",
                                            "missing_value": "0",
                                            "molydesc": "number of daily vapor pressure values",
                                            "molyname": "NVPT"
                                        }
                                    }
                                },
                                "sunshine": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sunshine",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "count": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "count",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "long_name": "count",
                                        "molyid": "42",
                                        "missing_value": "0",
                                        "molydesc": "number of daily sunshine values",
                                        "molyname": "NSV"
                                    }
                                },
                                "pan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "evaporation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evaporation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "count": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "count",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days",
                                            "long_name": "count",
                                            "molyid": "44",
                                            "missing_value": "0",
                                            "molydesc": "number of daily pan evaporation values",
                                            "molyname": "NPET"
                                        }
                                    }
                                },
                                "minimum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "minimum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind_chill": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind_chill",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "days": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "days",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "NMWC",
                                            "molyid": "41",
                                            "missing_value": "0",
                                            "molydesc": "number of daily minimum wind chill values",
                                            "scale_factor": "0.01",
                                            "units": "days",
                                            "long_name": "days"
                                        }
                                    },
                                    "temperature": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temperature",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "count": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "count",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "long_name": "count",
                                            "molyid": "35",
                                            "missing_value": "0",
                                            "molydesc": "number of daily minimum temperatures",
                                            "molyname": "NMN"
                                        }
                                    },
                                    "relative": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "relative",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "humidity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "humidity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "count": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "count",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "days",
                                                "long_name": "count",
                                                "molyid": "46",
                                                "missing_value": "0",
                                                "molydesc": "number of daily minimum relative humidity values",
                                                "molyname": "NMNRH"
                                            }
                                        }
                                    }
                                },
                                "maximum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "maximum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temperature": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temperature",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "count": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "count",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "long_name": "count",
                                            "molyid": "34",
                                            "missing_value": "0",
                                            "molydesc": "number of daily maximum temperatures",
                                            "molyname": "NMX"
                                        }
                                    },
                                    "relative": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "relative",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "humidity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "humidity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "count": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "count",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "days",
                                                "long_name": "count",
                                                "molyid": "45",
                                                "missing_value": "0",
                                                "molydesc": "number of daily maximum relative humidity values",
                                                "molyname": "NMXRH"
                                            }
                                        }
                                    },
                                    "apparent": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "apparent",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "days": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "days",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "days",
                                                "long_name": "days",
                                                "molyid": "40",
                                                "missing_value": "0",
                                                "molydesc": "number of daily maximum apparent temperatures",
                                                "molyname": "NMAPT"
                                            }
                                        }
                                    }
                                }
                            },
                            "hour": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "6hour",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "with_precip_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "with_precip_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "count": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "count",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "count",
                                        "molyid": "32",
                                        "missing_value": "-999",
                                        "molydesc": "number of 6 hour periods that precipitation estimated",
                                        "molyname": "N6HE"
                                    }
                                }
                            }
                        },
                        "DATES": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "DATES",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "minimum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "minimum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind_chill": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind_chill",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "day": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "MNWCD",
                                            "molyid": "48",
                                            "missing_value": "-999",
                                            "molydesc": "date monthly minimum wind chill occured",
                                            "scale_factor": "0.01",
                                            "units": "days",
                                            "long_name": "day"
                                        }
                                    }
                                },
                                "maximum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "maximum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "apparent": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "apparent",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "day": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "days",
                                                "long_name": "day",
                                                "molyid": "47",
                                                "missing_value": "0",
                                                "molydesc": "date monthly maximum apparent temperature occured",
                                                "molyname": "MXAPTD"
                                            }
                                        }
                                    }
                                }
                            },
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "minimum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "minimum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temperature": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temperature",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "day": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "long_name": "day",
                                            "molyid": "37",
                                            "missing_value": "-999",
                                            "molydesc": "date the minimum monthly temperature occured",
                                            "molyname": "MNDAT"
                                        }
                                    }
                                },
                                "maximum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "maximum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temperature": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temperature",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "day": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "long_name": "day",
                                            "molyid": "36",
                                            "missing_value": "-999",
                                            "molydesc": "date the maximum monthly temperature occured",
                                            "molyname": "MXDAT"
                                        }
                                    },
                                    "precipitation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precipitation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "day": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days",
                                            "long_name": "day",
                                            "molyid": "49",
                                            "missing_value": "-999",
                                            "molydesc": "date the maximum daily precipitation occurred",
                                            "molyname": "MXPCPD"
                                        }
                                    }
                                }
                            }
                        },
                        "DATA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "DATA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "total": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "reported": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reported",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "RPCP",
                                        "molyid": "13",
                                        "missing_value": "-999",
                                        "molydesc": "total reported precipitation for month",
                                        "scale_factor": "0.1",
                                        "units": "mm",
                                        "long_name": "precipitation"
                                    }
                                },
                                "heating": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heating",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "degree_days": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "degree_days",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "degree days",
                                        "molyid": "25",
                                        "missing_value": "-999",
                                        "molydesc": "total heating degree days",
                                        "molyname": "IHDD"
                                    }
                                },
                                "growing": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "growing",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "degree_days": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "degree_days",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "degree days",
                                        "molyid": "27",
                                        "missing_value": "-999",
                                        "molydesc": "total growing degree days",
                                        "molyname": "IGDD"
                                    }
                                },
                                "estimated": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "estimated",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "EPCP",
                                        "molyid": "14",
                                        "missing_value": "-999",
                                        "molydesc": "total precipitation including estimates for any periods that reported amounts were not available",
                                        "scale_factor": "0.1",
                                        "units": "mm",
                                        "long_name": "precipitation"
                                    }
                                },
                                "cooling": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cooling",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "degree_days": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "degree_days",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "degree days",
                                        "molyid": "26",
                                        "missing_value": "-999",
                                        "molydesc": "total cooling degree days",
                                        "molyname": "ICDD"
                                    }
                                }
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind_chill": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind_chill",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "WCLMINL",
                                        "molyid": "12",
                                        "missing_value": "-999",
                                        "molydesc": "lowest daily minimum whid chill temperature during month",
                                        "scale_factor": "0.1",
                                        "units": "degree_Celsius",
                                        "long_name": "temperature"
                                    }
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "molyname": "RMINL",
                                    "molyid": "7",
                                    "missing_value": "-999",
                                    "molydesc": "lowest minimum temperature reported during month",
                                    "scale_factor": "0.1",
                                    "units": "degree_Celsius",
                                    "long_name": "temperature"
                                }
                            },
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vapor": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vapor",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pressure": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pressure",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "AVP",
                                        "molyid": "18",
                                        "missing_value": "-999",
                                        "molydesc": "average vapor pressure",
                                        "scale_factor": "0.01",
                                        "units": "mb",
                                        "long_name": "vapor pressure"
                                    }
                                },
                                "total": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "radiation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "radiation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "long_name": "radiation",
                                        "molyid": "22",
                                        "missing_value": "-999",
                                        "scale_factor": "0.01",
                                        "molydesc": "average total radiation",
                                        "molyname": "TRAD"
                                    }
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "molyname": "TMEAN",
                                    "molyid": "3",
                                    "missing_value": "-999",
                                    "molydesc": "average daily mean temperature computed from all paired daily maximum and minimum temperatures",
                                    "scale_factor": "0.1",
                                    "units": "degree_Celsius",
                                    "long_name": "temperature"
                                },
                                "sunshine": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sunshine",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "molyname": "AHS",
                                    "molyid": "17",
                                    "missing_value": "-999",
                                    "molydesc": "average hours of sunshine",
                                    "scale_factor": "0.01",
                                    "units": "hours",
                                    "long_name": "sunshine"
                                },
                                "pan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "evaportransporation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evaportransporation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "APET",
                                        "molyid": "19",
                                        "missing_value": "-999",
                                        "molydesc": "average pan evaportransporation",
                                        "scale_factor": "0.01",
                                        "units": "mm",
                                        "long_name": "evaportransporation"
                                    }
                                },
                                "minimum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "minimum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind_chill": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind_chill",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "temp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "WCMIN",
                                            "molyid": "10",
                                            "missing_value": "-999",
                                            "molydesc": "average minimum wind chill temperature",
                                            "scale_factor": "0.1",
                                            "units": "degree_Celsius",
                                            "long_name": "temperature"
                                        }
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "TMIN",
                                        "molyid": "5",
                                        "missing_value": "-999",
                                        "molydesc": "average daily minimum temperature",
                                        "scale_factor": "0.1",
                                        "units": "degree_Celsius",
                                        "long_name": "temperature"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "long_name": "relative humitidy",
                                        "molyid": "24",
                                        "missing_value": "-999",
                                        "molydesc": "average minimum relative humidity",
                                        "molyname": "AMINRH"
                                    }
                                },
                                "maximum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "maximum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "TMAX",
                                        "molyid": "4",
                                        "missing_value": "-999",
                                        "molydesc": "average daily maximum temperature",
                                        "scale_factor": "0.1",
                                        "units": "degree_Celsius",
                                        "long_name": "temperature"
                                    },
                                    "rhum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rhum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "long_name": "relative humidity",
                                        "molyid": "23",
                                        "missing_value": "-999",
                                        "molydesc": "average maximum relative humidity",
                                        "molyname": "AMAXRH"
                                    },
                                    "apparent": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "apparent",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "temp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "APTMAX",
                                            "molyid": "9",
                                            "missing_value": "-999",
                                            "molydesc": "average maximum apparent temperature",
                                            "scale_factor": "0.1",
                                            "units": "degree_Celsius",
                                            "long_name": "temperature"
                                        }
                                    }
                                },
                                "deficit": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "deficit",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vapor": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vapor",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "pressure": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pressure",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "AVPD",
                                            "molyid": "20",
                                            "missing_value": "-999",
                                            "molydesc": "average vapor pressure deficit",
                                            "scale_factor": "0.01",
                                            "units": "mb",
                                            "long_name": "vapor pressure"
                                        }
                                    }
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "molyname": "HMAX",
                                    "molyid": "6",
                                    "missing_value": "-999",
                                    "molydesc": "highest daily maximum temperature",
                                    "scale_factor": "0.1",
                                    "units": "degree_Celsius",
                                    "long_name": "temperature"
                                },
                                "estimated": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "estimated",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "molyname": "EPCPMX",
                                            "molyid": "16",
                                            "missing_value": "-999",
                                            "molydesc": "maximum daily precipitation including estimates",
                                            "scale_factor": "0.1",
                                            "units": "mm",
                                            "long_name": "precipitation"
                                        }
                                    }
                                },
                                "apparent": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "apparent",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "HMAXAPT",
                                        "molyid": "11",
                                        "missing_value": "-999",
                                        "molydesc": "highest daily maximum apparent temperature during month",
                                        "scale_factor": "0.1",
                                        "units": "degree_Celsius",
                                        "long_name": "temperature"
                                    }
                                }
                            },
                            "climate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "CPCP",
                                        "molyid": "15",
                                        "missing_value": "-999",
                                        "molydesc": "total precipiation reported in CLIMAT message",
                                        "scale_factor": "0.1",
                                        "units": "mm",
                                        "long_name": "precipitation"
                                    }
                                },
                                "mean": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mean",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "molyname": "CTMEAN",
                                        "molyid": "8",
                                        "missing_value": "-999",
                                        "molydesc": "the reported monthly climate temperature",
                                        "scale_factor": "0.1",
                                        "units": "degree_Celsius",
                                        "long_name": "temperature"
                                    }
                                }
                            }
                        },
                        "Country": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Country",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        }
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "time",
                        "calendar": "360"
                    },
                    "IWMO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IWMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GSOD"
                },
                "GTS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GTS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GLOBALgriddedtemperaturedailyDocumentation": "https://www.esrl.noaa.gov/psd/data/gridded/data.cpc.globaltemp.html",
                        "GLOBALgriddedtemperaturedailyData": "ftp://ftp.cpc.ncep.noaa.gov/precip/PEOPLE/wd52ws/global_temp/",
                        "Conventions": "IRIDL"
                    },
                    "GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridded": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gridded",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "Daily Minimum Temperature",
                                        "units": "Celsius_scale",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "Daily Maximum Temperature",
                                        "units": "Celsius_scale",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "nmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Reports for Minimum Temperature",
                                        "units": "count",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "nmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Reports for Maximum Temperature",
                                        "units": "count",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/GTS"
                },
                "Indices": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Indices",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NHTIlong_name": "Northern Hemisphere Teleconnection Indices",
                        "NHTIreferences": "Barnston_Livezey1987 Bell_Halpert1995 Hurrell1995 Mo_Livezey1986 Wallace_Gutzler1981",
                        "NHTIexpires": "1614816000",
                        "NHTIdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Indices/.NHTI.dataset_documentation.html",
                        "description": "Northern Hemisphere Teleconnection Indices",
                        "Conventions": "IRIDL"
                    },
                    "NHTI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NHTI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "West Pacific Pattern",
                            "expires": "1614816000"
                        },
                        "TNH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TNH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "Tropical - Northern Hemisphere Pattern",
                            "expires": "1614816000"
                        },
                        "SCA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SCA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "Scandinavia Pattern",
                            "expires": "1614816000"
                        },
                        "PT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "Pacific Transition Pattern",
                            "expires": "1614816000"
                        },
                        "POL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "POL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "Polar - Eurasia Pattern",
                            "expires": "1614816000"
                        },
                        "PNA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PNA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "Pacific - North American Pattern",
                            "expires": "1614816000"
                        },
                        "NAO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NAO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "North Atlantic Oscillation",
                            "expires": "1614816000"
                        },
                        "ExplVar": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ExplVar",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.900002",
                            "long_name": "Explained Variance of leading 10 modes",
                            "expires": "1614816000"
                        },
                        "EPNP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EPNP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "East Pacific/North Pacific Pattern",
                            "expires": "1614816000"
                        },
                        "EAWR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EAWR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "East Atlantic/West Russia Pattern",
                            "expires": "1614816000"
                        },
                        "EA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "unitless",
                            "long_name": "East Atlantic Pattern",
                            "expires": "1614816000"
                        }
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "expires": "1614816000"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/Indices"
                },
                "Merged_Analysis": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Merged_Analysis",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pentadv9810ver2long_name": "Version 2",
                        "pentadv9810ver2description": "using rain gauge and satellite estimates",
                        "pentadv9810ver1long_name": "Version 1",
                        "pentadv9810ver1description": "using rain gauge , satellite, and  Numerical Model Predictions",
                        "pentadv9810long_name": "October 1998 Release",
                        "pentadv9810v0107": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0107/",
                        "pentadv1306ver2long_name": "Version 2",
                        "pentadv1306ver2description": "using rain gauge and satellite estimates",
                        "pentadv1306ver1long_name": "Version 1",
                        "pentadv1306ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv1201ver2long_name": "Version 2",
                        "pentadv1201ver2description": "using rain gauge and satellite estimates",
                        "pentadv1201ver1long_name": "Version 1",
                        "pentadv1201ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0911ver2long_name": "Version 2",
                        "pentadv0911ver2description": "using rain gauge and satellite estimates",
                        "pentadv0911ver1long_name": "Version 1",
                        "pentadv0911ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0811ver2long_name": "Version 2",
                        "pentadv0811ver2description": "using rain gauge and satellite estimates",
                        "pentadv0811ver1long_name": "Version 1",
                        "pentadv0811ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0806ver2long_name": "Version 2",
                        "pentadv0806ver2description": "using rain gauge and satellite estimates",
                        "pentadv0806ver1long_name": "Version 1",
                        "pentadv0806ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0802ver2long_name": "Version 2",
                        "pentadv0802ver2description": "using rain gauge and satellite estimates",
                        "pentadv0802ver1long_name": "Version 1",
                        "pentadv0802ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0705ver2long_name": "Version 2",
                        "pentadv0705ver2description": "using rain gauge and satellite estimates",
                        "pentadv0705ver1long_name": "Version 1",
                        "pentadv0705ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0610ver2long_name": "Version 2",
                        "pentadv0610ver2description": "using rain gauge and satellite estimates",
                        "pentadv0610ver1long_name": "Version 1",
                        "pentadv0610ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0605ver2long_name": "Version 2",
                        "pentadv0605ver2description": "using rain gauge and satellite estimates",
                        "pentadv0605ver1long_name": "Version 1",
                        "pentadv0605ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0512ver2long_name": "Version 2",
                        "pentadv0512ver2description": "using rain gauge and satellite estimates",
                        "pentadv0512ver1long_name": "Version 1",
                        "pentadv0512ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0504ver2long_name": "Version 2",
                        "pentadv0504ver2description": "using rain gauge and satellite estimates",
                        "pentadv0504ver1long_name": "Version 1",
                        "pentadv0504ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0504v0512": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0512/",
                        "pentadv0410ver2long_name": "Version 2",
                        "pentadv0410ver2description": "using rain gauge and satellite estimates",
                        "pentadv0410ver1long_name": "Version 1",
                        "pentadv0410ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0410v0504": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0504/",
                        "pentadv0309ver2long_name": "Version 2",
                        "pentadv0309ver2description": "using rain gauge and satellite estimates",
                        "pentadv0309ver1long_name": "Version 1",
                        "pentadv0309ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0309v0410": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0410/",
                        "pentadv0301ver2long_name": "Version 2",
                        "pentadv0301ver2description": "using rain gauge and satellite estimates",
                        "pentadv0301ver1long_name": "Version 1",
                        "pentadv0301ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0301v0309": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0309/",
                        "pentadv0207ver2long_name": "Version 2",
                        "pentadv0207ver2description": "using rain gauge and satellite estimates",
                        "pentadv0207ver1long_name": "Version 1",
                        "pentadv0207ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0207v0301": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0301/",
                        "pentadv0203ver2long_name": "Version 2",
                        "pentadv0203ver2description": "using rain gauge and satellite estimates",
                        "pentadv0203ver1long_name": "Version 1",
                        "pentadv0203ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0203v0207": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0207/",
                        "pentadv0107ver2long_name": "Version 2",
                        "pentadv0107ver2description": "using rain gauge and satellite estimates",
                        "pentadv0107ver1long_name": "Version 1",
                        "pentadv0107ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "pentadv0107v0203": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.pentad/.v0203/",
                        "pentadv0107long_name": "July 2001 Release",
                        "pentadlatestver2long_name": "Version 2",
                        "pentadlatestver2description": "using rain gauge and satellite estimates",
                        "pentadlatestver1long_name": "Version 1",
                        "pentadlatestver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv9912ver2long_name": "Version 2",
                        "monthlyv9912ver2description": "using rain gauge and satellite estimates",
                        "monthlyv9912ver1long_name": "Version 1",
                        "monthlyv9912ver1description": "using rain gauge , satellite, and  Numerical Model Predictions",
                        "monthlyv9912long_name": "December 1999 Release",
                        "monthlyv9912v0107": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0107/",
                        "monthlyv1912ver2long_name": "Version 2",
                        "monthlyv1912ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1912ver1long_name": "Version 1",
                        "monthlyv1912ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1911ver2long_name": "Version 2",
                        "monthlyv1911ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1911ver1long_name": "Version 1",
                        "monthlyv1911ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1910ver2long_name": "Version 2",
                        "monthlyv1910ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1910ver1long_name": "Version 1",
                        "monthlyv1910ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1903ver2long_name": "Version 2",
                        "monthlyv1903ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1903ver1long_name": "Version 1",
                        "monthlyv1903ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1807ver2long_name": "Version 2",
                        "monthlyv1807ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1807ver1long_name": "Version 1",
                        "monthlyv1807ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1611ver2long_name": "Version 2",
                        "monthlyv1611ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1611ver1long_name": "Version 1",
                        "monthlyv1611ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1504ver2long_name": "Version 2",
                        "monthlyv1504ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1504ver1long_name": "Version 1",
                        "monthlyv1504ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1201ver2long_name": "Version 2",
                        "monthlyv1201ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1201ver1long_name": "Version 1",
                        "monthlyv1201ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1101ver2long_name": "Version 2",
                        "monthlyv1101ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1101ver1long_name": "Version 1",
                        "monthlyv1101ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv1001ver2long_name": "Version 2",
                        "monthlyv1001ver2description": "using rain gauge and satellite estimates",
                        "monthlyv1001ver1long_name": "Version 1",
                        "monthlyv1001ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0809ver2long_name": "Version 2",
                        "monthlyv0809ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0809ver1long_name": "Version 1",
                        "monthlyv0809ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0806ver2long_name": "Version 2",
                        "monthlyv0806ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0806ver1long_name": "Version 1",
                        "monthlyv0806ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0802ver2long_name": "Version 2",
                        "monthlyv0802ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0802ver1long_name": "Version 1",
                        "monthlyv0802ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0703ver2long_name": "Version 2",
                        "monthlyv0703ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0703ver1long_name": "Version 1",
                        "monthlyv0703ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0610ver2long_name": "Version 2",
                        "monthlyv0610ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0610ver1long_name": "Version 1",
                        "monthlyv0610ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0605ver2long_name": "Version 2",
                        "monthlyv0605ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0605ver1long_name": "Version 1",
                        "monthlyv0605ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0511ver2long_name": "Version 2",
                        "monthlyv0511ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0511ver1long_name": "Version 1",
                        "monthlyv0511ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0507ver2long_name": "Version 2",
                        "monthlyv0507ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0507ver1long_name": "Version 1",
                        "monthlyv0507ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0507v0511": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0511/",
                        "monthlyv0411ver2long_name": "Version 2",
                        "monthlyv0411ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0411ver1long_name": "Version 1",
                        "monthlyv0411ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0411v0507": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0507/",
                        "monthlyv0407ver2long_name": "Version 2",
                        "monthlyv0407ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0407ver1long_name": "Version 1",
                        "monthlyv0407ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0407v0411": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0411/",
                        "monthlyv0312ver2long_name": "Version 2",
                        "monthlyv0312ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0312ver1long_name": "Version 1",
                        "monthlyv0312ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0312v0407": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0407/",
                        "monthlyv0309ver2long_name": "Version 2",
                        "monthlyv0309ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0309ver1long_name": "Version 1",
                        "monthlyv0309ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0309v0312": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0312/",
                        "monthlyv0207ver2long_name": "Version 2",
                        "monthlyv0207ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0207ver1long_name": "Version 1",
                        "monthlyv0207ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0207v0309": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0309/",
                        "monthlyv0203ver2long_name": "Version 2",
                        "monthlyv0203ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0203ver1long_name": "Version 1",
                        "monthlyv0203ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0203v0207": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0207/",
                        "monthlyv0107ver2long_name": "Version 2",
                        "monthlyv0107ver2description": "using rain gauge and satellite estimates",
                        "monthlyv0107ver1long_name": "Version 1",
                        "monthlyv0107ver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlyv0107v0203": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.Merged_Analysis/.monthly/.v0203/",
                        "monthlyv0107long_name": "July 2001 Release",
                        "monthlylatest_rotatingver2long_name": "Version 2",
                        "monthlylatest_rotatingver2description": "using rain gauge and satellite estimates",
                        "monthlylatest_rotatingver1long_name": "Version 1",
                        "monthlylatest_rotatingver1description": "using rain gauge, satellite, and numerical model predictions",
                        "monthlylatestver2long_name": "Version 2",
                        "monthlylatestver2description": "using rain gauge and satellite estimates",
                        "monthlylatestver1long_name": "Version 1",
                        "monthlylatestver1description": "using rain gauge, satellite, and numerical model predictions",
                        "references": "Xie_Arkin1996 Xie_Arkin1997",
                        "Conventions": "IRIDL"
                    },
                    "pentad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pentad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v9810": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v9810",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1306": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1306",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1201": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1201",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0911": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0911",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0811": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0811",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0806": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0806",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0802": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0802",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0705": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0705",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0610": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0610",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0605": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0605",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0512": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0512",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0504": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0504",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0410": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0410",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0309": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0309",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0301": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0301",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0207": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0207",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0203": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0203",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0107": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0107",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "latest": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "latest",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        }
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v9912": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v9912",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation",
                                    "missing_value": "-999.0",
                                    "iridlhasSemantics": "iridl:precipitation"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation",
                                    "missing_value": "-999.0",
                                    "iridlhasSemantics": "iridl:precipitation"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1912": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1912",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1911": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1911",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1910": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1910",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1903": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1903",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1807": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1807",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1611": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1611",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1504": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1504",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1201": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1201",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1101": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1101",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v1001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v1001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0809": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0809",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0806": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0806",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0802": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0802",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0703": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0703",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0610": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0610",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0605": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0605",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0511": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0511",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "iridlhasSemantics": "iridl:precipitation",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "iridlhasSemantics": "iridl:precipitation",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0507": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0507",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0411": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0411",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0407": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0407",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0312": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0312",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0309": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0309",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0207": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0207",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0203": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0203",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "maxncolor": "254",
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "v0107": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v0107",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "CMAP estimated precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "latest_rotating": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "latest_rotating",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "latest": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "latest",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ver2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            },
                            "ver1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ver1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "1989150",
                                    "scale_max": "22.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "22",
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "CMAP Estimated Precipitation",
                                    "units": "mm/day",
                                    "missing_value": "-999.0"
                                },
                                "error": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "error",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "percent",
                                    "missing_value": "-999.0"
                                }
                            }
                        }
                    },
                    "T_44": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_44",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "T_43": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_43",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_42": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_42",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_41": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_41",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_40": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_40",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_39": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_39",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_38": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_38",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_37": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_37",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_36": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_36",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_35": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_35",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_34": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_34",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_33": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_33",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_32": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_32",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_31": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_31",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_30": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_30",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_29": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_29",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_28": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_28",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "T_27": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_27",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1979-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "365"
                    },
                    "T_26": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_26",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "T_25": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_25",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_24": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_24",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_23": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_23",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_22": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_22",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_21": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_21",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_20": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_20",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_19": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_19",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_18": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_18",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_17": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_17",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_16": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_16",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_15": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_15",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_14": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_14",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_13": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_13",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_12": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_12",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_11": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_11",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_09": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_09",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_08": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_08",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/Merged_Analysis"
                },
                "PRECL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PRECL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v1p0deg2p5summary": "http://www.cpc.ncep.noaa.gov/products/global_precip/html/wpage.50yrrec.html",
                        "v1p0deg2p5dataset_documentation": "http://journals.ametsoc.org/doi/abs/10.1175/1525-7541%282002%29003%3C0249%3AGLPAYM%3E2.0.CO%3B2",
                        "v1p0deg2p5description": "PRECL Monthly Mean Rainfall and Number of Gauges in 2.5x2.5 boxes (Version 1.0)",
                        "v1p0deg2p5references": "Chen_etal2002",
                        "v1p0deg2p5source": "ftp://ftp.cpc.ncep.noaa.gov/precip/50yr/gauge/2.5deg/format_bin/",
                        "v1p0deg2p5iridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "v1p0deg1p0summary": "http://www.cpc.ncep.noaa.gov/products/global_precip/html/wpage.50yrrec.html",
                        "v1p0deg1p0dataset_documentation": "http://journals.ametsoc.org/doi/abs/10.1175/1525-7541%282002%29003%3C0249%3AGLPAYM%3E2.0.CO%3B2",
                        "v1p0deg1p0description": "PRECL Monthly Mean Rainfall and Number of Gauges in 1.0x1.0 boxes (Version 1.0)",
                        "v1p0deg1p0references": "Chen_etal2002",
                        "v1p0deg1p0source": "ftp://ftp.cpc.ncep.noaa.gov/precip/50yr/gauge/1.0deg/format_lnx/",
                        "v1p0deg1p0iridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "v1p0deg0p5summary": "http://www.cpc.ncep.noaa.gov/products/global_precip/html/wpage.50yrrec.html",
                        "v1p0deg0p5dataset_documentation": "http://journals.ametsoc.org/doi/abs/10.1175/1525-7541%282002%29003%3C0249%3AGLPAYM%3E2.0.CO%3B2",
                        "v1p0deg0p5description": "PRECL Monthly Mean Rainfall and Number of Gauges in 0.5x0.5 boxes (Version 1.0)",
                        "v1p0deg0p5references": "Chen_etal2002",
                        "v1p0deg0p5source": "ftp://ftp.cpc.ncep.noaa.gov/precip/50yr/gauge/0.5deg/format_bin_lnx/",
                        "v1p0deg0p5iridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "v1p0references": "Chen_etal2002",
                        "description": "Global Land Precipitation: A 50-yr Monthly Gauge-Based Analysis",
                        "Conventions": "IRIDL"
                    },
                    "v1p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "deg2p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg2p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "monthly mean of daily rainfall",
                                "units": "mm/day",
                                "scale_factor": "0.1",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            },
                            "gauge": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gauge",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "number of gauges in each 2.5 deg lat/lon grid box",
                                "units": "count",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            }
                        },
                        "deg1p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rain": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rain",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "monthly mean of daily rainfall",
                                "units": "mm/day",
                                "scale_factor": "0.1",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            },
                            "gnum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gnum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "number of gauges in each 1.0 deg lat/lon grid box",
                                "units": "count",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            }
                        },
                        "deg0p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rain": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rain",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "monthly mean of daily rainfall",
                                "units": "mm/day",
                                "scale_factor": "0.1",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            },
                            "gnum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gnum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "number of gauges in each 0.5 deg lat/lon grid box",
                                "units": "count",
                                "missing_value": "-999.0",
                                "expires": "1617235200",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "expires": "1617235200",
                        "pointwidth": "1.0",
                        "long_name": "Time",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/PRECL"
                },
                "REGIONAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "REGIONAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "USAdailygriddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.USA.daily.gridded.dataset_documentation.html",
                        "USAdailygriddediridlhasSemantics": "iriref:Yarosh_ES",
                        "US_Mexicodailygriddedrealtimedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.US_Mexico.daily.gridded.realtime.dataset_documentation.html",
                        "US_Mexicodailygriddedarchivedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.US_Mexico.daily.gridded.archive.dataset_documentation.html",
                        "Brazildailyv2005griddedreferences": "Silva_etal2006",
                        "Brazildailyv2005griddeddescription": "Brazil Daily Gridded Precipitation Analysis, 2005 Version",
                        "Brazildailyv2005griddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.Brazil.daily.v2005.gridded.dataset_documentation.html",
                        "Brazildailyoriginalgriddeddescription": "Brazil Daily Gridded Precipitation Analysis, Original Version",
                        "Brazildailyoriginalgriddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.Brazil.daily.original.gridded.dataset_documentation.html",
                        "Brazildailygriddeddescription": "Brazil Daily Precipitation Analysis",
                        "Brazildailygriddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.REGIONAL/.Brazil.daily.gridded.dataset_documentation.html",
                        "description": "Daily gridded precipitation in North and South America",
                        "Conventions": "IRIDL"
                    },
                    "USA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "USA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gridded": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gridded",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "inch"
                                }
                            }
                        }
                    },
                    "US_Mexico": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "US_Mexico",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gridded": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gridded",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "realtime": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "realtime",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "in/day",
                                        "missing_value": "-9999.0"
                                    }
                                },
                                "archive": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "archive",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "-9999.0",
                                        "units": "mm/day",
                                        "colormap": "290304",
                                        "scale_max": "16.0",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "CE": "16",
                                        "colorscalename": "precip_colors",
                                        "long_name": "Precipitation",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    },
                    "SA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gridded": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gridded",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "missing_value": "9999.0"
                                }
                            }
                        }
                    },
                    "Brazil": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Brazil",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v2005": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v2005",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gridded": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gridded",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day"
                                    }
                                }
                            },
                            "original": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "original",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gridded": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gridded",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day"
                                    }
                                }
                            },
                            "gridded": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gridded",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day"
                                }
                            }
                        }
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "latitude"
                    },
                    "T_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "latitude"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2001-05-01 12:00:00",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "longitude"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2000-01-01 12:00:00",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/REGIONAL"
                },
                "UNIFIED_PRCP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "UNIFIED_PRCP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GAUGE_BASEDGLOBALv1p0RETROData": "ftp://ftp.cpc.ncep.noaa.gov/precip/CPC_UNI_PRCP/GAUGE_GLB/V1.0/",
                        "GAUGE_BASEDGLOBALv1p0RETROreferences": "Xie_etal2007 Chen_etal2008a Chen_etal2008b",
                        "GAUGE_BASEDGLOBALv1p0RETROiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "GAUGE_BASEDGLOBALv1p0REALTIMEData": "ftp://ftp.cpc.ncep.noaa.gov/precip/CPC_UNI_PRCP/GAUGE_GLB/RT/",
                        "GAUGE_BASEDGLOBALv1p0REALTIMEreferences": "Xie_etal2007 Chen_etal2008a Chen_etal2008b",
                        "GAUGE_BASEDGLOBALv1p0REALTIMEiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "GAUGE_BASEDGLOBALv1p0REALTIMEexpires": "1615224000",
                        "GAUGE_BASEDGLOBALv1p0dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.UNIFIED_PRCP/.GAUGE_BASED.GLOBAL.v1p0.dataset_documentation.html",
                        "GAUGE_BASEDCONUSv1p0RETROData": "ftp://ftp.cpc.ncep.noaa.gov/precip/CPC_UNI_PRCP/GAUGE_CONUS/V1.0/",
                        "GAUGE_BASEDCONUSv1p0RETROreferences": "Xie_etal2007 Chen_etal2008a Chen_etal2008b",
                        "GAUGE_BASEDCONUSv1p0RETROiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "GAUGE_BASEDCONUSv1p0REALTIMEData": "ftp://ftp.cpc.ncep.noaa.gov/precip/CPC_UNI_PRCP/GAUGE_CONUS/RT/",
                        "GAUGE_BASEDCONUSv1p0REALTIMEreferences": "Xie_etal2007 Chen_etal2008a Chen_etal2008b",
                        "GAUGE_BASEDCONUSv1p0REALTIMEiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                        "GAUGE_BASEDCONUSv1p0REALTIMEexpires": "1615224000",
                        "description": "CPC Unified Precipitation Analyses",
                        "Conventions": "IRIDL"
                    },
                    "GAUGE_BASED": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GAUGE_BASED",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v1p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RETRO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RETRO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Precipitation",
                                        "units": "mm/day",
                                        "scale_factor": "0.1",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "gnum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gnum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Gauges Available in Each Grid Box",
                                        "units": "number of gauges",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "EOD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EOD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "hour",
                                        "long_name": "End of Day Time",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "REALTIME": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "REALTIME",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Precipitation",
                                        "units": "mm/day",
                                        "scale_factor": "0.1",
                                        "expires": "1615224000",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "gnum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gnum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Gauges Available in Each Grid Box",
                                        "units": "number of gauges",
                                        "expires": "1615224000",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "EOD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EOD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "hour",
                                        "long_name": "End of Day Time",
                                        "missing_value": "-999.0",
                                        "expires": "1615224000"
                                    }
                                },
                                "extREALTIME": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "extREALTIME",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "T:  0000 1 Jan 2006 to 0000 6 Mar 2021 appended from NOAA NCEP CPC UNIFIED_PRCP GAUGE_BASED GLOBAL v1p0 REALTIME rain",
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Precipitation",
                                        "units": "mm/day",
                                        "scale_factor": "0.1",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "CONUS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CONUS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v1p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RETRO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RETRO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Precipitation",
                                        "units": "mm/day",
                                        "scale_factor": "0.1",
                                        "missing_value": "-999.0",
                                        "pointwidth": "1"
                                    },
                                    "gnum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gnum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Gauges Available in Each Grid Box",
                                        "units": "number of gauges",
                                        "missing_value": "-999.0",
                                        "pointwidth": "1"
                                    }
                                },
                                "REALTIME": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "REALTIME",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_precipitation_rate",
                                        "long_name": "Precipitation",
                                        "units": "mm/day",
                                        "scale_factor": "0.1",
                                        "expires": "1615224000",
                                        "missing_value": "-999.0",
                                        "pointwidth": "1"
                                    },
                                    "gnum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gnum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Number of Gauges Available in Each Grid Box",
                                        "units": "number of gauges",
                                        "expires": "1615224000",
                                        "missing_value": "-999.0",
                                        "pointwidth": "1"
                                    }
                                }
                            }
                        }
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0",
                        "standard_name": "time"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615224000",
                        "pointwidth": "0",
                        "standard_name": "time"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1",
                        "standard_name": "time"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01 00:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615224000",
                        "pointwidth": "1",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.25",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/UNIFIED_PRCP"
                },
                "USA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "USA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dailygriddeddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.CPC/.USA/.daily.gridded.dataset_documentation.html",
                        "Conventions": "IRIDL"
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridded": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gridded",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "inch"
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.25",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/USA"
                },
                "temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dailyDocumentation": "https://www.esrl.noaa.gov/psd/data/gridded/data.cpc.globaltemp.html",
                        "dailyData": "ftp://ftp.cpc.ncep.noaa.gov/precip/PEOPLE/wd52ws/global_temp/",
                        "Conventions": "IRIDL"
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Daily Minimum Temperature",
                            "units": "Celsius_scale",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "air_temperature",
                            "long_name": "Daily Maximum Temperature",
                            "units": "Celsius_scale",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "nmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Number of Reports for Minimum Temperature",
                            "units": "count",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "nmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Number of Reports for Maximum Temperature",
                            "units": "count",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.5",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "1",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "0.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/CPC/temperature"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CAMS",
                    "CAMS_OPI",
                    "CA_SST",
                    "CLIMAT",
                    "CMORPH",
                    "DailyEVE",
                    "EVE",
                    "FEWS",
                    "GHCN_CAMS",
                    "GLOBAL",
                    "GMSM",
                    "GOB",
                    "GSOD",
                    "GTS",
                    "Indices",
                    "Merged_Analysis",
                    "PRECL",
                    "REGIONAL",
                    "UNIFIED_PRCP",
                    "USA",
                    "temperature"
                ]
            },
            "EMC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NOAA/NCEP/EMC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "EMC",
                "restriction": "Public",
                "CFS": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/NCEP/EMC/CFS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CFS",
                    "restriction": "Public",
                    "DAILY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DAILY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MSLlong_name": "Mean Sea Level",
                            "Conventions": "IRIDL"
                        },
                        "total_air_column": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_air_column",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PWAT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PWAT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2",
                                "gribfield": "1",
                                "gribNumBits": "10",
                                "long_name": "Precipitable water",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "200",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "scale_max": "78.599998",
                                "scale_min": "0.0",
                                "PTVersion": "2",
                                "gribparam": "54",
                                "gribcenter": "7",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PWAT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "gribNumBits": "10",
                                    "long_name": "solar flux",
                                    "PDS_TimeRange": "10",
                                    "gribleveltype": "8",
                                    "process": "98",
                                    "GRIBgridcode": "2",
                                    "gribparam": "211",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "gribcenter": "7",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "longwave flux",
                                    "gribNumBits": "8",
                                    "PDS_TimeRange": "10",
                                    "gribleveltype": "8",
                                    "process": "98",
                                    "GRIBgridcode": "2",
                                    "gribparam": "212",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "gribcenter": "7",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                }
                            }
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "0",
                            "standard_name": "time",
                            "long_name": "Forecast Time",
                            "units": "days since 1981-01-01",
                            "calendar": "standard"
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "solar flux",
                                    "gribNumBits": "9",
                                    "process": "98",
                                    "scale_min": "0.0",
                                    "gribleveltype": "1",
                                    "PDS_TimeRange": "10",
                                    "GRIBgridcode": "2",
                                    "gribparam": "211",
                                    "scale_max": "620.0",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "gribcenter": "7",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "longwave flux",
                                    "gribNumBits": "9",
                                    "process": "98",
                                    "scale_min": "65.0",
                                    "gribleveltype": "1",
                                    "PDS_TimeRange": "10",
                                    "GRIBgridcode": "2",
                                    "gribparam": "212",
                                    "scale_max": "601.0",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "gribcenter": "7",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                }
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional momentum flux",
                                "units": "N/m^2",
                                "gribNumBits": "12",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "PTVersion": "2",
                                "gribparam": "125",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "VFLX",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "0.0"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal momentum flux",
                                "units": "N/m^2",
                                "gribNumBits": "12",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "PTVersion": "2",
                                "gribparam": "124",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "UFLX",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "0.0"
                            },
                            "sensible_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sensible_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "gribfield": "1",
                                "long_name": "Sensible heat flux",
                                "gribNumBits": "10",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "gribparam": "122",
                                "PTVersion": "2",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "SHTFL",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "gribNumBits": "16",
                                "long_name": "Pressure",
                                "GRIBgridcode": "2",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "gribparam": "1",
                                "scale_min": "49181.0",
                                "scale_max": "109449.0",
                                "PTVersion": "2",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2/s",
                                "gribfield": "1",
                                "long_name": "Precipitation rate",
                                "gribNumBits": "12",
                                "process": "98",
                                "gribleveltype": "1",
                                "PDS_TimeRange": "10",
                                "GRIBgridcode": "2",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "59",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "PRATE",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "latent_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "latent_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "gribfield": "1",
                                "gribNumBits": "10",
                                "long_name": "Latent heat flux",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "subcenter": "Environmental Modeling Center",
                                "PTVersion": "2",
                                "gribparam": "121",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "LHTFL",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "solar flux",
                                    "gribNumBits": "10",
                                    "PDS_TimeRange": "10",
                                    "gribleveltype": "1",
                                    "process": "98",
                                    "GRIBgridcode": "2",
                                    "PTVersion": "2",
                                    "gribparam": "204",
                                    "center": "US Weather Service - National Met. Center",
                                    "gribcenter": "7",
                                    "grib_name": "DSWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "gribNumBits": "9",
                                    "long_name": "longwave flux",
                                    "PDS_TimeRange": "10",
                                    "gribleveltype": "1",
                                    "process": "98",
                                    "GRIBgridcode": "2",
                                    "PTVersion": "2",
                                    "gribparam": "205",
                                    "gribcenter": "7",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DLWRF",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                }
                            },
                            "DIST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DIST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "gribNumBits": "6",
                                "missing_value": "9.99900026E20",
                                "long_name": "Geometric height",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "1",
                                "process": "98",
                                "unnamed": "DIST",
                                "GRIBgridcode": "10",
                                "scale_min": "-1.9",
                                "scale_max": "1.3",
                                "PTVersion": "2",
                                "gribparam": "8",
                                "gribcenter": "7",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "DIST",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vpot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Velocity potential",
                                "units": "m^2/s",
                                "gribNumBits": "12",
                                "process": "98",
                                "gribleveltype": "100",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "2",
                                "PTVersion": "2",
                                "gribparam": "36",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "VPOT",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "long_name": "meridional wind",
                                "gribNumBits": "9",
                                "scale_min": "-42.400002",
                                "PDS_TimeRange": "3",
                                "gribleveltype": "100",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "gribparam": "34",
                                "scale_max": "45.700001",
                                "PTVersion": "2",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "long_name": "zonal wind",
                                "gribNumBits": "10",
                                "gribleveltype": "100",
                                "process": "98",
                                "PDS_TimeRange": "10",
                                "GRIBgridcode": "2",
                                "subcenter": "Environmental Modeling Center",
                                "scale_max": "44.0",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "UGRD",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribNumBits": "13",
                                "units": "m^2/s",
                                "long_name": "Stream function",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "100",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "subcenter": "Environmental Modeling Center",
                                "scale_min": "-43560000.0",
                                "PTVersion": "2",
                                "gribparam": "35",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "STRM",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "long_name": "Geopotential height",
                                "gribNumBits": "13",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "100",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "subcenter": "Environmental Modeling Center",
                                "PTVersion": "2",
                                "gribparam": "7",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "HGT"
                            }
                        },
                        "ocean_mixed_layer_bot": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ocean_mixed_layer_bot",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "ocean mixed layer depth",
                                "gribNumBits": "11",
                                "PDS_TimeRange": "3",
                                "process": "98",
                                "gribleveltype": "237",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "gribparam": "195",
                                "PTVersion": "129",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "ocean_isothermal_layer_bot": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ocean_isothermal_layer_bot",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "isothermal depth",
                                "gribNumBits": "11",
                                "process": "98",
                                "PDS_TimeRange": "3",
                                "gribleveltype": "238",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "129",
                                "gribparam": "195",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "ocean_isotherm_level": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ocean_isotherm_level",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "gribNumBits": "8",
                                "long_name": "isothermal depth",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "235",
                                "process": "98",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "gribparam": "195",
                                "PTVersion": "129",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "var195",
                                "calendar": "standard"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PRMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "gribNumBits": "14",
                                "long_name": "Pressure reduced to MSL",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "102",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "scale_max": "109003.0",
                                "scale_min": "92755.0",
                                "PTVersion": "2",
                                "gribparam": "2",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "PRMSL",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "forecast_period",
                            "long_name": "Lead Time",
                            "units": "days",
                            "calendar": "standard",
                            "pointwidth": "0"
                        },
                        "BelowSeaLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BelowSeaLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "gribNumBits": "12",
                                "PDS_TimeRange": "3",
                                "process": "98",
                                "gribleveltype": "160",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "3",
                                "gribparam": "11",
                                "subcenter": "Environmental Modeling Center",
                                "gribcenter": "7",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "tchp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tchp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "Tropical Cyclone Heat Potential",
                                "gribNumBits": "16",
                                "process": "98",
                                "PDS_TimeRange": "3",
                                "gribleveltype": "239",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "gribparam": "194",
                                "PTVersion": "129",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribNumBits": "9",
                                "units": "m/s",
                                "long_name": "meridional wind",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "105",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "PTVersion": "2",
                                "gribparam": "34",
                                "gribcenter": "7",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribNumBits": "9",
                                "units": "m/s",
                                "long_name": "zonal wind",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "105",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "gribcenter": "7",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "gribNumBits": "10",
                                "PDS_TimeRange": "10",
                                "gribleveltype": "105",
                                "process": "98",
                                "GRIBgridcode": "2",
                                "gribparam": "11",
                                "PTVersion": "2",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "grib_name": "TMP",
                                "pointwidth": "0.0"
                            }
                        },
                        "m_ocean_layer": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0-300m_ocean_layer",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "oceanheat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "oceanheat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "J/m2",
                                "gribfield": "1",
                                "gribNumBits": "16",
                                "long_name": "heat content",
                                "process": "98",
                                "PDS_TimeRange": "3",
                                "gribleveltype": "236",
                                "GRIBgridcode": "10",
                                "missing_value": "9.99900026E20",
                                "gribparam": "197",
                                "PTVersion": "129",
                                "subcenter": "Environmental Modeling Center",
                                "center": "US Weather Service - National Met. Center",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "pointwidth": "650.0"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0"
                        },
                        "Level": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Level",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "gridtype": "0"
                        },
                        "M_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "calendar": "standard",
                            "pointwidth": "1.0"
                        },
                        "Z_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "Z": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "2.5",
                            "standard_name": "latitude"
                        },
                        "L0_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L0_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "0.5",
                            "long_name": "Integration Time"
                        },
                        "X_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.5",
                            "standard_name": "longitude"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Integration Time"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gridtype": "0",
                            "calendar": "standard",
                            "long_name": "Forecast Issue Time",
                            "standard_name": "forecast_reference_time",
                            "scale_max": "-2434378.5",
                            "units": "days since 1981-01-01",
                            "scale_min": "-2444605.5",
                            "pointwidth": "0.0"
                        },
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFS/DAILY"
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MSLlong_name": "Mean Sea Level",
                            "source": "http://cfs.ncep.noaa.gov/cfs/monthly/",
                            "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFS/.MONTHLY/.griblist.html",
                            "Conventions": "IRIDL"
                        },
                        "top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "process": "98",
                                    "long_name": "solar flux",
                                    "gribleveltype": "8",
                                    "scale_max": "379.29999",
                                    "PTVersion": "2",
                                    "scale_min": "0.0",
                                    "gribparam": "211",
                                    "PDS_TimeRange": "3",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "calendar": "standard",
                                    "gribNumBits": "12",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "USWRF",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "process": "98",
                                    "long_name": "longwave flux",
                                    "gribleveltype": "8",
                                    "scale_max": "355.10001",
                                    "PTVersion": "2",
                                    "scale_min": "92.199997",
                                    "gribparam": "212",
                                    "PDS_TimeRange": "3",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "calendar": "standard",
                                    "gribNumBits": "11",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "ULWRF",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "WATR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "WATR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2",
                                "gribfield": "1",
                                "long_name": "Water runoff",
                                "process": "98",
                                "gribleveltype": "1",
                                "missing_value": "9.99900026E20",
                                "scale_max": "23.98",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "90",
                                "PDS_TimeRange": "3",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "calendar": "standard",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "11",
                                "grib_name": "WATR",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "solar flux",
                                    "process": "98",
                                    "gribleveltype": "1",
                                    "PTVersion": "2",
                                    "scale_max": "365.39999",
                                    "scale_min": "0.0",
                                    "gribparam": "211",
                                    "gribNumBits": "12",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "calendar": "standard",
                                    "grib_name": "USWRF",
                                    "center": "US Weather Service - National Met. Center",
                                    "PDS_TimeRange": "3",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "longwave flux",
                                    "process": "98",
                                    "gribleveltype": "1",
                                    "PTVersion": "2",
                                    "scale_max": "574.29999",
                                    "scale_min": "93.199997",
                                    "gribparam": "212",
                                    "gribNumBits": "12",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "calendar": "standard",
                                    "grib_name": "ULWRF",
                                    "center": "US Weather Service - National Met. Center",
                                    "PDS_TimeRange": "3",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                }
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "316.20999",
                                "PTVersion": "2",
                                "scale_min": "200.60001",
                                "gribparam": "11",
                                "calendar": "standard",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "gribNumBits": "13",
                                "grib_name": "TMP",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "snow_depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snow_depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2",
                                "gribfield": "1",
                                "long_name": "Accum. snow",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "55002.879",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "65",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "gribNumBits": "16",
                                "grib_name": "WEASD",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "sensible_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sensible_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "gribfield": "1",
                                "long_name": "Sensible heat flux",
                                "process": "98",
                                "gribleveltype": "1",
                                "PTVersion": "2",
                                "scale_max": "780.79999",
                                "scale_min": "-216.8",
                                "gribparam": "122",
                                "gribcenter": "7",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "98",
                                "gribNumBits": "13",
                                "grib_name": "SHTFL",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "long_name": "Pressure",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "110041.0",
                                "PTVersion": "2",
                                "scale_min": "49092.0",
                                "gribparam": "1",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "gribNumBits": "16",
                                "grib_name": "PRES",
                                "PDS_TimeRange": "3",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2/s",
                                "gribfield": "1",
                                "long_name": "Precipitation rate",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "7.87600002E-04",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "59",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "13",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRATE",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "potential_evap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "potential_evap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "gribfield": "1",
                                "long_name": "potential evaporation",
                                "process": "98",
                                "gribleveltype": "1",
                                "missing_value": "9.99900026E20",
                                "scale_max": "2923.7",
                                "PTVersion": "2",
                                "scale_min": "-8.8000002",
                                "gribparam": "145",
                                "gribcenter": "7",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "98",
                                "calendar": "standard",
                                "gribNumBits": "15",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PEVPR",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "latent_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "latent_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "gribfield": "1",
                                "long_name": "Latent heat flux",
                                "process": "98",
                                "gribleveltype": "1",
                                "PTVersion": "2",
                                "scale_max": "932.0",
                                "scale_min": "-39.5",
                                "gribparam": "121",
                                "gribcenter": "7",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "98",
                                "gribNumBits": "14",
                                "grib_name": "LHTFL",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "HPBL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HPBL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "long_name": "Planetary boundary layer height",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "3028.6001",
                                "PTVersion": "2",
                                "scale_min": "47.299999",
                                "gribparam": "221",
                                "gribcenter": "7",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "98",
                                "calendar": "standard",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "15",
                                "grib_name": "HPBL",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "Ground heat flux",
                                    "process": "98",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "PTVersion": "2",
                                    "scale_max": "275.79999",
                                    "scale_min": "-103.6",
                                    "gribparam": "155",
                                    "gribcenter": "7",
                                    "PDS_TimeRange": "3",
                                    "GRIBgridcode": "98",
                                    "gribNumBits": "11",
                                    "grib_name": "GFLUX",
                                    "center": "US Weather Service - National Met. Center",
                                    "subcenter": "Environmental Modeling Center",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "gribfield": "1",
                                    "long_name": "longwave flux",
                                    "process": "98",
                                    "gribleveltype": "1",
                                    "PTVersion": "2",
                                    "scale_max": "460.0",
                                    "scale_min": "57.0",
                                    "gribparam": "205",
                                    "gribNumBits": "12",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "calendar": "standard",
                                    "grib_name": "DLWRF",
                                    "center": "US Weather Service - National Met. Center",
                                    "PDS_TimeRange": "3",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                }
                            },
                            "DIST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DIST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "long_name": "Geometric height",
                                "process": "98",
                                "missing_value": "9.99900026E20",
                                "PDS_TimeRange": "3",
                                "gribleveltype": "1",
                                "scale_max": "1.3",
                                "PTVersion": "3",
                                "scale_min": "-2.0999999",
                                "gribparam": "8",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "10",
                                "gribNumBits": "5",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "DIST",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "cprate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cprate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2/s",
                                "gribfield": "1",
                                "long_name": "Convective precip. rate",
                                "process": "98",
                                "gribleveltype": "1",
                                "scale_max": "7.12600013E-04",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "214",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "12",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CPRAT",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "soil": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soil",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "process": "98",
                                "gribleveltype": "112",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "2",
                                "scale_max": "310.59",
                                "scale_min": "199.8",
                                "gribparam": "11",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "gribNumBits": "14",
                                "grib_name": "TMP",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "moisture": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "moisture",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "moisture",
                                "process": "98",
                                "gribleveltype": "112",
                                "missing_value": "9.99900026E20",
                                "scale_max": "0.468",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "144",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "gribNumBits": "13",
                                "grib_name": "SOILW",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa/s",
                                "gribfield": "1",
                                "long_name": "Pressure vertical velocity",
                                "process": "98",
                                "gribleveltype": "100",
                                "scale_max": "0.3047",
                                "PTVersion": "2",
                                "scale_min": "-0.4376",
                                "gribparam": "39",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "2",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "13",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VVEL",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "vpot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Velocity potential",
                                "units": "m^2/s",
                                "process": "98",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "scale_max": "19610000.0",
                                "scale_min": "-27080000.0",
                                "gribparam": "36",
                                "calendar": "standard",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "gribNumBits": "12",
                                "grib_name": "VPOT",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "units": "m/s",
                                "process": "98",
                                "gribleveltype": "100",
                                "scale_max": "30.129999",
                                "PTVersion": "2",
                                "scale_min": "-27.440001",
                                "gribparam": "34",
                                "PDS_TimeRange": "3",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "calendar": "standard",
                                "gribNumBits": "13",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "subcenter": "Environmental Modeling Center",
                                "gribfield": "1"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "units": "m/s",
                                "process": "98",
                                "gribleveltype": "100",
                                "scale_max": "87.510002",
                                "PTVersion": "2",
                                "scale_min": "-29.709999",
                                "gribparam": "33",
                                "PDS_TimeRange": "3",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "calendar": "standard",
                                "gribNumBits": "14",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "subcenter": "Environmental Modeling Center",
                                "gribfield": "1"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "process": "98",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "11",
                                "calendar": "standard",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "gribNumBits": "12",
                                "grib_name": "TMP",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Stream function",
                                "units": "m^2/s",
                                "process": "98",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "scale_max": "1.84530000E08",
                                "scale_min": "-1.81390000E08",
                                "gribparam": "35",
                                "calendar": "standard",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "gribNumBits": "15",
                                "grib_name": "STRM",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "gribfield": "1",
                                "pointwidth": "650.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "long_name": "Geopotential height",
                                "process": "98",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "7",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "2",
                                "gribNumBits": "16",
                                "grib_name": "HGT",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center"
                            }
                        },
                        "ocean_mixed_layer_bot": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ocean_mixed_layer_bot",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "process": "98",
                                "long_name": "ocean mixed layer depth",
                                "gribleveltype": "237",
                                "missing_value": "9.99900026E20",
                                "scale_max": "2864.0",
                                "PTVersion": "129",
                                "scale_min": "5.0",
                                "gribparam": "195",
                                "gribcenter": "7",
                                "GRIBgridcode": "10",
                                "PDS_TimeRange": "3",
                                "gribNumBits": "12",
                                "center": "US Weather Service - National Met. Center",
                                "calendar": "standard",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "ocean_isothermal_layer_bot": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ocean_isothermal_layer_bot",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gribfield": "1",
                                "process": "98",
                                "long_name": "isothermal depth",
                                "gribleveltype": "238",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "129",
                                "scale_max": "4479.0",
                                "scale_min": "6.0",
                                "gribparam": "195",
                                "gribcenter": "7",
                                "GRIBgridcode": "10",
                                "calendar": "standard",
                                "gribNumBits": "12",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PRMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gribfield": "1",
                                "long_name": "Pressure reduced to MSL",
                                "process": "98",
                                "gribleveltype": "102",
                                "scale_max": "105698.3",
                                "PTVersion": "2",
                                "scale_min": "96780.203",
                                "gribparam": "2",
                                "gribcenter": "7",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "2",
                                "calendar": "standard",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "16",
                                "grib_name": "PRMSL",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "middlecloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "middle-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "gribfield": "1",
                                "long_name": "cloud cover",
                                "process": "98",
                                "gribleveltype": "224",
                                "scale_max": "96.099998",
                                "PTVersion": "2",
                                "scale_min": "0.4",
                                "gribparam": "71",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "gribNumBits": "10",
                                "grib_name": "TCDC",
                                "PDS_TimeRange": "3",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "lowcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "low-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "gribfield": "1",
                                "long_name": "cloud cover",
                                "process": "98",
                                "gribleveltype": "214",
                                "scale_max": "98.300003",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "gribNumBits": "10",
                                "grib_name": "TCDC",
                                "PDS_TimeRange": "3",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "highcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "high-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "gribfield": "1",
                                "long_name": "cloud cover",
                                "process": "98",
                                "gribleveltype": "234",
                                "scale_max": "98.199997",
                                "PTVersion": "2",
                                "scale_min": "0.3",
                                "gribparam": "71",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "gribNumBits": "10",
                                "grib_name": "TCDC",
                                "PDS_TimeRange": "3",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "Environmental Modeling Center",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "bndarylayer_cld_layer": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bndary-layer_cld_layer",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "gribfield": "1",
                                "long_name": "cloud cover",
                                "process": "98",
                                "gribleveltype": "211",
                                "scale_max": "99.599998",
                                "PTVersion": "2",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "gribNumBits": "10",
                                "grib_name": "TCDC",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "BelowSeaLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BelowSeaLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "process": "98",
                                "gribleveltype": "160",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "3",
                                "scale_max": "305.16",
                                "scale_min": "271.16",
                                "gribparam": "11",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "10",
                                "gribNumBits": "12",
                                "grib_name": "TMP",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "tchp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tchp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "Tropical Cyclone Heat Potential",
                                "process": "98",
                                "gribleveltype": "239",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "129",
                                "scale_max": "2.89136000E09",
                                "scale_min": "0.0",
                                "gribparam": "194",
                                "gribcenter": "7",
                                "GRIBgridcode": "10",
                                "calendar": "standard",
                                "gribNumBits": "16",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "process": "98",
                                "long_name": "meridional wind",
                                "gribleveltype": "105",
                                "PTVersion": "2",
                                "gribparam": "34",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "gribNumBits": "9",
                                "PDS_TimeRange": "10",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "process": "98",
                                "long_name": "zonal wind",
                                "gribleveltype": "105",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "gribcenter": "7",
                                "GRIBgridcode": "2",
                                "gribNumBits": "9",
                                "PDS_TimeRange": "10",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "gribfield": "1",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gribfield": "1",
                                "long_name": "Temperature",
                                "process": "98",
                                "gribleveltype": "105",
                                "PTVersion": "2",
                                "scale_max": "315.62",
                                "scale_min": "206.64999",
                                "gribparam": "11",
                                "gribcenter": "7",
                                "calendar": "standard",
                                "GRIBgridcode": "98",
                                "gribNumBits": "13",
                                "grib_name": "TMP",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gribfield": "1",
                                "long_name": "Specific humidity",
                                "process": "98",
                                "gribleveltype": "105",
                                "scale_max": "0.02202",
                                "PTVersion": "2",
                                "scale_min": "-9.00000014E-05",
                                "gribparam": "51",
                                "PDS_TimeRange": "3",
                                "gribcenter": "7",
                                "GRIBgridcode": "98",
                                "calendar": "standard",
                                "gribNumBits": "11",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "long_name": "Temperature",
                                    "process": "98",
                                    "gribleveltype": "105",
                                    "PTVersion": "2",
                                    "gribparam": "16",
                                    "subcenter": "Environmental Modeling Center",
                                    "gribcenter": "7",
                                    "GRIBgridcode": "98",
                                    "center": "US Weather Service - National Met. Center",
                                    "PDS_TimeRange": "3",
                                    "gribNumBits": "13",
                                    "grib_name": "TMIN",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "long_name": "Temperature",
                                    "process": "98",
                                    "gribleveltype": "105",
                                    "PTVersion": "2",
                                    "scale_max": "322.91",
                                    "scale_min": "208.7",
                                    "gribparam": "15",
                                    "gribcenter": "7",
                                    "calendar": "standard",
                                    "GRIBgridcode": "98",
                                    "gribNumBits": "13",
                                    "grib_name": "TMAX",
                                    "center": "US Weather Service - National Met. Center",
                                    "PDS_TimeRange": "3",
                                    "subcenter": "Environmental Modeling Center",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "m_ocean_layer": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0-300m_ocean_layer",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "oceanheat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "oceanheat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "J/m2",
                                "gribfield": "1",
                                "process": "98",
                                "long_name": "heat content",
                                "gribleveltype": "236",
                                "missing_value": "9.99900026E20",
                                "PTVersion": "129",
                                "scale_max": "3.70693702E11",
                                "scale_min": "3.34610498E11",
                                "gribparam": "197",
                                "gribcenter": "7",
                                "GRIBgridcode": "10",
                                "gribNumBits": "16",
                                "calendar": "standard",
                                "center": "US Weather Service - National Met. Center",
                                "PDS_TimeRange": "3",
                                "subcenter": "Environmental Modeling Center",
                                "pointwidth": "1.0"
                            }
                        },
                        "Z_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "cm",
                            "gridtype": "0"
                        },
                        "P_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "P_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "pointwidth": "650.0"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0"
                        },
                        "Y_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "2.5",
                            "standard_name": "latitude"
                        },
                        "X_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.5",
                            "standard_name": "longitude"
                        },
                        "Z_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "pointwidth": "0",
                            "positive": "down"
                        },
                        "Z_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "Z": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m_above_gnd",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude"
                        },
                        "X_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.875",
                            "standard_name": "longitude"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Member"
                        },
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFS/MONTHLY"
                    },
                    "MONTHLY_REALTIME": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY_REALTIME",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL",
                            "CFSv2": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.MONTHLY_REALTIME/"
                        },
                        "SFLUX": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SFLUX",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "atmos col Precipitable water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWORK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWORK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "atmos col Cloud work function",
                                    "units": "J -kg",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "USWRFsfc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRFsfc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Upward short wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "top Upward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standarded_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WEASD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WEASD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Accum. snow",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "WATR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WATR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "V10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "10 m above gnd v wind",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional gravity wave stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "top Upward short wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRFsfc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRFsfc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Upward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal gravity wave stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible heat flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRATE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRATE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PEVPR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PEVPR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential evaporation rate",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Latent heat flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LAND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Land cover (land=1;sea=0)",
                                    "units": "fraction",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice concentration (ice=1;no ice=0)",
                                    "units": "fraction",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HPBL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HPBL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Planetary boundary layer height",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "GFLUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GFLUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground heat flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Downward short wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DLWRFsfc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DLWRFsfc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Downward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CPRAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CPRAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective precip. rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ALBDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface Albedo",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "clouds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clouds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMPmidcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMPmidcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mid cloud top Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMPlowcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMPlowcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "low cloud top Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMPhighcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMPhighcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDCmidcld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDCmidcld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mid cloud Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDClowcld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDClowcld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "low cloud Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDChighcld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDChighcld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDCconvectcld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDCconvectcld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convect-cld Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESmidcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESmidcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mid cloud top Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESmidcldbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESmidcldbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mid cloud bottom Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESlowcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESlowcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "low cloud top Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESlowcldbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESlowcldbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "low cloud bottom Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PREShighcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PREShighcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PREShighcldbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PREShighcldbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud bottom Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESconvectcldtop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESconvectcldtop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convect-cld top Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRESconvectcldbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRESconvectcldbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convect-cld bottom Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bndarylayer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bndary-layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDCbndarylayercld_": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDCbndarylayercld_",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "boundary layer Total cloud cover",
                                    "units": "percent",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "U10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "10 m above gnd u wind",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMIN2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMIN2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "2 m above gnd Min. temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMAX2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMAX2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "2 m above gnd Max. temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "T2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "2m above gnd Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "2m above gnd Specific humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "_cm_down": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0-10_cm_down",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "0-10 cm down Temp.",
                                    "units": "K",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "0-10 cm down Volumetric soil moisture",
                                    "units": "fraction",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "PRESS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PRESS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "10m v wind above ground",
                                "units": "m s-1",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "u10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "10m u wind above ground",
                                "units": "m s-1",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vwsh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vwsh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical speed shear",
                                    "units": "s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pres": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "totalAirColumn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "totalAirColumn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tozone": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tozone",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total ozone",
                                    "units": "dobson",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tcdc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tcdc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pwat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pwat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitable water",
                                    "units": "Kg m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cwork": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cwork",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "cloud work function",
                                    "units": "J kg-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cwat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cwat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "cloud water",
                                    "units": "kg m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ulwrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ulwrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "upward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dlwrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dlwrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "downward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "tmp2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2m temperature",
                                "units": "K",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "tcdcbl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcbl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "boundary layer total cloud cover",
                                "units": "percent",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "t2min": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2min",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "min 2m temperature",
                                "units": "K",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "t2max": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2max",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "max 2m temperature",
                                "units": "K",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "weasd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "weasd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "accum. snow",
                                    "units": "Kg m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "water": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "water",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "water runoff",
                                    "units": "kg m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "vgwd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v-gwd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional gravity wave stress",
                                    "units": "N m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "uswrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uswrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "upward short wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ulwrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ulwrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "upward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "uflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ugwd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u-gwd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal gravity wave stress",
                                    "units": "N m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "shtfl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "shtfl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "sensible heat flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prmsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prmsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure reduced to MSL",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pres": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precip rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pe": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pe",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "potential evaporation",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "lhtfl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lhtfl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "latent heat flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "lftx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "4lftx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "best 4-layer lifted index",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "land": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "land",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "land cover",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "icec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "icec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ice concentration",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hpbl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hpbl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "planetboundary layer height",
                                    "units": "m",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "gflux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gflux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ground heat flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dswrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dswrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "downward short wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dlwrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dlwrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "downward long wave flux",
                                    "units": "W m-2",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dist": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dist",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geometric height",
                                    "units": "m",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "csnow": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "csnow",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical snow [yes=1;no=0]",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "crain": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "crain",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical rain [yes=1;no=0]",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cprat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cprat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective precip rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective inhibition",
                                    "units": "J/Kg",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cicep": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cicep",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical ice pellets [yes=1;no=0]",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cfrzr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cfrzr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical freezing rain [yes=1;no=0]",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cape": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cape",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective avail. pot. energy",
                                    "units": "J/Kg",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "albdo": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "albdo",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "albedo",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "soil10200cm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soil10-200cm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "soilw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Volumetric soil moisture",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "soil010cm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soil0-10cm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "soilw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Volumetric soil moisture",
                                    "units": "fraction",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma0995": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sigma0.995",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vvel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vvel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure vertical velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature.",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "potential temp.",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma072094": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sigma0.72-0.94",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma044100": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sigma0.44-1.00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma044072": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sigma0.44-0.72",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma033100": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sigma0.33-1.00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "rh2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rh2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2m relative humidity",
                                "units": "percent",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "rh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "relative humidity",
                                "units": "percent",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "q2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "q2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "2m specific humidity",
                                "units": "kg kg-1",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "pvUnits": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pvUnits",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vwsh32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vwsh32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical speed shear 32770 pv units",
                                    "units": "s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "vwsh2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vwsh2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical speed shear 2 pv units",
                                    "units": "s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "v32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind32770 pv units",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "v2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind 2 pv units",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind32770 pv units",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind 2 pv units",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temp 32770 pv units",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temp 2 pv units",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pres32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure 32770 pv units",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pres2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure 2 pv units",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt32770": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt32770",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hgt 32770 pv units",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hgt 2 pv units",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vrt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vrt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute vorticity",
                                    "units": "s-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "vpot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vpot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "units": "m2 s-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal wind",
                                    "units": "m s -1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "K",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "strm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "strm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "stream function",
                                    "units": "m2 s-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "specific humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "pascal s-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "o3mr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "o3mr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ozone mixing ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "clw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "cloud water",
                                    "units": "kg kg-1",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "midCloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "midCloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top temp.",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tcdc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tcdc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prestop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prestop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "presbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "presbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "maxWindLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maxWindLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temp",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pres": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "lowCloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lowCloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top temp.",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tcdc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tcdc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prest": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prest",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "presb": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "presb",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "highCloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "highCloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top temp.",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tcdc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tcdc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prestop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prestop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "presbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "presbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "high cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "geopotential height",
                                "units": "gpm",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "gpa500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gpa500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height anomaly at 500 mb",
                                "units": "gpm",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "gpa1000": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gpa1000",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height anomaly at 1000 mb",
                                "units": "gpm",
                                "cNZ": "17",
                                "P": "P_01",
                                "gribfield": "1",
                                "gribparam": "84",
                                "gribNumBits": "14",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "convectCloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convectCloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tcdc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tcdc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "prestop": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prestop",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "top pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "presbot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "presbot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "500mb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wavh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "5wavh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "5-wave geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "wava": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "5wava",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "500mb 5-wave geopot. height anomaly",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "AMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1829AMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1829": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v1829",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v wind at 1829m above MSL",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "u1829": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u1829",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u wind at 1829m above MSL",
                                    "units": "m s-1",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "tmp1829": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmp1829",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "tmp 1829m above MSL",
                                    "units": "K",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mbAGL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "180-0mbAGL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective inhibition",
                                    "units": "J/Kg",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "cape": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cape",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective avail. pot. energy",
                                    "units": "J/Kg",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "CIsotherm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0CIsotherm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "rh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative humidity",
                                    "units": "percent",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "hgt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hgt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17",
                                    "P": "P_01",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "OCEAN": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCEAN",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "var202": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "var202",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "var202",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "var199": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "var199",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "var199",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "uflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dist": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dist",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geometric height",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "ocean_mixed_layer_bot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ocean_mixed_layer_bot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "depth": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depth",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean_mixed_layer_bot",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "ocean_isothermal_layer_bot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ocean_isothermal_layer_bot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "depth": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depth",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean_isothermal_layer_bot",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "ocean_isotherm_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ocean_isotherm_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "depth": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depth",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean_isotherm_level",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "below_sea_levl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "below_sea_levl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vogrd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vogrd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v of current",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "uogrd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uogrd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "u of current",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "salty": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "salty",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "salinity",
                                    "units": "kg kg-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "pot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "potential temp.",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "dzdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dzdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric vertical velocity",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_ocean_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0-300m_ocean_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vstm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vstm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "v-component of storm motion",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "gribparam": "84",
                                    "gribNumBits": "14",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "Y_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude"
                        },
                        "X_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.875",
                            "standard_name": "longitude"
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure level"
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "2.5",
                            "standard_name": "latitude"
                        },
                        "X_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.5",
                            "standard_name": "longitude"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "gridtype": "0",
                            "long_name": "isotherm level"
                        },
                        "Z": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "long_name": "Depth"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.0",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Member"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2009-01-01",
                            "gridtype": "0",
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "calendar": "standard"
                        },
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFS/MONTHLY_REALTIME"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "DAILY",
                        "MONTHLY",
                        "MONTHLY_REALTIME"
                    ]
                },
                "CFSv2": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CFSv2",
                    "restriction": "Public",
                    "_hourly_rotating": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/6_hourly_rotating",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "6_hourly_rotating",
                        "restriction": "Public",
                        "FLXF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "top_of_atmosphereexpires": "1615349503",
                                "surfaceexpires": "1615349503",
                                "middle_cloudexpires": "1615349503",
                                "low_cloudexpires": "1615349503",
                                "hybrid_levelexpires": "1615349503",
                                "high_cloudexpires": "1615349503",
                                "entire_atmosphereexpires": "1615349503",
                                "convective_cloudexpires": "1615349503",
                                "boundary_layerexpires": "1615349503",
                                "_cm_downexpires": "1615349503",
                                "m_above_groundexpires": "1615349503",
                                "expires": "1615349503",
                                "Conventions": "IRIDL"
                            },
                            "top_of_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top_of_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0.0",
                                "units": "days since 2012-1-1",
                                "standarded_name": "time",
                                "long_name": "Forecast Time",
                                "expires": "1615349503",
                                "calendar": "standard",
                                "standard_name": "forecast_reference_time",
                                "bounds": "S"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WEASD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WEASD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Equivalent of Accumulated Snow Depth",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "WATR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WATR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation Type [Integer(0-13)]",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upwnward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TRANS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TRANS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Transpiration",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tempeture",
                                    "units": "Kelven_degree",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSRUN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSRUN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Storm Surface Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Soil Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOWC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOHF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOHF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Phase Change Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SLTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SLTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Slope Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFEXC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFEXC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Exchange Coefficient",
                                    "units": "kg m-3 m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFCR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFCR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Roughness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SBSNO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SBSNO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation from snow",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRATE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRATE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PEVPR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PEVPR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Evaporation Rate",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LHTFL Latent Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LAND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Land Cover 1=land, 0=sea",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "IMGD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "IMGD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Image data",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HPBL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HPBL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Planetary Boundary Layer Height",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "GFLUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GFLUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "FRICV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRICV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Frictional Velocity",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVCW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVCW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Canopy water evaporation",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVBS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVBS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Direct evaporation from bare soil",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DLWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DLWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDLF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDLF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CRAIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CRAIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Rain (yes=1; no=0)",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CPRAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CPRAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CNWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CNWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Plant Canopy Surface Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CDUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CDUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear sky UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ALBDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Albedo",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ACOND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACOND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Aerodynamic conductance",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "middle_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "middle_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "low_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "low_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "hybrid_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "high_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "high_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "entire_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "entire_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitable Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWORK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWORK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Work Function",
                                    "units": "J kg-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "convective_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convective_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud top level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud bottom level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "boundary_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "boundary_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "_cm_down": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0-10_cm_down",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature 0-10_cm_down",
                                    "units": "Kelven_degree",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Volumetric Soil Moisture Content",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Liquid Volumetric Soil Moisture (non Frozen)",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "10m_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615349503",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.9375",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2012-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1615349503",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/6_hourly_rotating/FLXF"
                        },
                        "PGBF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/6_hourly_rotating/PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "PGBF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "FLXF",
                            "PGBF"
                        ]
                    },
                    "ENSEMBLE": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ENSEMBLE",
                        "restriction": "Public",
                        "FLXF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE/FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "FLXF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "OCNF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCNF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL",
                                "SamplingTable": "mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time",
                                "calendar": "360"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "0.0",
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "pointwidth": "0"
                                },
                                "THFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "THFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Downward Heat Flux at Surface",
                                    "units": "W m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSHG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSHG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Surface Height Relative to Geoid",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "units": "Proportion",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EMNP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EMNP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation - Precipitation",
                                    "units": "cm/day",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "skipM1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "skipM1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "sampleS": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sampleS",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "units": "days since 1960-01-01",
                                "missing_value": "NaN",
                                "calendar": "365"
                            },
                            "s365": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s365",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "calendar": "365",
                                "units": "days since 1960-01-01",
                                "pointwidth": "0.0",
                                "standard_name": "forecast_reference_time"
                            },
                            "offsets": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "offsets",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "M2hour": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M2hour",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "M2hour",
                                "fnname": "mod",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "layer_between_ocean_surface_and_26C_ocean_isothermal_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_ocean_surface_and_26C_ocean_isothermal_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCHP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCHP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tropical Cyclone Heat Potential",
                                    "units": "J m-2 Kelvin_scale-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_2_depths_below_ocean_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_2_depths_below_ocean_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OHC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OHC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ocean Heat Content",
                                    "units": "J m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "isothermal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "isothermal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_mixed_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_mixed_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_isothermal_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_isothermal_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "below_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "below_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SALTY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SALTY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Salinity",
                                    "units": "kg kg-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DZDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DZDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity (Geometric)",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "Z1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gridtype": "0",
                                "long_name": "isothermal"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gridtype": "0",
                                "long_name": "depth_below_sea_level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.0",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE/OCNF"
                        },
                        "PGBF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE/PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "PGBF",
                            "restriction": "Public",
                            "c8210": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE/PGBF/c8210",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "c8210",
                                "restriction": "Public",
                                "pressure_level": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/ENSEMBLE/PGBF/c8210/pressure_level",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "pressure_level",
                                    "restriction": "Public",
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ]
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "pressure_level"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "c8210"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "FLXF",
                            "OCNF",
                            "PGBF"
                        ]
                    },
                    "HINDCAST_CLIMATOLOGY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "HINDCAST_CLIMATOLOGY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "CLIMO_9MON_MMTSEROCNFsurfacedc9910long_name": "1999-2010 climatology",
                            "CLIMO_9MON_MMTSEROCNFsurfacedc9910description": "Climatology:  ATOVS period",
                            "CLIMO_9MON_MMTSEROCNFsurfacedc8210long_name": "1982-2010 climatology",
                            "CLIMO_9MON_MMTSEROCNFsurfacedc8210description": "Climatology:  Full period",
                            "CLIMO_9MON_MMTSEROCNFsurfacedata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSEROCNFsurfacedataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSEROCNFdata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSEROCNFdataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSERFLXFsurfacedc9910long_name": "1999-2010 climatology",
                            "CLIMO_9MON_MMTSERFLXFsurfacedc9910description": "Climatology:  ATOVS period",
                            "CLIMO_9MON_MMTSERFLXFsurfacedc8210long_name": "1982-2010 climatology",
                            "CLIMO_9MON_MMTSERFLXFsurfacedc8210description": "Climatology:  Full period",
                            "CLIMO_9MON_MMTSERFLXFsurfacedata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSERFLXFsurfacedataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddc9910long_name": "1999-2010 climatology",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddc9910description": "Climatology:  ATOVS period",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddc8210long_name": "1982-2010 climatology",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddc8210description": "Climatology:  Full period",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSERFLXF2m_above_grounddataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSERFLXFdata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSERFLXFdataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSERdata": "http://cfs.ncep.noaa.gov/pub/raid1/cfsv2/climo_9mon_mmtser/",
                            "CLIMO_9MON_MMTSERdataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "CLIMO_9MON_MMTSERdescription": "Climatological Time Series of Monthly Means from 9-Month Runs",
                            "dataset_documentation": "http://cfs.ncep.noaa.gov/cfsv2.info/CFSv2.Calibration.Data.doc",
                            "description": "CFSv2 Retrospective Forecast Calibration Climatologies",
                            "Conventions": "IRIDL"
                        },
                        "CLIMO_9MON_MMTSER": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CLIMO_9MON_MMTSER",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OCNF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OCNF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "dc9910": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc9910",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ocnsst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ocnsst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "0.0",
                                            "long_name": "sea surface temperature",
                                            "standard_name": "sea_surface_temperature",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "dc8210": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc8210",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ocnsst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ocnsst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "0.0",
                                            "long_name": "sea surface temperature",
                                            "standard_name": "sea_surface_temperature",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            },
                            "FLXF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FLXF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "dc9910": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc9910",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prate": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prate",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "precipitation rate",
                                            "standard_name": "lwe_precipitation_rate",
                                            "gribfield": "1",
                                            "units": "kg m-2 s-1",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "dc8210": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc8210",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prate": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prate",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "precipitation rate",
                                            "standard_name": "lwe_precipitation_rate",
                                            "gribfield": "1",
                                            "units": "kg m-2 s-1",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                },
                                "m_above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "2m_above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "dc9910": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc9910",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tmp2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2-meter air temperature",
                                            "standard_name": "air_temperature",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "dc8210": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dc8210",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tmp2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2-meter air temperature",
                                            "standard_name": "air_temperature",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            }
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude",
                            "long_name": "Latitude"
                        },
                        "X_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude",
                            "long_name": "Longitude"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "long_name": "Latitude",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "0.9375",
                            "standard_name": "longitude",
                            "long_name": "Longitude"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1984-01-01 00:00:00",
                            "gridtype": "0",
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Forecast Start Time",
                            "calendar": "standard"
                        },
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/HINDCAST_CLIMATOLOGY"
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "description": "hindcasts organized as pentad starts of 4 members",
                            "Conventions": "IRIDL"
                        },
                        "PGBF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical speed sheer",
                                    "units": "s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NCPCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCPCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Large-Scale Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LFTX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "4LFTX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Best (4 layer) Lifted Index",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSNOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSNOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Snow (yes=1; no=0)",
                                    "cNZ": "477",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CRAIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CRAIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Rain (yes=1; no=0)",
                                    "cNZ": "477",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ConvectiveInhibition",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CICEP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CICEP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Ice Pellets (yes=1; no=0)",
                                    "cNZ": "477",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CFRZR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFRZR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Freezing Rain (yes=1; no=0)",
                                    "cNZ": "477",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CAPE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CAPE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Available Potential Energy",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "APCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "APCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ACPCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACPCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "stream_function": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "stream_function",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VPOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VPOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Velocity Potential",
                                    "units": "m2 s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "STRM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "STRM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stream Function",
                                    "units": "m2 s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "PV2e06_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PV=-2e-06_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Speed Sheer",
                                    "units": "s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "PRMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean Sea Level Pressure",
                                "units": "Pa",
                                "cNZ": "477",
                                "gribfield": "1",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "pressure_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "O3MR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "O3MR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ozone Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CLWMR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLWMR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ABSV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ABSV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Absolute Vorticity",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "Model_top_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Model_top_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "O3MR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "O3MR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ozone Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ABSV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ABSV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Absolute Vorticity",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mean_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "max_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "max_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "highest_tropospheric_freezing_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "highest_tropospheric_freezing_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "entire_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "entire_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TOZONE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TOZONE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Ozone",
                                    "units": "Dobson",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Water",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1000-0m_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "HLCY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HLCY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Storm Relative Helicity",
                                    "units": "m2 s-2",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1000mb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GPA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GPA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height Anomaly",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_Mean_Sea_Level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1829m_above_Mean_Sea_Level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mb_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "180-0mb_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "CIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ConvectiveInhibition",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CAPE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CAPE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Available Potential Energy",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "C_isotherm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0C_isotherm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0.995sigma_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0.33-1sigma_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "OCNF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCNF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "UICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "fnname": "maskge",
                                    "long_name": "Temperature",
                                    "missing_value": "NaN",
                                    "file_missing_value": "0.0",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "pointwidth": "0"
                                },
                                "THFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "THFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Downward Heat Flux at Surface",
                                    "units": "W m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "SSHG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSHG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Surface Height Relative to Geoid",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "units": "Proportion",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "EMNP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EMNP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation - Precipitation",
                                    "units": "cm/day",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_ocean_surface_and_26C_ocean_isothermal_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_ocean_surface_and_26C_ocean_isothermal_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCHP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCHP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tropical Cyclone Heat Potential",
                                    "units": "J m-2 Kelvin_scale-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_2_depths_below_ocean_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_2_depths_below_ocean_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OHC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OHC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ocean Heat Content",
                                    "units": "J m-2",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "isothermal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "isothermal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_mixed_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_mixed_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_isothermal_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_isothermal_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            },
                            "below_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "below_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "UOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "SALTY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SALTY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Salinity",
                                    "units": "kg kg-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                },
                                "DZDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DZDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity (Geometric)",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "gribfield": "1",
                                    "missing_value": "0.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "FLXF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top_of_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top_of_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WEASD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WEASD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Equivalent of Accumulated Snow Depth",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "WATR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WATR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation Type [Integer(0-13)]",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upwnward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TRANS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TRANS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Transpiration",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSRUN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSRUN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Storm Surface Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Soil Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOWC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOHF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOHF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Phase Change Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SLTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SLTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Slope Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFEXC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFEXC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Exchange Coefficient",
                                    "units": "kg m-3 m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFCR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFCR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Roughness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SBSNO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SBSNO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation from snow",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRATE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRATE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PEVPR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PEVPR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Evaporation Rate",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LHTFL Latent Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LAND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Land Cover 1=land, 0=sea",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "IMGD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "IMGD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Image data",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HPBL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HPBL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Planetary Boundary Layer Height",
                                    "units": "m",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "GFLUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GFLUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "FRICV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRICV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Frictional Velocity",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVCW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVCW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Canopy water evaporation",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVBS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVBS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Direct evaporation from bare soil",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DLWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DLWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDLF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDLF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CRAIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CRAIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Rain (yes=1; no=0)",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CPRAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CPRAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CNWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CNWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Plant Canopy Surface Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CDUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CDUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear sky UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ALBDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Albedo",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ACOND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACOND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Aerodynamic conductance",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "middle_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "middle_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "low_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "low_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "hybrid_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "high_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "high_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "entire_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "entire_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitable Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWORK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWORK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Work Function",
                                    "units": "J kg-1",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "convective_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convective_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud top level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud bottom level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "boundary_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "boundary_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "_cm_down": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0-10_cm_down",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature 0-10_cm_down",
                                    "units": "Kelven_degree",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Volumetric Soil Moisture Content",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Liquid Volumetric Soil Moisture (non Frozen)",
                                    "cNZ": "0",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "10m_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "P_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure level"
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure level"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure level"
                        },
                        "Z_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Wind Component"
                        },
                        "Z1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gridtype": "0",
                            "long_name": "isothermal"
                        },
                        "Z": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "gridtype": "0",
                            "long_name": "depth_below_sea_level"
                        },
                        "Y_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "standard_name": "latitude"
                        },
                        "X_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "1.0",
                            "standard_name": "longitude"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months",
                            "gridtype": "0",
                            "pointwidth": "1",
                            "standard_name": "forecast_period"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "0.9375",
                            "standard_name": "longitude"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "6.0",
                            "long_name": "Initial time"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "pointwidth": "0",
                            "calendar": "365",
                            "standard_name": "forecast_reference_time"
                        },
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY"
                    },
                    "MONTHLY_REALTIME": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "MONTHLY_REALTIME",
                        "restriction": "Public",
                        "FLXF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "top_of_atmosphereexpires": "1615402800",
                                "surfaceexpires": "1615402800",
                                "middle_cloudexpires": "1615402800",
                                "low_cloudexpires": "1615402800",
                                "hybrid_levelexpires": "1615402800",
                                "high_cloudexpires": "1615402800",
                                "entire_atmosphereexpires": "1615402800",
                                "convective_cloudexpires": "1615402800",
                                "boundary_layerexpires": "1615402800",
                                "_cm_downexpires": "1615402800",
                                "m_above_groundexpires": "1615402800",
                                "expires": "1615402800",
                                "Conventions": "IRIDL"
                            },
                            "top_of_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top_of_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WEASD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WEASD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Equivalent of Accumulated Snow Depth",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "WATR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WATR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Water Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation Type [Integer(0-13)]",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vegetation",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Visible Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "USWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ULWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ULWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Upwnward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal momentum flux",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGWD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U-GWD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Flux of Gravity Wave Stress",
                                    "units": "N m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TRANS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TRANS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Transpiration",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tempeture",
                                    "units": "Kelven_degree",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSRUN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSRUN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Storm Surface Runoff",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Soil Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOWC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOHF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOHF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Phase Change Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SLTYP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SLTYP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Slope Type [Integer(1-9)]",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFEXC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFEXC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Exchange Coefficient",
                                    "units": "kg m-3 m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SFCR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SFCR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Surface Roughness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SBSNO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SBSNO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation from snow",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRATE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRATE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PEVPR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PEVPR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Evaporation Rate",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NDDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Diffuse Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "NBDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NBDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Near IR Beam Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LHTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LHTFL Latent Heat Net Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LAND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Land Cover 1=land, 0=sea",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "IMGD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "IMGD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Image data",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HPBL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HPBL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Planetary Boundary Layer Height",
                                    "units": "m",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "GFLUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GFLUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground Heat Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "FRICV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRICV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Frictional Velocity",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVCW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVCW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Canopy water evaporation",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EVBS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVBS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Direct evaporation from bare soil",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DSWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DSWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Short-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DLWRF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DLWRF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Downward Long-Wave Rad. Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSUSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSUSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSULF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSULF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Upward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Solar Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSDLF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSDLF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear Sky Downward Long Wave Flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CRAIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CRAIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Rain (yes=1; no=0)",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CPRAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CPRAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation Rate",
                                    "units": "kg m-2 s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CNWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CNWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Plant Canopy Surface Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CDUVB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CDUVB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Clear sky UV-B downward solar flux",
                                    "units": "W m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ALBDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Albedo",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ACOND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACOND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Aerodynamic conductance",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "middle_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "middle_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "low_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "low_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "hybrid_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "high_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "high_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Top pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Bottom pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "entire_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "entire_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Precipitable Water",
                                    "units": "kg m-2",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWORK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWORK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Work Function",
                                    "units": "J kg-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "convective_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convective_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud top level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES_bot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES_bot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "convective cloud bottom level pressure",
                                    "units": "Pa",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "boundary_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "boundary_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCDC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCDC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Cloud Cover",
                                    "units": "%",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "_cm_down": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0-10_cm_down",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature 0-10_cm_down",
                                    "units": "Kelven_degree",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Volumetric Soil Moisture Content",
                                    "units": "percentage",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SOILL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOILL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Liquid Volumetric Soil Moisture (non Frozen)",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "10m_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "0",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.9375",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "6.0",
                                "long_name": "Initial time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2011-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "calendar": "standard",
                                "expires": "1615402800"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME/FLXF"
                        },
                        "IPVF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPVF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surfaceexpires": "1615402800",
                                "isentropic_levelexpires": "1615402800",
                                "expires": "1615402800",
                                "Conventions": "IRIDL"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "isentropic_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "isentropic_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "Kelvin_scale m-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PVORT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PVORT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Vorticity",
                                    "units": "Kelvin_scale m2 kg-1 s-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "MNTSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MNTSF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Montgomery Stream Function",
                                    "units": "m2 s-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LAPR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAPR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Lapse Rate",
                                    "units": "Kelvin_scale m-1",
                                    "cNZ": "114",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gridtype": "0",
                                "long_name": "Isentropic level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.0",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "6.0",
                                "long_name": "Initial time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2011-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1615402800",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME/IPVF"
                        },
                        "OCNF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCNF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surfaceexpires": "1615402800",
                                "layer_between_ocean_surface_and_26C_ocean_isothermal_levelexpires": "1615402800",
                                "layer_between_2_depths_below_ocean_surfaceexpires": "1615402800",
                                "isothermalexpires": "1615402800",
                                "bottom_of_ocean_mixed_layerexpires": "1615402800",
                                "bottom_of_ocean_isothermal_layerexpires": "1615402800",
                                "below_sea_levelexpires": "1615402800",
                                "expires": "1615402800",
                                "Conventions": "IRIDL"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Momentum Flux",
                                    "units": "N m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "fnname": "maskge",
                                    "long_name": "Temperature",
                                    "missing_value": "NaN",
                                    "file_missing_value": "0.0",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "pointwidth": "0"
                                },
                                "THFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "THFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Downward Heat Flux at Surface",
                                    "units": "W m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSHG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSHG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Surface Height Relative to Geoid",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "units": "Proportion",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EMNP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EMNP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation - Precipitation",
                                    "units": "cm/day",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_ocean_surface_and_26C_ocean_isothermal_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_ocean_surface_and_26C_ocean_isothermal_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCHP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCHP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tropical Cyclone Heat Potential",
                                    "units": "J m-2 Kelvin_scale-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_2_depths_below_ocean_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_2_depths_below_ocean_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OHC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OHC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ocean Heat Content",
                                    "units": "J m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "isothermal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "isothermal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_mixed_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_mixed_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_isothermal_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_isothermal_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "below_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "below_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SALTY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SALTY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Salinity",
                                    "units": "kg kg-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temoerature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DZDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DZDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity (Geometric)",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gridtype": "0",
                                "long_name": "isothermal"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gridtype": "0",
                                "long_name": "depth_below_sea_level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.0",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "6.0",
                                "long_name": "Initial time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2011-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1615402800",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME/OCNF"
                        },
                        "OCNH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCNH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surfaceexpires": "1615402800",
                                "layer_between_ocean_surface_and_26C_ocean_isothermal_levelexpires": "1615402800",
                                "layer_between_2_depths_below_ocean_surfaceexpires": "1615402800",
                                "isothermalexpires": "1615402800",
                                "bottom_of_ocean_mixed_layerexpires": "1615402800",
                                "bottom_of_ocean_isothermal_layerexpires": "1615402800",
                                "below_sea_levelexpires": "1615402800",
                                "expires": "1615402800",
                                "Conventions": "IRIDL"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Momentum Flux",
                                    "units": "N s-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UICE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UICE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-component of Ice Drift",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Momentum Flux",
                                    "units": "N s-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "THFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "THFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Downward Heat Flux at Surface",
                                    "units": "W m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SSHG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSHG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sea Surface Height Relative to Geoid",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SNOD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Snow Depth",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICETK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICETK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Thickness",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ICEC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ICEC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ice Cover",
                                    "units": "Proportion",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "EMNP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EMNP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Evaporation - Precipitation",
                                    "units": "cm/day",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_ocean_surface_and_26C_ocean_isothermal_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_ocean_surface_and_26C_ocean_isothermal_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TCHP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TCHP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Tropical Cyclone Heat Potential",
                                    "units": "J m-2 Kelvin_scale-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "layer_between_2_depths_below_ocean_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_2_depths_below_ocean_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OHC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OHC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ocean Heat Content",
                                    "units": "J m-2",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "isothermal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "isothermal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_mixed_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_mixed_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "bottom_of_ocean_isothermal_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom_of_ocean_isothermal_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "units": "m",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "below_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "below_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Current",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SALTY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SALTY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Salinity",
                                    "units": "kg kg-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temoerature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "DZDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DZDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity (Geometric)",
                                    "units": "m s-1",
                                    "cNZ": "7",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "gridtype": "0",
                                "long_name": "isothermal"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gridtype": "0",
                                "long_name": "depth_below_sea_level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.5",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.5",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "6.0",
                                "long_name": "Initial time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2011-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "calendar": "standard",
                                "expires": "1615402800"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME/OCNH"
                        },
                        "PGBF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tropopauseexpires": "1615402800",
                                "surfaceexpires": "1615402800",
                                "stream_functionexpires": "1615402800",
                                "PV2e06_surfaceexpires": "1615402800",
                                "pressure_levelexpires": "1615402800",
                                "Model_top_levelexpires": "1615402800",
                                "mean_sea_levelexpires": "1615402800",
                                "max_windexpires": "1615402800",
                                "highest_tropospheric_freezing_levelexpires": "1615402800",
                                "entire_atmosphereexpires": "1615402800",
                                "m_above_groundexpires": "1615402800",
                                "mbexpires": "1615402800",
                                "m_above_Mean_Sea_Levelexpires": "1615402800",
                                "mb_above_groundexpires": "1615402800",
                                "C_isothermexpires": "1615402800",
                                "sigma_levelexpires": "1615402800",
                                "sigma_layerexpires": "1615402800",
                                "Conventions": "IRIDL",
                                "expires": "1615402800"
                            },
                            "tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical speed sheer",
                                    "units": "s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "calendar": "360",
                                "long_name": "Forecast Time",
                                "units": "months since 1960-01-01",
                                "standard_name": "time"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NCPCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCPCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Large-Scale Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "LFTX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "4LFTX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Best (4 layer) Lifted Index",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CSNOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSNOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Snow (yes=1; no=0)",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CRAIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CRAIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Rain (yes=1; no=0)",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ConvectiveInhibition",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CICEP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CICEP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Ice Pellets (yes=1; no=0)",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CFRZR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFRZR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Categorical Freezing Rain (yes=1; no=0)",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "units": "unitless",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CAPE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CAPE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Available Potential Energy",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "APCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "APCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ACPCP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACPCP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Precipitation",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "stream_function": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "stream_function",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VPOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VPOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Velocity Potential",
                                    "units": "m2 s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "STRM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "STRM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stream Function",
                                    "units": "m2 s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "PV2e06_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PV=-2e-06_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Speed Sheer",
                                    "units": "s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "PRMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean Sea Level Pressure",
                                "units": "Pa",
                                "cNZ": "477",
                                "expires": "1615402800",
                                "gribfield": "1",
                                "missing_value": "9.99900026E20",
                                "pointwidth": "0"
                            },
                            "pressure_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "O3MR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "O3MR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ozone Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CLWMR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLWMR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ABSV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ABSV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Absolute Vorticity",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "Model_top_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Model_top_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "Pa s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "SPFH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SPFH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Specific Humidity",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "O3MR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "O3MR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ozone Mixing Ratio",
                                    "units": "kg kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "ABSV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ABSV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Absolute Vorticity",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mean_sea_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean_sea_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "max_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "max_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "PRES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "Pa",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "highest_tropospheric_freezing_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "highest_tropospheric_freezing_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "entire_atmosphere": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "entire_atmosphere",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TOZONE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TOZONE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Ozone",
                                    "units": "Dobson",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cloud Water",
                                    "units": "kg m-2",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1000-0m_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "HLCY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HLCY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Storm Relative Helicity",
                                    "units": "m2 s-2",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1000mb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GPA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GPA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geopotential Height Anomaly",
                                    "units": "gpm",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "m_above_Mean_Sea_Level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1829m_above_Mean_Sea_Level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "mb_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "180-0mb_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "CIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ConvectiveInhibition",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "CAPE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CAPE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective Available Potential Energy",
                                    "units": "J kg-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "C_isotherm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0C_isotherm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "HGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma_level": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0.995sigma_level",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vertical Velocity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "VGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "V-Component of Wind",
                                    "gribfield": "2",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "UGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "U-Component of Wind",
                                    "gribfield": "1",
                                    "units": "m s-1",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "TMP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TMP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Potential Temperature",
                                    "units": "Kelvin_scale",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "sigma_layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0.33-1sigma_layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Relative Humidity",
                                    "units": "%",
                                    "cNZ": "477",
                                    "expires": "1615402800",
                                    "gribfield": "1",
                                    "missing_value": "9.99900026E20",
                                    "pointwidth": "0"
                                }
                            },
                            "P_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "P_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Wind Component"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.0",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "6.0",
                                "long_name": "Initial time"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2011-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "calendar": "standard",
                                "expires": "1615402800"
                            },
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/MONTHLY_REALTIME/PGBF"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "FLXF",
                            "IPVF",
                            "OCNF",
                            "OCNH",
                            "PGBF"
                        ]
                    },
                    "NMME_REALTIME_ENSEMBLE": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/NMME_REALTIME_ENSEMBLE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "NMME_REALTIME_ENSEMBLE",
                        "restriction": "Public",
                        "FLXF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/NMME_REALTIME_ENSEMBLE/FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "FLXF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "OCNF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/NMME_REALTIME_ENSEMBLE/OCNF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "OCNF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "PGBF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/NMME_REALTIME_ENSEMBLE/PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "PGBF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "FLXF",
                            "OCNF",
                            "PGBF"
                        ]
                    },
                    "REALTIME_ENSEMBLE": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/REALTIME_ENSEMBLE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "REALTIME_ENSEMBLE",
                        "restriction": "Public",
                        "FLXF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/REALTIME_ENSEMBLE/FLXF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "FLXF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "OCNF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/REALTIME_ENSEMBLE/OCNF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "OCNF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "PGBF": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/NOAA/NCEP/EMC/CFSv2/REALTIME_ENSEMBLE/PGBF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "PGBF",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "FLXF",
                            "OCNF",
                            "PGBF"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "_hourly_rotating",
                        "ENSEMBLE",
                        "HINDCAST_CLIMATOLOGY",
                        "MONTHLY",
                        "MONTHLY_REALTIME",
                        "NMME_REALTIME_ENSEMBLE",
                        "REALTIME_ENSEMBLE"
                    ]
                },
                "CMB": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CMB",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Pacificprxlong_name": "weekly without TOPEX altimetry",
                        "Pacificgodaslong_name": "weekly GODAS",
                        "PacificgodasCFS": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFS/",
                        "Pacificgdaslong_name": "weekly with TOPEX altimetry",
                        "Pacificreferences": "Behringer_etal1998 Ji_etal1995 Ji_Smith1995",
                        "Pacificdescription": "Pacific Ocean Hindcast data derived from a model-based ocean analysis system",
                        "Pacificdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.Pacific.dataset_documentation.html",
                        "PacificiridlhasSemantics": "iridl:Ocean",
                        "GODASmonthlygriblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GODAS/.monthly/.griblist.html",
                        "GODASmonthlyexpires": "1615507200",
                        "GODASreferences": "Behringer_Xue2004",
                        "GODASdescription": "Global Ocean Data Assimilation System",
                        "GODASiridlhasSemantics": "iridl:Ocean",
                        "GLOBALReyn_SmithOIv2weeklyexpires": "1615161600",
                        "GLOBALReyn_SmithOIv2monthlynote": "revised 13 Sep 2005: replaced pre Apr 2002 files with Apr 2002 versions",
                        "GLOBALReyn_SmithOIv2monthlyexpires": "1615161600",
                        "GLOBALReyn_SmithOIv2monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL.Reyn_SmithOIv2.monthly.dataset_documentation.html",
                        "GLOBALReyn_SmithOIv2climatologyc8110long_name": "1981-2010",
                        "GLOBALReyn_SmithOIv2climatologyc8110dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/NOAA/NCEP/EMC/CMB/GLOBAL/Reyn_SmithOIv2/Note_SST_Climatology_1981-2010.pdf",
                        "GLOBALReyn_SmithOIv2climatologyc8110source": "https://www.cpc.ncep.noaa.gov/products/people/yxue/sstclim/",
                        "GLOBALReyn_SmithOIv2climatologyc7100long_name": "1971-2000",
                        "GLOBALReyn_SmithOIv2climatologyc6190long_name": "1961-1990",
                        "GLOBALReyn_SmithOIv2climatologyiridlhasSemantics": "iridl:climatology",
                        "GLOBALReyn_SmithOIv2references": "Reynolds_etal2002",
                        "GLOBALReyn_SmithOIv2description": "SST fields updated from version 1 with more COADS data, new sea-ice to SST conversion algorithm, and 1971-2000 climatology",
                        "GLOBALReyn_SmithOIv2OISST": "http://www.emc.ncep.noaa.gov/research/cmb/sst_analysis/",
                        "GLOBALReyn_SmithOIv1weeklydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL.Reyn_SmithOIv1.weekly.dataset_documentation.html",
                        "GLOBALReyn_SmithOIv1pentadclimatologydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL.Reyn_SmithOIv1.pentad-climatology.dataset_documentation.html",
                        "GLOBALReyn_SmithOIv1monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL.Reyn_SmithOIv1.monthly.dataset_documentation.html",
                        "GLOBALReyn_SmithOIv1climatologydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL.Reyn_SmithOIv1.climatology.dataset_documentation.html",
                        "GLOBALReyn_SmithOIv1references": "Reynolds:Smith1994",
                        "GLOBALReyn_SmithOIv1description": "Sea surface temperature fields blended from ship, buoy and bias-corrected satellite data  (Reynolds and Smith 1994)",
                        "GLOBALReyn_SmithOIv1ReynoldsSmithOIv2": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL/.Reyn_SmithOIv2/",
                        "description": "Climate Modeling Branch",
                        "Conventions": "IRIDL"
                    },
                    "T40": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T40",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vort": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vort",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "vorticity",
                                "units": "unitless"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "meridional velocity",
                                "units": "m"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "zonal velocity",
                                "units": "m"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "temperature",
                                "units": "unitless"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "streamfunction",
                                "units": "m^2"
                            },
                            "hum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "humidity",
                                "units": "unitless"
                            },
                            "Div": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Div",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "divergence",
                                "units": "unitless"
                            },
                            "chi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB T40 Intrinsic P",
                                "missing_value": "NaN",
                                "long_name": "velocity potential",
                                "units": "m^2"
                            }
                        },
                        "Intrinsic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Intrinsic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vort": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vort",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "vorticity",
                                "units": "unitless"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional velocity",
                                "units": "m"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal velocity",
                                "units": "m"
                            },
                            "topo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "topo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "topography",
                                "units": "unitless"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "temperature",
                                "units": "unitless"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "streamfunction",
                                "units": "m^2"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "pressure",
                                "units": "mb",
                                "fnname": "eexp"
                            },
                            "lnpres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lnpres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "log of surface pressure",
                                "units": "unitless"
                            },
                            "hum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "humidity",
                                "units": "unitless"
                            },
                            "Div": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Div",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "divergence",
                                "units": "unitless"
                            },
                            "chi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "velocity potential",
                                "units": "m^2"
                            }
                        },
                        "Diagnostic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Diagnostic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional velocity at 10m",
                                "units": "m/s"
                            },
                            "uswfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface upward shortwave heat flux",
                                "units": "W/m2"
                            },
                            "ulwfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface upward longwave heat flux",
                                "units": "W/m2"
                            },
                            "u10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal velocity at 10m",
                                "units": "m/s"
                            },
                            "Tskin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Tskin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface skin temperature",
                                "units": "Kelvin_scale"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional surface momentun flux",
                                "units": "unitless"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal surface momentum flux",
                                "units": "dyn/cm2"
                            },
                            "Tair": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Tair",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "air temperature",
                                "units": "Kelvin_scale"
                            },
                            "shfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface sensible heat flux",
                                "units": "W/m2"
                            },
                            "pss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface pressure",
                                "units": "mb",
                                "fnname": "eexp"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "total precipitation",
                                "units": "2000 mm/day"
                            },
                            "olr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "olr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "outgoing longwave radiation",
                                "units": "W/m2"
                            },
                            "mcld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mcld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "mid  cloud fraction",
                                "units": "unitless"
                            },
                            "lhfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface latent heat flux",
                                "units": "W/m2"
                            },
                            "lcld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lcld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "low  cloud fraction",
                                "units": "unitless"
                            },
                            "hcld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hcld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "high cloud fraction",
                                "units": "unitless"
                            },
                            "dswfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface downward short wave heat flux",
                                "units": "W/m2"
                            },
                            "dlwfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "surface downward longwave heat flux",
                                "units": "W/m2"
                            },
                            "cprcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cprcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "convective precipitation",
                                "units": "2000 mm/day"
                            }
                        }
                    },
                    "Pacific": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Pacific",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "weekly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "weekly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas v",
                                "units": "cm/s",
                                "long_name": "meridional velocity",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas u",
                                "units": "cm/s",
                                "long_name": "zonal velocity",
                                "missing_value": "NaN"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas temp",
                                "units": "degree_Celsius",
                                "colormap": "12632256",
                                "missing_value": "NaN",
                                "scale_max": "35.0",
                                "ncolor": "256",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "colorscalename": "sstcolorscale",
                                "CE": "35",
                                "long_name": "temperature"
                            },
                            "tcor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas tcor",
                                "units": "degree_Celsius / hour",
                                "long_name": "temperature correction",
                                "missing_value": "NaN"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas tauy",
                                "units": "unitless",
                                "long_name": "meridional wind stress",
                                "missing_value": "NaN"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas taux",
                                "units": "unitless",
                                "long_name": "zonal wind stress",
                                "missing_value": "NaN"
                            },
                            "swfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "swfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "long_name": "short wave flux",
                                "missing_value": "NaN"
                            },
                            "sal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas sal",
                                "units": "1 above .035",
                                "long_name": "salinity",
                                "missing_value": "NaN",
                                "iridlhasSemantics": "iridl:Salinity"
                            },
                            "hflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas hflx",
                                "units": "langley/s",
                                "note": "swfx + hflx = net heat flux",
                                "long_name": "heat flux",
                                "missing_value": "NaN"
                            },
                            "H": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "H",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 26 Oct 2008 - 1 Nov 2008 appended from NOAA NCEP EMC CMB Pacific godas H",
                                "units": "cm",
                                "long_name": "sea level height anomaly",
                                "missing_value": "NaN"
                            },
                            "D20eq": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "D20eq",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  6-12 Feb 2005 to 1200 29 Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas D20eq",
                                "colormap": "2763429",
                                "scale_max": "200.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "200",
                                "long_name": "Depth of 20C",
                                "units": "m",
                                "missing_value": "NaN",
                                "positive": "down"
                            }
                        },
                        "prx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "meridional velocity",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "zonal velocity",
                                "missing_value": "NaN"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "colormap": "12632256",
                                "missing_value": "NaN",
                                "scale_max": "35.0",
                                "ncolor": "256",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "colorscalename": "sstcolorscale",
                                "CE": "35",
                                "long_name": "temperature"
                            },
                            "tcor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius / hour",
                                "long_name": "temperature correction",
                                "missing_value": "NaN"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "meridional wind stress",
                                "missing_value": "NaN"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "zonal wind stress",
                                "missing_value": "NaN"
                            },
                            "swfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "swfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "long_name": "short wave flux",
                                "missing_value": "NaN"
                            },
                            "sal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "1 above .035",
                                "long_name": "salinity",
                                "missing_value": "NaN"
                            },
                            "hflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "note": "swfx + hflx = net heat flux",
                                "long_name": "heat flux",
                                "missing_value": "NaN"
                            },
                            "H": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "H",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "cm",
                                "long_name": "sea level height anomaly"
                            }
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas v",
                                "units": "cm/s",
                                "long_name": "meridional velocity",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas u",
                                "units": "cm/s",
                                "long_name": "zonal velocity",
                                "missing_value": "NaN"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas temp",
                                "units": "degree_Celsius",
                                "colormap": "12632256",
                                "missing_value": "NaN",
                                "scale_max": "35.0",
                                "ncolor": "256",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "colorscalename": "sstcolorscale",
                                "CE": "35",
                                "long_name": "temperature"
                            },
                            "tcor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas tcor",
                                "units": "degree_Celsius / hour",
                                "long_name": "temperature correction",
                                "missing_value": "NaN"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas tauy",
                                "units": "unitless",
                                "long_name": "meridional wind stress",
                                "missing_value": "NaN"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas taux",
                                "units": "unitless",
                                "long_name": "zonal wind stress",
                                "missing_value": "NaN"
                            },
                            "sal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas sal",
                                "units": "1 above .035",
                                "long_name": "salinity",
                                "missing_value": "NaN"
                            },
                            "H": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "H",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas H",
                                "units": "cm",
                                "long_name": "sea level height anomaly",
                                "missing_value": "NaN"
                            },
                            "D20eq": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "D20eq",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2763429",
                                "scale_max": "200.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "200",
                                "long_name": "Depth of 20C",
                                "units": "m",
                                "missing_value": "NaN",
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB Pacific monthly temp",
                                "positive": "down"
                            }
                        },
                        "godas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "godas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm/s",
                                "long_name": "meridional velocity",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm/s",
                                "long_name": "zonal velocity",
                                "missing_value": "NaN"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "colormap": "12632256",
                                "missing_value": "NaN",
                                "scale_max": "35.0",
                                "ncolor": "256",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "colorscalename": "sstcolorscale",
                                "CE": "35",
                                "long_name": "temperature"
                            },
                            "tcor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius / hour",
                                "long_name": "temperature correction",
                                "missing_value": "NaN"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "meridional wind stress",
                                "missing_value": "NaN"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "zonal wind stress",
                                "missing_value": "NaN"
                            },
                            "sflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "g/cm2/s",
                                "long_name": "surface salt flux",
                                "missing_value": "NaN"
                            },
                            "sal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "1 above .035",
                                "long_name": "salinity",
                                "missing_value": "NaN",
                                "iridlhasSemantics": "iridl:Salinity"
                            },
                            "hflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "note": "swfx + hflx = net heat flux",
                                "long_name": "heat flux",
                                "missing_value": "NaN"
                            },
                            "H": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "H",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "cm",
                                "long_name": "sea level height anomaly"
                            },
                            "D20eq": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "D20eq",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Depth of 20C",
                                "units": "m",
                                "missing_value": "NaN",
                                "history": "toS: regridded Z to NOAA NCEP EMC CMB Pacific godas temp 0",
                                "positive": "down"
                            }
                        },
                        "gdas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gdas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "meridional velocity",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "zonal velocity",
                                "missing_value": "NaN"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "colormap": "12632256",
                                "missing_value": "NaN",
                                "scale_max": "35.0",
                                "ncolor": "256",
                                "scale_min": "-2.0",
                                "CS": "-2",
                                "colorscalename": "sstcolorscale",
                                "CE": "35",
                                "long_name": "temperature"
                            },
                            "tcor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius / hour",
                                "long_name": "temperature correction",
                                "missing_value": "NaN"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "meridional wind stress",
                                "missing_value": "NaN"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "zonal wind stress",
                                "missing_value": "NaN"
                            },
                            "swfx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "swfx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "long_name": "short wave flux",
                                "missing_value": "NaN"
                            },
                            "sal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "1 above .035",
                                "long_name": "salinity",
                                "missing_value": "NaN",
                                "iridlhasSemantics": "iridl:Salinity"
                            },
                            "hflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "langley/s",
                                "note": "swfx + hflx = net heat flux",
                                "long_name": "heat flux",
                                "missing_value": "NaN"
                            },
                            "H": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "H",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "cm",
                                "long_name": "sea level height anomaly"
                            }
                        }
                    },
                    "GODAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GODAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "THFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "THFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "W/m2",
                                    "long_name": "Total downward heat flux at surface",
                                    "gribNumBits": "16",
                                    "process": "129",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "939.72052",
                                    "scale_min": "-1257.8179",
                                    "gribparam": "202",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "129",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "THFLX",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "tauy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "N/m^2",
                                    "long_name": "Meridional momentum flux",
                                    "gribNumBits": "13",
                                    "process": "129",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.3894",
                                    "scale_min": "-0.3883",
                                    "gribparam": "125",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "VFLX",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "taux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "N/m^2",
                                    "long_name": "Zonal momentum flux",
                                    "gribNumBits": "13",
                                    "process": "129",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.4717",
                                    "scale_min": "-0.5229",
                                    "gribparam": "124",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "UFLX",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "SSHG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSHG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "m",
                                    "long_name": "Sea Surface Height Relative to Geoid",
                                    "gribNumBits": "15",
                                    "process": "129",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "1.3818001",
                                    "scale_min": "-1.9813",
                                    "gribparam": "198",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "129",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SSHG",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "SLTFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SLTFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "g/cm^2/s",
                                    "long_name": "Salt flux",
                                    "gribNumBits": "11",
                                    "process": "129",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "5.49999982E-07",
                                    "scale_min": "-1.67799999E-06",
                                    "gribparam": "199",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "129",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SLTFL",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            },
                            "ocean_mixed_layer_bot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ocean_mixed_layer_bot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "m",
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "gribNumBits": "16",
                                    "process": "129",
                                    "gribleveltype": "237",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "2847.811",
                                    "scale_min": "5.0",
                                    "gribparam": "195",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "129",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DBSS",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            },
                            "ocean_isothermal_layer_bot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ocean_isothermal_layer_bot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "DBSS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DBSS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "m",
                                    "long_name": "Geometric Depth Below Sea Surface",
                                    "gribNumBits": "16",
                                    "process": "129",
                                    "gribleveltype": "238",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "4478.499",
                                    "scale_min": "5.6090002",
                                    "gribparam": "195",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "129",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DBSS",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            },
                            "BelowSeaLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "BelowSeaLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "m/s",
                                    "long_name": "v of current",
                                    "gribNumBits": "15",
                                    "process": "129",
                                    "gribleveltype": "160",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "1.4098001",
                                    "scale_min": "-1.3663",
                                    "gribparam": "50",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "VOGRD",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "UOGRD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UOGRD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "units": "m/s",
                                    "long_name": "u of current",
                                    "gribNumBits": "15",
                                    "process": "129",
                                    "gribleveltype": "160",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "1.4153",
                                    "scale_min": "-1.3182",
                                    "gribparam": "49",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "UOGRD",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "SALTY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SALTY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "gribNumBits": "15",
                                    "units": "unitless",
                                    "long_name": "Salinity",
                                    "process": "129",
                                    "gribleveltype": "160",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.044372",
                                    "scale_min": "0.015498",
                                    "gribparam": "88",
                                    "PDS_TimeRange": "7",
                                    "iridlhasSemantics": "iridl:Salinity",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SALTY",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "POT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "POT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "gribNumBits": "16",
                                    "units": "Kelvin_scale",
                                    "long_name": "Potential temperature",
                                    "process": "129",
                                    "gribleveltype": "160",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "306.16",
                                    "scale_min": "267.55801",
                                    "gribparam": "13",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "POT",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                },
                                "DZDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DZDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribcenter": "7",
                                    "gribNumBits": "14",
                                    "units": "m/s",
                                    "long_name": "Geometric vertical velocity",
                                    "process": "129",
                                    "gribleveltype": "160",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "6.23759988E-04",
                                    "scale_min": "-7.24080019E-04",
                                    "gribparam": "40",
                                    "PDS_TimeRange": "7",
                                    "PTVersion": "2",
                                    "subcenter": "Environmental Modeling Center",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DZDT",
                                    "calendar": "standard",
                                    "cNZ": "0",
                                    "gribfield": "1",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Reyn_SmithOIv2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Reyn_SmithOIv2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weekly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weekly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ssta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ssta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature Anomaly",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "scale_max": "4.1999998",
                                    "ncolor": "254",
                                    "scale_min": "-4.1999998",
                                    "CS": "-4.1999998",
                                    "colorscalename": "sstacolorscale",
                                    "CE": "4.1999998",
                                    "units": "degree_Celsius",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "expires": "1615161600"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615161600",
                                    "units": "Celsius_scale",
                                    "colorscalename": "sstcolorscale",
                                    "scale_max": "35.0",
                                    "ncolor": "256",
                                    "scale_min": "-2.0",
                                    "colormap": "12632256",
                                    "CS": "-2",
                                    "CE": "35",
                                    "long_name": "Sea Surface Temperature"
                                },
                                "sea_ice": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sea_ice",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615161600",
                                    "scale_max": "100",
                                    "long_name": "Sea Ice Concentration",
                                    "units": "percent",
                                    "scale_min": "0"
                                },
                                "mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Land-Sea Mask",
                                    "expires": "1615161600"
                                },
                                "err": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "err",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615161600",
                                    "scale_max": "1.0",
                                    "long_name": "SST Normalized Error Variance",
                                    "units": "unitless",
                                    "scale_min": "0.0"
                                }
                            },
                            "pentadclimatology": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pentad-climatology",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "35.0",
                                    "scale_min": "-2.0",
                                    "CS": "-2",
                                    "CE": "35",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "units": "Celsius_scale",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.90002",
                                    "colormap": "12632256",
                                    "ncolor": "256",
                                    "colorscalename": "sstcolorscale",
                                    "long_name": "Sea Surface Temperature"
                                }
                            },
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ssta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ssta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "sea_surface_temperature",
                                    "long_name": "Sea Surface Temperature Anomaly",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "scale_max": "4.1999998",
                                    "ncolor": "254",
                                    "scale_min": "-4.1999998",
                                    "CS": "-4.1999998",
                                    "colorscalename": "sstacolorscale",
                                    "CE": "4.1999998",
                                    "units": "degree_Celsius",
                                    "missing_value": "NaN",
                                    "expires": "1615161600",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615161600",
                                    "units": "Celsius_scale",
                                    "colorscalename": "sstcolorscale",
                                    "scale_max": "35.0",
                                    "ncolor": "256",
                                    "scale_min": "-2.0",
                                    "colormap": "12632256",
                                    "CS": "-2",
                                    "CE": "35",
                                    "standard_name": "sea_surface_temperature",
                                    "long_name": "Sea Surface Temperature",
                                    "pointwidth": "1.0"
                                },
                                "sea_ice": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sea_ice",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615161600",
                                    "scale_max": "100",
                                    "long_name": "Sea Ice Concentration",
                                    "standard_name": "sea_ice_area_fraction",
                                    "units": "percent",
                                    "scale_min": "0",
                                    "valid_max": "100",
                                    "valid_min": "0",
                                    "pointwidth": "1.0"
                                },
                                "mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "standard_name": "land_binary_mask",
                                    "long_name": "Land-Sea Mask",
                                    "expires": "1615161600"
                                }
                            },
                            "climatology": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Land-Sea Mask"
                                },
                                "c8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "c8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "colormap": "12632256",
                                        "scale_max": "35.0",
                                        "ncolor": "256",
                                        "scale_min": "-2.0",
                                        "CS": "-2",
                                        "colorscalename": "sstcolorscale",
                                        "CE": "35",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "-9999.0"
                                    }
                                },
                                "c7100": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "c7100",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "colormap": "12632256",
                                        "scale_max": "35.0",
                                        "ncolor": "256",
                                        "scale_min": "-2.0",
                                        "CS": "-2",
                                        "colorscalename": "sstcolorscale",
                                        "CE": "35",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "-999.90002"
                                    }
                                },
                                "c6190": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "c6190",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "colormap": "12632256",
                                        "scale_max": "35.0",
                                        "ncolor": "256",
                                        "scale_min": "-2.0",
                                        "CS": "-2",
                                        "colorscalename": "sstcolorscale",
                                        "CE": "35",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "-999.90002"
                                    }
                                }
                            }
                        },
                        "Reyn_SmithOIv1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Reyn_SmithOIv1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weekly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weekly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ssta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ssta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature Anomaly",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "scale_max": "4.1999998",
                                    "ncolor": "254",
                                    "scale_min": "-4.1999998",
                                    "CS": "-4.1999998",
                                    "colorscalename": "sstacolorscale",
                                    "CE": "4.1999998",
                                    "units": "degree_Celsius",
                                    "history": "T regridded on NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 pentad-climatology sst"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "colormap": "12632256",
                                    "scale_max": "35.0",
                                    "ncolor": "256",
                                    "scale_min": "-2.0",
                                    "CS": "-2",
                                    "colorscalename": "sstcolorscale",
                                    "CE": "35",
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature",
                                    "history": "Weekly mean sea surface temperature (blended from ship, buoy, and bias-corrected satellite data)."
                                }
                            },
                            "pentadclimatology": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pentad-climatology",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "colormap": "12632256",
                                    "scale_max": "35.0",
                                    "ncolor": "256",
                                    "scale_min": "-2.0",
                                    "CS": "-2",
                                    "colorscalename": "sstcolorscale",
                                    "CE": "35",
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature",
                                    "labelinterval": "5.0",
                                    "history": "Interpolated Climatological sea surface temperature (blended from ship and buoy, data (1950-1979))."
                                }
                            },
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ssta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ssta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_Celsius",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "history": "Monthly mean sea surface temperature anomaly (blended from ship, buoy, and bias-corrected satellite data)",
                                    "scale_max": "4.1999998",
                                    "ncolor": "254",
                                    "scale_min": "-4.1999998",
                                    "CS": "-4.1999998",
                                    "colorscalename": "sstacolorscale",
                                    "CE": "4.1999998",
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature Anomaly"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "colormap": "12632256",
                                    "scale_max": "3500.0",
                                    "ncolor": "256",
                                    "scale_min": "-200.0",
                                    "CS": "-2",
                                    "colorscalename": "sstcolorscale",
                                    "CE": "35",
                                    "PLOTCOAST": "1",
                                    "long_name": "Sea Surface Temperature",
                                    "history": "Monthly mean sea surface temperature (blended from ship, buoy and bias-corrected satellite data). "
                                }
                            },
                            "climatology": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Celsius_scale",
                                    "colormap": "12632256",
                                    "scale_max": "3500.0",
                                    "ncolor": "256",
                                    "scale_min": "-200.0",
                                    "CS": "-2",
                                    "colorscalename": "sstcolorscale",
                                    "CE": "35",
                                    "PLOTCOAST": "1",
                                    "iridlhasSemantics": "iridl:climatology",
                                    "long_name": "Sea Surface Temperature",
                                    "references": "Reynolds_Smith1995",
                                    "labelinterval": "5.0",
                                    "history": "Climatological sea surface temperature (blended from ship and buoy, data (1950-1979))."
                                }
                            }
                        }
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "pressure"
                    },
                    "sp_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sp_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "C": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "C",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "complex"
                    },
                    "Z_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "long_name": "sigma"
                    },
                    "Z_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "long_name": "sigma"
                    },
                    "sp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "T_15": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_15",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "X_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.8125",
                        "standard_name": "longitude"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "Y_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0"
                    },
                    "T_14": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_14",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "7.0",
                        "standard_name": "time",
                        "add_offset": "2450450",
                        "calendar": "standard"
                    },
                    "T_13": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_13",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "7.0",
                        "add_offset": "2450450"
                    },
                    "T_12": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_12",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "2",
                        "calendar": "standard",
                        "pointwidth": "7.0",
                        "add_offset": "2450450"
                    },
                    "T_11": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_11",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "7.0",
                        "standard_name": "time",
                        "add_offset": "2450450",
                        "calendar": "standard"
                    },
                    "T_10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T_09": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_09",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "7.0",
                        "standard_name": "time",
                        "add_offset": "2450450",
                        "calendar": "standard"
                    },
                    "Z_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T_08": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_08",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "7.0",
                        "standard_name": "time",
                        "add_offset": "2450450",
                        "calendar": "standard"
                    },
                    "X_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.5",
                        "standard_name": "longitude"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.3333309",
                        "standard_name": "latitude"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "positive": "down"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "positive": "down"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.3333309",
                        "standard_name": "latitude"
                    },
                    "T_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "T_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615161600",
                        "standard_name": "time"
                    },
                    "T_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "modulo": "73.0",
                        "pointwidth": "1.0"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "expires": "1615161600",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "pointwidth": "7.0",
                        "standard_name": "time",
                        "add_offset": "2444910.0",
                        "calendar": "standard"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "modulo": "73.0",
                        "modulus": "73.0"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP/EMC/CMB"
                },
                "NARR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NARR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "threehourlyNARRAhistory": "Direct read of GRIB-1 into NetCDF-Java 4.0 API",
                        "threehourlyNARRAcreator_name": "US National Weather Service (NCEP) subcenter = 15",
                        "threehourlyNARRAGenerating_Process_or_Model": "North American Regional Reanalysis (NARR)",
                        "threehourlyNARRAcdm_data_type": "GRID",
                        "threehourlyNARRAfile_format": "GRIB-1",
                        "threehourlyNARRAConventions": "CF-1.0",
                        "threehourlyNARRAsource": "https://nomads.ncdc.noaa.gov/thredds/dodsC/narr/",
                        "threehourlyNARRAOriginating_center": "US National Weather Service (NCEP) subcenter = 15",
                        "threehourlyNARRAProduct_Type": "Forecast/Uninitialized Analysis/Image Product",
                        "threehourlyNARRAlocation": "/nomads3_data/raid2/noaaport/merged/narr/201012/20101228/narr-a_221_20101228_2100_000.grb",
                        "threehourlyNARRAserved_from": "nomads.ncdc.noaa.gov",
                        "threehourlyNARRA_CoordinateModelRunDate": "2010-12-28T21:00:00Z",
                        "narrHP": "http://www.emc.ncep.noaa.gov/mmb/rreanl/",
                        "references": "Mesinger_etal2006",
                        "description": "North America Regional Reanalysis",
                        "NCDC_NARR": "http://nomads.ncdc.noaa.gov/data.php?name=access#narr_datasets",
                        "Conventions": "IRIDL"
                    },
                    "threehourly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "three-hourly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NARRA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NARR-A",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Water_vapor_zonal_flux_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_zonal_flux_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_vapor_zonal_flux_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_zonal_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_zonal_flux_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "242",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WVUFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "242",
                                "pointwidth": "0.125"
                            },
                            "Water_vapor_zonal_flux_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_zonal_flux_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_vapor_zonal_flux_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_zonal_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_zonal_flux_vertical_int",
                                "GRIB_param_number": "242",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WVUFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "242",
                                "pointwidth": "0.125"
                            },
                            "Water_vapor_meridional_flux_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_meridional_flux_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_vapor_meridional_flux_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_meridional_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_meridional_flux_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "243",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WVVFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "243",
                                "pointwidth": "0.125"
                            },
                            "Water_vapor_meridional_flux_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_meridional_flux_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_vapor_meridional_flux_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_meridional_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_meridional_flux_vertical_int",
                                "GRIB_param_number": "243",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WVVFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "243",
                                "pointwidth": "0.125"
                            },
                            "Water_vapor_flux_convergence_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_flux_convergence_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Water_vapor_flux_convergence_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_flux_convergence_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_flux_convergence_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "237",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WVCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "237",
                                "pointwidth": "0.125"
                            },
                            "Water_vapor_flux_convergence_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_vapor_flux_convergence_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Water_vapor_flux_convergence_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_vapor_flux_convergence_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_vapor_flux_convergence_vertical_int",
                                "GRIB_param_number": "237",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WVCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "237",
                                "pointwidth": "0.125"
                            },
                            "water_vapor_added_by_precip_assimilation_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "water_vapor_added_by_precip_assimilation_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "water_vapor_added_by_precip_assimilation @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "water_vapor_added_by_precip_assimilation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "water_vapor_added_by_precip_assimilation_layer_between_two_isobaric",
                                "GRIB_param_number": "232",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WVINC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "232",
                                "pointwidth": "0.125"
                            },
                            "water_vapor_added_by_precip_assimilation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "water_vapor_added_by_precip_assimilation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "water_vapor_added_by_precip_assimilation @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "water_vapor_added_by_precip_assimilation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "water_vapor_added_by_precip_assimilation",
                                "GRIB_param_number": "232",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WVINC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "232",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_zonal_flux_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_zonal_flux_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_condensate_zonal_flux_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_zonal_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_zonal_flux_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "244",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WCUFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "244",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_zonal_flux_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_zonal_flux_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_condensate_zonal_flux_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_zonal_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_zonal_flux_vertical_int",
                                "GRIB_param_number": "244",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WCUFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "244",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_meridional_flux_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_meridional_flux_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_condensate_meridional_flux_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_meridional_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_meridional_flux_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "245",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WCVFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "245",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_meridional_flux_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_meridional_flux_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m",
                                "long_name": "Water_condensate_meridional_flux_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_meridional_flux_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_meridional_flux_vertical_int",
                                "GRIB_param_number": "245",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WCVFLX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "245",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_flux_convergence_vertical_int_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_flux_convergence_vertical_int_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Water_condensate_flux_convergence_vertical_int @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_flux_convergence_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_flux_convergence_vertical_int_layer_between_two_isobaric",
                                "GRIB_param_number": "241",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WCCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "241",
                                "pointwidth": "0.125"
                            },
                            "Water_condensate_flux_convergence_vertical_int": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Water_condensate_flux_convergence_vertical_int",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Water_condensate_flux_convergence_vertical_int @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Water_condensate_flux_convergence_vertical_int",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Water_condensate_flux_convergence_vertical_int",
                                "GRIB_param_number": "241",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WCCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "241",
                                "pointwidth": "0.125"
                            },
                            "water_condensate_added_by_precip_assimilaition_layer_between_two_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "water_condensate_added_by_precip_assimilaition_layer_between_two_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "water_condensate_added_by_precip_assimilaition @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "water_condensate_added_by_precip_assimilaition",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "water_condensate_added_by_precip_assimilaition_layer_between_two_isobaric",
                                "GRIB_param_number": "233",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "WCINC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "233",
                                "pointwidth": "0.125"
                            },
                            "water_condensate_added_by_precip_assimilaition": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "water_condensate_added_by_precip_assimilaition",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "water_condensate_added_by_precip_assimilaition @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "water_condensate_added_by_precip_assimilaition",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "water_condensate_added_by_precip_assimilaition",
                                "GRIB_param_number": "233",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "WCINC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "233",
                                "pointwidth": "0.125"
                            },
                            "Volumetric_soil_moisture_frozen__liquid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Volumetric_soil_moisture_frozen_+_liquid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Volumetric_soil_moisture_frozen_+_liquid @ layer_between_two_depths_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Volumetric_soil_moisture_frozen_+_liquid",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Volumetric_soil_moisture_frozen_+_liquid",
                                "GRIB_param_number": "144",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "112",
                                "GRIB_param_short_name": "SOILW",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "144",
                                "pointwidth": "0.0"
                            },
                            "Visibility": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Visibility",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Visibility @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Visibility",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Visibility",
                                "GRIB_param_number": "20",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "VIS",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "20",
                                "pointwidth": "0.0"
                            },
                            "Vertical_speed_shear": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Vertical_speed_shear",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/kg/s",
                                "long_name": "Vertical_speed_shear @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Vertical_speed_shear",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Vertical_speed_shear",
                                "GRIB_param_number": "136",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "VWSH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "136",
                                "pointwidth": "0.0"
                            },
                            "Vegetation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Vegetation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Vegetation @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Vegetation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Vegetation",
                                "GRIB_param_number": "87",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "VEG",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "87",
                                "pointwidth": "0.0"
                            },
                            "v_wind_tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind_tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind_tropopause",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "v_wind_maximum_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind_maximum_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ maximum_wind",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind_maximum_wind",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "6",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "v_wind_layer_between_two_pressure_difference_from_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind_layer_between_two_pressure_difference_from_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind_layer_between_two_pressure_difference_from_ground",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "v_wind_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind_hybrid",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "v_wind_height_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind_height_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind_height_above_ground",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "v_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v_wind @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v_wind",
                                "GRIB_param_number": "34",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "VGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "34",
                                "pointwidth": "0.0"
                            },
                            "vcomponent_of_storm_motion": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v-component_of_storm_motion",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "v-component_of_storm_motion @ layer_between_two_heights_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "v-component_of_storm_motion",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "v-component_of_storm_motion",
                                "GRIB_param_number": "197",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "106",
                                "GRIB_param_short_name": "VSTM",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "197",
                                "pointwidth": "0.0"
                            },
                            "Upward_short_wave_radiation_flux_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Upward_short_wave_radiation_flux_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Upward_short_wave_radiation_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Upward_short_wave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Upward_short_wave_radiation_flux_surface",
                                "GRIB_param_number": "211",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "USWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "211",
                                "pointwidth": "0.125"
                            },
                            "Upward_short_wave_radiation_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Upward_short_wave_radiation_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Upward_short_wave_radiation_flux @ atmosphere_top",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Upward_short_wave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Upward_short_wave_radiation_flux",
                                "GRIB_param_number": "211",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "8",
                                "GRIB_param_short_name": "USWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "211",
                                "pointwidth": "0.125"
                            },
                            "Upward_long_wave_radiation_flux_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Upward_long_wave_radiation_flux_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Upward_long_wave_radiation_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Upward_long_wave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Upward_long_wave_radiation_flux_surface",
                                "GRIB_param_number": "212",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "ULWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "212",
                                "pointwidth": "0.125"
                            },
                            "Upward_long_wave_radiation_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Upward_long_wave_radiation_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Upward_long_wave_radiation_flux @ atmosphere_top",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Upward_long_wave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Upward_long_wave_radiation_flux",
                                "GRIB_param_number": "212",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "8",
                                "GRIB_param_short_name": "ULWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "212",
                                "pointwidth": "0.125"
                            },
                            "u_wind_tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind_tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind_tropopause",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "u_wind_maximum_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind_maximum_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ maximum_wind",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind_maximum_wind",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "6",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "u_wind_layer_between_two_pressure_difference_from_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind_layer_between_two_pressure_difference_from_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind_layer_between_two_pressure_difference_from_ground",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "u_wind_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind_hybrid",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "u_wind_height_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind_height_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind_height_above_ground",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "u_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u_wind @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u_wind",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u_wind",
                                "GRIB_param_number": "33",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "UGRD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "33",
                                "pointwidth": "0.0"
                            },
                            "ucomponent_of_storm_motion": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u-component_of_storm_motion",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "u-component_of_storm_motion @ layer_between_two_heights_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "u-component_of_storm_motion",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "u-component_of_storm_motion",
                                "GRIB_param_number": "196",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "106",
                                "GRIB_param_short_name": "USTM",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "196",
                                "pointwidth": "0.0"
                            },
                            "Turbulent_Kinetic_Energy_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Turbulent_Kinetic_Energy_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Turbulent_Kinetic_Energy @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Turbulent_Kinetic_Energy",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Turbulent_Kinetic_Energy_hybrid",
                                "GRIB_param_number": "158",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "TKE",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "158",
                                "pointwidth": "0.0"
                            },
                            "Turbulent_Kinetic_Energy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Turbulent_Kinetic_Energy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Turbulent_Kinetic_Energy @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Turbulent_Kinetic_Energy",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Turbulent_Kinetic_Energy",
                                "GRIB_param_number": "158",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "TKE",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "158",
                                "pointwidth": "0.0"
                            },
                            "Total_precipitation_nearest_grid_point": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Total_precipitation_nearest_grid_point",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Total_precipitation_nearest_grid_point @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Total_precipitation_nearest_grid_point",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Total_precipitation_nearest_grid_point",
                                "GRIB_param_number": "202",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "APCPN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "202",
                                "pointwidth": "0.125"
                            },
                            "Total_precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Total_precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Total_precipitation @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Total_precipitation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Total_precipitation",
                                "GRIB_param_number": "61",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "APCP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "61",
                                "pointwidth": "0.125"
                            },
                            "Total_cloud_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Total_cloud_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Total_cloud_cover @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Total_cloud_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Total_cloud_cover",
                                "GRIB_param_number": "71",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "TCDC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "71",
                                "pointwidth": "0.125"
                            },
                            "Temperature_tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_tropopause",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_surface",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature_parameter_in_canopy_conductance": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_parameter_in_canopy_conductance",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Temperature_parameter_in_canopy_conductance @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature_parameter_in_canopy_conductance",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_parameter_in_canopy_conductance",
                                "GRIB_param_number": "247",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "RCT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "247",
                                "pointwidth": "0.0"
                            },
                            "Temperature_layer_between_two_pressure_difference_from_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_layer_between_two_pressure_difference_from_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_layer_between_two_pressure_difference_from_ground",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_hybrid",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature_height_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_height_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_height_above_ground",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature_cloud_tops": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature_cloud_tops",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ cloud_tops",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature_cloud_tops",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "3",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Temperature @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Temperature",
                                "GRIB_param_number": "11",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "TMP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "11",
                                "pointwidth": "0.0"
                            },
                            "Surface_runoff_noninfiltrating": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Surface_runoff_non-infiltrating",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Surface_runoff_non-infiltrating @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Surface_runoff_non-infiltrating",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Surface_runoff_non-infiltrating",
                                "GRIB_param_number": "235",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SSRUN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "235",
                                "pointwidth": "0.125"
                            },
                            "Surface_lifted_index": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Surface_lifted_index",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Surface_lifted_index @ layer_between_two_isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Surface_lifted_index",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Surface_lifted_index",
                                "GRIB_param_number": "131",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "101",
                                "GRIB_param_short_name": "LFTX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "131",
                                "pointwidth": "0.0"
                            },
                            "Surface_friction_velocity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Surface_friction_velocity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "Surface_friction_velocity @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Surface_friction_velocity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Surface_friction_velocity",
                                "GRIB_param_number": "253",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "FRICV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "253",
                                "pointwidth": "0.0"
                            },
                            "Surface_drag_coefficient": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Surface_drag_coefficient",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "non-dim",
                                "long_name": "Surface_drag_coefficient @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Surface_drag_coefficient",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Surface_drag_coefficient",
                                "GRIB_param_number": "252",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "252",
                                "pointwidth": "0.0"
                            },
                            "Subsurface_runoff_baseflow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Subsurface_runoff_baseflow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Subsurface_runoff_baseflow @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Subsurface_runoff_baseflow",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Subsurface_runoff_baseflow",
                                "GRIB_param_number": "234",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "BGRUN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "234",
                                "pointwidth": "0.125"
                            },
                            "Storm_relative_helicity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Storm_relative_helicity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Storm_relative_helicity @ layer_between_two_heights_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Storm_relative_helicity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Storm_relative_helicity",
                                "GRIB_param_number": "190",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "106",
                                "GRIB_param_short_name": "HLCY",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "190",
                                "pointwidth": "0.0"
                            },
                            "Specific_humidity_layer_between_two_pressure_difference_from_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Specific_humidity_layer_between_two_pressure_difference_from_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Specific_humidity @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Specific_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Specific_humidity_layer_between_two_pressure_difference_from_ground",
                                "GRIB_param_number": "51",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "SPFH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "51",
                                "pointwidth": "0.0"
                            },
                            "Specific_humidity_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Specific_humidity_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Specific_humidity @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Specific_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Specific_humidity_hybrid",
                                "GRIB_param_number": "51",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "SPFH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "51",
                                "pointwidth": "0.0"
                            },
                            "Specific_humidity_height_above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Specific_humidity_height_above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Specific_humidity @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Specific_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Specific_humidity_height_above_ground",
                                "GRIB_param_number": "51",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "SPFH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "51",
                                "pointwidth": "0.0"
                            },
                            "Specific_humidity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Specific_humidity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Specific_humidity @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Specific_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Specific_humidity",
                                "GRIB_param_number": "51",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "SPFH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "51",
                                "pointwidth": "0.0"
                            },
                            "Solar_parameter_in_canopy_conductance": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Solar_parameter_in_canopy_conductance",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Solar_parameter_in_canopy_conductance @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Solar_parameter_in_canopy_conductance",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Solar_parameter_in_canopy_conductance",
                                "GRIB_param_number": "246",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "RCS",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "246",
                                "pointwidth": "0.0"
                            },
                            "Soil_temperature_depth_below_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Soil_temperature_depth_below_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Soil_temperature @ depth_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Soil_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Soil_temperature_depth_below_surface",
                                "GRIB_param_number": "85",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "111",
                                "GRIB_param_short_name": "TSOIL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "85",
                                "pointwidth": "0.0"
                            },
                            "Soil_temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Soil_temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Soil_temperature @ layer_between_two_depths_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Soil_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Soil_temperature",
                                "GRIB_param_number": "85",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "112",
                                "GRIB_param_short_name": "TSOIL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "85",
                                "pointwidth": "0.0"
                            },
                            "Soil_moisture_parameter_in_canopy_conductance": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Soil_moisture_parameter_in_canopy_conductance",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Soil_moisture_parameter_in_canopy_conductance @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Soil_moisture_parameter_in_canopy_conductance",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Soil_moisture_parameter_in_canopy_conductance",
                                "GRIB_param_number": "249",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "RCSOL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "249",
                                "pointwidth": "0.0"
                            },
                            "Soil_moisture_content": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Soil_moisture_content",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Soil_moisture_content @ layer_between_two_depths_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Soil_moisture_content",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Soil_moisture_content",
                                "GRIB_param_number": "86",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "112",
                                "GRIB_param_short_name": "SOILM",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "86",
                                "pointwidth": "0.0"
                            },
                            "Snow_phasechange_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Snow_phase-change_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Snow_phase-change_heat_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Snow_phase-change_heat_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Snow_phase-change_heat_flux",
                                "GRIB_param_number": "229",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SNOHF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "229",
                                "pointwidth": "0.125"
                            },
                            "Snow_melt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Snow_melt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Snow_melt @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Snow_melt",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Snow_melt",
                                "GRIB_param_number": "99",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SNOM",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "99",
                                "pointwidth": "0.125"
                            },
                            "Snow_depth": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Snow_depth",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Snow_depth @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Snow_depth",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Snow_depth",
                                "GRIB_param_number": "66",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SNOD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "66",
                                "pointwidth": "0.0"
                            },
                            "Snow_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Snow_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Snow_cover @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Snow_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Snow_cover",
                                "GRIB_param_number": "238",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SNOWC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "238",
                                "pointwidth": "0.0"
                            },
                            "Sensible_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Sensible_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Sensible_heat_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Sensible_heat_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Sensible_heat_flux",
                                "GRIB_param_number": "122",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SHTFL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "122",
                                "pointwidth": "0.125"
                            },
                            "Relative_humidity_zeroDegC_isotherm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Relative_humidity_zeroDegC_isotherm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Relative_humidity @ zeroDegC_isotherm",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Relative_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Relative_humidity_zeroDegC_isotherm",
                                "GRIB_param_number": "52",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "4",
                                "GRIB_param_short_name": "RH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "52",
                                "pointwidth": "0.0"
                            },
                            "Relative_humidity_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Relative_humidity_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Relative_humidity @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Relative_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Relative_humidity_hybrid",
                                "GRIB_param_number": "52",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "RH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "52",
                                "pointwidth": "0.0"
                            },
                            "Relative_humidity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Relative_humidity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Relative_humidity @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Relative_humidity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Relative_humidity",
                                "GRIB_param_number": "52",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "RH",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "52",
                                "pointwidth": "0.0"
                            },
                            "Pressure_vertical_velocity_layer_between_two_pressure_difference_from_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_vertical_velocity_layer_between_two_pressure_difference_from_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa/s",
                                "long_name": "Pressure_vertical_velocity @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure_vertical_velocity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_vertical_velocity_layer_between_two_pressure_difference_from_ground",
                                "GRIB_param_number": "39",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "VVEL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "39",
                                "pointwidth": "0.0"
                            },
                            "Pressure_vertical_velocity_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_vertical_velocity_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa/s",
                                "long_name": "Pressure_vertical_velocity @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure_vertical_velocity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_vertical_velocity_hybrid",
                                "GRIB_param_number": "39",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "VVEL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "39",
                                "pointwidth": "0.0"
                            },
                            "Pressure_vertical_velocity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_vertical_velocity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa/s",
                                "long_name": "Pressure_vertical_velocity @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure_vertical_velocity",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_vertical_velocity",
                                "GRIB_param_number": "39",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "VVEL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "39",
                                "pointwidth": "0.0"
                            },
                            "Pressure_tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_tropopause",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_surface",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_reduced_to_MSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_reduced_to_MSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure_reduced_to_MSL @ msl",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure_reduced_to_MSL",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_reduced_to_MSL",
                                "GRIB_param_number": "2",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "102",
                                "GRIB_param_short_name": "PRMSL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "2",
                                "pointwidth": "0.0"
                            },
                            "Pressure_nearest_grid_point": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_nearest_grid_point",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure_nearest_grid_point @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure_nearest_grid_point",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_nearest_grid_point",
                                "GRIB_param_number": "134",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "PRESN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "134",
                                "pointwidth": "0.0"
                            },
                            "Pressure_maximum_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_maximum_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ maximum_wind",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_maximum_wind",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "6",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_hybrid",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_cloud_tops": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_cloud_tops",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ cloud_tops",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_cloud_tops",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "3",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_cloud_base": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_cloud_base",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ cloud_base",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_cloud_base",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "2",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure_adiabatic_condensation_lifted": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure_adiabatic_condensation_lifted",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ adiabatic_condensation_lifted",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure_adiabatic_condensation_lifted",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "5",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Pressure @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Pressure",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Pressure",
                                "GRIB_param_number": "1",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "PRES",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "1",
                                "pointwidth": "0.0"
                            },
                            "Precipitation_rate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Precipitation_rate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "(kg/m^3)(m/s)",
                                "long_name": "Precipitation_rate @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Precipitation_rate",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Precipitation_rate",
                                "GRIB_param_number": "59",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "PRATE",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "59",
                                "pointwidth": "0.125"
                            },
                            "Precipitable_water": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Precipitable_water",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Precipitable_water @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Precipitable_water",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Precipitable_water",
                                "GRIB_param_number": "54",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "PWAT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "54",
                                "pointwidth": "0.0"
                            },
                            "Potential_temperature_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Potential_temperature_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Potential_temperature @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Potential_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Potential_temperature_surface",
                                "GRIB_param_number": "13",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "POT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "13",
                                "pointwidth": "0.0"
                            },
                            "Potential_temperature_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Potential_temperature_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Potential_temperature @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Potential_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Potential_temperature_hybrid",
                                "GRIB_param_number": "13",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "POT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "13",
                                "pointwidth": "0.0"
                            },
                            "Potential_temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Potential_temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Potential_temperature @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Potential_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Potential_temperature",
                                "GRIB_param_number": "13",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "POT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "13",
                                "pointwidth": "0.0"
                            },
                            "Potential_evaporation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Potential_evaporation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Potential_evaporation @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Potential_evaporation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Potential_evaporation",
                                "GRIB_param_number": "228",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "PEVAP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "228",
                                "pointwidth": "0.125"
                            },
                            "Plant_canopy_surface_water": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Plant_canopy_surface_water",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Plant_canopy_surface_water @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Plant_canopy_surface_water",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Plant_canopy_surface_water",
                                "GRIB_param_number": "223",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CNWAT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "223",
                                "pointwidth": "0.0"
                            },
                            "Planetary_boundary_layer_height": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Planetary_boundary_layer_height",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Planetary_boundary_layer_height @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Planetary_boundary_layer_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Planetary_boundary_layer_height",
                                "GRIB_param_number": "221",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "HPBL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "221",
                                "pointwidth": "0.0"
                            },
                            "Nonconvective_cloud": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Non-convective_cloud",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Non-convective_cloud @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Non-convective_cloud",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Non-convective_cloud",
                                "GRIB_param_number": "213",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "CDLYR",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "213",
                                "pointwidth": "0.125"
                            },
                            "Moisture_availability": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Moisture_availability",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Moisture_availability @ layer_between_two_depths_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Moisture_availability",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Moisture_availability",
                                "GRIB_param_number": "207",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "112",
                                "GRIB_param_short_name": "MSTAV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "207",
                                "pointwidth": "0.0"
                            },
                            "Mid_level_cloud_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Mid_level_cloud_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Mid_level_cloud_cover @ middle_cloud_layer",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Mid_level_cloud_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Mid_level_cloud_cover",
                                "GRIB_param_number": "74",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "224",
                                "GRIB_param_short_name": "MCDC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "74",
                                "pointwidth": "0.125"
                            },
                            "Mean_sea_level_pressure_ETA_model": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Mean_sea_level_pressure_ETA_model",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Pa",
                                "long_name": "Mean_sea_level_pressure_ETA_model @ msl",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Mean_sea_level_pressure_ETA_model",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Mean_sea_level_pressure_ETA_model",
                                "GRIB_param_number": "130",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "102",
                                "GRIB_param_short_name": "MSLET",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "130",
                                "pointwidth": "0.0"
                            },
                            "Low_level_cloud_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Low_level_cloud_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Low_level_cloud_cover @ low_cloud_layer",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Low_level_cloud_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Low_level_cloud_cover",
                                "GRIB_param_number": "73",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "214",
                                "GRIB_param_short_name": "LCDC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "73",
                                "pointwidth": "0.125"
                            },
                            "Liquid_volumetric_soil_moisture_nonfrozen": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Liquid_volumetric_soil_moisture_non-frozen",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Liquid_volumetric_soil_moisture_non-frozen @ layer_between_two_depths_below_surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Liquid_volumetric_soil_moisture_non-frozen",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Liquid_volumetric_soil_moisture_non-frozen",
                                "GRIB_param_number": "160",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "112",
                                "GRIB_param_short_name": "SOILL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "160",
                                "pointwidth": "0.0"
                            },
                            "layer_between_two_pressure_difference_from_ground_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_pressure_difference_from_ground_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_pressure_difference_from_ground_bounds",
                                "long_name": "bounds for layer_between_two_pressure_difference_from_ground",
                                "units": "hPa"
                            },
                            "layer_between_two_pressure_difference_from_ground1_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_pressure_difference_from_ground1_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_pressure_difference_from_ground1_bounds",
                                "long_name": "bounds for layer_between_two_pressure_difference_from_ground1",
                                "units": "hPa"
                            },
                            "layer_between_two_isobaric_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_isobaric_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_isobaric_bounds",
                                "long_name": "bounds for layer_between_two_isobaric",
                                "units": "hPa"
                            },
                            "layer_between_two_isobaric1_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_isobaric1_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_isobaric1_bounds",
                                "long_name": "bounds for layer_between_two_isobaric1",
                                "units": "hPa"
                            },
                            "layer_between_two_heights_above_ground_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_heights_above_ground_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_heights_above_ground_bounds",
                                "long_name": "bounds for layer_between_two_heights_above_ground",
                                "units": "m"
                            },
                            "layer_between_two_heights_above_ground1_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_heights_above_ground1_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_heights_above_ground1_bounds",
                                "long_name": "bounds for layer_between_two_heights_above_ground1",
                                "units": "m"
                            },
                            "layer_between_two_depths_below_surface_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_depths_below_surface_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_depths_below_surface_bounds",
                                "long_name": "bounds for layer_between_two_depths_below_surface",
                                "units": "cm"
                            },
                            "layer_between_two_depths_below_surface2_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_depths_below_surface2_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_depths_below_surface2_bounds",
                                "long_name": "bounds for layer_between_two_depths_below_surface2",
                                "units": "cm"
                            },
                            "layer_between_two_depths_below_surface1_bounds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer_between_two_depths_below_surface1_bounds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dodsname": "layer_between_two_depths_below_surface1_bounds",
                                "long_name": "bounds for layer_between_two_depths_below_surface1",
                                "units": "cm"
                            },
                            "Latent_heat_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Latent_heat_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Latent_heat_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Latent_heat_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Latent_heat_flux",
                                "GRIB_param_number": "121",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "LHTFL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "121",
                                "pointwidth": "0.125"
                            },
                            "Lambert_Conformal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Lambert_Conformal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_param_LoV": "-107.0",
                                "GRIB_param_VectorComponentFlag": "gridRelative",
                                "GRIB_param_Lo1": "-145.5",
                                "latitude_of_projection_origin": "50.0",
                                "GRIB_param_Latin2": "50.0",
                                "dodsname": "Lambert_Conformal",
                                "GRIB_param_Dy": "32463.0",
                                "earth_shape": "spherical",
                                "GRIB_param_grid_shape": "spherical",
                                "GRIB_param_grid_units": "m",
                                "GRIB_param_Winds": "Relative",
                                "GRIB_param_Nx": "349",
                                "earth_radius": "6367.4702",
                                "longitude_of_central_meridian": "-107.0",
                                "standard_parallel": "50.0",
                                "GRIB_param_Ny": "277",
                                "units": "unitless",
                                "GRIB_param_GDSkey": "55295",
                                "GRIB_param_grid_shape_code": "0",
                                "GRIB_param_scanning_mode": "64",
                                "grid_mapping_name": "lambert_conformal_conic",
                                "GRIB_param_Latin1": "50.0",
                                "GRIB_param_NpProj": "true",
                                "GRIB_param_La1": "1.0",
                                "GRIB_param_grid_name": "Lambert_Conformal",
                                "GRIB_param_ProjFlag": "0",
                                "GRIB_param_grid_radius_spherical_earth": "6367.4702",
                                "GRIB_param_SpLon": "0.0",
                                "GRIB_param_Dx": "32463.0",
                                "GRIB_param_grid_type": "3",
                                "GRIB_param_ResCompFlag": "8",
                                "GRIB_param_SpLat": "0.0"
                            },
                            "Ice_mixing_ratio": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Ice_mixing_ratio",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Ice_mixing_ratio @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Ice_mixing_ratio",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Ice_mixing_ratio",
                                "GRIB_param_number": "178",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "ICMR",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "178",
                                "pointwidth": "0.0"
                            },
                            "Humidity_parameter_in_canopy_conductance": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Humidity_parameter_in_canopy_conductance",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Humidity_parameter_in_canopy_conductance @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Humidity_parameter_in_canopy_conductance",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Humidity_parameter_in_canopy_conductance",
                                "GRIB_param_number": "248",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "RCQ",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "248",
                                "pointwidth": "0.0"
                            },
                            "Horizontal_moisture_divergence_isobaric": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Horizontal_moisture_divergence_isobaric",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/kg/s",
                                "long_name": "Horizontal_moisture_divergence @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Horizontal_moisture_divergence",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Horizontal_moisture_divergence_isobaric",
                                "GRIB_param_number": "135",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "MCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "135",
                                "pointwidth": "0.0"
                            },
                            "Horizontal_moisture_divergence_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Horizontal_moisture_divergence_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/kg/s",
                                "long_name": "Horizontal_moisture_divergence @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Horizontal_moisture_divergence",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Horizontal_moisture_divergence_hybrid",
                                "GRIB_param_number": "135",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "MCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "135",
                                "pointwidth": "0.0"
                            },
                            "Horizontal_moisture_divergence": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Horizontal_moisture_divergence",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/kg/s",
                                "long_name": "Horizontal_moisture_divergence @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Horizontal_moisture_divergence",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Horizontal_moisture_divergence",
                                "GRIB_param_number": "135",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "MCONV",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "135",
                                "pointwidth": "0.0"
                            },
                            "High_level_cloud_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "High_level_cloud_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "High_level_cloud_cover @ high_cloud_layer",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "High_level_cloud_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "High_level_cloud_cover",
                                "GRIB_param_number": "75",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "234",
                                "GRIB_param_short_name": "HCDC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "75",
                                "pointwidth": "0.125"
                            },
                            "Ground_Heat_Flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Ground_Heat_Flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Ground_Heat_Flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Ground_Heat_Flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Ground_Heat_Flux",
                                "GRIB_param_number": "155",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "GFLUX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "155",
                                "pointwidth": "0.125"
                            },
                            "Geopotential_height_zeroDegC_isotherm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_zeroDegC_isotherm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ zeroDegC_isotherm",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_zeroDegC_isotherm",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "4",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height_tropopause": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_tropopause",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ tropopause",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_tropopause",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "7",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height_maximum_wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_maximum_wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ maximum_wind",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_maximum_wind",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "6",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height_hybrid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_hybrid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_hybrid",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height_cloud_tops": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_cloud_tops",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ cloud_tops",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_cloud_tops",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "3",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height_cloud_base": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height_cloud_base",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ cloud_base",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height_cloud_base",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "2",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Geopotential_height": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geopotential_height",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Geopotential_height @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Geopotential_height",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Geopotential_height",
                                "GRIB_param_number": "7",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "HGT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "7",
                                "pointwidth": "0.0"
                            },
                            "Exchange_coefficient": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Exchange_coefficient",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "(kg/m^3)(m/s)",
                                "long_name": "Exchange_coefficient @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Exchange_coefficient",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Exchange_coefficient",
                                "GRIB_param_number": "208",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "SFEXC",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "208",
                                "pointwidth": "0.0"
                            },
                            "Evaporation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Evaporation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Evaporation @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Evaporation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Evaporation",
                                "GRIB_param_number": "57",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "EVP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "57",
                                "pointwidth": "0.125"
                            },
                            "Downward_shortwave_radiation_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Downward_shortwave_radiation_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Downward_shortwave_radiation_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Downward_shortwave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Downward_shortwave_radiation_flux",
                                "GRIB_param_number": "204",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "DSWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "204",
                                "pointwidth": "0.125"
                            },
                            "Downward_longwave_radiation_flux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Downward_longwave_radiation_flux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "W/m2",
                                "long_name": "Downward_longwave_radiation_flux @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Downward_longwave_radiation_flux",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Downward_longwave_radiation_flux",
                                "GRIB_param_number": "205",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "DLWRF",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "205",
                                "pointwidth": "0.125"
                            },
                            "Dew_point_temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Dew_point_temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Dew_point_temperature @ height_above_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Dew_point_temperature",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Dew_point_temperature",
                                "GRIB_param_number": "17",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "105",
                                "GRIB_param_short_name": "DPT",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "17",
                                "pointwidth": "0.0"
                            },
                            "Convective_precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Convective_precipitation @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_precipitation",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_precipitation",
                                "GRIB_param_number": "63",
                                "GRIB_product_definition_type": "Accumulation",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "ACPCP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "63",
                                "pointwidth": "0.125"
                            },
                            "Convective_inhibition_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_inhibition_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Convective_inhibition @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_inhibition",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_inhibition_surface",
                                "GRIB_param_number": "156",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CIN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "156",
                                "pointwidth": "0.0"
                            },
                            "Convective_inhibition": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_inhibition",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Convective_inhibition @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_inhibition",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_inhibition",
                                "GRIB_param_number": "156",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "CIN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "156",
                                "pointwidth": "0.0"
                            },
                            "Convective_cloud_cover": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_cloud_cover",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Convective_cloud_cover @ entire_atmosphere",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_cloud_cover",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_cloud_cover",
                                "GRIB_param_number": "72",
                                "GRIB_product_definition_type": "Average",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "200",
                                "GRIB_param_short_name": "CDCON",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "72",
                                "pointwidth": "0.125"
                            },
                            "Convective_available_potential_energy_surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_available_potential_energy_surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Convective_available_potential_energy @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_available_potential_energy",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_available_potential_energy_surface",
                                "GRIB_param_number": "157",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CAPE",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "157",
                                "pointwidth": "0.0"
                            },
                            "Convective_available_potential_energy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Convective_available_potential_energy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "J/kg",
                                "long_name": "Convective_available_potential_energy @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Convective_available_potential_energy",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Convective_available_potential_energy",
                                "GRIB_param_number": "157",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "CAPE",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "157",
                                "pointwidth": "0.0"
                            },
                            "Cloud_water": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Cloud_water",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "unitless",
                                "long_name": "Cloud_water @ isobaric",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Cloud_water",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Cloud_water",
                                "GRIB_param_number": "153",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "100",
                                "GRIB_param_short_name": "CLWMR",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "153",
                                "pointwidth": "0.0"
                            },
                            "Categorical_snow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Categorical_snow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "yes=1;no=0",
                                "long_name": "Categorical_snow @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Categorical_snow",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Categorical_snow",
                                "GRIB_param_number": "143",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CSNOW",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "143",
                                "pointwidth": "0.125"
                            },
                            "Categorical_rain": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Categorical_rain",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "yes=1;no=0",
                                "long_name": "Categorical_rain @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Categorical_rain",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Categorical_rain",
                                "GRIB_param_number": "140",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CRAIN",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "140",
                                "pointwidth": "0.125"
                            },
                            "Categorical_ice_pellets": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Categorical_ice_pellets",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "yes=1;no=0",
                                "long_name": "Categorical_ice_pellets @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Categorical_ice_pellets",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Categorical_ice_pellets",
                                "GRIB_param_number": "142",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CICEP",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "142",
                                "pointwidth": "0.125"
                            },
                            "Categorical_freezing_rain": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Categorical_freezing_rain",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "yes=1;no=0",
                                "long_name": "Categorical_freezing_rain @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Categorical_freezing_rain",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Categorical_freezing_rain",
                                "GRIB_param_number": "141",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CFRZR",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "141",
                                "pointwidth": "0.125"
                            },
                            "Canopy_conductance": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Canopy_conductance",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m/s",
                                "long_name": "Canopy_conductance @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Canopy_conductance",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Canopy_conductance",
                                "GRIB_param_number": "181",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "CCOND",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "181",
                                "pointwidth": "0.0"
                            },
                            "Blackadars_mixing_length_scale": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Blackadars_mixing_length_scale",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "m",
                                "long_name": "Blackadars_mixing_length_scale @ hybrid",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Blackadars_mixing_length_scale",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Blackadars_mixing_length_scale",
                                "GRIB_param_number": "226",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "109",
                                "GRIB_param_short_name": "BMIXL",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "226",
                                "pointwidth": "0.0"
                            },
                            "Best_4layer_lifted_index": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Best_4-layer_lifted_index",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "Kelvin_scale",
                                "long_name": "Best_4-layer_lifted_index @ layer_between_two_pressure_difference_from_ground",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Best_4-layer_lifted_index",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Best_4-layer_lifted_index",
                                "GRIB_param_number": "132",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "116",
                                "GRIB_param_short_name": "4LFTX",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "132",
                                "pointwidth": "0.0"
                            },
                            "Albedo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Albedo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "percent",
                                "long_name": "Albedo @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Albedo",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Albedo",
                                "GRIB_param_number": "84",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "ALBDO",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "84",
                                "pointwidth": "0.0"
                            },
                            "Accumulated_snow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Accumulated_snow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GRIB_table_id": "131",
                                "GRIB_VectorComponentFlag": "gridRelative",
                                "units": "kg/m^2",
                                "long_name": "Accumulated_snow @ surface",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "GRIB_param_name": "Accumulated_snow",
                                "grid_mapping": "Lambert_Conformal",
                                "dodsname": "Accumulated_snow",
                                "GRIB_param_number": "65",
                                "GRIB_product_definition_type": "Forecast/Uninitialized Analysis/Image Product",
                                "missing_value": "-9999.0",
                                "GRIB_center_id": "7",
                                "GRIB_level_type": "1",
                                "GRIB_param_short_name": "WEASD",
                                "SpatialReferenceSystemDims": "y",
                                "GRIB_param_id": "65",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "isobaric1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "isobaric1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0"
                    },
                    "depth_below_surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "depth_below_surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "height_above_ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "height_above_ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0"
                    },
                    "height_above_ground1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "height_above_ground1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "20.0"
                    },
                    "layer_between_two_isobaric": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_isobaric",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_isobaric1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_isobaric1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_heights_above_ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_heights_above_ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_heights_above_ground1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_heights_above_ground1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_depths_below_surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_depths_below_surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm",
                        "gridtype": "0"
                    },
                    "layer_between_two_depths_below_surface2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_depths_below_surface2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "bounds_dim": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "bounds_dim",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "layer_between_two_depths_below_surface1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_depths_below_surface1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "isobaric2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "isobaric2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_pressure_difference_from_ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_pressure_difference_from_ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "30.0"
                    },
                    "height_above_ground2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "height_above_ground2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "isobaric": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "isobaric",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0"
                    },
                    "time_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1979-01-01",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0.125",
                        "standard_name": "time"
                    },
                    "hybrid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hybrid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "layer_between_two_pressure_difference_from_ground1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "layer_between_two_pressure_difference_from_ground1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "x": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "km",
                        "gridtype": "0",
                        "pointwidth": "32.463001"
                    },
                    "y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "km",
                        "gridtype": "0",
                        "pointwidth": "32.462997"
                    },
                    "time": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1979-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "pointwidth": "0.0",
                        "calendar": "standard"
                    },
                    "dir": "SOURCES/NOAA/NCEP/EMC/NARR"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CFS",
                    "CFSv2",
                    "CMB",
                    "NARR"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CPC",
                "EMC"
            ]
        },
        "NCEPDOE": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NCEP-DOE",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Reanalysis2Monthlypgbpgb_anl_climolong_name": "1979-1998 Monthly Climatology",
                "Reanalysis2Monthlypgbpgb_anl_climoreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlypgbpgb_anl_climodescription": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlypgbpgb_anl_climoftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlypgbpgb_anl_climoNCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlypgbpgbreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlypgbpgbdescription": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlypgbpgbftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2MonthlypgbpgbNCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlypgbc8009long_name": "1980-2009 Monthly Climatology",
                "Reanalysis2Monthlypgbc8009references": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlypgbc8009description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlypgbc8009ftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlypgbc8009NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlypgbc7908long_name": "1979-2008 Monthly Climatology",
                "Reanalysis2Monthlypgbc7908references": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlypgbc7908description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlypgbc7908ftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlypgbc7908NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2MonthlyflxgpcprainNCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlyflxgpcprainreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlyflxgpcpraindescription": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlyflxgpcprainftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlyflxflx_climo_7998NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlyflxflx_climo_7998references": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlyflxflx_climo_7998ftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlyflxflx_climo_7998description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2MonthlyflxflxNCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlyflxflxreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlyflxflxftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlyflxflxdescription": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2MonthlyflxcmporainNCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlyflxcmporainreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlyflxcmporaindescription": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlyflxcmporainftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlyflxc8009long_name": "1980-2009 Monthly Climatology",
                "Reanalysis2Monthlyflxc8009NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlyflxc8009references": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlyflxc8009ftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlyflxc8009description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Monthlydg3dg3long_name": "sigma-level fields",
                "Reanalysis2Monthlydg3dg3NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2Monthlydg3dg3references": "Kanamitsu_etal2002b",
                "Reanalysis2Monthlydg3dg3ftp": "ftp://nomad3.ncep.noaa.gov/pub/reanalysis-2/",
                "Reanalysis2Monthlydg3dg3description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2Dailysurfacesource": "http://www.esrl.noaa.gov/psd/thredds/catalog/Datasets/ncep.reanalysis2.dailyavgs/catalog.html",
                "Reanalysis2Dailysurfacereferences": "Kanamitsu_etal2002b",
                "Reanalysis2DailysurfaceESRL_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html",
                "Reanalysis2Dailysurfacetitle": "Daily NCEP/DOE Reanalysis 2",
                "Reanalysis2DailysurfaceConventions": "CF-1.0",
                "Reanalysis2Dailysurfacecomments": "Data is from NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) (4x/day).  Data interpolated from model (sigma) surfaces to a rectangular grid.",
                "Reanalysis2DailysurfaceCPC_documentation": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/",
                "Reanalysis2Dailysurfacereference": " http://wesley.ncep.noaa.gov/reanalysis2/ ; http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html ",
                "Reanalysis2Dailysurfaceplatform": "Model",
                "Reanalysis2Dailysurfacehistory": "created 2002/03 by Hoop (netCDF2.3)",
                "Reanalysis2Dailysurfacecitation": "Please note: If you acquire NCEP_Reanalysis 2 data products from PSD, we ask that you acknowledge us in your use of the data. This may be done by including text such as NCEP_Reanalysis 2 data provided by the NOAA/OAR/ESRL PSD, Boulder, Colorado, USA, from their Web site at http://www.esrl.noaa.gov/psd/ in any documents or publications using these data. We would also appreciate receiving a copy of the relevant publications. This will help PSD to justify keeping the NCEP_Reanalysis 2 data set freely available online in the future. Thank you!",
                "Reanalysis2Dailysurfaceinstitution": "National Centers for Environmental Prediction",
                "Reanalysis2Dailypressuresource": "http://www.esrl.noaa.gov/psd/thredds/catalog/Datasets/ncep.reanalysis2.dailyavgs/catalog.html",
                "Reanalysis2Dailypressurereferences": "Kanamitsu_etal2002b",
                "Reanalysis2DailypressureESRL_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html",
                "Reanalysis2Dailypressuretitle": "Daily NCEP/DOE Reanalysis 2",
                "Reanalysis2DailypressureConventions": "CF-1.0",
                "Reanalysis2Dailypressurecomments": "Data is from NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) (4x/day).  It consists of most variables interpolated to pressure surfaces from model (sigma) surfaces.",
                "Reanalysis2DailypressureCPC_documentation": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/",
                "Reanalysis2Dailypressurereference": " http://wesley.ncep.noaa.gov/reanalysis2/ ; http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html ",
                "Reanalysis2Dailypressureplatform": "Model",
                "Reanalysis2Dailypressurehistory": "created 2002/03/01 by RHS (netCDF2.3)",
                "Reanalysis2Dailypressurecitation": "Please note: If you acquire NCEP_Reanalysis 2 data products from PSD, we ask that you acknowledge us in your use of the data. This may be done by including text such as NCEP_Reanalysis 2 data provided by the NOAA/OAR/ESRL PSD, Boulder, Colorado, USA, from their Web site at http://www.esrl.noaa.gov/psd/ in any documents or publications using these data. We would also appreciate receiving a copy of the relevant publications. This will help PSD to justify keeping the NCEP_Reanalysis 2 data set freely available online in the future. Thank you!",
                "Reanalysis2Dailypressureinstitution": "National Centers for Environmental Prediction",
                "Reanalysis2Dailygaussian_gridsource": "http://www.esrl.noaa.gov/psd/thredds/catalog/Datasets/ncep.reanalysis2.dailyavgs/catalog.html",
                "Reanalysis2Dailygaussian_gridreferences": "Kanamitsu_etal2002b",
                "Reanalysis2Dailygaussian_gridESRL_documentation": "http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html",
                "Reanalysis2Dailygaussian_gridtitle": "Daily NCEP/DOE Reanalysis 2",
                "Reanalysis2Dailygaussian_gridConventions": "CF-1.0",
                "Reanalysis2Dailygaussian_gridcomments": "Data is from NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) (4x/day).  Data interpolated from model (sigma) surfaces to gaussian grid.",
                "Reanalysis2Dailygaussian_gridCPC_documentation": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/",
                "Reanalysis2Dailygaussian_gridreference": " http://wesley.ncep.noaa.gov/reanalysis2/ ; http://www.esrl.noaa.gov/psd/data/gridded/data.ncep.reanalysis2.html ",
                "Reanalysis2Dailygaussian_gridplatform": "Model",
                "Reanalysis2Dailygaussian_gridhistory": "created 2002/03 by Hoop (netCDF2.3)",
                "Reanalysis2Dailygaussian_gridcitation": "Please note: If you acquire NCEP_Reanalysis 2 data products from PSD, we ask that you acknowledge us in your use of the data. This may be done by including text such as NCEP_Reanalysis 2 data provided by the NOAA/OAR/ESRL PSD, Boulder, Colorado, USA, from their Web site at http://www.esrl.noaa.gov/psd/ in any documents or publications using these data. We would also appreciate receiving a copy of the relevant publications. This will help PSD to justify keeping the NCEP_Reanalysis 2 data set freely available online in the future. Thank you!",
                "Reanalysis2Dailygaussian_gridinstitution": "National Centers for Environmental Prediction",
                "Reanalysis2GrADSDODS": "http://nomad3.ncep.noaa.gov:9090/dods/reanalyses/reanalysis-2",
                "Reanalysis2NCEPDOE": "http://www.cpc.ncep.noaa.gov/products/wesley/reanalysis2/index.html",
                "Reanalysis2references": "Kanamitsu_etal2002b",
                "Reanalysis2description": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2)",
                "Reanalysis2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP-DOE/.Reanalysis-2.dataset_documentation.html",
                "iridlhasSemantics": "iridl:DOE",
                "Conventions": "IRIDL"
            },
            "Reanalysis2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Reanalysis-2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pgb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pgb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pgb_anl_climo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pgb_anl_climo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity on pressure levels",
                                "units": "Pa s-1",
                                "gribvariable": "39",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "vgrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "ugrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature on pressure levels",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "rh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity on pressure levels",
                                "units": "percent",
                                "gribvariable": "52",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "pwatclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwatclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water in atmospheric column",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at surface",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "presmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean Sea Level Pressure",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "102"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at surface",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgtsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgtsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height at surface",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height on pressure levels",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "absv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "absv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Absolute vorticity on pressure levels",
                                "units": "s-1",
                                "gribvariable": "41",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            }
                        },
                        "pgb": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pgb",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvelprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvelprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity",
                                "units": "Pa s-1",
                                "gribvariable": "39",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "vgrdprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrdprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "ugrdprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrdprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "tmpprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "rhprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "gribvariable": "52",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "pwatclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwatclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "presmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "102",
                                "pointwidth": "1.0"
                            },
                            "pratesfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pratesfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "hgtsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgtsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "hgtprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgtprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            },
                            "absvprs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "absvprs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Absolute vorticity",
                                "units": "s-1",
                                "gribvariable": "41",
                                "gribfield": "1",
                                "gribleveltype": "100",
                                "pointwidth": "1.0"
                            }
                        },
                        "c8009": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8009",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity on pressure levels",
                                "units": "Pa s-1",
                                "gribvariable": "39",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "vgrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "ugrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature on pressure levels",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "rh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity on pressure levels",
                                "units": "percent",
                                "gribvariable": "52",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "pwatclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwatclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water in atmospheric column",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at surface",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "presmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean Sea Level Pressure",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "102"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at surface",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgtsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgtsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height at surface",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height on pressure levels",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "absv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "absv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Absolute vorticity on pressure levels",
                                "units": "s-1",
                                "gribvariable": "41",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            }
                        },
                        "c7908": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7908",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity on pressure levels",
                                "units": "Pa s-1",
                                "gribvariable": "39",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "vgrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "ugrd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind on pressure levels",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature on pressure levels",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "rh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity on pressure levels",
                                "units": "percent",
                                "gribvariable": "52",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "pwatclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwatclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water in atmospheric column",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at surface",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "presmsl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmsl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean Sea Level Pressure",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "102"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at surface",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgtsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgtsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height at surface",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "hgt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hgt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height on pressure levels",
                                "units": "gpm",
                                "gribvariable": "7",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            },
                            "absv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "absv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Absolute vorticity on pressure levels",
                                "units": "s-1",
                                "gribvariable": "41",
                                "gribfield": "1",
                                "gribleveltype": "100"
                            }
                        }
                    },
                    "flx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "flx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gpcprain": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gpcprain",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            }
                        },
                        "flx_climo_7998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flx_climo_7998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weasd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weasd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Water Equiv. of Accum. Snow Depth at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "65",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "vgwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "148",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "vgrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "vflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "125",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "uswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "uswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Shortwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ulwrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "ulwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ugwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "147",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ugrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "uflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "124",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "tmpsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 0-10 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "tmpsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 10-200 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "tmpsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "SST/Land Skin Temperature at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "tmpmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "223"
                            },
                            "tmplct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmplct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "213"
                            },
                            "tmphct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmphct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "233"
                            },
                            "tmp2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tmin2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Minimum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "16",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tmax2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Maximum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "15",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tcdcmcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcmcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Middle Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "224"
                            },
                            "tcdclcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdclcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Low Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "214"
                            },
                            "tcdchcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdchcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "High Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "234"
                            },
                            "tcdcclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Cover Fraction for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "srweq": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "srweq",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Liquid Equivalent Snow Fall Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "64",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "spfh2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "spfh2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "51",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "soilwsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 0-10 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "soilwsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 10-200 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "snohf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snohf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow Heat Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "229",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "snoev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snoev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow evaporative heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "230",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "shtfl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shtfl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sensible Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "122",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "sdtrhsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdtrhsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Std dev of time tend of rel hum",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "221",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "runof": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runof",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Accumulation of Water Runoff at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "90",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "pwat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "presmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "223"
                            },
                            "presmcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "222"
                            },
                            "preslct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "213"
                            },
                            "preslcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "212"
                            },
                            "preshct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "233"
                            },
                            "preshcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "232"
                            },
                            "pratesfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pratesfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "pevprsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pevprsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Potential Evaporation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "145",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "lhtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Latent Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "121",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "land": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "land",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Land-sea mask",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "81",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "icec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "icec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice Concentration at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "91",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "gflux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gflux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ground heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "155",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "dswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "dswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "dlwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "205",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "cworkclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cworkclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud work function for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "J kg-1",
                                "gribvariable": "146",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "cprat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cprat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "214",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            }
                        },
                        "flx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weasdsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weasdsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Water Equiv. of Accum. Snow Depth at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "65",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "vgwdsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgwdsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "148",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "vgrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "vflxsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vflxsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "125",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "uswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "uswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Shortwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "ulwrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "ulwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "ugwdsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugwdsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "147",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "ugrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "uflxsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uflxsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "124",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "tmpsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 0-10 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "tmpsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 10-200 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "tmpsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "SST/Land Skin Temperature at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "tmpmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "223",
                                "pointwidth": "1.0"
                            },
                            "tmplct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmplct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "213",
                                "pointwidth": "1.0"
                            },
                            "tmphct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmphct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "233",
                                "pointwidth": "1.0"
                            },
                            "tmp2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "tmin2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Minimum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "16",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "tmax2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Maximum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "15",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "tcdcmcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcmcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Middle Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "224",
                                "pointwidth": "1.0"
                            },
                            "tcdclcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdclcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Low Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "214",
                                "pointwidth": "1.0"
                            },
                            "tcdchcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdchcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "High Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "234",
                                "pointwidth": "1.0"
                            },
                            "tcdcclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Cover Fraction for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "srweqsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "srweqsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Liquid Equivalent Snow Fall Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "64",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "spfh2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "spfh2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "51",
                                "gribfield": "1",
                                "gribleveltype": "105",
                                "pointwidth": "1.0"
                            },
                            "soilwsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 0-10 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "soilwsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 10-200 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "snohfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snohfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow Heat Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "229",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "snoevsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snoevsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow evaporative heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "230",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "shtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sensible Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "122",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "sdtrhsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdtrhsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Std dev of time tend of rel hum",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "221",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "runofsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runofsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Accumulation of Water Runoff at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "90",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "pwatclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwatclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "presmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "223",
                                "pointwidth": "1.0"
                            },
                            "presmcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "222",
                                "pointwidth": "1.0"
                            },
                            "preslct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "213",
                                "pointwidth": "1.0"
                            },
                            "preslcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "212",
                                "pointwidth": "1.0"
                            },
                            "preshct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "233",
                                "pointwidth": "1.0"
                            },
                            "preshcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "232",
                                "pointwidth": "1.0"
                            },
                            "pratesfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pratesfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "pevprsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pevprsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Potential Evaporation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "145",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "lhtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Latent Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "121",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "landsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "landsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Land-sea mask",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "81",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "icecsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "icecsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice Concentration at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "91",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "gfluxsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gfluxsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ground heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "155",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "dswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "dswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "dlwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "205",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "cworkclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cworkclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud work function for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "J kg-1",
                                "gribvariable": "146",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "cpratsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cpratsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "214",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "BGRUN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "BGRUN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Baseflow-groundwater runoff",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "234",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            }
                        },
                        "cmporain": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cmporain",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            }
                        },
                        "c8009": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8009",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weasd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weasd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Water Equiv. of Accum. Snow Depth at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "65",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "vgwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "148",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "vgrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "34",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "vflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "125",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "uswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "uswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Shortwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ulwrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "ulwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ugwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal gravity wave stress at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "147",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "ugrd10m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugrd10m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Wind at 10 m",
                                "missing_value": "9.99900026E20",
                                "units": "m s-1",
                                "gribvariable": "33",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "uflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal Momentum Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "124",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "tmpsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 0-10 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "tmpsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Temperature between 10-200 cm Below Ground Level",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "tmpsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "SST/Land Skin Temperature at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "tmpmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "223"
                            },
                            "tmplct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmplct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "213"
                            },
                            "tmphct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmphct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "233"
                            },
                            "tmp2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Air Temperature at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tmin2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Minimum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "16",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tmax2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Maximum Temperature at 2 m",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "15",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "tcdcmcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcmcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Middle Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "224"
                            },
                            "tcdclcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdclcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Low Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "214"
                            },
                            "tcdchcl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdchcl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "High Cloud Cover Fraction",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "234"
                            },
                            "tcdcclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Cloud Cover Fraction for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "srweq": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "srweq",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Liquid Equivalent Snow Fall Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "64",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "spfh2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "spfh2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity at 2 meters",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "51",
                                "gribfield": "1",
                                "gribleveltype": "105"
                            },
                            "soilwsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 0-10 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "soilwsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Volumetric Soil Moisture between 10-200 cm Below Ground Level",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112"
                            },
                            "snohf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snohf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow Heat Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "229",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "snoev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snoev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Snow evaporative heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "230",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "shtfl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shtfl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sensible Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "122",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "sdtrhsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdtrhsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Std dev of time tend of rel hum",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "221",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "runof": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runof",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Accumulation of Water Runoff at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "90",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "pwat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pwat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "54",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "pressfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "presmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "223"
                            },
                            "presmcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "presmcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Middle Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "222"
                            },
                            "preslct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "213"
                            },
                            "preslcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preslcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the Low Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "212"
                            },
                            "preshct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Top",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "233"
                            },
                            "preshcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "preshcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure at the High Cloud Bottom",
                                "missing_value": "9.99900026E20",
                                "units": "Pa",
                                "gribvariable": "1",
                                "gribfield": "1",
                                "gribleveltype": "232"
                            },
                            "pratesfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pratesfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "pevprsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pevprsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Potential Evaporation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "145",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "lhtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Latent Heat Net Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "121",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "icec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "icec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice Concentration at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "91",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "gflux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gflux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ground heat flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "155",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "dswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "8"
                            },
                            "dswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Solar Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "dlwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward Longwave Radiation Flux at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "205",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            },
                            "cworkclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cworkclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud work function for Total Air Column",
                                "missing_value": "9.99900026E20",
                                "units": "J kg-1",
                                "gribvariable": "146",
                                "gribfield": "1",
                                "gribleveltype": "200"
                            },
                            "cprat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cprat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective Precipitation Rate at Surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "214",
                                "gribfield": "1",
                                "gribleveltype": "1"
                            }
                        }
                    },
                    "dg3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dg3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dg3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dg3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weasdsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weasdsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Accumulated snow at surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2",
                                "gribvariable": "65",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "vflxsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vflxsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional momentum flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "N m-2",
                                "gribvariable": "125",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "vdfvasig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vdfvasig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertical diffusion meridional acceleration on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "m s-2",
                                "gribvariable": "248",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "vdfuasig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vdfuasig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertical diffusion zonal acceleration on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "m s-2",
                                "gribvariable": "247",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "vdfmrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vdfmrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertical diffusion moistening on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "kg kg-1 s-1",
                                "gribvariable": "249",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "vdfhrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vdfhrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertical diffusion heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "246",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "vddsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vddsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Visible diffuse downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "167",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "vbdsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vbdsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Visible beam downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "166",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "uswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward solar flux at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "uswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "211",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "ulwrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward longwave flux at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "ulwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Upward longwave flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "212",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "uflxsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uflxsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal momentum flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "N m-2",
                                "gribvariable": "124",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "tmpsoilt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Soil temperature at 0-10 cm down",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "tmpsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "9.99900026E20",
                                "long_name": "Soil temperature at 10-200 cm down",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "tmpsoilb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsoilb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Soil temperature at 300 cm down",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "111",
                                "pointwidth": "1.0"
                            },
                            "tmpsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmpsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature at surface",
                                "missing_value": "9.99900026E20",
                                "units": "Kelvin_scale",
                                "gribvariable": "11",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "tcdcsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdcsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud cover on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "71",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "swhrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "swhrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Solar radiative heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "250",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "soilwsoilm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilwsoilm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Soil moisture",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "144",
                                "gribfield": "1",
                                "gribleveltype": "112",
                                "pointwidth": "1.0"
                            },
                            "shtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sensible heat flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "122",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "shamrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shamrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Shallow convective moistening on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "kg kg-1 s-1",
                                "gribvariable": "245",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "shahrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shahrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Shallow convective heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "244",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "sglyrmct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrmct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Middle cloud top nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "223",
                                "pointwidth": "1.0"
                            },
                            "sglyrmcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrmcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Middle cloud bottom nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "222",
                                "pointwidth": "1.0"
                            },
                            "sglyrlct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrlct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Low cloud top nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "213",
                                "pointwidth": "1.0"
                            },
                            "sglyrlcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrlcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Low cloud bottom nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "212",
                                "pointwidth": "1.0"
                            },
                            "sglyrhct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrhct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "High cloud top nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "233",
                                "pointwidth": "1.0"
                            },
                            "sglyrhcb": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sglyrhcb",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "High cloud bottom nearby model level",
                                "missing_value": "9.99900026E20",
                                "units": "unitless",
                                "gribvariable": "175",
                                "gribfield": "1",
                                "gribleveltype": "232",
                                "pointwidth": "1.0"
                            },
                            "sfcrsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sfcrsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface roughness",
                                "missing_value": "9.99900026E20",
                                "units": "m",
                                "gribvariable": "83",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "pratesfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pratesfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation at surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "59",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "nddsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nddsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near IR diffuse downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "169",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "nbdsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nbdsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near IR beam downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "168",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "lwhrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lwhrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Longwave radiative heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "251",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "lrghrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lrghrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Large scale condensation heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "241",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "lhtflsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhtflsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Latent heat flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "121",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "dswrftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward solar flux at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "dswrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "204",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "dlwrfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwrfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Downward longwave flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "205",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "csusftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csusftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Clear-sky upward solar flux at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "160",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "csusfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csusfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Clear-sky upward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "160",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "csulftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csulftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Clear-sky upward longwave flux at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "162",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "csdsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csdsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Clear-sky downward solar flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "161",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "csdlfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "csdlfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Clear-sky downward longwave flux at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "163",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "cpratsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cpratsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective precipitation rate at surface",
                                "missing_value": "9.99900026E20",
                                "units": "kg m-2 s-1",
                                "gribvariable": "214",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "cnvmrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnvmrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Deep convective moistening on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "243",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "cnvhrsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnvhrsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Deep convective heating on sigma levels",
                                "missing_value": "9.99900026E20",
                                "units": "K s-1",
                                "gribvariable": "242",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "cfnsftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnsftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net shortwave cloud forcing at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "164",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "cfnsfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnsfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net shortwave cloud forcing at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "164",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "cfnsfclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnsfclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net shortwave cloud forcing in total atmospheric column",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "164",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "cfnlftoa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnlftoa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net longwave cloud forcing at nominal top of atmosphere",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "165",
                                "gribfield": "1",
                                "gribleveltype": "8",
                                "pointwidth": "1.0"
                            },
                            "cfnlfsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnlfsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net longwave cloud forcing at surface",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "165",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "cfnlfclm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cfnlfclm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Net longwave cloud forcing in total atmospheric column",
                                "missing_value": "9.99900026E20",
                                "units": "W m-2",
                                "gribvariable": "165",
                                "gribfield": "1",
                                "gribleveltype": "200",
                                "pointwidth": "1.0"
                            },
                            "cdconsig": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cdconsig",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Sigma-level convective cloud cover fraction",
                                "standard_name": "convective_cloud_area_fraction_in_atmospheric_layer",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "72",
                                "gribfield": "1",
                                "gribleveltype": "107",
                                "pointwidth": "1.0"
                            },
                            "cdconsfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cdconsfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective cloud cover fraction at surface",
                                "standard_name": "convective_cloud_area_fraction_in_atmospheric_layer",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "72",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            },
                            "albdosfc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "albdosfc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Albedo at Surface",
                                "standard_name": "surface_albedo",
                                "missing_value": "9.99900026E20",
                                "units": "percent",
                                "gribvariable": "84",
                                "gribfield": "1",
                                "gribleveltype": "1",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "Daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pres": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pres",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "-1",
                            "long_name": "Daily Pressure at Surface",
                            "statistic": "Mean",
                            "precision": "-1",
                            "unpacked_valid_range": "195000.0",
                            "standard_name": "pressure",
                            "missing_value": "32766",
                            "var_desc": "Pressure",
                            "level_desc": "Surface",
                            "add_offset": "359650.0",
                            "GRIB_name": "PRES",
                            "scale_factor": "10.0",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-16465",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "1",
                            "units": "Pascals",
                            "pointwidth": "0"
                        },
                        "pr_wtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pr_wtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "-1",
                            "statistic": "Mean",
                            "units": "kg/m^2",
                            "precision": "2",
                            "unpacked_valid_range": "160.0",
                            "standard_name": "atmosphere_water_content",
                            "level_desc": "Entire Atmosphere Considered As a Single Layer",
                            "var_desc": "Precipitable Water Content",
                            "missing_value": "32766",
                            "scale_factor": "0.01",
                            "add_offset": "287.64999",
                            "actual_range": "85.33",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "GRIB_name": "PWAT",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "valid_range": "-12765",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "54",
                            "long_name": "Daily Precipitable Water for Entire Atmosphere",
                            "pointwidth": "0"
                        },
                        "mslp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mslp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "-1",
                            "long_name": "Daily Mean Sea Level Pressure",
                            "statistic": "Mean",
                            "precision": "0",
                            "unpacked_valid_range": "125000.0",
                            "standard_name": "pressure",
                            "var_desc": "Mean Sea Level Pressure",
                            "missing_value": "32766",
                            "level_desc": "Sea Level",
                            "add_offset": "109766.0",
                            "GRIB_name": "PRMSL",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "valid_range": "15235",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "2",
                            "units": "Pascals",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "0",
                            "units": "m",
                            "statistic": "Individual Obs",
                            "long_name": "Geopotential Height at the Surface",
                            "unpacked_valid_range": "6300.0",
                            "standard_name": "geopotential_height",
                            "missing_value": "32766",
                            "var_desc": "Geopotential Height",
                            "level_desc": "Surface",
                            "add_offset": "31565.0",
                            "GRIB_name": "HGT",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-25265",
                            "parent_stat": "Other",
                            "GRIB_id": "7",
                            "precision": "0"
                        }
                    },
                    "pressure": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vwnd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vwnd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "statistic": "Mean",
                            "long_name": "Daily V-wind on Pressure Levels",
                            "precision": "2",
                            "unpacked_valid_range": "175.0",
                            "standard_name": "northward_wind",
                            "var_desc": "v-wind",
                            "missing_value": "32766",
                            "level_desc": "Pressure Levels",
                            "add_offset": "187.64999",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "scale_factor": "0.01",
                            "GRIB_name": "VGRD",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-1266",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "34",
                            "least_significant_digit": "1",
                            "pointwidth": "0"
                        },
                        "uwnd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uwnd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m/s",
                            "statistic": "Mean",
                            "long_name": "Daily U-wind on Pressure Levels",
                            "precision": "2",
                            "unpacked_valid_range": "175.0",
                            "standard_name": "eastward_wind",
                            "var_desc": "u-wind",
                            "missing_value": "32766",
                            "level_desc": "Pressure Levels",
                            "add_offset": "187.64999",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "scale_factor": "0.01",
                            "GRIB_name": "UGRD",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-1266",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "33",
                            "least_significant_digit": "1",
                            "pointwidth": "0"
                        },
                        "rhum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rhum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "0",
                            "units": "percent",
                            "long_name": "Daily Relative Humidity on Pressure Levels",
                            "precision": "2",
                            "unpacked_valid_range": "125.0",
                            "standard_name": "relative_humidity",
                            "missing_value": "32766",
                            "var_desc": "Relative humidity",
                            "level_desc": "Pressure Levels",
                            "add_offset": "302.64999",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "scale_factor": "0.01",
                            "GRIB_name": "RH",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-17766",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "52",
                            "statistic": "Mean",
                            "pointwidth": "0"
                        },
                        "omega": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "omega",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "3",
                            "statistic": "Mean",
                            "units": "Pascal/s",
                            "precision": "3",
                            "unpacked_valid_range": "8.0",
                            "standard_name": "omega",
                            "level_desc": "Pressure Levels",
                            "var_desc": "Omega (dp/dt)",
                            "missing_value": "32766",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "add_offset": "28.764999",
                            "scale_factor": "0.001",
                            "GRIB_name": "VVEL",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-20766",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "39",
                            "long_name": "Daily Omega on Pressure Levels",
                            "pointwidth": "0"
                        },
                        "hgt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hgt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m",
                            "long_name": "Daily Geopotential Heights on Pressure Levels",
                            "statistic": "Mean",
                            "precision": "0",
                            "unpacked_valid_range": "35800.0",
                            "standard_name": "geopotential_height",
                            "level_desc": "Pressure Levels",
                            "missing_value": "32766",
                            "var_desc": "Geopotential height",
                            "add_offset": "31265.0",
                            "GRIB_name": "HGT",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "valid_range": "4534",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "7",
                            "least_significant_digit": "0",
                            "pointwidth": "0"
                        },
                        "air": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "air",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "least_significant_digit": "1",
                            "statistic": "Mean",
                            "long_name": "Daily Air Temperature on Pressure Levels",
                            "precision": "2",
                            "unpacked_valid_range": "362.5",
                            "standard_name": "air_temperature",
                            "var_desc": "Air temperature",
                            "missing_value": "32766",
                            "level_desc": "Pressure Levels",
                            "add_offset": "465.14999",
                            "GRIB_name": "TMP",
                            "scale_factor": "0.01",
                            "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                            "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                            "valid_range": "-10260",
                            "parent_stat": "Individual Obs",
                            "GRIB_id": "11",
                            "units": "Kelvin_scale",
                            "pointwidth": "0"
                        }
                    },
                    "gaussian_grid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gaussian_grid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "weasd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "weasd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "kg/m^2",
                                "statistic": "Mean",
                                "precision": "0",
                                "unpacked_valid_range": "65530.0",
                                "standard_name": "surface_snow_amount",
                                "level_desc": "Surface",
                                "missing_value": "32766",
                                "var_desc": "Water Equiv. of Accum. Snow Depth",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "add_offset": "32765.0",
                                "GRIB_name": "WEASD",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "32765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "65",
                                "long_name": "Daily Forecast of Water Equiv. of Accum. Snow Depth at Surface",
                                "pointwidth": "0"
                            },
                            "vgwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vgwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "3",
                                "statistic": "Mean",
                                "units": "Pascals",
                                "long_name": "Daily Mean of Meridional Gravity Wave Stress at Surface",
                                "unpacked_valid_range": "32.0",
                                "standard_name": "northward_gravity_wave_stress",
                                "var_desc": "Meridional Gravity Wave Stress",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "0.001",
                                "add_offset": "0.765",
                                "GRIB_name": "V-GWD",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "31235",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "148",
                                "precision": "3",
                                "pointwidth": "0"
                            },
                            "vflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "3",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Momentum Flux, v-component at Surface",
                                "unpacked_valid_range": "6.0",
                                "standard_name": "downward_northward_stress_in_air",
                                "missing_value": "32766",
                                "var_desc": "Momentum Flux, v-component",
                                "level_desc": "Surface",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "27.764999",
                                "scale_factor": "0.001",
                                "GRIB_name": "V FLX",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-21766",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "125",
                                "least_significant_digit": "3",
                                "pointwidth": "0"
                            },
                            "uswrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "W/m2",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Upward Solar Radiation Flux at Surface",
                                "unpacked_valid_range": "845.0",
                                "standard_name": "surface_upward_shortwave_radiation_flux",
                                "missing_value": "32766",
                                "var_desc": "Upward Solar Radiation Flux",
                                "level_desc": "Surface",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "3131.5",
                                "scale_factor": "0.1",
                                "GRIB_name": "USWRF",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-22866",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "211",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "ulwrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "statistic": "Mean",
                                "units": "W/m2",
                                "long_name": "Daily Mean of Upward Longwave Radiation Flux at Surface",
                                "unpacked_valid_range": "945.0",
                                "standard_name": "surface_upward_longwave_radiation_flux",
                                "missing_value": "32766",
                                "var_desc": "Upward Longwave Radiation Flux",
                                "level_desc": "Surface",
                                "GRIB_name": "ULWRF",
                                "scale_factor": "0.1",
                                "add_offset": "3201.5",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-22566",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "212",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "ugwd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ugwd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Mean of Zonal Gravity Wave Stress at Surface",
                                "statistic": "Mean",
                                "units": "Pascals",
                                "precision": "3",
                                "unpacked_valid_range": "32.0",
                                "standard_name": "eastward_gravity_wave_stress",
                                "missing_value": "32766",
                                "var_desc": "Zonal Gravity Wave Stress",
                                "level_desc": "Surface",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "0.765",
                                "scale_factor": "0.001",
                                "GRIB_name": "U-GWD",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "31235",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "147",
                                "least_significant_digit": "3",
                                "pointwidth": "0"
                            },
                            "uflx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uflx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "3",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Momentum Flux, u-component at Surface",
                                "unpacked_valid_range": "6.0",
                                "standard_name": "downward_eastward_stress_in_air",
                                "missing_value": "32766",
                                "var_desc": "Momentum Flux, u-component",
                                "level_desc": "Surface",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "27.764999",
                                "scale_factor": "0.001",
                                "GRIB_name": "U FLX",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-21766",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "124",
                                "least_significant_digit": "3",
                                "pointwidth": "0"
                            },
                            "skt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "skt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "1",
                                "units": "Kelvin_scale",
                                "statistic": "Mean",
                                "long_name": "Daily Forecast of SST/Land Skin Temperature at the Surface",
                                "unpacked_valid_range": "430.0",
                                "standard_name": "temperature",
                                "var_desc": "Skin Temperature",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "add_offset": "447.64999",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "0.01",
                                "GRIB_name": "TMP",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "valid_range": "-1765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "11",
                                "precision": "2",
                                "pointwidth": "0"
                            },
                            "shtfl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shtfl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "precision": "1",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Sensible Heat Net Flux at Surface",
                                "unpacked_valid_range": "5750.0",
                                "standard_name": "surface_upward_sensible_heat_flux",
                                "missing_value": "32766",
                                "var_desc": "Sensible Heat Net Flux",
                                "level_desc": "Surface",
                                "add_offset": "2176.5",
                                "GRIB_name": "SHTFL",
                                "scale_factor": "0.1",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-29802",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "122",
                                "units": "W/m2",
                                "pointwidth": "0"
                            },
                            "runof": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runof",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/m^2",
                                "statistic": "Daily Accumulation",
                                "long_name": "Daily Accumulation of Water Runoff at Surface",
                                "precision": "2",
                                "unpacked_valid_range": "630.3",
                                "standard_name": "surface_runoff_amount",
                                "level_desc": "Surface",
                                "missing_value": "32766",
                                "var_desc": "Water Runoff",
                                "add_offset": "302.64999",
                                "GRIB_name": "RUNOF",
                                "scale_factor": "0.01",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Values",
                                "cell_methods": "time: accumulation (for each 6-hourly interval) accumulation (of 4 6-hourly accumulations)",
                                "valid_range": "-8265",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "90",
                                "least_significant_digit": "1",
                                "pointwidth": "0"
                            },
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "-1",
                                "units": "Pascals",
                                "long_name": "Daily Forecast of Surface Pressure",
                                "precision": "-1",
                                "unpacked_valid_range": "122750.0",
                                "standard_name": "air_pressure",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "level_desc": "Surface",
                                "add_offset": "359910.0",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-23715",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "statistic": "Mean",
                                "pointwidth": "0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Mean of Precipitation Rate at Surface",
                                "statistic": "Mean",
                                "units": "Kg/m^2/s",
                                "precision": "7",
                                "unpacked_valid_range": "0.00525",
                                "standard_name": "precipitation_rate",
                                "level_desc": "Surface",
                                "missing_value": "32766",
                                "var_desc": "Precipitation Rate",
                                "add_offset": "0.0032765",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "1.00000001E-07",
                                "GRIB_name": "PRATE",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "19735",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "59",
                                "least_significant_digit": "6",
                                "pointwidth": "0"
                            },
                            "pevpr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pevpr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "W/m2",
                                "long_name": "Daily Mean of Potential Evaporation Rate at Surface",
                                "precision": "1",
                                "unpacked_valid_range": "5350.0",
                                "standard_name": "potential_evaportion_rate",
                                "missing_value": "32766",
                                "var_desc": "Potential Evaporation Rate",
                                "level_desc": "Surface",
                                "add_offset": "2326.5",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "0.1",
                                "GRIB_name": "PEVPR",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "30235",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "145",
                                "statistic": "Mean",
                                "pointwidth": "0"
                            },
                            "lhtfl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lhtfl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "W/m2",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Latent Heat Net Flux at Surface",
                                "unpacked_valid_range": "2420.0",
                                "standard_name": "surface_upward_latent_heat_flux",
                                "var_desc": "Latent Heat Net Flux",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "add_offset": "856.5",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "0.1",
                                "GRIB_name": "LHTFL",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "15634",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "121",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "land": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "land",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "statistic": "Individual Obs",
                                "units": "unitless",
                                "long_name": "Land-sea mask",
                                "unpacked_valid_range": "1",
                                "standard_name": "land_binary_mask",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "var_desc": "Land-sea mask",
                                "actual_range": "1",
                                "GRIB_name": "LAND",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "1",
                                "parent_stat": "Other",
                                "GRIB_id": "81",
                                "precision": "0"
                            },
                            "icec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "icec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Daily Forecast of Ice Concentration at Surface",
                                "statistic": "Mean",
                                "precision": "1",
                                "unpacked_valid_range": "1.0",
                                "standard_name": "sea_ice_area_fraction",
                                "var_desc": "Ice Concentration",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "add_offset": "3276.5",
                                "GRIB_name": "ICE C",
                                "scale_factor": "0.1",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-32755",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "91",
                                "least_significant_digit": "0",
                                "pointwidth": "0"
                            },
                            "gflux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gflux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "statistic": "Mean",
                                "units": "W/m2",
                                "long_name": "Daily Mean of Ground Heat Flux at Surface",
                                "unpacked_valid_range": "750.0",
                                "standard_name": "ground_heat_flux",
                                "var_desc": "Ground Heat Flux",
                                "missing_value": "32766",
                                "level_desc": "Surface",
                                "add_offset": "2826.5",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "0.1",
                                "GRIB_name": "GFLUX",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "155",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "dswrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "W/m2",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Downward Solar Radiation Flux at Surface",
                                "unpacked_valid_range": "1370.0",
                                "standard_name": "surface_downward_solar_radiation_flux",
                                "missing_value": "32766",
                                "var_desc": "Downward Solar Radiation Flux",
                                "level_desc": "Surface",
                                "add_offset": "3086.5",
                                "GRIB_name": "DSWRF",
                                "scale_factor": "0.1",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-17166",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "204",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "dlwrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dlwrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "W/m2",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Downward Longwave Radiation Flux at Surface",
                                "unpacked_valid_range": "635.0",
                                "standard_name": "surface_downward_longwave_radiation_flux",
                                "missing_value": "32766",
                                "var_desc": "Downward Longwave Radiation Flux",
                                "level_desc": "Surface",
                                "add_offset": "3141.5",
                                "GRIB_name": "DLWRF",
                                "scale_factor": "0.1",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-25065",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "205",
                                "precision": "1",
                                "pointwidth": "0"
                            },
                            "cprat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cprat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "6",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Convective Precipitation Rate at Surface",
                                "precision": "7",
                                "unpacked_valid_range": "0.0015",
                                "standard_name": "convective_precipitation_rate",
                                "missing_value": "32766",
                                "var_desc": "Convective Precipitation Rate",
                                "level_desc": "Surface",
                                "add_offset": "0.0032765",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "1.00000001E-07",
                                "GRIB_name": "CPRAT",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-12765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "214",
                                "units": "Kg/m^2/s",
                                "pointwidth": "0"
                            }
                        },
                        "ntat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ntat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uswrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uswrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "statistic": "Mean",
                                "units": "W/m2",
                                "precision": "1",
                                "unpacked_valid_range": "1685.0",
                                "standard_name": "TOA_surface_upward_shortwave_radiation_flux",
                                "missing_value": "32766",
                                "var_desc": "Upward Solar Radiation Flux",
                                "level_desc": "Nominal top of atmosphere",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "0.1",
                                "add_offset": "3091.5",
                                "GRIB_name": "USWRF",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-14066",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "211",
                                "long_name": "Daily Mean of Upward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "pointwidth": "0"
                            },
                            "ulwrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ulwrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Mean of Upward Longwave Radiation Flux at the Nominal Top of Atmosphere",
                                "statistic": "Mean",
                                "units": "W/m2",
                                "precision": "1",
                                "unpacked_valid_range": "1050.0",
                                "standard_name": "TOA_upward_longwave_radiation_flux",
                                "missing_value": "32766",
                                "level_desc": "Nominal top of atmosphere",
                                "var_desc": "Upward Longwave Radiation Flux",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "3126.5",
                                "scale_factor": "0.1",
                                "GRIB_name": "ULWRF",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "valid_range": "-20766",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "212",
                                "least_significant_digit": "0",
                                "pointwidth": "0"
                            },
                            "dswrf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dswrf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "Daily Mean of Downward Solar Radiation Flux at the Nominal Top of Atmosphere",
                                "statistic": "Mean",
                                "precision": "1",
                                "unpacked_valid_range": "1685.0",
                                "standard_name": "TOA__downward_solar_radiation_flux",
                                "level_desc": "Nominal top of atmosphere",
                                "missing_value": "32766",
                                "var_desc": "Downward Solar Radiation Flux",
                                "add_offset": "3091.5",
                                "GRIB_name": "DSWRF",
                                "scale_factor": "0.1",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-14065",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "204",
                                "least_significant_digit": "0",
                                "pointwidth": "0"
                            }
                        },
                        "middle_cloud_top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "middle_cloud_top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the Middle Cloud Top",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "level_desc": "Middle cloud top",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "least_significant_digit": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "middle_cloud_bottom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "middle_cloud_bottom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the Middle Cloud Bottom",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "level_desc": "Middle cloud bottom",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "least_significant_digit": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "low_cloud_top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "low_cloud_top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the Low Cloud Top",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "level_desc": "Low cloud top",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "precision": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "low_cloud_bottom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "low_cloud_bottom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the Low Cloud Bottom",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "level_desc": "Low cloud bottom",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "least_significant_digit": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "high_cloud_top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "high_cloud_top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the High Cloud Top",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "level_desc": "High cloud top",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "precision": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "high_cloud_bottom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "high_cloud_bottom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pres": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pres",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "precision": "-1",
                                "units": "Pascals",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Pressure at the High Cloud Bottom",
                                "unpacked_valid_range": "120000.0",
                                "standard_name": "air_pressure",
                                "level_desc": "High cloud bottom",
                                "missing_value": "32766",
                                "var_desc": "Pressure",
                                "add_offset": "327650.0",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "10.0",
                                "GRIB_name": "PRES",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-20765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "1",
                                "least_significant_digit": "-1",
                                "pointwidth": "0"
                            }
                        },
                        "entire_depth_of_atmosphere": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "entire_depth_of_atmosphere",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tcdc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcdc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "0",
                                "units": "percent",
                                "statistic": "Mean",
                                "long_name": "Daily Mean of Total Cloud Cover at Entire Atmosphere Considered as a Single Layer",
                                "unpacked_valid_range": "100.0",
                                "standard_name": "cloud_area_fraction",
                                "missing_value": "32766",
                                "var_desc": "Total cloud cover",
                                "level_desc": "Entire Atmosphere Considered As a Single Layer",
                                "add_offset": "3276.5",
                                "GRIB_name": "TCDC",
                                "cell_methods": "time: mean (of each 6-hourly interval) mean (of 4 6-hourly means)",
                                "scale_factor": "0.1",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-31765",
                                "_FileValue": "-32767",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "71",
                                "precision": "1",
                                "pointwidth": "0"
                            }
                        },
                        "meters_agl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "10-meters_agl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vwnd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vwnd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "1",
                                "statistic": "Mean",
                                "units": "m/s",
                                "long_name": "Daily Forecast of V-wind at 10 m",
                                "unpacked_valid_range": "120.0",
                                "standard_name": "northward_wind",
                                "missing_value": "32766",
                                "level_desc": "10 m",
                                "var_desc": "v-wind",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "207.64999",
                                "scale_factor": "0.01",
                                "GRIB_name": "V GRD",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "valid_range": "-8765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "34",
                                "precision": "2",
                                "pointwidth": "0"
                            },
                            "uwnd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwnd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "1",
                                "statistic": "Mean",
                                "units": "m/s",
                                "long_name": "Daily Forecast of U-wind at 10 m",
                                "unpacked_valid_range": "120.0",
                                "standard_name": "eastward_wind",
                                "missing_value": "32766",
                                "level_desc": "10 m",
                                "var_desc": "u-wind",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "add_offset": "207.64999",
                                "scale_factor": "0.01",
                                "GRIB_name": "U GRD",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "valid_range": "-8765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "33",
                                "precision": "2",
                                "pointwidth": "0"
                            }
                        },
                        "_cm_down": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0-10_cm_down",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Daily Forecast of Temperature between 0-10 cm Below Ground Level",
                                "statistic": "Mean",
                                "units": "Kelvin_scale",
                                "precision": "2",
                                "unpacked_valid_range": "430.0",
                                "standard_name": "temperature",
                                "missing_value": "32766",
                                "var_desc": "Temperature",
                                "level_desc": "Between 0-10 cm BGL",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "scale_factor": "0.01",
                                "add_offset": "447.64999",
                                "GRIB_name": "TMP",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "valid_range": "-1765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "11",
                                "least_significant_digit": "1",
                                "pointwidth": "0"
                            },
                            "soilw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soilw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "least_significant_digit": "3",
                                "precision": "4",
                                "units": "unitless",
                                "long_name": "Daily Forecast of Volumetric Soil Moisture between 0-10 cm Below Ground Level",
                                "unpacked_valid_range": "1.0",
                                "standard_name": "soil_moisture",
                                "var_desc": "Volumetric Soil Moisture",
                                "missing_value": "32766",
                                "level_desc": "Between 0-10 cm BGL",
                                "add_offset": "3.2765",
                                "cell_methods": "time: mean (of 4 6-hourly values in one day)",
                                "scale_factor": "9.99999975E-05",
                                "GRIB_name": "SOILW",
                                "Dataset": "NCEP/DOE AMIP-II Reanalysis (Reanalysis-2) Daily Averages",
                                "valid_range": "-22765",
                                "parent_stat": "Individual Obs",
                                "GRIB_id": "144",
                                "statistic": "Mean",
                                "pointwidth": "0"
                            }
                        }
                    }
                }
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "P": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "millibar",
                "gridtype": "0",
                "long_name": "Pressure Level"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "Time",
                "standard_name": "time"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "long_name": "Time",
                "calendar": "360"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "long_name": "Time",
                "calendar": "360"
            },
            "Z1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0",
                "long_name": "Height"
            },
            "Z_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0",
                "long_name": "Height"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "modulo": "12.0",
                "pointwidth": "1.0",
                "long_name": "Time",
                "standard_name": "time",
                "modulus": "12.0",
                "calendar": "360"
            },
            "Z2_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z2_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "Depth",
                "standard_name": "depth"
            },
            "Z2_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z2_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "Depth",
                "standard_name": "depth"
            },
            "Z2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "Depth",
                "standard_name": "depth"
            },
            "Z": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "sigma",
                "gridtype": "0",
                "long_name": "Height"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "long_name": "latitude",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "long_name": "Time",
                "calendar": "360"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.875",
                "standard_name": "longitude",
                "long_name": "longitude"
            },
            "level_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "millibar",
                "gridtype": "0",
                "standard_name": "pressure"
            },
            "lon_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "lat_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "level_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0",
                "standard_name": "height"
            },
            "level_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0",
                "standard_name": "height"
            },
            "level_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "gridtype": "0",
                "pointwidth": "0",
                "standard_name": "depth"
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1979-01-01 12:00:0.0",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "level": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "gridtype": "0",
                "pointwidth": "0",
                "standard_name": "depth"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.875",
                "standard_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "dir": "SOURCES/NOAA/NCEP-DOE"
        },
        "NCEPNCAR": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/NOAA/NCEP-NCAR",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "NCEP-NCAR",
            "restriction": "Public",
            "CDAS1": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "CDAS-1",
                "restriction": "Public",
                "DAILY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DAILY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Intrinsictropopauseexpires": "1615297200",
                        "Intrinsicsurfaceexpires": "1615297200",
                        "Intrinsicsigma_072094expires": "1615297200",
                        "Intrinsicsigma_044100expires": "1615297200",
                        "Intrinsicsigma_044072expires": "1615297200",
                        "Intrinsicsigmaexpires": "1615297200",
                        "Intrinsicmax_wind_levexpires": "1615297200",
                        "Intrinsicabove_MSLexpires": "1615297200",
                        "Intrinsic300_mb_above_gndexpires": "1615297200",
                        "Intrinsicreferences": "Kalnay_etal1996",
                        "Diagnostictotal_air_columncloud_forcingnetexpires": "1615210800",
                        "Diagnostictotal_air_columncloud_forcingexpires": "1615210800",
                        "Diagnostictopupwardexpires": "1615210800",
                        "Diagnostictopdownwardexpires": "1615210800",
                        "Diagnostictopcloud_forcingnetexpires": "1615210800",
                        "Diagnostictopcloud_forcingexpires": "1615210800",
                        "Diagnostictopclear_skyupwardexpires": "1615210800",
                        "Diagnostictopclear_skyexpires": "1615210800",
                        "Diagnostictopexpires": "1615210800",
                        "Diagnosticsurfaceupwardexpires": "1615210800",
                        "Diagnosticsurfacesnowsublimationexpires": "1615210800",
                        "Diagnosticsurfacesnowmeltexpires": "1615210800",
                        "Diagnosticsurfacesnowexpires": "1615210800",
                        "Diagnosticsurfacepotentialexpires": "1615210800",
                        "Diagnosticsurfacenetexpires": "1615210800",
                        "Diagnosticsurfacegroundexpires": "1615210800",
                        "Diagnosticsurfacedownwardexpires": "1615210800",
                        "Diagnosticsurfacecloud_forcingnetexpires": "1615210800",
                        "Diagnosticsurfacecloud_forcingexpires": "1615210800",
                        "Diagnosticsurfaceclear_skyupwardexpires": "1615210800",
                        "Diagnosticsurfaceclear_skydownwardexpires": "1615210800",
                        "Diagnosticsurfaceclear_skyexpires": "1615210800",
                        "Diagnosticsoilexpires": "1615210800",
                        "Diagnosticmiddlecloudtopexpires": "1615210800",
                        "Diagnosticmiddlecloudbottomexpires": "1615210800",
                        "Diagnosticmiddlecloudexpires": "1615210800",
                        "Diagnosticlowcloudtopexpires": "1615210800",
                        "Diagnosticlowcloudbottomexpires": "1615210800",
                        "Diagnosticlowcloudexpires": "1615210800",
                        "Diagnostichighcloudtopexpires": "1615210800",
                        "Diagnostichighcloudbottomexpires": "1615210800",
                        "Diagnostichighcloudexpires": "1615210800",
                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP-NCAR/.CDAS-1/.DAILY/.griblist.html",
                        "expires": "1615297200",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tropopause": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tropopause",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "VSSH": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VSSH",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Vertical speed shear",
                                "standard_name": "wind_speed_shear",
                                "expires": "1615297200",
                                "units": "1/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "136",
                                "gribleveltype": "7",
                                "gribNumBits": "8",
                                "GRIBgridcode": "2",
                                "scale_max": "0.0133",
                                "scale_min": "-0.0103",
                                "gribparam": "136",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VSSH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "7",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "38.099998",
                                "scale_min": "-38.799999",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "7",
                                "gribNumBits": "11",
                                "GRIBgridcode": "2",
                                "scale_max": "67.199997",
                                "scale_min": "-35.599998",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "tropopause_air_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "11",
                                "gribleveltype": "7",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "235.8",
                                "scale_min": "189.0",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "standard_name": "tropopause_air_pressure",
                                "expires": "1615297200",
                                "units": "Pa",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "1",
                                "gribleveltype": "7",
                                "gribNumBits": "12",
                                "GRIBgridcode": "2",
                                "scale_max": "38680.0",
                                "scale_min": "8820.0",
                                "gribparam": "1",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "total_air_column": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_air_column",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity",
                                "standard_name": "relative_humidity",
                                "expires": "1615297200",
                                "units": "percent",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "200",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "PWAT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PWAT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water",
                                "standard_name": "atmosphere_mass_content_of_water_vapor",
                                "expires": "1615297200",
                                "units": "kg/m2",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "54",
                                "gribleveltype": "200",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "86.800003",
                                "scale_min": "-8.0",
                                "gribparam": "54",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PWAT",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "standard_name": "surface_air_pressure",
                                "expires": "1615297200",
                                "units": "Pa",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "1",
                                "gribleveltype": "1",
                                "gribNumBits": "13",
                                "GRIBgridcode": "2",
                                "scale_max": "108560.0",
                                "scale_min": "51270.0",
                                "gribparam": "1",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "expires": "1615297200",
                                "units": "gpm",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "7",
                                "gribleveltype": "1",
                                "gribNumBits": "13",
                                "GRIBgridcode": "2",
                                "scale_max": "5659.0",
                                "scale_min": "-583.0",
                                "gribparam": "7",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "LFTX": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "4LFTX",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Best (4-layer) lifted index",
                                "standard_name": "temperature_difference_between_ambient_air_and_air_lifted_adiabatically",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "132",
                                "gribleveltype": "1",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "26.1",
                                "scale_min": "-10.4",
                                "gribparam": "132",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "4LFTX",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "sigma_072094": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sigma_072-094",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "relative_humidity",
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "108",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "sigma_044100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sigma_044-100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "relative_humidity",
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "108",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "sigma_044072": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sigma_044-072",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "relative_humidity",
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "108",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "sigma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sigma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "expires": "1615297200",
                                "units": "Pa/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "39",
                                "gribleveltype": "107",
                                "gribNumBits": "11",
                                "GRIBgridcode": "2",
                                "scale_max": "2.21",
                                "scale_min": "-1.7410001",
                                "gribparam": "39",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VVEL",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "107",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "31.1",
                                "scale_min": "-33.5",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "107",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "31.9",
                                "scale_min": "-32.799999",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "11",
                                "gribleveltype": "107",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "317.79999",
                                "scale_min": "184.0",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity",
                                "standard_name": "relative_humidity",
                                "expires": "1615297200",
                                "units": "percent",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "107",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "POT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "POT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Potential temperature",
                                "standard_name": "air_potential_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "13",
                                "gribleveltype": "107",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "337.60001",
                                "scale_min": "208.2",
                                "gribparam": "13",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "POT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "long_name": "Pressure vertical velocity",
                                "units": "Pa/s",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "39",
                                "gribleveltype": "100",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "1.291",
                                "scale_min": "-1.235",
                                "gribparam": "39",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VVEL",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "vpot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Velocity potential",
                                "standard_name": "atmosphere_horizontal_velocity_potential",
                                "expires": "1615297200",
                                "units": "m2/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "36",
                                "gribleveltype": "100",
                                "gribNumBits": "16",
                                "GRIBgridcode": "2",
                                "scale_max": "33365800.0",
                                "scale_min": "-46008100.0",
                                "gribparam": "36",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VPOT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "gribNumBits": "8",
                                "GRIBgridcode": "2",
                                "scale_max": "108.7",
                                "scale_min": "-108.3",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "gribNumBits": "8",
                                "GRIBgridcode": "2",
                                "scale_max": "150.8",
                                "scale_min": "-107.1",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "320.29999",
                                "scale_min": "152.39999",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "relative_humidity",
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "100",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "relv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "relv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative vorticity",
                                "standard_name": "atmosphere_relative_vorticity",
                                "expires": "1615297200",
                                "units": "1/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "43",
                                "gribleveltype": "100",
                                "gribNumBits": "14",
                                "GRIBgridcode": "2",
                                "scale_max": "2.56920001E-04",
                                "scale_min": "-2.29890007E-04",
                                "gribparam": "43",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RELV",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "reld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative divergence",
                                "standard_name": "divergence_of_wind",
                                "expires": "1615297200",
                                "units": "1/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "44",
                                "gribleveltype": "100",
                                "gribNumBits": "13",
                                "GRIBgridcode": "2",
                                "scale_max": "8.71899974E-05",
                                "scale_min": "-7.36200018E-05",
                                "gribparam": "44",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RELD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "specific_humidity",
                                "long_name": "Specific humidity",
                                "units": "unitless",
                                "expires": "1615297200",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "GRIBgridcode": "2",
                                "scale_max": "0.0506",
                                "scale_min": "0.0",
                                "gribparam": "51",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Stream function",
                                "standard_name": "atmosphere_horizontal_streamfunction",
                                "expires": "1615297200",
                                "units": "m2/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "35",
                                "gribleveltype": "100",
                                "gribNumBits": "16",
                                "GRIBgridcode": "2",
                                "scale_max": "2.73200288E08",
                                "scale_min": "-1.99307008E08",
                                "gribparam": "35",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "STRM",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "expires": "1615297200",
                                "units": "gpm",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "32480.0",
                                "scale_min": "-605.0",
                                "gribparam": "7",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "ABSV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ABSV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Absolute vorticity",
                                "standard_name": "atmosphere_absolute_vorticity",
                                "expires": "1615297200",
                                "units": "1/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "41",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "GRIBgridcode": "2",
                                "scale_max": "3.40700004E-04",
                                "scale_min": "-3.21800006E-04",
                                "gribparam": "41",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "ABSV",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PRMSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRMSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure reduced to MSL",
                                "standard_name": "air_pressure_at_sea_level",
                                "expires": "1615297200",
                                "units": "Pa",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "2",
                                "gribleveltype": "102",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "112320.0",
                                "scale_min": "92750.0",
                                "gribparam": "2",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRMSL",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "standard_name": "air_pressure_at_sea_level",
                                "expires": "1615297200",
                                "units": "Pa",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "1",
                                "gribleveltype": "102",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "111912.0",
                                "scale_min": "92828.0",
                                "gribparam": "1",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 6 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            }
                        },
                        "max_wind_lev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "max_wind_lev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "6",
                                "gribNumBits": "11",
                                "GRIBgridcode": "2",
                                "scale_max": "88.400002",
                                "scale_min": "-85.300003",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "6",
                                "gribNumBits": "11",
                                "GRIBgridcode": "2",
                                "scale_max": "117.9",
                                "scale_min": "-77.0",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "11",
                                "gribleveltype": "6",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "273.10001",
                                "scale_min": "178.2",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "standard_name": "air_pressure",
                                "expires": "1615297200",
                                "units": "Pa",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "1",
                                "gribleveltype": "6",
                                "gribNumBits": "13",
                                "GRIBgridcode": "2",
                                "scale_max": "49360.0",
                                "scale_min": "6950.0",
                                "gribparam": "1",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "above_MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "103",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "44.900002",
                                "scale_min": "-42.799999",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "103",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "52.099998",
                                "scale_min": "-47.5",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "_mb_above_gnd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "30-0_mb_above_gnd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "34",
                                "gribleveltype": "116",
                                "gribNumBits": "9",
                                "GRIBgridcode": "2",
                                "scale_max": "21.9",
                                "scale_min": "-19.1",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "expires": "1615297200",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "33",
                                "gribleveltype": "116",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "24.299999",
                                "scale_min": "-27.200001",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "expires": "1615297200",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "11",
                                "gribleveltype": "116",
                                "gribNumBits": "10",
                                "GRIBgridcode": "2",
                                "scale_max": "314.39999",
                                "scale_min": "216.7",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity",
                                "standard_name": "relative_humidity",
                                "expires": "1615297200",
                                "units": "percent",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "52",
                                "gribleveltype": "116",
                                "gribNumBits": "7",
                                "GRIBgridcode": "2",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "process": " run",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "Diagnostic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Diagnostic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total_air_column": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_air_column",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PWAT2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PWAT2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water",
                                "standard_name": "atmosphere_mass_content_of_water_vapor",
                                "expires": "1615210800",
                                "units": "kg/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "54",
                                "gribleveltype": "200",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "86.800003",
                                "scale_min": "-8.0",
                                "gribparam": "54",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PWAT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CWORK": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CWORK",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Cloud work function",
                                "expires": "1615210800",
                                "units": "J/kg",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "146",
                                "gribleveltype": "200",
                                "gribNumBits": "12",
                                "missing_value": "9.99900026E20",
                                "scale_max": "3858.0",
                                "scale_min": "0.0",
                                "gribparam": "146",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CWORK",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "164",
                                        "gribleveltype": "200",
                                        "gribNumBits": "5",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "12.0",
                                        "scale_min": "-33.0",
                                        "gribparam": "164",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "165",
                                        "gribleveltype": "200",
                                        "gribNumBits": "8",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "160.0",
                                        "scale_min": "-131.0",
                                        "gribparam": "165",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "71",
                                "gribleveltype": "200",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            }
                        },
                        "top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "211",
                                    "gribleveltype": "8",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "423.0",
                                    "scale_min": "-3.0",
                                    "gribparam": "211",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "212",
                                    "gribleveltype": "8",
                                    "gribNumBits": "8",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "379.0",
                                    "scale_min": "56.0",
                                    "gribparam": "212",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "204",
                                    "gribleveltype": "8",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "563.0",
                                    "scale_min": "-4.0",
                                    "gribparam": "204",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DSWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "164",
                                        "gribleveltype": "8",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "37.0",
                                        "scale_min": "-321.0",
                                        "gribparam": "164",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "165",
                                        "gribleveltype": "8",
                                        "gribNumBits": "8",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "194.0",
                                        "scale_min": "-30.0",
                                        "gribparam": "165",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "clear_sky": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clear_sky",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "upward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "upward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "160",
                                        "gribleveltype": "8",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "404.0",
                                        "scale_min": "-3.0",
                                        "gribparam": "160",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSUSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "162",
                                        "gribleveltype": "8",
                                        "gribNumBits": "8",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "379.0",
                                        "scale_min": "58.0",
                                        "gribparam": "162",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSULF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "VDDSF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VDDSF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Visible diffuse downward solar flux",
                                "expires": "1615210800",
                                "units": "W/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "167",
                                "gribleveltype": "1",
                                "gribNumBits": "9",
                                "missing_value": "9.99900026E20",
                                "scale_max": "301.0",
                                "scale_min": "-2.0",
                                "gribparam": "167",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VDDSF",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "VBDSF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VBDSF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Visible beam downward solar flux",
                                "expires": "1615210800",
                                "units": "W/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "166",
                                "gribleveltype": "1",
                                "gribNumBits": "8",
                                "missing_value": "9.99900026E20",
                                "scale_max": "224.0",
                                "scale_min": "-46.0",
                                "gribparam": "166",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VBDSF",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "VGWD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V-GWD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional gravity wave stress",
                                "expires": "1615210800",
                                "units": "Pa",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "148",
                                "gribleveltype": "1",
                                "gribNumBits": "13",
                                "missing_value": "9.99900026E20",
                                "scale_max": "12.146",
                                "scale_min": "-5.9860001",
                                "gribparam": "148",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "V-GWD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "standard_name": "surface_net_upward_shortwave_flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "211",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "426.0",
                                    "scale_min": "-16.0",
                                    "gribparam": "211",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "standard_name": "surface_net_upward_longwave_flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "212",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "572.0",
                                    "scale_min": "44.0",
                                    "gribparam": "212",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "UGWD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "U-GWD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal gravity wave stress",
                                "expires": "1615210800",
                                "units": "Pa",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "147",
                                "gribleveltype": "1",
                                "gribNumBits": "13",
                                "missing_value": "9.99900026E20",
                                "scale_max": "12.948",
                                "scale_min": "-13.807",
                                "gribparam": "147",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "U-GWD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "standard_name": "surface_temperature",
                                "expires": "1615210800",
                                "units": "Kelvin_scale",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "11",
                                "gribleveltype": "1",
                                "gribNumBits": "11",
                                "missing_value": "9.99900026E20",
                                "scale_max": "322.0",
                                "scale_min": "154.89999",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional momentum flux",
                                "expires": "1615210800",
                                "units": "Pa",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "125",
                                "gribleveltype": "1",
                                "gribNumBits": "11",
                                "missing_value": "9.99900026E20",
                                "scale_max": "4.152",
                                "scale_min": "-3.5480001",
                                "gribparam": "125",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VFLX",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal momentum flux",
                                "expires": "1615210800",
                                "units": "N/m2",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "missing_value": "9.99900026E20",
                                "gribvariable": "124",
                                "gribleveltype": "1",
                                "gribNumBits": "11",
                                "GRIBgridcode": "2",
                                "scale_max": "3.4979999",
                                "scale_min": "-3.7579999",
                                "gribparam": "124",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UFLX",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "snow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sublimation": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sublimation",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "standard_name": "surface_snow_sublimation_heat_flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "230",
                                        "gribleveltype": "1",
                                        "gribNumBits": "8",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "520.0",
                                        "scale_min": "-151.0",
                                        "gribparam": "230",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "SNOEV",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "rate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "rate",
                                    "standard_name": "snowfall_flux",
                                    "expires": "1615210800",
                                    "units": "kg/m2/s",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "64",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.001029",
                                    "scale_min": "0.0",
                                    "gribparam": "64",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SRWEQ",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "melt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "melt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "standard_name": "surface_snow_melt_heat_flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "229",
                                        "gribleveltype": "1",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "693.0",
                                        "scale_min": "0.0",
                                        "gribparam": "229",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "SNOHF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "depth": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depth",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Accum. snow",
                                    "standard_name": "snowfall_amount",
                                    "expires": "1615210800",
                                    "units": "kg/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "65",
                                    "gribleveltype": "1",
                                    "gribNumBits": "16",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "55010.0",
                                    "scale_min": "0.0",
                                    "gribparam": "65",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "WEASD",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "SFCR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SFCR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface roughness",
                                "standard_name": "surface_roughness_length",
                                "expires": "1615210800",
                                "units": "m",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "83",
                                "gribleveltype": "1",
                                "gribNumBits": "8",
                                "missing_value": "9.99900026E20",
                                "scale_max": "0.00647",
                                "scale_min": "0.0",
                                "gribparam": "83",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SFCR",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "sensible": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sensible",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible heat flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "122",
                                    "gribleveltype": "1",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "2466.0",
                                    "scale_min": "-809.0",
                                    "gribparam": "122",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SHTFL",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            },
                            "runoff": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runoff",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Runoff",
                                "standard_name": "surface_runoff_amount",
                                "expires": "1615210800",
                                "units": "kg/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "90",
                                "gribleveltype": "1",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "46.200001",
                                "scale_min": "0.0",
                                "gribparam": "90",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RUNOF",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "standard_name": "surface_air_pressure",
                                "expires": "1615210800",
                                "units": "N/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "1",
                                "gribleveltype": "1",
                                "gribNumBits": "13",
                                "missing_value": "9.99900026E20",
                                "scale_max": "109250.0",
                                "scale_min": "48340.0",
                                "gribparam": "1",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate",
                                "standard_name": "precipitation_flux",
                                "expires": "1615210800",
                                "units": "kg/m2/s",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "59",
                                "gribleveltype": "1",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "0.002473",
                                "scale_min": "0.0",
                                "gribparam": "59",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRATE",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "potential": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "potential",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "evap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "evaporation",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "145",
                                    "gribleveltype": "1",
                                    "gribNumBits": "11",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "3358.0",
                                    "scale_min": "-152.0",
                                    "gribparam": "145",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PEVPR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "net": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "net",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "111",
                                    "grib_name": "NSWRS",
                                    "units": "W/m2",
                                    "missing_value": "NaN",
                                    "expires": "1615210800",
                                    "file_missing_value": "9.99900026E20",
                                    "long_name": "solar flux",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "211",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "112",
                                    "grib_name": "NLWRS",
                                    "units": "W/m2",
                                    "missing_value": "NaN",
                                    "expires": "1615210800",
                                    "file_missing_value": "9.99900026E20",
                                    "long_name": "longwave flux",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "212",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "NDDSF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDDSF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near IR diffuse downward solar flux",
                                "expires": "1615210800",
                                "units": "W/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "169",
                                "gribleveltype": "1",
                                "gribNumBits": "9",
                                "missing_value": "9.99900026E20",
                                "scale_max": "305.0",
                                "scale_min": "-61.0",
                                "gribparam": "169",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "NDDSF",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "NBDSF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NBDSF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Near IR beam downward solar flux",
                                "expires": "1615210800",
                                "units": "W/m2",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "168",
                                "gribleveltype": "1",
                                "gribNumBits": "9",
                                "missing_value": "9.99900026E20",
                                "scale_max": "326.0",
                                "scale_min": "-70.0",
                                "gribparam": "168",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "NBDSF",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "latent": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "latent",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Latent heat flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "121",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "1537.0",
                                    "scale_min": "-302.0",
                                    "gribparam": "121",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "LHTFL",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            },
                            "LAND": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "LAND",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Land-sea mask",
                                "standard_name": "land_binary_mask",
                                "expires": "1615210800",
                                "units": "1=land; 0=sea",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "81",
                                "gribleveltype": "1",
                                "gribNumBits": "1",
                                "missing_value": "9.99900026E20",
                                "scale_max": "1.0",
                                "scale_min": "0.0",
                                "gribparam": "81",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "LAND",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "ICEC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ICEC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice concentration",
                                "expires": "1615210800",
                                "units": "ice=1; no ice=0",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "91",
                                "gribleveltype": "1",
                                "gribNumBits": "1",
                                "missing_value": "9.99900026E20",
                                "scale_max": "1.0",
                                "scale_min": "0.0",
                                "gribparam": "91",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "ICEC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground heat flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "155",
                                    "gribleveltype": "1",
                                    "gribNumBits": "8",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "125.0",
                                    "scale_min": "-119.0",
                                    "gribparam": "155",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "GFLUX",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "standard_name": "surface_net_downward_shortwave_flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "204",
                                    "gribleveltype": "1",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "574.0",
                                    "scale_min": "-4.0",
                                    "gribparam": "204",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DSWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "standard_name": "surface_net_downward_longwave_flux",
                                    "expires": "1615210800",
                                    "units": "W/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "205",
                                    "gribleveltype": "1",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "497.0",
                                    "scale_min": "-1.0",
                                    "gribparam": "205",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DLWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "convective": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convective",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cprate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cprate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective precip. rate",
                                    "standard_name": "convective_precipitation_flux",
                                    "expires": "1615210800",
                                    "units": "kg/m2/s",
                                    "PTVersion": "2",
                                    "gribvariable": "214",
                                    "gribleveltype": "1",
                                    "gribNumBits": "10",
                                    "subcenter": "NCEP Ensemble Products",
                                    "scale_max": "0.00136",
                                    "scale_min": "0.0",
                                    "gribparam": "214",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "CPRAT",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            },
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "164",
                                        "gribleveltype": "1",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "39.0",
                                        "scale_min": "-307.0",
                                        "gribparam": "164",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "165",
                                        "gribleveltype": "1",
                                        "gribNumBits": "7",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "110.0",
                                        "scale_min": "-24.0",
                                        "gribparam": "165",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "clear_sky": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clear_sky",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "upward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "upward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "standard_name": "surface_net_upward_shortwave_flux",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "160",
                                        "gribleveltype": "1",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "410.0",
                                        "scale_min": "-3.0",
                                        "gribparam": "160",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSUSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "downward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "downward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "standard_name": "surface_net_downward_shortwave_flux_assuming_clear_sky",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "161",
                                        "gribleveltype": "1",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "541.0",
                                        "scale_min": "-4.0",
                                        "gribparam": "161",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSDSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "standard_name": "surface_net_downward_longwave_flux_assuming_clear_sky",
                                        "expires": "1615210800",
                                        "units": "W/m2",
                                        "PTVersion": "2",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribvariable": "163",
                                        "gribleveltype": "1",
                                        "gribNumBits": "9",
                                        "missing_value": "9.99900026E20",
                                        "scale_max": "478.0",
                                        "scale_min": "19.0",
                                        "gribparam": "163",
                                        "process": " run",
                                        "PDS_TimeRange": "3",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSDLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "soil": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soil",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "soil_temperature",
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "11",
                                "gribleveltype": "111",
                                "gribNumBits": "11",
                                "missing_value": "9.99900026E20",
                                "scale_max": "301.10001",
                                "scale_min": "179.8",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "middlecloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "middle-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "standard_name": "air_temperature",
                                    "expires": "1615210800",
                                    "units": "Kelvin_scale",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "11",
                                    "gribleveltype": "223",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "284.5",
                                    "scale_min": "215.5",
                                    "gribparam": "11",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "223",
                                    "gribNumBits": "5",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "72.0",
                                    "scale_min": "32.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "N/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "223",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "71830.0",
                                    "scale_min": "32150.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RH-type cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "225",
                                "gribleveltype": "224",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "71",
                                "gribleveltype": "224",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective cloud cover",
                                "standard_name": "convective_cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "72",
                                "gribleveltype": "224",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "77.0",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "bottom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "222",
                                    "gribNumBits": "5",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "77.0",
                                    "scale_min": "37.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "N/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "222",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "76920.0",
                                    "scale_min": "37440.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "lowcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "low-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "standard_name": "air_temperature",
                                    "expires": "1615210800",
                                    "units": "Kelvin_scale",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "11",
                                    "gribleveltype": "213",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "306.89999",
                                    "scale_min": "227.39999",
                                    "gribparam": "11",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "213",
                                    "gribNumBits": "5",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "92.0",
                                    "scale_min": "61.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "N/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "213",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "92490.0",
                                    "scale_min": "61080.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RH-type cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "225",
                                "gribleveltype": "214",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "71",
                                "gribleveltype": "214",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective cloud cover",
                                "standard_name": "convective_cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "72",
                                "gribleveltype": "214",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "77.0",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "bottom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "212",
                                    "gribNumBits": "5",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "103.0",
                                    "scale_min": "66.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "N/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "212",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "102300.0",
                                    "scale_min": "65920.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "highcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "high-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "standard_name": "air_temperature",
                                    "expires": "1615210800",
                                    "units": "Kelvin_scale",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "11",
                                    "gribleveltype": "233",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "252.39999",
                                    "scale_min": "184.89999",
                                    "gribparam": "11",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "233",
                                    "gribNumBits": "6",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "47.0",
                                    "scale_min": "9.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "N/m2",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "233",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "47420.0",
                                    "scale_min": "8720.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "RH-type cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "225",
                                "gribleveltype": "234",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "71",
                                "gribleveltype": "234",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Convective cloud cover",
                                "standard_name": "convective_cloud_area_fraction",
                                "expires": "1615210800",
                                "units": "percent",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "72",
                                "gribleveltype": "234",
                                "gribNumBits": "7",
                                "missing_value": "9.99900026E20",
                                "scale_max": "92.0",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "process": " run",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "bottom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bottom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SGLYR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGLYR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nearby model level",
                                    "standard_name": "model_level_number",
                                    "expires": "1615210800",
                                    "units": "unitless",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "175",
                                    "gribleveltype": "232",
                                    "gribNumBits": "6",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "53.0",
                                    "scale_min": "11.0",
                                    "gribparam": "175",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SGLYR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "standard_name": "air_pressure",
                                    "expires": "1615210800",
                                    "units": "Pa",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "1",
                                    "gribleveltype": "232",
                                    "gribNumBits": "12",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "52530.0",
                                    "scale_min": "11360.0",
                                    "gribparam": "1",
                                    "process": " run",
                                    "PDS_TimeRange": "3",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PRES",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "northward_wind",
                                "long_name": "meridional wind",
                                "units": "m/s",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "34",
                                "gribleveltype": "105",
                                "gribNumBits": "8",
                                "missing_value": "9.99900026E20",
                                "scale_max": "27.6",
                                "scale_min": "-30.700001",
                                "gribparam": "34",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "eastward_wind",
                                "long_name": "zonal wind",
                                "units": "m/s",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "33",
                                "gribleveltype": "105",
                                "gribNumBits": "8",
                                "missing_value": "9.99900026E20",
                                "scale_max": "28.6",
                                "scale_min": "-29.4",
                                "gribparam": "33",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "air_temperature",
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "11",
                                "gribleveltype": "105",
                                "gribNumBits": "10",
                                "missing_value": "9.99900026E20",
                                "scale_max": "318.60001",
                                "scale_min": "165.89999",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "specific_humidity",
                                "long_name": "Specific humidity",
                                "units": "unitless",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "51",
                                "gribleveltype": "105",
                                "gribNumBits": "8",
                                "missing_value": "9.99900026E20",
                                "scale_max": "0.0284",
                                "scale_min": "0.0",
                                "gribparam": "51",
                                "process": " run",
                                "PDS_TimeRange": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                "pointwidth": "0.0"
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "air_temperature",
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "expires": "1615210800",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "16",
                                    "gribleveltype": "105",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "311.60001",
                                    "scale_min": "161.60001",
                                    "gribparam": "16",
                                    "process": " run",
                                    "PDS_TimeRange": "2",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMIN",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "air_temperature",
                                    "long_name": "Temperature",
                                    "units": "Kelvin_scale",
                                    "expires": "1615210800",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "15",
                                    "gribleveltype": "105",
                                    "gribNumBits": "10",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "356.10001",
                                    "scale_min": "178.0",
                                    "gribparam": "15",
                                    "process": " run",
                                    "PDS_TimeRange": "2",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMAX",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            }
                        },
                        "_cm_down": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0-10_cm_down",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "soil_temperature",
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1615210800",
                                "PTVersion": "2",
                                "subcenter": "NCEP Ensemble Products",
                                "gribvariable": "11",
                                "gribleveltype": "112",
                                "gribNumBits": "11",
                                "missing_value": "9.99900026E20",
                                "scale_max": "317.29999",
                                "scale_min": "200.0",
                                "gribparam": "11",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "soil": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soil",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "moisture": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "moisture",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "moisture",
                                    "units": "unitless",
                                    "expires": "1615210800",
                                    "PTVersion": "2",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribvariable": "144",
                                    "gribleveltype": "112",
                                    "gribNumBits": "9",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.434",
                                    "scale_min": "0.0",
                                    "gribparam": "144",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SOILW",
                                    "calendar": "standard",
                                    "history": "T:  0000 1 Apr 2002 to 0000 5 Mar 2021 appended from datestring",
                                    "pointwidth": "0.0"
                                }
                            }
                        }
                    },
                    "Z1_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "sigma layer"
                    },
                    "Z1_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "sigma layer"
                    },
                    "Z1_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "sigma layer"
                    },
                    "Z_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "sigma",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P1"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615297200",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "Z_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m-above_MSL",
                        "gridtype": "0",
                        "long_name": "Height"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615297200",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Z_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm_down",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Depth"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Z1_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "Depth"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615210800",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "Z1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "Depth"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "long_name": "Latitude",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1948-01-01 12:00:00",
                        "gridtype": "0",
                        "calendar": "standard",
                        "expires": "1615210800",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/DAILY"
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Intrinsictotal_air_columnexpires": "1617408000",
                        "Intrinsicsurfaceexpires": "1617408000",
                        "IntrinsicPressureLevelexpires": "1617408000",
                        "IntrinsicMSLlong_name": "Mean Sea Level",
                        "IntrinsicMSLexpires": "1617408000",
                        "Intrinsicreferences": "Kalnay_etal1996",
                        "Intrinsicexpires": "1617408000",
                        "Intrinsicdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP-NCAR/.CDAS-1/.MONTHLY/.Intrinsic.dataset_documentation.html",
                        "Diagnostictotal_air_columncloud_forcingnetexpires": "1617408000",
                        "Diagnostictotal_air_columncloud_forcingexpires": "1617408000",
                        "Diagnostictotal_air_columnexpires": "1617408000",
                        "Diagnostictopupwardexpires": "1617408000",
                        "Diagnostictopdownwardexpires": "1617408000",
                        "Diagnostictopcloud_forcingnetexpires": "1617408000",
                        "Diagnostictopcloud_forcingexpires": "1617408000",
                        "Diagnostictopclear_skyupwardexpires": "1617408000",
                        "Diagnostictopclear_skyexpires": "1617408000",
                        "Diagnostictopexpires": "1617408000",
                        "Diagnosticsurfaceupwardexpires": "1617408000",
                        "Diagnosticsurfacesnowsublimationexpires": "1617408000",
                        "Diagnosticsurfacesnowmeltexpires": "1617408000",
                        "Diagnosticsurfacesnowexpires": "1617408000",
                        "Diagnosticsurfacesensibleexpires": "1617408000",
                        "Diagnosticsurfacepotentialexpires": "1617408000",
                        "Diagnosticsurfacenetexpires": "1617408000",
                        "Diagnosticsurfacelatentexpires": "1617408000",
                        "Diagnosticsurfacegroundexpires": "1617408000",
                        "Diagnosticsurfacedownwardexpires": "1617408000",
                        "Diagnosticsurfaceconvectiveexpires": "1617408000",
                        "Diagnosticsurfacecloud_forcingnetexpires": "1617408000",
                        "Diagnosticsurfacecloud_forcingexpires": "1617408000",
                        "Diagnosticsurfaceclear_skyupwardexpires": "1617408000",
                        "Diagnosticsurfaceclear_skydownwardexpires": "1617408000",
                        "Diagnosticsurfaceclear_skyexpires": "1617408000",
                        "Diagnosticsurfaceexpires": "1617408000",
                        "Diagnosticsoilexpires": "1617408000",
                        "Diagnosticmiddlecloudtopexpires": "1617408000",
                        "Diagnosticmiddlecloudexpires": "1617408000",
                        "Diagnosticlowcloudtopexpires": "1617408000",
                        "Diagnosticlowcloudexpires": "1617408000",
                        "Diagnostichighcloudtopexpires": "1617408000",
                        "Diagnostichighcloudexpires": "1617408000",
                        "Diagnosticabove_groundminimumexpires": "1617408000",
                        "Diagnosticabove_groundmaximumexpires": "1617408000",
                        "Diagnosticabove_groundexpires": "1617408000",
                        "Diagnostic10200_cm_downsoilexpires": "1617408000",
                        "Diagnostic10200_cm_downexpires": "1617408000",
                        "Diagnostic010_cm_downsoilexpires": "1617408000",
                        "Diagnostic010_cm_downexpires": "1617408000",
                        "Diagnosticreferences": "Kalnay_etal1996",
                        "Diagnosticexpires": "1617408000",
                        "Diagnosticdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP-NCAR/.CDAS-1/.MONTHLY/.Diagnostic.dataset_documentation.html",
                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP-NCAR/.CDAS-1/.MONTHLY/.griblist.html",
                        "expires": "1617408000",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total_air_column": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_air_column",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PWAT": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PWAT",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitable water",
                                "expires": "1617408000",
                                "units": "kg m-2",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "54",
                                "gribleveltype": "200",
                                "scale_max": "68.199997",
                                "scale_min": "-3.98",
                                "gribparam": "54",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PWAT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "1",
                                "gribleveltype": "1",
                                "scale_max": "109040.0",
                                "scale_min": "49590.0",
                                "gribparam": "1",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure vertical velocity",
                                "units": "Pa/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "39",
                                "gribleveltype": "100",
                                "scale_max": "0.7757",
                                "scale_min": "-0.4973",
                                "gribparam": "39",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VVEL",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "vtemp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vtemp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Virtual temperature",
                                "units": "Kelvin_scale",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "12",
                                "gribleveltype": "100",
                                "scale_max": "321.17999",
                                "scale_min": "202.48",
                                "gribparam": "12",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VTMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "vpot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Velocity potential",
                                "expires": "1617408000",
                                "units": "m2/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "36",
                                "gribleveltype": "100",
                                "scale_max": "25519200.0",
                                "scale_min": "-32949800.0",
                                "gribparam": "36",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VPOT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "expires": "1617408000",
                                "units": "m/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "scale_max": "66.379997",
                                "scale_min": "-66.660004",
                                "gribparam": "34",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "12",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "expires": "1617408000",
                                "units": "m/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "scale_max": "124.4",
                                "scale_min": "-66.379997",
                                "gribparam": "33",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "12",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "expires": "1617408000",
                                "units": "Kelvin_scale",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "scale_max": "316.38",
                                "scale_min": "164.5",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative humidity",
                                "units": "percent",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "52",
                                "gribleveltype": "100",
                                "scale_max": "100.0",
                                "scale_min": "0.0",
                                "gribparam": "52",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "10",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "relv": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "relv",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative vorticity",
                                "expires": "1617408000",
                                "units": "1/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "43",
                                "gribleveltype": "100",
                                "scale_max": "1.42160003E-04",
                                "scale_min": "-1.23299993E-04",
                                "gribparam": "43",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RELV",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "reld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Relative divergence",
                                "expires": "1617408000",
                                "units": "1/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "44",
                                "gribleveltype": "100",
                                "scale_max": "4.72100000E-05",
                                "scale_min": "-5.16200016E-05",
                                "gribparam": "44",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RELD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity",
                                "units": "unitless",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "scale_max": "0.041017",
                                "scale_min": "0.0",
                                "gribparam": "51",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "15",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "psi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Stream function",
                                "expires": "1617408000",
                                "units": "m2/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "35",
                                "gribleveltype": "100",
                                "scale_max": "2.82165888E08",
                                "scale_min": "-1.86532704E08",
                                "gribparam": "35",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "STRM",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "expires": "1617408000",
                                "units": "gpm",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "scale_max": "32321.5",
                                "scale_min": "-334.29999",
                                "gribparam": "7",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "12",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBVW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBVW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. v and omega",
                                "units": "m/s Pa/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "191",
                                "gribleveltype": "100",
                                "scale_max": "4.1022501",
                                "scale_min": "-5.1792898",
                                "gribparam": "191",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBVW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBVQ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBVQ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. v and specific hum",
                                "units": "m/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "193",
                                "gribleveltype": "100",
                                "scale_max": "0.0373494",
                                "scale_min": "-0.0282679",
                                "gribparam": "193",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBVQ",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBUW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBUW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. u and omega",
                                "units": "m/s Pa/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "190",
                                "gribleveltype": "100",
                                "scale_max": "4.3438802",
                                "scale_min": "-3.059",
                                "gribparam": "190",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBUW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBUQ": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBUQ",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. u and specific hum",
                                "units": "m/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "192",
                                "gribleveltype": "100",
                                "scale_max": "0.026067",
                                "scale_min": "-0.0257932",
                                "gribparam": "192",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBUQ",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBTZW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBTZW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. u and T",
                                "expires": "1617408000",
                                "units": "K m/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "197",
                                "gribleveltype": "100",
                                "scale_max": "688.99103",
                                "scale_min": "-790.64001",
                                "gribparam": "197",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBTZW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBTW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBTW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. T and omega",
                                "units": "K Pa/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "194",
                                "gribleveltype": "100",
                                "scale_max": "1.3482701",
                                "scale_min": "-3.27823",
                                "gribparam": "194",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBTW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBTMW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBTMW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. v and T",
                                "expires": "1617408000",
                                "units": "K m/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "198",
                                "gribleveltype": "100",
                                "scale_max": "604.81",
                                "scale_min": "-494.73901",
                                "gribparam": "198",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBTMW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBQW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBQW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. spec. hum and omega",
                                "units": "Pa/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "195",
                                "gribleveltype": "100",
                                "scale_max": "8.36261024E-04",
                                "scale_min": "-0.002593802",
                                "gribparam": "195",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBQW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CBMZW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CBMZW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Covar. v and u",
                                "expires": "1617408000",
                                "units": "m2/s2",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "196",
                                "gribleveltype": "100",
                                "scale_max": "1500.91",
                                "scale_min": "-1040.568",
                                "gribparam": "196",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CBMZW",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "1",
                                "gribleveltype": "102",
                                "scale_max": "108300.0",
                                "scale_min": "95947.0",
                                "gribparam": "1",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "GRIBgridcode": "2",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "Diagnostic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Diagnostic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total_air_column": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_air_column",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "164",
                                        "gribleveltype": "200",
                                        "scale_max": "7.0",
                                        "scale_min": "-19.1",
                                        "gribparam": "164",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "8",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "165",
                                        "gribleveltype": "200",
                                        "scale_max": "97.0",
                                        "scale_min": "-64.300003",
                                        "gribparam": "165",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "expires": "1617408000",
                                "units": "percent",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "71",
                                "gribleveltype": "200",
                                "scale_max": "99.400002",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "10",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "211",
                                    "gribleveltype": "8",
                                    "scale_max": "385.5",
                                    "scale_min": "-0.2",
                                    "gribparam": "211",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "212",
                                    "gribleveltype": "8",
                                    "scale_max": "353.0",
                                    "scale_min": "74.400002",
                                    "gribparam": "212",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "11",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "204",
                                    "gribleveltype": "8",
                                    "scale_max": "552.29999",
                                    "scale_min": "-0.3",
                                    "gribparam": "204",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "13",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DSWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "164",
                                        "gribleveltype": "8",
                                        "scale_max": "6.0999999",
                                        "scale_min": "-223.2",
                                        "gribparam": "164",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "165",
                                        "gribleveltype": "8",
                                        "scale_max": "126.1",
                                        "scale_min": "-10.8",
                                        "gribparam": "165",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "clear_sky": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clear_sky",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "upward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "upward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "160",
                                        "gribleveltype": "8",
                                        "scale_max": "386.29999",
                                        "scale_min": "-0.104",
                                        "gribparam": "160",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "12",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSUSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "162",
                                        "gribleveltype": "8",
                                        "scale_max": "353.5",
                                        "scale_min": "74.199997",
                                        "gribparam": "162",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSULF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "VGWD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V-GWD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional gravity wave stress",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "148",
                                "gribleveltype": "1",
                                "scale_max": "4.3457999",
                                "scale_min": "-1.9403",
                                "gribparam": "148",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "15",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "V-GWD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "upward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "upward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "211",
                                    "gribleveltype": "1",
                                    "scale_max": "398.39999",
                                    "scale_min": "-0.106",
                                    "gribparam": "211",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "USWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "212",
                                    "gribleveltype": "1",
                                    "scale_max": "554.70001",
                                    "scale_min": "67.0",
                                    "gribparam": "212",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "ULWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "UGWD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "U-GWD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal gravity wave stress",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "147",
                                "gribleveltype": "1",
                                "scale_max": "4.6689",
                                "scale_min": "-2.4251001",
                                "gribparam": "147",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "15",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "U-GWD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "expires": "1617408000",
                                "units": "Kelvin_scale",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "1",
                                "scale_max": "315.48001",
                                "scale_min": "180.16",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Meridional momentum flux",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "125",
                                "gribleveltype": "1",
                                "scale_max": "0.9143",
                                "scale_min": "-1.092",
                                "gribparam": "125",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VFLX",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Zonal momentum flux",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "124",
                                "gribleveltype": "1",
                                "scale_max": "0.9931",
                                "scale_min": "-1.1216",
                                "gribparam": "124",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UFLX",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "snow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sublimation": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sublimation",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "230",
                                        "gribleveltype": "1",
                                        "scale_max": "238.2",
                                        "scale_min": "-43.799999",
                                        "gribparam": "230",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "SNOEV",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "rate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "rate",
                                    "expires": "1617408000",
                                    "units": "kg/m2/s",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "64",
                                    "gribleveltype": "1",
                                    "scale_max": "3.45700013E-04",
                                    "scale_min": "0.0",
                                    "gribparam": "64",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "11",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SRWEQ",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "melt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "melt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "229",
                                        "gribleveltype": "1",
                                        "scale_max": "294.60001",
                                        "scale_min": "0.0",
                                        "gribparam": "229",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "SNOHF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "depth": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depth",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Accum. snow",
                                    "expires": "1617408000",
                                    "units": "kg/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "65",
                                    "gribleveltype": "1",
                                    "scale_max": "55003.199",
                                    "scale_min": "0.0",
                                    "gribparam": "65",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "16",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "WEASD",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "sensible": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sensible",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sensible heat flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "122",
                                    "gribleveltype": "1",
                                    "scale_max": "771.79999",
                                    "scale_min": "-319.5",
                                    "gribparam": "122",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "13",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SHTFL",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "runoff": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runoff",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Runoff",
                                "expires": "1617408000",
                                "units": "kg/m2",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "90",
                                "gribleveltype": "1",
                                "missing_value": "9.99900026E20",
                                "scale_max": "12.46",
                                "scale_min": "0.0",
                                "gribparam": "90",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "7",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RUNOF",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Pressure",
                                "expires": "1617408000",
                                "units": "Pa",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "1",
                                "gribleveltype": "1",
                                "scale_max": "108423.0",
                                "scale_min": "48932.0",
                                "gribparam": "1",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "16",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation rate",
                                "expires": "1617408000",
                                "units": "kg/m2/s",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "59",
                                "gribleveltype": "1",
                                "scale_max": "5.89100004E-04",
                                "scale_min": "0.0",
                                "gribparam": "59",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "12",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRATE",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "potential": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "potential",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "evap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "evaporation",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "145",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "2073.1001",
                                    "scale_min": "-45.5",
                                    "gribparam": "145",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "15",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "PEVPR",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "net": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "net",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "111",
                                    "gribleveltype": "1",
                                    "scale_max": "0.3",
                                    "scale_min": "-342.70001",
                                    "gribparam": "111",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "NSWRS",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "112",
                                    "gribleveltype": "1",
                                    "scale_max": "191.10001",
                                    "scale_min": "-20.1",
                                    "gribparam": "112",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "11",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "NLWRS",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "latent": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "latent",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Latent heat flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "121",
                                    "gribleveltype": "1",
                                    "scale_max": "544.29999",
                                    "scale_min": "-52.5",
                                    "gribparam": "121",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "LHTFL",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "LAND": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "LAND",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Land-sea mask",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "0",
                                "PTVersion": "2",
                                "gribvariable": "81",
                                "gribleveltype": "1",
                                "scale_max": "1.0",
                                "scale_min": "0.0",
                                "gribparam": "81",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "4",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "LAND",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "ICEC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ICEC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Ice concentration",
                                "expires": "1617408000",
                                "units": "ice=1;no ice=0",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "91",
                                "gribleveltype": "1",
                                "scale_max": "1.0",
                                "scale_min": "0.0",
                                "gribparam": "91",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "4",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "ICEC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heat_flux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heat_flux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ground heat flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "155",
                                    "gribleveltype": "1",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "236.5",
                                    "scale_min": "-50.400002",
                                    "gribparam": "155",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "9",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "GFLUX",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "downward": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "downward",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "solr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "solr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "solar flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "204",
                                    "gribleveltype": "1",
                                    "scale_max": "535.70001",
                                    "scale_min": "-0.2",
                                    "gribparam": "204",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "13",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DSWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "longwave flux",
                                    "expires": "1617408000",
                                    "units": "W/m2",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "205",
                                    "gribleveltype": "1",
                                    "scale_max": "468.10001",
                                    "scale_min": "10.92",
                                    "gribparam": "205",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "DLWRF",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "convective": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "convective",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cprate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cprate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Convective precip. rate",
                                    "expires": "1617408000",
                                    "units": "kg/m2/s",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "214",
                                    "gribleveltype": "1",
                                    "scale_max": "4.16800001E-04",
                                    "scale_min": "0.0",
                                    "gribparam": "214",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "CPRAT",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "cloud_forcing": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cloud_forcing",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "164",
                                        "gribleveltype": "1",
                                        "scale_max": "13.8",
                                        "scale_min": "-211.3",
                                        "gribparam": "164",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "11",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "165",
                                        "gribleveltype": "1",
                                        "scale_max": "74.400002",
                                        "scale_min": "-15.6",
                                        "gribparam": "165",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "10",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CFNLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "clear_sky": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clear_sky",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "upward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "upward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "160",
                                        "gribleveltype": "1",
                                        "scale_max": "393.79999",
                                        "scale_min": "-0.106",
                                        "gribparam": "160",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "12",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSUSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "downward": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "downward",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "solr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "solr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "161",
                                        "gribleveltype": "1",
                                        "scale_max": "519.5",
                                        "scale_min": "-0.2",
                                        "gribparam": "161",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "13",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSDSF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longwave flux",
                                        "expires": "1617408000",
                                        "units": "W/m2",
                                        "process": " run",
                                        "PDS_TimeRange": "113",
                                        "PTVersion": "2",
                                        "gribvariable": "163",
                                        "gribleveltype": "1",
                                        "scale_max": "451.89999",
                                        "scale_min": "24.299999",
                                        "gribparam": "163",
                                        "subcenter": "NCEP Ensemble Products",
                                        "gribNumBits": "12",
                                        "gribfield": "1",
                                        "center": "US Weather Service - National Met. Center",
                                        "grib_name": "CSDLF",
                                        "calendar": "standard",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "soil": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soil",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "111",
                                "missing_value": "9.99900026E20",
                                "scale_max": "301.10001",
                                "scale_min": "179.8",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "middlecloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "middle-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "expires": "1617408000",
                                    "units": "Kelvin_scale",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "11",
                                    "gribleveltype": "223",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "284.85001",
                                    "scale_min": "108.3",
                                    "gribparam": "11",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "14",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "RH-type cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "225",
                                "gribleveltype": "224",
                                "scale_max": "97.449997",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "expires": "1617408000",
                                "units": "percent",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "71",
                                "gribleveltype": "224",
                                "scale_max": "96.800003",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "10",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "Convective cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "72",
                                "gribleveltype": "224",
                                "scale_max": "57.799999",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "9",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "lowcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "low-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "expires": "1617408000",
                                    "units": "Kelvin_scale",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "11",
                                    "gribleveltype": "213",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "305.70999",
                                    "scale_min": "117.5",
                                    "gribparam": "11",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "14",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "RH-type cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "225",
                                "gribleveltype": "214",
                                "scale_max": "90.300003",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "expires": "1617408000",
                                "units": "percent",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "71",
                                "gribleveltype": "214",
                                "scale_max": "93.900002",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "10",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "Convective cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "72",
                                "gribleveltype": "214",
                                "scale_max": "57.799999",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "9",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "highcloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "high-cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "expires": "1617408000",
                                    "units": "Kelvin_scale",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "11",
                                    "gribleveltype": "233",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "251.004",
                                    "scale_min": "93.699997",
                                    "gribparam": "11",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "14",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMP",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "RHCLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RHCLD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "RH-type cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "225",
                                "gribleveltype": "234",
                                "scale_max": "85.870003",
                                "scale_min": "0.0",
                                "gribparam": "225",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "13",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RHCLD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "cloud cover",
                                "expires": "1617408000",
                                "units": "percent",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "71",
                                "gribleveltype": "234",
                                "scale_max": "84.5",
                                "scale_min": "0.0",
                                "gribparam": "71",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "10",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TCDC",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "CDCON": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CDCON",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "Convective cloud cover",
                                "expires": "1617408000",
                                "process": "181",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "72",
                                "gribleveltype": "234",
                                "scale_max": "60.700001",
                                "scale_min": "0.0",
                                "gribparam": "72",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "9",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "CDCON",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "meridional wind",
                                "units": "m/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "34",
                                "gribleveltype": "105",
                                "scale_max": "14.94",
                                "scale_min": "-13.05",
                                "gribparam": "34",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "11",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "zonal wind",
                                "units": "m/s",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "33",
                                "gribleveltype": "105",
                                "scale_max": "14.45",
                                "scale_min": "-13.78",
                                "gribparam": "33",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "11",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "expires": "1617408000",
                                "units": "Kelvin_scale",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "105",
                                "scale_max": "313.29999",
                                "scale_min": "187.45",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity",
                                "expires": "1617408000",
                                "units": "unitless",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "51",
                                "gribleveltype": "105",
                                "scale_max": "0.0257",
                                "scale_min": "0.0",
                                "gribparam": "51",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "12",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "expires": "1617408000",
                                    "units": "Kelvin_scale",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "16",
                                    "gribleveltype": "105",
                                    "scale_max": "308.60999",
                                    "scale_min": "182.95",
                                    "gribparam": "16",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "14",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMIN",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature",
                                    "expires": "1617408000",
                                    "units": "Kelvin_scale",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "15",
                                    "gribleveltype": "105",
                                    "scale_max": "325.03",
                                    "scale_min": "192.96001",
                                    "gribparam": "15",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "14",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMAX",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "_cm_down": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0-10_cm_down",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1617408000",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "112",
                                "missing_value": "9.99900026E20",
                                "scale_max": "314.54001",
                                "scale_min": "199.9838",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "gribNumBits": "14",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "soil": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "soil",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "moisture": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "moisture",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "moisture",
                                    "units": "unitless",
                                    "expires": "1617408000",
                                    "process": " run",
                                    "PDS_TimeRange": "113",
                                    "PTVersion": "2",
                                    "gribvariable": "144",
                                    "gribleveltype": "112",
                                    "missing_value": "9.99900026E20",
                                    "scale_max": "0.4284",
                                    "scale_min": "0.09999",
                                    "gribparam": "144",
                                    "subcenter": "NCEP Ensemble Products",
                                    "gribNumBits": "12",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "SOILW",
                                    "calendar": "standard",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P1"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "expires": "1617408000",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "Z_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "cm_down",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Depth"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "expires": "1617408000",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Z1_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "Depth"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "long_name": "Latitude",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "expires": "1617408000",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Z1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2",
                        "long_name": "Depth"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/MONTHLY"
                },
                "SIXHOURLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SIX-HOURLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Intrinsictotallong_name": "total atmospheric column",
                        "Intrinsicmaxwindlevellong_name": "maximum wind level",
                        "Intrinsiclowestsigmalong_name": "lowest sigma level",
                        "Intrinsiclowestlayerlong_name": "lowest 30-hPa layer",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tropopause": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tropopause",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "meridional wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "zonal wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "temperature",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "pressure",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "dwdz": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dwdz",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "1/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "vertical speed shear",
                                "variable_class": "A: strongly influenced by data"
                            }
                        },
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "relative humidity",
                                "variable_class": "B: observational data exists but strong model influence"
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "pressure",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "gpm",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "geopotential height",
                                "variable_class": "D: fixed from climatological values"
                            }
                        },
                        "SigmaLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SigmaLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "relative humidity",
                                "variable_class": "B: observational data exists but strong model influence"
                            }
                        },
                        "pwater": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pwater",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m2",
                            "Note": ">benno@ldeo.columbia.edu</a>.",
                            "long_name": "precipitable water",
                            "variable_class": "B: observational data exists but strong model influence"
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "meridional wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "zonal wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "temperature",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "relative humidity",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "gpm",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "geopotential height",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "dpdt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dp:dt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "pressure vertical velocity",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "avort": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "avort",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "1/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "absolute vorticity",
                                "variable_class": "A: strongly influenced by data"
                            }
                        },
                        "pmsl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pmsl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Pa",
                            "Note": ">benno@ldeo.columbia.edu</a>.",
                            "long_name": "pressure reduced to MSL",
                            "variable_class": "A: strongly influenced by data"
                        },
                        "maxwindlevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maxwindlevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "meridional wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "zonal wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "temperature",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "pressure",
                                "variable_class": "A: strongly influenced by data"
                            }
                        },
                        "lowestsigma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lowestsigma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "meridional wind",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "zonal wind",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "theta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "theta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "potential temperature",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "temperature",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "relative humidity",
                                "variable_class": "B: observational data exists but strong model influence"
                            },
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "pressure",
                                "variable_class": "B: observational data exists but strong model influence"
                            }
                        },
                        "lowestlayer": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lowestlayer",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "meridional wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "zonal wind",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "temperature",
                                "variable_class": "A: strongly influenced by data"
                            },
                            "rhum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rhum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "Note": ">benno@ldeo.columbia.edu</a>.",
                                "long_name": "relative humidity",
                                "variable_class": "B: observational data exists but strong model influence"
                            }
                        }
                    },
                    "sigma": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sigma",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "levels-hPa",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Pressure"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "levels-hPa",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Pressure"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "julian_day",
                        "gridtype": "0",
                        "calendar": "standard",
                        "pointwidth": "0.25",
                        "standard_name": "time",
                        "add_offset": "2444971"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/SIX-HOURLY"
                },
                "mc6190": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc6190",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1961-1990 Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "grib_name": "VGRD",
                                "PTVersion": "2",
                                "history": "Averaged over T2[1961, 1990]",
                                "long_name": "meridional wind",
                                "center": "US Weather Service - National Met. Center"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "grib_name": "UGRD",
                                "PTVersion": "2",
                                "history": "Averaged over T2[1961, 1990]",
                                "long_name": "zonal wind",
                                "center": "US Weather Service - National Met. Center"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "grib_name": "PRES",
                                "PTVersion": "1",
                                "history": "Averaged over T2[1961, 1990]",
                                "long_name": "Pressure",
                                "center": "US Weather Service - National Met. Center"
                            }
                        }
                    },
                    "Diagnostic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Diagnostic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "grib_name": "TMP",
                                "PTVersion": "2",
                                "history": "Averaged over T2[1961, 1990]",
                                "long_name": "Temperature",
                                "center": "US Weather Service - National Met. Center"
                            }
                        }
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "long_name": "Latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "modulus": "360.0",
                        "pointwidth": "2.5",
                        "long_name": "Longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "pointwidth": "1.0",
                        "long_name": "Time",
                        "modulo": "12.0",
                        "calendar": "360"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "modulus": "360.0",
                        "pointwidth": "1.875",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/mc6190"
                },
                "mc7100": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc7100",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1971-2000 Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "meridional wind",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "34",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "zonal wind",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "gribNumBits": "13",
                                "PTVersion": "2",
                                "gribparam": "11",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "Specific humidity",
                                "units": "unitless",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "gribNumBits": "15",
                                "PTVersion": "2",
                                "gribparam": "51",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "Geopotential height",
                                "units": "gpm",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "7",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "long_name": "Pressure",
                                "units": "Pa",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "1",
                                "gribleveltype": "102",
                                "gribNumBits": "13",
                                "PTVersion": "2",
                                "gribparam": "1",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "calendar": "360",
                        "modulo": "12.0",
                        "expires": "1617408000",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/mc7100"
                },
                "mc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1981-2010 Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "meridional wind",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "34",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "zonal wind",
                                "units": "m/s",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "Temperature",
                                "units": "Kelvin_scale",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "gribNumBits": "13",
                                "PTVersion": "2",
                                "gribparam": "11",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "Specific humidity",
                                "units": "unitless",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "gribNumBits": "15",
                                "PTVersion": "2",
                                "gribparam": "51",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "Geopotential height",
                                "units": "gpm",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "PTVersion": "2",
                                "gribparam": "7",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        },
                        "MSL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MSL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pressure": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pressure",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2010]",
                                "long_name": "Pressure",
                                "units": "Pa",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "GRIBgridcode": "2",
                                "gribvariable": "1",
                                "gribleveltype": "102",
                                "gribNumBits": "13",
                                "PTVersion": "2",
                                "gribparam": "1",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRES",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "calendar": "360",
                        "modulo": "12.0",
                        "expires": "1617408000",
                        "pointwidth": "1.0",
                        "standard_name": "time",
                        "long_name": "Time"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/mc8110"
                },
                "pc6190": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pc6190",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1961-1990 Pentad Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "grib_name": "VGRD",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "history": "[(pentad [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel v ] 1990) [(T regridded on $integral dT$ [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel v ]) (Data ends 1 Jan 1991) (Boxes with less than 0.0% dropped)] (Averaged over T2[Jul-Jun 1961, Dec 1990] minimum 0.0% data present)]",
                                "long_name": "meridional wind",
                                "gribparam": "34",
                                "PTVersion": "2",
                                "center": "US Weather Service - National Met. Center",
                                "file_missing_value": "9.99900026E20",
                                "units": "m/s",
                                "gribleveltype": "100",
                                "missing_value": "NaN"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PTVersion": "2",
                                "units": "m/s",
                                "grib_name": "UGRD",
                                "history": "[(pentad [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel u ] 1990) [(T regridded on $integral dT$ [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel u ]) (Data ends 1 Jan 1991) (Boxes with less than 0.0% dropped)] (Averaged over T2[Jul-Jun 1961, Dec 1990] minimum 0.0% data present)]",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "zonal wind",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "NCEP Reanalysis Project",
                                "missing_value": "NaN",
                                "process": " run"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PTVersion": "2",
                                "units": "Kelvin_scale",
                                "grib_name": "TMP",
                                "history": "[(pentad [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel temp ] 1990) [(T regridded on $integral dT$ [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel temp ]) (Data ends 1 Jan 1991) (Boxes with less than 0.0% dropped)] (Averaged over T2[Jul-Jun 1961, Dec 1990] minimum 0.0% data present)]",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Temperature",
                                "center": "US Weather Service - National Met. Center",
                                "subcenter": "NCEP Reanalysis Project",
                                "missing_value": "NaN",
                                "process": " run"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "grib_name": "HGT",
                                "process": " run",
                                "subcenter": "NCEP Reanalysis Project",
                                "history": "[(pentad [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel phi ] 1990) [(T regridded on $integral dT$ [ NOAA NCEP-NCAR CDAS-1 DAILY Intrinsic PressureLevel phi ]) (Data ends 1 Jan 1991)] (Averaged over T2[Jul-Jun 1961, Jan 1991])]",
                                "long_name": "Geopotential height",
                                "calendar": "standard",
                                "gribparam": "7",
                                "PTVersion": "2",
                                "center": "US Weather Service - National Met. Center",
                                "units": "gpm",
                                "gribleveltype": "100"
                            }
                        }
                    },
                    "Diagnostic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Diagnostic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Temperature",
                                "standard_name": "surface_temperature",
                                "gribNumBits": "11",
                                "process": " run",
                                "gribvariable": "11",
                                "gribleveltype": "1",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "N/m2",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Meridional momentum flux",
                                "gribNumBits": "11",
                                "process": " run",
                                "gribvariable": "125",
                                "gribleveltype": "1",
                                "gribparam": "125",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VFLX",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "N/m2",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Zonal momentum flux",
                                "gribNumBits": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "gribvariable": "124",
                                "gribleveltype": "1",
                                "gribparam": "124",
                                "PTVersion": "2",
                                "PDS_TimeRange": "3",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UFLX",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "runoff": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "runoff",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "kg/m2",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Runoff",
                                "standard_name": "surface_runoff_amount",
                                "gribNumBits": "7",
                                "process": " run",
                                "gribvariable": "90",
                                "gribleveltype": "1",
                                "gribparam": "90",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "RUNOF",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "prate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "kg/m2/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Precipitation rate",
                                "standard_name": "precipitation_flux",
                                "gribNumBits": "10",
                                "process": " run",
                                "gribvariable": "59",
                                "gribleveltype": "1",
                                "gribparam": "59",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "3",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "PRATE",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "northward_wind",
                                "long_name": "meridional wind",
                                "gribNumBits": "8",
                                "process": " run",
                                "gribvariable": "34",
                                "gribleveltype": "105",
                                "gribparam": "34",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "eastward_wind",
                                "long_name": "zonal wind",
                                "gribNumBits": "8",
                                "process": " run",
                                "gribvariable": "33",
                                "gribleveltype": "105",
                                "gribparam": "33",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "air_temperature",
                                "long_name": "Temperature",
                                "gribNumBits": "10",
                                "process": " run",
                                "gribvariable": "11",
                                "gribleveltype": "105",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "specific_humidity",
                                "long_name": "Specific humidity",
                                "gribNumBits": "8",
                                "process": " run",
                                "gribvariable": "51",
                                "gribleveltype": "105",
                                "gribparam": "51",
                                "subcenter": "NCEP Ensemble Products",
                                "PTVersion": "2",
                                "PDS_TimeRange": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99900026E20",
                                    "standard_name": "air_temperature",
                                    "long_name": "Temperature",
                                    "gribNumBits": "10",
                                    "process": " run",
                                    "gribvariable": "16",
                                    "gribleveltype": "105",
                                    "gribparam": "16",
                                    "subcenter": "NCEP Ensemble Products",
                                    "PTVersion": "2",
                                    "PDS_TimeRange": "2",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMIN",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over T2[1200 2 Jul 1960 - 1200 2 Jul 1961, 2400 31 Dec 1990] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99900026E20",
                                    "standard_name": "air_temperature",
                                    "long_name": "Temperature",
                                    "gribNumBits": "10",
                                    "process": " run",
                                    "gribvariable": "15",
                                    "gribleveltype": "105",
                                    "gribparam": "15",
                                    "subcenter": "NCEP Ensemble Products",
                                    "PTVersion": "2",
                                    "PDS_TimeRange": "2",
                                    "gribfield": "1",
                                    "center": "US Weather Service - National Met. Center",
                                    "grib_name": "TMAX",
                                    "calendar": "standard",
                                    "pointwidth": "0.0"
                                }
                            }
                        }
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "long_name": "Latitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "pointwidth": "1.0",
                        "long_name": "Time",
                        "modulo": "73.0",
                        "calendar": "365"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "modulus": "360.0",
                        "pointwidth": "2.5",
                        "long_name": "Longitude"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "long_name": "Latitude",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1961-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "modulo": "73.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/pc6190"
                },
                "pc7100": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pc7100",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1971-2000 Pentad Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "Pa/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "long_name": "Pressure vertical velocity",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "39",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "39",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "10",
                                "grib_name": "VVEL",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "34",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "8",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "33",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "8",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "11",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "10",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "specific_humidity",
                                "long_name": "Specific humidity",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "51",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "12",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1970 - 1200 2 Jul 1971, 2400 31 Dec 2000] minimum 0.0% data present",
                                "units": "gpm",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "subcenter": "NCEP Ensemble Products",
                                "process": " run",
                                "PDS_TimeRange": "113",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "PTVersion": "2",
                                "gribparam": "7",
                                "GRIBgridcode": "2",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "gribNumBits": "9",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P1"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1961-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "modulo": "73.0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/pc7100"
                },
                "pc8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pc8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1981-2010 Pentad Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vvel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vvel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "Pa/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "lagrangian_tendency_of_air_pressure",
                                "long_name": "Pressure vertical velocity",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "39",
                                "gribleveltype": "100",
                                "gribNumBits": "10",
                                "gribparam": "39",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VVEL",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "34",
                                "gribleveltype": "100",
                                "gribNumBits": "8",
                                "gribparam": "34",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "m/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "33",
                                "gribleveltype": "100",
                                "gribNumBits": "8",
                                "gribparam": "33",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "UGRD",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "gribNumBits": "10",
                                "gribparam": "11",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "qa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "qa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "unitless",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "specific_humidity",
                                "long_name": "Specific humidity",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "51",
                                "gribleveltype": "100",
                                "gribNumBits": "12",
                                "gribparam": "51",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "SPFH",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "gpm",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "gribNumBits": "9",
                                "gribparam": "7",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "Diagnostic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Diagnostic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "Kelvin_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "standard_name": "air_temperature",
                                "long_name": "Temperature",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "PTVersion": "2",
                                "gribvariable": "11",
                                "gribleveltype": "105",
                                "gribNumBits": "10",
                                "gribparam": "11",
                                "process": " run",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P1"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure",
                        "bounds": "P0"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m_above_gnd",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Height"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "long_name": "Latitude",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1961-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "modulo": "73.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/pc8110"
                },
                "pc9913": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pc9913",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1999-2013 Pentad Climatology",
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vpot": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpot",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1998 - 1200 2 Jul 1999, 2400 31 Dec 2013] minimum 0.0% data present",
                                "units": "m2/s",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Velocity potential",
                                "standard_name": "atmosphere_horizontal_velocity_potential",
                                "subcenter": "NCEP Ensemble Products",
                                "GRIBgridcode": "2",
                                "gribNumBits": "16",
                                "gribvariable": "36",
                                "gribleveltype": "100",
                                "process": " run",
                                "gribparam": "36",
                                "PTVersion": "2",
                                "PDS_TimeRANGE": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "VPOT",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1961-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "modulo": "73.0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/pc9913"
                },
                "prms8110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prms8110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "Intrinsic": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Intrinsic",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp925": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp925",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "degree_Celsius",
                                "missing_value": "NaN",
                                "expires": "1615297200",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Temperature",
                                "standard_name": "air_temperature",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribNumBits": "10",
                                "gribvariable": "11",
                                "gribleveltype": "100",
                                "process": " run",
                                "gribparam": "11",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "TMP",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "phi925": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi925",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "gpm",
                                "missing_value": "NaN",
                                "expires": "1615297200",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribNumBits": "9",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "process": " run",
                                "gribparam": "7",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "phi500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "gpm",
                                "missing_value": "NaN",
                                "expires": "1615297200",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribNumBits": "9",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "process": " run",
                                "gribparam": "7",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            },
                            "phi250": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi250",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1200 2 Jul 1980 - 1200 2 Jul 1981, 2400 31 Dec 2010] minimum 0.0% data present",
                                "units": "gpm",
                                "missing_value": "NaN",
                                "expires": "1615297200",
                                "file_missing_value": "9.99900026E20",
                                "long_name": "Geopotential height",
                                "standard_name": "geopotential_height",
                                "PTVersion": "2",
                                "GRIBgridcode": "2",
                                "gribNumBits": "9",
                                "gribvariable": "7",
                                "gribleveltype": "100",
                                "process": " run",
                                "gribparam": "7",
                                "subcenter": "NCEP Ensemble Products",
                                "PDS_TimeRange": "113",
                                "gribfield": "1",
                                "center": "US Weather Service - National Met. Center",
                                "grib_name": "HGT",
                                "calendar": "standard",
                                "pointwidth": "0.0"
                            }
                        }
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude",
                        "long_name": "Latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "pentads since 1961-01-01",
                        "gridtype": "1",
                        "modulus": "73.0",
                        "calendar": "365",
                        "pointwidth": "1.0",
                        "modulo": "73.0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mb",
                        "gridtype": "0",
                        "long_name": "Pressure"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/NOAA/NCEP-NCAR/CDAS-1/prms8110"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "DAILY",
                    "MONTHLY",
                    "SIXHOURLY",
                    "mc6190",
                    "mc7100",
                    "mc8110",
                    "pc6190",
                    "pc7100",
                    "pc8110",
                    "pc9913",
                    "prms8110"
                ]
            },
            "Reference_Data": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Reference_Data",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "CDAS Reference Data",
                    "Conventions": "IRIDL"
                },
                "DegreeGrid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DegreeGrid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gpcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gpcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "kg/m2/s",
                            "long_name": "mean precipitation rate",
                            "missing_value": "-9999.0",
                            "note": " x 86400 to get mm/day"
                        }
                    }
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/NOAA/NCEP-NCAR/Reference_Data"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CDAS1",
                "Reference_Data"
            ]
        },
        "NESDIS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NESDIS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "STARVHP16kmdataset_documentation": "ftp://ftp.star.nesdis.noaa.gov/pub/corp/scsb/wguo/doc/VHP_uguide_v1.4_2013_1221.pdf",
                "STARVHP16kmreferences": "Kogan_Sullivan1993",
                "STARVHPSTAR_VHP": "http://www.star.nesdis.noaa.gov/smcd/emb/vci/VH/index.php",
                "Conventions": "IRIDL"
            },
            "STAR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STAR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "VHP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "VHP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "km": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "16km",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "VHI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VHI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:VHI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "missing_value": "-999",
                            "scale_min": "0",
                            "scale_factor": "0.01"
                        },
                        "VCI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VCI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:VCI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "missing_value": "-999",
                            "scale_min": "0",
                            "scale_factor": "0.01"
                        },
                        "TCI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TCI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:TCI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "missing_value": "-999",
                            "scale_min": "0",
                            "scale_factor": "0.01"
                        },
                        "SMT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SMT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "4000",
                            "units": "Kelvin_scale",
                            "missing_value": "-999",
                            "scale_min": "0",
                            "scale_factor": "0.1"
                        },
                        "SMN": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SMN",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1000",
                            "units": "unitless",
                            "missing_value": "-999",
                            "scale_min": "-100",
                            "scale_factor": "0.001"
                        },
                        "satid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "satid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16777215",
                            "scale_max": "915",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-100",
                            "CS": "-0.1",
                            "CE": "0.916",
                            "colorscalename": "NDVIcolorscale",
                            "iridlhasSemantics": "iridl:NDVI",
                            "units": "unitless",
                            "missing_value": "-999",
                            "scale_factor": "0.001"
                        },
                        "BT4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BT4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "4000",
                            "units": "Kelvin_scale",
                            "missing_value": "-999",
                            "scale_min": "0",
                            "scale_factor": "0.1"
                        }
                    }
                }
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1981-01-01 00:00:00",
                "gridtype": "0",
                "standard_name": "time",
                "pointwidth": "7",
                "calendar": "standard"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/NOAA/NESDIS"
        },
        "NGDC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NGDC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MGSlong_name": "Marine Geological Samples",
                "MGSdescription": "Inventory and basic lithology from marine core samples",
                "GLOBEreferences": "Hastings_Dunbar1999",
                "GLOBEdescription": "Gridded 1-km, quality controlled global Digital Elevation Model (DEM) data from the Global Land One-km Base Elevation (GLOBE) Project",
                "GLOBEdataset_documentationhtml": "http://www.ngdc.noaa.gov/seg/topo/globe.shtml",
                "ETOPO5description": "ETOPO5 5x5 minute land surface elevations and sea floor depths",
                "ETOPO5dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NGDC/.ETOPO5.dataset_documentation.html",
                "ETOPO2v2More": "http://www.ngdc.noaa.gov/mgg/fliers/06mgg01.html",
                "ETOPO2v2ETOPO2v2": "http://www.ngdc.noaa.gov/mgg/global/etopo2.html",
                "ETOPO2v2description": "ETOPO2v2c Global Gridded 2-minute elevation and bathymetric data",
                "ETOPO2v2dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NGDC/.ETOPO2v2.dataset_documentation.html",
                "ETOPO2v2iridlhasSemantics": "iridl:PlanetarySurface",
                "ETOPO1More": "http://www.ngdc.noaa.gov/mgg/global/etopo1sources.html",
                "ETOPO1references": "Amante_Eakins2008",
                "ETOPO1description": "ETOPO1 Grid Registered 1 Arc-Minute Global Relief Model",
                "ETOPO1dataset_documentation": "http://www.ngdc.noaa.gov/mgg/global/relief/ETOPO1/docs/ETOPO1.pdf",
                "ETOPO1ETOPO1": "http://www.ngdc.noaa.gov/mgg/global/global.html",
                "ETOPO1iridlhasSemantics": "iridl:PlanetarySurface",
                "Index": "http://www.ngdc.noaa.gov/mgg/curator/curator.html",
                "National": "http://www.ngdc.noaa.gov/",
                "description": "National Geophysical Data Center",
                "Conventions": "IRIDL"
            },
            "MGS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MGS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "surface": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "surface",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "lith": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lith",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "12632256",
                        "scale_max": "35.0",
                        "maxncolor": "38",
                        "ncolor": "38",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "35",
                        "colorscalename": "custom",
                        "units": "ids",
                        "long_name": "lithology",
                        "CLIST": "evaporite",
                        "missing_value": "126"
                    }
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "longitude",
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "latitude",
                    "units": "degree_north"
                }
            },
            "GLOBE": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GLOBE",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "topo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "topo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "12632256",
                    "scale_max": "8752",
                    "maxncolor": "254",
                    "ncolor": "233",
                    "scale_min": "0",
                    "CS": "0",
                    "CE": "8752",
                    "units": "m",
                    "long_name": "elevation",
                    "missing_value": "-32768"
                }
            },
            "ETOPO5": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ETOPO5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "12632256",
                    "scale_max": "7964",
                    "maxncolor": "253",
                    "ncolor": "253",
                    "scale_min": "-9964",
                    "CS": "-9964.0",
                    "CE": "7964.0",
                    "colorscalename": "topographycolorscale",
                    "long_name": "elevation/bathymetry",
                    "units": "m"
                }
            },
            "ETOPO2v2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ETOPO2v2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridlhasSemantics": "iridl:Elevation",
                    "long_name": "elevation/bathymetry",
                    "units": "m",
                    "missing_value": "NaN",
                    "actual_range": "8440.0"
                }
            },
            "ETOPO1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ETOPO1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "z_ice": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "z_ice",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "long_name": "ice surface elevation/bathymetry",
                    "missing_value": "-32768",
                    "actual_range": "8224.0",
                    "iridlhasSemantics": "iridl:Elevation"
                },
                "z_bedrock": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "z_bedrock",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "long_name": "bedrock elevation/bathymetry",
                    "missing_value": "-32768",
                    "actual_range": "8224.0",
                    "iridlhasSemantics": "iridl:Elevation"
                }
            },
            "core": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "core",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.008333334",
                "standard_name": "latitude"
            },
            "X_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.008333334",
                "standard_name": "longitude"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.08333333",
                "standard_name": "latitude"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.08333333",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.03333333"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.03333333"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.01666667"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.01666667",
                "actual_range": "90.0",
                "long_name": "latitude"
            },
            "dir": "SOURCES/NOAA/NGDC"
        },
        "NODC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NODC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WOA98SEASONALselong_name": "standard error",
                "WOA98SEASONALsdlong_name": "standard deviation",
                "WOA98SEASONALrawWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Seasonal/.mn/",
                "WOA98SEASONALgridptWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Seasonal/.gp/",
                "WOA98SEASONALgridptlong_name": "grid points",
                "WOA98SEASONALdistWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Seasonal/.dd/",
                "WOA98SEASONALdistlong_name": "data distribution",
                "WOA98SEASONALanalyzedWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Seasonal/.an/",
                "WOA98SEASONALWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Seasonal/",
                "WOA98MONTHLYselong_name": "standard error",
                "WOA98MONTHLYsdlong_name": "standard deviation",
                "WOA98MONTHLYrawWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Monthly/.mn/",
                "WOA98MONTHLYgridptWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Monthly/.gp/",
                "WOA98MONTHLYgridptlong_name": "grid points",
                "WOA98MONTHLYdistWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Monthly/.dd/",
                "WOA98MONTHLYdistlong_name": "data distribution",
                "WOA98MONTHLYanalyzedWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Monthly/.an/",
                "WOA98MONTHLYWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Monthly/",
                "WOA98ANNUALselong_name": "standard error",
                "WOA98ANNUALsdlong_name": "standard deviation",
                "WOA98ANNUALrawWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Annual/.mn/",
                "WOA98ANNUALgridptWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Annual/.gp/",
                "WOA98ANNUALgridptlong_name": "grid points",
                "WOA98ANNUALdistWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Annual/.dd/",
                "WOA98ANNUALdistlong_name": "data distribution",
                "WOA98ANNUALanalyzedWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Annual/.an/",
                "WOA98ANNUALWOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/.Grid-1x1/.Annual/",
                "WOA98WOA01": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01/",
                "WOA98references": "Conkright:etal1998 Conkright_etal1998v10",
                "WOA98description": "World Ocean Atlas 1998, an atlas of objectively analyzed fields of major ocean parameters at monthly, seasonal, and annual time scales. Superceeded by WOA01",
                "WOA98dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA98.dataset_documentation.html",
                "WOA98iridlhasSemantics": "iridl:Ocean",
                "WOA09Grid5x5Seasonaltemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonaltemperatureprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonaltemperaturetime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonaltemperaturecdm_data_type": "Grid",
                "WOA09Grid5x5Seasonaltemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid5x5SeasonaltemperatureCVS_ID": "1.0",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonaltemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonaltemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonaltemperaturedate_created": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5Seasonaltemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonaltemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonaltemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonaltemperaturedate_issued": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5SeasonaltemperatureConventions": "CF-1.4",
                "WOA09Grid5x5Seasonaltemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaltemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonaltemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - seasonal",
                "WOA09Grid5x5Seasonaltemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid5x5Seasonaltemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonaltemperaturedate_modified": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonaltemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid5x5Seasonaltemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonaltemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Seasonaltemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonaltemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaltemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid5x5Seasonaltemperaturecreator_name": "NODC",
                "WOA09Grid5x5Seasonaltemperatureid": "2380e802-5c05-4ad1-b9aa-31b367ef4b1f",
                "WOA09Grid5x5Seasonaltemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonaltemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5SeasonaltemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonaltemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonaltemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonalsilicatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonalsilicateprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonalsilicatetime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonalsilicatecdm_data_type": "Grid",
                "WOA09Grid5x5Seasonalsilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonalsilicategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5SeasonalsilicateCVS_ID": "1.0",
                "WOA09Grid5x5Seasonalsilicategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonalsilicatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonalsilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonalsilicategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonalsilicatedate_created": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5Seasonalsilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonalsilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonalsilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonalsilicatedate_issued": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5SeasonalsilicateConventions": "CF-1.4",
                "WOA09Grid5x5Seasonalsilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalsilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalsilicatetitle": "World Ocean Atlas 09:  Silicate - seasonal",
                "WOA09Grid5x5Seasonalsilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid5x5Seasonalsilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonalsilicatedate_modified": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5Seasonalsilicategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonalsilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Seasonalsilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonalsilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonalsilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonalsilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonalsilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalsilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Seasonalsilicatecreator_name": "NODC",
                "WOA09Grid5x5Seasonalsilicateid": "96222367-7cad-4d1a-abc1-c0fbe6395f8c",
                "WOA09Grid5x5Seasonalsilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonalsilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonalsilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5SeasonalsilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonalsilicategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonalsilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonalsilicategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonalsalinitystandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonalsalinityprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonalsalinitytime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonalsalinitycdm_data_type": "Grid",
                "WOA09Grid5x5Seasonalsalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid5x5SeasonalsalinityCVS_ID": "1.0",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonalsalinitytime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonalsalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonalsalinitydate_created": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5Seasonalsalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonalsalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonalsalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonalsalinitydate_issued": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5SeasonalsalinityConventions": "CF-1.4",
                "WOA09Grid5x5Seasonalsalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalsalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalsalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - seasonal",
                "WOA09Grid5x5Seasonalsalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid5x5Seasonalsalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonalsalinitydate_modified": "2010-9-30T17:29:19Z",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonalsalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid5x5Seasonalsalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonalsalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Seasonalsalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonalsalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalsalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid5x5Seasonalsalinitycreator_name": "NODC",
                "WOA09Grid5x5Seasonalsalinityid": "79781af3-90b4-491d-b3e9-425c77e338c4",
                "WOA09Grid5x5Seasonalsalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonalsalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5SeasonalsalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonalsalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonalsalinitygeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonalphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonalphosphateprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonalphosphatetime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonalphosphatecdm_data_type": "Grid",
                "WOA09Grid5x5Seasonalphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonalphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5SeasonalphosphateCVS_ID": "1.0",
                "WOA09Grid5x5Seasonalphosphategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonalphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonalphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonalphosphategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonalphosphatedate_created": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5Seasonalphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonalphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonalphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonalphosphatedate_issued": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5SeasonalphosphateConventions": "CF-1.4",
                "WOA09Grid5x5Seasonalphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalphosphatetitle": "World Ocean Atlas 09:  Phosphate - seasonal",
                "WOA09Grid5x5Seasonalphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid5x5Seasonalphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonalphosphatedate_modified": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5Seasonalphosphategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonalphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Seasonalphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonalphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonalphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonalphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonalphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Seasonalphosphatecreator_name": "NODC",
                "WOA09Grid5x5Seasonalphosphateid": "5a46027b-19ad-42b2-97c4-c6d5b41544a2",
                "WOA09Grid5x5Seasonalphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonalphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonalphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5SeasonalphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonalphosphategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonalphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonalphosphategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonaloxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonaloxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonaloxygen_saturationtime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonaloxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid5x5Seasonaloxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Seasonaloxygen_saturationCVS_ID": "1.0",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonaloxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonaloxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonaloxygen_saturationdate_created": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonaloxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonaloxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonaloxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonaloxygen_saturationdate_issued": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonaloxygen_saturationConventions": "CF-1.4",
                "WOA09Grid5x5Seasonaloxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaloxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonaloxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - seasonal",
                "WOA09Grid5x5Seasonaloxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Seasonaloxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonaloxygen_saturationdate_modified": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonaloxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Seasonaloxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonaloxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonaloxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonaloxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaloxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Seasonaloxygen_saturationcreator_name": "NODC",
                "WOA09Grid5x5Seasonaloxygen_saturationid": "c6ada131-e45d-4861-8c01-014079009778",
                "WOA09Grid5x5Seasonaloxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonaloxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonaloxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonaloxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonaloxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonalnitratestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonalnitrateprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonalnitratetime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonalnitratecdm_data_type": "Grid",
                "WOA09Grid5x5Seasonalnitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonalnitrategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5SeasonalnitrateCVS_ID": "1.0",
                "WOA09Grid5x5Seasonalnitrategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonalnitratetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonalnitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonalnitrategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonalnitratedate_created": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5Seasonalnitratesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonalnitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonalnitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonalnitratedate_issued": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5SeasonalnitrateConventions": "CF-1.4",
                "WOA09Grid5x5Seasonalnitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalnitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalnitratetitle": "World Ocean Atlas 09:  Nitrate - seasonal",
                "WOA09Grid5x5Seasonalnitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid5x5Seasonalnitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonalnitratedate_modified": "2010-9-30T17:29:22Z",
                "WOA09Grid5x5Seasonalnitrategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonalnitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Seasonalnitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonalnitratetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonalnitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonalnitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonalnitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalnitratetime_coverage_start": "1950-05-23",
                "WOA09Grid5x5Seasonalnitratecreator_name": "NODC",
                "WOA09Grid5x5Seasonalnitrateid": "a595ed04-1517-48bb-9867-da119a473dfb",
                "WOA09Grid5x5Seasonalnitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonalnitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonalnitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5SeasonalnitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonalnitrategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonalnitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonalnitrategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonaldissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonaldissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonaldissolved_oxygentime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonaldissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid5x5Seasonaldissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Seasonaldissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonaldissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonaldissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonaldissolved_oxygendate_created": "2010-9-30T17:29:20Z",
                "WOA09Grid5x5Seasonaldissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonaldissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonaldissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonaldissolved_oxygendate_issued": "2010-9-30T17:29:20Z",
                "WOA09Grid5x5Seasonaldissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid5x5Seasonaldissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaldissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonaldissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - seasonal",
                "WOA09Grid5x5Seasonaldissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Seasonaldissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonaldissolved_oxygendate_modified": "2010-9-30T17:29:20Z",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonaldissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Seasonaldissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonaldissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonaldissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonaldissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonaldissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Seasonaldissolved_oxygencreator_name": "NODC",
                "WOA09Grid5x5Seasonaldissolved_oxygenid": "47d2e3d1-fb95-4881-a062-786640ebce7e",
                "WOA09Grid5x5Seasonaldissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonaldissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonaldissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonaldissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonaldissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationtime_coverage_resolution": "P3M",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationdate_created": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationdate_issued": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - seasonal",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationdate_modified": "2010-9-30T17:29:21Z",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationid": "2c6f0bd5-27f0-446d-b4fb-90019deacef3",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Seasonalapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Seasonallong_name": "Seasonal",
                "WOA09Grid5x5Monthlytemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlytemperatureprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlytemperaturetime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlytemperaturecdm_data_type": "Grid",
                "WOA09Grid5x5Monthlytemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid5x5MonthlytemperatureCVS_ID": "1.0",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlytemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlytemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlytemperaturedate_created": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5Monthlytemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlytemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlytemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlytemperaturedate_issued": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5MonthlytemperatureConventions": "CF-1.4",
                "WOA09Grid5x5Monthlytemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlytemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlytemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - monthly",
                "WOA09Grid5x5Monthlytemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid5x5Monthlytemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlytemperaturedate_modified": "2010-9-30T17:29:23Z",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlytemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid5x5Monthlytemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlytemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Monthlytemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlytemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlytemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid5x5Monthlytemperaturecreator_name": "NODC",
                "WOA09Grid5x5Monthlytemperatureid": "d13deaa2-53bd-4fb8-903a-c4f0088df9c7",
                "WOA09Grid5x5Monthlytemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlytemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5MonthlytemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlytemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlytemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlysilicatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlysilicateprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlysilicatetime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlysilicatecdm_data_type": "Grid",
                "WOA09Grid5x5Monthlysilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlysilicategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5MonthlysilicateCVS_ID": "1.0",
                "WOA09Grid5x5Monthlysilicategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlysilicatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlysilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlysilicategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlysilicatedate_created": "2010-9-30T17:29:32Z",
                "WOA09Grid5x5Monthlysilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlysilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlysilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlysilicatedate_issued": "2010-9-30T17:29:32Z",
                "WOA09Grid5x5MonthlysilicateConventions": "CF-1.4",
                "WOA09Grid5x5Monthlysilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlysilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlysilicatetitle": "World Ocean Atlas 09:  Silicate - monthly",
                "WOA09Grid5x5Monthlysilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid5x5Monthlysilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlysilicatedate_modified": "2010-9-30T17:29:32Z",
                "WOA09Grid5x5Monthlysilicategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlysilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Monthlysilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlysilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlysilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlysilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlysilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlysilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Monthlysilicatecreator_name": "NODC",
                "WOA09Grid5x5Monthlysilicateid": "652a5f90-c5c3-4f28-8993-0f804700213e",
                "WOA09Grid5x5Monthlysilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlysilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlysilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5MonthlysilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlysilicategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlysilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlysilicategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlysalinitystandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlysalinityprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlysalinitytime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlysalinitycdm_data_type": "Grid",
                "WOA09Grid5x5Monthlysalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlysalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid5x5MonthlysalinityCVS_ID": "1.0",
                "WOA09Grid5x5Monthlysalinitygeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlysalinitytime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlysalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlysalinitygeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlysalinitydate_created": "2010-9-30T17:29:25Z",
                "WOA09Grid5x5Monthlysalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlysalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlysalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlysalinitydate_issued": "2010-9-30T17:29:25Z",
                "WOA09Grid5x5MonthlysalinityConventions": "CF-1.4",
                "WOA09Grid5x5Monthlysalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlysalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlysalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - monthly",
                "WOA09Grid5x5Monthlysalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid5x5Monthlysalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlysalinitydate_modified": "2010-9-30T17:29:25Z",
                "WOA09Grid5x5Monthlysalinitygeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlysalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid5x5Monthlysalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlysalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Monthlysalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlysalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlysalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlysalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid5x5Monthlysalinitycreator_name": "NODC",
                "WOA09Grid5x5Monthlysalinityid": "6e10e985-bbb1-41e7-a00c-6597b3f22802",
                "WOA09Grid5x5Monthlysalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlysalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlysalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5MonthlysalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlysalinitygeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlysalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlysalinitygeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlyphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlyphosphateprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlyphosphatetime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlyphosphatecdm_data_type": "Grid",
                "WOA09Grid5x5Monthlyphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlyphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5MonthlyphosphateCVS_ID": "1.0",
                "WOA09Grid5x5Monthlyphosphategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlyphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlyphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlyphosphategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlyphosphatedate_created": "2010-9-30T17:29:31Z",
                "WOA09Grid5x5Monthlyphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlyphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlyphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlyphosphatedate_issued": "2010-9-30T17:29:31Z",
                "WOA09Grid5x5MonthlyphosphateConventions": "CF-1.4",
                "WOA09Grid5x5Monthlyphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlyphosphatetitle": "World Ocean Atlas 09:  Phosphate - monthly",
                "WOA09Grid5x5Monthlyphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid5x5Monthlyphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlyphosphatedate_modified": "2010-9-30T17:29:31Z",
                "WOA09Grid5x5Monthlyphosphategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlyphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Monthlyphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlyphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlyphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlyphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlyphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Monthlyphosphatecreator_name": "NODC",
                "WOA09Grid5x5Monthlyphosphateid": "aaf6c8b4-ffa8-4bb0-99c5-bc510c72a442",
                "WOA09Grid5x5Monthlyphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlyphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlyphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5MonthlyphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlyphosphategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlyphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlyphosphategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlyoxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlyoxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlyoxygen_saturationtime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlyoxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid5x5Monthlyoxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Monthlyoxygen_saturationCVS_ID": "1.0",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlyoxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlyoxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlyoxygen_saturationdate_created": "2010-9-30T17:29:29Z",
                "WOA09Grid5x5Monthlyoxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlyoxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlyoxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlyoxygen_saturationdate_issued": "2010-9-30T17:29:29Z",
                "WOA09Grid5x5Monthlyoxygen_saturationConventions": "CF-1.4",
                "WOA09Grid5x5Monthlyoxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyoxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlyoxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - monthly",
                "WOA09Grid5x5Monthlyoxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Monthlyoxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlyoxygen_saturationdate_modified": "2010-9-30T17:29:29Z",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlyoxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Monthlyoxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlyoxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlyoxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlyoxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyoxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Monthlyoxygen_saturationcreator_name": "NODC",
                "WOA09Grid5x5Monthlyoxygen_saturationid": "20f49cf1-8a07-45ae-aa94-bc2958627cce",
                "WOA09Grid5x5Monthlyoxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlyoxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlyoxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlyoxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlyoxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlynitratestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlynitrateprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlynitratetime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlynitratecdm_data_type": "Grid",
                "WOA09Grid5x5Monthlynitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlynitrategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5MonthlynitrateCVS_ID": "1.0",
                "WOA09Grid5x5Monthlynitrategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlynitratetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlynitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlynitrategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlynitratedate_created": "2010-9-30T17:29:30Z",
                "WOA09Grid5x5Monthlynitratesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlynitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlynitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlynitratedate_issued": "2010-9-30T17:29:30Z",
                "WOA09Grid5x5MonthlynitrateConventions": "CF-1.4",
                "WOA09Grid5x5Monthlynitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlynitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlynitratetitle": "World Ocean Atlas 09:  Nitrate - monthly",
                "WOA09Grid5x5Monthlynitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid5x5Monthlynitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlynitratedate_modified": "2010-9-30T17:29:30Z",
                "WOA09Grid5x5Monthlynitrategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlynitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Monthlynitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlynitratetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlynitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlynitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlynitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlynitratetime_coverage_start": "1950-05-23",
                "WOA09Grid5x5Monthlynitratecreator_name": "NODC",
                "WOA09Grid5x5Monthlynitrateid": "81ced51f-a67f-4937-8807-9e76072b6072",
                "WOA09Grid5x5Monthlynitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlynitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlynitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5MonthlynitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlynitrategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlynitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlynitrategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlydissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlydissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlydissolved_oxygentime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlydissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid5x5Monthlydissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Monthlydissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlydissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlydissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlydissolved_oxygendate_created": "2010-9-30T17:29:26Z",
                "WOA09Grid5x5Monthlydissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlydissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlydissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlydissolved_oxygendate_issued": "2010-9-30T17:29:26Z",
                "WOA09Grid5x5Monthlydissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid5x5Monthlydissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlydissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlydissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - monthly",
                "WOA09Grid5x5Monthlydissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Monthlydissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlydissolved_oxygendate_modified": "2010-9-30T17:29:26Z",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlydissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Monthlydissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlydissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlydissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlydissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlydissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Monthlydissolved_oxygencreator_name": "NODC",
                "WOA09Grid5x5Monthlydissolved_oxygenid": "8fdee4a7-7050-4b93-ac35-76af277f2577",
                "WOA09Grid5x5Monthlydissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlydissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlydissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlydissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlydissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationtime_coverage_resolution": "P1M",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationdate_created": "2010-9-30T17:29:27Z",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationdate_issued": "2010-9-30T17:29:27Z",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - monthly",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationdate_modified": "2010-9-30T17:29:27Z",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationid": "818f14d4-756e-4429-a8d1-e408a3bd0dc4",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Monthlyapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Monthlylong_name": "Monthly",
                "WOA09Grid5x5Annualtemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualtemperatureprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualtemperaturetime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualtemperaturecdm_data_type": "Grid",
                "WOA09Grid5x5Annualtemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualtemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid5x5AnnualtemperatureCVS_ID": "1.0",
                "WOA09Grid5x5Annualtemperaturegeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualtemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualtemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualtemperaturegeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualtemperaturedate_created": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualtemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualtemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualtemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualtemperaturedate_issued": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5AnnualtemperatureConventions": "CF-1.4",
                "WOA09Grid5x5Annualtemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualtemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualtemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - annual",
                "WOA09Grid5x5Annualtemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid5x5Annualtemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualtemperaturedate_modified": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualtemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualtemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid5x5Annualtemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualtemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Annualtemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualtemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualtemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualtemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid5x5Annualtemperaturecreator_name": "NODC",
                "WOA09Grid5x5Annualtemperatureid": "796d83ad-6aa7-4aae-b807-9964e0591fb6",
                "WOA09Grid5x5Annualtemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualtemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualtemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5AnnualtemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualtemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualtemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualtemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualsilicatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualsilicateprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualsilicatetime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualsilicatecdm_data_type": "Grid",
                "WOA09Grid5x5Annualsilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualsilicategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5AnnualsilicateCVS_ID": "1.0",
                "WOA09Grid5x5Annualsilicategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualsilicatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualsilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualsilicategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualsilicatedate_created": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualsilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualsilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualsilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualsilicatedate_issued": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5AnnualsilicateConventions": "CF-1.4",
                "WOA09Grid5x5Annualsilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualsilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualsilicatetitle": "World Ocean Atlas 09:  Silicate - annual",
                "WOA09Grid5x5Annualsilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid5x5Annualsilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualsilicatedate_modified": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualsilicategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualsilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Annualsilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualsilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualsilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualsilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualsilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualsilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Annualsilicatecreator_name": "NODC",
                "WOA09Grid5x5Annualsilicateid": "a322766a-edc4-4cb2-bbb8-c40cd45cba6f",
                "WOA09Grid5x5Annualsilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualsilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualsilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5AnnualsilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualsilicategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualsilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualsilicategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualsalinitystandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualsalinityprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualsalinitytime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualsalinitycdm_data_type": "Grid",
                "WOA09Grid5x5Annualsalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualsalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid5x5AnnualsalinityCVS_ID": "1.0",
                "WOA09Grid5x5Annualsalinitygeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualsalinitytime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualsalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualsalinitygeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualsalinitydate_created": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualsalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualsalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualsalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualsalinitydate_issued": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5AnnualsalinityConventions": "CF-1.4",
                "WOA09Grid5x5Annualsalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualsalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualsalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - annual",
                "WOA09Grid5x5Annualsalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid5x5Annualsalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualsalinitydate_modified": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualsalinitygeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualsalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid5x5Annualsalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualsalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid5x5Annualsalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualsalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualsalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualsalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid5x5Annualsalinitycreator_name": "NODC",
                "WOA09Grid5x5Annualsalinityid": "25e0b1c7-bf7e-4d8e-a8d9-9901b48fdfaa",
                "WOA09Grid5x5Annualsalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualsalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualsalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5AnnualsalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualsalinitygeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualsalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualsalinitygeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualphosphateprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualphosphatetime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualphosphatecdm_data_type": "Grid",
                "WOA09Grid5x5Annualphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5AnnualphosphateCVS_ID": "1.0",
                "WOA09Grid5x5Annualphosphategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualphosphategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualphosphatedate_created": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualphosphatedate_issued": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5AnnualphosphateConventions": "CF-1.4",
                "WOA09Grid5x5Annualphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualphosphatetitle": "World Ocean Atlas 09:  Phosphate - annual",
                "WOA09Grid5x5Annualphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid5x5Annualphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualphosphatedate_modified": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualphosphategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Annualphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid5x5Annualphosphatecreator_name": "NODC",
                "WOA09Grid5x5Annualphosphateid": "85467887-4175-4097-b788-28d958b3b724",
                "WOA09Grid5x5Annualphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5AnnualphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualphosphategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualphosphategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualoxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualoxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualoxygen_saturationtime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualoxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid5x5Annualoxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Annualoxygen_saturationCVS_ID": "1.0",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualoxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualoxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualoxygen_saturationdate_created": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualoxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualoxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualoxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualoxygen_saturationdate_issued": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualoxygen_saturationConventions": "CF-1.4",
                "WOA09Grid5x5Annualoxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualoxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualoxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - annual",
                "WOA09Grid5x5Annualoxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Annualoxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualoxygen_saturationdate_modified": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualoxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Annualoxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualoxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualoxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualoxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualoxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Annualoxygen_saturationcreator_name": "NODC",
                "WOA09Grid5x5Annualoxygen_saturationid": "2b5e46cc-4cce-4855-b719-b279230e2452",
                "WOA09Grid5x5Annualoxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualoxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualoxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualoxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualoxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualnitratestandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualnitrateprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualnitratetime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualnitratecdm_data_type": "Grid",
                "WOA09Grid5x5Annualnitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualnitrategeospatial_lat_min": "-90.0",
                "WOA09Grid5x5AnnualnitrateCVS_ID": "1.0",
                "WOA09Grid5x5Annualnitrategeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualnitratetime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualnitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualnitrategeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualnitratedate_created": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualnitratesource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualnitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualnitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualnitratedate_issued": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5AnnualnitrateConventions": "CF-1.4",
                "WOA09Grid5x5Annualnitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualnitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualnitratetitle": "World Ocean Atlas 09:  Nitrate - annual",
                "WOA09Grid5x5Annualnitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid5x5Annualnitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualnitratedate_modified": "2010-9-30T17:29:18Z",
                "WOA09Grid5x5Annualnitrategeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualnitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid5x5Annualnitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualnitratetime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualnitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualnitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualnitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualnitratetime_coverage_start": "1950-05-23",
                "WOA09Grid5x5Annualnitratecreator_name": "NODC",
                "WOA09Grid5x5Annualnitrateid": "df435ff4-06eb-4a2f-b727-634be9907236",
                "WOA09Grid5x5Annualnitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualnitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualnitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5AnnualnitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualnitrategeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualnitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualnitrategeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualdissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualdissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualdissolved_oxygentime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualdissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid5x5Annualdissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Annualdissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualdissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualdissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualdissolved_oxygendate_created": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualdissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualdissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualdissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualdissolved_oxygendate_issued": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualdissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid5x5Annualdissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualdissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualdissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - annual",
                "WOA09Grid5x5Annualdissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Annualdissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualdissolved_oxygendate_modified": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualdissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Annualdissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualdissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualdissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualdissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualdissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Annualdissolved_oxygencreator_name": "NODC",
                "WOA09Grid5x5Annualdissolved_oxygenid": "7f5ec8b4-4b02-489d-b6af-a414106be6a1",
                "WOA09Grid5x5Annualdissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualdissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualdissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualdissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualdissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationtime_coverage_resolution": "P1Y",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lat_resolution": "5.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lon_resolution": "5.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationdate_created": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationdate_issued": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - annual",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationdate_modified": "2010-9-30T17:29:17Z",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationid": "142ca968-a9af-4385-aa51-b11837c45e13",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid5x5Annualapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid5x5Annuallong_name": "Annual",
                "WOA09Grid1x1Seasonaltemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonaltemperatureprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonaltemperaturetime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonaltemperaturecdm_data_type": "Grid",
                "WOA09Grid1x1Seasonaltemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid1x1SeasonaltemperatureCVS_ID": "1.0",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonaltemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonaltemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonaltemperaturedate_created": "2010-9-30T15:18:01Z",
                "WOA09Grid1x1Seasonaltemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonaltemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonaltemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonaltemperaturedate_issued": "2010-9-30T15:18:01Z",
                "WOA09Grid1x1SeasonaltemperatureConventions": "CF-1.4",
                "WOA09Grid1x1Seasonaltemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaltemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonaltemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - seasonal",
                "WOA09Grid1x1Seasonaltemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid1x1Seasonaltemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonaltemperaturedate_modified": "2010-9-30T15:18:01Z",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonaltemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid1x1Seasonaltemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonaltemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Seasonaltemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonaltemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaltemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid1x1Seasonaltemperaturecreator_name": "NODC",
                "WOA09Grid1x1Seasonaltemperatureid": "3f22f395-8bea-481e-83c3-32e23208e48c",
                "WOA09Grid1x1Seasonaltemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonaltemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1SeasonaltemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonaltemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonaltemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonalsilicatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonalsilicateprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonalsilicatetime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonalsilicatecdm_data_type": "Grid",
                "WOA09Grid1x1Seasonalsilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonalsilicategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1SeasonalsilicateCVS_ID": "1.0",
                "WOA09Grid1x1Seasonalsilicategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonalsilicatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonalsilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonalsilicategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonalsilicatedate_created": "2010-9-30T15:20:30Z",
                "WOA09Grid1x1Seasonalsilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonalsilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonalsilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonalsilicatedate_issued": "2010-9-30T15:20:30Z",
                "WOA09Grid1x1SeasonalsilicateConventions": "CF-1.4",
                "WOA09Grid1x1Seasonalsilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalsilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalsilicatetitle": "World Ocean Atlas 09:  Silicate - seasonal",
                "WOA09Grid1x1Seasonalsilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid1x1Seasonalsilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonalsilicatedate_modified": "2010-9-30T15:20:30Z",
                "WOA09Grid1x1Seasonalsilicategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonalsilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Seasonalsilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonalsilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonalsilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonalsilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonalsilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalsilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Seasonalsilicatecreator_name": "NODC",
                "WOA09Grid1x1Seasonalsilicateid": "86bb329f-1a23-4cd5-92f4-8d83edf8af16",
                "WOA09Grid1x1Seasonalsilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonalsilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonalsilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1SeasonalsilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonalsilicategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonalsilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonalsilicategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonalsalinitystandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonalsalinityprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonalsalinitytime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonalsalinitycdm_data_type": "Grid",
                "WOA09Grid1x1Seasonalsalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid1x1SeasonalsalinityCVS_ID": "1.0",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonalsalinitytime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonalsalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonalsalinitydate_created": "2010-9-30T15:18:28Z",
                "WOA09Grid1x1Seasonalsalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonalsalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonalsalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonalsalinitydate_issued": "2010-9-30T15:18:28Z",
                "WOA09Grid1x1SeasonalsalinityConventions": "CF-1.4",
                "WOA09Grid1x1Seasonalsalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalsalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalsalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - seasonal",
                "WOA09Grid1x1Seasonalsalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid1x1Seasonalsalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonalsalinitydate_modified": "2010-9-30T15:18:28Z",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonalsalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid1x1Seasonalsalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonalsalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Seasonalsalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonalsalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalsalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid1x1Seasonalsalinitycreator_name": "NODC",
                "WOA09Grid1x1Seasonalsalinityid": "f1dd95ec-aaef-4658-bf18-8e94b7c57bca",
                "WOA09Grid1x1Seasonalsalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonalsalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1SeasonalsalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonalsalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonalsalinitygeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonalphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonalphosphateprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonalphosphatetime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonalphosphatecdm_data_type": "Grid",
                "WOA09Grid1x1Seasonalphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonalphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1SeasonalphosphateCVS_ID": "1.0",
                "WOA09Grid1x1Seasonalphosphategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonalphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonalphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonalphosphategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonalphosphatedate_created": "2010-9-30T15:20:19Z",
                "WOA09Grid1x1Seasonalphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonalphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonalphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonalphosphatedate_issued": "2010-9-30T15:20:19Z",
                "WOA09Grid1x1SeasonalphosphateConventions": "CF-1.4",
                "WOA09Grid1x1Seasonalphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalphosphatetitle": "World Ocean Atlas 09:  Phosphate - seasonal",
                "WOA09Grid1x1Seasonalphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid1x1Seasonalphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonalphosphatedate_modified": "2010-9-30T15:20:19Z",
                "WOA09Grid1x1Seasonalphosphategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonalphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Seasonalphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonalphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonalphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonalphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonalphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Seasonalphosphatecreator_name": "NODC",
                "WOA09Grid1x1Seasonalphosphateid": "2bd2d7f1-39c5-4e2c-aaf3-3b33806bf23d",
                "WOA09Grid1x1Seasonalphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonalphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonalphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1SeasonalphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonalphosphategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonalphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonalphosphategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonaloxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonaloxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonaloxygen_saturationtime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonaloxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid1x1Seasonaloxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Seasonaloxygen_saturationCVS_ID": "1.0",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonaloxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonaloxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonaloxygen_saturationdate_created": "2010-9-30T15:19:44Z",
                "WOA09Grid1x1Seasonaloxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonaloxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonaloxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonaloxygen_saturationdate_issued": "2010-9-30T15:19:44Z",
                "WOA09Grid1x1Seasonaloxygen_saturationConventions": "CF-1.4",
                "WOA09Grid1x1Seasonaloxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaloxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonaloxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - seasonal",
                "WOA09Grid1x1Seasonaloxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Seasonaloxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonaloxygen_saturationdate_modified": "2010-9-30T15:19:44Z",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonaloxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Seasonaloxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonaloxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonaloxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonaloxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaloxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Seasonaloxygen_saturationcreator_name": "NODC",
                "WOA09Grid1x1Seasonaloxygen_saturationid": "302ea5f2-9cae-4eb0-9533-2ced1211c8a8",
                "WOA09Grid1x1Seasonaloxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonaloxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonaloxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonaloxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonaloxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonalnitratestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonalnitrateprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonalnitratetime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonalnitratecdm_data_type": "Grid",
                "WOA09Grid1x1Seasonalnitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonalnitrategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1SeasonalnitrateCVS_ID": "1.0",
                "WOA09Grid1x1Seasonalnitrategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonalnitratetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonalnitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonalnitrategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonalnitratedate_created": "2010-9-30T15:20:08Z",
                "WOA09Grid1x1Seasonalnitratesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonalnitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonalnitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonalnitratedate_issued": "2010-9-30T15:20:08Z",
                "WOA09Grid1x1SeasonalnitrateConventions": "CF-1.4",
                "WOA09Grid1x1Seasonalnitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalnitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalnitratetitle": "World Ocean Atlas 09:  Nitrate - seasonal",
                "WOA09Grid1x1Seasonalnitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid1x1Seasonalnitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonalnitratedate_modified": "2010-9-30T15:20:08Z",
                "WOA09Grid1x1Seasonalnitrategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonalnitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Seasonalnitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonalnitratetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonalnitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonalnitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonalnitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalnitratetime_coverage_start": "1950-05-23",
                "WOA09Grid1x1Seasonalnitratecreator_name": "NODC",
                "WOA09Grid1x1Seasonalnitrateid": "a65514a8-ab2f-4f77-8e67-5cd143346df1",
                "WOA09Grid1x1Seasonalnitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonalnitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonalnitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1SeasonalnitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonalnitrategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonalnitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonalnitrategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonaldissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonaldissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonaldissolved_oxygentime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonaldissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid1x1Seasonaldissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Seasonaldissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonaldissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonaldissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonaldissolved_oxygendate_created": "2010-9-30T15:18:53Z",
                "WOA09Grid1x1Seasonaldissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonaldissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonaldissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonaldissolved_oxygendate_issued": "2010-9-30T15:18:53Z",
                "WOA09Grid1x1Seasonaldissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid1x1Seasonaldissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaldissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonaldissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - seasonal",
                "WOA09Grid1x1Seasonaldissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Seasonaldissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonaldissolved_oxygendate_modified": "2010-9-30T15:18:53Z",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonaldissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Seasonaldissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonaldissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonaldissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonaldissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonaldissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Seasonaldissolved_oxygencreator_name": "NODC",
                "WOA09Grid1x1Seasonaldissolved_oxygenid": "99347eec-549b-40dd-a5c2-d02b70ab1921",
                "WOA09Grid1x1Seasonaldissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonaldissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonaldissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonaldissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonaldissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationtime_coverage_resolution": "P3M",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationdate_created": "2010-9-30T15:19:19Z",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationdate_issued": "2010-9-30T15:19:19Z",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - seasonal",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationdate_modified": "2010-9-30T15:19:19Z",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationid": "d6e04d6a-24bb-4907-a5e6-1826e8e9c70a",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Seasonalapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Seasonallong_name": "Seasonal",
                "WOA09Grid1x1Monthlytemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlytemperatureprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlytemperaturetime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlytemperaturecdm_data_type": "Grid",
                "WOA09Grid1x1Monthlytemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid1x1MonthlytemperatureCVS_ID": "1.0",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlytemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlytemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlytemperaturedate_created": "2010-9-30T15:20:41Z",
                "WOA09Grid1x1Monthlytemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlytemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlytemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlytemperaturedate_issued": "2010-9-30T15:20:41Z",
                "WOA09Grid1x1MonthlytemperatureConventions": "CF-1.4",
                "WOA09Grid1x1Monthlytemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlytemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlytemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - monthly",
                "WOA09Grid1x1Monthlytemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid1x1Monthlytemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlytemperaturedate_modified": "2010-9-30T15:20:41Z",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlytemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid1x1Monthlytemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlytemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Monthlytemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlytemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlytemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid1x1Monthlytemperaturecreator_name": "NODC",
                "WOA09Grid1x1Monthlytemperatureid": "4614cb88-c9ac-457e-b9a7-fd3d58b912da",
                "WOA09Grid1x1Monthlytemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlytemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1MonthlytemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlytemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlytemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlysilicatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlysilicateprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlysilicatetime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlysilicatecdm_data_type": "Grid",
                "WOA09Grid1x1Monthlysilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlysilicategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1MonthlysilicateCVS_ID": "1.0",
                "WOA09Grid1x1Monthlysilicategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlysilicatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlysilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlysilicategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlysilicatedate_created": "2010-9-30T15:26:19Z",
                "WOA09Grid1x1Monthlysilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlysilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlysilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlysilicatedate_issued": "2010-9-30T15:26:19Z",
                "WOA09Grid1x1MonthlysilicateConventions": "CF-1.4",
                "WOA09Grid1x1Monthlysilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlysilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlysilicatetitle": "World Ocean Atlas 09:  Silicate - monthly",
                "WOA09Grid1x1Monthlysilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid1x1Monthlysilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlysilicatedate_modified": "2010-9-30T15:26:19Z",
                "WOA09Grid1x1Monthlysilicategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlysilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Monthlysilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlysilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlysilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlysilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlysilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlysilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Monthlysilicatecreator_name": "NODC",
                "WOA09Grid1x1Monthlysilicateid": "57c01248-ba87-458a-adcb-99d662115aba",
                "WOA09Grid1x1Monthlysilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlysilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlysilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1MonthlysilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlysilicategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlysilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlysilicategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlysalinitystandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlysalinityprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlysalinitytime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlysalinitycdm_data_type": "Grid",
                "WOA09Grid1x1Monthlysalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlysalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid1x1MonthlysalinityCVS_ID": "1.0",
                "WOA09Grid1x1Monthlysalinitygeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlysalinitytime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlysalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlysalinitygeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlysalinitydate_created": "2010-9-30T15:21:40Z",
                "WOA09Grid1x1Monthlysalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlysalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlysalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlysalinitydate_issued": "2010-9-30T15:21:40Z",
                "WOA09Grid1x1MonthlysalinityConventions": "CF-1.4",
                "WOA09Grid1x1Monthlysalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlysalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlysalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - monthly",
                "WOA09Grid1x1Monthlysalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid1x1Monthlysalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlysalinitydate_modified": "2010-9-30T15:21:40Z",
                "WOA09Grid1x1Monthlysalinitygeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlysalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid1x1Monthlysalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlysalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Monthlysalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlysalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlysalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlysalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid1x1Monthlysalinitycreator_name": "NODC",
                "WOA09Grid1x1Monthlysalinityid": "e006cef8-bbc5-42ac-9e1f-62855976c8d5",
                "WOA09Grid1x1Monthlysalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlysalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlysalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1MonthlysalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlysalinitygeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlysalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlysalinitygeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlyphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlyphosphateprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlyphosphatetime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlyphosphatecdm_data_type": "Grid",
                "WOA09Grid1x1Monthlyphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlyphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1MonthlyphosphateCVS_ID": "1.0",
                "WOA09Grid1x1Monthlyphosphategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlyphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlyphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlyphosphategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlyphosphatedate_created": "2010-9-30T15:25:48Z",
                "WOA09Grid1x1Monthlyphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlyphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlyphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlyphosphatedate_issued": "2010-9-30T15:25:48Z",
                "WOA09Grid1x1MonthlyphosphateConventions": "CF-1.4",
                "WOA09Grid1x1Monthlyphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlyphosphatetitle": "World Ocean Atlas 09:  Phosphate - monthly",
                "WOA09Grid1x1Monthlyphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid1x1Monthlyphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlyphosphatedate_modified": "2010-9-30T15:25:48Z",
                "WOA09Grid1x1Monthlyphosphategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlyphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Monthlyphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlyphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlyphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlyphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlyphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Monthlyphosphatecreator_name": "NODC",
                "WOA09Grid1x1Monthlyphosphateid": "baf58103-f14d-4f1f-8948-b55c1db865df",
                "WOA09Grid1x1Monthlyphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlyphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlyphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1MonthlyphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlyphosphategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlyphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlyphosphategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlyoxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlyoxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlyoxygen_saturationtime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlyoxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid1x1Monthlyoxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Monthlyoxygen_saturationCVS_ID": "1.0",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlyoxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlyoxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlyoxygen_saturationdate_created": "2010-9-30T15:24:24Z",
                "WOA09Grid1x1Monthlyoxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlyoxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlyoxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlyoxygen_saturationdate_issued": "2010-9-30T15:24:24Z",
                "WOA09Grid1x1Monthlyoxygen_saturationConventions": "CF-1.4",
                "WOA09Grid1x1Monthlyoxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyoxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlyoxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - monthly",
                "WOA09Grid1x1Monthlyoxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Monthlyoxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlyoxygen_saturationdate_modified": "2010-9-30T15:24:24Z",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlyoxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Monthlyoxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlyoxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlyoxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlyoxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyoxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Monthlyoxygen_saturationcreator_name": "NODC",
                "WOA09Grid1x1Monthlyoxygen_saturationid": "b9c0e81d-9bc6-4848-8c02-30fcf8c4afb8",
                "WOA09Grid1x1Monthlyoxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlyoxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlyoxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlyoxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlyoxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlynitratestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlynitrateprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlynitratetime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlynitratecdm_data_type": "Grid",
                "WOA09Grid1x1Monthlynitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlynitrategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1MonthlynitrateCVS_ID": "1.0",
                "WOA09Grid1x1Monthlynitrategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlynitratetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlynitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlynitrategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlynitratedate_created": "2010-9-30T15:25:17Z",
                "WOA09Grid1x1Monthlynitratesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlynitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlynitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlynitratedate_issued": "2010-9-30T15:25:17Z",
                "WOA09Grid1x1MonthlynitrateConventions": "CF-1.4",
                "WOA09Grid1x1Monthlynitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlynitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlynitratetitle": "World Ocean Atlas 09:  Nitrate - monthly",
                "WOA09Grid1x1Monthlynitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid1x1Monthlynitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlynitratedate_modified": "2010-9-30T15:25:17Z",
                "WOA09Grid1x1Monthlynitrategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlynitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Monthlynitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlynitratetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlynitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlynitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlynitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlynitratetime_coverage_start": "1950-05-23",
                "WOA09Grid1x1Monthlynitratecreator_name": "NODC",
                "WOA09Grid1x1Monthlynitrateid": "926b1850-c14c-4721-bb97-4e90fee1a573",
                "WOA09Grid1x1Monthlynitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlynitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlynitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1MonthlynitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlynitrategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlynitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlynitrategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlydissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlydissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlydissolved_oxygentime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlydissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid1x1Monthlydissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Monthlydissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlydissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlydissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlydissolved_oxygendate_created": "2010-9-30T15:22:38Z",
                "WOA09Grid1x1Monthlydissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlydissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlydissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlydissolved_oxygendate_issued": "2010-9-30T15:22:38Z",
                "WOA09Grid1x1Monthlydissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid1x1Monthlydissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlydissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlydissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - monthly",
                "WOA09Grid1x1Monthlydissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Monthlydissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlydissolved_oxygendate_modified": "2010-9-30T15:22:38Z",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlydissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Monthlydissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlydissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlydissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlydissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlydissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Monthlydissolved_oxygencreator_name": "NODC",
                "WOA09Grid1x1Monthlydissolved_oxygenid": "7cf0ee8c-1076-4a64-b86f-096e26490953",
                "WOA09Grid1x1Monthlydissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlydissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlydissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlydissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlydissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationtime_coverage_resolution": "P1M",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationdate_created": "2010-9-30T15:23:31Z",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationdate_issued": "2010-9-30T15:23:31Z",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - monthly",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationdate_modified": "2010-9-30T15:23:31Z",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationid": "82864de9-8146-4339-a6dd-e5990bd7880e",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Monthlyapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Monthlylong_name": "Monthly",
                "WOA09Grid1x1Annualtemperaturestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualtemperatureprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualtemperaturetime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualtemperaturecdm_data_type": "Grid",
                "WOA09Grid1x1Annualtemperaturecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualtemperaturegeospatial_lat_min": "-90.0",
                "WOA09Grid1x1AnnualtemperatureCVS_ID": "1.0",
                "WOA09Grid1x1Annualtemperaturegeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualtemperaturetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualtemperaturepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualtemperaturegeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualtemperaturedate_created": "2010-9-30T15:17:15Z",
                "WOA09Grid1x1Annualtemperaturesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualtemperaturenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualtemperaturekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualtemperaturedate_issued": "2010-9-30T15:17:15Z",
                "WOA09Grid1x1AnnualtemperatureConventions": "CF-1.4",
                "WOA09Grid1x1Annualtemperaturecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualtemperaturepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualtemperaturetitle": "World Ocean Atlas 09:  Sea Water Temperature - annual",
                "WOA09Grid1x1Annualtemperaturekeywords": "OCEANS > OCEAN TEMPERATURE > WATER TEMPERATURE",
                "WOA09Grid1x1Annualtemperatureproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualtemperaturedate_modified": "2010-9-30T15:17:15Z",
                "WOA09Grid1x1Annualtemperaturegeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualtemperaturereferences": "Locarnini, R. A., A. V. Mishonov, J. I. Antonov, T. P. Boyer, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 1: Temperature. S. Levitus, Ed. NOAA Atlas NESDIS 68, U.S. Government Printing Office, Washington, D.C., 184 pp. URL: ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text.pdf",
                "WOA09Grid1x1Annualtemperaturelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualtemperaturetime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Annualtemperatureacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualtemperaturegeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualtemperaturepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualtemperaturetime_coverage_start": "1773-1-13",
                "WOA09Grid1x1Annualtemperaturecreator_name": "NODC",
                "WOA09Grid1x1Annualtemperatureid": "035439b0-1809-41ef-b86c-29d5638c0350",
                "WOA09Grid1x1Annualtemperaturesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualtemperaturegeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualtemperaturecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1AnnualtemperatureMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualtemperaturegeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualtemperatureinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualtemperaturegeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualsilicatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualsilicateprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualsilicatetime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualsilicatecdm_data_type": "Grid",
                "WOA09Grid1x1Annualsilicatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualsilicategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1AnnualsilicateCVS_ID": "1.0",
                "WOA09Grid1x1Annualsilicategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualsilicatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualsilicatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualsilicategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualsilicatedate_created": "2010-9-30T15:17:56Z",
                "WOA09Grid1x1Annualsilicatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualsilicatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualsilicatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualsilicatedate_issued": "2010-9-30T15:17:56Z",
                "WOA09Grid1x1AnnualsilicateConventions": "CF-1.4",
                "WOA09Grid1x1Annualsilicatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualsilicatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualsilicatetitle": "World Ocean Atlas 09:  Silicate - annual",
                "WOA09Grid1x1Annualsilicatekeywords": "OCEANS > OCEAN CHEMISTRY > SILICATE",
                "WOA09Grid1x1Annualsilicateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualsilicatedate_modified": "2010-9-30T15:17:56Z",
                "WOA09Grid1x1Annualsilicategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualsilicatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Annualsilicatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualsilicatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualsilicateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualsilicategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualsilicatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualsilicatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Annualsilicatecreator_name": "NODC",
                "WOA09Grid1x1Annualsilicateid": "a9c5599a-aa65-4094-b5f3-c5fb972e90f5",
                "WOA09Grid1x1Annualsilicatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualsilicategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualsilicatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1AnnualsilicateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualsilicategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualsilicateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualsilicategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualsalinitystandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualsalinityprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualsalinitytime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualsalinitycdm_data_type": "Grid",
                "WOA09Grid1x1Annualsalinitycontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualsalinitygeospatial_lat_min": "-90.0",
                "WOA09Grid1x1AnnualsalinityCVS_ID": "1.0",
                "WOA09Grid1x1Annualsalinitygeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualsalinitytime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualsalinitypublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualsalinitygeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualsalinitydate_created": "2010-9-30T15:17:21Z",
                "WOA09Grid1x1Annualsalinitysource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualsalinitynaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualsalinitykeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualsalinitydate_issued": "2010-9-30T15:17:21Z",
                "WOA09Grid1x1AnnualsalinityConventions": "CF-1.4",
                "WOA09Grid1x1Annualsalinitycreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualsalinitypublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualsalinitytitle": "World Ocean Atlas 09:  Sea Water Salinity - annual",
                "WOA09Grid1x1Annualsalinitykeywords": "OCEANS > SALINITY/DENSITY > SALINITY",
                "WOA09Grid1x1Annualsalinityproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualsalinitydate_modified": "2010-9-30T15:17:21Z",
                "WOA09Grid1x1Annualsalinitygeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualsalinityreferences": "Antonov, J. I., D. Seidov, T. P. Boyer, R. A. Locarnini, A. V. Mishonov, and H. E. Garcia, 2010. World Ocean Atlas 2009, Volume 2: Salinity. S. Levitus, Ed. NOAA Atlas NESDIS 69, U.S. Government Printing Office, Washington, D.C., 184 pp. URL:ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol2_text.pdf",
                "WOA09Grid1x1Annualsalinitylicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualsalinitytime_coverage_end": "2008-12-25",
                "WOA09Grid1x1Annualsalinityacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualsalinitygeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualsalinitypublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualsalinitytime_coverage_start": "1890-06-27",
                "WOA09Grid1x1Annualsalinitycreator_name": "NODC",
                "WOA09Grid1x1Annualsalinityid": "414cbd6c-3dc3-49fb-8e6d-9b744f5cd810",
                "WOA09Grid1x1Annualsalinitysummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualsalinitygeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualsalinitycreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1AnnualsalinityMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualsalinitygeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualsalinityinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualsalinitygeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualphosphatestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualphosphateprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualphosphatetime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualphosphatecdm_data_type": "Grid",
                "WOA09Grid1x1Annualphosphatecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualphosphategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1AnnualphosphateCVS_ID": "1.0",
                "WOA09Grid1x1Annualphosphategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualphosphatetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualphosphatepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualphosphategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualphosphatedate_created": "2010-9-30T15:17:50Z",
                "WOA09Grid1x1Annualphosphatesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualphosphatenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualphosphatekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualphosphatedate_issued": "2010-9-30T15:17:50Z",
                "WOA09Grid1x1AnnualphosphateConventions": "CF-1.4",
                "WOA09Grid1x1Annualphosphatecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualphosphatepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualphosphatetitle": "World Ocean Atlas 09:  Phosphate - annual",
                "WOA09Grid1x1Annualphosphatekeywords": "OCEANS > OCEAN CHEMISTRY > PHOSPHATE",
                "WOA09Grid1x1Annualphosphateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualphosphatedate_modified": "2010-9-30T15:17:50Z",
                "WOA09Grid1x1Annualphosphategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualphosphatereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Annualphosphatelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualphosphatetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualphosphateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualphosphategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualphosphatepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualphosphatetime_coverage_start": "1933-07-24",
                "WOA09Grid1x1Annualphosphatecreator_name": "NODC",
                "WOA09Grid1x1Annualphosphateid": "6c91b03a-0329-4101-b16a-296eed92fd65",
                "WOA09Grid1x1Annualphosphatesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualphosphategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualphosphatecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1AnnualphosphateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualphosphategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualphosphateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualphosphategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualoxygen_saturationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualoxygen_saturationprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualoxygen_saturationtime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualoxygen_saturationcdm_data_type": "Grid",
                "WOA09Grid1x1Annualoxygen_saturationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Annualoxygen_saturationCVS_ID": "1.0",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualoxygen_saturationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualoxygen_saturationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualoxygen_saturationdate_created": "2010-9-30T15:17:39Z",
                "WOA09Grid1x1Annualoxygen_saturationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualoxygen_saturationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualoxygen_saturationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualoxygen_saturationdate_issued": "2010-9-30T15:17:39Z",
                "WOA09Grid1x1Annualoxygen_saturationConventions": "CF-1.4",
                "WOA09Grid1x1Annualoxygen_saturationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualoxygen_saturationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualoxygen_saturationtitle": "World Ocean Atlas 09:  Oxygen Saturation - annual",
                "WOA09Grid1x1Annualoxygen_saturationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Annualoxygen_saturationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualoxygen_saturationdate_modified": "2010-9-30T15:17:39Z",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualoxygen_saturationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Annualoxygen_saturationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualoxygen_saturationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualoxygen_saturationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualoxygen_saturationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualoxygen_saturationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Annualoxygen_saturationcreator_name": "NODC",
                "WOA09Grid1x1Annualoxygen_saturationid": "48aeff7b-0e0f-4f66-8b13-955e1cd9139c",
                "WOA09Grid1x1Annualoxygen_saturationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualoxygen_saturationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualoxygen_saturationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualoxygen_saturationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualoxygen_saturationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualnitratestandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualnitrateprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualnitratetime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualnitratecdm_data_type": "Grid",
                "WOA09Grid1x1Annualnitratecontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualnitrategeospatial_lat_min": "-90.0",
                "WOA09Grid1x1AnnualnitrateCVS_ID": "1.0",
                "WOA09Grid1x1Annualnitrategeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualnitratetime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualnitratepublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualnitrategeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualnitratedate_created": "2010-9-30T15:17:45Z",
                "WOA09Grid1x1Annualnitratesource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualnitratenaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualnitratekeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualnitratedate_issued": "2010-9-30T15:17:45Z",
                "WOA09Grid1x1AnnualnitrateConventions": "CF-1.4",
                "WOA09Grid1x1Annualnitratecreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualnitratepublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualnitratetitle": "World Ocean Atlas 09:  Nitrate - annual",
                "WOA09Grid1x1Annualnitratekeywords": "OCEANS > OCEAN CHEMISTRY > NITRATE",
                "WOA09Grid1x1Annualnitrateproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualnitratedate_modified": "2010-9-30T15:17:45Z",
                "WOA09Grid1x1Annualnitrategeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualnitratereferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 4: Nutrients (phosphate, nitrate, silicate).  S. Levitus, Ed. NOAA Atlas NESDIS 71, U.S. Government Printing Office, Washington, D.C., 398 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol4_text.pdf",
                "WOA09Grid1x1Annualnitratelicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualnitratetime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualnitrateacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualnitrategeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualnitratepublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualnitratetime_coverage_start": "1950-05-23",
                "WOA09Grid1x1Annualnitratecreator_name": "NODC",
                "WOA09Grid1x1Annualnitrateid": "28005a23-22ae-4e2b-b826-eec6e7da3b8e",
                "WOA09Grid1x1Annualnitratesummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualnitrategeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualnitratecreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1AnnualnitrateMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualnitrategeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualnitrateinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualnitrategeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualdissolved_oxygenstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualdissolved_oxygenprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualdissolved_oxygentime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualdissolved_oxygencdm_data_type": "Grid",
                "WOA09Grid1x1Annualdissolved_oxygencontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Annualdissolved_oxygenCVS_ID": "1.0",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualdissolved_oxygentime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualdissolved_oxygenpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualdissolved_oxygendate_created": "2010-9-30T15:17:27Z",
                "WOA09Grid1x1Annualdissolved_oxygensource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualdissolved_oxygennaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualdissolved_oxygenkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualdissolved_oxygendate_issued": "2010-9-30T15:17:27Z",
                "WOA09Grid1x1Annualdissolved_oxygenConventions": "CF-1.4",
                "WOA09Grid1x1Annualdissolved_oxygencreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualdissolved_oxygenpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualdissolved_oxygentitle": "World Ocean Atlas 09:  Dissolved Oxygen - annual",
                "WOA09Grid1x1Annualdissolved_oxygenkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Annualdissolved_oxygenproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualdissolved_oxygendate_modified": "2010-9-30T15:17:27Z",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualdissolved_oxygenreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Annualdissolved_oxygenlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualdissolved_oxygentime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualdissolved_oxygenacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualdissolved_oxygenpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualdissolved_oxygentime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Annualdissolved_oxygencreator_name": "NODC",
                "WOA09Grid1x1Annualdissolved_oxygenid": "57f07d58-1e0f-4237-b8a9-8e3434d25c92",
                "WOA09Grid1x1Annualdissolved_oxygensummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualdissolved_oxygencreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualdissolved_oxygenMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualdissolved_oxygeninstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualdissolved_oxygengeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationstandard_name_vocabulary": "CF",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationprocessing_level": "synthesized product",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationtime_coverage_resolution": "P1Y",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationcdm_data_type": "Grid",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationcontributor_name": "Ocean Climate Laboratory",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lat_min": "-90.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationCVS_ID": "1.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lat_resolution": "1.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationtime_coverage_duration": "P1Y",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationpublisher_name": "National Oceanographic Data Center(NODC)",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lon_resolution": "1.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationdate_created": "2010-9-30T15:17:33Z",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationsource": "Please see the acknowledgement and References",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationnaming_authority": "gov.noaa.nodc",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationkeywords_vocabulary": "Global Change Master Directory",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationdate_issued": "2010-9-30T15:17:33Z",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationConventions": "CF-1.4",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationcreator_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationpublisher_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationtitle": "World Ocean Atlas 09:  Apparent Oxygen Utilization - annual",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationkeywords": "OCEANS > OCEAN CHEMISTRY > OXYGEN",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationproject": "World Ocean Atlas - 2009",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationdate_modified": "2010-9-30T15:17:33Z",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lat_max": "90.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationreferences": "Garcia, H. E., R. A. Locarnini, T. P. Boyer, and J. I. Antonov, 2010. World Ocean Atlas 2009, Volume 3: Dissolved Oxygen, Apparent Oxygen Utilization, and Oxygen Saturation. S. Levitus, Ed. NOAA Atlas NESDIS 70, U.S. Government Printing Office, Washington, D.C., 344 pp. ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol3_text.pdf",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationlicense": "This data is free for anyone to use, reuse and redistribute without any restriction. NOAA and NODC make no warranty, expressed or implied, nor does the fact of distribution constitute such a warranty. NOAA and NODC cannot assume liability for any damages caused by any errors or omissions in the data.",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationtime_coverage_end": "2008-02-16",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationacknowledgment": " We acknowledge the scientists, technicians, and programmers who have collected and processed data, those individuals who have submitted data to national and regional data centers as well as the managers and staff at the various data centers. We thank our colleagues at the NODC. Their efforts have made this and similar works possible.",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lon_units": "degrees_north",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationpublisher_email": "NODC.Services@noaa.gov",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationtime_coverage_start": "1921-03-21",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationcreator_name": "NODC",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationid": "a8b474dd-517d-45c7-ae06-4a9a2ef309cd",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationsummary": "World Ocean Atlas 2009 (WOA09) is a set of objectively analyzed (1 degree grid) climatological fields of in situ temperature, salinity, dissolved oxygen, Apparent Oxygen Utilization (AOU), percent oxygen saturation, phosphate, silicate, and nitrate at standard depth levels for annual, seasonal, and monthly compositing periods for the World Ocean. It also includes associated statistical fields of observed oceanographic profile data interpolated to standard depth levels on both 1 degree and 5 degree grids. For more details, please see http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lat_units": "degrees_east",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationcreator_url": "http://www.nodc.noaa.gov",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationMetadata_Convention": "Unidata Dataset Discovery v1.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lon_min": "0.0",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationinstitution": "National Oceanographic Data Center(NODC), NOAA",
                "WOA09Grid1x1Annualapparent_oxygen_utilizationgeospatial_lon_max": "360.0",
                "WOA09Grid1x1Annuallong_name": "Annual",
                "WOA09references": "Locarnini_etal2010 Antonov_etal2010 Garcia_etal2010v3 Garcia_etal2010v4",
                "WOA09World": "ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09_vol1_text_figures.pdf",
                "WOA09description": "World Ocean Atlas 2009, an atlas of objectively analyzed fields of major ocean parameters at monthly, seasonal, and annual time scales",
                "WOA09dataset_documentation": "ftp://ftp.nodc.noaa.gov/pub/WOA09/DOC/woa09documentation.pdf",
                "WOA09source": "ftp://ftp.nodc.noaa.gov/pub/WOA09/",
                "WOA09WOA09_Product_Page": "http://www.nodc.noaa.gov/OC5/WOA09/pr_woa09.html",
                "WOA09iridlhasSemantics": "iridl:Ocean",
                "WOA05Grid5x5Seasonalselong_name": "standard error",
                "WOA05Grid5x5Seasonalsdlong_name": "standard deviation",
                "WOA05Grid5x5Seasonalmnlong_name": "statistical mean",
                "WOA05Grid5x5Seasonalddlong_name": "number of observations",
                "WOA05Grid5x5Monthlyselong_name": "standard error",
                "WOA05Grid5x5Monthlysdlong_name": "standard deviation",
                "WOA05Grid5x5Monthlymnlong_name": "statistical mean",
                "WOA05Grid5x5Monthlyddlong_name": "number of observations",
                "WOA05Grid5x5Annualselong_name": "standard error",
                "WOA05Grid5x5Annualsdlong_name": "standard deviation",
                "WOA05Grid5x5Annualmnlong_name": "statistical mean",
                "WOA05Grid5x5Annualddlong_name": "number of observations",
                "WOA05Grid1x1Seasonalselong_name": "standard error",
                "WOA05Grid1x1Seasonalsdlong_name": "standard deviation",
                "WOA05Grid1x1Seasonaloalong_name": "interpolation error",
                "WOA05Grid1x1Seasonalmnlong_name": "statistical mean",
                "WOA05Grid1x1Seasonalmalong_name": "difference from annual mean",
                "WOA05Grid1x1Seasonalgplong_name": "grid points of influence",
                "WOA05Grid1x1Seasonalddlong_name": "number of observations",
                "WOA05Grid1x1Seasonalanlong_name": "objectively analyzed mean",
                "WOA05Grid1x1Monthlyselong_name": "standard error",
                "WOA05Grid1x1Monthlysdlong_name": "standard deviation",
                "WOA05Grid1x1Monthlyoalong_name": "interpolation error",
                "WOA05Grid1x1Monthlymnlong_name": "statistical mean",
                "WOA05Grid1x1Monthlymalong_name": "difference from annual mean",
                "WOA05Grid1x1Monthlygplong_name": "grid points of influence",
                "WOA05Grid1x1Monthlyddlong_name": "number of observations",
                "WOA05Grid1x1Monthlyanlong_name": "objectively analyzed mean",
                "WOA05Grid1x1Annualselong_name": "standard error",
                "WOA05Grid1x1Annualsdlong_name": "standard deviation",
                "WOA05Grid1x1Annualoalong_name": "interpolation error",
                "WOA05Grid1x1Annualmnlong_name": "statistical mean",
                "WOA05Grid1x1Annualgplong_name": "grid points of influence",
                "WOA05Grid1x1Annualddlong_name": "number of observations",
                "WOA05Grid1x1Annualanlong_name": "objectively analyzed mean",
                "WOA05references": "Locarnini_etal2006 Antonov_etal2006 Garcia_etal2006v3 Garcia_etal2006v4",
                "WOA05dataset_documentation": "ftp://ftp.nodc.noaa.gov/pub/WOA05/DOC/woa05documentation.pdf",
                "WOA05description": "World Ocean Atlas 2005, an atlas of objectively analyzed fields of major ocean parameters at monthly, seasonal, and annual time scales.  Superseded by WOA09",
                "WOA05source": "ftp://ftp.nodc.noaa.gov/pub/WOA05/",
                "WOA05WOA09": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA09/",
                "WOA05iridlhasSemantics": "iridl:Ocean",
                "WOA05WOA05_Product_Page": "http://www.nodc.noaa.gov/OC5/WOA05/pr_woa05.html",
                "WOA01Grid5x5Seasonalselong_name": "standard error",
                "WOA01Grid5x5Seasonalsdlong_name": "standard deviation",
                "WOA01Grid5x5Seasonalmnlong_name": "unanalyzed mean",
                "WOA01Grid5x5Seasonalddlong_name": "number of observations",
                "WOA01Grid5x5Monthlyselong_name": "standard error",
                "WOA01Grid5x5Monthlysdlong_name": "standard deviation",
                "WOA01Grid5x5Monthlymnlong_name": "unanalyzed mean",
                "WOA01Grid5x5Monthlyddlong_name": "number of observations",
                "WOA01Grid5x5Annualselong_name": "standard error",
                "WOA01Grid5x5Annualsdlong_name": "standard deviation",
                "WOA01Grid5x5Annualmnlong_name": "unanalyzed mean",
                "WOA01Grid5x5Annualddlong_name": "number of observations",
                "WOA01Grid1x1Seasonalselong_name": "standard error",
                "WOA01Grid1x1Seasonalsdlong_name": "standard deviation",
                "WOA01Grid1x1Seasonaloalong_name": "interpolation error",
                "WOA01Grid1x1Seasonalmnplanktonlong_name": "zooplankton biomass",
                "WOA01Grid1x1Seasonalmnlong_name": "unanalyzed mean",
                "WOA01Grid1x1Seasonalmalong_name": "difference from annual",
                "WOA01Grid1x1Seasonalgplong_name": "grid points of influence",
                "WOA01Grid1x1Seasonalddplanktonlong_name": "zooplankton biomass",
                "WOA01Grid1x1Seasonalddlong_name": "number of observations",
                "WOA01Grid1x1Seasonalanlong_name": "objectively analyzed mean",
                "WOA01Grid1x1Monthlyselong_name": "standard error",
                "WOA01Grid1x1Monthlysdlong_name": "standard deviation",
                "WOA01Grid1x1Monthlyoalong_name": "interpolation error",
                "WOA01Grid1x1Monthlymnlong_name": "unanalyzed mean",
                "WOA01Grid1x1Monthlymalong_name": "difference from annual",
                "WOA01Grid1x1Monthlygplong_name": "grid points of influence",
                "WOA01Grid1x1Monthlyddlong_name": "number of observations",
                "WOA01Grid1x1Monthlyanlong_name": "objectively analyzed mean",
                "WOA01Grid1x1Annualselong_name": "standard error",
                "WOA01Grid1x1Annualsdlong_name": "standard deviation",
                "WOA01Grid1x1Annualoalong_name": "interpolation_error",
                "WOA01Grid1x1Annualmnplanktonlong_name": "zooplankton biomass",
                "WOA01Grid1x1Annualmnlong_name": "unanalyzed mean",
                "WOA01Grid1x1Annualgplong_name": "grid points of influence",
                "WOA01Grid1x1Annualddplanktonlong_name": "zooplankton biomass",
                "WOA01Grid1x1Annualddlong_name": "number of observations",
                "WOA01Grid1x1Annualanlong_name": "objectively analyzed mean",
                "WOA01WOA05": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA05/",
                "WOA01references": "Conkright_etal2002 Levitus1982",
                "WOA01description": "World Ocean Atlas 2001, an atlas of objectively analyzed fields of major ocean parameters at monthly, seasonal, and annual time scales.  Superseded by WOA05",
                "WOA01iridlhasSemantics": "iridl:Ocean",
                "WOA01dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NODC/.WOA01.dataset_documentation.html",
                "description": "National Oceanographic Data Center",
                "Conventions": "IRIDL"
            },
            "WOA98": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WOA98",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SEASONAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SEASONAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "se": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "se",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "sd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "raw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "raw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "gridpt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridpt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "dist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "analyzed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "analyzed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    }
                },
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "se": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "se",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "sd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "raw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "raw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "gridpt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridpt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "dist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "analyzed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "analyzed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    }
                },
                "ANNUAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ANNUAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "se": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "se",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "sd": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sd",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "raw": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "raw",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    },
                    "gridpt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridpt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "dist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-100.0"
                        }
                    },
                    "analyzed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "analyzed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "temperature",
                            "missing_value": "-99.999901"
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "PSU",
                            "long_name": "salinity",
                            "missing_value": "-99.999901"
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "Phosphate",
                            "missing_value": "-99.999901"
                        },
                        "o2sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "o2sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "missing_value": "-99.999901"
                        },
                        "O2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "dissolved oxygen",
                            "missing_value": "-99.999901"
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "missing_value": "-99.999901"
                        },
                        "chlorophyll": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "chlorophyll",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "micro mole/l",
                            "long_name": "chlorophyll",
                            "missing_value": "-99.999901"
                        },
                        "AOU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AOU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ml/l",
                            "long_name": "apparent oxygen utilization",
                            "missing_value": "-99.999901"
                        }
                    }
                }
            },
            "WOA09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WOA09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Masks": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Masks",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mixnumber": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mixnumber",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "mix number",
                        "valid_min": "-2",
                        "missing_value": "-100",
                        "valid_max": "2"
                    },
                    "landsea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landsea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "transition depth level",
                        "long_name": "landsea mask",
                        "missing_value": "-100"
                    },
                    "basin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "58",
                        "units": "ids",
                        "scale_min": "1",
                        "valid_max": "58",
                        "valid_min": "1",
                        "CLIST": "East Indian Atlantic Basin",
                        "long_name": "basin code",
                        "missing_value": "-100.0"
                    }
                },
                "Grid5x5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-5x5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            }
                        }
                    }
                },
                "Grid1x1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-1x1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "t_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_temperature",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Temperature for seasonal time period at each one-degree square at each standard depth.",
                                "units": "degrees Celsius",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "long_name": "Sea Water Temperature"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "i_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_silicate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Silicate for seasonal time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "long_name": "Silicate"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "s_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_salinity",
                                "grid_mapping": "crs",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Salinity for seasonal time period at each one-degree square at each standard depth.",
                                "units": "unitless",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "long_name": "Sea Water Salinity"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "p_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_phosphate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Phosphate for seasonal time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "long_name": "Phosphate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "O_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Oxygen Saturation",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Oxygen Saturation for seasonal time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "n_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_nitrate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Nitrate for seasonal time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "long_name": "Nitrate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "o_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Dissolved Oxygen",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Dissolved Oxygen for seasonal time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "A_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Apparent Oxygen Utilization",
                                "cell_methods": "time:mean within seasons time:mean over seasons",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Apparent Oxygen Utilization for seasonal time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "t_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_temperature",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Temperature for monthly time period at each one-degree square at each standard depth.",
                                "units": "degrees Celsius",
                                "cell_methods": "time:mean within months time:mean over months",
                                "long_name": "Sea Water Temperature"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "i_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_silicate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Silicate for monthly time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within months time:mean over months",
                                "long_name": "Silicate"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "s_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_salinity",
                                "grid_mapping": "crs",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Salinity for monthly time period at each one-degree square at each standard depth.",
                                "units": "unitless",
                                "cell_methods": "time:mean within months time:mean over months",
                                "long_name": "Sea Water Salinity"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "p_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_phosphate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Phosphate for monthly time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within months time:mean over months",
                                "long_name": "Phosphate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "O_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Oxygen Saturation",
                                "cell_methods": "time:mean within months time:mean over months",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Oxygen Saturation for monthly time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "n_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_nitrate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Nitrate for monthly time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within months time:mean over months",
                                "long_name": "Nitrate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "o_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Dissolved Oxygen",
                                "cell_methods": "time:mean within months time:mean over months",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Dissolved Oxygen for monthly time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_oa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_oa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean minus Objectively Analyzed Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The statistical mean minus the climatological mean at each one-degree square at each standard depth. This value is used as an estimate of interpolation and smoothing error.",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "A_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Apparent Oxygen Utilization",
                                "cell_methods": "time:mean within months time:mean over months",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Apparent Oxygen Utilization for monthly time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Temperature",
                                "grid_mapping": "crs"
                            },
                            "t_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degrees Celsius",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "t_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "t_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Temperature in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "t_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_temperature",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Temperature for annual time period at each one-degree square at each standard depth.",
                                "units": "degrees Celsius",
                                "cell_methods": "time:mean within years time:mean over years",
                                "long_name": "Sea Water Temperature"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "silicate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "silicate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "i_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Silicate",
                                "grid_mapping": "crs"
                            },
                            "i_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "i_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "i_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Silicate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "i_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_silicate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Silicate for annual time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within years time:mean over years",
                                "long_name": "Silicate"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "salinity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "salinity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "s_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Sea Water Salinity",
                                "grid_mapping": "crs"
                            },
                            "s_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "s_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "s_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Sea Water Salinity in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "s_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "s_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "sea_water_salinity",
                                "grid_mapping": "crs",
                                "salinity_scale": "Practical Salinity Scale(PSS-78)",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Sea Water Salinity for annual time period at each one-degree square at each standard depth.",
                                "units": "unitless",
                                "cell_methods": "time:mean within years time:mean over years",
                                "long_name": "Sea Water Salinity"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "phosphate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "phosphate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Phosphate",
                                "grid_mapping": "crs"
                            },
                            "p_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "p_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "p_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Phosphate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "p_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_phosphate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Phosphate for annual time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within years time:mean over years",
                                "long_name": "Phosphate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "oxygen_saturation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oxygen_saturation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "O_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Oxygen Saturation",
                                "grid_mapping": "crs"
                            },
                            "O_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "O_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "O_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Oxygen Saturation in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "O_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Oxygen Saturation",
                                "cell_methods": "time:mean within years time:mean over years",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Oxygen Saturation for annual time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "nitrate": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nitrate",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "n_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Nitrate",
                                "grid_mapping": "crs"
                            },
                            "n_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "n_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "n_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Nitrate in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "n_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "mole_concentration_of_nitrate_in_sea_water",
                                "grid_mapping": "crs",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Nitrate for annual time period at each one-degree square at each standard depth.",
                                "units": "micro mole/l",
                                "cell_methods": "time:mean within years time:mean over years",
                                "long_name": "Nitrate"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "dissolved_oxygen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dissolved_oxygen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "o_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Dissolved Oxygen",
                                "grid_mapping": "crs"
                            },
                            "o_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "o_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "o_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Dissolved Oxygen in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "o_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Dissolved Oxygen",
                                "cell_methods": "time:mean within years time:mean over years",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Dissolved Oxygen for annual time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            },
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            }
                        },
                        "apparent_oxygen_utilization": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apparent_oxygen_utilization",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Longitude Bounds"
                            },
                            "lat_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Latitude Bounds"
                            },
                            "climatology_bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "climatology_bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "description": "Climatology Bounds"
                            },
                            "A_se": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_se",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Error of the Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard error of the mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_sd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_sd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Standard Deviation from Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The standard deviation about the statistical mean in each one-degree square at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_mn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_mn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Statistical Mean",
                                "missing_value": "9.96920997E36",
                                "description": "The average of all unflagged interpolated values at each standard depth level in each one-degree square which contains at least one measurement of Apparent Oxygen Utilization",
                                "grid_mapping": "crs"
                            },
                            "A_ma": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_ma",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Seasonal or Monthly Climatology minus Annual Climatology",
                                "missing_value": "9.96920997E36",
                                "description": "The seasonal or monthly climatology minus the annual climatology at each one-degree square at each standard depth",
                                "grid_mapping": "crs"
                            },
                            "A_gp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_gp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Mean Values within Radius of Influence",
                                "missing_value": "-2147483647",
                                "description": "The number of one-degree squares within the smallest radius of influence around each one-degree square which contain a statistical mean.",
                                "grid_mapping": "crs"
                            },
                            "A_dd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_dd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Number of Observations",
                                "missing_value": "-2147483647",
                                "description": "The number of observations of Apparent Oxygen Utilization in each one-degree square of the World Ocean at each standard depth level",
                                "grid_mapping": "crs"
                            },
                            "A_an": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A_an",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "Apparent Oxygen Utilization",
                                "cell_methods": "time:mean within years time:mean over years",
                                "missing_value": "9.96920997E36",
                                "description": "The objectively interpolated mean field for Apparent Oxygen Utilization for annual time period at each one-degree square at each standard depth.",
                                "grid_mapping": "crs"
                            }
                        }
                    }
                }
            },
            "WOA05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WOA05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Masks": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Masks",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mixnumber": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mixnumber",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "mix number",
                        "valid_min": "-2",
                        "missing_value": "-100",
                        "valid_max": "2"
                    },
                    "landsea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landsea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "transition depth level",
                        "long_name": "landsea mask",
                        "missing_value": "-100"
                    },
                    "basin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "58",
                        "units": "ids",
                        "scale_min": "1",
                        "valid_max": "58",
                        "valid_min": "1",
                        "CLIST": "East Indian Atlantic Basin",
                        "long_name": "basin code",
                        "missing_value": "-100.0"
                    }
                },
                "Grid5x5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-5x5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        }
                    }
                },
                "Grid1x1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-1x1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "ma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "ma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Temperature",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Silicate",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Salinity",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Phosphate",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "o2sat",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "Nitrate",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "Temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "Salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "o2sat",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    }
                }
            },
            "WOA01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WOA01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Masks": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Masks",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "landsea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landsea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-100",
                        "units": "unitless"
                    },
                    "basin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-100",
                        "units": "unitless"
                    }
                },
                "Grid5x5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-5x5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "Z": "Z_04",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        }
                    }
                },
                "Grid1x1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Grid-1x1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seasonal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "plankton": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "plankton",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "carbon content",
                                    "missing_value": "-100.0"
                                }
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "ma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "Z": "Z_04",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "plankton": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "plankton",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "cc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "carbon content",
                                    "missing_value": "-100.0"
                                }
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "Z": "Z_04",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "Z": "Z_04",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    },
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "ma": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ma",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    },
                    "Annual": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "se": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "se",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "sd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "oa": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "mn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "plankton": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "plankton",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "wet mass",
                                    "missing_value": "-100.0"
                                },
                                "sv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "settled volume",
                                    "missing_value": "-100.0"
                                },
                                "dv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "displacement volume",
                                    "missing_value": "-100.0"
                                },
                                "dm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "dry mass",
                                    "missing_value": "-100.0"
                                },
                                "cc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mg-C/m^3",
                                    "long_name": "carbon content",
                                    "missing_value": "-100.0"
                                },
                                "am": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "am",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "ash-free dry mass",
                                    "missing_value": "-100.0"
                                }
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        },
                        "gp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "dd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "plankton": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "plankton",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "wet mass",
                                    "missing_value": "-100.0"
                                },
                                "sv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "settled volume",
                                    "missing_value": "-100.0"
                                },
                                "dv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ml/m^3",
                                    "long_name": "displacement volume",
                                    "missing_value": "-100.0"
                                },
                                "dm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "dry mass",
                                    "missing_value": "-100.0"
                                },
                                "cc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mg-C/m^3",
                                    "long_name": "carbon content",
                                    "missing_value": "-100.0"
                                },
                                "am": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "am",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "micrograms/l",
                                    "long_name": "ash-free dry mass",
                                    "missing_value": "-100.0"
                                }
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "missing_value": "-100.0"
                            }
                        },
                        "an": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "an",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temperature": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temperature",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "temperature",
                                "missing_value": "-99.999901"
                            },
                            "silicate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "silicate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Silicate",
                                "missing_value": "-99.999901"
                            },
                            "salinity": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "salinity",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "long_name": "salinity",
                                "missing_value": "-99.999901"
                            },
                            "phosphate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phosphate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Phosphate",
                                "missing_value": "-99.999901"
                            },
                            "o2sat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "o2sat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "missing_value": "-99.999901"
                            },
                            "O2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "O2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "dissolved oxygen",
                                "missing_value": "-99.999901"
                            },
                            "nitrate": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nitrate",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micro mole/l",
                                "long_name": "Nitrate",
                                "missing_value": "-99.999901"
                            },
                            "chlorophyll": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "chlorophyll",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "micrograms/l",
                                "long_name": "chlorophyll",
                                "missing_value": "-99.999901"
                            },
                            "aou": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aou",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ml/l",
                                "long_name": "apparent oxygen utilization",
                                "missing_value": "-99.999901"
                            }
                        }
                    }
                }
            },
            "lon_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "bounds": "lon_bnds",
                "long_name": "longitude",
                "standard_name": "longitude",
                "axis": "X",
                "description": "Longitude Range: 0 to 360 degrees with 0 at Greenwich Meridian and increasing along the east.",
                "modulus": "360.0"
            },
            "lat_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "bounds": "lat_bnds",
                "long_name": "latitude",
                "standard_name": "latitude",
                "axis": "Y",
                "description": "Latitude Range: -90 to 90 degrees with 0 at the Equator and increasing along the north."
            },
            "time_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 2008-1-1",
                "gridtype": "0",
                "climatology": "climatology_bnds",
                "long_name": "time",
                "standard_name": "time",
                "axis": "T",
                "description": "Annual Climatology",
                "calendar": "standard"
            },
            "time_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 01-Jan",
                "gridtype": "1",
                "modulus": "12.0",
                "calendar": "360",
                "pointwidth": "3.0",
                "modulo": "12.0"
            },
            "depth_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "depth_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "axis": "Z",
                "positive": "down",
                "long_name": "depth",
                "standard_name": "depth",
                "description": "Standard Depth Levels"
            },
            "time_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 01-Jan",
                "gridtype": "1",
                "modulus": "12.0",
                "calendar": "360",
                "pointwidth": "1.0",
                "modulo": "12.0"
            },
            "depth_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "depth_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "axis": "Z",
                "positive": "down",
                "long_name": "depth",
                "standard_name": "depth",
                "description": "Standard Depth Levels"
            },
            "nv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 2008-1-1",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "0"
            },
            "depth": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "depth",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "axis": "Z",
                "positive": "down",
                "long_name": "depth",
                "standard_name": "depth",
                "description": "Standard Depth Levels"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "bounds": "lon_bnds",
                "long_name": "longitude",
                "standard_name": "longitude",
                "axis": "X",
                "description": "Longitude Range: 0 to 360 degrees with 0 at Greenwich Meridian and increasing along the east.",
                "modulus": "360.0"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "bounds": "lat_bnds",
                "long_name": "latitude",
                "standard_name": "latitude",
                "axis": "Y",
                "description": "Latitude Range: -90 to 90 degrees with 0 at the Equator and increasing along the north."
            },
            "Z_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "Depth"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "5.0",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "5.0",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "Z_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "0",
                "longname": "Depth",
                "long_name": "Depth"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "pointwidth": "3.0",
                "standard_name": "time",
                "long_name": "Time",
                "modulo": "12.0",
                "modulus": "12.0",
                "calendar": "360"
            },
            "Z_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "longname": "Depth",
                "long_name": "Depth"
            },
            "Z_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "longname": "Depth",
                "long_name": "Depth"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "time",
                "long_name": "Time",
                "modulo": "12.0",
                "modulus": "12.0",
                "calendar": "360"
            },
            "Z_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "longname": "Depth",
                "long_name": "Depth"
            },
            "Z": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Z",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "longname": "Depth",
                "long_name": "Depth"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "longitude",
                "long_name": "Longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude",
                "long_name": "Latitude"
            },
            "dir": "SOURCES/NOAA/NODC"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "ERL",
            "ESRL",
            "GCPS",
            "NCDC",
            "NCEP",
            "NCEPDOE",
            "NCEPNCAR",
            "NESDIS",
            "NGDC",
            "NODC"
        ]
    },
    "OBERHUBER": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "OBERHUBER",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Conventions": "IRIDL",
            "references": "Oberhuber1988",
            "description": "Max Planck Institute heat flux and surface radiation climatology over global oceans",
            "iridlhasSemantics": "iridl:MPI_Met",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.OBERHUBER/.dataset_documentation.html"
        },
        "wssi": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "wssi",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "r.m.s. wind speed",
            "units": "m/s",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "v": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "v",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind speed",
            "units": "m/s",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "ustar": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ustar",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "frictional velocity",
            "units": "m/s",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "umag": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "umag",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "wind speed",
            "units": "m/s",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "u": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "u",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind speed",
            "units": "m/s",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-9990000.0",
            "long_name": "meridional wind stress",
            "units": "dyne/cm2",
            "history": "COADS climatology from Oberhuber"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-9990000.0",
            "long_name": "zonal wind stress",
            "units": "dyne/cm2",
            "history": "COADS climatology from Oberhuber"
        },
        "tair": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tair",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "air temperature",
            "units": "Celsius_scale",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "sst": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "sst",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "mixed layer temperature",
            "units": "Celsius_scale",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "solr": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "solr",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "solar radiation",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "slp": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "slp",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "sea level pressure",
            "units": "mb",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "shfx": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "shfx",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "sensible heat flux",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "rhum": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "rhum",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "relative humidity",
            "units": "unitless",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "rfx": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "rfx",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "net radiation",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "precipitation": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "precipitation",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "precipitation",
            "units": "mm/month",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "pme": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pme",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "net freshwater flux",
            "units": "mm/month",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "lwfx": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lwfx",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "outgoing longwave radiation",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "lhfx": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lhfx",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "latent heat flux",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "hfx": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "hfx",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "net downward heat flux",
            "units": "W/m2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "dqdt": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "dqdt",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "newtonian cooling rate",
            "units": "W K-1 m-2",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "cld": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "cld",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "cloud cover",
            "units": "octas",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "ce": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ce",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "transfer coefficient for latent heat",
            "units": "unitless",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "buoy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "buoy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "buoyancy flux",
            "units": "m2/s3",
            "missing_value": "-999.0",
            "history": "COADS climatology from Oberhuber"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/OBERHUBER"
    },
    "OORT": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "OORT",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "references": "Oort1983",
            "description": "Global atmospheric circulation statistics/analysis from the Geophysical Fluid Dynamics Laboratory based on weather station, ship, and buoy data",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.OORT/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "Surface": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Surface",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "zdelzdel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "zdelzdel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zdel variance",
                "units": "gpm2"
            },
            "zdel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "zdel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Z-Zsurface",
                "units": "gpm"
            },
            "vv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m2/s2"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridonal velocity",
                "units": "m/s"
            },
            "uu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m2/s2"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal velocity",
                "units": "m/s"
            },
            "TaTa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TaTa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degreeC2"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale"
            },
            "SSTSST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SSTSST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degreeC2"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "qaqa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qaqa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "qa variance",
                "units": "g2/kg2"
            }
        },
        "StdDev": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "StdDev",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "zdel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "zdel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridonal velocity",
                "units": "m/s"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal velocity",
                "units": "m/s"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "humidity",
                "units": "g/kg",
                "missing_value": "1.00000000E10"
            }
        },
        "Mean": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Mean",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "zdel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "zdel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "colormap": "2763429",
                "scale_max": "4.1999998",
                "ncolor": "254",
                "scale_min": "-4.1999998",
                "colorscalename": "custom",
                "long_name": "meridonal velocity"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "colormap": "2763429",
                "scale_max": "4.1999998",
                "ncolor": "254",
                "scale_min": "-4.1999998",
                "colorscalename": "custom",
                "long_name": "zonal velocity"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "humidity",
                "units": "g/kg",
                "missing_value": "1.00000000E10"
            },
            "omega": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "omega",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "vertical wind",
                "units": "10e-4 mb/s"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "gridtype": "0",
            "long_name": "Pressure"
        },
        "dir": "SOURCES/OORT"
    },
    "OSU": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "OSU",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "PRISMv2019024kmNorm81msource": "ftp://prism.nacse.org/monthly/",
            "PRISMv2019024kmNorm81mdataset_documentation": "http://www.prism.oregonstate.edu/",
            "PRISMv2019024kmNorm81mTerms_of_Use": "http://prism.oregonstate.edu/documents/PRISM_terms_of_use.pdf",
            "PRISMv2019024kmNorm81mPRISMCG": "http://www.prismclimate.org",
            "PRISMv2019024kmNorm81mreferences": "Daly_etal2008 Daly_etal2015",
            "PRISMv2019024kmNorm81mdescription": "1981-2010 Monthly Climatology",
            "PRISMv2019024kmNorm81mDataset_Description": "http://www.prism.oregonstate.edu/documents/PRISM_datasets.pdf",
            "PRISMv2019024kmAN81mstabledescription": "Stable release version",
            "PRISMv2019024kmAN81mreferences": "Daly_etal2008 Daly_etal2015",
            "PRISMv2019024kmAN81mTerms_of_Use": "http://prism.oregonstate.edu/documents/PRISM_terms_of_use.pdf",
            "PRISMv2019024kmAN81mdataset_documentation": "http://www.prism.oregonstate.edu/",
            "PRISMv2019024kmAN81mdescription": "All Networks Monthly Time Series, with 1981 Starting Year of Climatology (see Norm81m)",
            "PRISMv2019024kmAN81mPRISMCG": "http://www.prismclimate.org",
            "PRISMv2019024kmAN81msource": "ftp://prism.nacse.org/monthly/",
            "PRISMv2019024kmAN81mDataset_Description": "http://www.prism.oregonstate.edu/documents/PRISM_datasets.pdf",
            "PRISMv2019024kmreferences": "Daly_etal2008 Daly_etal2015",
            "PRISMv2019024kmdescription": "Data at 2.5 min, or approx 4km spatial resolution",
            "PRISMv201902references": "Daly_etal2008 Daly_etal2015",
            "PRISMv201902description": "Data Available from PRISM as of 1 Feb 2019, Advancing Monthly",
            "PRISMclimatologylong_name": "climatology 1971-2000",
            "PRISMreferences": "Daly_etal1994 Daly_etal2002",
            "PRISMdataset_documentation": "http://www.prism.oregonstate.edu/",
            "PRISMPRISMCG": "http://www.prismclimate.org",
            "iridlhasSemantics": "iridl:OSU",
            "Conventions": "IRIDL"
        },
        "PRISM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PRISM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v201902": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v201902",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "km": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "4km",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Norm81m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Norm81m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vpdmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vpdmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Average Daily Minimum Vapor Pressure Deficit",
                            "standard_name": "water_vapor_saturation_deficit_in_air",
                            "units": "hPa",
                            "pointwidth": "1.0"
                        },
                        "vpdmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vpdmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Average Daily Maximum Vapor Pressure Deficit",
                            "standard_name": "water_vapor_saturation_deficit_in_air",
                            "units": "hPa",
                            "pointwidth": "1.0"
                        },
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Minimum Temperature",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "pointwidth": "1.0"
                        },
                        "tmean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Mean Temperature",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "pointwidth": "1.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Maximum Temperature",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "pointwidth": "1.0"
                        },
                        "tdmean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdmean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Mean Dew Point Temperature",
                            "standard_name": "dew_point_temperature",
                            "units": "Celsius_scale",
                            "pointwidth": "1.0"
                        },
                        "ppt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ppt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-9999.0",
                            "long_name": "Precipitation",
                            "standard_name": "precipitation_amount",
                            "units": "mm/month",
                            "pointwidth": "1.0"
                        }
                    },
                    "AN81m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AN81m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "stable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vpdmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpdmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Average Daily Minimum Vapor Pressure Deficit",
                                "standard_name": "water_vapor_saturation_deficit_in_air",
                                "units": "hPa",
                                "pointwidth": "1.0"
                            },
                            "vpdmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vpdmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Average Daily Maximum Vapor Pressure Deficit",
                                "standard_name": "water_vapor_saturation_deficit_in_air",
                                "units": "hPa",
                                "pointwidth": "1.0"
                            },
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Minimum Temperature",
                                "standard_name": "air_temperature",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            },
                            "tmean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Mean Temperature",
                                "standard_name": "air_temperature",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Maximum Temperature",
                                "standard_name": "air_temperature",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            },
                            "tdmean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tdmean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Mean Dew Point Temperature",
                                "standard_name": "dew_point_temperature",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            },
                            "ppt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ppt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Precipitation",
                                "standard_name": "precipitation_amount",
                                "units": "mm/month",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                }
            },
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "air_temperature",
                    "missing_value": "-9999",
                    "units": "Celsius_scale",
                    "scale_factor": "0.01",
                    "pointwidth": "120"
                },
                "tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "air_temperature",
                    "missing_value": "-9999",
                    "units": "Celsius_scale",
                    "scale_factor": "0.01",
                    "pointwidth": "120"
                },
                "tdmean": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tdmean",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "dew_point_temperature",
                    "missing_value": "-9999",
                    "units": "Celsius_scale",
                    "scale_factor": "0.01",
                    "pointwidth": "120"
                },
                "ppt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ppt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "precipitation_amount",
                    "missing_value": "-9999",
                    "units": "mm",
                    "scale_factor": "0.01",
                    "pointwidth": "120"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "air_temperature",
                    "missing_value": "-9999",
                    "units": "Celsius_scale",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "air_temperature",
                    "missing_value": "-9999",
                    "units": "Celsius_scale",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "ppt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ppt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "standard_name": "precipitation_amount",
                    "missing_value": "-9999",
                    "units": "mm",
                    "scale_factor": "0.01",
                    "pointwidth": "1.0",
                    "modulo": "12.0",
                    "modulus": "12.0"
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/OSU"
    },
    "OSUSFC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "OSUSFC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981",
            "references": "Esbensen:Kushnir1981",
            "description": "Global ocean heat flux and wind stress from Oregon State University Climate Research Institute",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.OSUSFC/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:OSU",
            "Conventions": "IRIDL"
        },
        "DATA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DATA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "wspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Air Temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea Surface Temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "solar radiation",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea level pressure",
                "units": "mb",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "shfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sensible heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "rfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "net downward radiative flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "lwfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lwfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "longwave heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "lhfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lhfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "latent heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "hfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "net downward heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "dtsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dtsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea-Air Temperature Difference",
                "units": "degree_Celsius",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "dqsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dqsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea-Air Humidity Difference",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "cloudiness",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            }
        },
        "CNTS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CNTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "wspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for wind speed",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for Air Temperature",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for Sea Surface Temperature",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for sea level pressure",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for specific humidity",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "shfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for sensible heat flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "lwfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lwfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for longwave heat flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "lhfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lhfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for latent heat flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "hfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for net downward heat flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "dtsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dtsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for Sea-Air Temperature Difference",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            },
            "dqsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dqsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "log10(number of observations) for Sea-Air Humidity Difference",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Averaged surface data Esbensen and Kushnir OSU CRI#29 1981"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "4.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/OSUSFC"
    },
    "Oxford": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Oxford",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Zoologyseegmalariar5km_meanreferences": ">Air temperature suitability for Plasmodium falciparum malaria transmission in Africa 2000-2012: a high-resolution spatiotemporal prediction. Daniel J Weiss, Samir Bhatt, Bonnie Mappin, Thomas P Van Boeckel, David L Smith, Simon I Hay and Peter W Gething. Malaria Journal 2014, 13:171 doi:10.1186/1475-2875-13-171</a>",
            "Zoologyseegmalariar1kmreferences": ">Air temperature suitability for Plasmodium falciparum malaria transmission in Africa 2000-2012: a high-resolution spatiotemporal prediction. Daniel J Weiss, Samir Bhatt, Bonnie Mappin, Thomas P Van Boeckel, David L Smith, Simon I Hay and Peter W Gething. Malaria Journal 2014, 13:171 doi:10.1186/1475-2875-13-171</a>",
            "Zoologyseegdescription": "spatial ecology and epidemiology group",
            "Zoologydescription": "Department of Zoology",
            "description": "Univeristy of Oxford",
            "iridlhasSemantics": "iridl:UO",
            "Conventions": "IRIDL"
        },
        "Zoology": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Zoology",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "seeg": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "seeg",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "malaria": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "malaria",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "r5km_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "r5km_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "TSI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TSI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "25600",
                            "scale_max": "1.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "1",
                            "missing_value": "-9999.0",
                            "long_name": "malaria Temperature Suitability Index",
                            "units": "unitless",
                            "pointwidth": "1.0"
                        }
                    },
                    "r1km": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "r1km",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "TSI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TSI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "25600",
                            "scale_max": "1.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "1",
                            "missing_value": "-9999.0",
                            "long_name": "malaria Temperature Suitability Index",
                            "units": "unitless",
                            "pointwidth": "1.0"
                        }
                    }
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.04166665",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.04166665",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.008333347",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.008333347",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/Oxford"
    },
    "PAGASA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "PAGASA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "APHRO_PH_005degdescription": "Philippines APHRODITE at 0.05 degree",
            "PAGASA": "http://www.pagasa.dost.gov.ph/",
            "description": "Philippine Atmospheric, Geophysical and Astronomical Services Administration",
            "iridlhasSemantics": "iridl:PAGASA",
            "Conventions": "IRIDL"
        },
        "monthly": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "monthly",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "station": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "station",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "yrstart": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "yrstart",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "yrend": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "yrend",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids "
                },
                "Province": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Province",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm/month",
                    "long_name": "precipitation",
                    "missing_value": "-2.0"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "scale_max": "132.0",
                    "long_name": "Longitude",
                    "scale_min": "114.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "scale_max": "22.0",
                    "long_name": "Latitude",
                    "scale_min": "3.0"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "meters"
                }
            }
        },
        "daily": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "daily",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "stations": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stations",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "STN_NO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STN_NO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "STATION_NAME": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STATION_NAME",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "PROVINCE": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PROVINCE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipitation",
                    "missing_value": "-9.8999996",
                    "units": "mm/day"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Longitude",
                    "scale_max": "132.0",
                    "scale_min": "114.0",
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Latitude",
                    "scale_max": "22.0",
                    "scale_min": "3.0",
                    "units": "degree_north"
                },
                "ELEVATION": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ELEVATION",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "meters"
                }
            }
        },
        "APHRO_PH_005deg": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "APHRO_PH_005deg",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "precip": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "precip",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "0.0",
                "CS": "0",
                "colormap": "290304",
                "maxncolor": "254",
                "ncolor": "254",
                "colorscalename": "precip_colors",
                "units": "mm/day",
                "long_name": "daily precipitation",
                "missing_value": "-99.900002",
                "pointwidth": "0"
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "STNID_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Station"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "standard"
        },
        "STNID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Station"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.05",
            "standard_name": "latitude",
            "long_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "standard",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.04999999",
            "standard_name": "longitude",
            "long_name": "longitude"
        },
        "dir": "SOURCES/PAGASA"
    },
    "PALEO": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "PALEO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "TreeRingsreconstructionNADA2004": "http://iridl.ldeo.columbia.edu/SOURCES/.LDEO/.TRL/.NADA2004/",
            "TreeRingsreconstructioniridlhasSemantics": "iriref:Cook_ER",
            "TreeRingsdescription": "Reconstruction of Palmer Drought Index for the United States based on tree ring data",
            "description": "Reconstruction of Palmer Drought Index for the United States based on tree ring data",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "TreeRings": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TreeRings",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "reconstruction": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "reconstruction",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "drought": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "drought",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "Palmer Drought Index",
                    "iridlhasSemantics": "iridl:PalmerDroughtSeverityIndex",
                    "missing_value": "NaN",
                    "CS": "-5",
                    "CE": "5",
                    "colormap": "12632256"
                }
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "long_name": "Time",
            "pointwidth": "3.0",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "3.0",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/PALEO"
    },
    "PDA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "PDA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "BAWPmetstationsAlldescription": "Buhi, Nabua and Polangui meteorological stations",
            "BAWPdescription": "Bicol Agri-Water Project",
            "description": "Philippines Department of Agriculture",
            "Conventions": "IRIDL"
        },
        "BAWP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "BAWP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "metstations": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "metstations",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "POLANGUI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "POLANGUI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rainfall": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "missing_value": "-222.0",
                        "long_name": "daily total rainfall",
                        "units": "mm",
                        "pointwidth": "1.0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lon",
                        "scale_max": "125.0",
                        "scale_min": "122.0",
                        "long_name": "Longitude"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lon"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lat",
                        "scale_max": "15.0",
                        "scale_min": "11.2",
                        "long_name": "Latitude"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA label",
                        "long_name": "Label"
                    }
                },
                "NABUA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NABUA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rainfall": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "missing_value": "-222.0",
                        "long_name": "daily total rainfall",
                        "units": "mm",
                        "pointwidth": "1.0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "history": "FID:  1-014 to 1-020 appended from PDA BAWP metstations BUHI lon",
                        "scale_max": "125.0",
                        "scale_min": "122.0",
                        "long_name": "Longitude"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0",
                        "history": "FID:  1-014 to 1-020 appended from PDA BAWP metstations BUHI lon"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "history": "FID:  1-014 to 1-020 appended from PDA BAWP metstations BUHI lat",
                        "scale_max": "15.0",
                        "scale_min": "11.2",
                        "long_name": "Latitude"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "history": "FID:  1-014 to 1-020 appended from PDA BAWP metstations BUHI label",
                        "long_name": "Label"
                    }
                },
                "BUHI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "BUHI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rainfall": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "missing_value": "-222.0",
                        "long_name": "daily total rainfall",
                        "units": "mm",
                        "pointwidth": "1.0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0",
                        "long_name": "Longitude"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "15.0",
                        "units": "degree_north",
                        "scale_min": "11.2",
                        "long_name": "Latitude"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Label"
                    }
                },
                "All": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "All",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rainfall": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "history": "FID:  1-014 to 1-020 appended from PDA BAWP metstations BUHI rainfall",
                        "scale_min": "0.0",
                        "CS": "0",
                        "colormap": "290304",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "colorscalename": "precip_colors",
                        "missing_value": "-222.0",
                        "long_name": "daily total rainfall",
                        "units": "mm",
                        "pointwidth": "1.0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lon",
                        "long_name": "Longitude"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "OpenGISSimpleFeature": "Point",
                        "scale_max": "125.0",
                        "units": "degree_east",
                        "scale_min": "122.0",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lon"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "15.0",
                        "units": "degree_north",
                        "scale_min": "11.2",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA lat",
                        "long_name": "Latitude"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "history": "FID:  1-008 to 1-020 appended from PDA BAWP metstations NABUA label",
                        "long_name": "Label"
                    }
                }
            }
        },
        "FID_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "FID_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "FID_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "FID_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "FID_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "FID_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0"
        },
        "FID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "FID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2",
            "calendar": "standard",
            "pointwidth": "1"
        },
        "dir": "SOURCES/PDA"
    },
    "PELTIER": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "PELTIER",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "references": "Peltier1994",
            "description": "Ice age paleotopography from a gravitationally self-consistent theory",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.PELTIER/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:U_Toronto",
            "Conventions": "IRIDL"
        },
        "topography": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "topography",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "colormap": "12632256",
            "scale_max": "8000.0",
            "ncolor": "254",
            "scale_min": "-10000.0",
            "CS": "-10000",
            "colorscalename": "custom",
            "CE": "8000"
        },
        "ice": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ice",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "KBP",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/PELTIER"
    },
    "Princeton": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Princeton",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "VICDatasetDocumentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Princeton/.VIC.DatasetDocumentation.html",
            "VICreferences": "Sheffield_Wood2007 Sheffield_etal2006",
            "VICdescription": "VIC Hydrologic Cycle Model",
            "VICiridlhasSemantics": "iriref:Sheffield_J iriref:Wood_EF iriref:Goteti_G",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailysource": "Forcings are a hybrid of NCEP/NCAR reanalysis and observations",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailycontact": "Justin Sheffield (justin@princeton.edu)",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailyreferences": "Chaney_Sheffield2013 Sheffield_etal2006",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailytitle": "Princeton University Hydroclimatology Group Bias Corrected African (1979-2005) Meteorological Forcing Dataset V1.0",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailyHigh": "http://hydrology.princeton.edu/data.metdata_africa.php",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailyinstitution": "Princeton University",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailyhistory": "regridded by averaging to match gridding of CHIRPS v1.8 daily precipitation dataset over spatial domain common to both at 0.25 deg lat/lon resolution",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25dailycomment": "This dataset is described in Chaney and Sheffield (2012) (Chaney, N., and J. Sheffield, 2012: High Resolution Gridded Daily Meteorological Data for Africa: Dataset Development and Analysis of Trends in Means and Extremes, J. Climate, to be submitted) and is related to the original global version reported in Sheffield et al., J. Climate (2006). Updates/changes include: i. African continent domain; ii. extension to 2005; iii. assimilation of available GHCN/GSOD daily station observations; iv. step change detection and correction for observational datasets; v. improved sampling procedure for correction of rain day statistics; vi. use of latest versions of CRU, SRB and TRMM products; vii. improved consistency between specific and relative humidity and air temperature. See Sheffield et al., J. Climate (2006) for details of the observations used and the bias correction and downscaling methodology.",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdeg0p25description": "Regridded to 0.25 deg lat/lon resolution",
            "hydrologymetdataNWE_Africav1p0regriddedtoCHIRPSdescription": "Regridded to match spatial gridding of CHIRPS precipitation data",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailysource": "Forcings are a hybrid of NCEP/NCAR reanalysis and observations",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailycontact": "Justin Sheffield (justin@princeton.edu)",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailyreferences": "Chaney_Sheffield2013 Sheffield_etal2006",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailytitle": "Princeton University Hydroclimatology Group Bias Corrected African (1979-2005) Meteorological Forcing Dataset V1.0",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailyHigh": "http://hydrology.princeton.edu/data.metdata_africa.php",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Princeton/.hydrology.metdata.NWE_Africa.v1p0.regriddedtoARC2.daily.dataset_documentation.html",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailyinstitution": "Princeton University",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailyhistory": "regridded by averaging to match gridding of ARC2 daily precipitation dataset over spatial domain common to both",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailycomment": "This dataset is described in Chaney and Sheffield (2012) (Chaney, N., and J. Sheffield, 2012: High Resolution Gridded Daily Meteorological Data for Africa: Dataset Development and Analysis of Trends in Means and Extremes, J. Climate, to be submitted) and is related to the original global version reported in Sheffield et al., J. Climate (2006). Updates/changes include: i. African continent domain; ii. extension to 2005; iii. assimilation of available GHCN/GSOD daily station observations; iv. step change detection and correction for observational datasets; v. improved sampling procedure for correction of rain day statistics; vi. use of latest versions of CRU, SRB and TRMM products; vii. improved consistency between specific and relative humidity and air temperature. See Sheffield et al., J. Climate (2006) for details of the observations used and the bias correction and downscaling methodology.",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2dailygetting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Princeton/.hydrology.metdata.NWE_Africa.v1p0.regriddedtoARC2.daily.getting_permission.html",
            "hydrologymetdataNWE_Africav1p0regriddedtoARC2description": "Regridded to match spatial gridding of ARC2 precipitation data",
            "hydrologymetdataNWE_Africav1p0originaldailysource": "Forcings are a hybrid of NCEP/NCAR reanalysis and observations",
            "hydrologymetdataNWE_Africav1p0originaldailycontact": "Justin Sheffield (justin@princeton.edu)",
            "hydrologymetdataNWE_Africav1p0originaldailyreferences": "Chaney_Sheffield2013 Sheffield_etal2006",
            "hydrologymetdataNWE_Africav1p0originaldailytitle": "Princeton University Hydroclimatology Group Bias Corrected African (1979-2005) Meteorological Forcing Dataset V1.0",
            "hydrologymetdataNWE_Africav1p0originaldailyHigh": "http://hydrology.princeton.edu/data.metdata_africa.php",
            "hydrologymetdataNWE_Africav1p0originaldailydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Princeton/.hydrology.metdata.NWE_Africa.v1p0.original.daily.dataset_documentation.html",
            "hydrologymetdataNWE_Africav1p0originaldailyinstitution": "Princeton University",
            "hydrologymetdataNWE_Africav1p0originaldailyhistory": "Thu Feb  7 13:23:02 EST 2013: created by JS using convert2alma.sh",
            "hydrologymetdataNWE_Africav1p0originaldailygetting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Princeton/.hydrology.metdata.NWE_Africa.v1p0.original.daily.getting_permission.html",
            "hydrologymetdataNWE_Africav1p0originaldailycomment": "This dataset is described in Chaney and Sheffield (2012) (Chaney, N., and J. Sheffield, 2012: High Resolution Gridded Daily Meteorological Data for Africa: Dataset Development and Analysis of Trends in Means and Extremes, J. Climate, to be submitted) and is related to the original global version reported in Sheffield et al., J. Climate (2006). Updates/changes include: i. African continent domain; ii. extension to 2005; iii. assimilation of available GHCN/GSOD daily station observations; iv. step change detection and correction for observational datasets; v. improved sampling procedure for correction of rain day statistics; vi. use of latest versions of CRU, SRB and TRMM products; vii. improved consistency between specific and relative humidity and air temperature. See Sheffield et al., J. Climate (2006) for details of the observations used and the bias correction and downscaling methodology.",
            "hydrologymetdataNWE_Africadescription": "High resolution daily meteorological data for northern/west/east Africa",
            "hydrologymetdatadescription": "Meteorological Data",
            "hydrologydescription": "Terrestrial Hydrology Research Group",
            "iridlhasSemantics": "iridl:Princeton_University",
            "Conventions": "IRIDL"
        },
        "VIC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "VIC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "runoff": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "runoff",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "0.02075372",
                "units": "kg m-2 s-1",
                "title": "mean monthly runoff",
                "valid_min": "0.0",
                "long_name": "Mean monthly runoff",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Calculated as the sum of surface runoff and subsurface baseflow",
                "missing_value": "2.00000004E20"
            },
            "prcp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "prcp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "0.023825",
                "units": "kg m-2 s-1",
                "title": "mean monthly precipitation",
                "valid_min": "0.0",
                "long_name": "Mean monthly precipitation",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model.",
                "missing_value": "2.00000004E20"
            },
            "mrwso": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "mrwso",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "100.02883",
                "units": "percent",
                "title": "mean monthly soil wetness layer 1",
                "valid_min": "10.851552",
                "long_name": "Mean monthly soil wetness in model layer 1",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Wetness is depth of water divided by max possible depth of water",
                "missing_value": "2.00000004E20"
            },
            "moist3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "moist3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "100.38085",
                "units": "kg/m^2",
                "title": "mean monthly soil moisture layer 3",
                "valid_min": "2.3623705",
                "long_name": "Mean monthly soil moisture depth in layer 3",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Calculated as the depth of water in the soil layer",
                "missing_value": "2.00000004E20"
            },
            "moist2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "moist2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "577.66779",
                "units": "kg/m^2",
                "title": "mean monthly soil moisture layer 2",
                "valid_min": "33.757736",
                "long_name": "Mean monthly soil moisture depth in layer 2",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Calculated as the depth of water in the soil layer",
                "missing_value": "2.00000004E20"
            },
            "moist1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "moist1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "201.31572",
                "units": "kg/m^2",
                "title": "mean monthly soil moisture layer 1",
                "valid_min": "14.773803",
                "long_name": "Mean monthly soil moisture depth in layer 1",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Calculated as the depth of water in the soil layer",
                "missing_value": "2.00000004E20"
            },
            "evap": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "evap",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "valid_max": "0.002476974",
                "units": "kg m-2 s-1",
                "title": "mean monthly evapotranspiration",
                "valid_min": "-9.02257452E-04",
                "long_name": "Mean monthly evapotranspiration",
                "date": "01/01/48",
                "source": "Derived from daily output from the VIC model. Includes evaporation from the soil and canopy, transpiration and snow sublimation",
                "missing_value": "2.00000004E20"
            }
        },
        "hydrology": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "hydrology",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "metdata": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "metdata",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NWE_Africa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NWE_Africa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "regriddedtoCHIRPS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "regriddedtoCHIRPS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "deg0p25": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "deg0p25",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m s-1",
                                        "long_name": "Windspeed",
                                        "title": "Daily 10m windspeed",
                                        "standard_name": "wind_speed",
                                        "valid_min": "0.0",
                                        "missing_value": "NaN",
                                        "valid_max": "30.0",
                                        "file_missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "colormap": "255",
                                        "scale_max": "57.0",
                                        "maxncolor": "254",
                                        "ncolor": "237",
                                        "scale_min": "-18.0",
                                        "CS": "-18.0",
                                        "CE": "57.0",
                                        "units": "Celsius_scale",
                                        "long_name": "Minimum temperature",
                                        "title": "Daily bias corrected minimum temperature",
                                        "standard_name": "air_temperature",
                                        "valid_min": "-30.0",
                                        "missing_value": "NaN",
                                        "valid_max": "80.0",
                                        "file_missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "colormap": "255",
                                        "scale_max": "57.0",
                                        "maxncolor": "254",
                                        "ncolor": "237",
                                        "scale_min": "-18.0",
                                        "CS": "-18.0",
                                        "CE": "57.0",
                                        "units": "Celsius_scale",
                                        "long_name": "Maximum temperature",
                                        "title": "Daily bias corrected maximum temperature",
                                        "standard_name": "air_temperature",
                                        "valid_min": "-30.0",
                                        "missing_value": "NaN",
                                        "valid_max": "80.0",
                                        "file_missing_value": "-999.0",
                                        "pointwidth": "0"
                                    },
                                    "elev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "elev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "source": "NOAA NGDC ETOPO1 z_ice data selected over the NWE_Africa region and regridded to 0.25 deg. lat/lon gridding to match CHIRPS precipitation data",
                                        "units": "m",
                                        "ncolor": "239",
                                        "colormap": "[16777215 16777215 13826810 [8576494 15] [2139610 30] [755384 44] [2970272 150] 2970272]",
                                        "history": "[(Boxes with less than 0.0% dropped) (Boxes with less than 0.0% dropped)]",
                                        "actual_range": "8224.0",
                                        "scale_max": "8752.0",
                                        "standard_name": "surface_altitude",
                                        "long_name": "ice surface elevation/bathymetry",
                                        "maxncolor": "254",
                                        "missing_value": "NaN",
                                        "CE": "8752",
                                        "scale_min": "0.0",
                                        "CS": "0"
                                    },
                                    "dswrf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dswrf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "W/m2",
                                        "long_name": "Downward Surface Shortwave Radiation",
                                        "title": "Daily downward surface shortwave radiation",
                                        "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                        "valid_min": "60.0",
                                        "missing_value": "NaN",
                                        "valid_max": "450.0",
                                        "file_missing_value": "-999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "regriddedtoARC2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "regriddedtoARC2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m s-1",
                                    "long_name": "Windspeed",
                                    "title": "Daily 10m windspeed",
                                    "standard_name": "wind_speed",
                                    "valid_min": "0.0",
                                    "missing_value": "2.00000004E20",
                                    "date": "01/01/79",
                                    "valid_max": "30.0",
                                    "pointwidth": "0"
                                },
                                "tmin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "255",
                                    "scale_max": "57.0",
                                    "maxncolor": "254",
                                    "ncolor": "237",
                                    "scale_min": "-18.0",
                                    "CS": "-18.0",
                                    "CE": "57.0",
                                    "units": "Celsius_scale",
                                    "long_name": "Minimum temperature",
                                    "title": "Daily bias corrected minimum temperature",
                                    "standard_name": "air_temperature",
                                    "valid_min": "-30.0",
                                    "missing_value": "2.00000004E20",
                                    "date": "01/01/79",
                                    "valid_max": "80.0",
                                    "pointwidth": "0"
                                },
                                "tmax": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmax",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "255",
                                    "scale_max": "57.0",
                                    "maxncolor": "254",
                                    "ncolor": "237",
                                    "scale_min": "-18.0",
                                    "CS": "-18.0",
                                    "CE": "57.0",
                                    "units": "Celsius_scale",
                                    "long_name": "Maximum temperature",
                                    "title": "Daily bias corrected maximum temperature",
                                    "standard_name": "air_temperature",
                                    "valid_min": "-30.0",
                                    "missing_value": "2.00000004E20",
                                    "date": "01/01/79",
                                    "valid_max": "80.0",
                                    "pointwidth": "0"
                                },
                                "shum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "shum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Specific humidity",
                                    "title": "Daily bias corrected 2m specific humidity",
                                    "standard_name": "specific_humidity",
                                    "valid_min": "0.0",
                                    "missing_value": "2.00000004E20",
                                    "date": "01/01/79",
                                    "valid_max": "60.0",
                                    "pointwidth": "0"
                                },
                                "dswrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dswrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Downward Surface Shortwave Radiation",
                                    "title": "Daily downward surface shortwave radiation",
                                    "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                    "valid_min": "60.0",
                                    "missing_value": "NaN",
                                    "valid_max": "450.0",
                                    "file_missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "ARC2_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ARC2_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1615214100",
                                    "colormap": "14053594",
                                    "scale_max": "600.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "600",
                                    "units": "mm/day",
                                    "description": "CPC/Africa Rainfall Climatology 2: Daily Values",
                                    "long_name": "Estimated Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "missing_value": "-999.0",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "original": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "original",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "wind_speed",
                                    "long_name": "Windspeed",
                                    "units": "m s-1",
                                    "title": "Daily 10m windspeed",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "tmin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "255",
                                    "scale_max": "330.0",
                                    "maxncolor": "254",
                                    "ncolor": "237",
                                    "scale_min": "255.0",
                                    "CS": "255.0",
                                    "CE": "330.0",
                                    "standard_name": "air_temperature",
                                    "long_name": "Minimum temperature",
                                    "units": "Kelvin_scale",
                                    "title": "Daily bias corrected minimum temperature",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "tmax": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmax",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "255",
                                    "scale_max": "330.0",
                                    "maxncolor": "254",
                                    "ncolor": "237",
                                    "scale_min": "255.0",
                                    "CS": "255.0",
                                    "CE": "330.0",
                                    "standard_name": "air_temperature",
                                    "long_name": "Maximum temperature",
                                    "units": "Kelvin_scale",
                                    "title": "Daily bias corrected maximum temperature",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "255",
                                    "scale_max": "330.0",
                                    "maxncolor": "254",
                                    "ncolor": "237",
                                    "scale_min": "255.0",
                                    "CS": "255.0",
                                    "CE": "330.0",
                                    "standard_name": "air_temperature",
                                    "long_name": "Mean temperature",
                                    "units": "Kelvin_scale",
                                    "title": "Daily bias corrected mean temperature",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "shum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "shum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "title": "Daily bias corrected 2m specific humidity",
                                    "long_name": "Specific humidity",
                                    "standard_name": "specific_humidity",
                                    "units": "unitless",
                                    "missing_value": "2.00000004E20",
                                    "date": "01/01/79",
                                    "valid_min": "0.0",
                                    "pointwidth": "0"
                                },
                                "pres": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pres",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "air_pressure",
                                    "long_name": "Surface Pressure",
                                    "units": "Pa",
                                    "title": "Daily Surface Pressure",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "2.00000004E20",
                                    "title": "Daily bias corrected precipitation",
                                    "long_name": "Precipitation",
                                    "standard_name": "precipitation_flux",
                                    "units": "kg m-2 s-1",
                                    "date": "01/01/79",
                                    "valid_max": "0.006",
                                    "valid_min": "0.0",
                                    "pointwidth": "0"
                                },
                                "dswrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dswrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "surface_downwelling_shortwave_flux_in_air",
                                    "long_name": "Downward Surface Shortwave Radiation",
                                    "units": "W/m2",
                                    "title": "Daily downward surface shortwave radiation",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                },
                                "dlwrf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dlwrf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "surface_downwelling_longwave_flux_in_air",
                                    "long_name": "Downward Surface Longwave Radiation",
                                    "units": "W/m2",
                                    "title": "Daily downward surface longwave radiation",
                                    "missing_value": "-999.0",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                }
            }
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1948-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "level",
            "gridtype": "0"
        },
        "latitude": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "latitude",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "point_spacing": "even"
        },
        "longitude": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "longitude",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "1.0",
            "modulo": " ",
            "point_spacing": "even"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "longitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01 12:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1615214100",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01 12:00:00",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "time",
            "calendar": "standard"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/Princeton"
    },
    "RC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "RC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "Rasmussen-Carpenter",
            "references": "Rasmusson_Carpenter1982",
            "description": "Sea surface temperature and wind stress climatology for the tropical Pacific Ocean",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2",
            "scale_factor": "0.0329",
            "history": "Rasmussen-Carpenter climatological uxf, with large drag coef."
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2",
            "scale_factor": "0.0329",
            "history": "Rasmussen-Carpenter climatological uxf, with large drag coef."
        },
        "sst": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "sst",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "long_name": "Sea Surface Temperature",
            "history": "Rasmussen-Carpenter climatological sst"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "5.625",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/RC"
    },
    "REVERDIN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "REVERDIN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "BUOY15Mtitle": "15m tropical Pacific seasonal currents: Reverdin et al, 1994",
            "BUOY15Mreferences": "Reverdin_etal1994",
            "BUOY15Mdescription": "15 meter tropical Pacific seasonal currents",
            "BUOY15Mdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.REVERDIN/.BUOY.15M.dataset_documentation.html",
            "BUOY15MiridlhasSemantics": "iridl:LDEO",
            "description": "15 meter tropical Pacific seasonal currents by Reverdin et. al",
            "Conventions": "IRIDL"
        },
        "BUOY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "BUOY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "15M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "long_name": "meridional current",
                    "missing_value": "1.00000004E35"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "long_name": "zonal current",
                    "missing_value": "1.00000004E35"
                }
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "5.0"
        },
        "dir": "SOURCES/REVERDIN"
    },
    "RIHN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "RIHN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "aphroTempV1204R1APHRO_MA_025deglong_name": "Monsoon Asia daily temperature with 0.25deg grids",
            "aphroTempV1204R1APHRO_MA_025degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroTempV1204R1long_name": "Asian temperature from APHRODITE V1204R1",
            "aphroTempV1204R1references": "Kamiguchi2010 Kamiguchi2011 Yasutomi_etal2011 Yatagai_etal2012",
            "aphroTempV1204R1description": "Asian temperature products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroTempV1204R1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.RIHN/.aphroTemp.V1204R1.dataset_documentation.html",
            "aphroTempV1204R1iridlhasSemantics": "iridl:MRI",
            "aphroTempV1204R1APHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "aphroTemplong_name": "Asian temperature from APHRODITE",
            "aphroTempreferences": "Kamiguchi2010 Kamiguchi2011 Yasutomi_etal2011 Yatagai_etal2012",
            "aphroTempdescription": "Asian temperature products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroTempiridlhasSemantics": "iridl:MRI",
            "aphroTempAPHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "aphroditeV1101APHRO_MA_050deglong_name": "Monsoon Asia daily precipitation with 0.5deg grids",
            "aphroditeV1101APHRO_MA_050degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV1101APHRO_MA_025deglong_name": "Monsoon Asia daily precipitation with 0.25deg grids",
            "aphroditeV1101APHRO_MA_025degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV1101long_name": "Asian precipitation from APHRODITE V1101",
            "aphroditeV1101references": "Hamada2011 Xie_etal2007 Yatagai_etal2009 Yatagai_etal2012",
            "aphroditeV1101description": "Asian precipitation products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroditeV1101dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.RIHN/.aphrodite.V1101.dataset_documentation.html",
            "aphroditeV1101iridlhasSemantics": "iridl:MRI",
            "aphroditeV1101APHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "aphroditeV1003R1APHRO_RU_050deglong_name": "Russia daily precipitation with 0.5deg grids",
            "aphroditeV1003R1APHRO_RU_050degiridlhasSemantics": "irigaz:Russia_125_1",
            "aphroditeV1003R1APHRO_RU_025deglong_name": "Russia daily precipitation with 0.25deg grids",
            "aphroditeV1003R1APHRO_RU_025degiridlhasSemantics": "irigaz:Russia_125_1",
            "aphroditeV1003R1APHRO_ME_050deglong_name": "Middle East daily precipitation with 0.5deg grids",
            "aphroditeV1003R1APHRO_ME_050degiridlhasSemantics": "irigaz:Middle_East_328_0",
            "aphroditeV1003R1APHRO_ME_025deglong_name": "Middle East daily precipitation with 0.25deg grids",
            "aphroditeV1003R1APHRO_ME_025degiridlhasSemantics": "irigaz:Middle_East_328_0",
            "aphroditeV1003R1APHRO_MA_050deglong_name": "Monsoon Asia daily precipitation with 0.5deg grids",
            "aphroditeV1003R1APHRO_MA_050degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV1003R1APHRO_MA_025deglong_name": "Monsoon Asia daily precipitation with 0.25deg grids",
            "aphroditeV1003R1APHRO_MA_025degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV1003R1long_name": "Asian precipitation from APHRODITE V1003R1",
            "aphroditeV1003R1references": "Xie_etal2007 Yatagai_etal2009 Yatagai_etal2012",
            "aphroditeV1003R1description": "Asian precipitation products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroditeV1003R1iridlhasSemantics": "iridl:MRI",
            "aphroditeV1003R1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.RIHN/.aphrodite.V1003R1.dataset_documentation.html",
            "aphroditeV1003R1APHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "aphroditeV0902APHRO_RU_050deglong_name": "Russia daily precipitation with 0.5deg grids",
            "aphroditeV0902APHRO_RU_050degiridlhasSemantics": "irigaz:Russia_125_1",
            "aphroditeV0902APHRO_RU_025deglong_name": "Russia daily precipitation with 0.25deg grids",
            "aphroditeV0902APHRO_RU_025degiridlhasSemantics": "irigaz:Russia_125_1",
            "aphroditeV0902APHRO_ME_050deglong_name": "Middle East daily precipitation with 0.5deg grids",
            "aphroditeV0902APHRO_ME_050degiridlhasSemantics": "irigaz:Middle_East_328_0",
            "aphroditeV0902APHRO_ME_025deglong_name": "Middle East daily precipitation with 0.25deg grids",
            "aphroditeV0902APHRO_ME_025degiridlhasSemantics": "irigaz:Middle_East_328_0",
            "aphroditeV0902APHRO_MA_050deglong_name": "Monsoon Asia daily precipitation with 0.5deg grids",
            "aphroditeV0902APHRO_MA_050degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV0902APHRO_MA_025deglong_name": "Monsoon Asia daily precipitation with 0.25deg grids",
            "aphroditeV0902APHRO_MA_025degiridlhasSemantics": "irigaz:Asia_3329_1",
            "aphroditeV0902long_name": "Asian precipitation from APHRODITE V0902",
            "aphroditeV0902references": "Xie_etal2007",
            "aphroditeV0902APHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "aphroditeV0902description": "Asian precipitation products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroditeV0902iridlhasSemantics": "iridl:MRI",
            "aphroditeV0902dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.RIHN/.aphrodite.V0902.dataset_documentation.html",
            "aphroditelong_name": "Asian precipitation from APHRODITE",
            "aphroditereferences": "Hamada2011 Xie_etal2007 Yatagai_etal2009 Yatagai_etal2012",
            "aphroditedescription": "Asian precipitation products created by the Research Institute for Humanity and Nature and Meteorological Research Institute of Japan Meteorological Agency",
            "aphroditeiridlhasSemantics": "iridl:MRI",
            "aphroditeAPHRODITEs": "http://aphrodite.st.hirosaki-u.ac.jp/",
            "Conventions": "IRIDL"
        },
        "aphroTemp": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "aphroTemp",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "V1204R1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V1204R1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "APHRO_MA_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "40.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-40.0",
                        "CS": "-40",
                        "CE": "40",
                        "colorscalename": "temp_colors",
                        "colormap": "255",
                        "long_name": "temperature",
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                }
            }
        },
        "aphrodite": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "aphrodite",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "V1101": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V1101",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "APHRO_MA_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_MA_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                }
            },
            "V1003R1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V1003R1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "APHRO_RU_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_RU_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_RU_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_RU_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_ME_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_ME_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_ME_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_ME_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_MA_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                },
                "APHRO_MA_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0"
                    }
                }
            },
            "V0902": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "V0902",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "APHRO_RU_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_RU_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                },
                "APHRO_RU_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_RU_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                },
                "APHRO_ME_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_ME_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                },
                "APHRO_ME_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_ME_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                },
                "APHRO_MA_050deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_050deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                },
                "APHRO_MA_025deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "APHRO_MA_025deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ratio of 0.05 grid box contatining station(s)",
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "precipitation",
                        "units": "mm/day",
                        "missing_value": "-99.900002",
                        "pointwidth": "0.0"
                    }
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "standard",
            "standard_name": "time"
        },
        "Y_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "standard",
            "standard_name": "time"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "365",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/RIHN"
    },
    "RSMAS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "RSMAS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CCSM30DECADALensembleAveragelong_name": "RSMAS ccsm3.0 decadal forecast",
            "CCSM30DECADALdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.RSMAS/.CCSM3.0.DECADAL.dataset_documentation.html",
            "Conventions": "IRIDL"
        },
        "CCSM30": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CCSM3.0",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "DECADAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "DECADAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ensembleMembers": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ensembleMembers",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "TS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface temperature (radiative)",
                        "units": "Kelvin_scale",
                        "pointwidth": "1.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "PSL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PSL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea level pressure",
                        "units": "Pa",
                        "pointwidth": "1.0"
                    },
                    "PREC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PREC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Precipitation rate",
                        "units": "m/s",
                        "pointwidth": "1.0"
                    }
                },
                "ensembleAverage": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ensembleAverage",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "TS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface temperature (radiative)",
                        "units": "Kelvin_scale",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "PSL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PSL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea level pressure",
                        "units": "Pa",
                        "pointwidth": "0"
                    },
                    "PREC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PREC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Convective precipitation rate",
                        "units": "m/s",
                        "pointwidth": "0"
                    }
                }
            }
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Ensemble Member"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Lead time"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.40625",
            "standard_name": "longitude"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "long_name": "Start time",
            "pointwidth": "0",
            "standard_name": "forecast_reference_time",
            "calendar": "360"
        },
        "dir": "SOURCES/RSMAS"
    },
    "Reading": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Reading",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Reading",
        "restriction": "Public",
        "Meteorology": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Reading/Meteorology",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "Meteorology",
            "restriction": "Public",
            "TAMSAT": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Reading/Meteorology/TAMSAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "TAMSAT",
                "restriction": "Public",
                "TARCAT": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "TARCAT",
                    "restriction": "Public",
                    "v2p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v2p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dekadalinstitution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "dekadallonmin": "-19.012501",
                            "dekadalnote": " section of the page for terms of use",
                            "dekadaldata_policy": "http://www.tamsat.org.uk/docs/TAMSAT_Data_Policy_TARCATv2.0_2014.pdf",
                            "dekadaltitle": "TAMSAT Rain Fall Estimate (RFE)",
                            "dekadallonmax": "51.974998",
                            "dekadallatres": "0.0375",
                            "dekadalreferences": "Tarnavsky_etal2014 Maidment_etal2014",
                            "dekadalTAMSAT": "http://www.tamsat.org.uk/cgi-bin/data/index.cgi",
                            "dekadaldocumentation": "http://www.tamsat.org.uk/docs/TAMSAT_DailyRainfallEstimates_UsersGuide.pdf",
                            "dekadalcontact": "tamsat@reading.ac.uk",
                            "dekadallatmin": "-35.962502",
                            "dekadallatmax": "38.025002",
                            "dekadalConventions": "CF-1.5",
                            "dekadallonres": "0.0375",
                            "dailyinstitution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "dailylonmin": "-19.012501",
                            "dailynote": " section of the page for terms of use",
                            "dailydata_policy": "http://www.tamsat.org.uk/docs/TAMSAT_Data_Policy_TARCATv2.0_2014.pdf",
                            "dailytitle": "TAMSAT Rain Fall Estimate (RFE)",
                            "dailylonmax": "51.974998",
                            "dailylatres": "0.0375",
                            "dailyreferences": "Tarnavsky_etal2014 Maidment_etal2014",
                            "dailyTAMSAT": "http://www.tamsat.org.uk/cgi-bin/data/index.cgi",
                            "dailydocumentation": "http://www.tamsat.org.uk/docs/TAMSAT_DailyRainfallEstimates_UsersGuide.pdf",
                            "dailycontact": "tamsat@reading.ac.uk",
                            "dailylatmin": "-35.962502",
                            "dailylatmax": "38.025002",
                            "dailyConventions": "CF-1.5",
                            "dailylonres": "0.0375",
                            "Conventions": "IRIDL",
                            "description": "Version 2.0"
                        },
                        "dekadal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dekadal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "missing_value": "-99",
                                "short_name": "rfe",
                                "long_name": "Rain Fall Estimate",
                                "units": "mm",
                                "standard_name": "lwe_precipitation_rate"
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "fnname": "maskge",
                                "long_name": "Rain Fall Estimate",
                                "missing_value": "NaN",
                                "valid_max": "255.0",
                                "valid_min": "0.0",
                                "short_name": "rfe",
                                "units": "mm/day",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            }
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard"
                        },
                        "time": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "time",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "julian_day",
                            "gridtype": "0",
                            "standard_name": "time",
                            "pointwidth": "1.0",
                            "calendar": "standard"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "longitude",
                            "long_name": "longitude"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "latitude",
                            "long_name": "latitude"
                        },
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v2p0"
                    },
                    "v3p0": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "v3p0",
                        "restriction": "Public",
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "CF-1.5",
                                "lonmin": "-19.012501",
                                "note": " section of the page for terms of use",
                                "lonres": "0.0375",
                                "references": "Maidment_etal2017",
                                "expires": "1609545600",
                                "Scientific": "https://www.nature.com/articles/sdata201763",
                                "contact": "tamsat@reading.ac.uk",
                                "latmin": "-35.962502",
                                "title": "TAMSAT Rain Fall Estimate (RFE) - Version 3.0",
                                "documentation": "http://www.tamsat.org.uk/faq",
                                "Version": "http://iridl.ldeo.columbia.edu/SOURCES/.Reading/.Meteorology/.TAMSAT/.v3p1/.daily/",
                                "lonmax": "51.974998",
                                "TAMSAT": "http://www.tamsat.org.uk/data/",
                                "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                                "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                                "latres": "0.0375",
                                "latmax": "38.025002",
                                "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK"
                            },
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "missing_value": "-99.0",
                                "expires": "1609545600",
                                "long_name": "Rainfall Estimate",
                                "units": "mm/day",
                                "standard_name": "lwe_precipitation_rate",
                                "short_name": "rfe",
                                "pointwidth": "1.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "julian_day",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1609545600",
                                "standard_name": "time",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p0/daily"
                        },
                        "dekadal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dekadal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "CF-1.5",
                                "contact": "tamsat@reading.ac.uk",
                                "latmin": "-35.962502",
                                "note": " section of the page for terms of use",
                                "lonres": "0.0375",
                                "references": "Maidment_etal2017",
                                "expires": "1610323200",
                                "Scientific": "https://www.nature.com/articles/sdata201763",
                                "lonmax": "51.974998",
                                "latres": "0.0375",
                                "title": "TAMSAT Rain Fall Estimate (RFE) - Version 3.0",
                                "documentation": "http://www.tamsat.org.uk/faq",
                                "Version": "http://iridl.ldeo.columbia.edu/SOURCES/.Reading/.Meteorology/.TAMSAT/.v3p1/.dekadal/",
                                "lonmin": "-19.012501",
                                "TAMSAT": "http://www.tamsat.org.uk/data/",
                                "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                                "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                                "latmax": "38.025002",
                                "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK"
                            },
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "missing_value": "-99",
                                "expires": "1610323200",
                                "short_name": "rfe",
                                "long_name": "Rainfall Estimate",
                                "units": "mm",
                                "standard_name": "lwe_precipitation_rate"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1610323200"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p0/dekadal"
                        },
                        "monthly": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p0/monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "monthly",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "daily",
                            "dekadal",
                            "monthly"
                        ]
                    },
                    "v3p1": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "v3p1",
                        "restriction": "Public",
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "CF-1.7",
                                "lonmin": "-19.012501",
                                "references": "Maidment_etal2017",
                                "Scientific": "https://www.nature.com/articles/sdata201763",
                                "expires": "1609545600",
                                "contact": "tamsat@reading.ac.uk",
                                "title": "TAMSAT Rainfall Estimate (RFE) - Version 3.1",
                                "documentation": "http://www.tamsat.org.uk/faq",
                                "note": " section of the page for terms of use",
                                "lonres": "0.0375",
                                "latmin": "-35.962502",
                                "latres": "0.0375",
                                "TAMSAT": "http://www.tamsat.org.uk/data/",
                                "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                                "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                                "lonmax": "51.974998",
                                "latmax": "38.025002",
                                "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK"
                            },
                            "rfe_filled": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe_filled",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "missing_value": "-9999.0",
                                "expires": "1609545600",
                                "long_name": "Recovered Rainfall Estimate",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "short_name": "rfe_filled",
                                "description": "Rainfall Estimates with Missing Daily Data Filled",
                                "pointwidth": "1.0"
                            },
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "missing_value": "-9999.0",
                                "expires": "1609545600",
                                "long_name": "Rainfall Estimate",
                                "units": "mm/day",
                                "standard_name": "lwe_precipitation_rate",
                                "short_name": "rfe",
                                "pointwidth": "1.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "julian_day",
                                "gridtype": "0",
                                "calendar": "standard",
                                "expires": "1609545600",
                                "standard_name": "time",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p1/daily"
                        },
                        "dekadal": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p1/dekadal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "dekadal",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "CF-1.7",
                                "lonres": "0.0375",
                                "lonmin": "-19.012501",
                                "references": "Maidment_etal2017",
                                "Scientific": "https://www.nature.com/articles/sdata201763",
                                "expires": "1612137600",
                                "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                                "title": "TAMSAT Rainfall Estimate (RFE) - Version 3.1",
                                "contact": "tamsat@reading.ac.uk",
                                "documentation": "http://www.tamsat.org.uk/faq",
                                "note": " section of the page for terms of use",
                                "latres": "0.0375",
                                "latmin": "-35.962502",
                                "TAMSAT": "http://www.tamsat.org.uk/data/",
                                "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                                "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                                "lonmax": "51.974998",
                                "latmax": "38.025002"
                            },
                            "rfe_filled": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe_filled",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "145411",
                                "scale_max": "700.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "700",
                                "missing_value": "-9999.0",
                                "expires": "1612137600",
                                "long_name": "Recovered Rainfall Estimate",
                                "short_name": "rfe_filled",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "description": "Rainfall Estimates with Missing Daily Data Filled",
                                "pointwidth": "1.0"
                            },
                            "rfe": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "145411",
                                "scale_max": "700.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "700",
                                "missing_value": "-9999.0",
                                "expires": "1612137600",
                                "long_name": "Rainfall Estimate",
                                "short_name": "rfe",
                                "units": "mm/month",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "expires": "1612137600",
                                "standard_name": "time",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "0",
                                "pointwidth": "0.0375",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "dir": "SOURCES/Reading/Meteorology/TAMSAT/TARCAT/v3p1/monthly"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "daily",
                            "dekadal",
                            "monthly"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "v2p0",
                        "v3p0",
                        "v3p1"
                    ]
                },
                "v3p0": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "v3p0",
                    "restriction": "Public",
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Scientific": "https://www.nature.com/articles/sdata201763",
                            "lonmin": "-19.012501",
                            "references": "Maidment_etal2017",
                            "expires": "1609545600",
                            "title": "TAMSAT Rain Fall Estimate (RFE) - Version 3.0",
                            "Conventions": "CF-1.5",
                            "latmax": "38.025002",
                            "documentation": "http://www.tamsat.org.uk/faq",
                            "Version": "http://iridl.ldeo.columbia.edu/SOURCES/.Reading/.Meteorology/.TAMSAT/.v3p1/.daily/",
                            "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "note": " section of the page for terms of use",
                            "contact": "tamsat@reading.ac.uk",
                            "latmin": "-35.962502",
                            "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                            "TAMSAT": "http://www.tamsat.org.uk/data/",
                            "lonres": "0.0375",
                            "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                            "lonmax": "51.974998",
                            "latres": "0.0375"
                        },
                        "rfe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "colorscalename": "prcp_dailyrate_max100_smooth",
                            "missing_value": "-99.0",
                            "expires": "1609545600",
                            "long_name": "Rainfall Estimate",
                            "units": "mm/day",
                            "standard_name": "lwe_precipitation_rate",
                            "short_name": "rfe",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "latitude",
                            "long_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "julian_day",
                            "gridtype": "0",
                            "calendar": "standard",
                            "expires": "1609545600",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "longitude",
                            "long_name": "longitude"
                        },
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p0/daily"
                    },
                    "dekadal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Scientific": "https://www.nature.com/articles/sdata201763",
                            "lonmin": "-19.012501",
                            "references": "Maidment_etal2017",
                            "expires": "1610323200",
                            "title": "TAMSAT Rain Fall Estimate (RFE) - Version 3.0",
                            "Conventions": "CF-1.5",
                            "latmax": "38.025002",
                            "documentation": "http://www.tamsat.org.uk/faq",
                            "Version": "http://iridl.ldeo.columbia.edu/SOURCES/.Reading/.Meteorology/.TAMSAT/.v3p1/.dekadal/",
                            "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "note": " section of the page for terms of use",
                            "contact": "tamsat@reading.ac.uk",
                            "latmin": "-35.962502",
                            "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                            "TAMSAT": "http://www.tamsat.org.uk/data/",
                            "lonres": "0.0375",
                            "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                            "lonmax": "51.974998",
                            "latres": "0.0375"
                        },
                        "rfe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "100",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "colorscalename": "prcp_dailyrate_max100_smooth",
                            "missing_value": "-99",
                            "expires": "1610323200",
                            "long_name": "Rainfall Estimate",
                            "units": "mm",
                            "standard_name": "lwe_precipitation_rate",
                            "short_name": "rfe"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "latitude",
                            "long_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "expires": "1610323200"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "longitude",
                            "long_name": "longitude"
                        },
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p0/dekadal"
                    },
                    "monthly": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p0/monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "monthly",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "daily",
                        "dekadal",
                        "monthly"
                    ]
                },
                "v3p1": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "v3p1",
                    "restriction": "Public",
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "latmax": "38.025002",
                            "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "Scientific": "https://www.nature.com/articles/sdata201763",
                            "note": " section of the page for terms of use",
                            "lonmin": "-19.012501",
                            "references": "Maidment_etal2017",
                            "expires": "1609545600",
                            "lonres": "0.0375",
                            "latres": "0.0375",
                            "title": "TAMSAT Rainfall Estimate (RFE) - Version 3.1",
                            "Conventions": "CF-1.7",
                            "documentation": "http://www.tamsat.org.uk/faq",
                            "contact": "tamsat@reading.ac.uk",
                            "latmin": "-35.962502",
                            "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                            "TAMSAT": "http://www.tamsat.org.uk/data/",
                            "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                            "lonmax": "51.974998"
                        },
                        "rfe_filled": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_filled",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "colorscalename": "prcp_dailyrate_max100_smooth",
                            "missing_value": "-9999.0",
                            "expires": "1609545600",
                            "standard_name": "lwe_precipitation_rate",
                            "long_name": "Recovered Rainfall Estimate",
                            "short_name": "rfe_filled",
                            "units": "mm/day",
                            "description": "Rainfall Estimates with Missing Daily Data Filled",
                            "pointwidth": "1.0"
                        },
                        "rfe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "colorscalename": "prcp_dailyrate_max100_smooth",
                            "missing_value": "-9999.0",
                            "expires": "1609545600",
                            "long_name": "Rainfall Estimate",
                            "short_name": "rfe",
                            "units": "mm/day",
                            "standard_name": "lwe_precipitation_rate",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "latitude",
                            "long_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "julian_day",
                            "gridtype": "0",
                            "calendar": "standard",
                            "expires": "1609545600",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "longitude",
                            "long_name": "longitude"
                        },
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p1/daily"
                    },
                    "dekadal": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p1/dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "dekadal",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "institution": "TAMSAT Research Group, Meteorology Department, University of Reading, UK",
                            "lonmax": "51.974998",
                            "latmax": "38.025002",
                            "latres": "0.0375",
                            "Scientific": "https://www.nature.com/articles/sdata201763",
                            "note": " section of the page for terms of use",
                            "references": "Maidment_etal2017",
                            "expires": "1612137600",
                            "lonres": "0.0375",
                            "title": "TAMSAT Rainfall Estimate (RFE) - Version 3.1",
                            "Conventions": "CF-1.7",
                            "documentation": "http://www.tamsat.org.uk/faq",
                            "lonmin": "-19.012501",
                            "contact": "tamsat@reading.ac.uk",
                            "data_policy": "http://iridl.ldeo.columbia.edu/documentation/Reading/Meteorology/TAMSAT/TAMSAT_Data_Policy_2017.pdf",
                            "TAMSAT": "http://www.tamsat.org.uk/data/",
                            "history": "Processed from TIR archive using satop with max_gap[mins]=360",
                            "latmin": "-35.962502"
                        },
                        "rfe_filled": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_filled",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "145411",
                            "scale_max": "700.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "700",
                            "missing_value": "-9999.0",
                            "expires": "1612137600",
                            "long_name": "Recovered Rainfall Estimate",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/month",
                            "description": "Rainfall Estimates with Missing Daily Data Filled",
                            "short_name": "rfe_filled",
                            "pointwidth": "1.0"
                        },
                        "rfe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "145411",
                            "scale_max": "700.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "700",
                            "missing_value": "-9999.0",
                            "expires": "1612137600",
                            "long_name": "Rainfall Estimate",
                            "units": "mm/month",
                            "standard_name": "lwe_precipitation_rate",
                            "short_name": "rfe",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "latitude",
                            "long_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "expires": "1612137600",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.0375",
                            "standard_name": "longitude",
                            "long_name": "longitude"
                        },
                        "dir": "SOURCES/Reading/Meteorology/TAMSAT/v3p1/monthly"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "daily",
                        "dekadal",
                        "monthly"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "TARCAT",
                    "v3p0",
                    "v3p1"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "TAMSAT"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Meteorology"
        ]
    },
    "River": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "River",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "references": "Simpson_elal1993",
            "description": "Australian river flow data",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "Flow": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Flow",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Australia": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Australia",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MUNat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MUNat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Murray (Natural)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                },
                "MUDANat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MUDANat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Murray to South Australia (Natural)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                },
                "MUDAAct": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MUDAAct",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Murray to South Australia (Actual)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                },
                "MUAct": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MUAct",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Murray (Actual)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                },
                "DANat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DANat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Darling (Natural)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                },
                "DAAct": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DAAct",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Darling (Actual)",
                    "units": "unitless",
                    "missing_value": "-999.0"
                }
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "12.0",
            "standard_name": "time"
        },
        "dir": "SOURCES/River"
    },
    "SAWS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SAWS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "observationdescription": "daily gridded rainfall data ",
            "description": "South African Weather Service",
            "iridlhasSemantics": "iridl:SAWS",
            "Conventions": "IRIDL"
        },
        "observation": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "observation",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "precip": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "precip",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "long_name": "precipitation",
                "units": "mm/day"
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "1/365 years since 1970-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "standard_name": "Time",
            "long_name": "Time",
            "calendar": "365"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/SAWS"
    },
    "SENAMHI": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SENAMHI",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "HSRPISCOTempdataset_documentation": "http://iridl.ldeo.columbia.edu/documentation/.pisco/.PISCOt_report.pdf",
            "HSRPISCOTempdescription": "Temperature",
            "HSRPISCOStreamflowv1unstablemonthlyGR2MShapefilesZip": "https://iri.columbia.edu/~remic/files/Subbasins_GR2M_Peru/",
            "HSRPISCOStreamflowv1stablemonthlyGR2MShapefilesZip": "https://iri.columbia.edu/~remic/files/Subbasins_GR2M_Peru/",
            "HSRPISCOStreamflowdescription": "Streamflow v1beta",
            "HSRPISCOPrecdataset_documentation": "http://iridl.ldeo.columbia.edu/documentation/.pisco/.Manuscript_PISCO.pdf",
            "HSRPISCOPrecdescription": "Precipitation",
            "HSRPISCOPrecReadme": "http://iridl.ldeo.columbia.edu/documentation/.pisco/.Readme-first.txt",
            "HSRPISCOPETdescription": "Potential Evapotranspiration",
            "HSRPISCOdescription": "Peruvian Interpolated data",
            "HSRdescription": "Sub-direction of hydrological studies and research",
            "description": "Servicio Nacional de Meteorolog\\xc3\\xada e Hidrolog\\xc3\\xada del Per\\xc3\\xba",
            "Conventions": "IRIDL"
        },
        "HSR": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "HSR",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "PISCO": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PISCO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1p1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "stable": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "stable",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "colorscalename": "temp_colors",
                                        "units": "Celsius_scale",
                                        "long_name": "Minimum Temperature",
                                        "missing_value": "-3.39999995E38"
                                    }
                                },
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "colorscalename": "temp_colors",
                                        "units": "Celsius_scale",
                                        "long_name": "Minimum Temperature",
                                        "missing_value": "-3.39999995E38"
                                    }
                                }
                            }
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "stable": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "stable",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "colorscalename": "temp_colors",
                                        "units": "Celsius_scale",
                                        "long_name": "Maximum Temperature",
                                        "missing_value": "-3.39999995E38"
                                    }
                                },
                                "daily": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daily",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "colorscalename": "temp_colors",
                                        "units": "Celsius_scale",
                                        "long_name": "Maximum Temperature",
                                        "missing_value": "-3.39999995E38"
                                    }
                                }
                            }
                        }
                    }
                },
                "Streamflow": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Streamflow",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "unstable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "unstable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GR2M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GR2M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "the_geom": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "the_geom",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Geometry",
                                        "units": "unitless",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    },
                                    "SM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Soil Moisture",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "Region": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Region",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Region ID",
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "Precip": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Precip",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Precipitation",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "PET": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PET",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Potential Evapotranspiration",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "label": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "label",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Label",
                                        "units": "ids",
                                        "PGtype": "text"
                                    },
                                    "Discharge": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Discharge",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Discharge",
                                        "units": "m3/s",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        },
                        "stable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "GR2M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GR2M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "the_geom": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "the_geom",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Geometry",
                                        "units": "unitless",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    },
                                    "SM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Soil Moisture",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "Region": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Region",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Region ID",
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "Precip": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Precip",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Precipitation",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "PET": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PET",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Potential Evapotranspiration",
                                        "units": "mm",
                                        "pointwidth": "1.0"
                                    },
                                    "label": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "label",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Label",
                                        "units": "ids",
                                        "PGtype": "text"
                                    },
                                    "Discharge": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Discharge",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CS": "0",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "colorscalename": "daily_precip_colors",
                                        "long_name": "Discharge",
                                        "units": "m3/s",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        }
                    }
                },
                "Prec": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Prec",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v2p1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v2p1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "unstable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "unstable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "colormap": "290304",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "units": "mm/month",
                                    "long_name": "Precipitation",
                                    "missing_value": "-3.39999995E38",
                                    "expires": "1617235200",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "stable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "colormap": "290304",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "units": "mm/month",
                                    "long_name": "Precipitation",
                                    "missing_value": "-3.39999995E38"
                                }
                            },
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "colormap": "290304",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "units": "mm/day",
                                    "long_name": "Precipitation",
                                    "missing_value": "-3.39999995E38"
                                }
                            }
                        }
                    },
                    "v1p0_O": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p0_O",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Prec": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Prec",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "colormap": "290304",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "precip_colors",
                                "units": "mm/day",
                                "long_name": "Precipitation",
                                "missing_value": "-3.39999995E38",
                                "expires": "1614816000",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "PET": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PET",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1p1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "stable": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stable",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "colormap": "290304",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "units": "mm/day",
                                    "long_name": "Evapotranspiration",
                                    "missing_value": "-3.39999995E38"
                                }
                            },
                            "daily": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "daily",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "colormap": "290304",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "units": "mm/day",
                                    "long_name": "Potential Evapotranspiration",
                                    "missing_value": "-3.39999995E38"
                                }
                            }
                        }
                    }
                }
            }
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "gid_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "gid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "expires": "1617235200",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1614816000",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.09999998",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.1",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.09999996",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/SENAMHI"
    },
    "SERVAIN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SERVAIN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Tropical_Atlanticmonthlydescription": "Monthly sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticclimatologyc6403long_name": "1964-2003 Climatology",
            "Tropical_Atlanticclimatologyc6403description": "Climatological sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticclimatologyc6403iridlhasSemantics": "iridl:climatology",
            "Tropical_Atlanticdescription": "Sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.SERVAIN/.Tropical_Atlantic.dataset_documentation.html",
            "Conventions": "IRIDL"
        },
        "Tropical_Atlantic": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Tropical_Atlantic",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "sea surface temperature anomaly",
                    "units": "degree_Celsius",
                    "missing_value": "9999.7998",
                    "scale_max": "5.0",
                    "scale_min": "-5.0"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "sea surface temperature",
                    "units": "Celsius_scale",
                    "missing_value": "9999.7998",
                    "scale_max": "31.5",
                    "scale_min": "0.0"
                },
                "pwsyanom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsyanom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind pseudo-stress anomaly",
                    "units": "m2/s2",
                    "missing_value": "9999.7998",
                    "scale_max": "63.0",
                    "scale_min": "-78.0"
                },
                "pwsy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind pseudo-stress",
                    "units": "m2/s2",
                    "missing_value": "9999.7998",
                    "scale_max": "123.0",
                    "scale_min": "-106.0"
                },
                "pwsxanom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsxanom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind pseudo-stress anomaly",
                    "units": "m2/s2",
                    "missing_value": "9999.7998",
                    "scale_max": "122.0",
                    "scale_min": "-100.0"
                },
                "pwsx": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsx",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind pseudo-stress",
                    "units": "m2/s2",
                    "missing_value": "9999.7998",
                    "scale_max": "123.0",
                    "scale_min": "-132.0"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "c6403": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "c6403",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "sea surface temperature",
                        "units": "degree_Celsius",
                        "missing_value": "9999.7998",
                        "scale_max": "29.5",
                        "scale_min": "13.0"
                    },
                    "pwsy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pwsy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional wind pseudo-stress",
                        "units": "m2/s2",
                        "missing_value": "9999.7998",
                        "scale_max": "60.0",
                        "scale_min": "-70.0"
                    },
                    "pwsx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pwsx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal wind pseudo-stress",
                        "units": "m2/s2",
                        "missing_value": "9999.7998",
                        "scale_max": "27.0",
                        "scale_min": "-90.0"
                    }
                }
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/SERVAIN"
    },
    "SIO": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SIO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "SIO",
            "iridlhasSemantics": "iridl:SIO",
            "Conventions": "IRIDL"
        },
        "dir": "SOURCES/SIO"
    },
    "SMNH": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/SMNH",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "SMNH",
        "restriction": "Public",
        "SdC": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/SMNH/SdC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "SdC",
            "restriction": "Public",
            "estacion": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/SMNH/SdC/estacion",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "estacion",
                "restriction": "requires dlauth tokens"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "estacion"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "SdC"
        ]
    },
    "SOC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SOC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "GASC97description": "Global air-sea heat and momentum flux climatology from the Southampton Oceanography Centre",
            "GASC97dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.SOC/.GASC97.dataset_documentation.html",
            "GASC97references": "Josey:etal1999",
            "description": "Southampton Oceanography Centre",
            "iridlhasSemantics": "iridl:SOC",
            "Conventions": "IRIDL"
        },
        "GASC97": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GASC97",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "N/m^2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate",
                "time_statistic": "average",
                "long_name": "Northward surface wind stress (positive for northward wind)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "tauu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "N/m^2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate",
                "time_statistic": "average",
                "long_name": "Eastward surface wind stress (positive for eastward wind)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "rss": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rss",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "W/m2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate, Reed(1977)",
                "time_statistic": "average",
                "long_name": "SW radiation net surface (Positive for heat gain by the ocean)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "rls": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rls",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "W/m2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate, Clark et al(1974)",
                "time_statistic": "average",
                "long_name": "LW radiation net surface  (Positive for heat gain by the ocean)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "pr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "mm/3hr",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Present weather code estimate (Dorman & Bourke, 1978)",
                "time_statistic": "average",
                "long_name": "Total precipitation rate",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "hfss": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hfss",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "W/m2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate, Smith(1988)",
                "time_statistic": "average",
                "long_name": "Heat flux sensible surface (Positive for heat gain by the ocean)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "hfns": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hfns",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "W/m2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate,hfns=rss+rls+hfls+hfss",
                "time_statistic": "average",
                "long_name": "Net heat flux (positive for heat gain by the ocean)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            },
            "hfls": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hfls",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "grid_name": "generic grid",
                "units": "W/m2",
                "level_description": "Earth surface",
                "calendar": "standard",
                "grid_type": "generic",
                "comments": "Bulk formulae estimate, Smith(1988)",
                "time_statistic": "average",
                "long_name": "Heat flux latent surface (Positive for heat gain by the ocean)",
                "model": "",
                "center": "Southampton Oceanography Centre,UK",
                "missing_value": "1.00000002E20"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "modulo": "12.0",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "1.0",
            "long_name": "Longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Latitude"
        },
        "dir": "SOURCES/SOC"
    },
    "STEVE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "STEVE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Wind stress data for the Tropical Atlantic",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "TAU": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TAU",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Atlantic anomaly data"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Atlantic anomaly data"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "5.625",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/STEVE"
    },
    "Sandwell": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Sandwell",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "seafloorversion": "6.2",
            "seafloordescription": "Measured and estimated seafloor topography",
            "seafloordataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Sandwell/.seafloor.dataset_documentation.html",
            "references": "Smith_Sandwell1997",
            "description": "Measured and estimated seafloor topography by Sandwell et. al",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "seafloor": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "seafloor",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "height": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "height",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "maxncolor": "253",
                "colormap": "12632256",
                "scale_max": "7964.0",
                "ncolor": "253",
                "scale_min": "-9964.0",
                "CS": "-9964.0",
                "CE": "7964.0",
                "colorscalename": "topographycolorscale",
                "long_name": "topography"
            }
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.03333334",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ln(tan(pi/4+lat/2))*39.06657",
            "gridtype": "0",
            "pointwidth": "0.02273114",
            "long_name": "North"
        },
        "dir": "SOURCES/Sandwell"
    },
    "ShipDrift": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ShipDrift",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Surface velocity data for the tropical Atlantic Ocean",
            "iridlhasSemantics": "iridl:SeaSurface",
            "Conventions": "IRIDL"
        },
        "SM2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SM2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "vst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "northward surface velocity",
                "units": "cm/s",
                "history": "smoothed shipdrift data"
            },
            "ust": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ust",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "eastward surface velocity",
                "units": "cm/s",
                "history": "smoothed shipdrift data"
            }
        },
        "SM1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SM1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "vst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "northward surface velocity",
                "units": "cm/s",
                "history": "smoothed shipdrift data"
            },
            "ust": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ust",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "eastward surface velocity",
                "units": "cm/s",
                "history": "smoothed shipdrift data"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "5.0",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/ShipDrift"
    },
    "SoilGrids": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "SoilGrids",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Conventions": "IRIDL"
        },
        "GYGA_Results_ll": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GYGA_Results_ll",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Aggregated_overERZD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Aggregated_overERZD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wat_cap_whole": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_whole",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Total available water - fine earth and coarse fragments",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Total available water capacity (v\\\\%) of the whole earth (incl. both fine earth and coarse fragments), aggregated over the Effective Root Zone Depth for Maize, with field capacity defined at pF 2.3"
                },
                "wat_cap_fine": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_fine",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Available water capacity - fine earth",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Available water capacity (percent water by volume, v\\\\%) of the fine earth, aggregated over the Effective Root Zone Depth for Maize, with field capacity defined at pF 2.3"
                },
                "wat_cap_abs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_abs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "long_name": "Absolute total available water",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "mm",
                    "description": "Absolute total available water capacity (mm), aggregated over the Effective Root Zone Depth for Maize"
                },
                "Textural_Class": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Textural_Class",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "text_class": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "text_class",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "1.0",
                        "scale_max": "12.0",
                        "units": "ids",
                        "CLIST": "Sa",
                        "SpatialReferenceSystemWKT": "]]",
                        "missing_value": "NaN",
                        "valid_max": "255.0",
                        "valid_min": "0.0",
                        "long_name": "Textural class of the fine earth",
                        "SpatialReferenceSystemDims": "Y",
                        "description": "Textural class (USDA) of the fine earth, aggregated over the Effective Root Zone Depth for Maize"
                    }
                },
                "soil_qual": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "soil_qual",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "1.0",
                    "scale_max": "18.0",
                    "CLISTdesc": "Maximum root depth maize",
                    "units": "ids",
                    "CLIST": "ERMAIZE",
                    "SpatialReferenceSystemWKT": "]]",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "long_name": "Soil quality",
                    "SpatialReferenceSystemDims": "Y",
                    "description": "Factor (soil quality) limiting Effective Root Zone Depth for Maize"
                },
                "root_zone": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "root_zone",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "long_name": "Effective Root Zone Depth",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "cm",
                    "description": "Effective Root Zone Depth (cm) for Maize"
                },
                "moist_cont_wilt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_wilt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - wilting point",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at permanent wilting point, aggregated over the Effective Root Zone Depth for Maize, with PWP defined at pF 4.2"
                },
                "moist_cont_sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - saturation",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at saturation, aggregated over the Effective Root Zone Depth for Maize"
                },
                "coarse_frag_cont": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "coarse_frag_cont",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Coarse fragments content",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Coarse fragments content (v\\\\%) of the whole earth, aggregated over the Effective Root Zone Depth for Maize"
                }
            },
            "Aggregated_over30cm": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Aggregated_over30cm",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wat_cap_whole": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_whole",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Total available water - fine earth and coarse fragments",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Total available water capacity (v\\\\%) of the whole earth (incl. both fine earth and coarse fragments), aggregated over the top 30 cm, with field capacity defined at pF 2.3"
                },
                "wat_cap_fine": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_fine",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Available water capacity - fine earth",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Available water capacity (percent water by volume, v\\\\%) of the fine earth, aggregated over the top 30 cm, with field capacity defined at pF 2.3"
                },
                "wat_cap_abs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_abs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "long_name": "Absolute total available water",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "mm",
                    "description": "Absolute total available water capacity (mm), aggregated over the top 30 cm"
                },
                "text_class": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "text_class",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "1.0",
                    "scale_max": "12.0",
                    "units": "ids",
                    "CLIST": "Sa",
                    "SpatialReferenceSystemWKT": "]]",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "long_name": "Textural class of the fine earth",
                    "SpatialReferenceSystemDims": "Y",
                    "description": "Textural class (USDA) of the fine earth, aggregated over the top 30 cm"
                },
                "moist_cont_wilt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_wilt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - wilting point",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at permanent wilting point, aggregated over the top 30 cm, with PWP defined at pF 4.2"
                },
                "moist_cont_sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - saturation",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at saturation, aggregated over the top 30 cm"
                },
                "coarse_frag_cont": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "coarse_frag_cont",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "missing_value": "NaN",
                    "valid_max": "255.0",
                    "valid_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Coarse fragments content",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Coarse fragments content (v\\\\%) of the whole earth, aggregated over the top 30 cm"
                }
            }
        },
        "GYGA_Results_1km": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GYGA_Results_1km",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Aggregated_overERZD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Aggregated_overERZD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wat_cap_whole": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_whole",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Total available water - fine earth and coarse fragments",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Total available water capacity (v\\\\%) of the whole earth (incl. both fine earth and coarse fragments), aggregated over the Effective Root Zone Depth for Maize, with field capacity defined at pF 2.3",
                    "missing_value": "255"
                },
                "wat_cap_fine": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_fine",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Available water capacity - fine earth",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Available water capacity (percent water by volume, v\\\\%) of the fine earth, aggregated over the Effective Root Zone Depth for Maize, with field capacity defined at pF 2.3",
                    "missing_value": "255"
                },
                "wat_cap_abs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_abs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Absolute total available water",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "mm",
                    "description": "Absolute total available water capacity (mm), aggregated over the Effective Root Zone Depth for Maize",
                    "missing_value": "255"
                },
                "Textural_Class": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Textural_Class",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "text_class": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "text_class",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "1",
                        "scale_max": "12",
                        "CLIST": "Sa",
                        "long_name": "Textural class of the fine earth",
                        "SpatialReferenceSystemWKT": ",NORTH]]",
                        "SpatialReferenceSystemDims": "Y",
                        "units": "ids",
                        "description": "Textural class (USDA) of the fine earth, aggregated over the Effective Root Zone Depth for Maize",
                        "missing_value": "255"
                    }
                },
                "soil_qual": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "soil_qual",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "1",
                    "scale_max": "18",
                    "CLISTdesc": "Maximum root depth maize",
                    "CLIST": "ERMAIZE",
                    "long_name": "Soil quality",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "ids",
                    "description": "Factor (soil quality) limiting Effective Root Zone Depth for Maize",
                    "missing_value": "255"
                },
                "root_zone": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "root_zone",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Effective Root Zone Depth",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "cm",
                    "description": "Effective Root Zone Depth (cm) for Maize",
                    "missing_value": "255"
                },
                "moist_cont_wilt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_wilt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - wilting point",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at permanent wilting point, aggregated over the Effective Root Zone Depth for Maize, with PWP defined at pF 4.2",
                    "missing_value": "255"
                },
                "moist_cont_sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - saturation",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at saturation, aggregated over the Effective Root Zone Depth for Maize",
                    "missing_value": "255"
                },
                "coarse_frag_cont": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "coarse_frag_cont",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Coarse fragments content",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Coarse fragments content (v\\\\%) of the whole earth, aggregated over the Effective Root Zone Depth for Maize",
                    "missing_value": "255"
                }
            },
            "Aggregated_over30cm": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Aggregated_over30cm",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wat_cap_whole": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_whole",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Total available water - fine earth and coarse fragments",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Total available water capacity (v\\\\%) of the whole earth (incl. both fine earth and coarse fragments), aggregated over the top 30 cm, with field capacity defined at pF 2.3",
                    "missing_value": "255"
                },
                "wat_cap_fine": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_fine",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Available water capacity - fine earth",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Available water capacity (percent water by volume, v\\\\%) of the fine earth, aggregated over the top 30 cm, with field capacity defined at pF 2.3",
                    "missing_value": "255"
                },
                "wat_cap_abs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wat_cap_abs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Absolute total available water",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "mm",
                    "description": "Absolute total available water capacity (mm), aggregated over the top 30 cm",
                    "missing_value": "255"
                },
                "text_class": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "text_class",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "1",
                    "scale_max": "12",
                    "CLIST": "Sa",
                    "long_name": "Textural class of the fine earth",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "ids",
                    "description": "Textural class (USDA) of the fine earth, aggregated over the top 30 cm",
                    "missing_value": "255"
                },
                "moist_cont_wilt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_wilt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - wilting point",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at permanent wilting point, aggregated over the top 30 cm, with PWP defined at pF 4.2",
                    "missing_value": "255"
                },
                "moist_cont_sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "moist_cont_sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Moisture content of the fine earth - saturation",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Moisture content (v\\\\%) of the fine earth at saturation, aggregated over the top 30 cm",
                    "missing_value": "255"
                },
                "coarse_frag_cont": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "coarse_frag_cont",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "100.0",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "long_name": "Coarse fragments content",
                    "SpatialReferenceSystemWKT": ",NORTH]]",
                    "SpatialReferenceSystemDims": "Y",
                    "units": "percent",
                    "description": "Coarse fragments content (v\\\\%) of the whole earth, aggregated over the top 30 cm",
                    "missing_value": "255"
                }
            }
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.008999662",
            "long_name": "Longitude"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.009000123",
            "long_name": "Latitude"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.009000112",
            "long_name": "Longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "km",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "km",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "km",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Latitude"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "km",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/SoilGrids"
    },
    "TAMU": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "TAMU",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridlhasSemantics": "iridl:TAMU",
            "Conventions": "IRIDL"
        },
        "dir": "SOURCES/TAMU"
    },
    "TMA": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/TMA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "TMA",
        "restriction": "requires dlauth tokens"
    },
    "TRENBERTH": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "TRENBERTH",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Monthlyreference": "Trenberth,K.E.,J.G.Olson & W.G.Large, 1989: A Global Ocean Wind Stress Climatology Based on ECMWF Analyses.NCAR Tech. Note NCAR/TN-338+STR, 93 pp.",
            "Monthlyhistory": "ECMWF analyses Monthly Means 1980-1989",
            "Annualhistory": "ECMWF analyses Climate Annual Mean 1980-1989",
            "Annualreference": "Trenberth,K.E.,J.G.Olson & W.G.Large, 1989: A Global Ocean Wind Stress Climatology Based on ECMWF Analyses.NCAR Tech. Note NCAR/TN-338+STR, 93 pp.",
            "description": "Global ocean wind stress climatology based on ECMWF analyses by Trenberth et. al",
            "references": "Trenberth:etal1989",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.TRENBERTH/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NCAR",
            "Conventions": "IRIDL"
        },
        "Monthly": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Monthly",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Meridional wind"
            },
            "ut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Scalar mean of wind"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Zonal wind"
            },
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Stress in Y-direction"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Stress in X-direction"
            },
            "taut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Scalar mean of stress"
            },
            "sv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of meridional wind"
            },
            "sut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of scalar mean of wind"
            },
            "su": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "su",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of zonal wind"
            },
            "stauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of stress in Y-direction"
            },
            "staux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "staux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of stress in X-direction"
            },
            "staut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "staut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of scalar mean of stress"
            },
            "scurl": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "scurl",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "10**-9 dynes/cm**3",
                "long_name": "Standard deviation of curl of stress"
            },
            "mask": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "mask",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "integer*1",
                "long_name": "Land/Sea/Ice Mask: 0-sea, 1-land, 2-ice",
                "description": "land determination based on ETOPO5 elevation values at 1/12 deg resolution. Legend: 1-LAND ie. at least 75% of region is land even if grid point is ocean 0-SEA  ie. less than 25% of region is land even if grid point is land 2-SEAICE as inferred from the Alexander-Mobley SST climatology where SST < -2.0 Celsius for the month"
            },
            "curl": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "curl",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "10**-9 dynes/cm**3",
                "long_name": "Curl of stress"
            }
        },
        "Annual": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Annual",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Meridional wind"
            },
            "ut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Scalar mean of wind"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Zonal wind"
            },
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Stress in Y-direction"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Stress in X-direction"
            },
            "taut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Scalar mean of stress"
            },
            "sv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of meridional wind"
            },
            "sut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of scalar mean of wind"
            },
            "su": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "su",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m/s",
                "long_name": "Standard deviation of zonal wind"
            },
            "stauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of stress in Y-direction"
            },
            "staux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "staux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of stress in X-direction"
            },
            "staut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "staut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "dynes/cm**2",
                "long_name": "Standard deviation of scalar mean of stress"
            },
            "scurl": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "scurl",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "10**-9 dynes/cm**3",
                "long_name": "Standard deviation of curl of stress"
            },
            "curl": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "curl",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "10**-9 dynes/cm**3",
                "long_name": "Curl of stress"
            }
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "modulo": "12.0",
            "calendar": "360"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5"
        },
        "dir": "SOURCES/TRENBERTH"
    },
    "Taiwan": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Taiwan",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Taiwan",
        "restriction": "Public",
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ]
    },
    "UCSB": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UCSB",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CHIRTSv10dailyglobal0p05website": "https://www.chc.ucsb.edu/data/chirtsdaily",
            "CHIRTSv10dailyglobal0p05title": "CHIRTSdaily Version 1.0",
            "CHIRTSv10dailyglobal0p05history": "created by Climate Hazards Group",
            "CHIRTSv10dailyglobal0p05institution": "Climate Hazards Group.  University of California at Santa Barbara",
            "CHIRTSv10dailyglobal0p05ftp_url": "ftp://ftp.chc.ucsb.edu/pub/org/chg/products/CHIRTSdaily/v1.0/global_tifs_p05/",
            "CHIRTSv10dailyglobal0p05reference": "Funk, C. et al. A high-resolution 1983\\xe2\\x80\\x932016 Tmax climate data record based on infrared temperatures and stations by the Climate Hazard Center. J. Clim. 32, 5639-5658 (2019)",
            "CHIRPSv2p0monthlyglobalNMME_deg1p0description": "CHIRPS monthly precipitation regridded to 1.0 deg. lat/lon resolution to match NMME models between 49S and 49N",
            "CHIRPSv2p0monthlyglobalNMME_deg1p0expires": "1614556800",
            "CHIRPSv2p0monthlyglobaldeg1p0description": "regridded to 1.0 deg. lat/lon resolution",
            "CHIRPSv2p0monthlyglobaldeg1p0expires": "1614556800",
            "CHIRPSv2p0monthlyglobalc8113description": "1981-2013 climatology",
            "CHIRPSv2p0monthlyglobalc8113expires": "1614556800",
            "CHIRPSv2p0monthlyglobalUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0monthlyglobalreferences": "Funk_etal2014",
            "CHIRPSv2p0monthlyglobalsource": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0/global_monthly/tifs/",
            "CHIRPSv2p0monthlyglobalexpires": "1614556800",
            "CHIRPSv2p0monthlyglobalCHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dekadUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dekadreferences": "Funk_etal2014",
            "CHIRPSv2p0dekadsource": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0/global_dekad/tifs/",
            "CHIRPSv2p0dekadexpires": "1618531200",
            "CHIRPSv2p0dekadCHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyimprovedglobal0p25creator_email": "pete@geog.ucsb.edu",
            "CHIRPSv2p0dailyimprovedglobal0p25acknowledgements": " and the USGS Land Change Science Program.",
            "CHIRPSv2p0dailyimprovedglobal0p25version": "Version 2.0",
            "CHIRPSv2p0dailyimprovedglobal0p25source": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0/global_daily/tifs/p25/",
            "CHIRPSv2p0dailyimprovedglobal0p25institution": "Climate Hazards Group.  University of California at Santa Barbara",
            "CHIRPSv2p0dailyimprovedglobal0p25date_created": "2015-02-19",
            "CHIRPSv2p0dailyimprovedglobal0p25references": "Funk_etal2014",
            "CHIRPSv2p0dailyimprovedglobal0p25faq": "http://chg-wiki.geog.ucsb.edu/wiki/CHIRPS_FAQ",
            "CHIRPSv2p0dailyimprovedglobal0p25ftp_url": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0/",
            "CHIRPSv2p0dailyimprovedglobal0p25reference": "Funk, C.C., Peterson, P.J., Landsfeld, M.F., Pedreros, D.H., Verdin, J.P., Rowland, J.D., Romero, B.E., Husak, G.J., Michaelsen, J.C., and Verdin, A.P., 2014, A quasi-global precipitation time series for drought monitoring: U.S. Geological Survey Data Series 832, 4 p., http://dx.doi.org/110.3133/ds832. ",
            "CHIRPSv2p0dailyimprovedglobal0p25website": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyimprovedglobal0p25expires": "1614556800",
            "CHIRPSv2p0dailyimprovedglobal0p25note": "There is an improved temporal downscaling procedure for estimating the final daily CHIRPS.  The previous daily data will be supported through the end of 2015. Since CHIRPS pentads and monthly remain unchanged there will be no change in the CHIRPS version number. This is not a new version of CHIRPS, it is an improvement on the temporal downscaling to daily estimates.  The Problem:  When temporally downscaling CHIRPS to daily maps, there are many locations with significant residuals.  (Residual here is the difference between monthly CHIRPS and the sum of daily CHIRPS for that month) In fact for over 80 percent of the locations with residuals, the residual was 100 percent of the monthly CHIRPS. These are places where the daily CCD fails, often due to warm precipitation.  The Solution:  Add an extra step to distribute the monthly precipitation to across days in the month only for pixels where the monthly residual is > 1 mm.  The first challenge was to decide the appropriate number of days of precipitation for a given month. We used the locations with zero residual to derive a relationship between total monthly CHIRPS and number of rain days.  Now, using the total residual and number of rain days, we use the highest N values of daily CHIRP for the month to proportionally distribute the monthly total across those days.",
            "CHIRPSv2p0dailyimprovedglobal0p25title": "CHIRPS Version 2.0",
            "CHIRPSv2p0dailyimprovedglobal0p25documentation": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyimprovedglobal0p25USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyimprovedglobal0p25creator_name": "Pete Peterson",
            "CHIRPSv2p0dailyimprovedglobal0p25CHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyimprovedglobal0p25history": "created by Climate Hazards Center",
            "CHIRPSv2p0dailyimprovedglobal0p05creator_email": "pete@geog.ucsb.edu",
            "CHIRPSv2p0dailyimprovedglobal0p05acknowledgements": " and the USGS Land Change Science Program.",
            "CHIRPSv2p0dailyimprovedglobal0p05version": "Version 2.0",
            "CHIRPSv2p0dailyimprovedglobal0p05source": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0/global_daily/tifs/p05/",
            "CHIRPSv2p0dailyimprovedglobal0p05institution": "Climate Hazards Center.  University of California at Santa Barbara",
            "CHIRPSv2p0dailyimprovedglobal0p05date_created": "2015-02-20",
            "CHIRPSv2p0dailyimprovedglobal0p05references": "Funk_etal2014",
            "CHIRPSv2p0dailyimprovedglobal0p05faq": "http://chg-wiki.geog.ucsb.edu/wiki/CHIRPS_FAQ",
            "CHIRPSv2p0dailyimprovedglobal0p05ftp_url": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRPS-2.0",
            "CHIRPSv2p0dailyimprovedglobal0p05reference": "Funk, C.C., Peterson, P.J., Landsfeld, M.F., Pedreros, D.H., Verdin, J.P., Rowland, J.D., Romero, B.E., Husak, G.J., Michaelsen, J.C., and Verdin, A.P., 2014, A quasi-global precipitation time series for drought monitoring: U.S. Geological Survey Data Series 832, 4 p., http://dx.doi.org/110.3133/ds832. ",
            "CHIRPSv2p0dailyimprovedglobal0p05website": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyimprovedglobal0p05expires": "1614556800",
            "CHIRPSv2p0dailyimprovedglobal0p05note": "There is an improved temporal downscaling procedure for estimating the final daily CHIRPS.  The previous daily data will be supported through the end of 2015. Since CHIRPS pentads and monthly remain unchanged there will be no change in the CHIRPS version number. This is not a new version of CHIRPS, it is an improvement on the temporal downscaling to daily estimates.  The Problem:  When temporally downscaling CHIRPS to daily maps, there are many locations with significant residuals.  (Residual here is the difference between monthly CHIRPS and the sum of daily CHIRPS for that month) In fact for over 80 percent of the locations with residuals, the residual was 100 percent of the monthly CHIRPS. These are places where the daily CCD fails, often due to warm precipitation.  The Solution:  Add an extra step to distribute the monthly precipitation to across days in the month only for pixels where the monthly residual is > 1 mm.  The first challenge was to decide the appropriate number of days of precipitation for a given month. We used the locations with zero residual to derive a relationship between total monthly CHIRPS and number of rain days.  Now, using the total residual and number of rain days, we use the highest N values of daily CHIRP for the month to proportionally distribute the monthly total across those days.",
            "CHIRPSv2p0dailyimprovedglobal0p05title": "CHIRPS Version 2.0",
            "CHIRPSv2p0dailyimprovedglobal0p05documentation": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyimprovedglobal0p05USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyimprovedglobal0p05creator_name": "Pete Peterson",
            "CHIRPSv2p0dailyimprovedglobal0p05CHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyimprovedglobal0p05history": "created by Climate Hazards Center",
            "CHIRPSv2p0dailyimprovednote": "There is an improved temporal downscaling procedure for estimating the final daily CHIRPS.  The previous daily data will be supported through the end of 2015. Since CHIRPS pentads and monthly remain unchanged there will be no change in the CHIRPS version number. This is not a new version of CHIRPS, it is an improvement on the temporal downscaling to daily estimates.  The Problem:  When temporally downscaling CHIRPS to daily maps, there are many locations with significant residuals.  (Residual here is the difference between monthly CHIRPS and the sum of daily CHIRPS for that month) In fact for over 80 percent of the locations with residuals, the residual was 100 percent of the monthly CHIRPS. These are places where the daily CCD fails, often due to warm precipitation.  The Solution:  Add an extra step to distribute the monthly precipitation to across days in the month only for pixels where the monthly residual is > 1 mm.  The first challenge was to decide the appropriate number of days of precipitation for a given month. We used the locations with zero residual to derive a relationship between total monthly CHIRPS and number of rain days.  Now, using the total residual and number of rain days, we use the highest N values of daily CHIRP for the month to proportionally distribute the monthly total across those days.",
            "CHIRPSv2p0dailyimproveddescription": "Daily CHIRPS v2.0 data with improved temporal downscaling procedure",
            "CHIRPSv2p0dailyglobal0p25creator_email": "pete@geog.ucsb.edu",
            "CHIRPSv2p0dailyglobal0p25acknowledgements": " and the USGS Land Change Science Program.",
            "CHIRPSv2p0dailyglobal0p25version": "Version 2.0",
            "CHIRPSv2p0dailyglobal0p25source": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-2.0/global_daily/tifs/p25/",
            "CHIRPSv2p0dailyglobal0p25institution": "Climate Hazards Group.  University of California at Santa Barbara",
            "CHIRPSv2p0dailyglobal0p25date_created": "2015-02-19",
            "CHIRPSv2p0dailyglobal0p25references": "Funk_etal2014",
            "CHIRPSv2p0dailyglobal0p25faq": "http://chg-wiki.geog.ucsb.edu/wiki/CHIRPS_FAQ",
            "CHIRPSv2p0dailyglobal0p25ftp_url": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-latest/",
            "CHIRPSv2p0dailyglobal0p25reference": "Funk, C.C., Peterson, P.J., Landsfeld, M.F., Pedreros, D.H., Verdin, J.P., Rowland, J.D., Romero, B.E., Husak, G.J., Michaelsen, J.C., and Verdin, A.P., 2014, A quasi-global precipitation time series for drought monitoring: U.S. Geological Survey Data Series 832, 4 p., http://dx.doi.org/110.3133/ds832. ",
            "CHIRPSv2p0dailyglobal0p25website": "http://chg.geog.ucsb.edu/data/chirps/index.html",
            "CHIRPSv2p0dailyglobal0p25note": "IMPORTANT NOTE:  As of 24 April 2015, all daily CHIRPS 2.0 data from year 2000 onward available in the Data Library were removed and new data requests for that period will access data reprocessed by the UCSB Climate Hazards Group.  The reprocessing corrects a problem found in daily CHIRPS for the CPC-IR time period, 2000 \\xe2\\x80\\x93 present.  There was a problem creating the daily percent cold cloud duration (percent CCD) map used in the downscaling. Places with missing IR data were set to zero instead of missing. Anywhere this happened, the precipitation was set to zero. This was always a problem for Eastern Australia/Indonesia/Japan, where a gap between two geostationary satellites exists. There were a small number of times this problem occurred outside of these particular areas.",
            "CHIRPSv2p0dailyglobal0p25title": "CHIRPS Version 2.0",
            "CHIRPSv2p0dailyglobal0p25documentation": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyglobal0p25USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyglobal0p25creator_name": "Pete Peterson",
            "CHIRPSv2p0dailyglobal0p25CHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyglobal0p25history": "created by Climate Hazards Group",
            "CHIRPSv2p0dailyglobal0p25dailyimproved": "http://iridl.ldeo.columbia.edu/SOURCES/.UCSB/.CHIRPS/.v2p0/.daily-improved/.global/.0p25/.prcp/",
            "CHIRPSv2p0dailyglobal0p05creator_email": "pete@geog.ucsb.edu",
            "CHIRPSv2p0dailyglobal0p05acknowledgements": " and the USGS Land Change Science Program.",
            "CHIRPSv2p0dailyglobal0p05version": "Version 2.0",
            "CHIRPSv2p0dailyglobal0p05source": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-2.0/global_daily/tifs/p05/",
            "CHIRPSv2p0dailyglobal0p05institution": "Climate Hazards Group.  University of California at Santa Barbara",
            "CHIRPSv2p0dailyglobal0p05date_created": "2015-02-20",
            "CHIRPSv2p0dailyglobal0p05references": "Funk_etal2014",
            "CHIRPSv2p0dailyglobal0p05faq": "http://chg-wiki.geog.ucsb.edu/wiki/CHIRPS_FAQ",
            "CHIRPSv2p0dailyglobal0p05ftp_url": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-latest/",
            "CHIRPSv2p0dailyglobal0p05reference": "Funk, C.C., Peterson, P.J., Landsfeld, M.F., Pedreros, D.H., Verdin, J.P., Rowland, J.D., Romero, B.E., Husak, G.J., Michaelsen, J.C., and Verdin, A.P., 2014, A quasi-global precipitation time series for drought monitoring: U.S. Geological Survey Data Series 832, 4 p., http://dx.doi.org/110.3133/ds832. ",
            "CHIRPSv2p0dailyglobal0p05website": "http://chg.geog.ucsb.edu/data/chirps/index.html",
            "CHIRPSv2p0dailyglobal0p05note": "IMPORTANT NOTE:  As of 24 April 2015, all daily CHIRPS 2.0 data from year 2000 onward available in the Data Library were removed and new data requests for that period will access data reprocessed by the UCSB Climate Hazards Group.  The reprocessing corrects a problem found in daily CHIRPS for the CPC-IR time period, 2000 \\xe2\\x80\\x93 present.  There was a problem creating the daily percent cold cloud duration (percent CCD) map used in the downscaling. Places with missing IR data were set to zero instead of missing. Anywhere this happened, the precipitation was set to zero. This was always a problem for Eastern Australia/Indonesia/Japan, where a gap between two geostationary satellites exists. There were a small number of times this problem occurred outside of these particular areas.",
            "CHIRPSv2p0dailyglobal0p05title": "CHIRPS Version 2.0",
            "CHIRPSv2p0dailyglobal0p05documentation": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyglobal0p05USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv2p0dailyglobal0p05creator_name": "Pete Peterson",
            "CHIRPSv2p0dailyglobal0p05CHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv2p0dailyglobal0p05history": "created by Climate Hazards Group",
            "CHIRPSv2p0dailyglobal0p05dailyimproved": "http://iridl.ldeo.columbia.edu/SOURCES/.UCSB/.CHIRPS/.v2p0/.daily-improved/.global/.0p05/.prcp/",
            "CHIRPSv1p8monthlyglobalc8113description": "1981-2013 climatology",
            "CHIRPSv1p8monthlyglobalUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv1p8monthlyglobalreferences": "Funk_etal2014",
            "CHIRPSv1p8monthlyglobalsource": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-1.8/global_monthly/tifs/",
            "CHIRPSv1p8monthlyglobalv2p0": "http://iridl.ldeo.columbia.edu/SOURCES/.UCSB/.CHIRPS/.v2p0/.monthly/.global/",
            "CHIRPSv1p8monthlyglobalCHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv1p8dekadUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv1p8dekadreferences": "Funk_etal2014",
            "CHIRPSv1p8dekadsource": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-1.8/global_dekad/tifs/",
            "CHIRPSv1p8dekadv2p0": "http://iridl.ldeo.columbia.edu/SOURCES/.UCSB/.CHIRPS/.v2p0/.dekad/",
            "CHIRPSv1p8dekadCHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv1p8dailyafrica0p25USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv1p8dailyafrica0p25references": "Funk_etal2014",
            "CHIRPSv1p8dailyafrica0p25source": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-1.8/africa_daily/tifs/africa_p25_tif/",
            "CHIRPSv1p8dailyafrica0p25CHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv1p8dailyafrica0p05USGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPSv1p8dailyafrica0p05references": "Funk_etal2014",
            "CHIRPSv1p8dailyafrica0p05source": "ftp://chg-ftpout.geog.ucsb.edu/pub/org/chg/products/CHIRPS-1.8/africa_daily/tifs/africa_p05_tif/",
            "CHIRPSv1p8dailyafrica0p05CHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPSv1p7dekadv1p8": "http://iridl.ldeo.columbia.edu/SOURCES/.UCSB/.CHIRPS/.v1p8/.dekad/",
            "CHIRPSv1p7long_name": "v1.7",
            "CHIRPSv1p7dataset_documentation": "http://chg.geog.ucsb.edu/data/chirps.pdf",
            "CHIRPSiridlhasSemantics": "iridlsemantics:FEWS",
            "CHIRPSCHIRPS": "http://chg.geog.ucsb.edu/data/chirps/",
            "CHIRPv1p0dekadUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPv1p0dekadreferences": "Funk_etal2014",
            "CHIRPv1p0dekadsource": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRP/dekads/",
            "CHIRPv1p0dekadexpires": "1615420800",
            "CHIRPv1p0dekadCHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPv1p0dailycreator_email": "pete@geog.ucsb.edu",
            "CHIRPv1p0dailyacknowledgements": " and the USGS Land Change Science Program.",
            "CHIRPv1p0dailysource": "ftp://ftp.chc.ucsb.edu/pub/org/chc/products/CHIRP/daily/",
            "CHIRPv1p0dailyinstitution": "Climate Hazards Center.  University of California at Santa Barbara",
            "CHIRPv1p0dailyfaq": "https://wiki.chc.ucsb.edu/CHIRPS_FAQ",
            "CHIRPv1p0dailyreferences": "Funk_etal2014",
            "CHIRPv1p0dailyreference": "Funk, C.C., Peterson, P.J., Landsfeld, M.F., Pedreros, D.H., Verdin, J.P., Rowland, J.D., Romero, B.E., Husak, G.J., Michaelsen, J.C., and Verdin, A.P., 2014, A quasi-global precipitation time series for drought monitoring: U.S. Geological Survey Data Series 832, 4 p., http://dx.doi.org/110.3133/ds832. ",
            "CHIRPv1p0dailywebsite": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPv1p0dailyexpires": "1614643200",
            "CHIRPv1p0dailytitle": "CHIRP Daily",
            "CHIRPv1p0dailydocumentation": "http://pubs.usgs.gov/ds/832/",
            "CHIRPv1p0dailyUSGS": "http://pubs.usgs.gov/ds/832/",
            "CHIRPv1p0dailycreator_name": "Pete Peterson",
            "CHIRPv1p0dailyCHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "CHIRPv1p0dailyhistory": "created by Climate Hazards Center",
            "CHIRPiridlhasSemantics": "iridlsemantics:FEWS",
            "CHIRPCHIRPS": "https://www.chc.ucsb.edu/data/chirps/",
            "description": "UC Santa Barbara",
            "Conventions": "IRIDL"
        },
        "CHIRTS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CHIRTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1.0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Minimum Temperature ",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "long_name": "Maximum Temperature ",
                                "units": "Celsius_scale",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                }
            }
        },
        "CHIRPS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CHIRPS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v2p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "1500.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "1500.0",
                            "colorscalename": "prcp_monthlyrate_max1500_smooth",
                            "expires": "1614556800",
                            "long_name": "CHIRPS precipitation",
                            "units": "mm/month",
                            "standard_name": "lwe_precipitation_rate",
                            "missing_value": "-9999.0",
                            "pointwidth": "1.0"
                        },
                        "NMME_deg1p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NMME_deg1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 25.0% dropped",
                                "file_missing_value": "-9999.0",
                                "colormap": "2237106",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "0.0",
                                "CE": "1500.0",
                                "colorscalename": "prcp_monthlyrate_max1500_smooth",
                                "expires": "1614556800",
                                "long_name": "CHIRPS precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            }
                        },
                        "deg1p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "missing_value": "NaN",
                                "history": "Boxes with less than 50.0% dropped",
                                "file_missing_value": "-9999.0",
                                "colormap": "2237106",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "0.0",
                                "CE": "1500.0",
                                "colorscalename": "prcp_monthlyrate_max1500_smooth",
                                "expires": "1614556800",
                                "long_name": "CHIRPS precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            }
                        },
                        "c8113": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8113",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2013] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "colormap": "2237106",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_monthlyrate_max1500_smooth",
                                "expires": "1614556800",
                                "long_name": "CHIRPS precipitation",
                                "units": "mm/month",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "dekad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dekad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "2237106",
                        "scale_max": "600.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "600.0",
                        "colorscalename": "prcp_dekadrate_max600_smooth",
                        "expires": "1618531200",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "cacheRemoteFileUpdateType": "0",
                        "units": "mm",
                        "missing_value": "-9999.0"
                    }
                },
                "dailyimproved": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily-improved",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p25": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p25",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "expires": "1614556800",
                                "long_name": "precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "pointwidth": "1.0"
                            }
                        },
                        "p05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "expires": "1614556800",
                                "long_name": "precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p25": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p25",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "long_name": "precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "pointwidth": "1.0"
                            }
                        },
                        "p05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "long_name": "precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                }
            },
            "v1p8": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p8",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2237106",
                            "scale_max": "1500.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "1500.0",
                            "colorscalename": "prcp_monthlyrate_max1500_smooth",
                            "long_name": "CHIRPS precipitation",
                            "units": "mm/month",
                            "standard_name": "lwe_precipitation_rate",
                            "missing_value": "-9999.0",
                            "pointwidth": "1.0"
                        },
                        "c8113": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8113",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2013] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "colormap": "2237106",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "colorscalename": "prcp_monthlyrate_max1500_smooth",
                                "long_name": "CHIRPS precipitation",
                                "units": "mm/month",
                                "standard_name": "lwe_precipitation_rate",
                                "pointwidth": "1.0"
                            }
                        }
                    }
                },
                "dekad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dekad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "2237106",
                        "scale_max": "600.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "600.0",
                        "colorscalename": "prcp_dekadrate_max600_smooth",
                        "long_name": "precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm",
                        "missing_value": "-9999.0"
                    }
                },
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "africa": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "africa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p25": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p25",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "standard_name": "lwe_precipitation_rate",
                                "missing_value": "-9999.0",
                                "pointwidth": "1"
                            }
                        },
                        "p05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precipitation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precipitation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "100.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "100.0",
                                "colorscalename": "prcp_dailyrate_max100_smooth",
                                "long_name": "precipitation",
                                "units": "mm/day",
                                "standard_name": "lwe_precipitation_rate",
                                "missing_value": "-9999.0",
                                "pointwidth": "1"
                            }
                        }
                    }
                }
            },
            "v1p7": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p7",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "dekad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dekad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-9999.0"
                    }
                }
            }
        },
        "CHIRP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CHIRP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v1p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "dekad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dekad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "2237106",
                        "scale_max": "600.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "600.0",
                        "colorscalename": "prcp_dekadrate_max600_smooth",
                        "expires": "1615420800",
                        "missing_value": "-9999.0",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "units": "mm"
                    }
                },
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "2237106",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "100.0",
                        "colorscalename": "prcp_dailyrate_max100_smooth",
                        "expires": "1614643200",
                        "long_name": "precipitation",
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/day",
                        "missing_value": "-9999.0",
                        "pointwidth": "1.0"
                    }
                }
            }
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.05",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "expires": "1614556800",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0"
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1614556800",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time",
            "calendar": "360"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "calendar": "360",
            "modulo": "12.0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.05",
            "standard_name": "longitude"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.05",
            "standard_name": "latitude"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01 12:00:00",
            "gridtype": "0",
            "pointwidth": "1",
            "standard_name": "time",
            "calendar": "standard"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.05",
            "standard_name": "longitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1615420800",
            "standard_name": "time"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.05",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1614643200",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.05",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/UCSB"
    },
    "UEA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UEA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CRUTS4p01monthlystnBADC": "http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01monthlystncitation": "University of East Anglia Climatic Research Unit; Harris, I.C.; Jones, P.D. (2017): CRU TS4.01: Climatic Research Unit (CRU) Time-Series (TS) version 4.01 of high-resolution gridded data of month-by-month variation in climate (Jan. 1901- Dec. 2016). Centre for Environmental Data Analysis, date of citation. http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01monthlystnlong_name": "number of contributing stations",
            "CRUTS4p01monthlystnreferences": "Harris_etal2014",
            "CRUTS4p01monthlystntitle": "CRU TS4.01",
            "CRUTS4p01monthlystnConventions": "CF-1.4",
            "CRUTS4p01monthlystninstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS4p01monthlystncomment": "Access to these data is available to any registered CEDA user",
            "CRUTS4p01monthlystnnote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS4p01monthlystncontact": "BADC",
            "CRUTS4p01monthlyBADC": "http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01monthlycitation": "University of East Anglia Climatic Research Unit; Harris, I.C.; Jones, P.D. (2017): CRU TS4.01: Climatic Research Unit (CRU) Time-Series (TS) version 4.01 of high-resolution gridded data of month-by-month variation in climate (Jan. 1901- Dec. 2016). Centre for Environmental Data Analysis, date of citation. http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01monthlyReference": "https://www.nature.com/articles/s41597-020-0453-3",
            "CRUTS4p01monthlyreferences": "Harris_etal2020",
            "CRUTS4p01monthlytitle": "CRU TS4.01",
            "CRUTS4p01monthlyConventions": "CF-1.4",
            "CRUTS4p01monthlyinstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS4p01monthlycomment": "Access to these data is available to any registered CEDA user",
            "CRUTS4p01monthlyRelease": "https://crudata.uea.ac.uk/cru/data/hrg/cru_ts_4.01/Release_Notes_CRU_TS4.01.txt",
            "CRUTS4p01monthlynote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS4p01monthlycontact": "BADC",
            "CRUTS4p01getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS4p01.getting_permission.html",
            "CRUTS4p01comment": "Access to these data is available to any registered CEDA user",
            "CRUTS4p01citation": "f month-by-month variation in climate (Jan. 1901- Dec. 2016). Centre for Environmental Data Analysis, date of citation. http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01title": "CRU TS4.01",
            "CRUTS4p01Release": "https://crudata.uea.ac.uk/cru/data/hrg/cru_ts_4.01/Release_Notes_CRU_TS4.01.txt",
            "CRUTS4p01references": "Harris_etal2020",
            "CRUTS4p01description": "CRU TS4.01: Climatic Research Unit (CRU) Time-Series (TS) Version 4.01 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2016)",
            "CRUTS4p01BADC": "http://catalogue.ceda.ac.uk/uuid/58a8802721c94c66ae45c3baa4d814d0",
            "CRUTS4p01note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS4p01Reference": "https://www.nature.com/articles/s41597-020-0453-3",
            "CRUTS4p01institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS4p01Conventions": "CF-1.4",
            "CRUTS4p01contact": "BADC",
            "CRUTS3p23monthlystncontact": "badc@rl.ac.uk",
            "CRUTS3p23monthlystnBADC": "http://catalogue.ceda.ac.uk/uuid/5dca9487dc614711a3a933e44a933ad3",
            "CRUTS3p23monthlystncitation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2015): CRU TS3.23: Climatic Research Unit (CRU) Time-Series (TS) Version 3.23 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2014). Centre for Environmental Data Analysis, 09 November 2015. doi:10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5. http://dx.doi.org/10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5",
            "CRUTS3p23monthlystnlong_name": "number of stations within correlation decay distance of grid box",
            "CRUTS3p23monthlystnreferences": "Harris_etal2014",
            "CRUTS3p23monthlystntitle": "CRU TS3.23",
            "CRUTS3p23monthlystnConventions": "CF-1.4",
            "CRUTS3p23monthlystninstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p23monthlystncomment": "Access to these data is available to any registered CEDA user",
            "CRUTS3p23monthlystnnote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p23monthlyst0contact": "badc@rl.ac.uk",
            "CRUTS3p23monthlyst0BADC": "http://catalogue.ceda.ac.uk/uuid/5dca9487dc614711a3a933e44a933ad3",
            "CRUTS3p23monthlyst0citation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2015): CRU TS3.23: Climatic Research Unit (CRU) Time-Series (TS) Version 3.23 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2014). Centre for Environmental Data Analysis, 09 November 2015. doi:10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5. http://dx.doi.org/10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5",
            "CRUTS3p23monthlyst0long_name": "number of stations within grid box",
            "CRUTS3p23monthlyst0references": "Harris_etal2014",
            "CRUTS3p23monthlyst0title": "CRU TS3.23",
            "CRUTS3p23monthlyst0Conventions": "CF-1.4",
            "CRUTS3p23monthlyst0institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p23monthlyst0comment": "Access to these data is available to any registered CEDA user",
            "CRUTS3p23monthlyst0note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p23monthlyBADC": "http://catalogue.ceda.ac.uk/uuid/5dca9487dc614711a3a933e44a933ad3",
            "CRUTS3p23monthlycitation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2015): CRU TS3.23: Climatic Research Unit (CRU) Time-Series (TS) Version 3.23 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2014). Centre for Environmental Data Analysis, 09 November 2015. doi:10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5. http://dx.doi.org/10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5",
            "CRUTS3p23monthlyReference": "http://dx.doi.org/10.1002/joc.3711",
            "CRUTS3p23monthlyreferences": "Harris_etal2014",
            "CRUTS3p23monthlytitle": "CRU TS3.23",
            "CRUTS3p23monthlyConventions": "CF-1.4",
            "CRUTS3p23monthlyinstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p23monthlycomment": "Access to these data is available to any registered CEDA user",
            "CRUTS3p23monthlynote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p23monthlycontact": "badc@rl.ac.uk",
            "CRUTS3p23getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p23.getting_permission.html",
            "CRUTS3p23comment": "Access to these data is available to any registered CEDA user",
            "CRUTS3p23citation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2015): CRU TS3.23: Climatic Research Unit (CRU) Time-Series (TS) Version 3.23 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2014). Centre for Environmental Data Analysis, 09 November 2015. doi:10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5. http://dx.doi.org/10.5285/4c7fdfa6-f176-4c58-acee-683d5e9d2ed5",
            "CRUTS3p23title": "CRU TS3.23",
            "CRUTS3p23references": "Harris_etal2014",
            "CRUTS3p23description": "CRU TS3.23: Climatic Research Unit (CRU) Time-Series (TS) Version 3.23 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2014)",
            "CRUTS3p23BADC": "http://catalogue.ceda.ac.uk/uuid/5dca9487dc614711a3a933e44a933ad3",
            "CRUTS3p23note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p23Reference": "http://dx.doi.org/10.1002/joc.3711",
            "CRUTS3p23institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p23Conventions": "CF-1.4",
            "CRUTS3p23contact": "badc@rl.ac.uk",
            "CRUTS3p22monthlystncontact": "BADC ",
            "CRUTS3p22monthlystnBADC": "http://catalogue.ceda.ac.uk/uuid/4a6d071383976a5fb24b5b42e28cf28f",
            "CRUTS3p22monthlystncitation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2014): CRU TS3.22: Climatic Research Unit (CRU) Time-Series (TS) Version 3.22 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2013). NCAS British Atmospheric Data Centre, 24th September 2014. doi:10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C. http://dx.doi.org/10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C",
            "CRUTS3p22monthlystnlong_name": "number of stations within correlation decay distance of grid box",
            "CRUTS3p22monthlystnreferences": "Harris_etal2014",
            "CRUTS3p22monthlystntitle": "CRU TS3.22",
            "CRUTS3p22monthlystnConventions": "CF-1.4",
            "CRUTS3p22monthlystninstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p22monthlystncomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p22monthlystnnote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p22monthlyst0contact": "BADC ",
            "CRUTS3p22monthlyst0BADC": "http://catalogue.ceda.ac.uk/uuid/4a6d071383976a5fb24b5b42e28cf28f",
            "CRUTS3p22monthlyst0citation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2014): CRU TS3.22: Climatic Research Unit (CRU) Time-Series (TS) Version 3.22 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2013). NCAS British Atmospheric Data Centre, 24th September 2014. doi:10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C. http://dx.doi.org/10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C",
            "CRUTS3p22monthlyst0long_name": "number of stations within grid box",
            "CRUTS3p22monthlyst0references": "Harris_etal2014",
            "CRUTS3p22monthlyst0title": "CRU TS3.22",
            "CRUTS3p22monthlyst0Conventions": "CF-1.4",
            "CRUTS3p22monthlyst0institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p22monthlyst0comment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p22monthlyst0note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p22monthlyBADC": "http://catalogue.ceda.ac.uk/uuid/4a6d071383976a5fb24b5b42e28cf28f",
            "CRUTS3p22monthlycitation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2014): CRU TS3.22: Climatic Research Unit (CRU) Time-Series (TS) Version 3.22 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2013). NCAS British Atmospheric Data Centre, 24th September 2014. doi:10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C. http://dx.doi.org/10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C",
            "CRUTS3p22monthlyReference": "http://dx.doi.org/10.1002/joc.3711",
            "CRUTS3p22monthlyreferences": "Harris_etal2014",
            "CRUTS3p22monthlytitle": "CRU TS3.22",
            "CRUTS3p22monthlyConventions": "CF-1.4",
            "CRUTS3p22monthlyinstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p22monthlycomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p22monthlynote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p22monthlycontact": "BADC ",
            "CRUTS3p22getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p22.getting_permission.html",
            "CRUTS3p22comment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p22citation": "University of East Anglia Climatic Research Unit; Harris, I.; Jones, P.D. (2014): CRU TS3.22: Climatic Research Unit (CRU) Time-Series (TS) Version 3.22 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901- Dec. 2013). NCAS British Atmospheric Data Centre, 24 th September 2014. doi:10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C. http://dx.doi.org/10.5285/18BE23F8-D252-482D-8AF9-5D6A2D40990C",
            "CRUTS3p22title": "CRU TS3.22",
            "CRUTS3p22references": "Harris_etal2014",
            "CRUTS3p22description": "CRU TS3.22: Climatic Research Unit (CRU) Time-Series (TS) Version 3.22 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2013)",
            "CRUTS3p22BADC": "http://catalogue.ceda.ac.uk/uuid/4a6d071383976a5fb24b5b42e28cf28f",
            "CRUTS3p22note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p22Reference": "http://dx.doi.org/10.1002/joc.3711",
            "CRUTS3p22institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p22Conventions": "CF-1.4",
            "CRUTS3p22contact": "BADC ",
            "CRUTS3p21monthlystncontact": "BADC ",
            "CRUTS3p21monthlystnBADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233",
            "CRUTS3p21monthlystncitation": "University of East Anglia Climatic Research Unit (CRU). [Phil Jones, Ian Harris]. CRU TS3.21: Climatic Research Unit (CRU) Time-Series (TS) Version 3.21 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2012), [Internet]. NCAS British Atmospheric Data Centre, 2013, Date of citation. Available from http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233 ; doi: 10.5285/D0E1585D-3417-485F-87AE-4FCECF10A992",
            "CRUTS3p21monthlystnlong_name": "number of stations within correlation decay distance of grid box",
            "CRUTS3p21monthlystnreferences": "Harris_etal2014",
            "CRUTS3p21monthlystntitle": "CRU TS3.21",
            "CRUTS3p21monthlystnConventions": "CF-1.4",
            "CRUTS3p21monthlystninstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p21monthlystncomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p21monthlystnhistory": "Wed 10 Jul 2013 18:28:10 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p21monthlystnnote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p21monthlyst0contact": "BADC ",
            "CRUTS3p21monthlyst0BADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233",
            "CRUTS3p21monthlyst0citation": "University of East Anglia Climatic Research Unit (CRU). [Phil Jones, Ian Harris]. CRU TS3.21: Climatic Research Unit (CRU) Time-Series (TS) Version 3.21 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2012), [Internet]. NCAS British Atmospheric Data Centre, 2013, Date of citation. Available from http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233 ; doi: 10.5285/D0E1585D-3417-485F-87AE-4FCECF10A992",
            "CRUTS3p21monthlyst0long_name": "number of stations within grid box",
            "CRUTS3p21monthlyst0references": "Harris_etal2014",
            "CRUTS3p21monthlyst0title": "CRU TS3.21",
            "CRUTS3p21monthlyst0Conventions": "CF-1.4",
            "CRUTS3p21monthlyst0institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p21monthlyst0comment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p21monthlyst0history": "Wed 10 Jul 2013 18:28:10 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p21monthlyst0note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p21monthlyBADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233",
            "CRUTS3p21monthlycitation": "University of East Anglia Climatic Research Unit (CRU). [Phil Jones, Ian Harris]. CRU TS3.21: Climatic Research Unit (CRU) Time-Series (TS) Version 3.21 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2012), [Internet]. NCAS British Atmospheric Data Centre, 2013, Date of citation. Available from http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233 ; doi: 10.5285/D0E1585D-3417-485F-87AE-4FCECF10A992",
            "CRUTS3p21monthlyreferences": "Harris_etal2014",
            "CRUTS3p21monthlytitle": "CRU TS3.21",
            "CRUTS3p21monthlyConventions": "CF-1.4",
            "CRUTS3p21monthlyinstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p21monthlycomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p21monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p21.monthly.dataset_documentation.html",
            "CRUTS3p21monthlyhistory": "Wed 10 Jul 2013 18:28:10 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p21monthlynote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p21monthlycontact": "BADC ",
            "CRUTS3p21climatologyc19012012long_name": "1901-2012",
            "CRUTS3p21climatologyc19012012iridlhasSemantics": "iridl:climatology",
            "CRUTS3p21citation": "University of East Anglia Climatic Research Unit (CRU). [Phil Jones, Ian Harris]. CRU TS3.21: Climatic Research Unit (CRU) Time-Series (TS) Version 3.21 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2012), [Internet]. NCAS British Atmospheric Data Centre, 2013, Date of citation. Available from http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233 ; doi: 10.5285/D0E1585D-3417-485F-87AE-4FCECF10A992",
            "CRUTS3p21references": "Harris_etal2014",
            "CRUTS3p21description": "CRU TS3.21: Climatic Research Unit (CRU) Time-Series (TS) Version 3.21 of High Resolution Gridded Data of Month-by-month Variation in Climate (Jan. 1901 - Dec. 2012)",
            "CRUTS3p21BADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_0c08abfc-f2d5-11e2-a948-00163e251233",
            "CRUTS3p21note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p21dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p21.dataset_documentation.html",
            "CRUTS3p21TS3p22": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p22/",
            "CRUTS3p21getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p21.getting_permission.html",
            "CRUTS3p2monthlystncontact": "BADC ",
            "CRUTS3p2monthlystnBADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_3ec0d1c6-4616-11e2-89a3-00163e251233",
            "CRUTS3p2monthlystnlong_name": "number of stations within correlation decay distance of grid box",
            "CRUTS3p2monthlystnreferences": "Harris_etal2014",
            "CRUTS3p2monthlystntitle": "CRU TS3.20",
            "CRUTS3p2monthlystnConventions": "CF-1.4",
            "CRUTS3p2monthlystninstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p2monthlystncomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p2monthlystnhistory": "Thu 25 Oct 2012 22:16:55 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p2monthlystnnote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p2monthlyst0contact": "BADC ",
            "CRUTS3p2monthlyst0BADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_3ec0d1c6-4616-11e2-89a3-00163e251233",
            "CRUTS3p2monthlyst0long_name": "number of stations within grid box",
            "CRUTS3p2monthlyst0references": "Harris_etal2014",
            "CRUTS3p2monthlyst0title": "CRU TS3.20",
            "CRUTS3p2monthlyst0Conventions": "CF-1.4",
            "CRUTS3p2monthlyst0institution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p2monthlyst0comment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p2monthlyst0history": "Thu 25 Oct 2012 22:16:55 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p2monthlyst0note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p2monthlyBADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_3ec0d1c6-4616-11e2-89a3-00163e251233",
            "CRUTS3p2monthlyreferences": "Harris_etal2014",
            "CRUTS3p2monthlytitle": "CRU TS3.20",
            "CRUTS3p2monthlyConventions": "CF-1.4",
            "CRUTS3p2monthlyinstitution": "Data held at British Atmospheric Data Centre, RAL, UK.",
            "CRUTS3p2monthlycomment": "Data restrictions: for academic research use only.Contact BADC for details",
            "CRUTS3p2monthlyhistory": "Thu 25 Oct 2012 22:16:55 BST : User ianharris : Program makegridsauto.for called by update.for",
            "CRUTS3p2monthlynote": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p2monthlycontact": "BADC ",
            "CRUTS3p2getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p2.getting_permission.html",
            "CRUTS3p2TS3p1": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p1/",
            "CRUTS3p2references": "Harris_etal2014",
            "CRUTS3p2description": "TS3.2 Data:  Mean surface climate data over global land areas",
            "CRUTS3p2BADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__ACTIVITY_3ec0d1c6-4616-11e2-89a3-00163e251233",
            "CRUTS3p2note": "CRU Conditions of Use states that acknowledgement should preferably be by citing one or more of the papers referenced",
            "CRUTS3p2TS3p21": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p21/",
            "CRUTS3p1r2p5long_name": "coarser resolution",
            "CRUTS3p1r2p5maxage": "604800",
            "CRUTS3p1monthlystnlong_name": "number of stations within correlation decay distance of grid box",
            "CRUTS3p1monthlyst0long_name": "number of stations within grid box",
            "CRUTS3p1monthlyBADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__dataent_1256223773328276",
            "CRUTS3p1monthlynote": "count files were added to the IRI Data Library holdings on July 23, 2012, replacing the previous version of these files.",
            "CRUTS3p1climatologyc19012009long_name": "1901-2009",
            "CRUTS3p1climatologyc19012009iridlhasSemantics": "iridl:climatology",
            "CRUTS3p1climatologyc19012007long_name": "1901-2009",
            "CRUTS3p1climatologyc19012007iridlhasSemantics": "iridl:climatology",
            "CRUTS3p1TS3p2": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p2/",
            "CRUTS3p1references": "Harris_etal2014 Mitchell_Jones2005",
            "CRUTS3p1description": "TS3.1 Data:  Mean surface climate data over global land areas",
            "CRUTS3p1BADC": "http://badc.nerc.ac.uk/view/badc.nerc.ac.uk__ATOM__dataent_1256223773328276",
            "CRUTS3p1note": "these files.",
            "CRUTS3p1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p1.dataset_documentation.html",
            "CRUTS3p1getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p1.getting_permission.html",
            "CRUTS3p0monthlystnlong_name": "number of stations within influence range of grid box",
            "CRUTS3p0monthlycstnlong_name": "number of stations within grid box",
            "CRUTS3p0monthlygetting": "../getting_permission.html",
            "CRUTS3p0getting_permissionhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p0.getting_permission.html",
            "CRUTS3p0Replaced": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p1/",
            "CRUTS3p0references": "Mitchell_Jones2005",
            "CRUTS3p0description": "TS3.0 Pre-Release (Interim) Data:  Mean surface climate data over global land areas",
            "CRUTS3p0dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS3p0.dataset_documentation.html",
            "CRUTS2p1tercilesc7100long_name": "1971-2000",
            "CRUTS2p1percentilesc7100long_name": "1971-2000",
            "CRUTS2p1monthlystationslong_name": "number of stations within range of grid box",
            "CRUTS2p1climatologyc7100long_name": "1971-2000",
            "CRUTS2p1climatologyc7100iridlhasSemantics": "iridl:climatology",
            "CRUTS2p1TS3p0": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS3p0/",
            "CRUTS2p1references": "Mitchell_Jones2005",
            "CRUTS2p1description": "Mean surface climate data over global land areas, including tercile and percentile data",
            "CRUTS2p1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.TS2p1.dataset_documentation.html",
            "CRUNewCRU05climatologyc6190long_name": "1961-1990",
            "CRUNewCRU05climatologyc6190iridlhasSemantics": "iridl:climatology",
            "CRUNewCRU05climatologyc6190dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.New.CRU05.climatology.c6190.dataset_documentation.html",
            "CRUNewCRU05GCMD_id": "CRU05",
            "CRUNewCRU05references": "New_etal1999",
            "CRUNewCRU05dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.New.CRU05.dataset_documentation.html",
            "CRUNewCRU05TS2p1": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.TS2p1/",
            "CRUNewdescription": "Mean surface climate data over global land areas, including tercile and percentile data",
            "CRUJonesv199902landseaHadCRUT2": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.HadCRUT2/",
            "CRUJonesv199902landseadescription": "Historical land air temperature and sea surface temperature anomalies (superseded by HadCRUT2)",
            "CRUJonesv199902landseairidlhasSemantics": "iridl:HADLEY",
            "CRUJonesv199902landonlydescription": "Historical land air temperature anomalies (superseded by CRUTEM2)",
            "CRUJonesHadCRUT3vdescription": "Variance adjusted version of HadCRUT3",
            "CRUJonesHadCRUT3vreferences": "Brohan_etal2006",
            "CRUJonesHadCRUT3viridlhasSemantics": "iridl:HADLEY",
            "CRUJonesHadCRUT3description": "Combined land and marine [sea surface temperature (SST) anomalies from the Hadley Centre of the UK Meteorological Office]",
            "CRUJonesHadCRUT3references": "Brohan_etal2006",
            "CRUJonesHadCRUT3iridlhasSemantics": "iridl:HADLEY",
            "CRUJonesHADCRUT2vdescription": "Variance adjusted version of HadCRUT2 (superseded by HadCRUT3v)",
            "CRUJonesHADCRUT2viridlhasSemantics": "iridl:HADLEY",
            "CRUJonesHADCRUT2vHadCRUT3v": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.HadCRUT3v/",
            "CRUJonesHadCRUT2HadCRUT3": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.HadCRUT3/",
            "CRUJonesHadCRUT2description": "Combined land and marine [sea surface temperature (SST) anomalies from the Hadley Centre of the UK Meteorological Office] (superseded by HadCRUT3)",
            "CRUJonesHadCRUT2iridlhasSemantics": "iridl:HADLEY",
            "CRUJonesHadCRUT1HadCRUT2": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.HadCRUT2/",
            "CRUJonesHadCRUT1description": "Historical land air temperature and sea surface temperature anomalies (superseded by HadCRUT2)",
            "CRUJonesHadCRUT1iridlhasSemantics": "iridl:HADLEY",
            "CRUJonesCRUTEM4p2p0p0version": "CRUTEM.4.2.0.0",
            "CRUJonesCRUTEM4p2p0p0source": "http://hadobs.metoffice.com/crutem4/data/download.html",
            "CRUJonesCRUTEM4p2p0p0release_notes": "http://hadobs.metoffice.com/crutem4/data/CRUTEM.4.2.0.0_release_notes.html",
            "CRUJonesCRUTEM4p2p0p0references": "Jones_etal2012 Brohan_etal2006",
            "CRUJonesCRUTEM4p2p0p0description": "Land air temperature anomalies",
            "CRUJonesCRUTEM4p2p0p0reference": "Jones, P. D., D. H. Lister, T. J. Osborn, C. Harpham, M. Salmon, and C. P. Morice (2012), Hemispheric and large-scale land-surface air temperature variations: An extensive revision and an update to 2010, J. Geophys. Res., 117, D05127, doi:10.1029/2011JD017139",
            "CRUJonesCRUTEM4p2p0p0Conventions": "CF-1.0",
            "CRUJonesCRUTEM4p2p0p0institution": "Climatic Research Unit, University of East Anglia/Met Office Hadley Centre",
            "CRUJonesCRUTEM4p2p0p0iridlhasSemantics": "iridl:HADLEY",
            "CRUJonesCRUTEM4p2p0p0CRUTEM4": "http://hadobs.metoffice.com/crutem4/",
            "CRUJonesCRUTEM3vCRUTEM4200": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.CRUTEM4p2p0p0/",
            "CRUJonesCRUTEM3vdescription": "Variance adjusted version of CRUTEM3",
            "CRUJonesCRUTEM3vreferences": "Brohan_etal2006",
            "CRUJonesCRUTEM3viridlhasSemantics": "iridl:HADLEY",
            "CRUJonesCRUTEM3CRUTEM4200": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.CRUTEM4p2p0p0/",
            "CRUJonesCRUTEM3description": "Land air temperature anomalies",
            "CRUJonesCRUTEM3references": "Brohan_etal2006",
            "CRUJonesCRUTEM3iridlhasSemantics": "iridl:HADLEY",
            "CRUJonesCRUTEM2vdescription": "Variance adjusted version of land air temperature anomalies (superseded by CRUTEM3v)",
            "CRUJonesCRUTEM2vreferences": "Jones_etal2001",
            "CRUJonesCRUTEM2vCRUTEM3v": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.CRUTEM3v/",
            "CRUJonesCRUTEM2CRUTEM3": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU/.Jones/.CRUTEM3/",
            "CRUJonesCRUTEM2description": "Historical land air temperature anomalies (superseded by CRUTEM3)",
            "CRUJonesCRUTEM2references": "Jones_Moberg2003",
            "CRUJonesCRUTEM1description": "Historical land air temperature anomalies (superseded by CRUTEM2)",
            "CRUJonesclimatologydescription": "",
            "CRUJonesGCMD_id": "CRU_JONES",
            "CRUJonesCRU": "http://www.cru.uea.ac.uk/cru/data/temperature/",
            "CRUJonesreferences": "Jones_Moberg2003 Jones_etal2001 Brohan_etal2006",
            "CRUJonesdescription": "Land air temperature and sea surface temperature anomalies",
            "CRUHulmeGlobalreferences": "Hulme1992 Hulme_etal1998 Hulme1994",
            "CRUHulmeGlobaldescription": "Historical monthly precipitation dataset for global land areas",
            "CRUHulmeGlobaldataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.Hulme.Global.dataset_documentation.html",
            "CRUGlobalreferences": "Hulme1992 Hulme1994",
            "CRUGlobaldescription": "Historical monthly precipitation dataset for global land areas",
            "CRUGlobaldataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UEA/.CRU.Global.dataset_documentation.html",
            "CRUCRU": "http://www.cru.uea.ac.uk/",
            "description": "University of East Anglia",
            "iridlhasSemantics": "iridl:UEA",
            "Conventions": "IRIDL"
        },
        "CRU": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CRU",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "TS4p01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS4p01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "long_name": "wet day frequency",
                        "correlation_decay_distance": "450.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "long_name": "vapour pressure",
                        "correlation_decay_distance": "1000.0",
                        "units": "hPa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature maximum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0",
                        "units": "Celsius_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature minimum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for wet day frequency",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for wet",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for vapour pressure",
                            "correlation_decay_distance": "1000.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for vap",
                            "pointwidth": "1"
                        },
                        "tmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for maximum temperature",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for tmx",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for mean temperature",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for tmp",
                            "pointwidth": "1"
                        },
                        "tmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for minimum temperature",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for tmn",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for precipitation",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for pre",
                            "pointwidth": "1"
                        },
                        "frs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "frs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for ground frost frequency",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for frs",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for diurnal temperature range",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "description": "number of stations contributing to each datum for dtr",
                            "pointwidth": "1"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "long_name": "observation count for cloud cover",
                            "correlation_decay_distance": "600.0",
                            "units": "number",
                            "description": "pre-2003, size of station pool from which three are used for each datum; 2003 onwards, number of stations contributing to each datum",
                            "pointwidth": "1"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "700.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "700",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0",
                        "units": "mm/month",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "long_name": "potential evapotranspiration",
                        "units": "mm/day",
                        "correlation_decay_distance": "-999.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "9043968",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "long_name": "ground frost frequency",
                        "correlation_decay_distance": "750.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "diurnal temperature range",
                        "units": "degree_Celsius",
                        "correlation_decay_distance": "750.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "long_name": "cloud cover",
                        "correlation_decay_distance": "600.0",
                        "units": "percentage",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    }
                }
            },
            "TS3p23": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p23",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "long_name": "wet day frequency",
                        "correlation_decay_distance": "450.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "long_name": "vapour pressure",
                        "correlation_decay_distance": "1000.0",
                        "units": "hPa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature maximum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0",
                        "units": "Celsius_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature minimum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for wet",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for vap",
                            "correlation_decay_distance": "1000.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmpdtr",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmp",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for pre",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for dtr",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for cld",
                            "correlation_decay_distance": "600.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "st0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for wet",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for vap",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmpdtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmp",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for pre",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for dtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "700.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "700",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0",
                        "units": "mm/month",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "long_name": "potential evapotranspiration",
                        "units": "mm/day",
                        "correlation_decay_distance": "-999.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "9043968",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "long_name": "ground frost frequency",
                        "correlation_decay_distance": "750.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "diurnal temperature range",
                        "units": "degree_Celsius",
                        "correlation_decay_distance": "750.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "long_name": "cloud cover",
                        "correlation_decay_distance": "600.0",
                        "units": "percentage",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    }
                }
            },
            "TS3p22": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p22",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "long_name": "wet day frequency",
                        "correlation_decay_distance": "450.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "long_name": "vapour pressure",
                        "correlation_decay_distance": "1000.0",
                        "units": "hPa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature maximum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0",
                        "units": "Celsius_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature minimum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for wet",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for vap",
                            "correlation_decay_distance": "1000.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmpdtr",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmp",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for pre",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for dtr",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for cld",
                            "correlation_decay_distance": "600.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "st0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for wet",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for vap",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmpdtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmp",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for pre",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for dtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "700.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "700",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0",
                        "units": "mm/month",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "long_name": "potential evapotranspiration",
                        "units": "mm/day",
                        "correlation_decay_distance": "-999.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "9043968",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "long_name": "ground frost frequency",
                        "correlation_decay_distance": "750.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "diurnal temperature range",
                        "units": "degree_Celsius",
                        "correlation_decay_distance": "750.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "long_name": "cloud cover",
                        "correlation_decay_distance": "600.0",
                        "units": "percentage",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    }
                }
            },
            "TS3p21": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p21",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "long_name": "wet day frequency",
                        "correlation_decay_distance": "450.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "long_name": "vapour pressure",
                        "correlation_decay_distance": "1000.0",
                        "units": "hPa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature maximum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0",
                        "units": "Celsius_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature minimum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for wet",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for vap",
                            "correlation_decay_distance": "1000.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmpdtr",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmp",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for pre",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for dtr",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for cld",
                            "correlation_decay_distance": "600.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "st0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for wet",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for vap",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmpdtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmp",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for pre",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for dtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "1"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "700.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "700",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0",
                        "units": "mm/month",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "long_name": "potential evapotranspiration",
                        "units": "mm/day",
                        "correlation_decay_distance": "-999.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "9043968",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "long_name": "ground frost frequency",
                        "correlation_decay_distance": "750.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "diurnal temperature range",
                        "units": "degree_Celsius",
                        "correlation_decay_distance": "750.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "long_name": "cloud cover",
                        "correlation_decay_distance": "600.0",
                        "units": "percentage",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1"
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c19012012": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c1901-2012",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "colormap": "145411",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                            "long_name": "wet day frequency",
                            "correlation_decay_distance": "450.0",
                            "units": "days",
                            "pointwidth": "1"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_vapor_pressure",
                            "long_name": "vapour pressure",
                            "correlation_decay_distance": "1000.0",
                            "units": "hPa",
                            "pointwidth": "1"
                        },
                        "tmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "long_name": "near-surface temperature maximum",
                            "units": "Celsius_scale",
                            "correlation_decay_distance": "1200.0",
                            "pointwidth": "1"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "long_name": "near-surface temperature",
                            "correlation_decay_distance": "1200.0",
                            "units": "Celsius_scale",
                            "pointwidth": "1"
                        },
                        "tmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "long_name": "near-surface temperature minimum",
                            "units": "Celsius_scale",
                            "correlation_decay_distance": "1200.0",
                            "pointwidth": "1"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "colormap": "145411",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "standard_name": "lwe_precipitation_rate",
                            "long_name": "precipitation",
                            "correlation_decay_distance": "450.0",
                            "units": "mm/month",
                            "pointwidth": "1"
                        },
                        "pet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_potential_evaporation_flux",
                            "long_name": "potential evapotranspiration",
                            "units": "mm/day",
                            "correlation_decay_distance": "-999.0",
                            "pointwidth": "1"
                        },
                        "frs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "frs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "colormap": "9043968",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "long_name": "ground frost frequency",
                            "correlation_decay_distance": "750.0",
                            "units": "days",
                            "pointwidth": "1"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "long_name": "diurnal temperature range",
                            "units": "degree_Celsius",
                            "correlation_decay_distance": "750.0",
                            "pointwidth": "1"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2012] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "cloud_area_fraction",
                            "long_name": "cloud cover",
                            "correlation_decay_distance": "600.0",
                            "units": "percentage",
                            "pointwidth": "1"
                        }
                    }
                }
            },
            "TS3p2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "long_name": "wet day frequency",
                        "correlation_decay_distance": "450.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "long_name": "vapour pressure",
                        "correlation_decay_distance": "1000.0",
                        "units": "hPa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature maximum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0",
                        "units": "Celsius_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature minimum",
                        "units": "Celsius_scale",
                        "correlation_decay_distance": "1200.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for wet",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for vap",
                            "correlation_decay_distance": "1000.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmpdtr",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for tmp",
                            "correlation_decay_distance": "1200.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for pre",
                            "correlation_decay_distance": "450.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for dtr",
                            "correlation_decay_distance": "750.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "within-CDD station count for cld",
                            "correlation_decay_distance": "600.0",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        }
                    },
                    "st0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for wet",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for vap",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmpdtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for tmp",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for pre",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "in-cell station count for dtr",
                            "units": "number",
                            "missing_value": "9.96920997E36",
                            "pointwidth": "0"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "145411",
                        "scale_max": "700.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "700",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0",
                        "units": "mm/month",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "long_name": "potential evapotranspiration",
                        "units": "mm/day",
                        "correlation_decay_distance": "-999.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "9043968",
                        "scale_max": "31.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "31",
                        "long_name": "ground frost frequency",
                        "correlation_decay_distance": "750.0",
                        "units": "days",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "diurnal temperature range",
                        "units": "degree_Celsius",
                        "correlation_decay_distance": "750.0",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "long_name": "cloud cover",
                        "correlation_decay_distance": "600.0",
                        "units": "percentage",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "0"
                    }
                }
            },
            "TS3p1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "r2p5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "r2p5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxage": "604800",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 0.0% dropped",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "air_temperature",
                        "long_name": "near-surface temperature",
                        "correlation_decay_distance": "1200.0"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxage": "604800",
                            "units": "count",
                            "missing_value": "NaN",
                            "history": "Boxes with less than 0.0% dropped",
                            "file_missing_value": "9.96920997E36",
                            "long_name": "near-surface temperature",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxage": "604800",
                            "units": "count",
                            "missing_value": "NaN",
                            "history": "Boxes with less than 0.0% dropped",
                            "fnname": "maskrange",
                            "long_name": "within-CDD station count for pre",
                            "file_missing_value": "9.96920997E36",
                            "correlation_decay_distance": "450.0"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxage": "604800",
                        "units": "mm/month",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 0.0% dropped",
                        "file_missing_value": "9.96920997E36",
                        "standard_name": "lwe_precipitation_rate",
                        "long_name": "precipitation",
                        "correlation_decay_distance": "450.0"
                    }
                },
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                        "units": "days",
                        "long_name": "wet day frequency",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "450.0"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "units": "hPa",
                        "long_name": "vapour pressure",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "1000.0"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "units": "Celsius_scale",
                        "long_name": "near-surface temperature maximum",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "1200.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "units": "Celsius_scale",
                        "long_name": "near-surface temperature",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "1200.0"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "units": "Celsius_scale",
                        "long_name": "near-surface temperature minimum",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "1200.0"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "100.0",
                            "long_name": "wet day frequency",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "450.0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "long_name": "vapour pressure",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1000.0"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "number of tmp and dtr stations",
                            "units": "count",
                            "scale_factor": "10.0",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "long_name": "near-surface temperature",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "fnname": "maskrange",
                            "long_name": "within-CDD station count for pre",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "correlation_decay_distance": "450.0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "diurnal temperature range",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "correlation_decay_distance": "750.0"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "cloud cover",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "correlation_decay_distance": "600.0"
                        }
                    },
                    "st0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "100.0",
                            "long_name": "wet day frequency",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "450.0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "long_name": "vapour pressure",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1000.0"
                        },
                        "tmpdtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmpdtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "number of tmp and dtr stations",
                            "units": "count",
                            "scale_factor": "10.0",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "long_name": "near-surface temperature",
                            "missing_value": "9.96920997E36",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "fnname": "maskrange",
                            "long_name": "in-cell station count for pre",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "count",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "diurnal temperature range",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "correlation_decay_distance": "750.0"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "lwe_precipitation_rate",
                        "units": "mm/month",
                        "long_name": "precipitation",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "450.0"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_potential_evaporation_flux",
                        "units": "mm/day",
                        "long_name": "potential evapotranspiration",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "-999.0"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days",
                        "long_name": "ground frost frequency",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "750.0"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degrees Celsius",
                        "long_name": "diurnal temperature range",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "750.0"
                    },
                    "cld": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cld",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "cloud_area_fraction",
                        "units": "percentage",
                        "long_name": "cloud cover",
                        "missing_value": "9.96920997E36",
                        "correlation_decay_distance": "600.0"
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c19012009": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c1901-2009",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                            "units": "days",
                            "long_name": "wet day frequency",
                            "correlation_decay_distance": "450.0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_vapor_pressure",
                            "units": "hPa",
                            "long_name": "vapour pressure",
                            "correlation_decay_distance": "1000.0"
                        },
                        "tmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature maximum",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature minimum",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/month",
                            "long_name": "precipitation",
                            "correlation_decay_distance": "450.0"
                        },
                        "pet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_potential_evaporation_flux",
                            "units": "mm/day",
                            "long_name": "potential evapotranspiration",
                            "correlation_decay_distance": "-999.0"
                        },
                        "frs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "frs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "units": "days",
                            "long_name": "ground frost frequency",
                            "correlation_decay_distance": "750.0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "units": "degrees Celsius",
                            "long_name": "diurnal temperature range",
                            "correlation_decay_distance": "750.0"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "cloud_area_fraction",
                            "units": "percentage",
                            "long_name": "cloud cover",
                            "correlation_decay_distance": "600.0"
                        }
                    },
                    "c19012007": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c1901-2007",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "number_of_days_with_lwe_thickness_of_precipitation_amount_above_threshold",
                            "units": "days",
                            "long_name": "wet day frequency",
                            "correlation_decay_distance": "450.0"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_vapor_pressure",
                            "units": "hPa",
                            "long_name": "vapour pressure",
                            "correlation_decay_distance": "1000.0"
                        },
                        "tmx": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmx",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature maximum",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature",
                            "correlation_decay_distance": "1200.0"
                        },
                        "tmn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "air_temperature",
                            "units": "Celsius_scale",
                            "long_name": "near-surface temperature minimum",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "lwe_precipitation_rate",
                            "units": "mm/month",
                            "long_name": "precipitation",
                            "correlation_decay_distance": "450.0"
                        },
                        "pet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "water_potential_evaporation_flux",
                            "units": "mm/day",
                            "long_name": "potential evapotranspiration",
                            "correlation_decay_distance": "-999.0"
                        },
                        "frs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "frs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "units": "days",
                            "long_name": "ground frost frequency",
                            "correlation_decay_distance": "750.0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "units": "degrees Celsius",
                            "long_name": "diurnal temperature range",
                            "correlation_decay_distance": "750.0"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1901, 2009] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "9.96920997E36",
                            "standard_name": "cloud_area_fraction",
                            "units": "percentage",
                            "long_name": "cloud cover",
                            "correlation_decay_distance": "600.0"
                        }
                    }
                }
            },
            "TS3p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS3p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "fnname": "maskrange",
                        "long_name": "wet day frequency",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "days",
                        "correlation_decay_distance": "450.0"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "water_vapor_pressure",
                        "fnname": "maskrange",
                        "long_name": "vapour pressure",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "hPa",
                        "correlation_decay_distance": "1000.0"
                    },
                    "tmx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "fnname": "maskrange",
                        "long_name": "near-surface temperature maximum",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "degrees Celsius",
                        "correlation_decay_distance": "1200.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "fnname": "maskrange",
                        "long_name": "near-surface temperature",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "degrees Celsius",
                        "correlation_decay_distance": "1200.0"
                    },
                    "tmn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature",
                        "fnname": "maskrange",
                        "long_name": "near-surface temperature minimum",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "degrees Celsius",
                        "correlation_decay_distance": "1200.0"
                    },
                    "stn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "near-surface temperature",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "precipitation",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "450.0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "diurnal temperature range",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "1200.0"
                        }
                    },
                    "pre": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pre",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "precipitation_amount",
                        "fnname": "maskrange",
                        "long_name": "precipitation",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "mm",
                        "correlation_decay_distance": "450.0"
                    },
                    "frs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:Count",
                        "fnname": "maskrange",
                        "long_name": "ground frost frequency",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "days",
                        "correlation_decay_distance": "750.0"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:AirTemperature",
                        "fnname": "maskrange",
                        "long_name": "diurnal temperature range",
                        "missing_value": "NaN",
                        "file_missing_value": "-9999",
                        "units": "degrees Celsius",
                        "correlation_decay_distance": "1200.0"
                    },
                    "cstn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cstn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "near-surface temperature",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "1200.0"
                        },
                        "pre": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pre",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "precipitation",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "450.0"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:Count",
                            "units": "number of stations",
                            "scale_factor": "10.0",
                            "fnname": "maskrange",
                            "long_name": "diurnal temperature range",
                            "missing_value": "NaN",
                            "file_missing_value": "-9999",
                            "correlation_decay_distance": "1200.0"
                        }
                    }
                }
            },
            "TS2p1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS2p1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "terciles": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "terciles",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c7100": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c7100",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "seasonal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "seasonal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "units": "Celsius_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "long_name": "temperature"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "units": "mm/month",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "long_name": "precipitation"
                            }
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "mm/month",
                                "long_name": "precipitation"
                            }
                        }
                    }
                },
                "percentiles": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percentiles",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c7100": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c7100",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "seasonal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "seasonal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "units": "Celsius_scale",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "long_name": "temperature"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "units": "mm/month",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "long_name": "precipitation"
                            }
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 50% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "mm/month",
                                "long_name": "precipitation"
                            }
                        }
                    }
                },
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9.9899998",
                        "units": "days/month",
                        "long_name": "wet day frequency"
                    },
                    "vap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "hPa",
                        "long_name": "vapor pressure"
                    },
                    "stations": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stations",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "valid_max": "32767.0",
                            "valid_min": "-32768.0",
                            "long_name": "wet day frequency",
                            "units": "unitless"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "vapor pressure",
                            "missing_value": "-999.0"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "temperature",
                            "missing_value": "-999.0"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "precipitation",
                            "missing_value": "-999.0",
                            "iridlhasSemantics": "gcmdi:RAIN_GAUGES"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "diurnal temperature range",
                            "missing_value": "-999.0"
                        },
                        "cloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "percent cloud cover",
                            "missing_value": "-999.0"
                        }
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "mm/month",
                        "long_name": "precipitation"
                    },
                    "minimum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "minimum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "Celsius_scale",
                            "long_name": "temperature"
                        }
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "Celsius_scale",
                            "long_name": "temperature"
                        }
                    },
                    "maximum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "maximum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-99.900002",
                            "units": "Celsius_scale",
                            "long_name": "temperature"
                        }
                    },
                    "frost": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "frost",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9.9899998",
                        "units": "days/month",
                        "long_name": "frost day frequency"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-0.9990001",
                        "units": "km",
                        "long_name": "elevation"
                    },
                    "dtr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dtr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "Celsius_scale",
                        "long_name": "diurnal temperature range"
                    },
                    "cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.900002",
                        "units": "percent",
                        "long_name": "percent cloud cover"
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c7100": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c7100",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "145411",
                            "scale_max": "31.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "31",
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.9899998",
                            "units": "days/month",
                            "long_name": "wet day frequency"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "units": "hPa",
                            "long_name": "vapor pressure"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "145411",
                            "scale_max": "700.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "700",
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "units": "mm/month",
                            "long_name": "precipitation"
                        },
                        "minimum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "minimum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            }
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            }
                        },
                        "maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            }
                        },
                        "frost": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "frost",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "9043968",
                            "scale_max": "31.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "31",
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.9899998",
                            "units": "days/month",
                            "long_name": "frost day frequency"
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "units": "Celsius_scale",
                            "long_name": "diurnal temperature range"
                        },
                        "cloud": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cloud",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "units": "percent",
                            "long_name": "percent cloud cover"
                        }
                    }
                }
            },
            "New": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "New",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CRU05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRU05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "terciles": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "terciles",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "seasonal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "seasonal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "units": "Celsius_scale",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.90002",
                                    "long_name": "temperature"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "units": "mm/month",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9999",
                                    "long_name": "precipitation"
                                }
                            },
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.90002",
                                    "units": "Celsius_scale",
                                    "long_name": "temperature"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9999",
                                    "units": "mm/month",
                                    "long_name": "precipitation"
                                }
                            }
                        }
                    },
                    "percentiles": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "percentiles",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "seasonal": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "seasonal",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "units": "Celsius_scale",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.90002",
                                    "long_name": "temperature"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "units": "mm/month",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9999",
                                    "long_name": "precipitation"
                                }
                            },
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.90002",
                                    "units": "Celsius_scale",
                                    "long_name": "temperature"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "percentiles computed over T2:1961-1990 50% min data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9999",
                                    "units": "mm/month",
                                    "long_name": "precipitation"
                                }
                            }
                        }
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "wet": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wet",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.90002",
                            "units": "days/month",
                            "long_name": "wet day frequency"
                        },
                        "vap": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vap",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.90002",
                            "units": "hPa",
                            "long_name": "vapor pressure"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/month",
                            "long_name": "precipitation",
                            "missing_value": "-9999.0"
                        },
                        "mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "temp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "temp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "Celsius_scale",
                                "long_name": "temperature"
                            }
                        },
                        "dtr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dtr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.90002",
                            "units": "degree_Celsius",
                            "long_name": "diurnal temperature range"
                        },
                        "cld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "percent",
                            "long_name": "cloud cover",
                            "missing_value": "-9999.0"
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wspd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wspd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "m/s",
                                "long_name": "wind speed"
                            },
                            "wet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "days/month",
                                "long_name": "wet day frequency"
                            },
                            "vap": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vap",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "hPa",
                                "long_name": "vapor pressure"
                            },
                            "rad": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rad",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "long_name": "radiation",
                                "missing_value": "-9999.0"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "mm/day",
                                "long_name": "precipitation"
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.90002",
                                    "units": "Celsius_scale",
                                    "long_name": "temperature"
                                }
                            },
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.90002",
                                    "units": "Celsius_scale",
                                    "long_name": "temperature"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.90002",
                                    "units": "Celsius_scale",
                                    "long_name": "temperature"
                                }
                            },
                            "frs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "frs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "days/month",
                                "long_name": "Ground-frost Frequency"
                            },
                            "dtr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dtr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "degree_Celsius",
                                "long_name": "diurnal temperature range"
                            },
                            "cld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "percent",
                                "long_name": "cloud cover",
                                "missing_value": "-9999.0"
                            }
                        }
                    }
                }
            },
            "Jones": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Jones",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v199902": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v199902",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "landsea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landsea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "t_air": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_air",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Celsius",
                            "missing_value": "-32768",
                            "scale_factor": "0.01"
                        }
                    },
                    "landonly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landonly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "t_air": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "t_air",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_Celsius",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        },
                        "count": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "count",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless"
                        }
                    }
                },
                "HadCRUT3v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HadCRUT3v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "varadjtanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "varadjtanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Variance Adjusted Temperature Anomaly",
                        "valid_max": "22.449213",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-18.970049",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    }
                },
                "HadCRUT3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HadCRUT3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature Anomaly",
                        "valid_max": "22.46298",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.9",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "stnerror": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stnerror",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Station Error",
                        "valid_max": "3.0933638",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "0.0",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "mserror": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mserror",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Measurement and Sampling Error",
                        "valid_max": "10.0",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "0.00400244",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "biased_97p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_97p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature Anomalies Including Biases at the Upper Uncertainty Range",
                        "valid_max": "22.46298",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.752542",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "biased_2p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_2p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature Anomalies Including Biases at the Lower Uncertainty Range",
                        "valid_max": "22.46298",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.984934",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    }
                },
                "HADCRUT2v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HADCRUT2v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Celsius",
                        "long_name": "temperature_anomaly",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    }
                },
                "HadCRUT2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HadCRUT2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Celsius",
                        "long_name": "temperature_anomaly",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    }
                },
                "HadCRUT1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HadCRUT1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "t_air": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_air",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Celsius",
                        "missing_value": "-32768",
                        "scale_factor": "0.01"
                    }
                },
                "CRUTEM4p2p0p0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM4p2p0p0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "var_adj_tanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "var_adj_tanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "2237106",
                        "scale_max": "6.0",
                        "ncolor": "254",
                        "scale_min": "-6.0",
                        "CS": "-6.0",
                        "colorscalename": "temp_anomaly_colors_gcm",
                        "CE": "6.0",
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Variance-Adjusted Temperature Anomaly",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "tanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "2237106",
                        "scale_max": "6.0",
                        "ncolor": "254",
                        "scale_min": "-6.0",
                        "CS": "-6.0",
                        "colorscalename": "temp_anomaly_colors_gcm",
                        "CE": "6.0",
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Best Estimate Temperature Anomaly",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "station_error": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "station_error",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Station Error",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "sampling_error": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sampling_error",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sampling Error",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "nobs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nobs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Number of Observations",
                        "units": "unitless",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "biased_97p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_97p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "2237106",
                        "scale_max": "6.0",
                        "ncolor": "254",
                        "scale_min": "-6.0",
                        "CS": "-6.0",
                        "colorscalename": "temp_anomaly_colors_gcm",
                        "CE": "6.0",
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Temperature Anomalies Including Biases at the Upper Uncertainty Range",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    },
                    "biased_2p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_2p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "2237106",
                        "scale_max": "6.0",
                        "ncolor": "254",
                        "scale_min": "-6.0",
                        "CS": "-6.0",
                        "colorscalename": "temp_anomaly_colors_gcm",
                        "CE": "6.0",
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Temperature Anomalies Including Biases at the Lower Uncertainty Range",
                        "units": "Kelvin_scale",
                        "missing_value": "-1.00000002E30",
                        "reference_period": "1990"
                    }
                },
                "CRUTEM3v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM3v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "varadjtanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "varadjtanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Variance Adjusted Temperature Anomaly",
                        "valid_max": "17.352436",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-18.970049",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    }
                },
                "CRUTEM3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tanom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tanom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Best Estimate Temperature Anomaly",
                        "valid_max": "19.5",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.9",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "stnerror": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "stnerror",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Station Error",
                        "valid_max": "3.0933638",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "0.1292091",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "serror": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "serror",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sampling Error",
                        "valid_max": "2.937566",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "0.05871618",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "nobs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nobs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Number of Observations",
                        "units": "unitless",
                        "valid_max": "77.0",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "1.0",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "biased_97p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_97p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Temperature Anomalies Including Biases at the Upper Uncertainty Range",
                        "valid_max": "19.526951",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.752542",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    },
                    "biased_2p5pc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biased_2p5pc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "long_name": "Temperature Anomalies Including Biases at the Lower Uncertainty Range",
                        "valid_max": "19.5",
                        "units": "Kelvin_scale",
                        "title": "Temperature T",
                        "time": "00:00",
                        "valid_min": "-20.984934",
                        "date": "01/01/50",
                        "source": "No field processing",
                        "missing_value": "2.00000004E20"
                    }
                },
                "CRUTEM2v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM2v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "units": "degree_Celsius",
                        "long_name": "temperature_anomaly",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    }
                },
                "CRUTEM2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "air_temperature_anomaly",
                        "units": "degree_Celsius",
                        "long_name": "temperature_anomaly",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "count": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "count",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "0",
                        "units": "unitless"
                    }
                },
                "CRUTEM1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CRUTEM1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "t_air": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t_air",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Celsius",
                        "missing_value": "-9999",
                        "scale_factor": "0.01"
                    },
                    "count": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "count",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c6190": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c6190",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "long_name": "surface temperature",
                            "missing_value": "-9999",
                            "scale_factor": "0.01"
                        }
                    }
                }
            },
            "Hulme": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Hulme",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Global": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Global",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "Precipitation",
                        "history": "CRU Gridded Global Precip Dataset 3.75x2.5",
                        "missing_value": "-999.0"
                    }
                }
            },
            "Global": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Global",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm/month",
                    "long_name": "Precipitation",
                    "history": "CRU Gridded Global Precip Dataset 3.75x2.5",
                    "missing_value": "-999.0"
                }
            }
        },
        "T_21": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_21",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_20": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_20",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_19": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_19",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_18": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_18",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_17": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_17",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "long_name": "latitude"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.5",
            "modulus": "360.0",
            "long_name": "longitude"
        },
        "T_16": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_16",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "long_name": "latitude"
        },
        "T_15": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_15",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "bounds": "time"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5",
            "modulus": "360.0",
            "long_name": "longitude"
        },
        "T_14": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_14",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "percentile_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "percentile_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "percentile": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "percentile",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "T_13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "T_12": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_12",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "T_11": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_11",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "T_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1870-1-1",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "360"
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1856-1-1",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "360"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "time",
            "calendar": "360"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0",
            "point_spacing": "even"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1851-1-1",
            "gridtype": "0",
            "pointwidth": "1.0",
            "calendar": "360"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "time",
            "calendar": "360"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "modulus": "360.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "modulus": "360.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "modulo": "12.0",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "long_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "Time",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "3.75",
            "long_name": "longitude"
        },
        "dir": "SOURCES/UEA"
    },
    "UKMO": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UKMO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "GloSea5d1x1shiftnchindcast_ens28_multiyearassociated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearsource": "model-generated, GloSea5-GC2",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearmodeling_realm": "atmos",
            "GloSea5d1x1shiftnchindcast_ens28_multiyeartitle": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearum_version": "10.1",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearConventions": "CF-1.6",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearphysics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearcontributor_name": "Met Office",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearforecast_type": "hindcast",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearassociated_experiment": "GloSea5-GC2",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearinstitute_id": "UKMO",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearcontact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearinstitution": "Met Office",
            "GloSea5d1x1shiftnchindcast_ens28_multiyearmodel_id": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftnchindcast_ens28associated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftnchindcast_ens28source": "model-generated, GloSea5-GC2",
            "GloSea5d1x1shiftnchindcast_ens28initialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
            "GloSea5d1x1shiftnchindcast_ens28modeling_realm": "atmos",
            "GloSea5d1x1shiftnchindcast_ens28title": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1shiftnchindcast_ens28um_version": "10.1",
            "GloSea5d1x1shiftnchindcast_ens28Conventions": "CF-1.6",
            "GloSea5d1x1shiftnchindcast_ens28physics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1shiftnchindcast_ens28contributor_name": "Met Office",
            "GloSea5d1x1shiftnchindcast_ens28forecast_type": "hindcast",
            "GloSea5d1x1shiftnchindcast_ens28associated_experiment": "GloSea5-GC2",
            "GloSea5d1x1shiftnchindcast_ens28institute_id": "UKMO",
            "GloSea5d1x1shiftnchindcast_ens28contact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1shiftnchindcast_ens28institution": "Met Office",
            "GloSea5d1x1shiftnchindcast_ens28model_id": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftncforecastassociated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftncforecastsource": "model-generated, GloSea5-GC2",
            "GloSea5d1x1shiftncforecastinitialization_description": "Atmos:Met Office NWP 4DVar; Ocean & Sea-ice: Met Office FOAM NEMOVAR",
            "GloSea5d1x1shiftncforecastexpires": "1615420800",
            "GloSea5d1x1shiftncforecastmodeling_realm": "atmos",
            "GloSea5d1x1shiftncforecasttitle": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1shiftncforecastum_version": "10.1",
            "GloSea5d1x1shiftncforecastConventions": "CF-1.6",
            "GloSea5d1x1shiftncforecastphysics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1shiftncforecastcontributor_name": "Met Office",
            "GloSea5d1x1shiftncforecastforecast_type": "forecast",
            "GloSea5d1x1shiftncforecastassociated_experiment": "GloSea5-GC2",
            "GloSea5d1x1shiftncforecastinstitute_id": "UKMO",
            "GloSea5d1x1shiftncforecastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1shiftncforecastinstitution": "Met Office",
            "GloSea5d1x1shiftncforecastmodel_id": "HadGEM3-GC2.0",
            "GloSea5d1x1shiftncdescription": "GloSea5 hindcasts & forecasts for forecast start times starting from Apr 2019",
            "GloSea5d1x1nchindcast_ens28_multiyearcontributor_name": "Met Office",
            "GloSea5d1x1nchindcast_ens28_multiyearinstitution": "Met Office",
            "GloSea5d1x1nchindcast_ens28_multiyearassociated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1nchindcast_ens28_multiyearsource": "model-generated, GloSea5-GC2",
            "GloSea5d1x1nchindcast_ens28_multiyearinstitute_id": "UKMO",
            "GloSea5d1x1nchindcast_ens28_multiyearConventions": "CF-1.6",
            "GloSea5d1x1nchindcast_ens28_multiyearmodeling_realm": "atmos",
            "GloSea5d1x1nchindcast_ens28_multiyeartitle": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1nchindcast_ens28_multiyearforecast_type": "hindcast",
            "GloSea5d1x1nchindcast_ens28_multiyearcontact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1nchindcast_ens28_multiyearassociated_experiment": "GloSea5-GC2",
            "GloSea5d1x1nchindcast_ens28_multiyearinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
            "GloSea5d1x1nchindcast_ens28_multiyearmodel_id": "HadGEM3-GC2.0",
            "GloSea5d1x1nchindcast_ens28_multiyearum_version": "10.1",
            "GloSea5d1x1nchindcast_ens28_multiyearphysics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1nchindcast_ens28associated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1nchindcast_ens28source": "model-generated, GloSea5-GC2",
            "GloSea5d1x1nchindcast_ens28initialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
            "GloSea5d1x1nchindcast_ens28modeling_realm": "atmos",
            "GloSea5d1x1nchindcast_ens28title": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1nchindcast_ens28um_version": "10.1",
            "GloSea5d1x1nchindcast_ens28Conventions": "CF-1.6",
            "GloSea5d1x1nchindcast_ens28physics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1nchindcast_ens28contributor_name": "Met Office",
            "GloSea5d1x1nchindcast_ens28forecast_type": "hindcast",
            "GloSea5d1x1nchindcast_ens28associated_experiment": "GloSea5-GC2",
            "GloSea5d1x1nchindcast_ens28institute_id": "UKMO",
            "GloSea5d1x1nchindcast_ens28contact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1nchindcast_ens28institution": "Met Office",
            "GloSea5d1x1nchindcast_ens28model_id": "HadGEM3-GC2.0",
            "GloSea5d1x1nchindcastassociated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1nchindcastsource": "model-generated, GloSea5-GC2",
            "GloSea5d1x1nchindcastinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
            "GloSea5d1x1nchindcastmodeling_realm": "atmos",
            "GloSea5d1x1nchindcasttitle": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1nchindcastum_version": "10.1",
            "GloSea5d1x1nchindcastConventions": "CF-1.6",
            "GloSea5d1x1nchindcastphysics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1nchindcastcontributor_name": "Met Office",
            "GloSea5d1x1nchindcastforecast_type": "hindcast",
            "GloSea5d1x1nchindcastassociated_experiment": "GloSea5-GC2",
            "GloSea5d1x1nchindcastinstitute_id": "UKMO",
            "GloSea5d1x1nchindcastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1nchindcastinstitution": "Met Office",
            "GloSea5d1x1nchindcastmodel_id": "HadGEM3-GC2.0",
            "GloSea5d1x1ncforecastcontributor_name": "Met Office",
            "GloSea5d1x1ncforecastinstitution": "Met Office",
            "GloSea5d1x1ncforecastassociated_model": "HadGEM3-GC2.0",
            "GloSea5d1x1ncforecastsource": "model-generated, GloSea5-GC2",
            "GloSea5d1x1ncforecastinstitute_id": "UKMO",
            "GloSea5d1x1ncforecastConventions": "CF-1.6",
            "GloSea5d1x1ncforecastmodeling_realm": "atmos",
            "GloSea5d1x1ncforecasttitle": "Operational seasonal forecast data from UK Met Office.",
            "GloSea5d1x1ncforecastforecast_type": "forecast",
            "GloSea5d1x1ncforecastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
            "GloSea5d1x1ncforecastassociated_experiment": "GloSea5-GC2",
            "GloSea5d1x1ncforecastinitialization_description": "Atmos:Met Office NWP 4DVar; Ocean & Sea-ice: Met Office FOAM NEMOVAR",
            "GloSea5d1x1ncforecastmodel_id": "HadGEM3-GC2.0",
            "GloSea5d1x1ncforecastum_version": "10.1",
            "GloSea5d1x1ncforecastphysics_description": "See Williams et al, 2015 for GC2 description",
            "GloSea5d1x1ncdescription": "GloSea5 hindcasts & forecasts for forecast start times from Dec 2016 to Mar 2019",
            "Conventions": "IRIDL"
        },
        "GloSea5": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GloSea5",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "d2p5": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "d2p5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "hindcast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "132",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Meridional Velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "132",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "131",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Zonal Velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "131",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "130",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "130",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "t1p5m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t1p5m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "167",
                        "gribfield": "1",
                        "gribleveltype": "105",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "1.5m Air Temperature",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "scale_max": "307.56787",
                        "scale_min": "218.74658",
                        "gribparam": "167",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "34",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Sea Surface Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "34",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "kg/m2/s",
                        "gribvariable": "228",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "precipitation",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "228",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "mslp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mslp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Pa",
                        "gribvariable": "151",
                        "gribfield": "1",
                        "gribleveltype": "102",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Mean Sea Level Pressure",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "151",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gribvariable": "129",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Geopotential Height",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "129",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    }
                },
                "forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "132",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Meridional velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "132",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "131",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Zonal velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "131",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "130",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "130",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "t1p5m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t1p5m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "167",
                        "gribfield": "1",
                        "gribleveltype": "105",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "1.5m Air Temperature",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "scale_max": "307.56787",
                        "scale_min": "218.74658",
                        "gribparam": "167",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "34",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Sea Surface Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "34",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "kg/m2/s",
                        "gribvariable": "228",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "precipitation",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "228",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "mslp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mslp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Pa",
                        "gribvariable": "151",
                        "gribfield": "1",
                        "gribleveltype": "102",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Mean Sea Level Pressure",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "151",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gribvariable": "129",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Geopotential Height",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "129",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    }
                }
            },
            "d1x1shiftnc": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "d1x1shiftnc",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "hindcast_ens28_multiyear": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast_ens28_multiyear",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360",
                        "defaultvalue": "733.0",
                        "bounds": "S"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "Sp5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sp5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "Sp1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sp1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "733.0",
                        "pointwidth": "0.0"
                    }
                },
                "hindcast_ens28": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast_ens28",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    }
                },
                "forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "um_stash_source": "m01s15i202",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "units": "m/s",
                        "standard_name": "northward_wind",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "missing_value": "1.00000002E20",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "um_stash_source": "m01s15i201",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "units": "m/s",
                        "standard_name": "eastward_wind",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "missing_value": "1.00000002E20",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "expires": "1615420800",
                        "calendar": "360",
                        "bounds": "S"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615420800",
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    }
                }
            },
            "d1x1nc": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "d1x1nc",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "hindcast_ens28_multiyear": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast_ens28_multiyear",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "y_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "x_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "x_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360",
                        "defaultvalue": "710.0",
                        "bounds": "S"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "Sp5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sp5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "Sp1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sp1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "defaultvalue": "710.0",
                        "pointwidth": "0.0"
                    }
                },
                "hindcast_ens28": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast_ens28",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "y_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    }
                },
                "hindcast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "standard_name": "y_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity",
                        "standard_name": "y_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "standard_name": "x_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity",
                        "standard_name": "x_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    }
                },
                "forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "y_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "y_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "northward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "y_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "um_stash_source": "m01s15i202",
                        "long_name": "Meridional Velocity on Pressure Levels",
                        "units": "m/s",
                        "standard_name": "northward_wind",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "missing_value": "1.00000002E20",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "x_wind_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                        "um_stash_source": "m01s15i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "x_wind_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                        "standard_name": "eastward_wind",
                        "units": "m/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i201",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "x_wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "um_stash_source": "m01s15i201",
                        "long_name": "Zonal Velocity on Pressure Levels",
                        "units": "m/s",
                        "standard_name": "eastward_wind",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "missing_value": "1.00000002E20",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "Time",
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360",
                        "bounds": "S"
                    },
                    "surface_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Surface Temperature",
                        "standard_name": "surface_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i024",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "sea_ice_area_fraction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice_area_fraction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.07374182E09",
                        "long_name": "Sea Ice Area Fraction",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "unitless",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s00i031",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "precipitation_flux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation_flux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Precipitation Flux",
                        "standard_name": "precipitation_flux",
                        "units": "kg/m2/s",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s05i216",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "geopotential_height": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geopotential_height",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Geopotential Height",
                        "standard_name": "geopotential_height",
                        "units": "m",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i202",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0_old": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0_old",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels, Through Feb 2017",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_temperature_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Air Temperature on Pressure Levels",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s30i204",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Near-Surface Air Temperature",
                        "standard_name": "air_temperature",
                        "units": "Kelvin_scale",
                        "coordinates": "forecast_period forecast_reference_time height realization",
                        "um_stash_source": "m01s03i236",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    },
                    "air_pressure_at_sea_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_pressure_at_sea_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "long_name": "Mean Sea Level Pressure",
                        "standard_name": "air_pressure_at_mean_sea_level",
                        "units": "Pa",
                        "coordinates": "forecast_period forecast_reference_time realization",
                        "um_stash_source": "m01s16i222",
                        "cell_methods": "time: mean (interval: 1 hour)",
                        "grid_mapping": "latitude_longitude",
                        "pointwidth": "0.0"
                    }
                }
            },
            "d1x1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "d1x1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "hindcast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hindcast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "132",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Meridional Velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "132",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "131",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Zonal Velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "131",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "130",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "130",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "t1p5m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t1p5m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "167",
                        "gribfield": "1",
                        "gribleveltype": "105",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "1.5m Air Temperature",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "scale_max": "307.56787",
                        "scale_min": "218.74658",
                        "gribparam": "167",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "34",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Sea Surface Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "34",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "kg/m2/s",
                        "gribvariable": "228",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "precipitation",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "228",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "mslp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mslp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Pa",
                        "gribvariable": "151",
                        "gribfield": "1",
                        "gribleveltype": "102",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Mean Sea Level Pressure",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "151",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gribvariable": "129",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Geopotential Height",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "129",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "fnname": "flagrange",
                        "pointwidth": "0.0"
                    }
                },
                "forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "132",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Meridional velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "132",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m/s",
                        "gribvariable": "131",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Zonal velocity",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "131",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "tmp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "130",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "130",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "t1p5m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t1p5m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "167",
                        "gribfield": "1",
                        "gribleveltype": "105",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "1.5m Air Temperature",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "scale_max": "307.56787",
                        "scale_min": "218.74658",
                        "gribparam": "167",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1.0",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "gribvariable": "34",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Sea Surface Temperature",
                        "process": "1",
                        "missing_value": "0.0",
                        "gribparam": "34",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "kg/m2/s",
                        "gribvariable": "228",
                        "gribfield": "1",
                        "gribleveltype": "1",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "precipitation",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "228",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "mslp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mslp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Pa",
                        "gribvariable": "151",
                        "gribfield": "1",
                        "gribleveltype": "102",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Mean Sea Level Pressure",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "151",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gribvariable": "129",
                        "gribfield": "1",
                        "gribleveltype": "100",
                        "gribNumBits": "12",
                        "PTVersion": "1",
                        "long_name": "Geopotential Height",
                        "process": "1",
                        "missing_value": "9.99900026E20",
                        "gribparam": "129",
                        "center": "U.K. Met Office - Exeter",
                        "gribcenter": "74",
                        "PDS_TimeRange": "3",
                        "calendar": "standard",
                        "pointwidth": "0.0"
                    }
                }
            }
        },
        "GloSea4": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GloSea4",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "hindcast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hindcast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "gribvariable": "132",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Meridional Velocity",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "132",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "gribvariable": "131",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Zonal Velocity",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "131",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "tmp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "130",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Temperature",
                    "process": "1",
                    "missing_value": "0.0",
                    "gribparam": "130",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "t1p5m": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "t1p5m",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "167",
                    "gribfield": "1",
                    "gribleveltype": "105",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "1.5m Air Temperature",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "scale_max": "307.56787",
                    "scale_min": "218.74658",
                    "gribparam": "167",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pointwidth": "1.0",
                    "units": "months since 1960-01-01",
                    "calendar": "360"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "34",
                    "gribfield": "1",
                    "gribleveltype": "1",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Sea Surface Temperature",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "34",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "kg/m2/s",
                    "gribvariable": "228",
                    "gribfield": "1",
                    "gribleveltype": "1",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "precipitation",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "228",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "mslp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mslp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Pa",
                    "gribvariable": "151",
                    "gribfield": "1",
                    "gribleveltype": "102",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Mean Sea Level Pressure",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "151",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gribvariable": "129",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Geopotential Height",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "129",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "fnname": "flagge",
                    "pointwidth": "0.0"
                },
                "dirname": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dirname",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                }
            },
            "forecast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "forecast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "gribvariable": "132",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Meridional velocity",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "132",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "gribvariable": "131",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Zonal velocity",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "131",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "tmp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "130",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Temperature",
                    "process": "1",
                    "missing_value": "0.0",
                    "gribparam": "130",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "t1p5m": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "t1p5m",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "167",
                    "gribfield": "1",
                    "gribleveltype": "105",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "1.5m Air Temperature",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "scale_max": "307.56787",
                    "scale_min": "218.74658",
                    "gribparam": "167",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pointwidth": "1.0",
                    "units": "months since 1960-01-01",
                    "calendar": "360"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Kelvin_scale",
                    "gribvariable": "34",
                    "gribfield": "1",
                    "gribleveltype": "1",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Sea Surface Temperature",
                    "process": "1",
                    "missing_value": "0.0",
                    "gribparam": "34",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "kg/m2/s",
                    "gribvariable": "228",
                    "gribfield": "1",
                    "gribleveltype": "1",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "precipitation",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "228",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "mslp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mslp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Pa",
                    "gribvariable": "151",
                    "gribfield": "1",
                    "gribleveltype": "102",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Mean Sea Level Pressure",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "151",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                },
                "gz": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gz",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gribvariable": "129",
                    "gribfield": "1",
                    "gribleveltype": "100",
                    "gribNumBits": "12",
                    "PTVersion": "1",
                    "long_name": "Geopotential Height",
                    "process": "1",
                    "missing_value": "9.99900026E20",
                    "gribparam": "129",
                    "center": "U.K. Met Office - Exeter",
                    "gribcenter": "74",
                    "PDS_TimeRange": "3",
                    "calendar": "standard",
                    "pointwidth": "0.0"
                }
            }
        },
        "S_13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.0"
        },
        "hdate_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "hdate_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "12.0"
        },
        "S_12": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_12",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "S_11": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_11",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "expires": "1615420800",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time"
        },
        "S_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "pointwidth": "0",
            "modulus": "12",
            "standard_name": "forecast_reference_time",
            "modulo": "12",
            "calendar": "360",
            "long_name": "Forecast Start Time"
        },
        "hdate": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "hdate",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "12.0"
        },
        "S_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "defaultvalue": "710.0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time"
        },
        "pressure_0_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_0_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "300.0",
            "standard_name": "air_pressure"
        },
        "M_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "realization",
            "long_name": "Ensemble Member"
        },
        "pressure_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "standard_name": "air_pressure"
        },
        "S_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "pressure_2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "standard_name": "air_pressure"
        },
        "S_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "pressure_1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "standard_name": "air_pressure"
        },
        "pressure_0": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_0",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "300.0",
            "standard_name": "air_pressure"
        },
        "S_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "pressure_3": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure_3",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "standard_name": "air_pressure"
        },
        "S_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "pressure": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "pressure",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "standard_name": "air_pressure"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "S_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0.0",
            "standard_name": "forecast_reference_time",
            "long_name": "Forecast Start Time",
            "calendar": "360"
        },
        "M_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "S_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "L_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "M_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "S_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.0"
        },
        "P_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "M_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "S_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.0"
        },
        "P_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "P_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "hPa",
            "gridtype": "0",
            "pointwidth": "350.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "standard_name": "latitude"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.5",
            "standard_name": "longitude"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.0"
        },
        "dir": "SOURCES/UKMO"
    },
    "UKZN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UKZN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SchulzeQCDB2006dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UKZN/.Schulze.QCDB2006.dataset_documentation.html",
            "Conventions": "IRIDL"
        },
        "Schulze": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Schulze",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "QCDB2006": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "QCDB2006",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "VPD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "VPD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "TMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale"
                },
                "TMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale"
                },
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "SUR2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SUR2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "SUR1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SUR1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "STO2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STO2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "STO1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STO1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "SRAD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SRAD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "RHMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RHMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "percent"
                },
                "RHMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RHMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "percent"
                },
                "RFL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RFL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "Qstats": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Qstats",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "tertiary": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tertiary",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "secondary": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "secondary",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "mar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "hydroz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hydroz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "curve": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "curve",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "cmap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cmap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "catnum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "catnum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "catid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "catid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "catch1_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "catch1_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "catch1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "catch1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "__primary": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "__primary",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "PM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P-M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "IYIMID": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "IYIMID",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "DEF2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DEF2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "DEF1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "DEF1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                }
            }
        },
        "quartern": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "quartern",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "2",
            "units": "ids"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "dir": "SOURCES/UKZN"
    },
    "UMD": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UMD",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "GLCFGLCDSreferences": "Hansen_etal1998",
            "GLCFGLCDSdescription": "Gridded 1-km global land cover data set from the University of Maryland",
            "GLCFGLCDSdataset_documentationhtml": "http://glcf.umd.edu/data/landcover/index.shtml",
            "GLCFGIMMSNDVIgreferences": "Pinzon_etal2005 Tucker_etal2005",
            "GLCFGIMMSlong_name": "Global Inventory Modeling and Mapping Studies",
            "GLCFlong_name": "Global Land Cover Facility",
            "Cartongoabeta7binaryfilename": "/Data/data6/carton/goa/beta7/asm16_%y4.dat",
            "Cartongoabeta7missing_value": "-9.98999971E33",
            "Cartongoabeta7Note": "Contains 20 Aug 2001 correction to 1979-1997, 22 Apr 2002 correction to 1995-2001",
            "Cartongoabeta7references": "Carton_etal2000a Carton_etal2000b",
            "Cartongoabeta7description": "beta7 run with 16 level data assimilation (altimetry 14 level), 50-2000",
            "Cartongoabeta7SODA": "http://iridl.ldeo.columbia.edu/SOURCES/.CARTON-GIESE/.SODA/.v1p4p2/",
            "Cartongoabeta7history": "beta7 run with 16 level data assimilation (altimetry 14 level), 50-2000",
            "Cartongoabeta6binaryfilename": "/Data/data6/carton/goa/beta6_g1deg_%y2.dat",
            "Cartongoabeta6missing_value": "-9.98999971E33",
            "Cartongoabeta6references": "Carton_etal2000a Carton_etal2000b",
            "Cartongoabeta6description": "beta6 assimilation at 1*1 global t&s grid, 50-11/98",
            "Cartongoabeta6SODA": "http://iridl.ldeo.columbia.edu/SOURCES/.CARTON-GIESE/.SODA/.v1p4p2/",
            "Cartongoabeta6history": "beta6 assimilation at 1*1 global t&s grid, 50-11/98",
            "Cartongoalong_name": "Global Ocean Analysis",
            "Cartongoaalso_known_as": "SODA",
            "Cartongoadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UMD/.Carton.goa.dataset_documentation.html",
            "CartonSODA": "/SOURCES/.CARTON-GIESE/.SODA/",
            "description": "University of Maryland",
            "iridlhasSemantics": "UMD",
            "Conventions": "IRIDL"
        },
        "GLCF": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GLCF",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "GLCDS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GLCDS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "lc": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lc",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "16776960",
                    "scale_max": "13.0",
                    "maxncolor": "17",
                    "ncolor": "17",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "13",
                    "units": "ids",
                    "long_name": "land cover",
                    "CLIST": "Urban and Built-up",
                    "iridlhasSemantics": "iridl:LandCover"
                }
            },
            "GIMMS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GIMMS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NDVIg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NDVIg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_global": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "global",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "NOAA satellite"
                        },
                        "ndvi": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ndvi",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2263842",
                            "scale_max": "1000",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-100",
                            "CS": "-0.1",
                            "CE": "1.0",
                            "iridlhasSemantics": "iridl:NDVI",
                            "plotlast": "1.0",
                            "plotfirst": "-0.1",
                            "long_name": "NDVI",
                            "units": "unitless",
                            "missing_value": "-10000",
                            "scale_factor": "0.001"
                        },
                        "flag": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flag",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "6",
                            "long_name": "flag",
                            "units": "ids",
                            "scale_min": "0",
                            "CLIST": "missing data"
                        }
                    }
                }
            }
        },
        "Carton": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Carton",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "goa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "goa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "beta7": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "beta7",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "z20": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "z20",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "20 degree depth",
                        "units": "m",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional velocity",
                        "units": "cm/s",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal velocity",
                        "units": "cm/s",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface meridional wind stress",
                        "units": "dyne/cm2",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface zonal wind stress",
                        "units": "dyne/cm2",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "t": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "temperature",
                        "units": "Celsius_scale",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "sfh": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sfh",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface height ",
                        "units": "m",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "s": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "s",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "salinity",
                        "units": "PSU",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "hc500": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc500",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hc500",
                        "units": "m degree_C",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "hc125": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc125",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hc125",
                        "units": "m degree_C",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    }
                },
                "beta6": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "beta6",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "z20": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "z20",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "20 degree depth",
                        "units": "m",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional velocity",
                        "units": "cm/s",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal velocity",
                        "units": "cm/s",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface meridional wind stress",
                        "units": "dyne/cm2",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface zonal wind stress",
                        "units": "dyne/cm2",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "t": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "temperature",
                        "units": "Celsius_scale",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "sfh": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sfh",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface height ",
                        "units": "m",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "s": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "s",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "salinity",
                        "units": "PSU",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "hc500": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc500",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hc500",
                        "units": "m degree_C",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    },
                    "hc125": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hc125",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hc125",
                        "units": "m degree_C",
                        "missing_value": "-9.98999971E33",
                        "bounds": "T",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "standard_name": "time"
                    }
                }
            }
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.008333334",
            "standard_name": "latitude"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.008333334",
            "standard_name": "longitude"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1981-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0",
            "standard_name": "time"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.07272727",
            "standard_name": "latitude"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.07272727",
            "standard_name": "longitude"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.07276207",
            "standard_name": "latitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1981-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.07274197",
            "standard_name": "longitude"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.0"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/UMD"
    },
    "UN": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/UN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "UN",
        "restriction": "Public",
        "FAO": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/UN/FAO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "FAO",
            "restriction": "Public",
            "FAOSTAT": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/UN/FAO/FAOSTAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "FAOSTAT",
                "restriction": "Public",
                "Mali": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/UN/FAO/FAOSTAT/Mali",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Mali",
                    "restriction": "Public",
                    "Feb2012": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/UN/FAO/FAOSTAT/Mali/Feb2012",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Feb2012",
                        "restriction": "Public",
                        "Production": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/FAO/FAOSTAT/Mali/Feb2012/Production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "Production",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "Production"
                        ]
                    },
                    "Jul2010": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Jul2010",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Yieldhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Yieldsource": ">FAOSTAT</a>",
                            "Stockshistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Stockssource": ">FAOSTAT</a>",
                            "Seedhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Seedsource": ">FAOSTAT</a>",
                            "Price_USDhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Price_USDsource": ">FAOSTAT</a>",
                            "Price_SLChistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Price_SLCsource": ">FAOSTAT</a>",
                            "Price_LCUhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Price_LCUsource": ">FAOSTAT</a>",
                            "Populationhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Populationsource": ">FAOSTAT</a>",
                            "Forest_Prod_Weihistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Prod_Weisource": ">FAOSTAT</a>",
                            "Forest_Prod_Volhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Prod_Volsource": ">FAOSTAT</a>",
                            "Forest_Imp_Weihistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Imp_Weisource": ">FAOSTAT</a>",
                            "Forest_Imp_Volhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Imp_Volsource": ">FAOSTAT</a>",
                            "Forest_Imp_Valhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Imp_Valsource": ">FAOSTAT</a>",
                            "Forest_Exp_Weihistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Exp_Weisource": ">FAOSTAT</a>",
                            "Forest_Exp_Volhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Exp_Volsource": ">FAOSTAT</a>",
                            "Forest_Exp_Valhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Forest_Exp_Valsource": ">FAOSTAT</a>",
                            "Areashistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Areassource": ">FAOSTAT</a>",
                            "Area_Harvestedhistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Area_Harvestedsource": ">FAOSTAT</a>",
                            "Animalshistory": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2010",
                            "Animalssource": ">FAOSTAT</a>",
                            "Conventions": "IRIDL"
                        },
                        "Yield": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Yield",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Yield": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yield",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "kg/hectare",
                                "long_name": "yield",
                                "scale_min": "0.0",
                                "scale_factor": "0.1"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Stocks": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Stocks",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Scale_Factor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Scale_Factor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "scale factor"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Head": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Head",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "count",
                                "long_name": "stocks",
                                "scale_min": "0.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Seed": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Seed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Seed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Seed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "tonne",
                                "long_name": "seed",
                                "scale_min": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Price_USD": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Price_USD",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "USD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "USD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "$/tonne",
                                "long_name": "price USD",
                                "scale_min": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Price_SLC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Price_SLC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "SLC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SLC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "SLC/tonne",
                                "long_name": "price standard local currency",
                                "scale_min": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Price_LCU": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Price_LCU",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "LCU": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "LCU",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "LCU/tonne",
                                "long_name": "price local currency",
                                "scale_min": "0.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Population": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Population",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Population": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Population",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "count",
                                "long_name": "population estimation and projection",
                                "scale_factor": "1000.0",
                                "missing_value": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Prod_Wei": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Prod_Wei",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Prod_Wei": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Prod_Wei",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "tonne",
                                "long_name": "forest production weight",
                                "scale_min": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Prod_Vol": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Prod_Vol",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Prod_Vol": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Prod_Vol",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3",
                                "long_name": "forest production volume",
                                "scale_min": "0.0"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Imp_Wei": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Imp_Wei",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Imp_Wei": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Imp_Wei",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "tonne",
                                "long_name": "forest importation weight",
                                "scale_min": "0.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Imp_Vol": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Imp_Vol",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Imp_Vol": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Imp_Vol",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3",
                                "long_name": "forest importation volume",
                                "scale_min": "0.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Imp_Val": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Imp_Val",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Imp_Val": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Imp_Val",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "$",
                                "long_name": "forest importation value",
                                "scale_min": "0.0",
                                "scale_factor": "1000.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "Forest_Exp_Wei": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Exp_Wei",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            },
                            "Exp_Wei": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Exp_Wei",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "tonne",
                                "long_name": "forest exportation weight",
                                "scale_min": "0.0"
                            }
                        },
                        "Forest_Exp_Vol": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Exp_Vol",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            },
                            "Exp_Vol": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Exp_Vol",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3",
                                "long_name": "forest exportation volume",
                                "scale_min": "0.0"
                            }
                        },
                        "Forest_Exp_Val": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forest_Exp_Val",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            },
                            "Exp_Val": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Exp_Val",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "$",
                                "long_name": "forest exportation value",
                                "scale_min": "0.0",
                                "scale_factor": "1000.0"
                            }
                        },
                        "Areas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Areas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            },
                            "Areas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Areas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "hectare",
                                "long_name": "areas",
                                "scale_min": "0.0",
                                "scale_factor": "1000.0"
                            }
                        },
                        "Area_Harvested": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Area_Harvested",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            },
                            "Area": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Area",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "hectare",
                                "long_name": "area harvested",
                                "scale_min": "0.0"
                            }
                        },
                        "Animals": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Animals",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Scale_Factor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Scale_Factor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "scale factor"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "long_name": "item name"
                            },
                            "Head": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Head",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "count",
                                "long_name": "animals",
                                "scale_min": "0.0"
                            },
                            "Flag": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Flag",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "16777215",
                                "scale_max": "8.0",
                                "maxncolor": "12",
                                "ncolor": "12",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "8",
                                "units": "ids",
                                "long_name": "data quality",
                                "CLIST": "Official data reported on FAO Questionnaires from countries"
                            }
                        },
                        "code_14": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_14",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_13": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_13",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_12": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_12",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "T_05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "code_11": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_11",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "T_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "code_10": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_10",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "0"
                        },
                        "code_09": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_09",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_08": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_08",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_07": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_07",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_06": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_06",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "T_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "code_05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "T_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "code_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "T_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "code_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "12",
                            "standard_name": "time"
                        },
                        "dir": "SOURCES/UN/FAO/FAOSTAT/Mali/Jul2010"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Feb2012",
                        "Jul2010"
                    ]
                },
                "Senegal": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/UN/FAO/FAOSTAT/Senegal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Senegal",
                    "restriction": "Public",
                    "Feb2012": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/UN/FAO/FAOSTAT/Senegal/Feb2012",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Feb2012",
                        "restriction": "Public",
                        "Production": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/FAO/FAOSTAT/Senegal/Feb2012/Production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "Production",
                            "restriction": "Public",
                            "Production_Indices": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Production_Indices",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "FAOSTAT | \\xc2\\xa9 FAO Statistics Division 2012 | 09 February 2012 Updated: 21 July 2011",
                                    "source": ">FAOSTAT</a>",
                                    "Conventions": "IRIDL"
                                },
                                "NPIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NPIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Net Production Index Number (2004-2006 = 100)",
                                    "units": "unitless"
                                },
                                "NpcPIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NpcPIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Net per capita Production Index Number (2004-2006 = 100)",
                                    "units": "unitless"
                                },
                                "Name": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Name",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "item name"
                                },
                                "GPIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GPIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Gross Production Index Number (2004-2006 = 100)",
                                    "units": "unitless"
                                },
                                "GpcPIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GpcPIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Gross per capita Production Index Number (2004-2006 = 100)",
                                    "units": "unitless"
                                },
                                "code": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "code",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "calendar": "360",
                                    "pointwidth": "12",
                                    "standard_name": "time"
                                },
                                "dir": "SOURCES/UN/FAO/FAOSTAT/Senegal/Feb2012/Production/Production_Indices"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "Production_Indices"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "Production"
                        ]
                    },
                    "Oct2018": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Oct2018",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "_yield": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "yield",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Yield",
                            "units": "hectogram/hectare",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Production",
                            "units": "tonne",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "items": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "items",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Items names"
                        },
                        "flag_y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flag_y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "0",
                            "scale_max": "6.0",
                            "maxncolor": "254",
                            "ncolor": "9",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "6",
                            "long_name": "Yield Flag",
                            "units": "ids",
                            "CLIST": "Unofficial figure",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "flag_p": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flag_p",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "0",
                            "scale_max": "6.0",
                            "maxncolor": "254",
                            "ncolor": "9",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "6",
                            "long_name": "Production Flag",
                            "units": "ids",
                            "CLIST": "Unofficial figure",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "flag_ah": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flag_ah",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "0",
                            "scale_max": "6.0",
                            "maxncolor": "254",
                            "ncolor": "9",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "6",
                            "long_name": "Area harvested Flag",
                            "units": "ids",
                            "CLIST": "Unofficial figure",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "area_harvested": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "area_harvested",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Area harvested",
                            "units": "hectare",
                            "history": "Averaged over myline[0.5, 6117.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9"
                        },
                        "item_codes_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "item_codes_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "years since 0000-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "1.0"
                        },
                        "item_codes": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "item_codes",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/UN/FAO/FAOSTAT/Senegal/Oct2018"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Feb2012",
                        "Oct2018"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Mali",
                    "Senegal"
                ]
            },
            "GeoNetwork": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GeoNetwork",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "agrometeorologicalETdeg0p5edition1c6190history": "prepared according to the FAO Penman-Monteith method from University of East Anglia Climate Research Unit CRU CL 1.0 climate dataset, 1961-1990",
                    "agrometeorologicalETdeg0p5edition1c6190dataset_documentation": "http://www.fao.org/geonetwork/srv/en/metadata.show?id=5017&currTab=simple",
                    "agrometeorologicalETdeg0p5edition1c6190FAO_GeoNetwork": "http://www.fao.org/geonetwork/srv/en/main.home",
                    "agrometeorologicalETdeg0p5edition1c6190source": ">FAO</a>",
                    "Conventions": "IRIDL"
                },
                "agrometeorological": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "agrometeorological",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ET": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ET",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "deg0p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "edition1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "edition1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "c6190": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "c6190",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "etref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "etref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference evapotranspiration",
                                        "scale_factor": "0.1",
                                        "units": "mm/day",
                                        "missing_value": "-9999",
                                        "pointwidth": "1.0",
                                        "modulo": "12.0",
                                        "modulus": "12.0"
                                    }
                                }
                            }
                        }
                    }
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/UN/FAO/GeoNetwork"
            },
            "NRMED": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NRMED",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SDClimateDerivedlong_name": "Derived Climate Products",
                    "SDClimatedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UN/.FAO/.NRMED/.SD.Climate.dataset_documentation.html",
                    "SDdescription": "Sustainable Development",
                    "NRMED_Home": "http://www.fao.org/nr/index_en.htm",
                    "description": "Natural Resources Management and Environment Department",
                    "Conventions": "IRIDL"
                },
                "SD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Climate": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Climate",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Derived": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Derived",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "_class": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "class",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "long_name": "Koeppen Climate Classification",
                                "CLIST": "Dry BWk\\'",
                                "missing_value": "-999.0",
                                "scale_max": "48.0",
                                "scale_min": "1.0",
                                "iridlhasSemantics": "iridl:Classification"
                            }
                        }
                    }
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/UN/FAO/NRMED"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "FAOSTAT",
                "GeoNetwork",
                "NRMED"
            ]
        },
        "WFP": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/UN/WFP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "WFP",
            "restriction": "Public",
            "Philippines": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/UN/WFP/Philippines",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "Philippines",
                "restriction": "Public",
                "Demographics": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Demographics",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pop_settlemdescription": "Population Settlements",
                        "description": "Demographics in the Philippines",
                        "Conventions": "IRIDL"
                    },
                    "pop_settlem": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pop_settlem",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Region": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Region",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Region",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "population": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "population",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Population",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "Name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Settlement Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "110.0",
                            "scale_max": "132.0",
                            "long_name": "Longitude",
                            "units": "degree_east",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Location",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "POINT",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "4.0",
                            "scale_max": "22.0",
                            "long_name": "Latitude",
                            "units": "degree_north",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "iso3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "iso3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name ISO3",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "iso2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "iso2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name ISO2",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "geonameid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "geonameid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geo Name ID",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "fcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "fcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "F code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "country": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "country",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "continent": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "continent",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Continent",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "alternaten": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "alternaten",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Alternate Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "admin4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "admin4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Administration Level 4 ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "admin3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "admin3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Administation Level 3 ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "admin2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "admin2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Province ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "admin1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "admin1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Region ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "objectid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "objectid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/UN/WFP/Philippines/Demographics"
                },
                "ICA": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/UN/WFP/Philippines/ICA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "ICA",
                    "restriction": "Public",
                    "Barangay": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Barangay",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "description": "Barangay Results",
                            "Conventions": "IRIDL"
                        },
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "ranking": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ranking",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Ranking",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "psgc_baran": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psgc_baran",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Barangay PSGC",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "prov_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Province Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Province ID",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "population": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "population",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "long_name": "Population",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "objectid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "objectid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Object ID",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "name_3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Municipality Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Provicne Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Region Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mun_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mun_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Municipality ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mun": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mun",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Municipality ID",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "main_lc_te": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "main_lc_te",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "main Land Cover term",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "main_lc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "main_lc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "main Land Cover",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "landslide1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "landslide1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Landslide Risk",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "landslide": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "landslide",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "ncolor": "6",
                            "colormap": "65280",
                            "scale_min": "0.0",
                            "scale_max": "2.0",
                            "long_name": "Landslide Risk Level",
                            "CLIST": "None",
                            "CS": "0",
                            "CE": "2",
                            "fnname": "maskle",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "int2"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "iso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "iso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name ISO",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "households": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "households",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Households",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "househol_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "househol_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Household",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "flood_risk": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flood_risk",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "ncolor": "6",
                            "colormap": "65280",
                            "scale_min": "0.0",
                            "scale_max": "2.0",
                            "long_name": "Flood Risk Level",
                            "CLIST": "None",
                            "CS": "0",
                            "CE": "2",
                            "fnname": "maskle",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "int2"
                        },
                        "flood_ri_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "flood_ri_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Flood Risk",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "brgy_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "brgy_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Barangay Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm4code_d": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm4code_d",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Barangay Code",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "adm4_pco_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm4_pco_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Barangay Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "gid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "dir": "SOURCES/UN/WFP/Philippines/ICA/Barangay"
                    },
                    "Forestation": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/UN/WFP/Philippines/ICA/Forestation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Forestation",
                        "restriction": "Public",
                        "Mangrove": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Forestation/Mangrove",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "Mangrove",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "SlopeDefor": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Forestation/SlopeDefor",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "SlopeDefor",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "TreeChange": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Forestation/TreeChange",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "TreeChange",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "TreeCoverage": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Forestation/TreeCoverage",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "TreeCoverage",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "Mangrove",
                            "SlopeDefor",
                            "TreeChange",
                            "TreeCoverage"
                        ]
                    },
                    "Municipality": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Municipality",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "description": "Municipalities Results",
                            "Conventions": "IRIDL"
                        },
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "Region": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Region",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Region ID",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "provincial": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "provincial",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Focus Area",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "poverty_es": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "poverty_es",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "128",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "100",
                            "long_name": "Families below poverty line",
                            "units": "percent",
                            "fnname": "maskle",
                            "missing_value": "NaN",
                            "PGtype": "int4"
                        },
                        "new_p_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "new_p_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "New P Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Provicne Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Region Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "name_0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name_0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "MEC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MEC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "ncolor": "8",
                            "colormap": "2263842",
                            "long_name": "Mangrove Extent Change Class",
                            "scale_max": "5",
                            "units": "ids",
                            "scale_min": "1",
                            "CS": "1",
                            "CE": "5",
                            "missing_value": "0",
                            "CLIST": "Strong increase",
                            "history": "dominant_class over mangrove_2[Strong decrease, Strong increase]",
                            "valid_min": "1",
                            "valid_max": "5",
                            "colorscalename": "halfgreyscale",
                            "PGtype": "float8"
                        },
                        "mcode_shor": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mcode_shor",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Short Municipilaty Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mcode_sh_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mcode_sh_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Short Municipality Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mcode_long": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mcode_long",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Long Municipality Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mcode_lo_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mcode_lo_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Long Municipality Code",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "mangrove_k": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mangrove_k",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mangrove k",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "mangrove_2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mangrove_2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "16.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-16.0",
                            "CS": "-16",
                            "CE": "16",
                            "colormap": "2263842",
                            "long_name": "Mangrove Extent Change",
                            "units": "km2",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "mangrove_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mangrove_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mangrove 1",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "main_lc_te": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "main_lc_te",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "main Land Cover term",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "main_lc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "main_lc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "main Land Cover",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "magrove_ch": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "magrove_ch",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mangrove Change",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "iso": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "iso",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name ISO",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "hasc_2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hasc_2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "engtype_2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "engtype_2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "ave_percen": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ave_percen",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "50.0",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "50",
                            "units": "percent",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "gid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "dir": "SOURCES/UN/WFP/Philippines/ICA/Municipality"
                    },
                    "TS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Watersheddescription": "Tropical Storms, 20km buffers, wind speed >= 63",
                            "Provincedescription": "Tropical Storms, 20km buffers, wind speed >= 63",
                            "Barangaydescription": "Tropical Storms, 20km buffers, wind speed >= 63",
                            "description": "History of Tropical Storms 2002-12",
                            "Conventions": "IRIDL"
                        },
                        "Watershed": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Watershed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wfp_waters": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wfp_waters",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "WFP Waters",
                                "units": "unitless",
                                "PGtype": "int2"
                            },
                            "wfp_wate_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wfp_wate_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "WFP Waters",
                                "units": "unitless",
                                "PGtype": "int2"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "shape_leng": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shape_leng",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "shap_area": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shap_area",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Area",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "objectid_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "objectid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "frequency": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "frequency",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Frequency of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "first_leve": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "first_leve",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "First Level",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "1710726",
                                "scale_max": "10",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0",
                                "CE": "10",
                                "long_name": "Number of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "ave_treeco": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ave_treeco",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "average tree cover",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            }
                        },
                        "Province": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Province",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "validto_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "validto_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Valid to",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "validfr_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "validfr_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Valid from",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "type_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "type_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Type",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "shape_leng": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shape_leng",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "shape_le_2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shape_le_2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "shape_le_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shape_le_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "shap_area": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "shap_area",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Area",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "Region": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Region",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "pcode_shor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pcode_shor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "pcode_long": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pcode_long",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "pcode_lo_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pcode_lo_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "objectid_2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid_2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "objectid_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "objectid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "name_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "name_0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Country Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "iso": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iso",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Country Name ISO",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "hasc_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hasc_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hasc",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "frequency": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "frequency",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Frequency of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "engtype_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "engtype_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "eng Type",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "128",
                                "scale_max": "9",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0",
                                "CE": "9",
                                "long_name": "Number of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            }
                        },
                        "Municipality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Municipality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "objectid_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "objectid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "name_2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provicne Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "name_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "mcode_shor": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mcode_shor",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Short Municipilaty Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "mcode_long": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mcode_long",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Long Municipality Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "mcode_lo_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mcode_lo_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Long Municipality Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "main_lc_te": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "main_lc_te",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "main Land Cover term",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "main_lc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "main_lc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "main Land Cover",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "leng": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leng",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "iso": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iso",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Country Name ISO",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "frequency": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "frequency",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Frequency of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "freq2063All": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "freq2063All",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "128",
                                "scale_max": "6",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0",
                                "CE": "6",
                                "long_name": "N. of TS, buff: 20km, ws>=63, All Months",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "count2063All": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count2063All",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "128",
                                "scale_max": "6",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0",
                                "CE": "6",
                                "long_name": "N. of TS, buff: 20km, ws>=63, All Months",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0",
                                "scale_max": "6",
                                "colormap": "128",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "CS": "0",
                                "CE": "6",
                                "long_name": "Number of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "area": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "area",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Area",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            }
                        },
                        "Barangay": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Barangay",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "type_3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "type_3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Type 3",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "population": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "population",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "long_name": "Population",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "objectid_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "objectid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "objectid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Object ID",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "name_3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Municipality Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "name_2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provicne Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "name_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "name_0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "name_0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Country Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "leng": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leng",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "le_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "le_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "iso": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "iso",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Country Name ISO",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "frequency": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "frequency",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Frequency of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "count": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "count",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "128",
                                "scale_max": "6",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0",
                                "CS": "0",
                                "CE": "6",
                                "long_name": "Number of Tropical Storms",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "area": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "area",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Area",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "adm4code_d": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm4code_d",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Barangay Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "adm4code_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm4code_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Barangay Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "adm4_pco_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm4_pco_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Barangay Code",
                                "units": "ids",
                                "PGtype": "varchar"
                            }
                        },
                        "gid_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gid_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gridtype": "2",
                            "units": "ids"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "1",
                            "calendar": "360",
                            "pointwidth": "3",
                            "standard_name": "time",
                            "modulo": "12.0",
                            "modulus": "12.0"
                        },
                        "gid_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gid_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "gid": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gid",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0"
                        },
                        "dir": "SOURCES/UN/WFP/Philippines/ICA/TS"
                    },
                    "Topography": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/UN/WFP/Philippines/ICA/Topography",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Topography",
                        "restriction": "Public",
                        "dem": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Topography/dem",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "dem",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "slope": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/Philippines/ICA/Topography/slope",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "slope",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "dem",
                            "slope"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Barangay",
                        "Forestation",
                        "Municipality",
                        "TS",
                        "Topography"
                    ]
                },
                "LandCover": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "LandCover",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "Land Cover of the Philippines",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "symbol": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "symbol",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Symbol",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "shape_leng": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_leng",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Length",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "shape_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "rrp250lv_i": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rrp250lv_i",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "rrp250lv": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rrp250lv",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Perimeter",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "descript": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "descript",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Description",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "objectid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "objectid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/UN/WFP/Philippines/LandCover"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Demographics",
                    "ICA",
                    "LandCover"
                ]
            },
            "VAM": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/UN/WFP/VAM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "VAM",
                "restriction": "Public",
                "CFSVA": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/UN/WFP/VAM/CFSVA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CFSVA",
                    "restriction": "Public",
                    "Niger": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Niger",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "FSA2011Section12description": "Calculs",
                            "FSA2011Section11description": "Migration",
                            "FSA2011Section10description": "Strat\\xc3\\xa9gies",
                            "FSA2011Section09description": "Chocs",
                            "FSA2011Section08description": "Alimentation",
                            "FSA2011Section07description": "Aide",
                            "FSA2011Section05description": "Stocks",
                            "FSA2011Section04description": "Agriculture",
                            "FSA2011Section03description": "\\xc3\\x89levage",
                            "FSA2011Section02description": "M\\xc3\\xa9nages",
                            "FSA2011Section01description": "Revenus",
                            "FSA2011Section00description": "Questionnaire",
                            "FSA2011description": "Food Security Analysis Jan. 2011",
                            "FSA2010Section13description": "Calculs",
                            "FSA2010Section12description": "Calculs",
                            "FSA2010Section11description": "Migration",
                            "FSA2010Section10description": "Strat\\xc3\\xa9gies",
                            "FSA2010Section09description": "Chocs",
                            "FSA2010Section08description": "Alimentation",
                            "FSA2010Section07description": "Aide",
                            "FSA2010Section05description": "Stocks",
                            "FSA2010Section04description": "Agriculture",
                            "FSA2010Section03description": "\\xc3\\x89levage",
                            "FSA2010Section02description": "M\\xc3\\xa9nages",
                            "FSA2010Section01description": "Revenus",
                            "FSA2010Section00description": "Questionnaire",
                            "FSA2010description": "Food Security Analysis Avr. 2010",
                            "FSA2009Section12description": "Calculs",
                            "FSA2009Section11description": "Migration",
                            "FSA2009Section10description": "Strat\\xc3\\xa9gies",
                            "FSA2009Section09description": "Chocs",
                            "FSA2009Section08description": "Alimentation",
                            "FSA2009Section07description": "Aide",
                            "FSA2009Section06description": "D\\xc3\\xa9penses",
                            "FSA2009Section05description": "Stocks",
                            "FSA2009Section04description": "Agriculture",
                            "FSA2009Section03description": "\\xc3\\x89levage",
                            "FSA2009Section02description": "M\\xc3\\xa9nages",
                            "FSA2009Section01description": "Revenus",
                            "FSA2009Section00description": "Questionnaire",
                            "FSA2009description": "Food Security Analysis Dec. 2009",
                            "FSA2008Section12description": "Calculs",
                            "FSA2008Section11description": "Migration",
                            "FSA2008Section10description": "Strat\\xc3\\xa9gies",
                            "FSA2008Section09description": "Chocs",
                            "FSA2008Section07description": "Aide",
                            "FSA2008Section05description": "Stocks",
                            "FSA2008Section04description": "Agriculture",
                            "FSA2008Section03description": "\\xc3\\x89levage",
                            "FSA2008Section02description": "M\\xc3\\xa9nages",
                            "FSA2008Section01description": "Revenus",
                            "FSA2008Section00description": "Questionnaire",
                            "FSA2008description": "Food Security Analysis Nov. 2008",
                            "brm2013Section12description": "Calculs",
                            "brm2013Section11description": "Migration",
                            "brm2013Section10description": "Strat\\xc3\\xa9gies",
                            "brm2013Section09description": "Chocs",
                            "brm2013Section08description": "Alimentation",
                            "brm2013Section07description": "Aide",
                            "brm2013Section05description": "Stocks",
                            "brm2013Section04description": "Agriculture",
                            "brm2013Section03description": "\\xc3\\x89levage",
                            "brm2013Section02description": "M\\xc3\\xa9nages",
                            "brm2013Section01description": "Revenus",
                            "brm2013Section00description": "Questionnaire",
                            "brm2013description": "Base rurale m\\xc3\\xa9nage Nov. 2013",
                            "bmv2014Section12description": "Calculs",
                            "bmv2014Section11description": "Migration",
                            "bmv2014Section10description": "Strat\\xc3\\xa9gies",
                            "bmv2014Section09description": "Chocs",
                            "bmv2014Section08description": "Alimentation",
                            "bmv2014Section07description": "Aide",
                            "bmv2014Section06description": "D\\xc3\\xa9penses",
                            "bmv2014Section05description": "Stocks",
                            "bmv2014Section04description": "Agriculture",
                            "bmv2014Section03description": "\\xc3\\x89levage",
                            "bmv2014Section02description": "M\\xc3\\xa9nages",
                            "bmv2014Section01description": "Revenus",
                            "bmv2014Section00description": "Questionnaire",
                            "bmv2014description": "Base m\\xc3\\xa9nage vuln\\xc3\\xa9rabilit\\xc3\\xa9 2014",
                            "Conventions": "IRIDL"
                        },
                        "FSA2011": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FSA2011",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "TUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SUCRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SUCRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "SUCRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenutet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenutet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu mensuel moyen par tete",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu moyen mensuel du menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "RCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PROTANI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PROTANI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PROTEINE ANIMALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES Y COMPRIS AUTOCONSOMMATION",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pctroc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pctroc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production totale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production pluviale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcdons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcdons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent Dons/Zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcchas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcchas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent chasse et cueillette",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcaut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcaut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcaid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcaid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent aide",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcachat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcachat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcachah7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcachah7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achats effectues en dehors des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcacha7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcacha7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat effectue au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NUBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NUBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRevenut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRevenut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of Revenutet",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of RCSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NFAC1_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NFAC1_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of FAC1_1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NDurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of DurSto",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NDEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of DEPTET",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of CSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "nbalcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbalcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltroc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltroc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total d\\'aliments consomes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalpprod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalpprod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalppan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalppan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naldon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naldon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des dons/zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalchas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalchas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de chasse et cueillette",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalaut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalaut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalaid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalaid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de aide/assistance",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalachh7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalachh7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des achats au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalach7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalach7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des achats au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LEGMSES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LEGMSES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LEGUMINEUSES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LAITPDLAIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAITPDLAIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LAIT ET PRODUITS LAITIERS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "HUILE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HUILE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FRUIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRUIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FRUITS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FEUILEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FEUILEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FEUILLES ET LEGUMES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Food consumption score",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FAC1_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FAC1_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "REGR factor score   1 for analysis 1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "dursto2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dursto2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "dursto2",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Dur\\xc3\\xa9e des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTMC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTMC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par tete par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPNAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPNAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES NON ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CFCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Consommation alimentaire acceptable",
                                    "long_name": "Classes food consumption score",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "CERTUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CERTUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES ET TUBERCULE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CEREALES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CEREALES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q96D6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les gar\\xc3\\xa7ons de moins de 15 ans : La raison principal",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les filles de moins de 15 ans : La raison principale",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les jeunes femmes (15 ans et plus) : La raison princ",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les jeunes hommes (15 ans et plus) : La raison princ",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : La raison principale",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Le chef de m\\xc3\\xa9nage : La raison",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les gar\\xc3\\xa7ons de moins de 15 ans : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les filles de moins de 15 ans : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les jeunes femmes (15 ans et plus) : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les jeunes hommes (15 ans et plus) : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Le chef de m\\xc3\\xa9nage : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les gar\\xc3\\xa7on de moins de 15 ans  : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les filles de moins de 15 ans  : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les jeunes femmes (15 ans et plus) : combien sont-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les jeunes hommes (15 ans et plus) : combien sont-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les gar\\xc3\\xa7ons de moins de 15 ans : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les filles de moins de 15 ans : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les jeunes femmes ( 15 ans et plus) : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les jeunes hommes ( 15 ans et plus) : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Le chef de m\\xc3\\xa9nage : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q95. : Y a-t-il dans votre m\\xc3\\xa9nage un membre ou des membre qu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q946": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q946",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.6 : Est-ce que votre m\\xc3\\xa9nage a retir\\xc3\\xa9 les enfants de l\\'\\xc3\\xa9c",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q945": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q945",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.5 : Est-ce que votre m\\xc3\\xa9nage a vendu des terres pour des",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q944": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q944",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.4 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens productifs",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q943": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q943",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.3 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens non produc",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q942": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q942",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.2 : Est-ce que votre m\\xc3\\xa9nage a vendu des animaux reproduc",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q941": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q941",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.1 : Est-ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\'a",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q939": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q939",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.9 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb demander \\xc3\\xa0 d\\'autres m\\xc3\\xa9n",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q938": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q938",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.8 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des semences pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q937": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q937",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.7 : Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 la",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q936": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q936",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.6 : Est-ce que votre m\\xc3\\xa9nage a du renoncer au paiement de",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q935": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q935",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.5 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\'aide alim",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q934": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q934",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.4 : Est-ce que votre m\\xc3\\xa9nage a achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9dit",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q933": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q933",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.3 : Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q932": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q932",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.2 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moin",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9316": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9316",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.16 : Est-ce que vous-m\\xc3\\xaame ou un membre de votre m\\xc3\\xa9nage e",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9315": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9315",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.15 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une journ",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9314": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9314",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.14 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de repa",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9313": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9313",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.13 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9312": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9312",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.12 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration jou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9311": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9311",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.11 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journal",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9310": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9310",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.10 : Est-ce que au moins un membre de votre m\\xc3\\xa9nage a eu",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q931": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q931",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.1 : Y a-t-il eu des moments o\\xc3\\xb9 vous n\\'avez pas assez de",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enf",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q92A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enf",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans l",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans l",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q909": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q909",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 9 = Coupure d\\'\\xc3\\xa9lec",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q908": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q908",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 8 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q907": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q907",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 7 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q906": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q906",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 6 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q905": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q905",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 5 = augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q904": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q904",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 4 = D\\xc3\\xa9c\\xc3\\xa8s d\\'un mem",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q903": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q903",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 3 = Maladie/d\\xc3\\xa9pens",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q902": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q902",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 2 = Baisse de reve",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9015": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9015",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 15 = Autres \\xc3\\xa0 pr\\xc3\\xa9c",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9014": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9014",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 14 = Irr\\xc3\\xa9gularit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9013": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9013",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 13 = Catastrophes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9012": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9012",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 12 = Ch\\xc3\\xb4mage de lo",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9011": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9011",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 11 = Remboursement",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9010": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9010",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 10 = Ins\\xc3\\xa9curit\\xc3\\xa9/ v",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q901": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q901",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 1 = Perte d\\'emploi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9005": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9005",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'enfants de moins de 5 ans",
                                    "long_name": "Q90.5 : Comment jugez-vous l\\'impact sur la situation nutriti",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9004": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9004",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'impact",
                                    "long_name": "Q90.4 : Comment jugez-vous l\\'impact sur la situation aliment",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9003": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9003",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.3 : Principales difficult\\xc3\\xa9s ou chocs..: 3\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9002": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9002",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.2 : Principales difficult\\xc3\\xa9s ou chocs..: 2\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9001": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9001",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.1 : Principales difficult\\xc3\\xa9s ou chocs..: 1\\xc3\\xa8re difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q89": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q89",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q89 : Est ce qu\\'il y a des aliments que vous ne consommez pl",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q88": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q88",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q88 : Les aliments que vous consommez actuellement......",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q87": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q87",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "S\\'est am\\xc3\\xa9lior\\xc3\\xa9e",
                                    "long_name": "Q87 : Comment trouvez-vous votre consommation alimentaire ac",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 24 Huile, grai",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 23 Sucre, miel",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 22 Lait, froma",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 21 Oeufs : Que",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 20 Volaille :",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 19 Poisson (co)",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 18 Poisson : Q",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 17 Viande (com)",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Viande, aba",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Fruits : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Autres feui",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Autres l\\xc3\\xa9gu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Ni\\xc3\\xa9b\\xc3\\xa9/ arac",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Ni\\xc3\\xa9b\\xc3\\xa9/haric",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres tube",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Igname : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Manioc : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 Autres c\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 Riz : Quell",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 Ma\\xc3\\xafs : Quel",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Sorgho : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 Mil : Quell",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 24 Huile, grai",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 23 Sucre, miel",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 22 Lait, froma",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 21 Oeufs : Pen",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 20 Volaille :",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 19 Poisson (co)",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 18 Poisson : P",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 17 Viande (com)",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Viande, aba",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Fruits : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Autres feui",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Autres l\\xc3\\xa9gu",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Ni\\xc3\\xa9b\\xc3\\xa9/ arac",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Ni\\xc3\\xa9b\\xc3\\xa9/haric",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres tube",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Igname : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Manioc : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 Autres c\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 Riz : Penda",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 Ma\\xc3\\xafs : Pend",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Sorgho : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 Mil : Penda",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q859": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q859",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.9 Ration compl\\xc3\\xa9mentaire pour les femmes enceintes et all",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q858": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q858",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.8 Blanket feeding",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q857": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q857",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.7 Don/Zakat",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q856": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q856",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.6 Ration de d\\xc3\\xa9charge/ protection",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q855": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q855",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.5 Argent contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q854": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q854",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.4 Vivre contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q853": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q853",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.3 Vente de c\\xc3\\xa9r\\xc3\\xa9ales \\xc3\\xa0 prix mod\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q852": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q852",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.2 Distribution gratuite",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8512": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8512",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.12 Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8511": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8511",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.11 Cash transfert",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8510": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8510",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.10 Intrants agricoles (engrais, semences...)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q851": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q851",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.1 Banque c\\xc3\\xa9r\\xc3\\xa9ali\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Section06d": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06d",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q8417": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8417",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.7 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Transport",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8416": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8416",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.6 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Education",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8415": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8415",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.5 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Sant\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8414": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8414",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.4 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Intrants agrico",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8413": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8413",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.3 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Logement",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8412": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8412",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.2 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Energie (cuisso)",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8411": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8411",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.1 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Alimentation",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q84": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q84",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Ont augment\\xc3\\xa9",
                                        "long_name": "Q84 : Vos d\\xc3\\xa9penses ont-elles chang\\xc3\\xa9 compar\\xc3\\xa9es \\xc3\\xa0 celles de la",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06c": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06c",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q83B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q83 : Autres : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q83A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q83 : Autres : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q82B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q82A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : aviez-vous effectu\\xc3\\xa9 la",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q81B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q81A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : aviez-vous effect",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q80B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q80 : Frais de transport : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q80A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q80 : Frais de transport : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q79B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : Montant en F CF",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q79A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : aviez-vous effe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q78B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q78A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : aviez-vous effectu",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q77B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q77 : Habillement/chaussures : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q77A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q77 : Habillement/chaussures : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pens",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q76B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q76 : Equipement domestique : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q76A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q76 : Equipement domestique : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q75B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : Montant en F C",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q75A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : aviez-vous eff",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q74B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q74 : Achat d\\'animaux : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q74A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q74 : Achat d\\'animaux : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q73B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : Montant en F CF",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q73A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : aviez-vous effe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q72B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q72A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense.",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q71B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q71A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q70B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q70A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q69B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q69A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : aviez-vous effectu\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q68B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q68 : Carburant/lubrifiants : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q68A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q68 : Carburant/lubrifiants : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q67B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : Montant en",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q67A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : aviez-vous",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q66B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q66A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : aviez-vous effectu\\xc3\\xa9 la",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q65B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q65 : Bois de chauffe : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q65A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q65 : Bois de chauffe : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06b": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06b",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q64A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q64 : Autres condiments : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q63A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des pro",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des pro",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q63 : Pomme de terre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q62A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des pr",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des pr",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q62 : Feuilles vertes : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q61A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q61 : Igname : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q60A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q60 : Manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q59A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q59 : Sel : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q58A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q58 : Oignon : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q57A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits \\xc3\\xa9ch",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits aut",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q57 : Sucre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q56A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q56 : Voandzou : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q55A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA de",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA de",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quel est le montant de la d\\xc3\\xa9pens",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q55 : Petit pois/lentille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q54A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quel est le montant de la d\\xc3\\xa9pe",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q53A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q53 : Arachide : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q52A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q52 : Beurre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q51A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q51 : Oeuf : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q50A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q50 : Lait : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q49A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits \\xc3\\xa9",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits a",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q49 : Fromage : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q48A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits \\xc3\\xa9",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits a",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q48 : Poisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q47A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q47 : Volaille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q46A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produ",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produ",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q46 : Viande/Abats : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q45A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q45 : Huile de cuisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q44A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q43A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q43 : Pain : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q42A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produit",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produit",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q41A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q41 : Farine de manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q40A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q39A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q39 : Sorgho : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q38A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q38 : Mil : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q37A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q37 : Riz : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q36": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q36",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q36 : Si oui le remboursement a-t-il d\\xc3\\xa9j\\xc3\\xa0 \\xc3\\xa9t\\xc3\\xa9 fait ou engag\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.b En esp\\xc3\\xa8ce (y compris la valeur des animaux)",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    }
                                },
                                "Section06a": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06a",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q35A7C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Nombre d\\'UML pour un s",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A7B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A7A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9, Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A6A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9 , Nombre d\\'UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A5A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, quantit\\xc3\\xa9 en UM",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz , Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A4A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Nombre d\\'UML pour un sa",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A3A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Nombre d\\'UML pour un",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A2A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A1A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q34": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q34",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q34 : Depuis les r\\xc3\\xa9coltes de l\\'ann\\xc3\\xa9e pass\\xc3\\xa9e 2009, aviez-vous",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q33B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33.b : Combien de mois pensez-vous que votre stock ou appro",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.a : Si oui pensez-vous que votre stock ou vos moyens son",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33 : Disposez-vous encore aujourd\\'hui de stocks.....",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q32A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2009/20",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2009/20",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mauvaise",
                                    "long_name": "Q31 : Comment jugez-vous la campagne agricole 2010/2011",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q30 : Comment ont \\xc3\\xa9volu\\xc3\\xa9 les superficies cultiv\\xc3\\xa9es.....",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.b : La superficie total des champs/jardins en hectares",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.a : Si oui, combien de champs/jardins exploit\\xc3\\xa9s",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q29 : Exploitation des champs/jardins campagne agricole pass",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q28A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Canards/Oies",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pintades",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Poulets",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Equins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Asins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Camelins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Caprins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Ovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Autres",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pigeons",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Bovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Le m\\xc3\\xa9nage poss\\xc3\\xa8de t-il des aminaux",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q27C9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27B9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires:  Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale des murs du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale du toit du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Le statut d\\'occupation du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9nergie pour la cuisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Le principal type de toilette qu\\'utilise le m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale source d\\'eau de boisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale activit\\xc3\\xa9 du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "C\\xc3\\xa9libataire",
                                    "long_name": "Statut matrimonial du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age du chef de m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q16C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant m",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribut",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage :montant mo",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage: contributi",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Combien de sources de revenu mon\\xc3\\xa9taire le m\\xc3\\xa9nage dispose t-i",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ubt_tete": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ubt_tete",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT par tete",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "taille": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taille",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "taille du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total des membres actifs dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de 6 \\xc3\\xa0 24 mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de moins de 5 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q15A",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Zone pastorale et d\\xc3\\xa9sertique",
                                    "long_name": "Zone agro \\xc3\\xa9cologique",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la ZD",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la grappe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Centre urbain/Canton/Zone restante",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Pondind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pondind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration individu final",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9",
                                    "long_name": "Classe d\\'ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire retenue",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "IDMEN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "IDMEN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDMEN",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ID": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "hhweight": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hhweight",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration finale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "depart": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depart",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement administratif",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "classe": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "classe",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9 alimentaire",
                                    "long_name": "Classe d\\'ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire(deux groupes)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "FSA2010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FSA2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section13": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section13",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "X",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Vuln10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Vuln10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Vulnerabilite mai 2010 comparaison dec 09",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q939_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q939_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q939 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q938_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q938_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q938 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q937_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q937_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q937 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q936_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q936_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q936 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q935_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q935_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q935 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q934_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q934_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q934 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q933_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q933_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q933 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q932_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q932_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q932 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q931_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q931_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q931 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9316_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9316_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9316 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9315_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9315_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9315 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9314_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9314_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9314 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9313_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9313_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9313 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9312_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9312_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9312 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9311_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9311_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9311 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9310_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9310_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9310 recod\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Pca_FoodInsec5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pca_FoodInsec5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes food insecurity PCA5",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pca_FoodInsec4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pca_FoodInsec4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes food insecurity PCA4",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pca_FoodInsec3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pca_FoodInsec3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes food insecurity PCA3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NFAC1_4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NFAC1_4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of FAC1_4",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NFAC1_3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NFAC1_3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of FAC1_3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Livelihood": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Livelihood",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "Livelihood groups to be refined",
                                    "units": "ids",
                                    "scale_max": "12.0",
                                    "missing_value": "-999.0"
                                },
                                "FoodInsec1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FoodInsec1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Securite alimentaire",
                                    "long_name": "Insecurite alimentaire definitive",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "FAC1_4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FAC1_4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "REGR factor score   1 for analysis 4",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FAC1_3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FAC1_3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "REGR factor score   1 for analysis 3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DureeStock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DureeStock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Duree des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont39": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont39",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont39",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont38": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont38",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont38",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont37": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont37",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont37",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont36": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont36",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont36",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont35": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont35",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont35",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont34": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont34",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont34",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont33",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont32",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont314": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont314",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont314",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont313": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont313",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont313",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont312": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont312",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont312",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont311": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont311",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont311",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont310": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont310",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont310",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont31",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont29",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont28",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont27": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont27",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont27",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont26",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont25": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont25",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont25",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont24",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont23",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont22",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont214": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont214",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont214",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont213": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont213",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont213",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont212": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont212",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont212",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont211": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont211",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont211",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont210": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont210",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont210",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont21",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont19",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont18",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont17",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont16",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont15",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont14",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont13",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont12",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont114": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont114",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont114",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont113": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont113",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont113",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont112": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont112",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont112",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont111": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont111",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont111",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cont110",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Cont11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Cont11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "cltaile": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltaile",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "16 et plus",
                                    "long_name": "Classes taille du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "_class": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "class",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes livelihood",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "TUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SUCRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SUCRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "SUCRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenutet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenutet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu mensuel moyen par tete",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu moyen mensuel du menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "RCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PROTANI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PROTANI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PROTEINE ANIMALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES Y COMPRIS AUTOCONSOMMATION",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pctroc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pctroc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production totale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production pluviale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcdons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcdons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent Dons/Zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcchas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcchas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent chasse et cueillette",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcaut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcaut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcaid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcaid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent aide",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcachat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcachat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcachah7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcachah7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achats effectues en dehors des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcacha7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcacha7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat effectue au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NUBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NUBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRevenut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRevenut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of Revenutet",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of RCSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NFAC1_2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NFAC1_2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of FAC1_2",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NFAC1_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NFAC1_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Nantis",
                                    "long_name": "Pauvrete selon asset index",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "NDEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of DEPTET",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of CSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "nbalcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbalcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltroc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltroc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total d\\'aliments consomes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalpprod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalpprod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalppan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalppan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naldon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naldon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des dons/zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalchas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalchas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de chasse et cueillette",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalaut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalaut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalaid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalaid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de aide/assistance",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalachh7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalachh7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des achats au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalach7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalach7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des achats au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "milieu2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "milieu2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Urbain",
                                    "long_name": "Milieu en 2 classes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "LEGMSES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LEGMSES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LEGUMINEUSES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LAITPDLAIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAITPDLAIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LAIT ET PRODUITS LAITIERS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "HUILE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HUILE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FRUIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRUIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FRUITS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "filter_": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filter_$",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Selected",
                                    "long_name": "Q33 = 1 (FILTER)",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "FEUILEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FEUILEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FEUILLES ET LEGUMES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Food consumption score",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FAC1_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FAC1_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "REGR factor score   1 for analysis 1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTMC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTMC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par tete par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPNAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPNAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES NON ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CFCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes food consumption score",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CERTUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CERTUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES ET TUBERCULE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CEREALES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CEREALES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q97": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q97",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non app^licable",
                                    "long_name": "Q97 : D\\'habitude en ce moment (avril-mai-juin), les personne",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les gar\\xc3\\xa7ons de moins de 15 ans : La raison principal",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les filles de moins de 15 ans : La raison principale",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les jeunes femmes (15 ans et plus) : La raison princ",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Les jeunes hommes (15 ans et plus) : La raison princ",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : La raison principale",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96D1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96D1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q96.d : Le chef de m\\xc3\\xa9nage : La raison",
                                    "units": "ids",
                                    "scale_max": "6.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les gar\\xc3\\xa7ons de moins de 15 ans : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les filles de moins de 15 ans : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les jeunes femmes (15 ans et plus) : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Les jeunes hommes (15 ans et plus) : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q96.c : Le chef de m\\xc3\\xa9nage : La destination",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les gar\\xc3\\xa7on de moins de 15 ans  : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les filles de moins de 15 ans  : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les jeunes femmes (15 ans et plus) : combien sont-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : Les jeunes hommes (15 ans et plus) : combien sont-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q96.b : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : combien sont-ils",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q96A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les gar\\xc3\\xa7ons de moins de 15 ans : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les filles de moins de 15 ans : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les jeunes femmes ( 15 ans et plus) : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Les jeunes hommes ( 15 ans et plus) : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : L\\'\\xc3\\xa9pouse du chef de m\\xc3\\xa9nage : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q96A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q96A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q96.a : Le chef de m\\xc3\\xa9nage : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q95. : Y a-t-il dans votre m\\xc3\\xa9nage un membre ou des membre qu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q946": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q946",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.6 : Est-ce que votre m\\xc3\\xa9nage a retir\\xc3\\xa9 les enfants de l\\'\\xc3\\xa9c",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q945": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q945",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.5 : Est-ce que votre m\\xc3\\xa9nage a vendu des terres pour des",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q944": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q944",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.4 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens productifs",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q943": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q943",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.3 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens non produc",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q942": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q942",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.2 : Est-ce que votre m\\xc3\\xa9nage a vendu des animaux reproduc",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q941": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q941",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.1 : Est-ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\'a",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q939": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q939",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.9 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb demander \\xc3\\xa0 d\\'autres m\\xc3\\xa9n",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q938": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q938",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.8 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des semences pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q937": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q937",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.7 : Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 la",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q936": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q936",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.6 : Est-ce que votre m\\xc3\\xa9nage a du renoncer au paiement de",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q935": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q935",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.5 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\'aide alim",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q934": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q934",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.4 : Est-ce que votre m\\xc3\\xa9nage a achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9dit",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q933": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q933",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.3 : Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q932": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q932",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.2 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moin",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9316": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9316",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.16 : Est-ce que vous-m\\xc3\\xaame ou un membre de votre m\\xc3\\xa9nage e",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9315": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9315",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.15 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une journ",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9314": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9314",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.14 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de repa",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9313": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9313",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.13 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9312": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9312",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.12 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration jou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9311": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9311",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.11 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journal",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9310": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9310",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.10 : Est-ce que au moins un membre de votre m\\xc3\\xa9nage a eu",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q931": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q931",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.1 : Y a-t-il eu des moments o\\xc3\\xb9 vous n\\'avez pas assez de",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enf",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q92A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enf",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans l",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans l",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q909": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q909",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 9 = Coupure d\\'\\xc3\\xa9lec",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q908": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q908",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 8 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q907": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q907",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 7 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q906": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q906",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 6 = Augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q905": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q905",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 5 = augmentation d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q904": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q904",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 4 = D\\xc3\\xa9c\\xc3\\xa8s d\\'un mem",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q903": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q903",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 3 = Maladie/d\\xc3\\xa9pens",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q902": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q902",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 2 = Baisse de reve",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9015": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9015",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 15 = Autres \\xc3\\xa0 pr\\xc3\\xa9c",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9014": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9014",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 14 = Irr\\xc3\\xa9gularit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9013": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9013",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 13 = Catastrophes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9012": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9012",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 12 = Ch\\xc3\\xb4mage de lo",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9011": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9011",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 11 = Remboursement",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9010": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9010",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 10 = Ins\\xc3\\xa9curit\\xc3\\xa9/ v",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q901": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q901",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 1 = Perte d\\'emploi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9005": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9005",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'enfants de moins de 5 ans",
                                    "long_name": "Q90.5 : Comment jugez-vous l\\'impact sur la situation nutriti",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9004": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9004",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'impact",
                                    "long_name": "Q90.4 : Comment jugez-vous l\\'impact sur la situation aliment",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9003": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9003",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.3 : Principales difficult\\xc3\\xa9s ou chocs..: 3\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9002": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9002",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.2 : Principales difficult\\xc3\\xa9s ou chocs..: 2\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9001": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9001",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.1 : Principales difficult\\xc3\\xa9s ou chocs..: 1\\xc3\\xa8re difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q89": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q89",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q89 : Comment trouvez-vous votre consommation alimentaire ac",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q88": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q88",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q88 : Comment trouvez-vous votre consommation alimentaire ac",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q87": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q87",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "S\\'est am\\xc3\\xa9lior\\xc3\\xa9e",
                                    "long_name": "Q87 : Comment trouvez-vous votre consommation alimentaire ac",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 24 Huile, grai",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 23 Sucre, miel",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 22 Lait, froma",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 21 Oeufs : Que",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 20 Volaille :",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 19 Poisson (co)",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 18 Poisson : Q",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 17 Viande (com)",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Viande, aba",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Fruits : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Autres feui",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Autres l\\xc3\\xa9gu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Ni\\xc3\\xa9b\\xc3\\xa9/ arac",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Ni\\xc3\\xa9b\\xc3\\xa9/haric",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres tube",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Igname : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Manioc : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 Autres c\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 Riz : Quell",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 Ma\\xc3\\xafs : Quel",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Sorgho : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 Mil : Quell",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 24 Huile, grai",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 23 Sucre, miel",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 22 Lait, froma",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 21 Oeufs : Pen",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 20 Volaille :",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 19 Poisson (co)",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 18 Poisson : P",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 17 Viande (com)",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Viande, aba",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Fruits : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Autres feui",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Feuilles ve",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Autres l\\xc3\\xa9gu",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Ni\\xc3\\xa9b\\xc3\\xa9/ arac",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Ni\\xc3\\xa9b\\xc3\\xa9/haric",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres tube",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Igname : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Manioc : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 Autres c\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 Riz : Penda",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 Ma\\xc3\\xafs : Pend",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Sorgho : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86A01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86A01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.a : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 Mil : Penda",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q859": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q859",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.9 Ration compl\\xc3\\xa9mentaire pour les femmes enceintes et all",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q858": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q858",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.8 Blanket feeding",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q857": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q857",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.7 Don/Zakat",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q856": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q856",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.6 Ration de d\\xc3\\xa9charge/ protection",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q855": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q855",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.5 Argent contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q854": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q854",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.4 Vivre contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q853": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q853",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.3 Vente de c\\xc3\\xa9r\\xc3\\xa9ales \\xc3\\xa0 prix mod\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q852": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q852",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.2 Distribution gratuite",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8512": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8512",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.12 Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8511": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8511",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.11 Cash transfert",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8510": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8510",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.10 Intrants agricoles (engrais, semences...)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q851": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q851",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q85.1 Banque c\\xc3\\xa9r\\xc3\\xa9ali\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Section06d": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06d",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q8417": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8417",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.7 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Transport",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8416": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8416",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.6 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Education",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8415": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8415",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.5 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Sant\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8414": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8414",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.4 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Intrants agrico",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8413": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8413",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.3 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Logement",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8412": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8412",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.2 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Energie (cuisso)",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8411": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8411",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.1 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Alimentation",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q84": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q84",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Ont augment\\xc3\\xa9",
                                        "long_name": "Q84 : Vos d\\xc3\\xa9penses ont-elles chang\\xc3\\xa9 compar\\xc3\\xa9es \\xc3\\xa0 celles de la",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06c": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06c",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q83B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q83 : Autres : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q83A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q83 : Autres : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q82B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q82A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : aviez-vous effectu\\xc3\\xa9 la",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q81B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q81A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : aviez-vous effect",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q80B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q80 : Frais de transport : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q80A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q80 : Frais de transport : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q79B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : Montant en F CF",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q79A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : aviez-vous effe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q78B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q78A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : aviez-vous effectu",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q77B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q77 : Habillement/chaussures : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q77A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q77 : Habillement/chaussures : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pens",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q76B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q76 : Equipement domestique : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q76A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q76 : Equipement domestique : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q75B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : Montant en F C",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q75A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : aviez-vous eff",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q74B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q74 : Achat d\\'animaux : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q74A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q74 : Achat d\\'animaux : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q73B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : Montant en F CF",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q73A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : aviez-vous effe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q72B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q72A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense.",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q71B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q71A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pe",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q70B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q70A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q69B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q69A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : aviez-vous effectu\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q68B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q68 : Carburant/lubrifiants : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q68A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q68 : Carburant/lubrifiants : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q67B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : Montant en",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q67A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : aviez-vous",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q66B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q66A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : aviez-vous effectu\\xc3\\xa9 la",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q65B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q65 : Bois de chauffe : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q65A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q65 : Bois de chauffe : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06b": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06b",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q64A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q64 : Autres condiments : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q63A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des pro",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des pro",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q63 : Pomme de terre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q62A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des pr",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des pr",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q62 : Feuilles vertes : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q61A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q61 : Igname : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q60A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q60 : Manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q59A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q59 : Sel : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q58A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q58 : Oignon : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q57A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits \\xc3\\xa9ch",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits aut",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q57 : Sucre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q56A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q56 : Voandzou : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q55A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA de",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA de",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quel est le montant de la d\\xc3\\xa9pens",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q55 : Petit pois/lentille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q54A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quel est le montant de la d\\xc3\\xa9pe",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q53A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q53 : Arachide : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q52A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q52 : Beurre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q51A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q51 : Oeuf : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q50A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q50 : Lait : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q49A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits \\xc3\\xa9",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits a",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q49 : Fromage : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q48A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits \\xc3\\xa9",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits a",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q48 : Poisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q47A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q47 : Volaille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q46A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produ",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produ",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q46 : Viande/Abats : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q45A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q45 : Huile de cuisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q44A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q43A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q43 : Pain : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q42A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produit",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produit",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q41A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des p",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q41 : Farine de manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q40A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits \\xc3\\xa9cha",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits auto",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q39A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits \\xc3\\xa9c",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits au",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q39 : Sorgho : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q38A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q38 : Mil : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q37A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits \\xc3\\xa9chan",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits auto.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q37 : Riz : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q36": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q36",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q36 : Si oui le remboursement a-t-il d\\xc3\\xa9j\\xc3\\xa0 \\xc3\\xa9t\\xc3\\xa9 fait ou engag\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.b En esp\\xc3\\xa8ce (y compris la valeur des animaux)",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    }
                                },
                                "Section06a": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06a",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q35A7C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Nombre d\\'UML pour un s",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A7B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A7A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9, Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A6A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9 , Nombre d\\'UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A5A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, quantit\\xc3\\xa9 en UM",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz , Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A4A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Nombre d\\'UML pour un sa",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A3A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Nombre d\\'UML pour un",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A2A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Nombre d\\'UML pour un sac",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A1A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q34": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q34",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q34 : Depuis les r\\xc3\\xa9coltes de l\\'ann\\xc3\\xa9e pass\\xc3\\xa9e 2009, aviez-vous",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q33B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33.b : Combien de mois pensez-vous que votre stock ou appro",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.a : Si oui pensez-vous que votre stock ou vos moyens son",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33 : Disposez-vous encore aujourd\\'hui de stocks.....",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q32A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2008/20",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2008/20",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mauvaise",
                                    "long_name": "Q31 : Comment jugez-vous la campagne agricole 2009/2010",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q30 : Comment ont \\xc3\\xa9volu\\xc3\\xa9 les superficies cultiv\\xc3\\xa9es.....",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.b : La superficie total des champs/jardins en hectares",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.a : Si oui, combien de champs/jardins exploit\\xc3\\xa9s",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q29 : Exploitation des champs/jardins campagne agricole pass",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q28A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Canards/Oies",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pintades",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Poulets",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Equins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Asins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Camelins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Caprins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Ovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pigeons",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Bovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Le m\\xc3\\xa9nage poss\\xc3\\xa8de t-il des aminaux",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q27C9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27B9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires:  Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale des murs du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale du toit du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Le statut d\\'occupation du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9nergie pour la cuisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Le principal type de toilette qu\\'utilise le m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale source d\\'eau de boisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale activit\\xc3\\xa9 du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "C\\xc3\\xa9libataire",
                                    "long_name": "Statut matrimonial du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Occupation principale",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q16C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant m",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribut",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage :montant mo",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage: contributi",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Combien de sources de revenu mon\\xc3\\xa9taire le m\\xc3\\xa9nage dispose t-i",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TEAM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TEAM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "12.0",
                                    "CLIST": " BOUBACAR MOHAMED GAOH",
                                    "long_name": "NUMERO EQUIPE",
                                    "units": "ids",
                                    "scale_max": "45.0",
                                    "missing_value": "-999.0"
                                },
                                "Q18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age du chef de m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total des membres actifs dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de 6 \\xc3\\xa0 24 mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de moins de 5 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total membres dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Le niveau d\\'instruction",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Absent",
                                    "long_name": "Satatut de r\\xc3\\xa9sidence",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age en ann\\xc3\\xa9e r\\xc3\\xa9volue",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Aucun lien de parent\\xc3\\xa9",
                                    "long_name": "Lien de parent\\xc3\\xa9 avec le CM",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro d\\'ordre dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Zone pastorale et d\\xc3\\xa9sertique",
                                    "long_name": "Zone agro \\xc3\\xa9cologique",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la ZD",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la grappe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Centre urbain/Canton/Zone restante",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Pond_men": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pond_men",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pond_ind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pond_ind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration individu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "milieu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "milieu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "P\\xc3\\xa9riph\\xc3\\xa9rie de Ny",
                                    "long_name": "MILIEU DE RESIDENCE",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "ID0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ID": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Foodlnsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Foodlnsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Securite alimentaire",
                                    "long_name": "Classe d\\'insecurite alimentaire definitive",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "departement": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "departement",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement administratif",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "depart": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depart",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement administratif",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            }
                        },
                        "FSA2009": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FSA2009",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "xxx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "xxx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "xxx",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "XX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "XX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "XX",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "UBTTETE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBTTETE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nouvelle UBT par t\\xc3\\xaate",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "stock_paysan2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stock_paysan2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock paysan sans le riz et le bl\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "stock_paysan1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stock_paysan1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock paysan avec toutes les c\\xc3\\xa9r\\xc3\\xa9ales",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "sorg_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sorg_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du sorgho en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "sorg_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sorg_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du sorgho en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "sorg_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sorg_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du sorgho en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizpad_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizpad_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du riz paddyl en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizpad_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizpad_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du riz paddyl en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizpad_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizpad_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du riz paddyl en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizblan_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizblan_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du riz blanchi en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizblan_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizblan_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du riz blanchi en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "rizblan_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rizblan_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du riz blanchi en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q309A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.9A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.9A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q308A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.8A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.8A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q307A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.7A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.7A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q306A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.6A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.6A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q305A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.5A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.5A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q304A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.4A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.4A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q303A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.3A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q302A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.2A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q301A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.1A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3015A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.15A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.15A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3014A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.14A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.14A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3013A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.13A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.13A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3012A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.12A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.12A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3011A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.11A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.11A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3010A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30.10A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "SOUVENT",
                                    "long_name": "Q30.10A",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q309A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.9A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.9A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q308A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.8A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.8A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q307A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.7A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.7A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q306A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.6A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.6A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q305A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.5A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.5A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q304A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.4A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.4A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q303A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.3A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.3A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q302A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.2A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.2A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q301A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.1A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.1A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3015A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.15A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.15A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3014A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.14A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.14A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3013A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.13A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.13A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3012A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.12A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.12A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3011A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.11A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.11A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q3010A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q30.10A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "SOUVENT",
                                        "long_name": "Q30.10A",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "produc_secT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "produc_secT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production mil sorgho mais fonio et riz en tonne",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "produc_sec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "produc_sec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production s\\xc3\\xa8che en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "produc_cereaT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "produc_cereaT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production mil sorgho mais fonio et riz en tonne",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "produc_cerea": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "produc_cerea",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production Mil sorgho mais fonio et riz (en kg)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pond_INDI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pond_INDI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration individu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "nbmois_eq231": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbmois_eq231",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre de mois que le stock peut couvrir (norme 231kg)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "nbmois_eq207": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbmois_eq207",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre de mois que le stock peut couvrir (norme 207kg)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mois_equi231": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mois_equi231",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Besoin mensuel 231kg toutes c\\xc3\\xa9r\\xc3\\xa9ales",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mois_equi207": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mois_equi207",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Besoin mensuel 207kg sans le riz et le bl\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mil_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mil_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du mil en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mil_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mil_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du mil en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mil_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mil_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du mil en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mais_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mais_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du mais en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mais_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mais_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du mais en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "mais_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mais_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du mais en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "hhweight": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hhweight",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "fonio_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fonio_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du fonio en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "fonio_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fonio_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du fonio en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "fonio_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fonio_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du fonio en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "equivalent1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "equivalent1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Stock suffisant",
                                    "long_name": "Equivalent 207 kg",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "equivalent": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "equivalent",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Stock suffisant",
                                    "long_name": "Equivalent 231 kg",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "diff": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "diff",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "diff",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation universelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ble_stock": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ble_stock",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Stock du bl\\xc3\\xa9 en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ble_prod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ble_prod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Production du bl\\xc3\\xa9 en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ble_endet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ble_endet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Endettement du bl\\xc3\\xa9 en kg",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "besoin_men1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "besoin_men1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Besoins du m\\xc3\\xa9nage sans le riz et le ble pour l\\'ann\\xc3\\xa9e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "besoin_men": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "besoin_men",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Besoins r\\xc3\\xa9els du m\\xc3\\xa9nage toutes c\\xc3\\xa9r\\xc3\\xa9ales pour l\\'ann\\xc3\\xa9e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RCSI0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced coping strategy index ponderation universelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q_316A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_316A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_316A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_315A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_315A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_315A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_314A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_314A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_314A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_313A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_313A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_313A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_312A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_312A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_312A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_311A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_311A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_311A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_309A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_309A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_309A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_308A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_308A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_308A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_307A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_307A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_307A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_306A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_306A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_306A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_305A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_305A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_305A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_304A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_304A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_304A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_303A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_303A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_303A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_302A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_302A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_302A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_301A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_301A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3015A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3015A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3015A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3014A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3014A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3014A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3013A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3013A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3013A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3012A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3012A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3012A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3011A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3011A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3011A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q_3010A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q_3010A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q_3010A",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "CS": "0",
                                    "CE": "1",
                                    "fnname": "flaggt",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999"
                                },
                                "Q32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NSP",
                                    "long_name": "Q32.  : Connaissez-vous des m\\xc3\\xa9nages de votre localit\\xc3\\xa9 qui on",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_6A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_6A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a  retir\\xc3\\xa9 les enfants de l\\xe2\\x80\\x99\\xc3\\xa9cole pour des raisons alimentaires\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_5A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_5A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a  vendu des terres pour des raisons d\\xe2\\x80\\x99ins\\xc3\\xa9curit\\xc3\\xa9  alimentaire ?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_4A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_4A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a  vendu des biens productifs (b\\xc5\\x93ufs de trait, charrue, charrette) pour des raisons  d\\xe2\\x80\\x99ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire ?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a vendu des biens non productifs (bijoux, objets de valeur\\xe2\\x80\\xa6) pour des besoins alimentaires ?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a  vendu des animaux reproducteurs pour des besoins alimentaires\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31_1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31_1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\xe2\\x80\\x99actifs plus que d\\xe2\\x80\\x99habitude\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q316B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q316B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.6  : Est-ce que votre m\\xc3\\xa9nage a retir\\xc3\\xa9 les enfants de l\\'\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q316A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q316A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.6  : Est-ce que votre m\\xc3\\xa9nage a retir\\xc3\\xa9 les enfants de l\\'\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q315B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q315B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.5  : Est-ce que votre m\\xc3\\xa9nage a vendu des terres pour des",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q315A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q315A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.5  : Est-ce que votre m\\xc3\\xa9nage a vendu des terres pour des",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q314B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q314B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.4  : Est-ce que votre m\\xc3\\xa9nage a vendu des biens productif",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q314A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q314A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.4  : Est-ce que votre m\\xc3\\xa9nage a vendu des biens productif",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q313B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q313B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.3  : Est-ce que votre m\\xc3\\xa9nage a vendu des biens non produ",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q313A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q313A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.3  : Est-ce que votre m\\xc3\\xa9nage a vendu des biens non produ",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q312B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q312B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.2  : Est-ce que votre m\\xc3\\xa9nage a vendu des animaux reprodu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q312A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q312A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.2  : Est-ce que votre m\\xc3\\xa9nage a vendu des animaux reprodu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q311B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q311B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.1  : Est-ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\'",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q311A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q311A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.1  : Est-ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\'",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q309B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q309B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.9  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb demander \\xc3\\xa0 d\\'autres m\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q309A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q309A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.9  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb demander \\xc3\\xa0 d\\'autres m\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q309_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q309_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb  demander \\xc3\\xa0 d\\xe2\\x80\\x99autres m\\xc3\\xa9nages de la nourriture pour les enfants\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q308B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q308B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.8  : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des semences pou",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q308A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q308A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.8  : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des semences pou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q308_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q308_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des  semences pour des raisons d\\xe2\\x80\\x99ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q307B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q307B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.7  : Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 l",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q307A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q307A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.7  : Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 l",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q307_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q307_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 la consommation d\\xe2\\x80\\x99aliments de p\\xc3\\xa9nurie (Anza, Jigga, Agua, Guera sp.)",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q306B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q306B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.6  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb renoncer au paiement d",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q306A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q306A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.6  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb renoncer au paiement d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q306_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q306_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb renoncer au paiement de dettes contract\\xc3\\xa9es pour acheter des vivres\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q305B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q305B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.5  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\'aide ali",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q305A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q305A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.5  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\'aide ali",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q305_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q305_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\xe2\\x80\\x99aide alimentaire ext\\xc3\\xa9rieure\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q304B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q304B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.4  : Est-ce que votre m\\xc3\\xa9nage a achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9di",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q304A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q304A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.4  : Est-ce que votre m\\xc3\\xa9nage a achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9di",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q304_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q304_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a  achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9dit\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q303B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q303B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.3  : Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q303A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q303A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.3  : Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q303_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q303_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez des parents, des voisins ou des amis\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q302B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q302B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.2  : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moi",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q302A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q302A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.2  : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moi",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q302_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q302_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moins pr\\xc3\\xa9f\\xc3\\xa9r\\xc3\\xa9s ?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q301B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q301B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.1  : Y a-t-il eu des moments o\\xc3\\xb9 vous n\\'aviez pas assez d",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q301A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q301A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.1  : Y a-t-il eu des moments o\\xc3\\xb9 vous n\\'aviez pas assez d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q301_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q301_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Y-a-t-il eu des moments o\\xc3\\xb9 vous n\\'aviez pas assez de vivres ou d\\'argent pour en acheter\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3015B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3015B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.15  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une jour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3015A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3015A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.15  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une jour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3015_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3015_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une journ\\xc3\\xa9e sans manger\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3014B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3014B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.14  : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de rep",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3014A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3014A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.14  : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de rep",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3014_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3014_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de repas pris par jour\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3013B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3013B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.13  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pou",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3013A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3013A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.13  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3013_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3013_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pour des raisons d\\xe2\\x80\\x99\\xc3\\xa9conomie\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3012B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3012B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.12  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration jo",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3012A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3012A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.12  : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration jo",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3012_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3012_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration journali\\xc3\\xa8re pour les adultes au profit des enfants\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3011B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3011B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.11  : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journa",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3011A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3011A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.11  : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journa",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3011_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3011_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journali\\xc3\\xa8re\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3010B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3010B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q30.10  : Est-ce que au moins un membre de votre m\\xc3\\xa9nage a eu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3010A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3010A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q30.10  : Est-ce que au moins un membre de votre m\\xc3\\xa9nage a eu",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q3010_A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3010_A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Est-ce que  au moins un membre de votre m\\xc3\\xa9nage a eu recours \\xc3\\xa0 la mendicit\\xc3\\xa9\\xc2\\xa0?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29 : Combien de repas sont pris par jour dans le m\\xc3\\xa9nage par",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29 : Combien de repas sont pris par jour dans le m\\xc3\\xa9nage par",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28 : Combien de repas collectifs sont pris par jour dans le",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28 : Combien de repas collectifs sont pris par jour dans le",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_forte1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_forte1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CSI_forte1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation adapt\\xc3\\xa9e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation adapt\\xc3\\xa9e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation adapt\\xc3\\xa9e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation adapt\\xc3\\xa9e finale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation universelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q27": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q27 : Si oui, le remboursement a-t-il d\\xc3\\xa9j\\xc3\\xa0 \\xc3\\xa9t\\xc3\\xa9 fait ou engag",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.b : Si oui, En esp\\xc3\\xa8ces (y compris la valeur des aminaux)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A7C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A7C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Fonio : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A7B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A7B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Fonio : Nombre d\\'UML",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A7A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A7A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Fonio : Quantit\\xc3\\xa9 en",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A6C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A6C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Bl\\xc3\\xa9 : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A6B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A6B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Bl\\xc3\\xa9 : Nombre d\\'UML p",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A6A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A6A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Bl\\xc3\\xa9 : Quantit\\xc3\\xa9 en UM",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A5C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A5C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Blanchi : Code U",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A5B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A5B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Blanchi : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A5A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A5A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Blanchi : Quanti",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A4C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A4C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Paddy : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A4B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A4B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Paddy : Nombre d",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A4A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A4A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Riz Paddy : Quantit\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A3C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A3C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Ma\\xc3\\xafs : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A3B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A3B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Ma\\xc3\\xafs : Nombre d\\'UML",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Ma\\xc3\\xafs : Quantit\\xc3\\xa9 en U",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A2C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A2C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Sorgho : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A2B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A2B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Sorgho : Nombre d\\'UM",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Sorgho : Quantit\\xc3\\xa9 en",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A1C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A1C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Mil : Code UML",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A1B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A1B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Mil : Nombre d\\'UML p",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26.a : Si oui, En vivres (en nature) ? Mil : Quantit\\xc3\\xa9 en UM",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q25 : Depuis les r\\xc3\\xa9coltes de l\\'ann\\xc3\\xa9e 2008, aviez-vous eu \\xc3\\xa0 v",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q24C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.c : Si non \\xc3\\xa0 Q24.b Combien de mois pensez-vous que votre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q24.b : Pensez-vous que votre stock actuel est suffusant pou",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A7C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A7C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Fonio : C",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A7B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A7B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Fonio : N",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A7A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A7A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Fonio : S",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A6C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A6C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Bl\\xc3\\xa9 : Cod",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A6B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A6B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Bl\\xc3\\xa9 : Nom",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A6A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A6A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Bl\\xc3\\xa9 : Sto",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A5C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A5C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Blanc",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A5B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A5B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Blanc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A5A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A5A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Blanc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A4C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A4C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Paddy",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A4B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A4B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Paddy",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A4A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A4A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Riz Paddy",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A3C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A3C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Ma\\xc3\\xafs : Co",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A3B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A3B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Ma\\xc3\\xafs : No",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Ma\\xc3\\xafs : St",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A2C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A2C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Sorgho :",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A2B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A2B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Sorgho :",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Sorgho :",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A1C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A1C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Mil : Cod",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A1B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A1B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Mil : Nom",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24A1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24.a : Quel est le niveau de votre stock actuel ? Mil : Sto",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q24 : Disposez-vous encore aujourd\\'hui de stocks (stock et/o)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q23A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q23.a : Si oui, quels types de cultures 3. Cultures potag\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q23.a : Si oui, quels types de cultures 2. Cultures de rente",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q23.a : Si oui, quels types de cultures 1. Cultures vivri\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q23 : Votre m\\xc3\\xa9nage a-t-il l\\'intention de pratiquer des cultu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q22.a : Si oui, quels types de cultures 3. Cultures potag\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q22.a : Si oui, quels types de cultures 2. Cultures de rente",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q22.a : Si oui, quels types de cultures 1. Cultures vivri\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q22 : Votre m\\xc3\\xa9nage pratique-il des cultures de contre saison",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q217": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q217",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 7. Autres",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q216": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q216",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 6. Inondat",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q215": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q215",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 5. Manques",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q214": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q214",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 4. Arr\\xc3\\xaat p",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q213": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q213",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 3. Manque",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q212": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q212",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 2. Insecte",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q211": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q211",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q21: Si Q21 = 3, quelle est la cause principale ? 1. Faible",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q21: Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2008, qu",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mauvaise",
                                    "long_name": "Q20 : Comment jugez-vous la derni\\xc3\\xa8re campagne agricole ?",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B7C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B7C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B7B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B7B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B7A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B7A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B6C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B6C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B6B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B6B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B6A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B6A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B5C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B5C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B5B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B5B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B5A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B5A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B4C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B4C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B4B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B4B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B4A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B4A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B3C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B3C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B3B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B3B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B2C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B2C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B2B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B2B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B1C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B1C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Tongolo",
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19B1B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B1B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19B1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19B1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q19.b : Quel est le niveau de votre production vivri\\xc3\\xa8re pour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q19A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q19.a : Comment ont \\xc3\\xa9volu\\xc3\\xa9 les superficies cultiv\\xc3\\xa9es cette a",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q19 : Aviez-vous exploit\\xc3\\xa9 des champs/jardins cette ann\\xc3\\xa9e ?",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q18A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Canards",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Pintades",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Poulets",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Equins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Asins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Camelins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Caprins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Ovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Pigeons",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q18a : Si oui, combien pour les esp\\xc3\\xa8ces suivantes ? Bovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q18 : Le m\\xc3\\xa9nage poss\\xc3\\xa8de t-il des animaux (y compris la volai)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q71": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q71",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q71",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14I": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14I",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Occupation principale",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NA",
                                    "long_name": "Fr\\xc3\\xa9quentation actuelle",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Le niveau d\\'instruction",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "C\\xc3\\xa9libataire",
                                    "long_name": "Statut matrimonial",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Absent",
                                    "long_name": "R\\xc3\\xa9sidence",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro d\\'ordre dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PID": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PID",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT INDIVIDU",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "enfants": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "enfants",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Enfant de 1 \\xc3\\xa0 4 ans dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q17 : les revenus tir\\xc3\\xa9s de ces diff\\xc3\\xa9rentes sources, vous per",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q16 : Combien de sources de revenu le m\\xc3\\xa9nage dispose t-il ?",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q16 : Combien de sources de revenu le m\\xc3\\xa9nage dispose t-il ?",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q16 : Combien de sources de revenu le m\\xc3\\xa9nage dispose t-il ?",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q16 : Combien de sources de revenu le m\\xc3\\xa9nage dispose t-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vul_fan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vul_fan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non vuln\\xc3\\xa9rable",
                                    "long_name": " Classification de l\\'ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire selon la m\\xc3\\xa9thode FANTA",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "UBTTETE0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBTTETE0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT PAR TETE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "UBT0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT ancienne",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT nouvelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "taille_men": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taille_men",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Taille des m\\xc3\\xa9nages",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "N\\xc2\\xb0 ZD",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "N\\xc2\\xb0 Grappe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Commune de :",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q345": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q345",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Centre urbain/Canton/Zone restante de :",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement de r\\xc3\\xa9sidence",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q15 : Nombre total des membres du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Zone pastorale et d\\xc3\\xa9sertique",
                                    "long_name": "Zone agro \\xc3\\xa9cologique",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey ph\\xc3\\xa9riph\\xc3\\xa9rie",
                                    "long_name": "R\\xc3\\xa9gion de r\\xc3\\xa9sidence",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Pondmen": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pondmen",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration finale m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pond_ind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pond_ind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration finale individu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "milieu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "milieu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey p\\xc3\\xa9riph\\xc3\\xa9rie",
                                    "long_name": "Milieu de r\\xc3\\xa9sidence",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "ID": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Dur\\xc3\\xa9e des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "classevulR0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "classevulR0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9",
                                    "long_name": "Classe de vuln\\xc3\\xa9rabilit\\xc3\\xa9  finale avec 3 variables actives",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "classevulR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "classevulR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non vuln\\xc3\\xa9rable",
                                    "long_name": "Classe de vuln\\xc3\\xa9rabilit\\xc3\\xa9  finale",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                }
                            }
                        },
                        "FSA2008": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FSA2008",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v026": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v026",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Classe 15/15",
                                    "long_name": "Partition en 15 classes",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "TUBERC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TUBERC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "troc1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "troc1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "troc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "troc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "troc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SUCRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SUCRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "SUCRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "source_revenu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "source_revenu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autr.",
                                    "long_name": "Premi\\xc3\\xa8res sources de revenu recod\\xc3\\xa9e",
                                    "units": "ids",
                                    "scale_max": "10.0",
                                    "missing_value": "-999.0"
                                },
                                "Revtetj": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revtetj",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu par tete et par jour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revmois": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revmois",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu mensuel en cash des menages",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "q939_9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q939_9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q939 NOMBRE DE JOUR DEMANDE DE NOURRITURE POUR LES ENFANTS",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q938_8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q938_8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q938 NOMBRE DE JOUR CONSOMMATION DES SEMENCES",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q937_7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q937_7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q937 NOMBRE DE JOUR RECOURS INHABITUEL ALIMENT DE PENURIE",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q936_6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q936_6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q936 NOMBRE DE JOUR RENONCER AU PAIEMENT DES DETTES CONTRACT",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q935_5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q935_5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q935 NOMBRE DE JOUR DEPENDANCE DE L\\'EXTERIEURE",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q934_4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q934_4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q934 NOMBRE DE JOUR ACHAT DES VIVRES A CREDIT",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q933_3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q933_3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q933 NOMBRE DE JOUR EMPRUNT DES VIVRES",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q932_2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q932_2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q932 NOMBRE DE JOUR ALIMENTS MOINS PREFERES",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q931_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q931_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q931 NOMBRE DE JOUR MANQUE ASSEZ DE VIVRE OU D\\'ARGENT",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9315_15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9315_15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9315 NOMBRE DE JOUR PASSER TOUTE UNE JOURNEE SANS MANGER",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9314_14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9314_14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9314 NOMBRE DE JOUR DIMINUTION DE NOMBRE DE REPAS",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9313_13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9313_13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9313 NOMBRE DE JOUR ACHAT DES REPAS POUR DES RAISONS ECONOM",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9312_12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9312_12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9312 NOMBRE DE JOUR DIMINUTION DE LA QUANTITE RATION JOURNA",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9311_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9311_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9311 NOMBRE DE JOUR DIMINUTION DE LA RATION JOURNALIERE",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "q9310_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q9310_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q9310 NOMBRE DE JOUR RECOURS A LA MENDICTE",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Trois repas et plus",
                                    "long_name": "Q92B NBRE REPAS COLLECTIFS MOINS 5 ANS HABITUELLEMENT",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Trois repas et plus",
                                    "long_name": "Q92A NBRE REPAS COLLECTIFS MOINS 5 ANS ACTUELLEMENT",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q91B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Trois repas et plus",
                                    "long_name": "Q91B NBRE REPAS COLLECTIFS PRIS HABITUELLEMENT DANS LE MENAG",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q91A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Trois repas et plus",
                                    "long_name": "Q91A NBRE REPAS COLLECTIFS PRIS ACTUELLEMENT DANS LE MENAGE",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON APPLICABLE",
                                    "long_name": "Q24H Le niveau d\\'instruction 5 ans et plus",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON APPLICABLE",
                                    "long_name": "Q24G Occupation principale",
                                    "units": "ids",
                                    "scale_max": "13.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "FEMININ",
                                    "long_name": "Q24F Sexe",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24E1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24E1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24E1 Age en mois (enfants 0 \\xc3\\xa0 24 mois)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24E Age",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q24D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "ABSENT",
                                    "long_name": "Q24D R\\xc3\\xa9sidence",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUCUN LIEN DE PARENTE",
                                    "long_name": "Q24C lien de parent\\xc3\\xa9 avec le Chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q24A ID",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PROTEAN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PROTEAN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PROTEINE ANIMALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pprod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pprod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pppl1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pppl1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production pluviale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pppl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pppl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pppl",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ppcs1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ppcs1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ppcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ppcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ppcs",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ppa1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ppa1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ppa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ppa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ppa",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "poste_depense": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_depense",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "poste_depense",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "poste_dep9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Autres d\\xc3\\xa9penses",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Remboursement emprunts et dettes",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "C\\xc3\\xa9r\\xc3\\xa9monies et fun\\xc3\\xa9railles",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Habits et chaussures",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Logement eau et electricit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Transport",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Education",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Sant\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Alimentation",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Pdepalc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pdepalc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion depenses alimentaires en cash",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pauvrete": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pauvrete",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non pauvre",
                                    "long_name": "Pauvrete",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "ntalco": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntalco",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total aliments conommes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRevmois": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRevmois",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "NTILES of Revmois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NDeptot3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDeptot3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "NTILES of Deptot30",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "NTILES of CSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nachats1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nachats1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "NTILES of achats1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Marketd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Marketd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "High",
                                    "long_name": "Market dependance",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "livelihood": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "livelihood",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mendicite",
                                    "long_name": "Livelihood",
                                    "units": "ids",
                                    "scale_max": "13.0",
                                    "missing_value": "-999.0"
                                },
                                "LEGMSES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LEGMSES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LEGUMINEUSES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LAIPDLAI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAIPDLAI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LAIT ET PRODUITS LAITIERS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA5_recode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA5_recode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9 alimentaire",
                                    "long_name": "CLASSE VULNERABILITE EN DEUX GROUPES",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "ISA3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ISA3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ISA2",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classes insecurite alimentaire",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "HUILE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HUILE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FRUIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRUIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FRUIT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "filter_": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filter_$",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Selected",
                                    "long_name": "Depart = 55 (FILTER)",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "FEUILEGM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FEUILEGM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FEUILLES ET LEGUMES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "emp1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "emp1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "emp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "emp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "emp",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "dzak1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dzak1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent dons/zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "dzak": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dzak",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "dzak",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Deptot30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Deptot30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "depnse30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "depnse30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9pense totales en cash au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depnalto30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depnalto30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses non alimentaires totales par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depnal30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depnal30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses non alimentaires au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depnal1230": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depnal1230",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses non alimentaires au cours des 12 derniers mois recalcul\\xc3\\xa9es par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depnal12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depnal12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses non alimentaires au cours des 12 derniers mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depalto30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depalto30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses alimentaires totales au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depalec30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depalec30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses alimentaires en produits \\xc3\\xa9chang\\xc3\\xa9s au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depalca30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depalca30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses alimentaires en cash au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depalca": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depalca",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses alimentaires mensuelles en cash",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depalau30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depalau30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses alimentaires en autoconsommation au cours des 30 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CLSCORE28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLSCORE28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Acceptable",
                                    "long_name": "CLASSES SCORE DE CONSOMMATION ALIMENTAIRE SEUIL 28",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "CLSCORE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLSCORE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Classe score 42 62",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "classevul0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "classevul0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9 alimentaire",
                                    "long_name": "Classe de vuln\\xc3\\xa9rabilit\\xc3\\xa9 recalcul\\xc3\\xa9e",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "_class": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "class",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "class",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CERTUB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CERTUB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES & TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CEREAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CEREAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ccp1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ccp1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent chasse/cueillette/peche",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ccp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ccp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ccp",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "aut1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "aut1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "aut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "aut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "aut",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "aida1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "aida1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent aide/assistance",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "aida": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "aida",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "aida",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "achats1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "achats1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "achats": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "achats",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "achats",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q946": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q946",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q946 RETIRER LES ENFANTS DE L\\'ECOLE POUR DES RAISONS ALIMENT",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q945": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q945",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q945 VENTE TERRE POUR RAISONS ALIMENTAIRES",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q944": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q944",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q944 VENTE BIENS PRODUCTIFS POUR RAISON ALIMENTAIRE",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q943": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q943",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q943 VENTE BIENS NON PRODUCTIFS POUR RAISON ALIMENTAIRE",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q942": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q942",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q942 VENTE ANIMAUX REPRODUCTEURS POUR RAISON ALIMENTAIRE",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q941": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q941",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q941 DEPART INHABITUEL D\\'ACTIFS AU COURS  DES 30 DERNIERS JO",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q939": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q939",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q939 NOMBRE DE JOUR DEMANDE DE NOURRITURE POUR LES ENFANTS",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q938": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q938",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q938 NOMBRE DE JOUR CONSOMMATION DES SEMENCES",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q937": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q937",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q937 NOMBRE DE JOUR RECOURS INHABITUEL ALIMENT DE PENURIE",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q936": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q936",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q936 NOMBRE DE JOUR RENONCER AU PAIEMENT DES DETTES CONTRACT",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q935": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q935",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q935 NOMBRE DE JOUR DEPENDANCE DE L\\'EXTERIEURE",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q934": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q934",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q934 NOMBRE DE JOUR ACHAT DES VIVRES A CREDIT",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q933": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q933",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q933 NOMBRE DE JOUR EMPRUNT DES VIVRES",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q932": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q932",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q932 NOMBRE DE JOUR ALIMENTS MOINS PREFERES",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9315": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9315",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9315 NOMBRE DE JOUR PASSER TOUTE UNE JOURNEE SANS MANGER",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9314": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9314",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9314 NOMBRE DE JOUR DIMINUTION DE NOMBRE DE REPAS",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9313": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9313",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9313 NOMBRE DE JOUR ACHAT DES REPAS POUR DES RAISONS ECONOM",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9312": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9312",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9312 NOMBRE DE JOUR DIMINUTION DE LA QUANTITE RATION JOURNA",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9311": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9311",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9311 NOMBRE DE JOUR DIMINUTION DE LA RATION JOURNALIERE",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9310": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9310",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q9310 NOMBRE DE JOUR RECOURS A LA MENDICTE",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q931": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q931",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Non",
                                    "long_name": "Q931 NOMBRE DE JOUR MANQUE ASSEZ DE VIVRE OU D\\'ARGENT",
                                    "units": "ids",
                                    "scale_max": "0.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92B NBRE REPAS COLLECTIFS MOINS 5 ANS HABITUELLEMENT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q92A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92A NBRE REPAS COLLECTIFS MOINS 5 ANS ACTUELLEMENT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91B NBRE REPAS COLLECTIFS PRIS HABITUELLEMENT DANS LE MENAG",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91A NBRE REPAS COLLECTIFS PRIS ACTUELLEMENT DANS LE MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q905": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q905",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q905 JUGEMENT DE L\\'IMPACT SUR LA SITUATION NUTRITIONNELLE DE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q904": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q904",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q904 JUGEMENT DE L\\'IMPACT SUR LA SITUATION ALIMENTAIRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q903": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q903",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q903 3\\xc3\\xa8me Difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q902": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q902",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q902 2\\xc3\\xa8me Difficut\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q901": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q901",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q901 1\\xc3\\xa8re Difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Section08c": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section08c",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q86B_P24": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P24",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P23": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P23",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P22": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P22",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P21": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P21",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P20": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P20",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P19": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P19",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P18": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P18",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P17": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P17",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P16": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P16",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P15": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P15",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P14": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P14",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P13": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P13",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86A_P24": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P24",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P23": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P23",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P22": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P22",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P21": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P21",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P20": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P20",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P19": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P19",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P18": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P18",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P17": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P17",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P16": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P16",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P15": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P15",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P14": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P14",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P13": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P13",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86_P24": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P24",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P23": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P23",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P22": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P22",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P21": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P21",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P20": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P20",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P19": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P19",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P18": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P18",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P17": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P17",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P16": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P16",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P15": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P15",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P14": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P14",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P13": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P13",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section08b": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section08b",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q86B_P12": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P12",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P11": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P11",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86B_P01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86B_P01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "CLIST": "AUTRE A PRECISER",
                                        "long_name": "Q86B PRINCIPALE SOURCE",
                                        "units": "ids",
                                        "scale_max": "10.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86A_P12": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P12",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P11": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P11",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86A_P01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86A_P01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q86A NOMBRE DE JOURS DE CONSOMMATION AUCOURS DES 7 DERNIERS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q86_P12": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P12",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P11": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P11",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q86_P01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q86_P01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "HUILES GRAISSES",
                                        "long_name": "Q86 CODE ALIMENTS",
                                        "units": "ids",
                                        "scale_max": "24.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section08a": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section08a",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q89A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q89A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "Q89 EST-CE-QUE IL Y\\'A DES ALIMENTS QUE VOUS NE CONSOMMEZ PLU",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q88A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q88A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "Q88 LES ALIMENTS QUE VOUS CONSOMMEZ ACTUELLEMENT SONT T-ILS",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q87": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q87",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "S\\'est am\\xc3\\xa9lior\\xc3\\xa9e",
                                        "long_name": "Q87 COMMENT TROUVEZ-VOUS VOTRE CONSOMMATION ALIMENTAIRE ACTU",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    }
                                }
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "RECU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RECU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "A recu un transfert au cours des 12 derniers mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85G_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85G_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85G QUANTITE DE CSB RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85F_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85F_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85F QUANTITE DE SUCRE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85E_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85E_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85E QUANTITE D\\'HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85D_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85D_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85D QUANTITE DE LEGUMINEUSE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85C_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85C_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85C QUANTITE DE CEREALE RECUE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85B_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85B_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q85B MONTANT RECU PAR JOUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q85A_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85A_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85A_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "N0N",
                                    "long_name": "Q85A AVEZ VOUS BENEFICE OUI OU NON",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q85_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q85_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q85 CODE PROGRAMME",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Section06d": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06d",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QB2B83": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B83",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B82": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B82",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B81": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B81",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B80": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B80",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B79": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B79",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B78": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B78",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B77": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B77",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B76": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B76",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B75": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B75",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B74": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B74",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B73": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B73",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B72": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B72",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B71": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B71",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2B70": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2B70",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB2B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB2A83": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A83",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A82": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A82",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A81": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A81",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A80": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A80",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A79": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A79",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A78": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A78",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A77": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A77",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A76": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A76",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A75": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A75",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A74": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A74",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A73": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A73",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A72": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A72",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A71": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A71",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB2A70": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB2A70",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB2A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB283": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB283",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB282": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB282",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB281": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB281",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB280": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB280",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB279": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB279",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB278": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB278",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB277": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB277",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB276": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB276",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB275": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB275",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB274": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB274",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB273": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB273",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB272": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB272",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB271": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB271",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB270": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB270",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "70.0",
                                        "CLIST": "AUTRES",
                                        "long_name": "QB2 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "83.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB1B69": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1B69",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB1B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB1B68": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1B68",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB1B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB1B67": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1B67",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB1B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB1B66": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1B66",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB1B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB1B65": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1B65",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QB1B MONTANT DEPENSE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QB1A69": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1A69",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB1A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB1A68": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1A68",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB1A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB1A67": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1A67",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB1A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB1A66": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1A66",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB1A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB1A65": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB1A65",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QB1A AVEZ VOUS EFFECTUE DES DEPENSES",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB169": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB169",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "65.0",
                                        "CLIST": "SOINS D\\'ENTRETIEN CORPOREL",
                                        "long_name": "QB1 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "69.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB168": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB168",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "65.0",
                                        "CLIST": "SOINS D\\'ENTRETIEN CORPOREL",
                                        "long_name": "QB1 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "69.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB167": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB167",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "65.0",
                                        "CLIST": "SOINS D\\'ENTRETIEN CORPOREL",
                                        "long_name": "QB1 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "69.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB166": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB166",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "65.0",
                                        "CLIST": "SOINS D\\'ENTRETIEN CORPOREL",
                                        "long_name": "QB1 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "69.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QB165": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QB165",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "65.0",
                                        "CLIST": "SOINS D\\'ENTRETIEN CORPOREL",
                                        "long_name": "QB1 CODE DEPENSES NON ALIMENTAIRES",
                                        "units": "ids",
                                        "scale_max": "69.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06c": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06c",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QA64": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA64",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA63": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA63",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA62": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA62",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA61": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA61",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA60": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA60",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA59": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA59",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA58": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA58",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA57": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA57",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA56": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA56",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA55": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA55",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA54": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA54",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA53": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA53",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA52": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA52",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA51": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA51",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA464": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA464",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA463": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA463",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA462": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA462",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA461": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA461",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA460": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA460",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA459": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA459",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA458": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA458",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA457": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA457",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA456": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA456",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA455": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA455",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA454": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA454",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA453": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA453",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA452": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA452",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA451": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA451",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA364": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA364",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA363": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA363",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA362": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA362",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA361": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA361",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA360": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA360",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA359": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA359",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA358": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA358",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA357": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA357",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA356": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA356",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA355": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA355",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA354": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA354",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA353": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA353",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA352": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA352",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA351": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA351",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA264": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA264",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA263": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA263",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA262": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA262",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA261": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA261",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA260": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA260",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA259": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA259",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA258": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA258",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA257": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA257",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA256": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA256",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA255": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA255",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA254": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA254",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA253": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA253",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA252": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA252",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA251": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA251",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA164": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA164",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA163": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA163",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA162": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA162",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA161": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA161",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA160": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA160",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA159": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA159",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA158": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA158",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA157": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA157",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA156": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA156",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA155": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA155",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA154": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA154",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA153": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA153",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA152": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA152",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA151": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA151",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06b": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06b",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QA50": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA50",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA49": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA49",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA48": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA48",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA47": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA47",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA46": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA46",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA450": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA450",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA45": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA45",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA449": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA449",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA448": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA448",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA447": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA447",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA446": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA446",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA445": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA445",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA444": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA444",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA443": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA443",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA442": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA442",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA441": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA441",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA440": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA440",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA44": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA44",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA439": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA439",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA438": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA438",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA437": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA437",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA4 VALEUR PRODUIT ECHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA43": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA43",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA42": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA42",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA41": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA41",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA40": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA40",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA39": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA39",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA38": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA38",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA37": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA37",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "37.0",
                                        "CLIST": "ATRES CONDIMENTS",
                                        "long_name": "QA CODE ALIMENT",
                                        "units": "ids",
                                        "scale_max": "64.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA350": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA350",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA349": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA349",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA348": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA348",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA347": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA347",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA346": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA346",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA345": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA345",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA344": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA344",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA343": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA343",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA342": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA342",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA341": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA341",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA340": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA340",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA339": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA339",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA338": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA338",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA337": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA337",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA3 VALEUR PRODUITS AUTOCOCONSOMMES",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA250": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA250",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA249": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA249",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA248": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA248",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA247": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA247",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA246": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA246",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA245": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA245",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA244": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA244",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA243": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA243",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA242": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA242",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA241": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA241",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA240": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA240",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA239": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA239",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA238": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA238",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA237": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA237",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "QA2 MONTANT DEPENSE CASH 30 DERNIERS JOURS",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "QA150": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA150",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA149": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA149",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA148": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA148",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA147": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA147",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA146": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA146",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA145": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA145",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA144": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA144",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA143": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA143",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA142": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA142",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA141": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA141",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA140": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA140",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA139": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA139",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA138": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA138",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "QA137": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QA137",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON",
                                        "long_name": "QA1 AVEZ VOUS EFFECTUE LA DEPENSE",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06a": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06a",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q8417": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8417",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8417 TRANSPORT",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8416": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8416",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8416 EDUCATION",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8415": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8415",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8415 SANTE",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8414": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8414",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8414 INTRANTS AGRICOLE EQUIPEMENT ET MAIN D\\'OEUVRE",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8413": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8413",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8413 LOGEMENT",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8412": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8412",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8412 ENERGIE",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8411": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8411",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "NON APPLICABLE",
                                        "long_name": "Q8411ALIMENTATION",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q84": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q84",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q84 VOS DEPENSES ONT ELLES CHANGE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q36": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q36",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "ND",
                                        "long_name": "Q36 LE REMBOURSEMENT A-T-IL ETE FAIT OU ENGAGE",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0",
                                        "fnname": "maskle",
                                        "file_missing_value": "-999"
                                    },
                                    "Q35A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A2 EN ESPECE (y compris les animaux)",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1F": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1F",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1F QUANTITE FONIO ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1E": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1E",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1E QUANTITE BLE ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1D": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1D",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1D QUANTITE RIZ ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1C QUANTITE MAIS ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1B QUANTITE SORGHO ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35A1A QUANTITE MIL ENDETTE",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q34": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q34",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "ND",
                                        "long_name": "Q34 DEPUIS LES RECOLTES 2007 AVEZ -VOUS EU A VOUS ENDETTER P",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0",
                                        "fnname": "maskle",
                                        "file_missing_value": "-999"
                                    }
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q33B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33B NOMBRE DE MOIS QUE LE STOCK DOIT COUVRIR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q33A SUFFISANCE DU STOCK",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q33 DISPOSITION DE STOCKS AUJOURD\\'HUI  DE CEREALES",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q32B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES",
                                    "long_name": "Q32B CAUSE PRINCIPALE",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q32A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON APPLICABLE",
                                    "long_name": "Q32A PAR RAPPORT CAMPAGNE 2007 NIVEAU DE RECOLTE 2008",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "MAUVAISE",
                                    "long_name": "Q31 COMMENT JUGEZ VOUS LA CAMPAGNE AGRICOLE ACTUELLE",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "ND",
                                    "long_name": "Q30 EVOLUTION SUPERFICIES CULTIVEES",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29B SI OUI QUELLE EST LA SUPERFICIE TOTALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29A SI OUI COMBIEN DE CHAMPS SONT-IL EXPLOITES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q29 AVEZ VOUS EXPLOITE DES CHAMPS L\\' ANNEE PASSEE",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q28A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A9 EFFECTIF CANARDS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A8 EFFECTIF PINTADES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A7 EFFECTIF POULETS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A6 EFFECTIF EQUINS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A5 EFFECTIF ASINS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A4 EFFECTIF CAMELIN",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A3 EFFECTIF CAPRINS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A2 EFFECTIF OVINS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A10 EFFECTIF PIGEONS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q28A1 EFFECTIF BOVINS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "NON",
                                    "long_name": "Q28 POSSESSION DES ANIMAUX Y COMPRIS LA VOLAILLE",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q25D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q25D NOMBRE TOTAL DES MEMBRES ACTIFS DU MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q25C NOMBRE D\\'ENFANTS DE 6 \\xc3\\xa0 24 MOIS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q25B NOMBRE D\\'ENFANTS DE MOINS DE 5ANS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q25A NOMBRE TOTAL DES MEMBRES DU MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q23 QUELLE EST LA NATURE PRINCIPALE DU MUR DU LOGEMENT",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES A PRECISER",
                                    "long_name": "Q22 QUELE EST LA NATURE DU PRINCIPAL TOIT DE LOGEMENT",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRE A PRECISER",
                                    "long_name": "Q21 QUELLE EST LE STATUT D\\'OCCUPATION DU LOGEMENT",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRE",
                                    "long_name": "Q20 QUELLE EST LA PRINCIPALE SOURCE D\\'ENERGIE POUR LA CUISSO",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRE A PRECISER",
                                    "long_name": "Q19 QUELLE EST LE PRINCIPAL TYPE DE TOILETTE",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRE A PRECISER",
                                    "long_name": "Q18 QUELLE EST LA PRINCIPALE SOURCE D\\'EAU DE BOISSON",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES",
                                    "long_name": "Q17 PRINCIPALE  ACTIVITE  CM",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "CELIBATAIRE",
                                    "long_name": "Q16 STATUT MATRIMONIAL CM",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q15 AGE DU CM",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "FEMININ",
                                    "long_name": "Q14 SEXE CM",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Milieu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Milieu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Rural",
                                    "long_name": "Milieu de residence",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q26C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26C3 MONTANT TIRE DE CETTE SOURCE 3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26C2 CONTRIBUTION AU REVENU TOTAL 3",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES",
                                    "long_name": "Q26C1 TROISIEME  SOURCE DE REVENU",
                                    "units": "ids",
                                    "scale_max": "13.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26B3 MONTANT TIRE DE CETTE SOURCE 2",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26B2 CONTRIBUTION AU REVENU TOTAL 2",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES",
                                    "long_name": "Q26B1 DEUXIEME SOURCE DE REVENU",
                                    "units": "ids",
                                    "scale_max": "13.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26A3 MONTANT TIRE DE CETTE SOURCE 1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26A2 CONTRIBUTION AU REVENU TOTAL 1",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "AUTRES",
                                    "long_name": "Q26A1 PREMIERE SOURCE DE REVENU",
                                    "units": "ids",
                                    "scale_max": "13.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q26 COMBIEN DE SOURCE DE REVENU LE MENAGE DISPOSE T-IL",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "STOCK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "STOCK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Duree des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SCORE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SCORE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Score consommation alimentaire",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "region": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "region",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "RCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced coping strategy index ponderation universelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "NUMERO DE ZD",
                                    "long_name": "Num\\xc3\\xa9ro ZD",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "NUMERO DE GRAPPE",
                                    "long_name": "N\\xc2\\xb0 Grappe",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Commune",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "C.urbain ou canton ou Z. restante",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pastorale et d\\xc3\\xa9sertique",
                                    "long_name": "Zone agro \\xc3\\xa9cologique",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "NUMERO MENAGE",
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "poste_dep": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "poste_dep",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres d\\xc3\\xa9penses",
                                    "long_name": "Poste de d\\xc3\\xa9pense",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Pondmen": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pondmen",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pond\\xc3\\xa9ration m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pondind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pondind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ponderation individu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pdepal": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pdepal",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion despenses alimentaires dans les depenses globales",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "MOIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MOIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Mois de Passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "JOUR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "JOUR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Jour de Passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "EN SECURITE ALIMENTAIRE",
                                    "long_name": "CLASSES INSECURITE ALIMENTAIRE RETENUE FINALE",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "ISA4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "EN SECURITE ALIMENTAIRE",
                                    "long_name": "CLASSES INSECURITE ALIMENTAIRE RETENUE",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "IDMEN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "IDMEN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDMEN",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ID0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Identifiant m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Deptotet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Deptotet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par tete et par jour",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Depart": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Depart",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping strategy index ponderation universelle",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CODE_ENQUETEUR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CODE_ENQUETEUR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CODE ENQUETEUR",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CODE_CHEF_D_EQUIPE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CODE_CHEF_D_EQUIPE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "MME ABDOU HALIMATOU ISSA",
                                    "long_name": "CODE CHEF D\\'EQUIPE",
                                    "units": "ids",
                                    "scale_max": "35.0",
                                    "missing_value": "-999.0"
                                },
                                "CODE_AGENT_DE_SAISIE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CODE_AGENT_DE_SAISIE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Hamissou Mahamadou Hafizou",
                                    "long_name": "CODE AGENT DE SAISIE",
                                    "units": "ids",
                                    "scale_max": "20.0",
                                    "missing_value": "-999.0"
                                },
                                "classevul": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "classevul",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9 alimentaire",
                                    "long_name": "Classe de vuln\\xc3\\xa9rabilit\\xc3\\xa9 retenue finale",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "AN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ann\\xc3\\xa9e de Passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            }
                        },
                        "brm2013": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "brm2013",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "TUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SUCRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SUCRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "SUCRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenutet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenutet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu mensuel moyen par tete",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu moyen mensuel du menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "RCSI_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "RCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Indice reduit des strat\\xc3\\xa9gies d\\'adaptation",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PROTANI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PROTANI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PROTEINE ANIMALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES Y COMPRIS AUTOCONSOMMATION",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production pluviale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcppa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcppa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent emprunt",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcdons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcdons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent Dons/Zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Pcacha7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Pcacha7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pourcent achat effectue au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NUBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NUBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NRCSI_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NRCSI_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of RCSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NDurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of DurSto",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NDEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of DEPTET",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "NCSI_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NCSI_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Percentile Group of CSI",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "nbalcs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbalcs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la contre saison",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltravn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltravn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de travail contre nourriture10",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltrav": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltrav",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de nourriture contre travail",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naltot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naltot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total d\\'aliments consomes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalpprod": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalpprod",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalppan": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalppan",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de la propre production animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des emprunts",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Naldons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Naldons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des dons/zakat",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalchass": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalchass",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes de chasse/cueillette/peche",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalaut": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalaut",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant de autre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalassist": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalassist",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des assistances alimentaires",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Nalach7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Nalach7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre aliments consommes provenant des achats au cours des 7 derniers jours",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LEGMSES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LEGMSES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LEGUMINEUSES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LAITPDLAIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAITPDLAIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LAIT ET PRODUITS LAITIERS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "HUILE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HUILE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FRUIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRUIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FRUITS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FEUILEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FEUILEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FEUILLES ET LEGUMES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCSG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCSG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Acceptable",
                                    "long_name": "Classes du score de consommation alimentaire",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "FCS_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Food consumption score",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Huile",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Sucre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Lait",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G54": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G54",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Oeufs",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G53": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G53",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Poisson",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G52": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G52",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Abats",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G51": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G51",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Viande",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Prot\\xc3\\xa9\\xc3\\xafne d\\'orgine animale",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G42": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G42",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Autres fruits",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G41": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G41",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Fruit riches en vitamine A",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Fruits",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Autres l\\xc3\\xa9gumes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "L\\xc3\\xa9gumes riches en vitamine A",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Feuilles et legumes",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "L\\xc3\\xa9gumineuse",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Racines et tubercules",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "C\\xc3\\xa9r\\xc3\\xa9ales",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS8_G1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS8_G1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Cereales et tubercules",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Score de consommation alimentaire",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Dur\\xc3\\xa9e des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTMC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTMC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par tete par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPNAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPNAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES NON ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Indice des strat\\xc3\\xa9gies d\\'adaptation",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CFCS_OLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFCS_OLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Consommation alimentaire acceptable",
                                    "long_name": "Classes food consumption score",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "CERTUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CERTUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES ET TUBERCULE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CEREALES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CEREALES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q95I": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95I",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q95i : Comment les resources attendues pendant les 12 derniers \\xc3\\xa0 venir sont-elle",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q95h : Comment les resources envoy\\xc3\\xa9es pendant les 12 derniers sont-elles jug\\xc3\\xa9es",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q95g : Approximativement, quel a \\xc3\\xa9t\\xc3\\xa9 le montant des transferts mon\\xc3\\xa9taires de ces",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q95F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Plus de 9 mois dans l\\'ann\\xc3\\xa9e",
                                    "long_name": "Q95f : Aproximativement les migrants saisonniers de votre m\\xc3\\xa9nage sont absents pe",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q95e : Parmi ces migrants y a-t-il le chef de m\\xc3\\xa9nage ?",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D3B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D3B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D2B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D2B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D1B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D1B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95D1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95D1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95d : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95c : O\\xc3\\xb9 vivent-ils/travaillent-ils actuellement ? Hors d\\'Afrique",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95c : O\\xc3\\xb9 vivent-ils/travaillent-ils actuellement ? Autre pays d\\'Afrique pr\\xc3\\xa9cise",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95c : O\\xc3\\xb9 vivent-ils/travaillent-ils actuellement ? Autre ville du Niger",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95c : O\\xc3\\xb9 vivent-ils/travaillent-ils actuellement ? Ville Niamey",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95c : O\\xc3\\xb9 vivent-ils/travaillent-ils actuellement ? Autre village",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B3B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B3B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B3A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B3A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B2B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B2B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B2A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B2A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B1B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B1B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95B1A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95B1A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Vers un pays africain",
                                    "long_name": "Q95b : Combien de membres de votre village ont migr\\xc3\\xa9 pour la recherche d\\'un empl",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q95A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q95A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q95a. : Y a-t-il un membre ou ancien membre de votre m\\xc3\\xa9nage vivant et travaillan",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q949": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q949",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.9 : Emprunter de l\\'argent/nourriture \\xc3\\xa0 un commer\\xc3\\xa7ant  usurier reconnu du vil",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q948": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q948",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.8 : Reduire les d\\xc3\\xa9penses li\\xc3\\xa9es \\xc3\\xa0 la sant\\xc3\\xa9 et/ou \\xc3\\xa0 l\\'\\xc3\\xa9ducation pour acheter d",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q947": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q947",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.7 : Votre m\\xc3\\xa9nage a-t-il fait travailler ses enfants (moins de 18 ans) en r\\xc3\\xa9p",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q946": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q946",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.6 : Est-ce que votre m\\xc3\\xa9nage a retir\\xc3\\xa9 les enfants de l\\'\\xc3\\xa9cole pour des raisons",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q945": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q945",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.5 : Est-ce que votre m\\xc3\\xa9nage a vendu des terres pour des raisons d\\'ins\\xc3\\xa9curit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q944": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q944",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.4 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens productifs (boeufs de trait...)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q943": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q943",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.3 : Est-ce que votre m\\xc3\\xa9nage a vendu des biens non productifs (bijoux...)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q942": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q942",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.2 : Est-ce que votre m\\xc3\\xa9nage a vendu des animaux reproducteurs pour des besoi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9413": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9413",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.13 : Vente d\\'une partie de la r\\xc3\\xa9colte sur pied",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9412": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9412",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.12 : R\\xc3\\xa9colte pr\\xc3\\xa9coce pour consommer",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9411": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9411",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.11 : Reduire les d\\xc3\\xa9penses pr\\xc3\\xa9vues pour les intrants agricoles  (semences, en)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9410": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9410",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.10 : Contraint de d\\xc3\\xa9penser son \\xc3\\xa9pargne pour des raisons d\\'ins\\xc3\\xa9curit\\xc3\\xa9 aliment",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q941": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q941",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q94.1 : Est-ce que votre m\\xc3\\xa9nage a enregistr\\xc3\\xa9 des d\\xc3\\xa9parts d\\'actifs plus que d\\'hab",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q939": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q939",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.9 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb demander \\xc3\\xa0 d\\'autres m\\xc3\\xa9nages de la nourritur",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q938": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q938",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.8 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des semences pour des raisons d\\'ins\\xc3\\xa9c",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q937": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q937",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.7 : Est-ce que votre m\\xc3\\xa9nage a eu recours inhabituel \\xc3\\xa0 la consommation d\\'alim",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q936": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q936",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.6 : Est-ce que votre m\\xc3\\xa9nage a du renoncer au paiement de dettes contract\\xc3\\xa9es",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q935": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q935",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.5 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb d\\xc3\\xa9pendre de l\\'aide alimentaire ext\\xc3\\xa9rieure",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q934": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q934",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.4 : Est-ce que votre m\\xc3\\xa9nage a achet\\xc3\\xa9 des vivres \\xc3\\xa0 cr\\xc3\\xa9dits",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q933": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q933",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.3 : Est-ce que votre m\\xc3\\xa9nage a emprunt\\xc3\\xa9 des vivres chez des parents, des vois",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q932": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q932",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.2 : Est-ce que votre m\\xc3\\xa9nage a consomm\\xc3\\xa9 des aliments moins pr\\xc3\\xa9f\\xc3\\xa9r\\xc3\\xa9s",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9316": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9316",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.16 : Est-ce que vous-m\\xc3\\xaame ou un membre de votre m\\xc3\\xa9nage est all\\xc3\\xa9 au lit en ay",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9315": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9315",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.15 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb passer toute une journ\\xc3\\xa9e sans manger",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9314": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9314",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.14 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 le nombre de repas pris par jour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9313": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9313",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.13 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb acheter des repas pour des raisons d\\'\\xc3\\xa9cono",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9312": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9312",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.12 : Est-ce que votre m\\xc3\\xa9nage a d\\xc3\\xbb diminuer la ration journali\\xc3\\xa8re pour les ad",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9311": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9311",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.11 : Est-ce que votre m\\xc3\\xa9nage a diminu\\xc3\\xa9 la ration journali\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9310": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9310",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.10 : Est-ce que au moins un membre de votre m\\xc3\\xa9nage a eu recours \\xc3\\xa0 la mendici",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q931": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q931",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q93.1 : Y a-t-il eu des moments o\\xc3\\xb9 vous n\\'avez pas assez de vivre ou d\\'argent po",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q92B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enfants : Habituellemen",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q92A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q92A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q92. : Combien de repas sont pris dans le m\\xc3\\xa9nage par les enfants : Actuellement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans le m\\xc3\\xa9nage : Habituell",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q91A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q91A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q91. : Combien de repas collectifs sont pris par jour dans le m\\xc3\\xa9nage : Actuellem",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q909": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q909",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 9 = Coupure d\\'\\xc3\\xa9lectricit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q908": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q908",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 8 = Augmentation des prix des intrants",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q907": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q907",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 7 = Augmentation des prix du loyer",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q906": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q906",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 6 = Augmentation des prix du carburant",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q905": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q905",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 5 = augmentation des prix des denr\\xc3\\xa9es",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q904": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q904",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 4 = D\\xc3\\xa9c\\xc3\\xa8s d\\'un membre de la famille",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q903": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q903",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 3 = Maladie/d\\xc3\\xa9penses de sant\\xc3\\xa9 exceptio",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q902": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q902",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 2 = Baisse de revenu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9016": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9016",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 16 = Autres \\xc3\\xa0 pr\\xc3\\xa9ciser...",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9015": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9015",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 15 = baisse des r\\xc3\\xa9coltes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9014": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9014",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 14 = Irr\\xc3\\xa9gularit\\xc3\\xa9 des pluies",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9013": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9013",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 13 = Catastrophes naturelles (inondati)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9012": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9012",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 12 = Ch\\xc3\\xb4mage de longue dur\\xc3\\xa9e",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9011": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9011",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 11 = Remboursement de dettes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9010": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9010",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 10 = Ins\\xc3\\xa9curit\\xc3\\xa9/ vols",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q901": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q901",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q90 : Principales difficult\\xc3\\xa9s ou chocs..: 1 = Perte d\\'emploi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9005": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9005",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'enfants de moins de 5 ans",
                                    "long_name": "Q90.5 : Comment jugez-vous l\\'impact sur la situation nutritionnelle des enfants",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9004": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9004",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Pas d\\'impact",
                                    "long_name": "Q90.4 : Comment jugez-vous l\\'impact sur la situation alimentaire de votre m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9003": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9003",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.3 : Principales difficult\\xc3\\xa9s ou chocs..: 3\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9002": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9002",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.2 : Principales difficult\\xc3\\xa9s ou chocs..: 2\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q9001": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9001",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q90.1 : Principales difficult\\xc3\\xa9s ou chocs..: 1\\xc3\\xa8re difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q89": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q89",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q89 : Est ce qu\\'il y a des aliments que vous ne consommez plus......",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q88": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q88",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q88 : Les aliments que vous consommez actuellement......",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q87": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q87",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "S\\'est am\\xc3\\xa9lior\\xc3\\xa9e",
                                    "long_name": "Q87 : Comment trouvez-vous votre consommation alimentaire actuellement......",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Epices/condiments : Quelle \\xc3\\xa9tai",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Sucre ou produits sucr\\xc3\\xa9s : Quel",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Huiles/gras/beurre : Quelle \\xc3\\xa9ta",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Laits et produits laitiers : Qu",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Oeufs : Quelle \\xc3\\xa9tait la princip",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Poisson : Quelle \\xc3\\xa9tait la princ",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Foie/rognon : Quelle \\xc3\\xa9tait la p",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Viande : Quelle \\xc3\\xa9tait la princi",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres fruits : Quelle \\xc3\\xa9tait la",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Fruit de couleur orange : Quell",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Autres l\\xc3\\xa9gumes : Quelle \\xc3\\xa9tait l",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes : Que",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 L\\xc3\\xa9gumes de couleur orange : Que",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 L\\xc3\\xa9gumineuse/noix : Quelle \\xc3\\xa9tait",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Racines tubercules : Quelle \\xc3\\xa9ta",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86D01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86D01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q86.d : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 C\\xc3\\xa9r\\xc3\\xa9ales : Quelle \\xc3\\xa9tait la prin",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Epices/condiments : Pendant com",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Sucre et produits sucr\\xc3\\xa9s : Pend",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Huiles/gras/beurre : Pendant co",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Laits et produits laitiers : Pe",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Oeufs :  Pendant combien de jou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Poisson : Pendant combien de jo",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Foie/rognon : Pendant combien d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Viande : Pendant combien de jou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres fruits : Pendant combien",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Fruit de couleur orange : Penda",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Autres l\\xc3\\xa9gumes : Pendant combie",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes : Pen",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 L\\xc3\\xa9gumes de couleur orange : Pen",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 L\\xc3\\xa9gumineuse/noix : Pendant comb",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Racines tubercules : Pendant co",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86C01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86C01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q86.c : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 C\\xc3\\xa9r\\xc3\\xa9ales : Pendant combien de j",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 16 Epices/condiments : Consomm\\xc3\\xa9 le",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 15 Sucre ou produits sucr\\xc3\\xa9s : Cons",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 14 Huiles/gras/beurre : Consomm\\xc3\\xa9 l",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 13 Laits et autres produits laitie",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 12 Oeufs : Consomm\\xc3\\xa9 les 24 heures.",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 11 Poisson : Consomm\\xc3\\xa9 les 24 heure",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 10 Foie, rognon : Consomm\\xc3\\xa9 les 24",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 09 Viande : Consomm\\xc3\\xa9 les 24 heures",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 08 Autres fruits : Consomm\\xc3\\xa9 les 24",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 07 Fruit de couleur orange : Conso",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 06 Autres l\\xc3\\xa9gumes : Consomm\\xc3\\xa9 les 2",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes : Con",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 04 L\\xc3\\xa9gumes decouleur orange: Conso",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 03 L\\xc3\\xa9gumineuse/noix : Consomm\\xc3\\xa9 les",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 02 Racines tubercules : Consomm\\xc3\\xa9 l",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q86B01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q86B01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q86.b : Aliements consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage  : 01 C\\xc3\\xa9r\\xc3\\xa9ales : Consomm\\xc3\\xa9 les 24 heur",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q859": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q859",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.9 Ration compl\\xc3\\xa9mentaire pour les femmes enceintes et allaitantes",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q858": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q858",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.8 Blanket feeding",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q857": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q857",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.7 Don/Zakat",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q856": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q856",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.6 Ration de d\\xc3\\xa9charge/ protection",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q855": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q855",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.5 Argent contre travail",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q854": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q854",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.4 Vivre contre travail",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q853": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q853",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.3 Vente de c\\xc3\\xa9r\\xc3\\xa9ales \\xc3\\xa0 prix mod\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q852": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q852",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.2 Distribution gratuite",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q851A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q851A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Financement dans autres d\\xc3\\xa9penses du m\\xc3\\xa9nage",
                                    "long_name": "Q85.1 Si la r\\xc3\\xa9ponse \\xc3\\xa0 la question Q85 est 5 ou 11 quelle est la principale utili",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8515": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8515",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.15 Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8514": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8514",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.14 D\\xc3\\xa9stockage strat\\xc3\\xa9gique des animaux",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8513": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8513",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.13 Reconstitution sociale du cheptel",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8512": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8512",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.12 Banques aliments b\\xc3\\xa9tail",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8511": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8511",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.11 Cash transfert",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q8510": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q8510",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.10 Intrants agricoles (engrais, semences...)",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q851": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q851",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q85.1 Banque c\\xc3\\xa9r\\xc3\\xa9ali\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Section06d": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06d",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q8417": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8417",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.7 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Transport",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8416": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8416",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.6 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Education",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8415": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8415",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.5 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Sant\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8414": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8414",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.4 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Intrants agricoles, \\xc3\\xa9quipement et m",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8413": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8413",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.3 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Logement",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8412": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8412",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.2 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Energie (cuisson, chauffage...)",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q8411": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q8411",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non applicable",
                                        "long_name": "Q84.1.1 Quels types de d\\xc3\\xa9penses ont chang\\xc3\\xa9 : Alimentation",
                                        "units": "ids",
                                        "scale_max": "4.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q84": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q84",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Ont augment\\xc3\\xa9",
                                        "long_name": "Q84 : Vos d\\xc3\\xa9penses ont-elles chang\\xc3\\xa9 compar\\xc3\\xa9es \\xc3\\xa0 celles de la m\\xc3\\xaame p\\xc3\\xa9riode l\\'ann\\xc3\\xa9",
                                        "units": "ids",
                                        "scale_max": "3.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06c": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06c",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q83B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q83 : D\\xc3\\xa9penses de communication : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q83AB": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83AB",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q83a : Autres : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q83AA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83AA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q83a : Autres : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q83A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q83A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q83 : D\\xc3\\xa9penses de communication : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q82B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q82A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q82A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q82 : Salaire pay\\xc3\\xa9 (domestiques...) : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q81B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q81A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q81A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q81 : Remboursement d\\'emprunts ou dettes : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q80B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q80 : Frais de transport : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q80A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q80A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q80 : Frais de transport : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q79B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q79A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q79A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q79 : Construction, r\\xc3\\xa9paration, habitation : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q78B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q78A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q78A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q78 : C\\xc3\\xa9r\\xc3\\xa9monies/Fun\\xc3\\xa9railles/Festivit\\xc3\\xa9s : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q77B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q77 : Habillement/chaussures : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q77A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q77A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q77 : Habillement/chaussures : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q76B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q76 : Equipement domestique : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q76A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q76A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q76 : Equipement domestique : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q75B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q75A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q75A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q75 : D\\xc3\\xa9penses en produits zoo v\\xc3\\xa9t\\xc3\\xa9riniaire : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q74B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q74 : Achat d\\'animaux : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q74A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q74A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q74 : Achat d\\'animaux : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q73B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q73A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q73A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q73 : Equipements agricoles/outils/semence : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q72B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q72A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q72A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q72 : D\\xc3\\xa9penses d\\'\\xc3\\xa9ducation : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q71B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q71A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q71A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q71 : Logement/eau/\\xc3\\xa9lectricit\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q70B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q70A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q70A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q70 : D\\xc3\\xa9penses de sant\\xc3\\xa9 : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q69B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q69A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q69A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q69 : Soins d\\'entretien corporel (.;) : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q68B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q68 : Carburant/lubrifiants : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q68A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q68A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q68 : Carburant/lubrifiants : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q67B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q67A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q67A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q67 : Savon en marceau en liquide ou en poudre : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense.",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q66B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q66A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q66A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q66 : P\\xc3\\xa9trole, gaz, charbon, piles : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q65B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q65 : Bois de chauffe : Montant en F CFA",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q65A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q65A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q65 : Bois de chauffe : aviez-vous effectu\\xc3\\xa9 la d\\xc3\\xa9pense...",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                },
                                "Section06b": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06b",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q64A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q64 : Autres condiments : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q64A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q64A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q64 : Autres condiments : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q63A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q63 : Pomme de terre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q63A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q63A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q63 : Pomme de terre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q62A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q62 : Feuilles vertes : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q62A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q62A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q62 : Feuilles vertes : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q61A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q61 : Igname : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q61A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q61A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q61 : Igname : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q60A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q60 : Manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q60A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q60A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q60 : Manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q59A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q59 : Sel : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q59A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q59A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q59 : Sel : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q58A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q58 : Oignon : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q58A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q58A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q58 : Oignon : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q57A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q57 : Sucre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q57A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q57A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q57 : Sucre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q56A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q56 : Voandzou : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q56A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q56A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q56 : Voandzou : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q55A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s.",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q55 : Petit pois/lentille : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q55A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q55A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q55 : Petit pois/lentille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q54A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q54A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q54A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q54 : Ni\\xc3\\xa9b\\xc3\\xa9/Haricot/dolique : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q53A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q53 : Arachide : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q53A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q53A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q53 : Arachide : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q52A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q52 : Beurre : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q52A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q52A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q52 : Beurre : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q51A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q51 : Oeuf : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q51A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q51A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q51 : Oeuf : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q50A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q50 : Lait : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q50A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q50A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q50 : Lait : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q49A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q49 : Fromage : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q49A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q49A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q49 : Fromage : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q48A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q48 : Poisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q48A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q48A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q48 : Poisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q47A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q47 : Volaille : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q47A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q47A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q47 : Volaille : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q46A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q46 : Viande/Abats : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q46A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q46A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q46 : Viande/Abats : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q45A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q45 : Huile de cuisson : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q45A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q45A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q45 : Huile de cuisson : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q44A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s..",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q44A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q44A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q44 : P\\xc3\\xa2tes alimentaires : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q43A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q43 : Pain : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q43A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q43A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q43 : Pain : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q42A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q42A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q42A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q42 : Bl\\xc3\\xa9/farine : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q41A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q41 : Farine de manioc : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q41A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q41A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q41 : Farine de manioc : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q40A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q40A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q40A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q40 : Ma\\xc3\\xafs : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q39A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q39 : Sorgho : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q39A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q39A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q39 : Sorgho : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q38A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q38 : Mil : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q38A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q38A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q38 : Mil : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q37A4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits \\xc3\\xa9chang\\xc3\\xa9s...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quelle est la valeur en F CFA des produits auto...",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q37 : Riz : Quel est le montant de la d\\xc3\\xa9pense",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q37A1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q37A1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q37 : Riz : Aviez effectu\\xc3\\xa9 la d\\xc3\\xa9pense",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q36": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q36",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q36 : Si oui le remboursement a-t-il d\\xc3\\xa9j\\xc3\\xa0 \\xc3\\xa9t\\xc3\\xa9 fait ou engag\\xc3\\xa9 ?",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.b En esp\\xc3\\xa8ce (y compris la valeur des animaux)",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    }
                                },
                                "Section06a": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Section06a",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Q35A7C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A7B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A7A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A7A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Fonio , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9, Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A6B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A6A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A6A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Bl\\xc3\\xa9 , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9 , Nombre d\\'UML pour un sac de 100 k",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A5B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A5A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A5A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz d\\xc3\\xa9cortiqu\\xc3\\xa9, quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz , Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A4B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A4A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A4A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Riz paddy , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A3B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A3A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A3A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Ma\\xc3\\xafs , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A2B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A2A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A2A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Sorgho , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Nombre d\\'UML pour un sac de 100 kg",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q35A1B": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1B",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Tongolo",
                                        "long_name": "Q35.a En vivres (en nature) : Mil , Code UML",
                                        "units": "ids",
                                        "scale_max": "7.0",
                                        "missing_value": "-999.0"
                                    },
                                    "Q35A1A": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q35A1A",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Q35.a En vivres (en nature) : Mil , quantit\\xc3\\xa9 en UML",
                                        "missing_value": "-999.0",
                                        "units": "unitless"
                                    },
                                    "Q34": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q34",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "1.0",
                                        "CLIST": "Non",
                                        "long_name": "Q34 : Depuis les r\\xc3\\xa9coltes de l\\'ann\\xc3\\xa9e pass\\xc3\\xa9e 2010, aviez-vous eu \\xc3\\xa0 vous endetter.",
                                        "units": "ids",
                                        "scale_max": "2.0",
                                        "missing_value": "-999.0"
                                    }
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q33D6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Riz",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33D5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Bl\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33D4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Ni\\xc3\\xa9b\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33D3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Ma\\xc3\\xaes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33D2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Sorgho",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33D1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33D1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.d : Si oui \\xc3\\xa0 Q33c, lesquels ? Mil",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.c : Est-ce que vous disposez-vous d\\'un stock de semences pour la prochaine c",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33.b : Combien de mois pensez-vous que votre stock ou appro...",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33.a : Si oui pensez-vous que votre stock ou vos moyens sont suffisants.....",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33 : Disposez-vous encore aujourd\\'hui de stocks.....",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q32A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2010/2011.... : Si Q32 = 3",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q32 : Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2010/2011....",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mauvaise",
                                    "long_name": "Q31 : Comment jugez-vous la campagne agricole 2011/2012",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q30 : Comment ont \\xc3\\xa9volu\\xc3\\xa9 les superficies cultiv\\xc3\\xa9es.....",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.b : La superficie total des champs/jardins en hectares",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q29.a : Si oui, combien de champs/jardins exploit\\xc3\\xa9s",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q29 : Exploitation des champs/jardins campagne agricole 2011/2012 ?",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q28A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Canards/Oies",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pintades",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Poulets",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Equins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Asins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Camelins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Caprins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Ovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Autres",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Pigeons",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, : nombre de Bovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Le m\\xc3\\xa9nage poss\\xc3\\xa8de t-il des aminaux",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q27C9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27B9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 9. T\\xc3\\xa9l\\xc3\\xa9phone portable : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 8. Machine \\xc3\\xa0 coudre : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 7. Fer \\xc3\\xa0 repasser : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 6. Bijoux : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 5. Natte : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 4. Lit : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 3. Table : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 2. Couverture/Sakala : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 19. Autres : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 18. Lampe/Torche : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 17. Moustiquaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 16. Charrue : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 15. Charrette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 14. Bicyclette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 13. Cyclomoteur : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 12. Houe/Daba/hilaire : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 11. Radio : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 10. Appareil TV/Accessoires:  Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage : 1. Chaise : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale des murs du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale du toit du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "9.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Le statut d\\'occupation du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9nergie pour l\\'\\xc3\\xa9clairage pour le m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9nergie pour la cuisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Le principal type de toilette qu\\'utilise le m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale source d\\'eau de boisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "C\\xc3\\xa9libataire",
                                    "long_name": "Statut matrimonial du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q16C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribution au revenu total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribution au revenu total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage :montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage: contribution au revenu total e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q16A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Combien de sources de revenu mon\\xc3\\xa9taire le m\\xc3\\xa9nage dispose t-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "taille": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taille",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "taille du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total des membres actifs dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de 6 \\xc3\\xa0 24 mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de moins de 5 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Sup\\xc3\\xa9rieur",
                                    "long_name": "Le niveau d\\'instruction du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autres",
                                    "long_name": "Occupation principale du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "14.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Absent",
                                    "long_name": "Statut de r\\xc3\\xa9sidence du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age du chef de m\\xc3\\xa9nage (en ann\\xc3\\xa9es r\\xc3\\xa9volues)",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe du chef de menage",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Zone pastorale et d\\xc3\\xa9sertique",
                                    "long_name": "Zone agro \\xc3\\xa9cologique",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la ZD",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la grappe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "D\\xc3\\xa9partement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "pondmen_r": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pondmen_r",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pondmen_r",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pondmen": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pondmen",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "coefficient de ponderation menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pondind_r": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pondind_r",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pondind_r",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "pondind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pondind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pondind",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9",
                                    "long_name": "Classes d\\'insecurite alimentaire",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "ID": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ID",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "IDENTIFIANT MENAGE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "departement": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "departement",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "departement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            }
                        },
                        "bmv2014": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bmv2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Section12": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section12",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "UBT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UBT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "UBT",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "TUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "TUBERCULES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "SUCRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SUCRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "SUCRE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenutet": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenutet",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu mensuel moyen par tete",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Revenu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Revenu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Revenu moyen mensuel du menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "RCSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RCSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reduced Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PROTANI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PROTANI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PROTEINE ANIMALE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PDEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PDEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "PART DES DEPENSES ALIMENTAIRES DANS LES DEPENSES TOTALES Y COMPRIS AUTOCONSOMMATION",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LEGMSES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LEGMSES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LEGUMINEUSES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "LAITPDLAIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LAITPDLAIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "LAIT ET PRODUITS LAITIERS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "HUILE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HUILE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "HUILE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FRUIT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRUIT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FRUITS",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FEUILEG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FEUILEG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FEUILLES ET LEGUMES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Food consumption score",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DurSto": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DurSto",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Dur\\xc3\\xa9e des stocks",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTMC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTMC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTOTM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTOTM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES TOTALES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPTET": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPTET",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Depenses totales par tete par mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPNALT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPNALT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES NON ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPNALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPNALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES NON ALIMENTAIRES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPALC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPALC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES EN CASH",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "DEPAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEPAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "DEPENSES ALIMENTAIRES MENSUELLES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Coping Strategy Index",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CFCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CFCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Consommation alimentaire acceptable",
                                    "long_name": "Classes food consumption score",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "CERTUBER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CERTUBER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES ET TUBERCULE",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "CEREALES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CEREALES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "CEREALES",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q59I": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59I",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q59.i: Comment les ressources attendues pendant les 12 derniers mois sont elles",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q59H": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59H",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q59.h: Comment les ressources envoy\\xc3\\xa9es  pendant les 12 derniers mois sont elles",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q59G": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59G",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.g: Approximativement quel est le montant des transferts mon\\xc3\\xa9taires des migra",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Plus de 9 mois dans l\\'ann\\xc3\\xa9e",
                                    "long_name": "Q59.f: Les migrants saisonniers sont absents pendant combien de mois en moyenne",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q59E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q59.e : Parmi ces migrants y a t-il le chef de m\\xc3\\xa9nage: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q59D3M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D3M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres Masculin de plus de 50 ans qui ont migr\\xc3\\xa9 pour la recher",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59D3F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D3F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres F\\xc3\\xa9minin de plus de 50 ans qui ont migr\\xc3\\xa9 pour la recherc",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59D2M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D2M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres Masculin de 18 \\xc3\\xa0 50 ans qui ont migr\\xc3\\xa9 pour la recherche",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59D2F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D2F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres F\\xc3\\xa9minin de18 \\xc3\\xa0 50 ans qui ont migr\\xc3\\xa9 pour la recherche d",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59D1M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D1M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres Masculin de Moins de 18 ans qui ont migr\\xc3\\xa9 pour la reche",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59D1F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59D1F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.d: Nombre de membres F\\xc3\\xa9minin de Moins de 18 ans qui ont migr\\xc3\\xa9 pour la recher",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.c: Ou vivent t-ils actuellement: Hors d\\'Afrique",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.c: Ou vivent t-ils actuellement: Autre pays d\\'Afrique",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.c: Ou vivent t-ils actuellement: Autre ville du Niger",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.c: Ou vivent t-ils actuellement: Ville Niamey",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.c: Ou vivent t-ils actuellement: Autre village",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B3M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B3M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres Masculin de plus de 50 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B3F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B3F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres F\\xc3\\xa9minin de plus de 50 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B2M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B2M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres Masculin de 18 \\xc3\\xa0 50 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B2F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B2F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres F\\xc3\\xa9minin de18 \\xc3\\xa0 50 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B1M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B1M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres Masculin de Moins de 18 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59B1F": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59B1F",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q59.b: Nombre de membres F\\xc3\\xa9minin de Moins de 18 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q59A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q59A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q59.a : Y a t-il un membre de m\\xc3\\xa9nage vivant en dehors du village: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q589B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q589B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.9: contraint de d\\xc3\\xa9penser pour des raisons d\\'insecurit\\xc3\\xa9 alimentaire Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q589A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q589A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.9: Au cours des 30 derniers jours contraint de d\\xc3\\xa9penser son \\xc3\\xa9pargne pour des",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q588B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q588B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.8: Emprunter de l\\'argent/Nourriture \\xc3\\xa0 un commercant usurier du village  Si N",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q588A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q588A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.8: Au cours des 30 derniers jours emprunter de l\\'argent/Nourriture \\xc3\\xa0 un comm",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q587B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q587B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.7: r\\xc3\\xa9duire les d\\xc3\\xa9penses li\\xc3\\xa9es \\xc3\\xa0 la sant\\xc3\\xa9/Education pour achat des vivres Si",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q587A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q587A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.7: Au cours des 30 derniers jours r\\xc3\\xa9duire les d\\xc3\\xa9penses li\\xc3\\xa9es \\xc3\\xa0 la sant\\xc3\\xa9/Educ",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q586B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q586B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.6: retirer les enfants pour des raisons alimentaires Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q586A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q586A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.6: Au cours des 30 derniers jours retirer les enfants de l\\'\\xc3\\xa9cole pour des ra",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q585B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q585B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.5: vente des terres pour des raisons d\\'insecurit\\xc3\\xa9 alimentaire Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q585A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q585A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.5: Au cours des 30 derniers jours vente des terres pour des raisons d\\'insecu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q584B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q584B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.4: vente des biens productifs pour des raisons d\\'insecurit\\xc3\\xa9 alimentaire Si N",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q584A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q584A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.4: Au cours des 30 derniers jours vente des biens productifs pour des raison",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q583B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q583B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.3: vente des actifs domestiques pour des besoins alimentaires Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q583A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q583A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.3: Au cours des 30 derniers jours vente des actifs domestiques pour les beso",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q582B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q582B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.2: vente des animaux reproducteurs pour des besoins alimentaires Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q582A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q582A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.2: Au cours des 30 derniers jours vente des animaux reproducteurs pour des b",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q581B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q581B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.1: Departs d\\'actifs plus que d\\'habitude Si non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q581A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q581A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.1: Au cours des 30 derniers jours...departs d\\'actifs plus que d\\'habitude",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5813B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5813B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.13: Hypoth\\xc3\\xa8que des terres Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5813A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5813A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.13: Au cours des 30 derniers jours Hypoth\\xc3\\xa8que des terres",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5812B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5812B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.12: Vente r\\xc3\\xa9colte sur pied Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5812A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5812A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.12: Au cours des 30 derniers jours vente r\\xc3\\xa9colte sur pied",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5811B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5811B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.11: r\\xc3\\xa9colte pr\\xc3\\xa9coce pour consommer Si Non",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5811A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5811A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.11: Au cours des 30 derniers jours r\\xc3\\xa9colte pr\\xc3\\xa9coce pour consommer",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5810B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5810B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q58.10: Reduire les d\\xc3\\xa9penses pr\\xc3\\xa9vues pour les intrants agricoles pour acheter de",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5810A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5810A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q58.10: Au cours des 30 derniers jours reduire les d\\xc3\\xa9penses pr\\xc3\\xa9vues pour les int",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q579": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q579",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.9: Au cours des 7 derniers jours...d\\xc3\\xa9pendre de l\\'aide",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q578": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q578",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.8: Au cours des 7 derniers jours...envoyer un membre de m\\xc3\\xa9nage manger chez l",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q577": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q577",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.7: Au cours des 7 derniers jours...passer une journ\\xc3\\xa9e enti\\xc3\\xa8re sans manger",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q576": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q576",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.6: Au cours des 7 derniers jours...acheter des vivres \\xc3\\xa0 cr\\xc3\\xa9dit",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q575": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q575",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.5: Au cours des 7 derniers jours...diminuer le nombre de repas par jour",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q574": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q574",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.4: Au cours des 7 derniers jours...restreindre la consommation des adultes",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q573": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q573",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.3: Au cours des 7 derniers jours...diminuer la quantit\\xc3\\xa9 consomm\\xc3\\xa9e pdt les re",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q572": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q572",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.2: Au cours des 7 derniers jours...emprunt\\xc3\\xa9 de la  nourriture chez des paren",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5715": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5715",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.15: Au cours des 7 derniers jours...achat des repas pour des raisons d\\'\\xc3\\xa9cono",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5714": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5714",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.14: Au cours des 7 derniers jours...recours \\xc3\\xa0 la mendicit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5713": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5713",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.13: Au cours des 7 derniers jours...demander de la nourriture pour enfants",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5712": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5712",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.12: Au cours des 7 derniers jours...consommation des semences reserv\\xc3\\xa9es",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5711": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5711",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.11: Au cours des 7 derniers jours...recours inhabituel \\xc3\\xa0 la consommation d\\'a",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5710": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5710",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.10: Au cours des 7 derniers jours...renoncer au paiement des dettes contract",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q571": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q571",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q57.1: Au cours des 7 derniers jours...consommer des aliments moins pr\\xc3\\xa9f\\xc3\\xa9r\\xc3\\xa9s",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q56B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q56B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q56: Combien de repas sont pris dans le m\\xc3\\xa9nage par les enfants: Habituellement \\xc3\\xa0",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q56A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q56A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q56: Combien de repas sont pris dans le m\\xc3\\xa9nage par les enfants: Actuellement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q55B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q55B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q55: Combien de repas collectifs sont pris par jour dans le m\\xc3\\xa9nage: Habituelleme",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q55A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q55A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q55: Combien de repas collectifs sont pris par jour dans le m\\xc3\\xa9nage: Actuellement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q549": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q549",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 9 = Coupure d\\'\\xc3\\xa9lectricit\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q548": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q548",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 8 = Augmentation des prix des intrants ag",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q547": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q547",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 7 = Augmentation des prix du loyer",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q546": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q546",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 6 = Augmentation des prix du carburant/ t",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q545": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q545",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 5 = augmentation des prix des denr\\xc3\\xa9es ali",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q544": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q544",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 4 = D\\xc3\\xa9c\\xc3\\xa8s d\\'un membre de la famille",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q543": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q543",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 3 = Maladie/d\\xc3\\xa9penses de sant\\xc3\\xa9 exceptionne",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q542": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q542",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 2 = Baisse de revenu",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q541C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q541C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q54.3 : Principales difficult\\xc3\\xa9s ou chocs: 3\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "17.0",
                                    "missing_value": "-999.0"
                                },
                                "Q541B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q541B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q54.2 : Principales difficult\\xc3\\xa9s ou chocs: 2\\xc3\\xa8me difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "17.0",
                                    "missing_value": "-999.0"
                                },
                                "Q541A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q541A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q54.1 : Principales difficult\\xc3\\xa9s ou chocs: 1\\xc3\\xa8re difficult\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "17.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5417": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5417",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54 : Principales difficult\\xc3\\xa9s ou chocs: 17 = Autres \\xc3\\xa0 pr\\xc3\\xa9ciser...",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5416": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5416",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 16 = Innondations",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5415": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5415",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 15 = Baisse des r\\xc3\\xa9coltes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5414": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5414",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 14 = Irr\\xc3\\xa9gularit\\xc3\\xa9 des pluies",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5413": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5413",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 13 = Catastrophes naturelles (Incendie Ve)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5412": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5412",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 12 = Ch\\xc3\\xb4mage de longue dur\\xc3\\xa9e",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5411": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5411",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 11 = Remboursement de dettes",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5410": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5410",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 10 = Ins\\xc3\\xa9curit\\xc3\\xa9/ vols",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q541": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q541",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q54: Principales difficult\\xc3\\xa9s ou chocs: 1 = Perte d\\'emploi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q53": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q53",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "S\\'est am\\xc3\\xa9lior\\xc3\\xa9e",
                                    "long_name": "Q53: Comment trouvez-vous votre consommation alimentaire actuellement......",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 09 Viande Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 08 Autres fruits Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 07 Fruits de couleur orange Source princi",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 06 Autres L\\xc3\\xa9gumes Source principale",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes Source princ",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 04 L\\xc3\\xa9gumes de couleur orange Source princ",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 03 L\\xc3\\xa9gumineuse noix Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 02 Racines Tubercules Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Propre production pluviale",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 16 Epices/Condiments Source principale",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 15 Sucre ou autres prdts sucr\\xc3\\xa9s Source pr",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 14 Huile/Gras/Beurre Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 13 Lait et autres prdts laitiers Source p",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 12 Oeufs Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 11 Poissons Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 10 Foie Rognon Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52D1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52D1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 01 C\\xc3\\xa9r\\xc3\\xa9ales Source principale",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 09 Viande Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 08 Autres fruits Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 07 Fruits de couleur orange Nombre de jou",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 06 Autres L\\xc3\\xa9gumes Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes Nombre de jo",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 04 L\\xc3\\xa9gumes de couleur orange Nombre de jo",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 03 L\\xc3\\xa9gumineuse Noix Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 02 Racines Tubercules Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 16 Epices/Condiments Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 15 Sucre ou autres prdts sucr\\xc3\\xa9s Nombre de",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 14 Huile/Gras/Beurre Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 13 Lait et autres prdts laitiers Nombre d",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 12 Oeufs Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 11 Poisson Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 10 Foie Rognon Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CLIST": "7 jours",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 01 C\\xc3\\xa9r\\xc3\\xa9ales Nombre de jours",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 09 Viande Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 08 Autres fruits Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Oui",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 07 Fruits de couleur orange Oui/Non",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 06 Autres L\\xc3\\xa9gumes Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 05 L\\xc3\\xa9gumes \\xc3\\xa0 feuilles vertes Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 04 L\\xc3\\xa9gumes de couleur orange Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 03 L\\xc3\\xa9gumineuse Noix Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 02 Racines Tubercules Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 16 Epices/Condiments Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 15 Sucre ou autres prdts sucr\\xc3\\xa9s Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 14 Huile/Gras/Beurre Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 13 Lait et autres prdts laitiers Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 12 Oeufs Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 11 Poisson Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 10 Foie Rognon Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q52B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q52B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q52 Aliments consomm\\xc3\\xa9s dans le m\\xc3\\xa9nage: 01 C\\xc3\\xa9r\\xc3\\xa9ales Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q519": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q519",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.9 Ration compl\\xc3\\xa9mentaire (femmes enceintes et allaitantes)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q518": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q518",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.8 Blanket feeding",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q517": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q517",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.7 Cantine scolaire",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q516": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q516",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.6 Prise en charge Malnutrition",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q515": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q515",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.5 Argent contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q514": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q514",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.4 Vivre contre travail",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q513": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q513",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.3 Vente de c\\xc3\\xa9r\\xc3\\xa9ales \\xc3\\xa0 prix mod\\xc3\\xa9r\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q512": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q512",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.2 Distribution gratuite vivres",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5116": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5116",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Q51.16 Quelle est la principale utilisation faite des transferts recus",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5115": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5115",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.15 Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5114": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5114",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.14 D\\xc3\\xa9stockage strat\\xc3\\xa9gique des animaux",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5113": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5113",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.13 Reconstitution sociale du cheptel (distribution des animaux)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5112": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5112",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.12 Banque aliments b\\xc3\\xa9tails",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5111": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5111",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.11 Cash transfert",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q5110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q5110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.10 Intrants agricoles (engrais, semences...)",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q511": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q511",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q51.1 Banque c\\xc3\\xa9r\\xc3\\xa9ali\\xc3\\xa8re",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q50A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q50A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q50: Autres d\\xc3\\xa9penses non alimentaires: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q50A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q50A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q50: Autres depenses non alimentaire: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q49A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q49A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q49: Communication: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q49A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q49A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q49: Communication: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q48A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q48A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q48: Remboursement de dettes: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q47A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q47A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q47: Transport: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q47A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q47A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q47: Transport: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q46A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q46A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q46: Dons/zakat: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q46A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q46A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q46: Dons/Zakat: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q45A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q45A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q45: Education: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q45A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q45A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q45: Education: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q44A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q44A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q44: Sant\\xc3\\xa9: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q44A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q44A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q44: Sant\\xc3\\xa9: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q43A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q43A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q43: C\\xc3\\xa9r\\xc3\\xa9monie: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q43A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q43A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q43: C\\xc3\\xa9r\\xc3\\xa9monie: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q42A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q42A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q42: Autres repas consomm\\xc3\\xa9s hors de la maison: Quelle est la valeur estim\\xc3\\xa9e en F",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q42A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q42A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q42: Autres repas consomm\\xc3\\xa9s hors de la maison: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q42A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q42A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q42: Autres repas consomm\\xc3\\xa9s hors de la maison: consommation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q42A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q42A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q42: Autres repas consomm\\xc3\\xa9s hors de la maison: d\\xc3\\xa9pense  \\xc3\\xa0 credit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q42A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q42A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q42: Autres repas consomm\\xc3\\xa9s hors de la maison: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q41A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q41A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q41: Th\\xc3\\xa9/Caf\\xc3\\xa9: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q41A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q41A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q41: Th\\xc3\\xa9/Caf\\xc3\\xa9: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q41A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q41A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q41: Th\\xc3\\xa9/Caf\\xc3\\xa9: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q41A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q41A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q41: Th\\xc3\\xa9/Caf\\xc3\\xa9: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q41A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q41A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q41: Th\\xc3\\xa9/Caf\\xc3\\xa9: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q40A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q40A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q40: Sucre/Sel: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q40A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q40A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q40: Sucre/Sel: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q40A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q40A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q40: Sucre/Sel: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q40A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q40A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q40: Sucre/Sel: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q40A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q40A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q40: Sucre/Sel: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q39A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q39A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q39: Lait/Fromage/Yagourt: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q39A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q39A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q39: Lait/Fromage/Yagourt : principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q39A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q39A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q39: Lait/Fromage/Yagourt : consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q39A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q39A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q39: Lait/Fromage/Yagourt : d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q39A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q39A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q39: Lait /Fromage/Yagourt: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q38A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q38A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q38: Huiles, mati\\xc3\\xa8res grasses: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q38A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q38A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q38: Huiles, mati\\xc3\\xa8res grasses: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q38A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q38A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q38: Huiles, mati\\xc3\\xa8res grasses: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q38A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q38A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q38: Huiles, mati\\xc3\\xa8res grasses: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q38A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q38A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q38: Huiles, mati\\xc3\\xa8res grasses: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q37A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q37A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q37: Poisson/Viande/Oeuf/Poulet: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q37A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q37A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q37: Poisson/Viandes/Oeuf/Poulet : principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q37A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q37A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q37: Poisson/Viandes/Oeuf/Poulet : consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q37A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q37A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q37: Poisson/Viande/Oeuf/Poulet: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q37A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q37A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q37: Poisson/Viande/Ooeuf/poulet: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q36A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q36A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q36: Fruits et l\\xc3\\xa9gumes: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q36A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q36A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q36: Fruits et l\\xc3\\xa9gumes: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q36A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q36A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q36: Fruits et  l\\xc3\\xa9gumes: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q36A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q36A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q36: Fruits er l\\xc3\\xa9gumes: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q36A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q36A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q36: fruits et l\\xc3\\xa9gumes: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q35A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q35A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q35: L\\xc3\\xa9gumineuses: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q35A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q35A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q35: L\\xc3\\xa9gumineuses: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q35A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q35A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q35: L\\xc3\\xa9gumineuse: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q35A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q35A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q35: L\\xc3\\xa9gumineuses: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q35A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q35A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q35: L\\xc3\\xa9gumineuses: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q34A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q34A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q34:Tubercules: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q34A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q34A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieure",
                                    "long_name": "Q34:Tubercules: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q34A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q34A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q34:Tubercules: consomation",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q34A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q34A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q34:Tubercules: d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q34A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q34A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q34:Tubercules: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33: C\\xc3\\xa9r\\xc3\\xa9ales: Quelle est la valeur estim\\xc3\\xa9e en F CFA",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Achat anterieur",
                                    "long_name": "Q33: C\\xc3\\xa9r\\xc3\\xa9ales: principale source",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33A02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q33: C\\xc3\\xa9r\\xc3\\xa9ales: consomation",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q33A01B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A01B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33: C\\xc3\\xa9r\\xc3\\xa9ales:  d\\xc3\\xa9pense au  cr\\xc3\\xa9dit",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q33A01A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q33A01A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q33: C\\xc3\\xa9r\\xc3\\xa9ales: d\\xc3\\xa9pense au comptant",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q32A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En espece et en nature",
                                    "long_name": "Q32a: Si oui quelle est la nature de l\\'endettement",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q32": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q32",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q32: Depuis r\\xc3\\xa9colte 2014 avez vous \\xc3\\xa9t\\xc3\\xa9 endett\\xc3\\xa9 pour satisfaire vos besoins",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q31F6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f6: Riz",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31F5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f5: Bl\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31F4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f4: Ni\\xc3\\xa8b\\xc3\\xa9",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31F3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f3: Ma\\xc3\\xafs",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31F2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f2: Sorgho",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31F1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31F1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.f1: Mil",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31E": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31E",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.e: Disposez vous d\\'un stock de semence pour la campagne pluviale",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q31.d: Combien de mois pensez-vous que votre stock ou approvisionnement permettr",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q31C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.c : Pensez vous que votre stock et vos moyens sont suffisants pour vos besoi",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.b: Disposez vous encore aujourd\\'hui  des  moyens",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q31A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q31A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q31.a: Disposez-vous encore aujourd\\'hui de stocks?",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q30B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Q30.b:  Si Q30a = 3: Cause principale",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q30A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q30A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q30.a: Par rapport \\xc3\\xa0 la campagne agricole pluviale de 2013  niveau recolte 2014",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q29": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q29",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Mauvaise",
                                    "long_name": "Q29: Comment jugez-vous la derni\\xc3\\xa8re campagne agricole 2014",
                                    "units": "ids",
                                    "scale_max": "3.0",
                                    "missing_value": "-999.0"
                                },
                                "Q28": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q28",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non applicable",
                                    "long_name": "Q28: Comment ont \\xc3\\xa9volu\\xc3\\xa9 les superficies cultiv\\xc3\\xa9es",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q27B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q27.b: La superficie total des champs/jardins en hectares",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q27.a: Si oui, combien de champs/jardins exploit\\xc3\\xa9s",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q27": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q27",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Q27: Exploitation des champs/jardins campagne agricole pass\\xc3\\xa9e",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q26A9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Canards/Oies",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Pintades",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Poules/coqs",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Equins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Asins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Camelins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Caprins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Ovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Autres",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Pigeons",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Si oui, nombre de Bovins",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q26": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q26",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Le m\\xc3\\xa9nage poss\\xc3\\xa8de t-il des aminaux",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q25C9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 9. V\\xc3\\xa9lo: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 8. Cyclomoteur: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 7. Petit outillage agricole: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 6. Appareil TV/Accessoires : Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 5. T\\xc3\\xa9l\\xc3\\xa9phone portable: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 4. Machine \\xc3\\xa0 coudre: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 3. Fer \\xc3\\xa0 repasser: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 2. Bijoux de valeur (or,argent): Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 14. Autres: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 13. Unit\\xc3\\xa9 de culture attel\\xc3\\xa9e: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 12. Voiture: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 11. Motopompe: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 10. Charrette: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Biens du m\\xc3\\xa9nage: 1. Meubles: Nombre",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q25B9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 9. V\\xc3\\xa9lo: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B8": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B8",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 8. Cyclomoteur : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B7": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B7",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 7. Petit outillage agricole: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B6": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B6",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 6. Appareil TV/Accessoires: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 5. T\\xc3\\xa9l\\xc3\\xa9phone portable: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 4. Machine \\xc3\\xa0 coudre: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 3. Fer \\xc3\\xa0 repasser: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 2. Bijoux de valeur (or, argent): Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 14. Autres: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 13. Unit\\xc3\\xa9 de culture attel\\xc3\\xa9e: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 12. Voiture: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 11. Motopompe: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 10. Charrette : Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q25B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q25B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Non",
                                    "long_name": "Biens du m\\xc3\\xa9nage: 1. Meubles: Oui/Non",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                },
                                "Q24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Ciments/b\\xc3\\xa9ton",
                                    "long_name": "La nature principale des murs du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "1.0",
                                    "missing_value": "-999.0"
                                },
                                "Q23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La nature principale du toit du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "Le statut d\\'occupation du logement du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9clairage  pour votre  m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "7.0",
                                    "missing_value": "-999.0"
                                },
                                "Q21A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q21A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre",
                                    "long_name": "La principale source d\\'\\xc3\\xa9nergie pour la cuisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "Le principal type de toilette qu\\'utilise le m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autre \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale source d\\'eau de boisson du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "Q18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres \\xc3\\xa0 pr\\xc3\\xa9ciser",
                                    "long_name": "La principale activit\\xc3\\xa9 du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "11.0",
                                    "missing_value": "-999.0"
                                },
                                "Q17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "C\\xc3\\xa9libataire",
                                    "long_name": "Statut matrimonial du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "5.0",
                                    "missing_value": "-999.0"
                                },
                                "Q16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Age du chef de m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "F\\xc3\\xa9minin",
                                    "long_name": "Sexe du chef de m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "2.0",
                                    "missing_value": "-999.0"
                                }
                            },
                            "Section01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Q14C3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14C3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14C2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14C2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribution au revenu total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14C1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14C1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La troisi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14B3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14B3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14B2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14B2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage : contribution au revenu total",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14B1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14B1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La deuxi\\xc3\\xa8me source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14A3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14A3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage :montant moyen tir\\xc3\\xa9",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14A2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14A2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage: contribution au revenu total e",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q14A1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14A1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Autres",
                                    "long_name": "La premi\\xc3\\xa8re source de revenu mon\\xc3\\xa9taire du m\\xc3\\xa9nage",
                                    "units": "ids",
                                    "scale_max": "15.0",
                                    "missing_value": "-999.0"
                                },
                                "Q14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Combien de sources de revenu mon\\xc3\\xa9taire le m\\xc3\\xa9nage dispose t-il",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            },
                            "Section00": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Section00",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "taille": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taille",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Taille du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q9": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q9",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Code enqu\\xc3\\xaateur",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q13D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q13D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre total des membres actifs dans le m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q13C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q13C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de 6 \\xc3\\xa0 23 mois",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q13B": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q13B",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nombre d\\'enfants de moins de 5 ans",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q11M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Mois de passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q11J": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11J",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Jour de passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q11A": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q11A",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ann\\xc3\\xa9e de passage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Code chef d\\'\\xc3\\xa9quipe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro du m\\xc3\\xa9nage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la ZD",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Num\\xc3\\xa9ro de la grappe",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Commune",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Q02",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "Q01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "Niamey",
                                    "long_name": "R\\xc3\\xa9gion",
                                    "units": "ids",
                                    "scale_max": "8.0",
                                    "missing_value": "-999.0"
                                },
                                "PONDMEN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PONDMEN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ponderation menage",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "PONDIND": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PONDIND",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Ponderation individu",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                },
                                "ISA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ISA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "1.0",
                                    "CLIST": "En s\\xc3\\xa9curit\\xc3\\xa9",
                                    "long_name": "Classe ins\\xc3\\xa9curit\\xc3\\xa9 alimentaire",
                                    "units": "ids",
                                    "scale_max": "4.0",
                                    "missing_value": "-999.0"
                                },
                                "DEP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DEP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Departement",
                                    "missing_value": "-999.0",
                                    "units": "unitless"
                                }
                            }
                        },
                        "hh_05": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh_05",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "hh_04": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh_04",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "hh_03": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh_03",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "hh_02": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh_02",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "hh_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "hh": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hh",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "Households"
                        },
                        "dir": "SOURCES/UN/WFP/VAM/CFSVA/Niger"
                    },
                    "Senegal": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Senegal",
                        "restriction": "Public",
                        "EFSA201802": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/EFSA201802",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "EFSA201802",
                            "restriction": "requires dlauth tokens"
                        },
                        "ENSAN2013v3": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/ENSAN2013v3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ENSAN2013v3",
                            "restriction": "requires dlauth tokens"
                        },
                        "ENSAR2019": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/ENSAR2019",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ENSAR2019",
                            "restriction": "requires dlauth tokens"
                        },
                        "ENSAS2016": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/ENSAS2016",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ENSAS2016",
                            "restriction": "requires dlauth tokens"
                        },
                        "ERASAN2014": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/ERASAN2014",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ERASAN2014",
                            "restriction": "requires dlauth tokens"
                        },
                        "Features": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Features",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SN_LHZ_2015description": "Senegal Livelihood Zones 2015 from WFP VAM",
                                "Conventions": "IRIDL"
                            },
                            "SN_LHZ_2015": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SN_LHZ_2015",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "lznum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lznum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Liveliood Zone Number",
                                    "units": "unitless",
                                    "PGtype": "int2"
                                },
                                "lznamefr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lznamefr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Nom des Zones de Moyen d\\'Existence",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "lznameen": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lznameen",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Livelihood Zone Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "lzcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lzcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Livlihood Zone Code",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "fnid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fnid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "FN ID",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "eff_year": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eff_year",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Effective Year",
                                    "units": "unitless",
                                    "PGtype": "int2"
                                },
                                "country": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "country",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Country",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "_class": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "class",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Class",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                }
                            },
                            "gid": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gid",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/Features"
                        },
                        "grouped": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "grouped",
                            "restriction": "Public",
                            "Arrondissement": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Arrondissement",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by Arrondissement",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pGCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pGCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion of hh per GCA",
                                    "scale_min": "0.0",
                                    "scale_max": "100.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "ncolor": "254",
                                    "colormap": "12632256",
                                    "colorscalename": "rainbowcolorscale",
                                    "maxncolor": "256",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "GCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "id_3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "id_3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/Arrondissement"
                            },
                            "Commune": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Commune",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by Commune",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pGCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pGCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion of hh per GCA",
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "ncolor": "254",
                                    "colormap": "12632256",
                                    "colorscalename": "rainbowcolorscale",
                                    "maxncolor": "256",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "GCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "id_4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "id_4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/Commune"
                            },
                            "Department": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Department",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by Department",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pGCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pGCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion of hh per GCA",
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "ncolor": "254",
                                    "colormap": "12632256",
                                    "colorscalename": "rainbowcolorscale",
                                    "maxncolor": "256",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "GCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "id_2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "id_2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/Department"
                            },
                            "Region": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Region",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by Region",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pGCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pGCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion of hh per GCA",
                                    "scale_min": "0.0",
                                    "scale_max": "100.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "ncolor": "254",
                                    "colormap": "12632256",
                                    "colorscalename": "rainbowcolorscale",
                                    "maxncolor": "256",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "GCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "id_1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "id_1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/Region"
                            },
                            "SN_LHZ_2015": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SN_LHZ_2015",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by livelihood zones 2015",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pGCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pGCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Proportion of hh per GCA",
                                    "scale_min": "0.0",
                                    "scale_max": "100.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "ncolor": "254",
                                    "colormap": "12632256",
                                    "colorscalename": "rainbowcolorscale",
                                    "maxncolor": "256",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Label",
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "GCA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GCA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "gid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/SN_LHZ_2015"
                            },
                            "Zonage_PAM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Zonage_PAM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "description": "Survey data aggregated by livelihood zones",
                                    "Conventions": "IRIDL"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zones geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "pdadt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pdadt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "100.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "100",
                                    "long_name": "Part des d\\xc3\\xa9penses alimentairs sur d\\xc3\\xa9penses totales",
                                    "units": "percent",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "FCS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "112.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "112",
                                    "long_name": "Food Consumption Score",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "CSI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CSI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "56.0",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "56",
                                    "long_name": "Coping Strategy Index",
                                    "history": "Averaged over hhid[0.5, 10333.5] minimum 0.0% data present",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "standard_name": "time",
                                    "pointwidth": "1.0",
                                    "calendar": "360"
                                },
                                "gid": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gid",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/grouped/Zonage_PAM"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "Arrondissement",
                                "Commune",
                                "Department",
                                "Region",
                                "SN_LHZ_2015",
                                "Zonage_PAM"
                            ]
                        },
                        "y2011": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/UN/WFP/VAM/CFSVA/Senegal/y2011",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "y2011",
                            "restriction": "requires dlauth tokens"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "EFSA201802",
                            "ENSAN2013v3",
                            "ENSAR2019",
                            "ENSAS2016",
                            "ERASAN2014",
                            "Features",
                            "grouped",
                            "y2011"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Niger",
                        "Senegal"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CFSVA"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "Philippines",
                "VAM"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "FAO",
            "WFP"
        ]
    },
    "UNAM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UNAM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "griddedmonthlyv0705long_name": "Version Released May 2007",
            "griddedmonthlyv0705description": " for the Cressman analysis, from the Centro de Ciencias de la Atm&#243;sfera",
            "griddedmonthlyv0705dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UNAM/.gridded.monthly.v0705.dataset_documentation.html",
            "griddedmonthlyv0705iridlhasSemantics": "iriref:Mendez_M",
            "griddedmonthlyv0602iridlhasSemantics": "iriref:Mendez_M",
            "griddedCCA_home": "http://dragon.dgsca.unam.mx/cca/",
            "griddeddescription": "Gridded data from the Centro de Ciencias de la Atm&#243;sfera",
            "description": "Universidad Nacional Aut&#243;noma de M&#233;xico",
            "iridlhasSemantics": "UNAM",
            "Conventions": "IRIDL"
        },
        "gridded": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gridded",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v0705": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v0705",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Minimum Temperature",
                        "missing_value": "-999.90002"
                    },
                    "tmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "long_name": "Maximum Temperature",
                        "missing_value": "-999.90002"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "maxncolor": "254",
                        "colormap": "341760",
                        "scale_max": "500.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "500",
                        "colorscalename": "prcp_0to500_colors",
                        "long_name": "Precipitation",
                        "missing_value": "-999.90002"
                    }
                },
                "v0602": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v0602",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "maxncolor": "254",
                        "colormap": "1989150",
                        "scale_max": "22.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "22",
                        "long_name": "Monthly Precipitation",
                        "missing_value": "-99.989998"
                    }
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1",
            "standard_name": "time",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/UNAM"
    },
    "UNH": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "UNH",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CSRCRivDISlong_name": "Global River Discharge (RivDIS) ",
            "CSRCRivDISreferences": "Vorosmarty_etal1998",
            "CSRCRivDISdescription": "Monthly averaged river discharge measurements",
            "CSRCRivDISdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.UNH/.CSRC.RivDIS.dataset_documentation.html",
            "CSRCdescription": "Complex Systems Research Center",
            "description": "University of New Hampshire",
            "iridlhasSemantics": "iridl:UNH",
            "Conventions": "IRIDL"
        },
        "CSRC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CSRC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RivDIS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RivDIS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "station": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "station",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Station Name",
                    "units": "unitless"
                },
                "river": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "river",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "River",
                    "units": "unitless"
                },
                "reliable": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "reliable",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Data_Reliability",
                    "units": "unitless"
                },
                "reason": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "reason",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Reliability_Reason",
                    "units": "unitless"
                },
                "ocean": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ocean",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Ocean",
                    "units": "unitless"
                },
                "nxtpnt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "nxtpnt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99999",
                    "long_name": "Next_Point",
                    "units": "unitless"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Longitude",
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Latitude",
                    "units": "degree_north"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "long_name": "Elevation",
                    "missing_value": "-99999"
                },
                "dischrg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dischrg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "[m^3][s^-1]",
                    "long_name": "Discharge",
                    "missing_value": "-99999.0"
                },
                "country": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "country",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Country",
                    "units": "unitless"
                },
                "cont": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cont",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Continent",
                    "units": "unitless"
                },
                "basn_stn": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "basn_stn",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Basin-STN",
                    "units": "unitless"
                },
                "basin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "basin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Basin-UNESCO",
                    "units": "unitless"
                },
                "area": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "area",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99999",
                    "units": "km^2"
                }
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "0",
            "long_name": "Time",
            "calendar": "360"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "long_name": "Station_ID"
        },
        "dir": "SOURCES/UNH"
    },
    "USGS": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/USGS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "USGS",
        "restriction": "Public",
        "ADDS": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/USGS/ADDS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ADDS",
            "restriction": "Public",
            "NDVI": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/USGS/ADDS/NDVI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "NDVI",
                "restriction": "Public",
                "NDVIe": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NDVIe",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dekadalSTAiridlhasSemantics": "iridl:climatology",
                        "dekadalSTAConventions": "CF-1.0",
                        "dekadalmaximumreferences": "Tucker_etal2005",
                        "dekadalmaximumNDVIrg": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.ADDS/.NDVI/.NDVIrg/.dekadal/.maximum/",
                        "dekadalmaximumConventions": "CF-1.0",
                        "dekadalLTAiridlhasSemantics": "iridl:climatology",
                        "dekadalLTAConventions": "CF-1.0",
                        "references": "Tucker_etal2005",
                        "NDVIrg": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.ADDS/.NDVI/.NDVIrg/.dekadal/.maximum/",
                        "Conventions": "IRIDL"
                    },
                    "dekadal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "STA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "STA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "false_easting": "0",
                                "units": "unitless",
                                "latitude_of_projection_origin": "1",
                                "longitude_of_central_meridian": "20.0",
                                "standard_parallel": "-19.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "false_northing": "0"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "1",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "long_name": "Normalized Difference Vegetation Index",
                                "grid_mapping": "Projection",
                                "standard_name": "normalized_difference_vegetation_index",
                                "SpatialReferenceSystemDims": "y",
                                "iridlhasSemantics": "iridl:NDVI",
                                "units": "unitless",
                                "parallel1": "-19.0",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "dy": "8000.0",
                                "y_center": "576.0",
                                "x_center": "576.0",
                                "title": " asm011nd",
                                "projection": "ALBERS EQUAL-AREA CONIC",
                                "image_type": "-56",
                                "long_center": "20.0",
                                "lat_center": "1.0",
                                "parallel2": "21.0",
                                "dx": "8000.0"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        },
                        "maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "false_easting": "0",
                                "units": "unitless",
                                "latitude_of_projection_origin": "1",
                                "longitude_of_central_meridian": "20.0",
                                "standard_parallel": "-19.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "false_northing": "0"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "1.0",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "standard_name": "normalized_difference_vegetation_index",
                                "long_name": "Normalized Difference Vegetation Index",
                                "grid_mapping": "Projection",
                                "SpatialReferenceSystemDims": "y",
                                "iridlhasSemantics": "iridl:NDVI",
                                "units": "unitless",
                                "parallel1": "-19.0",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "dy": "8000.0",
                                "y_center": "576.0",
                                "x_center": "576.0",
                                "title": " ac810701",
                                "projection": "ALBERS EQUAL-AREA CONIC",
                                "image_type": "-56",
                                "long_center": "20.0",
                                "lat_center": "1.0",
                                "parallel2": "21.0",
                                "dx": "8000.0"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        },
                        "LTA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "LTA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "false_easting": "0",
                                "units": "unitless",
                                "latitude_of_projection_origin": "1",
                                "longitude_of_central_meridian": "20.0",
                                "standard_parallel": "-19.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "false_northing": "0"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "1",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "long_name": "Normalized Difference Vegetation Index",
                                "grid_mapping": "Projection",
                                "standard_name": "normalized_difference_vegetation_index",
                                "SpatialReferenceSystemDims": "y",
                                "iridlhasSemantics": "iridl:NDVI",
                                "units": "unitless",
                                "parallel1": "-19.0",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "dy": "8000.0",
                                "y_center": "576.0",
                                "x_center": "576.0",
                                "title": " alm011nd",
                                "projection": "ALBERS EQUAL-AREA CONIC",
                                "image_type": "-56",
                                "long_center": "20.0",
                                "lat_center": "1.0",
                                "parallel2": "21.0",
                                "dx": "8000.0",
                                "modulus": "365.0",
                                "modulo": "365.0"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        }
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "x_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_x_coordinate"
                    },
                    "y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_y_coordinate"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "365.0",
                        "calendar": "365",
                        "modulo": "365.0"
                    },
                    "x": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_x_coordinate"
                    },
                    "y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_y_coordinate"
                    },
                    "dir": "SOURCES/USGS/ADDS/NDVI/NDVIe"
                },
                "NDVIg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NDVIg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthlysd8204long_name": "1982-2004 standard deviation",
                        "monthlysd8204description": "1982-2004 standard deviation of monthly maximum NDVIg data",
                        "monthlysd8204Conventions": "CF-1.0",
                        "monthlyc8204long_name": "1982-2004 climatology",
                        "monthlyc8204description": "1982-2004 climatology of monthly NDVIg data",
                        "monthlyc8204Conventions": "CF-1.0",
                        "dekadalSTAiridlhasSemantics": "iridl:climatology",
                        "dekadalSTAConventions": "CF-1.0",
                        "dekadalmaximumConventions": "CF-1.0",
                        "dekadalLTAiridlhasSemantics": "iridl:climatology",
                        "dekadalLTAConventions": "CF-1.0",
                        "dekadalreferences": "Tucker_etal2005",
                        "dekadaldescription": "Dekadal NDVIg data from FEWS/ADDS",
                        "dekadalsource": "http://earlywarning.usgs.gov/fews/africa/web/datatheme.php",
                        "references": "Tucker_etal2005",
                        "Conventions": "IRIDL"
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sd8204": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sd8204",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "sdNDVImonmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sdNDVImonmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "1982-2004 SD of Monthly Maximum NDVI",
                                "missing_value": "99999.0",
                                "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                "colormap": "2304",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "grid_mapping": "Projection",
                                "standard_name": "normalized_difference_vegetation_index",
                                "iridlhasSemantics": "iridl:NDVI",
                                "units": "unitless"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        },
                        "c8204": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8204",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            },
                            "avgNDVImonmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "avgNDVImonmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "1982-2004 Avg. of Monthly Maximum NDVI",
                                "missing_value": "99999.0",
                                "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                "colormap": "2304",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "grid_mapping": "Projection",
                                "standard_name": "normalized_difference_vegetation_index",
                                "iridlhasSemantics": "iridl:NDVI",
                                "units": "unitless"
                            }
                        }
                    },
                    "dekadal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "STA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "STA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "longitude_of_central_meridian": "20.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "standard_parallel": "-19.0",
                                "false_northing": "0",
                                "false_easting": "0",
                                "latitude_of_projection_origin": "1"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "1.0",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "SpatialReferenceSystemDims": "y",
                                "long_name": "Normalized Difference Vegetation Index",
                                "standard_name": "normalized_difference_vegetation_index",
                                "grid_mapping": "Projection",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "units": "unitless"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        },
                        "maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "longitude_of_central_meridian": "20.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "standard_parallel": "-19.0",
                                "false_northing": "0",
                                "false_easting": "0",
                                "latitude_of_projection_origin": "1"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "1.0",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "grid_mapping": "Projection",
                                "long_name": "Normalized Difference Vegetation Index",
                                "SpatialReferenceSystemDims": "y",
                                "standard_name": "normalized_difference_vegetation_index",
                                "iridlhasSemantics": "iridl:NDVI",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "units": "unitless"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        },
                        "LTA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "LTA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Projection": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Projection",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "longitude_of_central_meridian": "20.0",
                                "grid_mapping_name": "albers_conical_equal_area",
                                "standard_parallel": "-19.0",
                                "false_northing": "0",
                                "false_easting": "0",
                                "latitude_of_projection_origin": "1"
                            },
                            "NDVI": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NDVI",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2304",
                                "scale_max": "1.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0.0",
                                "CE": "1.0",
                                "missing_value": "NaN",
                                "valid_max": "0.999984",
                                "valid_min": "0.0",
                                "SpatialReferenceSystemDims": "y",
                                "long_name": "Normalized Difference Vegetation Index",
                                "standard_name": "normalized_difference_vegetation_index",
                                "grid_mapping": "Projection",
                                "SpatialReferenceSystemWKT": ",1]]",
                                "units": "unitless",
                                "modulus": "365.0",
                                "modulo": "365.0"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "standard_name": "longitude",
                                "scale_max": "65.0",
                                "scale_min": "-24.0"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "standard_name": "latitude",
                                "scale_max": "45.0",
                                "scale_min": "-40.0"
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "calendar": "360",
                        "modulo": "12.0",
                        "pointwidth": "1.0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "365.0",
                        "calendar": "365",
                        "modulo": "365.0"
                    },
                    "x": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_x_coordinate"
                    },
                    "y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_y_coordinate"
                    },
                    "dir": "SOURCES/USGS/ADDS/NDVI/NDVIg"
                },
                "NDVIrg": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/USGS/ADDS/NDVI/NDVIrg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "NDVIrg",
                    "restriction": "Public",
                    "dekadal": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/USGS/ADDS/NDVI/NDVIrg/dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "dekadal",
                        "restriction": "Public",
                        "maximum": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/USGS/ADDS/NDVI/NDVIrg/dekadal/maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "maximum",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "maximum"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "dekadal"
                    ]
                },
                "dekadal": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dekadal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "STAiridlhasSemantics": "iridl:climatology",
                        "STAConventions": "CF-1.0",
                        "maximumreferences": "Tucker_etal2005",
                        "maximumNDVIrg": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.ADDS/.NDVI/.NDVIrg/.dekadal/.maximum/",
                        "maximumConventions": "CF-1.0",
                        "LTAiridlhasSemantics": "iridl:climatology",
                        "LTAConventions": "CF-1.0",
                        "Conventions": "IRIDL"
                    },
                    "STA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Projection": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Projection",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "latitude_of_projection_origin": "1",
                            "longitude_of_central_meridian": "20.0",
                            "standard_parallel": "-19.0",
                            "grid_mapping_name": "albers_conical_equal_area",
                            "false_northing": "0",
                            "false_easting": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2304",
                            "scale_max": "1.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "1",
                            "missing_value": "NaN",
                            "valid_max": "0.999984",
                            "valid_min": "0.0",
                            "long_name": "Normalized Difference Vegetation Index",
                            "standard_name": "normalized_difference_vegetation_index",
                            "SpatialReferenceSystemDims": "y",
                            "iridlhasSemantics": "iridl:NDVI",
                            "grid_mapping": "Projection",
                            "units": "unitless",
                            "parallel1": "-19.0",
                            "SpatialReferenceSystemWKT": ",1]]",
                            "dy": "8000.0",
                            "y_center": "576.0",
                            "x_center": "576.0",
                            "title": " asm011nd",
                            "projection": "ALBERS EQUAL-AREA CONIC",
                            "image_type": "-56",
                            "long_center": "20.0",
                            "lat_center": "1.0",
                            "parallel2": "21.0",
                            "dx": "8000.0"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "standard_name": "longitude",
                            "scale_max": "65.0",
                            "scale_min": "-24.0"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "standard_name": "latitude",
                            "scale_max": "45.0",
                            "scale_min": "-40.0"
                        }
                    },
                    "maximum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "maximum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Projection": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Projection",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "latitude_of_projection_origin": "1",
                            "longitude_of_central_meridian": "20.0",
                            "standard_parallel": "-19.0",
                            "grid_mapping_name": "albers_conical_equal_area",
                            "false_northing": "0",
                            "false_easting": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2304",
                            "scale_max": "1.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "1.0",
                            "missing_value": "NaN",
                            "valid_max": "0.999984",
                            "valid_min": "0.0",
                            "long_name": "Normalized Difference Vegetation Index",
                            "standard_name": "normalized_difference_vegetation_index",
                            "SpatialReferenceSystemDims": "y",
                            "iridlhasSemantics": "iridl:NDVI",
                            "grid_mapping": "Projection",
                            "units": "unitless",
                            "parallel1": "-19.0",
                            "SpatialReferenceSystemWKT": ",1]]",
                            "dy": "8000.0",
                            "y_center": "576.0",
                            "x_center": "576.0",
                            "title": " ac810701",
                            "projection": "ALBERS EQUAL-AREA CONIC",
                            "image_type": "-56",
                            "long_center": "20.0",
                            "lat_center": "1.0",
                            "parallel2": "21.0",
                            "dx": "8000.0"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "standard_name": "longitude",
                            "scale_max": "65.0",
                            "scale_min": "-24.0"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "standard_name": "latitude",
                            "scale_max": "45.0",
                            "scale_min": "-40.0"
                        }
                    },
                    "LTA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LTA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Projection": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Projection",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "latitude_of_projection_origin": "1",
                            "longitude_of_central_meridian": "20.0",
                            "standard_parallel": "-19.0",
                            "grid_mapping_name": "albers_conical_equal_area",
                            "false_northing": "0",
                            "false_easting": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "2304",
                            "scale_max": "1.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "1",
                            "missing_value": "NaN",
                            "valid_max": "0.999984",
                            "valid_min": "0.0",
                            "long_name": "Normalized Difference Vegetation Index",
                            "standard_name": "normalized_difference_vegetation_index",
                            "SpatialReferenceSystemDims": "y",
                            "iridlhasSemantics": "iridl:NDVI",
                            "grid_mapping": "Projection",
                            "units": "unitless",
                            "parallel1": "-19.0",
                            "SpatialReferenceSystemWKT": ",1]]",
                            "dy": "8000.0",
                            "y_center": "576.0",
                            "x_center": "576.0",
                            "title": " alm011nd",
                            "projection": "ALBERS EQUAL-AREA CONIC",
                            "image_type": "-56",
                            "long_center": "20.0",
                            "lat_center": "1.0",
                            "parallel2": "21.0",
                            "dx": "8000.0",
                            "modulus": "365.0",
                            "modulo": "365.0"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "standard_name": "longitude",
                            "scale_max": "65.0",
                            "scale_min": "-24.0"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "standard_name": "latitude",
                            "scale_max": "45.0",
                            "scale_min": "-40.0"
                        }
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "x_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_x_coordinate"
                    },
                    "y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_y_coordinate"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "365.0",
                        "calendar": "365",
                        "modulo": "365.0"
                    },
                    "x": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "x",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_x_coordinate"
                    },
                    "y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "8000.0",
                        "standard_name": "projection_y_coordinate"
                    },
                    "dir": "SOURCES/USGS/ADDS/NDVI/dekadal"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "NDVIe",
                    "NDVIg",
                    "NDVIrg",
                    "dekadal"
                ]
            },
            "NOAA16_calib": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA16_calib",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v3monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.ADDS/.NOAA16_calib/.v3.monthly.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "v3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "long_name": "Normalized Difference Vegetation Index",
                            "description": "Reprojected and recomposited (to monthly) NOAA-16 NDVI data for Africa",
                            "valid_min": "0",
                            "scale_factor": "0.004",
                            "valid_max": "250",
                            "pointwidth": "1.0",
                            "standard_name": "time",
                            "calendar": "360"
                        }
                    }
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/USGS/ADDS/NOAA16_calib"
            },
            "WRSI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WRSI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.ADDS/.WRSI/.dataset_documentation.html",
                    "Conventions": "CF-1.0"
                },
                "South_Africa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "South_Africa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "grid_mapping": "Projection",
                    "iridlhasSemantics": "irigaz:Africa_Southern_306_0",
                    "SpatialReferenceSystemDims": "y",
                    "colormap": "12632256",
                    "scale_max": "100.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "units": "percent",
                    "parallel1": "-19.0",
                    "SpatialReferenceSystemWKT": ",1]]",
                    "dy": "8000.0",
                    "y_center": "575.5",
                    "x_center": "575.5",
                    "title": "Process Import Binary                                                           ",
                    "valid_min": "1",
                    "projection": "ALBERS EQUAL-AREA CONIC",
                    "image_type": "GENERIC",
                    "long_center": "20.0",
                    "lat_center": "1.0",
                    "parallel2": "21.0",
                    "dx": "8000.0",
                    "valid_max": "100",
                    "pointwidth": "12.0"
                },
                "Sahel": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sahel",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "grid_mapping": "Projection",
                    "iridlhasSemantics": "irigaz:Africa_Sahelian_316_0",
                    "SpatialReferenceSystemDims": "y",
                    "colormap": "12632256",
                    "scale_max": "100.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "units": "percent",
                    "parallel1": "-19.0",
                    "SpatialReferenceSystemWKT": ",1]]",
                    "dy": "8000.0",
                    "y_center": "575.5",
                    "x_center": "575.5",
                    "title": "Process Import Binary                                                           ",
                    "valid_min": "1",
                    "projection": "ALBERS EQUAL-AREA CONIC",
                    "image_type": "GENERIC",
                    "long_center": "20.0",
                    "lat_center": "1.0",
                    "parallel2": "21.0",
                    "dx": "8000.0",
                    "valid_max": "100",
                    "pointwidth": "12.0"
                },
                "Projection": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Projection",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "latitude_of_projection_origin": "1",
                    "units": "unitless",
                    "longitude_of_central_meridian": "20.0",
                    "standard_parallel": "-19.0",
                    "grid_mapping_name": "albers_conical_equal_area",
                    "false_northing": "0",
                    "false_easting": "0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "standard_name": "longitude",
                    "scale_max": "65.0",
                    "scale_min": "-24.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "standard_name": "latitude",
                    "scale_max": "45.0",
                    "scale_min": "-40.0"
                },
                "East_Africa_MayNov": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "East_Africa_May-Nov",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "grid_mapping": "Projection",
                    "iridlhasSemantics": "irigaz:Africa_East_303_0",
                    "SpatialReferenceSystemDims": "y",
                    "colormap": "12632256",
                    "scale_max": "100.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "units": "percent",
                    "parallel1": "-19.0",
                    "SpatialReferenceSystemWKT": ",1]]",
                    "dy": "8000.0",
                    "y_center": "575.5",
                    "x_center": "575.5",
                    "title": "Process Import Binary                                                           ",
                    "valid_min": "1",
                    "projection": "ALBERS EQUAL-AREA CONIC",
                    "image_type": "GENERIC",
                    "long_center": "20.0",
                    "lat_center": "1.0",
                    "parallel2": "21.0",
                    "dx": "8000.0",
                    "valid_max": "100",
                    "pointwidth": "12.0"
                },
                "East_Africa_MarMay": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "East_Africa_Mar-May",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "grid_mapping": "Projection",
                    "iridlhasSemantics": "irigaz:Africa_East_303_0",
                    "SpatialReferenceSystemDims": "y",
                    "colormap": "12632256",
                    "scale_max": "100.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "100",
                    "units": "percent",
                    "parallel1": "-19.0",
                    "SpatialReferenceSystemWKT": ",1]]",
                    "dy": "8000.0",
                    "y_center": "575.5",
                    "x_center": "575.5",
                    "title": "Process Import Binary                                                           ",
                    "valid_min": "1",
                    "projection": "ALBERS EQUAL-AREA CONIC",
                    "image_type": "GENERIC",
                    "long_center": "20.0",
                    "lat_center": "1.0",
                    "parallel2": "21.0",
                    "dx": "8000.0",
                    "valid_max": "100",
                    "pointwidth": "12.0"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "12.0"
                },
                "x_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "x_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "8000.0",
                    "standard_name": "projection_x_coordinate"
                },
                "y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "8000.0",
                    "standard_name": "projection_y_coordinate"
                },
                "x": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "x",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "8000.0",
                    "standard_name": "projection_x_coordinate"
                },
                "y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "gridtype": "0",
                    "pointwidth": "8000.0",
                    "standard_name": "projection_y_coordinate"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "12.0",
                    "standard_name": "time"
                },
                "dir": "SOURCES/USGS/ADDS/WRSI"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "NDVI",
                "NOAA16_calib",
                "WRSI"
            ]
        },
        "CHARM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CHARM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Conventions": "IRIDL"
            },
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "est_prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "est_prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "colormap": "14053594",
                    "scale_max": "1200",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0",
                    "CS": "0",
                    "CE": "1200",
                    "description": "Collaborative Historical African Rainfall Model (CHARM) Rainfall Estimates",
                    "long_name": "Estimated Precipitation",
                    "missing_value": "9999",
                    "units": "mm",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "360"
                }
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.1",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "time",
                "calendar": "360"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "pointwidth": "0.1",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/USGS/CHARM"
        },
        "EROS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "EROS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "LandCoverGLCCDBV2p0references": "Loveland_etal2000",
                "LandCoverGLCCDBV2p0description": "Version 2.0",
                "LandCoverGLCCDBV2p0dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.EROS/.LandCover.GLCCDB.V2p0.dataset_documentation.html",
                "LandCoverGLCCDBV2p0Home": "http://edc2.usgs.gov/glcc/globe_int.php",
                "LandCoverGLCCDBdescription": "Global Land Cover Characteristics Data Base",
                "description": "Earth Resources Observation and Science",
                "Conventions": "IRIDL"
            },
            "LandCover": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LandCover",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GLCCDB": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GLCCDB",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "V2p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V2p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "_class": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "class",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16777215",
                            "scale_max": "24.0",
                            "maxncolor": "27",
                            "ncolor": "27",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "24",
                            "units": "ids",
                            "long_name": "land cover class",
                            "CLIST": "Snow or Ice",
                            "missing_value": "100",
                            "iridlhasSemantics": "iridl:LandCover"
                        }
                    }
                }
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.008333334",
                "standard_name": "latitude"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.008333334",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/USGS/EROS"
        },
        "HCDN": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "HCDN",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Hydro-Climate Data Network",
                "references": "Slack_Landwehr1992",
                "description": "streamflow data set for the study  of climate variations",
                "Conventions": "IRIDL",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.HCDN/.dataset_documentation.html"
            },
            "State": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "State",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "CLIST": "WY"
            },
            "region": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "region",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "NGVD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NGVD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "long_name": "National Geodetic Vertical Datun of 1929",
                "missing_value": "-99.0"
            },
            "NCdrainage": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCdrainage",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Non-contributing drainage area",
                "units": "unitless"
            },
            "Name": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Name",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "flow": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "flow",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "cf/s",
                    "long_name": "stream flow",
                    "missing_value": "-99999.0"
                }
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "scale_max": "-50.0",
                "long_name": "longitude",
                "scale_min": "-230.0"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "scale_max": "71.5",
                "long_name": "latitude",
                "scale_min": "-14.5"
            },
            "HUC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "HUC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "drainage": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "drainage",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "drainage area",
                "units": "unitless"
            },
            "District": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "District",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "CLIST": "WY"
            },
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "flow": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "flow",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "cf/s",
                    "long_name": "stream flow",
                    "missing_value": "-99999.0"
                }
            },
            "County": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "County",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "calendar": "360"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "pointwidth": "1.0",
                "long_name": "time",
                "add_offset": "2405432",
                "calendar": "standard"
            },
            "ISTA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ISTA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2"
            },
            "dir": "SOURCES/USGS/HCDN"
        },
        "LandDAAC": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/USGS/LandDAAC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "LandDAAC",
            "restriction": "Public",
            "MODIS": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/USGS/LandDAAC/MODIS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "MODIS",
                "restriction": "Public",
                "km": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "1km",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dayversion_005TerraSSANightlong_name": "Southern_South_America_night",
                        "dayversion_005TerraSSANightiridlhasSemantics": "irigaz:South_America_366_0",
                        "dayversion_005TerraSSADaylong_name": "Southern_South_America_day",
                        "dayversion_005TerraSSADayiridlhasSemantics": "irigaz:South_America_366_0",
                        "dayversion_005TerraSSAdescription": "Day and Night Land Surface Temperature of Southern South America",
                        "dayversion_005TerraNYNightlong_name": "New_York_night",
                        "dayversion_005TerraNYNightiridlhasSemantics": "irigaz:New_York_2314_2",
                        "dayversion_005TerraNYDaylong_name": "New_York_day",
                        "dayversion_005TerraNYDayiridlhasSemantics": "irigaz:New_York_2314_2",
                        "dayversion_005TerraNYdescription": "Day and Night Land Surface Temperature of New York",
                        "dayversion_005TerraNSANightlong_name": "Northern_South_America_night",
                        "dayversion_005TerraNSANightiridlhasSemantics": "irigaz:South_America_366_0",
                        "dayversion_005TerraNSADaylong_name": "Northern_South_America_day",
                        "dayversion_005TerraNSADayiridlhasSemantics": "irigaz:South_America_366_0",
                        "dayversion_005TerraNSAdescription": "Day and Night Land Surface Temperature of Northern South America",
                        "dayversion_005Terradescription": "8-day composite Terra observation",
                        "dayversion_005AquaWAFNightlong_name": "WestAfrica_night",
                        "dayversion_005AquaWAFNightiridlhasSemantics": "irigaz:Africa_West_302_0",
                        "dayversion_005AquaWAFDaylong_name": "WestAfrica_day",
                        "dayversion_005AquaWAFDayiridlhasSemantics": "irigaz:Africa_West_302_0",
                        "dayversion_005AquaWAFdescription": "Day and Night Land Surface Temperature of West Africa",
                        "dayversion_005AquaSAFNightlong_name": "SouthernAfrica_night",
                        "dayversion_005AquaSAFNightiridlhasSemantics": "irigaz:Africa_Southern_306_0",
                        "dayversion_005AquaSAFDaylong_name": "SouthernAfrica_day",
                        "dayversion_005AquaSAFDayiridlhasSemantics": "irigaz:Africa_Southern_306_0",
                        "dayversion_005AquaSAFdescription": "Day and Night Land Surface Temperature of Southern Africa",
                        "dayversion_005AquaEAFNightlong_name": "EastAfrica_night",
                        "dayversion_005AquaEAFNightiridlhasSemantics": "irigaz:Africa_East_303_0",
                        "dayversion_005AquaEAFDaylong_name": "EastAfrica_day",
                        "dayversion_005AquaEAFDayiridlhasSemantics": "irigaz:Africa_East_303_0",
                        "dayversion_005AquaEAFdescription": "Day and Night Land Surface Temperature of East Africa",
                        "dayversion_005AquaCNNightlong_name": "China_night",
                        "dayversion_005AquaCNDaylong_name": "China_day",
                        "dayversion_005AquaCNdescription": "Day and Night Land Surface Temperature of China",
                        "dayversion_005AquaASNightlong_name": "EastAsia_night",
                        "dayversion_005AquaASDaylong_name": "EastAsia_day",
                        "dayversion_005AquaASdescription": "Day and Night Land Surface Temperature of East Asia",
                        "dayversion_005Aquadescription": "8-day composite Aqua observation",
                        "dayversion_005references": "Huete_etal2002 Vancutsem_etal2010",
                        "dayversion_005iridlhasSemantics": "iridl:NASA",
                        "Conventions": "IRIDL"
                    },
                    "day": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "8day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "version_005": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version_005",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Terra": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Terra",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SSA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SSA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "NY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "NSA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NSA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            },
                            "Aqua_reconstructed": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Aqua_reconstructed",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmax_rec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax_rec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "missing_value": "NaN",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    }
                                },
                                "SAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmax_rec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax_rec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "missing_value": "NaN",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    }
                                },
                                "EAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tmax_rec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax_rec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "missing_value": "NaN",
                                        "colormap": "255",
                                        "maxncolor": "254",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "Aqua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Aqua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "SAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "EAF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16500",
                                            "scale_min": "12750",
                                            "CS": "255",
                                            "CE": "330",
                                            "colormap": "255",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "CN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "AS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Night": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Night",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "view_time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "240",
                                            "scale_min": "0",
                                            "units": "hours",
                                            "scale_factor": "0.1",
                                            "missing_value": "255",
                                            "valid_max": "240",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "view_angl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "view_angl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "130",
                                            "units": "unitless",
                                            "scale_min": "0",
                                            "missing_value": "255",
                                            "valid_max": "130",
                                            "valid_min": "0",
                                            "pointwidth": "0"
                                        },
                                        "LST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "0",
                                            "scale_factor": "0.02",
                                            "valid_max": "65535",
                                            "valid_min": "7500",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "Y_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.01064817",
                        "standard_name": "latitude"
                    },
                    "X_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.01064817",
                        "standard_name": "longitude"
                    },
                    "Y_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.01130287",
                        "standard_name": "latitude"
                    },
                    "X_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.01130286",
                        "standard_name": "longitude"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.008348919",
                        "standard_name": "latitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.008348919",
                        "standard_name": "longitude"
                    },
                    "X_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.008868163",
                        "standard_name": "longitude"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.008737757",
                        "standard_name": "latitude"
                    },
                    "X_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.008737757",
                        "standard_name": "longitude"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.008868163",
                        "standard_name": "latitude"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.008868163",
                        "standard_name": "longitude"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.01030058",
                        "standard_name": "latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.01030058",
                        "standard_name": "longitude"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.008333347",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.008333348",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/USGS/LandDAAC/MODIS/1km"
                },
                "m": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/USGS/LandDAAC/MODIS/250m",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "250m",
                    "restriction": "Public",
                    "day": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/250m/16day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "16day",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "version_005": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/250m/version_005",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "version_005",
                        "restriction": "Public",
                        "day": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/USGS/LandDAAC/MODIS/250m/version_005/16day",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "16day",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "day"
                        ]
                    },
                    "version_006": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/250m/version_006",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "version_006",
                        "restriction": "Public",
                        "day": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/USGS/LandDAAC/MODIS/250m/version_006/16day",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "16day",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "day"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "day",
                        "version_005",
                        "version_006"
                    ]
                },
                "version_004": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version_004",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WAFlong_name": "West Africa",
                        "WAFiridlhasSemantics": "irigaz:Africa_West_302_0",
                        "SWASlong_name": "South West Asia",
                        "SWASiridlhasSemantics": "irigaz:Asia_South_319_0",
                        "SSAlong_name": "Southern South America",
                        "SEASlong_name": "South East Asia",
                        "SEASiridlhasSemantics": "irigaz:Asia_Southeast_317_0",
                        "NOMADE_regiondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.LandDAAC/.MODIS/.version_004/.NOMADE_region.dataset_documentation.html",
                        "Madagascarlong_name": "Madagascar",
                        "Horn_of_AfricairidlhasSemantics": "irigaz:Africa_Greater_Horn_305_0",
                        "EAFlong_name": "East Africa",
                        "EAFiridlhasSemantics": "irigaz:Africa_East_303_0",
                        "references": "Huete_etal2002",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.LandDAAC/.MODIS/.version_004/.dataset_documentation.html",
                        "Conventions": "IRIDL",
                        "version_005": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.LandDAAC/.MODIS/.version_005/"
                    },
                    "WAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "WAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SWAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SWAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SSA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SSA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SEAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SEAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "NOMADE_region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NOMADE_region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "image": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "image",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        }
                    },
                    "Madagascar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Madagascar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "Horn_of_Africa": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Horn_of_Africa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "image": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "image",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        }
                    },
                    "EAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "EAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "X_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "X_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002662043",
                        "standard_name": "latitude"
                    },
                    "T_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002662043",
                        "standard_name": "longitude"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002083337",
                        "standard_name": "latitude"
                    },
                    "T_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2000-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002083337",
                        "standard_name": "longitude"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "longitude"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00219055",
                        "standard_name": "latitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.00219055",
                        "standard_name": "longitude"
                    },
                    "band_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "band_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "latitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "longitude"
                    },
                    "band": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "band",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00221704",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/USGS/LandDAAC/MODIS/version_004"
                },
                "version_005": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "version_005",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WAFlong_name": "West Africa",
                        "WAFiridlhasSemantics": "irigaz:Africa_West_302_0",
                        "SWASlong_name": "South West Asia",
                        "SWASiridlhasSemantics": "irigaz:Asia_South_319_0",
                        "SSAlong_name": "Southern South America",
                        "SSAiridlhasSemantics": "irigaz:South_America_366_0",
                        "SNAlong_name": "Southern North America",
                        "SEASlong_name": "South East Asia",
                        "SEASiridlhasSemantics": "irigaz:Asia_Southeast_317_0",
                        "SAFlong_name": "Southern Africa",
                        "SAFiridlhasSemantics": "irigaz:Africa_Southern_306_0",
                        "NSAlong_name": "Northern South America",
                        "NSAiridlhasSemantics": "irigaz:South_America_366_0",
                        "NOMADE_regiondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.LandDAAC/.MODIS/.version_005/.NOMADE_region.dataset_documentation.html",
                        "NOMADE_regioniridlhasSemantics": "irigaz:Africa_West_302_0",
                        "Madagascarlong_name": "Madagascar",
                        "MadagascariridlhasSemantics": "irigaz:Madagascar_94_1",
                        "Horn_of_AfricairidlhasSemantics": "irigaz:Africa_Greater_Horn_305_0",
                        "EAFlong_name": "East Africa",
                        "EAFiridlhasSemantics": "irigaz:Africa_East_303_0",
                        "CAlong_name": "Canada",
                        "AKlong_name": "Alaska",
                        "references": "Huete_etal2002",
                        "Conventions": "IRIDL",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USGS/.LandDAAC/.MODIS/.version_005/.dataset_documentation.html"
                    },
                    "WAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "WAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SWAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SWAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SSA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SSA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SNA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SEAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SEAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "SAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:view_zenith_angle",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:EVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "NSA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NSA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "NOMADE_region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NOMADE_region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "image": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "image",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        }
                    },
                    "Madagascar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Madagascar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:EVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "Horn_of_Africa": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Horn_of_Africa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "image": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "image",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        }
                    },
                    "EAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "EAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "CA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "AK": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AK",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "X_12": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_12",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "X_11": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_11",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "Y_09": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_09",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002662043",
                        "standard_name": "latitude"
                    },
                    "X_10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002662043",
                        "standard_name": "longitude"
                    },
                    "Y_08": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_08",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00243049",
                        "standard_name": "latitude"
                    },
                    "X_09": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_09",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.00243049",
                        "standard_name": "longitude"
                    },
                    "Y_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002083337",
                        "standard_name": "latitude"
                    },
                    "T_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2000-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_08": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_08",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002083337",
                        "standard_name": "longitude"
                    },
                    "Y_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002184439",
                        "standard_name": "latitude"
                    },
                    "X_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002184439",
                        "standard_name": "longitude"
                    },
                    "Y_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00208723",
                        "standard_name": "latitude"
                    },
                    "X_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.00208723",
                        "standard_name": "longitude"
                    },
                    "X_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "longitude"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00219055",
                        "standard_name": "latitude"
                    },
                    "X_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.00219055",
                        "standard_name": "longitude"
                    },
                    "band_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "band_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "latitude"
                    },
                    "T_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002115475",
                        "standard_name": "longitude"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.00221704",
                        "standard_name": "latitude"
                    },
                    "T_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.002217041",
                        "standard_name": "longitude"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.004408704",
                        "standard_name": "latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.004408704",
                        "standard_name": "longitude"
                    },
                    "band": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "band",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "2"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.004199726",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 2003-01-01",
                        "gridtype": "0",
                        "standard_name": "time",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.004199725",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/USGS/LandDAAC/MODIS/version_005"
                },
                "version_006": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "version_006",
                    "restriction": "Public",
                    "AK": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AK",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Alaska",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.004199726",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.004199725",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/AK"
                    },
                    "CA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Canada",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.004408704",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.004408704",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/CA"
                    },
                    "EAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "EAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "East Africa",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:Africa_East_303_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.00221704",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002217041",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/EAF"
                    },
                    "NSA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NSA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Northern South America",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:South_America_366_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.00208723",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.00208723",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/NSA"
                    },
                    "SAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Southern Africa",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:Africa_Southern_306_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:view_zenith_angle",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:EVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.002184439",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002184439",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/SAF"
                    },
                    "SEAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SEAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "South East Asia",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:Asia_Southeast_317_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.002083337",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2000-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002083337",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/SEAS"
                    },
                    "SNA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Southern North America",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.00243049",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.00243049",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/SNA"
                    },
                    "SSA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SSA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Southern South America",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:South_America_366_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.002662043",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002662043",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/SSA"
                    },
                    "SWAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SWAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "South West Asia",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:Asia_South_319_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.00221704",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002217041",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/SWAS"
                    },
                    "VNM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "VNM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Vietnam",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:view_zenith_angle",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:EVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.002161966",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002161966",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/VNM"
                    },
                    "WAF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "WAF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "West Africa",
                            "dataset_documentation": "https://lpdaac.usgs.gov/dataset_discovery/modis/modis_products_table/mod13q1_v006",
                            "expires": "1615248000",
                            "iridlhasSemantics": "irigaz:Africa_West_302_0",
                            "Conventions": "IRIDL"
                        },
                        "view_zenith_angle": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "view_zenith_angle",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_max": "9000",
                            "units": "unitless",
                            "scale_min": "-9000",
                            "missing_value": "10000",
                            "scale_factor": "0.01",
                            "valid_max": "9000",
                            "valid_min": "-9000",
                            "pointwidth": "0"
                        },
                        "VI_Quality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VI_Quality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "units": "unitless",
                            "missing_value": "65535",
                            "valid_max": "65534",
                            "valid_min": "0",
                            "pointwidth": "0"
                        },
                        "reflectance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reflectance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "254",
                            "scale_min": "0",
                            "valid_max": "254",
                            "add_offset": "1",
                            "missing_value": "255",
                            "scale_factor": "39.366142",
                            "valid_min": "0",
                            "expires": "1615248000",
                            "units": "unitless",
                            "pointwidth": "0"
                        },
                        "NDVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EVI": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EVI",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615248000",
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "band": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "band",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "pointwidth": "0.00221704",
                            "standard_name": "latitude"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 2003-01-01",
                            "gridtype": "0",
                            "standard_name": "time",
                            "calendar": "standard",
                            "expires": "1615248000"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "pointwidth": "0.002217041",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/USGS/LandDAAC/MODIS/version_006/WAF"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "AK",
                        "CA",
                        "EAF",
                        "NSA",
                        "SAF",
                        "SEAS",
                        "SNA",
                        "SSA",
                        "SWAS",
                        "VNM",
                        "WAF"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "km",
                    "m",
                    "version_004",
                    "version_005",
                    "version_006"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "MODIS"
            ]
        },
        "VCAP": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/USGS/VCAP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "VCAP",
            "restriction": "Public",
            "VCAPpdf": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/USGS/VCAP/VCAP.pdf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "VCAP.pdf",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9999.0",
                    "units": "Celsius_scale",
                    "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2004-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/USGS/VCAP/daily"
            },
            "dekad": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/USGS/VCAP/dekad",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "dekad",
                "restriction": "Public",
                "v200811": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/USGS/VCAP/dekad/v200811",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "v200811",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "v200901": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v200901",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "units": "Celsius_scale"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "standard_name": "latitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "days since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "standard"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/USGS/VCAP/dekad/v200901"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "v200811",
                    "v200901"
                ]
            },
            "eightday": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "eight-day",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "v200906": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v200906",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vcap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vcap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "8388608",
                        "scale_max": "50.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "50.0",
                        "missing_value": "-9999.0",
                        "units": "unitless",
                        "iridlhasSemantics": "iridl:Malaria",
                        "pointwidth": "0"
                    },
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "units": "Celsius_scale",
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "iridlhasSemantics": "iridl:precipitation_amount",
                        "long_name": "precipitation",
                        "units": "mm",
                        "pointwidth": "0"
                    }
                },
                "Sheffield": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sheffield",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vcap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vcap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "units": "unitless",
                        "iridlhasSemantics": "iridl:Malaria",
                        "pointwidth": "0"
                    },
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colormap": "255",
                        "scale_max": "40.0",
                        "ncolor": "254",
                        "scale_min": "-40.0",
                        "CS": "-40",
                        "colorscalename": "temp_colors",
                        "CE": "40",
                        "missing_value": "-9999.0",
                        "units": "Celsius_scale",
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "pointwidth": "0"
                    },
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9999.0",
                        "iridlhasSemantics": "iridl:precipitation_amount",
                        "long_name": "precipitation",
                        "units": "mm",
                        "pointwidth": "0"
                    }
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.008333334",
                    "standard_name": "latitude"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2004-01-01",
                    "gridtype": "0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.008333334",
                    "standard_name": "longitude"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "latitude"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2004-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "longitude"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1990-01-01",
                    "gridtype": "0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/USGS/VCAP/eight-day"
            },
            "indextex": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/USGS/VCAP/index.tex",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "index.tex",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "VCAPpdf",
                "daily",
                "dekad",
                "eightday",
                "indextex"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "ADDS",
            "CHARM",
            "EROS",
            "HCDN",
            "LandDAAC",
            "VCAP"
        ]
    },
    "USTOPO": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "USTOPO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "NOAA US topography with 1/120 degree resolution",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.USTOPO/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "topo": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "topo",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "colormap": "12632256",
            "scale_max": "8000.0",
            "ncolor": "254",
            "scale_min": "-10000.0",
            "CS": "-10000",
            "colorscalename": "custom",
            "CE": "8000",
            "long_name": "topography",
            "missing_value": "-6000.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.008333334",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.008333334",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/USTOPO"
    },
    "U_Chicago": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "U_Chicago",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Archer1996Source": "http://geosci.uchicago.edu/~archer/data/",
            "Archer1996references": "Archer1996 Kleypas_etal1999",
            "Archer1996Kleypas_etal1999": "http://geosci.uchicago.edu/~archer/reprints/science99/kleypas.pdf",
            "Archer1996Archer1996": "http://geosci.uchicago.edu/~archer/reprints/archer.gbc1996.atlas.pdf",
            "iridlhasSemantics": "iridl:U_Chicago",
            "Conventions": "IRIDL"
        },
        "Archer1996": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Archer1996",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "surface_water_TCO2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "surface_water_TCO2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromoles / kilogram"
            },
            "PrePO4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PrePO4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "pct_CaCO3_LGM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pct_CaCO3_LGM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "history": "Interpolated Calcite",
                "units": "percent"
            },
            "ksp_arag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ksp_arag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9.96920997E36",
                "units": "unitless"
            },
            "CO3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CO3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromoles / kilogram"
            },
            "CaCO3_coretop_pct": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CaCO3_coretop_pct",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9.96920997E36",
                "units": "percent"
            },
            "bottom_water_dCO3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "bottom_water_dCO3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micromoles / kilogram"
            },
            "bath": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "bath",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "colormap": "12632256",
                "scale_max": "7964.0",
                "maxncolor": "253",
                "ncolor": "253",
                "scale_min": "-9964.0",
                "CS": "-9964.0",
                "CE": "7964.0",
                "colorscalename": "topographycolorscale",
                "units": "m",
                "missing_value": "1.00000002E30",
                "history": "U.S. Navy bathymetry plus land heights"
            },
            "AOU": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AOU",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless"
            },
            "Alk": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Alk",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mEq/l"
            }
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "2.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "2.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "dir": "SOURCES/U_Chicago"
    },
    "U_Mainz": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/U_Mainz",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "U_Mainz",
        "restriction": "Public",
        "IAP": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/U_Mainz/IAP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "IAP",
            "restriction": "Public",
            "KnippertzWernli2010": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/U_Mainz/IAP/KnippertzWernli2010",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "KnippertzWernli2010",
                "restriction": "requires dlauth tokens",
                "KnippertzWernli_JCL10pdf": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/U_Mainz/IAP/KnippertzWernli2010/KnippertzWernli_JCL10.pdf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "KnippertzWernli_JCL10.pdf",
                    "restriction": "requires dlauth tokens"
                },
                "indextex": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/U_Mainz/IAP/KnippertzWernli2010/index.tex",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "index.tex",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "KnippertzWernli_JCL10pdf",
                    "indextex"
                ]
            },
            "TMEv2": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/U_Mainz/IAP/TMEv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "TMEv2",
                "restriction": "requires dlauth tokens"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "KnippertzWernli2010",
                "TMEv2"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "IAP"
        ]
    },
    "U_Zulia": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "U_Zulia",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CMCOA_NOSA30iridlhasSemantics": "iridl:INAMHI",
            "CMCdescription": "Centro de Modelado Cientifico",
            "CMCdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.U_Zulia/.CMC.dataset_documentation.html",
            "CMCiridlhasSemantics": "iridl:Zulia_CMC",
            "description": "La Universidad del Zulia",
            "iridlhasSemantics": "iridl:Zulia",
            "Conventions": "IRIDL"
        },
        "CMC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CMC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "OA_NOSA30": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OA_NOSA30",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "vertical": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vertical",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "W": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "W",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Z",
                        "units": "m s-1",
                        "description": "z-wind component",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "V": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Y",
                        "units": "m s-1",
                        "description": "y-wind component",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "U": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "U",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "X",
                        "units": "m s-1",
                        "description": "x-wind component",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "QVAPOR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QVAPOR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "Water vapor mixing ratio",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "QRAIN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QRAIN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "Rain water mixing ratio",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "QCLOUD": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QCLOUD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "Cloud water mixing ratio",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "PHB": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PHB",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Z",
                        "units": "m2 s-2",
                        "description": "base-state geopotential",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "PH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Z",
                        "units": "m2 s-2",
                        "description": "perturbation geopotential",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "PB": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PB",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "",
                        "units": "Pa",
                        "description": "BASE STATE PRESSURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "",
                        "units": "Pa",
                        "description": "perturbation pressure",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "MUB": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MUB",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Pa",
                        "description": "base state dry air mass in column",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "MU": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MU",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Pa",
                        "description": "perturbation dry air mass in column",
                        "FieldType": "104",
                        "pointwidth": "0"
                    }
                },
                "top": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "top",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "OLR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "OLR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "W/m2",
                        "description": "TOA OUTGOING LONG WAVE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    }
                },
                "surface": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "surface",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "XLAND": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "XLAND",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "LAND MASK (1 FOR LAND, 2 FOR WATER)",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "XICE": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "XICE",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "units": "unitless",
                        "description": "SEA ICE FLAG",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "VEGFRA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "VEGFRA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "VEGETATION FRACTION",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "V10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "V10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "m s-1",
                        "description": "V at 10 M",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "U10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "U10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "m s-1",
                        "description": "U at 10 M",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "TSK": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TSK",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Kelvin_scale",
                        "description": "SURFACE SKIN TEMPERATURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "TMN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TMN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Kelvin_scale",
                        "description": "SOIL TEMPERATURE AT LOWER BOUNDARY",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "Temp2m": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Temp2m",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "units": "Kelvin_scale",
                        "description": "TEMP at 2 M",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SWDOWN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SWDOWN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "units": "W/m2",
                        "description": "DOWNWARD SHORT WAVE FLUX AT GROUND SURFACE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SST": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SST",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Kelvin_scale",
                        "description": "SEA SURFACE TEMPERATURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SNOWNC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNOWNC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "mm",
                        "description": "ACCUMULATED TOTAL GRID SCALE SNOW AND ICE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SNOWH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNOWH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "m",
                        "description": "PHYSICAL SNOW DEPTH",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SNOWC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNOWC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "FLAG INDICATING SNOW COVERAGE (1 FOR SNOW COVER)",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SNOW": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SNOW",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "kg m-2",
                        "description": "SNOW WATER EQUIVALENT",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SFROFF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SFROFF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "mm",
                        "description": "SURFACE RUNOFF",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "RAINNC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "RAINNC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "mm",
                        "description": "ACCUMULATED TOTAL GRID SCALE PRECIPITATION",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "RAINC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "RAINC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "mm",
                        "description": "ACCUMULATED TOTAL CUMULUS PRECIPITATION",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "QFX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "QFX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "kg m-2 s-1",
                        "description": "UPWARD MOISTURE FLUX AT THE SURFACE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "Q2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Q2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "QV at 2 M",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "PSFC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PSFC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "Pa",
                        "description": "SFC PRESSURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "PBLH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PBLH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "m",
                        "description": "PBL HEIGHT",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "LU_INDEX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LU_INDEX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "LAND USE CATEGORY",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "LH": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LH",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "W/m2",
                        "description": "LATENT HEAT FLUX AT THE SURFACE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "LANDMASK": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LANDMASK",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "LAND MASK (1 FOR LAND, 0 FOR WATER)",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "IVGTYP": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "IVGTYP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "DOMINANT VEGETATION CATEGORY",
                        "FieldType": "106",
                        "pointwidth": "0"
                    },
                    "ISLTYP": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ISLTYP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "DOMINANT SOIL CATEGORY",
                        "FieldType": "106",
                        "pointwidth": "0"
                    },
                    "HGT": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "HGT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "m",
                        "description": "Terrain Height",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "HFX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "HFX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "W/m2",
                        "description": "UPWARD HEAT FLUX AT THE SURFACE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "GRDFLX": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GRDFLX",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "W/m2",
                        "description": "GROUND HEAT FLUX",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "GRAUPELNC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GRAUPELNC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "mm",
                        "description": "ACCUMULATED TOTAL GRID SCALE GRAUPEL",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "GLW": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GLW",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "W/m2",
                        "description": "DOWNWARD LONG WAVE FLUX AT GROUND SURFACE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "CANWAT": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CANWAT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "kg m-2",
                        "description": "CANOPY WATER",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "ALBEDO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ALBEDO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XY ",
                        "stagger": "",
                        "units": "unitless",
                        "description": "ALBEDO",
                        "FieldType": "104",
                        "pointwidth": "0"
                    }
                },
                "soil": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "soil",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ZS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ZS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "Z  ",
                        "stagger": "Z",
                        "units": "m",
                        "description": "DEPTHS OF CENTERS OF SOIL LAYERS",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "TSLB": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TSLB",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Z",
                        "units": "Kelvin_scale",
                        "description": "SOIL TEMPERATURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "SMOIS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SMOIS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "XYZ",
                        "stagger": "Z",
                        "units": "unitless",
                        "description": "SOIL MOISTURE",
                        "FieldType": "104",
                        "pointwidth": "0"
                    },
                    "DZS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DZS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MemoryOrder": "Z  ",
                        "stagger": "Z",
                        "units": "m",
                        "description": "THICKNESSES OF SOIL LAYERS",
                        "FieldType": "104",
                        "pointwidth": "0"
                    }
                }
            }
        },
        "south_north_stag": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "south_north_stag",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "west_east_stag": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "west_east_stag",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.2702869"
        },
        "bottom_top_stag": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "bottom_top_stag",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "bottom_top": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "bottom_top",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "south_north": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "south_north",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "west_east": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "west_east",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.270287"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since  1971-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0",
            "standard_name": "time"
        },
        "soil_layers_stag": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "soil_layers_stag",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/U_Zulia"
    },
    "VUT": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "VUT",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SMv04p4product_version": "04.4",
            "SMv04p4cdm_data_type": "Grid",
            "SMv04p4tracking_id": "793d9cfa-c879-4315-887b-0c98e50661bb",
            "SMv04p4geospatial_lat_min": "-90.0",
            "SMv04p4platform": "Nimbus 7, DMSP, TRMM, AQUA, Coriolis, GCOM-W1, MIRAS; ERS-1, ERS-2, METOP-A, METOP-B",
            "SMv04p4creator_url": "http://rs.geo.tuwien.ac.at",
            "SMv04p4geospatial_lat_units": "degrees_north",
            "SMv04p4naming_authority": "TU Wien",
            "SMv04p4creator_name": "Department of Geodesy and Geoinformation, Technische Universt\\xc3\\xa4t Wien",
            "SMv04p4source": "https://www.esa-soilmoisture-cci.org/node/145",
            "SMv04p4Conventions": "CF-1.6",
            "SMv04p4geospatial_lon_max": "180.0",
            "SMv04p4history": "2018-11-07 12:00:00 - product produced",
            "SMv04p4geospatial_lat_max": "90.0",
            "SMv04p4geospatial_vertical_min": "0.0",
            "SMv04p4contact": "cci_sm_contact@eodc.eu",
            "SMv04p4time_coverage_duration": "P39Y",
            "SMv04p4title": "ESA CCI Surface Soil Moisture COMBINED active+passive Product",
            "SMv04p4project": "Climate Change Initiative - European Space Agency",
            "SMv04p4creator_email": "cci_sm_developer@eodc.eu",
            "SMv04p4dataset_documentation": "https://www.esa-soilmoisture-cci.org/sites/default/files/documents/Release04.2/ESA_CCI_SM_PSD_D1.2.1_version_4.2.pdf",
            "SMv04p4comment": "These data were produced as part of the ESA CCI Soil Moisture and FP7-Earth2Observe projects. Contract No. 4000112226/14/I-NB and GA No. 603608.",
            "SMv04p4references": "http://www.esa-soilmoisture-cci.org; Liu, Y.Y., Dorigo, W.A., Parinussa, R.M., de Jeu, R.A.M. , Wagner, W., McCabe, M.F., Evans, J.P., van Dijk, A.I.J.M. (2012). Trend-preserving blending of passive and active microwave soil moisture retrievals, Remote Sensing of Environment, 123, 280-297, doi: 10.1016/j.rse.2012.03.014.; Liu, Y.Y., Parinussa, R.M., Dorigo, W.A., De Jeu, R.A.M., Wagner, W., van Dijk, A.I.J.M., McCabe, M.F., & Evans, J.P. (2011). Developing an improved soil moisture dataset by blending passive and active microwave satellite based retrievals. Hydrology and Earth System Sciences, 15, 425-436.; Wagner, W., W. Dorigo, R. de Jeu, D. Fernandez, J. Benveniste, E. Haas, M. Ertl (2012). Fusion of active and passive microwave observations to create an Essential Climate Variable data record on soil moisture. ISPRS Annals of the Photogrammetry, Remote Sensing and Spatial Information Sciences, Volume I-7, 2012. XXII ISPRS Congress, 25 August - 01 September 2012, Melbourne, Australia.; Gruber, A., Dorigo, W. Crow, W., & Wagner, W. (2017). Triple collocation-based merging of satellite soil moisture retrievals. IEEE Transactions on Geoscience and Remote Sensing, 1-13.; Dorigo, W.A., Wagner, W., Albergel, C., Albrecht, F., Balsamo, G., Brocca, L., Chung, D., Ertl, M., Forkel, M., Gruber, A., Haas, E., Hamer, P. D., Hirschi, M., Ikonen, J., de Jeu, R., Kidd, R., Lahoz, W., Liu, Y. Y.,Miralles, D., Mistelbauer, T., Nicolai-Shaw, N., Parinussa, R., Pratola, C., Reimer, C., van der Schalie, R., Seneviratne, S. I. Smolander, T., Lecomte, P. (2017). ESA CCI Soil Moisture for improved Earth system understanding: State-of-the art and future directions, Remote Sensing of Environment. https://doi.org/10.1016/j.rse.2017.07.001.",
            "SMv04p4institution": "Technische Universit\\xc3\\xa4t Wien (AUT); Transmissivity B.V. / VanderSat B.V. Noordwijk (NL)",
            "SMv04p4geospatial_lon_resolution": "0.25 degree",
            "SMv04p4summary": "The data set was produced with funding of the ESA CCI Soil Moisture and FP7-Earth2Observe projects.",
            "SMv04p4note": "NO ONWARD DISTRIBUTION:  The use of the downloaded data is restricted to the user and the associated organisation, no onward distribution is permitted.  This is in the best interest of both the individual data providers and the potential users as unrestricted copying of the original data by multiple, independent users may lead to errors in the data.  Full data citation must be adhered to for all data usage.",
            "SMv04p4keywords_vocabulary": "NASA Global Change Master Directory (GCMD) Science Keywords",
            "SMv04p4geospatial_lon_units": "degrees_east",
            "SMv04p4keywords": "Soil Moisture/Water Content",
            "SMv04p4time_coverage_resolution": "P1D",
            "SMv04p4geospatial_lon_min": "-180.0",
            "SMv04p4geospatial_vertical_max": "0.0",
            "SMv04p4spatial_resolution": "25km",
            "SMv04p4license": "Data use is free and open for all registered users.",
            "SMv04p4geospatial_lat_resolution": "0.25 degree",
            "SMv04p4standard_name_vocabulary": "NetCDF Climate and Forecast (CF) Metadata Convention",
            "SMv02p3product_version": "02.3",
            "SMv02p3cdm_data_type": "Grid",
            "SMv02p3tracking_id": "c6a6a4c1-76f6-4e51-9c82-63622990a238",
            "SMv02p3geospatial_lat_min": "-90.0",
            "SMv02p3platform": "Nimbus 7, DMSP, TRMM, ERS-1, ERS-2, METOP-A, AQUA, Coriolis, GCOM-W1",
            "SMv02p3creator_url": "http://rs.geo.tuwien.ac.at",
            "SMv02p3geospatial_lat_units": "degrees_north",
            "SMv02p3naming_authority": "TU Wien",
            "SMv02p3date_created": "20160204T153622Z",
            "SMv02p3time_coverage_start": "19781101T000000Z",
            "SMv02p3creator_name": "Department of Geodesy and Geoinformation, Vienna University of Technology",
            "SMv02p3source": "WARP 5.5R1.1/AMI-WS/ERS12 Level 2 Soil Moisture; WARP 5.4R1.0/AMI-WS/ERS2 Level 2 Soil Moisture; WARP 5.5R2.2/ASCAT/MetOp-A Level 2 Soil Moisture; LPRMv05/SMMR/Nimbus 7 L3 Surface Soil Moisture, Ancillary Params, and quality flags; LPRMv05/SSMI/F08, F11, F13 DMSP L3 Surface Soil Moisture, Ancillary Params, and quality flags; LPRMv05/TMI/TRMM L2 Surface Soil Moisture, Ancillary Params, and QC; LPRMv05/AMSR-E/Aqua L2B Surface Soil Moisture, Ancillary Params, and QC; LPRMv05/WINDSAT/CORIOLIS L2 Surface Soil Moisture, Ancillary Params, and QC; LPRMv05/AMSR2/GCOM-W1 L3 Surface Soil Moisture, Ancillary Params",
            "SMv02p3nco_openmp_thread_number": "1",
            "SMv02p3geospatial_lon_max": "180.0",
            "SMv02p3Conventions": "CF-1.5",
            "SMv02p3geospatial_lat_max": "90.0",
            "SMv02p3geospatial_vertical_min": "0.0",
            "SMv02p3contact": "cci_sm_contact@eodc.eu",
            "SMv02p3time_coverage_duration": "P37Y",
            "SMv02p3title": "ESA CCI Surface Soil Moisture Combined Product",
            "SMv02p3project": "Climate Change Initiative - European Space Agency",
            "SMv02p3creator_email": "cci_sm_developer@eodc.eu",
            "SMv02p3comment": "These data were produced as part of the ESA soil moisture CCI projects. Contract No. ESRIN 22086/08/I-EC, ESRIN 4000104814/11/I-NB",
            "SMv02p3references": "http://www.esa-soilmoisture-cci.org; Liu, Y.Y., Dorigo, W.A., Parinussa, R.M., de Jeu, R.A.M. , Wagner, W., McCabe, M.F., Evans, J.P., van Dijk, A.I.J.M. (2012). Trend-preserving blending of passive and active microwave soil moisture retrievals, Remote Sensing of Environment, 123, 280-297, doi: 10.1016/j.rse.2012.03.014; Liu, Y.Y., Parinussa, R.M., Dorigo, W.A., De Jeu, R.A.M., Wagner, W., van Dijk, A.I.J.M., McCabe, M.F., & Evans, J.P. (2011): Developing an improved soil moisture dataset by blending passive and active microwave satellite based retrievals. Hydrology and Earth System Sciences, 15, 425-436; Wagner, W., W. Dorigo, R. de Jeu, D. Fernandez, J. Benveniste, E. Haas, M. Ertl (2012): Fusion of active and passive microwave observations to create an Essential Climate Variable data record on soil moisture. ISPRS Annals of the Photogrammetry, Remote Sensing and Spatial Information Sciences, Volume I-7, 2012. XXII ISPRS Congress, 25 August \\xe2\\x80\\x93 01 September 2012, Melbourne, Australia",
            "SMv02p3institution": "Vienna University of Technology, VU University Amsterdam",
            "SMv02p3geospatial_lon_resolution": "0.25 degree",
            "SMv02p3summary": "The data set was produced during the CCI project.",
            "SMv02p3keywords_vocabulary": "NASA Global Change Master Directory (GCMD) Science Keywords",
            "SMv02p3geospatial_lon_units": "degrees_east",
            "SMv02p3keywords": "Soil Moisture/Water Content",
            "SMv02p3time_coverage_resolution": "P1D",
            "SMv02p3id": "ESACCI-SOILMOISTURE-L3S-SSMV-COMBINED-19781101000000-fv02.3.nc",
            "SMv02p3geospatial_lon_min": "-180.0",
            "SMv02p3time_coverage_end": "20151231T235959Z",
            "SMv02p3geospatial_vertical_max": "0.0",
            "SMv02p3spatial_resolution": "25km",
            "SMv02p3license": "data use is free and open for all registered users",
            "SMv02p3geospatial_lat_resolution": "0.25 degree",
            "SMv02p3standard_name_vocabulary": "NetCDF Climate and Forecast (CF) Metadata Convention",
            "SMv02p3NCO": "4.4.4",
            "Conventions": "IRIDL"
        },
        "SM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v04p4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v04p4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "t0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "t0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "time lat lon",
                    "calendar": "standard",
                    "long_name": "Observation Timestamp",
                    "units": "days since 1970-01-01 00:00:00 UTC",
                    "missing_value": "-9999.0",
                    "pointwidth": "1.0"
                },
                "sm_uncertainty": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sm_uncertainty",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Units are m3 m-3, volume of water per volume of moist soil",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Volumetric Soil Moisture Uncertainty",
                    "units": "unitless",
                    "description": "Uncertainty is the estimated standard deviation of the  observation",
                    "missing_value": "-9999.0",
                    "valid_range": "1.0",
                    "pointwidth": "1.0"
                },
                "sm": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sm",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Units are m3 m-3, volume of water per volume of moist soil",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Volumetric Soil Moisture",
                    "units": "unitless",
                    "missing_value": "-9999.0",
                    "valid_range": "1.0",
                    "pointwidth": "1.0"
                },
                "sensor": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sensor",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "824",
                    "scale_min": "0",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Sensor",
                    "units": "unitless",
                    "flag_values": "824",
                    "missing_value": "0",
                    "flag_meanings": "NaN SMMR SSMI TMI AMSRE WindSat AMSRE+WindSat AMSR2 AMSRE+AMSR2 WindSat+AMSR2 AMSRE+WindSat+AMSR2 AMIWS SSMI+AMIWS TMI+AMIWS AMSRE+AMIWS ASCATA AMSRE+ASCATA WindSat+ASCATA AMSRE+WindSat+ASCATA AMSR2+ASCATA AMSRE+AMSR2+ASCATA WindSat+AMSR2+ASCATA AMSRE+WindSat+AMSR2+ASCATA ASCATB AMSR2+ASCATB ASCATA+ASCATB AMSRE+ASCATA+ASCATB WindSat+ASCATA+ASCATB AMSRE+WindSat+ASCATA+ASCATB AMSR2+ASCATA+ASCATB AMSRE+AMSR2+ASCATA+ASCATB WindSat+AMSR2+ASCATA+ASCATB AMSRE+WindSat+AMSR2+ASCATA+ASCATB",
                    "pointwidth": "1.0"
                },
                "mode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3",
                    "scale_min": "0",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Satellite  Mode",
                    "units": "unitless",
                    "flag_values": "3",
                    "missing_value": "0",
                    "flag_meanings": "NaN ascending descending ascending_descending_combination",
                    "pointwidth": "1.0"
                },
                "freqbandID": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "freqbandID",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "130",
                    "scale_min": "0",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Frequency Band Identification",
                    "units": "ids",
                    "flag_values": "130",
                    "missing_value": "0",
                    "flag_meanings": "NaN L14 C53 L14+C53 C66 C68 L14+C68 C53+C68 L14+C53+C68 C69 L14+C69 C53+C69 L14+C53+C69 C68+C69 L14+C68+C69 C53+C68+C69 L14+C53+C68+C69 C73 L14+C73 C53+C73 L14+C53+C73 X107 L14+X107 C53+X107 L14+C53+X107 C68+X107 L14+C68+X107 C53+C68+X107 L14+C53+C68+X107 C69+X107 L14+C69+X107 C53+C69+X107 L14+C53+C69+X107 K194 C53+K194",
                    "pointwidth": "1.0"
                },
                "flag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "flag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "127",
                    "scale_min": "0",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Flag",
                    "standard_name": "status_flag",
                    "units": "unitless",
                    "flag_values": "127",
                    "missing_value": "127",
                    "flag_meanings": "no_data_inconsistency_detected snow_coverage_or_temperature_below_zero dense_vegetation combination_of_flag_values_1_and_2 others_no_convergence_in_the_model_thus_no_valid_sm_estimates combination_of_flag_values_1_and_4 combination_of_flag_values_2_and_4 combination_of_flag_values_1_and_2_and_4 soil_moisture_value_exceeds_physical_boundary weight_of_measurement_below_threshold combination_of_flag_values_1_and_16 combination_of_flag_values_2_and_16 combination_of_flag_values_1_and_2_and_16 combination_of_flag_values_4_and_16 combination_of_flag_values_1_and_4_and_16 combination_of_flag_values_2_and_4_and_16 combination_of_flag_values_1_and_2_and_4_and_16 NaN",
                    "pointwidth": "1.0"
                },
                "dnflag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dnflag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3",
                    "scale_min": "0",
                    "_CoordinateAxes": "time lat lon",
                    "long_name": "Day / Night Flag",
                    "standard_name": "status_flag",
                    "units": "unitless",
                    "flag_values": "3",
                    "missing_value": "0",
                    "flag_meanings": "NaN day night day_night_combination",
                    "pointwidth": "1.0"
                }
            },
            "v02p3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v02p3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "t0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "t0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "calendar": "standard",
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Observation Timestamp",
                    "units": "days since 1970-01-01 00:00:00 UTC",
                    "missing_value": "-9999.0",
                    "valid_range": "3226.5"
                },
                "sm_uncertainty": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sm_uncertainty",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Volumetric Soil Moisture Uncertainty",
                    "units": "unitless",
                    "missing_value": "-9999",
                    "description": "Uncertainty is the estimated standard deviation of the observation",
                    "scale_factor": "9.99999975E-05",
                    "valid_range": "10000.0"
                },
                "sm": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sm",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Volumetric Soil Moisture",
                    "units": "unitless",
                    "missing_value": "-9999",
                    "scale_factor": "9.99999975E-05",
                    "valid_range": "10000.0"
                },
                "sensor": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sensor",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Sensor",
                    "units": "unitless",
                    "missing_value": "127",
                    "flag_values": "18",
                    "flag_meanings": "SMMR SSMI TMI AMSR_E AMI_WS ASCAT SSMI+AMI_WS TMI+AMI_WS AMSR_E+AMI_WS AMSR_E+ASCAT WindSat AMSR2 WindSat+ASCAT AMSR2+ASCAT"
                },
                "mode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Satellite Mode",
                    "units": "unitless",
                    "missing_value": "127",
                    "flag_values": "68",
                    "flag_meanings": "ascending descending"
                },
                "freqband": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "freqband",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Frequency Band",
                    "units": "unitless",
                    "missing_value": "127",
                    "flag_values": "19",
                    "flag_meanings": "c_band c_band c_band x_band ku_band"
                },
                "flag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "flag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Flag",
                    "units": "unitless",
                    "missing_value": "127",
                    "flag_values": "3",
                    "flag_meanings": "no_data_inconsistency_detected snow_coverage_or_temperature_below_zero dense_vegetation others_no_convergence_in_the_model_thus_no_valid_sm_estimates"
                },
                "dnflag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dnflag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "_CoordinateAxes": "lat lon time",
                    "long_name": "Day(100) or Night(110) Flag",
                    "units": "unitless",
                    "missing_value": "127",
                    "flag_values": "110",
                    "flag_meanings": "day night"
                }
            }
        },
        "time_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1970-01-01 00:00:00 UTC",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "standard"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1970-01-01 00:00:00 UTC",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.25",
            "standard_name": "longitude"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.25",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/VUT"
    },
    "Vietnam": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Vietnam",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Vietnam",
        "restriction": "Public",
        "ENACTS": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Vietnam/ENACTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ENACTS",
            "restriction": "Public",
            "ALL": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Vietnam/ENACTS/ALL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ALL",
                "restriction": "Public",
                "CIPH": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/ALL/CIPH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CIPH",
                    "restriction": "Public",
                    "CSMT": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/CIPH/CSMT",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CSMT",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "CSMT"
                    ]
                },
                "daily": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/ALL/daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "daily",
                    "restriction": "Public",
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/daily/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "temperature": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/daily/temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "temperature",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "rainfall",
                        "temperature"
                    ]
                },
                "dekadal": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/ALL/dekadal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "dekadal",
                    "restriction": "Public",
                    "climatologies": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/dekadal/climatologies",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "climatologies",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/dekadal/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "temperature": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/dekadal/temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "temperature",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "climatologies",
                        "rainfall",
                        "temperature"
                    ]
                },
                "monthly": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "monthly",
                    "restriction": "Public",
                    "WASP": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly/WASP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "WASP",
                        "restriction": "Public",
                        "month": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly/WASP/3-month",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "3-month",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "month",
                            "month",
                            "month"
                        ]
                    },
                    "climatologies": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly/climatologies",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "climatologies",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "temperature": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/ALL/monthly/temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "temperature",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "WASP",
                        "climatologies",
                        "rainfall",
                        "temperature"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CIPH",
                    "daily",
                    "dekadal",
                    "monthly"
                ]
            },
            "MON": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Vietnam/ENACTS/MON",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "MON",
                "restriction": "Public",
                "daily": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/MON/daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "daily",
                    "restriction": "Public",
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/daily/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "rainfall"
                    ]
                },
                "dekadal": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/MON/dekadal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "dekadal",
                    "restriction": "Public",
                    "climatologies": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/dekadal/climatologies",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "climatologies",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/dekadal/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "climatologies",
                        "rainfall"
                    ]
                },
                "monthly": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/MON/monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "monthly",
                    "restriction": "Public",
                    "WASP": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/monthly/WASP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "WASP",
                        "restriction": "Public",
                        "month": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/Vietnam/ENACTS/MON/monthly/WASP/3-month",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "3-month",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "month",
                            "month",
                            "month"
                        ]
                    },
                    "climatologies": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/monthly/climatologies",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "climatologies",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/monthly/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "WASP",
                        "climatologies",
                        "rainfall"
                    ]
                },
                "seasonal": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/Vietnam/ENACTS/MON/seasonal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "seasonal",
                    "restriction": "Public",
                    "rainfall": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/Vietnam/ENACTS/MON/seasonal/rainfall",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rainfall",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "rainfall"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "daily",
                    "dekadal",
                    "monthly",
                    "seasonal"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "ALL",
                "MON"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "ENACTS"
        ]
    },
    "WCRP": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/WCRP",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "WCRP",
        "restriction": "Public",
        "CHFP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CHFP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "IRIECHAM4p5MOM3DC2fmt2OCEANzohConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANzmloConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANwoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANvoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANuoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANthetaoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANtauyoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANtauxoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANsoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANhtfConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANfwfConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2OCEANConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMvasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMvaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMuasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMuaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtdpsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtauyConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtauxConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtasminConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtasmaxConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMtaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMsnldConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMrstConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMrssConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMrltConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMrlsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMpslConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMprlrConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMmrsovConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMhusConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMhfssdConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMhflsdConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMgConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMcltConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2ATMConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2fmt2references": "Roeckner_etal1996 Danabasoglu_etal2006 Derber_Rosati1989 DeWitt_DG2005 Luo_JJ2005a Pacanowski_Griffies1998 ",
                "IRIECHAM4p5MOM3DC2fmt2iridlhasSemantics": "iriref:DeWitt_DG",
                "IRIECHAM4p5MOM3DC2fmt2Conventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANzohConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANzmloConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANwoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANvoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANuoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANthetaoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANtauyoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANtauxoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANsoConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANhtfConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANfwfConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2OCEANConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMvasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMvaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMuasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMuaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtdpsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtauyConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtauxConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtasminConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtasmaxConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtasConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMtaConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMsnldConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMrstConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMrssConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMrltConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMrlsConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMpslConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMprlrConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMmrsovConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMhusConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMhfssdConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMhflsdConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMgConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMcltConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2ATMConventions": "CF-1.0",
                "IRIECHAM4p5MOM3DC2references": "Roeckner_etal1996 Danabasoglu_etal2006 Derber_Rosati1989 DeWitt_DG2005 Luo_JJ2005a Pacanowski_Griffies1998 ",
                "IRIECHAM4p5MOM3DC2iridlhasSemantics": "iriref:DeWitt_DG",
                "IRIECHAM4p5MOM3DC2Conventions": "CF-1.0",
                "description": "Climate-system Historical Forecast Project",
                "CHFP": "http://www.clivar.org/organization/wgsip/chfp/chfp_data.php/",
                "Conventions": "IRIDL"
            },
            "IRI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IRI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ECHAM4p5MOM3DC2fmt2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5-MOM3-DC2fmt2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "OCEAN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "OCEAN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zoh": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zoh",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zoh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zoh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "free surface height",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "zmlo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zmlo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zmlo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zmlo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "kpp mixed layer depth",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "ocean_mixed_layer_thickness",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "wo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "upward_sea_water_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "vo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "sea_water_y_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "uo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "zonal current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "sea_water_x_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "thetao": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "thetao",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "thetao": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "thetao",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauyo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauyo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauyo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauyo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface meridional wind stress",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauxo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauxo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauxo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauxo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface zonal wind stress",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "so": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "so",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "so": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "so",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "salinity",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "reftime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reftime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S",
                            "long_name": "Start time"
                        },
                        "leadtime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "leadtime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "forecast_period",
                            "long_name": "lead time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "institution": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "institution",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "htf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "htf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "htf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "htf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "heat flux",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "fwf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "fwf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "fwf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "fwf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meter+3/sq meter",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "fresh water flux",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "experiment_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "experiment_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        }
                    },
                    "ATM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ATM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "10 meter meridional wind",
                                "standard_name": "northward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "10 meter zonal wind",
                                "standard_name": "eastward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface temperature",
                                "standard_name": "surface_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tdps": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tdps",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter dewpoint",
                                "standard_name": "dew_point_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauy": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauy",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface meridional wind stress",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "taux": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "taux",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface zonal wind stress",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tasmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter minimum temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tasmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter maximum temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature at 2m",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "snld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "snld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "snow depth",
                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net shortwave at toa",
                                "standard_name": "toa_net_downward_shortwave_fluxflux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net shortwave at ground",
                                "standard_name": "surface_net_downward_shortwave_flux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rlt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rlt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "out long wave radiation",
                                "standard_name": "toa_net_downward_longwave_fluxxflux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net longwave at ground",
                                "standard_name": "surface_net_downward_longwave_flux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "reftime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reftime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S",
                            "long_name": "Start time"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "sea level pressure",
                                "standard_name": "air_pressure_at_sea_level",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "prlr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prlr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "prlr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prlr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "total precipitation",
                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "mrsov": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrsov",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "mrsov": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mrsov",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "soil wetness",
                                "standard_name": "soil wetness",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "leadtime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "leadtime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "forecast_period",
                            "long_name": "lead time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "institution": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "institution",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "hus": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hus",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "specific humidity",
                                "standard_name": "specific_humidity",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "hfssd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfssd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hfssd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfssd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface sensible heat flux",
                                "standard_name": "surface_downward_sensible_heat_flux",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "hflsd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hflsd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hflsd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflsd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": " watts/sq meter",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface latent heat flux",
                                "standard_name": "surface_downward_latent_heat_flux",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "g": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "g",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "g": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "g",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "geopotential height",
                                "standard_name": "geopotential",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "experiment_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "experiment_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "clt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "clt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "total cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "cNZ": "9"
                            }
                        }
                    }
                },
                "ECHAM4p5MOM3DC2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5-MOM3-DC2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "OCEAN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "OCEAN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "zoh": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zoh",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zoh": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zoh",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "free surface height",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "zmlo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "zmlo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zmlo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zmlo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "kpp mixed layer depth",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "ocean_mixed_layer_thickness",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "wo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "wo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "upward_sea_water_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "vo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "sea_water_y_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "uo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "zonal current",
                                "file_missing_value": "-9.99999979E33",
                                "standard_name": "sea_water_x_velocity",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "thetao": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "thetao",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "thetao": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "thetao",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauyo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauyo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauyo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauyo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface meridional wind stress",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauxo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauxo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauxo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauxo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface zonal wind stress",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "so": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "so",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "so": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "so",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "PSU",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "salinity",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "reftime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reftime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S",
                            "long_name": "Start time"
                        },
                        "leadtime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "leadtime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "forecast_period",
                            "long_name": "lead time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "institution": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "institution",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "htf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "htf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "htf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "htf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "heat flux",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "fwf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "fwf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "fwf": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "fwf",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meter+3/sq meter",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "fresh water flux",
                                "file_missing_value": "-9.99999979E33",
                                "cNZ": "0"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "experiment_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "experiment_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        }
                    },
                    "ATM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ATM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "10 meter meridional wind",
                                "standard_name": "northward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "va": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "va",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "meridional wind",
                                "standard_name": "northward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "uas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "uas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "10 meter zonal wind",
                                "standard_name": "eastward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ua": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ua",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "zonal wind",
                                "standard_name": "eastward_wind",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ts": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ts",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface temperature",
                                "standard_name": "surface_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tdps": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tdps",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tdps": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tdps",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter dewpoint",
                                "standard_name": "dew_point_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tauy": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tauy",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface meridional wind stress",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "taux": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "taux",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface zonal wind stress",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tasmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tasmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter minimum temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tasmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tasmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tasmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tasmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "two meter maximum temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "tas": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tas",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tas": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tas",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature at 2m",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "ta": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ta",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "temperature",
                                "standard_name": "air_temperature",
                                "cNZ": "9"
                            },
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "snld": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "snld",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "snld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "snld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "snow depth",
                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net shortwave at toa",
                                "standard_name": "toa_net_downward_shortwave_fluxflux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rss": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rss",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net shortwave at ground",
                                "standard_name": "surface_net_downward_shortwave_flux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rlt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rlt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rlt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rlt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "out long wave radiation",
                                "standard_name": "toa_net_downward_longwave_fluxxflux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "rls": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rls",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "rls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "net longwave at ground",
                                "standard_name": "surface_net_downward_longwave_flux",
                                "cNZ": "9"
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "reftime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reftime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "0",
                            "standard_name": "forecast_reference_time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S",
                            "long_name": "Start time"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "psl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "psl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pascals",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "sea level pressure",
                                "standard_name": "air_pressure_at_sea_level",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "prlr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prlr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "prlr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prlr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m s-1",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "total precipitation",
                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "mrsov": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mrsov",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "mrsov": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mrsov",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "soil wetness",
                                "standard_name": "soil wetness",
                                "cNZ": "9"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "leadtime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "leadtime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "1",
                            "standard_name": "forecast_period",
                            "long_name": "lead time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "institution": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "institution",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "hus": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hus",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "specific humidity",
                                "standard_name": "specific_humidity",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "hfssd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hfssd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hfssd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfssd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "W/m2",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface sensible heat flux",
                                "standard_name": "surface_downward_sensible_heat_flux",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "hflsd": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hflsd",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "hflsd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hflsd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": " watts/sq meter",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "surface latent heat flux",
                                "standard_name": "surface_downward_latent_heat_flux",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "g": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "g",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "g": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "g",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "geopotential height",
                                "standard_name": "geopotential",
                                "cNZ": "9"
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "experiment_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "experiment_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "clt": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "clt",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "source": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "source",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "reftime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "reftime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "0",
                                "standard_name": "forecast_reference_time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S",
                                "long_name": "Start time"
                            },
                            "leadtime": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "leadtime",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pointwidth": "1",
                                "standard_name": "forecast_period",
                                "long_name": "lead time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "bounds": "S"
                            },
                            "institution": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "institution",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "experiment_id": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "experiment_id",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "clt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "clt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "history": "Boxes with less than 0.0% dropped",
                                "missing_value": "NaN",
                                "long_name": "total cloud cover",
                                "standard_name": "cloud_area_fraction",
                                "cNZ": "9"
                            }
                        }
                    }
                }
            },
            "L": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "forecast_period",
                "long_name": "Lead time"
            },
            "S": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "pointwidth": "0",
                "standard_name": "forecast_reference_time",
                "calendar": "360",
                "long_name": "Start time"
            },
            "level_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "2",
                "standard_name": "depth"
            },
            "latitude_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "latitude_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "longitude_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "longitude_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "standard_name": "longitude"
            },
            "level": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "level",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "gridtype": "0",
                "standard_name": "air_pressure"
            },
            "string14": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "string14",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "string4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "string4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "string18": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "string18",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "time": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "time",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "ensemble": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ensemble",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "realization",
                "calendar": "standard"
            },
            "latitude": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "latitude",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude"
            },
            "longitude": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "longitude",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5"
            },
            "dir": "SOURCES/WCRP/CHFP"
        },
        "CLIVAR": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/WCRP/CLIVAR",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "CLIVAR",
            "restriction": "Public",
            "ETCCDI": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/WCRP/CLIVAR/ETCCDI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ETCCDI",
                "restriction": "Public",
                "CMIP5": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CMIP5",
                    "restriction": "Public",
                    "historical": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "historical",
                        "restriction": "Public",
                        "ACCESS10": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ACCESS1-0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlybranch_time": "109207.0",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlyproduct": "output",
                                "v1monthlymodel_id": "ACCESS1-0",
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlyinput_title": "ACCESS1-0 model output prepared for CMIP5 historical",
                                "v1monthlyfrequency": "mon",
                                "v1monthlysource": "ACCESS1-0 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: MOSES2 (1.875 degree EW x 1.25 degree NS, 4 levels)",
                                "v1monthlyparent_experiment_id": "piControl",
                                "v1monthlyexperiment_id": "historical",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlyforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1monthlyinput_creation_date": "2012-01-17T11:50:52Z",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlyinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1monthlytitle": "ETCCDI indices computed on ACCESS1-0 model output prepared for CMIP5 historical",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyinstitute_id": "CSIRO-BOM",
                                "v1monthlycmor_version": "2.8.0",
                                "v1monthlyETCCDI_software_version": "0.6.1",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlycreation_date": "2012-07-14T22:08:59Z",
                                "v1monthlyphysics_version": "1",
                                "v1monthlytable_id": "Table day (27 April 2011) 38b0ef063ca8bcf7f2436f94c40ed33c",
                                "v1monthlyexperiment": "historical",
                                "v1monthlyversion_number": "v20120115",
                                "v1monthlyrealization": "1",
                                "v1monthlyinput_tracking_id": "17b856d4-32b6-423d-b02f-7ac1e32da227",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1monthlyparent_experiment_rip": "r1i1p1",
                                "v1monthlyCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1monthlyparent_experiment": "pre-industrial control",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualbranch_time": "109207.0",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualmodel_id": "ACCESS1-0",
                                "v1annualproduct": "output",
                                "v1annualproject_id": "CMIP5",
                                "v1annualinput_title": "ACCESS1-0 model output prepared for CMIP5 historical",
                                "v1annualfrequency": "yr",
                                "v1annualsource": "ACCESS1-0 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: MOSES2 (1.875 degree EW x 1.25 degree NS, 4 levels)",
                                "v1annualparent_experiment_id": "piControl",
                                "v1annualexperiment_id": "historical",
                                "v1annualinitialization_method": "1",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1annualinput_creation_date": "2012-01-17T11:50:52Z",
                                "v1annualConventions": "CF-1.4",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1annualtitle": "ETCCDI indices computed on ACCESS1-0 model output prepared for CMIP5 historical",
                                "v1annualinput_frequency": "day",
                                "v1annualinstitute_id": "CSIRO-BOM",
                                "v1annualcmor_version": "2.8.0",
                                "v1annualETCCDI_software_version": "0.6.1",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualcreation_date": "2012-07-14T22:26:10Z",
                                "v1annualphysics_version": "1",
                                "v1annualtable_id": "Table day (27 April 2011) 38b0ef063ca8bcf7f2436f94c40ed33c",
                                "v1annualexperiment": "historical",
                                "v1annualversion_number": "v20120115",
                                "v1annualrealization": "1",
                                "v1annualinput_tracking_id": "17b856d4-32b6-423d-b02f-7ac1e32da227",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1annualparent_experiment_rip": "r1i1p1",
                                "v1annualCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1annualparent_experiment": "pre-industrial control",
                                "iridlhasSemantics": "iridl:ACCESS1-0",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/ACCESS1-0"
                        },
                        "BNUESM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BNU-ESM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120312monthlyparent_experiment_id": "piControl",
                                "v20120312monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120312monthlyfrequency": "mon",
                                "v20120312monthlyBNU_contact": "Ji Duoying (duoyingji@bnu.edu.cn)",
                                "v20120312monthlyproduct": "output",
                                "v20120312monthlyinput_frequency": "day",
                                "v20120312monthlycreation_date": "2012-07-12T17:12:07Z",
                                "v20120312monthlyphysics_version": "1",
                                "v20120312monthlysource": "BNU-ESM",
                                "v20120312monthlymodeling_realm": "atmos",
                                "v20120312monthlyinput_creation_date": "2012-03-12T06:03:00Z",
                                "v20120312monthlybranch_time": "0.0",
                                "v20120312monthlyexperiment": "historical",
                                "v20120312monthlyConventions": "CF-1.4",
                                "v20120312monthlyhistory": "2012-03-12T06:02:50Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120312monthlytitle": "ETCCDI indices computed on BNU-ESM model output prepared for CMIP5 historical",
                                "v20120312monthlyinitialization_method": "1",
                                "v20120312monthlyETCCDI_software_version": "0.6.1",
                                "v20120312monthlyproject_id": "CMIP5",
                                "v20120312monthlyparent_experiment_rip": "r1i1p1",
                                "v20120312monthlyinstitute_id": "BNU",
                                "v20120312monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120312monthlyrealization": "1",
                                "v20120312monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120312monthlyinstitution": "GCESS,BNU,Beijing,China",
                                "v20120312monthlyETCCDI_software": "climdex.pcic",
                                "v20120312monthlyinput_title": "BNU-ESM model output prepared for CMIP5 historical",
                                "v20120312monthlyforcing": "Nat,Ant",
                                "v20120312monthlyexperiment_id": "historical",
                                "v20120312monthlyinput_tracking_id": "4e7ce19e-884a-482b-8e84-efe022b63a00",
                                "v20120312monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120312monthlyparent_experiment": "pre-industrial control",
                                "v20120312monthlycmor_version": "2.7.1",
                                "v20120312monthlymodel_id": "BNU-ESM",
                                "v20120312monthlyETCCDI_institution_id": "PCIC",
                                "v20120312monthlycontact": "bronaugh@uvic.ca",
                                "v20120312annualparent_experiment_id": "piControl",
                                "v20120312annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120312annualfrequency": "yr",
                                "v20120312annualBNU_contact": "Ji Duoying (duoyingji@bnu.edu.cn)",
                                "v20120312annualproduct": "output",
                                "v20120312annualinput_frequency": "day",
                                "v20120312annualcreation_date": "2012-07-12T17:13:00Z",
                                "v20120312annualphysics_version": "1",
                                "v20120312annualsource": "BNU-ESM",
                                "v20120312annualmodeling_realm": "atmos",
                                "v20120312annualinput_creation_date": "2012-03-12T06:03:00Z",
                                "v20120312annualbranch_time": "0.0",
                                "v20120312annualexperiment": "historical",
                                "v20120312annualConventions": "CF-1.4",
                                "v20120312annualhistory": "2012-03-12T06:02:50Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120312annualtitle": "ETCCDI indices computed on BNU-ESM model output prepared for CMIP5 historical",
                                "v20120312annualinitialization_method": "1",
                                "v20120312annualETCCDI_software_version": "0.6.1",
                                "v20120312annualproject_id": "CMIP5",
                                "v20120312annualparent_experiment_rip": "r1i1p1",
                                "v20120312annualinstitute_id": "BNU",
                                "v20120312annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120312annualrealization": "1",
                                "v20120312annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120312annualinstitution": "GCESS,BNU,Beijing,China",
                                "v20120312annualETCCDI_software": "climdex.pcic",
                                "v20120312annualinput_title": "BNU-ESM model output prepared for CMIP5 historical",
                                "v20120312annualforcing": "Nat,Ant",
                                "v20120312annualexperiment_id": "historical",
                                "v20120312annualinput_tracking_id": "4e7ce19e-884a-482b-8e84-efe022b63a00",
                                "v20120312annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120312annualparent_experiment": "pre-industrial control",
                                "v20120312annualcmor_version": "2.7.1",
                                "v20120312annualmodel_id": "BNU-ESM",
                                "v20120312annualETCCDI_institution_id": "PCIC",
                                "v20120312annualcontact": "bronaugh@uvic.ca",
                                "iridlhasSemantics": "iridl:BNU-ESM",
                                "Conventions": "IRIDL"
                            },
                            "v20120312": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120312",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1950-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1950-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/BNU-ESM"
                        },
                        "CCSM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CCSM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlycesm_compset": "B20TRCN",
                                "mult_versionsmonthlyprocessed_by": "strandwg on copper.cgd.ucar.edu at 20111107  -160231.257",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlycreation_date": "2012-07-22T03:22:52Z",
                                "mult_versionsmonthlycesm_repotag": "ccsm4_0_beta43",
                                "mult_versionsmonthlysource": "CCSM4",
                                "mult_versionsmonthlyinstitution": "NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "mult_versionsmonthlyprocessing_code_information": "Last Changed Rev: 446 Last Changed Date: 2011-11-07 07:45:55 -0700 (Mon, 07 Nov 2011) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "mult_versionsmonthlyforcing": "Sl GHG Vl SS Ds SD BC MD OC Oz AA LU",
                                "mult_versionsmonthlyinput_title": "CCSM4 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyNCAR_references": "Gent P. R., et.al. 2011: The Community Climate System Model version 4. J. Climate, doi: 10.1175/2011JCLI4083.1",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on CCSM4 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "mult_versionsmonthlymodel_id": "CCSM4",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlybranch_time": "1031.0",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinstitute_id": "NCAR",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyinput_tracking_id": "0295768d-11a5-43b5-ab10-f20ef0a8ed51",
                                "mult_versionsmonthlyinput_creation_date": "2011-11-07T23:02:31Z",
                                "mult_versionsmonthlycesm_casename": "b40.20th.track1.1deg.009",
                                "mult_versionsmonthlyNCAR_contact": "cesm_data@ucar.edu",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualcesm_compset": "B20TRCN",
                                "mult_versionsannualprocessed_by": "strandwg on copper.cgd.ucar.edu at 20111107  -160231.257",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualcreation_date": "2012-07-22T03:24:00Z",
                                "mult_versionsannualcesm_repotag": "ccsm4_0_beta43",
                                "mult_versionsannualsource": "CCSM4",
                                "mult_versionsannualinstitution": "NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualprocessing_code_information": "Last Changed Rev: 446 Last Changed Date: 2011-11-07 07:45:55 -0700 (Mon, 07 Nov 2011) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualforcing": "Sl GHG Vl SS Ds SD BC MD OC Oz AA LU",
                                "mult_versionsannualinput_title": "CCSM4 model output prepared for CMIP5 historical",
                                "mult_versionsannualNCAR_references": "Gent P. R., et.al. 2011: The Community Climate System Model version 4. J. Climate, doi: 10.1175/2011JCLI4083.1",
                                "mult_versionsannualtitle": "ETCCDI indices computed on CCSM4 model output prepared for CMIP5 historical",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "mult_versionsannualmodel_id": "CCSM4",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualbranch_time": "1031.0",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitute_id": "NCAR",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualinput_tracking_id": "0295768d-11a5-43b5-ab10-f20ef0a8ed51",
                                "mult_versionsannualinput_creation_date": "2011-11-07T23:02:31Z",
                                "mult_versionsannualcesm_casename": "b40.20th.track1.1deg.009",
                                "mult_versionsannualNCAR_contact": "cesm_data@ucar.edu",
                                "iridlhasSemantics": "iridl:CCSM4",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "startyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "startyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days"
                                    },
                                    "startyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "startyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "long_name": "realization",
                                "standard_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.25",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.9424084",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CCSM4"
                        },
                        "CESM1FASTCHEM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CESM1-FASTCHEM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120522monthlyparent_experiment": "pre-industrial control",
                                "v20120522monthlyinput_title": "CESM1-FASTCHEM model output prepared for CMIP5 historical",
                                "v20120522monthlyinstitution": "NSF/DOE NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "v20120522monthlycreation_date": "2013-06-27T17:09:21Z",
                                "v20120522monthlyproject_id": "CMIP5",
                                "v20120522monthlymodeling_realm": "atmos",
                                "v20120522monthlyproduct": "output",
                                "v20120522monthlyexperiment_id": "historical",
                                "v20120522monthlyprocessing_code_information": "Last Changed Rev: 759 Last Changed Date: 2012-05-14 13:18:28 -0600 (Mon, 14 May 2012) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "v20120522monthlyETCCDI_software_version": "0.7.1",
                                "v20120522monthlyphysics_version": "1",
                                "v20120522monthlyNSFDOENCAR_references": "TBD",
                                "v20120522monthlycomment": "CESM home page: http://www.cesm.ucar.edu",
                                "v20120522monthlyinput_frequency": "day",
                                "v20120522monthlysource": "CESM1-FASTCHEM",
                                "v20120522monthlycesm_casename": "b40.20th.1deg.fschem.002",
                                "v20120522monthlyConventions": "CF-1.4",
                                "v20120522monthlytitle": "ETCCDI indices computed on CESM1-FASTCHEM model output prepared for CMIP5 historical",
                                "v20120522monthlycesm_repotag": "ccsm4_0_beta55",
                                "v20120522monthlyETCCDI_software": "climdex.pcic",
                                "v20120522monthlyexperiment": "historical",
                                "v20120522monthlyNSFDOENCAR_contact": "cesm_data@ucar.edu",
                                "v20120522monthlyETCCDI_institution_id": "PCIC",
                                "v20120522monthlybranch_time": "0.0",
                                "v20120522monthlyinitialization_method": "1",
                                "v20120522monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120522monthlyprocessed_by": "strandwg on silver.cgd.ucar.edu at 20120515  -154138.404",
                                "v20120522monthlycontact": "bronaugh@uvic.ca",
                                "v20120522monthlytable_id": "Table day (12 January 2012) 7757d80c56ae0b9009f150afa4850c4e",
                                "v20120522monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120522monthlyinput_creation_date": "2012-05-15T21:45:33Z",
                                "v20120522monthlyacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "v20120522monthlyparent_experiment_id": "piControl",
                                "v20120522monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120522monthlyresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "v20120522monthlyinstitute_id": "NSF-DOE-NCAR",
                                "v20120522monthlyforcing": "Sl GHG Vl SS Ds SD BC MD OC Oz AA LU",
                                "v20120522monthlymodel_id": "CESM1-FASTCHEM",
                                "v20120522monthlycesm_compset": "B20TRCNCHM",
                                "v20120522monthlyfrequency": "mon",
                                "v20120522monthlyinput_tracking_id": "d47d9aed-bcdd-487b-8254-76b0a60d0f38",
                                "v20120522monthlynco_openmp_thread_number": "1",
                                "v20120522monthlyforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "v20120522monthlycmor_version": "2.8.1",
                                "v20120522annualparent_experiment": "pre-industrial control",
                                "v20120522annualinput_title": "CESM1-FASTCHEM model output prepared for CMIP5 historical",
                                "v20120522annualinstitution": "NSF/DOE NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "v20120522annualcreation_date": "2013-06-27T17:09:22Z",
                                "v20120522annualproject_id": "CMIP5",
                                "v20120522annualmodeling_realm": "atmos",
                                "v20120522annualproduct": "output",
                                "v20120522annualexperiment_id": "historical",
                                "v20120522annualprocessing_code_information": "Last Changed Rev: 759 Last Changed Date: 2012-05-14 13:18:28 -0600 (Mon, 14 May 2012) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "v20120522annualETCCDI_software_version": "0.7.1",
                                "v20120522annualphysics_version": "1",
                                "v20120522annualNSFDOENCAR_references": "TBD",
                                "v20120522annualcomment": "CESM home page: http://www.cesm.ucar.edu",
                                "v20120522annualinput_frequency": "day",
                                "v20120522annualsource": "CESM1-FASTCHEM",
                                "v20120522annualcesm_casename": "b40.20th.1deg.fschem.002",
                                "v20120522annualConventions": "CF-1.4",
                                "v20120522annualtitle": "ETCCDI indices computed on CESM1-FASTCHEM model output prepared for CMIP5 historical",
                                "v20120522annualcesm_repotag": "ccsm4_0_beta55",
                                "v20120522annualexperiment": "historical",
                                "v20120522annualETCCDI_software": "climdex.pcic",
                                "v20120522annualNSFDOENCAR_contact": "cesm_data@ucar.edu",
                                "v20120522annualETCCDI_institution_id": "PCIC",
                                "v20120522annualbranch_time": "0.0",
                                "v20120522annualinitialization_method": "1",
                                "v20120522annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120522annualprocessed_by": "strandwg on silver.cgd.ucar.edu at 20120515  -154138.404",
                                "v20120522annualcontact": "bronaugh@uvic.ca",
                                "v20120522annualtable_id": "Table day (12 January 2012) 7757d80c56ae0b9009f150afa4850c4e",
                                "v20120522annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120522annualinput_creation_date": "2012-05-15T21:45:33Z",
                                "v20120522annualacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "v20120522annualparent_experiment_id": "piControl",
                                "v20120522annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120522annualresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "v20120522annualinstitute_id": "NSF-DOE-NCAR",
                                "v20120522annualforcing": "Sl GHG Vl SS Ds SD BC MD OC Oz AA LU",
                                "v20120522annualmodel_id": "CESM1-FASTCHEM",
                                "v20120522annualcesm_compset": "B20TRCNCHM",
                                "v20120522annualfrequency": "yr",
                                "v20120522annualinput_tracking_id": "d47d9aed-bcdd-487b-8254-76b0a60d0f38",
                                "v20120522annualnco_openmp_thread_number": "1",
                                "v20120522annualforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "v20120522annualcmor_version": "2.8.1",
                                "iridlhasSemantics": "iridl:CESM1-FASTCHEM",
                                "Conventions": "IRIDL"
                            },
                            "v20120522": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120522",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "N_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.25",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.9424084",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CESM1-FASTCHEM"
                        },
                        "CMCCCESM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMCC-CESM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120907monthlyETCCDI_institution_id": "PCIC",
                                "v20120907monthlyinput_creation_date": "2012-08-01T14:32:01Z",
                                "v20120907monthlyinstitute_id": "CMCC",
                                "v20120907monthlybranch_time": "0.0",
                                "v20120907monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120907monthlyforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120907monthlyproduct": "output",
                                "v20120907monthlyinput_tracking_id": "9da935c4-4b25-41f4-a1bd-1349a55335b2",
                                "v20120907monthlyphysics_version": "1",
                                "v20120907monthlyproject_id": "CMIP5",
                                "v20120907monthlyETCCDI_software": "climdex.pcic",
                                "v20120907monthlysource": "CMCC-CESM",
                                "v20120907monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120907monthlyrealization": "1",
                                "v20120907monthlyConventions": "CF-1.4",
                                "v20120907monthlymodeling_realm": "atmos",
                                "v20120907monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120907monthlyparent_experiment_rip": "N/A",
                                "v20120907monthlycreation_date": "2013-04-18T17:44:54Z",
                                "v20120907monthlytitle": "ETCCDI indices computed on CMCC-CESM model output prepared for CMIP5 historical",
                                "v20120907monthlycmor_version": "2.7.1",
                                "v20120907monthlycomment": "Equilibrium reached after more than 1500-year spin-up of the physics, 200-year spin-up of carbon content and 276 year at pre-industrial GHG concentrations after which data were output with nominal date of January 1850.",
                                "v20120907monthlyinitialization_method": "1",
                                "v20120907monthlyparent_experiment_id": "N/A",
                                "v20120907monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120907monthlyexperiment_id": "historical",
                                "v20120907monthlyfrequency": "monClim",
                                "v20120907monthlyETCCDI_software_version": "0.6.2",
                                "v20120907monthlyinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120907monthlymodel_id": "CMCC-CESM",
                                "v20120907monthlyparent_experiment": "N/A",
                                "v20120907monthlycontact": "bronaugh@uvic.ca",
                                "v20120907monthlyCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120907monthlyCMCC_contact": "Marcello Vichi (marcello.vichi@cmcc.it)",
                                "v20120907monthlynco_openmp_thread_number": "1",
                                "v20120907monthlyinput_title": "CMCC-CESM model output prepared for CMIP5 historical",
                                "v20120907monthlyinput_frequency": "day",
                                "v20120907monthlyexperiment": "historical",
                                "v20120907annualETCCDI_institution_id": "PCIC",
                                "v20120907annualinstitute_id": "CMCC",
                                "v20120907annualinput_creation_date": "2012-08-01T14:32:01Z",
                                "v20120907annualbranch_time": "0.0",
                                "v20120907annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120907annualforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120907annualproduct": "output",
                                "v20120907annualinput_tracking_id": "9da935c4-4b25-41f4-a1bd-1349a55335b2",
                                "v20120907annualphysics_version": "1",
                                "v20120907annualproject_id": "CMIP5",
                                "v20120907annualETCCDI_software": "climdex.pcic",
                                "v20120907annualsource": "CMCC-CESM",
                                "v20120907annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120907annualrealization": "1",
                                "v20120907annualConventions": "CF-1.4",
                                "v20120907annualmodeling_realm": "atmos",
                                "v20120907annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120907annualparent_experiment_rip": "N/A",
                                "v20120907annualcreation_date": "2013-04-18T17:22:51Z",
                                "v20120907annualtitle": "ETCCDI indices computed on CMCC-CESM model output prepared for CMIP5 historical",
                                "v20120907annualcmor_version": "2.7.1",
                                "v20120907annualcomment": "Equilibrium reached after more than 1500-year spin-up of the physics, 200-year spin-up of carbon content and 276 year at pre-industrial GHG concentrations after which data were output with nominal date of January 1850.",
                                "v20120907annualinitialization_method": "1",
                                "v20120907annualparent_experiment_id": "N/A",
                                "v20120907annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120907annualfrequency": "yr",
                                "v20120907annualETCCDI_software_version": "0.6.2",
                                "v20120907annualinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120907annualmodel_id": "CMCC-CESM",
                                "v20120907annualexperiment_id": "historical",
                                "v20120907annualparent_experiment": "N/A",
                                "v20120907annualcontact": "bronaugh@uvic.ca",
                                "v20120907annualCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120907annualCMCC_contact": "Marcello Vichi (marcello.vichi@cmcc.it)",
                                "v20120907annualnco_openmp_thread_number": "1",
                                "v20120907annualinput_title": "CMCC-CESM model output prepared for CMIP5 historical",
                                "v20120907annualinput_frequency": "day",
                                "v20120907annualexperiment": "historical",
                                "iridlhasSemantics": "iridl:CMCC-CESM",
                                "Conventions": "IRIDL"
                            },
                            "v20120907": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120907",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CMCC-CESM"
                        },
                        "CMCCCM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMCC-CM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120514monthlycmor_version": "2.7.1",
                                "v20120514monthlyETCCDI_software": "climdex.pcic",
                                "v20120514monthlyCMCC_contact": "Silvio Gualdi (gualdi@bo.ingv.it)",
                                "v20120514monthlyinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti",
                                "v20120514monthlyinput_title": "CMCC-CM model output prepared for CMIP5 historical",
                                "v20120514monthlyforcing": "Nat,Ant,GHG,SA,TO,Sl",
                                "v20120514monthlynco_openmp_thread_number": "1",
                                "v20120514monthlyproduct": "output",
                                "v20120514monthlycomment": "simulation starting at the end of the piControl run, thus after 600+300=900 years spin-up at pre-industrial GHG concentrations",
                                "v20120514monthlyexperiment_id": "historical",
                                "v20120514monthlyCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120514monthlyinput_frequency": "day",
                                "v20120514monthlysource": "CMCC-CM",
                                "v20120514monthlyrealization": "1",
                                "v20120514monthlyexperiment": "historical",
                                "v20120514monthlyparent_experiment_id": "piControl",
                                "v20120514monthlyConventions": "CF-1.4",
                                "v20120514monthlyparent_experiment": "pre-industrial control",
                                "v20120514monthlybranch_time": "109562.0",
                                "v20120514monthlyinput_creation_date": "2011-11-30T13:27:25Z",
                                "v20120514monthlyfrequency": "monClim",
                                "v20120514monthlytitle": "ETCCDI indices computed on CMCC-CM model output prepared for CMIP5 historical",
                                "v20120514monthlyproject_id": "CMIP5",
                                "v20120514monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120514monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120514monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120514monthlymodel_id": "CMCC-CM",
                                "v20120514monthlycreation_date": "2012-07-20T18:12:58Z",
                                "v20120514monthlyinitialization_method": "1",
                                "v20120514monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120514monthlycontact": "bronaugh@uvic.ca",
                                "v20120514monthlymodeling_realm": "atmos",
                                "v20120514monthlyparent_experiment_rip": "N/A",
                                "v20120514monthlyinstitute_id": "CMCC",
                                "v20120514monthlyinput_tracking_id": "d2fb6b9d-f2b1-42fe-991c-892d40a7fb8f",
                                "v20120514monthlyETCCDI_software_version": "0.6.1",
                                "v20120514monthlyETCCDI_institution_id": "PCIC",
                                "v20120514monthlyphysics_version": "1",
                                "v20120514annualcmor_version": "2.7.1",
                                "v20120514annualETCCDI_software": "climdex.pcic",
                                "v20120514annualCMCC_contact": "Silvio Gualdi (gualdi@bo.ingv.it)",
                                "v20120514annualinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti",
                                "v20120514annualinput_title": "CMCC-CM model output prepared for CMIP5 historical",
                                "v20120514annualforcing": "Nat,Ant,GHG,SA,TO,Sl",
                                "v20120514annualnco_openmp_thread_number": "1",
                                "v20120514annualproduct": "output",
                                "v20120514annualcomment": "simulation starting at the end of the piControl run, thus after 600+300=900 years spin-up at pre-industrial GHG concentrations",
                                "v20120514annualexperiment_id": "historical",
                                "v20120514annualCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120514annualinput_frequency": "day",
                                "v20120514annualsource": "CMCC-CM",
                                "v20120514annualrealization": "1",
                                "v20120514annualexperiment": "historical",
                                "v20120514annualparent_experiment_id": "piControl",
                                "v20120514annualConventions": "CF-1.4",
                                "v20120514annualparent_experiment": "pre-industrial control",
                                "v20120514annualbranch_time": "109562.0",
                                "v20120514annualinput_creation_date": "2011-11-30T13:27:25Z",
                                "v20120514annualfrequency": "yr",
                                "v20120514annualtitle": "ETCCDI indices computed on CMCC-CM model output prepared for CMIP5 historical",
                                "v20120514annualproject_id": "CMIP5",
                                "v20120514annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120514annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120514annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120514annualmodel_id": "CMCC-CM",
                                "v20120514annualcreation_date": "2012-07-21T11:41:31Z",
                                "v20120514annualinitialization_method": "1",
                                "v20120514annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120514annualcontact": "bronaugh@uvic.ca",
                                "v20120514annualmodeling_realm": "atmos",
                                "v20120514annualparent_experiment_rip": "N/A",
                                "v20120514annualinstitute_id": "CMCC",
                                "v20120514annualinput_tracking_id": "d2fb6b9d-f2b1-42fe-991c-892d40a7fb8f",
                                "v20120514annualETCCDI_software_version": "0.6.1",
                                "v20120514annualETCCDI_institution_id": "PCIC",
                                "v20120514annualphysics_version": "1",
                                "iridlhasSemantics": "iridl:CMCC-CM",
                                "Conventions": "IRIDL"
                            },
                            "v20120514": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120514",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CMCC-CM"
                        },
                        "CMCCCMS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMCC-CMS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120717monthlynco_openmp_thread_number": "1",
                                "v20120717monthlyCMCC_contact": "Chiara Cagnazzo (chiara.cagnazzo@cmcc.it)",
                                "v20120717monthlycomment": "Equilibrium reached after more than 1500-year spin-up at pre-industrial GHG concentrations after which data were output with nominal date of January 1850. The starting point was the same as that of the piControl experiment (r1i1p1).",
                                "v20120717monthlyproduct": "output",
                                "v20120717monthlyparent_experiment_rip": "N/A",
                                "v20120717monthlyfrequency": "monClim",
                                "v20120717monthlyinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120717monthlyrealization": "1",
                                "v20120717monthlyparent_experiment_id": "N/A",
                                "v20120717monthlyparent_experiment": "N/A",
                                "v20120717monthlycreation_date": "2013-04-18T20:04:00Z",
                                "v20120717monthlysource": "CMCC-CMS",
                                "v20120717monthlyinitialization_method": "1",
                                "v20120717monthlyETCCDI_institution_id": "PCIC",
                                "v20120717monthlyConventions": "CF-1.4",
                                "v20120717monthlyproject_id": "CMIP5",
                                "v20120717monthlyinput_frequency": "day",
                                "v20120717monthlyinstitute_id": "CMCC",
                                "v20120717monthlyETCCDI_software_version": "0.6.2",
                                "v20120717monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120717monthlytitle": "ETCCDI indices computed on CMCC-CMS model output prepared for CMIP5 historical",
                                "v20120717monthlyexperiment": "historical",
                                "v20120717monthlymodel_id": "CMCC-CMS",
                                "v20120717monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120717monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120717monthlyexperiment_id": "historical",
                                "v20120717monthlycontact": "bronaugh@uvic.ca",
                                "v20120717monthlyphysics_version": "1",
                                "v20120717monthlycmor_version": "2.7.1",
                                "v20120717monthlymodeling_realm": "atmos",
                                "v20120717monthlyETCCDI_software": "climdex.pcic",
                                "v20120717monthlybranch_time": "0.0",
                                "v20120717monthlyinput_tracking_id": "510f0118-dedf-42e2-a11a-71de71573348",
                                "v20120717monthlyforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120717monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120717monthlyinput_creation_date": "2011-10-18T19:44:33Z",
                                "v20120717monthlyinput_title": "CMCC-CMS model output prepared for CMIP5 historical",
                                "v20120717monthlyCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120717annualnco_openmp_thread_number": "1",
                                "v20120717annualCMCC_contact": "Chiara Cagnazzo (chiara.cagnazzo@cmcc.it)",
                                "v20120717annualcomment": "Equilibrium reached after more than 1500-year spin-up at pre-industrial GHG concentrations after which data were output with nominal date of January 1850. The starting point was the same as that of the piControl experiment (r1i1p1).",
                                "v20120717annualproduct": "output",
                                "v20120717annualparent_experiment_rip": "N/A",
                                "v20120717annualfrequency": "yr",
                                "v20120717annualinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120717annualrealization": "1",
                                "v20120717annualparent_experiment_id": "N/A",
                                "v20120717annualparent_experiment": "N/A",
                                "v20120717annualcreation_date": "2013-04-18T17:29:34Z",
                                "v20120717annualsource": "CMCC-CMS",
                                "v20120717annualinitialization_method": "1",
                                "v20120717annualETCCDI_institution_id": "PCIC",
                                "v20120717annualConventions": "CF-1.4",
                                "v20120717annualproject_id": "CMIP5",
                                "v20120717annualinput_frequency": "day",
                                "v20120717annualinstitute_id": "CMCC",
                                "v20120717annualETCCDI_software_version": "0.6.2",
                                "v20120717annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120717annualtitle": "ETCCDI indices computed on CMCC-CMS model output prepared for CMIP5 historical",
                                "v20120717annualexperiment": "historical",
                                "v20120717annualmodel_id": "CMCC-CMS",
                                "v20120717annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120717annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120717annualcontact": "bronaugh@uvic.ca",
                                "v20120717annualexperiment_id": "historical",
                                "v20120717annualphysics_version": "1",
                                "v20120717annualcmor_version": "2.7.1",
                                "v20120717annualmodeling_realm": "atmos",
                                "v20120717annualETCCDI_software": "climdex.pcic",
                                "v20120717annualbranch_time": "0.0",
                                "v20120717annualinput_tracking_id": "510f0118-dedf-42e2-a11a-71de71573348",
                                "v20120717annualforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120717annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120717annualinput_creation_date": "2011-10-18T19:44:33Z",
                                "v20120717annualinput_title": "CMCC-CMS model output prepared for CMIP5 historical",
                                "v20120717annualCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "iridlhasSemantics": "iridl:CMCC-CMS",
                                "Conventions": "IRIDL"
                            },
                            "v20120717": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120717",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CMCC-CMS"
                        },
                        "CNRMCM5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CNRM-CM5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyinstitution": "CNRM (Centre National de Recherches Meteorologiques, Meteo-France, Toulouse,France) and CERFACS (Centre Europeen de Recherches et de Formation Avancee en Calcul Scientifique, Toulouse, France)",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyinstitute_id": "CNRM-CERFACS",
                                "mult_versionsmonthlyinput_creation_date": "2011-04-07T06:38:40Z",
                                "mult_versionsmonthlycmor_version": "2.5.3",
                                "mult_versionsmonthlyinput_title": "CNRM-CM5 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlytable_id": "Table day (31 January 2011) 43a867c1fea438258e3971754e4dacea",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlycreation_date": "2012-07-13T22:16:02Z",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlysource": "CNRM-CM5 2010 Atmosphere: ARPEGE-Climat (V5.2.1, TL127L31); Ocean: NEMO (nemo3.3.v10.6.6P, ORCA1degL42); Sea Ice: GELATO (V5.30); River Routing: TRIP (v1); Land: SURFEX (v5.1.c); Coupler : OASIS 3",
                                "mult_versionsmonthlycomment": "Soil layers depth scheme is specific for mrlsl and tsl - see variable-level comments. Atmosphere vertical hybrid coordinate : a_bnds and b_bnds arrays are correct, but a and b values provided are mid-sum of a_bnds and b_bnds, which is a poor approximation compared to the hydrostatic approximation actually used in the model.",
                                "mult_versionsmonthlymodel_id": "CNRM-CM5",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyparent_experiment_rip": "N/A",
                                "mult_versionsmonthlyinput_tracking_id": "cd7cec78-19cb-412b-a863-a2d16951f240",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on CNRM-CM5 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyforcing": "N/A",
                                "mult_versionsmonthlyparent_experiment": "N/A",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyCNRMCERFACS_contact": "for all but decadal predictions : contact.CMIP5@meteo.fr - METEO-FRANCE, CNRM/GMGEC/ASTER, CNRS URA 1357, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1 /for decadal predictions : contact.CMIP5@cerfacs.fr - CERFACS, Climate Modelling And Global Change, URA CERFACS/CNRS No1875, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1",
                                "mult_versionsmonthlybranch_time": "0.0",
                                "mult_versionsmonthlyCNRMCERFACS_references": "See http://www.cnrm.meteo.fr/cmip5 - Follow model description link",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyparent_experiment_id": "N/A",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualinstitution": "CNRM (Centre National de Recherches Meteorologiques, Meteo-France, Toulouse,France) and CERFACS (Centre Europeen de Recherches et de Formation Avancee en Calcul Scientifique, Toulouse, France)",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualinstitute_id": "CNRM-CERFACS",
                                "mult_versionsannualinput_creation_date": "2011-04-07T06:38:40Z",
                                "mult_versionsannualcmor_version": "2.5.3",
                                "mult_versionsannualinput_title": "CNRM-CM5 model output prepared for CMIP5 historical",
                                "mult_versionsannualtable_id": "Table day (31 January 2011) 43a867c1fea438258e3971754e4dacea",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualcreation_date": "2012-07-14T16:54:17Z",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualsource": "CNRM-CM5 2010 Atmosphere: ARPEGE-Climat (V5.2.1, TL127L31); Ocean: NEMO (nemo3.3.v10.6.6P, ORCA1degL42); Sea Ice: GELATO (V5.30); River Routing: TRIP (v1); Land: SURFEX (v5.1.c); Coupler : OASIS 3",
                                "mult_versionsannualcomment": "Soil layers depth scheme is specific for mrlsl and tsl - see variable-level comments. Atmosphere vertical hybrid coordinate : a_bnds and b_bnds arrays are correct, but a and b values provided are mid-sum of a_bnds and b_bnds, which is a poor approximation compared to the hydrostatic approximation actually used in the model.",
                                "mult_versionsannualmodel_id": "CNRM-CM5",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualparent_experiment_rip": "N/A",
                                "mult_versionsannualinput_tracking_id": "cd7cec78-19cb-412b-a863-a2d16951f240",
                                "mult_versionsannualtitle": "ETCCDI indices computed on CNRM-CM5 model output prepared for CMIP5 historical",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualforcing": "N/A",
                                "mult_versionsannualparent_experiment": "N/A",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualCNRMCERFACS_contact": "for all but decadal predictions : contact.CMIP5@meteo.fr - METEO-FRANCE, CNRM/GMGEC/ASTER, CNRS URA 1357, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1 /for decadal predictions : contact.CMIP5@cerfacs.fr - CERFACS, Climate Modelling And Global Change, URA CERFACS/CNRS No1875, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1",
                                "mult_versionsannualbranch_time": "0.0",
                                "mult_versionsannualCNRMCERFACS_references": "See http://www.cnrm.meteo.fr/cmip5 - Follow model description link",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualparent_experiment_id": "N/A",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "iridlhasSemantics": "iridl:CNRM-CM5",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.40625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CNRM-CM5"
                        },
                        "CSIROMk360": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CSIRO-Mk3-6-0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlyinput_tracking_id": "2a96df5f-1e8a-464d-8fa3-d7ddba8402c8",
                                "v1monthlyCSIROQCCCE_references": "a. Rotstayn, L., Collier, M., Dix, M., Feng, Y., Gordon, H., O\\\\\\'Farrell, S., Smith, I. and Syktus, J. 2010. Improved simulation of Australian climate and ENSO-related climate variability in a GCM with an interactive aerosol treatment. Int. J. Climatology, vol 30(7), pp1067-1088, DOI 10.1002/joc.1952 b. Please refer to online documentation at: http://cmip-pcmdi.llnl.gov/cmip5/",
                                "v1monthlyproduct": "output",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyETCCDI_software_version": "0.6.1",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlytable_id": "Table day (27 April 2011) bf45c74b31f20daf85ca72b20a6007b7",
                                "v1monthlysource": "CSIRO-Mk3-6-0 2010 atmosphere: AGCM v7.3.8 (T63 spectral, 1.875 degrees EW x approx. 1.875 degrees NS, 18 levels); ocean: GFDL MOM2.2 (1.875 degrees EW x approx. 0.9375 degrees NS, 31 levels)",
                                "v1monthlyCSIROQCCCE_contact": "Project leaders: Stephen Jeffrey (Stephen.Jeffrey@climatechange.qld.gov.au) and Leon Rotstayn (Leon.Rotstayn@csiro.au). Technical team: Mark Collier (Mark.Collier@csiro.au, diagnostics and post-processing), Stacey Dravitzki (Stacey.Dravitzki@csiro.au, post-processing), Hal Gordon (Hal.Gordon@csiro.au, atmosphere dynamics), Carlo Hamalainen (Carlo.Hamalainen@climatechange.qld.gov.au, post-processing), Tony Hirst (Tony.Hirst@csiro.au, ocean model), Stephen Jeffrey (Stephen.Jeffrey@climatechange.qld.gov.au, experimental design, modelling operations and post-processing), Eva Kowalczyk (Eva.Kowalczyk@csiro.au, land-surface), Siobhan O\\\\\\'Farrell (Sibohan.O\\\\\\'Farrell@csiro.au, ocean model, sea-ice and ocean diagnostics) Leon Rotstayn (Leon.Rotstayn@csiro.au, atmospheric physics), Kenneth Wong (Kenneth Wong@climatechange.qld.gov.au, data management and diagnostics)",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlymodel_id": "CSIRO-Mk3-6-0",
                                "v1monthlycmor_version": "2.6.0",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlyphysics_version": "1",
                                "v1monthlyfrequency": "monClim",
                                "v1monthlytitle": "ETCCDI indices computed on CSIRO-Mk3-6-0 model output prepared for CMIP5 historical",
                                "v1monthlycomment": "Model output post-processed by the CSIRO-QCCCE CMIP5 Data post-processor for the IPCC Fifth Assessment.",
                                "v1monthlyparent_experiment": "pre-industrial control",
                                "v1monthlyinput_title": "CSIRO-Mk3-6-0 model output prepared for CMIP5 historical",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlyexperiment": "historical",
                                "v1monthlybranch_time": "29200.0",
                                "v1monthlyinput_creation_date": "2011-07-27T02:39:19Z",
                                "v1monthlyexperiment_id": "historical",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlyforcing": "Ant,Nat (all forcings)",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlyinstitute_id": "CSIRO-QCCCE",
                                "v1monthlyparent_experiment_id": "piControl",
                                "v1monthlycreation_date": "2012-07-14T08:45:50Z",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlyversion_number": "v20110518",
                                "v1monthlyinstitution": "Australian Commonwealth Scientific and Industrial Research Organization (CSIRO) Marine and Atmospheric Research (Melbourne, Australia) in collaboration with the Queensland Climate Change Centre of Excellence (QCCCE) (Brisbane, Australia)",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1annualproject_id": "CMIP5",
                                "v1annualinput_tracking_id": "2a96df5f-1e8a-464d-8fa3-d7ddba8402c8",
                                "v1annualCSIROQCCCE_references": "a. Rotstayn, L., Collier, M., Dix, M., Feng, Y., Gordon, H., O\\\\\\'Farrell, S., Smith, I. and Syktus, J. 2010. Improved simulation of Australian climate and ENSO-related climate variability in a GCM with an interactive aerosol treatment. Int. J. Climatology, vol 30(7), pp1067-1088, DOI 10.1002/joc.1952 b. Please refer to online documentation at: http://cmip-pcmdi.llnl.gov/cmip5/",
                                "v1annualproduct": "output",
                                "v1annualinput_frequency": "day",
                                "v1annualETCCDI_software_version": "0.6.1",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualtable_id": "Table day (27 April 2011) bf45c74b31f20daf85ca72b20a6007b7",
                                "v1annualsource": "CSIRO-Mk3-6-0 2010 atmosphere: AGCM v7.3.8 (T63 spectral, 1.875 degrees EW x approx. 1.875 degrees NS, 18 levels); ocean: GFDL MOM2.2 (1.875 degrees EW x approx. 0.9375 degrees NS, 31 levels)",
                                "v1annualCSIROQCCCE_contact": "Project leaders: Stephen Jeffrey (Stephen.Jeffrey@climatechange.qld.gov.au) and Leon Rotstayn (Leon.Rotstayn@csiro.au). Technical team: Mark Collier (Mark.Collier@csiro.au, diagnostics and post-processing), Stacey Dravitzki (Stacey.Dravitzki@csiro.au, post-processing), Hal Gordon (Hal.Gordon@csiro.au, atmosphere dynamics), Carlo Hamalainen (Carlo.Hamalainen@climatechange.qld.gov.au, post-processing), Tony Hirst (Tony.Hirst@csiro.au, ocean model), Stephen Jeffrey (Stephen.Jeffrey@climatechange.qld.gov.au, experimental design, modelling operations and post-processing), Eva Kowalczyk (Eva.Kowalczyk@csiro.au, land-surface), Siobhan O\\\\\\'Farrell (Sibohan.O\\\\\\'Farrell@csiro.au, ocean model, sea-ice and ocean diagnostics) Leon Rotstayn (Leon.Rotstayn@csiro.au, atmospheric physics), Kenneth Wong (Kenneth Wong@climatechange.qld.gov.au, data management and diagnostics)",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualmodel_id": "CSIRO-Mk3-6-0",
                                "v1annualcmor_version": "2.6.0",
                                "v1annualConventions": "CF-1.4",
                                "v1annualphysics_version": "1",
                                "v1annualtitle": "ETCCDI indices computed on CSIRO-Mk3-6-0 model output prepared for CMIP5 historical",
                                "v1annualfrequency": "yr",
                                "v1annualcomment": "Model output post-processed by the CSIRO-QCCCE CMIP5 Data post-processor for the IPCC Fifth Assessment.",
                                "v1annualparent_experiment": "pre-industrial control",
                                "v1annualinput_title": "CSIRO-Mk3-6-0 model output prepared for CMIP5 historical",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualinitialization_method": "1",
                                "v1annualexperiment": "historical",
                                "v1annualbranch_time": "29200.0",
                                "v1annualinput_creation_date": "2011-07-27T02:39:19Z",
                                "v1annualexperiment_id": "historical",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualforcing": "Ant,Nat (all forcings)",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualinstitute_id": "CSIRO-QCCCE",
                                "v1annualparent_experiment_id": "piControl",
                                "v1annualcreation_date": "2012-07-14T14:37:56Z",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualversion_number": "v20110518",
                                "v1annualinstitution": "Australian Commonwealth Scientific and Industrial Research Organization (CSIRO) Marine and Atmospheric Research (Melbourne, Australia) in collaboration with the Queensland Climate Change Centre of Excellence (QCCCE) (Brisbane, Australia)",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "iridlhasSemantics": "iridl:CSIRO-Mk3-6-0",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CSIRO-Mk3-6-0"
                        },
                        "CanCM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CanCM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyCCCma_runid": "DHFP1N_E009",
                                "mult_versionsmonthlytable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinput_title": "CanCM4 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "mult_versionsmonthlyinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "mult_versionsmonthlyCCCma_parent_runid": "IGA",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlysource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
                                "mult_versionsmonthlycomment": "These experiments serve as unitialized comparisons for CCCma CanCM4 decadal experiments.",
                                "mult_versionsmonthlymodel_id": "CanCM4",
                                "mult_versionsmonthlyCCCma_contact": "cccma_info@ec.gc.ca",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyinstitute_id": "CCCma",
                                "mult_versionsmonthlycreation_date": "2013-04-18T17:20:59Z",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on CanCM4 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlybranch_time_YMDH": "2521:01:01:00",
                                "mult_versionsmonthlybranch_time": "244915.0",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlycmor_version": "2.8.0",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinput_creation_date": "2012-02-01T01:08:03Z",
                                "mult_versionsmonthlyCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.2",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsannualCCCma_runid": "DHFP1N_E009",
                                "mult_versionsannualtable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinput_title": "CanCM4 model output prepared for CMIP5 historical",
                                "mult_versionsannualforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "mult_versionsannualinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "mult_versionsannualCCCma_parent_runid": "IGA",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualsource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
                                "mult_versionsannualcomment": "These experiments serve as unitialized comparisons for CCCma CanCM4 decadal experiments.",
                                "mult_versionsannualCCCma_contact": "cccma_info@ec.gc.ca",
                                "mult_versionsannualmodel_id": "CanCM4",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualhistory": "2012-02-01T01:08:03Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualinstitute_id": "CCCma",
                                "mult_versionsannualcreation_date": "2013-04-18T17:21:22Z",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualtitle": "ETCCDI indices computed on CanCM4 model output prepared for CMIP5 historical",
                                "mult_versionsannualbranch_time_YMDH": "2521:01:01:00",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualbranch_time": "244915.0",
                                "mult_versionsannualcmor_version": "2.8.0",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinput_creation_date": "2012-02-01T01:08:03Z",
                                "mult_versionsannualCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "mult_versionsannualETCCDI_software_version": "0.6.2",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "iridlhasSemantics": "iridl:CanCM4",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CanCM4"
                        },
                        "CanESM2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CanESM2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120410monthlycmor_version": "2.5.4",
                                "v20120410monthlymodeling_realm": "atmos",
                                "v20120410monthlyinput_creation_date": "2011-04-11T02:07:07Z",
                                "v20120410monthlyCCCma_runid": "IEC",
                                "v20120410monthlyETCCDI_software": "climdex.pcic",
                                "v20120410monthlyETCCDI_software_version": "0.6.1",
                                "v20120410monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120410monthlyproduct": "output",
                                "v20120410monthlyCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "v20120410monthlyexperiment": "historical",
                                "v20120410monthlycontact": "bronaugh@uvic.ca",
                                "v20120410monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120410monthlysource": "CanESM2 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) and CMOC1.2 sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7 and CTEM1",
                                "v20120410monthlyinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "v20120410monthlybranch_time_YMDH": "2121:01:01:00",
                                "v20120410monthlyConventions": "CF-1.4",
                                "v20120410monthlyCCCma_contact": "cccma_info@ec.gc.ca",
                                "v20120410monthlyparent_experiment_id": "piControl",
                                "v20120410monthlyCCCma_parent_runid": "IGA",
                                "v20120410monthlytitle": "ETCCDI indices computed on CanESM2 model output prepared for CMIP5 historical",
                                "v20120410monthlymodel_id": "CanESM2",
                                "v20120410monthlyinstitute_id": "CCCma",
                                "v20120410monthlyphysics_version": "1",
                                "v20120410monthlyCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "v20120410monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120410monthlybranch_time": "98915.0",
                                "v20120410monthlyETCCDI_institution_id": "PCIC",
                                "v20120410monthlytable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "v20120410monthlyparent_experiment": "pre-industrial control",
                                "v20120410monthlyfrequency": "mon",
                                "v20120410monthlyproject_id": "CMIP5",
                                "v20120410monthlyinput_title": "CanESM2 model output prepared for CMIP5 historical",
                                "v20120410monthlyinput_frequency": "day",
                                "v20120410monthlyforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "v20120410monthlyexperiment_id": "historical",
                                "v20120410monthlyinitialization_method": "1",
                                "v20120410monthlycreation_date": "2012-07-14T12:51:52Z",
                                "v20120410annualcmor_version": "2.5.4",
                                "v20120410annualmodeling_realm": "atmos",
                                "v20120410annualinput_creation_date": "2011-04-11T02:07:07Z",
                                "v20120410annualETCCDI_software_version": "0.6.1",
                                "v20120410annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120410annualETCCDI_software": "climdex.pcic",
                                "v20120410annualCCCma_runid": "IEC",
                                "v20120410annualproduct": "output",
                                "v20120410annualCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "v20120410annualexperiment": "historical",
                                "v20120410annualcontact": "bronaugh@uvic.ca",
                                "v20120410annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120410annualsource": "CanESM2 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) and CMOC1.2 sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7 and CTEM1",
                                "v20120410annualinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "v20120410annualbranch_time_YMDH": "2121:01:01:00",
                                "v20120410annualConventions": "CF-1.4",
                                "v20120410annualCCCma_contact": "cccma_info@ec.gc.ca",
                                "v20120410annualparent_experiment_id": "piControl",
                                "v20120410annualCCCma_parent_runid": "IGA",
                                "v20120410annualtitle": "ETCCDI indices computed on CanESM2 model output prepared for CMIP5 historical",
                                "v20120410annualmodel_id": "CanESM2",
                                "v20120410annualinstitute_id": "CCCma",
                                "v20120410annualphysics_version": "1",
                                "v20120410annualCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "v20120410annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120410annualbranch_time": "98915.0",
                                "v20120410annualETCCDI_institution_id": "PCIC",
                                "v20120410annualtable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "v20120410annualparent_experiment": "pre-industrial control",
                                "v20120410annualfrequency": "yr",
                                "v20120410annualproject_id": "CMIP5",
                                "v20120410annualinput_title": "CanESM2 model output prepared for CMIP5 historical",
                                "v20120410annualinput_frequency": "day",
                                "v20120410annualforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "v20120410annualexperiment_id": "historical",
                                "v20120410annualinitialization_method": "1",
                                "v20120410annualcreation_date": "2012-07-14T12:50:47Z",
                                "iridlhasSemantics": "iridl:CanESM2",
                                "Conventions": "IRIDL"
                            },
                            "v20120410": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120410",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/CanESM2"
                        },
                        "ECEARTH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EC-EARTH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlymodel_id": "EC-EARTH",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinput_title": "EC-EARTH model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyforcing": "Nat,Ant",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlycomment": "SMHI contact klaus.wyser-at-smhi.se",
                                "mult_versionsmonthlysource": "EC-EARTH 2.3 (2011); atmosphere: IFS (cy31R1+modifications, T159L62); ocean: NEMO (version2+modifications, ORCA1-42lev); sea ice: LIM2; land: HTessel",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlyICHEC_contact": "Alastair McKinstry ",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyICHEC_references": "Model described by Hazeleger et al. (Bull. Amer. Meteor. Soc., 2010, 91, 1357-1363). Also see http://ecearth.knmi.nl.",
                                "mult_versionsmonthlyinput_creation_date": "2012-03-21T09:16:44Z",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on EC-EARTH model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlycreation_date": "2013-06-28T17:04:50Z",
                                "mult_versionsmonthlyinstitute_id": "ICHEC",
                                "mult_versionsmonthlyinstitution": "EC-EARTH (European Earth System Model)",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) 0640f2bc62aad4ebefa8ecc119311890",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlybranch_time": "2265.0",
                                "mult_versionsmonthlycmor_version": "2.8.0",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyinput_tracking_id": "a02add71-5c5f-4c91-864b-0408bca4d9ff",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualmodel_id": "EC-EARTH",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinput_title": "EC-EARTH model output prepared for CMIP5 historical",
                                "mult_versionsannualforcing": "Nat,Ant",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualcomment": "SMHI contact klaus.wyser-at-smhi.se",
                                "mult_versionsannualsource": "EC-EARTH 2.3 (2011); atmosphere: IFS (cy31R1+modifications, T159L62); ocean: NEMO (version2+modifications, ORCA1-42lev); sea ice: LIM2; land: HTessel",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualICHEC_contact": "Alastair McKinstry ",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualICHEC_references": "Model described by Hazeleger et al. (Bull. Amer. Meteor. Soc., 2010, 91, 1357-1363). Also see http://ecearth.knmi.nl.",
                                "mult_versionsannualinput_creation_date": "2012-03-21T09:16:44Z",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualtitle": "ETCCDI indices computed on EC-EARTH model output prepared for CMIP5 historical",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitute_id": "ICHEC",
                                "mult_versionsannualcreation_date": "2013-06-28T13:43:35Z",
                                "mult_versionsannualinstitution": "EC-EARTH (European Earth System Model)",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) 0640f2bc62aad4ebefa8ecc119311890",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualbranch_time": "2265.0",
                                "mult_versionsannualcmor_version": "2.8.0",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualinput_tracking_id": "a02add71-5c5f-4c91-864b-0408bca4d9ff",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "iridlhasSemantics": "iridl:EC-EARTH",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "7.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "7.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "7.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/EC-EARTH"
                        },
                        "FGOALSg2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FGOALS-g2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyinput_title": "FGOALS_g2 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlybranch_time": "160235.0",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyinput_creation_date": "2013-01-21T09:46:22Z",
                                "mult_versionsmonthlysource": "FGOALS_g2 2011 atmosphere: GAMIL (gamil2, 128x60L26); ocean: LICOM (licom2, 360x196L30); ice: CICE (cice4_lasg, 360x196L4); land: CLM (clm3, 128x60)",
                                "mult_versionsmonthlycomment": "N/A",
                                "mult_versionsmonthlyLASGCESS_contact": "Dr. Tianjun ZHOU, Email: zhoutj@lasg.iap.ac.cn",
                                "mult_versionsmonthlyinput_tracking_id": "0a2a7cd1-a384-4f88-af18-d716f6dbece1",
                                "mult_versionsmonthlymodel_id": "FGOALS_g2",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on FGOALS_g2 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlycreation_date": "2013-04-19T00:22:12Z",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyforcing": "GHG,Oz,SA,BC,Ds,OC,SS,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Aerosol also includes sulfate.)",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyinstitution": "IAP (Institute of Atmospheric Physics, Chinese Academy of Sciences, Beijing, China) and THU (Tsinghua University)",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.2",
                                "mult_versionsmonthlyinstitute_id": "LASG-CESS",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyLASGCESS_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsannualinput_title": "FGOALS_g2 model output prepared for CMIP5 historical",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualbranch_time": "160235.0",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualinput_creation_date": "2013-01-21T09:46:22Z",
                                "mult_versionsannualsource": "FGOALS_g2 2011 atmosphere: GAMIL (gamil2, 128x60L26); ocean: LICOM (licom2, 360x196L30); ice: CICE (cice4_lasg, 360x196L4); land: CLM (clm3, 128x60)",
                                "mult_versionsannualcomment": "N/A",
                                "mult_versionsannualLASGCESS_contact": "Dr. Tianjun ZHOU, Email: zhoutj@lasg.iap.ac.cn",
                                "mult_versionsannualinput_tracking_id": "0a2a7cd1-a384-4f88-af18-d716f6dbece1",
                                "mult_versionsannualmodel_id": "FGOALS_g2",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualtitle": "ETCCDI indices computed on FGOALS_g2 model output prepared for CMIP5 historical",
                                "mult_versionsannualcreation_date": "2013-04-19T00:01:56Z",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualforcing": "GHG,Oz,SA,BC,Ds,OC,SS,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Aerosol also includes sulfate.)",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualinstitution": "IAP (Institute of Atmospheric Physics, Chinese Academy of Sciences, Beijing, China) and THU (Tsinghua University)",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualETCCDI_software_version": "0.6.2",
                                "mult_versionsannualinstitute_id": "LASG-CESS",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualLASGCESS_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "iridlhasSemantics": "iridl:FGOALS-g2",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "2.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "2.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 0001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 0001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "2.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/FGOALS-g2"
                        },
                        "FGOALSs2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FGOALS-s2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v2monthlybranch_time": "1300.0",
                                "v2monthlyfrequency": "monClim",
                                "v2monthlyexperiment": "historical",
                                "v2monthlyproduct": "output",
                                "v2monthlyinitialization_method": "1",
                                "v2monthlycreation_date": "2013-04-19T02:36:15Z",
                                "v2monthlyinstitute_id": "LASG-IAP",
                                "v2monthlyETCCDI_software": "climdex.pcic",
                                "v2monthlymodel_id": "FGOALS-s2",
                                "v2monthlyinput_tracking_id": "84b8d742-1f4b-4b0e-bc95-50b4473fa015",
                                "v2monthlymodeling_realm": "atmos",
                                "v2monthlyinput_frequency": "day",
                                "v2monthlysource": "FGOALS-s2 SAMIL 2-4-7",
                                "v2monthlyinstitution": "IAP(Institute of Atmospheric Physics),CAS(Chinese Academy of Sciences),Beijing,China",
                                "v2monthlyConventions": "CF-1.4",
                                "v2monthlyLASGIAP_contact": "Dr.Tianjun Zhou(zhoutj@lasg.iap.ac.cn)",
                                "v2monthlytitle": "ETCCDI indices computed on FGOALS-s2 model output prepared for CMIP5 historical",
                                "v2monthlyLASGIAP_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v2monthlynco_openmp_thread_number": "1",
                                "v2monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v2monthlyinput_title": "FGOALS-s2 model output prepared for CMIP5 historical",
                                "v2monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v2monthlyparent_experiment_id": "piControl",
                                "v2monthlytable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "v2monthlyphysics_version": "1",
                                "v2monthlycontact": "bronaugh@uvic.ca",
                                "v2monthlycmor_version": "2.5.1",
                                "v2monthlyinput_creation_date": "2011-09-20T01:03:54Z",
                                "v2monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v2monthlyparent_experiment": "pre-industrial control",
                                "v2monthlyexperiment_id": "historical",
                                "v2monthlyETCCDI_software_version": "0.6.2",
                                "v2monthlyETCCDI_institution_id": "PCIC",
                                "v2monthlyforcing": "GHG, SD, Oz, Sl, Vl, SS, Ds, BC, OC",
                                "v2monthlyproject_id": "CMIP5",
                                "v2annualbranch_time": "1300.0",
                                "v2annualfrequency": "yr",
                                "v2annualexperiment": "historical",
                                "v2annualproduct": "output",
                                "v2annualinitialization_method": "1",
                                "v2annualcreation_date": "2013-04-19T00:40:33Z",
                                "v2annualinstitute_id": "LASG-IAP",
                                "v2annualETCCDI_software": "climdex.pcic",
                                "v2annualmodel_id": "FGOALS-s2",
                                "v2annualinput_tracking_id": "84b8d742-1f4b-4b0e-bc95-50b4473fa015",
                                "v2annualmodeling_realm": "atmos",
                                "v2annualinput_frequency": "day",
                                "v2annualsource": "FGOALS-s2 SAMIL 2-4-7",
                                "v2annualinstitution": "IAP(Institute of Atmospheric Physics),CAS(Chinese Academy of Sciences),Beijing,China",
                                "v2annualConventions": "CF-1.4",
                                "v2annualLASGIAP_contact": "Dr.Tianjun Zhou(zhoutj@lasg.iap.ac.cn)",
                                "v2annualtitle": "ETCCDI indices computed on FGOALS-s2 model output prepared for CMIP5 historical",
                                "v2annualLASGIAP_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v2annualnco_openmp_thread_number": "1",
                                "v2annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v2annualinput_title": "FGOALS-s2 model output prepared for CMIP5 historical",
                                "v2annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v2annualparent_experiment_id": "piControl",
                                "v2annualtable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "v2annualphysics_version": "1",
                                "v2annualcontact": "bronaugh@uvic.ca",
                                "v2annualinput_creation_date": "2011-09-20T01:03:54Z",
                                "v2annualcmor_version": "2.5.1",
                                "v2annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v2annualparent_experiment": "pre-industrial control",
                                "v2annualexperiment_id": "historical",
                                "v2annualETCCDI_software_version": "0.6.2",
                                "v2annualETCCDI_institution_id": "PCIC",
                                "v2annualforcing": "GHG, SD, Oz, Sl, Vl, SS, Ds, BC, OC",
                                "v2annualproject_id": "CMIP5",
                                "iridlhasSemantics": "iridl:FGOALS-s2",
                                "Conventions": "IRIDL"
                            },
                            "v2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/FGOALS-s2"
                        },
                        "GFDLCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-CM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120227monthlyinstitute_id": "NOAA GFDL",
                                "v20120227monthlycreation_date": "2012-07-14T18:10:53Z",
                                "v20120227monthlyproduct": "output1",
                                "v20120227monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120227monthlymodel_id": "GFDL-CM3",
                                "v20120227monthlyNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20120227monthlyinitialization_method": "1",
                                "v20120227monthlyETCCDI_software": "climdex.pcic",
                                "v20120227monthlysource": "GFDL-CM3 2010 atmosphere: AM3 (AM3p9,C48L48); sea ice: SIS (SISp2,Tripolar360x200); land: LM3 (LM3p7_cCM3,C48); ocean: MOM4 (MOM4p1_x1_Z50_cCM3,Tripolar360x200L50)",
                                "v20120227monthlyNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20120227monthlyETCCDI_software_version": "0.6.1",
                                "v20120227monthlyexperiment": "historical",
                                "v20120227monthlyproject_id": "CMIP5",
                                "v20120227monthlyConventions": "CF-1.4",
                                "v20120227monthlynco_openmp_thread_number": "1",
                                "v20120227monthlytitle": "ETCCDI indices computed on NOAA GFDL GFDL-CM3, historical (run 1) experiment output for CMIP5 AR5",
                                "v20120227monthlyinput_creation_date": "2011-09-06T05:44:19Z",
                                "v20120227monthlycontact": "bronaugh@uvic.ca",
                                "v20120227monthlytable_id": "Table day (31 Jan 2011)",
                                "v20120227monthlyinput_title": "NOAA GFDL GFDL-CM3, historical (run 1) experiment output for CMIP5 AR5",
                                "v20120227monthlybranch_time": "0.0",
                                "v20120227monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120227monthlyinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20120227monthlygfdl_experiment_name": "CM3Z_D1_1860-2005_AllForc_H1",
                                "v20120227monthlyforcing": "GHG,SA,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20120227monthlymodeling_realm": "atmos",
                                "v20120227monthlyparent_experiment_id": "piControl",
                                "v20120227monthlyinput_frequency": "day",
                                "v20120227monthlyinput_tracking_id": "969e1aa2-a75e-4284-ae01-e603352b90b8",
                                "v20120227monthlyphysics_version": "1",
                                "v20120227monthlyfrequency": "monClim",
                                "v20120227monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120227monthlyexperiment_id": "historical",
                                "v20120227monthlyETCCDI_institution_id": "PCIC",
                                "v20120227monthlycomment": "timeseries or internally calculated emissions. This model includes direct and indirect aerosol effects.",
                                "v20120227annualinstitute_id": "NOAA GFDL",
                                "v20120227annualcreation_date": "2012-07-13T15:26:44Z",
                                "v20120227annualproduct": "output1",
                                "v20120227annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120227annualmodel_id": "GFDL-CM3",
                                "v20120227annualNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20120227annualinitialization_method": "1",
                                "v20120227annualETCCDI_software": "climdex.pcic",
                                "v20120227annualsource": "GFDL-CM3 2010 atmosphere: AM3 (AM3p9,C48L48); sea ice: SIS (SISp2,Tripolar360x200); land: LM3 (LM3p7_cCM3,C48); ocean: MOM4 (MOM4p1_x1_Z50_cCM3,Tripolar360x200L50)",
                                "v20120227annualNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20120227annualETCCDI_software_version": "0.6.1",
                                "v20120227annualexperiment": "historical",
                                "v20120227annualproject_id": "CMIP5",
                                "v20120227annualConventions": "CF-1.4",
                                "v20120227annualnco_openmp_thread_number": "1",
                                "v20120227annualinput_creation_date": "2011-09-06T05:44:19Z",
                                "v20120227annualtitle": "ETCCDI indices computed on NOAA GFDL GFDL-CM3, historical (run 1) experiment output for CMIP5 AR5",
                                "v20120227annualcontact": "bronaugh@uvic.ca",
                                "v20120227annualtable_id": "Table day (31 Jan 2011)",
                                "v20120227annualinput_title": "NOAA GFDL GFDL-CM3, historical (run 1) experiment output for CMIP5 AR5",
                                "v20120227annualbranch_time": "0.0",
                                "v20120227annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120227annualinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20120227annualgfdl_experiment_name": "CM3Z_D1_1860-2005_AllForc_H1",
                                "v20120227annualforcing": "GHG,SA,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20120227annualmodeling_realm": "atmos",
                                "v20120227annualparent_experiment_id": "piControl",
                                "v20120227annualinput_frequency": "day",
                                "v20120227annualinput_tracking_id": "969e1aa2-a75e-4284-ae01-e603352b90b8",
                                "v20120227annualphysics_version": "1",
                                "v20120227annualfrequency": "yr",
                                "v20120227annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120227annualexperiment_id": "historical",
                                "v20120227annualETCCDI_institution_id": "PCIC",
                                "v20120227annualcomment": "timeseries or internally calculated emissions. This model includes direct and indirect aerosol effects.",
                                "iridlhasSemantics": "iridl:GFDL-CM3",
                                "Conventions": "IRIDL"
                            },
                            "v20120227": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120227",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1860-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1860-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.0",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/GFDL-CM3"
                        },
                        "GFDLESM2G": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-ESM2G",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110601monthlytable_id": "Table day (31 Jan 2011)",
                                "v20110601monthlyinput_creation_date": "2011-11-19T18:23:26Z",
                                "v20110601monthlyNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20110601monthlyinitialization_method": "1",
                                "v20110601monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110601monthlyproduct": "output1",
                                "v20110601monthlyETCCDI_software": "climdex.pcic",
                                "v20110601monthlyinput_tracking_id": "375cd87e-9718-4348-8782-46389b7f5e7d",
                                "v20110601monthlyparent_experiment_rip": "r1i1p1",
                                "v20110601monthlyforcing": "GHG,SD,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20110601monthlycreation_date": "2012-07-14T19:36:24Z",
                                "v20110601monthlyinstitute_id": "NOAA GFDL",
                                "v20110601monthlyinput_frequency": "day",
                                "v20110601monthlysource": "GFDL-ESM2G 2010 ocean: TOPAZ (TOPAZ1p2,Tripolar360x210L63); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x210L63); land: LM3 (LM3p7_cESM,M45)",
                                "v20110601monthlyproject_id": "CMIP5",
                                "v20110601monthlyrealization": "1",
                                "v20110601monthlymodeling_realm": "atmos",
                                "v20110601monthlyConventions": "CF-1.4",
                                "v20110601monthlyfrequency": "monClim",
                                "v20110601monthlynco_openmp_thread_number": "1",
                                "v20110601monthlyinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20110601monthlycontact": "bronaugh@uvic.ca",
                                "v20110601monthlytitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2G, historical (run 1) experiment output for CMIP5 AR5",
                                "v20110601monthlyinput_title": "NOAA GFDL GFDL-ESM2G, historical (run 1) experiment output for CMIP5 AR5",
                                "v20110601monthlybranch_time": "58765",
                                "v20110601monthlycomment": "GFDL experiment name = ESM2G-C2_all_historical_HC2. PCMDI experiment name = historical (run1). Initial conditions for this experiment were taken from 1 January of year 1861 of the parent experiment, ESM2G-C2_1700-1860_historical_HC2, which is an unpublished experiment branched from 1 January of year 1 of 1860 control model experiment, ESM2G_pi-control_C2 (piControl). This parent experiment is an extension of piControl except historical transitions of land use are applied from 1700-1860 in order to allow the terrestrial carbon stores to respond to the imposition of land use and produce realistic fluxes by the start of the historical run in 1861. Several forcing agents varied during the 145 year duration of the ESM2G-C2_all_historical_HC2 experiment in a manner based upon observations and reconstructions for the late 19th and 20th centuries. The aerosol concentrations were computed by an off-line model. The time varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, aerosol concentrations (sulfate, black and organic carbon, sea salt, dust), volcanic aerosols, solar irradiance and land use transitions. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20110601monthlyETCCDI_institution_id": "PCIC",
                                "v20110601monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110601monthlyphysics_version": "1",
                                "v20110601monthlyNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20110601monthlyexperiment_id": "historical",
                                "v20110601monthlyparent_experiment_id": "historicalMisc",
                                "v20110601monthlymodel_id": "GFDL-ESM2G",
                                "v20110601monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110601monthlyETCCDI_software_version": "0.6.1",
                                "v20110601monthlyexperiment": "historical",
                                "v20110601monthlygfdl_experiment_name": "ESM2G-C2_all_historical_HC2",
                                "v20110601annualtable_id": "Table day (31 Jan 2011)",
                                "v20110601annualinput_creation_date": "2011-11-19T18:23:26Z",
                                "v20110601annualNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20110601annualinitialization_method": "1",
                                "v20110601annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110601annualproduct": "output1",
                                "v20110601annualETCCDI_software": "climdex.pcic",
                                "v20110601annualinput_tracking_id": "375cd87e-9718-4348-8782-46389b7f5e7d",
                                "v20110601annualparent_experiment_rip": "r1i1p1",
                                "v20110601annualforcing": "GHG,SD,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20110601annualcreation_date": "2012-07-13T15:26:47Z",
                                "v20110601annualinstitute_id": "NOAA GFDL",
                                "v20110601annualinput_frequency": "day",
                                "v20110601annualsource": "GFDL-ESM2G 2010 ocean: TOPAZ (TOPAZ1p2,Tripolar360x210L63); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x210L63); land: LM3 (LM3p7_cESM,M45)",
                                "v20110601annualproject_id": "CMIP5",
                                "v20110601annualrealization": "1",
                                "v20110601annualmodeling_realm": "atmos",
                                "v20110601annualConventions": "CF-1.4",
                                "v20110601annualinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20110601annualcontact": "bronaugh@uvic.ca",
                                "v20110601annualtitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2G, historical (run 1) experiment output for CMIP5 AR5",
                                "v20110601annualnco_openmp_thread_number": "1",
                                "v20110601annualfrequency": "yr",
                                "v20110601annualinput_title": "NOAA GFDL GFDL-ESM2G, historical (run 1) experiment output for CMIP5 AR5",
                                "v20110601annualbranch_time": "58765",
                                "v20110601annualcomment": "GFDL experiment name = ESM2G-C2_all_historical_HC2. PCMDI experiment name = historical (run1). Initial conditions for this experiment were taken from 1 January of year 1861 of the parent experiment, ESM2G-C2_1700-1860_historical_HC2, which is an unpublished experiment branched from 1 January of year 1 of 1860 control model experiment, ESM2G_pi-control_C2 (piControl). This parent experiment is an extension of piControl except historical transitions of land use are applied from 1700-1860 in order to allow the terrestrial carbon stores to respond to the imposition of land use and produce realistic fluxes by the start of the historical run in 1861. Several forcing agents varied during the 145 year duration of the ESM2G-C2_all_historical_HC2 experiment in a manner based upon observations and reconstructions for the late 19th and 20th centuries. The aerosol concentrations were computed by an off-line model. The time varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, aerosol concentrations (sulfate, black and organic carbon, sea salt, dust), volcanic aerosols, solar irradiance and land use transitions. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20110601annualETCCDI_institution_id": "PCIC",
                                "v20110601annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110601annualphysics_version": "1",
                                "v20110601annualNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20110601annualexperiment_id": "historical",
                                "v20110601annualparent_experiment_id": "historicalMisc",
                                "v20110601annualmodel_id": "GFDL-ESM2G",
                                "v20110601annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110601annualETCCDI_software_version": "0.6.1",
                                "v20110601annualexperiment": "historical",
                                "v20110601annualgfdl_experiment_name": "ESM2G-C2_all_historical_HC2",
                                "iridlhasSemantics": "iridl:GFDL-ESM2G",
                                "Conventions": "IRIDL"
                            },
                            "v20110601": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110601",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1861-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1861-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/GFDL-ESM2G"
                        },
                        "GFDLESM2M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-ESM2M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20111228monthlycreation_date": "2013-04-19T02:08:53Z",
                                "v20111228monthlyphysics_version": "1",
                                "v20111228monthlycontact": "bronaugh@uvic.ca",
                                "v20111228monthlyinput_tracking_id": "417b65fb-a619-406f-81f8-bb2173634139",
                                "v20111228monthlyinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20111228monthlyparent_experiment_rip": "r1i1p1",
                                "v20111228monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111228monthlyproduct": "output1",
                                "v20111228monthlyinitialization_method": "1",
                                "v20111228monthlyNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20111228monthlysource": "GFDL-ESM2M 2010 ocean: MOM4 (MOM4p1_x1_Z50_cCM2M,Tripolar360x200L50); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x200L50); land: LM3 (LM3p7_cESM,M45)",
                                "v20111228monthlymodel_id": "GFDL-ESM2M",
                                "v20111228monthlyrealization": "1",
                                "v20111228monthlyparent_experiment_id": "historicalMisc",
                                "v20111228monthlyforcing": "GHG,SD,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20111228monthlyConventions": "CF-1.4",
                                "v20111228monthlycomment": "GFDL experiment name = ESM2M-C1_all_historical_HC1. PCMDI experiment name = historical (run1). Initial conditions for this experiment were taken from 1 January of year 1861 of the parent experiment, ESM2M-C1_1700-1860_historical_HC1, which is an unpublished experiment branched from 1 January of year 1 of 1860 control model experiment, ESM2M_pi-control_C1 (piControl). This parent experiment is an extension of piControl except historical transitions of land use are applied from 1700-1860 in order to allow the terrestrial carbon stores to respond to the imposition of land use and produce realistic fluxes by the start of the historical run in 1861. Several forcing agents varied during the 145 year duration of the ESM2M-C1_all_historical_HC1 experiment in a manner based upon observations and reconstructions for the late 19th and 20th centuries. The aerosol concentrations were computed by an off-line model. The time varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, aerosol concentrations (sulfate, black and organic carbon, sea salt, dust), volcanic aerosols, solar irradiance and land use transitions. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20111228monthlyinstitute_id": "NOAA GFDL",
                                "v20111228monthlyinput_creation_date": "2011-07-12T17:46:30Z",
                                "v20111228monthlymodeling_realm": "atmos",
                                "v20111228monthlytable_id": "Table day (31 Jan 2011)",
                                "v20111228monthlytitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2M, historical (run 1) experiment output for CMIP5 AR5",
                                "v20111228monthlybranch_time": "58765",
                                "v20111228monthlyinput_frequency": "day",
                                "v20111228monthlynco_openmp_thread_number": "1",
                                "v20111228monthlygfdl_experiment_name": "ESM2M-C1_all_historical_HC1",
                                "v20111228monthlyETCCDI_institution_id": "PCIC",
                                "v20111228monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111228monthlyinput_title": "NOAA GFDL GFDL-ESM2M, historical (run 1) experiment output for CMIP5 AR5",
                                "v20111228monthlyexperiment_id": "historical",
                                "v20111228monthlyETCCDI_software_version": "0.6.2",
                                "v20111228monthlyproject_id": "CMIP5",
                                "v20111228monthlyfrequency": "monClim",
                                "v20111228monthlyNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20111228monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111228monthlyETCCDI_software": "climdex.pcic",
                                "v20111228monthlyexperiment": "historical",
                                "v20111228annualcreation_date": "2013-04-19T00:39:42Z",
                                "v20111228annualphysics_version": "1",
                                "v20111228annualcontact": "bronaugh@uvic.ca",
                                "v20111228annualinput_tracking_id": "417b65fb-a619-406f-81f8-bb2173634139",
                                "v20111228annualinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20111228annualparent_experiment_rip": "r1i1p1",
                                "v20111228annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111228annualproduct": "output1",
                                "v20111228annualinitialization_method": "1",
                                "v20111228annualNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20111228annualsource": "GFDL-ESM2M 2010 ocean: MOM4 (MOM4p1_x1_Z50_cCM2M,Tripolar360x200L50); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x200L50); land: LM3 (LM3p7_cESM,M45)",
                                "v20111228annualmodel_id": "GFDL-ESM2M",
                                "v20111228annualrealization": "1",
                                "v20111228annualparent_experiment_id": "historicalMisc",
                                "v20111228annualforcing": "GHG,SD,Oz,LU,Sl,Vl,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20111228annualConventions": "CF-1.4",
                                "v20111228annualcomment": "GFDL experiment name = ESM2M-C1_all_historical_HC1. PCMDI experiment name = historical (run1). Initial conditions for this experiment were taken from 1 January of year 1861 of the parent experiment, ESM2M-C1_1700-1860_historical_HC1, which is an unpublished experiment branched from 1 January of year 1 of 1860 control model experiment, ESM2M_pi-control_C1 (piControl). This parent experiment is an extension of piControl except historical transitions of land use are applied from 1700-1860 in order to allow the terrestrial carbon stores to respond to the imposition of land use and produce realistic fluxes by the start of the historical run in 1861. Several forcing agents varied during the 145 year duration of the ESM2M-C1_all_historical_HC1 experiment in a manner based upon observations and reconstructions for the late 19th and 20th centuries. The aerosol concentrations were computed by an off-line model. The time varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, aerosol concentrations (sulfate, black and organic carbon, sea salt, dust), volcanic aerosols, solar irradiance and land use transitions. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20111228annualinstitute_id": "NOAA GFDL",
                                "v20111228annualtable_id": "Table day (31 Jan 2011)",
                                "v20111228annualinput_creation_date": "2011-07-12T17:46:30Z",
                                "v20111228annualmodeling_realm": "atmos",
                                "v20111228annualtitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2M, historical (run 1) experiment output for CMIP5 AR5",
                                "v20111228annualbranch_time": "58765",
                                "v20111228annualinput_frequency": "day",
                                "v20111228annualgfdl_experiment_name": "ESM2M-C1_all_historical_HC1",
                                "v20111228annualnco_openmp_thread_number": "1",
                                "v20111228annualETCCDI_institution_id": "PCIC",
                                "v20111228annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111228annualinput_title": "NOAA GFDL GFDL-ESM2M, historical (run 1) experiment output for CMIP5 AR5",
                                "v20111228annualexperiment_id": "historical",
                                "v20111228annualETCCDI_software_version": "0.6.2",
                                "v20111228annualproject_id": "CMIP5",
                                "v20111228annualfrequency": "yr",
                                "v20111228annualNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20111228annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111228annualETCCDI_software": "climdex.pcic",
                                "v20111228annualexperiment": "historical",
                                "iridlhasSemantics": "iridl:GFDL-ESM2M",
                                "Conventions": "IRIDL"
                            },
                            "v20111228": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20111228",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1861-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1861-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/GFDL-ESM2M"
                        },
                        "GISSE2R": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GISS-E2-R",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlymodel_id": "GISS-E2-R",
                                "mult_versionsmonthlyinstitution": "NASA/GISS (Goddard Institute for Space Studies) New York, NY",
                                "mult_versionsmonthlyinput_creation_date": "2012-01-05T16:35:24Z",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyNASAGISS_references": "http://data.giss.nasa.gov/modelE/ar5",
                                "mult_versionsmonthlysource": "GISS-E2-R-E135f9fF40oQ32 Atmosphere: GISS-E2; Ocean: R",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyforcing": "GHG, LU, Sl, Vl, BC, OC, SA, Oz (also includes orbital change - BC on snow - Nitrate aerosols)",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on GISS-E2-R model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyparent_experiment_rip": "r1i1p1",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlybranch_time": "4081.0",
                                "mult_versionsmonthlyinput_tracking_id": "752ac51f-0136-4174-b2a9-6971d71f5037",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyNASAGISS_contact": "Kenneth Lo (cdkkl@giss.nasa.gov)",
                                "mult_versionsmonthlycreation_date": "2012-07-14T23:20:55Z",
                                "mult_versionsmonthlycmor_version": "2.5.7",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyinstitute_id": "NASA-GISS",
                                "mult_versionsmonthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsmonthlyinput_title": "GISS-E2-R model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyrealization": "6",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualmodel_id": "GISS-E2-R",
                                "mult_versionsannualinstitution": "NASA/GISS (Goddard Institute for Space Studies) New York, NY",
                                "mult_versionsannualinput_creation_date": "2012-01-05T16:35:24Z",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualNASAGISS_references": "http://data.giss.nasa.gov/modelE/ar5",
                                "mult_versionsannualsource": "GISS-E2-R-E135f9fF40oQ32 Atmosphere: GISS-E2; Ocean: R",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualforcing": "GHG, LU, Sl, Vl, BC, OC, SA, Oz (also includes orbital change - BC on snow - Nitrate aerosols)",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualtitle": "ETCCDI indices computed on GISS-E2-R model output prepared for CMIP5 historical",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualbranch_time": "4081.0",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualinput_tracking_id": "752ac51f-0136-4174-b2a9-6971d71f5037",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualNASAGISS_contact": "Kenneth Lo (cdkkl@giss.nasa.gov)",
                                "mult_versionsannualcreation_date": "2012-07-14T14:02:46Z",
                                "mult_versionsannualcmor_version": "2.5.7",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualinstitute_id": "NASA-GISS",
                                "mult_versionsannualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsannualinput_title": "GISS-E2-R model output prepared for CMIP5 historical",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualrealization": "6",
                                "iridlhasSemantics": "iridl:GISS-E2-R",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.0",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/GISS-E2-R"
                        },
                        "HadCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyforcing": "GHG, Oz, SA, Sl, Vl, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlybranch_time": "1893690.0",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyMOHC_contact": "doug.smith@metoffice.gov.uk, holger.pohlmann@metoffice.gov.uk",
                                "mult_versionsmonthlysource": "HadCM3 - Hadley Centre Coupled Model Version 3 (2000) atmosphere: HadAM3 (N48L19); ocean: HadOM (lat: 1.25 lon: 1.25 L20); land-surface/vegetation: MOSES1;",
                                "mult_versionsmonthlyinstitute_id": "MOHC",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyinput_creation_date": "2011-07-22T16:57:03Z",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on HadCM3 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyinput_title": "HadCM3 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlycreation_date": "2013-06-28T04:46:45Z",
                                "mult_versionsmonthlyinput_tracking_id": "8b7d3016-21bc-4c2b-994a-eab898bc70d4",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlymodel_id": "HadCM3",
                                "mult_versionsmonthlyMOHC_references": "Collins, M. S.F.B Tett, and C. Cooper (2001) the Internal Climate Variability of HadCM3, a Version of the Hadley Centre Coupled Model without Flux Adjustments. Climate Dynamics, 17 (1): 61-81.; Smith, D.M., S. Cusack, A.W. Colman, C.K. Folland, G.R. Harris and J.M. Murphy (2007) Improved surface temperature prediction for the coming decade from a global climate model. Science, 317, 796-799; Smith, D.M., R. Eade, N.J. Dunstone, D. Fereday, J.M. Murphy, H. Pohlman, and A.A. Scaife (2010) Skilful multi-year predictions of Atlantic hurricane frequency. Nature Geoscience, DOI: 10.1038/NGE01004;",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlymo_runid": "ajeea ajeek",
                                "mult_versionsmonthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualforcing": "GHG, Oz, SA, Sl, Vl, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualbranch_time": "1893690.0",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualMOHC_contact": "doug.smith@metoffice.gov.uk, holger.pohlmann@metoffice.gov.uk",
                                "mult_versionsannualsource": "HadCM3 - Hadley Centre Coupled Model Version 3 (2000) atmosphere: HadAM3 (N48L19); ocean: HadOM (lat: 1.25 lon: 1.25 L20); land-surface/vegetation: MOSES1;",
                                "mult_versionsannualinstitute_id": "MOHC",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualinput_creation_date": "2011-07-22T16:57:03Z",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualtitle": "ETCCDI indices computed on HadCM3 model output prepared for CMIP5 historical",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualinput_title": "HadCM3 model output prepared for CMIP5 historical",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualcreation_date": "2013-06-28T03:59:27Z",
                                "mult_versionsannualinput_tracking_id": "8b7d3016-21bc-4c2b-994a-eab898bc70d4",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualmodel_id": "HadCM3",
                                "mult_versionsannualMOHC_references": "Collins, M. S.F.B Tett, and C. Cooper (2001) the Internal Climate Variability of HadCM3, a Version of the Hadley Centre Coupled Model without Flux Adjustments. Climate Dynamics, 17 (1): 61-81.; Smith, D.M., S. Cusack, A.W. Colman, C.K. Folland, G.R. Harris and J.M. Murphy (2007) Improved surface temperature prediction for the coming decade from a global climate model. Science, 317, 796-799; Smith, D.M., R. Eade, N.J. Dunstone, D. Fereday, J.M. Murphy, H. Pohlman, and A.A. Scaife (2010) Skilful multi-year predictions of Atlantic hurricane frequency. Nature Geoscience, DOI: 10.1038/NGE01004;",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualmo_runid": "ajeea ajeek",
                                "mult_versionsannualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "iridlhasSemantics": "iridl:HadCM3",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1859-12-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "360",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1859-12-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "360",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.5",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/HadCM3"
                        },
                        "HadGEM2CC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadGEM2-CC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyMOHC_references": "Bellouin N. et al, (2007) Improved representation of aerosols for HadGEM2. Meteorological Office Hadley Centre, Technical Note 73, March 2007; Collins W.J.  et al, (2008) Evaluation of the HadGEM2 model. Meteorological Office Hadley Centre, Technical Note 74,; Johns T.C. et al, (2006) The new Hadley Centre climate model HadGEM1: Evaluation of coupled simulations. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1327-1353.; Martin G.M. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 1: Model description and global climatology. Journal of Climate, American Meteorological Society, Vol. 19, No.7, pages 1274-1301.; Ringer M.A. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 2: Aspects of variability and regional climate. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1302-1326.",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyinput_title": "HadGEM2-CC model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlycreation_date": "2013-04-19T17:38:03Z",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyinstitute_id": "MOHC",
                                "mult_versionsmonthlybranch_time": "0.0",
                                "mult_versionsmonthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsmonthlysource": "HadGEM2-CC (2011) atmosphere: HadGAM2(N96L60); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; ocean biogeochemistry: diat-HadOCC",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlymodel_id": "HadGEM2-CC",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on HadGEM2-CC model output prepared for CMIP5 historical",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlymo_runid": "akgid",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.2",
                                "mult_versionsmonthlyinput_tracking_id": "06391ccc-baf1-4386-86ea-a7a8fb17931d",
                                "mult_versionsmonthlyMOHC_contact": "chris.d.jones@metoffice.gov.uk, steven.hardiman@metoffice.gov.uk",
                                "mult_versionsmonthlyinput_creation_date": "2011-09-07T18:26:18Z",
                                "mult_versionsannualMOHC_references": "Bellouin N. et al, (2007) Improved representation of aerosols for HadGEM2. Meteorological Office Hadley Centre, Technical Note 73, March 2007; Collins W.J.  et al, (2008) Evaluation of the HadGEM2 model. Meteorological Office Hadley Centre, Technical Note 74,; Johns T.C. et al, (2006) The new Hadley Centre climate model HadGEM1: Evaluation of coupled simulations. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1327-1353.; Martin G.M. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 1: Model description and global climatology. Journal of Climate, American Meteorological Society, Vol. 19, No.7, pages 1274-1301.; Ringer M.A. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 2: Aspects of variability and regional climate. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1302-1326.",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualinput_title": "HadGEM2-CC model output prepared for CMIP5 historical",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualcreation_date": "2013-04-19T12:01:01Z",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitute_id": "MOHC",
                                "mult_versionsannualbranch_time": "0.0",
                                "mult_versionsannualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsannualsource": "HadGEM2-CC (2011) atmosphere: HadGAM2(N96L60); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; ocean biogeochemistry: diat-HadOCC",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualmodel_id": "HadGEM2-CC",
                                "mult_versionsannualtitle": "ETCCDI indices computed on HadGEM2-CC model output prepared for CMIP5 historical",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualmo_runid": "akgid",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualETCCDI_software_version": "0.6.2",
                                "mult_versionsannualinput_tracking_id": "06391ccc-baf1-4386-86ea-a7a8fb17931d",
                                "mult_versionsannualMOHC_contact": "chris.d.jones@metoffice.gov.uk, steven.hardiman@metoffice.gov.uk",
                                "mult_versionsannualinput_creation_date": "2011-09-07T18:26:18Z",
                                "iridlhasSemantics": "iridl:HadGEM2-CC",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "startyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "startyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "startyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "startyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "startyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/HadGEM2-CC"
                        },
                        "HadGEM2ES": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadGEM2-ES",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlycmor_version": "2.5.0",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyinstitute_id": "MOHC",
                                "mult_versionsmonthlysource": "HadGEM2-ES (2009) atmosphere: HadGAM2 (N96L38); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; tropospheric chemistry: UKCA; ocean biogeochemistry: diat-HadOCC",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyMOHC_references": "Bellouin N. et al, (2007) Improved representation of aerosols for HadGEM2. Meteorological Office Hadley Centre, Technical Note 73, March 2007; Collins W.J.  et al, (2008) Evaluation of the HadGEM2 model. Meteorological Office Hadley Centre, Technical Note 74,; Johns T.C. et al, (2006) The new Hadley Centre climate model HadGEM1: Evaluation of coupled simulations. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1327-1353.; Martin G.M. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 1: Model description and global climatology. Journal of Climate, American Meteorological Society, Vol. 19, No.7, pages 1274-1301.; Ringer M.A. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 2: Aspects of variability and regional climate. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1302-1326.",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlymodel_id": "HadGEM2-ES",
                                "mult_versionsmonthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsmonthlyinput_tracking_id": "4b8bd3d7-6e69-499d-93de-68723653c44d",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on HadGEM2-ES model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlybranch_time": "0.0",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyinput_title": "HadGEM2-ES model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlytable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyinput_creation_date": "2010-11-22T15:34:22Z",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.2",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyMOHC_contact": "chris.d.jones@metoffice.gov.uk, michael.sanderson@metoffice.gov.uk",
                                "mult_versionsmonthlycreation_date": "2013-04-19T17:52:29Z",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlymo_runid": "ajhoh",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsannualcmor_version": "2.5.0",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualinstitute_id": "MOHC",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualsource": "HadGEM2-ES (2009) atmosphere: HadGAM2 (N96L38); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; tropospheric chemistry: UKCA; ocean biogeochemistry: diat-HadOCC",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualparent_experiment_rip": "r1i1p1",
                                "mult_versionsannualMOHC_references": "Bellouin N. et al, (2007) Improved representation of aerosols for HadGEM2. Meteorological Office Hadley Centre, Technical Note 73, March 2007; Collins W.J.  et al, (2008) Evaluation of the HadGEM2 model. Meteorological Office Hadley Centre, Technical Note 74,; Johns T.C. et al, (2006) The new Hadley Centre climate model HadGEM1: Evaluation of coupled simulations. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1327-1353.; Martin G.M. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 1: Model description and global climatology. Journal of Climate, American Meteorological Society, Vol. 19, No.7, pages 1274-1301.; Ringer M.A. et al, (2006) The physical properties of the atmosphere in the new Hadley Centre Global Environmental Model, HadGEM1 - Part 2: Aspects of variability and regional climate. Journal of Climate, American Meteorological Society, Vol. 19, No. 7, pages 1302-1326.",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualmodel_id": "HadGEM2-ES",
                                "mult_versionsannualforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "mult_versionsannualinput_tracking_id": "4b8bd3d7-6e69-499d-93de-68723653c44d",
                                "mult_versionsannualtitle": "ETCCDI indices computed on HadGEM2-ES model output prepared for CMIP5 historical",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualbranch_time": "0.0",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualinput_title": "HadGEM2-ES model output prepared for CMIP5 historical",
                                "mult_versionsannualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualtable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualinput_creation_date": "2010-11-22T15:34:22Z",
                                "mult_versionsannualETCCDI_software_version": "0.6.2",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualMOHC_contact": "chris.d.jones@metoffice.gov.uk, michael.sanderson@metoffice.gov.uk",
                                "mult_versionsannualcreation_date": "2013-04-19T12:03:54Z",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualmo_runid": "ajhoh",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualexperiment_id": "historical",
                                "iridlhasSemantics": "iridl:HadGEM2-ES",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/HadGEM2-ES"
                        },
                        "IPSLCM5ALR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPSL-CM5A-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlybranch_time": "1850.0",
                                "mult_versionsmonthlyinstitute_id": "IPSL",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlytable_id": "Table day (30 November 2010) 124740b2ad2bc003e05675678080dc82",
                                "mult_versionsmonthlysource": "IPSL-CM5A-LR (2010) : atmos : LMDZ4 (LMDZ4_v5, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsmonthlycomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "mult_versionsmonthlyinput_title": "IPSL-CM5A-LR model output prepared for CMIP5 historical",
                                "mult_versionsmonthlycreation_date": "2012-07-15T02:31:14Z",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on IPSL-CM5A-LR model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyforcing": "Nat, Ant, GHG, SA, Oz, LU, SS, Ds, BC, MD, OC, AA",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlycmor_version": "2.5.1",
                                "mult_versionsmonthlyinput_tracking_id": "14b481b6-ef09-4800-bd24-229f659abd58",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyinput_creation_date": "2011-01-07T23:42:44Z",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlymodel_id": "IPSL-CM5A-LR",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualbranch_time": "1850.0",
                                "mult_versionsannualinstitute_id": "IPSL",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualtable_id": "Table day (30 November 2010) 124740b2ad2bc003e05675678080dc82",
                                "mult_versionsannualsource": "IPSL-CM5A-LR (2010) : atmos : LMDZ4 (LMDZ4_v5, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsannualcomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "mult_versionsannualinput_title": "IPSL-CM5A-LR model output prepared for CMIP5 historical",
                                "mult_versionsannualcreation_date": "2012-07-14T13:02:02Z",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualtitle": "ETCCDI indices computed on IPSL-CM5A-LR model output prepared for CMIP5 historical",
                                "mult_versionsannualinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualforcing": "Nat, Ant, GHG, SA, Oz, LU, SS, Ds, BC, MD, OC, AA",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualcmor_version": "2.5.1",
                                "mult_versionsannualinput_tracking_id": "14b481b6-ef09-4800-bd24-229f659abd58",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualinput_creation_date": "2011-01-07T23:42:44Z",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualmodel_id": "IPSL-CM5A-LR",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualexperiment": "historical",
                                "iridlhasSemantics": "iridl:IPSL-CM5A-LR",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/IPSL-CM5A-LR"
                        },
                        "IPSLCM5AMR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPSL-CM5A-MR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyinput_tracking_id": "eb029b4d-4bad-466d-a85f-0f64b5860e23",
                                "mult_versionsmonthlyinstitute_id": "IPSL",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlysource": "IPSL-CM5A-MR (2010) : atmos : LMDZ4 (LMDZ4_v5, 144x143x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on IPSL-CM5A-MR model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsmonthlyinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlycreation_date": "2012-07-15T07:59:58Z",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlycomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "mult_versionsmonthlybranch_time": "1850.0",
                                "mult_versionsmonthlytable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "mult_versionsmonthlymodel_id": "IPSL-CM5A-MR",
                                "mult_versionsmonthlyforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyinput_title": "IPSL-CM5A-MR model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinput_creation_date": "2011-09-23T02:27:17Z",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualinput_tracking_id": "eb029b4d-4bad-466d-a85f-0f64b5860e23",
                                "mult_versionsannualIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsannualinstitute_id": "IPSL",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualsource": "IPSL-CM5A-MR (2010) : atmos : LMDZ4 (LMDZ4_v5, 144x143x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualtitle": "ETCCDI indices computed on IPSL-CM5A-MR model output prepared for CMIP5 historical",
                                "mult_versionsannualIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsannualinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualcreation_date": "2012-07-14T15:07:34Z",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualcomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "mult_versionsannualbranch_time": "1850.0",
                                "mult_versionsannualtable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "mult_versionsannualmodel_id": "IPSL-CM5A-MR",
                                "mult_versionsannualforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinput_title": "IPSL-CM5A-MR model output prepared for CMIP5 historical",
                                "mult_versionsannualinput_creation_date": "2011-09-23T02:27:17Z",
                                "mult_versionsannualexperiment_id": "historical",
                                "iridlhasSemantics": "iridl:IPSL-CM5A-MR",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.2676057",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/IPSL-CM5A-MR"
                        },
                        "IPSLCM5BLR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPSL-CM5B-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120718monthlyETCCDI_institution_id": "PCIC",
                                "v20120718monthlyrealization": "1",
                                "v20120718monthlymodeling_realm": "atmos",
                                "v20120718monthlyphysics_version": "1",
                                "v20120718monthlyexperiment": "historical",
                                "v20120718monthlyproduct": "output",
                                "v20120718monthlyinitialization_method": "1",
                                "v20120718monthlyproject_id": "CMIP5",
                                "v20120718monthlyparent_experiment_rip": "r1i1p1",
                                "v20120718monthlyparent_experiment_id": "piControl",
                                "v20120718monthlyfrequency": "monClim",
                                "v20120718monthlyinstitute_id": "IPSL",
                                "v20120718monthlyinput_creation_date": "2012-01-28T12:56:05Z",
                                "v20120718monthlytable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "v20120718monthlysource": "IPSL-CM5B-LR (2011) : atmos : LMDZ5 (LMDZ5_NPv3.1, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "v20120718monthlyparent_experiment": "pre-industrial control",
                                "v20120718monthlyexperiment_id": "historical",
                                "v20120718monthlyinput_frequency": "day",
                                "v20120718monthlyConventions": "CF-1.4",
                                "v20120718monthlyforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "v20120718monthlyETCCDI_software": "climdex.pcic",
                                "v20120718monthlytitle": "ETCCDI indices computed on IPSL-CM5B-LR model output prepared for CMIP5 historical",
                                "v20120718monthlyinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "v20120718monthlycreation_date": "2012-07-15T10:59:54Z",
                                "v20120718monthlycomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "v20120718monthlyETCCDI_software_version": "0.6.1",
                                "v20120718monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120718monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120718monthlycmor_version": "2.7.1",
                                "v20120718monthlycontact": "bronaugh@uvic.ca",
                                "v20120718monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120718monthlybranch_time": "1850.0",
                                "v20120718monthlyIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "v20120718monthlymodel_id": "IPSL-CM5B-LR",
                                "v20120718monthlyinput_title": "IPSL-CM5B-LR model output prepared for CMIP5 historical",
                                "v20120718monthlyIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "v20120718monthlyinput_tracking_id": "6dc2cd88-0d37-4294-8204-0bb646441b78",
                                "v20120718annualETCCDI_institution_id": "PCIC",
                                "v20120718annualrealization": "1",
                                "v20120718annualmodeling_realm": "atmos",
                                "v20120718annualphysics_version": "1",
                                "v20120718annualexperiment": "historical",
                                "v20120718annualproduct": "output",
                                "v20120718annualinitialization_method": "1",
                                "v20120718annualproject_id": "CMIP5",
                                "v20120718annualparent_experiment_rip": "r1i1p1",
                                "v20120718annualparent_experiment_id": "piControl",
                                "v20120718annualfrequency": "yr",
                                "v20120718annualinstitute_id": "IPSL",
                                "v20120718annualinput_creation_date": "2012-01-28T12:56:05Z",
                                "v20120718annualtable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "v20120718annualsource": "IPSL-CM5B-LR (2011) : atmos : LMDZ5 (LMDZ5_NPv3.1, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "v20120718annualparent_experiment": "pre-industrial control",
                                "v20120718annualexperiment_id": "historical",
                                "v20120718annualinput_frequency": "day",
                                "v20120718annualConventions": "CF-1.4",
                                "v20120718annualforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "v20120718annualETCCDI_software": "climdex.pcic",
                                "v20120718annualtitle": "ETCCDI indices computed on IPSL-CM5B-LR model output prepared for CMIP5 historical",
                                "v20120718annualinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "v20120718annualcreation_date": "2012-07-12T18:07:16Z",
                                "v20120718annualcomment": "This 20th century simulation include natural and anthropogenic forcings.",
                                "v20120718annualETCCDI_software_version": "0.6.1",
                                "v20120718annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120718annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120718annualcontact": "bronaugh@uvic.ca",
                                "v20120718annualcmor_version": "2.7.1",
                                "v20120718annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120718annualbranch_time": "1850.0",
                                "v20120718annualIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "v20120718annualmodel_id": "IPSL-CM5B-LR",
                                "v20120718annualinput_title": "IPSL-CM5B-LR model output prepared for CMIP5 historical",
                                "v20120718annualIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "v20120718annualinput_tracking_id": "6dc2cd88-0d37-4294-8204-0bb646441b78",
                                "iridlhasSemantics": "iridl:IPSL-CM5B-LR",
                                "Conventions": "IRIDL"
                            },
                            "v20120718": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120718",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/IPSL-CM5B-LR"
                        },
                        "MIROCESM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC-ESM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120710monthlyMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710monthlyinput_creation_date": "2011-10-04T11:32:55Z",
                                "v20120710monthlyETCCDI_institution_id": "PCIC",
                                "v20120710monthlyparent_experiment_id": "piControl",
                                "v20120710monthlyproduct": "output",
                                "v20120710monthlyinstitute_id": "MIROC",
                                "v20120710monthlymodeling_realm": "atmos",
                                "v20120710monthlyphysics_version": "1",
                                "v20120710monthlycontact": "bronaugh@uvic.ca",
                                "v20120710monthlyproject_id": "CMIP5",
                                "v20120710monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710monthlysource": "MIROC-ESM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710monthlyparent_experiment": "pre-industrial control",
                                "v20120710monthlyConventions": "CF-1.4",
                                "v20120710monthlyexperiment": "historical",
                                "v20120710monthlyfrequency": "monClim",
                                "v20120710monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710monthlytitle": "ETCCDI indices computed on MIROC-ESM model output prepared for CMIP5 historical",
                                "v20120710monthlycmor_version": "2.7.1",
                                "v20120710monthlymodel_id": "MIROC-ESM",
                                "v20120710monthlyETCCDI_software_version": "0.6.1",
                                "v20120710monthlyexperiment_id": "historical",
                                "v20120710monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710monthlybranch_time": "29219.0",
                                "v20120710monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710monthlyinput_title": "MIROC-ESM model output prepared for CMIP5 historical",
                                "v20120710monthlyinitialization_method": "1",
                                "v20120710monthlyMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710monthlyETCCDI_software": "climdex.pcic",
                                "v20120710monthlyinput_tracking_id": "35ce430e-dfd4-457b-bfc6-421eff466148",
                                "v20120710monthlycreation_date": "2012-07-15T12:21:04Z",
                                "v20120710monthlyinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710monthlyinput_frequency": "day",
                                "v20120710monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC",
                                "v20120710annualMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710annualinput_creation_date": "2011-10-04T11:32:55Z",
                                "v20120710annualETCCDI_institution_id": "PCIC",
                                "v20120710annualparent_experiment_id": "piControl",
                                "v20120710annualproduct": "output",
                                "v20120710annualinstitute_id": "MIROC",
                                "v20120710annualmodeling_realm": "atmos",
                                "v20120710annualphysics_version": "1",
                                "v20120710annualcontact": "bronaugh@uvic.ca",
                                "v20120710annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710annualsource": "MIROC-ESM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710annualproject_id": "CMIP5",
                                "v20120710annualparent_experiment": "pre-industrial control",
                                "v20120710annualConventions": "CF-1.4",
                                "v20120710annualexperiment": "historical",
                                "v20120710annualfrequency": "yr",
                                "v20120710annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710annualtitle": "ETCCDI indices computed on MIROC-ESM model output prepared for CMIP5 historical",
                                "v20120710annualcmor_version": "2.7.1",
                                "v20120710annualmodel_id": "MIROC-ESM",
                                "v20120710annualETCCDI_software_version": "0.6.1",
                                "v20120710annualexperiment_id": "historical",
                                "v20120710annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710annualbranch_time": "29219.0",
                                "v20120710annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710annualinput_title": "MIROC-ESM model output prepared for CMIP5 historical",
                                "v20120710annualinitialization_method": "1",
                                "v20120710annualMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710annualETCCDI_software": "climdex.pcic",
                                "v20120710annualinput_tracking_id": "35ce430e-dfd4-457b-bfc6-421eff466148",
                                "v20120710annualcreation_date": "2012-07-14T13:23:24Z",
                                "v20120710annualinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710annualinput_frequency": "day",
                                "v20120710annualforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC",
                                "iridlhasSemantics": "iridl:MIROC-ESM",
                                "Conventions": "IRIDL"
                            },
                            "v20120710": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120710",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MIROC-ESM"
                        },
                        "MIROCESMCHEM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC-ESM-CHEM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120710monthlyETCCDI_institution_id": "PCIC",
                                "v20120710monthlyproject_id": "CMIP5",
                                "v20120710monthlyparent_experiment_id": "piControl",
                                "v20120710monthlyrealization": "1",
                                "v20120710monthlyMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710monthlyproduct": "output",
                                "v20120710monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710monthlyinput_title": "MIROC-ESM-CHEM model output prepared for CMIP5 historical",
                                "v20120710monthlyparent_experiment_rip": "r1i1p1",
                                "v20120710monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC (Ozone is predicted)",
                                "v20120710monthlyexperiment_id": "historical",
                                "v20120710monthlymodel_id": "MIROC-ESM-CHEM",
                                "v20120710monthlysource": "MIROC-ESM-CHEM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):atmospheric-chemistry: CHASER (CHASER 4.1, T42L80): ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710monthlyexperiment": "historical",
                                "v20120710monthlyETCCDI_software": "climdex.pcic",
                                "v20120710monthlyConventions": "CF-1.4",
                                "v20120710monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710monthlytitle": "ETCCDI indices computed on MIROC-ESM-CHEM model output prepared for CMIP5 historical",
                                "v20120710monthlycontact": "bronaugh@uvic.ca",
                                "v20120710monthlyMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710monthlycmor_version": "2.7.1",
                                "v20120710monthlyfrequency": "monClim",
                                "v20120710monthlyETCCDI_software_version": "0.6.1",
                                "v20120710monthlyparent_experiment": "pre-industrial control",
                                "v20120710monthlycreation_date": "2012-07-17T11:53:06Z",
                                "v20120710monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710monthlyinstitute_id": "MIROC",
                                "v20120710monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710monthlyphysics_version": "1",
                                "v20120710monthlyinput_frequency": "day",
                                "v20120710monthlyinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710monthlyinput_creation_date": "2011-10-21T02:53:23Z",
                                "v20120710monthlymodeling_realm": "atmos",
                                "v20120710monthlybranch_time": "1461.0",
                                "v20120710monthlyinput_tracking_id": "5a2b00f0-d681-42cf-a3c1-135df1e6fad7",
                                "v20120710monthlyinitialization_method": "1",
                                "v20120710annualETCCDI_institution_id": "PCIC",
                                "v20120710annualproject_id": "CMIP5",
                                "v20120710annualparent_experiment_id": "piControl",
                                "v20120710annualrealization": "1",
                                "v20120710annualMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710annualproduct": "output",
                                "v20120710annualinput_title": "MIROC-ESM-CHEM model output prepared for CMIP5 historical",
                                "v20120710annualparent_experiment_rip": "r1i1p1",
                                "v20120710annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710annualforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC (Ozone is predicted)",
                                "v20120710annualexperiment_id": "historical",
                                "v20120710annualmodel_id": "MIROC-ESM-CHEM",
                                "v20120710annualsource": "MIROC-ESM-CHEM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):atmospheric-chemistry: CHASER (CHASER 4.1, T42L80): ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710annualexperiment": "historical",
                                "v20120710annualETCCDI_software": "climdex.pcic",
                                "v20120710annualConventions": "CF-1.4",
                                "v20120710annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710annualMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710annualcontact": "bronaugh@uvic.ca",
                                "v20120710annualtitle": "ETCCDI indices computed on MIROC-ESM-CHEM model output prepared for CMIP5 historical",
                                "v20120710annualcmor_version": "2.7.1",
                                "v20120710annualETCCDI_software_version": "0.6.1",
                                "v20120710annualfrequency": "yr",
                                "v20120710annualparent_experiment": "pre-industrial control",
                                "v20120710annualcreation_date": "2012-07-12T18:37:54Z",
                                "v20120710annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710annualinstitute_id": "MIROC",
                                "v20120710annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710annualphysics_version": "1",
                                "v20120710annualinput_frequency": "day",
                                "v20120710annualinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710annualinput_creation_date": "2011-10-21T02:53:23Z",
                                "v20120710annualmodeling_realm": "atmos",
                                "v20120710annualbranch_time": "1461.0",
                                "v20120710annualinput_tracking_id": "5a2b00f0-d681-42cf-a3c1-135df1e6fad7",
                                "v20120710annualinitialization_method": "1",
                                "iridlhasSemantics": "iridl:MIROC-ESM-CHEM",
                                "Conventions": "IRIDL"
                            },
                            "v20120710": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120710",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MIROC-ESM-CHEM"
                        },
                        "MIROC4h": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC4h",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120628monthlyinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), and JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120628monthlymodeling_realm": "atmos",
                                "v20120628monthlyproduct": "output",
                                "v20120628monthlyETCCDI_software": "climdex.pcic",
                                "v20120628monthlyinput_frequency": "day",
                                "v20120628monthlycreation_date": "2012-07-16T05:14:20Z",
                                "v20120628monthlyphysics_version": "1",
                                "v20120628monthlyMIROC_contact": "Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp), Masayoshi Ishii (ism@jamstec.go.jp)",
                                "v20120628monthlyinput_creation_date": "2011-04-28T05:26:29Z",
                                "v20120628monthlysource": "MIROC4h 2009 atmosphere: AGCM (AGCM5.8, T213L56); ocean: COCO (COCO3.4, rotated pole 1280x912 L48); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, 2x3L5)",
                                "v20120628monthlyinput_title": "MIROC4h model output prepared for CMIP5 historical",
                                "v20120628monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2)",
                                "v20120628monthlyConventions": "CF-1.4",
                                "v20120628monthlynco_openmp_thread_number": "1",
                                "v20120628monthlycmor_version": "2.5.8",
                                "v20120628monthlytitle": "ETCCDI indices computed on MIROC4h model output prepared for CMIP5 historical",
                                "v20120628monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120628monthlymodel_id": "MIROC4h",
                                "v20120628monthlyinput_tracking_id": "06213403-7acc-4aba-b2a2-f060c38995ea",
                                "v20120628monthlyproject_id": "CMIP5",
                                "v20120628monthlybranch_time": "14600.0",
                                "v20120628monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120628monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120628monthlyfrequency": "monClim",
                                "v20120628monthlyexperiment_id": "historical",
                                "v20120628monthlyETCCDI_institution_id": "PCIC",
                                "v20120628monthlyparent_experiment": "pre-industrial control",
                                "v20120628monthlyMIROC_references": "Sakamoto et al., 2011: MIROC4h -- a new high-resolution atmosphere-ocean coupled general circulation model. (in preparation); Tatebe et al., 2011: (in preparation)",
                                "v20120628monthlyETCCDI_software_version": "0.6.1",
                                "v20120628monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120628monthlyparent_experiment_id": "piControl",
                                "v20120628monthlyexperiment": "historical",
                                "v20120628monthlycontact": "bronaugh@uvic.ca",
                                "v20120628monthlyinstitute_id": "MIROC",
                                "v20120628monthlyinitialization_method": "1",
                                "v20120628annualinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), and JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120628annualmodeling_realm": "atmos",
                                "v20120628annualproduct": "output",
                                "v20120628annualETCCDI_software": "climdex.pcic",
                                "v20120628annualinput_frequency": "day",
                                "v20120628annualcreation_date": "2012-07-23T00:31:49Z",
                                "v20120628annualphysics_version": "1",
                                "v20120628annualMIROC_contact": "Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp), Masayoshi Ishii (ism@jamstec.go.jp)",
                                "v20120628annualinput_creation_date": "2011-04-28T05:26:29Z",
                                "v20120628annualsource": "MIROC4h 2009 atmosphere: AGCM (AGCM5.8, T213L56); ocean: COCO (COCO3.4, rotated pole 1280x912 L48); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, 2x3L5)",
                                "v20120628annualinput_title": "MIROC4h model output prepared for CMIP5 historical",
                                "v20120628annualforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2)",
                                "v20120628annualConventions": "CF-1.4",
                                "v20120628annualnco_openmp_thread_number": "1",
                                "v20120628annualcmor_version": "2.5.8",
                                "v20120628annualtitle": "ETCCDI indices computed on MIROC4h model output prepared for CMIP5 historical",
                                "v20120628annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120628annualmodel_id": "MIROC4h",
                                "v20120628annualinput_tracking_id": "06213403-7acc-4aba-b2a2-f060c38995ea",
                                "v20120628annualproject_id": "CMIP5",
                                "v20120628annualbranch_time": "14600.0",
                                "v20120628annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120628annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120628annualfrequency": "yr",
                                "v20120628annualexperiment_id": "historical",
                                "v20120628annualETCCDI_institution_id": "PCIC",
                                "v20120628annualparent_experiment": "pre-industrial control",
                                "v20120628annualMIROC_references": "Sakamoto et al., 2011: MIROC4h -- a new high-resolution atmosphere-ocean coupled general circulation model. (in preparation); Tatebe et al., 2011: (in preparation)",
                                "v20120628annualETCCDI_software_version": "0.6.1",
                                "v20120628annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120628annualparent_experiment_id": "piControl",
                                "v20120628annualexperiment": "historical",
                                "v20120628annualcontact": "bronaugh@uvic.ca",
                                "v20120628annualinstitute_id": "MIROC",
                                "v20120628annualinitialization_method": "1",
                                "iridlhasSemantics": "iridl:MIROC4h",
                                "Conventions": "IRIDL"
                            },
                            "v20120628": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120628",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1950-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1950-1-1",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.5625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MIROC4h"
                        },
                        "MIROC5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyfrequency": "monClim",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinput_title": "MIROC5 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinput_tracking_id": "29118f0b-7417-4635-9a7d-99503fa0c23f",
                                "mult_versionsmonthlyexperiment_id": "historical",
                                "mult_versionsmonthlyinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyexperiment": "historical",
                                "mult_versionsmonthlyMIROC_contact": "Masahiro Watanabe (hiro@aori.u-tokyo.ac.jp), Seita Emori (emori@nies.go.jp), Masayoshi Ishii (ism@jamstec.go.jp), Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp)",
                                "mult_versionsmonthlyparent_experiment": "pre-industrial control",
                                "mult_versionsmonthlyinput_creation_date": "2011-10-19T10:12:01Z",
                                "mult_versionsmonthlysource": "MIROC5 2010 atmosphere: MIROC-AGCM6 (T85L40); ocean: COCO (COCO4.5, 256x224 L50); sea ice: COCO (COCO4.5); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T85L40)",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlymodel_id": "MIROC5",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlycreation_date": "2013-06-28T06:26:28Z",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on MIROC5 model output prepared for CMIP5 historical",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2; LU excludes change in lake fraction)",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyinstitute_id": "MIROC",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyMIROC_references": "Watanabe et al., 2010: Improved climate simulation by MIROC5: Mean states, variability, and climate sensitivity. J. Climate, 23, 6312-6335",
                                "mult_versionsmonthlybranch_time": "150015.0",
                                "mult_versionsmonthlyparent_experiment_id": "piControl",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinput_title": "MIROC5 model output prepared for CMIP5 historical",
                                "mult_versionsannualinput_tracking_id": "29118f0b-7417-4635-9a7d-99503fa0c23f",
                                "mult_versionsannualexperiment_id": "historical",
                                "mult_versionsannualinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualexperiment": "historical",
                                "mult_versionsannualMIROC_contact": "Masahiro Watanabe (hiro@aori.u-tokyo.ac.jp), Seita Emori (emori@nies.go.jp), Masayoshi Ishii (ism@jamstec.go.jp), Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp)",
                                "mult_versionsannualparent_experiment": "pre-industrial control",
                                "mult_versionsannualinput_creation_date": "2011-10-19T10:12:01Z",
                                "mult_versionsannualsource": "MIROC5 2010 atmosphere: MIROC-AGCM6 (T85L40); ocean: COCO (COCO4.5, 256x224 L50); sea ice: COCO (COCO4.5); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T85L40)",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualmodel_id": "MIROC5",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualcreation_date": "2013-06-28T05:05:55Z",
                                "mult_versionsannualtitle": "ETCCDI indices computed on MIROC5 model output prepared for CMIP5 historical",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2; LU excludes change in lake fraction)",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualinstitute_id": "MIROC",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualMIROC_references": "Watanabe et al., 2010: Improved climate simulation by MIROC5: Mean states, variability, and climate sensitivity. J. Climate, 23, 6312-6335",
                                "mult_versionsannualbranch_time": "150015.0",
                                "mult_versionsannualparent_experiment_id": "piControl",
                                "iridlhasSemantics": "iridl:MIROC5",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.40625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MIROC5"
                        },
                        "MPIESMLR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MPI-ESM-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20111006monthlyexperiment_id": "historical",
                                "v20111006monthlymodel_id": "MPI-ESM-LR",
                                "v20111006monthlynco_openmp_thread_number": "1",
                                "v20111006monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111006monthlybranch_time": "10957.0",
                                "v20111006monthlyinput_creation_date": "2011-05-27T17:18:57Z",
                                "v20111006monthlycontact": "bronaugh@uvic.ca",
                                "v20111006monthlyproduct": "output",
                                "v20111006monthlyforcing": "GHG Oz SD Sl Vl LU",
                                "v20111006monthlyinput_tracking_id": "cd1f610d-ce7b-4164-a36a-c07157045357",
                                "v20111006monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20111006monthlyinput_frequency": "day",
                                "v20111006monthlysource": "MPI-ESM-LR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4603), T63L47; land: JSBACH (REV: 4603); ocean: MPIOM (REV: 4603), GR15L40; sea ice: 4603; marine bgc: HAMOCC (REV: 4603);",
                                "v20111006monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111006monthlyfrequency": "monClim",
                                "v20111006monthlyparent_experiment": "pre-industrial control",
                                "v20111006monthlyETCCDI_institution_id": "PCIC",
                                "v20111006monthlyConventions": "CF-1.4",
                                "v20111006monthlyETCCDI_software": "climdex.pcic",
                                "v20111006monthlyparent_experiment_id": "piControl",
                                "v20111006monthlytitle": "ETCCDI indices computed on MPI-ESM-LR model output prepared for CMIP5 historical",
                                "v20111006monthlyMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20111006monthlyinstitute_id": "MPI-M",
                                "v20111006monthlymodeling_realm": "atmos",
                                "v20111006monthlyproject_id": "CMIP5",
                                "v20111006monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111006monthlyphysics_version": "1",
                                "v20111006monthlyinput_title": "MPI-ESM-LR model output prepared for CMIP5 historical",
                                "v20111006monthlyexperiment": "historical",
                                "v20111006monthlyMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20111006monthlycreation_date": "2013-06-28T15:17:26Z",
                                "v20111006monthlycmor_version": "2.5.9",
                                "v20111006monthlyinstitution": "Max Planck Institute for Meteorology",
                                "v20111006monthlyETCCDI_software_version": "0.7.1",
                                "v20111006monthlyinitialization_method": "1",
                                "v20111006annualexperiment_id": "historical",
                                "v20111006annualmodel_id": "MPI-ESM-LR",
                                "v20111006annualnco_openmp_thread_number": "1",
                                "v20111006annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111006annualbranch_time": "10957.0",
                                "v20111006annualinput_creation_date": "2011-05-27T17:18:57Z",
                                "v20111006annualcontact": "bronaugh@uvic.ca",
                                "v20111006annualproduct": "output",
                                "v20111006annualforcing": "GHG Oz SD Sl Vl LU",
                                "v20111006annualinput_tracking_id": "cd1f610d-ce7b-4164-a36a-c07157045357",
                                "v20111006annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20111006annualinput_frequency": "day",
                                "v20111006annualsource": "MPI-ESM-LR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4603), T63L47; land: JSBACH (REV: 4603); ocean: MPIOM (REV: 4603), GR15L40; sea ice: 4603; marine bgc: HAMOCC (REV: 4603);",
                                "v20111006annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111006annualfrequency": "yr",
                                "v20111006annualparent_experiment": "pre-industrial control",
                                "v20111006annualETCCDI_institution_id": "PCIC",
                                "v20111006annualConventions": "CF-1.4",
                                "v20111006annualETCCDI_software": "climdex.pcic",
                                "v20111006annualparent_experiment_id": "piControl",
                                "v20111006annualtitle": "ETCCDI indices computed on MPI-ESM-LR model output prepared for CMIP5 historical",
                                "v20111006annualMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20111006annualinstitute_id": "MPI-M",
                                "v20111006annualmodeling_realm": "atmos",
                                "v20111006annualproject_id": "CMIP5",
                                "v20111006annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111006annualinput_title": "MPI-ESM-LR model output prepared for CMIP5 historical",
                                "v20111006annualphysics_version": "1",
                                "v20111006annualexperiment": "historical",
                                "v20111006annualMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20111006annualcreation_date": "2013-06-28T13:16:54Z",
                                "v20111006annualcmor_version": "2.5.9",
                                "v20111006annualinstitution": "Max Planck Institute for Meteorology",
                                "v20111006annualETCCDI_software_version": "0.7.1",
                                "v20111006annualinitialization_method": "1",
                                "iridlhasSemantics": "iridl:MPI-ESM-LR",
                                "Conventions": "IRIDL"
                            },
                            "v20111006": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20111006",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MPI-ESM-LR"
                        },
                        "MPIESMMR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MPI-ESM-MR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120503monthlyparent_experiment_rip": "N/A",
                                "v20120503monthlyMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20120503monthlycontact": "bronaugh@uvic.ca",
                                "v20120503monthlyforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "v20120503monthlyproduct": "output",
                                "v20120503monthlyETCCDI_software": "climdex.pcic",
                                "v20120503monthlymodeling_realm": "atmos",
                                "v20120503monthlyexperiment": "historical",
                                "v20120503monthlyproject_id": "CMIP5",
                                "v20120503monthlynco_openmp_thread_number": "1",
                                "v20120503monthlysource": "MPI-ESM-MR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4936), T63L47; land: JSBACH (REV: 4936); ocean: MPIOM (REV: 4936), GR15L40; sea ice: 4936; marine bgc: HAMOCC (REV: 4936);",
                                "v20120503monthlyinput_title": "MPI-ESM-MR model output prepared for CMIP5 historical",
                                "v20120503monthlyMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20120503monthlyinitialization_method": "1",
                                "v20120503monthlyinput_tracking_id": "193f4631-10ba-49de-a85f-8d4888838ef8",
                                "v20120503monthlyConventions": "CF-1.4",
                                "v20120503monthlyinstitute_id": "MPI-M",
                                "v20120503monthlyfrequency": "monClim",
                                "v20120503monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120503monthlyexperiment_id": "historical",
                                "v20120503monthlyinput_frequency": "day",
                                "v20120503monthlytitle": "ETCCDI indices computed on MPI-ESM-MR model output prepared for CMIP5 historical",
                                "v20120503monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120503monthlyinput_creation_date": "2011-10-08T16:30:10Z",
                                "v20120503monthlycmor_version": "2.6.0",
                                "v20120503monthlymodel_id": "MPI-ESM-MR",
                                "v20120503monthlyETCCDI_software_version": "0.6.1",
                                "v20120503monthlyinstitution": "Max Planck Institute for Meteorology",
                                "v20120503monthlyETCCDI_institution_id": "PCIC",
                                "v20120503monthlyparent_experiment_id": "N/A",
                                "v20120503monthlyparent_experiment": "N/A",
                                "v20120503monthlycreation_date": "2012-07-12T17:29:17Z",
                                "v20120503monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120503monthlybranch_time": "0.0",
                                "v20120503monthlyphysics_version": "1",
                                "v20120503monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120503annualparent_experiment_rip": "N/A",
                                "v20120503annualMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20120503annualcontact": "bronaugh@uvic.ca",
                                "v20120503annualforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "v20120503annualproduct": "output",
                                "v20120503annualmodeling_realm": "atmos",
                                "v20120503annualETCCDI_software": "climdex.pcic",
                                "v20120503annualexperiment": "historical",
                                "v20120503annualproject_id": "CMIP5",
                                "v20120503annualnco_openmp_thread_number": "1",
                                "v20120503annualsource": "MPI-ESM-MR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4936), T63L47; land: JSBACH (REV: 4936); ocean: MPIOM (REV: 4936), GR15L40; sea ice: 4936; marine bgc: HAMOCC (REV: 4936);",
                                "v20120503annualinput_title": "MPI-ESM-MR model output prepared for CMIP5 historical",
                                "v20120503annualMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20120503annualinitialization_method": "1",
                                "v20120503annualinput_tracking_id": "193f4631-10ba-49de-a85f-8d4888838ef8",
                                "v20120503annualConventions": "CF-1.4",
                                "v20120503annualinstitute_id": "MPI-M",
                                "v20120503annualfrequency": "yr",
                                "v20120503annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120503annualexperiment_id": "historical",
                                "v20120503annualinput_frequency": "day",
                                "v20120503annualtitle": "ETCCDI indices computed on MPI-ESM-MR model output prepared for CMIP5 historical",
                                "v20120503annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120503annualmodel_id": "MPI-ESM-MR",
                                "v20120503annualcmor_version": "2.6.0",
                                "v20120503annualinput_creation_date": "2011-10-08T16:30:10Z",
                                "v20120503annualETCCDI_software_version": "0.6.1",
                                "v20120503annualinstitution": "Max Planck Institute for Meteorology",
                                "v20120503annualETCCDI_institution_id": "PCIC",
                                "v20120503annualparent_experiment_id": "N/A",
                                "v20120503annualparent_experiment": "N/A",
                                "v20120503annualcreation_date": "2012-07-14T15:16:49Z",
                                "v20120503annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120503annualbranch_time": "0.0",
                                "v20120503annualphysics_version": "1",
                                "v20120503annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "iridlhasSemantics": "iridl:MPI-ESM-MR",
                                "Conventions": "IRIDL"
                            },
                            "v20120503": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120503",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MPI-ESM-MR"
                        },
                        "MPIESMP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MPI-ESM-P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120315monthlycontact": "bronaugh@uvic.ca",
                                "v20120315monthlynco_openmp_thread_number": "1",
                                "v20120315monthlycomment": "The historical experiments with MPI-ESM-P differ from those based on MPI-ESM-LR in the choice of boundary conditions: orbit (prescribed orbital parameters (PMIP3) instead of calendar-based orbit);land-cover-changes (use of historical land-cover-change maps)",
                                "v20120315monthlyinput_tracking_id": "cc8470d9-2f89-4c90-a68d-9548c61e4408",
                                "v20120315monthlyproduct": "output",
                                "v20120315monthlyETCCDI_software": "climdex.pcic",
                                "v20120315monthlyinstitution": "Max Planck Institute for Meteorology",
                                "v20120315monthlyETCCDI_software_version": "0.6.1",
                                "v20120315monthlysource": "MPI-ESM-P 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 5051), T63L47; land: JSBACH (REV: 5051); ocean: MPIOM (REV: 5051), GR15L40; sea ice: 5051; marine bgc: HAMOCC (REV: 5051);",
                                "v20120315monthlyforcing": "GHG Oz SD Sl Vl LU",
                                "v20120315monthlybranch_time": "365242.0",
                                "v20120315monthlycmor_version": "2.6.0",
                                "v20120315monthlyConventions": "CF-1.4",
                                "v20120315monthlyinstitute_id": "MPI-M",
                                "v20120315monthlyinput_creation_date": "2012-02-17T14:56:55Z",
                                "v20120315monthlyinput_title": "MPI-ESM-P model output prepared for CMIP5 historical",
                                "v20120315monthlytitle": "ETCCDI indices computed on MPI-ESM-P model output prepared for CMIP5 historical",
                                "v20120315monthlyinput_frequency": "day",
                                "v20120315monthlyMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20120315monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120315monthlyinitialization_method": "1",
                                "v20120315monthlyMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20120315monthlyphysics_version": "1",
                                "v20120315monthlyexperiment": "historical",
                                "v20120315monthlytable_id": "Table day (12 January 2012) 7757d80c56ae0b9009f150afa4850c4e",
                                "v20120315monthlyparent_experiment": "last millennium",
                                "v20120315monthlymodel_id": "MPI-ESM-P",
                                "v20120315monthlyexperiment_id": "historical",
                                "v20120315monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120315monthlyproject_id": "CMIP5",
                                "v20120315monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120315monthlyparent_experiment_id": "past1000",
                                "v20120315monthlyfrequency": "monClim",
                                "v20120315monthlymodeling_realm": "atmos",
                                "v20120315monthlycreation_date": "2012-07-17T23:12:12Z",
                                "v20120315monthlyETCCDI_institution_id": "PCIC",
                                "v20120315annualcontact": "bronaugh@uvic.ca",
                                "v20120315annualnco_openmp_thread_number": "1",
                                "v20120315annualcomment": "The historical experiments with MPI-ESM-P differ from those based on MPI-ESM-LR in the choice of boundary conditions: orbit (prescribed orbital parameters (PMIP3) instead of calendar-based orbit);land-cover-changes (use of historical land-cover-change maps)",
                                "v20120315annualinput_tracking_id": "cc8470d9-2f89-4c90-a68d-9548c61e4408",
                                "v20120315annualproduct": "output",
                                "v20120315annualETCCDI_software": "climdex.pcic",
                                "v20120315annualinstitution": "Max Planck Institute for Meteorology",
                                "v20120315annualETCCDI_software_version": "0.6.1",
                                "v20120315annualsource": "MPI-ESM-P 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 5051), T63L47; land: JSBACH (REV: 5051); ocean: MPIOM (REV: 5051), GR15L40; sea ice: 5051; marine bgc: HAMOCC (REV: 5051);",
                                "v20120315annualforcing": "GHG Oz SD Sl Vl LU",
                                "v20120315annualbranch_time": "365242.0",
                                "v20120315annualcmor_version": "2.6.0",
                                "v20120315annualConventions": "CF-1.4",
                                "v20120315annualinstitute_id": "MPI-M",
                                "v20120315annualinput_creation_date": "2012-02-17T14:56:55Z",
                                "v20120315annualinput_title": "MPI-ESM-P model output prepared for CMIP5 historical",
                                "v20120315annualtitle": "ETCCDI indices computed on MPI-ESM-P model output prepared for CMIP5 historical",
                                "v20120315annualinput_frequency": "day",
                                "v20120315annualMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20120315annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120315annualinitialization_method": "1",
                                "v20120315annualMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20120315annualphysics_version": "1",
                                "v20120315annualexperiment": "historical",
                                "v20120315annualtable_id": "Table day (12 January 2012) 7757d80c56ae0b9009f150afa4850c4e",
                                "v20120315annualparent_experiment": "last millennium",
                                "v20120315annualmodel_id": "MPI-ESM-P",
                                "v20120315annualexperiment_id": "historical",
                                "v20120315annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120315annualproject_id": "CMIP5",
                                "v20120315annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120315annualparent_experiment_id": "past1000",
                                "v20120315annualfrequency": "yr",
                                "v20120315annualmodeling_realm": "atmos",
                                "v20120315annualcreation_date": "2012-07-14T14:57:58Z",
                                "v20120315annualETCCDI_institution_id": "PCIC",
                                "iridlhasSemantics": "iridl:MPI-ESM-P",
                                "Conventions": "IRIDL"
                            },
                            "v20120315": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120315",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "proleptic_gregorian",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MPI-ESM-P"
                        },
                        "MRICGCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MRI-CGCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120701monthlybranch_time": "36159.0",
                                "v20120701monthlyexperiment_id": "historical",
                                "v20120701monthlyinput_title": "MRI-CGCM3 model output prepared for CMIP5 historical",
                                "v20120701monthlyinput_creation_date": "2011-05-02T04:36:01Z",
                                "v20120701monthlyMRI_contact": "Seiji Yukimoto (yukimoto@mri-jma.go.jp)",
                                "v20120701monthlyproduct": "output",
                                "v20120701monthlymodeling_realm": "atmos",
                                "v20120701monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120701monthlyETCCDI_software_version": "0.7.1",
                                "v20120701monthlysource": "MRI-CGCM3 2011 atmosphere: GSMUV (gsmuv-110112, TL159L48); ocean: MRI.COM3 (MRICOM-3_0-20101116, 1x0.5L51); sea ice: MRI.COM3; land: HAL (HAL_cmip5_v0.31_04); aerosol: MASINGAR-mk2 (masingar_mk2-20110111_0203, TL95L48)",
                                "v20120701monthlyparent_experiment": "pre-industrial control",
                                "v20120701monthlyinput_tracking_id": "d80424aa-d221-4967-98e9-9f2718e613d4",
                                "v20120701monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120701monthlyConventions": "CF-1.4",
                                "v20120701monthlyphysics_version": "1",
                                "v20120701monthlyparent_experiment_id": "piControl",
                                "v20120701monthlytitle": "ETCCDI indices computed on MRI-CGCM3 model output prepared for CMIP5 historical",
                                "v20120701monthlycmor_version": "2.5.9",
                                "v20120701monthlycreation_date": "2013-06-29T04:44:31Z",
                                "v20120701monthlyexperiment": "historical",
                                "v20120701monthlyETCCDI_software": "climdex.pcic",
                                "v20120701monthlyinstitute_id": "MRI",
                                "v20120701monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120701monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120701monthlymodel_id": "MRI-CGCM3",
                                "v20120701monthlycontact": "bronaugh@uvic.ca",
                                "v20120701monthlyinput_frequency": "day",
                                "v20120701monthlyfrequency": "monClim",
                                "v20120701monthlyinstitution": "MRI (Meteorological Research Institute, Tsukuba, Japan)",
                                "v20120701monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC (GHG includes CO2, CH4, N2O, CFC-11, CFC-12, and HCFC-22)",
                                "v20120701monthlyinitialization_method": "1",
                                "v20120701monthlyproject_id": "CMIP5",
                                "v20120701monthlynco_openmp_thread_number": "1",
                                "v20120701monthlyMRI_references": "Model described by Yukimoto et al. (Technical Report of the Meteorological Research Institute, 2011, 64, 83pp.)",
                                "v20120701monthlyETCCDI_institution_id": "PCIC",
                                "v20120701annualbranch_time": "36159.0",
                                "v20120701annualinput_title": "MRI-CGCM3 model output prepared for CMIP5 historical",
                                "v20120701annualexperiment_id": "historical",
                                "v20120701annualinput_creation_date": "2011-05-02T04:36:01Z",
                                "v20120701annualMRI_contact": "Seiji Yukimoto (yukimoto@mri-jma.go.jp)",
                                "v20120701annualproduct": "output",
                                "v20120701annualmodeling_realm": "atmos",
                                "v20120701annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120701annualETCCDI_software_version": "0.7.1",
                                "v20120701annualsource": "MRI-CGCM3 2011 atmosphere: GSMUV (gsmuv-110112, TL159L48); ocean: MRI.COM3 (MRICOM-3_0-20101116, 1x0.5L51); sea ice: MRI.COM3; land: HAL (HAL_cmip5_v0.31_04); aerosol: MASINGAR-mk2 (masingar_mk2-20110111_0203, TL95L48)",
                                "v20120701annualparent_experiment": "pre-industrial control",
                                "v20120701annualinput_tracking_id": "d80424aa-d221-4967-98e9-9f2718e613d4",
                                "v20120701annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120701annualConventions": "CF-1.4",
                                "v20120701annualphysics_version": "1",
                                "v20120701annualparent_experiment_id": "piControl",
                                "v20120701annualtitle": "ETCCDI indices computed on MRI-CGCM3 model output prepared for CMIP5 historical",
                                "v20120701annualcmor_version": "2.5.9",
                                "v20120701annualcreation_date": "2013-06-29T03:13:39Z",
                                "v20120701annualexperiment": "historical",
                                "v20120701annualETCCDI_software": "climdex.pcic",
                                "v20120701annualinstitute_id": "MRI",
                                "v20120701annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120701annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120701annualmodel_id": "MRI-CGCM3",
                                "v20120701annualcontact": "bronaugh@uvic.ca",
                                "v20120701annualinput_frequency": "day",
                                "v20120701annualfrequency": "yr",
                                "v20120701annualforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC (GHG includes CO2, CH4, N2O, CFC-11, CFC-12, and HCFC-22)",
                                "v20120701annualinstitution": "MRI (Meteorological Research Institute, Tsukuba, Japan)",
                                "v20120701annualinitialization_method": "1",
                                "v20120701annualproject_id": "CMIP5",
                                "v20120701annualnco_openmp_thread_number": "1",
                                "v20120701annualMRI_references": "Model described by Yukimoto et al. (Technical Report of the Meteorological Research Institute, 2011, 64, 83pp.)",
                                "v20120701annualETCCDI_institution_id": "PCIC",
                                "iridlhasSemantics": "iridl:MRI-CGCM3",
                                "Conventions": "IRIDL"
                            },
                            "v20120701": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120701",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/MRI-CGCM3"
                        },
                        "NorESM1M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NorESM1-M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110901monthlyproject_id": "CMIP5",
                                "v20110901monthlybranch_time": "255135.0",
                                "v20110901monthlyinstitution": "Norwegian Climate Centre",
                                "v20110901monthlyexperiment_id": "historical",
                                "v20110901monthlyproduct": "output",
                                "v20110901monthlyexperiment": "historical",
                                "v20110901monthlyETCCDI_software_version": "0.6.1",
                                "v20110901monthlyfrequency": "monClim",
                                "v20110901monthlyETCCDI_software": "climdex.pcic",
                                "v20110901monthlymodeling_realm": "atmos",
                                "v20110901monthlyparent_experiment": "pre-industrial control",
                                "v20110901monthlyforcing": "GHG, SA, Oz, Sl, Vl, BC, OC",
                                "v20110901monthlycreation_date": "2012-07-13T19:27:15Z",
                                "v20110901monthlysource": "NorESM1-M 2011  atmosphere: CAM-Oslo (CAM4-Oslo-noresm-ver1_cmip5-r112, f19L26);  ocean: MICOM (MICOM-noresm-ver1_cmip5-r112, gx1v6L53);  sea ice: CICE (CICE4-noresm-ver1_cmip5-r112);  land: CLM (CLM4-noresm-ver1_cmip5-r112)",
                                "v20110901monthlycmor_version": "2.6.0",
                                "v20110901monthlyinput_tracking_id": "abdfa126-e2d9-45e6-9e36-07cec4ca9472",
                                "v20110901monthlyConventions": "CF-1.4",
                                "v20110901monthlyinput_frequency": "day",
                                "v20110901monthlytitle": "ETCCDI indices computed on NorESM1-M model output prepared for CMIP5 historical",
                                "v20110901monthlyparent_experiment_id": "piControl",
                                "v20110901monthlyphysics_version": "1",
                                "v20110901monthlyETCCDI_institution_id": "PCIC",
                                "v20110901monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110901monthlynco_openmp_thread_number": "1",
                                "v20110901monthlyinstitute_id": "NCC",
                                "v20110901monthlycontact": "bronaugh@uvic.ca",
                                "v20110901monthlymodel_id": "NorESM1-M",
                                "v20110901monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110901monthlyinput_creation_date": "2011-06-01T01:20:15Z",
                                "v20110901monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20110901monthlyinitialization_method": "1",
                                "v20110901monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110901monthlyinput_title": "NorESM1-M model output prepared for CMIP5 historical",
                                "v20110901monthlyNCC_contact": "Please send any requests or bug reports to noresm-ncc@met.no.",
                                "v20110901annualproject_id": "CMIP5",
                                "v20110901annualbranch_time": "255135.0",
                                "v20110901annualinstitution": "Norwegian Climate Centre",
                                "v20110901annualexperiment_id": "historical",
                                "v20110901annualproduct": "output",
                                "v20110901annualexperiment": "historical",
                                "v20110901annualETCCDI_software_version": "0.6.1",
                                "v20110901annualfrequency": "yr",
                                "v20110901annualETCCDI_software": "climdex.pcic",
                                "v20110901annualmodeling_realm": "atmos",
                                "v20110901annualsource": "NorESM1-M 2011  atmosphere: CAM-Oslo (CAM4-Oslo-noresm-ver1_cmip5-r112, f19L26);  ocean: MICOM (MICOM-noresm-ver1_cmip5-r112, gx1v6L53);  sea ice: CICE (CICE4-noresm-ver1_cmip5-r112);  land: CLM (CLM4-noresm-ver1_cmip5-r112)",
                                "v20110901annualforcing": "GHG, SA, Oz, Sl, Vl, BC, OC",
                                "v20110901annualcreation_date": "2012-07-14T14:51:30Z",
                                "v20110901annualparent_experiment": "pre-industrial control",
                                "v20110901annualcmor_version": "2.6.0",
                                "v20110901annualinput_tracking_id": "abdfa126-e2d9-45e6-9e36-07cec4ca9472",
                                "v20110901annualConventions": "CF-1.4",
                                "v20110901annualinput_frequency": "day",
                                "v20110901annualtitle": "ETCCDI indices computed on NorESM1-M model output prepared for CMIP5 historical",
                                "v20110901annualphysics_version": "1",
                                "v20110901annualparent_experiment_id": "piControl",
                                "v20110901annualETCCDI_institution_id": "PCIC",
                                "v20110901annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110901annualnco_openmp_thread_number": "1",
                                "v20110901annualinstitute_id": "NCC",
                                "v20110901annualcontact": "bronaugh@uvic.ca",
                                "v20110901annualmodel_id": "NorESM1-M",
                                "v20110901annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110901annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20110901annualinitialization_method": "1",
                                "v20110901annualinput_creation_date": "2011-06-01T01:20:15Z",
                                "v20110901annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110901annualinput_title": "NorESM1-M model output prepared for CMIP5 historical",
                                "v20110901annualNCC_contact": "Please send any requests or bug reports to noresm-ncc@met.no.",
                                "iridlhasSemantics": "iridl:NorESM1-M",
                                "Conventions": "IRIDL"
                            },
                            "v20110901": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110901",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "base_period": "1961-1990",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "base_period": "1961-1990",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/NorESM1-M"
                        },
                        "bcccsm11": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bcc-csm1-1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlybranch_time": "470.0",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyinput_tracking_id": "563b5f28-2748-46fe-8293-246d36f98571",
                                "v1monthlyproduct": "output",
                                "v1monthlyinstitute_id": "BCC",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlysource": "bcc-csm1-1:atmosphere:  BCC_AGCM2.1 (T42L26); land: BCC_AVIM1.0;ocean: MOM4_L40 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v1monthlyforcing": "Nat Ant GHG SD Oz Sl Vl SS Ds BC OC",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlyhistory": "Output from daily mean data 2011-06-15T08:56:11Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v1monthlyETCCDI_software_version": "0.6.1",
                                "v1monthlyexperiment": "historical",
                                "v1monthlyBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v1monthlymodel_id": "bcc-csm1-1",
                                "v1monthlytitle": "ETCCDI indices computed on bcc-csm1-1 model output prepared for CMIP5 historical",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyexperiment_id": "historical",
                                "v1monthlyparent_experiment": "pre-industrial control",
                                "v1monthlyfrequency": "mon",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlycreation_date": "2012-09-25T23:28:23Z",
                                "v1monthlycmor_version": "2.5.6",
                                "v1monthlyinput_title": "bcc-csm1-1 model output prepared for CMIP5 historical",
                                "v1monthlyinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v1monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v1monthlyphysics_version": "1",
                                "v1monthlyinput_creation_date": "2011-06-15T08:56:16Z",
                                "v1monthlycomment": "The experiment starts from piControl run at year 470. RCP8.5 scenario forcing data are used beyond year 2005.",
                                "v1monthlyparent_experiment_id": "piControl",
                                "v1annualbranch_time": "470.0",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualinput_tracking_id": "563b5f28-2748-46fe-8293-246d36f98571",
                                "v1annualproduct": "output",
                                "v1annualinstitute_id": "BCC",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualsource": "bcc-csm1-1:atmosphere:  BCC_AGCM2.1 (T42L26); land: BCC_AVIM1.0;ocean: MOM4_L40 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v1annualforcing": "Nat Ant GHG SD Oz Sl Vl SS Ds BC OC",
                                "v1annualinput_frequency": "day",
                                "v1annualinitialization_method": "1",
                                "v1annualConventions": "CF-1.4",
                                "v1annualhistory": "Output from daily mean data 2011-06-15T08:56:11Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v1annualETCCDI_software_version": "0.6.1",
                                "v1annualexperiment": "historical",
                                "v1annualBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v1annualmodel_id": "bcc-csm1-1",
                                "v1annualtitle": "ETCCDI indices computed on bcc-csm1-1 model output prepared for CMIP5 historical",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualexperiment_id": "historical",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualparent_experiment": "pre-industrial control",
                                "v1annualfrequency": "yr",
                                "v1annualproject_id": "CMIP5",
                                "v1annualcreation_date": "2012-09-25T23:28:43Z",
                                "v1annualcmor_version": "2.5.6",
                                "v1annualinput_title": "bcc-csm1-1 model output prepared for CMIP5 historical",
                                "v1annualinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v1annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v1annualinput_creation_date": "2011-06-15T08:56:16Z",
                                "v1annualphysics_version": "1",
                                "v1annualcomment": "The experiment starts from piControl run at year 470. RCP8.5 scenario forcing data are used beyond year 2005.",
                                "v1annualparent_experiment_id": "piControl",
                                "iridlhasSemantics": "iridl:bcc-csm-1",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "365",
                                "pointwidth": "1.0",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "365",
                                "pointwidth": "1.0"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/bcc-csm1-1"
                        },
                        "bcccsm11m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bcc-csm1-1-m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120709monthlyexperiment_id": "historical",
                                "v20120709monthlyexperiment": "historical",
                                "v20120709monthlyBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120709monthlycontact": "bronaugh@uvic.ca",
                                "v20120709monthlyproduct": "output",
                                "v20120709monthlycmor_version": "2.5.6",
                                "v20120709monthlyforcing": "Nat Ant GHG SD Oz Sl Vl SS Ds BC OC",
                                "v20120709monthlycreation_date": "2013-06-27T22:55:19Z",
                                "v20120709monthlyfrequency": "mon",
                                "v20120709monthlysource": "bcc-csm1-1-m:atmosphere:  BCC_AGCM2.2 (T106L26); land: BCC_AVIM1.1;ocean: MOM4_L40v2 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120709monthlycomment": "The main difference between BCC-CSM1-1-M and BCC-CSM1-1 is their horizontal resolutions of the atmospheric component and the corresponding mask of sea-land. The experiment starts from piControl run at year 300. RCP8.5 scenario forcing data are used beyond year 2005.",
                                "v20120709monthlymodel_id": "bcc-csm1-1-m",
                                "v20120709monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120709monthlyinput_tracking_id": "5bbc1d61-36ef-4837-9f01-2e28c6797716",
                                "v20120709monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120709monthlyConventions": "CF-1.4",
                                "v20120709monthlyETCCDI_software_version": "0.7.1",
                                "v20120709monthlyphysics_version": "1",
                                "v20120709monthlytitle": "ETCCDI indices computed on bcc-csm1-1-m model output prepared for CMIP5 historical",
                                "v20120709monthlyproject_id": "CMIP5",
                                "v20120709monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120709monthlyinput_frequency": "day",
                                "v20120709monthlyinput_title": "bcc-csm1-1-m model output prepared for CMIP5 historical",
                                "v20120709monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120709monthlybranch_time": "300.0",
                                "v20120709monthlynco_openmp_thread_number": "1",
                                "v20120709monthlyinitialization_method": "1",
                                "v20120709monthlymodeling_realm": "atmos",
                                "v20120709monthlyparent_experiment": "pre-industrial control",
                                "v20120709monthlyinstitute_id": "BCC",
                                "v20120709monthlyparent_experiment_id": "piControl",
                                "v20120709monthlyETCCDI_software": "climdex.pcic",
                                "v20120709monthlyETCCDI_institution_id": "PCIC",
                                "v20120709monthlyinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120709monthlyinput_creation_date": "2012-03-15T08:43:42Z",
                                "v20120709annualexperiment_id": "historical",
                                "v20120709annualexperiment": "historical",
                                "v20120709annualBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120709annualcontact": "bronaugh@uvic.ca",
                                "v20120709annualproduct": "output",
                                "v20120709annualcmor_version": "2.5.6",
                                "v20120709annualforcing": "Nat Ant GHG SD Oz Sl Vl SS Ds BC OC",
                                "v20120709annualcreation_date": "2013-06-27T22:55:20Z",
                                "v20120709annualfrequency": "yr",
                                "v20120709annualsource": "bcc-csm1-1-m:atmosphere:  BCC_AGCM2.2 (T106L26); land: BCC_AVIM1.1;ocean: MOM4_L40v2 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120709annualcomment": "The main difference between BCC-CSM1-1-M and BCC-CSM1-1 is their horizontal resolutions of the atmospheric component and the corresponding mask of sea-land. The experiment starts from piControl run at year 300. RCP8.5 scenario forcing data are used beyond year 2005.",
                                "v20120709annualmodel_id": "bcc-csm1-1-m",
                                "v20120709annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120709annualinput_tracking_id": "5bbc1d61-36ef-4837-9f01-2e28c6797716",
                                "v20120709annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120709annualConventions": "CF-1.4",
                                "v20120709annualETCCDI_software_version": "0.7.1",
                                "v20120709annualphysics_version": "1",
                                "v20120709annualtitle": "ETCCDI indices computed on bcc-csm1-1-m model output prepared for CMIP5 historical",
                                "v20120709annualproject_id": "CMIP5",
                                "v20120709annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120709annualinput_frequency": "day",
                                "v20120709annualinput_title": "bcc-csm1-1-m model output prepared for CMIP5 historical",
                                "v20120709annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120709annualbranch_time": "300.0",
                                "v20120709annualnco_openmp_thread_number": "1",
                                "v20120709annualinitialization_method": "1",
                                "v20120709annualmodeling_realm": "atmos",
                                "v20120709annualparent_experiment": "pre-industrial control",
                                "v20120709annualinstitute_id": "BCC",
                                "v20120709annualparent_experiment_id": "piControl",
                                "v20120709annualETCCDI_software": "climdex.pcic",
                                "v20120709annualETCCDI_institution_id": "PCIC",
                                "v20120709annualinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120709annualinput_creation_date": "2012-03-15T08:43:42Z",
                                "iridlhasSemantics": "iridl:bcc-csm1-1-m",
                                "Conventions": "IRIDL"
                            },
                            "v20120709": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120709",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "base_period": "1961-1990",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "365",
                                "pointwidth": "1.0",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-01-01",
                                "gridtype": "0",
                                "calendar": "365",
                                "pointwidth": "1.0"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/bcc-csm1-1-m"
                        },
                        "inmcm4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "inmcm4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110323monthlyinput_title": "inmcm4 model output prepared for CMIP5 Historical",
                                "v20110323monthlyfrequency": "monClim",
                                "v20110323monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110323monthlycreation_date": "2012-07-15T00:24:00Z",
                                "v20110323monthlymodeling_realm": "atmos",
                                "v20110323monthlyproduct": "output",
                                "v20110323monthlybranch_time": "0.0",
                                "v20110323monthlycontact": "bronaugh@uvic.ca",
                                "v20110323monthlyETCCDI_institution_id": "PCIC",
                                "v20110323monthlytable_id": "Table day (12 May 2010) f130b8ed0705d49c749410c0519c50cb",
                                "v20110323monthlyETCCDI_software": "climdex.pcic",
                                "v20110323monthlycmor_version": "2.0.0",
                                "v20110323monthlyinput_tracking_id": "6ccb4a84-3f8d-45a1-98d9-cca7ba404535",
                                "v20110323monthlysource": "inmcm4 (2009)",
                                "v20110323monthlyinstitute_id": "INM",
                                "v20110323monthlyConventions": "CF-1.4",
                                "v20110323monthlyexperiment": "Historical",
                                "v20110323monthlyINM_references": "Volodin, Diansky, Gusev 2010. Climate model INMCM4.0. Izvestia RAS. Atmospheric and oceanic physics, V.46, N4, in print.",
                                "v20110323monthlyrealization": "1",
                                "v20110323monthlymodel_id": "inmcm4",
                                "v20110323monthlytitle": "ETCCDI indices computed on inmcm4 model output prepared for CMIP5 Historical",
                                "v20110323monthlyinput_frequency": "day",
                                "v20110323monthlyinput_creation_date": "2010-08-31T12:17:32Z",
                                "v20110323monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110323monthlyproject_id": "CMIP5",
                                "v20110323monthlyparent_experiment_id": "piControl",
                                "v20110323monthlyETCCDI_software_version": "0.6.1",
                                "v20110323monthlyexperiment_id": "historical",
                                "v20110323monthlycomment": "no comments",
                                "v20110323monthlyforcing": "N/A",
                                "v20110323monthlyinstitution": "INM (Institute for Numerical Mathematics,  Moscow, Russia)",
                                "v20110323monthlyinitialization_method": "1",
                                "v20110323monthlynco_openmp_thread_number": "1",
                                "v20110323monthlyphysics_version": "1",
                                "v20110323monthlyINM_contact": "Evgeny Volodin, volodin@inm.ras.ru,INM RAS, Gubkina 8, Moscow, 119333 Russia,+7-495-9383904",
                                "v20110323monthlyparent_experiment": "pre-industrial control",
                                "v20110323monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110323annualinput_title": "inmcm4 model output prepared for CMIP5 Historical",
                                "v20110323annualfrequency": "yr",
                                "v20110323annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110323annualcreation_date": "2012-07-14T16:38:07Z",
                                "v20110323annualmodeling_realm": "atmos",
                                "v20110323annualproduct": "output",
                                "v20110323annualbranch_time": "0.0",
                                "v20110323annualcontact": "bronaugh@uvic.ca",
                                "v20110323annualETCCDI_institution_id": "PCIC",
                                "v20110323annualtable_id": "Table day (12 May 2010) f130b8ed0705d49c749410c0519c50cb",
                                "v20110323annualETCCDI_software": "climdex.pcic",
                                "v20110323annualcmor_version": "2.0.0",
                                "v20110323annualinput_tracking_id": "6ccb4a84-3f8d-45a1-98d9-cca7ba404535",
                                "v20110323annualsource": "inmcm4 (2009)",
                                "v20110323annualinstitute_id": "INM",
                                "v20110323annualConventions": "CF-1.4",
                                "v20110323annualexperiment": "Historical",
                                "v20110323annualINM_references": "Volodin, Diansky, Gusev 2010. Climate model INMCM4.0. Izvestia RAS. Atmospheric and oceanic physics, V.46, N4, in print.",
                                "v20110323annualrealization": "1",
                                "v20110323annualmodel_id": "inmcm4",
                                "v20110323annualtitle": "ETCCDI indices computed on inmcm4 model output prepared for CMIP5 Historical",
                                "v20110323annualinput_frequency": "day",
                                "v20110323annualinput_creation_date": "2010-08-31T12:17:32Z",
                                "v20110323annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110323annualproject_id": "CMIP5",
                                "v20110323annualparent_experiment_id": "piControl",
                                "v20110323annualETCCDI_software_version": "0.6.1",
                                "v20110323annualexperiment_id": "historical",
                                "v20110323annualcomment": "no comments",
                                "v20110323annualforcing": "N/A",
                                "v20110323annualinstitution": "INM (Institute for Numerical Mathematics,  Moscow, Russia)",
                                "v20110323annualinitialization_method": "1",
                                "v20110323annualnco_openmp_thread_number": "1",
                                "v20110323annualphysics_version": "1",
                                "v20110323annualINM_contact": "Evgeny Volodin, volodin@inm.ras.ru,INM RAS, Gubkina 8, Moscow, 119333 Russia,+7-495-9383904",
                                "v20110323annualparent_experiment": "pre-industrial control",
                                "v20110323annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "iridlhasSemantics": "iridl:inmcm4",
                                "Conventions": "IRIDL"
                            },
                            "v20110323": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110323",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "units": "kg m-2 d-1",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time",
                                "bounds": "time2"
                            },
                            "time2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1850-1-1",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "365",
                                "standard_name": "time"
                            },
                            "bnds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "bnds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.0",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.5",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/historical/inmcm4"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "ACCESS10",
                            "BNUESM",
                            "CCSM4",
                            "CESM1FASTCHEM",
                            "CMCCCESM",
                            "CMCCCM",
                            "CMCCCMS",
                            "CNRMCM5",
                            "CSIROMk360",
                            "CanCM4",
                            "CanESM2",
                            "ECEARTH",
                            "FGOALSg2",
                            "FGOALSs2",
                            "GFDLCM3",
                            "GFDLESM2G",
                            "GFDLESM2M",
                            "GISSE2R",
                            "HadCM3",
                            "HadGEM2CC",
                            "HadGEM2ES",
                            "IPSLCM5ALR",
                            "IPSLCM5AMR",
                            "IPSLCM5BLR",
                            "MIROCESM",
                            "MIROCESMCHEM",
                            "MIROC4h",
                            "MIROC5",
                            "MPIESMLR",
                            "MPIESMMR",
                            "MPIESMP",
                            "MRICGCM3",
                            "NorESM1M",
                            "bcccsm11",
                            "bcccsm11m",
                            "inmcm4"
                        ]
                    },
                    "rcp45": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "rcp45",
                        "restriction": "Public",
                        "ACCESS10": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ACCESS1-0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlyforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1monthlyrealization": "1",
                                "v1monthlyparent_experiment": "historical",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlyparent_experiment_rip": "r1i1p1",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlyproduct": "output",
                                "v1monthlyinput_title": "ACCESS1-0 model output prepared for CMIP5 RCP4.5",
                                "v1monthlyinput_creation_date": "2012-02-29T04:22:20Z",
                                "v1monthlymodel_id": "ACCESS1-0",
                                "v1monthlyexperiment_id": "rcp45",
                                "v1monthlyCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1monthlyphysics_version": "1",
                                "v1monthlyCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1monthlysource": "ACCESS1-0 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: MOSES2 (1.875 degree EW x 1.25 degree NS, 4 levels)",
                                "v1monthlyETCCDI_software_version": "0.6.1",
                                "v1monthlyparent_experiment_id": "historical",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlytitle": "ETCCDI indices computed on ACCESS1-0 model output prepared for CMIP5 RCP4.5",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyversion_number": "v20120115",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1monthlyinstitute_id": "CSIRO-BOM",
                                "v1monthlycmor_version": "2.8.0",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlycreation_date": "2012-07-12T17:58:18Z",
                                "v1monthlybranch_time": "732311.0",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlyexperiment": "RCP4.5",
                                "v1monthlyfrequency": "mon",
                                "v1monthlytable_id": "Table day (01 February 2012) b6353e9919862612c81d65cae757c88a",
                                "v1annualforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1annualrealization": "1",
                                "v1annualparent_experiment": "historical",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualproduct": "output",
                                "v1annualexperiment_id": "rcp45",
                                "v1annualinput_creation_date": "2012-02-29T04:22:20Z",
                                "v1annualmodel_id": "ACCESS1-0",
                                "v1annualinput_title": "ACCESS1-0 model output prepared for CMIP5 RCP4.5",
                                "v1annualCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1annualphysics_version": "1",
                                "v1annualCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1annualsource": "ACCESS1-0 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: MOSES2 (1.875 degree EW x 1.25 degree NS, 4 levels)",
                                "v1annualETCCDI_software_version": "0.6.1",
                                "v1annualparent_experiment_id": "historical",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualConventions": "CF-1.4",
                                "v1annualinitialization_method": "1",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualtitle": "ETCCDI indices computed on ACCESS1-0 model output prepared for CMIP5 RCP4.5",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualinput_frequency": "day",
                                "v1annualversion_number": "v20120115",
                                "v1annualinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualinstitute_id": "CSIRO-BOM",
                                "v1annualcmor_version": "2.8.0",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualproject_id": "CMIP5",
                                "v1annualcreation_date": "2012-07-12T17:58:23Z",
                                "v1annualbranch_time": "732311.0",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualexperiment": "RCP4.5",
                                "v1annualfrequency": "yr",
                                "v1annualtable_id": "Table day (01 February 2012) b6353e9919862612c81d65cae757c88a",
                                "iridlhasSemantics": "iridl:ACCESS1-0",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:18 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 12 17:58:24 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/ACCESS1-0"
                        },
                        "ACCESS13": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ACCESS1-3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlyphysics_version": "1",
                                "v1monthlyinput_title": "ACCESS1-3 model output prepared for CMIP5 RCP4.5",
                                "v1monthlytable_id": "Table day (01 February 2012) b6353e9919862612c81d65cae757c88a",
                                "v1monthlyproduct": "output",
                                "v1monthlybranch_time": "732311.0",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyparent_experiment_rip": "r1i1p1",
                                "v1monthlyinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1monthlyrealization": "1",
                                "v1monthlymodel_id": "ACCESS1.3",
                                "v1monthlyinput_creation_date": "2012-04-03T07:15:06Z",
                                "v1monthlysource": "ACCESS1-3 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: CABLE1.0 (1.875 degree EW x 1.25 degree NS, 6 levels)",
                                "v1monthlyCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyinstitute_id": "CSIRO-BOM",
                                "v1monthlyparent_experiment": "historical",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlyparent_experiment_id": "historical",
                                "v1monthlytitle": "ETCCDI indices computed on ACCESS1-3 model output prepared for CMIP5 RCP4.5",
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlyversion_number": "v20120413",
                                "v1monthlyETCCDI_software_version": "0.6.1",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1monthlyexperiment": "RCP4.5",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlycreation_date": "2012-07-30T13:25:17Z",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlycmor_version": "2.8.0",
                                "v1monthlyforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1monthlyexperiment_id": "rcp45",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlyfrequency": "mon",
                                "v1annualphysics_version": "1",
                                "v1annualinput_title": "ACCESS1-3 model output prepared for CMIP5 RCP4.5",
                                "v1annualtable_id": "Table day (01 February 2012) b6353e9919862612c81d65cae757c88a",
                                "v1annualproduct": "output",
                                "v1annualbranch_time": "732311.0",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualparent_experiment_rip": "r1i1p1",
                                "v1annualinstitution": "CSIRO (Commonwealth Scientific and Industrial Research Organisation, Australia), and BOM (Bureau of Meteorology, Australia)",
                                "v1annualrealization": "1",
                                "v1annualmodel_id": "ACCESS1.3",
                                "v1annualinput_creation_date": "2012-04-03T07:15:06Z",
                                "v1annualsource": "ACCESS1-3 2011. Atmosphere: AGCM v1.0 (N96 grid-point, 1.875 degrees EW x approx 1.25 degree NS, 38 levels); ocean: NOAA/GFDL MOM4p1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S, 50 levels); sea ice: CICE4.1 (nominal 1.0 degree EW x 1.0 degrees NS, tripolar north of 65N, equatorial refinement to 1/3 degree from 10S to 10 N, cosine dependent NS south of 25S); land: CABLE1.0 (1.875 degree EW x 1.25 degree NS, 6 levels)",
                                "v1annualCSIROBOM_contact": "The ACCESS wiki: http://wiki.csiro.au/confluence/display/ACCESS/Home. Contact Tony.Hirst@csiro.au regarding the ACCESS coupled climate model. Contact Peter.Uhe@csiro.au regarding ACCESS coupled climate model CMIP5 datasets.",
                                "v1annualinput_frequency": "day",
                                "v1annualinstitute_id": "CSIRO-BOM",
                                "v1annualparent_experiment": "historical",
                                "v1annualConventions": "CF-1.4",
                                "v1annualparent_experiment_id": "historical",
                                "v1annualtitle": "ETCCDI indices computed on ACCESS1-3 model output prepared for CMIP5 RCP4.5",
                                "v1annualproject_id": "CMIP5",
                                "v1annualversion_number": "v20120413",
                                "v1annualETCCDI_software_version": "0.6.1",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualCSIROBOM_references": "See http://wiki.csiro.au/confluence/display/ACCESS/ACCESS+Publications",
                                "v1annualexperiment": "RCP4.5",
                                "v1annualinitialization_method": "1",
                                "v1annualcreation_date": "2012-07-30T13:25:34Z",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualcmor_version": "2.8.0",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualforcing": "GHG, Oz, SA, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFC11, CFC12, CFC113, HCFC22, HFC125, HFC134a)",
                                "v1annualexperiment_id": "rcp45",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualfrequency": "yr",
                                "iridlhasSemantics": "iridl:ACCESS1-3",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:17 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 30 13:25:34 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/ACCESS1-3"
                        },
                        "BNUESM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "BNU-ESM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120406monthlyparent_experiment_id": "historical",
                                "v20120406monthlyfrequency": "mon",
                                "v20120406monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120406monthlyproduct": "output",
                                "v20120406monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120406monthlyexperiment": "RCP4.5",
                                "v20120406monthlyexperiment_id": "rcp45",
                                "v20120406monthlyinitialization_method": "1",
                                "v20120406monthlyinput_tracking_id": "1835a868-6891-4291-8086-524b068bc4db",
                                "v20120406monthlysource": "BNU-ESM",
                                "v20120406monthlyETCCDI_institution_id": "PCIC",
                                "v20120406monthlyETCCDI_software_version": "0.6.1",
                                "v20120406monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120406monthlyparent_experiment_rip": "r1i1p1",
                                "v20120406monthlyConventions": "CF-1.4",
                                "v20120406monthlyhistory": "2012-04-06T12:28:29Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120406monthlymodeling_realm": "atmos",
                                "v20120406monthlytitle": "ETCCDI indices computed on BNU-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120406monthlyETCCDI_software": "climdex.pcic",
                                "v20120406monthlyforcing": "Nat,Ant",
                                "v20120406monthlyrealization": "1",
                                "v20120406monthlyparent_experiment": "historical",
                                "v20120406monthlycreation_date": "2012-07-19T11:13:25Z",
                                "v20120406monthlyinstitution": "GCESS,BNU,Beijing,China",
                                "v20120406monthlymodel_id": "BNU-ESM",
                                "v20120406monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120406monthlyinput_frequency": "day",
                                "v20120406monthlybranch_time": "0.0",
                                "v20120406monthlyBNU_contact": "Ji Duoying (duoyingji@bnu.edu.cn)",
                                "v20120406monthlycontact": "bronaugh@uvic.ca",
                                "v20120406monthlyinput_creation_date": "2012-04-06T12:28:49Z",
                                "v20120406monthlyproject_id": "CMIP5",
                                "v20120406monthlyinstitute_id": "BNU",
                                "v20120406monthlyphysics_version": "1",
                                "v20120406monthlyinput_title": "BNU-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120406monthlycmor_version": "2.7.1",
                                "v20120406annualparent_experiment_id": "historical",
                                "v20120406annualfrequency": "yr",
                                "v20120406annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120406annualproduct": "output",
                                "v20120406annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120406annualexperiment": "RCP4.5",
                                "v20120406annualexperiment_id": "rcp45",
                                "v20120406annualinitialization_method": "1",
                                "v20120406annualsource": "BNU-ESM",
                                "v20120406annualETCCDI_institution_id": "PCIC",
                                "v20120406annualETCCDI_software_version": "0.6.1",
                                "v20120406annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120406annualparent_experiment_rip": "r1i1p1",
                                "v20120406annualConventions": "CF-1.4",
                                "v20120406annualmodeling_realm": "atmos",
                                "v20120406annualhistory": "2012-04-06T12:28:29Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120406annualtitle": "ETCCDI indices computed on BNU-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120406annualETCCDI_software": "climdex.pcic",
                                "v20120406annualforcing": "Nat,Ant",
                                "v20120406annualrealization": "1",
                                "v20120406annualparent_experiment": "historical",
                                "v20120406annualcreation_date": "2012-07-19T11:13:27Z",
                                "v20120406annualinstitution": "GCESS,BNU,Beijing,China",
                                "v20120406annualmodel_id": "BNU-ESM",
                                "v20120406annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120406annualinput_frequency": "day",
                                "v20120406annualbranch_time": "0.0",
                                "v20120406annualBNU_contact": "Ji Duoying (duoyingji@bnu.edu.cn)",
                                "v20120406annualcontact": "bronaugh@uvic.ca",
                                "v20120406annualinput_creation_date": "2012-04-06T12:28:49Z",
                                "v20120406annualproject_id": "CMIP5",
                                "v20120406annualinstitute_id": "BNU",
                                "v20120406annualphysics_version": "1",
                                "v20120406annualinput_title": "BNU-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120406annualcmor_version": "2.7.1",
                                "iridlhasSemantics": "iridl:BNU-ESM",
                                "Conventions": "IRIDL"
                            },
                            "v20120406": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120406",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:25 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Thu Jul 19 11:13:27 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/BNU-ESM"
                        },
                        "CCSM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CCSM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyforcing": "Sl GHG Vl SS Ds SA BC MD OC Oz AA",
                                "mult_versionsmonthlyparent_experiment_id": "historical",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlycesm_compset": "BRCP45CN",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsmonthlycreation_date": "2013-07-20T10:39:20Z",
                                "mult_versionsmonthlyexperiment_id": "rcp45",
                                "mult_versionsmonthlyforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlyresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "mult_versionsmonthlysource": "CCSM4",
                                "mult_versionsmonthlyinstitute_id": "NCAR",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlycmor_version": "2.7.1",
                                "mult_versionsmonthlyinput_tracking_id": "d72d5ac8-1241-41dc-89e8-434d76309a29",
                                "mult_versionsmonthlyexperiment": "RCP4.5",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on CCSM4 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlymodel_id": "CCSM4",
                                "mult_versionsmonthlybranch_time": "2005.0",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyNCAR_references": "Gent P. R., et.al. 2011: The Community Climate System Model version 4. J. Climate, doi: 10.1175/2011JCLI4083.1",
                                "mult_versionsmonthlyprocessing_code_information": "Last Changed Rev: 451 Last Changed Date: 2011-11-09 10:57:45 -0700 (Wed, 09 Nov 2011) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyprocessed_by": "strandwg on copper.cgd.ucar.edu at 20111109  -134521.156",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlycesm_casename": "b40.rcp4_5.1deg.001",
                                "mult_versionsmonthlyparent_experiment": "historical",
                                "mult_versionsmonthlyinput_title": "CCSM4 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyNCAR_contact": "cesm_data@ucar.edu",
                                "mult_versionsmonthlyinstitution": "NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "mult_versionsmonthlyinput_creation_date": "2011-11-09T20:45:21Z",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlycesm_repotag": "ccsm4_0_beta49",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsannualforcing": "Sl GHG Vl SS Ds SA BC MD OC Oz AA",
                                "mult_versionsannualparent_experiment_id": "historical",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualcesm_compset": "BRCP45CN",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "mult_versionsannualcreation_date": "2013-07-20T10:39:21Z",
                                "mult_versionsannualexperiment_id": "rcp45",
                                "mult_versionsannualsource": "CCSM4",
                                "mult_versionsannualforcing_note": "Additional information on the external forcings used in this experiment can be found at http://www.cesm.ucar.edu/CMIP5/forcing_information",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualresolution": "f09_g16 (0.9x1.25_gx1v6)",
                                "mult_versionsannualinstitute_id": "NCAR",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualcmor_version": "2.7.1",
                                "mult_versionsannualinput_tracking_id": "d72d5ac8-1241-41dc-89e8-434d76309a29",
                                "mult_versionsannualexperiment": "RCP4.5",
                                "mult_versionsannualtitle": "ETCCDI indices computed on CCSM4 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualmodel_id": "CCSM4",
                                "mult_versionsannualbranch_time": "2005.0",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualprocessing_code_information": "Last Changed Rev: 451 Last Changed Date: 2011-11-09 10:57:45 -0700 (Wed, 09 Nov 2011) Repository UUID: d2181dbe-5796-6825-dc7f-cbd98591f93d",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualNCAR_references": "Gent P. R., et.al. 2011: The Community Climate System Model version 4. J. Climate, doi: 10.1175/2011JCLI4083.1",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualprocessed_by": "strandwg on copper.cgd.ucar.edu at 20111109  -134521.156",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualcesm_casename": "b40.rcp4_5.1deg.001",
                                "mult_versionsannualparent_experiment": "historical",
                                "mult_versionsannualinput_title": "CCSM4 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualNCAR_contact": "cesm_data@ucar.edu",
                                "mult_versionsannualinstitution": "NCAR (National Center for Atmospheric Research) Boulder, CO, USA",
                                "mult_versionsannualinput_creation_date": "2011-11-09T20:45:21Z",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualacknowledgements": "The CESM project is supported by the National Science Foundation and the Office of Science (BER) of the U.S. Department of Energy. NCAR is sponsored by the National Science Foundation. Computing resources were provided by the Climate Simulation Laboratory at the NCAR Computational and Information Systems Laboratory (CISL), sponsored by the National Science Foundation and other agencies.",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualcesm_repotag": "ccsm4_0_beta49",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "iridlhasSemantics": "iridl:CCSM4",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "long_name": "realization",
                                "standard_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.25",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "0.9424084",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CCSM4"
                        },
                        "CMCCCM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMCC-CM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120518monthlyparent_experiment_rip": "N/A",
                                "v20120518monthlycomment": "RCP4.5 simulation starting at the end of the historical run",
                                "v20120518monthlyCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120518monthlymodel_id": "CMCC-CM",
                                "v20120518monthlycmor_version": "2.7.1",
                                "v20120518monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120518monthlyproduct": "output",
                                "v20120518monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120518monthlyinput_title": "CMCC-CM model output prepared for CMIP5 RCP4.5",
                                "v20120518monthlysource": "CMCC-CM",
                                "v20120518monthlyinitialization_method": "1",
                                "v20120518monthlyinput_frequency": "day",
                                "v20120518monthlyConventions": "CF-1.4",
                                "v20120518monthlyinstitute_id": "CMCC",
                                "v20120518monthlynco_openmp_thread_number": "1",
                                "v20120518monthlyinput_creation_date": "2012-01-12T19:33:41Z",
                                "v20120518monthlyparent_experiment_id": "historical",
                                "v20120518monthlyrealization": "1",
                                "v20120518monthlytitle": "ETCCDI indices computed on CMCC-CM model output prepared for CMIP5 RCP4.5",
                                "v20120518monthlyparent_experiment": "historical",
                                "v20120518monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120518monthlycreation_date": "2012-07-20T22:19:12Z",
                                "v20120518monthlyETCCDI_software": "climdex.pcic",
                                "v20120518monthlyCMCC_contact": "Silvio Gualdi (gualdi@bo.ingv.it)",
                                "v20120518monthlymodeling_realm": "atmos",
                                "v20120518monthlyexperiment": "RCP4.5",
                                "v20120518monthlyfrequency": "mon",
                                "v20120518monthlyproject_id": "CMIP5",
                                "v20120518monthlyinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti",
                                "v20120518monthlybranch_time": "56978.0",
                                "v20120518monthlycontact": "bronaugh@uvic.ca",
                                "v20120518monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120518monthlyexperiment_id": "rcp45",
                                "v20120518monthlyETCCDI_software_version": "0.6.1",
                                "v20120518monthlyforcing": "Nat,Ant,GHG,SA,TO,Sl",
                                "v20120518monthlyETCCDI_institution_id": "PCIC",
                                "v20120518monthlyphysics_version": "1",
                                "v20120518annualparent_experiment_rip": "N/A",
                                "v20120518annualcomment": "RCP4.5 simulation starting at the end of the historical run",
                                "v20120518annualCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120518annualmodel_id": "CMCC-CM",
                                "v20120518annualcmor_version": "2.7.1",
                                "v20120518annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120518annualproduct": "output",
                                "v20120518annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120518annualinput_title": "CMCC-CM model output prepared for CMIP5 RCP4.5",
                                "v20120518annualsource": "CMCC-CM",
                                "v20120518annualinitialization_method": "1",
                                "v20120518annualinput_frequency": "day",
                                "v20120518annualConventions": "CF-1.4",
                                "v20120518annualinstitute_id": "CMCC",
                                "v20120518annualnco_openmp_thread_number": "1",
                                "v20120518annualinput_creation_date": "2012-01-12T19:33:41Z",
                                "v20120518annualrealization": "1",
                                "v20120518annualparent_experiment_id": "historical",
                                "v20120518annualtitle": "ETCCDI indices computed on CMCC-CM model output prepared for CMIP5 RCP4.5",
                                "v20120518annualparent_experiment": "historical",
                                "v20120518annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120518annualcreation_date": "2012-07-20T22:20:24Z",
                                "v20120518annualETCCDI_software": "climdex.pcic",
                                "v20120518annualCMCC_contact": "Silvio Gualdi (gualdi@bo.ingv.it)",
                                "v20120518annualmodeling_realm": "atmos",
                                "v20120518annualexperiment": "RCP4.5",
                                "v20120518annualfrequency": "yr",
                                "v20120518annualproject_id": "CMIP5",
                                "v20120518annualinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti",
                                "v20120518annualbranch_time": "56978.0",
                                "v20120518annualcontact": "bronaugh@uvic.ca",
                                "v20120518annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120518annualexperiment_id": "rcp45",
                                "v20120518annualETCCDI_software_version": "0.6.1",
                                "v20120518annualETCCDI_institution_id": "PCIC",
                                "v20120518annualforcing": "Nat,Ant,GHG,SA,TO,Sl",
                                "v20120518annualphysics_version": "1",
                                "iridlhasSemantics": "iridl:CMCC-CM",
                                "Conventions": "IRIDL"
                            },
                            "v20120518": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120518",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:19:12 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 20 22:20:24 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CMCC-CM"
                        },
                        "CMCCCMS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMCC-CMS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120717monthlyphysics_version": "1",
                                "v20120717monthlynco_openmp_thread_number": "1",
                                "v20120717monthlyinput_creation_date": "2011-12-05T01:24:43Z",
                                "v20120717monthlyproduct": "output",
                                "v20120717monthlyinitialization_method": "1",
                                "v20120717monthlyparent_experiment_rip": "r1i1p1",
                                "v20120717monthlyETCCDI_institution_id": "PCIC",
                                "v20120717monthlysource": "CMCC-CMS",
                                "v20120717monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120717monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120717monthlyinput_title": "CMCC-CMS model output prepared for CMIP5 RCP4.5",
                                "v20120717monthlycmor_version": "2.7.1",
                                "v20120717monthlyexperiment": "RCP4.5",
                                "v20120717monthlyforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120717monthlyConventions": "CF-1.4",
                                "v20120717monthlybranch_time": "56978.0",
                                "v20120717monthlyinstitute_id": "CMCC",
                                "v20120717monthlyproject_id": "CMIP5",
                                "v20120717monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120717monthlyinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120717monthlytitle": "ETCCDI indices computed on CMCC-CMS model output prepared for CMIP5 RCP4.5",
                                "v20120717monthlycreation_date": "2013-06-29T21:52:02Z",
                                "v20120717monthlyrealization": "1",
                                "v20120717monthlymodel_id": "CMCC-CMS",
                                "v20120717monthlyETCCDI_software": "climdex.pcic",
                                "v20120717monthlyinput_frequency": "day",
                                "v20120717monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120717monthlymodeling_realm": "atmos",
                                "v20120717monthlyparent_experiment_id": "historical",
                                "v20120717monthlyfrequency": "mon",
                                "v20120717monthlyCMCC_contact": "Chiara Cagnazzo (chiara.cagnazzo@cmcc.it)",
                                "v20120717monthlyparent_experiment": "historical",
                                "v20120717monthlyCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120717monthlyexperiment_id": "rcp45",
                                "v20120717monthlycontact": "bronaugh@uvic.ca",
                                "v20120717monthlycomment": "Equilibrium reached after more than 1500-year spin-up at pre-industrial GHG concentrations after which data were output with nominal date of January 1850.",
                                "v20120717monthlyETCCDI_software_version": "0.7.1",
                                "v20120717annualphysics_version": "1",
                                "v20120717annualnco_openmp_thread_number": "1",
                                "v20120717annualinput_creation_date": "2011-12-05T01:24:43Z",
                                "v20120717annualproduct": "output",
                                "v20120717annualinitialization_method": "1",
                                "v20120717annualparent_experiment_rip": "r1i1p1",
                                "v20120717annualETCCDI_institution_id": "PCIC",
                                "v20120717annualsource": "CMCC-CMS",
                                "v20120717annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120717annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120717annualinput_title": "CMCC-CMS model output prepared for CMIP5 RCP4.5",
                                "v20120717annualcmor_version": "2.7.1",
                                "v20120717annualexperiment": "RCP4.5",
                                "v20120717annualforcing": "Nat,Ant,GHG,SA,Oz,Sl",
                                "v20120717annualConventions": "CF-1.4",
                                "v20120717annualbranch_time": "56978.0",
                                "v20120717annualinstitute_id": "CMCC",
                                "v20120717annualproject_id": "CMIP5",
                                "v20120717annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120717annualinstitution": "CMCC - Centro Euro-Mediterraneo per i Cambiamenti Climatici, Bologna, Italy",
                                "v20120717annualtitle": "ETCCDI indices computed on CMCC-CMS model output prepared for CMIP5 RCP4.5",
                                "v20120717annualcreation_date": "2013-06-29T21:52:03Z",
                                "v20120717annualrealization": "1",
                                "v20120717annualinput_frequency": "day",
                                "v20120717annualETCCDI_software": "climdex.pcic",
                                "v20120717annualmodel_id": "CMCC-CMS",
                                "v20120717annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120717annualmodeling_realm": "atmos",
                                "v20120717annualparent_experiment_id": "historical",
                                "v20120717annualfrequency": "yr",
                                "v20120717annualCMCC_contact": "Chiara Cagnazzo (chiara.cagnazzo@cmcc.it)",
                                "v20120717annualparent_experiment": "historical",
                                "v20120717annualCMCC_references": "model described in the documentation at http://www.cmcc.it/data-models/models",
                                "v20120717annualexperiment_id": "rcp45",
                                "v20120717annualETCCDI_software_version": "0.7.1",
                                "v20120717annualcomment": "Equilibrium reached after more than 1500-year spin-up at pre-industrial GHG concentrations after which data were output with nominal date of January 1850.",
                                "v20120717annualcontact": "bronaugh@uvic.ca",
                                "iridlhasSemantics": "iridl:CMCC-CMS",
                                "Conventions": "IRIDL"
                            },
                            "v20120717": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120717",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:02 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:03 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CMCC-CMS"
                        },
                        "CNRMCM5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CNRM-CM5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20130204monthlyproject_id": "CMIP5",
                                "v20130204monthlyETCCDI_software": "climdex.pcic",
                                "v20130204monthlymodeling_realm": "atmos",
                                "v20130204monthlyparent_experiment_id": "historical",
                                "v20130204monthlycreation_date": "2013-06-29T21:52:12Z",
                                "v20130204monthlyETCCDI_software_version": "0.7.1",
                                "v20130204monthlyproduct": "output",
                                "v20130204monthlycontact": "bronaugh@uvic.ca",
                                "v20130204monthlyinput_frequency": "day",
                                "v20130204monthlyinput_creation_date": "2011-05-17T12:37:39Z",
                                "v20130204monthlyinput_title": "CNRM-CM5 model output prepared for CMIP5 RCP4.5",
                                "v20130204monthlytable_id": "Table day (31 January 2011) 43a867c1fea438258e3971754e4dacea",
                                "v20130204monthlyexperiment": "RCP4.5",
                                "v20130204monthlyparent_experiment_rip": "r1i1p1",
                                "v20130204monthlycomment": "Soil layers depth scheme is specific for mrlsl and tsl - see variable-level comments. Atmosphere vertical hybrid coordinate : a_bnds and b_bnds arrays are correct, but a and b values provided are mid-sum of a_bnds and b_bnds, which is a poor approximation compared to the hydrostatic approximation actually used in the model.",
                                "v20130204monthlysource": "CNRM-CM5 2010 Atmosphere: ARPEGE-Climat (V5.2.1, TL127L31); Ocean: NEMO (nemo3.3.v10.6.6P, ORCA1degL42); Sea Ice: GELATO (V5.30); River Routing: TRIP (v1); Land: SURFEX (v5.1.c); Coupler : OASIS 3",
                                "v20130204monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20130204monthlymodel_id": "CNRM-CM5",
                                "v20130204monthlyConventions": "CF-1.4",
                                "v20130204monthlyCNRMCERFACS_references": "See http://www.cnrm.meteo.fr/cmip5 - Follow model description link",
                                "v20130204monthlyinstitution": "CNRM (Centre National de Recherches Meteorologiques, Meteo-France, Toulouse,France) and CERFACS (Centre Europeen de Recherches et de Formation Avancee en Calcul Scientifique, Toulouse, France)",
                                "v20130204monthlytitle": "ETCCDI indices computed on CNRM-CM5 model output prepared for CMIP5 RCP4.5",
                                "v20130204monthlyfrequency": "mon",
                                "v20130204monthlyETCCDI_institution_id": "PCIC",
                                "v20130204monthlynco_openmp_thread_number": "1",
                                "v20130204monthlyinitialization_method": "1",
                                "v20130204monthlyphysics_version": "1",
                                "v20130204monthlyparent_experiment": "historical",
                                "v20130204monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20130204monthlyinstitute_id": "CNRM-CERFACS",
                                "v20130204monthlyforcing": "GHG, SA, Sl, BC, OC (Sl variation as a 13-year cycle, according to CMIP5 spec)",
                                "v20130204monthlyexperiment_id": "rcp45",
                                "v20130204monthlybranch_time": "56978",
                                "v20130204monthlyCNRMCERFACS_contact": "for all but decadal predictions : contact.CMIP5@meteo.fr - METEO-FRANCE, CNRM/GMGEC/ASTER, CNRS URA 1357, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1 /for decadal predictions : contact.CMIP5@cerfacs.fr - CERFACS, Climate Modelling And Global Change, URA CERFACS/CNRS No1875, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1",
                                "v20130204monthlyrealization": "1",
                                "v20130204monthlycmor_version": "2.5.3",
                                "v20130204monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20130204annualproject_id": "CMIP5",
                                "v20130204annualETCCDI_software": "climdex.pcic",
                                "v20130204annualmodeling_realm": "atmos",
                                "v20130204annualparent_experiment_id": "historical",
                                "v20130204annualcreation_date": "2013-06-29T21:52:12Z",
                                "v20130204annualETCCDI_software_version": "0.7.1",
                                "v20130204annualproduct": "output",
                                "v20130204annualcontact": "bronaugh@uvic.ca",
                                "v20130204annualinput_frequency": "day",
                                "v20130204annualinput_creation_date": "2011-05-17T12:37:39Z",
                                "v20130204annualinput_title": "CNRM-CM5 model output prepared for CMIP5 RCP4.5",
                                "v20130204annualtable_id": "Table day (31 January 2011) 43a867c1fea438258e3971754e4dacea",
                                "v20130204annualexperiment": "RCP4.5",
                                "v20130204annualparent_experiment_rip": "r1i1p1",
                                "v20130204annualcomment": "Soil layers depth scheme is specific for mrlsl and tsl - see variable-level comments. Atmosphere vertical hybrid coordinate : a_bnds and b_bnds arrays are correct, but a and b values provided are mid-sum of a_bnds and b_bnds, which is a poor approximation compared to the hydrostatic approximation actually used in the model.",
                                "v20130204annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20130204annualsource": "CNRM-CM5 2010 Atmosphere: ARPEGE-Climat (V5.2.1, TL127L31); Ocean: NEMO (nemo3.3.v10.6.6P, ORCA1degL42); Sea Ice: GELATO (V5.30); River Routing: TRIP (v1); Land: SURFEX (v5.1.c); Coupler : OASIS 3",
                                "v20130204annualmodel_id": "CNRM-CM5",
                                "v20130204annualConventions": "CF-1.4",
                                "v20130204annualCNRMCERFACS_references": "See http://www.cnrm.meteo.fr/cmip5 - Follow model description link",
                                "v20130204annualinstitution": "CNRM (Centre National de Recherches Meteorologiques, Meteo-France, Toulouse,France) and CERFACS (Centre Europeen de Recherches et de Formation Avancee en Calcul Scientifique, Toulouse, France)",
                                "v20130204annualtitle": "ETCCDI indices computed on CNRM-CM5 model output prepared for CMIP5 RCP4.5",
                                "v20130204annualfrequency": "yr",
                                "v20130204annualETCCDI_institution_id": "PCIC",
                                "v20130204annualnco_openmp_thread_number": "1",
                                "v20130204annualinitialization_method": "1",
                                "v20130204annualphysics_version": "1",
                                "v20130204annualparent_experiment": "historical",
                                "v20130204annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20130204annualinstitute_id": "CNRM-CERFACS",
                                "v20130204annualforcing": "GHG, SA, Sl, BC, OC (Sl variation as a 13-year cycle, according to CMIP5 spec)",
                                "v20130204annualexperiment_id": "rcp45",
                                "v20130204annualbranch_time": "56978",
                                "v20130204annualCNRMCERFACS_contact": "for all but decadal predictions : contact.CMIP5@meteo.fr - METEO-FRANCE, CNRM/GMGEC/ASTER, CNRS URA 1357, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1 /for decadal predictions : contact.CMIP5@cerfacs.fr - CERFACS, Climate Modelling And Global Change, URA CERFACS/CNRS No1875, 42 Av. Coriolis F-31057 TOULOUSE CEDEX 1",
                                "v20130204annualrealization": "1",
                                "v20130204annualcmor_version": "2.5.3",
                                "v20130204annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "iridlhasSemantics": "iridl:CNRM-CM5",
                                "Conventions": "IRIDL"
                            },
                            "v20130204": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20130204",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 21:52:12 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.40625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CNRM-CM5"
                        },
                        "CSIROMk360": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CSIRO-Mk3-6-0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlybranch_time": "56940.0",
                                "v1monthlyfrequency": "mon",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlyinput_title": "CSIRO-Mk3-6-0 model output prepared for CMIP5 RCP4.5",
                                "v1monthlyinstitution": "Australian Commonwealth Scientific and Industrial Research Organization (CSIRO) Marine and Atmospheric Research (Melbourne, Australia) in collaboration with the Queensland Climate Change Centre of Excellence (QCCCE) (Brisbane, Australia)",
                                "v1monthlyforcing": "Ant,Nat (RCP 4.5)",
                                "v1monthlyproduct": "output",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlyinstitute_id": "CSIRO-QCCCE",
                                "v1monthlysource": "CSIRO-Mk3-6-0 2010 atmosphere: AGCM v7.3.8 (T63 spectral, 1.875 degrees EW x approx. 1.875 degrees NS, 18 levels); ocean: GFDL MOM2.2 (1.875 degrees EW x approx. 0.9375 degrees NS, 31 levels)",
                                "v1monthlymodel_id": "CSIRO-Mk3-6-0",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlycreation_date": "2013-06-30T11:21:10Z",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlytitle": "ETCCDI indices computed on CSIRO-Mk3-6-0 model output prepared for CMIP5 RCP4.5",
                                "v1monthlyETCCDI_software_version": "0.7.1",
                                "v1monthlyparent_experiment": "historical",
                                "v1monthlyexperiment_id": "rcp45",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyinput_tracking_id": "38b87986-10a3-4db9-a426-679bd900985a",
                                "v1monthlyexperiment": "RCP4.5",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyCSIROQCCCE_references": "a. Rotstayn, L., Collier, M., Dix, M., Feng, Y., Gordon, H., O\\\\\\'Farrell, S., Smith, I. and Syktus, J. 2010. Improved simulation of Australian climate and ENSO-related climate variability in a GCM with an interactive aerosol treatment. Int. J. Climatology, vol 30(7), pp1067-1088, DOI 10.1002/joc.1952 b. Please refer to online documentation at: http://cmip-pcmdi.llnl.gov/cmip5/",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlyinput_creation_date": "2011-08-06T01:16:21Z",
                                "v1monthlycmor_version": "2.6.0",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlytable_id": "Table day (27 April 2011) bf45c74b31f20daf85ca72b20a6007b7",
                                "v1monthlyparent_experiment_id": "historical",
                                "v1monthlyCSIROQCCCE_contact": "Project leaders: Stephen Jeffrey (Stephen.Jeffrey@qld.gov.au) & Leon Rotstayn (Leon.Rotstayn@csiro.au). Project team: Mark Collier (Mark.Collier@csiro.au: diagnostics & post-processing), Stacey Dravitzki (Stacey.Dravitzki@csiro.au: post-processing), Carlo Hamalainen (Carlo.Hamalainen@qld.gov.au: post-processing), Steve Jeffrey (Stephen.Jeffrey@qld.gov.au: modeling & post-processing), Chris Moeseneder (Chris.Moeseneder@csiro.au: post-processing), Leon Rotstayn (Leon.Rotstayn@csiro.au: modeling & atmos. physics), Jozef Syktus (Jozef.Syktus@qld.gov.au: model evaluation), Kenneth Wong (Kenneth.Wong@qld.gov.au: data management), Contributors: Martin Dix (Martin.Dix@csiro.au: tech. support), Hal Gordon (Hal.Gordon@csiro.au: atmos. dynamics), Eva Kowalczyk (Eva.Kowalczyk@csiro.au: land-surface), Siobhan O\\'Farrell (Siobhan.OFarrell@csiro.au: ocean & sea-ice)",
                                "v1monthlyproject_id": "CMIP5",
                                "v1monthlyversion_number": "v20110518",
                                "v1monthlyphysics_version": "1",
                                "v1monthlycomment": "Model output post-processed by the CSIRO-QCCCE CMIP5 Data post-processor for the IPCC Fifth Assessment.",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualbranch_time": "56940.0",
                                "v1annualfrequency": "yr",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualinput_title": "CSIRO-Mk3-6-0 model output prepared for CMIP5 RCP4.5",
                                "v1annualinstitution": "Australian Commonwealth Scientific and Industrial Research Organization (CSIRO) Marine and Atmospheric Research (Melbourne, Australia) in collaboration with the Queensland Climate Change Centre of Excellence (QCCCE) (Brisbane, Australia)",
                                "v1annualforcing": "Ant,Nat (RCP 4.5)",
                                "v1annualproduct": "output",
                                "v1annualinitialization_method": "1",
                                "v1annualinstitute_id": "CSIRO-QCCCE",
                                "v1annualsource": "CSIRO-Mk3-6-0 2010 atmosphere: AGCM v7.3.8 (T63 spectral, 1.875 degrees EW x approx. 1.875 degrees NS, 18 levels); ocean: GFDL MOM2.2 (1.875 degrees EW x approx. 0.9375 degrees NS, 31 levels)",
                                "v1annualmodel_id": "CSIRO-Mk3-6-0",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualConventions": "CF-1.4",
                                "v1annualcreation_date": "2013-06-30T11:21:10Z",
                                "v1annualinput_frequency": "day",
                                "v1annualtitle": "ETCCDI indices computed on CSIRO-Mk3-6-0 model output prepared for CMIP5 RCP4.5",
                                "v1annualparent_experiment": "historical",
                                "v1annualETCCDI_software_version": "0.7.1",
                                "v1annualexperiment_id": "rcp45",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualinput_tracking_id": "38b87986-10a3-4db9-a426-679bd900985a",
                                "v1annualexperiment": "RCP4.5",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualCSIROQCCCE_references": "a. Rotstayn, L., Collier, M., Dix, M., Feng, Y., Gordon, H., O\\\\\\'Farrell, S., Smith, I. and Syktus, J. 2010. Improved simulation of Australian climate and ENSO-related climate variability in a GCM with an interactive aerosol treatment. Int. J. Climatology, vol 30(7), pp1067-1088, DOI 10.1002/joc.1952 b. Please refer to online documentation at: http://cmip-pcmdi.llnl.gov/cmip5/",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualinput_creation_date": "2011-08-06T01:16:21Z",
                                "v1annualcmor_version": "2.6.0",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualtable_id": "Table day (27 April 2011) bf45c74b31f20daf85ca72b20a6007b7",
                                "v1annualparent_experiment_id": "historical",
                                "v1annualCSIROQCCCE_contact": "Project leaders: Stephen Jeffrey (Stephen.Jeffrey@qld.gov.au) & Leon Rotstayn (Leon.Rotstayn@csiro.au). Project team: Mark Collier (Mark.Collier@csiro.au: diagnostics & post-processing), Stacey Dravitzki (Stacey.Dravitzki@csiro.au: post-processing), Carlo Hamalainen (Carlo.Hamalainen@qld.gov.au: post-processing), Steve Jeffrey (Stephen.Jeffrey@qld.gov.au: modeling & post-processing), Chris Moeseneder (Chris.Moeseneder@csiro.au: post-processing), Leon Rotstayn (Leon.Rotstayn@csiro.au: modeling & atmos. physics), Jozef Syktus (Jozef.Syktus@qld.gov.au: model evaluation), Kenneth Wong (Kenneth.Wong@qld.gov.au: data management), Contributors: Martin Dix (Martin.Dix@csiro.au: tech. support), Hal Gordon (Hal.Gordon@csiro.au: atmos. dynamics), Eva Kowalczyk (Eva.Kowalczyk@csiro.au: land-surface), Siobhan O\\'Farrell (Siobhan.OFarrell@csiro.au: ocean & sea-ice)",
                                "v1annualproject_id": "CMIP5",
                                "v1annualversion_number": "v20110518",
                                "v1annualphysics_version": "1",
                                "v1annualcomment": "Model output post-processed by the CSIRO-QCCCE CMIP5 Data post-processor for the IPCC Fifth Assessment.",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "iridlhasSemantics": "iridl:CSIRO-Mk3-6-0",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CSIRO-Mk3-6-0"
                        },
                        "CanCM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CanCM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120612monthlyCCCma_contact": "cccma_info@ec.gc.ca",
                                "v20120612monthlyinput_tracking_id": "9477bee5-9c28-4fbf-9343-0a87e844a1df",
                                "v20120612monthlyCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "v20120612monthlyinput_frequency": "day",
                                "v20120612monthlyCCCma_parent_runid": "IGA",
                                "v20120612monthlycomment": "These experiments serve as unitialized comparisons for CCCma CanCM4 decadal experiments.",
                                "v20120612monthlyproduct": "output",
                                "v20120612monthlymodeling_realm": "atmos",
                                "v20120612monthlycmor_version": "2.8.0",
                                "v20120612monthlyexperiment": "RCP4.5",
                                "v20120612monthlyETCCDI_institution_id": "PCIC",
                                "v20120612monthlytable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "v20120612monthlysource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
                                "v20120612monthlyCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "v20120612monthlyparent_experiment_id": "piControl",
                                "v20120612monthlyConventions": "CF-1.4",
                                "v20120612monthlyhistory": "2012-02-10T21:02:30Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120612monthlyproject_id": "CMIP5",
                                "v20120612monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120612monthlyinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "v20120612monthlytitle": "ETCCDI indices computed on CanCM4 model output prepared for CMIP5 RCP4.5",
                                "v20120612monthlyexperiment_id": "rcp45",
                                "v20120612monthlybranch_time_YMDH": "2121:01:01:00",
                                "v20120612monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120612monthlyinput_title": "CanCM4 model output prepared for CMIP5 RCP4.5",
                                "v20120612monthlyfrequency": "mon",
                                "v20120612monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120612monthlyforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "v20120612monthlybranch_time": "98915.0",
                                "v20120612monthlymodel_id": "CanCM4",
                                "v20120612monthlyinput_creation_date": "2012-02-10T21:02:30Z",
                                "v20120612monthlyparent_experiment": "pre-industrial control",
                                "v20120612monthlyinstitute_id": "CCCma",
                                "v20120612monthlycreation_date": "2013-06-29T21:17:33Z",
                                "v20120612monthlyETCCDI_software": "climdex.pcic",
                                "v20120612monthlyrealization": "1",
                                "v20120612monthlyphysics_version": "1",
                                "v20120612monthlycontact": "bronaugh@uvic.ca",
                                "v20120612monthlyETCCDI_software_version": "0.7.1",
                                "v20120612monthlyinitialization_method": "1",
                                "v20120612monthlyCCCma_runid": "DHFP1N_E001",
                                "v20120612annualCCCma_contact": "cccma_info@ec.gc.ca",
                                "v20120612annualinput_tracking_id": "9477bee5-9c28-4fbf-9343-0a87e844a1df",
                                "v20120612annualCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "v20120612annualinput_frequency": "day",
                                "v20120612annualCCCma_parent_runid": "IGA",
                                "v20120612annualcomment": "These experiments serve as unitialized comparisons for CCCma CanCM4 decadal experiments.",
                                "v20120612annualproduct": "output",
                                "v20120612annualmodeling_realm": "atmos",
                                "v20120612annualcmor_version": "2.8.0",
                                "v20120612annualexperiment": "RCP4.5",
                                "v20120612annualETCCDI_institution_id": "PCIC",
                                "v20120612annualtable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "v20120612annualsource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
                                "v20120612annualCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "v20120612annualparent_experiment_id": "piControl",
                                "v20120612annualConventions": "CF-1.4",
                                "v20120612annualhistory": "2012-02-10T21:02:30Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120612annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120612annualproject_id": "CMIP5",
                                "v20120612annualtitle": "ETCCDI indices computed on CanCM4 model output prepared for CMIP5 RCP4.5",
                                "v20120612annualinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "v20120612annualexperiment_id": "rcp45",
                                "v20120612annualbranch_time_YMDH": "2121:01:01:00",
                                "v20120612annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120612annualinput_title": "CanCM4 model output prepared for CMIP5 RCP4.5",
                                "v20120612annualfrequency": "yr",
                                "v20120612annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120612annualforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
                                "v20120612annualbranch_time": "98915.0",
                                "v20120612annualmodel_id": "CanCM4",
                                "v20120612annualinput_creation_date": "2012-02-10T21:02:30Z",
                                "v20120612annualparent_experiment": "pre-industrial control",
                                "v20120612annualinstitute_id": "CCCma",
                                "v20120612annualcreation_date": "2013-06-29T21:17:33Z",
                                "v20120612annualETCCDI_software": "climdex.pcic",
                                "v20120612annualphysics_version": "1",
                                "v20120612annualcontact": "bronaugh@uvic.ca",
                                "v20120612annualETCCDI_software_version": "0.7.1",
                                "v20120612annualinitialization_method": "1",
                                "v20120612annualCCCma_runid": "DHFP1N_E001",
                                "iridlhasSemantics": "iridl:CanCM4",
                                "Conventions": "IRIDL"
                            },
                            "v20120612": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120612",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:34 2013",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CanCM4"
                        },
                        "CanESM2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CanESM2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyCCCma_contact": "cccma_info@ec.gc.ca",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlyexperiment_id": "rcp45",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlycmor_version": "2.5.4",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyinput_tracking_id": "57a1401a-eb5a-411d-81dc-65bbb3cce59b",
                                "mult_versionsmonthlysource": "CanESM2 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) and CMOC1.2 sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7 and CTEM1",
                                "mult_versionsmonthlybranch_time_YMDH": "2006:01:01:00",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyparent_experiment": "historical",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlyparent_experiment_id": "historical",
                                "mult_versionsmonthlyinstitute_id": "CCCma",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on CanESM2 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "mult_versionsmonthlybranch_time": "56940.0",
                                "mult_versionsmonthlyexperiment": "RCP4.5",
                                "mult_versionsmonthlyinput_creation_date": "2011-04-08T05:35:06Z",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyCCCma_runid": "ICA",
                                "mult_versionsmonthlymodel_id": "CanESM2",
                                "mult_versionsmonthlyCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyforcing": "GHG,Oz,SA,BC,OC,LU,Sl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Sl is the repeat of the 23rd solar cycle, years 1997-2008, after year 2008.)",
                                "mult_versionsmonthlyCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "mult_versionsmonthlytable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "mult_versionsmonthlyCCCma_parent_runid": "IGM",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyinput_title": "CanESM2 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlycreation_date": "2013-07-20T10:18:18Z",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualCCCma_contact": "cccma_info@ec.gc.ca",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualexperiment_id": "rcp45",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualcmor_version": "2.5.4",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualbranch_time_YMDH": "2006:01:01:00",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualsource": "CanESM2 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) and CMOC1.2 sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7 and CTEM1",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualparent_experiment": "historical",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualparent_experiment_id": "historical",
                                "mult_versionsannualinstitute_id": "CCCma",
                                "mult_versionsannualtitle": "ETCCDI indices computed on CanESM2 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
                                "mult_versionsannualbranch_time": "56940.0",
                                "mult_versionsannualexperiment": "RCP4.5",
                                "mult_versionsannualinput_creation_date": "2011-04-08T05:35:06Z",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualCCCma_runid": "ICA",
                                "mult_versionsannualmodel_id": "CanESM2",
                                "mult_versionsannualCCCma_references": "http://www.cccma.ec.gc.ca/models",
                                "mult_versionsannualforcing": "GHG,Oz,SA,BC,OC,LU,Sl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Sl is the repeat of the 23rd solar cycle, years 1997-2008, after year 2008.)",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualCCCma_data_licence": "Licensee\\'s use of the Data product.",
                                "mult_versionsannualtable_id": "Table day (28 March 2011) f9d6cfec5981bb8be1801b35a81002f0",
                                "mult_versionsannualCCCma_parent_runid": "IGM",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualinput_title": "CanESM2 model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualcreation_date": "2013-07-20T10:18:18Z",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "iridlhasSemantics": "iridl:CanESM2",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/CanESM2"
                        },
                        "ECEARTH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EC-EARTH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120622monthlyETCCDI_institution_id": "PCIC",
                                "v20120622monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120622monthlytable_id": "Table day (26 July 2011) 0640f2bc62aad4ebefa8ecc119311890",
                                "v20120622monthlyexperiment_id": "rcp45",
                                "v20120622monthlyETCCDI_software_version": "0.6.1",
                                "v20120622monthlyproduct": "output",
                                "v20120622monthlyexperiment": "RCP4.5",
                                "v20120622monthlycmor_version": "2.7.1",
                                "v20120622monthlycreation_date": "2012-07-13T10:55:14Z",
                                "v20120622monthlyfrequency": "mon",
                                "v20120622monthlysource": "EC-EARTH 2.3 (2011); atmosphere: IFS (cy31R1+modifications, T159L62); ocean: NEMO (version2+modifications, ORCA1-42lev); sea ice: LIM2; land: HTessel",
                                "v20120622monthlyrealization": "6",
                                "v20120622monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120622monthlyparent_experiment_id": "piControl",
                                "v20120622monthlyConventions": "CF-1.4",
                                "v20120622monthlyinput_creation_date": "2012-01-11T10:36:06Z",
                                "v20120622monthlyinstitution": "EC-Earth (European Earth System Model)",
                                "v20120622monthlytitle": "ETCCDI indices computed on EC-EARTH model output prepared for CMIP5 RCP4.5",
                                "v20120622monthlymodeling_realm": "atmos",
                                "v20120622monthlyforcing": "Nat,Ant",
                                "v20120622monthlyinput_title": "EC-EARTH model output prepared for CMIP5 RCP4.5",
                                "v20120622monthlyparent_experiment": "pre-industrial control",
                                "v20120622monthlymodel_id": "EC-EARTH",
                                "v20120622monthlyphysics_version": "1",
                                "v20120622monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120622monthlybranch_time": "2175.0",
                                "v20120622monthlyETCCDI_software": "climdex.pcic",
                                "v20120622monthlyproject_id": "CMIP5",
                                "v20120622monthlycontact": "bronaugh@uvic.ca",
                                "v20120622monthlyinput_frequency": "day",
                                "v20120622monthlycomment": "KNMI contact c.severijns@knmi.nl",
                                "v20120622monthlyinitialization_method": "1",
                                "v20120622monthlynco_openmp_thread_number": "1",
                                "v20120622monthlyinstitute_id": "ICHEC",
                                "v20120622monthlyICHEC_references": "Model described by Hazeleger et al. (Bull. Amer. Meteor. Soc., 2010, 91, 1357-1363). Also see http://ecearth.knmi.nl.",
                                "v20120622annualETCCDI_institution_id": "PCIC",
                                "v20120622annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120622annualtable_id": "Table day (26 July 2011) 0640f2bc62aad4ebefa8ecc119311890",
                                "v20120622annualexperiment_id": "rcp45",
                                "v20120622annualETCCDI_software_version": "0.6.1",
                                "v20120622annualproduct": "output",
                                "v20120622annualexperiment": "RCP4.5",
                                "v20120622annualcmor_version": "2.7.1",
                                "v20120622annualsource": "EC-EARTH 2.3 (2011); atmosphere: IFS (cy31R1+modifications, T159L62); ocean: NEMO (version2+modifications, ORCA1-42lev); sea ice: LIM2; land: HTessel",
                                "v20120622annualcreation_date": "2012-07-13T10:55:23Z",
                                "v20120622annualfrequency": "yr",
                                "v20120622annualrealization": "6",
                                "v20120622annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120622annualparent_experiment_id": "piControl",
                                "v20120622annualConventions": "CF-1.4",
                                "v20120622annualinput_creation_date": "2012-01-11T10:36:06Z",
                                "v20120622annualinstitution": "EC-Earth (European Earth System Model)",
                                "v20120622annualtitle": "ETCCDI indices computed on EC-EARTH model output prepared for CMIP5 RCP4.5",
                                "v20120622annualmodeling_realm": "atmos",
                                "v20120622annualforcing": "Nat,Ant",
                                "v20120622annualinput_title": "EC-EARTH model output prepared for CMIP5 RCP4.5",
                                "v20120622annualparent_experiment": "pre-industrial control",
                                "v20120622annualmodel_id": "EC-EARTH",
                                "v20120622annualphysics_version": "1",
                                "v20120622annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120622annualbranch_time": "2175.0",
                                "v20120622annualproject_id": "CMIP5",
                                "v20120622annualETCCDI_software": "climdex.pcic",
                                "v20120622annualcontact": "bronaugh@uvic.ca",
                                "v20120622annualinput_frequency": "day",
                                "v20120622annualcomment": "KNMI contact c.severijns@knmi.nl",
                                "v20120622annualinitialization_method": "1",
                                "v20120622annualnco_openmp_thread_number": "1",
                                "v20120622annualinstitute_id": "ICHEC",
                                "v20120622annualICHEC_references": "Model described by Hazeleger et al. (Bull. Amer. Meteor. Soc., 2010, 91, 1357-1363). Also see http://ecearth.knmi.nl.",
                                "iridlhasSemantics": "iridl:EC-EARTH",
                                "Conventions": "IRIDL"
                            },
                            "v20120622": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120622",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:14 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Fri Jul 13 10:55:23 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/EC-EARTH"
                        },
                        "FGOALSg2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FGOALS-g2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v1monthlyETCCDI_software_version": "0.7.1",
                                "v1monthlyETCCDI_software": "climdex.pcic",
                                "v1monthlyforcing": "GHG,Oz,SA,BC,OC,LU,Sl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Sl is the repeat of the 23rd solar cycle, years 1997-2008, after year 2008.)",
                                "v1monthlybranch_time": "56940.0",
                                "v1monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1monthlyexperiment_id": "rcp45",
                                "v1monthlyrealization": "1",
                                "v1monthlyproduct": "output",
                                "v1monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1monthlyinput_frequency": "day",
                                "v1monthlyexperiment": "RCP4.5",
                                "v1monthlymodeling_realm": "atmos",
                                "v1monthlyLASGCESS_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v1monthlysource": "FGOALS_g2 2011 atmosphere: GAMIL (gamil2, 128x60L26); ocean: LICOM (licom2, 360x196L30); ice: CICE (cice4_lasg, 360x196L4); land: CLM (clm3, 128x60)",
                                "v1monthlyinput_title": "FGOALS_g2 model output prepared for CMIP5 RCP4.5",
                                "v1monthlycontact": "bronaugh@uvic.ca",
                                "v1monthlycmor_version": "2.7.1",
                                "v1monthlyETCCDI_institution_id": "PCIC",
                                "v1monthlyConventions": "CF-1.4",
                                "v1monthlynco_openmp_thread_number": "1",
                                "v1monthlyfrequency": "mon",
                                "v1monthlytitle": "ETCCDI indices computed on FGOALS_g2 model output prepared for CMIP5 RCP4.5",
                                "v1monthlycomment": "N/A",
                                "v1monthlyinstitute_id": "LASG-CESS",
                                "v1monthlymodel_id": "FGOALS_g2",
                                "v1monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1monthlyparent_experiment_rip": "r1i1p1",
                                "v1monthlyphysics_version": "1",
                                "v1monthlyinitialization_method": "1",
                                "v1monthlyinput_creation_date": "2011-12-27T04:50:19Z",
                                "v1monthlyparent_experiment": "historical",
                                "v1monthlyLASGCESS_contact": "Dr. Tianjun ZHOU, Email: zhoutj@lasg.iap.ac.cn",
                                "v1monthlyparent_experiment_id": "historical",
                                "v1monthlyinstitution": "IAP (Institute of Atmospheric Physics, Chinese Academy of Sciences, Beijing, China) and THU (Tsinghua University)",
                                "v1monthlycreation_date": "2013-06-29T22:26:30Z",
                                "v1monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v1monthlyproject_id": "CMIP5",
                                "v1annualETCCDI_software_version": "0.7.1",
                                "v1annualETCCDI_software": "climdex.pcic",
                                "v1annualforcing": "GHG,Oz,SA,BC,OC,LU,Sl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12. Sl is the repeat of the 23rd solar cycle, years 1997-2008, after year 2008.)",
                                "v1annualbranch_time": "56940.0",
                                "v1annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v1annualexperiment_id": "rcp45",
                                "v1annualrealization": "1",
                                "v1annualproduct": "output",
                                "v1annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v1annualinput_frequency": "day",
                                "v1annualexperiment": "RCP4.5",
                                "v1annualmodeling_realm": "atmos",
                                "v1annualLASGCESS_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v1annualsource": "FGOALS_g2 2011 atmosphere: GAMIL (gamil2, 128x60L26); ocean: LICOM (licom2, 360x196L30); ice: CICE (cice4_lasg, 360x196L4); land: CLM (clm3, 128x60)",
                                "v1annualinput_title": "FGOALS_g2 model output prepared for CMIP5 RCP4.5",
                                "v1annualcontact": "bronaugh@uvic.ca",
                                "v1annualcmor_version": "2.7.1",
                                "v1annualETCCDI_institution_id": "PCIC",
                                "v1annualConventions": "CF-1.4",
                                "v1annualnco_openmp_thread_number": "1",
                                "v1annualfrequency": "yr",
                                "v1annualtitle": "ETCCDI indices computed on FGOALS_g2 model output prepared for CMIP5 RCP4.5",
                                "v1annualcomment": "N/A",
                                "v1annualinstitute_id": "LASG-CESS",
                                "v1annualmodel_id": "FGOALS_g2",
                                "v1annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v1annualparent_experiment_rip": "r1i1p1",
                                "v1annualphysics_version": "1",
                                "v1annualinitialization_method": "1",
                                "v1annualinput_creation_date": "2011-12-27T04:50:19Z",
                                "v1annualparent_experiment": "historical",
                                "v1annualLASGCESS_contact": "Dr. Tianjun ZHOU, Email: zhoutj@lasg.iap.ac.cn",
                                "v1annualparent_experiment_id": "historical",
                                "v1annualinstitution": "IAP (Institute of Atmospheric Physics, Chinese Academy of Sciences, Beijing, China) and THU (Tsinghua University)",
                                "v1annualcreation_date": "2013-06-29T22:26:31Z",
                                "v1annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v1annualproject_id": "CMIP5",
                                "iridlhasSemantics": "iridl:FGOALS-g2",
                                "Conventions": "IRIDL"
                            },
                            "v1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:30 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 22:26:31 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/FGOALS-g2"
                        },
                        "FGOALSs2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "FGOALS-s2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v2monthlyinstitute_id": "LASG-IAP",
                                "v2monthlyphysics_version": "1",
                                "v2monthlyproduct": "output",
                                "v2monthlynco_openmp_thread_number": "1",
                                "v2monthlycmor_version": "2.5.1",
                                "v2monthlyinitialization_method": "1",
                                "v2monthlysource": "FGOALS-s2 SAMIL 2-4-7",
                                "v2monthlyinstitution": "IAP(Institute of Atmospheric Physics),CAS(Chinese Academy of Sciences),Beijing,China",
                                "v2monthlyETCCDI_institution_id": "PCIC",
                                "v2monthlymodeling_realm": "atmos",
                                "v2monthlytable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "v2monthlyfrequency": "mon",
                                "v2monthlyConventions": "CF-1.4",
                                "v2monthlyETCCDI_software_version": "0.7.1",
                                "v2monthlytitle": "ETCCDI indices computed on FGOALS-s2 model output prepared for CMIP5 rcp45",
                                "v2monthlyinput_frequency": "day",
                                "v2monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v2monthlyinput_creation_date": "2011-10-10T19:13:17Z",
                                "v2monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v2monthlyparent_experiment": "historical",
                                "v2monthlyinput_tracking_id": "f9735fb9-eaa8-4203-80fc-d0d0377a76e5",
                                "v2monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v2monthlyinput_title": "FGOALS-s2 model output prepared for CMIP5 rcp45",
                                "v2monthlyexperiment_id": "rcp45",
                                "v2monthlyforcing": "GHG, SD, Oz, Sl, Vl, SS, Ds, BC, OC",
                                "v2monthlycreation_date": "2013-06-29T22:38:00Z",
                                "v2monthlybranch_time": "1456.0",
                                "v2monthlymodel_id": "FGOALS-s2",
                                "v2monthlyLASGIAP_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v2monthlyLASGIAP_contact": "Dr. Tianjun Zhou(zhoutj@lasg.iap.ac.cn)",
                                "v2monthlycontact": "bronaugh@uvic.ca",
                                "v2monthlyexperiment": "RCP4.5",
                                "v2monthlyproject_id": "CMIP5",
                                "v2monthlyETCCDI_software": "climdex.pcic",
                                "v2monthlyparent_experiment_id": "historical",
                                "v2annualinstitute_id": "LASG-IAP",
                                "v2annualphysics_version": "1",
                                "v2annualproduct": "output",
                                "v2annualnco_openmp_thread_number": "1",
                                "v2annualcmor_version": "2.5.1",
                                "v2annualinitialization_method": "1",
                                "v2annualsource": "FGOALS-s2 SAMIL 2-4-7",
                                "v2annualinstitution": "IAP(Institute of Atmospheric Physics),CAS(Chinese Academy of Sciences),Beijing,China",
                                "v2annualETCCDI_institution_id": "PCIC",
                                "v2annualmodeling_realm": "atmos",
                                "v2annualtable_id": "Table day (12 November 2010) 53fa6f63b86081d1c644183416239052",
                                "v2annualfrequency": "yr",
                                "v2annualConventions": "CF-1.4",
                                "v2annualETCCDI_software_version": "0.7.1",
                                "v2annualtitle": "ETCCDI indices computed on FGOALS-s2 model output prepared for CMIP5 rcp45",
                                "v2annualinput_frequency": "day",
                                "v2annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v2annualinput_creation_date": "2011-10-10T19:13:17Z",
                                "v2annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v2annualparent_experiment": "historical",
                                "v2annualinput_tracking_id": "f9735fb9-eaa8-4203-80fc-d0d0377a76e5",
                                "v2annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v2annualinput_title": "FGOALS-s2 model output prepared for CMIP5 rcp45",
                                "v2annualexperiment_id": "rcp45",
                                "v2annualforcing": "GHG, SD, Oz, Sl, Vl, SS, Ds, BC, OC",
                                "v2annualcreation_date": "2013-06-29T22:38:00Z",
                                "v2annualbranch_time": "1456.0",
                                "v2annualmodel_id": "FGOALS-s2",
                                "v2annualLASGIAP_references": "http://www.lasg.ac.cn/FGOALS/CMIP5",
                                "v2annualLASGIAP_contact": "Dr. Tianjun Zhou(zhoutj@lasg.iap.ac.cn)",
                                "v2annualcontact": "bronaugh@uvic.ca",
                                "v2annualexperiment": "RCP4.5",
                                "v2annualproject_id": "CMIP5",
                                "v2annualETCCDI_software": "climdex.pcic",
                                "v2annualparent_experiment_id": "historical",
                                "iridlhasSemantics": "iridl:FGOALS-s2",
                                "Conventions": "IRIDL"
                            },
                            "v2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/FGOALS-s2"
                        },
                        "GFDLESM2G": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-ESM2G",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110601monthlyparent_experiment_rip": "r1i1p1",
                                "v20110601monthlyinput_frequency": "day",
                                "v20110601monthlycreation_date": "2012-07-14T20:30:59Z",
                                "v20110601monthlyforcing": "GHG,SD,Oz,LU,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20110601monthlygfdl_experiment_name": "ESM2G-HC2_2006-2100_all_rcp45_XC2",
                                "v20110601monthlyproduct": "output1",
                                "v20110601monthlynco_openmp_thread_number": "1",
                                "v20110601monthlyinput_tracking_id": "80f6d740-ab0b-4f2c-91c7-13c452612dcf",
                                "v20110601monthlymodeling_realm": "atmos",
                                "v20110601monthlyETCCDI_software": "climdex.pcic",
                                "v20110601monthlyinput_title": "NOAA GFDL GFDL-ESM2G, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20110601monthlycontact": "bronaugh@uvic.ca",
                                "v20110601monthlysource": "GFDL-ESM2G 2010 ocean: TOPAZ (TOPAZ1p2,Tripolar360x210L63); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x210L63); land: LM3 (LM3p7_cESM,M45)",
                                "v20110601monthlyinput_creation_date": "2011-11-22T00:13:02Z",
                                "v20110601monthlyETCCDI_software_version": "0.6.1",
                                "v20110601monthlyrealization": "1",
                                "v20110601monthlyinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20110601monthlyConventions": "CF-1.4",
                                "v20110601monthlymodel_id": "GFDL-ESM2G",
                                "v20110601monthlyexperiment": "RCP4.5",
                                "v20110601monthlytitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2G, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20110601monthlyfrequency": "mon",
                                "v20110601monthlyphysics_version": "1",
                                "v20110601monthlyexperiment_id": "rcp45",
                                "v20110601monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110601monthlyETCCDI_institution_id": "PCIC",
                                "v20110601monthlytable_id": "Table day (31 Jan 2011)",
                                "v20110601monthlyproject_id": "CMIP5",
                                "v20110601monthlyinstitute_id": "NOAA GFDL",
                                "v20110601monthlyNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20110601monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110601monthlyparent_experiment_id": "historical",
                                "v20110601monthlyinitialization_method": "1",
                                "v20110601monthlycomment": "GFDL experiment name = ESM2G-HC2_2006-2100_all_rcp45_XC2. PCMDI experiment name = RCP4.5 (run1). Initial conditions for this experiment were taken from 1 January 2006 of the parent experiment, ESM2G-C2_all_historical_HC2 (historical). Several forcing agents varied during the 95 year duration of the RCP4.5 experiment based upon the MINICAM integrated assessment model for the 21st century. The time-varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, model-derived aerosol concentrations (sulfate, black and organic carbon, sea salt and dust), and land use transitions. Volcanic aerosols were zero and solar irradiance varied seasonally based upon late 20th century averages but with no interannual variation. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20110601monthlybranch_time": "52925",
                                "v20110601monthlyNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20110601monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110601annualparent_experiment_rip": "r1i1p1",
                                "v20110601annualinput_frequency": "day",
                                "v20110601annualcreation_date": "2012-07-14T20:31:02Z",
                                "v20110601annualforcing": "GHG,SD,Oz,LU,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20110601annualgfdl_experiment_name": "ESM2G-HC2_2006-2100_all_rcp45_XC2",
                                "v20110601annualproduct": "output1",
                                "v20110601annualnco_openmp_thread_number": "1",
                                "v20110601annualinput_tracking_id": "80f6d740-ab0b-4f2c-91c7-13c452612dcf",
                                "v20110601annualmodeling_realm": "atmos",
                                "v20110601annualETCCDI_software": "climdex.pcic",
                                "v20110601annualinput_title": "NOAA GFDL GFDL-ESM2G, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20110601annualcontact": "bronaugh@uvic.ca",
                                "v20110601annualsource": "GFDL-ESM2G 2010 ocean: TOPAZ (TOPAZ1p2,Tripolar360x210L63); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x210L63); land: LM3 (LM3p7_cESM,M45)",
                                "v20110601annualinput_creation_date": "2011-11-22T00:13:02Z",
                                "v20110601annualETCCDI_software_version": "0.6.1",
                                "v20110601annualrealization": "1",
                                "v20110601annualinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20110601annualConventions": "CF-1.4",
                                "v20110601annualmodel_id": "GFDL-ESM2G",
                                "v20110601annualexperiment": "RCP4.5",
                                "v20110601annualtitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2G, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20110601annualfrequency": "yr",
                                "v20110601annualphysics_version": "1",
                                "v20110601annualexperiment_id": "rcp45",
                                "v20110601annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110601annualETCCDI_institution_id": "PCIC",
                                "v20110601annualtable_id": "Table day (31 Jan 2011)",
                                "v20110601annualproject_id": "CMIP5",
                                "v20110601annualinstitute_id": "NOAA GFDL",
                                "v20110601annualNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20110601annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110601annualparent_experiment_id": "historical",
                                "v20110601annualinitialization_method": "1",
                                "v20110601annualcomment": "GFDL experiment name = ESM2G-HC2_2006-2100_all_rcp45_XC2. PCMDI experiment name = RCP4.5 (run1). Initial conditions for this experiment were taken from 1 January 2006 of the parent experiment, ESM2G-C2_all_historical_HC2 (historical). Several forcing agents varied during the 95 year duration of the RCP4.5 experiment based upon the MINICAM integrated assessment model for the 21st century. The time-varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, model-derived aerosol concentrations (sulfate, black and organic carbon, sea salt and dust), and land use transitions. Volcanic aerosols were zero and solar irradiance varied seasonally based upon late 20th century averages but with no interannual variation. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20110601annualbranch_time": "52925",
                                "v20110601annualNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20110601annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "iridlhasSemantics": "iridl:GFDL-ESM2G",
                                "Conventions": "IRIDL"
                            },
                            "v20110601": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110601",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:30:59 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 20:31:02 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/GFDL-ESM2G"
                        },
                        "GFDLESM2M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-ESM2M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20111228monthlyfrequency": "mon",
                                "v20111228monthlyinput_creation_date": "2011-08-12T01:18:01Z",
                                "v20111228monthlyexperiment_id": "rcp45",
                                "v20111228monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111228monthlymodeling_realm": "atmos",
                                "v20111228monthlyproduct": "output1",
                                "v20111228monthlyparent_experiment_id": "historical",
                                "v20111228monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111228monthlyrealization": "1",
                                "v20111228monthlynco_openmp_thread_number": "1",
                                "v20111228monthlyforcing": "GHG,SD,Oz,LU,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20111228monthlysource": "GFDL-ESM2M 2010 ocean: MOM4 (MOM4p1_x1_Z50_cCM2M,Tripolar360x200L50); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x200L50); land: LM3 (LM3p7_cESM,M45)",
                                "v20111228monthlymodel_id": "GFDL-ESM2M",
                                "v20111228monthlyNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20111228monthlycreation_date": "2012-07-14T22:22:40Z",
                                "v20111228monthlyexperiment": "RCP4.5",
                                "v20111228monthlyinitialization_method": "1",
                                "v20111228monthlyConventions": "CF-1.4",
                                "v20111228monthlyETCCDI_software": "climdex.pcic",
                                "v20111228monthlyinput_title": "NOAA GFDL GFDL-ESM2M, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20111228monthlyinput_frequency": "day",
                                "v20111228monthlytitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2M, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20111228monthlybranch_time": "52925",
                                "v20111228monthlyinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20111228monthlyphysics_version": "1",
                                "v20111228monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111228monthlyinstitute_id": "NOAA GFDL",
                                "v20111228monthlygfdl_experiment_name": "ESM2M-HC1_2006-2100_all_rcp45_XC1",
                                "v20111228monthlyETCCDI_institution_id": "PCIC",
                                "v20111228monthlycontact": "bronaugh@uvic.ca",
                                "v20111228monthlyNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20111228monthlycomment": "GFDL experiment name = ESM2M-HC1_2006-2100_all_rcp45_XC1. PCMDI experiment name = RCP4.5 (run1). Initial conditions for this experiment were taken from 1 January 2006 of the parent experiment, ESM2M-C1_all_historical_HC1 (historical). Several forcing agents varied during the 95 year duration of the RCP4.5 experiment based upon the MINICAM integrated assessment model for the 21st century. The time-varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, model-derived aerosol concentrations (sulfate, black and organic carbon, sea salt and dust), and land use transitions. Volcanic aerosols were zero and solar irradiance varied seasonally based upon late 20th century averages but with no interannual variation. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20111228monthlyparent_experiment_rip": "r1i1p1",
                                "v20111228monthlyETCCDI_software_version": "0.6.1",
                                "v20111228monthlytable_id": "Table day (31 Jan 2011)",
                                "v20111228monthlyinput_tracking_id": "6a437b79-74bf-48ac-82a4-eac5cc1fd8fa",
                                "v20111228monthlyproject_id": "CMIP5",
                                "v20111228annualfrequency": "yr",
                                "v20111228annualinput_creation_date": "2011-08-12T01:18:01Z",
                                "v20111228annualexperiment_id": "rcp45",
                                "v20111228annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111228annualmodeling_realm": "atmos",
                                "v20111228annualproduct": "output1",
                                "v20111228annualparent_experiment_id": "historical",
                                "v20111228annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111228annualrealization": "1",
                                "v20111228annualnco_openmp_thread_number": "1",
                                "v20111228annualforcing": "GHG,SD,Oz,LU,SS,BC,MD,OC (GHG includes CO2, CH4, N2O, CFC11, CFC12, HCFC22, CFC113)",
                                "v20111228annualsource": "GFDL-ESM2M 2010 ocean: MOM4 (MOM4p1_x1_Z50_cCM2M,Tripolar360x200L50); atmosphere: AM2 (AM2p14,M45L24); sea ice: SIS (SISp2,Tripolar360x200L50); land: LM3 (LM3p7_cESM,M45)",
                                "v20111228annualNOAAGFDL_contact": "gfdl.climate.model.info@noaa.gov",
                                "v20111228annualmodel_id": "GFDL-ESM2M",
                                "v20111228annualcreation_date": "2012-07-14T22:22:43Z",
                                "v20111228annualexperiment": "RCP4.5",
                                "v20111228annualinitialization_method": "1",
                                "v20111228annualConventions": "CF-1.4",
                                "v20111228annualETCCDI_software": "climdex.pcic",
                                "v20111228annualinput_title": "NOAA GFDL GFDL-ESM2M, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20111228annualinput_frequency": "day",
                                "v20111228annualtitle": "ETCCDI indices computed on NOAA GFDL GFDL-ESM2M, RCP4.5 (run 1) experiment output for CMIP5 AR5",
                                "v20111228annualbranch_time": "52925",
                                "v20111228annualinstitution": "NOAA GFDL(201 Forrestal Rd, Princeton, NJ, 08540)",
                                "v20111228annualphysics_version": "1",
                                "v20111228annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111228annualinstitute_id": "NOAA GFDL",
                                "v20111228annualgfdl_experiment_name": "ESM2M-HC1_2006-2100_all_rcp45_XC1",
                                "v20111228annualETCCDI_institution_id": "PCIC",
                                "v20111228annualcontact": "bronaugh@uvic.ca",
                                "v20111228annualNOAAGFDL_references": "The GFDL Data Portal (http://nomads.gfdl.noaa.gov/) provides access to NOAA/GFDL\\'s publicly available model input and output data sets. From this web site one can view and download data sets and documentation, including those related to the GFDL coupled models experiments run for the IPCC\\'s 5th Assessment Report and the US CCSP.",
                                "v20111228annualcomment": "GFDL experiment name = ESM2M-HC1_2006-2100_all_rcp45_XC1. PCMDI experiment name = RCP4.5 (run1). Initial conditions for this experiment were taken from 1 January 2006 of the parent experiment, ESM2M-C1_all_historical_HC1 (historical). Several forcing agents varied during the 95 year duration of the RCP4.5 experiment based upon the MINICAM integrated assessment model for the 21st century. The time-varying forcing agents include the well-mixed greenhouse gases (CO2, CH4, N2O, halons), tropospheric and stratospheric O3, model-derived aerosol concentrations (sulfate, black and organic carbon, sea salt and dust), and land use transitions. Volcanic aerosols were zero and solar irradiance varied seasonally based upon late 20th century averages but with no interannual variation. The direct effect of tropospheric aerosols is calculated by the model, but not the indirect effects.",
                                "v20111228annualparent_experiment_rip": "r1i1p1",
                                "v20111228annualETCCDI_software_version": "0.6.1",
                                "v20111228annualtable_id": "Table day (31 Jan 2011)",
                                "v20111228annualinput_tracking_id": "6a437b79-74bf-48ac-82a4-eac5cc1fd8fa",
                                "v20111228annualproject_id": "CMIP5",
                                "iridlhasSemantics": "iridl:GFDL-ESM2M",
                                "Conventions": "IRIDL"
                            },
                            "v20111228": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20111228",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:40 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sat Jul 14 22:22:43 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/GFDL-ESM2M"
                        },
                        "GISSE2R": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GISS-E2-R",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinstitute_id": "NASA-GISS",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinstitution": "NASA/GISS (Goddard Institute for Space Studies) New York, NY",
                                "mult_versionsmonthlyNASAGISS_references": "http://data.giss.nasa.gov/modelE/ar5",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlysource": "GISS-E2-R-E134TcadiRCP45fF40oQ32 Atmosphere: GISS-E2; Ocean: R",
                                "mult_versionsmonthlycreation_date": "2013-06-29T22:59:13Z",
                                "mult_versionsmonthlybranch_time": "2006.0",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlycmor_version": "2.5.7",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlyrealization": "6",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on GISS-E2-R model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyexperiment_id": "rcp45",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyinput_creation_date": "2012-09-25T19:00:18Z",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlymodel_id": "GISS-E2-R",
                                "mult_versionsmonthlyinput_title": "GISS-E2-R model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyparent_experiment_id": "historical",
                                "mult_versionsmonthlyexperiment": "RCP4.5",
                                "mult_versionsmonthlyforcing": "GHG, LU, Sl, Vl, BC, OC, SA, Oz (also includes orbital change - BC on snow - Nitrate aerosols - interactive CH4)",
                                "mult_versionsmonthlyparent_experiment": "historical",
                                "mult_versionsmonthlyNASAGISS_contact": "Kenneth Lo (cdkkl@giss.nasa.gov)",
                                "mult_versionsmonthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitute_id": "NASA-GISS",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinstitution": "NASA/GISS (Goddard Institute for Space Studies) New York, NY",
                                "mult_versionsannualNASAGISS_references": "http://data.giss.nasa.gov/modelE/ar5",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualsource": "GISS-E2-R-E135RCP45fF40oQ32 Atmosphere: GISS-E2; Ocean: R",
                                "mult_versionsannualcreation_date": "2012-07-14T23:40:54Z",
                                "mult_versionsannualbranch_time": "2006.0",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualcmor_version": "2.5.7",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualrealization": "6",
                                "mult_versionsannualtitle": "ETCCDI indices computed on GISS-E2-R model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualexperiment_id": "rcp45",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualinput_creation_date": "2012-05-10T17:53:44Z",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualmodel_id": "GISS-E2-R",
                                "mult_versionsannualinput_title": "GISS-E2-R model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualparent_experiment_id": "historical",
                                "mult_versionsannualexperiment": "RCP4.5",
                                "mult_versionsannualforcing": "GHG, LU, Sl, Vl, BC, OC, SA, Oz (also includes orbital change - BC on snow - Nitrate aerosols)",
                                "mult_versionsannualparent_experiment": "historical",
                                "mult_versionsannualNASAGISS_contact": "Kenneth Lo (cdkkl@giss.nasa.gov)",
                                "mult_versionsannualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "iridlhasSemantics": "iridl:GISS-E2-R",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "2.0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.0",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/GISS-E2-R"
                        },
                        "HadCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110905monthlycontact": "bronaugh@uvic.ca",
                                "v20110905monthlyfrequency": "mon",
                                "v20110905monthlyrealization": "1",
                                "v20110905monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20110905monthlyproduct": "output",
                                "v20110905monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110905monthlynco_openmp_thread_number": "1",
                                "v20110905monthlysource": "HadCM3 - Hadley Centre Coupled Model Version 3 (2000) atmosphere: HadAM3 (N48L19); ocean: HadOM (lat: 1.25 lon: 1.25 L20); land-surface/vegetation: MOSES1;",
                                "v20110905monthlyexperiment": "RCP4.5",
                                "v20110905monthlyparent_experiment": "historical",
                                "v20110905monthlyETCCDI_software": "climdex.pcic",
                                "v20110905monthlyinput_frequency": "day",
                                "v20110905monthlyConventions": "CF-1.4",
                                "v20110905monthlyinitialization_method": "1",
                                "v20110905monthlycmor_version": "2.7.1",
                                "v20110905monthlyforcing": "GHG, Oz, SA, Sl, Vl, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20110905monthlyETCCDI_institution_id": "PCIC",
                                "v20110905monthlytitle": "ETCCDI indices computed on HadCM3 model output prepared for CMIP5 RCP4.5",
                                "v20110905monthlymo_runid": "ajeek",
                                "v20110905monthlyMOHC_contact": "doug.smith@metoffice.gov.uk, holger.pohlmann@metoffice.gov.uk",
                                "v20110905monthlymodel_id": "HadCM3",
                                "v20110905monthlyMOHC_references": "Collins, M. S.F.B Tett, and C. Cooper (2001) the Internal Climate Variability of HadCM3, a Version of the Hadley Centre Coupled Model without Flux Adjustments. Climate Dynamics, 17 (1): 61-81.; Smith, D.M., S. Cusack, A.W. Colman, C.K. Folland, G.R. Harris and J.M. Murphy (2007) Improved surface temperature prediction for the coming decade from a global climate model. Science, 317, 796-799; Smith, D.M., R. Eade, N.J. Dunstone, D. Fereday, J.M. Murphy, H. Pohlman, and A.A. Scaife (2010) Skilful multi-year predictions of Atlantic hurricane frequency. Nature Geoscience, DOI: 10.1038/NGE01004;",
                                "v20110905monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110905monthlycreation_date": "2012-07-16T22:55:28Z",
                                "v20110905monthlyinput_title": "HadCM3 model output prepared for CMIP5 RCP4.5",
                                "v20110905monthlyphysics_version": "1",
                                "v20110905monthlyproject_id": "CMIP5",
                                "v20110905monthlyETCCDI_software_version": "0.6.1",
                                "v20110905monthlyexperiment_id": "rcp45",
                                "v20110905monthlyinput_creation_date": "2011-08-12T09:59:33Z",
                                "v20110905monthlyparent_experiment_id": "historical",
                                "v20110905monthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20110905monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110905monthlyinstitute_id": "MOHC",
                                "v20110905monthlybranch_time": "52590.0",
                                "v20110905monthlyinput_tracking_id": "9ddd4cff-2d74-427b-9a16-9b2dd1df506c",
                                "v20110905monthlymodeling_realm": "atmos",
                                "v20110905annualcontact": "bronaugh@uvic.ca",
                                "v20110905annualfrequency": "yr",
                                "v20110905annualrealization": "1",
                                "v20110905annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20110905annualproduct": "output",
                                "v20110905annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110905annualnco_openmp_thread_number": "1",
                                "v20110905annualexperiment": "RCP4.5",
                                "v20110905annualsource": "HadCM3 - Hadley Centre Coupled Model Version 3 (2000) atmosphere: HadAM3 (N48L19); ocean: HadOM (lat: 1.25 lon: 1.25 L20); land-surface/vegetation: MOSES1;",
                                "v20110905annualparent_experiment": "historical",
                                "v20110905annualETCCDI_software": "climdex.pcic",
                                "v20110905annualinput_frequency": "day",
                                "v20110905annualConventions": "CF-1.4",
                                "v20110905annualinitialization_method": "1",
                                "v20110905annualcmor_version": "2.7.1",
                                "v20110905annualforcing": "GHG, Oz, SA, Sl, Vl, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20110905annualETCCDI_institution_id": "PCIC",
                                "v20110905annualtitle": "ETCCDI indices computed on HadCM3 model output prepared for CMIP5 RCP4.5",
                                "v20110905annualmo_runid": "ajeek",
                                "v20110905annualMOHC_contact": "doug.smith@metoffice.gov.uk, holger.pohlmann@metoffice.gov.uk",
                                "v20110905annualmodel_id": "HadCM3",
                                "v20110905annualMOHC_references": "Collins, M. S.F.B Tett, and C. Cooper (2001) the Internal Climate Variability of HadCM3, a Version of the Hadley Centre Coupled Model without Flux Adjustments. Climate Dynamics, 17 (1): 61-81.; Smith, D.M., S. Cusack, A.W. Colman, C.K. Folland, G.R. Harris and J.M. Murphy (2007) Improved surface temperature prediction for the coming decade from a global climate model. Science, 317, 796-799; Smith, D.M., R. Eade, N.J. Dunstone, D. Fereday, J.M. Murphy, H. Pohlman, and A.A. Scaife (2010) Skilful multi-year predictions of Atlantic hurricane frequency. Nature Geoscience, DOI: 10.1038/NGE01004;",
                                "v20110905annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110905annualcreation_date": "2012-07-16T22:55:31Z",
                                "v20110905annualinput_title": "HadCM3 model output prepared for CMIP5 RCP4.5",
                                "v20110905annualphysics_version": "1",
                                "v20110905annualproject_id": "CMIP5",
                                "v20110905annualETCCDI_software_version": "0.6.1",
                                "v20110905annualexperiment_id": "rcp45",
                                "v20110905annualinput_creation_date": "2011-08-12T09:59:33Z",
                                "v20110905annualparent_experiment_id": "historical",
                                "v20110905annualinstitute_id": "MOHC",
                                "v20110905annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110905annualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20110905annualbranch_time": "52590.0",
                                "v20110905annualinput_tracking_id": "9ddd4cff-2d74-427b-9a16-9b2dd1df506c",
                                "v20110905annualmodeling_realm": "atmos",
                                "iridlhasSemantics": "iridl:HadCM3",
                                "Conventions": "IRIDL"
                            },
                            "v20110905": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110905",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:23 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:26 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:26 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:28 2012",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Jul 16 22:55:31 2012",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.5",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/HadCM3"
                        },
                        "HadGEM2CC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadGEM2-CC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120531monthlyinput_frequency": "day",
                                "v20120531monthlymodeling_realm": "atmos",
                                "v20120531monthlyexperiment_id": "rcp45",
                                "v20120531monthlycontact": "bronaugh@uvic.ca",
                                "v20120531monthlyproduct": "output",
                                "v20120531monthlyrealization": "1",
                                "v20120531monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120531monthlyMOHC_contact": "chris.d.jones@metoffice.gov.uk, steven.hardiman@metoffice.gov.uk",
                                "v20120531monthlymo_runid": "akgii",
                                "v20120531monthlycreation_date": "2013-06-29T23:35:12Z",
                                "v20120531monthlysource": "HadGEM2-CC (2011) atmosphere: HadGAM2(N96L60); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; ocean biogeochemistry: diat-HadOCC",
                                "v20120531monthlyETCCDI_institution_id": "PCIC",
                                "v20120531monthlynco_openmp_thread_number": "1",
                                "v20120531monthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20120531monthlyConventions": "CF-1.4",
                                "v20120531monthlyforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20120531monthlyinitialization_method": "1",
                                "v20120531monthlyproject_id": "CMIP5",
                                "v20120531monthlytitle": "ETCCDI indices computed on HadGEM2-CC model output prepared for CMIP5 RCP4.5",
                                "v20120531monthlyparent_experiment_id": "historical",
                                "v20120531monthlymodel_id": "HadGEM2-CC",
                                "v20120531monthlyinput_creation_date": "2011-10-12T10:55:07Z",
                                "v20120531monthlyexperiment": "RCP4.5",
                                "v20120531monthlycmor_version": "2.7.1",
                                "v20120531monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120531monthlyinstitute_id": "MOHC",
                                "v20120531monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120531monthlyparent_experiment_rip": "r1i1p1",
                                "v20120531monthlyETCCDI_software": "climdex.pcic",
                                "v20120531monthlyinput_title": "HadGEM2-CC model output prepared for CMIP5 RCP4.5",
                                "v20120531monthlyfrequency": "mon",
                                "v20120531monthlyETCCDI_software_version": "0.7.1",
                                "v20120531monthlyphysics_version": "1",
                                "v20120531monthlyMOHC_references": "Jones, C.D. et al. (2011) The HadGEM2-ES implementation of CMIP5 centennial simulations. Geosci. Model Dev., 4, 543-570, http://www.geosci-model-dev.net/4/543/2011/gmd-4-543-2011.html; Martin G.M. et al. (2011) The HadGEM2 family of Met Office Unified Model climate configurations, Geosci. Model Dev., 4, 723-757, http://www.geosci-model-dev.net/4/723/2011/gmd-4-723-2011.html; Collins, W.J. et al. (2011) Development and evaluation of an Earth-system model - HadGEM2, Geosci. Model Dev. Discuss., 4, 997-1062, http://www.geosci-model-dev-discuss.net/4/997/2011/gmdd-4-997-2011.html",
                                "v20120531monthlyparent_experiment": "historical",
                                "v20120531monthlybranch_time": "52560.0",
                                "v20120531monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120531annualinput_frequency": "day",
                                "v20120531annualmodeling_realm": "atmos",
                                "v20120531annualexperiment_id": "rcp45",
                                "v20120531annualcontact": "bronaugh@uvic.ca",
                                "v20120531annualproduct": "output",
                                "v20120531annualrealization": "1",
                                "v20120531annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120531annualMOHC_contact": "chris.d.jones@metoffice.gov.uk, steven.hardiman@metoffice.gov.uk",
                                "v20120531annualmo_runid": "akgii",
                                "v20120531annualcreation_date": "2013-06-29T23:35:13Z",
                                "v20120531annualsource": "HadGEM2-CC (2011) atmosphere: HadGAM2(N96L60); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; ocean biogeochemistry: diat-HadOCC",
                                "v20120531annualETCCDI_institution_id": "PCIC",
                                "v20120531annualnco_openmp_thread_number": "1",
                                "v20120531annualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20120531annualConventions": "CF-1.4",
                                "v20120531annualforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20120531annualinitialization_method": "1",
                                "v20120531annualproject_id": "CMIP5",
                                "v20120531annualtitle": "ETCCDI indices computed on HadGEM2-CC model output prepared for CMIP5 RCP4.5",
                                "v20120531annualparent_experiment_id": "historical",
                                "v20120531annualmodel_id": "HadGEM2-CC",
                                "v20120531annualinput_creation_date": "2011-10-12T10:55:07Z",
                                "v20120531annualexperiment": "RCP4.5",
                                "v20120531annualcmor_version": "2.7.1",
                                "v20120531annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120531annualinstitute_id": "MOHC",
                                "v20120531annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120531annualparent_experiment_rip": "r1i1p1",
                                "v20120531annualETCCDI_software": "climdex.pcic",
                                "v20120531annualinput_title": "HadGEM2-CC model output prepared for CMIP5 RCP4.5",
                                "v20120531annualfrequency": "yr",
                                "v20120531annualETCCDI_software_version": "0.7.1",
                                "v20120531annualphysics_version": "1",
                                "v20120531annualMOHC_references": "Jones, C.D. et al. (2011) The HadGEM2-ES implementation of CMIP5 centennial simulations. Geosci. Model Dev., 4, 543-570, http://www.geosci-model-dev.net/4/543/2011/gmd-4-543-2011.html; Martin G.M. et al. (2011) The HadGEM2 family of Met Office Unified Model climate configurations, Geosci. Model Dev., 4, 723-757, http://www.geosci-model-dev.net/4/723/2011/gmd-4-723-2011.html; Collins, W.J. et al. (2011) Development and evaluation of an Earth-system model - HadGEM2, Geosci. Model Dev. Discuss., 4, 997-1062, http://www.geosci-model-dev-discuss.net/4/997/2011/gmdd-4-997-2011.html",
                                "v20120531annualparent_experiment": "historical",
                                "v20120531annualbranch_time": "52560.0",
                                "v20120531annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "iridlhasSemantics": "iridl:HadGEM2-CC",
                                "Conventions": "IRIDL"
                            },
                            "v20120531": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120531",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:12 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jun 29 23:35:13 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/HadGEM2-CC"
                        },
                        "HadGEM2ES": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HadGEM2-ES",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20111205monthlyproject_id": "CMIP5",
                                "v20111205monthlycontact": "bronaugh@uvic.ca",
                                "v20111205monthlymo_runid": "kaadd",
                                "v20111205monthlymodel_id": "HadGEM2-ES",
                                "v20111205monthlyinput_frequency": "day",
                                "v20111205monthlyproduct": "output",
                                "v20111205monthlycmor_version": "2.7.1",
                                "v20111205monthlyMOHC_contact": "chris.d.jones@metoffice.gov.uk, ron.kahana@metoffice.gov.uk",
                                "v20111205monthlyparent_experiment_id": "historical",
                                "v20111205monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20111205monthlycreation_date": "2013-06-29T23:35:57Z",
                                "v20111205monthlyinput_creation_date": "2011-11-07T14:08:06Z",
                                "v20111205monthlyinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20111205monthlyinitialization_method": "1",
                                "v20111205monthlysource": "HadGEM2-ES (2009) atmosphere: HadGAM2 (N96L38); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; tropospheric chemistry: UKCA; ocean biogeochemistry: diat-HadOCC",
                                "v20111205monthlyETCCDI_software_version": "0.7.1",
                                "v20111205monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111205monthlyforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20111205monthlyConventions": "CF-1.4",
                                "v20111205monthlytitle": "ETCCDI indices computed on HadGEM2-ES model output prepared for CMIP5 RCP4.5",
                                "v20111205monthlyexperiment": "RCP4.5",
                                "v20111205monthlymodeling_realm": "atmos",
                                "v20111205monthlyinstitute_id": "MOHC",
                                "v20111205monthlyparent_experiment": "historical",
                                "v20111205monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111205monthlynco_openmp_thread_number": "1",
                                "v20111205monthlyETCCDI_institution_id": "PCIC",
                                "v20111205monthlyphysics_version": "1",
                                "v20111205monthlyETCCDI_software": "climdex.pcic",
                                "v20111205monthlybranch_time": "52560.0",
                                "v20111205monthlyinput_title": "HadGEM2-ES model output prepared for CMIP5 RCP4.5",
                                "v20111205monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111205monthlyfrequency": "mon",
                                "v20111205monthlyexperiment_id": "rcp45",
                                "v20111205annualproject_id": "CMIP5",
                                "v20111205annualcontact": "bronaugh@uvic.ca",
                                "v20111205annualmo_runid": "kaadd",
                                "v20111205annualmodel_id": "HadGEM2-ES",
                                "v20111205annualinput_frequency": "day",
                                "v20111205annualproduct": "output",
                                "v20111205annualcmor_version": "2.7.1",
                                "v20111205annualMOHC_contact": "chris.d.jones@metoffice.gov.uk, ron.kahana@metoffice.gov.uk",
                                "v20111205annualparent_experiment_id": "historical",
                                "v20111205annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20111205annualcreation_date": "2013-06-29T23:35:57Z",
                                "v20111205annualinput_creation_date": "2011-11-07T14:08:06Z",
                                "v20111205annualinstitution": "Met Office Hadley Centre, Fitzroy Road, Exeter, Devon, EX1 3PB, UK, (http://www.metoffice.gov.uk)",
                                "v20111205annualinitialization_method": "1",
                                "v20111205annualsource": "HadGEM2-ES (2009) atmosphere: HadGAM2 (N96L38); ocean: HadGOM2 (lat: 1.0-0.3 lon: 1.0 L40); land-surface/vegetation: MOSES2 and TRIFFID; tropospheric chemistry: UKCA; ocean biogeochemistry: diat-HadOCC",
                                "v20111205annualETCCDI_software_version": "0.7.1",
                                "v20111205annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111205annualforcing": "GHG, Oz, SA, LU, Sl, Vl, BC, OC, (GHG = CO2, N2O, CH4, CFCs)",
                                "v20111205annualConventions": "CF-1.4",
                                "v20111205annualtitle": "ETCCDI indices computed on HadGEM2-ES model output prepared for CMIP5 RCP4.5",
                                "v20111205annualexperiment": "RCP4.5",
                                "v20111205annualmodeling_realm": "atmos",
                                "v20111205annualinstitute_id": "MOHC",
                                "v20111205annualparent_experiment": "historical",
                                "v20111205annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111205annualnco_openmp_thread_number": "1",
                                "v20111205annualETCCDI_institution_id": "PCIC",
                                "v20111205annualphysics_version": "1",
                                "v20111205annualETCCDI_software": "climdex.pcic",
                                "v20111205annualbranch_time": "52560.0",
                                "v20111205annualinput_title": "HadGEM2-ES model output prepared for CMIP5 RCP4.5",
                                "v20111205annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111205annualfrequency": "yr",
                                "v20111205annualexperiment_id": "rcp45",
                                "iridlhasSemantics": "iridl:HadGEM2-ES",
                                "Conventions": "IRIDL"
                            },
                            "v20111205": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20111205",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:56 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:56 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:56 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:56 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:56 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:58 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 23:35:57 2013",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.25",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/HadGEM2-ES"
                        },
                        "IPSLCM5ALR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPSL-CM5A-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyexperiment_id": "rcp45",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlyinstitute_id": "IPSL",
                                "mult_versionsmonthlycomment": "This 21th century simulation has been forced by prescribed concentration following the rcp 4.5 scenario.",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsmonthlymodel_id": "IPSL-CM5A-LR",
                                "mult_versionsmonthlyETCCDI_software_version": "0.7.1",
                                "mult_versionsmonthlysource": "IPSL-CM5A-LR (2010) : atmos : LMDZ4 (LMDZ4_v5, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsmonthlyinput_title": "IPSL-CM5A-LR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyinput_tracking_id": "bca77d4e-326f-4367-84a2-2fcb10bca77c",
                                "mult_versionsmonthlyIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsmonthlyparent_experiment_id": "historical",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on IPSL-CM5A-LR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "mult_versionsmonthlycreation_date": "2013-07-20T10:47:17Z",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsmonthlyinput_creation_date": "2011-06-24T03:18:48Z",
                                "mult_versionsmonthlybranch_time": "2005.0",
                                "mult_versionsmonthlyexperiment": "RCP4.5",
                                "mult_versionsmonthlyparent_experiment": "historical",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlycmor_version": "2.5.1",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlytable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualexperiment_id": "rcp45",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualinstitute_id": "IPSL",
                                "mult_versionsannualcomment": "This 21th century simulation has been forced by prescribed concentration following the rcp 4.5 scenario.",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "mult_versionsannualmodel_id": "IPSL-CM5A-LR",
                                "mult_versionsannualETCCDI_software_version": "0.7.1",
                                "mult_versionsannualsource": "IPSL-CM5A-LR (2010) : atmos : LMDZ4 (LMDZ4_v5, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "mult_versionsannualinput_title": "IPSL-CM5A-LR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualinput_tracking_id": "bca77d4e-326f-4367-84a2-2fcb10bca77c",
                                "mult_versionsannualIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "mult_versionsannualparent_experiment_id": "historical",
                                "mult_versionsannualtitle": "ETCCDI indices computed on IPSL-CM5A-LR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "mult_versionsannualcreation_date": "2013-07-20T10:47:17Z",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "mult_versionsannualinput_creation_date": "2011-06-24T03:18:48Z",
                                "mult_versionsannualbranch_time": "2005.0",
                                "mult_versionsannualexperiment": "RCP4.5",
                                "mult_versionsannualparent_experiment": "historical",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualcmor_version": "2.5.1",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualtable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualinitialization_method": "1",
                                "iridlhasSemantics": "iridl:IPSL-CM5A-LR",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/IPSL-CM5A-LR"
                        },
                        "IPSLCM5BLR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IPSL-CM5B-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120430monthlyIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "v20120430monthlyETCCDI_software_version": "0.6.1",
                                "v20120430monthlyrealization": "1",
                                "v20120430monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120430monthlyinput_frequency": "day",
                                "v20120430monthlyproduct": "output",
                                "v20120430monthlyparent_experiment_id": "historical",
                                "v20120430monthlyETCCDI_institution_id": "PCIC",
                                "v20120430monthlyinput_title": "IPSL-CM5B-LR model output prepared for CMIP5 RCP4.5",
                                "v20120430monthlyparent_experiment": "historical",
                                "v20120430monthlyETCCDI_software": "climdex.pcic",
                                "v20120430monthlycreation_date": "2012-07-15T11:14:06Z",
                                "v20120430monthlysource": "IPSL-CM5B-LR (2011) : atmos : LMDZ5 (LMDZ5_NPv3.1, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "v20120430monthlyConventions": "CF-1.4",
                                "v20120430monthlyhistory": "2012-04-14T21:42:36Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120430monthlycomment": "This 21th century simulation has been forced by prescribed concentration following the rcp 4.5 scenario.",
                                "v20120430monthlyinput_creation_date": "2012-04-14T21:42:36Z",
                                "v20120430monthlyforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "v20120430monthlytitle": "ETCCDI indices computed on IPSL-CM5B-LR model output prepared for CMIP5 RCP4.5",
                                "v20120430monthlyIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "v20120430monthlycontact": "bronaugh@uvic.ca",
                                "v20120430monthlyfrequency": "mon",
                                "v20120430monthlyparent_experiment_rip": "r1i1p1",
                                "v20120430monthlymodeling_realm": "atmos",
                                "v20120430monthlyinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "v20120430monthlycmor_version": "2.7.1",
                                "v20120430monthlymodel_id": "IPSL-CM5B-LR",
                                "v20120430monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120430monthlytable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "v20120430monthlyproject_id": "CMIP5",
                                "v20120430monthlyexperiment_id": "rcp45",
                                "v20120430monthlyinitialization_method": "1",
                                "v20120430monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120430monthlybranch_time": "2005.0",
                                "v20120430monthlyphysics_version": "1",
                                "v20120430monthlyinstitute_id": "IPSL",
                                "v20120430monthlyexperiment": "RCP4.5",
                                "v20120430annualIPSL_references": "Model documentation and further reference available here : http://icmc.ipsl.fr",
                                "v20120430annualETCCDI_software_version": "0.6.1",
                                "v20120430annualrealization": "1",
                                "v20120430annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120430annualinput_frequency": "day",
                                "v20120430annualproduct": "output",
                                "v20120430annualparent_experiment_id": "historical",
                                "v20120430annualETCCDI_institution_id": "PCIC",
                                "v20120430annualinput_title": "IPSL-CM5B-LR model output prepared for CMIP5 RCP4.5",
                                "v20120430annualparent_experiment": "historical",
                                "v20120430annualETCCDI_software": "climdex.pcic",
                                "v20120430annualcreation_date": "2012-07-15T11:14:08Z",
                                "v20120430annualsource": "IPSL-CM5B-LR (2011) : atmos : LMDZ5 (LMDZ5_NPv3.1, 96x95x39); ocean : ORCA2 (NEMOV2_3, 2x2L31); seaIce : LIM2 (NEMOV2_3); ocnBgchem : PISCES (NEMOV2_3); land : ORCHIDEE (orchidee_1_9_4_AR5)",
                                "v20120430annualConventions": "CF-1.4",
                                "v20120430annualhistory": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012 2012-04-14T21:42:36Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120430annualcomment": "This 21th century simulation has been forced by prescribed concentration following the rcp 4.5 scenario.",
                                "v20120430annualinput_creation_date": "2012-04-14T21:42:36Z",
                                "v20120430annualforcing": "Nat,Ant,GHG,SA,Oz,LU,SS,Ds,BC,MD,OC,AA",
                                "v20120430annualtitle": "ETCCDI indices computed on IPSL-CM5B-LR model output prepared for CMIP5 RCP4.5",
                                "v20120430annualIPSL_contact": "ipsl-cmip5 _at_ ipsl.jussieu.fr Data manager : Sebastien Denvil",
                                "v20120430annualcmor_version": "2.7.1",
                                "v20120430annualfrequency": "yr",
                                "v20120430annualparent_experiment_rip": "r1i1p1",
                                "v20120430annualmodeling_realm": "atmos",
                                "v20120430annualinstitution": "IPSL (Institut Pierre Simon Laplace, Paris, France)",
                                "v20120430annualcontact": "bronaugh@uvic.ca",
                                "v20120430annualmodel_id": "IPSL-CM5B-LR",
                                "v20120430annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120430annualtable_id": "Table day (10 February 2011) 80e409bd73611e9d25d049ad2059c310",
                                "v20120430annualproject_id": "CMIP5",
                                "v20120430annualexperiment_id": "rcp45",
                                "v20120430annualinitialization_method": "1",
                                "v20120430annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120430annualbranch_time": "2005.0",
                                "v20120430annualphysics_version": "1",
                                "v20120430annualinstitute_id": "IPSL",
                                "v20120430annualexperiment": "RCP4.5",
                                "iridlhasSemantics": "iridl:IPSL-CM5B-LR",
                                "Conventions": "IRIDL"
                            },
                            "v20120430": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120430",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:06 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 11:14:08 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "3.75",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/IPSL-CM5B-LR"
                        },
                        "MIROCESM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC-ESM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120710monthlyinstitute_id": "MIROC",
                                "v20120710monthlyinput_creation_date": "2011-10-05T10:52:29Z",
                                "v20120710monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710monthlyinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710monthlyphysics_version": "1",
                                "v20120710monthlyproduct": "output",
                                "v20120710monthlyparent_experiment_id": "historical",
                                "v20120710monthlyexperiment_id": "rcp45",
                                "v20120710monthlycontact": "bronaugh@uvic.ca",
                                "v20120710monthlyparent_experiment_rip": "r1i1p1",
                                "v20120710monthlyfrequency": "mon",
                                "v20120710monthlysource": "MIROC-ESM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710monthlyexperiment": "RCP4.5",
                                "v20120710monthlyConventions": "CF-1.4",
                                "v20120710monthlyETCCDI_software": "climdex.pcic",
                                "v20120710monthlyETCCDI_institution_id": "PCIC",
                                "v20120710monthlytitle": "ETCCDI indices computed on MIROC-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlyETCCDI_software_version": "0.7.1",
                                "v20120710monthlymodeling_realm": "atmos",
                                "v20120710monthlyinput_title": "MIROC-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlyinitialization_method": "1",
                                "v20120710monthlyMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710monthlyMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710monthlyproject_id": "CMIP5",
                                "v20120710monthlyinput_tracking_id": "a70f6aa3-4507-4f09-92cb-b6ba75f96f7f",
                                "v20120710monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710monthlycreation_date": "2013-07-20T11:09:18Z",
                                "v20120710monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC",
                                "v20120710monthlybranch_time": "56978.0",
                                "v20120710monthlynco_openmp_thread_number": "1",
                                "v20120710monthlyrealization": "1",
                                "v20120710monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710monthlycmor_version": "2.7.1",
                                "v20120710monthlyinput_frequency": "day",
                                "v20120710monthlymodel_id": "MIROC-ESM",
                                "v20120710monthlyparent_experiment": "historical",
                                "v20120710annualinstitute_id": "MIROC",
                                "v20120710annualinput_creation_date": "2011-10-05T10:52:29Z",
                                "v20120710annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710annualinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710annualphysics_version": "1",
                                "v20120710annualproduct": "output",
                                "v20120710annualparent_experiment_id": "historical",
                                "v20120710annualexperiment_id": "rcp45",
                                "v20120710annualcontact": "bronaugh@uvic.ca",
                                "v20120710annualparent_experiment_rip": "r1i1p1",
                                "v20120710annualfrequency": "yr",
                                "v20120710annualsource": "MIROC-ESM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710annualexperiment": "RCP4.5",
                                "v20120710annualConventions": "CF-1.4",
                                "v20120710annualETCCDI_software": "climdex.pcic",
                                "v20120710annualETCCDI_institution_id": "PCIC",
                                "v20120710annualtitle": "ETCCDI indices computed on MIROC-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120710annualETCCDI_software_version": "0.7.1",
                                "v20120710annualinitialization_method": "1",
                                "v20120710annualinput_title": "MIROC-ESM model output prepared for CMIP5 RCP4.5",
                                "v20120710annualMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710annualmodeling_realm": "atmos",
                                "v20120710annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710annualMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710annualproject_id": "CMIP5",
                                "v20120710annualinput_tracking_id": "a70f6aa3-4507-4f09-92cb-b6ba75f96f7f",
                                "v20120710annualnco_openmp_thread_number": "1",
                                "v20120710annualcreation_date": "2013-07-20T11:09:18Z",
                                "v20120710annualforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC",
                                "v20120710annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710annualbranch_time": "56978.0",
                                "v20120710annualrealization": "1",
                                "v20120710annualcmor_version": "2.7.1",
                                "v20120710annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710annualinput_frequency": "day",
                                "v20120710annualmodel_id": "MIROC-ESM",
                                "v20120710annualparent_experiment": "historical",
                                "iridlhasSemantics": "iridl:MIROC-ESM",
                                "Conventions": "IRIDL"
                            },
                            "v20120710": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120710",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:09:18 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MIROC-ESM"
                        },
                        "MIROCESMCHEM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC-ESM-CHEM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120710monthlymodel_id": "MIROC-ESM-CHEM",
                                "v20120710monthlyinput_title": "MIROC-ESM-CHEM model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlyrealization": "1",
                                "v20120710monthlyETCCDI_software": "climdex.pcic",
                                "v20120710monthlyproduct": "output",
                                "v20120710monthlycreation_date": "2012-07-17T12:40:25Z",
                                "v20120710monthlyETCCDI_institution_id": "PCIC",
                                "v20120710monthlyparent_experiment_id": "historical",
                                "v20120710monthlyinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710monthlyexperiment_id": "rcp45",
                                "v20120710monthlysource": "MIROC-ESM-CHEM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):atmospheric-chemistry: CHASER (CHASER 4.1, T42L80): ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710monthlyinput_frequency": "day",
                                "v20120710monthlymodeling_realm": "atmos",
                                "v20120710monthlyConventions": "CF-1.4",
                                "v20120710monthlyfrequency": "mon",
                                "v20120710monthlycmor_version": "2.7.1",
                                "v20120710monthlybranch_time": "56978.0",
                                "v20120710monthlyhistory": "2011-10-22T02:29:22Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120710monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710monthlyparent_experiment": "historical",
                                "v20120710monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC (Ozone is predicted)",
                                "v20120710monthlytitle": "ETCCDI indices computed on MIROC-ESM-CHEM model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlyinitialization_method": "1",
                                "v20120710monthlyparent_experiment_rip": "r1i1p1",
                                "v20120710monthlyproject_id": "CMIP5",
                                "v20120710monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710monthlytable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710monthlyMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710monthlycontact": "bronaugh@uvic.ca",
                                "v20120710monthlyMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710monthlyexperiment": "RCP4.5",
                                "v20120710monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710monthlyinput_creation_date": "2011-10-22T02:29:22Z",
                                "v20120710monthlyinstitute_id": "MIROC",
                                "v20120710monthlyETCCDI_software_version": "0.6.1",
                                "v20120710monthlyphysics_version": "1",
                                "v20120710annualmodel_id": "MIROC-ESM-CHEM",
                                "v20120710annualinput_title": "MIROC-ESM-CHEM model output prepared for CMIP5 RCP4.5",
                                "v20120710annualrealization": "1",
                                "v20120710annualETCCDI_software": "climdex.pcic",
                                "v20120710annualproduct": "output",
                                "v20120710annualcreation_date": "2012-07-17T12:40:27Z",
                                "v20120710annualETCCDI_institution_id": "PCIC",
                                "v20120710annualparent_experiment_id": "historical",
                                "v20120710annualinstitution": "JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan), AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), and NIES (National Institute for Environmental Studies, Ibaraki, Japan)",
                                "v20120710annualexperiment_id": "rcp45",
                                "v20120710annualinput_frequency": "day",
                                "v20120710annualsource": "MIROC-ESM-CHEM 2010 atmosphere: MIROC-AGCM (MIROC-AGCM 2010, T42L80); ocean: COCO (COCO3.4, 256x192 L44); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T42L80):atmospheric-chemistry: CHASER (CHASER 4.1, T42L80): ocean-biogeochemistry: NPZD ; land-biogeochemistry: SEIB-DGVM (SEIB-DGVM, T42)",
                                "v20120710annualmodeling_realm": "atmos",
                                "v20120710annualConventions": "CF-1.4",
                                "v20120710annualfrequency": "yr",
                                "v20120710annualcmor_version": "2.7.1",
                                "v20120710annualbranch_time": "56978.0",
                                "v20120710annualhistory": "2011-10-22T02:29:22Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
                                "v20120710annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710annualparent_experiment": "historical",
                                "v20120710annualforcing": "GHG, SA, Oz, LU, Sl, Vl, MD, BC, OC (Ozone is predicted)",
                                "v20120710annualtitle": "ETCCDI indices computed on MIROC-ESM-CHEM model output prepared for CMIP5 RCP4.5",
                                "v20120710annualinitialization_method": "1",
                                "v20120710annualparent_experiment_rip": "r1i1p1",
                                "v20120710annualproject_id": "CMIP5",
                                "v20120710annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710annualtable_id": "Table day (26 July 2011) f21c16b785432e6bd3f72e80f2cade49",
                                "v20120710annualMIROC_references": "Watanabe et al., : MIROC-ESM: model description and basic results of CMIP5-20c3m experiments, Geosci. Model Dev. Discuss., 4, 1063-1128, doi:10.5194/gmdd-4-1063-2011, 2011.",
                                "v20120710annualcontact": "bronaugh@uvic.ca",
                                "v20120710annualMIROC_contact": "Michio Kawamiya (kawamiya@jamstec.go.jp) and Toru Nozawa (nozawa@nies.go.jp)",
                                "v20120710annualexperiment": "RCP4.5",
                                "v20120710annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710annualinput_creation_date": "2011-10-22T02:29:22Z",
                                "v20120710annualinstitute_id": "MIROC",
                                "v20120710annualETCCDI_software_version": "0.6.1",
                                "v20120710annualphysics_version": "1",
                                "iridlhasSemantics": "iridl:MIROC-ESM-CHEM",
                                "Conventions": "IRIDL"
                            },
                            "v20120710": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120710",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:25 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Tue Jul 17 12:40:27 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MIROC-ESM-CHEM"
                        },
                        "MIROC4h": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC4h",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120628monthlymodel_id": "MIROC4h",
                                "v20120628monthlyinstitute_id": "MIROC",
                                "v20120628monthlyphysics_version": "1",
                                "v20120628monthlyinitialization_method": "1",
                                "v20120628monthlyproduct": "output",
                                "v20120628monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120628monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120628monthlybranch_time": "35054.0",
                                "v20120628monthlyexperiment": "RCP4.5",
                                "v20120628monthlyinput_frequency": "day",
                                "v20120628monthlycmor_version": "2.5.8",
                                "v20120628monthlyMIROC_references": "Sakamoto et al., 2011: MIROC4h -- a new high-resolution atmosphere-ocean coupled general circulation model. (in preparation); Tatebe et al., 2011: (in preparation)",
                                "v20120628monthlycreation_date": "2013-07-20T11:01:45Z",
                                "v20120628monthlyMIROC_contact": "Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp), Masayoshi Ishii (ism@jamstec.go.jp)",
                                "v20120628monthlysource": "MIROC4h 2009 atmosphere: AGCM (AGCM5.8, T213L56); ocean: COCO (COCO3.4, rotated pole 1280x912 L48); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, 2x3L5)",
                                "v20120628monthlyConventions": "CF-1.4",
                                "v20120628monthlyproject_id": "CMIP5",
                                "v20120628monthlyETCCDI_institution_id": "PCIC",
                                "v20120628monthlytitle": "ETCCDI indices computed on MIROC4h model output prepared for CMIP5 RCP4.5",
                                "v20120628monthlynco_openmp_thread_number": "1",
                                "v20120628monthlyparent_experiment": "historical",
                                "v20120628monthlyETCCDI_software_version": "0.7.1",
                                "v20120628monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120628monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120628monthlyparent_experiment_id": "historical",
                                "v20120628monthlyinput_title": "MIROC4h model output prepared for CMIP5 RCP4.5",
                                "v20120628monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2)",
                                "v20120628monthlyfrequency": "mon",
                                "v20120628monthlyinput_creation_date": "2011-08-22T04:38:45Z",
                                "v20120628monthlyinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), and JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120628monthlycontact": "bronaugh@uvic.ca",
                                "v20120628monthlymodeling_realm": "atmos",
                                "v20120628monthlyETCCDI_software": "climdex.pcic",
                                "v20120628monthlyexperiment_id": "rcp45",
                                "v20120628annualmodel_id": "MIROC4h",
                                "v20120628annualinstitute_id": "MIROC",
                                "v20120628annualphysics_version": "1",
                                "v20120628annualinitialization_method": "1",
                                "v20120628annualproduct": "output",
                                "v20120628annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120628annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120628annualbranch_time": "35054.0",
                                "v20120628annualexperiment": "RCP4.5",
                                "v20120628annualinput_frequency": "day",
                                "v20120628annualcmor_version": "2.5.8",
                                "v20120628annualMIROC_references": "Sakamoto et al., 2011: MIROC4h -- a new high-resolution atmosphere-ocean coupled general circulation model. (in preparation); Tatebe et al., 2011: (in preparation)",
                                "v20120628annualcreation_date": "2013-07-20T11:01:46Z",
                                "v20120628annualMIROC_contact": "Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp), Masayoshi Ishii (ism@jamstec.go.jp)",
                                "v20120628annualsource": "MIROC4h 2009 atmosphere: AGCM (AGCM5.8, T213L56); ocean: COCO (COCO3.4, rotated pole 1280x912 L48); sea ice: COCO (COCO3.4); land: MATSIRO (MATSIRO, 2x3L5)",
                                "v20120628annualConventions": "CF-1.4",
                                "v20120628annualproject_id": "CMIP5",
                                "v20120628annualETCCDI_institution_id": "PCIC",
                                "v20120628annualtitle": "ETCCDI indices computed on MIROC4h model output prepared for CMIP5 RCP4.5",
                                "v20120628annualnco_openmp_thread_number": "1",
                                "v20120628annualparent_experiment": "historical",
                                "v20120628annualETCCDI_software_version": "0.7.1",
                                "v20120628annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120628annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120628annualparent_experiment_id": "historical",
                                "v20120628annualinput_title": "MIROC4h model output prepared for CMIP5 RCP4.5",
                                "v20120628annualforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2)",
                                "v20120628annualfrequency": "yr",
                                "v20120628annualinput_creation_date": "2011-08-22T04:38:45Z",
                                "v20120628annualinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), and JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120628annualcontact": "bronaugh@uvic.ca",
                                "v20120628annualmodeling_realm": "atmos",
                                "v20120628annualETCCDI_software": "climdex.pcic",
                                "v20120628annualexperiment_id": "rcp45",
                                "iridlhasSemantics": "iridl:MIROC4h",
                                "Conventions": "IRIDL"
                            },
                            "v20120628": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120628",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jun 29 21:17:33 2013",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:01:46 2013",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "0.5625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MIROC4h"
                        },
                        "MIROC5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MIROC5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120710monthlymodel_id": "MIROC5",
                                "v20120710monthlyMIROC_contact": "Masahiro Watanabe (hiro@aori.u-tokyo.ac.jp), Seita Emori (emori@nies.go.jp), Masayoshi Ishii (ism@jamstec.go.jp), Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp)",
                                "v20120710monthlyETCCDI_software": "climdex.pcic",
                                "v20120710monthlyproject_id": "CMIP5",
                                "v20120710monthlyproduct": "output",
                                "v20120710monthlyinput_frequency": "day",
                                "v20120710monthlyinstitute_id": "MIROC",
                                "v20120710monthlyexperiment": "RCP4.5",
                                "v20120710monthlyinput_title": "MIROC5 model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlycmor_version": "2.7.1",
                                "v20120710monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710monthlysource": "MIROC5 2010 atmosphere: MIROC-AGCM6 (T85L40); ocean: COCO (COCO4.5, 256x224 L50); sea ice: COCO (COCO4.5); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T85L40)",
                                "v20120710monthlyETCCDI_software_version": "0.7.1",
                                "v20120710monthlyConventions": "CF-1.4",
                                "v20120710monthlyparent_experiment": "historical",
                                "v20120710monthlyMIROC_references": "Watanabe et al., 2010: Improved climate simulation by MIROC5: Mean states, variability, and climate sensitivity. J. Climate, 23, 6312-6335",
                                "v20120710monthlyfrequency": "mon",
                                "v20120710monthlytitle": "ETCCDI indices computed on MIROC5 model output prepared for CMIP5 RCP4.5",
                                "v20120710monthlymodeling_realm": "atmos",
                                "v20120710monthlynco_openmp_thread_number": "1",
                                "v20120710monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710monthlyexperiment_id": "rcp45",
                                "v20120710monthlycontact": "bronaugh@uvic.ca",
                                "v20120710monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120710monthlyETCCDI_institution_id": "PCIC",
                                "v20120710monthlyinitialization_method": "1",
                                "v20120710monthlybranch_time": "56940.0",
                                "v20120710monthlycreation_date": "2013-07-20T11:00:45Z",
                                "v20120710monthlyphysics_version": "1",
                                "v20120710monthlyinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120710monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2; LU excludes change in lake fraction)",
                                "v20120710monthlyparent_experiment_id": "historical",
                                "v20120710monthlyinput_creation_date": "2011-07-19T09:45:46Z",
                                "v20120710annualmodel_id": "MIROC5",
                                "v20120710annualMIROC_contact": "Masahiro Watanabe (hiro@aori.u-tokyo.ac.jp), Seita Emori (emori@nies.go.jp), Masayoshi Ishii (ism@jamstec.go.jp), Masahide Kimoto (kimoto@aori.u-tokyo.ac.jp)",
                                "v20120710annualETCCDI_software": "climdex.pcic",
                                "v20120710annualproject_id": "CMIP5",
                                "v20120710annualproduct": "output",
                                "v20120710annualinput_frequency": "day",
                                "v20120710annualinstitute_id": "MIROC",
                                "v20120710annualexperiment": "RCP4.5",
                                "v20120710annualinput_title": "MIROC5 model output prepared for CMIP5 RCP4.5",
                                "v20120710annualcmor_version": "2.7.1",
                                "v20120710annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120710annualsource": "MIROC5 2010 atmosphere: MIROC-AGCM6 (T85L40); ocean: COCO (COCO4.5, 256x224 L50); sea ice: COCO (COCO4.5); land: MATSIRO (MATSIRO, L6); aerosols: SPRINTARS (SPRINTARS 5.00, T85L40)",
                                "v20120710annualETCCDI_software_version": "0.7.1",
                                "v20120710annualConventions": "CF-1.4",
                                "v20120710annualparent_experiment": "historical",
                                "v20120710annualMIROC_references": "Watanabe et al., 2010: Improved climate simulation by MIROC5: Mean states, variability, and climate sensitivity. J. Climate, 23, 6312-6335",
                                "v20120710annualfrequency": "yr",
                                "v20120710annualtitle": "ETCCDI indices computed on MIROC5 model output prepared for CMIP5 RCP4.5",
                                "v20120710annualmodeling_realm": "atmos",
                                "v20120710annualnco_openmp_thread_number": "1",
                                "v20120710annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120710annualexperiment_id": "rcp45",
                                "v20120710annualcontact": "bronaugh@uvic.ca",
                                "v20120710annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120710annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120710annualbranch_time": "56940.0",
                                "v20120710annualETCCDI_institution_id": "PCIC",
                                "v20120710annualinitialization_method": "1",
                                "v20120710annualcreation_date": "2013-07-20T11:00:45Z",
                                "v20120710annualphysics_version": "1",
                                "v20120710annualinstitution": "AORI (Atmosphere and Ocean Research Institute, The University of Tokyo, Chiba, Japan), NIES (National Institute for Environmental Studies, Ibaraki, Japan), JAMSTEC (Japan Agency for Marine-Earth Science and Technology, Kanagawa, Japan)",
                                "v20120710annualforcing": "GHG, SA, Oz, LU, Sl, Vl, SS, Ds, BC, MD, OC (GHG includes CO2, N2O, methane, and fluorocarbons; Oz includes OH and H2O2; LU excludes change in lake fraction)",
                                "v20120710annualparent_experiment_id": "historical",
                                "v20120710annualinput_creation_date": "2011-07-19T09:45:46Z",
                                "iridlhasSemantics": "iridl:MIROC5",
                                "Conventions": "IRIDL"
                            },
                            "v20120710": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120710",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Created by climdex.pcic 0.7.1 on Sat Jul 20 11:00:45 2013",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.40625",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MIROC5"
                        },
                        "MPIESMLR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MPI-ESM-LR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20111006monthlyinput_frequency": "day",
                                "v20111006monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111006monthlyproduct": "output",
                                "v20111006monthlycontact": "bronaugh@uvic.ca",
                                "v20111006monthlycmor_version": "2.5.9",
                                "v20111006monthlyparent_experiment_id": "historical",
                                "v20111006monthlyETCCDI_institution_id": "PCIC",
                                "v20111006monthlyforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "v20111006monthlysource": "MPI-ESM-LR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4619), T63L47; land: JSBACH (REV: 4619); ocean: MPIOM (REV: 4619), GR15L40; sea ice: 4619; marine bgc: HAMOCC (REV: 4619);",
                                "v20111006monthlyETCCDI_software": "climdex.pcic",
                                "v20111006monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20111006monthlyETCCDI_software_version": "0.7.1",
                                "v20111006monthlyConventions": "CF-1.4",
                                "v20111006monthlyinput_tracking_id": "aec1b455-b23f-4177-85d4-e088cf40dcd4",
                                "v20111006monthlyinitialization_method": "1",
                                "v20111006monthlytitle": "ETCCDI indices computed on MPI-ESM-LR model output prepared for CMIP5 RCP4.5",
                                "v20111006monthlyMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20111006monthlymodeling_realm": "atmos",
                                "v20111006monthlyproject_id": "CMIP5",
                                "v20111006monthlyinput_creation_date": "2011-07-17T14:42:08Z",
                                "v20111006monthlybranch_time": "56978.0",
                                "v20111006monthlyexperiment_id": "rcp45",
                                "v20111006monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111006monthlyinput_title": "MPI-ESM-LR model output prepared for CMIP5 RCP4.5",
                                "v20111006monthlyphysics_version": "1",
                                "v20111006monthlyfrequency": "mon",
                                "v20111006monthlycreation_date": "2013-07-01T00:34:47Z",
                                "v20111006monthlyinstitute_id": "MPI-M",
                                "v20111006monthlynco_openmp_thread_number": "1",
                                "v20111006monthlyparent_experiment": "historical",
                                "v20111006monthlyexperiment": "RCP4.5",
                                "v20111006monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111006monthlyMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20111006monthlyinstitution": "Max Planck Institute for Meteorology",
                                "v20111006monthlymodel_id": "MPI-ESM-LR",
                                "v20111006annualinput_frequency": "day",
                                "v20111006annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20111006annualproduct": "output",
                                "v20111006annualcontact": "bronaugh@uvic.ca",
                                "v20111006annualcmor_version": "2.5.9",
                                "v20111006annualparent_experiment_id": "historical",
                                "v20111006annualETCCDI_institution_id": "PCIC",
                                "v20111006annualforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "v20111006annualsource": "MPI-ESM-LR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4619), T63L47; land: JSBACH (REV: 4619); ocean: MPIOM (REV: 4619), GR15L40; sea ice: 4619; marine bgc: HAMOCC (REV: 4619);",
                                "v20111006annualETCCDI_software": "climdex.pcic",
                                "v20111006annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20111006annualETCCDI_software_version": "0.7.1",
                                "v20111006annualConventions": "CF-1.4",
                                "v20111006annualinput_tracking_id": "aec1b455-b23f-4177-85d4-e088cf40dcd4",
                                "v20111006annualinitialization_method": "1",
                                "v20111006annualtitle": "ETCCDI indices computed on MPI-ESM-LR model output prepared for CMIP5 RCP4.5",
                                "v20111006annualMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "v20111006annualmodeling_realm": "atmos",
                                "v20111006annualproject_id": "CMIP5",
                                "v20111006annualinput_creation_date": "2011-07-17T14:42:08Z",
                                "v20111006annualbranch_time": "56978.0",
                                "v20111006annualexperiment_id": "rcp45",
                                "v20111006annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20111006annualinput_title": "MPI-ESM-LR model output prepared for CMIP5 RCP4.5",
                                "v20111006annualphysics_version": "1",
                                "v20111006annualfrequency": "yr",
                                "v20111006annualcreation_date": "2013-07-01T00:34:47Z",
                                "v20111006annualparent_experiment": "historical",
                                "v20111006annualnco_openmp_thread_number": "1",
                                "v20111006annualinstitute_id": "MPI-M",
                                "v20111006annualexperiment": "RCP4.5",
                                "v20111006annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20111006annualMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "v20111006annualinstitution": "Max Planck Institute for Meteorology",
                                "v20111006annualmodel_id": "MPI-ESM-LR",
                                "iridlhasSemantics": "iridl:MPI-ESM-LR",
                                "Conventions": "IRIDL"
                            },
                            "v20111006": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20111006",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "percent",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "pointwidth": "1.0"
                                    },
                                    "endyr1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "calendar": "360"
                                    },
                                    "endyr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "endyr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days",
                                        "missing_value": "NaN",
                                        "file_missing_value": "1.00000002E20",
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MPI-ESM-LR"
                        },
                        "MPIESMMR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MPI-ESM-MR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mult_versionsmonthlybranch_time": "56978.0",
                                "mult_versionsmonthlycontact": "bronaugh@uvic.ca",
                                "mult_versionsmonthlyinput_creation_date": "2011-10-11T11:27:38Z",
                                "mult_versionsmonthlynco_openmp_thread_number": "1",
                                "mult_versionsmonthlyproduct": "output",
                                "mult_versionsmonthlyinput_title": "MPI-ESM-MR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsmonthlyETCCDI_institution_id": "PCIC",
                                "mult_versionsmonthlyexperiment": "RCP4.5",
                                "mult_versionsmonthlyinput_frequency": "day",
                                "mult_versionsmonthlysource": "MPI-ESM-MR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4936), T63L47; land: JSBACH (REV: 4936); ocean: MPIOM (REV: 4936), GR15L40; sea ice: 4936; marine bgc: HAMOCC (REV: 4936);",
                                "mult_versionsmonthlyphysics_version": "1",
                                "mult_versionsmonthlymodeling_realm": "atmos",
                                "mult_versionsmonthlyproject_id": "CMIP5",
                                "mult_versionsmonthlyConventions": "CF-1.4",
                                "mult_versionsmonthlyETCCDI_software": "climdex.pcic",
                                "mult_versionsmonthlyinstitution": "Max Planck Institute for Meteorology",
                                "mult_versionsmonthlyfrequency": "mon",
                                "mult_versionsmonthlyinitialization_method": "1",
                                "mult_versionsmonthlycreation_date": "2012-07-12T18:39:25Z",
                                "mult_versionsmonthlytitle": "ETCCDI indices computed on MPI-ESM-MR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsmonthlyparent_experiment_id": "historical",
                                "mult_versionsmonthlymodel_id": "MPI-ESM-MR",
                                "mult_versionsmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsmonthlyinstitute_id": "MPI-M",
                                "mult_versionsmonthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsmonthlyexperiment_id": "rcp45",
                                "mult_versionsmonthlyMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "mult_versionsmonthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsmonthlyETCCDI_software_version": "0.6.1",
                                "mult_versionsmonthlyparent_experiment": "historical",
                                "mult_versionsmonthlyMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "mult_versionsmonthlycmor_version": "2.6.0",
                                "mult_versionsmonthlyforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "mult_versionsannualcontact": "bronaugh@uvic.ca",
                                "mult_versionsannualinput_creation_date": "2011-10-11T11:27:38Z",
                                "mult_versionsannualnco_openmp_thread_number": "1",
                                "mult_versionsannualproduct": "output",
                                "mult_versionsannualinput_title": "MPI-ESM-MR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "mult_versionsannualETCCDI_institution_id": "PCIC",
                                "mult_versionsannualexperiment": "RCP4.5",
                                "mult_versionsannualinput_frequency": "day",
                                "mult_versionsannualsource": "MPI-ESM-MR 2011; URL: http://svn.zmaw.de/svn/cosmos/branches/releases/mpi-esm-cmip5/src/mod; atmosphere: ECHAM6 (REV: 4936), T63L47; land: JSBACH (REV: 4936); ocean: MPIOM (REV: 4936), GR15L40; sea ice: 4936; marine bgc: HAMOCC (REV: 4936);",
                                "mult_versionsannualphysics_version": "1",
                                "mult_versionsannualmodeling_realm": "atmos",
                                "mult_versionsannualproject_id": "CMIP5",
                                "mult_versionsannualConventions": "CF-1.4",
                                "mult_versionsannualETCCDI_software": "climdex.pcic",
                                "mult_versionsannualfrequency": "yr",
                                "mult_versionsannualinitialization_method": "1",
                                "mult_versionsannualtitle": "ETCCDI indices computed on MPI-ESM-MR model output prepared for CMIP5 RCP4.5",
                                "mult_versionsannualcreation_date": "2012-07-12T18:39:36Z",
                                "mult_versionsannualinstitution": "Max Planck Institute for Meteorology",
                                "mult_versionsannualparent_experiment_id": "historical",
                                "mult_versionsannualmodel_id": "MPI-ESM-MR",
                                "mult_versionsannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "mult_versionsannualinstitute_id": "MPI-M",
                                "mult_versionsannualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "mult_versionsannualexperiment_id": "rcp45",
                                "mult_versionsannualMPIM_references": "ECHAM6: n/a; JSBACH: Raddatz et al., 2007. Will the tropical land biosphere dominate the climate-carbon cycle feedback during the twenty first century? Climate Dynamics, 29, 565-574, doi 10.1007/s00382-007-0247-8;  MPIOM: Marsland et al., 2003. The Max-Planck-Institute global ocean/sea ice model with orthogonal curvilinear coordinates. Ocean Modelling, 5, 91-127;  HAMOCC: Technical Documentation, http://www.mpimet.mpg.de/fileadmin/models/MPIOM/HAMOCC5.1_TECHNICAL_REPORT.pdf;",
                                "mult_versionsannualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "mult_versionsannualparent_experiment": "historical",
                                "mult_versionsannualETCCDI_software_version": "0.6.1",
                                "mult_versionsannualMPIM_contact": "cmip5-mpi-esm@dkrz.de",
                                "mult_versionsannualcmor_version": "2.6.0",
                                "mult_versionsannualbranch_time": "56978.0",
                                "mult_versionsannualforcing": "GHG,Oz,SD,Sl,Vl,LU",
                                "iridlhasSemantics": "iridl:MPI-ESM-MR",
                                "Conventions": "IRIDL"
                            },
                            "mult_versions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mult_versions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "1.0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.875",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MPI-ESM-MR"
                        },
                        "MRICGCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MRI-CGCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120701monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120701monthlyinput_title": "MRI-CGCM3 model output prepared for CMIP5 RCP4.5",
                                "v20120701monthlycreation_date": "2012-07-18T19:45:19Z",
                                "v20120701monthlyMRI_references": "Model described by Yukimoto et al. (Technical Report of the Meteorological Research Institute, 2011, 64, 83pp.)",
                                "v20120701monthlyphysics_version": "1",
                                "v20120701monthlyETCCDI_institution_id": "PCIC",
                                "v20120701monthlyproduct": "output",
                                "v20120701monthlyparent_experiment_rip": "r1i1p1",
                                "v20120701monthlyexperiment_id": "rcp45",
                                "v20120701monthlybranch_time": "56978.0",
                                "v20120701monthlyfrequency": "mon",
                                "v20120701monthlyinput_frequency": "day",
                                "v20120701monthlyETCCDI_software_version": "0.6.1",
                                "v20120701monthlyinitialization_method": "1",
                                "v20120701monthlyMRI_contact": "Seiji Yukimoto (yukimoto@mri-jma.go.jp)",
                                "v20120701monthlysource": "MRI-CGCM3 2011 atmosphere: GSMUV (gsmuv-110112, TL159L48); ocean: MRI.COM3 (MRICOM-3_0-20101116, 1x0.5L51); sea ice: MRI.COM3; land: HAL (HAL_cmip5_v0.31_04); aerosol: MASINGAR-mk2 (masingar_mk2-20110111_0203, TL95L48)",
                                "v20120701monthlyConventions": "CF-1.4",
                                "v20120701monthlynco_openmp_thread_number": "1",
                                "v20120701monthlyETCCDI_software": "climdex.pcic",
                                "v20120701monthlytitle": "ETCCDI indices computed on MRI-CGCM3 model output prepared for CMIP5 RCP4.5",
                                "v20120701monthlyexperiment": "RCP4.5",
                                "v20120701monthlyparent_experiment_id": "historical",
                                "v20120701monthlyparent_experiment": "historical",
                                "v20120701monthlycontact": "bronaugh@uvic.ca",
                                "v20120701monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120701monthlyforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC (GHG includes CO2, CH4, N2O, CFC-11, CFC-12, and HCFC-22)",
                                "v20120701monthlyinstitution": "MRI (Meteorological Research Institute, Tsukuba, Japan)",
                                "v20120701monthlyproject_id": "CMIP5",
                                "v20120701monthlymodel_id": "MRI-CGCM3",
                                "v20120701monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120701monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120701monthlyrealization": "1",
                                "v20120701monthlymodeling_realm": "atmos",
                                "v20120701monthlyinstitute_id": "MRI",
                                "v20120701monthlyinput_creation_date": "2011-06-08T06:25:49Z",
                                "v20120701monthlycmor_version": "2.6.0",
                                "v20120701annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120701annualinput_title": "MRI-CGCM3 model output prepared for CMIP5 RCP4.5",
                                "v20120701annualcreation_date": "2012-07-18T19:45:44Z",
                                "v20120701annualMRI_references": "Model described by Yukimoto et al. (Technical Report of the Meteorological Research Institute, 2011, 64, 83pp.)",
                                "v20120701annualphysics_version": "1",
                                "v20120701annualETCCDI_institution_id": "PCIC",
                                "v20120701annualproduct": "output",
                                "v20120701annualexperiment_id": "rcp45",
                                "v20120701annualbranch_time": "56978.0",
                                "v20120701annualfrequency": "yr",
                                "v20120701annualinput_frequency": "day",
                                "v20120701annualETCCDI_software_version": "0.6.1",
                                "v20120701annualinitialization_method": "1",
                                "v20120701annualMRI_contact": "Seiji Yukimoto (yukimoto@mri-jma.go.jp)",
                                "v20120701annualsource": "MRI-CGCM3 2011 atmosphere: GSMUV (gsmuv-110112, TL159L48); ocean: MRI.COM3 (MRICOM-3_0-20101116, 1x0.5L51); sea ice: MRI.COM3; land: HAL (HAL_cmip5_v0.31_04); aerosol: MASINGAR-mk2 (masingar_mk2-20110111_0203, TL95L48)",
                                "v20120701annualConventions": "CF-1.4",
                                "v20120701annualnco_openmp_thread_number": "1",
                                "v20120701annualETCCDI_software": "climdex.pcic",
                                "v20120701annualtitle": "ETCCDI indices computed on MRI-CGCM3 model output prepared for CMIP5 RCP4.5",
                                "v20120701annualexperiment": "RCP4.5",
                                "v20120701annualparent_experiment_id": "historical",
                                "v20120701annualparent_experiment": "historical",
                                "v20120701annualcontact": "bronaugh@uvic.ca",
                                "v20120701annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120701annualforcing": "GHG, SA, Oz, LU, Sl, Vl, BC, OC (GHG includes CO2, CH4, N2O, CFC-11, CFC-12, and HCFC-22)",
                                "v20120701annualinstitution": "MRI (Meteorological Research Institute, Tsukuba, Japan)",
                                "v20120701annualproject_id": "CMIP5",
                                "v20120701annualmodel_id": "MRI-CGCM3",
                                "v20120701annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20120701annualrealization": "1",
                                "v20120701annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120701annualmodeling_realm": "atmos",
                                "v20120701annualinstitute_id": "MRI",
                                "v20120701annualinput_creation_date": "2011-06-08T06:25:49Z",
                                "v20120701annualcmor_version": "2.6.0",
                                "iridlhasSemantics": "iridl:MRI-CGCM3",
                                "Conventions": "IRIDL"
                            },
                            "v20120701": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120701",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:19 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "base_period": "1961-1990",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "base_period": "1961-1990",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "base_period": "1961-1990",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Wed Jul 18 19:45:44 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/MRI-CGCM3"
                        },
                        "NorESM1M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NorESM1-M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20121031monthlyproject_id": "CMIP5",
                                "v20121031monthlyinstitution": "Norwegian Climate Centre",
                                "v20121031monthlyproduct": "output",
                                "v20121031monthlyinput_creation_date": "2011-06-05T18:45:18Z",
                                "v20121031monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20121031monthlyinitialization_method": "1",
                                "v20121031monthlyinstitute_id": "NCC",
                                "v20121031monthlysource": "NorESM1-M 2011  atmosphere: CAM-Oslo (CAM4-Oslo-noresm-ver1_cmip5-r112, f19L26);  ocean: MICOM (MICOM-noresm-ver1_cmip5-r112, gx1v6L53);  sea ice: CICE (CICE4-noresm-ver1_cmip5-r112);  land: CLM (CLM4-noresm-ver1_cmip5-r112)",
                                "v20121031monthlyNCC_contact": "Please send any requests or bug reports to noresm-ncc@met.no.",
                                "v20121031monthlyETCCDI_software_version": "0.7.1",
                                "v20121031monthlybranch_time": "56940.0",
                                "v20121031monthlyrealization": "1",
                                "v20121031monthlynco_openmp_thread_number": "1",
                                "v20121031monthlyETCCDI_software": "climdex.pcic",
                                "v20121031monthlyforcing": "GHG, SA, Oz, Sl, BC, OC",
                                "v20121031monthlyConventions": "CF-1.4",
                                "v20121031monthlycmor_version": "2.6.0",
                                "v20121031monthlyphysics_version": "1",
                                "v20121031monthlyfrequency": "mon",
                                "v20121031monthlytitle": "ETCCDI indices computed on NorESM1-M model output prepared for CMIP5 RCP4.5",
                                "v20121031monthlyexperiment": "RCP4.5",
                                "v20121031monthlycontact": "bronaugh@uvic.ca",
                                "v20121031monthlyexperiment_id": "rcp45",
                                "v20121031monthlymodel_id": "NorESM1-M",
                                "v20121031monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20121031monthlyparent_experiment_rip": "r1i1p1",
                                "v20121031monthlyinput_title": "NorESM1-M model output prepared for CMIP5 RCP4.5",
                                "v20121031monthlyparent_experiment": "historical",
                                "v20121031monthlymodeling_realm": "atmos",
                                "v20121031monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20121031monthlyparent_experiment_id": "historical",
                                "v20121031monthlyETCCDI_institution_id": "PCIC",
                                "v20121031monthlycreation_date": "2013-07-20T11:13:00Z",
                                "v20121031monthlytable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20121031monthlyinput_frequency": "day",
                                "v20121031annualproject_id": "CMIP5",
                                "v20121031annualinstitution": "Norwegian Climate Centre",
                                "v20121031annualproduct": "output",
                                "v20121031annualinput_creation_date": "2011-06-05T18:45:18Z",
                                "v20121031annualinitialization_method": "1",
                                "v20121031annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20121031annualinstitute_id": "NCC",
                                "v20121031annualsource": "NorESM1-M 2011  atmosphere: CAM-Oslo (CAM4-Oslo-noresm-ver1_cmip5-r112, f19L26);  ocean: MICOM (MICOM-noresm-ver1_cmip5-r112, gx1v6L53);  sea ice: CICE (CICE4-noresm-ver1_cmip5-r112);  land: CLM (CLM4-noresm-ver1_cmip5-r112)",
                                "v20121031annualNCC_contact": "Please send any requests or bug reports to noresm-ncc@met.no.",
                                "v20121031annualETCCDI_software_version": "0.7.1",
                                "v20121031annualbranch_time": "56940.0",
                                "v20121031annualrealization": "1",
                                "v20121031annualnco_openmp_thread_number": "1",
                                "v20121031annualETCCDI_software": "climdex.pcic",
                                "v20121031annualforcing": "GHG, SA, Oz, Sl, BC, OC",
                                "v20121031annualConventions": "CF-1.4",
                                "v20121031annualcmor_version": "2.6.0",
                                "v20121031annualphysics_version": "1",
                                "v20121031annualfrequency": "yr",
                                "v20121031annualtitle": "ETCCDI indices computed on NorESM1-M model output prepared for CMIP5 RCP4.5",
                                "v20121031annualexperiment": "RCP4.5",
                                "v20121031annualcontact": "bronaugh@uvic.ca",
                                "v20121031annualexperiment_id": "rcp45",
                                "v20121031annualmodel_id": "NorESM1-M",
                                "v20121031annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20121031annualparent_experiment_rip": "r1i1p1",
                                "v20121031annualinput_title": "NorESM1-M model output prepared for CMIP5 RCP4.5",
                                "v20121031annualparent_experiment": "historical",
                                "v20121031annualmodeling_realm": "atmos",
                                "v20121031annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20121031annualparent_experiment_id": "historical",
                                "v20121031annualETCCDI_institution_id": "PCIC",
                                "v20121031annualcreation_date": "2013-07-20T11:13:00Z",
                                "v20121031annualtable_id": "Table day (27 April 2011) 86d1558d99b6ed1e7a886ab3fd717b58",
                                "v20121031annualinput_frequency": "day",
                                "iridlhasSemantics": "iridl:NorESM1-M",
                                "Conventions": "IRIDL"
                            },
                            "v20121031": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20121031",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.7.1 on Sat Jul 20 11:13:00 2013",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.8947369",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/NorESM1-M"
                        },
                        "bcccsm11": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bcc-csm1-1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120705monthlyinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120705monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120705monthlyfrequency": "mon",
                                "v20120705monthlyexperiment": "RCP4.5",
                                "v20120705monthlyproject_id": "CMIP5",
                                "v20120705monthlyproduct": "output",
                                "v20120705monthlybranch_time": "2006.0",
                                "v20120705monthlyETCCDI_software": "climdex.pcic",
                                "v20120705monthlycreation_date": "2013-06-29T21:17:51Z",
                                "v20120705monthlycomment": "Future projection (2006-2099) forced with prescribed concentration scenario of RCP4.5. The carbon cycle in land and ocean component model is considered, but the time-evolution of CO2 concentration in atmospheric component is prescribed.",
                                "v20120705monthlyBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120705monthlysource": "bcc-csm1-1:atmosphere:  BCC_AGCM2.1 (T42L26); land: BCC_AVIM1.0;ocean: MOM4_L40 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120705monthlynco_openmp_thread_number": "1",
                                "v20120705monthlyETCCDI_software_version": "0.7.1",
                                "v20120705monthlyrealization": "1",
                                "v20120705monthlyparent_experiment": "historical",
                                "v20120705monthlyparent_experiment_rip": "r1i1p1",
                                "v20120705monthlyforcing": "Nat Ant GHG SD Oz Sl SS Ds BC OC",
                                "v20120705monthlyConventions": "CF-1.4",
                                "v20120705monthlycmor_version": "2.5.6",
                                "v20120705monthlyinput_tracking_id": "5f35b08d-312c-4560-a534-56ed12686ca0",
                                "v20120705monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120705monthlytitle": "ETCCDI indices computed on bcc-csm1-1 model output prepared for CMIP5 RCP4.5",
                                "v20120705monthlyinput_title": "bcc-csm1-1 model output prepared for CMIP5 RCP4.5",
                                "v20120705monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120705monthlycontact": "bronaugh@uvic.ca",
                                "v20120705monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120705monthlyinstitute_id": "BCC",
                                "v20120705monthlyinitialization_method": "1",
                                "v20120705monthlymodeling_realm": "atmos",
                                "v20120705monthlyphysics_version": "1",
                                "v20120705monthlyETCCDI_institution_id": "PCIC",
                                "v20120705monthlyinput_creation_date": "2011-07-04T08:33:08Z",
                                "v20120705monthlyinput_frequency": "day",
                                "v20120705monthlyexperiment_id": "rcp45",
                                "v20120705monthlyparent_experiment_id": "historical",
                                "v20120705monthlymodel_id": "bcc-csm1-1",
                                "v20120705annualinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120705annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120705annualfrequency": "yr",
                                "v20120705annualexperiment": "RCP4.5",
                                "v20120705annualproject_id": "CMIP5",
                                "v20120705annualproduct": "output",
                                "v20120705annualbranch_time": "2006.0",
                                "v20120705annualETCCDI_software": "climdex.pcic",
                                "v20120705annualcreation_date": "2013-06-29T21:17:51Z",
                                "v20120705annualcomment": "Future projection (2006-2099) forced with prescribed concentration scenario of RCP4.5. The carbon cycle in land and ocean component model is considered, but the time-evolution of CO2 concentration in atmospheric component is prescribed.",
                                "v20120705annualBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120705annualsource": "bcc-csm1-1:atmosphere:  BCC_AGCM2.1 (T42L26); land: BCC_AVIM1.0;ocean: MOM4_L40 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120705annualnco_openmp_thread_number": "1",
                                "v20120705annualETCCDI_software_version": "0.7.1",
                                "v20120705annualrealization": "1",
                                "v20120705annualparent_experiment": "historical",
                                "v20120705annualparent_experiment_rip": "r1i1p1",
                                "v20120705annualforcing": "Nat Ant GHG SD Oz Sl SS Ds BC OC",
                                "v20120705annualConventions": "CF-1.4",
                                "v20120705annualcmor_version": "2.5.6",
                                "v20120705annualinput_tracking_id": "5f35b08d-312c-4560-a534-56ed12686ca0",
                                "v20120705annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120705annualtitle": "ETCCDI indices computed on bcc-csm1-1 model output prepared for CMIP5 RCP4.5",
                                "v20120705annualinput_title": "bcc-csm1-1 model output prepared for CMIP5 RCP4.5",
                                "v20120705annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120705annualcontact": "bronaugh@uvic.ca",
                                "v20120705annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120705annualinstitute_id": "BCC",
                                "v20120705annualinitialization_method": "1",
                                "v20120705annualphysics_version": "1",
                                "v20120705annualmodeling_realm": "atmos",
                                "v20120705annualETCCDI_institution_id": "PCIC",
                                "v20120705annualinput_creation_date": "2011-07-04T08:33:08Z",
                                "v20120705annualinput_frequency": "day",
                                "v20120705annualexperiment_id": "rcp45",
                                "v20120705annualparent_experiment_id": "historical",
                                "v20120705annualmodel_id": "bcc-csm1-1",
                                "iridlhasSemantics": "iridl:bcc-csm1-1",
                                "Conventions": "IRIDL"
                            },
                            "v20120705": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120705",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "base_period": "1961-1990",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "base_period": "1961-1990",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "base_period": "1961-1990",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/bcc-csm1-1"
                        },
                        "bcccsm11m": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bcc-csm1-1-m",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20120724monthlycomment": "The main difference between BCC-CSM1-1-M and BCC-CSM1-1 is their horizontal resolutions of the atmospheric component and the corresponding mask of sea-land. Future projection (2006-2100) forced with prescribed concentration scenario of RCP4.5. The carbon cycle in land and ocean component model is considered, but the time-evolution of CO2 concentration in atmospheric component is prescribed.",
                                "v20120724monthlyinput_creation_date": "2012-07-07T08:05:05Z",
                                "v20120724monthlyETCCDI_software_version": "0.7.1",
                                "v20120724monthlycontact": "bronaugh@uvic.ca",
                                "v20120724monthlyparent_experiment_id": "historical",
                                "v20120724monthlyforcing": "Nat Ant GHG SD Oz Sl SS Ds BC OC",
                                "v20120724monthlyproduct": "output",
                                "v20120724monthlyinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120724monthlyexperiment_id": "rcp45",
                                "v20120724monthlyparent_experiment": "historical",
                                "v20120724monthlytable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120724monthlyinput_frequency": "day",
                                "v20120724monthlyinstitute_id": "BCC",
                                "v20120724monthlysource": "bcc-csm1-1-m:atmosphere:  BCC_AGCM2.2 (T106L26); land: BCC_AVIM1.1;ocean: MOM4_L40v2 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120724monthlyinput_tracking_id": "1cc20be4-015d-4d34-90c1-7395aaf328cc",
                                "v20120724monthlybranch_time": "2006.0",
                                "v20120724monthlyConventions": "CF-1.4",
                                "v20120724monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120724monthlytitle": "ETCCDI indices computed on bcc-csm1-1-m model output prepared for CMIP5 RCP4.5",
                                "v20120724monthlyETCCDI_institution_id": "PCIC",
                                "v20120724monthlyexperiment": "RCP4.5",
                                "v20120724monthlycmor_version": "2.5.6",
                                "v20120724monthlymodeling_realm": "atmos",
                                "v20120724monthlynco_openmp_thread_number": "1",
                                "v20120724monthlyETCCDI_software": "climdex.pcic",
                                "v20120724monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120724monthlymodel_id": "bcc-csm1-1-m",
                                "v20120724monthlyphysics_version": "1",
                                "v20120724monthlyfrequency": "mon",
                                "v20120724monthlyinitialization_method": "1",
                                "v20120724monthlyproject_id": "CMIP5",
                                "v20120724monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120724monthlyBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120724monthlyinput_title": "bcc-csm1-1-m model output prepared for CMIP5 RCP4.5",
                                "v20120724monthlycreation_date": "2013-06-29T21:18:04Z",
                                "v20120724annualcomment": "The main difference between BCC-CSM1-1-M and BCC-CSM1-1 is their horizontal resolutions of the atmospheric component and the corresponding mask of sea-land. Future projection (2006-2100) forced with prescribed concentration scenario of RCP4.5. The carbon cycle in land and ocean component model is considered, but the time-evolution of CO2 concentration in atmospheric component is prescribed.",
                                "v20120724annualinput_creation_date": "2012-07-07T08:05:05Z",
                                "v20120724annualETCCDI_software_version": "0.7.1",
                                "v20120724annualcontact": "bronaugh@uvic.ca",
                                "v20120724annualparent_experiment_id": "historical",
                                "v20120724annualforcing": "Nat Ant GHG SD Oz Sl SS Ds BC OC",
                                "v20120724annualproduct": "output",
                                "v20120724annualinstitution": "Beijing Climate Center(BCC),China Meteorological Administration,China",
                                "v20120724annualexperiment_id": "rcp45",
                                "v20120724annualparent_experiment": "historical",
                                "v20120724annualtable_id": "Table day (11 April 2011) ec52f6ea2595168e5458ad1b950fd49c",
                                "v20120724annualinput_frequency": "day",
                                "v20120724annualinstitute_id": "BCC",
                                "v20120724annualsource": "bcc-csm1-1-m:atmosphere:  BCC_AGCM2.2 (T106L26); land: BCC_AVIM1.1;ocean: MOM4_L40v2 (tripolar, 1 lon x (1-1/3) lat, L40);sea ice: SIS (tripolar,1 lon x (1-1/3) lat)",
                                "v20120724annualinput_tracking_id": "1cc20be4-015d-4d34-90c1-7395aaf328cc",
                                "v20120724annualbranch_time": "2006.0",
                                "v20120724annualConventions": "CF-1.4",
                                "v20120724annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20120724annualtitle": "ETCCDI indices computed on bcc-csm1-1-m model output prepared for CMIP5 RCP4.5",
                                "v20120724annualETCCDI_institution_id": "PCIC",
                                "v20120724annualcmor_version": "2.5.6",
                                "v20120724annualexperiment": "RCP4.5",
                                "v20120724annualmodeling_realm": "atmos",
                                "v20120724annualnco_openmp_thread_number": "1",
                                "v20120724annualETCCDI_software": "climdex.pcic",
                                "v20120724annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20120724annualmodel_id": "bcc-csm1-1-m",
                                "v20120724annualphysics_version": "1",
                                "v20120724annualfrequency": "yr",
                                "v20120724annualinitialization_method": "1",
                                "v20120724annualproject_id": "CMIP5",
                                "v20120724annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20120724annualBCC_contact": "Dr. Tongwen Wu (twwu@cma.gov.cn)",
                                "v20120724annualinput_title": "bcc-csm1-1-m model output prepared for CMIP5 RCP4.5",
                                "v20120724annualcreation_date": "2013-06-29T21:18:04Z",
                                "iridlhasSemantics": "iridl:bcc-csm1-1-m",
                                "Conventions": "IRIDL"
                            },
                            "v20120724": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20120724",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "1.125",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/bcc-csm1-1-m"
                        },
                        "inmcm4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "inmcm4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v20110323monthlyinitialization_method": "1",
                                "v20110323monthlyinstitute_id": "INM",
                                "v20110323monthlymodel_id": "inmcm4",
                                "v20110323monthlyINM_contact": "Evgeny Volodin, volodin@inm.ras.ru,INM RAS, Gubkina 8, Moscow, 119333 Russia,+7-495-9383904",
                                "v20110323monthlyphysics_version": "1",
                                "v20110323monthlyproduct": "output",
                                "v20110323monthlysource": "inmcm4 (2009)",
                                "v20110323monthlycontact": "bronaugh@uvic.ca",
                                "v20110323monthlytable_id": "Table day (12 May 2010) f130b8ed0705d49c749410c0519c50cb",
                                "v20110323monthlymodeling_realm": "atmos",
                                "v20110323monthlyETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110323monthlyforcing": "N/A",
                                "v20110323monthlyfrequency": "mon",
                                "v20110323monthlyparent_experiment": "Historical",
                                "v20110323monthlyparent_experiment_id": "historical",
                                "v20110323monthlyConventions": "CF-1.4",
                                "v20110323monthlyrealization": "1",
                                "v20110323monthlybranch_time": "56940.0",
                                "v20110323monthlycomment": "no comments",
                                "v20110323monthlytitle": "ETCCDI indices computed on inmcm4 model output prepared for CMIP5 RCP4.5",
                                "v20110323monthlyINM_references": "Volodin, Diansky, Gusev 2010. Climate model INMCM4.0. Izvestia RAS. Atmospheric and oceanic physics, V.46, N4, in print.",
                                "v20110323monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110323monthlyinput_creation_date": "2010-11-15T08:41:23Z",
                                "v20110323monthlyexperiment": "RCP4.5",
                                "v20110323monthlycreation_date": "2012-07-15T00:58:09Z",
                                "v20110323monthlyinput_title": "inmcm4 model output prepared for CMIP5 RCP4.5",
                                "v20110323monthlycmor_version": "2.0.0",
                                "v20110323monthlyproject_id": "CMIP5",
                                "v20110323monthlyinstitution": "INM (Institute for Numerical Mathematics,  Moscow, Russia)",
                                "v20110323monthlyinput_frequency": "day",
                                "v20110323monthlyETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110323monthlyETCCDI_software": "climdex.pcic",
                                "v20110323monthlyexperiment_id": "rcp45",
                                "v20110323monthlyETCCDI_software_version": "0.6.1",
                                "v20110323monthlynco_openmp_thread_number": "1",
                                "v20110323monthlyETCCDI_institution_id": "PCIC",
                                "v20110323annualinitialization_method": "1",
                                "v20110323annualinstitute_id": "INM",
                                "v20110323annualmodel_id": "inmcm4",
                                "v20110323annualINM_contact": "Evgeny Volodin, volodin@inm.ras.ru,INM RAS, Gubkina 8, Moscow, 119333 Russia,+7-495-9383904",
                                "v20110323annualphysics_version": "1",
                                "v20110323annualproduct": "output",
                                "v20110323annualsource": "inmcm4 (2009)",
                                "v20110323annualcontact": "bronaugh@uvic.ca",
                                "v20110323annualtable_id": "Table day (12 May 2010) f130b8ed0705d49c749410c0519c50cb",
                                "v20110323annualmodeling_realm": "atmos",
                                "v20110323annualETCCDI_institution": "Pacific Climate Impacts Consortium",
                                "v20110323annualforcing": "N/A",
                                "v20110323annualfrequency": "yr",
                                "v20110323annualparent_experiment": "Historical",
                                "v20110323annualparent_experiment_id": "historical",
                                "v20110323annualConventions": "CF-1.4",
                                "v20110323annualrealization": "1",
                                "v20110323annualbranch_time": "56940.0",
                                "v20110323annualcomment": "no comments",
                                "v20110323annualtitle": "ETCCDI indices computed on inmcm4 model output prepared for CMIP5 RCP4.5",
                                "v20110323annualINM_references": "Volodin, Diansky, Gusev 2010. Climate model INMCM4.0. Izvestia RAS. Atmospheric and oceanic physics, V.46, N4, in print.",
                                "v20110323annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                                "v20110323annualinput_creation_date": "2010-11-15T08:41:23Z",
                                "v20110323annualexperiment": "RCP4.5",
                                "v20110323annualcreation_date": "2012-07-15T00:58:14Z",
                                "v20110323annualinput_title": "inmcm4 model output prepared for CMIP5 RCP4.5",
                                "v20110323annualcmor_version": "2.0.0",
                                "v20110323annualproject_id": "CMIP5",
                                "v20110323annualinstitution": "INM (Institute for Numerical Mathematics,  Moscow, Russia)",
                                "v20110323annualinput_frequency": "day",
                                "v20110323annualETCCDI_indices_archive": "Please check http://www.cccma.ec.gc.ca/data/climdex/climdex.shtml for errata or updates.",
                                "v20110323annualETCCDI_software": "climdex.pcic",
                                "v20110323annualexperiment_id": "rcp45",
                                "v20110323annualETCCDI_software_version": "0.6.1",
                                "v20110323annualnco_openmp_thread_number": "1",
                                "v20110323annualETCCDI_institution_id": "PCIC",
                                "iridlhasSemantics": "iridl:inmcm4",
                                "Conventions": "IRIDL"
                            },
                            "v20110323": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v20110323",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:09 2012",
                                        "pointwidth": "0"
                                    }
                                },
                                "annual": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "annual",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "long_name": "Warm Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "version": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "version",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "long_name": "Version Number"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "long_name": "Number of Tropical Nights",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "units": "percent",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "long_name": "Number of Summer Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "units": "mm/day",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "units": "mm",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "units": "mm",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "long_name": "Number of Icing Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "long_name": "Growing Season Length",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "long_name": "Number of Frost Days",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "units": "degree_Celsius",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "long_name": "Cold Spell Duration Index",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "base_period": "1961-1990",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1 mm of Precipitation",
                                        "units": "days",
                                        "missing_value": "1.00000002E20",
                                        "history": "Processed by climdex.pcic 0.6.1 on Sun Jul 15 00:58:14 2012",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1",
                                "standard_name": "time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "perturbed physics"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "12",
                                "standard_name": "time"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "initialization method"
                            },
                            "N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "realization",
                                "long_name": "realization"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.0",
                                "standard_name": "longitude",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "1.5",
                                "standard_name": "latitude",
                                "long_name": "latitude"
                            },
                            "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/CMIP5/rcp45/inmcm4"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "ACCESS10",
                            "ACCESS13",
                            "BNUESM",
                            "CCSM4",
                            "CMCCCM",
                            "CMCCCMS",
                            "CNRMCM5",
                            "CSIROMk360",
                            "CanCM4",
                            "CanESM2",
                            "ECEARTH",
                            "FGOALSg2",
                            "FGOALSs2",
                            "GFDLESM2G",
                            "GFDLESM2M",
                            "GISSE2R",
                            "HadCM3",
                            "HadGEM2CC",
                            "HadGEM2ES",
                            "IPSLCM5ALR",
                            "IPSLCM5BLR",
                            "MIROCESM",
                            "MIROCESMCHEM",
                            "MIROC4h",
                            "MIROC5",
                            "MPIESMLR",
                            "MPIESMMR",
                            "MRICGCM3",
                            "NorESM1M",
                            "bcccsm11",
                            "bcccsm11m",
                            "inmcm4"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "historical",
                        "rcp45"
                    ]
                },
                "REANALYSES": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "REANALYSES",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "historicalNCEPREANALYSIS2monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSIS2mc7908references": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSIS2annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSIS2iridlhasSemantics": "iridl:NCEPREANALYSIS2",
                        "historicalNCEPREANALYSISmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSISmc6190references": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSISannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalNCEPREANALYSISiridlhasSemantics": "iridl:NCEPREANALYSIS",
                        "historicalERAInterimmonthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERAInterimmc7908references": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERAInterimannualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERAInterimiridlhasSemantics": "iridl:ERAInterim",
                        "historicalERA40monthlyreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERA40mc6190references": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERA40annualreferences": "Sillmann_etal2013a Sillmann_etal2013b",
                        "historicalERA40iridlhasSemantics": "iridl:ERA40",
                        "Conventions": "IRIDL"
                    },
                    "historical": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "historical",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NCEPREANALYSIS2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NCEPREANALYSIS2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:08 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:10 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:15 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:13 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:09 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:11 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:14 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:12 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:20 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:19 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:18 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            },
                            "mc7908": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mc7908",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:39:20 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    }
                                }
                            },
                            "annual": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "annual",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "units": "days",
                                        "long_name": "Warm Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "units": "days",
                                        "long_name": "Number of Tropical Nights",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "units": "days",
                                        "long_name": "Number of Summer Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "units": "mm/day",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "units": "days",
                                        "long_name": "Number of Icing Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "units": "days",
                                        "long_name": "Growing Season Length",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:08 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "units": "days",
                                        "long_name": "Number of Frost Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:20 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "units": "days",
                                        "long_name": "Cold Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:23 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:22 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            }
                        },
                        "NCEPREANALYSIS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NCEPREANALYSIS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:38 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:42 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:52 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:48 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:40 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:44 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:50 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:46 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:01 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:59 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:57 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            },
                            "mc6190": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mc6190",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Mon Oct 29 18:11:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    }
                                }
                            },
                            "annual": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "annual",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "units": "days",
                                        "long_name": "Warm Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:55 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:53 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:54 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:55 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:55 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "units": "days",
                                        "long_name": "Number of Tropical Nights",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:53 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:54 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:55 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:54 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "units": "days",
                                        "long_name": "Number of Summer Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "units": "mm/day",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:03 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:03 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:02 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:06 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:06 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:04 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:05 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:04 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:06 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "units": "days",
                                        "long_name": "Number of Icing Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "units": "days",
                                        "long_name": "Growing Season Length",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "units": "days",
                                        "long_name": "Number of Frost Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:36 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:02 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:05 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "units": "days",
                                        "long_name": "Cold Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:07:56 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:05 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:08 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:07 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Oct 15 11:08:07 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            }
                        },
                        "ERAInterim": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ERAInterim",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:04 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:07 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:16 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:12 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:05 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:09 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:14 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:10 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:23 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:21 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:20 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            },
                            "mc7908": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mc7908",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 23:30:23 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    }
                                }
                            },
                            "annual": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "annual",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "units": "days",
                                        "long_name": "Warm Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:18 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:18 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:18 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "units": "days",
                                        "long_name": "Number of Tropical Nights",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:03 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:18 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:17 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "units": "days",
                                        "long_name": "Number of Summer Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:02 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "units": "mm/day",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:24 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:24 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:26 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:26 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:26 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "units": "days",
                                        "long_name": "Number of Icing Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:03 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "units": "days",
                                        "long_name": "Growing Season Length",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:03 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "units": "days",
                                        "long_name": "Number of Frost Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:02 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:24 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "units": "days",
                                        "long_name": "Cold Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:19 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:25 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:27 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:26 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:27 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1979-2008"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Sun Sep 23 22:28:26 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            }
                        },
                        "ERA40": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ERA40",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:38 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:40 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:44 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:42 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:39 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Monthly Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:41 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:43 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:41 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:48 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Monthly Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:47 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:46 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            },
                            "mc6190": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mc6190",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tx90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmax",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn90thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "90th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_Celsius",
                                        "long_name": "10th_percentile_running_baseline_tasmin",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r99thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "99th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r95thresh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95thresh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg m-2 d-1",
                                        "long_name": "95th_percentile_baseline_wet_day_pr",
                                        "history": "Created by climdex.pcic 0.6.2 on Sun Sep 23 22:33:35 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    }
                                }
                            },
                            "annual": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "annual",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "r1i1p1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "r1i1p1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:WSDI",
                                        "units": "days",
                                        "long_name": "Warm Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:46 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "txx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:44 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "txn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "txn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TXn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Maximum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tx90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tx10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tx10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TX10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Maximum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TR",
                                        "units": "days",
                                        "long_name": "Number of Tropical Nights",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNx",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Maximum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:44 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tnn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tnn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TNn",
                                        "units": "degree_Celsius",
                                        "long_name": "Annual Minimum of Daily Minimum Temperature",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "tn90p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn90p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN90p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Above the 90th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "tn10p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tn10p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:TN10p",
                                        "units": "percent",
                                        "long_name": "Percentage of Days when Daily Minimum Temperature is Below the 10th Percentile",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:45 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "su": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "su",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SU",
                                        "units": "days",
                                        "long_name": "Number of Summer Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "sdii": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sdii",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:SDII",
                                        "units": "mm/day",
                                        "long_name": "Simple Precipitation Intensity Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx5day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx5day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx5day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum Consecutive 5-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "rx1day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rx1day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:Rx1day",
                                        "units": "mm",
                                        "long_name": "Annual Maximum 1-day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:48 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r99p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r99p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R99pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 99th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r95p": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r95p",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R95pTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation when Daily Precipitation Exceeds the 95th Percentile of Wet Day Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "r20mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r20mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R20mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 20mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r1mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r1mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R01mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "r10mm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "r10mm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:R10mm",
                                        "units": "days",
                                        "long_name": "Annual Count of Days with At Least 10mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "prcptot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcptot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:PRCPTOT",
                                        "units": "mm",
                                        "long_name": "Annual Total Precipitation in Wet Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ID",
                                        "units": "days",
                                        "long_name": "Number of Icing Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "gsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:GSL",
                                        "units": "days",
                                        "long_name": "Growing Season Length",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:38 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "fd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "fd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:FD",
                                        "units": "days",
                                        "long_name": "Number of Frost Days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:37 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "dtr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:DTR",
                                        "units": "degree_Celsius",
                                        "long_name": "Mean Diurnal Temperature Range",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:48 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "cwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "csdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "csdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CSDI",
                                        "units": "days",
                                        "long_name": "Cold Spell Duration Index",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:46 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "cdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:CDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:49 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altwsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altwsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Warm Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTWSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:51 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "altcwd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcwd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCWD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with At Least 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20"
                                    },
                                    "altcsdi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcsdi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Cold Spell Duration Index Spanning Years",
                                        "iridlhasSemantics": "climdex:ALTCSDI",
                                        "units": "days",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20",
                                        "base_period": "1961-1990"
                                    },
                                    "altcdd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "altcdd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridlhasSemantics": "climdex:ALTCDD",
                                        "units": "days",
                                        "long_name": "Maximum Number of Consecutive Days Per Year with Less Than 1mm of Precipitation",
                                        "history": "Created by climdex.pcic 0.6.1 on Mon Sep 24 10:51:50 2012",
                                        "missing_value": "1.00000002E20"
                                    }
                                }
                            }
                        }
                    },
                    "time_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0"
                    },
                    "time_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0"
                    },
                    "time_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "12.0"
                    },
                    "lat_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "axis": "Y",
                        "long_name": "Latitude",
                        "standard_name": "latitude",
                        "actual_range": "-88.542"
                    },
                    "lon_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875",
                        "long_name": "Longitude",
                        "standard_name": "longitude",
                        "axis": "X",
                        "modulus": "360.0",
                        "actual_range": "358.125"
                    },
                    "time_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0"
                    },
                    "time_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "12.0"
                    },
                    "lat_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "axis": "Y",
                        "long_name": "latitude",
                        "standard_name": "latitude",
                        "pointwidth": "1.5"
                    },
                    "lon_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "axis": "X",
                        "long_name": "longitude",
                        "standard_name": "longitude",
                        "modulus": "360.0",
                        "pointwidth": "1.5"
                    },
                    "time_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1.0"
                    },
                    "time_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 01-Jan",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "modulo": "12.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "long_name": "latitude"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "modulus": "360.0",
                        "long_name": "longitude"
                    },
                    "time": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "time",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "12.0"
                    },
                    "dir": "SOURCES/WCRP/CLIVAR/ETCCDI/REANALYSES"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CMIP5",
                    "REANALYSES"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "ETCCDI"
            ]
        },
        "GCOS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GCOS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GPCCMonitoringMONTHLYversion4GPCC_Products_2018": "https://iridl.ldeo.columbia.edu/documentation/WCRP/GCOS/GPCC/GPCC_intro_products_v2018.pdf",
                "GPCCMonitoringCLIMATOLOGYy61_90long_name": "1961-1990",
                "GPCCMonitoringCLIMATOLOGYversion2011GPCC_Products_2011": "ftp://ftp-anon.dwd.de/pub/data/gpcc/PDF/GPCC_intro_products_v2011.pdf",
                "GPCCMonitoringlong_name": "Monitoring",
                "GPCCMonitoringiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                "GPCCFDPversion72p5citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Rudolf, Bruno; Ziese, Markus (2015): GPCC Full Data Reanalysis Version 7.0 at 2.5\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historic Data. DOI: 10.5676/DWD_GPCC/FD_M_V7_250",
                "GPCCFDPversion72p5title": "GPCC Full Data Product version 7, precipitation in mm/month, 2.5 degree",
                "GPCCFDPversion72p5data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata_v7_doi_download.html",
                "GPCCFDPversion72p5id": "full_data_precipitation_25",
                "GPCCFDPversion71p0citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Rudolf, Bruno; Ziese, Markus (2015): GPCC Full Data Reanalysis Version 7.0 at 1.0\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historic Data. DOI: 10.5676/DWD_GPCC/FD_M_V7_100",
                "GPCCFDPversion71p0title": "GPCC Full Data Product version 7, precipitation in mm/month, 1.0 degree",
                "GPCCFDPversion71p0data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata_v7_doi_download.html",
                "GPCCFDPversion71p0id": "full_data_precipitation_10",
                "GPCCFDPversion70p5citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Rudolf, Bruno; Ziese, Markus (2015): GPCC Full Data Reanalysis Version 7.0 at 0.5\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historic Data. DOI: 10.5676/DWD_GPCC/FD_M_V7_050",
                "GPCCFDPversion70p5title": "GPCC Full Data Product version 7, precipitation in mm/month, 0.5 degree",
                "GPCCFDPversion70p5data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata_v7_doi_download.html",
                "GPCCFDPversion70p5id": "full_data_precipitation_05",
                "GPCCFDPversion7data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata_v7_doi_download.html",
                "GPCCFDPversion7creator_email": "gpcc@dwd.de",
                "GPCCFDPversion7time_coverage_start": "1901-01-01",
                "GPCCFDPversion7keywords": "precipitation climatology,gpcc,global,gpcp,",
                "GPCCFDPversion7geospatial_lon_max": "180.",
                "GPCCFDPversion7date_created": "Mo 1. Jun 07:33:28 UTC 2015",
                "GPCCFDPversion7dataset": "http://www.earth-syst-sci-data.net/5/71/2013/essd-5-71-2013.html",
                "GPCCFDPversion7references": "Becker_etal2013",
                "GPCCFDPversion7institution": "Deutscher Wetterdienst",
                "GPCCFDPversion7creator_url": "http://gpcc.dwd.de",
                "GPCCFDPversion7Conventions": "CF-1.4",
                "GPCCFDPversion7geospatial_lat_min": "-90.",
                "GPCCFDPversion7summary": "The Full Data Reanalysis Product is of much higher accuracy compared to the GPCC near real-time products mentioned above. Therefore, its application is recommended for hydrometeorological model verification and water cycle studies, e.g. in context of UNESCO, GEWEX, and GTN-H (Global Terrestrial Network for Hydrology). This analysis product is based on all stations, near real-time and non real-time, in the GPCC data base supplying data for the individual month. The GPCC Full Data Reanalysis Product Version 7 covers the period from 1901 to 2013 ; this new extended product version using the new GPCC climatology as analysis background was generated in Apr. 2015. The data coverage per month varies from less than 10,000 to more than 48,000 stations. The full data re-analyses will be updated at irregular time intervals subsequent to significant data base improvements.",
                "GPCCFDPversion7CDI": "Climate Data Interface version 1.5.9 (http://code.zmaw.de/projects/cdi)",
                "GPCCFDPversion7geospatial_lat_max": "90.",
                "GPCCFDPversion7time_coverage_end": "2013-12-01",
                "GPCCFDPversion7geospatial_lon_min": "-180.",
                "GPCCFDPversion7history": "Mon Jun 01 07:35:23 2015: cdo -settunits,days /media/x18913/NETCDF/full_data_v7_25.nc /media/x18913/NETCDF/full_25.nc Mon Jun 01 07:34:25 2015: cdo -setgatts,gattfile_25 /media/x18913/NETCDF/full_data_v7_25.nc /media/x18913/NETCDF/full_25.nc Mon Jun 01 07:33:27 2015: cdo -merge /media/x18913/NETCDF/full_data_v7_precip_25.nc /media/x18913/NETCDF/full_data_v7_statio_25.nc /media/x18913/NETCDF/full_data_v7_25.nc Mon Jun 01 05:06:18 2015: cdo cat full_statio_25.nc /media/x18913/NETCDF/full_data_v7_statio_25.nc Mon Jun 01 05:06:18 2015: cdo -b 32 -a -f nc -setgrid,full25desc.asc -setmissval,-99999.99 -setname,s -setpartab,codetable.txt -setcode,19 -setdate,1901-01-01 -input,r144x72 full_statio_25.nc",
                "GPCCFDPversion7time_coverage_resolution": "month",
                "GPCCFDPversion7CDO": "Climate Data Operators version 1.5.9 (http://code.zmaw.de/projects/cdo)",
                "GPCCFDPversion7creator_name": "GPCC/DWD",
                "GPCCFDPversion4dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.WCRP/.GCOS/.GPCC.FDP.version4.dataset_documentation.html",
                "GPCCFDPversion3FDP": "http://iridl.ldeo.columbia.edu/SOURCES/.WCRP/.GCOS/.GPCC/.FDP/.version4/",
                "GPCCFDPversion20182p5creator_email": "gpcc@dwd.de",
                "GPCCFDPversion20182p5long_name": "2.5 Degree Resolution",
                "GPCCFDPversion20182p5geospatial_lon_max": "180.",
                "GPCCFDPversion20182p5time_coverage_start": "1891-01-01",
                "GPCCFDPversion20182p5keywords": "precipitation climatology,gpcc,global,gpcp,",
                "GPCCFDPversion20182p5date_created": "Mi 30. Mai 07:01:41 UTC 2018",
                "GPCCFDPversion20182p5institution": "Deutscher Wetterdienst",
                "GPCCFDPversion20182p5title": "GPCC Full Data Monthly Product Version 2018, at 2.5 Degree Resolution Monthly Land Surface Precipitation from Rain Gauges",
                "GPCCFDPversion20182p5creator_url": "http://gpcc.dwd.de",
                "GPCCFDPversion20182p5Conventions": "CF-1.4",
                "GPCCFDPversion20182p5geospatial_lat_min": "-90.",
                "GPCCFDPversion20182p5summary": "The Full Data Monthly Product is of much higher accuracy compared to the GPCC near real-time products mentioned above. Therefore, its application is recommended for hydrometeorological model verification and water cycle studies, e.g. in context of UNESCO, GEWEX, and GTN-H (Global Terrestrial Network for Hydrology). This analysis product is based on all stations, near real-time and non real-time, in the GPCC data base supplying data for the individual month. The GPCC Full Data Monthly Product Version 2018 covers the period from 1891 to 2016 ; this new extended product version using the new GPCC climatology as analysis background was generated in May 2018. The data coverage per month varies from less than 10,000 to more than 50,000 stations. The full data re-analyses will be updated at irregular time intervals subsequent to significant data base improvements.",
                "GPCCFDPversion20182p5citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Ziese, Markus (2018): GPCC Full Data Monthly Product Version 2018 at 2.5\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historical Data. DOI: 10.5676/DWD_GPCC/FD_M_V2018_250",
                "GPCCFDPversion20182p5CDI": "Climate Data Interface version 1.7.0 (http://mpimet.mpg.de/cdi)",
                "GPCCFDPversion20182p5geospatial_lat_max": "90.",
                "GPCCFDPversion20182p5time_coverage_end": "2016-12-01",
                "GPCCFDPversion20182p5id": "full_data_precipitation_25",
                "GPCCFDPversion20182p5data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata-monthly_v2018_doi_download.html",
                "GPCCFDPversion20182p5geospatial_lon_min": "-180.",
                "GPCCFDPversion20182p5time_coverage_resolution": "month",
                "GPCCFDPversion20182p5CDO": "Climate Data Operators version 1.7.0 (http://mpimet.mpg.de/cdo)",
                "GPCCFDPversion20182p5creator_name": "GPCC/DWD",
                "GPCCFDPversion20181p0creator_email": "gpcc@dwd.de",
                "GPCCFDPversion20181p0long_name": "1.0 Degree Resolution",
                "GPCCFDPversion20181p0geospatial_lon_max": "180.",
                "GPCCFDPversion20181p0time_coverage_start": "1891-01-01",
                "GPCCFDPversion20181p0keywords": "precipitation climatology,gpcc,global,gpcp,",
                "GPCCFDPversion20181p0date_created": "Mi 30. Mai 07:01:41 UTC 2018",
                "GPCCFDPversion20181p0institution": "Deutscher Wetterdienst",
                "GPCCFDPversion20181p0title": "GPCC Full Data Monthly Product Version 2018, at 1.0 Degree Resolution Monthly Land Surface Precipitation from Rain Gauges",
                "GPCCFDPversion20181p0creator_url": "http://gpcc.dwd.de",
                "GPCCFDPversion20181p0Conventions": "CF-1.4",
                "GPCCFDPversion20181p0geospatial_lat_min": "-90.",
                "GPCCFDPversion20181p0summary": "The Full Data Monthly Product is of much higher accuracy compared to the GPCC near real-time products mentioned above. Therefore, its application is recommended for hydrometeorological model verification and water cycle studies, e.g. in context of UNESCO, GEWEX, and GTN-H (Global Terrestrial Network for Hydrology). This analysis product is based on all stations, near real-time and non real-time, in the GPCC data base supplying data for the individual month. The GPCC Full Data Monthly Product Version 2018 covers the period from 1891 to 2016 ; this new extended product version using the new GPCC climatology as analysis background was generated in May 2018. The data coverage per month varies from less than 10,000 to more than 50,000 stations. The full data re-analyses will be updated at irregular time intervals subsequent to significant data base improvements.",
                "GPCCFDPversion20181p0citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Ziese, Markus (2018): GPCC Full Data Monthly Product Version 2018 at 1.0\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historical Data. DOI: 10.5676/DWD_GPCC/FD_M_V2018_100",
                "GPCCFDPversion20181p0CDI": "Climate Data Interface version 1.7.0 (http://mpimet.mpg.de/cdi)",
                "GPCCFDPversion20181p0geospatial_lat_max": "90.",
                "GPCCFDPversion20181p0time_coverage_end": "2016-12-01",
                "GPCCFDPversion20181p0id": "full_data_precipitation_10",
                "GPCCFDPversion20181p0data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata-monthly_v2018_doi_download.html",
                "GPCCFDPversion20181p0geospatial_lon_min": "-180.",
                "GPCCFDPversion20181p0time_coverage_resolution": "month",
                "GPCCFDPversion20181p0CDO": "Climate Data Operators version 1.7.0 (http://mpimet.mpg.de/cdo)",
                "GPCCFDPversion20181p0creator_name": "GPCC/DWD",
                "GPCCFDPversion20180p5creator_email": "gpcc@dwd.de",
                "GPCCFDPversion20180p5long_name": "0.5 Degree Resolution",
                "GPCCFDPversion20180p5geospatial_lon_max": "180.",
                "GPCCFDPversion20180p5time_coverage_start": "1891-01-01",
                "GPCCFDPversion20180p5keywords": "precipitation climatology,gpcc,global,gpcp,",
                "GPCCFDPversion20180p5date_created": "Mi 30. Mai 07:01:41 UTC 2018",
                "GPCCFDPversion20180p5institution": "Deutscher Wetterdienst",
                "GPCCFDPversion20180p5title": "GPCC Full Data Monthly Product Version 2018, at 0.5 Degree Resolution Monthly Land Surface Precipitation from Rain Gauges",
                "GPCCFDPversion20180p5creator_url": "http://gpcc.dwd.de",
                "GPCCFDPversion20180p5Conventions": "CF-1.4",
                "GPCCFDPversion20180p5geospatial_lat_min": "-90.",
                "GPCCFDPversion20180p5summary": "The Full Data Monthly Product is of much higher accuracy compared to the GPCC near real-time products mentioned above. Therefore, its application is recommended for hydrometeorological model verification and water cycle studies, e.g. in context of UNESCO, GEWEX, and GTN-H (Global Terrestrial Network for Hydrology). This analysis product is based on all stations, near real-time and non real-time, in the GPCC data base supplying data for the individual month. The GPCC Full Data Monthly Product Version 2018 covers the period from 1891 to 2016 ; this new extended product version using the new GPCC climatology as analysis background was generated in May 2018. The data coverage per month varies from less than 10,000 to more than 50,000 stations. The full data re-analyses will be updated at irregular time intervals subsequent to significant data base improvements.",
                "GPCCFDPversion20180p5citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Ziese, Markus (2018): GPCC Full Data Monthly Product Version 2018 at 0.5\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historical Data. DOI: 10.5676/DWD_GPCC/FD_M_V2018_050",
                "GPCCFDPversion20180p5CDI": "Climate Data Interface version 1.7.0 (http://mpimet.mpg.de/cdi)",
                "GPCCFDPversion20180p5geospatial_lat_max": "90.",
                "GPCCFDPversion20180p5time_coverage_end": "2016-12-01",
                "GPCCFDPversion20180p5id": "full_data_precipitation_05",
                "GPCCFDPversion20180p5data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata-monthly_v2018_doi_download.html",
                "GPCCFDPversion20180p5geospatial_lon_min": "-180.",
                "GPCCFDPversion20180p5time_coverage_resolution": "month",
                "GPCCFDPversion20180p5CDO": "Climate Data Operators version 1.7.0 (http://mpimet.mpg.de/cdo)",
                "GPCCFDPversion20180p5creator_name": "GPCC/DWD",
                "GPCCFDPversion20180p25creator_email": "gpcc@dwd.de",
                "GPCCFDPversion20180p25long_name": "0.25 Degree Resolution",
                "GPCCFDPversion20180p25geospatial_lon_max": "180.",
                "GPCCFDPversion20180p25time_coverage_start": "1891-01-01",
                "GPCCFDPversion20180p25keywords": "precipitation climatology,gpcc,global,gpcp,",
                "GPCCFDPversion20180p25date_created": "Mi 30. Mai 07:01:41 UTC 2018",
                "GPCCFDPversion20180p25institution": "Deutscher Wetterdienst",
                "GPCCFDPversion20180p25title": "GPCC Full Data Monthly Product Version 2018, at 0.25 Degree Resolution Monthly Land Surface Precipitation from Rain Gauges",
                "GPCCFDPversion20180p25creator_url": "http://gpcc.dwd.de",
                "GPCCFDPversion20180p25Conventions": "CF-1.4",
                "GPCCFDPversion20180p25geospatial_lat_min": "-90.",
                "GPCCFDPversion20180p25summary": "The Full Data Monthly Product is of much higher accuracy compared to the GPCC near real-time products mentioned above. Therefore, its application is recommended for hydrometeorological model verification and water cycle studies, e.g. in context of UNESCO, GEWEX, and GTN-H (Global Terrestrial Network for Hydrology). This analysis product is based on all stations, near real-time and non real-time, in the GPCC data base supplying data for the individual month. The GPCC Full Data Monthly Product Version 2018 covers the period from 1891 to 2016 ; this new extended product version using the new GPCC climatology as analysis background was generated in May 2018. The data coverage per month varies from less than 10,000 to more than 50,000 stations. The full data re-analyses will be updated at irregular time intervals subsequent to significant data base improvements.",
                "GPCCFDPversion20180p25citation": "Schneider, Udo; Becker, Andreas; Finger, Peter; Meyer-Christoffer, Anja; Ziese, Markus (2018): GPCC Full Data Monthly Product Version 2018 at 0.25\\xc2\\xb0: Monthly Land-Surface Precipitation from Rain-Gauges built on GTS-based and Historical Data. DOI: 10.5676/DWD_GPCC/FD_M_V2018_025",
                "GPCCFDPversion20180p25CDI": "Climate Data Interface version 1.7.0 (http://mpimet.mpg.de/cdi)",
                "GPCCFDPversion20180p25geospatial_lat_max": "90.",
                "GPCCFDPversion20180p25time_coverage_end": "2016-12-01",
                "GPCCFDPversion20180p25id": "full_data_precipitation_025",
                "GPCCFDPversion20180p25data": "ftp://ftp.dwd.de/pub/data/gpcc/html/fulldata-monthly_v2018_doi_download.html",
                "GPCCFDPversion20180p25geospatial_lon_min": "-180.",
                "GPCCFDPversion20180p25time_coverage_resolution": "month",
                "GPCCFDPversion20180p25CDO": "Climate Data Operators version 1.7.0 (http://mpimet.mpg.de/cdo)",
                "GPCCFDPversion20180p25creator_name": "GPCC/DWD",
                "GPCCFDPversion2018GPCC": "ftp://ftp-anon.dwd.de/pub/data/gpcc/PDF/GPCC_intro_products_v2018.pdf",
                "GPCCFDPversion2018dataset": "http://www.earth-syst-sci-data.net/5/71/2013/essd-5-71-2013.html",
                "GPCCFDPversion2018references": "Becker_etal2013",
                "GPCCFDPversion2018data": "ftp://ftp.dwd.de/pub/data/gpcc/full_data_2018/",
                "GPCCFDPlong_name": "Full Data Product",
                "GPCCFDPiridlhasSemantics": "gcmdi:RAIN_GAUGES",
                "GPCClong_name": "Global Precipitation Climatology Centre",
                "GPCCGPCC_Products_2008": "ftp://ftp-anon.dwd.de/pub/data/gpcc/PDF/GPCC_intro_products_2008.pdf",
                "GPCCreferences": "Rudolf_etal2010 Schneider_etal2008 Rudolf_Rubel2005 Rudolf_Schneider2005 Beck_etal2005 Rudolf_etal1994",
                "GPCCdataset_documentation": "http://www.dwd.de/bvbw/generator/DWDWWW/Content/Oeffentlichkeit/KU/KU4/KU42/en/Reports__Publications/GPCC__status__report__2010,templateId=raw,property=publicationFile.pdf/GPCC_status_report_2010.pdf",
                "GPCCReferences": "http://www.dwd.de/bvbw/appmanager/bvbw/dwdwwwDesktop/?_nfpb=true&_pageLabel=_dwdwww_klima_umwelt_datenzentren_wzn&T12404518261141645246564gsbDocumentPath=Content%2FOeffentlichkeit%2FKU%2FKU4%2FKU42%2Fteaser__product__access.html&_state=maximized&_windowLabel=T12404518261141645246564&lastPageLabel=_dwdwww_klima_umwelt_datenzentren_wzn",
                "GPCCGPCC_Products_2011": "ftp://ftp-anon.dwd.de/pub/data/gpcc/PDF/GPCC_intro_products_v2011.pdf",
                "GPCCGPCC_Home": "http://gpcc.dwd.de/",
                "GPCCiridlhasSemantics": "iridl:GPCC",
                "long_name": "Global Climate Observing System",
                "Conventions": "IRIDL"
            },
            "GPCC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GPCC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Monitoring": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Monitoring",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "version4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "2p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "unitless",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "lwe_precipitation_rate",
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "unitless",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "version3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "2p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "version2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "2p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "version1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "2p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of solid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "reprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "reprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "relative systematic gauge error",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "lprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "proportion of liquid precip",
                                    "units": "percent",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "gec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "systematic gauge error correction factor",
                                    "units": "fraction",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "eprcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "eprcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "absolute systematic gauge error",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992",
                                    "pointwidth": "1.0"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-99999.992",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "CLIMATOLOGY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CLIMATOLOGY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "y61_90": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "y61_90",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "2p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                }
                            }
                        },
                        "version2011": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version2011",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p25": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p25",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            }
                        },
                        "version2010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version2010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p25": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p25",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            }
                        },
                        "version2008": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "version2008",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p0": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "1p0",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            },
                            "p25": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "0p25",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "precipitation_amount",
                                    "long_name": "Total Precipitation",
                                    "units": "mm/month",
                                    "missing_value": "-99999.992"
                                },
                                "cnts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cnts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of gauges per grid",
                                    "missing_value": "-99999.992",
                                    "units": "unitless"
                                }
                            }
                        }
                    }
                },
                "FDP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FDP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "version7": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version7",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "code": "18",
                                "missing_value": "-99999.992"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "units": "gauges per grid",
                                "code": "19",
                                "missing_value": "-99999.992"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "code": "18",
                                "missing_value": "-99999.992"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "units": "gauges per grid",
                                "code": "19",
                                "missing_value": "-99999.992"
                            }
                        }
                    },
                    "version6": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version6",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "code": "16",
                                "missing_value": "-99999.992"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "units": "gauges per grid",
                                "code": "17",
                                "missing_value": "-99999.992"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "lwe_precipitation_rate",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "code": "16",
                                "missing_value": "-99999.992"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "units": "gauges per grid",
                                "code": "17",
                                "missing_value": "-99999.992"
                            }
                        }
                    },
                    "version5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "anom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation Anomaly",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "anom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation Anomaly",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "version4": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version4",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "anom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation Anomaly",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "long_name": "Total Precipitation",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of gauges per grid",
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "anom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "anom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Precipitation Anomaly",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "version3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "0"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "precipitation_amount",
                                "units": "mm/month",
                                "missing_value": "-99999.992",
                                "pointwidth": "0"
                            },
                            "cnts": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cnts",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99999.992",
                                "units": "unitless",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "version2018": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version2018",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "code": "20",
                                "missing_value": "-99999.992"
                            },
                            "numgauge": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "numgauge",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Stations per Grid",
                                "units": "gauges per grid",
                                "code": "21",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error_infilled": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error_infilled",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) With Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "24",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) Without Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "22",
                                "missing_value": "-99999.992"
                            },
                            "infilled_numgauges": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "infilled_numgauges",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Infilled Stations per Grid",
                                "units": "gauges per grid",
                                "code": "23",
                                "missing_value": "-99999.992"
                            },
                            "diff_new_old_method": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "diff_new_old_method",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Difference of New Minus Old Interpolation Method per Grid",
                                "units": "mm/month",
                                "code": "25",
                                "missing_value": "-99999.992"
                            }
                        },
                        "p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "code": "20",
                                "missing_value": "-99999.992"
                            },
                            "numgauge": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "numgauge",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Stations per Grid",
                                "units": "gauges per grid",
                                "code": "21",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error_infilled": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error_infilled",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) With Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "24",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) Without Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "22",
                                "missing_value": "-99999.992"
                            },
                            "infilled_numgauges": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "infilled_numgauges",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Infilled Stations per Grid",
                                "units": "gauges per grid",
                                "code": "23",
                                "missing_value": "-99999.992"
                            },
                            "diff_new_old_method": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "diff_new_old_method",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Difference of New Minus Old Interpolation Method per Grid",
                                "units": "mm/month",
                                "code": "25",
                                "missing_value": "-99999.992"
                            }
                        },
                        "p25": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "0p25",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "standard_name": "lwe_precipitation_rate",
                                "units": "mm/month",
                                "code": "20",
                                "missing_value": "-99999.992"
                            },
                            "numgauge": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "numgauge",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Stations per Grid",
                                "units": "gauges per grid",
                                "code": "21",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error_infilled": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error_infilled",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) With Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "24",
                                "missing_value": "-99999.992"
                            },
                            "interpolation_error": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "interpolation_error",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Interpolation Error (YAMAMOTO) Without Infilled Stations per Grid",
                                "units": "mm/month",
                                "code": "22",
                                "missing_value": "-99999.992"
                            },
                            "infilled_numgauges": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "infilled_numgauges",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Number of Infilled Stations per Grid",
                                "units": "gauges per grid",
                                "code": "23",
                                "missing_value": "-99999.992"
                            },
                            "diff_new_old_method": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "diff_new_old_method",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Difference of New Minus Old Interpolation Method per Grid",
                                "units": "mm/month",
                                "code": "25",
                                "missing_value": "-99999.992"
                            }
                        }
                    }
                }
            },
            "T_12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_11": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_11",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0"
            },
            "T_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time",
                "modulo": "12.0",
                "modulus": "12.0"
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 01-Jan",
                "gridtype": "1",
                "modulus": "12.0",
                "calendar": "360",
                "pointwidth": "1.0",
                "modulo": "12.0"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "Y_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "axis": "Y",
                "long_name": "latitude",
                "standard_name": "latitude",
                "pointwidth": "2.5"
            },
            "X_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "axis": "X",
                "long_name": "longitude",
                "standard_name": "longitude",
                "modulus": "360.0",
                "pointwidth": "2.5"
            },
            "Y_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "axis": "Y",
                "long_name": "latitude",
                "standard_name": "latitude",
                "pointwidth": "1.0"
            },
            "X_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "axis": "X",
                "long_name": "longitude",
                "standard_name": "longitude",
                "modulus": "360.0",
                "pointwidth": "1.0"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0"
            },
            "Y_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "axis": "Y",
                "long_name": "latitude",
                "standard_name": "latitude",
                "pointwidth": "0.5"
            },
            "X_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "axis": "X",
                "long_name": "longitude",
                "standard_name": "longitude",
                "modulus": "360.0",
                "pointwidth": "0.5"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0"
            },
            "Y_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "2.5",
                "standard_name": "latitude"
            },
            "X_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "2.5",
                "standard_name": "longitude"
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "1.0",
                "standard_name": "latitude"
            },
            "X_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "1.0",
                "standard_name": "longitude"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.5",
                "standard_name": "latitude"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.5",
                "standard_name": "longitude"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "pointwidth": "0.25",
                "standard_name": "latitude"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "1.0",
                "standard_name": "time"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "pointwidth": "0.25",
                "standard_name": "longitude"
            },
            "dir": "SOURCES/WCRP/GCOS"
        },
        "SMIP2": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/WCRP/SMIP-2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "SMIP-2",
            "restriction": "Public",
            "forecast_SST": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/WCRP/SMIP-2/forecast_SST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "forecast_SST",
                "restriction": "Public",
                "CCCma": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/CCCma",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CCCma",
                    "restriction": "Public",
                    "GCM2": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/CCCma/GCM2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "GCM2",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "GCM3": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/CCCma/GCM3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "GCM3",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "GCM2",
                        "GCM3"
                    ]
                },
                "KMA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "KMA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "references": "Lee_etal2001",
                        "description": "Korea Meteorological Agency",
                        "Conventions": "IRIDL",
                        "iridlhasSemantics": "iridl:KMA"
                    },
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential height",
                        "title": "Geopotential height",
                        "units": "m",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Northward wind",
                        "title": "Northward wind",
                        "units": "m/s",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Eastward wind",
                        "title": "Eastward wind",
                        "units": "m/s",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "title": "Ground Surface Temperature",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface (2m) air temperature",
                        "title": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Air Temperature",
                        "title": "Air Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Mean sea-level pressure",
                        "title": "Mean sea-level pressure",
                        "units": "Pa",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total precipitation rate",
                        "title": "Total precipitation rate",
                        "units": "kg/(m^2 s)",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "level_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "500.0"
                    },
                    "level_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "650.0"
                    },
                    "level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "150.0"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "lead time"
                    },
                    "latitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "latitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "members"
                    },
                    "longitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "longitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "start time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/KMA"
                },
                "MGO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MGO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "institution": "MGO",
                        "comments": "Monthly Mean Hindcast Output",
                        "calendar": "gregorian",
                        "model": "MGOAM2",
                        "references": "Shneerov_etal1997 Shneerov_etal1999 Shneerov_etal2001",
                        "description": "Main Geophysical Observatory, Russia",
                        "Conventions": "COARDS",
                        "iridlhasSemantics": "iridl:MGO"
                    },
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "comment": "Geopotential height",
                        "long_name": "Geopotential height",
                        "units": "m",
                        "grid_type": "uniform",
                        "grid_name": "U2.5x2.5",
                        "time_statistic": "average",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "comment": "Meridional velocity",
                        "long_name": "Northward wind",
                        "units": "m/s",
                        "grid_type": "uniform",
                        "grid_name": "U2.5x2.5",
                        "time_statistic": "average",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "comment": "Zonal velocity",
                        "long_name": "Eastward wind",
                        "units": "m/s",
                        "grid_type": "uniform",
                        "grid_name": "U2.5x2.5",
                        "time_statistic": "average",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "Ground Surface Temperature",
                        "comment": "Ground Surface Temperature",
                        "grid_type": "uniform",
                        "units": "Kelvin_scale",
                        "time_statistic": "average",
                        "level_description": "Earth surface",
                        "grid_name": "U2.5x2.5",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface (2m) air temperature",
                        "comment": "Surface (2m) air temperature",
                        "grid_type": "uniform",
                        "units": "Kelvin_scale",
                        "time_statistic": "average",
                        "level_description": "2 meters above earth surface",
                        "grid_name": "U2.5x2.5",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Mean sea-level pressure",
                        "comment": "Mean Sea Level Pressure",
                        "grid_type": "uniform",
                        "units": "Pa",
                        "time_statistic": "average",
                        "level_description": "Mean Sea Level",
                        "grid_name": "U2.5x2.5",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total precipitation rate",
                        "comment": "Precipitation",
                        "grid_type": "uniform",
                        "units": "kg/(m^2*s)",
                        "time_statistic": "average",
                        "level_description": "Earth surface",
                        "grid_name": "U2.5x2.5",
                        "pointwidth": "0"
                    },
                    "plev_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "500.0"
                    },
                    "plev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "plev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "650.0"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "lead time"
                    },
                    "latitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "latitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "members"
                    },
                    "longitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "longitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "start time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/MGO"
                },
                "NASA_GMAO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NASA_GMAO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "references": "Vintzileos_etal2005",
                        "description": "National Aeronautics and Space Administration, USA",
                        "Conventions": "IRIDL",
                        "iridlhasSemantics": "iridl:NASA"
                    },
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential height",
                        "units": "m",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Northward wind",
                        "units": "m/s",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Eastward wind",
                        "units": "m/s",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Air Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Mean sea-level pressure",
                        "units": "Pa",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total Precipitation rate",
                        "units": "kg/(m^2*s)",
                        "missing_value": "9.96920997E36",
                        "pointwidth": "1.0"
                    },
                    "level_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0"
                    },
                    "level_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0"
                    },
                    "level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "lead time"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "members"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.0",
                        "standard_name": "latitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "start time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/NASA_GMAO"
                },
                "RPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "references": "Cote_etal1998a Cote_etal1998b",
                        "description": "Canadian Meteorological Centre",
                        "Conventions": "CF-1.0",
                        "iridlhasSemantics": "iridl:CMC",
                        "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.WCRP/.SMIP-2/.forecast_SST/.RPN/.dataset_documentation.html"
                    },
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential height",
                        "units": "gpm",
                        "title": "Geopotential height",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "v wind",
                        "units": "m/s",
                        "title": "v wind",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "u wind",
                        "units": "m/s",
                        "title": "u wind",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "surface Soil temperature",
                        "units": "Kelvin_scale",
                        "title": "surface Soil temperature",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface Air Temperature",
                        "units": "Kelvin_scale",
                        "title": "Surface Air Temperature",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature",
                        "units": "Kelvin_scale",
                        "title": "Temperature",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Pressure reduced to MSL",
                        "units": "Pa",
                        "title": "Pressure reduced to MSL",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface Precipitation rate",
                        "units": "kg/m^2/s",
                        "title": "surface Precipitation rate",
                        "missing_value": "9.99899956E20",
                        "pointwidth": "0"
                    },
                    "level_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "500.0"
                    },
                    "level_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "650.0"
                    },
                    "level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "lev",
                        "gridtype": "0",
                        "pointwidth": "150.0"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "modulo": "12.0",
                        "modulus": "12.0"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period",
                        "long_name": "lead time"
                    },
                    "latitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "latitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "members"
                    },
                    "longitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "longitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "1.875"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "start time",
                        "calendar": "360"
                    },
                    "dir": "SOURCES/WCRP/SMIP-2/forecast_SST/RPN"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CCCma",
                    "KMA",
                    "MGO",
                    "NASA_GMAO",
                    "RPN"
                ]
            },
            "prescribed_SST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "prescribed_SST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SCRIPPScenter": "ncep",
                    "SCRIPPScalendar": "standard",
                    "SCRIPPSreferences": "Kanamitsu_etal2002",
                    "SCRIPPSdescription": "Scripps Institute of Oceanography",
                    "SCRIPPSConventions": "COARDS",
                    "SCRIPPSmodel": "sfm2000",
                    "SCRIPPSiridlhasSemantics": "iridl:SIO",
                    "SCRIPPScomments": "file created by grads using lats4d available from http://dao.gsfc.nasa.gov/software/grads/lats4d/",
                    "MRIreferences": "JMA1997",
                    "MRIdescription": "Meteorological Research Institute (Japan)",
                    "MRIiridlhasSemantics": "iridl:MRI",
                    "MGOreferences": "Shneerov_etal1997 Shneerov_etal1999 Shneerov_etal2001",
                    "MGOinstitution": "MGO",
                    "MGOdescription": "Main Geophysical Observatory, Russia",
                    "MGOConventions": "COARDS",
                    "MGOmodel": "MGOAM2",
                    "MGOiridlhasSemantics": "iridl:MGO",
                    "MGOcomments": "Monthly Mean Hindcast Output",
                    "KMAreferences": "Lee_etal2001",
                    "KMAdescription": "Korea Meteorological Agency",
                    "KMAConventions": "CF-1.0",
                    "KMAiridlhasSemantics": "iridl:KMA",
                    "IAPreferences": "Wang_etal2004",
                    "IAPdescription": "Institute of Atmospheric Physics, China",
                    "IAPConventions": "CF-1.0",
                    "IAPiridlhasSemantics": "iridl:IAP",
                    "HMCcalendar": "standard",
                    "HMCreferences": "Tolstykh2001",
                    "HMCdescription": "Hydrometcentre of Russia",
                    "HMCmodel": "slav",
                    "HMCiridlhasSemantics": "iridl:HMC",
                    "HMCHMC_Skill_Maps": "http://wmc.meteoinfo.ru/season",
                    "HMCcomments": "file created by grads using lats4d available from http://dao.gsfc.nasa.gov/software/grads/lats4d/",
                    "CPTECdescription": "Centro de Previs\\xc3\\xa3o de Tempo e Estudos Clim\\xc3\\xa1ticos",
                    "CPTECiridlhasSemantics": "iridl:CPTEC",
                    "Conventions": "IRIDL"
                },
                "SCRIPPS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SCRIPPS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Geopotential height",
                        "units": "m",
                        "missing_value": "9.99899956E20",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Northward wind",
                        "units": "m/s",
                        "missing_value": "9.99899956E20",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Eastward wind",
                        "units": "m/s",
                        "missing_value": "9.99899956E20",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "grid_name": "grid-1",
                        "long_name": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.99899956E20",
                        "grid_type": "generic",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.99899956E20",
                        "grid_type": "generic",
                        "level_description": "2 meters above earth surface",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Air Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "9.99899956E20",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Mean sea-level pressure",
                        "units": "N/m2",
                        "missing_value": "9.99899956E20",
                        "grid_type": "linear",
                        "level_description": "Mean Sea Level",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "missing_value": "9.99899956E20",
                        "grid_type": "generic",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    }
                },
                "MRI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MRI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Geopotential height",
                        "units": "m",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "grid_name": "grid-1",
                        "long_name": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "level_description": "2 meters above earth surface",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Air Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Mean sea-level pressure",
                        "units": "N/m2",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "level_description": "Mean Sea Level",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "missing_value": "-9.98999971E33",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    }
                },
                "MGO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MGO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Geopotential height",
                        "units": "m",
                        "comment": "Geopotential height",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Northward wind",
                        "units": "m/s",
                        "comment": "Meridional velocity",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Eastward wind",
                        "units": "m/s",
                        "comment": "Zonal velocity",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "comment": "Ground Surface Temperature",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "level_description": "Earth surface",
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "comment": "Surface (2m) air temperature",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "level_description": "2 meters above earth surface",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Air Temperature",
                        "units": "Kelvin_scale",
                        "comment": "Air temperature",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Mean sea-level pressure",
                        "units": "N/m2",
                        "comment": "Mean Sea Level Pressure",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "level_description": "Mean Sea Level",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "U2.5x2.5",
                        "long_name": "Total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "comment": "Precipitation",
                        "time_statistic": "average",
                        "grid_type": "uniform",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    }
                },
                "KMA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "KMA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geopotential height",
                        "units": "m",
                        "title": "Geopotential height",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Northward wind",
                        "units": "m/s",
                        "title": "Northward wind",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Eastward wind",
                        "units": "m/s",
                        "title": "Eastward wind",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "Ground Surface Temperature",
                        "title": "Ground Surface Temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "title": "Surface (2m) air temperature",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Air Temperature",
                        "units": "Kelvin_scale",
                        "title": "Air Temperature",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Mean sea-level pressure",
                        "units": "N/m2",
                        "title": "Mean sea-level pressure",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "title": "Total precipitation rate",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "bounds_latitude": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "bounds_latitude",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    }
                },
                "IAP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "IAP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "ground temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "surface (2m) air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "1.00000002E20",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "mean sea-level pressure",
                        "units": "N/m2",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "missing_value": "1.00000002E20",
                        "pointwidth": "0"
                    }
                },
                "HMC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "HMC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "geopotential height",
                        "units": "m",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "northward wind",
                        "units": "m/s",
                        "time_statistic": "instantaneous",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "comments": "Unknown1 variable comment",
                        "pointwidth": "0"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "eastward wind",
                        "units": "m/s",
                        "time_statistic": "instantaneous",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "comments": "Unknown1 variable comment",
                        "pointwidth": "0"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "grid_name": "grid-1",
                        "long_name": "ground temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "tauv": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauv",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "northward wind stress",
                        "units": "N/m2",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "tauu": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauu",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "eastward wind stress",
                        "units": "N/m2",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "T2m",
                        "units": "Kelvin_scale",
                        "time_statistic": "instantaneous",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "air temperature",
                        "units": "Kelvin_scale",
                        "time_statistic": "instantaneous",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "pointwidth": "0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "1",
                        "standard_name": "time",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "slp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "slp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "MSLP",
                        "units": "N/m2",
                        "grid_type": "linear",
                        "missing_value": "-9999.0",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "rlt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rlt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "outgoing longwave radiation",
                        "units": "W/m2",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "Total precipitation rate",
                        "units": "kg/(m^2*s)",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "hfss": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hfss",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "sensible heat flux",
                        "units": "W/m2",
                        "missing_value": "-9999.0",
                        "grid_type": "linear",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    },
                    "hfls": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hfls",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "grid_name": "grid-1",
                        "long_name": "latent heat flux",
                        "units": "W/m2",
                        "grid_type": "linear",
                        "missing_value": "-9999.0",
                        "level_description": "Earth surface",
                        "pointwidth": "0"
                    }
                },
                "CPTEC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CPTEC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "time mean geopotential height",
                        "units": "m",
                        "missing_value": "-2.55999996E33"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "northward wind",
                        "units": "m/s",
                        "missing_value": "-2.55999996E33"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "eastward wind",
                        "units": "m/s",
                        "missing_value": "-2.55999996E33"
                    },
                    "ts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ground/surface cover temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-2.55999996E33"
                    },
                    "TOPO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TOPO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "topography",
                        "units": "M",
                        "missing_value": "-2.55999996E33"
                    },
                    "tcas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tcas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                        "long_name": "temperature of canopy air space",
                        "units": "Kelvin_scale",
                        "missing_value": "-2.55999996E33"
                    },
                    "ta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "air temperature",
                        "units": "Kelvin_scale",
                        "missing_value": "-2.55999996E33"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Forecast Time",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "psl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "time mean sea-level pressure",
                        "units": "mb above 1000",
                        "missing_value": "-2.55999996E33"
                    },
                    "pr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "total precipitation",
                        "units": "Kg m-2 day-1",
                        "missing_value": "-2.55999996E33"
                    },
                    "LSMK": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LSMK",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "land mask",
                        "missing_value": "-2.55999996E33"
                    }
                },
                "levels_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0"
                },
                "latitude_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latitude_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "members"
                },
                "levels_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "levels_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "levels_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "S_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "calendar": "360"
                },
                "plev_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "plev_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "500.0"
                },
                "plev_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "plev_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "650.0"
                },
                "plev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "plev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "150.0"
                },
                "S_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "S_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "calendar": "360"
                },
                "level_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "level_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "lev",
                    "gridtype": "0",
                    "pointwidth": "500.0"
                },
                "level_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "level_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "lev",
                    "gridtype": "0",
                    "pointwidth": "650.0"
                },
                "level": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "level",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "lev",
                    "gridtype": "0",
                    "pointwidth": "150.0"
                },
                "S_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "S_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "calendar": "360"
                },
                "bound": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "bound",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "levels_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "500.0"
                },
                "levels_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "650.0"
                },
                "levels_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "150.0"
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "lead time"
                },
                "latitude_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latitude_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "longitude_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "longitude_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.8125"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "calendar": "360"
                },
                "levels_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "500.0"
                },
                "levels_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "650.0"
                },
                "levels": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "levels",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "150.0"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "lead time"
                },
                "latitude_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latitude_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "members"
                },
                "longitude_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "longitude_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "calendar": "360"
                },
                "Z": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Z",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "modulo": "12.0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "lead time"
                },
                "latitude": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latitude",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "members"
                },
                "longitude": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "longitude",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.875"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "long_name": "start time"
                },
                "dir": "SOURCES/WCRP/SMIP-2/prescribed_SST"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "forecast_SST",
                "prescribed_SST"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "CHFP",
            "CLIVAR",
            "GCOS",
            "SMIP2"
        ]
    },
    "WEARE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "WEARE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Marine climate atlas of the tropical Pacific Ocean",
            "references": "Weare:etal1980 Weare:etal1981",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.WEARE/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:UC_Davis",
            "Conventions": "IRIDL"
        },
        "MONTHLY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MONTHLY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "wspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Wind Speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vvsp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vvsp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "merdional wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vusp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vusp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vt": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vt",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vsst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vsst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sst variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vqh": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vqh",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "vq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "uv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy flux of zonal momentum",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "ut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "uspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "uq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea surface temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "available solar radiation",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "shfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sensible heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "pres": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pres",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea Level Pressure",
                "units": "mb",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "nobs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nobs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of observations",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "lwfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lwfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "long wave heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "lcld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lcld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "low cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "dqsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dqsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea-air specific humidity difference",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            },
            "ce": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ce",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "exchange coefficient",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare averaged surface data"
            }
        },
        "MEAN": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MEAN",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "wspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Wind Speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vvsp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vvsp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "merdional wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vusp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vusp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vt": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vt",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vsst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vsst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sst variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vqh": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vqh",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "vq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "uv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy flux of zonal momentum",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "ut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "uspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "uq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea surface temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "available solar radiation",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "shfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sensible heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "pres": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pres",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea Level Pressure",
                "units": "mb",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "nobs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nobs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of observations",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "lwfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lwfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "long wave heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "lcld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lcld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "low cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "dqsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dqsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea-air specific humidity difference",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            },
            "ce": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ce",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "exchange coefficient",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare time-averaged surface data 1957-1976"
            }
        },
        "CLIMO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CLIMO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "wspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "wspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Wind Speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vvsp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vvsp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "merdional wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vusp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vusp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed variance",
                "units": "(m/s)^2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vt": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vt",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vsst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vsst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sst variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vqh": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vqh",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity variance",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "vq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "uv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional eddy flux of zonal momentum",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "ut": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ut",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy temperature flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "uspd": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uspd",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind speed",
                "units": "m/s",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "uq": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uq",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal eddy moisture flux",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dyne/cm2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "air temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea surface temperature",
                "units": "Celsius_scale",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "solr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "solr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "available solar radiation",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "shfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sensible heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "qhum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "qhum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "specific humidity",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "pres": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pres",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Sea Level Pressure",
                "units": "mb",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "nobs": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "nobs",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of observations",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "lwfx": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lwfx",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "long wave heat flux",
                "units": "W/m2",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "lcld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lcld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "low cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "dqsa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dqsa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sea-air specific humidity difference",
                "units": "g/kg",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "cld": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cld",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "cloud cover",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            },
            "ce": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ce",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "exchange coefficient",
                "units": "unitless",
                "missing_value": "1.00000002E30",
                "history": "Weare monthly surface data climatology 1957-1976"
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time",
            "calendar": "360"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "time",
            "long_name": "Time",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "5.0",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "5.0",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "dir": "SOURCES/WEARE"
    },
    "WORLDBATH": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "WORLDBATH",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "ETOPO5 5x5 minute Navy bathymetry",
            "NOAA": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NGDC/.ETOPO5/",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.WORLDBATH/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "bath": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "bath",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "maxncolor": "253",
            "colormap": "12632256",
            "scale_max": "7964.0",
            "ncolor": "253",
            "scale_min": "-9964.0",
            "CS": "-9964.0",
            "CE": "7964.0",
            "colorscalename": "topographycolorscale",
            "long_name": "topography",
            "note": "updated 27 Feb 1998 from NGDC CD-ROM 29 April 1993"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.08333333",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.08333334",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/WORLDBATH"
    },
    "WORLDBATH432": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "WORLDBATH432",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NOAA": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NGDC/.ETOPO5/",
            "description": "Sampled ETOPO5 5x5 minute Navy bathymetry",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.WORLDBATH432/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL"
        },
        "bath": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "bath",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "maxncolor": "253",
            "colormap": "12632256",
            "scale_max": "7964.0",
            "ncolor": "253",
            "scale_min": "-9964.0",
            "CS": "-9964.0",
            "CE": "7964.0",
            "colorscalename": "topographycolorscale",
            "long_name": "topography"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.8333333",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.8333333",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/WORLDBATH432"
    },
    "WORLDCLIM": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/WORLDCLIM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "WORLDCLIM",
        "restriction": "Public",
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ]
    },
    "ZMD": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ZMD",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ENACTSrainfallMONmonthlyWASPqueriesENACTScountryquerylong_name": "country info",
            "ENACTSCIPHCSMTfalciparumreferences": "Grover-Kopec_etal2006",
            "ENACTSCIPHCSMTfalciparumdescription": "Climatic Suitability for a Malaria Transmission",
            "description": "Zambia Meteorological Department",
            "Conventions": "IRIDL"
        },
        "ENACTS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ENACTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temperature": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temperature",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MRG": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MRG",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colormap": "255",
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "long_name": "Merged Minimum Temperature",
                            "units": "degree_Celsius",
                            "missing_value": "NaN",
                            "history": "Boxes with less than 0.0% dropped",
                            "file_missing_value": "-99.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colormap": "255",
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "long_name": "Merged Maximum Temperature",
                            "units": "degree_Celsius",
                            "missing_value": "NaN",
                            "history": "Boxes with less than 0.0% dropped",
                            "file_missing_value": "-99.0"
                        },
                        "climatologies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatologies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "255",
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "long_name": "tmin 1981-2010 average",
                                "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                                "units": "degree_Celsius",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.0"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "255",
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "long_name": "tmax 1981-2010 average",
                                "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                                "units": "degree_Celsius",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.0"
                            }
                        }
                    },
                    "dekadly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tmin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colormap": "255",
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "long_name": "Minimum Temperature",
                            "units": "degree_Celsius",
                            "missing_value": "-99.0"
                        },
                        "tmax": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tmax",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colormap": "255",
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "long_name": "Maximum Temperature",
                            "units": "degree_Celsius",
                            "missing_value": "-99.0"
                        },
                        "climatologies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatologies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "255",
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "long_name": "minimum temperature 1981-2010 average",
                                "history": "Averaged over T2[0.5, 1080.5] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.0",
                                "units": "degree_Celsius"
                            },
                            "tmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "255",
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "long_name": "maximum temperature 1981-2010 average",
                                "history": "Averaged over T2[0.5, 1080.5] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.0",
                                "units": "degree_Celsius"
                            }
                        }
                    }
                }
            },
            "rainfall": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rainfall",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MON": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MON",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WASP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WASP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wasp_functions": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wasp_functions",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "WASP12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "WASP12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "scale_max": "3.5",
                                    "ncolor": "254",
                                    "scale_min": "-3.5",
                                    "CS": "-3.5",
                                    "colorscalename": "std_wasp_colors",
                                    "CE": "3.5",
                                    "long_name": "WASP 12-month",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN"
                                }
                            },
                            "queriesENACTS": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "queriesENACTS",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "provincequery": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provincequery",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "the_geom": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "the_geom",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    },
                                    "prov_na": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prov_na",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "label": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "label",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "gid": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gid",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "geom_src_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "geom_src_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "feature_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "feature_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "country_na": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "country_na",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "collection_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "collection_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    }
                                },
                                "paWASP12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "paWASP12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-2.5",
                                    "long_name": "Province-Average ENACTS 12-Month WASP",
                                    "scale_max": "2.5",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "CS": "-3.5",
                                    "colorscalename": "std_wasp_colors",
                                    "CE": "3.5"
                                },
                                "pabaseline_full": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pabaseline_full",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                },
                                "pabaseline": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pabaseline",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                },
                                "districtquery": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "districtquery",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "the_geom": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "the_geom",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    },
                                    "prov_na": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prov_na",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "label": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "label",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "gid": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gid",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "geom_src_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "geom_src_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "feature_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "feature_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    },
                                    "dist_na": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dist_na",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "country_na": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "country_na",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    },
                                    "collection_id": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "collection_id",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "int4"
                                    }
                                },
                                "daWASP12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "daWASP12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-2.5",
                                    "long_name": "District-Average ENACTS 12-Month WASP",
                                    "scale_max": "2.5",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "CS": "-3.5",
                                    "colorscalename": "std_wasp_colors",
                                    "CE": "3.5"
                                },
                                "dabaseline_full": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dabaseline_full",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "District-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                },
                                "dabaseline": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dabaseline",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "District-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                },
                                "countryquery": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "countryquery",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "the_geom": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "the_geom",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    },
                                    "cntry_name": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cntry_name",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "PGtype": "varchar"
                                    }
                                },
                                "caWASP12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "caWASP12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-2.5",
                                    "long_name": "Country-Average ENACTS 12-Month WASP",
                                    "scale_max": "2.5",
                                    "units": "unitless",
                                    "missing_value": "NaN",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "CS": "-3.5",
                                    "colorscalename": "std_wasp_colors",
                                    "CE": "3.5"
                                },
                                "cabaseline_full": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cabaseline_full",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Country-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                },
                                "cabaseline": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cabaseline",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Country-Average ENACTS 12-Month WASP Baseline",
                                    "units": "unitless",
                                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "maxncolor": "254",
                                    "colormap": "360960",
                                    "ncolor": "254",
                                    "colorscalename": "std_wasp_colors"
                                }
                            }
                        },
                        "rfe_merged": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_merged",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "800.0",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "800",
                            "colormap": "290304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "colorscalename": "precip_colors",
                            "long_name": "Monthly Rainfall",
                            "units": "mm"
                        },
                        "climatologies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatologies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rfe_merged": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe_merged",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "ncolor": "16",
                                "colormap": "13434880",
                                "long_name": "rfe 1983-2012 average",
                                "history": "Averaged over T2[1983, 2012]",
                                "colorscalename": "precip_colors",
                                "units": "mm"
                            }
                        }
                    },
                    "dekadly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SPIrfe_merged_1dekad": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SPI-rfe_merged_1-dekad",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Standard Precipitation Index 1-dekad",
                            "scale_max": "3.0999999",
                            "maxncolor": "254",
                            "ncolor": "253",
                            "scale_min": "-3.0999999",
                            "CS": "-3.0999999",
                            "CE": "3.0999999",
                            "colormap": "45",
                            "units": "unitless",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.9899998",
                            "valid_max": "32767.0",
                            "valid_min": "-32768.0"
                        },
                        "rfe_mergeddiff_percent": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_mergeddiff_percent",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "4026644",
                            "scale_max": "500.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-100.0",
                            "CS": "-100",
                            "CE": "500",
                            "long_name": "Merged Station-Satellite Rainfall Difference Expressed as Percent of Long-Term Average (%)",
                            "units": "percent",
                            "history": "Averaged over T2[0.5, 1080.5]"
                        },
                        "rfe_mergeddiff": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_mergeddiff",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "150.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-150.0",
                            "CS": "-150",
                            "CE": "150",
                            "long_name": "Merged Station-Satellite Rainfall Anomaly",
                            "colormap": "10526303",
                            "units": "mm",
                            "history": "Averaged over T2[0.5, 1080.5]"
                        },
                        "rfe_merged_vs_meanrfe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_merged_vs_meanrfe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "4026644",
                            "scale_max": "600.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0",
                            "CE": "600",
                            "long_name": "Merged Station-Satellite Rainfall Expressed as Percentages of the Long-Term Average",
                            "units": "percent",
                            "history": "Averaged over T2[0.5, 1080.5]"
                        },
                        "rfe_merged": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rfe_merged",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0",
                            "CS": "0",
                            "maxncolor": "254",
                            "ncolor": "16",
                            "colormap": "13434880",
                            "long_name": "Merged Station-Satellite Rainfall",
                            "units": "mm"
                        },
                        "climatologies": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatologies",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "rfe_merged_stddev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe_merged_stddev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "colormap": "2237106",
                                "scale_max": "300.0",
                                "maxncolor": "254",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CS": "0",
                                "CE": "300",
                                "colorscalename": "cmorph_dekad_colors",
                                "long_name": "rfe merged 1983-2012 standard deviation",
                                "history": "Averaged over T2[18.5, 1062.5]",
                                "units": "mm"
                            },
                            "rfe_merged": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rfe_merged",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "ncolor": "16",
                                "colormap": "13434880",
                                "long_name": "rfe merged 1983-2012 average",
                                "history": "Averaged over T2[0.5, 1080.5]",
                                "units": "mm"
                            }
                        }
                    }
                }
            },
            "CIPH": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CIPH",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CSMT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CSMT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "falciparum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "falciparum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "TempCondProb": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TempCondProb",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16777215",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "CI": "25.0",
                            "long_name": "Percent Occurrence of Temperature Condition in Historical Record",
                            "history": "Averaged over T2=1960 minimum 0.0% data present",
                            "units": "unitless",
                            "missing_value": "NaN",
                            "fnname": "flagge",
                            "colorscalename": "temp_colors",
                            "file_missing_value": "-99.0"
                        },
                        "RHCondProb": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RHCondProb",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "13882323",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "CI": "25.0",
                            "long_name": "Percent Occurrence of Relative Humidity Condition in Historical Record",
                            "history": "Averaged over T2[1983, 2014]",
                            "units": "unitless",
                            "fnname": "flagge",
                            "process": " run",
                            "PDS_TimeRange": "113",
                            "PTVersion": "2",
                            "gribvariable": "51",
                            "gribleveltype": "100",
                            "gribparam": "51",
                            "subcenter": "NCEP Ensemble Products",
                            "gribNumBits": "15",
                            "GRIBgridcode": "2",
                            "gribfield": "1",
                            "center": "US Weather Service - National Met. Center",
                            "grib_name": "SPFH",
                            "calendar": "standard",
                            "pointwidth": "1.0"
                        },
                        "PcpnCondProb": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PcpnCondProb",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "16777215",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "CI": "25.0",
                            "long_name": "Percent Occurrence of Precipitation Condition in Historical Record",
                            "history": "Averaged over T2[1983, 2014]",
                            "units": "unitless",
                            "fnname": "flagge",
                            "colorscalename": "precip_colors"
                        },
                        "Annual_Sum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Annual_Sum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "0",
                            "scale_max": "12.5",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "12.5",
                            "long_name": "Number of Months Suitable for Malaria Transmission",
                            "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                            "units": "unitless",
                            "missing_value": "NaN",
                            "fnname": "flagge",
                            "colorscalename": "precip_colors"
                        },
                        "AllCondProb": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AllCondProb",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "colormap": "13882323",
                            "scale_max": "100.0",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CS": "0.0",
                            "CE": "100.0",
                            "CI": "25.0",
                            "long_name": "Percent Occurrence of All Three Climate Conditions in Historical Record",
                            "history": "Averaged over T2[1983, 2014] minimum 0.0% data present",
                            "units": "unitless",
                            "missing_value": "NaN",
                            "fnname": "flagge",
                            "colorscalename": "precip_colors"
                        }
                    }
                }
            }
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1981-01-01",
            "gridtype": "1",
            "modulus": "365.0",
            "calendar": "365",
            "modulo": "365.0"
        },
        "province": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "province",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "2",
            "units": "ids"
        },
        "district": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "district",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "2",
            "units": "ids"
        },
        "country": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "country",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "2",
            "units": "ids"
        },
        "BaseYears": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "BaseYears",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "12.0",
            "calendar": "360"
        },
        "Baseline_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Baseline_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "calendar": "360",
            "pointwidth": "1.0",
            "modulo": "12.0"
        },
        "Baseline": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Baseline",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "12",
            "calendar": "360"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "12.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1983-01-01",
            "gridtype": "1",
            "modulus": "365.0",
            "calendar": "365",
            "modulo": "365.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.0375",
            "standard_name": "latitude",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulus": "12.0",
            "calendar": "360",
            "long_name": "Month",
            "modulo": "12.0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "0.0375",
            "standard_name": "longitude",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/ZMD"
    },
    "indextex": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/index.tex",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "index.tex",
        "restriction": "Public",
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ]
    },
    "banned_long": [
        "dir",
        "invalid",
        "parent",
        "name",
        "banned",
        "banned_long",
        "iridl_ds_name",
        "iridl_type",
        "ANEEL",
        "ARCTIC",
        "BRF",
        "BerkeleyEarth",
        "Biosphere",
        "BoM",
        "CAC",
        "CARDONE",
        "CARTON",
        "CARTONGIESE",
        "CAYAN",
        "CCCma",
        "CCROM",
        "CDIAC",
        "CEREGE",
        "CHRIS",
        "CIAT",
        "CIESIN",
        "CIMH",
        "CLARIS_LPB",
        "CLIMAP",
        "CMA",
        "CNES",
        "COADS",
        "COLA",
        "CORAL",
        "Chile",
        "CountrySTAT",
        "DASILVA",
        "DEKLIM",
        "DGM",
        "EC9293",
        "ECHAM",
        "ECMWF",
        "ECOSYSTEMS",
        "ECP9293",
        "ENSOFORECAST",
        "EPCU",
        "ERBE",
        "EU",
        "Ethiopia",
        "FAO",
        "FSU",
        "FUNCEME",
        "Features",
        "GEDEX",
        "GEOSECS",
        "GISS",
        "GOSTA",
        "Gambia",
        "Ghana",
        "HADLEY",
        "HELLERMAN",
        "IBGE",
        "ICE",
        "IGOSS",
        "IITM",
        "IMD",
        "INIA",
        "INMET",
        "INPE",
        "IPB",
        "IPC",
        "IRI",
        "IRIARCS",
        "ISCCP",
        "IWMI",
        "Indices",
        "JAMSTEC",
        "JONES",
        "KAPLAN",
        "KEELING",
        "LDEO",
        "LEVITUS",
        "LEVITUS94",
        "LSTM",
        "Lithosphere",
        "MIT",
        "MODELRUNS",
        "MPI",
        "MSJ",
        "MaliMeteo",
        "Models",
        "Morliere",
        "NASA",
        "NCAR",
        "NMC",
        "NMC9195",
        "NOAA",
        "OBERHUBER",
        "OORT",
        "OSU",
        "OSUSFC",
        "Oxford",
        "PAGASA",
        "PALEO",
        "PDA",
        "PELTIER",
        "Princeton",
        "RC",
        "REVERDIN",
        "RIHN",
        "RSMAS",
        "Reading",
        "River",
        "SAWS",
        "SENAMHI",
        "SERVAIN",
        "SIO",
        "SMNH",
        "SOC",
        "STEVE",
        "Sandwell",
        "ShipDrift",
        "SoilGrids",
        "TAMU",
        "TMA",
        "TRENBERTH",
        "Taiwan",
        "UCSB",
        "UEA",
        "UKMO",
        "UKZN",
        "UMD",
        "UN",
        "UNAM",
        "UNH",
        "USGS",
        "USTOPO",
        "U_Chicago",
        "U_Mainz",
        "U_Zulia",
        "VUT",
        "Vietnam",
        "WCRP",
        "WEARE",
        "WORLDBATH",
        "WORLDBATH432",
        "WORLDCLIM",
        "ZMD",
        "indextex"
    ]
}